WebDriver for Selenium 2
========================
This WebDriver client implementation is based on Facebook's [php-webdriver](https://github.com/facebook/php-webdriver/) project by Justin Bishop.

Distinguishing features:
* Up-to-date with [Selenium 2 JSON Wire Protocol](https://github.com/SeleniumHQ/selenium/wiki/JsonWireProtocol) (including WebDriver commands yet to be documented).
* In the *master* branch, class names and file organization follow PSR-0 conventions for php 5.3+ namespaces.
* Coding style follows PSR-1, PSR-2, and Symfony2 conventions.
* Auto-generate API documentation via [phpDocumentor 2.x](http://phpdoc.org/).

[![Build Status](https://travis-ci.org/instaclick/php-webdriver.png)](https://travis-ci.org/instaclick/php-webdriver)
[![Coverage Status](https://coveralls.io/repos/instaclick/php-webdriver/badge.png)](https://coveralls.io/r/instaclick/php-webdriver)
[![Dependency Status](https://www.versioneye.com/php/instaclick:php-webdriver/badge.png)](https://www.versioneye.com/php/instaclick:php-webdriver/)

[![Latest Stable Version](https://poser.pugx.org/instaclick/php-webdriver/v/stable.png)](https://packagist.org/packages/instaclick/php-webdriver)
[![Total Downloads](https://poser.pugx.org/instaclick/php-webdriver/downloads.png)](https://packagist.org/packages/instaclick/php-webdriver)

Downloads
=========
* [Packagist (dev-master)](http://packagist.org/packages/instaclick/php-webdriver)
* [Github](https://github.com/instaclick/php-webdriver)

Notes
=====
* The *5.2.x* branch is no longer maintained. This branch features class names and file re-organization that follow PEAR/ZF1 conventions. Bug fixes and enhancements from the master branch likely won't be backported.
