-- MySQL dump 10.13  Distrib 5.7.23, for Linux (x86_64)
--
-- Host: localhost    Database: drupal8
-- ------------------------------------------------------
-- Server version	5.7.23-0ubuntu0.18.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `batch`
--

DROP TABLE IF EXISTS `batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `batch` (
  `bid` int(10) unsigned NOT NULL COMMENT 'Primary Key: Unique batch ID.',
  `token` varchar(64) CHARACTER SET ascii NOT NULL COMMENT 'A string token generated against the current user''s session id and the batch id, used to ensure that only the user who submitted the batch can effectively access it.',
  `timestamp` int(11) NOT NULL COMMENT 'A Unix timestamp indicating when this batch was submitted for processing. Stale batches are purged at cron time.',
  `batch` longblob COMMENT 'A serialized array containing the processing data for the batch.',
  PRIMARY KEY (`bid`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores details about batches (processes that run in…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `batch`
--

LOCK TABLES `batch` WRITE;
/*!40000 ALTER TABLE `batch` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `batch` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_content`
--

DROP TABLE IF EXISTS `block_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `revision_id` int(10) unsigned DEFAULT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `block_content_field__uuid__value` (`uuid`),
  UNIQUE KEY `block_content__revision_id` (`revision_id`),
  KEY `block_content_field__type__target_id` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for block_content entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_content`
--

LOCK TABLES `block_content` WRITE;
/*!40000 ALTER TABLE `block_content` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_content` VALUES (1,1,'basic','b2c199ed-e84d-44a0-8f59-7e94a3b3acd5','en'),(2,2,'basic','7993d995-a122-46f3-9c9f-62f8b28133eb','en'),(3,3,'basic','69b28a06-16c3-4192-bdfb-3e8718c35702','en'),(4,5,'basic','3d212339-d3f3-42ac-8949-508d768855c5','en'),(5,6,'basic','48f3ff65-fa94-4d14-ac71-9ba2d9ecb411','en'),(6,7,'basic','1cc39cd6-2ba8-486a-8ee3-ee52fb37c772','en'),(7,8,'basic','b2311339-bbd3-476c-a3e0-1ec52517bf54','en'),(8,9,'basic','27c4769c-fa48-4193-8c80-d3167875cca4','en'),(9,10,'basic','faf60d22-96bd-4cb9-b755-76962ba13b03','en'),(10,11,'basic','342a6d52-2574-4715-ba9d-33a1b621cb88','en'),(11,12,'basic','36888687-d0d1-49c9-8bb2-77cac2d2666c','en');
/*!40000 ALTER TABLE `block_content` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_content__body`
--

DROP TABLE IF EXISTS `block_content__body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_content__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for block_content field body.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_content__body`
--

LOCK TABLES `block_content__body` WRITE;
/*!40000 ALTER TABLE `block_content__body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_content__body` VALUES ('basic',0,1,1,'en',0,'<div class=\"col-md-4\"><span class=\"copyright\">Copyright © Your Website 2018</span></div>\r\n\r\n<div class=\"col-md-4\">\r\n<ul class=\"list-inline social-buttons\">\r\n	<li class=\"list-inline-item\">&nbsp;</li>\r\n	<li class=\"list-inline-item\">&nbsp;</li>\r\n	<li class=\"list-inline-item\">&nbsp;</li>\r\n</ul>\r\n</div>\r\n\r\n<div class=\"col-md-4\">\r\n<ul class=\"list-inline quicklinks\">\r\n	<li class=\"list-inline-item\"><a href=\"#\">Privacy Policy</a></li>\r\n	<li class=\"list-inline-item\"><a href=\"#\">Terms of Use</a></li>\r\n</ul>\r\n</div>\r\n','','full_html'),('basic',0,2,2,'en',0,'<!-- Modal 1 --><!-- Project Details Go Here -->\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/01-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Threads</li>\r\n	<li>Category: Illustration</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 2 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/02-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Explore</li>\r\n	<li>Category: Graphic Design</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 3 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/03-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Finish</li>\r\n	<li>Category: Identity</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 4 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/04-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Lines</li>\r\n	<li>Category: Branding</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 5 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/05-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Southwest</li>\r\n	<li>Category: Website Design</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n','','full_html'),('basic',0,3,3,'en',0,'<ul class=\"gtco-social-icons pull-right\">\r\n	<li><a href=\"#\"><i class=\"icon-twitter\">&nbsp;</i></a></li>\r\n	<li><a href=\"#\"><i class=\"icon-facebook\">&nbsp;</i></a></li>\r\n	<li><a href=\"#\"><i class=\"icon-linkedin\">&nbsp;</i></a></li>\r\n	<li><a href=\"#\"><i class=\"icon-dribbble\">&nbsp;</i></a></li>\r\n</ul>\r\n','','full_html'),('basic',0,4,5,'en',0,'<div class=\"col-md-5\" data-aos=\"fade-up\" data-aos-duration=\"500\">\r\n<div class=\"process__text\">\r\n<h4>What is Cowork?</h4>\r\n\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s,</p>\r\n\r\n<div class=\"btn\"><a class=\"btn--primary smoothscroll\" href=\"#services\">Read More</a></div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-md-7 \">\r\n<div class=\"col-md-6 widget-banners\" data-aos=\"fade-up\" data-aos-duration=\"500\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n\r\n<div class=\"col-md-6 widget-banners\" data-aos=\"fade-up\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n\r\n<div class=\"col-md-6 mt_20 widget-banners\" data-aos=\"fade-up\" data-aos-duration=\"500\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n\r\n<div class=\"col-md-6 mt_20 widget-banners\" data-aos=\"fade-up\" data-aos-duration=\"500\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n</div>\r\n','','full_html'),('basic',0,5,6,'en',0,'<div class=\"display-t\">\r\n<div class=\"display-tc\">\r\n<h1 class=\"animate-box\" data-animate-effect=\"fadeIn\">The Greatest Firm You Can Trust</h1>\r\n\r\n<p class=\"gtco-video-link animate-box\" data-animate-effect=\"fadeIn\"><a class=\"popup-vimeo\" href=\"https://vimeo.com/channels/staffpicks/93951774\"><i class=\"icon-controller-play\">&nbsp;</i></a></p>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,6,7,'en',0,'<p class=\"pull-left\"><small class=\"block\">© 2016 Free HTML5. All Rights Reserved.</small> <small class=\"block\">Designed by <a href=\"http://freehtml5.co/\" target=\"_blank\">FreeHTML5.co</a> Demo Images: <a href=\"http://unsplash.co/\" target=\"_blank\">Unsplash</a></small></p>\r\n','','full_html'),('basic',0,7,8,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Welcome To Our Law Offices</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Welcome</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row\">\r\n<div class=\"col-md-6 col-md-pull-1 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<div class=\"img-shadow\"><img alt=\"Free HTML5 Bootstrap Template by FreeHTML5.co\" class=\"img-responsive\" data-entity-type=\"file\" data-entity-uuid=\"f51a3df9-bfc6-451e-b38d-7523930719ec\" src=\"/sites/default/files/inline-images/img_1.jpg\" /></div>\r\n</div>\r\n\r\n<div class=\"col-md-6 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<h2 class=\"heading-colored\">Excellence &amp; Honesty</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquid aut praesentium nihil hic quam culpa magnam ducimus suscipit repellat quidem cumque, unde impedit, labore earum eligendi perspiciatis nemo molestiae sequi veritatis. Veritatis, reprehenderit, eaque! Rerum, libero ipsam enim, iusto adipisci quae repellendus officia consequatur ducimus cupiditate impedit, aliquam numquam excepturi.</p>\r\n\r\n<p><a class=\"read-more\" href=\"#\">Read more </a></p>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,8,9,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Practice Areas</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Practice <span>Areas</span></p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row\">\r\n<div class=\"col-md-6\">\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Criminal Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Industrial Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Financial Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-md-6\">\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Divorce Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Corporate Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Accident Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,9,10,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Our Team</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Our Team</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row team-item gtco-team-reverse\">\r\n<div class=\"col-md-6 col-md-push-7 animate-box\" data-animate-effect=\"fadeInRight\">\r\n<div class=\"img-shadow\"><img alt=\"our team\" class=\"img-responsive\" data-entity-type=\"file\" data-entity-uuid=\"aa57822e-ae19-42c8-8b78-1358c1b16b9c\" src=\"/sites/default/files/inline-images/img_team_2_0.jpg\" /></div>\r\n</div>\r\n\r\n<div class=\"col-md-6  col-md-pull-6 animate-box\" data-animate-effect=\"fadeInRight\">\r\n<h2>Jeff Finley</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Necessitatibus aliquid maiores, voluptatum ex. Accusantium, eum distinctio laudantium. Perferendis dolor, corporis quasi? Tempore quod molestiae quis cumque pariatur dolore vel sit, fugit delectus quasi reprehenderit officia voluptate incidunt, culpa odit impedit qui dolorum fugiat. Quidem possimus reprehenderit, quae recusandae voluptatibus magnam!</p>\r\n\r\n<p>Ratione facilis quod laborum eaque illo dolore blanditiis nobis dicta voluptatem fugit optio, eveniet non dolor quia delectus, sint, dignissimos atque porro consequuntur unde. Soluta ex necessitatibus delectus saepe aliquam, culpa officiis doloremque, ipsa facere hic, voluptatem accusantium veniam, quasi! Explicabo accusantium sint, corporis consequuntur fugit ipsam, dolorum excepturi adipisci.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row team-item gtco-team\">\r\n<div class=\"col-md-6 col-md-pull-1 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<div class=\"img-shadow\"><img alt=\"Our Team\" class=\"img-responsive\" data-entity-type=\"file\" data-entity-uuid=\"f8c9d2a8-165a-439d-9624-20e7b600dfe1\" src=\"/sites/default/files/inline-images/img_team_1.jpg\" /></div>\r\n</div>\r\n\r\n<div class=\"col-md-6 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<h2>Craig Campbell</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Necessitatibus aliquid maiores, voluptatum ex. Accusantium, eum distinctio laudantium. Perferendis dolor, corporis quasi? Tempore quod molestiae quis cumque pariatur dolore vel sit, fugit delectus quasi reprehenderit officia voluptate incidunt, culpa odit impedit qui dolorum fugiat. Quidem possimus reprehenderit, quae recusandae voluptatibus magnam!</p>\r\n\r\n<p>Ratione facilis quod laborum eaque illo dolore blanditiis nobis dicta voluptatem fugit optio, eveniet non dolor quia delectus, sint, dignissimos atque porro consequuntur unde. Soluta ex necessitatibus delectus saepe aliquam, culpa officiis doloremque, ipsa facere hic, voluptatem accusantium veniam, quasi! Explicabo accusantium sint, corporis consequuntur fugit ipsam, dolorum excepturi adipisci.</p>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,10,11,'en',0,'<div class=\"gtco-contact-info\">\r\n<ul>\r\n	<li class=\"address\">198 West 21th Street, Suite 721 New York NY 10016</li>\r\n	<li class=\"phone\"><a href=\"tel://+919998564703\">+919998564703</a></li>\r\n	<li class=\"email\"><a href=\"mailto:suryagangwar281@gamil.com\">suryagangwar281@gamil.com</a></li>\r\n	<li class=\"url\"><a href=\"#\">http://drupal-cms.com</a></li>\r\n</ul>\r\n</div>\r\n','','full_html'),('basic',0,11,12,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Contact Us</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Contact</p>\r\n</div>\r\n</div>\r\n','','full_html');
/*!40000 ALTER TABLE `block_content__body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_content_field_data`
--

DROP TABLE IF EXISTS `block_content_field_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_content_field_data` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `status` tinyint(4) NOT NULL,
  `info` varchar(255) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  `reusable` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`,`langcode`),
  KEY `block_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `block_content__revision_id` (`revision_id`),
  KEY `block_content_field__type__target_id` (`type`),
  KEY `block_content__status_type` (`status`,`type`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for block_content entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_content_field_data`
--

LOCK TABLES `block_content_field_data` WRITE;
/*!40000 ALTER TABLE `block_content_field_data` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_content_field_data` VALUES (1,1,'basic','en',1,'Footer',1536922659,1,1,1),(2,2,'basic','en',1,'Portfolio',1536922654,1,1,1),(3,3,'basic','en',1,'Social Media Link',1540191254,1,1,1),(4,5,'basic','en',1,'What is Cowork?',1538573979,1,1,1),(5,6,'basic','en',1,'Home Page Banner Text ',1540189041,1,1,1),(6,7,'basic','en',1,'Power By company',1540191224,1,1,1),(7,8,'basic','en',1,'About US',1540200201,1,1,1),(8,9,'basic','en',1,'Practice Areas',1540199912,1,1,1),(9,10,'basic','en',1,'Our Team',1540202132,1,1,1),(10,11,'basic','en',1,'Contact Us',1540293696,1,1,1),(11,12,'basic','en',1,'content info title',1540289280,1,1,1);
/*!40000 ALTER TABLE `block_content_field_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_content_field_revision`
--

DROP TABLE IF EXISTS `block_content_field_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_content_field_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `status` tinyint(4) NOT NULL,
  `info` varchar(255) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`revision_id`,`langcode`),
  KEY `block_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision data table for block_content entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_content_field_revision`
--

LOCK TABLES `block_content_field_revision` WRITE;
/*!40000 ALTER TABLE `block_content_field_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_content_field_revision` VALUES (1,1,'en',1,'Footer',1536922659,1,1),(2,2,'en',1,'Portfolio',1536922654,1,1),(3,3,'en',1,'Social Media Link',1540191254,1,1),(4,4,'en',1,'What is Cowork?',1538569412,1,1),(4,5,'en',1,'What is Cowork?',1538573979,1,1),(5,6,'en',1,'Home Page Banner Text ',1540189041,1,1),(6,7,'en',1,'Power By company',1540191224,1,1),(7,8,'en',1,'About US',1540200201,1,1),(8,9,'en',1,'Practice Areas',1540199912,1,1),(9,10,'en',1,'Our Team',1540202132,1,1),(10,11,'en',1,'Contact Us',1540293696,1,1),(11,12,'en',1,'content info title',1540289280,1,1);
/*!40000 ALTER TABLE `block_content_field_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_content_revision`
--

DROP TABLE IF EXISTS `block_content_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_content_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `revision_user` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `revision_created` int(11) DEFAULT NULL,
  `revision_log` longtext,
  `revision_default` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`revision_id`),
  KEY `block_content__id` (`id`),
  KEY `block_content_field__revision_user__target_id` (`revision_user`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for block_content entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_content_revision`
--

LOCK TABLES `block_content_revision` WRITE;
/*!40000 ALTER TABLE `block_content_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_content_revision` VALUES (1,1,'en',NULL,1536922381,NULL,1),(2,2,'en',NULL,1536922654,NULL,1),(3,3,'en',NULL,1538564567,NULL,1),(4,4,'en',NULL,1538569412,NULL,1),(4,5,'en',1,1538573658,NULL,1),(5,6,'en',NULL,1540187592,NULL,1),(6,7,'en',NULL,1540189714,NULL,1),(7,8,'en',NULL,1540192381,NULL,1),(8,9,'en',NULL,1540199453,NULL,1),(9,10,'en',NULL,1540200865,NULL,1),(10,11,'en',NULL,1540203714,NULL,1),(11,12,'en',NULL,1540289280,NULL,1);
/*!40000 ALTER TABLE `block_content_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_content_revision__body`
--

DROP TABLE IF EXISTS `block_content_revision__body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_content_revision__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for block_content field body.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_content_revision__body`
--

LOCK TABLES `block_content_revision__body` WRITE;
/*!40000 ALTER TABLE `block_content_revision__body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_content_revision__body` VALUES ('basic',0,1,1,'en',0,'<div class=\"col-md-4\"><span class=\"copyright\">Copyright © Your Website 2018</span></div>\r\n\r\n<div class=\"col-md-4\">\r\n<ul class=\"list-inline social-buttons\">\r\n	<li class=\"list-inline-item\">&nbsp;</li>\r\n	<li class=\"list-inline-item\">&nbsp;</li>\r\n	<li class=\"list-inline-item\">&nbsp;</li>\r\n</ul>\r\n</div>\r\n\r\n<div class=\"col-md-4\">\r\n<ul class=\"list-inline quicklinks\">\r\n	<li class=\"list-inline-item\"><a href=\"#\">Privacy Policy</a></li>\r\n	<li class=\"list-inline-item\"><a href=\"#\">Terms of Use</a></li>\r\n</ul>\r\n</div>\r\n','','full_html'),('basic',0,2,2,'en',0,'<!-- Modal 1 --><!-- Project Details Go Here -->\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/01-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Threads</li>\r\n	<li>Category: Illustration</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 2 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/02-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Explore</li>\r\n	<li>Category: Graphic Design</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 3 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/03-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Finish</li>\r\n	<li>Category: Identity</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 4 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/04-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Lines</li>\r\n	<li>Category: Branding</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n<!-- Modal 5 --><!-- Project Details Go Here -->\r\n\r\n<h2>Project Name</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetur.</p>\r\n\r\n<p><img alt=\"\" src=\"img/portfolio/05-full.jpg\" /></p>\r\n\r\n<p>Use this area to describe your project. Lorem ipsum dolor sit amet, consectetur adipisicing elit. Est blanditiis dolorem culpa incidunt minus dignissimos deserunt repellat aperiam quasi sunt officia expedita beatae cupiditate, maiores repudiandae, nostrum, reiciendis facere nemo!</p>\r\n\r\n<ul>\r\n	<li>Date: January 2017</li>\r\n	<li>Client: Southwest</li>\r\n	<li>Category: Website Design</li>\r\n</ul>\r\n\r\n<p>Close Project</p>\r\n','','full_html'),('basic',0,3,3,'en',0,'<ul class=\"gtco-social-icons pull-right\">\r\n	<li><a href=\"#\"><i class=\"icon-twitter\">&nbsp;</i></a></li>\r\n	<li><a href=\"#\"><i class=\"icon-facebook\">&nbsp;</i></a></li>\r\n	<li><a href=\"#\"><i class=\"icon-linkedin\">&nbsp;</i></a></li>\r\n	<li><a href=\"#\"><i class=\"icon-dribbble\">&nbsp;</i></a></li>\r\n</ul>\r\n','','full_html'),('basic',0,4,4,'en',0,'<h4>What is Cowork?</h4>\r\n\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s,</p>\r\n\r\n<p><a href=\"#services\">Read More</a></p>\r\n\r\n<p><img alt=\"\" src=\"images/about_1.jpg\" /></p>\r\n\r\n<p><img alt=\"\" src=\"images/about_2.jpg\" /></p>\r\n\r\n<p><img alt=\"\" src=\"images/about_3.jpg\" /></p>\r\n\r\n<p><img alt=\"\" src=\"images/about_4.jpg\" /></p>\r\n','','basic_html'),('basic',0,4,5,'en',0,'<div class=\"col-md-5\" data-aos=\"fade-up\" data-aos-duration=\"500\">\r\n<div class=\"process__text\">\r\n<h4>What is Cowork?</h4>\r\n\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s,</p>\r\n\r\n<div class=\"btn\"><a class=\"btn--primary smoothscroll\" href=\"#services\">Read More</a></div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-md-7 \">\r\n<div class=\"col-md-6 widget-banners\" data-aos=\"fade-up\" data-aos-duration=\"500\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n\r\n<div class=\"col-md-6 widget-banners\" data-aos=\"fade-up\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n\r\n<div class=\"col-md-6 mt_20 widget-banners\" data-aos=\"fade-up\" data-aos-duration=\"500\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n\r\n<div class=\"col-md-6 mt_20 widget-banners\" data-aos=\"fade-up\" data-aos-duration=\"500\"><img alt=\"about_1\" data-entity-type=\"file\" data-entity-uuid=\"1c56a1ad-c2ad-4aa4-98ec-f4648e51fece\" src=\"/sites/default/files/inline-images/about_1.jpg\" /></div>\r\n</div>\r\n','','full_html'),('basic',0,5,6,'en',0,'<div class=\"display-t\">\r\n<div class=\"display-tc\">\r\n<h1 class=\"animate-box\" data-animate-effect=\"fadeIn\">The Greatest Firm You Can Trust</h1>\r\n\r\n<p class=\"gtco-video-link animate-box\" data-animate-effect=\"fadeIn\"><a class=\"popup-vimeo\" href=\"https://vimeo.com/channels/staffpicks/93951774\"><i class=\"icon-controller-play\">&nbsp;</i></a></p>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,6,7,'en',0,'<p class=\"pull-left\"><small class=\"block\">© 2016 Free HTML5. All Rights Reserved.</small> <small class=\"block\">Designed by <a href=\"http://freehtml5.co/\" target=\"_blank\">FreeHTML5.co</a> Demo Images: <a href=\"http://unsplash.co/\" target=\"_blank\">Unsplash</a></small></p>\r\n','','full_html'),('basic',0,7,8,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Welcome To Our Law Offices</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Welcome</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row\">\r\n<div class=\"col-md-6 col-md-pull-1 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<div class=\"img-shadow\"><img alt=\"Free HTML5 Bootstrap Template by FreeHTML5.co\" class=\"img-responsive\" data-entity-type=\"file\" data-entity-uuid=\"f51a3df9-bfc6-451e-b38d-7523930719ec\" src=\"/sites/default/files/inline-images/img_1.jpg\" /></div>\r\n</div>\r\n\r\n<div class=\"col-md-6 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<h2 class=\"heading-colored\">Excellence &amp; Honesty</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquid aut praesentium nihil hic quam culpa magnam ducimus suscipit repellat quidem cumque, unde impedit, labore earum eligendi perspiciatis nemo molestiae sequi veritatis. Veritatis, reprehenderit, eaque! Rerum, libero ipsam enim, iusto adipisci quae repellendus officia consequatur ducimus cupiditate impedit, aliquam numquam excepturi.</p>\r\n\r\n<p><a class=\"read-more\" href=\"#\">Read more </a></p>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,8,9,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Practice Areas</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Practice <span>Areas</span></p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row\">\r\n<div class=\"col-md-6\">\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Criminal Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Industrial Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Financial Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n</div>\r\n\r\n<div class=\"col-md-6\">\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Divorce Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Corporate Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"gtco-practice-area-item animate-box\">\r\n<div class=\"gtco-icon\"><img alt=\"ss\" data-entity-type=\"file\" data-entity-uuid=\"4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45\" src=\"/sites/default/files/inline-images/scale.png\" /></div>\r\n\r\n<div class=\"gtco-copy\">\r\n<h3>Accident Law</h3>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla sed scelerisque sapien. Sed sodales, libero non faucibus rutrum, purus tellus finibus diam, eget ornare tortor leo eget erat.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,9,10,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Our Team</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Our Team</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row team-item gtco-team-reverse\">\r\n<div class=\"col-md-6 col-md-push-7 animate-box\" data-animate-effect=\"fadeInRight\">\r\n<div class=\"img-shadow\"><img alt=\"our team\" class=\"img-responsive\" data-entity-type=\"file\" data-entity-uuid=\"aa57822e-ae19-42c8-8b78-1358c1b16b9c\" src=\"/sites/default/files/inline-images/img_team_2_0.jpg\" /></div>\r\n</div>\r\n\r\n<div class=\"col-md-6  col-md-pull-6 animate-box\" data-animate-effect=\"fadeInRight\">\r\n<h2>Jeff Finley</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Necessitatibus aliquid maiores, voluptatum ex. Accusantium, eum distinctio laudantium. Perferendis dolor, corporis quasi? Tempore quod molestiae quis cumque pariatur dolore vel sit, fugit delectus quasi reprehenderit officia voluptate incidunt, culpa odit impedit qui dolorum fugiat. Quidem possimus reprehenderit, quae recusandae voluptatibus magnam!</p>\r\n\r\n<p>Ratione facilis quod laborum eaque illo dolore blanditiis nobis dicta voluptatem fugit optio, eveniet non dolor quia delectus, sint, dignissimos atque porro consequuntur unde. Soluta ex necessitatibus delectus saepe aliquam, culpa officiis doloremque, ipsa facere hic, voluptatem accusantium veniam, quasi! Explicabo accusantium sint, corporis consequuntur fugit ipsam, dolorum excepturi adipisci.</p>\r\n</div>\r\n</div>\r\n\r\n<div class=\"row team-item gtco-team\">\r\n<div class=\"col-md-6 col-md-pull-1 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<div class=\"img-shadow\"><img alt=\"Our Team\" class=\"img-responsive\" data-entity-type=\"file\" data-entity-uuid=\"f8c9d2a8-165a-439d-9624-20e7b600dfe1\" src=\"/sites/default/files/inline-images/img_team_1.jpg\" /></div>\r\n</div>\r\n\r\n<div class=\"col-md-6 animate-box\" data-animate-effect=\"fadeInLeft\">\r\n<h2>Craig Campbell</h2>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Necessitatibus aliquid maiores, voluptatum ex. Accusantium, eum distinctio laudantium. Perferendis dolor, corporis quasi? Tempore quod molestiae quis cumque pariatur dolore vel sit, fugit delectus quasi reprehenderit officia voluptate incidunt, culpa odit impedit qui dolorum fugiat. Quidem possimus reprehenderit, quae recusandae voluptatibus magnam!</p>\r\n\r\n<p>Ratione facilis quod laborum eaque illo dolore blanditiis nobis dicta voluptatem fugit optio, eveniet non dolor quia delectus, sint, dignissimos atque porro consequuntur unde. Soluta ex necessitatibus delectus saepe aliquam, culpa officiis doloremque, ipsa facere hic, voluptatem accusantium veniam, quasi! Explicabo accusantium sint, corporis consequuntur fugit ipsam, dolorum excepturi adipisci.</p>\r\n</div>\r\n</div>\r\n','','full_html'),('basic',0,10,11,'en',0,'<div class=\"gtco-contact-info\">\r\n<ul>\r\n	<li class=\"address\">198 West 21th Street, Suite 721 New York NY 10016</li>\r\n	<li class=\"phone\"><a href=\"tel://+919998564703\">+919998564703</a></li>\r\n	<li class=\"email\"><a href=\"mailto:suryagangwar281@gamil.com\">suryagangwar281@gamil.com</a></li>\r\n	<li class=\"url\"><a href=\"#\">http://drupal-cms.com</a></li>\r\n</ul>\r\n</div>\r\n','','full_html'),('basic',0,11,12,'en',0,'<div class=\"row row-pb-md\">\r\n<div class=\"col-md-8 col-md-offset-2 heading animate-box\" data-animate-effect=\"fadeIn\">\r\n<h1>Contact Us</h1>\r\n\r\n<p class=\"sub\">Dignissimos asperiores vitae velit veniam totam fuga molestias accusamus alias autem provident. Odit ab aliquam dolor eius.</p>\r\n\r\n<p class=\"subtle-text animate-box\" data-animate-effect=\"fadeIn\">Contact</p>\r\n</div>\r\n</div>\r\n','','full_html');
/*!40000 ALTER TABLE `block_content_revision__body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_bootstrap`
--

DROP TABLE IF EXISTS `cache_bootstrap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_bootstrap` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_bootstrap`
--

LOCK TABLES `cache_bootstrap` WRITE;
/*!40000 ALTER TABLE `cache_bootstrap` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_bootstrap` VALUES ('hook_info',_binary 'a:39:{s:10:\"token_info\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:16:\"token_info_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:6:\"tokens\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:12:\"tokens_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:10:\"views_data\";a:1:{s:5:\"group\";s:5:\"views\";}s:16:\"views_data_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:13:\"views_analyze\";a:1:{s:5:\"group\";s:5:\"views\";}s:22:\"views_invalidate_cache\";a:1:{s:5:\"group\";s:5:\"views\";}s:26:\"views_plugins_access_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:24:\"views_plugins_area_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:28:\"views_plugins_argument_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:36:\"views_plugins_argument_default_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:38:\"views_plugins_argument_validator_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:25:\"views_plugins_cache_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:36:\"views_plugins_display_extender_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:27:\"views_plugins_display_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:32:\"views_plugins_exposed_form_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:25:\"views_plugins_field_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:26:\"views_plugins_filter_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:24:\"views_plugins_join_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:25:\"views_plugins_pager_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:25:\"views_plugins_query_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:32:\"views_plugins_relationship_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:23:\"views_plugins_row_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:24:\"views_plugins_sort_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:25:\"views_plugins_style_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:26:\"views_plugins_wizard_alter\";a:1:{s:5:\"group\";s:5:\"views\";}s:25:\"views_query_substitutions\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:24:\"views_form_substitutions\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:14:\"views_pre_view\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:15:\"views_pre_build\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:16:\"views_post_build\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:17:\"views_pre_execute\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:18:\"views_post_execute\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:16:\"views_pre_render\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:17:\"views_post_render\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:17:\"views_query_alter\";a:1:{s:5:\"group\";s:15:\"views_execution\";}s:16:\"field_views_data\";a:1:{s:5:\"group\";s:5:\"views\";}s:22:\"field_views_data_alter\";a:1:{s:5:\"group\";s:5:\"views\";}}',-1,1540294709.173,1,'','0'),('system_list',_binary 'a:2:{s:5:\"theme\";a:5:{s:6:\"bartik\";C:31:\"Drupal\\Core\\Extension\\Extension\":2338:{a:16:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:34:\"core/themes/bartik/bartik.info.yml\";s:8:\"filename\";s:12:\"bartik.theme\";s:7:\"subpath\";s:13:\"themes/bartik\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:17:{s:4:\"name\";s:6:\"Bartik\";s:4:\"type\";s:5:\"theme\";s:10:\"base theme\";s:6:\"classy\";s:11:\"description\";s:86:\"A flexible, recolorable theme with many regions and a responsive, mobile-first layout.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:9:\"libraries\";a:1:{i:0;s:21:\"bartik/global-styling\";}s:20:\"ckeditor_stylesheets\";a:4:{i:0;s:21:\"css/base/elements.css\";i:1;s:27:\"css/components/captions.css\";i:2;s:24:\"css/components/table.css\";i:3;s:33:\"css/components/text-formatted.css\";}s:7:\"regions\";a:19:{s:6:\"header\";s:6:\"Header\";s:12:\"primary_menu\";s:12:\"Primary menu\";s:14:\"secondary_menu\";s:14:\"Secondary menu\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:12:\"featured_top\";s:12:\"Featured top\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:21:\"featured_bottom_first\";s:21:\"Featured bottom first\";s:22:\"featured_bottom_second\";s:22:\"Featured bottom second\";s:21:\"featured_bottom_third\";s:21:\"Featured bottom third\";s:12:\"footer_first\";s:12:\"Footer first\";s:13:\"footer_second\";s:13:\"Footer second\";s:12:\"footer_third\";s:12:\"Footer third\";s:13:\"footer_fourth\";s:13:\"Footer fourth\";s:12:\"footer_fifth\";s:12:\"Footer fifth\";}s:6:\"engine\";s:4:\"twig\";s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:33:\"core/themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1536580207;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"classy\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:0:{}s:8:\"requires\";a:2:{s:6:\"classy\";a:1:{s:4:\"name\";s:6:\"classy\";}s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-2;s:11:\"base_themes\";a:2:{s:6:\"stable\";s:6:\"Stable\";s:6:\"classy\";s:6:\"Classy\";}s:9:\"libraries\";a:1:{i:0;s:21:\"bartik/global-styling\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"classy\";}}s:6:\"classy\";C:31:\"Drupal\\Core\\Extension\\Extension\":2362:{a:17:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:34:\"core/themes/classy/classy.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:13:\"themes/classy\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Classy\";s:4:\"type\";s:5:\"theme\";s:11:\"description\";s:176:\"A base theme with sensible default CSS classes added. Learn how to use Classy as a base theme in the <a href=\"https://www.drupal.org/docs/8/theming\">Drupal 8 Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:9:\"libraries\";a:3:{i:0;s:11:\"classy/base\";i:1;s:15:\"classy/messages\";i:2;s:14:\"core/normalize\";}s:16:\"libraries-extend\";a:5:{s:16:\"user/drupal.user\";a:1:{i:0;s:11:\"classy/user\";}s:22:\"core/drupal.dropbutton\";a:1:{i:0;s:17:\"classy/dropbutton\";}s:18:\"core/drupal.dialog\";a:1:{i:0;s:13:\"classy/dialog\";}s:16:\"file/drupal.file\";a:1:{i:0;s:11:\"classy/file\";}s:20:\"core/drupal.progress\";a:1:{i:0;s:15:\"classy/progress\";}}s:6:\"engine\";s:4:\"twig\";s:10:\"base theme\";s:6:\"stable\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:12:\"primary_menu\";s:12:\"Primary menu\";s:14:\"secondary_menu\";s:14:\"Secondary menu\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";}s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:33:\"core/themes/classy/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1536580207;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"stable\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:2:{s:6:\"bartik\";a:1:{s:4:\"name\";s:6:\"classy\";}s:5:\"seven\";a:1:{s:4:\"name\";s:6:\"classy\";}}s:8:\"requires\";a:1:{s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-1;s:10:\"sub_themes\";a:2:{s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:11:\"base_themes\";a:1:{s:6:\"stable\";s:6:\"Stable\";}s:9:\"libraries\";a:3:{i:0;s:11:\"classy/base\";i:1;s:15:\"classy/messages\";i:2;s:14:\"core/normalize\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"stable\";}}s:5:\"seven\";C:31:\"Drupal\\Core\\Extension\\Extension\":3224:{a:16:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:32:\"core/themes/seven/seven.info.yml\";s:8:\"filename\";s:11:\"seven.theme\";s:7:\"subpath\";s:12:\"themes/seven\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:20:{s:4:\"name\";s:5:\"Seven\";s:4:\"type\";s:5:\"theme\";s:10:\"base theme\";s:6:\"classy\";s:11:\"description\";s:153:\"The default administration theme for Drupal 8 was designed with clean lines, simple blocks, and sans-serif font to emphasize the tools and tasks at hand.\";s:8:\"alt text\";s:77:\"Default administration theme for Drupal 8 with simple blocks and clean lines.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:9:\"libraries\";a:1:{i:0;s:20:\"seven/global-styling\";}s:18:\"libraries-override\";a:6:{s:11:\"system/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:3:{s:67:\"/core/themes/stable/css/system/components/system-status-counter.css\";s:40:\"css/components/system-status-counter.css\";s:75:\"/core/themes/stable/css/system/components/system-status-report-counters.css\";s:48:\"css/components/system-status-report-counters.css\";s:79:\"/core/themes/stable/css/system/components/system-status-report-general-info.css\";s:52:\"css/components/system-status-report-general-info.css\";}}}s:25:\"core/drupal.vertical-tabs\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"misc/vertical-tabs.css\";b:0;}}}s:14:\"core/jquery.ui\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:45:\"assets/vendor/jquery.ui/themes/base/theme.css\";b:0;}}}s:21:\"core/jquery.ui.dialog\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:46:\"assets/vendor/jquery.ui/themes/base/dialog.css\";b:0;}}}s:13:\"classy/dialog\";s:25:\"seven/seven.drupal.dialog\";s:11:\"classy/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:26:\"css/components/details.css\";b:0;}}}}s:16:\"libraries-extend\";a:4:{s:13:\"core/ckeditor\";a:1:{i:0;s:21:\"seven/ckeditor-dialog\";}s:25:\"core/drupal.vertical-tabs\";a:1:{i:0;s:19:\"seven/vertical-tabs\";}s:14:\"core/jquery.ui\";a:1:{i:0;s:21:\"seven/seven.jquery.ui\";}s:17:\"tour/tour-styling\";a:1:{i:0;s:18:\"seven/tour-styling\";}}s:21:\"quickedit_stylesheets\";a:1:{i:0;s:28:\"css/components/quickedit.css\";}s:7:\"regions\";a:9:{s:6:\"header\";s:6:\"Header\";s:11:\"pre_content\";s:11:\"Pre-content\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:6:\"engine\";s:4:\"twig\";s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:32:\"core/themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:1:{i:0;s:6:\"classy\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:0:{}s:8:\"requires\";a:2:{s:6:\"classy\";a:1:{s:4:\"name\";s:6:\"classy\";}s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-3;s:11:\"base_themes\";a:2:{s:6:\"stable\";s:6:\"Stable\";s:6:\"classy\";s:6:\"Classy\";}s:9:\"libraries\";a:1:{i:0;s:20:\"seven/global-styling\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"classy\";}}s:6:\"stable\";C:31:\"Drupal\\Core\\Extension\\Extension\":13206:{a:14:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:34:\"core/themes/stable/stable.info.yml\";s:8:\"filename\";s:12:\"stable.theme\";s:7:\"subpath\";s:13:\"themes/stable\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:16:{s:4:\"name\";s:6:\"Stable\";s:4:\"type\";s:5:\"theme\";s:11:\"description\";s:62:\"A default base theme using Drupal 8.0.0\'s core markup and CSS.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:18:\"libraries-override\";a:48:{s:24:\"block/drupal.block.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:19:\"css/block.admin.css\";s:25:\"css/block/block.admin.css\";}}}s:24:\"ckeditor/drupal.ckeditor\";a:1:{s:3:\"css\";a:1:{s:5:\"state\";a:1:{s:16:\"css/ckeditor.css\";s:25:\"css/ckeditor/ckeditor.css\";}}}s:51:\"ckeditor/drupal.ckeditor.plugins.drupalimagecaption\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:62:\"css/plugins/drupalimagecaption/ckeditor.drupalimagecaption.css\";s:71:\"css/ckeditor/plugins/drupalimagecaption/ckeditor.drupalimagecaption.css\";}}}s:41:\"ckeditor/drupal.ckeditor.plugins.language\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:42:\"css/plugins/language/ckeditor.language.css\";s:51:\"css/ckeditor/plugins/language/ckeditor.language.css\";}}}s:30:\"ckeditor/drupal.ckeditor.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:22:\"css/ckeditor.admin.css\";s:31:\"css/ckeditor/ckeditor.admin.css\";}}}s:11:\"color/admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:19:\"css/color.admin.css\";s:25:\"css/color/color.admin.css\";}}}s:50:\"config_translation/drupal.config_translation.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:32:\"css/config_translation.admin.css\";s:51:\"css/config_translation/config_translation.admin.css\";}}}s:52:\"content_translation/drupal.content_translation.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:33:\"css/content_translation.admin.css\";s:53:\"css/content_translation/content_translation.admin.css\";}}}s:37:\"content_moderation/content_moderation\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:33:\"css/content_moderation.module.css\";s:52:\"css/content_moderation/content_moderation.module.css\";}s:5:\"theme\";a:1:{s:32:\"css/content_moderation.theme.css\";s:51:\"css/content_moderation/content_moderation.theme.css\";}}}s:34:\"contextual/drupal.contextual-links\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:25:\"css/contextual.module.css\";s:36:\"css/contextual/contextual.module.css\";}s:5:\"theme\";a:2:{s:24:\"css/contextual.theme.css\";s:35:\"css/contextual/contextual.theme.css\";s:30:\"css/contextual.icons.theme.css\";s:41:\"css/contextual/contextual.icons.theme.css\";}}}s:36:\"contextual/drupal.contextual-toolbar\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:26:\"css/contextual.toolbar.css\";s:37:\"css/contextual/contextual.toolbar.css\";}}}s:29:\"core/drupal.dialog.off_canvas\";a:1:{s:3:\"css\";a:2:{s:4:\"base\";a:4:{s:32:\"misc/dialog/off-canvas.reset.css\";s:36:\"css/core/dialog/off-canvas.reset.css\";s:31:\"misc/dialog/off-canvas.base.css\";s:35:\"css/core/dialog/off-canvas.base.css\";s:26:\"misc/dialog/off-canvas.css\";s:30:\"css/core/dialog/off-canvas.css\";s:32:\"misc/dialog/off-canvas.theme.css\";s:36:\"css/core/dialog/off-canvas.theme.css\";}s:9:\"component\";a:8:{s:33:\"misc/dialog/off-canvas.motion.css\";s:37:\"css/core/dialog/off-canvas.motion.css\";s:33:\"misc/dialog/off-canvas.button.css\";s:37:\"css/core/dialog/off-canvas.button.css\";s:31:\"misc/dialog/off-canvas.form.css\";s:35:\"css/core/dialog/off-canvas.form.css\";s:32:\"misc/dialog/off-canvas.table.css\";s:36:\"css/core/dialog/off-canvas.table.css\";s:34:\"misc/dialog/off-canvas.details.css\";s:38:\"css/core/dialog/off-canvas.details.css\";s:36:\"misc/dialog/off-canvas.tabledrag.css\";s:40:\"css/core/dialog/off-canvas.tabledrag.css\";s:37:\"misc/dialog/off-canvas.dropbutton.css\";s:41:\"css/core/dialog/off-canvas.dropbutton.css\";s:33:\"misc/dialog/off-canvas.layout.css\";s:37:\"css/core/dialog/off-canvas.layout.css\";}}}s:22:\"core/drupal.dropbutton\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:30:\"misc/dropbutton/dropbutton.css\";s:34:\"css/core/dropbutton/dropbutton.css\";}}}s:25:\"core/drupal.vertical-tabs\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"misc/vertical-tabs.css\";s:26:\"css/core/vertical-tabs.css\";}}}s:18:\"dblog/drupal.dblog\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:20:\"css/dblog.module.css\";s:26:\"css/dblog/dblog.module.css\";}}}s:24:\"field_ui/drupal.field_ui\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:22:\"css/field_ui.admin.css\";s:31:\"css/field_ui/field_ui.admin.css\";}}}s:16:\"file/drupal.file\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:18:\"css/file.admin.css\";s:23:\"css/file/file.admin.css\";}}}s:26:\"filter/drupal.filter.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/filter.admin.css\";s:27:\"css/filter/filter.admin.css\";}}}s:20:\"filter/drupal.filter\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/filter.admin.css\";s:27:\"css/filter/filter.admin.css\";}}}s:14:\"filter/caption\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"css/filter.caption.css\";s:29:\"css/filter/filter.caption.css\";}}}s:11:\"image/admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:19:\"css/image.admin.css\";s:25:\"css/image/image.admin.css\";}}}s:35:\"image/quickedit.inPlaceEditor.image\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:21:\"css/editors/image.css\";s:27:\"css/image/editors/image.css\";}s:5:\"theme\";a:1:{s:27:\"css/editors/image.theme.css\";s:33:\"css/image/editors/image.theme.css\";}}}s:30:\"language/drupal.language.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:22:\"css/language.admin.css\";s:31:\"css/language/language.admin.css\";}}}s:26:\"locale/drupal.locale.admin\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:20:\"css/locale.admin.css\";s:27:\"css/locale/locale.admin.css\";}}}s:33:\"menu_ui/drupal.menu_ui.adminforms\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:21:\"css/menu_ui.admin.css\";s:29:\"css/menu_ui/menu_ui.admin.css\";}}}s:22:\"migrate_drupal_ui/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:49:\"css/components/upgrade-analysis-report-tables.css\";s:67:\"css/migrate_drupal_ui/components/upgrade-analysis-report-tables.css\";}}}s:16:\"node/drupal.node\";a:1:{s:3:\"css\";a:1:{s:6:\"layout\";a:1:{s:19:\"css/node.module.css\";s:24:\"css/node/node.module.css\";}}}s:24:\"node/drupal.node.preview\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/node.preview.css\";s:25:\"css/node/node.preview.css\";}}}s:9:\"node/form\";a:1:{s:3:\"css\";a:1:{s:6:\"layout\";a:1:{s:19:\"css/node.module.css\";s:24:\"css/node/node.module.css\";}}}s:22:\"node/drupal.node.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:18:\"css/node.admin.css\";s:23:\"css/node/node.admin.css\";}}}s:19:\"quickedit/quickedit\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:24:\"css/quickedit.module.css\";s:34:\"css/quickedit/quickedit.module.css\";}s:5:\"theme\";a:2:{s:23:\"css/quickedit.theme.css\";s:33:\"css/quickedit/quickedit.theme.css\";s:29:\"css/quickedit.icons.theme.css\";s:39:\"css/quickedit/quickedit.icons.theme.css\";}}}s:34:\"settings_tray/drupal.settings_tray\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:3:{s:28:\"css/settings_tray.module.css\";s:42:\"css/settings_tray/settings_tray.module.css\";s:28:\"css/settings_tray.motion.css\";s:42:\"css/settings_tray/settings_tray.motion.css\";s:29:\"css/settings_tray.toolbar.css\";s:43:\"css/settings_tray/settings_tray.toolbar.css\";}s:5:\"theme\";a:1:{s:27:\"css/settings_tray.theme.css\";s:41:\"css/settings_tray/settings_tray.theme.css\";}}}s:24:\"shortcut/drupal.shortcut\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:2:{s:22:\"css/shortcut.theme.css\";s:31:\"css/shortcut/shortcut.theme.css\";s:28:\"css/shortcut.icons.theme.css\";s:37:\"css/shortcut/shortcut.icons.theme.css\";}}}s:28:\"simpletest/drupal.simpletest\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:25:\"css/simpletest.module.css\";s:36:\"css/simpletest/simpletest.module.css\";}}}s:11:\"system/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:22:{s:39:\"css/components/ajax-progress.module.css\";s:46:\"css/system/components/ajax-progress.module.css\";s:31:\"css/components/align.module.css\";s:38:\"css/system/components/align.module.css\";s:46:\"css/components/autocomplete-loading.module.css\";s:53:\"css/system/components/autocomplete-loading.module.css\";s:36:\"css/components/fieldgroup.module.css\";s:43:\"css/system/components/fieldgroup.module.css\";s:42:\"css/components/container-inline.module.css\";s:49:\"css/system/components/container-inline.module.css\";s:34:\"css/components/clearfix.module.css\";s:41:\"css/system/components/clearfix.module.css\";s:33:\"css/components/details.module.css\";s:40:\"css/system/components/details.module.css\";s:32:\"css/components/hidden.module.css\";s:39:\"css/system/components/hidden.module.css\";s:35:\"css/components/item-list.module.css\";s:42:\"css/system/components/item-list.module.css\";s:28:\"css/components/js.module.css\";s:35:\"css/system/components/js.module.css\";s:32:\"css/components/nowrap.module.css\";s:39:\"css/system/components/nowrap.module.css\";s:44:\"css/components/position-container.module.css\";s:51:\"css/system/components/position-container.module.css\";s:34:\"css/components/progress.module.css\";s:41:\"css/system/components/progress.module.css\";s:42:\"css/components/reset-appearance.module.css\";s:49:\"css/system/components/reset-appearance.module.css\";s:32:\"css/components/resize.module.css\";s:39:\"css/system/components/resize.module.css\";s:39:\"css/components/sticky-header.module.css\";s:46:\"css/system/components/sticky-header.module.css\";s:40:\"css/components/system-status-counter.css\";s:47:\"css/system/components/system-status-counter.css\";s:48:\"css/components/system-status-report-counters.css\";s:55:\"css/system/components/system-status-report-counters.css\";s:52:\"css/components/system-status-report-general-info.css\";s:59:\"css/system/components/system-status-report-general-info.css\";s:35:\"css/components/tabledrag.module.css\";s:42:\"css/system/components/tabledrag.module.css\";s:35:\"css/components/tablesort.module.css\";s:42:\"css/system/components/tablesort.module.css\";s:36:\"css/components/tree-child.module.css\";s:43:\"css/system/components/tree-child.module.css\";}}}s:12:\"system/admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/system.admin.css\";s:27:\"css/system/system.admin.css\";}}}s:18:\"system/maintenance\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:26:\"css/system.maintenance.css\";s:33:\"css/system/system.maintenance.css\";}}}s:11:\"system/diff\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:19:\"css/system.diff.css\";s:26:\"css/system/system.diff.css\";}}}s:24:\"taxonomy/drupal.taxonomy\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"css/taxonomy.theme.css\";s:31:\"css/taxonomy/taxonomy.theme.css\";}}}s:15:\"toolbar/toolbar\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:22:\"css/toolbar.module.css\";s:30:\"css/toolbar/toolbar.module.css\";}s:5:\"theme\";a:2:{s:21:\"css/toolbar.theme.css\";s:29:\"css/toolbar/toolbar.theme.css\";s:27:\"css/toolbar.icons.theme.css\";s:35:\"css/toolbar/toolbar.icons.theme.css\";}}}s:20:\"toolbar/toolbar.menu\";a:1:{s:3:\"css\";a:1:{s:5:\"state\";a:1:{s:20:\"css/toolbar.menu.css\";s:28:\"css/toolbar/toolbar.menu.css\";}}}s:17:\"tour/tour-styling\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:19:\"css/tour.module.css\";s:24:\"css/tour/tour.module.css\";}}}s:26:\"update/drupal.update.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:26:\"css/update.admin.theme.css\";s:33:\"css/update/update.admin.theme.css\";}}}s:16:\"user/drupal.user\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:19:\"css/user.module.css\";s:24:\"css/user/user.module.css\";}}}s:22:\"user/drupal.user.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:18:\"css/user.admin.css\";s:23:\"css/user/user.admin.css\";}}}s:22:\"user/drupal.user.icons\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:24:\"css/user.icons.admin.css\";s:29:\"css/user/user.icons.admin.css\";}}}s:18:\"views/views.module\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:20:\"css/views.module.css\";s:26:\"css/views/views.module.css\";}}}s:22:\"views_ui/admin.styling\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:22:\"css/views_ui.admin.css\";s:31:\"css/views_ui/views_ui.admin.css\";}s:5:\"theme\";a:2:{s:28:\"css/views_ui.admin.theme.css\";s:37:\"css/views_ui/views_ui.admin.theme.css\";s:27:\"css/views_ui.contextual.css\";s:36:\"css/views_ui/views_ui.contextual.css\";}}}}s:6:\"engine\";s:4:\"twig\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:12:\"primary_menu\";s:12:\"Primary menu\";s:14:\"secondary_menu\";s:14:\"Secondary menu\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";}s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:33:\"core/themes/stable/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:9:\"libraries\";a:0:{}s:5:\"mtime\";i:1536580207;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:5:{s:6:\"classy\";a:1:{s:4:\"name\";s:6:\"stable\";}s:6:\"bartik\";a:1:{s:4:\"name\";s:6:\"stable\";}s:5:\"seven\";a:1:{s:4:\"name\";s:6:\"stable\";}s:6:\"cowork\";a:1:{s:4:\"name\";s:6:\"stable\";}s:7:\"justice\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:8:\"requires\";a:0:{}s:4:\"sort\";i:0;s:10:\"sub_themes\";a:5:{s:6:\"bartik\";s:6:\"Bartik\";s:6:\"classy\";s:6:\"Classy\";s:5:\"seven\";s:5:\"Seven\";s:6:\"cowork\";s:35:\"Cowork One Page Responsive Template\";s:7:\"justice\";s:7:\"justice\";}s:6:\"engine\";s:4:\"twig\";}}s:7:\"justice\";C:31:\"Drupal\\Core\\Extension\\Extension\":1869:{a:16:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:38:\"themes/custom/justice/justice.info.yml\";s:8:\"filename\";s:13:\"justice.theme\";s:7:\"subpath\";s:21:\"themes/custom/justice\";s:6:\"origin\";s:0:\"\";s:6:\"status\";i:1;s:4:\"info\";a:18:{s:4:\"name\";s:7:\"justice\";s:4:\"type\";s:5:\"theme\";s:11:\"description\";s:48:\"Justice is a one page Bootstrap HTML5 base theme\";s:7:\"package\";s:7:\"theming\";s:9:\"libraries\";a:2:{i:0;s:22:\"justice/global-styling\";i:1;s:23:\"justice/justice-styling\";}s:7:\"regions\";a:13:{s:8:\"branding\";s:13:\"Site Branding\";s:10:\"navigation\";s:10:\"Navigation\";s:7:\"top_bar\";s:7:\"Top Bar\";s:16:\"home_page_banner\";s:15:\"Home Page Banne\";s:8:\"about_us\";s:8:\"About Us\";s:14:\"practice_areas\";s:14:\"Practice Areas\";s:8:\"our_team\";s:8:\"Our Team\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar First\";s:14:\"sidebar_second\";s:14:\"Sidebar Second\";s:7:\"contact\";s:7:\"Contact\";s:6:\"footer\";s:6:\"Footer\";s:12:\"social_media\";s:12:\"Social Media\";}s:7:\"version\";s:11:\"8.x-5.x-dev\";s:4:\"core\";s:3:\"8.x\";s:7:\"project\";s:7:\"justice\";s:9:\"datestamp\";i:1526042904;s:6:\"engine\";s:4:\"twig\";s:10:\"base theme\";s:6:\"stable\";s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:36:\"themes/custom/justice/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1540291313;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"stable\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:0:{}s:8:\"requires\";a:1:{s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-5;s:11:\"base_themes\";a:1:{s:6:\"stable\";s:6:\"Stable\";}s:9:\"libraries\";a:2:{i:0;s:22:\"justice/global-styling\";i:1;s:23:\"justice/justice-styling\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"stable\";}}}s:9:\"filepaths\";a:5:{i:0;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:6:\"bartik\";s:8:\"filepath\";s:34:\"core/themes/bartik/bartik.info.yml\";}i:1;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:6:\"classy\";s:8:\"filepath\";s:34:\"core/themes/classy/classy.info.yml\";}i:2;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:5:\"seven\";s:8:\"filepath\";s:32:\"core/themes/seven/seven.info.yml\";}i:3;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:6:\"stable\";s:8:\"filepath\";s:34:\"core/themes/stable/stable.info.yml\";}i:4;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:7:\"justice\";s:8:\"filepath\";s:38:\"themes/custom/justice/justice.info.yml\";}}}',-1,1540294709.177,1,'','0');
/*!40000 ALTER TABLE `cache_bootstrap` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_config`
--

DROP TABLE IF EXISTS `cache_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_config` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_config`
--

LOCK TABLES `cache_config` WRITE;
/*!40000 ALTER TABLE `cache_config` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_config` VALUES ('block.block.aboutus',_binary 'a:12:{s:4:\"uuid\";s:36:\"19bd1239-abdc-48e1-88cd-361de22cf485\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b2311339-bbd3-476c-a3e0-1ec52517bf54\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:7:\"aboutus\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:8:\"about_us\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b2311339-bbd3-476c-a3e0-1ec52517bf54\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b2311339-bbd3-476c-a3e0-1ec52517bf54\";s:5:\"label\";s:8:\"About US\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.bartik_account_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"c9a468ba-c37d-4438-ac97-a98b26cbf506\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:19:\"system.menu.account\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DweBpscQZdG0-fHkSpUzdYucrNH45G_KF7Z82V-oyQM\";}s:2:\"id\";s:19:\"bartik_account_menu\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:14:\"secondary_menu\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:25:\"system_menu_block:account\";s:8:\"settings\";a:6:{s:2:\"id\";s:25:\"system_menu_block:account\";s:5:\"label\";s:17:\"User account menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_branding',_binary 'a:13:{s:4:\"uuid\";s:36:\"bc41e0f1-65b2-4e8d-8fca-8cc98d42043a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NDwadleLD3YVSbDUaakxyYZyINYtkFtOVGShfq4kWy8\";}s:2:\"id\";s:15:\"bartik_branding\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_breadcrumbs',_binary 'a:13:{s:4:\"uuid\";s:36:\"0c14917b-2ced-498e-9fc0-2f02b4517917\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oXUb3JZR2WW5VOdw4HrhRicCsq51mCgLfRyvheG68ck\";}s:2:\"id\";s:18:\"bartik_breadcrumbs\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:10:\"breadcrumb\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"d9f91af5-4a48-40e5-b9f5-0032468739aa\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9EoWV2Lot6FVSr50t4hoKgiz1LIXYWNG-IIPYsWxBqo\";}s:2:\"id\";s:14:\"bartik_content\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_footer',_binary 'a:13:{s:4:\"uuid\";s:36:\"bffa31a0-5cb6-411e-b8f7-671634564c49\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:18:\"system.menu.footer\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kkISXE1LT2FJEoYnqCrCpeFB-2pmGmMxMklVk7rQcfg\";}s:2:\"id\";s:13:\"bartik_footer\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:12:\"footer_fifth\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:24:\"system_menu_block:footer\";s:8:\"settings\";a:6:{s:2:\"id\";s:24:\"system_menu_block:footer\";s:5:\"label\";s:11:\"Footer menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"a737de56-27fb-4d37-8f65-67419bc1b268\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8I8iACSa0sKO3k3jlvUG1ge52rfcKX7USJAQYnzuBgg\";}s:2:\"id\";s:11:\"bartik_help\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_local_actions',_binary 'a:13:{s:4:\"uuid\";s:36:\"2d00ca46-356d-410e-83ac-52a1af2d16c2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"13GQpeITIJsp1kyPniXtWZfyFH87vb1xxJCHifL4UeE\";}s:2:\"id\";s:20:\"bartik_local_actions\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-20;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"bf29a35d-8303-4e72-81a9-6b50c6652eba\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"X9I1OB0W3WlWtrK-CNcg6hNWwa8wficanpH8pYnDZDE\";}s:2:\"id\";s:18:\"bartik_local_tasks\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-40;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:4:\"Tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_main_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"bdb8507f-f9ca-4c0c-8da6-1efead8376cc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rx9IrdDv7Ldc4kpalZAxdhIPZfYIeOMh1N-qKoQZwHo\";}s:2:\"id\";s:16:\"bartik_main_menu\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:12:\"primary_menu\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:22:\"system_menu_block:main\";s:8:\"settings\";a:6:{s:2:\"id\";s:22:\"system_menu_block:main\";s:5:\"label\";s:15:\"Main navigation\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"3fe30bca-4df3-48e6-921f-47fc8a819f91\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KHQIJ7Vfl25lTjzIc7qIvnuistt-Mw2O0kG4jCofmkI\";}s:2:\"id\";s:15:\"bartik_messages\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"51173fd1-d55e-44c1-8b86-1f2e5c2290ba\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7rR9chwXvdM2H8OYMAYx9Zj3GGlPMrZp_M3ZA4thYTk\";}s:2:\"id\";s:17:\"bartik_page_title\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-50;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_powered',_binary 'a:13:{s:4:\"uuid\";s:36:\"878721c6-46a3-4ad3-a296-ece0f089d3f0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jQQUUWN2Uxr5qZtc9zcJKBCxpKY8orN1u2HPqYYRQDI\";}s:2:\"id\";s:14:\"bartik_powered\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:12:\"footer_fifth\";s:6:\"weight\";i:10;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_powered_by_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_powered_by_block\";s:5:\"label\";s:17:\"Powered by Drupal\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_search',_binary 'a:13:{s:4:\"uuid\";s:36:\"39dc9b33-ab89-4da5-af5e-c5d2b8574148\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"search\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"za-39d5WDUg6XvbyqSnuVYEeq6QM4qKJxW8MnoAha5A\";}s:2:\"id\";s:13:\"bartik_search\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"search_form_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"search_form_block\";s:5:\"label\";s:6:\"Search\";s:8:\"provider\";s:6:\"search\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.bartik_tools',_binary 'a:13:{s:4:\"uuid\";s:36:\"8f0dcbbc-0ab1-4035-ac62-47db9b0160dd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:17:\"system.menu.tools\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NeHSoqm4XFqA7_0bDmR429ZZQt3LRbZMNRJTMsFyOfI\";}s:2:\"id\";s:12:\"bartik_tools\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_menu_block:tools\";s:8:\"settings\";a:6:{s:2:\"id\";s:23:\"system_menu_block:tools\";s:5:\"label\";s:5:\"Tools\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:7:\"visible\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}',-1,1540294709.194,1,'','0'),('block.block.contactblock',_binary 'a:13:{s:4:\"uuid\";s:36:\"30a3d876-55e5-487a-ab67-ee9b2ba6589e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:21:\"contact.form.feedback\";}s:6:\"module\";a:3:{i:0;s:11:\"block_class\";i:1;s:13:\"contact_block\";i:2;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:34:\"col-md-6 col-md-push-6 animate-box\";}}s:2:\"id\";s:12:\"contactblock\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"contact\";s:6:\"weight\";i:-9;s:8:\"provider\";N;s:6:\"plugin\";s:13:\"contact_block\";s:8:\"settings\";a:5:{s:2:\"id\";s:13:\"contact_block\";s:5:\"label\";s:13:\"Contact block\";s:8:\"provider\";s:13:\"contact_block\";s:13:\"label_display\";s:1:\"0\";s:12:\"contact_form\";s:8:\"feedback\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.contactus',_binary 'a:13:{s:4:\"uuid\";s:36:\"89f3d8b2-f40e-426d-86c4-cb3fdf8866c8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:342a6d52-2574-4715-ba9d-33a1b621cb88\";}s:6:\"module\";a:3:{i:0;s:11:\"block_class\";i:1;s:13:\"block_content\";i:2;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:34:\"col-md-4 col-md-pull-6 animate-box\";}}s:2:\"id\";s:9:\"contactus\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"contact\";s:6:\"weight\";i:-8;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:342a6d52-2574-4715-ba9d-33a1b621cb88\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:342a6d52-2574-4715-ba9d-33a1b621cb88\";s:5:\"label\";s:10:\"Contact Us\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.contentinfotitle',_binary 'a:12:{s:4:\"uuid\";s:36:\"48c65ea9-2308-42d4-8edc-7a676f524b87\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:36888687-d0d1-49c9-8bb2-77cac2d2666c\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:16:\"contentinfotitle\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"contact\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:36888687-d0d1-49c9-8bb2-77cac2d2666c\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:36888687-d0d1-49c9-8bb2-77cac2d2666c\";s:5:\"label\";s:18:\"content info title\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.homepagebannertext',_binary 'a:12:{s:4:\"uuid\";s:36:\"2fc0a04c-094a-4c24-b349-da9505e28957\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:48f3ff65-fa94-4d14-ac71-9ba2d9ecb411\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:18:\"homepagebannertext\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:16:\"home_page_banner\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:48f3ff65-fa94-4d14-ac71-9ba2d9ecb411\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:48f3ff65-fa94-4d14-ac71-9ba2d9ecb411\";s:5:\"label\";s:22:\"Home Page Banner Text \";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.justice_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"cb53df72-fa2f-4662-84ed-741e0d4f0e59\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fNNLN48MSGSLiqwIFywCuxH2Dk_IxDbaP0kYhg_IPrg\";}s:2:\"id\";s:15:\"justice_content\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block.block.justice_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"89364af3-94dc-4306-bce0-175d4abdf0c6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"MhtNdV__HKRTab0ZPjkPNfYL4Ng4UPBucDLoC7Rg5Eo\";}s:2:\"id\";s:12:\"justice_help\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"top_bar\";s:6:\"weight\";i:-6;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block.block.justice_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"370ed465-768f-409c-a5c6-76e18e59f263\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9RnnTUBcn0WRWXfrGOnId2H0Q31uQUeu_F5TnDxl2yg\";}s:2:\"id\";s:16:\"justice_messages\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"top_bar\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block.block.justice_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"788d55ca-8a56-44d9-9525-2effbcc9c002\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1TQP4b3ZnlzvIH9bj6cpCz_SyUHdJjLQkZnHpikjjhw\";}s:2:\"id\";s:18:\"justice_page_title\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"top_bar\";s:6:\"weight\";i:-5;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block.block.justice_search',_binary 'a:13:{s:4:\"uuid\";s:36:\"aa7516a1-78b6-41c7-8292-d4adee150209\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:2:{i:0;s:6:\"search\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"F3d5hyAFunLh4PhGviJF019fHn1Z3_zy5gzsQ0tX1K0\";}s:2:\"id\";s:14:\"justice_search\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"search_form_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"search_form_block\";s:5:\"label\";s:6:\"Search\";s:8:\"provider\";s:6:\"search\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:1;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.mainnavigation_2',_binary 'a:12:{s:4:\"uuid\";s:36:\"269853f6-e94c-489b-be6d-b93fd658edf1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:16:\"mainnavigation_2\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:-6;s:8:\"provider\";N;s:6:\"plugin\";s:22:\"system_menu_block:main\";s:8:\"settings\";a:6:{s:2:\"id\";s:22:\"system_menu_block:main\";s:5:\"label\";s:15:\"Main navigation\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block.block.ourteam',_binary 'a:12:{s:4:\"uuid\";s:36:\"f20f488a-51d6-4a07-a76b-f8d36a941c2b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:faf60d22-96bd-4cb9-b755-76962ba13b03\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:7:\"ourteam\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:8:\"our_team\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:faf60d22-96bd-4cb9-b755-76962ba13b03\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:faf60d22-96bd-4cb9-b755-76962ba13b03\";s:5:\"label\";s:8:\"Our Team\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.powerbycompany',_binary 'a:13:{s:4:\"uuid\";s:36:\"3a5041d3-b995-4106-b633-b567de5037f9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:1cc39cd6-2ba8-486a-8ee3-ee52fb37c772\";}s:6:\"module\";a:2:{i:0;s:11:\"block_class\";i:1;s:13:\"block_content\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:9:\"pull-left\";}}s:2:\"id\";s:14:\"powerbycompany\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:6:\"footer\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:1cc39cd6-2ba8-486a-8ee3-ee52fb37c772\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:1cc39cd6-2ba8-486a-8ee3-ee52fb37c772\";s:5:\"label\";s:16:\"Power By company\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block.block.practiceareas',_binary 'a:12:{s:4:\"uuid\";s:36:\"e5488b49-86c8-47fc-8585-c14f5c82b399\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:27c4769c-fa48-4193-8c80-d3167875cca4\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:13:\"practiceareas\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:14:\"practice_areas\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:27c4769c-fa48-4193-8c80-d3167875cca4\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:27c4769c-fa48-4193-8c80-d3167875cca4\";s:5:\"label\";s:14:\"Practice Areas\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}',-1,1540294709.208,1,'','0'),('block.block.seven_breadcrumbs',_binary 'a:13:{s:4:\"uuid\";s:36:\"7d402b08-83ae-4e19-985e-84fd96958d64\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WWu2OQswgCztl9OeXjD1stexIEMZsSgPMYIdC-JHx9c\";}s:2:\"id\";s:17:\"seven_breadcrumbs\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:10:\"breadcrumb\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"21a7dcd0-f294-4dd2-9cce-1d86fd3f3f47\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YRY68JWkaUiGeZlWMv1nzeIgDm0ZZwXYgpqUpLFzwAY\";}s:2:\"id\";s:13:\"seven_content\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"cd5176e8-5c8d-489a-956a-212e1af9f742\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NU5A_49mwLHfs5xFzMFrZ850w9pgUolxMS9NNF3vv4c\";}s:2:\"id\";s:10:\"seven_help\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:4:\"help\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_local_actions',_binary 'a:13:{s:4:\"uuid\";s:36:\"1761c270-a1e6-47b8-a403-19fd7d2a3764\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"HHryZVJbeKi9WnuBGC8FOhBZmBnk2G1H6KxFuy-rC9A\";}s:2:\"id\";s:19:\"seven_local_actions\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_login',_binary 'a:13:{s:4:\"uuid\";s:36:\"4f34c925-e599-42df-9c50-153df2d8609e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"IItlF4SKHgxduIysVQdvirDJ_v3HGuAviOkidAOJYRE\";}s:2:\"id\";s:11:\"seven_login\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:10;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"user_login_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"user_login_block\";s:5:\"label\";s:10:\"User login\";s:8:\"provider\";s:4:\"user\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"d799da0e-1a16-4778-bd61-a62887e50e5a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XJqWwLt1LDCnazcEN6QkJmCLjk4R0__-8s0OO9xeNjg\";}s:2:\"id\";s:14:\"seven_messages\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"ab63c563-08ef-4571-88fe-2ff3f51a840f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ZSpc3IoSaLd0PkB02nxjVPBMztIdsTdHek9SiGaqZ_c\";}s:2:\"id\";s:16:\"seven_page_title\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_primary_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"6e4b0270-602b-4a46-ae90-24dfe257b248\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ddy1OsBbWxjwEI8VL1viD4I69qcLHOkul4BxbTqLBTs\";}s:2:\"id\";s:25:\"seven_primary_local_tasks\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:12:\"Primary tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:0;}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.seven_secondary_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"1caa940e-0c1d-409a-8d6b-5391707ce5d1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QeZBeCilQfeET3GeW6ZtJkEiwROADTZktFgKWwPieD4\";}s:2:\"id\";s:27:\"seven_secondary_local_tasks\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:11:\"pre_content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:14:\"Secondary tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:0;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}',-1,1540294709.200,1,'','0'),('block.block.sitebranding',_binary 'a:12:{s:4:\"uuid\";s:36:\"8f5f2569-87e9-437f-b39f-b9e013558e7e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:12:\"sitebranding\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block.block.socialmedialink',_binary 'a:13:{s:4:\"uuid\";s:36:\"7bdc1e2f-1880-4e13-a188-41c30188e4b0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:69b28a06-16c3-4192-bdfb-3e8718c35702\";}s:6:\"module\";a:2:{i:0;s:11:\"block_class\";i:1;s:13:\"block_content\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:10:\"pull-right\";}}s:2:\"id\";s:15:\"socialmedialink\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:12:\"social_media\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:69b28a06-16c3-4192-bdfb-3e8718c35702\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:69b28a06-16c3-4192-bdfb-3e8718c35702\";s:5:\"label\";s:17:\"Social Media Link\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:0:{}}',-1,1540294709.208,1,'','0'),('block_content.type.basic',_binary 'a:9:{s:4:\"uuid\";s:36:\"980a1874-9109-4ca4-8a1a-2615ef7a0ba2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zglzjmYxi0G0ag9MZ02y0LSJOdpWRwJxyP_OvFojFyo\";}s:2:\"id\";s:5:\"basic\";s:5:\"label\";s:11:\"Basic block\";s:8:\"revision\";i:0;s:11:\"description\";s:42:\"A basic block contains a title and a body.\";}',-1,1540294709.980,1,'','0'),('comment.type.comment',_binary 'a:9:{s:4:\"uuid\";s:36:\"05ccd90a-c7b2-45f4-b6cc-cc1136bec740\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"bqZsN31T2n0UjcbyCpOPi9D2iO0sAOHR7FnEs9qMvaA\";}s:2:\"id\";s:7:\"comment\";s:5:\"label\";s:16:\"Default comments\";s:21:\"target_entity_type_id\";s:4:\"node\";s:11:\"description\";s:28:\"Allows commenting on content\";}',-1,1540294709.983,1,'','0'),('comment.type.migrate_example_advanced_comment',_binary 'a:9:{s:4:\"uuid\";s:36:\"1d023fb1-3275-4c7e-aee4-a535f43aa0de\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UVmAi942I-2Z_YDnpwk48PlAQKlKkL3W6wEENgQuqEU\";}s:2:\"id\";s:32:\"migrate_example_advanced_comment\";s:5:\"label\";s:13:\"Node comments\";s:21:\"target_entity_type_id\";s:4:\"node\";s:11:\"description\";s:0:\"\";}',-1,1540294709.983,1,'','0'),('comment.type.node_comments',_binary 'a:9:{s:4:\"uuid\";s:36:\"3ddbde0f-8b00-4ff9-87a0-d999813a1877\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_iidyBpZhk61ekfCNeZlPQe6CTRTRGvu6s0XtxltmQ8\";}s:2:\"id\";s:13:\"node_comments\";s:5:\"label\";s:13:\"Node comments\";s:21:\"target_entity_type_id\";s:4:\"node\";s:11:\"description\";s:0:\"\";}',-1,1540294709.983,1,'','0'),('contact.form.feedback',_binary 'a:12:{s:4:\"uuid\";s:36:\"e9fa7b4d-e502-42d8-ab68-b6aa97c4ef44\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vymHlgJy26BuI5GGj9-IXjwR3dRC5C0tij4BpWJnoqw\";}s:2:\"id\";s:8:\"feedback\";s:5:\"label\";s:16:\"Website feedback\";s:10:\"recipients\";a:1:{i:0;s:15:\"admin@admin.com\";}s:5:\"reply\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"message\";s:27:\"Your message has been sent.\";s:8:\"redirect\";s:0:\"\";}',-1,1540294709.992,1,'','0'),('contact.form.personal',_binary 'a:12:{s:4:\"uuid\";s:36:\"ad8d038d-72e3-4c11-9047-f6e440521081\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jonvgt3CkUM2eMLTFwWfHileWWDC4YtXCuIlCahTk_I\";}s:2:\"id\";s:8:\"personal\";s:5:\"label\";s:21:\"Personal contact form\";s:10:\"recipients\";a:0:{}s:5:\"reply\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"message\";s:27:\"Your message has been sent.\";s:8:\"redirect\";s:0:\"\";}',-1,1540294709.992,1,'','0'),('core.base_field_override.block_content.basic.changed',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.default_langcode',_binary 'b:0;',-1,1540294710.522,1,'','0'),('core.base_field_override.block_content.basic.id',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.info',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.langcode',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.moderation_state',_binary 'b:0;',-1,1540294710.522,1,'','0'),('core.base_field_override.block_content.basic.reusable',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.revision_created',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.revision_default',_binary 'b:0;',-1,1540294710.522,1,'','0'),('core.base_field_override.block_content.basic.revision_id',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.revision_log',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.revision_translation_affected',_binary 'b:0;',-1,1540294710.522,1,'','0'),('core.base_field_override.block_content.basic.revision_user',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.status',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.type',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.block_content.basic.uuid',_binary 'b:0;',-1,1540294710.521,1,'','0'),('core.base_field_override.comment.comment.changed',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.cid',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.comment_type',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.created',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.default_langcode',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.entity_id',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.entity_type',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.field_name',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.homepage',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.hostname',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.langcode',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.mail',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.name',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.pid',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.status',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.subject',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.thread',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.uid',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.comment.uuid',_binary 'b:0;',-1,1540294710.638,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.changed',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.cid',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.comment_type',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.created',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.default_langcode',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.entity_id',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.entity_type',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.field_name',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.homepage',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.hostname',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.langcode',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.mail',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.name',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.pid',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.status',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.subject',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.thread',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.uid',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.migrate_example_advanced_comment.uuid',_binary 'b:0;',-1,1540294710.708,1,'','0'),('core.base_field_override.comment.node_comments.changed',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.cid',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.comment_type',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.created',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.default_langcode',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.entity_id',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.entity_type',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.field_name',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.homepage',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.hostname',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.langcode',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.mail',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.name',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.pid',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.status',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.subject',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.thread',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.uid',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.comment.node_comments.uuid',_binary 'b:0;',-1,1540294710.725,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.bundle',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.changed',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.default_langcode',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.description',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.enabled',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.expanded',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.external',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.id',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.langcode',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.link',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.menu_name',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.parent',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.rediscover',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.title',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.uuid',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.menu_link_content.menu_link_content.weight',_binary 'b:0;',-1,1540294711.891,1,'','0'),('core.base_field_override.node.article.changed',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.created',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.default_langcode',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.langcode',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.moderation_state',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.nid',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.path',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.promote',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.revision_default',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.revision_log',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.revision_timestamp',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.revision_translation_affected',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.revision_uid',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.status',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.sticky',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.title',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.type',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.uid',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.uuid',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.article.vid',_binary 'b:0;',-1,1540294710.785,1,'','0'),('core.base_field_override.node.migrate_example_beer.changed',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.created',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.default_langcode',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.langcode',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.moderation_state',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.nid',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.path',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.promote',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.revision_default',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.revision_log',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.revision_timestamp',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.revision_translation_affected',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.revision_uid',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.status',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.sticky',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.title',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.type',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.uid',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.uuid',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_beer.vid',_binary 'b:0;',-1,1540294710.809,1,'','0'),('core.base_field_override.node.migrate_example_producer.changed',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.created',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.default_langcode',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.langcode',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.moderation_state',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.nid',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.path',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.promote',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.revision_default',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.revision_log',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.revision_timestamp',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.revision_translation_affected',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.revision_uid',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.status',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.sticky',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.title',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.type',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.uid',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.uuid',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_producer.vid',_binary 'b:0;',-1,1540294710.833,1,'','0'),('core.base_field_override.node.migrate_example_wine.changed',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.created',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.default_langcode',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.langcode',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.moderation_state',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.nid',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.path',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.promote',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.revision_default',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.revision_log',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.revision_timestamp',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.revision_translation_affected',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.revision_uid',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.status',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.sticky',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.title',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.type',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.uid',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.uuid',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.migrate_example_wine.vid',_binary 'b:0;',-1,1540294710.859,1,'','0'),('core.base_field_override.node.page.changed',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.created',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.default_langcode',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.langcode',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.moderation_state',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.nid',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.path',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.promote',_binary 'a:17:{s:4:\"uuid\";s:36:\"bc5657f1-35bc-4b89-a06e-1d160e0b66f7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:14:\"node.type.page\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fPUEnm4T5zfZRr3ttDUqq7yCDd2uW3clWD-pvos4tlQ\";}s:2:\"id\";s:17:\"node.page.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.revision_default',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.revision_log',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.revision_timestamp',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.revision_translation_affected',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.revision_uid',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.status',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.sticky',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.title',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.type',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.uid',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.uuid',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.node.page.vid',_binary 'b:0;',-1,1540294710.884,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.changed',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.default_langcode',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.description',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.langcode',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.name',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.parent',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.path',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.status',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.tid',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.uuid',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.vid',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_beer_styles.weight',_binary 'b:0;',-1,1540294710.912,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.changed',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.default_langcode',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.description',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.langcode',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.name',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.parent',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.path',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.status',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.tid',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.uuid',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.vid',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_best_with.weight',_binary 'b:0;',-1,1540294710.927,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.changed',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.default_langcode',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.description',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.langcode',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.name',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.parent',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.path',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.status',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.tid',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.uuid',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.vid',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_regions.weight',_binary 'b:0;',-1,1540294710.945,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.changed',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.default_langcode',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.description',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.langcode',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.name',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.parent',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.path',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.status',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.tid',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.uuid',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.vid',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.migrate_example_wine_varieties.weight',_binary 'b:0;',-1,1540294710.962,1,'','0'),('core.base_field_override.taxonomy_term.tags.changed',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.default_langcode',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.description',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.langcode',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.name',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.parent',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.path',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.status',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.tid',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.uuid',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.vid',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.taxonomy_term.tags.weight',_binary 'b:0;',-1,1540294710.979,1,'','0'),('core.base_field_override.user.user.access',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.changed',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.created',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.default_langcode',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.init',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.langcode',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.login',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.mail',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.name',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.pass',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.preferred_admin_langcode',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.preferred_langcode',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.roles',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.status',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.timezone',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.uid',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.base_field_override.user.user.uuid',_binary 'b:0;',-1,1540294711.005,1,'','0'),('core.extension',_binary 'a:4:{s:6:\"module\";a:64:{s:13:\"admin_toolbar\";i:0;s:14:\"automated_cron\";i:0;s:8:\"big_pipe\";i:0;s:5:\"block\";i:0;s:11:\"block_class\";i:0;s:13:\"block_content\";i:0;s:10:\"breakpoint\";i:0;s:8:\"ckeditor\";i:0;s:5:\"color\";i:0;s:7:\"comment\";i:0;s:6:\"config\";i:0;s:7:\"contact\";i:0;s:13:\"contact_block\";i:0;s:18:\"content_moderation\";i:0;s:32:\"content_moderation_notifications\";i:0;s:10:\"contextual\";i:0;s:8:\"datetime\";i:0;s:5:\"dblog\";i:0;s:5:\"devel\";i:0;s:14:\"devel_generate\";i:0;s:18:\"dynamic_page_cache\";i:0;s:6:\"editor\";i:0;s:6:\"entity\";i:0;s:5:\"field\";i:0;s:8:\"field_ui\";i:0;s:4:\"file\";i:0;s:6:\"filter\";i:0;s:10:\"ga_reports\";i:0;s:4:\"help\";i:0;s:7:\"history\";i:0;s:5:\"image\";i:0;s:4:\"kint\";i:0;s:4:\"link\";i:0;s:7:\"menu_ui\";i:0;s:7:\"migrate\";i:0;s:14:\"migrate_drupal\";i:0;s:27:\"migrate_drupal_multilingual\";i:0;s:17:\"migrate_drupal_ui\";i:0;s:12:\"migrate_plus\";i:0;s:13:\"migrate_tools\";i:0;s:15:\"migrate_upgrade\";i:0;s:4:\"node\";i:0;s:7:\"options\";i:0;s:10:\"page_cache\";i:0;s:4:\"path\";i:0;s:9:\"quickedit\";i:0;s:3:\"rdf\";i:0;s:4:\"rest\";i:0;s:6:\"search\";i:0;s:13:\"serialization\";i:0;s:8:\"shortcut\";i:0;s:6:\"system\";i:0;s:8:\"taxonomy\";i:0;s:4:\"text\";i:0;s:7:\"toolbar\";i:0;s:4:\"tour\";i:0;s:6:\"twilio\";i:0;s:6:\"update\";i:0;s:4:\"user\";i:0;s:8:\"views_ui\";i:0;s:9:\"workflows\";i:0;s:17:\"menu_link_content\";i:1;s:5:\"views\";i:10;s:8:\"standard\";i:1000;}s:5:\"theme\";a:8:{s:6:\"stable\";i:0;s:6:\"classy\";i:0;s:6:\"bartik\";i:0;s:5:\"seven\";i:0;s:10:\"credit_due\";i:0;s:15:\"yg_business_one\";i:0;s:14:\"yg_fitness_gym\";i:0;s:7:\"justice\";i:0;}s:7:\"profile\";s:8:\"standard\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"R4IF-ClDHXxblLcG0L7MgsLvfBIMAvi_skumNFQwkDc\";}}',-1,1540294708.673,1,'','0'),('core.menu.static_menu_link_overrides',_binary 'a:2:{s:11:\"definitions\";a:2:{s:18:\"contact__site_page\";a:5:{s:7:\"enabled\";b:1;s:9:\"menu_name\";s:6:\"footer\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:8:\"expanded\";b:0;}s:20:\"standard__front_page\";a:5:{s:6:\"weight\";i:-50;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:8:\"expanded\";b:0;s:7:\"enabled\";b:1;}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jdY7AU0tU-QsjmiOw3W8vwpYMb-By--_MSFgbqKUTYM\";}}',-1,1540294711.918,1,'','0'),('devel.settings',_binary 'a:8:{s:10:\"page_alter\";b:0;s:9:\"raw_names\";b:0;s:14:\"error_handlers\";a:1:{i:1;i:1;}s:13:\"rebuild_theme\";b:0;s:22:\"debug_mail_file_format\";s:31:\"%to-%subject-%datetime.mail.txt\";s:20:\"debug_mail_directory\";s:23:\"temporary://devel-mails\";s:12:\"devel_dumper\";s:7:\"default\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8SYa5OOpQGdg4wnttb0LFNuG6GmivsS2qNv9sTH9gDI\";}}',-1,1540294708.645,1,'','0'),('field.field.block_content.basic.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"9a2ee506-d13c-486a-8dad-1114bf13ecdd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:32:\"field.storage.block_content.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"R__6wc-rMfFMO8d7jcgqnqiA92j8spKhcc5MiqecrMc\";}s:2:\"id\";s:24:\"block_content.basic.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";s:5:\"basic\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:0;}s:10:\"field_type\";s:17:\"text_with_summary\";}',-1,1540294710.515,1,'','0'),('field.field.comment.comment.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"188c0a73-e905-428e-baa9-63416be401c9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:20:\"comment.type.comment\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TmAKjNrJ7RR60YpqvJq_QqEewYe_S8Kd23n8VRCqiWs\";}s:2:\"id\";s:28:\"comment.comment.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}',-1,1540294710.538,1,'','0'),('field.field.comment.migrate_example_advanced_comment.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"05f4283e-ad3e-49c2-970e-f5ede246bd7d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:45:\"comment.type.migrate_example_advanced_comment\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"5irzyp55d3gwt2chUnKWoOF0EBd3ugEZ4xJQI8pZoo0\";}s:2:\"id\";s:53:\"comment.migrate_example_advanced_comment.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:32:\"migrate_example_advanced_comment\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}',-1,1540294710.629,1,'','0'),('field.field.comment.node_comments.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"3d172ace-741f-4ed1-ae61-060febfffbeb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"comment.type.node_comments\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dWlqg_QGePh1bX60Pg3FuThe4ZKPAqEBBYStmTcBhgc\";}s:2:\"id\";s:34:\"comment.node_comments.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:13:\"node_comments\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}',-1,1540294710.620,1,'','0'),('field.field.node.article.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"25b7e1bf-d194-4422-9906-63492bc85817\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ay3b2hq42cpQTFB_lNu8S2ZxuVIY6-dlBsc7vLeJ-YY\";}s:2:\"id\";s:17:\"node.article.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}',-1,1540294710.750,1,'','0'),('field.field.node.article.comment',_binary 'a:17:{s:4:\"uuid\";s:36:\"af3a4c23-8dec-4594-bcd8-3168f75a5ed4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.storage.node.comment\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"r-hrxwbKKXBKQnBefGjXNSdU00u2fPvMWEykGRHqd10\";}s:2:\"id\";s:20:\"node.article.comment\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:17:\"last_comment_name\";N;s:22:\"last_comment_timestamp\";i:0;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:13:\"form_location\";b:1;s:9:\"anonymous\";i:0;s:7:\"preview\";i:1;}s:10:\"field_type\";s:7:\"comment\";}',-1,1540294710.792,1,'','0'),('field.field.node.article.field_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"f425d91a-c5fe-4194-a937-bf2c28379389\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"field.storage.node.field_image\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tgJzhA7Swh4M_gWU5FwFe5lPxPj5rebpMbvhpdNrERs\";}s:2:\"id\";s:24:\"node.article.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";b:0;s:18:\"alt_field_required\";b:1;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}',-1,1540294710.792,1,'','0'),('field.field.node.article.field_tags',_binary 'a:17:{s:4:\"uuid\";s:36:\"ca9cbb33-7c78-4fc9-b85a-51fa25db81c4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:29:\"field.storage.node.field_tags\";i:1;s:17:\"node.type.article\";i:2;s:24:\"taxonomy.vocabulary.tags\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QdUgf_beeoaPiyKorFv0q1fcJpWH_uZTqe_xoVJacrw\";}s:2:\"id\";s:23:\"node.article.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:84:\"Enter a comma-separated list. For example: Amsterdam, Mexico City, \"Cleveland, Ohio\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:1;}}s:10:\"field_type\";s:16:\"entity_reference\";}',-1,1540294710.792,1,'','0'),('field.field.node.migrate_example_beer.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"629b21a2-39a2-44ff-b256-9cccb759ad23\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"0wEsWyeweie_9qpPaMIbZ4_vzPZfrFx1RuOVFpIYhCg\";}s:2:\"id\";s:30:\"node.migrate_example_beer.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}',-1,1540294710.758,1,'','0'),('field.field.node.migrate_example_beer.field_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"383e99f5-f45a-4dff-9687-935f48052827\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:33:\"field.storage.node.field_comments\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oQu63YXAvXvSWvIwwACbcmXsta4CGVhjJ9c61AEvbUg\";}s:2:\"id\";s:40:\"node.migrate_example_beer.field_comments\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:1;}s:10:\"field_type\";s:7:\"comment\";}',-1,1540294710.817,1,'','0'),('field.field.node.migrate_example_beer.field_migrate_example_beer_style',_binary 'a:17:{s:4:\"uuid\";s:36:\"3f50dbe5-8e5a-447a-88b9-b9d4597d8ce3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_beer_style\";i:1;s:30:\"node.type.migrate_example_beer\";i:2;s:47:\"taxonomy.vocabulary.migrate_example_beer_styles\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ux7VJdLoguhU4M-c5krgHOWQ-EUzEFKAWXk_8d68S14\";}s:2:\"id\";s:58:\"node.migrate_example_beer.field_migrate_example_beer_style\";s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:27:\"Migrate Example Beer Styles\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}',-1,1540294710.817,1,'','0'),('field.field.node.migrate_example_beer.field_migrate_example_country',_binary 'a:17:{s:4:\"uuid\";s:36:\"197b7775-2b8b-4f16-a866-8fafdcc6502a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:48:\"field.storage.node.field_migrate_example_country\";i:1;s:30:\"node.type.migrate_example_beer\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"267WOazRYNp4VIbrd7mXDTFpKn2y10nXzvCOETAlCOA\";}s:2:\"id\";s:55:\"node.migrate_example_beer.field_migrate_example_country\";s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:9:\"Countries\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}',-1,1540294710.817,1,'','0'),('field.field.node.migrate_example_beer.field_migrate_example_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"15c1e1cd-290a-46b5-a3b5-ff79effd05eb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:46:\"field.storage.node.field_migrate_example_image\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rTTSbnynVpKFdSUronbULx6m23C0t_BNxQgSinwvpnM\";}s:2:\"id\";s:53:\"node.migrate_example_beer.field_migrate_example_image\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:0:\"\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:0;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}',-1,1540294710.817,1,'','0'),('field.field.node.migrate_example_producer.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"e98961e2-0cec-4ea5-bd07-287701755573\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:34:\"node.type.migrate_example_producer\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"JgX7dNn2ZZjdq1XeVaoasaaWggHCSTw1B5UEy_B-_XU\";}s:2:\"id\";s:34:\"node.migrate_example_producer.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:24:\"migrate_example_producer\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}',-1,1540294710.775,1,'','0'),('field.field.node.migrate_example_producer.field_migrate_example_wine_regio',_binary 'a:17:{s:4:\"uuid\";s:36:\"98571a36-53c2-4ad0-8fef-d503496cf7f4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_regio\";i:1;s:34:\"node.type.migrate_example_producer\";i:2;s:48:\"taxonomy.vocabulary.migrate_example_wine_regions\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4jQmcEs7K8dHbvrVrKuz76I2J4UJ2UpUNVt0O7kwnhg\";}s:2:\"id\";s:62:\"node.migrate_example_producer.field_migrate_example_wine_regio\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:24:\"migrate_example_producer\";s:5:\"label\";s:28:\"Migrate Example Wine Regions\";s:11:\"description\";s:38:\"Select the region this wine comes from\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}',-1,1540294710.841,1,'','0'),('field.field.node.migrate_example_wine.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"02b0fbcd-2986-44f7-927d-3e62bdd90c62\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vq3DCSKc6pTaZwP7vJB6S75vq2zwxDXxHAG2a82526U\";}s:2:\"id\";s:30:\"node.migrate_example_wine.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}',-1,1540294710.767,1,'','0'),('field.field.node.migrate_example_wine.field_migrate_example_adv_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"fea3b469-b569-4529-9189-47b66ece7ed2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:50:\"field.storage.node.field_migrate_example_adv_image\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dde5g37whYUHPGt2O6lHpPCd4oKV-jKmJChum1XXHSI\";}s:2:\"id\";s:57:\"node.migrate_example_wine.field_migrate_example_adv_image\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:37:\"Upload an image to go with this wine.\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:27:\"field/migrate_example/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:0;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}',-1,1540294710.868,1,'','0'),('field.field.node.migrate_example_wine.field_migrate_example_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"eece7e20-cd5d-4e4c-b4f7-8aea79d5d9f0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:49:\"field.storage.node.field_migrate_example_comments\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ljjlc3_-z66T0-LFF2z53sK90atzoirmJ9SPNlhcYzc\";}s:2:\"id\";s:56:\"node.migrate_example_wine.field_migrate_example_comments\";s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:1;}s:10:\"field_type\";s:7:\"comment\";}',-1,1540294710.868,1,'','0'),('field.field.node.migrate_example_wine.field_migrate_example_top_vintag',_binary 'a:17:{s:4:\"uuid\";s:36:\"c3fa4924-0661-4d6f-a4cb-3d49e11080e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:51:\"field.storage.node.field_migrate_example_top_vintag\";i:1;s:30:\"node.type.migrate_example_wine\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"x1l7jyHt74QqCON-PMg05LruTMlDLgfoOkN8A1YU6gY\";}s:2:\"id\";s:58:\"node.migrate_example_wine.field_migrate_example_top_vintag\";s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:20:\"Recommended vintages\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:4:{s:3:\"min\";N;s:3:\"max\";N;s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"field_type\";s:7:\"integer\";}',-1,1540294710.868,1,'','0'),('field.field.node.migrate_example_wine.field_migrate_example_wine_best',_binary 'a:17:{s:4:\"uuid\";s:36:\"b7f2771d-df62-4c67-b7c1-2179ae6e3cb7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:50:\"field.storage.node.field_migrate_example_wine_best\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:50:\"taxonomy.vocabulary.migrate_example_wine_best_with\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XhPNldNk37gxWD2j9pgrLapzt781hNew8V8YLBsZme4\";}s:2:\"id\";s:57:\"node.migrate_example_wine.field_migrate_example_wine_best\";s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:30:\"Migrate Example Wine Best With\";s:11:\"description\";s:65:\"Enter any foods this wine may be paired with, separated by commas\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}',-1,1540294710.868,1,'','0'),('field.field.node.migrate_example_wine.field_migrate_example_wine_ratin',_binary 'a:17:{s:4:\"uuid\";s:36:\"1ee670bc-250c-42be-aa39-8ed00eba65d5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_ratin\";i:1;s:30:\"node.type.migrate_example_wine\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"f_RIakTCpup3t5_tfuPwr3Il2wvYTXciVBN_LRcg14U\";}s:2:\"id\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_ratin\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:6:\"Rating\";s:11:\"description\";s:23:\"Rating on a 1-100 scale\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:4:{s:3:\"min\";d:1;s:3:\"max\";d:100;s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"field_type\";s:7:\"decimal\";}',-1,1540294710.868,1,'','0'),('field.field.node.migrate_example_wine.field_migrate_example_wine_regio',_binary 'a:17:{s:4:\"uuid\";s:36:\"7b85b545-1e00-4ff2-bf16-546d82c42d96\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_regio\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:48:\"taxonomy.vocabulary.migrate_example_wine_regions\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SY0L1xid1zVRqtdbHoMATu_eJDGsXBoULcxzmqWuFXY\";}s:2:\"id\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_regio\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:28:\"Migrate Example Wine Regions\";s:11:\"description\";s:38:\"Select the region this wine comes from\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}',-1,1540294710.868,1,'','0'),('field.field.node.migrate_example_wine.field_migrate_example_wine_var',_binary 'a:17:{s:4:\"uuid\";s:36:\"a73f752d-1642-45ea-a85c-8ab426c8ddad\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:49:\"field.storage.node.field_migrate_example_wine_var\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wUq7WvEbY6a-6yW8OZULmZfSj7OwD1qMpKiS3upiOtI\";}s:2:\"id\";s:56:\"node.migrate_example_wine.field_migrate_example_wine_var\";s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:30:\"Migrate Example Wine Varieties\";s:11:\"description\";s:31:\"Select the variety of this wine\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}',-1,1540294710.868,1,'','0'),('field.field.node.page.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"b8cf44dd-b10b-40db-9324-26854c19e8de\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rUop-8b6hvxxDYbv-KobTfNIBNbPY9qOPl8f6kBNSpw\";}s:2:\"id\";s:14:\"node.page.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}',-1,1540294710.742,1,'','0'),('field.field.taxonomy_term.migrate_example_wine_varieties.field_variety_attributes',_binary 'a:17:{s:4:\"uuid\";s:36:\"038fa040-ae08-4314-b74b-60f3e45a5f47\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:52:\"field.storage.taxonomy_term.field_variety_attributes\";i:1;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6rU_9CZGIOdWqzPHF8GH37JaWcUoQYymrdTuTlUD8r0\";}s:2:\"id\";s:69:\"taxonomy_term.migrate_example_wine_varieties.field_variety_attributes\";s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:30:\"migrate_example_wine_varieties\";s:5:\"label\";s:10:\"Attributes\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}',-1,1540294710.907,1,'','0'),('field.field.user.user.field_migrate_example_favbeers',_binary 'a:17:{s:4:\"uuid\";s:36:\"c06b3c71-8b56-4b1a-b937-f7022336734e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:49:\"field.storage.user.field_migrate_example_favbeers\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"pIDsWln9Pgayq3gsbJPTHTNoEWaq1fFTerjS_EKtFtg\";}s:2:\"id\";s:40:\"user.user.field_migrate_example_favbeers\";s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:14:\"Favorite Beers\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:12:\"default:node\";s:16:\"handler_settings\";a:2:{s:14:\"target_bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}s:4:\"sort\";a:2:{s:5:\"field\";s:5:\"title\";s:9:\"direction\";s:3:\"ASC\";}}}s:10:\"field_type\";s:16:\"entity_reference\";}',-1,1540294710.995,1,'','0'),('field.field.user.user.field_migrate_example_gender',_binary 'a:17:{s:4:\"uuid\";s:36:\"b3f24804-97d4-4400-9102-e06b37d5f75f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:47:\"field.storage.user.field_migrate_example_gender\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-13X2hbfPYQnoVLm2sC5J6tVgYycYRTicNxDqunahwU\";}s:2:\"id\";s:38:\"user.user.field_migrate_example_gender\";s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:6:\"Gender\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}',-1,1540294711.012,1,'','0'),('field.field.user.user.user_picture',_binary 'a:17:{s:4:\"uuid\";s:36:\"15a8ada2-7804-4a52-b07f-ddb0442179ea\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:31:\"field.storage.user.user_picture\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Iiq0AttdhgbebJwabSFwQQ1ORn64GoGz0xSZ_eyCJ8A\";}s:2:\"id\";s:22:\"user.user.user_picture\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:7:\"Picture\";s:11:\"description\";s:29:\"Your virtual face or picture.\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:14:\"file_directory\";s:40:\"pictures/[date:custom:Y]-[date:custom:m]\";s:12:\"max_filesize\";s:0:\"\";s:9:\"alt_field\";b:0;s:11:\"title_field\";b:0;s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:18:\"alt_field_required\";b:0;s:20:\"title_field_required\";b:0;s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}',-1,1540294711.012,1,'','0'),('field.storage.block_content.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"d224118f-844d-4d9b-8fc5-afa0888f4af1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eS0snV_L3dx9shtWRTzm5eblwOJ7qKWC9IE-4GMTDFc\";}s:2:\"id\";s:18:\"block_content.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:4:\"type\";s:17:\"text_with_summary\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}',-1,1540294710.161,1,'','0'),('field.storage.comment.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"ca2a0686-6c75-4895-bb9e-670fa7ef511f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"swYoCch_hY8QO5uwr4FURplfnUCUlpPB4idF8WGVCpw\";}s:2:\"id\";s:20:\"comment.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:4:\"type\";s:9:\"text_long\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}',-1,1540294710.225,1,'','0'),('field.storage.node.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"4bd18d5b-1b54-4d93-8809-1f2a2cfbcc80\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EBUo7qOWqaiZaQ_RC9sLY5IoDKphS34v77VIHSACmVY\";}s:2:\"id\";s:9:\"node.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:17:\"text_with_summary\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.comment',_binary 'a:17:{s:4:\"uuid\";s:36:\"ccf999c7-4756-4fb3-b254-edec33730b53\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ktCna9xmWvYZIUfOCUyDQvedn5RtnS4CRmEIwNmvYjc\";}s:2:\"id\";s:12:\"node.comment\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"cb6e812d-2115-4faf-98d1-e6a4706413c9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-Fbi4WKTGUpcyPzZFp_Ioroz-Xni60AHP3Rt0VaNYzs\";}s:2:\"id\";s:19:\"node.field_comments\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:13:\"node_comments\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"eb5224c0-e6c7-49cf-82b6-229f46ef800b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SkXIPKZYiIMMtnBmfnxk58RYfbZ8cHSw5NZPY_JByME\";}s:2:\"id\";s:16:\"node.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_adv_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"64472a0e-1641-463b-8103-ec2ed8f6c5e3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RwVJ29uGaznr4EjFpnLkdADJBx7DLYwfcu7ti4bVe-c\";}s:2:\"id\";s:36:\"node.field_migrate_example_adv_image\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_beer_style',_binary 'a:17:{s:4:\"uuid\";s:36:\"11b2a4ff-4513-4663-938d-060cda2689e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OydFp62jbcZgS1dcDCNzxvhJjx-UDf-ng1or4wTY7-w\";}s:2:\"id\";s:37:\"node.field_migrate_example_beer_style\";s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"5ec526fb-c67f-4c40-80df-1e2b92438662\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GcdoHWF-KMjeae1Roq8JEh7Xr3Onq8_oZAP3B1sRuhA\";}s:2:\"id\";s:35:\"node.field_migrate_example_comments\";s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:32:\"migrate_example_advanced_comment\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_country',_binary 'a:17:{s:4:\"uuid\";s:36:\"174d947b-0f2d-4bbc-97a0-ed966f6519d4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uBaHGWI3rO-tpQurs304h90LTJoBpjWI2JHNhbMY1TM\";}s:2:\"id\";s:34:\"node.field_migrate_example_country\";s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"d57d2d8a-c9f4-4b45-9c8e-f544aa2f818e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"3SSh1H4dQsPZoZV-d3sjeQK7GPJfi-mo6sgECfiOtn8\";}s:2:\"id\";s:32:\"node.field_migrate_example_image\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_top_vintag',_binary 'a:17:{s:4:\"uuid\";s:36:\"2245f192-9a68-4931-b960-80ddce78214d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sE33za4WgJVU7T_nG_PZp5CVmEBALuzB_Vn-tfw-q8s\";}s:2:\"id\";s:37:\"node.field_migrate_example_top_vintag\";s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"integer\";s:8:\"settings\";a:2:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_wine_best',_binary 'a:17:{s:4:\"uuid\";s:36:\"34bb10e9-a28d-459d-9cfe-ce04b8a54387\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9YbUjnyyl-8owZ1KCETbExQGZu4aog3n7l3PHy0dSds\";}s:2:\"id\";s:36:\"node.field_migrate_example_wine_best\";s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_wine_ratin',_binary 'a:17:{s:4:\"uuid\";s:36:\"9db1bcab-f817-4886-a5b5-34d700f8848f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_kyPHNTTC5ibCxEq_nKImDTCSdOLFBhkXjobmMN4zJ4\";}s:2:\"id\";s:37:\"node.field_migrate_example_wine_ratin\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"decimal\";s:8:\"settings\";a:2:{s:9:\"precision\";i:10;s:5:\"scale\";i:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_wine_regio',_binary 'a:17:{s:4:\"uuid\";s:36:\"89bb858a-3fa0-40a3-b7e5-29a286ecbe05\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AJoyPVhHsJ7K3A9G3Ztn6dKHZBZ5ao3c7SdEK2rH3dM\";}s:2:\"id\";s:37:\"node.field_migrate_example_wine_regio\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_migrate_example_wine_var',_binary 'a:17:{s:4:\"uuid\";s:36:\"e627ec31-c833-465f-ba31-28b765ab8f37\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TcM1vLCiI-U8EN4bH2-tWOgR-HU8fDhHf3oMVGzrA-8\";}s:2:\"id\";s:35:\"node.field_migrate_example_wine_var\";s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.node.field_tags',_binary 'a:17:{s:4:\"uuid\";s:36:\"73418115-95a0-4170-9dd7-284673acd7d2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WpOE_bs8Bs_HY2ns7n2r__de-xno0-Bxkqep5-MsHAs\";}s:2:\"id\";s:15:\"node.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.419,1,'','0'),('field.storage.taxonomy_term.field_variety_attributes',_binary 'a:17:{s:4:\"uuid\";s:36:\"50da2584-5c3b-41ad-87cb-032fa5039401\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sfP27J9-TcVbjBJviBOAkXgwSpQe1DoGxCc5Ysz_8rc\";}s:2:\"id\";s:38:\"taxonomy_term.field_variety_attributes\";s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.454,1,'','0'),('field.storage.user.field_migrate_example_favbeers',_binary 'a:17:{s:4:\"uuid\";s:36:\"4d9219b4-339a-4759-aaf2-9dcd7a27fb11\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tKsR0YH5ckB1vHHdiiA7gYHhFVOvdwIS6N3-NvAxwqM\";}s:2:\"id\";s:35:\"user.field_migrate_example_favbeers\";s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:4:\"node\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.470,1,'','0'),('field.storage.user.field_migrate_example_gender',_binary 'a:17:{s:4:\"uuid\";s:36:\"3a033163-ac33-47ae-9186-2aecf22e5a8a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-qbjvRZ4YV6YRW3_WOy0fiV1K4bHVBlJNA4AC2E9Z8I\";}s:2:\"id\";s:33:\"user.field_migrate_example_gender\";s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.470,1,'','0'),('field.storage.user.user_picture',_binary 'a:17:{s:4:\"uuid\";s:36:\"7fa5154f-d1e9-4c85-a43d-2cedc39808c0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6k-VBFilDLuzgSOT-77CFgHFlcd5D-kqRixtH89EShU\";}s:2:\"id\";s:17:\"user.user_picture\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}',-1,1540294710.470,1,'','0'),('node.settings',_binary 'a:2:{s:15:\"use_admin_theme\";b:1;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2OMXCScXUOLSYID9-phjO4q36nnnaMWNUlDxEqZzG1U\";}}',-1,1540294711.657,1,'','0'),('node.type.article',_binary 'a:12:{s:4:\"uuid\";s:36:\"570dc409-91e0-48b4-a412-def16b756fd7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AeW1SEDgb1OTQACAWGhzvMknMYAJlcZu0jljfeU3oso\";}s:4:\"name\";s:7:\"Article\";s:4:\"type\";s:7:\"article\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:1;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}',-1,1540294710.010,1,'','0'),('node.type.migrate_example_beer',_binary 'a:12:{s:4:\"uuid\";s:36:\"5b8a080b-4883-4eef-9e9b-451db02d8bc5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U_maKgojQ2WxF-bkAntFDvaXHU4jYMvALeeGQHMCPnQ\";}s:4:\"name\";s:4:\"Beer\";s:4:\"type\";s:20:\"migrate_example_beer\";s:11:\"description\";s:22:\"Beer is what we drink.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}',-1,1540294710.010,1,'','0'),('node.type.migrate_example_producer',_binary 'a:12:{s:4:\"uuid\";s:36:\"942256f1-1a4c-4828-995d-d1aec2ca115f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OHHNffqa__jzWnLEnKqyHnMSmftu2Ynj7LPIUJQl_js\";}s:4:\"name\";s:13:\"Wine Producer\";s:4:\"type\";s:24:\"migrate_example_producer\";s:11:\"description\";s:41:\"Wineries, vineyards, and large producers.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}',-1,1540294710.010,1,'','0'),('node.type.migrate_example_wine',_binary 'a:12:{s:4:\"uuid\";s:36:\"e70c6013-aa35-47e9-8c2b-df483f60588f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"al1Ui692C2r_G8Nj3LLNVk5TYFjFouP8FipmWiCDFC8\";}s:4:\"name\";s:4:\"Wine\";s:4:\"type\";s:20:\"migrate_example_wine\";s:11:\"description\";s:22:\"Wine is what we drink.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}',-1,1540294710.010,1,'','0'),('node.type.page',_binary 'a:12:{s:4:\"uuid\";s:36:\"5ee98c60-03db-4240-8408-7d1a9adc8a8d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KuyA4NHPXcmKAjRtwa0vQc2ZcyrUJy6IlS2TAyMNRbc\";}s:4:\"name\";s:10:\"Basic page\";s:4:\"type\";s:4:\"page\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:1;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:0;}',-1,1540294710.010,1,'','0'),('search.page.node_search',_binary 'a:11:{s:4:\"uuid\";s:36:\"c4bb8f59-527e-4bb9-99d3-c6109c3cef5d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"97tvtzGOa8_flb22CzSjgtm_YkiGMHvEBO-6q2K9V_U\";}s:2:\"id\";s:11:\"node_search\";s:5:\"label\";s:7:\"Content\";s:4:\"path\";s:4:\"node\";s:6:\"weight\";i:-10;s:6:\"plugin\";s:11:\"node_search\";s:13:\"configuration\";a:1:{s:8:\"rankings\";a:0:{}}}',-1,1540294709.412,1,'','0'),('search.page.user_search',_binary 'a:11:{s:4:\"uuid\";s:36:\"bdd6728c-1758-4580-a896-098f2403cabd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"k3aUaZXGDuhkek2TZIee0PApOPTvYZLadziekdyHA5A\";}s:2:\"id\";s:11:\"user_search\";s:5:\"label\";s:5:\"Users\";s:4:\"path\";s:4:\"user\";s:6:\"weight\";i:0;s:6:\"plugin\";s:11:\"user_search\";s:13:\"configuration\";a:0:{}}',-1,1540294709.412,1,'','0'),('search.settings',_binary 'a:5:{s:12:\"and_or_limit\";i:7;s:12:\"default_page\";s:11:\"node_search\";s:5:\"index\";a:4:{s:10:\"cron_limit\";i:100;s:11:\"overlap_cjk\";b:1;s:17:\"minimum_word_size\";i:3;s:11:\"tag_weights\";a:12:{s:2:\"h1\";i:25;s:2:\"h2\";i:18;s:2:\"h3\";i:15;s:2:\"h4\";i:14;s:2:\"h5\";i:9;s:2:\"h6\";i:6;s:1:\"u\";i:3;s:1:\"b\";i:3;s:1:\"i\";i:3;s:6:\"strong\";i:3;s:2:\"em\";i:3;s:1:\"a\";i:10;}}s:7:\"logging\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"hvVxL1G-ZCxaq32IZws0YsfuhvaDiQE_np-0g35KjUk\";}}',-1,1540294709.419,1,'','0'),('shortcut.set.default',_binary 'a:7:{s:4:\"uuid\";s:36:\"29cc33d0-f17d-4e92-ab21-a709f2d740e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U5VlGjd_SfV0Qm_EfnaynOfc549cNscFAx48JfYoMRI\";}s:2:\"id\";s:7:\"default\";s:5:\"label\";s:7:\"Default\";}',-1,1540294710.018,1,'','0'),('simpletest.settings',_binary 'b:0;',-1,1540294708.682,1,'','0'),('system.action.comment_delete_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"8cd78467-3aa6-4642-a795-cc3cbd214493\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"VetuwpecspsjqMCd8e7wKyr2l-AZEh1UNYWNtNywHXM\";}s:2:\"id\";s:21:\"comment_delete_action\";s:5:\"label\";s:14:\"Delete comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:28:\"entity:delete_action:comment\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.comment_publish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"2d5637bf-26b3-41ba-9d8d-740bbd679ee7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"C00dyL_W_5M0nFlgUB3lWUTUs96jn51Jw1MLHVEHZD0\";}s:2:\"id\";s:22:\"comment_publish_action\";s:5:\"label\";s:15:\"Publish comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:29:\"entity:publish_action:comment\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.comment_save_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"c3af90be-2491-4050-b1ea-5e0706449649\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lfyE_snmvfg_EQ3VDyhUtGAXgmqtEiqa46I3bTMg8DU\";}s:2:\"id\";s:19:\"comment_save_action\";s:5:\"label\";s:12:\"Save comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:26:\"entity:save_action:comment\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.comment_unpublish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"a71a6d49-8f5b-46ad-bf21-2066215da09d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tWOIjSMobEWOFZddMkNqb9JySbOVwE1diC6NRqcfLTk\";}s:2:\"id\";s:24:\"comment_unpublish_action\";s:5:\"label\";s:17:\"Unpublish comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:31:\"entity:unpublish_action:comment\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_delete_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"2829ed55-ae83-413f-8152-d5fd5bc7297a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Zx0jD1Klh5tZaGJy8uOeR_2MCu9FDM4xg7TaUJUEbkI\";}s:2:\"id\";s:18:\"node_delete_action\";s:5:\"label\";s:14:\"Delete content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:25:\"entity:delete_action:node\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_make_sticky_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"f9d82e49-e281-4865-b089-7568d6e5e9ba\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sOb26JSy3fGpWkvR0WYN6_hMqj_6d1rvbvrkzp1yya0\";}s:2:\"id\";s:23:\"node_make_sticky_action\";s:5:\"label\";s:19:\"Make content sticky\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:23:\"node_make_sticky_action\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_make_unsticky_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"c62d0d8a-2d20-45cc-87fa-c0f243532223\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lDM9mvIGAu8Sw8rt-uCO4Sr7yX5VPrDPxYcawkbKd6k\";}s:2:\"id\";s:25:\"node_make_unsticky_action\";s:5:\"label\";s:21:\"Make content unsticky\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:25:\"node_make_unsticky_action\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_promote_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"92aec9d7-7996-4297-8492-8763768657e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"N0RDBTqiK4dKoN4p4oW2j0SGWycdHyALUe9M-Ofp89U\";}s:2:\"id\";s:19:\"node_promote_action\";s:5:\"label\";s:29:\"Promote content to front page\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:19:\"node_promote_action\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_publish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"b926720c-f69d-4b38-8a89-8b07a36077e9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2B9uF8NL5gutNKSdPRAhhAsDWFZZG1PJOBmx0aBGd_0\";}s:2:\"id\";s:19:\"node_publish_action\";s:5:\"label\";s:15:\"Publish content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:26:\"entity:publish_action:node\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_save_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"937a38cd-6717-45fd-b62a-bdbdeb7c6d0d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"LhdsoZPL_pFas2fjaAWue4zvrQ_tEVofLYtcNec-JGM\";}s:2:\"id\";s:16:\"node_save_action\";s:5:\"label\";s:12:\"Save content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:23:\"entity:save_action:node\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_unpromote_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"0c73ca87-df28-4bad-93cb-fe172680de60\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"JBptjnfuOMtsdKygklXxoOgeOCTMtQxlkymjnnj-cC0\";}s:2:\"id\";s:21:\"node_unpromote_action\";s:5:\"label\";s:30:\"Remove content from front page\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:21:\"node_unpromote_action\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.node_unpublish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"713d1349-e6b2-499e-bb0e-f46ed358c79f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"C7X8h9FWlwkQ9y5mnU2JzgaZICAdc6HFbPVbhvjlAYE\";}s:2:\"id\";s:21:\"node_unpublish_action\";s:5:\"label\";s:17:\"Unpublish content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:28:\"entity:unpublish_action:node\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.user_add_role_action.administrator',_binary 'a:9:{s:4:\"uuid\";s:36:\"3070619a-a245-45ea-95c9-e4ec02516863\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"user.role.administrator\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:34:\"user_add_role_action.administrator\";s:5:\"label\";s:50:\"Add the Administrator role to the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:20:\"user_add_role_action\";s:13:\"configuration\";a:1:{s:3:\"rid\";s:13:\"administrator\";}}',-1,1540294709.901,1,'','0'),('system.action.user_block_user_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"b159d6cd-eeca-41d7-a86f-1a171ef1441e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DyypzTfThX10FFQw-399qPfEbLLyrhXgQrKPVsmAoJ4\";}s:2:\"id\";s:22:\"user_block_user_action\";s:5:\"label\";s:26:\"Block the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:22:\"user_block_user_action\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.user_cancel_user_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"342f19e7-4fcc-43c3-be06-077b2ff1c27d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nvrL9bFilzBvm2bjO9rQnFDpBA7dBBUjShSSt6NS-DU\";}s:2:\"id\";s:23:\"user_cancel_user_action\";s:5:\"label\";s:35:\"Cancel the selected user account(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:23:\"user_cancel_user_action\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('system.action.user_remove_role_action.administrator',_binary 'a:9:{s:4:\"uuid\";s:36:\"76a2a0e3-51b6-4a14-a8eb-3eebb78d8cb3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"user.role.administrator\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:37:\"user_remove_role_action.administrator\";s:5:\"label\";s:55:\"Remove the Administrator role from the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:23:\"user_remove_role_action\";s:13:\"configuration\";a:1:{s:3:\"rid\";s:13:\"administrator\";}}',-1,1540294709.901,1,'','0'),('system.action.user_unblock_user_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"8768000c-4a49-4700-9512-dd545e53405d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SPsUXsR3Rc8d1y3gewzaAKWa1ncea_ywXX3f7LTn7k0\";}s:2:\"id\";s:24:\"user_unblock_user_action\";s:5:\"label\";s:28:\"Unblock the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:24:\"user_unblock_user_action\";s:13:\"configuration\";a:0:{}}',-1,1540294709.901,1,'','0'),('taxonomy.vocabulary.migrate_example_beer_styles',_binary 'a:10:{s:4:\"uuid\";s:36:\"11c2f626-3a04-4f09-bf65-36ef6620dadb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gDVMNhIaN-Ev0gqPyZU5Y7yUCwRfMlA-cv2gHC01hl4\";}s:4:\"name\";s:27:\"Migrate Example Beer Styles\";s:3:\"vid\";s:27:\"migrate_example_beer_styles\";s:11:\"description\";s:58:\"Use tags to group beers on similar topics into categories.\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}',-1,1540294710.027,1,'','0'),('taxonomy.vocabulary.migrate_example_wine_best_with',_binary 'a:10:{s:4:\"uuid\";s:36:\"55a19acc-deb2-4c76-aaa3-03cd390feab6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Um5-fw3xl_sy7j8TL2BdvXxYGTZk5fWXvZM_d3j_5HI\";}s:4:\"name\";s:30:\"Migrate Example Wine Best With\";s:3:\"vid\";s:30:\"migrate_example_wine_best_with\";s:11:\"description\";s:29:\"Foods the wine goes best with\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}',-1,1540294710.027,1,'','0'),('taxonomy.vocabulary.migrate_example_wine_regions',_binary 'a:10:{s:4:\"uuid\";s:36:\"35a776b4-9412-46b9-b8cc-1f5c2e473fb9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EtlAQvGtTNN6MaeLyMkoK4gCOyQxe2cMD4rblLAzoyY\";}s:4:\"name\";s:28:\"Migrate Example Wine Regions\";s:3:\"vid\";s:28:\"migrate_example_wine_regions\";s:11:\"description\";s:12:\"Wine regions\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}',-1,1540294710.027,1,'','0'),('taxonomy.vocabulary.migrate_example_wine_varieties',_binary 'a:10:{s:4:\"uuid\";s:36:\"d6b0d5dc-57b7-447c-8aef-2fdaa810601b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4wp7G-IhzYtgI33DfQlm4mNx9UleyBZ2sAlaXu0Gke4\";}s:4:\"name\";s:30:\"Migrate Example Wine Varieties\";s:3:\"vid\";s:30:\"migrate_example_wine_varieties\";s:11:\"description\";s:14:\"Wine varieties\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}',-1,1540294710.027,1,'','0'),('taxonomy.vocabulary.tags',_binary 'a:10:{s:4:\"uuid\";s:36:\"5e143112-8b1f-406b-8e42-9e932a410678\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lO5ziR5dVI1PpEeHZsSOfQ-Y7NWihSDKW8-MMf6uoms\";}s:4:\"name\";s:4:\"Tags\";s:3:\"vid\";s:4:\"tags\";s:11:\"description\";s:61:\"Use tags to group articles on similar topics into categories.\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}',-1,1540294710.027,1,'','0'),('user.settings',_binary 'a:9:{s:9:\"anonymous\";s:9:\"Anonymous\";s:11:\"verify_mail\";b:1;s:6:\"notify\";a:8:{s:14:\"cancel_confirm\";b:1;s:14:\"password_reset\";b:1;s:16:\"status_activated\";b:1;s:14:\"status_blocked\";b:0;s:15:\"status_canceled\";b:0;s:22:\"register_admin_created\";b:1;s:29:\"register_no_approval_required\";b:1;s:25:\"register_pending_approval\";b:1;}s:8:\"register\";s:23:\"visitors_admin_approval\";s:13:\"cancel_method\";s:17:\"user_cancel_block\";s:22:\"password_reset_timeout\";i:86400;s:17:\"password_strength\";b:1;s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"r4kwhOM0IWXVMUZDz744Yc16EOh37ZhYbA8kGOhSmLk\";}}',-1,1540294710.270,1,'','0'),('views.settings',_binary 'a:6:{s:17:\"display_extenders\";a:0:{}s:10:\"skip_cache\";b:0;s:13:\"sql_signature\";b:0;s:2:\"ui\";a:3:{s:4:\"show\";a:7:{s:18:\"additional_queries\";b:0;s:15:\"advanced_column\";b:0;s:14:\"master_display\";b:0;s:22:\"performance_statistics\";b:1;s:19:\"preview_information\";b:1;s:9:\"sql_query\";a:2:{s:7:\"enabled\";b:1;s:5:\"where\";s:5:\"above\";}s:13:\"display_embed\";b:0;}s:19:\"always_live_preview\";b:1;s:24:\"exposed_filter_any_label\";s:7:\"old_any\";}s:22:\"field_rewrite_elements\";a:29:{s:3:\"div\";s:3:\"DIV\";s:4:\"span\";s:4:\"SPAN\";s:2:\"h1\";s:2:\"H1\";s:2:\"h2\";s:2:\"H2\";s:2:\"h3\";s:2:\"H3\";s:2:\"h4\";s:2:\"H4\";s:2:\"h5\";s:2:\"H5\";s:2:\"h6\";s:2:\"H6\";s:1:\"p\";s:1:\"P\";s:6:\"header\";s:6:\"HEADER\";s:6:\"footer\";s:6:\"FOOTER\";s:7:\"article\";s:7:\"ARTICLE\";s:7:\"section\";s:7:\"SECTION\";s:5:\"aside\";s:5:\"ASIDE\";s:7:\"details\";s:7:\"DETAILS\";s:10:\"blockquote\";s:10:\"BLOCKQUOTE\";s:6:\"figure\";s:6:\"FIGURE\";s:7:\"address\";s:7:\"ADDRESS\";s:4:\"code\";s:4:\"CODE\";s:3:\"pre\";s:3:\"PRE\";s:3:\"var\";s:3:\"VAR\";s:4:\"samp\";s:4:\"SAMP\";s:3:\"kbd\";s:3:\"KBD\";s:6:\"strong\";s:6:\"STRONG\";s:2:\"em\";s:2:\"EM\";s:3:\"del\";s:3:\"DEL\";s:3:\"ins\";s:3:\"INS\";s:1:\"q\";s:1:\"Q\";s:1:\"s\";s:1:\"S\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RaRd9EIcwA4u3qCSRLL8EnCicbda1kV__ASmVbyehvQ\";}}',-1,1540294709.236,1,'','0'),('views.view.archive',_binary 'a:14:{s:4:\"uuid\";s:36:\"969da648-5dfb-4525-b549-1f4491e0cbf4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SRH1EhxAiIRj01P9xYv0h_LfIfWxjll0Yq-eDfjziFI\";}s:2:\"id\";s:7:\"archive\";s:5:\"label\";s:7:\"Archive\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:22:\"All content, by month.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";}}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:13:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:12:\"title_enable\";b:1;s:5:\"title\";s:34:\"{{ arguments.created_year_month }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:10:\"sort_order\";s:4:\"desc\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:2:{s:8:\"override\";b:1;s:14:\"items_per_page\";i:30;}s:18:\"specify_validation\";b:1;s:9:\"plugin_id\";s:15:\"date_year_month\";s:11:\"entity_type\";s:4:\"node\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:13:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:12:\"title_enable\";b:1;s:5:\"title\";s:34:\"{{ arguments.created_year_month }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";i:30;}s:18:\"specify_validation\";b:1;s:9:\"plugin_id\";s:15:\"date_year_month\";s:11:\"entity_type\";s:4:\"node\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:2;s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"archive\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.446,1,'','0'),('views.view.block_content',_binary 'a:14:{s:4:\"uuid\";s:36:\"509e5844-fc48-4698-880e-985b043c408e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gkRJCqHr3uSO8ALHLatX-7YKfX0lWEgkC5qMBtCf_Sg\";}s:2:\"id\";s:13:\"block_content\";s:5:\"label\";s:20:\"Custom block library\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:30:\"Find and manage custom blocks.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:24:\"block_content_field_data\";s:10:\"base_field\";s:2:\"id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:17:\"administer blocks\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:4:\"info\";s:4:\"info\";s:4:\"type\";s:4:\"type\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:4:{s:4:\"info\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:4:{s:4:\"info\";a:37:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:17:\"Block description\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Block type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:7:\"changed\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:13:\"block_content\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:3:{s:4:\"info\";a:16:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:7:\"info_op\";s:5:\"label\";s:17:\"Block description\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"info_op\";s:10:\"identifier\";s:4:\"info\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:10:\"Block type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:8:\"reusable\";a:16:{s:2:\"id\";s:8:\"reusable\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:8:\"reusable\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:9:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:8:\"reusable\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:20:\"Custom block library\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:2:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:37:\"There are no custom blocks available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}s:27:\"block_content_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:27:\"block_content_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:27:\"block_content_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:13:\"block_content\";s:9:\"plugin_id\";s:27:\"block_content_listing_empty\";s:11:\"entity_type\";s:13:\"block_content\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:35:\"admin/structure/block/block-content\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:20:\"Custom block library\";s:11:\"description\";s:0:\"\";s:6:\"parent\";s:19:\"block.admin_display\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.446,1,'','0'),('views.view.comment',_binary 'a:14:{s:4:\"uuid\";s:36:\"44e54189-22c3-4dd6-aecd-2cc361466496\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cCq1vjj1qmyd39oBIUyOe8YPDsobJ5fZRhp2Xy5O7lA\";}s:2:\"id\";s:7:\"comment\";s:5:\"label\";s:8:\"Comments\";s:6:\"module\";s:7:\"comment\";s:11:\"description\";s:25:\"Find and manage comments.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:18:\"comment_field_data\";s:10:\"base_field\";s:3:\"cid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:26:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"administer comments\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:6:{s:17:\"comment_bulk_form\";s:17:\"comment_bulk_form\";s:7:\"subject\";s:7:\"subject\";s:3:\"uid\";s:3:\"uid\";s:9:\"entity_id\";s:9:\"entity_id\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:6:{s:17:\"comment_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"subject\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"uid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"entity_id\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:24:\"comment_unpublish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:5:\"sorts\";a:1:{s:7:\"changed\";a:13:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:8:\"Comments\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:22:\"No comments available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"group_by\";b:0;s:9:\"css_class\";s:0:\"\";s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:14:\"page_published\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:14:\"page_published\";s:13:\"display_title\";s:18:\"Published comments\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:21:\"admin/content/comment\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:8:\"Comments\";s:11:\"description\";s:18:\"Comments published\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}s:19:\"display_description\";s:30:\"The approved comments listing.\";s:17:\"display_extenders\";a:0:{}s:13:\"exposed_block\";b:0;s:15:\"display_comment\";s:0:\"\";}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:15:\"page_unapproved\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:15:\"page_unapproved\";s:13:\"display_title\";s:19:\"Unapproved comments\";s:8:\"position\";i:2;s:15:\"display_options\";a:8:{s:4:\"path\";s:30:\"admin/content/comment/approval\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:19:\"Unapproved comments\";s:11:\"description\";s:19:\"Comments unapproved\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:1;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}s:19:\"display_description\";s:32:\"The unapproved comments listing.\";s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author Name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:8:\"defaults\";a:3:{s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;}s:17:\"display_extenders\";a:0:{}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:22:\"comment_publish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.446,1,'','0'),('views.view.comments_recent',_binary 'a:14:{s:4:\"uuid\";s:36:\"e1d6c846-7e7f-45e2-8242-2bd70c6eed1c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:4:\"node\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"HacS-nsDH7uyoKhQHNyV_MNRClmPVuhU_fWZgNuEyIs\";}s:2:\"id\";s:15:\"comments_recent\";s:5:\"label\";s:15:\"Recent comments\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:16:\"Recent comments.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:18:\"comment_field_data\";s:10:\"base_field\";s:3:\"cid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:14:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:15:\"access comments\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:2:{s:22:\"default_field_elements\";b:1;s:10:\"hide_empty\";b:0;}}s:13:\"relationships\";a:1:{s:4:\"node\";a:5:{s:5:\"field\";s:4:\"node\";s:2:\"id\";s:4:\"node\";s:5:\"table\";s:18:\"comment_field_data\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:2:{s:7:\"subject\";a:26:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:9:\"plugin_id\";s:5:\"field\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:15:\"@interval hence\";s:11:\"past_format\";s:13:\"@interval ago\";s:11:\"granularity\";i:2;}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";}s:11:\"status_node\";a:10:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"node\";s:2:\"id\";s:11:\"status_node\";s:9:\"plugin_id\";s:7:\"boolean\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}}s:5:\"sorts\";a:2:{s:7:\"created\";a:12:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"created\";}s:3:\"cid\";a:11:{s:2:\"id\";s:3:\"cid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"cid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"cid\";}}s:5:\"title\";s:15:\"Recent comments\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:11:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:22:\"No comments available.\";s:8:\"tokenize\";b:0;s:9:\"plugin_id\";s:11:\"text_custom\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"block_description\";s:15:\"Recent comments\";s:14:\"block_category\";s:13:\"Lists (Views)\";s:5:\"allow\";a:1:{s:14:\"items_per_page\";b:1;}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.446,1,'','0'),('views.view.content',_binary 'a:14:{s:4:\"uuid\";s:36:\"b41b4bd4-c008-45ad-9078-affdc821f445\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tS8PbpJX90aRFC3-UTgXzdqkq7_2frk2pz4TMijEebM\";}s:2:\"id\";s:7:\"content\";s:5:\"label\";s:7:\"Content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:24:\"Find and manage content.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:23:\"access content overview\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:50;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:14:\"node_bulk_form\";s:14:\"node_bulk_form\";s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:7:\"changed\";s:7:\"changed\";s:9:\"edit_node\";s:9:\"edit_node\";s:11:\"delete_node\";s:11:\"delete_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";s:9:\"timestamp\";s:5:\"title\";}s:4:\"info\";a:10:{s:14:\"node_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"delete_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:7:{s:14:\"node_bulk_form\";a:14:{s:2:\"id\";s:14:\"node_bulk_form\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:14:\"node_bulk_form\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"node_bulk_form\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:17:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Content type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:17:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:17:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:9:\"Published\";s:19:\"format_custom_false\";s:11:\"Unpublished\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"changed\";a:17:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";}s:10:\"operations\";a:23:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:5:{s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Content type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"bundle\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:16:\"Published status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:9:\"Published\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:11:\"Unpublished\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}s:12:\"status_extra\";a:8:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:12:\"status_extra\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";b:0;s:9:\"plugin_id\";s:11:\"node_status\";s:5:\"group\";i:1;s:11:\"entity_type\";s:4:\"node\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:7:\"Content\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:21:\"No content available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"uid\";a:6:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:16:\"show_admin_links\";b:0;s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:2:\"id\";s:7:\"default\";s:8:\"position\";i:0;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:21:\"user.node_grants:view\";i:6;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:15:\"display_options\";a:4:{s:4:\"path\";s:18:\"admin/content/node\";s:4:\"menu\";a:6:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:0:\"\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:23:\"Find and manage content\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:2:\"id\";s:6:\"page_1\";s:8:\"position\";i:1;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:21:\"user.node_grants:view\";i:6;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.446,1,'','0'),('views.view.content_recent',_binary 'a:14:{s:4:\"uuid\";s:36:\"bdd50755-73e5-47be-976b-ae900ccabe94\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sqwEJaSgef4rCaRMf-JdNAdV_kCICU1SfQh5Wl2sUrc\";}s:2:\"id\";s:14:\"content_recent\";s:5:\"label\";s:14:\"Recent content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:15:\"Recent content.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:22:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:2:{s:5:\"title\";a:26:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:12:\"status_extra\";a:15:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:12:\"status_extra\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";b:0;s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"node_status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:5:\"sorts\";a:1:{s:7:\"changed\";a:13:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:14:\"Recent content\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:21:\"No content available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"More\";s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:1:\"0\";}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:4:\"user\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:4:\"user\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.446,1,'','0'),('views.view.files',_binary 'a:14:{s:4:\"uuid\";s:36:\"0435a20c-c8f6-4a0b-9685-ac4cc90a84d6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"file\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rRWxAX-IQkJ5viACQRovRkC784EyCl9493GU_G23n2Q\";}s:2:\"id\";s:5:\"files\";s:5:\"label\";s:5:\"Files\";s:6:\"module\";s:4:\"file\";s:11:\"description\";s:22:\"Find and manage files.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:12:\"file_managed\";s:10:\"base_field\";s:3:\"fid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:21:\"access files overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:3:\"fid\";s:3:\"fid\";s:8:\"filename\";s:8:\"filename\";s:8:\"filemime\";s:8:\"filemime\";s:8:\"filesize\";s:8:\"filesize\";s:6:\"status\";s:6:\"status\";s:7:\"created\";s:7:\"created\";s:7:\"changed\";s:7:\"changed\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:8:{s:3:\"fid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filename\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filemime\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:8:\"filesize\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:3:\"fid\";a:24:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"Fid\";s:7:\"exclude\";b:1;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}s:8:\"filename\";a:36:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Name\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"file_link\";s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:25:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"MIME type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"file_filemime\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:8:\"filesize\";a:25:{s:2:\"id\";s:8:\"filesize\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filesize\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Size\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"file_size\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filesize\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:19:\"format_custom_false\";s:9:\"Temporary\";s:18:\"format_custom_true\";s:9:\"Permanent\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Upload date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"created\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Changed date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"changed\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:3:\"fid\";s:10:\"group_type\";s:3:\"sum\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Used in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/content/files/usage/{{ fid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:1;s:20:\"format_plural_string\";s:21:\"1 place@count places\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:3:{s:8:\"filename\";a:16:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:8:\"Filename\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filename_op\";s:10:\"identifier\";s:8:\"filename\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:16:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:9:\"MIME type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filemime_op\";s:10:\"identifier\";s:8:\"filemime\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:9:\"status_op\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"file_status\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:5:\"Files\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:19:\"No files available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:9:\"arguments\";a:0:{}s:8:\"group_by\";b:1;s:16:\"show_admin_links\";b:1;s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:14:\"Files overview\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:19:\"admin/content/files\";s:4:\"menu\";a:6:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:5:\"Files\";s:11:\"description\";s:0:\"\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:0;s:7:\"context\";s:0:\"\";}s:19:\"display_description\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"pager\";b:1;s:13:\"relationships\";b:0;}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:0;}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:10:\"File usage\";s:8:\"position\";i:2;s:15:\"display_options\";a:15:{s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:27:\"admin/content/files/usage/%\";s:5:\"empty\";a:0:{}s:8:\"defaults\";a:11:{s:5:\"empty\";b:0;s:5:\"pager\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;s:8:\"group_by\";b:0;s:5:\"title\";b:0;s:9:\"arguments\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:13:\"relationships\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:7:\"filters\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:0:{}}s:6:\"fields\";a:4:{s:12:\"entity_label\";a:23:{s:2:\"id\";s:12:\"entity_label\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:12:\"entity_label\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Entity\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:14:\"link_to_entity\";b:1;s:9:\"plugin_id\";s:12:\"entity_label\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Entity type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:6:\"module\";a:22:{s:2:\"id\";s:6:\"module\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:6:\"module\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:18:\"Registering module\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Use count\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"group_by\";b:0;s:5:\"title\";s:10:\"File usage\";s:9:\"arguments\";a:1:{s:3:\"fid\";a:23:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:46:\"File usage information for {{ arguments.fid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:9:\"plugin_id\";s:8:\"file_fid\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:12:\"entity_label\";s:12:\"entity_label\";s:4:\"type\";s:4:\"type\";s:6:\"module\";s:6:\"module\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:4:{s:12:\"entity_label\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:6:\"module\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:12:\"entity_label\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.446,1,'','0'),('views.view.frontpage',_binary 'a:14:{s:4:\"uuid\";s:36:\"13ca1035-59fd-489b-987d-488b35db0447\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"core.entity_view_mode.node.rss\";i:1;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ezK5Dw8P_4bqJdDQIiecSAJak9p1Wf1yDwHzTutGFuQ\";}s:2:\"id\";s:9:\"frontpage\";s:5:\"label\";s:9:\"Frontpage\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:39:\"All content promoted to the front page.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"empty\";a:3:{s:16:\"area_text_custom\";a:11:{s:11:\"admin_label\";s:0:\"\";s:7:\"content\";s:181:\"No front page content has been created yet.<br/>Follow the <a target=\"_blank\" href=\"https://www.drupal.org/docs/user_guide/en/index.html\">User Guide</a> to start building your site.\";s:5:\"empty\";b:1;s:5:\"field\";s:16:\"area_text_custom\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:16:\"area_text_custom\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:5:\"views\";s:8:\"tokenize\";b:0;s:9:\"plugin_id\";s:11:\"text_custom\";}s:18:\"node_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:18:\"node_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:18:\"node_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:4:\"node\";s:9:\"plugin_id\";s:18:\"node_listing_empty\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:10:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"title\";s:22:\"Welcome to [site:name]\";s:9:\"plugin_id\";s:5:\"title\";}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:7:\"filters\";a:3:{s:7:\"promote\";a:16:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:10:{s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"operator\";s:0:\"\";s:11:\"operator_id\";s:0:\"\";s:8:\"remember\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:8:\"required\";b:0;s:12:\"use_operator\";b:0;}s:7:\"exposed\";b:0;s:5:\"field\";s:7:\"promote\";s:5:\"group\";i:1;s:10:\"group_info\";a:10:{s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"description\";s:0:\"\";s:11:\"group_items\";a:0:{}s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"optional\";b:1;s:8:\"remember\";b:0;s:6:\"widget\";s:6:\"select\";}s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:7:\"promote\";s:10:\"is_grouped\";b:0;s:8:\"operator\";s:1:\"=\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"promote\";}s:6:\"status\";a:9:{s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"field\";s:6:\"status\";s:5:\"group\";i:1;s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:8:\"quantity\";i:9;}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:12:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:7:\"exposed\";b:0;s:5:\"field\";s:6:\"sticky\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"sticky\";}s:7:\"created\";a:13:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:5:\"title\";s:0:\"\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:2:\"id\";s:7:\"default\";s:8:\"position\";i:0;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:14:\"url.query_args\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"feed_1\";a:6:{s:14:\"display_plugin\";s:4:\"feed\";s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:14:\"sitename_title\";b:1;s:4:\"path\";s:7:\"rss.xml\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:0:\"\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:3:\"rss\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:21:\"user.node_grants:view\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:15:\"display_options\";a:2:{s:4:\"path\";s:4:\"node\";s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:2:\"id\";s:6:\"page_1\";s:8:\"position\";i:1;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:14:\"url.query_args\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.ga_reports_page',_binary 'a:14:{s:4:\"uuid\";s:36:\"64a1de1e-195f-4d38-8c57-14a4bc8a9181\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:10:\"ga_reports\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"qcRlAYMa4PKQeB5UugTcREIac_H8F7fJyJBo1EBUyhQ\";}s:2:\"id\";s:15:\"ga_reports_page\";s:5:\"label\";s:16:\"Google Analytics\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:35:\"Display Google Analytics Statistics\";s:3:\"tag\";s:16:\"Google Analytics\";s:10:\"base_table\";s:2:\"ga\";s:10:\"base_field\";s:0:\"\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:6:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:31:\"access google analytics reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:5:\"table\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:7:{s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:15:\"uniquePageviews\";a:30:{s:2:\"id\";s:15:\"uniquePageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:15:\"uniquePageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:16:\"Unique Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:13:\"avgTimeOnPage\";a:25:{s:2:\"id\";s:13:\"avgTimeOnPage\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:13:\"avgTimeOnPage\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:17:\"Avg. Time on Page\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"i:s\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:9:\"entrances\";a:30:{s:2:\"id\";s:9:\"entrances\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"entrances\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Entrances\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:10:\"bounceRate\";a:30:{s:2:\"id\";s:10:\"bounceRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"bounceRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bounce Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:8:\"exitRate\";a:30:{s:2:\"id\";s:8:\"exitRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"exitRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Exit Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:9:\"pageValue\";a:30:{s:2:\"id\";s:9:\"pageValue\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageValue\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Page Value\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:1:\"$\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:29:\"Google Analytics Reports Page\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:24:\"This page was not viewed\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:33:\"<h2>This page was not viewed</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:39:\"Google Analytics details for front page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:23:\"attachment_top_keywords\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:23:\"attachment_top_keywords\";s:13:\"display_title\";s:12:\"Top Keywords\";s:8:\"position\";i:4;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:8:\"defaults\";a:9:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"sorts\";b:0;s:5:\"empty\";b:0;s:9:\"arguments\";b:0;s:6:\"header\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:6:\"fields\";a:2:{s:7:\"keyword\";a:22:{s:2:\"id\";s:7:\"keyword\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:7:\"keyword\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:8:\"displays\";a:2:{s:10:\"page_front\";s:10:\"page_front\";s:11:\"page_others\";s:11:\"page_others\";}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:18:\"Keywords not found\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:19:\"Keywords not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:38:\"Google Analytics details for \"%1\" page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:12:\"Top Keywords\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:21:\"<h2>Top Keywords</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:24:\"attachment_top_referrals\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:24:\"attachment_top_referrals\";s:13:\"display_title\";s:13:\"Top Referrals\";s:8:\"position\";i:4;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:8:\"defaults\";a:9:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"sorts\";b:0;s:5:\"empty\";b:0;s:9:\"arguments\";b:0;s:6:\"header\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:6:\"fields\";a:2:{s:6:\"source\";a:22:{s:2:\"id\";s:6:\"source\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"source\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:3:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:6:\"medium\";a:14:{s:2:\"id\";s:6:\"medium\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"medium\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:8:\"referral\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:9:\"ga_string\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:8:\"displays\";a:2:{s:10:\"page_front\";s:10:\"page_front\";s:11:\"page_others\";s:11:\"page_others\";}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:19:\"Referrals not found\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"Referrals not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:38:\"Google Analytics details for \"%1\" page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:13:\"Top Referrals\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:22:\"<h2>Top Referrals</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:5:\"block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:6;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:34:\"Page traffic over the past 30 days\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:9:\"arguments\";b:0;s:5:\"empty\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:3:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:7:\"ga_path\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:33:\"Page doesn\'t have any statistics.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:17:\"block_description\";s:35:\"Google Analytics Reports Page Block\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:10:\"page_front\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:10:\"page_front\";s:13:\"display_title\";s:12:\"Page - Front\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:43:\"admin/reports/google-analytics-reports/page\";s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:11:\"page_others\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:11:\"page_others\";s:13:\"display_title\";s:13:\"Page - Others\";s:8:\"position\";i:3;s:15:\"display_options\";a:5:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:45:\"admin/reports/google-analytics-reports/page/%\";s:19:\"display_description\";s:0:\"\";s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:60:\"Google Analytics details for \"{{ arguments.pagePath }}\" page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.ga_summary',_binary 'a:14:{s:4:\"uuid\";s:36:\"fs5ek9f7-ffd8-4bb4-a4b6-323187899236\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:17:\"system.menu.admin\";}s:6:\"module\";a:2:{i:0;s:10:\"ga_reports\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cMHSU3DaAgwZnhwWwbba07iBHGBv5SiMazN3JSB9hl4\";}s:2:\"id\";s:10:\"ga_summary\";s:5:\"label\";s:24:\"Google Analytics Summary\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:74:\"Display summary statistic information about website from Google Analytics.\";s:3:\"tag\";s:24:\"Google Analytics Reports\";s:10:\"base_table\";s:2:\"ga\";s:10:\"base_field\";s:0:\"\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:6:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:31:\"access google analytics reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:5:\"table\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:7:{s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Sessions\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:5:\"users\";a:30:{s:2:\"id\";s:5:\"users\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:5:\"users\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Users\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:19:\"pageviewsPerSession\";a:30:{s:2:\"id\";s:19:\"pageviewsPerSession\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:19:\"pageviewsPerSession\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:15:\"Pages / Session\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:18:\"avgSessionDuration\";a:25:{s:2:\"id\";s:18:\"avgSessionDuration\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:18:\"avgSessionDuration\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:21:\"Avg. Session Duration\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"i:s\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:10:\"bounceRate\";a:30:{s:2:\"id\";s:10:\"bounceRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"bounceRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bounce Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:18:\"percentNewSessions\";a:30:{s:2:\"id\";s:18:\"percentNewSessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:18:\"percentNewSessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:14:\"% New Sessions\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:24:\"Google Analytics Summary\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:9:\"css_class\";s:32:\"google-analytics-reports-summary\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:23:\"attachment_top_keywords\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:23:\"attachment_top_keywords\";s:13:\"display_title\";s:12:\"Top Keywords\";s:8:\"position\";i:4;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:8:\"displays\";a:1:{s:6:\"page_1\";s:6:\"page_1\";}s:6:\"fields\";a:2:{s:7:\"keyword\";a:22:{s:2:\"id\";s:7:\"keyword\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:7:\"keyword\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:30:\"<strong>{{ keyword }}</strong>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:8:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;}s:5:\"title\";s:0:\"\";s:9:\"css_class\";s:78:\"google-analytics-reports-summary google-analytics-reports-summary-top-keywords\";s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:16:\"Pages not found.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:16:\"Pages not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:12:\"Top Keywords\";s:5:\"empty\";b:0;s:8:\"tokenize\";b:0;s:7:\"content\";s:21:\"<h2>Top Keywords</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:20:\"attachment_top_pages\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:20:\"attachment_top_pages\";s:13:\"display_title\";s:9:\"Top Pages\";s:8:\"position\";i:2;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:8:\"displays\";a:1:{s:6:\"page_1\";s:6:\"page_1\";}s:6:\"fields\";a:3:{s:8:\"pagePath\";a:22:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageTitle\";a:22:{s:2:\"id\";s:9:\"pageTitle\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageTitle\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:44:\"<a href=\"{{ pagePath }}\">{{ pageTitle }}</a>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:6:\" views\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:8:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;}s:5:\"title\";s:0:\"\";s:9:\"css_class\";s:75:\"google-analytics-reports-summary google-analytics-reports-summary-top-pages\";s:5:\"sorts\";a:1:{s:9:\"pageviews\";a:10:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:16:\"Pages not found.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:16:\"Pages not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:9:\"Top Pages\";s:5:\"empty\";b:0;s:8:\"tokenize\";b:0;s:7:\"content\";s:18:\"<h2>Top Pages</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:22:\"attachment_top_sources\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:22:\"attachment_top_sources\";s:13:\"display_title\";s:11:\"Top Sources\";s:8:\"position\";i:3;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:8:\"displays\";a:1:{s:6:\"page_1\";s:6:\"page_1\";}s:6:\"fields\";a:3:{s:6:\"source\";a:22:{s:2:\"id\";s:6:\"source\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"source\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:32:\"<strong>{{ source }}</strong> - \";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:6:\"medium\";a:22:{s:2:\"id\";s:6:\"medium\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"medium\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:2:\"- \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:8:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;}s:5:\"title\";s:0:\"\";s:9:\"css_class\";s:77:\"google-analytics-reports-summary google-analytics-reports-summary-top-sources\";s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:16:\"Pages not found.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:16:\"Pages not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:11:\"Top Sources\";s:5:\"empty\";b:0;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"<h2>Top Sources</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:5;s:15:\"display_options\";a:17:{s:17:\"display_extenders\";a:0:{}s:6:\"fields\";a:3:{s:8:\"pagePath\";a:22:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageTitle\";a:22:{s:2:\"id\";s:9:\"pageTitle\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageTitle\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:44:\"<a href=\"{{ pagePath }}\">{{ pageTitle }}</a>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:6:\" views\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:14:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;s:5:\"pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";b:0;s:12:\"link_display\";b:0;s:8:\"link_url\";b:0;}s:5:\"title\";s:31:\"Top pages over the last 30 days\";s:9:\"css_class\";s:38:\"google-analytics-reports-summary-block\";s:5:\"sorts\";a:1:{s:9:\"pageviews\";a:10:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:5;s:6:\"offset\";i:0;}}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:33:\"Site doesn\'t have any statistics.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:33:\"Site doesn\'t have any statistics.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:0:{}s:19:\"display_description\";s:0:\"\";s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:11:\"Full report\";s:12:\"link_display\";s:6:\"page_1\";s:8:\"link_url\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:46:\"admin/reports/google-analytics-reports/summary\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:24:\"Google Analytics Summary\";s:11:\"description\";s:36:\"View a traffic report for your site.\";s:8:\"expanded\";b:0;s:6:\"parent\";s:20:\"system.admin_reports\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.glossary',_binary 'a:14:{s:4:\"uuid\";s:36:\"bbbb06c0-2d37-4f22-9554-be4d562c4786\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_12Vkw1VGBz_s0_W_LLVCrBPpioNSnB6zcd1lUAQubM\";}s:2:\"id\";s:8:\"glossary\";s:5:\"label\";s:8:\"Glossary\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:23:\"All content, by letter.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:8:\"use_ajax\";b:1;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:36;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:6:\"fields\";a:3:{s:5:\"title\";a:24:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:6:\"Author\";s:12:\"relationship\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:11:\"Last update\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:4:\"long\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";}}s:9:\"arguments\";a:1:{s:5:\"title\";a:27:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"glossary\";b:1;s:5:\"limit\";i:1;s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";b:0;s:9:\"plugin_id\";s:6:\"string\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:0:{}s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:7:\"columns\";a:3:{s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:7:\"changed\";s:7:\"changed\";}s:7:\"default\";s:5:\"title\";s:4:\"info\";a:3:{s:5:\"title\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}s:7:\"changed\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;s:5:\"order\";s:3:\"asc\";s:7:\"summary\";s:0:\"\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:5:\"sorts\";a:0:{}s:7:\"filters\";a:1:{s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:12:\"attachment_1\";a:6:{s:2:\"id\";s:12:\"attachment_1\";s:13:\"display_title\";s:10:\"Attachment\";s:14:\"display_plugin\";s:10:\"attachment\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:0;}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:5:\"title\";a:27:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:19:\"unformatted_summary\";}s:15:\"summary_options\";a:3:{s:14:\"items_per_page\";i:25;s:6:\"inline\";b:1;s:9:\"separator\";s:3:\" | \";}s:18:\"specify_validation\";b:1;s:8:\"glossary\";b:1;s:5:\"limit\";i:1;s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";b:0;s:9:\"plugin_id\";s:6:\"string\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:25:\"default_argument_skip_url\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}}s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:6:\"page_1\";s:6:\"page_1\";}s:17:\"inherit_arguments\";b:0;s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"glossary\";s:4:\"menu\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Glossary\";s:6:\"weight\";i:0;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.moderated_content',_binary 'a:14:{s:4:\"uuid\";s:36:\"f6f3c9f5-4596-47b7-84af-492bc8409347\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:18:\"content_moderation\";i:1;s:4:\"node\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1UIjNd6iIhogbx50cJPDN7Me8cUQx2xCP2IBgrKG6Ms\";}s:2:\"id\";s:17:\"moderated_content\";s:5:\"label\";s:17:\"Moderated content\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:26:\"Find and moderate content.\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:19:\"node_field_revision\";s:10:\"base_field\";s:3:\"vid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:28:\"view any unpublished content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:5:{s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:4:\"name\";s:4:\"name\";s:16:\"moderation_state\";s:16:\"moderation_state\";s:7:\"changed\";s:7:\"changed\";}s:4:\"info\";a:5:{s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:16:\"moderation_state\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:6:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:3:\"nid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Content type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:16:\"moderation_state\";a:36:{s:2:\"id\";s:16:\"moderation_state\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:16:\"Moderation state\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:24:\"content_moderation_state\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:6:{s:15:\"latest_revision\";a:15:{s:2:\"id\";s:15:\"latest_revision\";s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:15:\"latest_revision\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:15:\"latest_revision\";}s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:3:\"nid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Content type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:16:\"moderation_state\";a:15:{s:2:\"id\";s:16:\"moderation_state\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:2:{s:15:\"editorial-draft\";s:15:\"editorial-draft\";s:18:\"editorial-archived\";s:18:\"editorial-archived\";}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:19:\"moderation_state_op\";s:5:\"label\";s:16:\"Moderation state\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:19:\"moderation_state_op\";s:10:\"identifier\";s:16:\"moderation_state\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:23:\"moderation_state_filter\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}s:18:\"moderation_state_1\";a:15:{s:2:\"id\";s:18:\"moderation_state_1\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:1:{s:19:\"editorial-published\";s:19:\"editorial-published\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:23:\"moderation_state_filter\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:17:\"Moderated content\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:98:\"No moderated content available. Only pending versions of content, such as drafts, are listed here.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:2:{s:3:\"nid\";a:10:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:47:\"Get the actual content from a content revision.\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"nid\";s:9:\"plugin_id\";s:8:\"standard\";}s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"User\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:20:\"config:workflow_list\";}}}s:17:\"moderated_content\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:17:\"moderated_content\";s:13:\"display_title\";s:17:\"Moderated content\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:23:\"admin/content/moderated\";s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:20:\"config:workflow_list\";}}}}}',-1,1540294709.447,1,'','0'),('views.view.taxonomy_term',_binary 'a:14:{s:4:\"uuid\";s:36:\"c9844857-b656-434f-9b2e-b4fbe1a98e68\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:3:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Gy5PaLdfFhtFSRqJxV-DBTF5AocKgNA2CsCNNEbvx4c\";}s:2:\"id\";s:13:\"taxonomy_term\";s:5:\"label\";s:13:\"Taxonomy term\";s:6:\"module\";s:8:\"taxonomy\";s:11:\"description\";s:45:\"Content belonging to a certain taxonomy term.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:10:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:8:\"standard\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:11:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:9:\"arguments\";a:1:{s:3:\"tid\";a:23:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:19:\"{{ arguments.tid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:4:{s:6:\"access\";b:1;s:9:\"operation\";s:4:\"view\";s:8:\"multiple\";i:0;s:7:\"bundles\";a:0:{}}s:12:\"break_phrase\";b:0;s:9:\"add_table\";b:0;s:13:\"require_value\";b:0;s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:18:\"taxonomy_index_tid\";}}s:7:\"filters\";a:2:{s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}s:6:\"status\";a:14:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"header\";a:1:{s:20:\"entity_taxonomy_term\";a:12:{s:2:\"id\";s:20:\"entity_taxonomy_term\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:20:\"entity_taxonomy_term\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:1;s:6:\"target\";s:23:\"{{ raw_arguments.tid }}\";s:9:\"view_mode\";s:4:\"full\";s:13:\"bypass_access\";b:0;s:9:\"plugin_id\";s:6:\"entity\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:6:\"page_1\";}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"feed_1\";a:6:{s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:4:\"path\";s:20:\"taxonomy/term/%/feed\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:1:\"0\";}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:7:\"default\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"taxonomy/term/%\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.user_admin_people',_binary 'a:14:{s:4:\"uuid\";s:36:\"3aa0a697-db85-4dd5-8e95-ec0beebce912\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wTJRNzsLVTenCALONNlVfgm_pBOlqucSPuVFLOD56ck\";}s:2:\"id\";s:17:\"user_admin_people\";s:5:\"label\";s:6:\"People\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:25:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:16:\"administer users\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:8:{s:14:\"user_bulk_form\";s:14:\"user_bulk_form\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:3:\"rid\";s:3:\"rid\";s:7:\"created\";s:7:\"created\";s:6:\"access\";s:6:\"access\";s:9:\"edit_node\";s:9:\"edit_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";}s:4:\"info\";a:8:{s:14:\"user_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:3:\"rid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"access\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:14:\"user_bulk_form\";a:23:{s:2:\"id\";s:14:\"user_bulk_form\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:14:\"user_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bulk update\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"user_bulk_form\";s:11:\"entity_type\";s:4:\"user\";}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Username\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:6:\"Active\";s:19:\"format_custom_false\";s:7:\"Blocked\";}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:15:\"roles_target_id\";a:24:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Roles\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:9:\"plugin_id\";s:10:\"user_roles\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Member for\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:9:\"@interval\";s:11:\"past_format\";s:9:\"@interval\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}s:6:\"access\";a:26:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Last access\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:15:\"@interval hence\";s:11:\"past_format\";s:13:\"@interval ago\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:4:\"user\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:4:\"mail\";a:37:{s:2:\"id\";s:4:\"mail\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"mail\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"basic_string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"mail\";}}s:7:\"filters\";a:6:{s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:22:\"Name or email contains\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:4:\"user\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:4:\"mail\";s:4:\"mail\";}s:9:\"plugin_id\";s:7:\"combine\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:6:\"Active\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:7:\"Blocked\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:15:\"roles_target_id\";a:15:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:18:\"roles_target_id_op\";s:5:\"label\";s:4:\"Role\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:18:\"roles_target_id_op\";s:10:\"identifier\";s:4:\"role\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:10:\"user_roles\";}s:10:\"permission\";a:15:{s:2:\"id\";s:10:\"permission\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:10:\"permission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:13:\"permission_op\";s:5:\"label\";s:10:\"Permission\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:13:\"permission_op\";s:10:\"identifier\";s:10:\"permission\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:16:\"user_permissions\";}s:16:\"default_langcode\";a:16:{s:2:\"id\";s:16:\"default_langcode\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:16:\"default_langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:16:\"default_langcode\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"uid_raw\";a:15:{s:2:\"id\";s:7:\"uid_raw\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"uid_raw\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"!=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:1:\"0\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:1:\"0\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"numeric\";s:11:\"entity_type\";s:4:\"user\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"title\";s:6:\"People\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"No people available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:15:\"display_comment\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"group_by\";b:0;s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:6:\"page_1\";s:9:\"css_class\";s:0:\"\";s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:17:\"admin/people/list\";s:16:\"show_admin_links\";b:0;s:4:\"menu\";a:6:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:4:\"List\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:6:\"People\";s:11:\"description\";s:45:\"Manage user accounts, roles, and permissions.\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:0;}s:8:\"defaults\";a:1:{s:16:\"show_admin_links\";b:0;}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.watchdog',_binary 'a:14:{s:4:\"uuid\";s:36:\"8e979f14-95c2-44a5-afc5-ccfc2417086d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:5:\"dblog\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"3QZ9apklK6mQ7BzodmxzOxqO---2BCPtOLE3k9eQ0Is\";}s:2:\"id\";s:8:\"watchdog\";s:5:\"label\";s:8:\"Watchdog\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:19:\"Recent log messages\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:8:\"watchdog\";s:10:\"base_field\";s:3:\"wid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"access site reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:0;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:25:\"{{ type }} {{ severity }}\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:7:\"nothing\";s:7:\"nothing\";s:3:\"wid\";s:3:\"wid\";s:8:\"severity\";s:8:\"severity\";s:4:\"type\";s:4:\"type\";s:9:\"timestamp\";s:9:\"timestamp\";s:7:\"message\";s:7:\"message\";s:4:\"name\";s:4:\"name\";s:4:\"link\";s:4:\"link\";}s:4:\"info\";a:8:{s:7:\"nothing\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:3:\"wid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:8:\"severity\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"message\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:4:\"link\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}}s:7:\"default\";s:3:\"wid\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:7:\"nothing\";a:22:{s:2:\"id\";s:7:\"nothing\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"nothing\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"Icon\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:4:\"icon\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:0;s:9:\"plugin_id\";s:6:\"custom\";}s:3:\"wid\";a:22:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"WID\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"severity\";a:23:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Severity\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"machine_name\";b:0;s:9:\"plugin_id\";s:12:\"machine_name\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"timestamp\";a:25:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:9:\"timestamp\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:7:\"message\";a:23:{s:2:\"id\";s:7:\"message\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:7:\"message\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Message\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/reports/dblog/event/{{ wid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:13:\"{{ message }}\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:56;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:1;s:4:\"trim\";b:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"replace_variables\";b:1;s:9:\"plugin_id\";s:13:\"dblog_message\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"User\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"link\";a:22:{s:2:\"id\";s:4:\"link\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:16:\"dblog_operations\";}}s:7:\"filters\";a:2:{s:4:\"type\";a:14:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"dblog_types\";}s:8:\"severity\";a:14:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"severity_op\";s:5:\"label\";s:8:\"Severity\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"severity_op\";s:10:\"identifier\";s:8:\"severity\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"in_operator\";}}s:5:\"sorts\";a:1:{s:3:\"wid\";a:10:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"title\";s:19:\"Recent log messages\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:26:\"No log messages available.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:26:\"No log messages available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"User\";s:8:\"required\";b:0;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:9:\"css_class\";s:11:\"admin-dblog\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:4:\"page\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:2:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:19:\"admin/reports/dblog\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.who_s_new',_binary 'a:14:{s:4:\"uuid\";s:36:\"248c0cf4-3881-404a-bc41-3269e0302465\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"o_8fSWHZOVIbydZACGsSX09DtuJhqkRmNOzcVj-4bQI\";}s:2:\"id\";s:9:\"who_s_new\";s:5:\"label\";s:9:\"Who\'s new\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:53:\"Shows a list of the newest user accounts on the site.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:5;s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:9:\"html_list\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:0:\"\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:5:\"group\";i:1;s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:6:\"access\";a:16:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\">\";s:5:\"value\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:10:\"1970-01-01\";s:4:\"type\";s:4:\"date\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:1:\"0\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"title\";s:9:\"Who\'s new\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:9:\"Who\'s new\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:19:\"display_description\";s:19:\"A list of new users\";s:17:\"block_description\";s:9:\"Who\'s new\";s:14:\"block_category\";s:4:\"User\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('views.view.who_s_online',_binary 'a:14:{s:4:\"uuid\";s:36:\"510cbdf1-d2b7-4bc9-96e9-c372ecb6d545\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"m0vmYmhrzMR6S_IC0UlK0Cl-q5lEvL8-EbxbbcDtk34\";}s:2:\"id\";s:12:\"who_s_online\";s:5:\"label\";s:18:\"Who\'s online block\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:93:\"Shows the user names of the most recently active users, and the total number of active users.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:20:\"access user profiles\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:0:\"\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:5:\"group\";i:1;s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:6:\"access\";a:16:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\">=\";s:5:\"value\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:11:\"-15 minutes\";s:4:\"type\";s:6:\"offset\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:9:\"access_op\";s:5:\"label\";s:11:\"Last access\";s:11:\"description\";s:77:\"A user is considered online for this long after they have last viewed a page.\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"access_op\";s:10:\"identifier\";s:6:\"access\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"sorts\";a:1:{s:6:\"access\";a:13:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:5:\"order\";s:4:\"DESC\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"title\";s:12:\"Who\'s online\";s:6:\"header\";a:1:{s:6:\"result\";a:9:{s:2:\"id\";s:6:\"result\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:6:\"result\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:7:\"content\";s:40:\"There are currently @total users online.\";s:9:\"plugin_id\";s:6:\"result\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:35:\"There are currently 0 users online.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:18:\"who_s_online_block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:18:\"who_s_online_block\";s:13:\"display_title\";s:12:\"Who\'s online\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"block_description\";s:12:\"Who\'s online\";s:19:\"display_description\";s:45:\"A list of users that are currently logged in.\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}',-1,1540294709.447,1,'','0'),('workflows.workflow.editorial',_binary 'a:9:{s:4:\"uuid\";s:36:\"20c79df6-385e-4ffd-bb07-65f3bb58d891\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:18:\"content_moderation\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"T_JxNjYlfoRBi7Bj1zs5Xv9xv1btuBkKp5C1tNrjMhI\";}s:2:\"id\";s:9:\"editorial\";s:5:\"label\";s:9:\"Editorial\";s:4:\"type\";s:18:\"content_moderation\";s:13:\"type_settings\";a:3:{s:6:\"states\";a:3:{s:8:\"archived\";a:4:{s:5:\"label\";s:8:\"Archived\";s:6:\"weight\";i:5;s:9:\"published\";b:0;s:16:\"default_revision\";b:1;}s:5:\"draft\";a:4:{s:5:\"label\";s:5:\"Draft\";s:9:\"published\";b:0;s:16:\"default_revision\";b:0;s:6:\"weight\";i:-5;}s:9:\"published\";a:4:{s:5:\"label\";s:9:\"Published\";s:9:\"published\";b:1;s:16:\"default_revision\";b:1;s:6:\"weight\";i:0;}}s:11:\"transitions\";a:5:{s:7:\"archive\";a:4:{s:5:\"label\";s:7:\"Archive\";s:4:\"from\";a:1:{i:0;s:9:\"published\";}s:2:\"to\";s:8:\"archived\";s:6:\"weight\";i:2;}s:14:\"archived_draft\";a:4:{s:5:\"label\";s:16:\"Restore to Draft\";s:4:\"from\";a:1:{i:0;s:8:\"archived\";}s:2:\"to\";s:5:\"draft\";s:6:\"weight\";i:3;}s:18:\"archived_published\";a:4:{s:5:\"label\";s:7:\"Restore\";s:4:\"from\";a:1:{i:0;s:8:\"archived\";}s:2:\"to\";s:9:\"published\";s:6:\"weight\";i:4;}s:16:\"create_new_draft\";a:4:{s:5:\"label\";s:16:\"Create New Draft\";s:2:\"to\";s:5:\"draft\";s:6:\"weight\";i:0;s:4:\"from\";a:2:{i:0;s:5:\"draft\";i:1;s:9:\"published\";}}s:7:\"publish\";a:4:{s:5:\"label\";s:7:\"Publish\";s:2:\"to\";s:9:\"published\";s:6:\"weight\";i:1;s:4:\"from\";a:2:{i:0;s:5:\"draft\";i:1;s:9:\"published\";}}}s:12:\"entity_types\";a:0:{}}}',-1,1540294710.035,1,'','0');
/*!40000 ALTER TABLE `cache_config` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_container`
--

DROP TABLE IF EXISTS `cache_container`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_container` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_container`
--

LOCK TABLES `cache_container` WRITE;
/*!40000 ALTER TABLE `cache_container` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_container` VALUES ('service_container:prod:8.6.1::Linux:a:1:{i:0;s:52:\"/var/www/html/drupal8/web/sites/default/services.yml\";}',_binary 'a:5:{s:7:\"aliases\";a:6:{s:32:\"Psr\\Container\\ContainerInterface\";s:17:\"service_container\";s:56:\"Symfony\\Component\\DependencyInjection\\ContainerInterface\";s:17:\"service_container\";s:19:\"config.storage.sync\";s:22:\"config.storage.staging\";s:15:\"session_handler\";s:26:\"session_handler.write_safe\";s:12:\"element_info\";s:27:\"plugin.manager.element_info\";s:22:\"access_check.rest.csrf\";s:24:\"access_check.header.csrf\";}s:10:\"parameters\";a:24:{s:18:\"kernel.environment\";s:4:\"prod\";s:17:\"container.modules\";a:64:{s:13:\"admin_toolbar\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:52:\"modules/contrib/admin_toolbar/admin_toolbar.info.yml\";s:8:\"filename\";s:20:\"admin_toolbar.module\";}s:14:\"automated_cron\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:51:\"core/modules/automated_cron/automated_cron.info.yml\";s:8:\"filename\";s:21:\"automated_cron.module\";}s:8:\"big_pipe\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:39:\"core/modules/big_pipe/big_pipe.info.yml\";s:8:\"filename\";s:15:\"big_pipe.module\";}s:5:\"block\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:33:\"core/modules/block/block.info.yml\";s:8:\"filename\";s:12:\"block.module\";}s:11:\"block_class\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:48:\"modules/contrib/block_class/block_class.info.yml\";s:8:\"filename\";s:18:\"block_class.module\";}s:13:\"block_content\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:49:\"core/modules/block_content/block_content.info.yml\";s:8:\"filename\";s:20:\"block_content.module\";}s:10:\"breakpoint\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:43:\"core/modules/breakpoint/breakpoint.info.yml\";s:8:\"filename\";s:17:\"breakpoint.module\";}s:8:\"ckeditor\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:39:\"core/modules/ckeditor/ckeditor.info.yml\";s:8:\"filename\";s:15:\"ckeditor.module\";}s:5:\"color\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:33:\"core/modules/color/color.info.yml\";s:8:\"filename\";s:12:\"color.module\";}s:7:\"comment\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:37:\"core/modules/comment/comment.info.yml\";s:8:\"filename\";s:14:\"comment.module\";}s:6:\"config\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:35:\"core/modules/config/config.info.yml\";s:8:\"filename\";s:13:\"config.module\";}s:7:\"contact\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:37:\"core/modules/contact/contact.info.yml\";s:8:\"filename\";s:14:\"contact.module\";}s:13:\"contact_block\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:52:\"modules/contrib/contact_block/contact_block.info.yml\";s:8:\"filename\";N;}s:18:\"content_moderation\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:59:\"core/modules/content_moderation/content_moderation.info.yml\";s:8:\"filename\";s:25:\"content_moderation.module\";}s:32:\"content_moderation_notifications\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:90:\"modules/contrib/content_moderation_notifications/content_moderation_notifications.info.yml\";s:8:\"filename\";s:39:\"content_moderation_notifications.module\";}s:10:\"contextual\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:43:\"core/modules/contextual/contextual.info.yml\";s:8:\"filename\";s:17:\"contextual.module\";}s:8:\"datetime\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:39:\"core/modules/datetime/datetime.info.yml\";s:8:\"filename\";s:15:\"datetime.module\";}s:5:\"dblog\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:33:\"core/modules/dblog/dblog.info.yml\";s:8:\"filename\";s:12:\"dblog.module\";}s:5:\"devel\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:36:\"modules/contrib/devel/devel.info.yml\";s:8:\"filename\";s:12:\"devel.module\";}s:14:\"devel_generate\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:60:\"modules/contrib/devel/devel_generate/devel_generate.info.yml\";s:8:\"filename\";s:21:\"devel_generate.module\";}s:18:\"dynamic_page_cache\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:59:\"core/modules/dynamic_page_cache/dynamic_page_cache.info.yml\";s:8:\"filename\";s:25:\"dynamic_page_cache.module\";}s:6:\"editor\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:35:\"core/modules/editor/editor.info.yml\";s:8:\"filename\";s:13:\"editor.module\";}s:6:\"entity\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:38:\"modules/contrib/entity/entity.info.yml\";s:8:\"filename\";s:13:\"entity.module\";}s:5:\"field\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:33:\"core/modules/field/field.info.yml\";s:8:\"filename\";s:12:\"field.module\";}s:8:\"field_ui\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:39:\"core/modules/field_ui/field_ui.info.yml\";s:8:\"filename\";s:15:\"field_ui.module\";}s:4:\"file\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/file/file.info.yml\";s:8:\"filename\";s:11:\"file.module\";}s:6:\"filter\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:35:\"core/modules/filter/filter.info.yml\";s:8:\"filename\";s:13:\"filter.module\";}s:10:\"ga_reports\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:46:\"modules/ custom/ga_reports/ga_reports.info.yml\";s:8:\"filename\";s:17:\"ga_reports.module\";}s:4:\"help\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/help/help.info.yml\";s:8:\"filename\";s:11:\"help.module\";}s:7:\"history\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:37:\"core/modules/history/history.info.yml\";s:8:\"filename\";s:14:\"history.module\";}s:5:\"image\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:33:\"core/modules/image/image.info.yml\";s:8:\"filename\";s:12:\"image.module\";}s:4:\"kint\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:40:\"modules/contrib/devel/kint/kint.info.yml\";s:8:\"filename\";s:11:\"kint.module\";}s:4:\"link\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/link/link.info.yml\";s:8:\"filename\";s:11:\"link.module\";}s:7:\"menu_ui\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:37:\"core/modules/menu_ui/menu_ui.info.yml\";s:8:\"filename\";s:14:\"menu_ui.module\";}s:7:\"migrate\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:37:\"core/modules/migrate/migrate.info.yml\";s:8:\"filename\";s:14:\"migrate.module\";}s:14:\"migrate_drupal\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:51:\"core/modules/migrate_drupal/migrate_drupal.info.yml\";s:8:\"filename\";s:21:\"migrate_drupal.module\";}s:27:\"migrate_drupal_multilingual\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:77:\"core/modules/migrate_drupal_multilingual/migrate_drupal_multilingual.info.yml\";s:8:\"filename\";s:34:\"migrate_drupal_multilingual.module\";}s:17:\"migrate_drupal_ui\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:57:\"core/modules/migrate_drupal_ui/migrate_drupal_ui.info.yml\";s:8:\"filename\";s:24:\"migrate_drupal_ui.module\";}s:12:\"migrate_plus\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:50:\"modules/contrib/migrate_plus/migrate_plus.info.yml\";s:8:\"filename\";s:19:\"migrate_plus.module\";}s:13:\"migrate_tools\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:52:\"modules/contrib/migrate_tools/migrate_tools.info.yml\";s:8:\"filename\";s:20:\"migrate_tools.module\";}s:15:\"migrate_upgrade\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:56:\"modules/contrib/migrate_upgrade/migrate_upgrade.info.yml\";s:8:\"filename\";N;}s:4:\"node\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/node/node.info.yml\";s:8:\"filename\";s:11:\"node.module\";}s:7:\"options\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:37:\"core/modules/options/options.info.yml\";s:8:\"filename\";s:14:\"options.module\";}s:10:\"page_cache\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:43:\"core/modules/page_cache/page_cache.info.yml\";s:8:\"filename\";s:17:\"page_cache.module\";}s:4:\"path\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/path/path.info.yml\";s:8:\"filename\";s:11:\"path.module\";}s:9:\"quickedit\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:41:\"core/modules/quickedit/quickedit.info.yml\";s:8:\"filename\";s:16:\"quickedit.module\";}s:3:\"rdf\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:29:\"core/modules/rdf/rdf.info.yml\";s:8:\"filename\";s:10:\"rdf.module\";}s:4:\"rest\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/rest/rest.info.yml\";s:8:\"filename\";s:11:\"rest.module\";}s:6:\"search\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:35:\"core/modules/search/search.info.yml\";s:8:\"filename\";s:13:\"search.module\";}s:13:\"serialization\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:49:\"core/modules/serialization/serialization.info.yml\";s:8:\"filename\";s:20:\"serialization.module\";}s:8:\"shortcut\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:39:\"core/modules/shortcut/shortcut.info.yml\";s:8:\"filename\";s:15:\"shortcut.module\";}s:6:\"system\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:35:\"core/modules/system/system.info.yml\";s:8:\"filename\";s:13:\"system.module\";}s:8:\"taxonomy\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:39:\"core/modules/taxonomy/taxonomy.info.yml\";s:8:\"filename\";s:15:\"taxonomy.module\";}s:4:\"text\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/text/text.info.yml\";s:8:\"filename\";s:11:\"text.module\";}s:7:\"toolbar\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:37:\"core/modules/toolbar/toolbar.info.yml\";s:8:\"filename\";s:14:\"toolbar.module\";}s:4:\"tour\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/tour/tour.info.yml\";s:8:\"filename\";s:11:\"tour.module\";}s:6:\"twilio\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:38:\"modules/contrib/twilio/twilio.info.yml\";s:8:\"filename\";s:13:\"twilio.module\";}s:6:\"update\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:35:\"core/modules/update/update.info.yml\";s:8:\"filename\";s:13:\"update.module\";}s:4:\"user\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:31:\"core/modules/user/user.info.yml\";s:8:\"filename\";s:11:\"user.module\";}s:8:\"views_ui\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:39:\"core/modules/views_ui/views_ui.info.yml\";s:8:\"filename\";s:15:\"views_ui.module\";}s:9:\"workflows\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:41:\"core/modules/workflows/workflows.info.yml\";s:8:\"filename\";s:16:\"workflows.module\";}s:17:\"menu_link_content\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:57:\"core/modules/menu_link_content/menu_link_content.info.yml\";s:8:\"filename\";s:24:\"menu_link_content.module\";}s:5:\"views\";a:3:{s:4:\"type\";s:6:\"module\";s:8:\"pathname\";s:33:\"core/modules/views/views.info.yml\";s:8:\"filename\";s:12:\"views.module\";}s:8:\"standard\";a:3:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:40:\"core/profiles/standard/standard.info.yml\";s:8:\"filename\";s:16:\"standard.profile\";}}s:15:\"install_profile\";s:8:\"standard\";s:20:\"container.namespaces\";a:77:{s:20:\"Drupal\\admin_toolbar\";s:33:\"modules/contrib/admin_toolbar/src\";s:21:\"Drupal\\automated_cron\";s:31:\"core/modules/automated_cron/src\";s:15:\"Drupal\\big_pipe\";s:25:\"core/modules/big_pipe/src\";s:12:\"Drupal\\block\";s:22:\"core/modules/block/src\";s:18:\"Drupal\\block_class\";s:31:\"modules/contrib/block_class/src\";s:20:\"Drupal\\block_content\";s:30:\"core/modules/block_content/src\";s:17:\"Drupal\\breakpoint\";s:27:\"core/modules/breakpoint/src\";s:15:\"Drupal\\ckeditor\";s:25:\"core/modules/ckeditor/src\";s:12:\"Drupal\\color\";s:22:\"core/modules/color/src\";s:14:\"Drupal\\comment\";s:24:\"core/modules/comment/src\";s:13:\"Drupal\\config\";s:23:\"core/modules/config/src\";s:14:\"Drupal\\contact\";s:24:\"core/modules/contact/src\";s:20:\"Drupal\\contact_block\";s:33:\"modules/contrib/contact_block/src\";s:25:\"Drupal\\content_moderation\";s:35:\"core/modules/content_moderation/src\";s:39:\"Drupal\\content_moderation_notifications\";s:52:\"modules/contrib/content_moderation_notifications/src\";s:17:\"Drupal\\contextual\";s:27:\"core/modules/contextual/src\";s:15:\"Drupal\\datetime\";s:25:\"core/modules/datetime/src\";s:12:\"Drupal\\dblog\";s:22:\"core/modules/dblog/src\";s:12:\"Drupal\\devel\";s:25:\"modules/contrib/devel/src\";s:21:\"Drupal\\devel_generate\";s:40:\"modules/contrib/devel/devel_generate/src\";s:25:\"Drupal\\dynamic_page_cache\";s:35:\"core/modules/dynamic_page_cache/src\";s:13:\"Drupal\\editor\";s:23:\"core/modules/editor/src\";s:13:\"Drupal\\entity\";s:26:\"modules/contrib/entity/src\";s:12:\"Drupal\\field\";s:22:\"core/modules/field/src\";s:15:\"Drupal\\field_ui\";s:25:\"core/modules/field_ui/src\";s:11:\"Drupal\\file\";s:21:\"core/modules/file/src\";s:13:\"Drupal\\filter\";s:23:\"core/modules/filter/src\";s:17:\"Drupal\\ga_reports\";s:30:\"modules/ custom/ga_reports/src\";s:11:\"Drupal\\help\";s:21:\"core/modules/help/src\";s:14:\"Drupal\\history\";s:24:\"core/modules/history/src\";s:12:\"Drupal\\image\";s:22:\"core/modules/image/src\";s:11:\"Drupal\\kint\";s:30:\"modules/contrib/devel/kint/src\";s:11:\"Drupal\\link\";s:21:\"core/modules/link/src\";s:14:\"Drupal\\menu_ui\";s:24:\"core/modules/menu_ui/src\";s:14:\"Drupal\\migrate\";s:24:\"core/modules/migrate/src\";s:21:\"Drupal\\migrate_drupal\";s:31:\"core/modules/migrate_drupal/src\";s:34:\"Drupal\\migrate_drupal_multilingual\";s:44:\"core/modules/migrate_drupal_multilingual/src\";s:24:\"Drupal\\migrate_drupal_ui\";s:34:\"core/modules/migrate_drupal_ui/src\";s:19:\"Drupal\\migrate_plus\";s:32:\"modules/contrib/migrate_plus/src\";s:20:\"Drupal\\migrate_tools\";s:33:\"modules/contrib/migrate_tools/src\";s:22:\"Drupal\\migrate_upgrade\";s:35:\"modules/contrib/migrate_upgrade/src\";s:11:\"Drupal\\node\";s:21:\"core/modules/node/src\";s:14:\"Drupal\\options\";s:24:\"core/modules/options/src\";s:17:\"Drupal\\page_cache\";s:27:\"core/modules/page_cache/src\";s:11:\"Drupal\\path\";s:21:\"core/modules/path/src\";s:16:\"Drupal\\quickedit\";s:26:\"core/modules/quickedit/src\";s:10:\"Drupal\\rdf\";s:20:\"core/modules/rdf/src\";s:11:\"Drupal\\rest\";s:21:\"core/modules/rest/src\";s:13:\"Drupal\\search\";s:23:\"core/modules/search/src\";s:20:\"Drupal\\serialization\";s:30:\"core/modules/serialization/src\";s:15:\"Drupal\\shortcut\";s:25:\"core/modules/shortcut/src\";s:13:\"Drupal\\system\";s:23:\"core/modules/system/src\";s:15:\"Drupal\\taxonomy\";s:25:\"core/modules/taxonomy/src\";s:11:\"Drupal\\text\";s:21:\"core/modules/text/src\";s:14:\"Drupal\\toolbar\";s:24:\"core/modules/toolbar/src\";s:11:\"Drupal\\tour\";s:21:\"core/modules/tour/src\";s:13:\"Drupal\\twilio\";s:26:\"modules/contrib/twilio/src\";s:13:\"Drupal\\update\";s:23:\"core/modules/update/src\";s:11:\"Drupal\\user\";s:21:\"core/modules/user/src\";s:15:\"Drupal\\views_ui\";s:25:\"core/modules/views_ui/src\";s:16:\"Drupal\\workflows\";s:26:\"core/modules/workflows/src\";s:24:\"Drupal\\menu_link_content\";s:34:\"core/modules/menu_link_content/src\";s:12:\"Drupal\\views\";s:22:\"core/modules/views/src\";s:15:\"Drupal\\standard\";s:26:\"core/profiles/standard/src\";s:20:\"Drupal\\Core\\Datetime\";s:29:\"core/lib/Drupal/Core/Datetime\";s:18:\"Drupal\\Core\\Render\";s:27:\"core/lib/Drupal/Core/Render\";s:16:\"Drupal\\Core\\Menu\";s:25:\"core/lib/Drupal/Core/Menu\";s:16:\"Drupal\\Core\\Mail\";s:25:\"core/lib/Drupal/Core/Mail\";s:18:\"Drupal\\Core\\Entity\";s:27:\"core/lib/Drupal/Core/Entity\";s:18:\"Drupal\\Core\\Action\";s:27:\"core/lib/Drupal/Core/Action\";s:17:\"Drupal\\Core\\Field\";s:26:\"core/lib/Drupal/Core/Field\";s:21:\"Drupal\\Core\\TypedData\";s:30:\"core/lib/Drupal/Core/TypedData\";s:17:\"Drupal\\Core\\Block\";s:26:\"core/lib/Drupal/Core/Block\";s:22:\"Drupal\\Core\\Validation\";s:31:\"core/lib/Drupal/Core/Validation\";s:18:\"Drupal\\Core\\Config\";s:27:\"core/lib/Drupal/Core/Config\";s:22:\"Drupal\\Core\\ProxyClass\";s:31:\"core/lib/Drupal/Core/ProxyClass\";s:27:\"Drupal\\Component\\Annotation\";s:36:\"core/lib/Drupal/Component/Annotation\";}s:23:\"language.default_values\";a:5:{s:2:\"id\";s:2:\"en\";s:4:\"name\";s:7:\"English\";s:9:\"direction\";s:3:\"ltr\";s:6:\"weight\";i:0;s:6:\"locked\";b:0;}s:23:\"session.storage.options\";a:4:{s:14:\"gc_probability\";i:1;s:10:\"gc_divisor\";i:100;s:14:\"gc_maxlifetime\";i:200000;s:15:\"cookie_lifetime\";i:2000000;}s:11:\"twig.config\";a:3:{s:5:\"debug\";b:1;s:11:\"auto_reload\";b:1;s:5:\"cache\";b:1;}s:15:\"renderer.config\";a:2:{s:23:\"required_cache_contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:5:\"theme\";i:2;s:16:\"user.permissions\";}s:27:\"auto_placeholder_conditions\";a:3:{s:7:\"max-age\";i:0;s:8:\"contexts\";a:2:{i:0;s:7:\"session\";i:1;s:4:\"user\";}s:4:\"tags\";a:0:{}}}s:16:\"factory.keyvalue\";a:0:{}s:40:\"http.response.debug_cacheability_headers\";b:1;s:26:\"factory.keyvalue.expirable\";a:0:{}s:16:\"filter_protocols\";a:13:{i:0;s:4:\"http\";i:1;s:5:\"https\";i:2;s:3:\"ftp\";i:3;s:4:\"news\";i:4;s:4:\"nntp\";i:5;s:3:\"tel\";i:6;s:6:\"telnet\";i:7;s:6:\"mailto\";i:8;s:3:\"irc\";i:9;s:3:\"ssh\";i:10;s:4:\"sftp\";i:11;s:6:\"webcal\";i:12;s:4:\"rtsp\";}s:11:\"cors.config\";a:7:{s:7:\"enabled\";b:0;s:14:\"allowedHeaders\";a:0:{}s:14:\"allowedMethods\";a:0:{}s:14:\"allowedOrigins\";a:1:{i:0;s:1:\"*\";}s:14:\"exposedHeaders\";b:0;s:6:\"maxAge\";b:0;s:19:\"supportsCredentials\";b:0;}s:16:\"tempstore.expire\";i:604800;s:11:\"persist_ids\";a:4:{i:0;s:12:\"class_loader\";i:1;s:6:\"kernel\";i:2;s:13:\"request_stack\";i:3;s:22:\"router.request_context\";}s:21:\"user.tempstore.expire\";i:604800;s:22:\"main_content_renderers\";a:7:{s:4:\"html\";s:26:\"main_content_renderer.html\";s:11:\"drupal_ajax\";s:26:\"main_content_renderer.ajax\";s:12:\"iframeupload\";s:26:\"main_content_renderer.ajax\";s:13:\"drupal_dialog\";s:28:\"main_content_renderer.dialog\";s:24:\"drupal_dialog.off_canvas\";s:32:\"main_content_renderer.off_canvas\";s:28:\"drupal_dialog.off_canvas_top\";s:36:\"main_content_renderer.off_canvas_top\";s:12:\"drupal_modal\";s:27:\"main_content_renderer.modal\";}s:19:\"twig_extension_hash\";s:43:\"mqcM6T9nha_a79Ek2Og0E4q_vTr-m8YZQ1vVZtAj8jk\";s:10:\"cache_bins\";a:15:{s:12:\"cache.static\";s:6:\"static\";s:15:\"cache.bootstrap\";s:9:\"bootstrap\";s:12:\"cache.config\";s:6:\"config\";s:13:\"cache.default\";s:7:\"default\";s:12:\"cache.entity\";s:6:\"entity\";s:10:\"cache.menu\";s:4:\"menu\";s:12:\"cache.render\";s:6:\"render\";s:10:\"cache.data\";s:4:\"data\";s:15:\"cache.discovery\";s:9:\"discovery\";s:24:\"cache.dynamic_page_cache\";s:18:\"dynamic_page_cache\";s:13:\"cache.migrate\";s:7:\"migrate\";s:25:\"cache.discovery_migration\";s:19:\"discovery_migration\";s:10:\"cache.page\";s:4:\"page\";s:10:\"cache.rest\";s:4:\"rest\";s:13:\"cache.toolbar\";s:7:\"toolbar\";}s:26:\"cache_default_bin_backends\";a:4:{s:6:\"static\";s:20:\"cache.backend.memory\";s:9:\"bootstrap\";s:25:\"cache.backend.chainedfast\";s:6:\"config\";s:25:\"cache.backend.chainedfast\";s:9:\"discovery\";s:25:\"cache.backend.chainedfast\";}s:14:\"cache_contexts\";a:24:{i:0;s:7:\"cookies\";i:1;s:7:\"headers\";i:2;s:2:\"ip\";i:3;s:9:\"languages\";i:4;s:14:\"request_format\";i:5;s:5:\"route\";i:6;s:24:\"route.menu_active_trails\";i:7;s:10:\"route.name\";i:8;s:7:\"session\";i:9;s:14:\"session.exists\";i:10;s:5:\"theme\";i:11;s:8:\"timezone\";i:12;s:3:\"url\";i:13;s:8:\"url.path\";i:14;s:17:\"url.path.is_front\";i:15;s:15:\"url.path.parent\";i:16;s:14:\"url.query_args\";i:17;s:21:\"url.query_args.pagers\";i:18;s:8:\"url.site\";i:19;s:4:\"user\";i:20;s:18:\"user.is_super_user\";i:21;s:16:\"user.node_grants\";i:22;s:16:\"user.permissions\";i:23;s:10:\"user.roles\";}s:24:\"authentication_providers\";a:1:{s:6:\"cookie\";s:4:\"user\";}s:18:\"serializer.formats\";a:2:{i:0;s:4:\"json\";i:1;s:3:\"xml\";}s:27:\"serializer.format_providers\";a:2:{s:4:\"json\";s:13:\"serialization\";s:3:\"xml\";s:13:\"serialization\";}}s:8:\"services\";a:572:{s:17:\"service_container\";s:196:\"a:4:{s:5:\"class\";s:56:\"Symfony\\Component\\DependencyInjection\\ContainerInterface\";s:9:\"synthetic\";b:1;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"service_container\";}}\";s:12:\"class_loader\";s:115:\"a:3:{s:9:\"synthetic\";b:1;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"class_loader\";}}\";s:6:\"kernel\";s:172:\"a:4:{s:5:\"class\";s:44:\"Symfony\\Component\\HttpKernel\\KernelInterface\";s:9:\"synthetic\";b:1;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:6:\"kernel\";}}\";s:16:\"cache_context.ip\";s:364:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Cache\\Context\\IpCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"cache_context.ip\";}}\";s:21:\"cache_context.headers\";s:374:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\Cache\\Context\\HeadersCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"cache_context.headers\";}}\";s:21:\"cache_context.cookies\";s:374:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\Cache\\Context\\CookiesCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"cache_context.cookies\";}}\";s:21:\"cache_context.session\";s:374:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\Cache\\Context\\SessionCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"cache_context.session\";}}\";s:28:\"cache_context.session.exists\";s:500:\"a:4:{s:5:\"class\";s:51:\"Drupal\\Core\\Cache\\Context\\SessionExistsCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"session_configuration\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"cache_context.session.exists\";}}\";s:28:\"cache_context.request_format\";s:387:\"a:4:{s:5:\"class\";s:51:\"Drupal\\Core\\Cache\\Context\\RequestFormatCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"cache_context.request_format\";}}\";s:17:\"cache_context.url\";s:366:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Cache\\Context\\UrlCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"cache_context.url\";}}\";s:22:\"cache_context.url.site\";s:372:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\Cache\\Context\\SiteCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"cache_context.url.site\";}}\";s:22:\"cache_context.url.path\";s:372:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\Cache\\Context\\PathCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"cache_context.url.path\";}}\";s:29:\"cache_context.url.path.parent\";s:385:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Cache\\Context\\PathParentCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"cache_context.url.path.parent\";}}\";s:31:\"cache_context.url.path.is_front\";s:387:\"a:4:{s:5:\"class\";s:49:\"Drupal\\Core\\Cache\\Context\\IsFrontPathCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.matcher\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"cache_context.url.path.is_front\";}}\";s:28:\"cache_context.url.query_args\";s:383:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\Cache\\Context\\QueryArgsCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"cache_context.url.query_args\";}}\";s:35:\"cache_context.url.query_args.pagers\";s:387:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Cache\\Context\\PagersCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"cache_context.url.query_args.pagers\";}}\";s:19:\"cache_context.route\";s:376:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Cache\\Context\\RouteCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"cache_context.route\";}}\";s:24:\"cache_context.route.name\";s:385:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\Cache\\Context\\RouteNameCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"cache_context.route.name\";}}\";s:38:\"cache_context.route.menu_active_trails\";s:444:\"a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\Cache\\Context\\MenuActiveTrailsCacheContext\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:38:\"cache_context.route.menu_active_trails\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:18:\"cache_context.user\";s:367:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\Cache\\Context\\UserCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"cache_context.user\";}}\";s:30:\"cache_context.user.permissions\";s:516:\"a:4:{s:5:\"class\";s:56:\"Drupal\\Core\\Cache\\Context\\AccountPermissionsCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"user_permissions_hash_generator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"cache_context.user.permissions\";}}\";s:24:\"cache_context.user.roles\";s:378:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\Cache\\Context\\UserRolesCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"cache_context.user.roles\";}}\";s:32:\"cache_context.user.is_super_user\";s:388:\"a:4:{s:5:\"class\";s:49:\"Drupal\\Core\\Cache\\Context\\IsSuperUserCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"cache_context.user.is_super_user\";}}\";s:23:\"cache_context.languages\";s:381:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\Cache\\Context\\LanguagesCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"cache_context.languages\";}}\";s:19:\"cache_context.theme\";s:370:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Cache\\Context\\ThemeCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"cache_context.theme\";}}\";s:22:\"cache_context.timezone\";s:171:\"a:3:{s:5:\"class\";s:46:\"Drupal\\Core\\Cache\\Context\\TimeZoneCacheContext\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"cache_context.timezone\";}}\";s:13:\"cache_factory\";s:689:\"a:5:{s:5:\"class\";s:30:\"Drupal\\Core\\Cache\\CacheFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:26:\"cache_default_bin_backends\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"cache_factory\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:22:\"cache_contexts_manager\";s:463:\"a:4:{s:5:\"class\";s:46:\"Drupal\\Core\\Cache\\Context\\CacheContextsManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:14:\"cache_contexts\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"cache_contexts_manager\";}}\";s:22:\"cache_tags.invalidator\";s:890:\"a:4:{s:5:\"class\";s:38:\"Drupal\\Core\\Cache\\CacheTagsInvalidator\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"cache_tags.invalidator\";}s:5:\"calls\";a:3:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:14:\"addInvalidator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"cache_tags.invalidator.checksum\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:31:\"cache_tags.invalidator.checksum\";s:376:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Cache\\DatabaseCacheTagsChecksum\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"cache_tags.invalidator.checksum\";}}\";s:25:\"cache.backend.chainedfast\";s:619:\"a:5:{s:5:\"class\";s:43:\"Drupal\\Core\\Cache\\ChainedFastBackendFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"cache.backend.chainedfast\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:22:\"cache.backend.database\";s:586:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Cache\\DatabaseBackendFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"cache_tags.invalidator.checksum\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"cache.backend.database\";}}\";s:18:\"cache.backend.apcu\";s:579:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Cache\\ApcuBackendFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:9:\"site.path\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"cache_tags.invalidator.checksum\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"cache.backend.apcu\";}}\";s:17:\"cache.backend.php\";s:378:\"a:4:{s:5:\"class\";s:35:\"Drupal\\Core\\Cache\\PhpBackendFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"cache_tags.invalidator.checksum\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"cache.backend.php\";}}\";s:20:\"cache.backend.memory\";s:161:\"a:3:{s:5:\"class\";s:38:\"Drupal\\Core\\Cache\\MemoryBackendFactory\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"cache.backend.memory\";}}\";s:12:\"cache.static\";s:332:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:6:\"static\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"cache.static\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:15:\"cache.bootstrap\";s:338:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:9:\"bootstrap\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"cache.bootstrap\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:12:\"cache.config\";s:332:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:6:\"config\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"cache.config\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:13:\"cache.default\";s:334:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:7:\"default\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"cache.default\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:12:\"cache.entity\";s:332:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:6:\"entity\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"cache.entity\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:10:\"cache.menu\";s:328:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:4:\"menu\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"cache.menu\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:12:\"cache.render\";s:332:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:6:\"render\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"cache.render\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:10:\"cache.data\";s:328:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:4:\"data\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"cache.data\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:15:\"cache.discovery\";s:338:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:9:\"discovery\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"cache.discovery\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:31:\"cache_router_rebuild_subscriber\";s:190:\"a:3:{s:5:\"class\";s:56:\"Drupal\\Core\\EventSubscriber\\CacheRouterRebuildSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"cache_router_rebuild_subscriber\";}}\";s:25:\"page_cache_request_policy\";s:663:\"a:5:{s:5:\"class\";s:42:\"Drupal\\Core\\PageCache\\DefaultRequestPolicy\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"session_configuration\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"page_cache_request_policy\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:52:\"toolbar.page_cache_request_policy.allow_toolbar_path\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:26:\"page_cache_response_policy\";s:458:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\ProxyClass\\PageCache\\ChainResponsePolicy\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:56:\"drupal.proxy_original_service.page_cache_response_policy\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"page_cache_response_policy\";}}\";s:22:\"page_cache_kill_switch\";s:172:\"a:3:{s:5:\"class\";s:47:\"Drupal\\Core\\PageCache\\ResponsePolicy\\KillSwitch\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"page_cache_kill_switch\";}}\";s:14:\"config.manager\";s:889:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Config\\ConfigManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"config.typed\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.storage\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"config.manager\";}}\";s:14:\"config.factory\";s:567:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Config\\ConfigFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.storage\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"config.typed\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"config.factory\";}}\";s:26:\"config.importer_subscriber\";s:186:\"a:3:{s:5:\"class\";s:57:\"Drupal\\Core\\Config\\Importer\\FinalMissingContentSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"config.importer_subscriber\";}}\";s:16:\"config.installer\";s:431:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\ProxyClass\\Config\\ConfigInstaller\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:46:\"drupal.proxy_original_service.config.installer\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"config.installer\";}}\";s:14:\"config.storage\";s:828:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Config\\CachedStorage\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__iippmE3zvNM7poZWNLe9KCo1TBvrcSIYWA79dl3VOK4\";s:5:\"value\";a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Config\\DatabaseStorage\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;s:6:\"config\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;}s:6:\"shared\";b:0;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"cache.config\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"config.storage\";}}\";s:22:\"config.storage.staging\";s:242:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Config\\FileStorage\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"config.storage.staging\";}s:7:\"factory\";a:2:{i:0;s:37:\"Drupal\\Core\\Config\\FileStorageFactory\";i:1;s:7:\"getSync\";}}\";s:23:\"config.storage.snapshot\";s:386:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Config\\DatabaseStorage\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;s:15:\"config_snapshot\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"config.storage.snapshot\";}}\";s:21:\"config.storage.schema\";s:435:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\Config\\ExtensionInstallStorage\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.storage\";s:15:\"invalidBehavior\";i:1;}i:1;s:13:\"config/schema\";i:2;s:0:\"\";i:3;b:1;i:4;s:8:\"standard\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"config.storage.schema\";}}\";s:12:\"config.typed\";s:1061:\"a:5:{s:5:\"class\";s:37:\"Drupal\\Core\\Config\\TypedConfigManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.storage\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"config.storage.schema\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"config.typed\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:30:\"setValidationConstraintManager\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"validation.constraint\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:15:\"context.handler\";s:369:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Plugin\\Context\\ContextHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"typed_data_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"context.handler\";}}\";s:18:\"context.repository\";s:505:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Plugin\\Context\\LazyContextRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;a:3:{i:0;s:33:\"language.current_language_context\";i:1;s:23:\"node.node_route_context\";i:2;s:25:\"user.current_user_context\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"context.repository\";}}\";s:4:\"cron\";s:388:\"a:4:{s:5:\"class\";s:27:\"Drupal\\Core\\ProxyClass\\Cron\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:34:\"drupal.proxy_original_service.cron\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:4:\"cron\";}}\";s:14:\"diff.formatter\";s:353:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Diff\\DiffFormatter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"diff.formatter\";}}\";s:8:\"database\";s:267:\"a:5:{s:5:\"class\";s:31:\"Drupal\\Core\\Database\\Connection\";s:9:\"arguments\";a:1:{i:0;s:7:\"default\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:8:\"database\";}s:7:\"factory\";a:2:{i:0;s:29:\"Drupal\\Core\\Database\\Database\";i:1;s:13:\"getConnection\";}}\";s:13:\"datetime.time\";s:351:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Component\\Datetime\\Time\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"datetime.time\";}}\";s:11:\"file_system\";s:565:\"a:4:{s:5:\"class\";s:27:\"Drupal\\Core\\File\\FileSystem\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"stream_wrapper_manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"logger.channel.file\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:11:\"file_system\";}}\";s:12:\"form_builder\";s:2413:\"a:4:{s:5:\"class\";s:28:\"Drupal\\Core\\Form\\FormBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:10:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"form_validator\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"form_submitter\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__PD3YmWYK-ozn4oUDwsLM6JbLqdgT2Qz4ywy4C3BTrxI\";s:5:\"value\";a:4:{s:5:\"class\";s:26:\"Drupal\\Core\\Form\\FormCache\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:8:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"keyvalue.expirable\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"logger.channel.form\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"page_cache_request_policy\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:8;}s:6:\"shared\";b:0;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.element_info\";s:15:\"invalidBehavior\";i:1;}i:8;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}i:9;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:3;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:10;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"form_builder\";}}\";s:14:\"form_validator\";s:785:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Form\\FormValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"logger.channel.form\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"form_error_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"form_validator\";}}\";s:14:\"form_submitter\";s:457:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Form\\FormSubmitter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"form_submitter\";}}\";s:18:\"form_error_handler\";s:154:\"a:3:{s:5:\"class\";s:33:\"Drupal\\Core\\Form\\FormErrorHandler\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"form_error_handler\";}}\";s:8:\"keyvalue\";s:370:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\KeyValueStore\\KeyValueFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;a:0:{}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:8:\"keyvalue\";}}\";s:17:\"keyvalue.database\";s:486:\"a:4:{s:5:\"class\";s:49:\"Drupal\\Core\\KeyValueStore\\KeyValueDatabaseFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"serialization.phpserialize\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"keyvalue.database\";}}\";s:18:\"keyvalue.expirable\";s:390:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\KeyValueStore\\KeyValueExpirableFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;a:0:{}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"keyvalue.expirable\";}}\";s:27:\"keyvalue.expirable.database\";s:505:\"a:4:{s:5:\"class\";s:58:\"Drupal\\Core\\KeyValueStore\\KeyValueDatabaseExpirableFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"serialization.phpserialize\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"keyvalue.expirable.database\";}}\";s:14:\"logger.factory\";s:635:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Logger\\LoggerChannelFactory\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"logger.factory\";}s:5:\"calls\";a:2:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:9:\"addLogger\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"logger.dblog\";s:15:\"invalidBehavior\";i:1;}i:1;i:0;}s:7:\"resolve\";b:1;}}}}\";s:22:\"logger.channel.default\";s:336:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:6:\"system\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"logger.channel.default\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:18:\"logger.channel.php\";s:329:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:3:\"php\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"logger.channel.php\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:20:\"logger.channel.image\";s:333:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:5:\"image\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"logger.channel.image\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:19:\"logger.channel.cron\";s:331:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:4:\"cron\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"logger.channel.cron\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:19:\"logger.channel.file\";s:331:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:4:\"file\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"logger.channel.file\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:19:\"logger.channel.form\";s:331:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:4:\"form\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"logger.channel.form\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:25:\"logger.log_message_parser\";s:163:\"a:3:{s:5:\"class\";s:35:\"Drupal\\Core\\Logger\\LogMessageParser\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"logger.log_message_parser\";}}\";s:18:\"serialization.json\";s:156:\"a:3:{s:5:\"class\";s:35:\"Drupal\\Component\\Serialization\\Json\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"serialization.json\";}}\";s:26:\"serialization.phpserialize\";s:172:\"a:3:{s:5:\"class\";s:43:\"Drupal\\Component\\Serialization\\PhpSerialize\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"serialization.phpserialize\";}}\";s:18:\"serialization.yaml\";s:156:\"a:3:{s:5:\"class\";s:35:\"Drupal\\Component\\Serialization\\Yaml\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"serialization.yaml\";}}\";s:8:\"settings\";s:215:\"a:4:{s:5:\"class\";s:25:\"Drupal\\Core\\Site\\Settings\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:8:\"settings\";}s:7:\"factory\";a:2:{i:0;s:25:\"Drupal\\Core\\Site\\Settings\";i:1;s:11:\"getInstance\";}}\";s:5:\"state\";s:531:\"a:4:{s:5:\"class\";s:23:\"Drupal\\Core\\State\\State\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"keyvalue\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:5:\"state\";}}\";s:5:\"queue\";s:585:\"a:5:{s:5:\"class\";s:30:\"Drupal\\Core\\Queue\\QueueFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:5:\"queue\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:14:\"queue.database\";s:354:\"a:4:{s:5:\"class\";s:38:\"Drupal\\Core\\Queue\\QueueDatabaseFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"queue.database\";}}\";s:20:\"path.alias_whitelist\";s:694:\"a:4:{s:5:\"class\";s:31:\"Drupal\\Core\\Path\\AliasWhitelist\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:20:\"path_alias_whitelist\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"path.alias_storage\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"path.alias_whitelist\";}}\";s:18:\"path.alias_manager\";s:682:\"a:4:{s:5:\"class\";s:29:\"Drupal\\Core\\Path\\AliasManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"path.alias_storage\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"path.alias_whitelist\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.data\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"path.alias_manager\";}}\";s:12:\"path.current\";s:353:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Path\\CurrentPathStack\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"path.current\";}}\";s:11:\"http_client\";s:285:\"a:4:{s:5:\"class\";s:17:\"GuzzleHttp\\Client\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:11:\"http_client\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"http_client_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:11:\"fromOptions\";}}\";s:19:\"http_client_factory\";s:1103:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Http\\ClientFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__2i5FjkeRC6Vc7PWR5LdG3PRuCttDvRDyMUY6XsHzapc\";s:5:\"value\";a:5:{s:5:\"class\";s:23:\"GuzzleHttp\\HandlerStack\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:7:\"factory\";a:2:{i:0;s:23:\"GuzzleHttp\\HandlerStack\";i:1;s:6:\"create\";}s:12:\"configurator\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__WjN_c7oQM_lsfryd4mPfbEhm7nV93eUSgEmLNALMX84\";s:5:\"value\";a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Http\\HandlerStackConfigurator\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;a:0:{}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;}s:6:\"shared\";b:0;}i:1;s:9:\"configure\";}}s:6:\"shared\";b:0;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"http_client_factory\";}}\";s:33:\"plugin.manager.link_relation_type\";s:589:\"a:4:{s:5:\"class\";s:41:\"\\Drupal\\Core\\Http\\LinkRelationTypeManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"plugin.manager.link_relation_type\";}}\";s:16:\"theme.negotiator\";s:728:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Theme\\ThemeNegotiator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"access_check.theme\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}i:2;a:6:{i:0;s:31:\"theme.negotiator.ajax_base_page\";i:1;s:33:\"theme.negotiator.block.admin_demo\";i:2;s:29:\"theme.negotiator.system.batch\";i:3;s:33:\"theme.negotiator.system.db_update\";i:4;s:28:\"theme.negotiator.admin_theme\";i:5;s:24:\"theme.negotiator.default\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"theme.negotiator\";}}\";s:24:\"theme.negotiator.default\";s:368:\"a:4:{s:5:\"class\";s:35:\"Drupal\\Core\\Theme\\DefaultNegotiator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"theme.negotiator.default\";}}\";s:31:\"theme.negotiator.ajax_base_page\";s:587:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Theme\\AjaxBasePageNegotiator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"theme.negotiator.ajax_base_page\";}}\";s:20:\"container.namespaces\";s:323:\"a:4:{s:5:\"class\";s:11:\"ArrayObject\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:20:\"container.namespaces\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"container.namespaces\";}}\";s:14:\"module_handler\";s:544:\"a:4:{s:5:\"class\";s:35:\"Drupal\\Core\\Extension\\ModuleHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:17:\"container.modules\";}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"module_handler\";}}\";s:16:\"module_installer\";s:434:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\ProxyClass\\Extension\\ModuleInstaller\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:46:\"drupal.proxy_original_service.module_installer\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"module_installer\";}}\";s:21:\"extension.list.module\";s:1118:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Extension\\ModuleExtensionList\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:10:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;s:6:\"module\";i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache.default\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"info_parser\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"extension.list.profile\";s:15:\"invalidBehavior\";i:1;}i:8;s:8:\"standard\";i:9;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:17:\"container.modules\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:10;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"extension.list.module\";}}\";s:22:\"extension.list.profile\";s:813:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\Extension\\ProfileExtensionList\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;s:7:\"profile\";i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache.default\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"info_parser\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:6;s:8:\"standard\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"extension.list.profile\";}}\";s:27:\"content_uninstall_validator\";s:463:\"a:4:{s:5:\"class\";s:55:\"Drupal\\Core\\ProxyClass\\Entity\\ContentUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:57:\"drupal.proxy_original_service.content_uninstall_validator\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"content_uninstall_validator\";}}\";s:35:\"required_module_uninstall_validator\";s:489:\"a:4:{s:5:\"class\";s:65:\"Drupal\\Core\\ProxyClass\\Extension\\RequiredModuleUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:65:\"drupal.proxy_original_service.required_module_uninstall_validator\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"required_module_uninstall_validator\";}}\";s:13:\"theme_handler\";s:760:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Extension\\ThemeHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"info_parser\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"theme_handler\";}}\";s:15:\"theme_installer\";s:1223:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Extension\\ThemeInstaller\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:9:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"config.installer\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.manager\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"asset.css.collection_optimizer\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"router.builder\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"logger.channel.default\";s:15:\"invalidBehavior\";i:1;}i:8;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:9;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"theme_installer\";}}\";s:14:\"entity.manager\";s:398:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Entity\\EntityManager\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"entity.manager\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:19:\"entity.memory_cache\";s:163:\"a:3:{s:5:\"class\";s:41:\"Drupal\\Core\\Cache\\MemoryCache\\MemoryCache\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"entity.memory_cache\";}}\";s:19:\"entity_type.manager\";s:1048:\"a:5:{s:5:\"class\";s:36:\"Drupal\\Core\\Entity\\EntityTypeManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"entity_type.manager\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:22:\"entity_type.repository\";s:375:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Entity\\EntityTypeRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"entity_type.repository\";}}\";s:23:\"entity_type.bundle.info\";s:807:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Entity\\EntityTypeBundleInfo\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"typed_data_manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"entity_type.bundle.info\";}}\";s:17:\"entity.repository\";s:474:\"a:4:{s:5:\"class\";s:35:\"Drupal\\Core\\Entity\\EntityRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"entity.repository\";}}\";s:25:\"entity_display.repository\";s:702:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\Entity\\EntityDisplayRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"entity_display.repository\";}}\";s:20:\"entity_field.manager\";s:1133:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Entity\\EntityFieldManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:8:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"entity_type.bundle.info\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"entity_display.repository\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"typed_data_manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"keyvalue\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:8;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"entity_field.manager\";}}\";s:20:\"entity_type.listener\";s:722:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Entity\\EntityTypeListener\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"entity_field.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:39:\"entity.last_installed_schema.repository\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"entity_type.listener\";}}\";s:22:\"entity_bundle.listener\";s:708:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Entity\\EntityBundleListener\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"entity_type.bundle.info\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"entity_field.manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"entity_bundle.listener\";}}\";s:23:\"entity_route_subscriber\";s:389:\"a:4:{s:5:\"class\";s:57:\"Drupal\\Core\\EventSubscriber\\EntityRouteProviderSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"entity_route_subscriber\";}}\";s:32:\"entity.definition_update_manager\";s:520:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\EntityDefinitionUpdateManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:39:\"entity.last_installed_schema.repository\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"entity.definition_update_manager\";}}\";s:39:\"entity.last_installed_schema.repository\";s:395:\"a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\EntityLastInstalledSchemaRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"keyvalue\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:39:\"entity.last_installed_schema.repository\";}}\";s:38:\"entity_field.deleted_fields_repository\";s:378:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Field\\DeletedFieldsRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:38:\"entity_field.deleted_fields_repository\";}}\";s:33:\"field_storage_definition.listener\";s:876:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Field\\FieldStorageDefinitionListener\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:39:\"entity.last_installed_schema.repository\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"entity_field.manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:38:\"entity_field.deleted_fields_repository\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"field_storage_definition.listener\";}}\";s:25:\"field_definition.listener\";s:698:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Field\\FieldDefinitionListener\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"entity_field.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"keyvalue\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"field_definition.listener\";}}\";s:19:\"entity.form_builder\";s:468:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Entity\\EntityFormBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"form_builder\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"entity.form_builder\";}}\";s:37:\"entity.bundle_config_import_validator\";s:503:\"a:4:{s:5:\"class\";s:51:\"Drupal\\Core\\Entity\\Event\\BundleConfigImportValidate\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:37:\"entity.bundle_config_import_validator\";}}\";s:27:\"entity.autocomplete_matcher\";s:407:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Entity\\EntityAutocompleteMatcher\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:41:\"plugin.manager.entity_reference_selection\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"entity.autocomplete_matcher\";}}\";s:19:\"plugin_form.factory\";s:364:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Plugin\\PluginFormFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"plugin_form.factory\";}}\";s:41:\"plugin.manager.entity_reference_selection\";s:635:\"a:4:{s:5:\"class\";s:66:\"Drupal\\Core\\Entity\\EntityReferenceSelection\\SelectionPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:41:\"plugin.manager.entity_reference_selection\";}}\";s:20:\"plugin.manager.block\";s:692:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Block\\BlockManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"logger.channel.default\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"plugin.manager.block\";}}\";s:31:\"plugin.manager.field.field_type\";s:709:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Field\\FieldTypePluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"typed_data_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"plugin.manager.field.field_type\";}}\";s:27:\"plugin.manager.field.widget\";s:715:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Field\\WidgetPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.field.field_type\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.field.widget\";}}\";s:30:\"plugin.manager.field.formatter\";s:721:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Field\\FormatterPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.field.field_type\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"plugin.manager.field.formatter\";}}\";s:23:\"plugin.manager.archiver\";s:587:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Archiver\\ArchiverManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"plugin.manager.archiver\";}}\";s:21:\"plugin.manager.action\";s:581:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Action\\ActionManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"plugin.manager.action\";}}\";s:24:\"plugin.manager.menu.link\";s:1140:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Menu\\MenuLinkManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:17:\"menu.tree_storage\";s:5:\"value\";a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Menu\\MenuTreeStorage\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.menu\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}i:3;s:9:\"menu_tree\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;}s:6:\"shared\";b:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"menu_link.static.overrides\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"plugin.manager.menu.link\";}}\";s:14:\"menu.link_tree\";s:1352:\"a:4:{s:5:\"class\";s:29:\"Drupal\\Core\\Menu\\MenuLinkTree\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:17:\"menu.tree_storage\";s:5:\"value\";a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Menu\\MenuTreeStorage\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.menu\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}i:3;s:9:\"menu_tree\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;}s:6:\"shared\";b:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.menu.link\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"menu.active_trail\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"menu.link_tree\";}}\";s:30:\"menu.default_tree_manipulators\";s:602:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Menu\\DefaultMenuLinkTreeManipulators\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"access_manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"menu.default_tree_manipulators\";}}\";s:17:\"menu.active_trail\";s:676:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Menu\\MenuActiveTrail\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.menu.link\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.menu\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"menu.active_trail\";}}\";s:25:\"menu.parent_form_selector\";s:589:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Menu\\MenuParentFormSelector\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"menu.link_tree\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"menu.parent_form_selector\";}}\";s:32:\"plugin.manager.menu.local_action\";s:1262:\"a:4:{s:5:\"class\";s:35:\"Drupal\\Core\\Menu\\LocalActionManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:9:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"http_kernel.controller.argument_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"access_manager\";s:15:\"invalidBehavior\";i:1;}i:8;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:9;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"plugin.manager.menu.local_action\";}}\";s:30:\"plugin.manager.menu.local_task\";s:1258:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Menu\\LocalTaskManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:9:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"http_kernel.controller.argument_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"access_manager\";s:15:\"invalidBehavior\";i:1;}i:8;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:9;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"plugin.manager.menu.local_task\";}}\";s:35:\"plugin.manager.menu.contextual_link\";s:1023:\"a:4:{s:5:\"class\";s:38:\"Drupal\\Core\\Menu\\ContextualLinkManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"access_manager\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"plugin.manager.menu.contextual_link\";}}\";s:30:\"plugin.manager.display_variant\";s:592:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Display\\VariantManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"plugin.manager.display_variant\";}}\";s:27:\"plugin.manager.queue_worker\";s:591:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Queue\\QueueWorkerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.queue_worker\";}}\";s:20:\"plugin.cache_clearer\";s:16600:\"a:5:{s:5:\"class\";s:52:\"Drupal\\Core\\ProxyClass\\Plugin\\CachedDiscoveryClearer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:50:\"drupal.proxy_original_service.plugin.cache_clearer\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"plugin.cache_clearer\";}s:5:\"calls\";a:65:{i:0;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"config.typed\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"plugin.manager.link_relation_type\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:4;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:41:\"plugin.manager.entity_reference_selection\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:5;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"plugin.manager.block\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:6;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.field.field_type\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:7;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.field.widget\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:8;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"plugin.manager.field.formatter\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:9;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"plugin.manager.archiver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:10;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"plugin.manager.action\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:11;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:32:\"plugin.manager.menu.local_action\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:12;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"plugin.manager.menu.local_task\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:13;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:35:\"plugin.manager.menu.contextual_link\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:14;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"plugin.manager.display_variant\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:15;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.queue_worker\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:16;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"typed_data_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:17;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"validation.constraint\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:18;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"plugin.manager.mail\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:19;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.condition\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:20;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.element_info\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:21;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"image.toolkit.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:22;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"image.toolkit.operation.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:23;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"breakpoint.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:24;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"plugin.manager.ckeditor.plugin\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:25;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.devel_dumper\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:26;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"plugin.manager.develgenerate\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:27;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"plugin.manager.editor\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:28;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"plugin.manager.filter\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:29;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.help_section\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:30;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.image.effect\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:31;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"plugin.manager.migrate.source\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:32;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"plugin.manager.migrate.process\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:33;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:34:\"plugin.manager.migrate.destination\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:34;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"plugin.manager.migrate.id_map\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:35;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.migration\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:36;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"plugin.manager.migrate.field\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:37;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.migrate.cckfield\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:38;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:42:\"plugin.manager.migrate_plus.authentication\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:39;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"plugin.manager.migrate_plus.data_fetcher\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:40;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:39:\"plugin.manager.migrate_plus.data_parser\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:41;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.quickedit.editor\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:42;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"plugin.manager.rest\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:43;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"plugin.manager.search\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:44;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"plugin.manager.tour.tip\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:45;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"plugin.manager.workflows.type\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:46;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.views.access\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:47;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"plugin.manager.views.area\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:48;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"plugin.manager.views.argument\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:49;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:37:\"plugin.manager.views.argument_default\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:50;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:39:\"plugin.manager.views.argument_validator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:51;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"plugin.manager.views.cache\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:52;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:37:\"plugin.manager.views.display_extender\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:53;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"plugin.manager.views.display\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:54;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"plugin.manager.views.exposed_form\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:55;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"plugin.manager.views.field\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:56;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.views.filter\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:57;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"plugin.manager.views.join\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:58;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"plugin.manager.views.pager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:59;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"plugin.manager.views.query\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:60;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"plugin.manager.views.relationship\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:61;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.views.row\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:62;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"plugin.manager.views.sort\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:63;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"plugin.manager.views.style\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:64;a:2:{i:0;s:18:\"addCachedDiscovery\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.views.wizard\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:24:\"paramconverter.menu_link\";s:463:\"a:4:{s:5:\"class\";s:61:\"Drupal\\Core\\ProxyClass\\ParamConverter\\MenuLinkPluginConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"paramconverter.menu_link\";}}\";s:26:\"menu_link.static.overrides\";s:375:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Menu\\StaticMenuLinkOverrides\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"menu_link.static.overrides\";}}\";s:13:\"request_stack\";s:161:\"a:3:{s:5:\"class\";s:45:\"Symfony\\Component\\HttpFoundation\\RequestStack\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"request_stack\";}}\";s:19:\"current_route_match\";s:364:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Routing\\CurrentRouteMatch\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"current_route_match\";}}\";s:16:\"event_dispatcher\";s:12924:\"a:4:{s:5:\"class\";s:62:\"Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;a:23:{s:22:\"routing.route_finished\";a:4:{i:200;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:31:\"cache_router_rebuild_subscriber\";i:1;s:16:\"onRouterFinished\";}}}i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:23:\"menu.rebuild_subscriber\";i:1;s:15:\"onRouterRebuild\";}}}i:0;a:4:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:21:\"router.route_provider\";i:1;s:5:\"reset\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"router.route_preloader\";i:1;s:16:\"onFinishedRoutes\";}}i:2;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"router.path_roots_subscriber\";i:1;s:15:\"onRouteFinished\";}}i:3;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"views.route_subscriber\";i:1;s:20:\"routeRebuildFinished\";}}}i:-3000;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:34:\"router.route_provider.lazy_builder\";i:1;s:21:\"routerRebuildFinished\";}}}}s:11:\"config.save\";a:3:{i:255;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:14:\"config.factory\";i:1;s:12:\"onConfigSave\";}}}i:128;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:19:\"entity.query.config\";i:1;s:12:\"onConfigSave\";}}}i:0;a:5:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:30:\"color.config_cache_invalidator\";i:1;s:8:\"onChange\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"rest.config_subscriber\";i:1;s:6:\"onSave\";}}i:2;a:1:{s:7:\"service\";a:2:{i:0;s:34:\"serialization.bc_config_subscriber\";i:1;s:12:\"onConfigSave\";}}i:3;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"system.config_subscriber\";i:1;s:12:\"onConfigSave\";}}i:4;a:1:{s:7:\"service\";a:2:{i:0;s:23:\"system.config_cache_tag\";i:1;s:6:\"onSave\";}}}}s:13:\"config.delete\";a:3:{i:255;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:14:\"config.factory\";i:1;s:14:\"onConfigDelete\";}}}i:128;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:19:\"entity.query.config\";i:1;s:14:\"onConfigDelete\";}}}i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:30:\"color.config_cache_invalidator\";i:1;s:8:\"onChange\";}}}}s:31:\"config.importer.missing_content\";a:1:{i:-1024;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:26:\"config.importer_subscriber\";i:1;s:16:\"onMissingContent\";}}}}s:21:\"routing.route_dynamic\";a:3:{i:3000;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:34:\"router.route_provider.lazy_builder\";i:1;s:16:\"routerRebuilding\";}}}i:0;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:23:\"entity_route_subscriber\";i:1;s:19:\"onDynamicRouteEvent\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:20:\"rest.resource_routes\";i:1;s:19:\"onDynamicRouteEvent\";}}}i:-10;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:42:\"rest.resource.entity.post_route.subscriber\";i:1;s:19:\"onDynamicRouteEvent\";}}}}s:24:\"config.importer.validate\";a:3:{i:512;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"system.config_subscriber\";i:1;s:32:\"onConfigImporterValidateNotEmpty\";}}}i:256;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"system.config_subscriber\";i:1;s:32:\"onConfigImporterValidateSiteUUID\";}}}i:20;a:4:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:37:\"entity.bundle_config_import_validator\";i:1;s:24:\"onConfigImporterValidate\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"config_import_subscriber\";i:1;s:24:\"onConfigImporterValidate\";}}i:2;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"config.config_subscriber\";i:1;s:24:\"onConfigImporterValidate\";}}i:3;a:1:{s:7:\"service\";a:2:{i:0;s:43:\"content_moderation.config_import_subscriber\";i:1;s:24:\"onConfigImporterValidate\";}}}}s:19:\"routing.route_alter\";a:9:{i:5000;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"route_http_method_subscriber\";i:1;s:15:\"onRouteBuilding\";}}}i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"devel.route_subscriber\";i:1;s:13:\"onAlterRoutes\";}}}i:0;a:7:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:23:\"route_subscriber.module\";i:1;s:13:\"onAlterRoutes\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:35:\"route_special_attributes_subscriber\";i:1;s:13:\"onAlterRoutes\";}}i:2;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"route_subscriber.no_big_pipe\";i:1;s:31:\"onRoutingRouteAlterSetNoBigPipe\";}}i:3;a:1:{s:7:\"service\";a:2:{i:0;s:27:\"ga_reports.route_subscriber\";i:1;s:13:\"onAlterRoutes\";}}i:4;a:1:{s:7:\"service\";a:2:{i:0;s:21:\"node.route_subscriber\";i:1;s:13:\"onAlterRoutes\";}}i:5;a:1:{s:7:\"service\";a:2:{i:0;s:32:\"node.admin_path.route_subscriber\";i:1;s:13:\"onAlterRoutes\";}}i:6;a:1:{s:7:\"service\";a:2:{i:0;s:41:\"serialization.user_route_alter_subscriber\";i:1;s:24:\"onRoutingAlterAddFormats\";}}}i:-100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:19:\"field_ui.subscriber\";i:1;s:13:\"onAlterRoutes\";}}}i:-150;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:23:\"route_subscriber.entity\";i:1;s:26:\"onRoutingRouteAlterSetType\";}}}i:-175;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"views.route_subscriber\";i:1;s:13:\"onAlterRoutes\";}}}i:-200;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:35:\"content_moderation.route_subscriber\";i:1;s:13:\"onAlterRoutes\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:34:\"system.admin_path.route_subscriber\";i:1;s:13:\"onAlterRoutes\";}}}i:-220;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:25:\"paramconverter_subscriber\";i:1;s:41:\"onRoutingRouteAlterSetParameterConverters\";}}}i:-1024;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"router.route_preloader\";i:1;s:13:\"onAlterRoutes\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"router.path_roots_subscriber\";i:1;s:12:\"onRouteAlter\";}}}}s:14:\"kernel.request\";a:10:{i:1000;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"options_request_listener\";i:1;s:9:\"onRequest\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:35:\"redirect_leading_slashes_subscriber\";i:1;s:8:\"redirect\";}}}i:300;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:25:\"authentication_subscriber\";i:1;s:27:\"onKernelRequestAuthenticate\";}}}i:256;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"devel.error_subscriber\";i:1;s:20:\"registerErrorHandler\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:30:\"devel.theme_rebuild_subscriber\";i:1;s:16:\"rebuildThemeInfo\";}}}i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"redirect_response_subscriber\";i:1;s:19:\"sanitizeDestination\";}}}i:50;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"ajax_response.subscriber\";i:1;s:9:\"onRequest\";}}}i:32;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:15:\"router_listener\";i:1;s:15:\"onKernelRequest\";}}}i:31;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:25:\"authentication_subscriber\";i:1;s:29:\"onKernelRequestFilterProvider\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:32:\"user_maintenance_mode_subscriber\";i:1;s:26:\"onKernelRequestMaintenance\";}}}i:30;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:27:\"maintenance_mode_subscriber\";i:1;s:26:\"onKernelRequestMaintenance\";}}}i:27;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:29:\"dynamic_page_cache_subscriber\";i:1;s:9:\"onRequest\";}}}i:0;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"router.route_preloader\";i:1;s:9:\"onRequest\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:35:\"replica_database_ignore__subscriber\";i:1;s:18:\"checkReplicaServer\";}}}}s:15:\"kernel.response\";a:10:{i:128;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:32:\"exception.enforced_form_response\";i:1;s:16:\"onKernelResponse\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:33:\"rest.resource_response.subscriber\";i:1;s:10:\"onResponse\";}}}i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:29:\"dynamic_page_cache_subscriber\";i:1;s:10:\"onResponse\";}}}i:16;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:26:\"finish_response_subscriber\";i:1;s:13:\"onAllResponds\";}}}i:10;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:32:\"route_access_response_subscriber\";i:1;s:9:\"onRespond\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:32:\"client_error_response_subscriber\";i:1;s:9:\"onRespond\";}}}i:5;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:34:\"anonymous_user_response_subscriber\";i:1;s:9:\"onRespond\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:45:\"html_response.placeholder_strategy_subscriber\";i:1;s:9:\"onRespond\";}}}i:3;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:33:\"html_response.big_pipe_subscriber\";i:1;s:14:\"onRespondEarly\";}}}i:0;a:4:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"html_response.subscriber\";i:1;s:9:\"onRespond\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:26:\"finish_response_subscriber\";i:1;s:9:\"onRespond\";}}i:2;a:1:{s:7:\"service\";a:2:{i:0;s:29:\"response_generator_subscriber\";i:1;s:9:\"onRespond\";}}i:3;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"redirect_response_subscriber\";i:1;s:16:\"checkRedirectUrl\";}}}i:-100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"ajax_response.subscriber\";i:1;s:10:\"onResponse\";}}}i:-512;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:27:\"response_filter.active_link\";i:1;s:10:\"onResponse\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:32:\"response_filter.rss.relative_url\";i:1;s:10:\"onResponse\";}}}i:-10000;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:33:\"html_response.big_pipe_subscriber\";i:1;s:9:\"onRespond\";}}}}s:16:\"kernel.exception\";a:14:{i:200;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:23:\"exception.fast_404_html\";i:1;s:11:\"onException\";}}}i:128;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:32:\"exception.enforced_form_response\";i:1;s:17:\"onKernelException\";}}}i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:25:\"exception.needs_installer\";i:1;s:11:\"onException\";}}}i:75;a:3:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:31:\"route_enhancer.param_conversion\";i:1;s:11:\"onException\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:25:\"authentication_subscriber\";i:1;s:24:\"onExceptionSendChallenge\";}}i:2;a:1:{s:7:\"service\";a:2:{i:0;s:29:\"user_access_denied_subscriber\";i:1;s:11:\"onException\";}}}i:51;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:20:\"form_ajax_subscriber\";i:1;s:11:\"onException\";}}}i:50;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:16:\"exception.logger\";i:1;s:11:\"onException\";}}}i:3;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:19:\"exception.test_site\";i:1;s:11:\"onException\";}}}i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:27:\"maintenance_mode_subscriber\";i:1;s:26:\"onKernelRequestMaintenance\";}}}i:-50;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:26:\"exception.custom_page_html\";i:1;s:11:\"onException\";}}}i:-64;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:15:\"router_listener\";i:1;s:17:\"onKernelException\";}}}i:-70;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:31:\"serialization.exception.default\";i:1;s:11:\"onException\";}}}i:-75;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"exception.default_json\";i:1;s:11:\"onException\";}}}i:-128;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:22:\"exception.default_html\";i:1;s:11:\"onException\";}}}i:-256;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:15:\"exception.final\";i:1;s:11:\"onException\";}}}}s:11:\"kernel.view\";a:3:{i:1;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:20:\"form_ajax_subscriber\";i:1;s:6:\"onView\";}}}i:0;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"psr_response_view_subscriber\";i:1;s:12:\"onKernelView\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:28:\"main_content_view_subscriber\";i:1;s:17:\"onViewRenderArray\";}}}i:-10;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:17:\"renderer_non_html\";i:1;s:9:\"onRespond\";}}}}s:21:\"kernel.finish_request\";a:1:{i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:15:\"router_listener\";i:1;s:21:\"onKernelFinishRequest\";}}}}s:17:\"kernel.controller\";a:2:{i:200;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:15:\"path_subscriber\";i:1;s:18:\"onKernelController\";}}}i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:45:\"early_rendering_controller_wrapper_subscriber\";i:1;s:12:\"onController\";}}}}s:16:\"kernel.terminate\";a:4:{i:300;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:27:\"user_last_access_subscriber\";i:1;s:17:\"onKernelTerminate\";}}}i:200;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:15:\"path_subscriber\";i:1;s:17:\"onKernelTerminate\";}}}i:100;a:2:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:24:\"request_close_subscriber\";i:1;s:11:\"onTerminate\";}}i:1;a:1:{s:7:\"service\";a:2:{i:0;s:25:\"automated_cron.subscriber\";i:1;s:11:\"onTerminate\";}}}i:-100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:26:\"kernel_destruct_subscriber\";i:1;s:17:\"onKernelTerminate\";}}}}s:22:\"config.importer.import\";a:1:{i:40;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:26:\"config_snapshot_subscriber\";i:1;s:22:\"onConfigImporterImport\";}}}}s:34:\"render.page_display_variant.select\";a:1:{i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:37:\"block.page_display_variant_subscriber\";i:1;s:26:\"onSelectPageDisplayVariant\";}}}}s:18:\"migrate.pre_import\";a:1:{i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:31:\"migrate.plugin_event_subscriber\";i:1;s:9:\"preImport\";}}}}s:19:\"migrate.post_import\";a:1:{i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:31:\"migrate.plugin_event_subscriber\";i:1;s:10:\"postImport\";}}}}s:20:\"migrate.pre_rollback\";a:1:{i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:31:\"migrate.plugin_event_subscriber\";i:1;s:11:\"preRollback\";}}}}s:21:\"migrate.post_rollback\";a:1:{i:0;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:31:\"migrate.plugin_event_subscriber\";i:1;s:12:\"postRollback\";}}}}s:29:\"entity_type.definition.create\";a:1:{i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:30:\"views.entity_schema_subscriber\";i:1;s:17:\"onEntityTypeEvent\";}}}}s:29:\"entity_type.definition.update\";a:1:{i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:30:\"views.entity_schema_subscriber\";i:1;s:17:\"onEntityTypeEvent\";}}}}s:29:\"entity_type.definition.delete\";a:1:{i:100;a:1:{i:0;a:1:{s:7:\"service\";a:2:{i:0;s:30:\"views.entity_schema_subscriber\";i:1;s:17:\"onEntityTypeEvent\";}}}}}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"event_dispatcher\";}}\";s:8:\"app.root\";s:543:\"a:3:{s:5:\"class\";s:9:\"SplString\";s:15:\"arguments_count\";i:0;s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__Zsw1Sj4oDjvzkmxM28DwWfx9Nnh9vi4D2mcS7WCJLbg\";s:5:\"value\";a:4:{s:5:\"class\";s:26:\"Drupal\\Core\\AppRootFactory\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"kernel\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:0;}i:1;s:3:\"get\";}}\";s:9:\"site.path\";s:544:\"a:3:{s:5:\"class\";s:9:\"SplString\";s:15:\"arguments_count\";i:0;s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__q7FBVi7mHs7UOJnYi5kAkY_Xr2APp9Ue5a9KP7FyvMA\";s:5:\"value\";a:4:{s:5:\"class\";s:27:\"Drupal\\Core\\SitePathFactory\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"kernel\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:0;}i:1;s:3:\"get\";}}\";s:19:\"controller_resolver\";s:486:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Controller\\ControllerResolver\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"psr7.http_message_factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"controller_resolver\";}}\";s:14:\"class_resolver\";s:411:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\DependencyInjection\\ClassResolver\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"class_resolver\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:14:\"title_resolver\";s:606:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Controller\\TitleResolver\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"http_kernel.controller.argument_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"title_resolver\";}}\";s:11:\"http_kernel\";s:1151:\"a:4:{s:5:\"class\";s:23:\"Stack\\StackedHttpKernel\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"http_middleware.negotiation\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"http_middleware.negotiation\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"http_middleware.reverse_proxy\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"http_middleware.page_cache\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"http_middleware.kernel_pre_handle\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"http_middleware.session\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"http_kernel.basic\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:11:\"http_kernel\";}}\";s:17:\"http_kernel.basic\";s:730:\"a:5:{s:5:\"class\";s:39:\"Symfony\\Component\\HttpKernel\\HttpKernel\";s:4:\"lazy\";b:1;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"http_kernel.controller.argument_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"http_kernel.basic\";}}\";s:40:\"http_kernel.controller.argument_resolver\";s:2682:\"a:4:{s:5:\"class\";s:56:\"Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__aVVgmTsbLy2mehkCW1XkPCxoNfAe-gToi9ed1epV65A\";s:5:\"value\";a:3:{s:5:\"class\";s:71:\"Symfony\\Component\\HttpKernel\\ControllerMetadata\\ArgumentMetadataFactory\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:0;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__4paxHwrBqZgLMOLaRrJsmOfZ3q3b8GmysfCJVR59dww\";s:5:\"value\";a:3:{s:5:\"class\";s:86:\"Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver\\RequestAttributeValueResolver\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:0;}i:1;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__PhticrBBzcjC79bzKkozEgo29oWMlYExB1k4XZRI_a0\";s:5:\"value\";a:3:{s:5:\"class\";s:65:\"Drupal\\Core\\Controller\\ArgumentResolver\\RawParameterValueResolver\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:0;}i:2;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__s9WvKxAAioSxnrbszotBL4p3vALnLB-MHJQxkpMqIAU\";s:5:\"value\";a:3:{s:5:\"class\";s:77:\"Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver\\RequestValueResolver\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:0;}i:3;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__eDpbPL4wwnQyhPmwwLlalHD-HQzju54CeEhnePoq77M\";s:5:\"value\";a:4:{s:5:\"class\";s:64:\"Drupal\\Core\\Controller\\ArgumentResolver\\Psr7RequestValueResolver\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"psr7.http_message_factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:0;}i:4;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__jmHlQ8DenPOz2Y1rQPf6wcbGV3XZvwuMnC6wCu8cgXM\";s:5:\"value\";a:3:{s:5:\"class\";s:63:\"Drupal\\Core\\Controller\\ArgumentResolver\\RouteMatchValueResolver\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:0;}i:5;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__E5RB7EPjMp2Q_miXb0vh6M0K5wUh779hDQkqBCZjB2g\";s:5:\"value\";a:3:{s:5:\"class\";s:77:\"Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver\\DefaultValueResolver\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:0;}}s:7:\"resolve\";b:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:40:\"http_kernel.controller.argument_resolver\";}}\";s:27:\"http_middleware.negotiation\";s:524:\"a:5:{s:5:\"class\";s:49:\"Drupal\\Core\\StackMiddleware\\NegotiationMiddleware\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"http_middleware.reverse_proxy\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"http_middleware.negotiation\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:14:\"registerFormat\";i:1;a:2:{i:0;s:3:\"bin\";i:1;a:1:{i:0;s:24:\"application/octet-stream\";}}}}}\";s:29:\"http_middleware.reverse_proxy\";s:499:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"http_middleware.page_cache\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"http_middleware.reverse_proxy\";}}\";s:33:\"http_middleware.kernel_pre_handle\";s:506:\"a:5:{s:5:\"class\";s:43:\"Drupal\\Core\\StackMiddleware\\KernelPreHandle\";s:4:\"lazy\";b:1;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"http_middleware.session\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"kernel\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"http_middleware.kernel_pre_handle\";}}\";s:23:\"http_middleware.session\";s:634:\"a:6:{s:5:\"class\";s:35:\"Drupal\\Core\\StackMiddleware\\Session\";s:4:\"lazy\";b:1;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"http_kernel.basic\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"http_middleware.session\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:28:\"psr7.http_foundation_factory\";s:190:\"a:3:{s:5:\"class\";s:59:\"Symfony\\Bridge\\PsrHttpMessage\\Factory\\HttpFoundationFactory\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"psr7.http_foundation_factory\";}}\";s:25:\"psr7.http_message_factory\";s:182:\"a:3:{s:5:\"class\";s:54:\"Symfony\\Bridge\\PsrHttpMessage\\Factory\\DiactorosFactory\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"psr7.http_message_factory\";}}\";s:16:\"language_manager\";s:363:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Language\\LanguageManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language.default\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"language_manager\";}}\";s:33:\"language.current_language_context\";s:403:\"a:4:{s:5:\"class\";s:59:\"Drupal\\Core\\Language\\ContextProvider\\CurrentLanguageContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"language.current_language_context\";}}\";s:16:\"language.default\";s:347:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Language\\LanguageDefault\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:23:\"language.default_values\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"language.default\";}}\";s:32:\"string_translator.custom_strings\";s:388:\"a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\StringTranslation\\Translator\\CustomStrings\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"string_translator.custom_strings\";}}\";s:18:\"string_translation\";s:651:\"a:5:{s:5:\"class\";s:48:\"Drupal\\Core\\StringTranslation\\TranslationManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language.default\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"string_translation\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:13:\"addTranslator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:32:\"string_translator.custom_strings\";s:15:\"invalidBehavior\";i:1;}i:1;i:30;}s:7:\"resolve\";b:1;}}}}\";s:16:\"database.replica\";s:276:\"a:5:{s:5:\"class\";s:31:\"Drupal\\Core\\Database\\Connection\";s:9:\"arguments\";a:1:{i:0;s:7:\"replica\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"database.replica\";}s:7:\"factory\";a:2:{i:0;s:29:\"Drupal\\Core\\Database\\Database\";i:1;s:13:\"getConnection\";}}\";s:18:\"typed_data_manager\";s:961:\"a:5:{s:5:\"class\";s:38:\"Drupal\\Core\\TypedData\\TypedDataManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"typed_data_manager\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:30:\"setValidationConstraintManager\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"validation.constraint\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:21:\"validation.constraint\";s:589:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Validation\\ConstraintManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"validation.constraint\";}}\";s:4:\"lock\";s:408:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\ProxyClass\\Lock\\DatabaseLockBackend\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:34:\"drupal.proxy_original_service.lock\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:4:\"lock\";}}\";s:15:\"lock.persistent\";s:441:\"a:4:{s:5:\"class\";s:57:\"Drupal\\Core\\ProxyClass\\Lock\\PersistentDatabaseLockBackend\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:45:\"drupal.proxy_original_service.lock.persistent\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"lock.persistent\";}}\";s:22:\"router.request_context\";s:408:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Routing\\RequestContext\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"router.request_context\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:16:\"fromRequestStack\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:20:\"router.admin_context\";s:366:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Routing\\AdminContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"router.admin_context\";}}\";s:21:\"router.route_provider\";s:1011:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Routing\\RouteProvider\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:8:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.current\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.data\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"path_processor_manager\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}i:6;s:6:\"router\";i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:8;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"router.route_provider\";}}\";s:34:\"router.route_provider.lazy_builder\";s:500:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Routing\\RouteProviderLazyBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"router.builder\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"router.route_provider.lazy_builder\";}}\";s:22:\"router.route_preloader\";s:575:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Routing\\RoutePreloader\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"router.route_preloader\";}}\";s:28:\"router.matcher.final_matcher\";s:365:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Routing\\UrlMatcher\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.current\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"router.matcher.final_matcher\";}}\";s:14:\"router.matcher\";s:650:\"a:5:{s:5:\"class\";s:57:\"Symfony\\Cmf\\Component\\Routing\\NestedMatcher\\NestedMatcher\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"router.matcher\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:15:\"setFinalMatcher\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"router.matcher.final_matcher\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:13:\"url_generator\";s:1755:\"a:5:{s:5:\"class\";s:47:\"Drupal\\Core\\Render\\MetadataBubblingUrlGenerator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__zpo0hTnDUvjD5VJF99cYFfEg3efThaha5qz1wHgNfRA\";s:5:\"value\";a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Routing\\UrlGenerator\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"path_processor_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"route_processor_manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:16:\"filter_protocols\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:10:\"setContext\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"router.request_context\";s:15:\"invalidBehavior\";i:3;}}s:7:\"resolve\";b:1;}}}}s:6:\"shared\";b:0;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"url_generator\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:10:\"setContext\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"router.request_context\";s:15:\"invalidBehavior\";i:3;}}s:7:\"resolve\";b:1;}}}}\";s:20:\"redirect.destination\";s:472:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Routing\\RedirectDestination\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"redirect.destination\";}}\";s:22:\"unrouted_url_assembler\";s:569:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Utility\\UnroutedUrlAssembler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"path_processor_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:16:\"filter_protocols\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"unrouted_url_assembler\";}}\";s:14:\"link_generator\";s:560:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Utility\\LinkGenerator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"link_generator\";}}\";s:6:\"router\";s:570:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Routing\\AccessAwareRouter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"router.no_access_checks\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"access_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:6:\"router\";}}\";s:14:\"router.dynamic\";s:585:\"a:4:{s:5:\"class\";s:43:\"Symfony\\Cmf\\Component\\Routing\\DynamicRouter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"router.request_context\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"router.matcher\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"router.dynamic\";}}\";s:23:\"router.no_access_checks\";s:2756:\"a:5:{s:5:\"class\";s:27:\"\\Drupal\\Core\\Routing\\Router\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.current\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"router.no_access_checks\";}s:5:\"calls\";a:9:{i:0;a:2:{i:0;s:10:\"setContext\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"router.request_context\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:16:\"addRouteEnhancer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"route_enhancer.param_conversion\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:16:\"addRouteEnhancer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"route_enhancer.entity\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:16:\"addRouteEnhancer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"route_enhancer.form\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:4;a:2:{i:0;s:16:\"addRouteEnhancer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"route_enhancer.entity_revision\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:5;a:2:{i:0;s:16:\"addRouteEnhancer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"field_ui.route_enhancer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:6;a:2:{i:0;s:14:\"addRouteFilter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"method_filter\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:7;a:2:{i:0;s:14:\"addRouteFilter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"content_type_header_matcher\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:8;a:2:{i:0;s:14:\"addRouteFilter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"request_format_route_filter\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:28:\"router.path_roots_subscriber\";s:374:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\EventSubscriber\\PathRootsSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"router.path_roots_subscriber\";}}\";s:12:\"entity.query\";s:607:\"a:5:{s:5:\"class\";s:37:\"Drupal\\Core\\Entity\\Query\\QueryFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"entity.query\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:19:\"entity.query.config\";s:577:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Config\\Entity\\Query\\QueryFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"keyvalue\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"entity.query.config\";}}\";s:16:\"entity.query.sql\";s:359:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Entity\\Query\\Sql\\QueryFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"entity.query.sql\";}}\";s:22:\"pgsql.entity.query.sql\";s:371:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\Entity\\Query\\Sql\\pgsql\\QueryFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"pgsql.entity.query.sql\";}}\";s:17:\"entity.query.null\";s:162:\"a:3:{s:5:\"class\";s:42:\"Drupal\\Core\\Entity\\Query\\Null\\QueryFactory\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"entity.query.null\";}}\";s:21:\"entity.query.keyvalue\";s:374:\"a:4:{s:5:\"class\";s:51:\"Drupal\\Core\\Entity\\KeyValueStore\\Query\\QueryFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"keyvalue\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"entity.query.keyvalue\";}}\";s:13:\"router.dumper\";s:424:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\ProxyClass\\Routing\\MatcherDumper\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:43:\"drupal.proxy_original_service.router.dumper\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"router.dumper\";}}\";s:14:\"router.builder\";s:425:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\ProxyClass\\Routing\\RouteBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:44:\"drupal.proxy_original_service.router.builder\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"router.builder\";}}\";s:23:\"menu.rebuild_subscriber\";s:492:\"a:4:{s:5:\"class\";s:55:\"Drupal\\Core\\EventSubscriber\\MenuRouterRebuildSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.menu.link\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"menu.rebuild_subscriber\";}}\";s:18:\"path.alias_storage\";s:455:\"a:4:{s:5:\"class\";s:29:\"Drupal\\Core\\Path\\AliasStorage\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"path.alias_storage\";}}\";s:12:\"path.matcher\";s:460:\"a:4:{s:5:\"class\";s:28:\"Drupal\\Core\\Path\\PathMatcher\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"path.matcher\";}}\";s:14:\"path.validator\";s:677:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Path\\PathValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"router\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"router.no_access_checks\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"path_processor_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"path.validator\";}}\";s:8:\"password\";s:182:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Password\\PhpassHashedPassword\";s:9:\"arguments\";a:1:{i:0;i:16;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:8:\"password\";}}\";s:27:\"request_format_route_filter\";s:174:\"a:3:{s:5:\"class\";s:44:\"Drupal\\Core\\Routing\\RequestFormatRouteFilter\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"request_format_route_filter\";}}\";s:13:\"method_filter\";s:148:\"a:3:{s:5:\"class\";s:32:\"Drupal\\Core\\Routing\\MethodFilter\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"method_filter\";}}\";s:27:\"content_type_header_matcher\";s:174:\"a:3:{s:5:\"class\";s:44:\"Drupal\\Core\\Routing\\ContentTypeHeaderMatcher\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"content_type_header_matcher\";}}\";s:22:\"paramconverter_manager\";s:2359:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\ParamConverter\\ParamConverterManager\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"paramconverter_manager\";}s:5:\"calls\";a:7:{i:0;a:2:{i:0;s:12:\"addConverter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";s:15:\"invalidBehavior\";i:1;}i:1;s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:12:\"addConverter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"paramconverter.latest_revision\";s:15:\"invalidBehavior\";i:1;}i:1;s:30:\"paramconverter.latest_revision\";}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:12:\"addConverter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";s:15:\"invalidBehavior\";i:1;}i:1;s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:12:\"addConverter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"paramconverter.entity\";s:15:\"invalidBehavior\";i:1;}i:1;s:21:\"paramconverter.entity\";}s:7:\"resolve\";b:1;}}i:4;a:2:{i:0;s:12:\"addConverter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"paramconverter.entity_revision\";s:15:\"invalidBehavior\";i:1;}i:1;s:30:\"paramconverter.entity_revision\";}s:7:\"resolve\";b:1;}}i:5;a:2:{i:0;s:12:\"addConverter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";s:15:\"invalidBehavior\";i:1;}i:1;s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";}s:7:\"resolve\";b:1;}}i:6;a:2:{i:0;s:12:\"addConverter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:42:\"drupal.proxy_original_service.node_preview\";s:15:\"invalidBehavior\";i:1;}i:1;s:42:\"drupal.proxy_original_service.node_preview\";}s:7:\"resolve\";b:1;}}}}\";s:25:\"paramconverter_subscriber\";s:394:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\EventSubscriber\\ParamConverterSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"paramconverter_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"paramconverter_subscriber\";}}\";s:21:\"paramconverter.entity\";s:480:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\ParamConverter\\EntityConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"paramconverter.entity\";}}\";s:30:\"paramconverter.entity_revision\";s:508:\"a:4:{s:5:\"class\";s:55:\"Drupal\\Core\\ParamConverter\\EntityRevisionParamConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"entity.repository\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"paramconverter.entity_revision\";}}\";s:33:\"paramconverter.configentity_admin\";s:488:\"a:4:{s:5:\"class\";s:68:\"Drupal\\Core\\ProxyClass\\ParamConverter\\AdminPathConfigEntityConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"paramconverter.configentity_admin\";}}\";s:23:\"route_subscriber.module\";s:381:\"a:4:{s:5:\"class\";s:49:\"Drupal\\Core\\EventSubscriber\\ModuleRouteSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"route_subscriber.module\";}}\";s:23:\"resolver_manager.entity\";s:478:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Entity\\EntityResolverManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"resolver_manager.entity\";}}\";s:23:\"route_subscriber.entity\";s:395:\"a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\EventSubscriber\\EntityRouteAlterSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"resolver_manager.entity\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"route_subscriber.entity\";}}\";s:24:\"ajax_response.subscriber\";s:404:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\EventSubscriber\\AjaxResponseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:35:\"ajax_response.attachments_processor\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"ajax_response.subscriber\";}}\";s:20:\"form_ajax_subscriber\";s:602:\"a:4:{s:5:\"class\";s:51:\"Drupal\\Core\\Form\\EventSubscriber\\FormAjaxSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"form_ajax_response_builder\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:9:\"messenger\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"form_ajax_subscriber\";}}\";s:31:\"route_enhancer.param_conversion\";s:400:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\Routing\\Enhancer\\ParamConversionEnhancer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"paramconverter_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"route_enhancer.param_conversion\";}}\";s:19:\"route_enhancer.form\";s:168:\"a:3:{s:5:\"class\";s:46:\"Drupal\\Core\\Routing\\Enhancer\\FormRouteEnhancer\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"route_enhancer.form\";}}\";s:21:\"route_enhancer.entity\";s:171:\"a:3:{s:5:\"class\";s:47:\"Drupal\\Core\\Entity\\Enhancer\\EntityRouteEnhancer\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"route_enhancer.entity\";}}\";s:30:\"route_enhancer.entity_revision\";s:189:\"a:3:{s:5:\"class\";s:56:\"Drupal\\Core\\Routing\\Enhancer\\EntityRevisionRouteEnhancer\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"route_enhancer.entity_revision\";}}\";s:35:\"route_special_attributes_subscriber\";s:198:\"a:3:{s:5:\"class\";s:60:\"Drupal\\Core\\EventSubscriber\\SpecialAttributesRouteSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"route_special_attributes_subscriber\";}}\";s:28:\"route_http_method_subscriber\";s:180:\"a:3:{s:5:\"class\";s:49:\"Drupal\\Core\\EventSubscriber\\RouteMethodSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"route_http_method_subscriber\";}}\";s:28:\"psr_response_view_subscriber\";s:400:\"a:4:{s:5:\"class\";s:49:\"Drupal\\Core\\EventSubscriber\\PsrResponseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"psr7.http_foundation_factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"psr_response_view_subscriber\";}}\";s:28:\"main_content_view_subscriber\";s:592:\"a:4:{s:5:\"class\";s:53:\"Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:22:\"main_content_renderers\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"main_content_view_subscriber\";}}\";s:17:\"renderer_non_html\";s:176:\"a:3:{s:5:\"class\";s:56:\"Drupal\\Core\\EventSubscriber\\RenderArrayNonHtmlSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"renderer_non_html\";}}\";s:26:\"main_content_renderer.html\";s:1001:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Render\\MainContent\\HtmlRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"title_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"plugin.manager.display_variant\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"render_cache\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:15:\"renderer.config\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"main_content_renderer.html\";}}\";s:26:\"main_content_renderer.ajax\";s:391:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Render\\MainContent\\AjaxRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.element_info\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"main_content_renderer.ajax\";}}\";s:28:\"main_content_renderer.dialog\";s:382:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\Render\\MainContent\\DialogRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"title_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"main_content_renderer.dialog\";}}\";s:32:\"main_content_renderer.off_canvas\";s:488:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Render\\MainContent\\OffCanvasRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"title_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"main_content_renderer.off_canvas\";}}\";s:36:\"main_content_renderer.off_canvas_top\";s:506:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Render\\MainContent\\OffCanvasRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"title_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:2;s:3:\"top\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:36:\"main_content_renderer.off_canvas_top\";}}\";s:27:\"main_content_renderer.modal\";s:380:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Render\\MainContent\\ModalRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"title_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"main_content_renderer.modal\";}}\";s:15:\"controller.form\";s:601:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\Controller\\HtmlFormController\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"http_kernel.controller.argument_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"form_builder\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"class_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"controller.form\";}}\";s:22:\"controller.entity_form\";s:610:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Entity\\HtmlEntityFormController\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"http_kernel.controller.argument_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"form_builder\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"controller.entity_form\";}}\";s:26:\"form_ajax_response_builder\";s:498:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Form\\FormAjaxResponseBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"main_content_renderer.ajax\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"form_ajax_response_builder\";}}\";s:15:\"router_listener\";s:597:\"a:4:{s:5:\"class\";s:57:\"Symfony\\Component\\HttpKernel\\EventListener\\RouterListener\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"router\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"router.request_context\";s:15:\"invalidBehavior\";i:1;}i:3;N;}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"router_listener\";}}\";s:24:\"options_request_listener\";s:392:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\EventSubscriber\\OptionsRequestSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"options_request_listener\";}}\";s:23:\"bare_html_page_renderer\";s:450:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\ProxyClass\\Render\\BareHtmlPageRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:53:\"drupal.proxy_original_service.bare_html_page_renderer\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"bare_html_page_renderer\";}}\";s:11:\"private_key\";s:332:\"a:4:{s:5:\"class\";s:22:\"Drupal\\Core\\PrivateKey\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:11:\"private_key\";}}\";s:10:\"csrf_token\";s:473:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Access\\CsrfTokenGenerator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"private_key\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"session_manager.metadata_bag\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"csrf_token\";}}\";s:33:\"access_arguments_resolver_factory\";s:185:\"a:3:{s:5:\"class\";s:49:\"Drupal\\Core\\Access\\AccessArgumentsResolverFactory\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"access_arguments_resolver_factory\";}}\";s:14:\"access_manager\";s:5126:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Access\\AccessManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"paramconverter_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"access_arguments_resolver_factory\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:29:\"access_manager.check_provider\";s:5:\"value\";a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Access\\CheckProvider\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:5:\"calls\";a:27:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:20:\"access_check.default\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:7:\"_access\";}i:3;b:0;}}i:2;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:19:\"access_check.entity\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:14:\"_entity_access\";}i:3;b:0;}}i:3;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:26:\"access_check.entity_create\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_entity_create_access\";}i:3;b:0;}}i:4;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:30:\"access_check.entity_create_any\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:25:\"_entity_create_any_access\";}i:3;b:0;}}i:5;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:35:\"access_check.entity_delete_multiple\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:30:\"_entity_delete_multiple_access\";}i:3;b:0;}}i:6;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:18:\"access_check.theme\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:13:\"_access_theme\";}i:3;b:0;}}i:7;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:19:\"access_check.custom\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:14:\"_custom_access\";}i:3;b:0;}}i:8;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:17:\"access_check.csrf\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:11:\"_csrf_token\";}i:3;b:1;}}i:9;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:24:\"access_check.header.csrf\";i:1;s:6:\"access\";i:2;a:0:{}i:3;b:1;}}i:10;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:29:\"access_check.contact_personal\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:28:\"_access_contact_personal_tab\";}i:3;b:0;}}i:11;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:28:\"access_check.latest_revision\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:34:\"_content_moderation_latest_version\";}i:3;b:0;}}i:12;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:30:\"access_checker.entity_revision\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:23:\"_entity_access_revision\";}i:3;b:0;}}i:13;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:31:\"access_check.field_ui.view_mode\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:26:\"_field_ui_view_mode_access\";}i:3;b:0;}}i:14;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:31:\"access_check.field_ui.form_mode\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:26:\"_field_ui_form_mode_access\";}i:3;b:0;}}i:15;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:26:\"access_check.node.revision\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_access_node_revision\";}i:3;b:0;}}i:16;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:21:\"access_check.node.add\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:16:\"_node_add_access\";}i:3;b:0;}}i:17;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:25:\"access_check.node.preview\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:20:\"_node_preview_access\";}i:3;b:0;}}i:18;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:35:\"access_check.quickedit.entity_field\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:30:\"_access_quickedit_entity_field\";}i:3;b:0;}}i:19;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:17:\"access_check.cron\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:19:\"_access_system_cron\";}i:3;b:0;}}i:20;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:22:\"access_check.db_update\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_access_system_update\";}i:3;b:0;}}i:21;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:34:\"access_check.update.manager_access\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:22:\"_access_update_manager\";}i:3;b:0;}}i:22;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:23:\"access_check.permission\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:11:\"_permission\";}i:3;b:0;}}i:23;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:26:\"access_check.user.register\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_access_user_register\";}i:3;b:0;}}i:24;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:22:\"access_check.user.role\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:5:\"_role\";}i:3;b:0;}}i:25;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:30:\"access_check.user.login_status\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:18:\"_user_is_logged_in\";}i:3;b:0;}}i:26;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:35:\"workflows.access_check.delete_state\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:29:\"_workflow_state_delete_access\";}i:3;b:0;}}}}s:6:\"shared\";b:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"access_manager\";}}\";s:20:\"access_check.default\";s:160:\"a:3:{s:5:\"class\";s:37:\"Drupal\\Core\\Access\\DefaultAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"access_check.default\";}}\";s:19:\"access_check.entity\";s:158:\"a:3:{s:5:\"class\";s:36:\"Drupal\\Core\\Entity\\EntityAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"access_check.entity\";}}\";s:26:\"access_check.entity_create\";s:377:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\Entity\\EntityCreateAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"access_check.entity_create\";}}\";s:30:\"access_check.entity_create_any\";s:504:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\Entity\\EntityCreateAnyAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"entity_type.bundle.info\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"access_check.entity_create_any\";}}\";s:35:\"access_check.entity_delete_multiple\";s:615:\"a:4:{s:5:\"class\";s:52:\"Drupal\\entity\\Access\\EntityDeleteMultipleAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"tempstore.private\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"access_check.entity_delete_multiple\";}}\";s:18:\"access_check.theme\";s:360:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Theme\\ThemeAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"access_check.theme\";}}\";s:19:\"access_check.custom\";s:494:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Access\\CustomAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"access_arguments_resolver_factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"access_check.custom\";}}\";s:17:\"access_check.csrf\";s:356:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Access\\CsrfAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"access_check.csrf\";}}\";s:24:\"access_check.header.csrf\";s:489:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\Access\\CsrfRequestHeaderAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"session_configuration\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"access_check.header.csrf\";}}\";s:16:\"maintenance_mode\";s:451:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Site\\MaintenanceMode\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"maintenance_mode\";}}\";s:27:\"maintenance_mode_subscriber\";s:1031:\"a:4:{s:5:\"class\";s:53:\"Drupal\\Core\\EventSubscriber\\MaintenanceModeSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"maintenance_mode\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"bare_html_page_renderer\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:9:\"messenger\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"maintenance_mode_subscriber\";}}\";s:15:\"path_subscriber\";s:474:\"a:4:{s:5:\"class\";s:42:\"Drupal\\Core\\EventSubscriber\\PathSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"path.alias_manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.current\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"path_subscriber\";}}\";s:32:\"route_access_response_subscriber\";s:192:\"a:3:{s:5:\"class\";s:57:\"Drupal\\Core\\EventSubscriber\\RouteAccessResponseSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"route_access_response_subscriber\";}}\";s:32:\"client_error_response_subscriber\";s:192:\"a:3:{s:5:\"class\";s:57:\"Drupal\\Core\\EventSubscriber\\ClientErrorResponseSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"client_error_response_subscriber\";}}\";s:34:\"anonymous_user_response_subscriber\";s:400:\"a:4:{s:5:\"class\";s:59:\"Drupal\\Core\\EventSubscriber\\AnonymousUserResponseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"anonymous_user_response_subscriber\";}}\";s:35:\"ajax_response.attachments_processor\";s:1050:\"a:4:{s:5:\"class\";s:49:\"Drupal\\Core\\Ajax\\AjaxResponseAttachmentsProcessor\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"asset.resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"asset.css.collection_renderer\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"asset.js.collection_renderer\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"ajax_response.attachments_processor\";}}\";s:24:\"html_response.subscriber\";s:404:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\EventSubscriber\\HtmlResponseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:35:\"html_response.attachments_processor\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"html_response.subscriber\";}}\";s:26:\"finish_response_subscriber\";s:852:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\EventSubscriber\\FinishResponseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"page_cache_request_policy\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"page_cache_response_policy\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_contexts_manager\";s:15:\"invalidBehavior\";i:1;}i:5;b:1;}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"finish_response_subscriber\";}}\";s:29:\"response_generator_subscriber\";s:187:\"a:3:{s:5:\"class\";s:55:\"Drupal\\Core\\EventSubscriber\\ResponseGeneratorSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"response_generator_subscriber\";}}\";s:28:\"redirect_response_subscriber\";s:513:\"a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\EventSubscriber\\RedirectResponseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"unrouted_url_assembler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"router.request_context\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"redirect_response_subscriber\";}}\";s:35:\"redirect_leading_slashes_subscriber\";s:198:\"a:3:{s:5:\"class\";s:60:\"Drupal\\Core\\EventSubscriber\\RedirectLeadingSlashesSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"redirect_leading_slashes_subscriber\";}}\";s:24:\"request_close_subscriber\";s:383:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\EventSubscriber\\RequestCloseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"request_close_subscriber\";}}\";s:24:\"config_import_subscriber\";s:382:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\EventSubscriber\\ConfigImportSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"config_import_subscriber\";}}\";s:26:\"config_snapshot_subscriber\";s:608:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\EventSubscriber\\ConfigSnapshotSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.storage\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"config.storage.snapshot\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"config_snapshot_subscriber\";}}\";s:25:\"exception.needs_installer\";s:392:\"a:4:{s:5:\"class\";s:65:\"Drupal\\Core\\EventSubscriber\\ExceptionDetectNeedsInstallSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"exception.needs_installer\";}}\";s:22:\"exception.default_json\";s:176:\"a:3:{s:5:\"class\";s:51:\"Drupal\\Core\\EventSubscriber\\ExceptionJsonSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"exception.default_json\";}}\";s:22:\"exception.default_html\";s:723:\"a:4:{s:5:\"class\";s:58:\"Drupal\\Core\\EventSubscriber\\DefaultExceptionHtmlSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"http_kernel\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"logger.channel.php\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"redirect.destination\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"router.no_access_checks\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"exception.default_html\";}}\";s:15:\"exception.final\";s:376:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\EventSubscriber\\FinalExceptionSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"exception.final\";}}\";s:16:\"exception.logger\";s:379:\"a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\EventSubscriber\\ExceptionLoggingSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"exception.logger\";}}\";s:26:\"exception.custom_page_html\";s:942:\"a:4:{s:5:\"class\";s:61:\"Drupal\\Core\\EventSubscriber\\CustomPageExceptionHtmlSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"http_kernel\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"logger.channel.php\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"redirect.destination\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"router.no_access_checks\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"access_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"exception.custom_page_html\";}}\";s:23:\"exception.fast_404_html\";s:493:\"a:4:{s:5:\"class\";s:58:\"Drupal\\Core\\EventSubscriber\\Fast404ExceptionHtmlSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"http_kernel\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"exception.fast_404_html\";}}\";s:19:\"exception.test_site\";s:177:\"a:3:{s:5:\"class\";s:55:\"Drupal\\Core\\EventSubscriber\\ExceptionTestSiteSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"exception.test_site\";}}\";s:32:\"exception.enforced_form_response\";s:193:\"a:3:{s:5:\"class\";s:58:\"Drupal\\Core\\EventSubscriber\\EnforcedFormResponseSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"exception.enforced_form_response\";}}\";s:23:\"route_processor_manager\";s:1177:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\RouteProcessor\\RouteProcessorManager\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"route_processor_manager\";}s:5:\"calls\";a:4:{i:0;a:2:{i:0;s:11:\"addOutbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"route_processor_current\";s:15:\"invalidBehavior\";i:1;}i:1;i:200;}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:11:\"addOutbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"route_processor_csrf\";s:15:\"invalidBehavior\";i:1;}i:1;i:0;}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:11:\"addOutbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"route_processor.migrate_group\";s:15:\"invalidBehavior\";i:1;}i:1;i:0;}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:11:\"addOutbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"rest.route_processor_get_bc\";s:15:\"invalidBehavior\";i:1;}i:1;i:0;}s:7:\"resolve\";b:1;}}}}\";s:22:\"path_processor_manager\";s:2152:\"a:4:{s:5:\"class\";s:46:\"Drupal\\Core\\PathProcessor\\PathProcessorManager\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"path_processor_manager\";}s:5:\"calls\";a:8:{i:0;a:2:{i:0;s:10:\"addInbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"path_processor_decode\";s:15:\"invalidBehavior\";i:1;}i:1;i:1000;}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:10:\"addInbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"path_processor.image_styles\";s:15:\"invalidBehavior\";i:1;}i:1;i:300;}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:10:\"addInbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"path_processor_front\";s:15:\"invalidBehavior\";i:1;}i:1;i:200;}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:10:\"addInbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"path_processor.files\";s:15:\"invalidBehavior\";i:1;}i:1;i:200;}s:7:\"resolve\";b:1;}}i:4;a:2:{i:0;s:10:\"addInbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"path_processor_alias\";s:15:\"invalidBehavior\";i:1;}i:1;i:100;}s:7:\"resolve\";b:1;}}i:5;a:2:{i:0;s:10:\"addInbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:38:\"rest.path_processor_entity_resource_bc\";s:15:\"invalidBehavior\";i:1;}i:1;i:0;}s:7:\"resolve\";b:1;}}i:6;a:2:{i:0;s:11:\"addOutbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"path_processor_alias\";s:15:\"invalidBehavior\";i:1;}i:1;i:300;}s:7:\"resolve\";b:1;}}i:7;a:2:{i:0;s:11:\"addOutbound\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"path_processor_front\";s:15:\"invalidBehavior\";i:1;}i:1;i:200;}s:7:\"resolve\";b:1;}}}}\";s:21:\"path_processor_decode\";s:169:\"a:3:{s:5:\"class\";s:45:\"Drupal\\Core\\PathProcessor\\PathProcessorDecode\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"path_processor_decode\";}}\";s:20:\"path_processor_front\";s:373:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\PathProcessor\\PathProcessorFront\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"path_processor_front\";}}\";s:23:\"route_processor_current\";s:385:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\RouteProcessor\\RouteProcessorCurrent\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"route_processor_current\";}}\";s:20:\"path_processor_alias\";s:377:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\PathProcessor\\PathProcessorAlias\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"path.alias_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"path_processor_alias\";}}\";s:20:\"route_processor_csrf\";s:362:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Access\\RouteProcessorCsrf\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"route_processor_csrf\";}}\";s:15:\"transliteration\";s:376:\"a:4:{s:5:\"class\";s:46:\"Drupal\\Core\\Transliteration\\PhpTransliteration\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;N;i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"transliteration\";}}\";s:5:\"flood\";s:444:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Flood\\DatabaseBackend\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:5:\"flood\";}}\";s:19:\"plugin.manager.mail\";s:996:\"a:4:{s:5:\"class\";s:28:\"Drupal\\Core\\Mail\\MailManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"plugin.manager.mail\";}}\";s:24:\"plugin.manager.condition\";s:590:\"a:4:{s:5:\"class\";s:38:\"Drupal\\Core\\Condition\\ConditionManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"plugin.manager.condition\";}}\";s:27:\"plugin.manager.element_info\";s:811:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Render\\ElementInfoManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.element_info\";}}\";s:22:\"stream_wrapper_manager\";s:725:\"a:4:{s:5:\"class\";s:46:\"Drupal\\Core\\StreamWrapper\\StreamWrapperManager\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"stream_wrapper_manager\";}s:5:\"calls\";a:3:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:16:\"addStreamWrapper\";i:1;a:3:{i:0;s:21:\"stream_wrapper.public\";i:1;s:38:\"Drupal\\Core\\StreamWrapper\\PublicStream\";i:2;s:6:\"public\";}}i:2;a:2:{i:0;s:16:\"addStreamWrapper\";i:1;a:3:{i:0;s:24:\"stream_wrapper.temporary\";i:1;s:41:\"Drupal\\Core\\StreamWrapper\\TemporaryStream\";i:2;s:9:\"temporary\";}}}}\";s:21:\"stream_wrapper.public\";s:162:\"a:3:{s:5:\"class\";s:38:\"Drupal\\Core\\StreamWrapper\\PublicStream\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"stream_wrapper.public\";}}\";s:24:\"stream_wrapper.temporary\";s:168:\"a:3:{s:5:\"class\";s:41:\"Drupal\\Core\\StreamWrapper\\TemporaryStream\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"stream_wrapper.temporary\";}}\";s:26:\"kernel_destruct_subscriber\";s:997:\"a:4:{s:5:\"class\";s:55:\"Drupal\\Core\\EventSubscriber\\KernelDestructionSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"kernel_destruct_subscriber\";}s:5:\"calls\";a:8:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:15:\"registerService\";i:1;a:1:{i:0;s:5:\"state\";}}i:2;a:2:{i:0;s:15:\"registerService\";i:1;a:1:{i:0;s:20:\"path.alias_whitelist\";}}i:3;a:2:{i:0;s:15:\"registerService\";i:1;a:1:{i:0;s:17:\"menu.active_trail\";}}i:4;a:2:{i:0;s:15:\"registerService\";i:1;a:1:{i:0;s:14:\"theme.registry\";}}i:5;a:2:{i:0;s:15:\"registerService\";i:1;a:1:{i:0;s:27:\"library.discovery.collector\";}}i:6;a:2:{i:0;s:15:\"registerService\";i:1;a:1:{i:0;s:25:\"block_content.uuid_lookup\";}}i:7;a:2:{i:0;s:15:\"registerService\";i:1;a:1:{i:0;s:44:\"drupal.proxy_original_service.router.builder\";}}}}\";s:21:\"image.toolkit.manager\";s:699:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\ImageToolkit\\ImageToolkitManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"image.toolkit.manager\";}}\";s:31:\"image.toolkit.operation.manager\";s:837:\"a:4:{s:5:\"class\";s:53:\"Drupal\\Core\\ImageToolkit\\ImageToolkitOperationManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"logger.channel.image\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"image.toolkit.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"image.toolkit.operation.manager\";}}\";s:13:\"image.factory\";s:359:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Image\\ImageFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"image.toolkit.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"image.factory\";}}\";s:10:\"breadcrumb\";s:1109:\"a:5:{s:5:\"class\";s:40:\"Drupal\\Core\\Breadcrumb\\BreadcrumbManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"breadcrumb\";}s:5:\"calls\";a:3:{i:0;a:2:{i:0;s:10:\"addBuilder\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"taxonomy_term.breadcrumb\";s:15:\"invalidBehavior\";i:1;}i:1;i:1002;}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:10:\"addBuilder\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"comment.breadcrumb\";s:15:\"invalidBehavior\";i:1;}i:1;i:100;}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:10:\"addBuilder\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"system.breadcrumb.default\";s:15:\"invalidBehavior\";i:1;}i:1;i:0;}s:7:\"resolve\";b:1;}}}}\";s:5:\"token\";s:764:\"a:4:{s:5:\"class\";s:25:\"Drupal\\Core\\Utility\\Token\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache.default\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:5:\"token\";}}\";s:13:\"batch.storage\";s:421:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\ProxyClass\\Batch\\BatchStorage\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:43:\"drupal.proxy_original_service.batch.storage\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"batch.storage\";}}\";s:35:\"replica_database_ignore__subscriber\";s:197:\"a:3:{s:5:\"class\";s:59:\"Drupal\\Core\\EventSubscriber\\ReplicaDatabaseIgnoreSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"replica_database_ignore__subscriber\";}}\";s:15:\"country_manager\";s:357:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Locale\\CountryManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"country_manager\";}}\";s:14:\"date.formatter\";s:786:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Datetime\\DateFormatter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"date.formatter\";}}\";s:18:\"feed.bridge.reader\";s:570:\"a:5:{s:5:\"class\";s:53:\"Drupal\\Component\\Bridge\\ZfExtensionManagerSfContainer\";s:9:\"arguments\";a:1:{i:0;s:12:\"feed.reader.\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"feed.bridge.reader\";}s:5:\"calls\";a:2:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:13:\"setStandalone\";i:1;a:1:{i:0;s:44:\"\\Zend\\Feed\\Reader\\StandaloneExtensionManager\";}}}}\";s:18:\"feed.bridge.writer\";s:570:\"a:5:{s:5:\"class\";s:53:\"Drupal\\Component\\Bridge\\ZfExtensionManagerSfContainer\";s:9:\"arguments\";a:1:{i:0;s:12:\"feed.writer.\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"feed.bridge.writer\";}s:5:\"calls\";a:2:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:13:\"setStandalone\";i:1;a:1:{i:0;s:44:\"\\Zend\\Feed\\Writer\\StandaloneExtensionManager\";}}}}\";s:27:\"feed.reader.dublincoreentry\";s:190:\"a:4:{s:5:\"class\";s:43:\"Zend\\Feed\\Reader\\Extension\\DublinCore\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"feed.reader.dublincoreentry\";}s:6:\"shared\";b:0;}\";s:26:\"feed.reader.dublincorefeed\";s:188:\"a:4:{s:5:\"class\";s:42:\"Zend\\Feed\\Reader\\Extension\\DublinCore\\Feed\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"feed.reader.dublincorefeed\";}s:6:\"shared\";b:0;}\";s:24:\"feed.reader.contententry\";s:184:\"a:4:{s:5:\"class\";s:40:\"Zend\\Feed\\Reader\\Extension\\Content\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"feed.reader.contententry\";}s:6:\"shared\";b:0;}\";s:21:\"feed.reader.atomentry\";s:178:\"a:4:{s:5:\"class\";s:37:\"Zend\\Feed\\Reader\\Extension\\Atom\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"feed.reader.atomentry\";}s:6:\"shared\";b:0;}\";s:20:\"feed.reader.atomfeed\";s:176:\"a:4:{s:5:\"class\";s:36:\"Zend\\Feed\\Reader\\Extension\\Atom\\Feed\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"feed.reader.atomfeed\";}s:6:\"shared\";b:0;}\";s:22:\"feed.reader.slashentry\";s:180:\"a:4:{s:5:\"class\";s:38:\"Zend\\Feed\\Reader\\Extension\\Slash\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"feed.reader.slashentry\";}s:6:\"shared\";b:0;}\";s:30:\"feed.reader.wellformedwebentry\";s:196:\"a:4:{s:5:\"class\";s:46:\"Zend\\Feed\\Reader\\Extension\\WellFormedWeb\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"feed.reader.wellformedwebentry\";}s:6:\"shared\";b:0;}\";s:23:\"feed.reader.threadentry\";s:182:\"a:4:{s:5:\"class\";s:39:\"Zend\\Feed\\Reader\\Extension\\Thread\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"feed.reader.threadentry\";}s:6:\"shared\";b:0;}\";s:24:\"feed.reader.podcastentry\";s:184:\"a:4:{s:5:\"class\";s:40:\"Zend\\Feed\\Reader\\Extension\\Podcast\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"feed.reader.podcastentry\";}s:6:\"shared\";b:0;}\";s:23:\"feed.reader.podcastfeed\";s:182:\"a:4:{s:5:\"class\";s:39:\"Zend\\Feed\\Reader\\Extension\\Podcast\\Feed\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"feed.reader.podcastfeed\";}s:6:\"shared\";b:0;}\";s:28:\"feed.writer.atomrendererfeed\";s:193:\"a:4:{s:5:\"class\";s:45:\"Zend\\Feed\\Writer\\Extension\\Atom\\Renderer\\Feed\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"feed.writer.atomrendererfeed\";}s:6:\"shared\";b:0;}\";s:32:\"feed.writer.contentrendererentry\";s:201:\"a:4:{s:5:\"class\";s:49:\"Zend\\Feed\\Writer\\Extension\\Content\\Renderer\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"feed.writer.contentrendererentry\";}s:6:\"shared\";b:0;}\";s:35:\"feed.writer.dublincorerendererentry\";s:207:\"a:4:{s:5:\"class\";s:52:\"Zend\\Feed\\Writer\\Extension\\DublinCore\\Renderer\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"feed.writer.dublincorerendererentry\";}s:6:\"shared\";b:0;}\";s:34:\"feed.writer.dublincorerendererfeed\";s:205:\"a:4:{s:5:\"class\";s:51:\"Zend\\Feed\\Writer\\Extension\\DublinCore\\Renderer\\Feed\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"feed.writer.dublincorerendererfeed\";}s:6:\"shared\";b:0;}\";s:23:\"feed.writer.itunesentry\";s:182:\"a:4:{s:5:\"class\";s:39:\"Zend\\Feed\\Writer\\Extension\\ITunes\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"feed.writer.itunesentry\";}s:6:\"shared\";b:0;}\";s:22:\"feed.writer.itunesfeed\";s:180:\"a:4:{s:5:\"class\";s:38:\"Zend\\Feed\\Writer\\Extension\\ITunes\\Feed\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"feed.writer.itunesfeed\";}s:6:\"shared\";b:0;}\";s:31:\"feed.writer.itunesrendererentry\";s:199:\"a:4:{s:5:\"class\";s:48:\"Zend\\Feed\\Writer\\Extension\\ITunes\\Renderer\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"feed.writer.itunesrendererentry\";}s:6:\"shared\";b:0;}\";s:30:\"feed.writer.itunesrendererfeed\";s:197:\"a:4:{s:5:\"class\";s:47:\"Zend\\Feed\\Writer\\Extension\\ITunes\\Renderer\\Feed\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"feed.writer.itunesrendererfeed\";}s:6:\"shared\";b:0;}\";s:30:\"feed.writer.slashrendererentry\";s:197:\"a:4:{s:5:\"class\";s:47:\"Zend\\Feed\\Writer\\Extension\\Slash\\Renderer\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"feed.writer.slashrendererentry\";}s:6:\"shared\";b:0;}\";s:34:\"feed.writer.threadingrendererentry\";s:205:\"a:4:{s:5:\"class\";s:51:\"Zend\\Feed\\Writer\\Extension\\Threading\\Renderer\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"feed.writer.threadingrendererentry\";}s:6:\"shared\";b:0;}\";s:38:\"feed.writer.wellformedwebrendererentry\";s:213:\"a:4:{s:5:\"class\";s:55:\"Zend\\Feed\\Writer\\Extension\\WellFormedWeb\\Renderer\\Entry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:38:\"feed.writer.wellformedwebrendererentry\";}s:6:\"shared\";b:0;}\";s:13:\"theme.manager\";s:921:\"a:5:{s:5:\"class\";s:30:\"Drupal\\Core\\Theme\\ThemeManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"theme.negotiator\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"theme.initialization\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"theme.manager\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:16:\"setThemeRegistry\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"theme.registry\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:20:\"theme.initialization\";s:677:\"a:4:{s:5:\"class\";s:37:\"Drupal\\Core\\Theme\\ThemeInitialization\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"theme.initialization\";}}\";s:14:\"theme.registry\";s:1226:\"a:5:{s:5:\"class\";s:26:\"Drupal\\Core\\Theme\\Registry\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:8:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache.default\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"theme.initialization\";s:15:\"invalidBehavior\";i:1;}i:6;N;i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:8;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"theme.registry\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:15:\"setThemeManager\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:14:\"authentication\";s:381:\"a:4:{s:5:\"class\";s:48:\"Drupal\\Core\\Authentication\\AuthenticationManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"authentication_collector\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"authentication\";}}\";s:24:\"authentication_collector\";s:467:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\Authentication\\AuthenticationCollector\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"authentication_collector\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:11:\"addProvider\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"user.authentication.cookie\";s:15:\"invalidBehavior\";i:1;}i:1;s:6:\"cookie\";i:2;i:0;i:3;b:1;}s:7:\"resolve\";b:1;}}}}\";s:25:\"authentication_subscriber\";s:490:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\EventSubscriber\\AuthenticationSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"authentication\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"authentication_subscriber\";}}\";s:16:\"account_switcher\";s:476:\"a:4:{s:5:\"class\";s:35:\"Drupal\\Core\\Session\\AccountSwitcher\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"session_handler.write_safe\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"account_switcher\";}}\";s:31:\"user_permissions_hash_generator\";s:592:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Session\\PermissionsHashGenerator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"private_key\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"cache.static\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"user_permissions_hash_generator\";}}\";s:12:\"current_user\";s:147:\"a:3:{s:5:\"class\";s:32:\"Drupal\\Core\\Session\\AccountProxy\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"current_user\";}}\";s:21:\"session_configuration\";s:356:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Session\\SessionConfiguration\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:23:\"session.storage.options\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"session_configuration\";}}\";s:7:\"session\";s:897:\"a:4:{s:5:\"class\";s:48:\"Symfony\\Component\\HttpFoundation\\Session\\Session\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"session_manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__g9uAg6Wct6g4hzpSWnSSQC4s0UIIVnnc9tWJB9kq-_A\";s:5:\"value\";a:3:{s:5:\"class\";s:63:\"Symfony\\Component\\HttpFoundation\\Session\\Attribute\\AttributeBag\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:0;}i:2;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:17:\"session.flash_bag\";s:5:\"value\";a:3:{s:5:\"class\";s:55:\"Symfony\\Component\\HttpFoundation\\Session\\Flash\\FlashBag\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:7:\"session\";}}\";s:23:\"session_handler.storage\";s:464:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Session\\SessionHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"session_handler.storage\";}}\";s:27:\"session_handler.write_check\";s:426:\"a:4:{s:5:\"class\";s:81:\"Symfony\\Component\\HttpFoundation\\Session\\Storage\\Handler\\WriteCheckSessionHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"session_handler.storage\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"session_handler.write_check\";}}\";s:26:\"session_handler.write_safe\";s:391:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Session\\WriteSafeSessionHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"session_handler.write_check\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"session_handler.write_safe\";}}\";s:15:\"session_manager\";s:1072:\"a:5:{s:5:\"class\";s:34:\"Drupal\\Core\\Session\\SessionManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"session_manager.metadata_bag\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"session_configuration\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"session_handler.write_safe\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"session_manager\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:19:\"setWriteSafeHandler\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"session_handler.write_safe\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:28:\"session_manager.metadata_bag\";s:361:\"a:4:{s:5:\"class\";s:31:\"Drupal\\Core\\Session\\MetadataBag\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"session_manager.metadata_bag\";}}\";s:29:\"asset.css.collection_renderer\";s:367:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Asset\\CssCollectionRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"asset.css.collection_renderer\";}}\";s:30:\"asset.css.collection_optimizer\";s:708:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Asset\\CssCollectionOptimizer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"asset.css.collection_grouper\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"asset.css.optimizer\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"asset.css.dumper\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"asset.css.collection_optimizer\";}}\";s:19:\"asset.css.optimizer\";s:152:\"a:3:{s:5:\"class\";s:30:\"Drupal\\Core\\Asset\\CssOptimizer\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"asset.css.optimizer\";}}\";s:28:\"asset.css.collection_grouper\";s:169:\"a:3:{s:5:\"class\";s:38:\"Drupal\\Core\\Asset\\CssCollectionGrouper\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"asset.css.collection_grouper\";}}\";s:16:\"asset.css.dumper\";s:148:\"a:3:{s:5:\"class\";s:29:\"Drupal\\Core\\Asset\\AssetDumper\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"asset.css.dumper\";}}\";s:28:\"asset.js.collection_renderer\";s:365:\"a:4:{s:5:\"class\";s:38:\"Drupal\\Core\\Asset\\JsCollectionRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"asset.js.collection_renderer\";}}\";s:29:\"asset.js.collection_optimizer\";s:703:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Asset\\JsCollectionOptimizer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"asset.js.collection_grouper\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"asset.js.optimizer\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"asset.js.dumper\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"asset.js.collection_optimizer\";}}\";s:18:\"asset.js.optimizer\";s:150:\"a:3:{s:5:\"class\";s:29:\"Drupal\\Core\\Asset\\JsOptimizer\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"asset.js.optimizer\";}}\";s:27:\"asset.js.collection_grouper\";s:167:\"a:3:{s:5:\"class\";s:37:\"Drupal\\Core\\Asset\\JsCollectionGrouper\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"asset.js.collection_grouper\";}}\";s:15:\"asset.js.dumper\";s:147:\"a:3:{s:5:\"class\";s:29:\"Drupal\\Core\\Asset\\AssetDumper\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"asset.js.dumper\";}}\";s:17:\"library.discovery\";s:373:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Asset\\LibraryDiscovery\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"library.discovery.collector\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"library.discovery\";}}\";s:27:\"library.discovery.collector\";s:696:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Asset\\LibraryDiscoveryCollector\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"library.discovery.parser\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"library.discovery.collector\";}}\";s:24:\"library.discovery.parser\";s:577:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Asset\\LibraryDiscoveryParser\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"library.discovery.parser\";}}\";s:27:\"library.dependency_resolver\";s:382:\"a:4:{s:5:\"class\";s:43:\"Drupal\\Core\\Asset\\LibraryDependencyResolver\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"library.discovery\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"library.dependency_resolver\";}}\";s:14:\"asset.resolver\";s:897:\"a:4:{s:5:\"class\";s:31:\"Drupal\\Core\\Asset\\AssetResolver\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"library.discovery\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"library.dependency_resolver\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.data\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"asset.resolver\";}}\";s:11:\"info_parser\";s:146:\"a:3:{s:5:\"class\";s:32:\"Drupal\\Core\\Extension\\InfoParser\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:11:\"info_parser\";}}\";s:4:\"twig\";s:2591:\"a:5:{s:5:\"class\";s:36:\"Drupal\\Core\\Template\\TwigEnvironment\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache.default\";s:15:\"invalidBehavior\";i:1;}i:2;s:43:\"mqcM6T9nha_a79Ek2Og0E4q_vTr-m8YZQ1vVZtAj8jk\";i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__J8C_Uy0ugquAvYtQrfWiecSnkvzRPt5tbhbj878y7lQ\";s:5:\"value\";a:4:{s:5:\"class\";s:17:\"Twig_Loader_Chain\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:5:\"calls\";a:3:{i:0;a:2:{i:0;s:9:\"addLoader\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"twig.loader.filesystem\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:9:\"addLoader\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"twig.loader.theme_registry\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:9:\"addLoader\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"twig.loader.string\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}s:6:\"shared\";b:0;}i:5;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:11:\"twig.config\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:4:\"twig\";}s:5:\"calls\";a:4:{i:0;a:2:{i:0;s:12:\"addExtension\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"twig.extension\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:12:\"addExtension\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"twig.extension.debug\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:12:\"addExtension\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"devel.twig.debug_extension\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:12:\"addExtension\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"kint.twig.kint_extension\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:14:\"twig.extension\";s:666:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Template\\TwigExtension\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"date.formatter\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"twig.extension\";}}\";s:20:\"twig.extension.debug\";s:143:\"a:3:{s:5:\"class\";s:20:\"Twig_Extension_Debug\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"twig.extension.debug\";}}\";s:22:\"twig.loader.filesystem\";s:492:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Template\\Loader\\FilesystemLoader\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;s:1:\".\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"twig.loader.filesystem\";}}\";s:26:\"twig.loader.theme_registry\";s:382:\"a:4:{s:5:\"class\";s:47:\"Drupal\\Core\\Template\\Loader\\ThemeRegistryLoader\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"theme.registry\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"twig.loader.theme_registry\";}}\";s:18:\"twig.loader.string\";s:161:\"a:3:{s:5:\"class\";s:40:\"Drupal\\Core\\Template\\Loader\\StringLoader\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"twig.loader.string\";}}\";s:22:\"file.mime_type.guesser\";s:450:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\ProxyClass\\File\\MimeType\\MimeTypeGuesser\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:52:\"drupal.proxy_original_service.file.mime_type.guesser\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"file.mime_type.guesser\";}}\";s:32:\"file.mime_type.guesser.extension\";s:479:\"a:4:{s:5:\"class\";s:61:\"Drupal\\Core\\ProxyClass\\File\\MimeType\\ExtensionMimeTypeGuesser\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:62:\"drupal.proxy_original_service.file.mime_type.guesser.extension\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"file.mime_type.guesser.extension\";}}\";s:28:\"render_placeholder_generator\";s:354:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Render\\PlaceholderGenerator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:15:\"renderer.config\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"render_placeholder_generator\";}}\";s:12:\"render_cache\";s:703:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Render\\PlaceholderingRenderCache\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_contexts_manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"render_placeholder_generator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"render_cache\";}}\";s:8:\"renderer\";s:985:\"a:4:{s:5:\"class\";s:27:\"Drupal\\Core\\Render\\Renderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.element_info\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"render_placeholder_generator\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"render_cache\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:15:\"renderer.config\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:8:\"renderer\";}}\";s:45:\"early_rendering_controller_wrapper_subscriber\";s:548:\"a:4:{s:5:\"class\";s:69:\"Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"http_kernel.controller.argument_resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:45:\"early_rendering_controller_wrapper_subscriber\";}}\";s:45:\"html_response.placeholder_strategy_subscriber\";s:429:\"a:4:{s:5:\"class\";s:69:\"Drupal\\Core\\EventSubscriber\\HtmlResponsePlaceholderStrategySubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"placeholder_strategy\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:45:\"html_response.placeholder_strategy_subscriber\";}}\";s:20:\"placeholder_strategy\";s:708:\"a:4:{s:5:\"class\";s:57:\"Drupal\\Core\\Render\\Placeholder\\ChainedPlaceholderStrategy\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"placeholder_strategy\";}s:5:\"calls\";a:2:{i:0;a:2:{i:0;s:22:\"addPlaceholderStrategy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"placeholder_strategy.big_pipe\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:22:\"addPlaceholderStrategy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"placeholder_strategy.single_flush\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:33:\"placeholder_strategy.single_flush\";s:186:\"a:3:{s:5:\"class\";s:50:\"Drupal\\Core\\Render\\Placeholder\\SingleFlushStrategy\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"placeholder_strategy.single_flush\";}}\";s:15:\"email.validator\";s:155:\"a:3:{s:5:\"class\";s:37:\"Egulias\\EmailValidator\\EmailValidator\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"email.validator\";}}\";s:27:\"update.post_update_registry\";s:327:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Update\\UpdateRegistry\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"update.post_update_registry\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:35:\"update.post_update_registry_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:6:\"create\";}}\";s:35:\"update.post_update_registry_factory\";s:427:\"a:4:{s:5:\"class\";s:40:\"Drupal\\Core\\Update\\UpdateRegistryFactory\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"update.post_update_registry_factory\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:4:\"uuid\";s:131:\"a:3:{s:5:\"class\";s:25:\"Drupal\\Component\\Uuid\\Php\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:4:\"uuid\";}}\";s:27:\"response_filter.active_link\";s:702:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\EventSubscriber\\ActiveLinkResponseFilter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.current\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.matcher\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"response_filter.active_link\";}}\";s:32:\"response_filter.rss.relative_url\";s:191:\"a:3:{s:5:\"class\";s:56:\"Drupal\\Core\\EventSubscriber\\RssResponseRelativeUrlFilter\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"response_filter.rss.relative_url\";}}\";s:9:\"messenger\";s:601:\"a:4:{s:5:\"class\";s:31:\"Drupal\\Core\\Messenger\\Messenger\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:17:\"session.flash_bag\";s:5:\"value\";a:3:{s:5:\"class\";s:55:\"Symfony\\Component\\HttpFoundation\\Session\\Flash\\FlashBag\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"page_cache_kill_switch\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:9:\"messenger\";}}\";s:17:\"tempstore.private\";s:692:\"a:4:{s:5:\"class\";s:45:\"Drupal\\Core\\TempStore\\PrivateTempStoreFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"keyvalue.expirable\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:4;i:604800;}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"tempstore.private\";}}\";s:16:\"tempstore.shared\";s:586:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\TempStore\\SharedTempStoreFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"keyvalue.expirable\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:3;i:604800;}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"tempstore.shared\";}}\";s:25:\"automated_cron.subscriber\";s:576:\"a:4:{s:5:\"class\";s:51:\"Drupal\\automated_cron\\EventSubscriber\\AutomatedCron\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"cron\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"automated_cron.subscriber\";}}\";s:33:\"html_response.big_pipe_subscriber\";s:396:\"a:4:{s:5:\"class\";s:61:\"Drupal\\big_pipe\\EventSubscriber\\HtmlResponseBigPipeSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"big_pipe\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"html_response.big_pipe_subscriber\";}}\";s:29:\"placeholder_strategy.big_pipe\";s:611:\"a:4:{s:5:\"class\";s:50:\"Drupal\\big_pipe\\Render\\Placeholder\\BigPipeStrategy\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"session_configuration\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"placeholder_strategy.big_pipe\";}}\";s:8:\"big_pipe\";s:859:\"a:4:{s:5:\"class\";s:30:\"Drupal\\big_pipe\\Render\\BigPipe\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:7:\"session\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"http_kernel\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:8:\"big_pipe\";}}\";s:28:\"route_subscriber.no_big_pipe\";s:192:\"a:3:{s:5:\"class\";s:61:\"Drupal\\big_pipe\\EventSubscriber\\NoBigPipeRouteAlterSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"route_subscriber.no_big_pipe\";}}\";s:33:\"theme.negotiator.block.admin_demo\";s:174:\"a:3:{s:5:\"class\";s:38:\"Drupal\\block\\Theme\\AdminDemoNegotiator\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"theme.negotiator.block.admin_demo\";}}\";s:37:\"block.page_display_variant_subscriber\";s:202:\"a:3:{s:5:\"class\";s:62:\"Drupal\\block\\EventSubscriber\\BlockPageDisplayVariantSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:37:\"block.page_display_variant_subscriber\";}}\";s:16:\"block.repository\";s:565:\"a:4:{s:5:\"class\";s:28:\"Drupal\\block\\BlockRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"context.handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"block.repository\";}}\";s:25:\"block_content.uuid_lookup\";s:585:\"a:4:{s:5:\"class\";s:44:\"\\Drupal\\block_content\\BlockContentUuidLookup\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.bootstrap\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"block_content.uuid_lookup\";}}\";s:18:\"breakpoint.manager\";s:684:\"a:4:{s:5:\"class\";s:35:\"Drupal\\breakpoint\\BreakpointManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"breakpoint.manager\";}}\";s:30:\"plugin.manager.ckeditor.plugin\";s:595:\"a:4:{s:5:\"class\";s:37:\"Drupal\\ckeditor\\CKEditorPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"plugin.manager.ckeditor.plugin\";}}\";s:30:\"color.config_cache_invalidator\";s:403:\"a:4:{s:5:\"class\";s:56:\"Drupal\\color\\EventSubscriber\\ColorConfigCacheInvalidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"color.config_cache_invalidator\";}}\";s:18:\"comment.breadcrumb\";s:366:\"a:4:{s:5:\"class\";s:39:\"Drupal\\comment\\CommentBreadcrumbBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"comment.breadcrumb\";}}\";s:15:\"comment.manager\";s:884:\"a:4:{s:5:\"class\";s:29:\"Drupal\\comment\\CommentManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:15:\"comment.manager\";}}\";s:18:\"comment.statistics\";s:658:\"a:4:{s:5:\"class\";s:32:\"Drupal\\comment\\CommentStatistics\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"comment.statistics\";}}\";s:21:\"comment.lazy_builders\";s:891:\"a:4:{s:5:\"class\";s:34:\"Drupal\\comment\\CommentLazyBuilders\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity.form_builder\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"comment.manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"comment.lazy_builders\";}}\";s:20:\"comment.link_builder\";s:789:\"a:4:{s:5:\"class\";s:33:\"Drupal\\comment\\CommentLinkBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"comment.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"comment.link_builder\";}}\";s:24:\"config.config_subscriber\";s:157:\"a:3:{s:5:\"class\";s:30:\"Drupal\\config\\ConfigSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"config.config_subscriber\";}}\";s:29:\"access_check.contact_personal\";s:477:\"a:4:{s:5:\"class\";s:39:\"Drupal\\contact\\Access\\ContactPageAccess\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:9:\"user.data\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"access_check.contact_personal\";}}\";s:20:\"contact.mail_handler\";s:798:\"a:4:{s:5:\"class\";s:26:\"Drupal\\contact\\MailHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"plugin.manager.mail\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"logger.channel.contact\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"contact.mail_handler\";}}\";s:22:\"logger.channel.contact\";s:337:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:7:\"contact\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"logger.channel.contact\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:30:\"paramconverter.latest_revision\";s:511:\"a:4:{s:5:\"class\";s:64:\"Drupal\\content_moderation\\ParamConverter\\EntityRevisionConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"paramconverter.latest_revision\";}}\";s:46:\"content_moderation.state_transition_validation\";s:434:\"a:4:{s:5:\"class\";s:52:\"\\Drupal\\content_moderation\\StateTransitionValidation\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:41:\"content_moderation.moderation_information\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:46:\"content_moderation.state_transition_validation\";}}\";s:41:\"content_moderation.moderation_information\";s:517:\"a:4:{s:5:\"class\";s:47:\"Drupal\\content_moderation\\ModerationInformation\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:23:\"entity_type.bundle.info\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:41:\"content_moderation.moderation_information\";}}\";s:28:\"access_check.latest_revision\";s:416:\"a:4:{s:5:\"class\";s:52:\"Drupal\\content_moderation\\Access\\LatestRevisionCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:41:\"content_moderation.moderation_information\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"access_check.latest_revision\";}}\";s:43:\"content_moderation.config_import_subscriber\";s:527:\"a:4:{s:5:\"class\";s:64:\"Drupal\\content_moderation\\EventSubscriber\\ConfigImportSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:43:\"content_moderation.config_import_subscriber\";}}\";s:35:\"content_moderation.route_subscriber\";s:415:\"a:4:{s:5:\"class\";s:66:\"Drupal\\content_moderation\\Routing\\ContentModerationRouteSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"content_moderation.route_subscriber\";}}\";s:57:\"content_moderation_notifications.notification_information\";s:567:\"a:4:{s:5:\"class\";s:63:\"Drupal\\content_moderation_notifications\\NotificationInformation\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:41:\"content_moderation.moderation_information\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:57:\"content_moderation_notifications.notification_information\";}}\";s:45:\"content_moderation_notifications.notification\";s:887:\"a:4:{s:5:\"class\";s:52:\"Drupal\\content_moderation_notifications\\Notification\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"plugin.manager.mail\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:57:\"content_moderation_notifications.notification_information\";s:15:\"invalidBehavior\";i:1;}i:5;N;}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:45:\"content_moderation_notifications.notification\";}}\";s:12:\"logger.dblog\";s:456:\"a:4:{s:5:\"class\";s:25:\"Drupal\\dblog\\Logger\\DbLog\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"logger.log_message_parser\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"logger.dblog\";}}\";s:22:\"devel.error_subscriber\";s:380:\"a:4:{s:5:\"class\";s:51:\"Drupal\\devel\\EventSubscriber\\ErrorHandlerSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"devel.error_subscriber\";}}\";s:30:\"devel.theme_rebuild_subscriber\";s:603:\"a:4:{s:5:\"class\";s:55:\"Drupal\\devel\\EventSubscriber\\ThemeInfoRebuildSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"devel.theme_rebuild_subscriber\";}}\";s:22:\"devel.route_subscriber\";s:372:\"a:4:{s:5:\"class\";s:36:\"Drupal\\devel\\Routing\\RouteSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"devel.route_subscriber\";}}\";s:27:\"plugin.manager.devel_dumper\";s:592:\"a:4:{s:5:\"class\";s:37:\"Drupal\\devel\\DevelDumperPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.devel_dumper\";}}\";s:12:\"devel.dumper\";s:575:\"a:4:{s:5:\"class\";s:31:\"Drupal\\devel\\DevelDumperManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.devel_dumper\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"devel.dumper\";}}\";s:26:\"devel.twig.debug_extension\";s:366:\"a:4:{s:5:\"class\";s:33:\"Drupal\\devel\\Twig\\Extension\\Debug\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"devel.dumper\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"devel.twig.debug_extension\";}}\";s:28:\"plugin.manager.develgenerate\";s:604:\"a:4:{s:5:\"class\";s:48:\"Drupal\\devel_generate\\DevelGeneratePluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"plugin.manager.develgenerate\";}}\";s:24:\"cache.dynamic_page_cache\";s:357:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:18:\"dynamic_page_cache\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"cache.dynamic_page_cache\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:29:\"dynamic_page_cache_subscriber\";s:739:\"a:4:{s:5:\"class\";s:68:\"Drupal\\dynamic_page_cache\\EventSubscriber\\DynamicPageCacheSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"dynamic_page_cache_request_policy\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:34:\"dynamic_page_cache_response_policy\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"render_cache\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:15:\"renderer.config\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"dynamic_page_cache_subscriber\";}}\";s:33:\"dynamic_page_cache_request_policy\";s:206:\"a:3:{s:5:\"class\";s:70:\"Drupal\\dynamic_page_cache\\PageCache\\RequestPolicy\\DefaultRequestPolicy\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"dynamic_page_cache_request_policy\";}}\";s:34:\"dynamic_page_cache_response_policy\";s:474:\"a:4:{s:5:\"class\";s:52:\"Drupal\\Core\\ProxyClass\\PageCache\\ChainResponsePolicy\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:64:\"drupal.proxy_original_service.dynamic_page_cache_response_policy\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"dynamic_page_cache_response_policy\";}}\";s:21:\"plugin.manager.editor\";s:583:\"a:4:{s:5:\"class\";s:34:\"Drupal\\editor\\Plugin\\EditorManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"plugin.manager.editor\";}}\";s:14:\"element.editor\";s:351:\"a:4:{s:5:\"class\";s:21:\"Drupal\\editor\\Element\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"plugin.manager.editor\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"element.editor\";}}\";s:30:\"access_checker.entity_revision\";s:509:\"a:4:{s:5:\"class\";s:54:\"\\Drupal\\entity\\Access\\EntityRevisionRouteAccessChecker\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"access_checker.entity_revision\";}}\";s:30:\"entity.bundle_plugin_installer\";s:748:\"a:4:{s:5:\"class\";s:48:\"Drupal\\entity\\BundlePlugin\\BundlePluginInstaller\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"entity_bundle.listener\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"field_storage_definition.listener\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"field_definition.listener\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"entity.bundle_plugin_installer\";}}\";s:40:\"entity.bundle_plugin.uninstall_validator\";s:522:\"a:4:{s:5:\"class\";s:58:\"\\Drupal\\entity\\BundlePlugin\\BundlePluginUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:40:\"entity.bundle_plugin.uninstall_validator\";}}\";s:25:\"field.uninstall_validator\";s:451:\"a:4:{s:5:\"class\";s:47:\"Drupal\\field\\ProxyClass\\FieldUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:55:\"drupal.proxy_original_service.field.uninstall_validator\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"field.uninstall_validator\";}}\";s:19:\"field_ui.subscriber\";s:367:\"a:4:{s:5:\"class\";s:39:\"Drupal\\field_ui\\Routing\\RouteSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"field_ui.subscriber\";}}\";s:23:\"field_ui.route_enhancer\";s:376:\"a:4:{s:5:\"class\";s:44:\"Drupal\\field_ui\\Routing\\FieldUiRouteEnhancer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"field_ui.route_enhancer\";}}\";s:31:\"access_check.field_ui.view_mode\";s:382:\"a:4:{s:5:\"class\";s:42:\"Drupal\\field_ui\\Access\\ViewModeAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"access_check.field_ui.view_mode\";}}\";s:31:\"access_check.field_ui.form_mode\";s:382:\"a:4:{s:5:\"class\";s:42:\"Drupal\\field_ui\\Access\\FormModeAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"access_check.field_ui.form_mode\";}}\";s:10:\"file.usage\";s:486:\"a:4:{s:5:\"class\";s:46:\"Drupal\\file\\FileUsage\\DatabaseFileUsageBackend\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;s:10:\"file_usage\";i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"file.usage\";}}\";s:21:\"plugin.manager.filter\";s:582:\"a:4:{s:5:\"class\";s:33:\"Drupal\\filter\\FilterPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"plugin.manager.filter\";}}\";s:26:\"filter.uninstall_validator\";s:455:\"a:4:{s:5:\"class\";s:49:\"Drupal\\filter\\ProxyClass\\FilterUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:56:\"drupal.proxy_original_service.filter.uninstall_validator\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"filter.uninstall_validator\";}}\";s:27:\"ga_reports.route_subscriber\";s:171:\"a:3:{s:5:\"class\";s:41:\"Drupal\\ga_reports\\Routing\\RouteSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"ga_reports.route_subscriber\";}}\";s:27:\"plugin.manager.help_section\";s:585:\"a:4:{s:5:\"class\";s:30:\"Drupal\\help\\HelpSectionManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.help_section\";}}\";s:27:\"path_processor.image_styles\";s:395:\"a:4:{s:5:\"class\";s:51:\"Drupal\\image\\PathProcessor\\PathProcessorImageStyles\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"stream_wrapper_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"path_processor.image_styles\";}}\";s:27:\"plugin.manager.image.effect\";s:586:\"a:4:{s:5:\"class\";s:31:\"Drupal\\image\\ImageEffectManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.image.effect\";}}\";s:24:\"kint.twig.kint_extension\";s:157:\"a:3:{s:5:\"class\";s:30:\"Drupal\\kint\\Twig\\KintExtension\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"kint.twig.kint_extension\";}}\";s:31:\"migrate.plugin_event_subscriber\";s:177:\"a:3:{s:5:\"class\";s:43:\"Drupal\\migrate\\Plugin\\PluginEventSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"migrate.plugin_event_subscriber\";}}\";s:13:\"cache.migrate\";s:334:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:7:\"migrate\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"cache.migrate\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:29:\"plugin.manager.migrate.source\";s:622:\"a:4:{s:5:\"class\";s:48:\"Drupal\\migrate\\Plugin\\MigrateSourcePluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:6:\"source\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"plugin.manager.migrate.source\";}}\";s:30:\"plugin.manager.migrate.process\";s:676:\"a:4:{s:5:\"class\";s:42:\"Drupal\\migrate\\Plugin\\MigratePluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:7:\"process\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;s:46:\"Drupal\\migrate\\Annotation\\MigrateProcessPlugin\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"plugin.manager.migrate.process\";}}\";s:34:\"plugin.manager.migrate.destination\";s:744:\"a:4:{s:5:\"class\";s:53:\"Drupal\\migrate\\Plugin\\MigrateDestinationPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:11:\"destination\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"plugin.manager.migrate.destination\";}}\";s:29:\"plugin.manager.migrate.id_map\";s:616:\"a:4:{s:5:\"class\";s:42:\"Drupal\\migrate\\Plugin\\MigratePluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:6:\"id_map\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"plugin.manager.migrate.id_map\";}}\";s:25:\"cache.discovery_migration\";s:359:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:19:\"discovery_migration\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"cache.discovery_migration\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:24:\"plugin.manager.migration\";s:829:\"a:4:{s:5:\"class\";s:44:\"Drupal\\migrate_drupal\\MigrationPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"cache.discovery_migration\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"plugin.manager.migrate.source\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"plugin.manager.migration\";}}\";s:28:\"plugin.manager.migrate.field\";s:684:\"a:4:{s:5:\"class\";s:54:\"Drupal\\migrate_drupal\\Plugin\\MigrateFieldPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:5:\"field\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;s:46:\"\\Drupal\\migrate_drupal\\Annotation\\MigrateField\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"plugin.manager.migrate.field\";}}\";s:31:\"plugin.manager.migrate.cckfield\";s:696:\"a:4:{s:5:\"class\";s:57:\"Drupal\\migrate_drupal\\Plugin\\MigrateCckFieldPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:8:\"cckfield\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;s:49:\"\\Drupal\\migrate_drupal\\Annotation\\MigrateCckField\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"plugin.manager.migrate.cckfield\";}}\";s:42:\"plugin.manager.migrate_plus.authentication\";s:617:\"a:4:{s:5:\"class\";s:47:\"Drupal\\migrate_plus\\AuthenticationPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:42:\"plugin.manager.migrate_plus.authentication\";}}\";s:40:\"plugin.manager.migrate_plus.data_fetcher\";s:612:\"a:4:{s:5:\"class\";s:44:\"Drupal\\migrate_plus\\DataFetcherPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:40:\"plugin.manager.migrate_plus.data_fetcher\";}}\";s:39:\"plugin.manager.migrate_plus.data_parser\";s:610:\"a:4:{s:5:\"class\";s:43:\"Drupal\\migrate_plus\\DataParserPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:39:\"plugin.manager.migrate_plus.data_parser\";}}\";s:28:\"logger.channel.migrate_tools\";s:350:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:13:\"migrate_tools\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"logger.channel.migrate_tools\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:29:\"route_processor.migrate_group\";s:175:\"a:3:{s:5:\"class\";s:43:\"Drupal\\migrate_tools\\Routing\\RouteProcessor\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"route_processor.migrate_group\";}}\";s:21:\"node.route_subscriber\";s:159:\"a:3:{s:5:\"class\";s:35:\"Drupal\\node\\Routing\\RouteSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"node.route_subscriber\";}}\";s:18:\"node.grant_storage\";s:570:\"a:4:{s:5:\"class\";s:36:\"Drupal\\node\\NodeGrantDatabaseStorage\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:18:\"node.grant_storage\";}}\";s:26:\"access_check.node.revision\";s:377:\"a:4:{s:5:\"class\";s:42:\"Drupal\\node\\Access\\NodeRevisionAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"access_check.node.revision\";}}\";s:21:\"access_check.node.add\";s:367:\"a:4:{s:5:\"class\";s:37:\"Drupal\\node\\Access\\NodeAddAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"access_check.node.add\";}}\";s:25:\"access_check.node.preview\";s:375:\"a:4:{s:5:\"class\";s:41:\"Drupal\\node\\Access\\NodePreviewAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"access_check.node.preview\";}}\";s:32:\"node.admin_path.route_subscriber\";s:393:\"a:4:{s:5:\"class\";s:52:\"Drupal\\node\\EventSubscriber\\NodeAdminRouteSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"node.admin_path.route_subscriber\";}}\";s:12:\"node_preview\";s:436:\"a:4:{s:5:\"class\";s:58:\"Drupal\\node\\ProxyClass\\ParamConverter\\NodePreviewConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:42:\"drupal.proxy_original_service.node_preview\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:12:\"node_preview\";}}\";s:30:\"cache_context.user.node_grants\";s:383:\"a:4:{s:5:\"class\";s:46:\"Drupal\\node\\Cache\\NodeAccessGrantsCacheContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"cache_context.user.node_grants\";}}\";s:23:\"node.node_route_context\";s:381:\"a:4:{s:5:\"class\";s:44:\"Drupal\\node\\ContextProvider\\NodeRouteContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"node.node_route_context\";}}\";s:26:\"http_middleware.page_cache\";s:734:\"a:4:{s:5:\"class\";s:43:\"Drupal\\page_cache\\StackMiddleware\\PageCache\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:33:\"http_middleware.kernel_pre_handle\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.page\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"page_cache_request_policy\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:26:\"page_cache_response_policy\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"http_middleware.page_cache\";}}\";s:10:\"cache.page\";s:328:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:4:\"page\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"cache.page\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:31:\"plugin.manager.quickedit.editor\";s:603:\"a:4:{s:5:\"class\";s:44:\"Drupal\\quickedit\\Plugin\\InPlaceEditorManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"plugin.manager.quickedit.editor\";}}\";s:35:\"access_check.quickedit.entity_field\";s:193:\"a:3:{s:5:\"class\";s:55:\"Drupal\\quickedit\\Access\\QuickEditEntityFieldAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"access_check.quickedit.entity_field\";}}\";s:25:\"quickedit.editor.selector\";s:504:\"a:4:{s:5:\"class\";s:31:\"Drupal\\quickedit\\EditorSelector\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.quickedit.editor\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:30:\"plugin.manager.field.formatter\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"quickedit.editor.selector\";}}\";s:28:\"quickedit.metadata.generator\";s:632:\"a:4:{s:5:\"class\";s:34:\"Drupal\\quickedit\\MetadataGenerator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:35:\"access_check.quickedit.entity_field\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:25:\"quickedit.editor.selector\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.quickedit.editor\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"quickedit.metadata.generator\";}}\";s:19:\"plugin.manager.rest\";s:592:\"a:4:{s:5:\"class\";s:45:\"Drupal\\rest\\Plugin\\Type\\ResourcePluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"plugin.manager.rest\";}}\";s:10:\"cache.rest\";s:328:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:4:\"rest\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"cache.rest\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:20:\"rest.resource_routes\";s:590:\"a:4:{s:5:\"class\";s:34:\"Drupal\\rest\\Routing\\ResourceRoutes\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"plugin.manager.rest\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"logger.channel.rest\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"rest.resource_routes\";}}\";s:19:\"logger.channel.rest\";s:331:\"a:5:{s:5:\"class\";s:32:\"Drupal\\Core\\Logger\\LoggerChannel\";s:9:\"arguments\";a:1:{i:0;s:4:\"rest\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:19:\"logger.channel.rest\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"logger.factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:33:\"rest.resource_response.subscriber\";s:602:\"a:4:{s:5:\"class\";s:54:\"Drupal\\rest\\EventSubscriber\\ResourceResponseSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"serializer\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"rest.resource_response.subscriber\";}}\";s:22:\"rest.config_subscriber\";s:379:\"a:4:{s:5:\"class\";s:48:\"Drupal\\rest\\EventSubscriber\\RestConfigSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"router.builder\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"rest.config_subscriber\";}}\";s:42:\"rest.resource.entity.post_route.subscriber\";s:418:\"a:4:{s:5:\"class\";s:62:\"\\Drupal\\rest\\EventSubscriber\\EntityResourcePostRouteSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:42:\"rest.resource.entity.post_route.subscriber\";}}\";s:38:\"rest.path_processor_entity_resource_bc\";s:408:\"a:4:{s:5:\"class\";s:56:\"\\Drupal\\rest\\PathProcessor\\PathProcessorEntityResourceBC\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:38:\"rest.path_processor_entity_resource_bc\";}}\";s:27:\"rest.route_processor_get_bc\";s:489:\"a:4:{s:5:\"class\";s:59:\"\\Drupal\\rest\\RouteProcessor\\RestResourceGetRouteProcessorBC\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:18:\"serializer.formats\";}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"rest.route_processor_get_bc\";}}\";s:21:\"plugin.manager.search\";s:582:\"a:4:{s:5:\"class\";s:33:\"Drupal\\search\\SearchPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"plugin.manager.search\";}}\";s:29:\"search.search_page_repository\";s:478:\"a:4:{s:5:\"class\";s:34:\"Drupal\\search\\SearchPageRepository\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"search.search_page_repository\";}}\";s:10:\"serializer\";s:6721:\"a:4:{s:5:\"class\";s:39:\"Symfony\\Component\\Serializer\\Serializer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:13:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__LA-sp64m2mA5d5vj3I2EqvmXMUZmzL1H8DdZVBczrps\";s:5:\"value\";a:5:{s:5:\"class\";s:46:\"Drupal\\serialization\\Normalizer\\NullNormalizer\";s:6:\"public\";b:0;s:9:\"arguments\";a:1:{i:0;s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:41:\"serializer.normalizer.password_field_item\";}}s:6:\"shared\";b:0;}i:1;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__RjvfXTzb1eYYruArvyU-NB4dMSyaUsrDjzBi0Zp6KWk\";s:5:\"value\";a:4:{s:5:\"class\";s:46:\"Drupal\\serialization\\Normalizer\\ListNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"serializer.normalizer.list\";}}s:6:\"shared\";b:0;}i:2;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__75tZkz6aclTajQ31zNVQcvpapTgkz86KTUe0C4ZqteY\";s:5:\"value\";a:5:{s:5:\"class\";s:66:\"Drupal\\serialization\\Normalizer\\EntityReferenceFieldItemNormalizer\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"entity.repository\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:49:\"serializer.normalizer.entity_reference_field_item\";}}s:6:\"shared\";b:0;}i:3;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__7jhY2PaBXjmJ7k9prEvDjkDJsEaJeNP92yAc8F8i2bg\";s:5:\"value\";a:4:{s:5:\"class\";s:55:\"Drupal\\serialization\\Normalizer\\TimestampItemNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:36:\"serializer.normalizer.timestamp_item\";}}s:6:\"shared\";b:0;}i:4;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__OUeP0F3teHTbzNV6q5sO5d0gZ9dHRwY9dH8yr8KDvQ8\";s:5:\"value\";a:4:{s:5:\"class\";s:51:\"Drupal\\serialization\\Normalizer\\FieldItemNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"serialization.normalizer.field_item\";}}s:6:\"shared\";b:0;}i:5;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__kbn2PNYI3mJuRbXePuPNjy_NY1nd6_q7-BuM89J-A50\";s:5:\"value\";a:4:{s:5:\"class\";s:47:\"Drupal\\serialization\\Normalizer\\FieldNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"serialization.normalizer.field\";}}s:6:\"shared\";b:0;}i:6;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__zmH8zC404LUmJuF9wpOvqpSOxETDuHwMqDeu0z8BCug\";s:5:\"value\";a:4:{s:5:\"class\";s:55:\"Drupal\\serialization\\Normalizer\\PrimitiveDataNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:36:\"serializer.normalizer.primitive_data\";}}s:6:\"shared\";b:0;}i:7;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__KH4CLOwzkKA1miEzpbqQgwABG0OTnb39kxxx1AoPWKI\";s:5:\"value\";a:5:{s:5:\"class\";s:54:\"Drupal\\serialization\\Normalizer\\ConfigEntityNormalizer\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"serializer.normalizer.config_entity\";}}s:6:\"shared\";b:0;}i:8;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__UUKpXX0zOz_u-D1zV5Ss5zDvS6zJXrCwjFy8xiWUGms\";s:5:\"value\";a:5:{s:5:\"class\";s:55:\"Drupal\\serialization\\Normalizer\\ContentEntityNormalizer\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:36:\"serializer.normalizer.content_entity\";}}s:6:\"shared\";b:0;}i:9;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__zOWMe8LjPsN5j9CGuPwA6_Jaezh3I1zn3HqAqVPFkuA\";s:5:\"value\";a:5:{s:5:\"class\";s:48:\"Drupal\\serialization\\Normalizer\\EntityNormalizer\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"serializer.normalizer.entity\";}}s:6:\"shared\";b:0;}i:10;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__Ll7cnjBgKFfqKHY54oXA64iudTJrvpvhbAd7N9C4uE4\";s:5:\"value\";a:4:{s:5:\"class\";s:53:\"Drupal\\serialization\\Normalizer\\ComplexDataNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"serializer.normalizer.complex_data\";}}s:6:\"shared\";b:0;}i:11;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__aVupMPUdQhi_uG1uZ8c8KW2dAwOBvR78r7D7IFQG2tk\";s:5:\"value\";a:4:{s:5:\"class\";s:48:\"Drupal\\serialization\\Normalizer\\MarkupNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"serializer.normalizer.safe_string\";}}s:6:\"shared\";b:0;}i:12;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__n5zQ0RHJzRshT_cLZkHDEUYq_CWAf0JYaKrrzqpE-VY\";s:5:\"value\";a:4:{s:5:\"class\";s:51:\"Drupal\\serialization\\Normalizer\\TypedDataNormalizer\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"serializer.normalizer.typed_data\";}}s:6:\"shared\";b:0;}}s:7:\"resolve\";b:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__GBckT32uKLRuSmsqxKN_M-i6cMr68UBBazNwp865II8\";s:5:\"value\";a:4:{s:5:\"class\";s:40:\"Drupal\\serialization\\Encoder\\JsonEncoder\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"serializer.encoder.json\";}}s:6:\"shared\";b:0;}i:1;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__NIAfawpJHeMjIDiGybnL6HsREtdABxpy6wsL2Euai_8\";s:5:\"value\";a:4:{s:5:\"class\";s:39:\"Drupal\\serialization\\Encoder\\XmlEncoder\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"serializer.encoder.xml\";}}s:6:\"shared\";b:0;}}s:7:\"resolve\";b:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:10:\"serializer\";}}\";s:26:\"serializer.entity_resolver\";s:698:\"a:4:{s:5:\"class\";s:55:\"Drupal\\serialization\\EntityResolver\\ChainEntityResolver\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"serializer.entity_resolver\";}s:5:\"calls\";a:2:{i:0;a:2:{i:0;s:11:\"addResolver\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"serializer.entity_resolver.uuid\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:11:\"addResolver\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:39:\"serialization.entity_resolver.target_id\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:31:\"serializer.entity_resolver.uuid\";s:391:\"a:4:{s:5:\"class\";s:48:\"Drupal\\serialization\\EntityResolver\\UuidResolver\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"entity.repository\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"serializer.entity_resolver.uuid\";}}\";s:39:\"serialization.entity_resolver.target_id\";s:194:\"a:3:{s:5:\"class\";s:52:\"Drupal\\serialization\\EntityResolver\\TargetIdResolver\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:39:\"serialization.entity_resolver.target_id\";}}\";s:31:\"serialization.exception.default\";s:486:\"a:4:{s:5:\"class\";s:63:\"Drupal\\serialization\\EventSubscriber\\DefaultExceptionSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"serializer\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:18:\"serializer.formats\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:31:\"serialization.exception.default\";}}\";s:41:\"serialization.user_route_alter_subscriber\";s:392:\"a:4:{s:5:\"class\";s:61:\"Drupal\\serialization\\EventSubscriber\\UserRouteAlterSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":2:{s:4:\"type\";s:9:\"parameter\";s:4:\"name\";s:18:\"serializer.formats\";}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:41:\"serialization.user_route_alter_subscriber\";}}\";s:34:\"serialization.bc_config_subscriber\";s:389:\"a:4:{s:5:\"class\";s:55:\"Drupal\\serialization\\EventSubscriber\\BcConfigSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"kernel\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"serialization.bc_config_subscriber\";}}\";s:17:\"access_check.cron\";s:156:\"a:3:{s:5:\"class\";s:36:\"Drupal\\system\\Access\\CronAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"access_check.cron\";}}\";s:22:\"access_check.db_update\";s:165:\"a:3:{s:5:\"class\";s:40:\"Drupal\\system\\Access\\DbUpdateAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"access_check.db_update\";}}\";s:14:\"system.manager\";s:776:\"a:4:{s:5:\"class\";s:27:\"Drupal\\system\\SystemManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"menu.link_tree\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"menu.active_trail\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"system.manager\";}}\";s:25:\"system.breadcrumb.default\";s:1223:\"a:4:{s:5:\"class\";s:40:\"Drupal\\system\\PathBasedBreadcrumbBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:9:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"router.request_context\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"access_manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"router\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"path_processor_manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"title_resolver\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.current\";s:15:\"invalidBehavior\";i:1;}i:8;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"path.matcher\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:9;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"system.breadcrumb.default\";}}\";s:20:\"path_processor.files\";s:169:\"a:3:{s:5:\"class\";s:46:\"Drupal\\system\\PathProcessor\\PathProcessorFiles\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:20:\"path_processor.files\";}}\";s:34:\"system.admin_path.route_subscriber\";s:187:\"a:3:{s:5:\"class\";s:50:\"Drupal\\system\\EventSubscriber\\AdminRouteSubscriber\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"system.admin_path.route_subscriber\";}}\";s:29:\"theme.negotiator.system.batch\";s:477:\"a:4:{s:5:\"class\";s:35:\"Drupal\\system\\Theme\\BatchNegotiator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"batch.storage\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"theme.negotiator.system.batch\";}}\";s:33:\"theme.negotiator.system.db_update\";s:380:\"a:4:{s:5:\"class\";s:38:\"Drupal\\system\\Theme\\DbUpdateNegotiator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"theme.negotiator.system.db_update\";}}\";s:24:\"system.config_subscriber\";s:369:\"a:4:{s:5:\"class\";s:36:\"Drupal\\system\\SystemConfigSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"router.builder\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"system.config_subscriber\";}}\";s:23:\"system.config_cache_tag\";s:489:\"a:4:{s:5:\"class\";s:44:\"Drupal\\system\\EventSubscriber\\ConfigCacheTag\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"system.config_cache_tag\";}}\";s:24:\"taxonomy_term.breadcrumb\";s:370:\"a:4:{s:5:\"class\";s:37:\"Drupal\\taxonomy\\TermBreadcrumbBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"taxonomy_term.breadcrumb\";}}\";s:13:\"cache.toolbar\";s:334:\"a:5:{s:5:\"class\";s:39:\"Drupal\\Core\\Cache\\CacheBackendInterface\";s:9:\"arguments\";a:1:{i:0;s:7:\"toolbar\";}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:13:\"cache.toolbar\";}s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache_factory\";s:15:\"invalidBehavior\";i:1;}i:1;s:3:\"get\";}}\";s:52:\"toolbar.page_cache_request_policy.allow_toolbar_path\";s:196:\"a:3:{s:5:\"class\";s:41:\"Drupal\\toolbar\\PageCache\\AllowToolbarPath\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:52:\"toolbar.page_cache_request_policy.allow_toolbar_path\";}}\";s:17:\"toolbar.menu_tree\";s:1578:\"a:4:{s:5:\"class\";s:39:\"Drupal\\toolbar\\Menu\\ToolbarMenuLinkTree\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:17:\"menu.tree_storage\";s:5:\"value\";a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Menu\\MenuTreeStorage\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.menu\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"cache_tags.invalidator\";s:15:\"invalidBehavior\";i:1;}i:3;s:9:\"menu_tree\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;}s:6:\"shared\";b:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.menu.link\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"menu.active_trail\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"cache.menu\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:17:\"toolbar.menu_tree\";}}\";s:23:\"plugin.manager.tour.tip\";s:579:\"a:4:{s:5:\"class\";s:28:\"Drupal\\tour\\TipPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"plugin.manager.tour.tip\";}}\";s:14:\"twilio.command\";s:147:\"a:3:{s:5:\"class\";s:30:\"Drupal\\twilio\\Services\\Command\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"twilio.command\";}}\";s:34:\"access_check.update.manager_access\";s:381:\"a:4:{s:5:\"class\";s:45:\"Drupal\\update\\Access\\UpdateManagerAccessCheck\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"settings\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"access_check.update.manager_access\";}}\";s:14:\"update.manager\";s:889:\"a:4:{s:5:\"class\";s:27:\"Drupal\\update\\UpdateManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"update.processor\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"keyvalue.expirable\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"theme_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"update.manager\";}}\";s:16:\"update.processor\";s:964:\"a:4:{s:5:\"class\";s:29:\"Drupal\\update\\UpdateProcessor\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"queue\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"update.fetcher\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"private_key\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"keyvalue\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"keyvalue.expirable\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"update.processor\";}}\";s:14:\"update.fetcher\";s:453:\"a:4:{s:5:\"class\";s:27:\"Drupal\\update\\UpdateFetcher\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:11:\"http_client\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"update.fetcher\";}}\";s:11:\"update.root\";s:653:\"a:3:{s:5:\"class\";s:9:\"SplString\";s:15:\"arguments_count\";i:0;s:7:\"factory\";a:2:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__bMLhoCgZQoyy4RMydJYnVYuoywhbXV-jZ8BeVGwyepM\";s:5:\"value\";a:4:{s:5:\"class\";s:31:\"Drupal\\update\\UpdateRootFactory\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"kernel\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;}s:6:\"shared\";b:0;}i:1;s:3:\"get\";}}\";s:23:\"access_check.permission\";s:166:\"a:3:{s:5:\"class\";s:40:\"Drupal\\user\\Access\\PermissionAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"access_check.permission\";}}\";s:26:\"access_check.user.register\";s:167:\"a:3:{s:5:\"class\";s:38:\"Drupal\\user\\Access\\RegisterAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"access_check.user.register\";}}\";s:22:\"access_check.user.role\";s:159:\"a:3:{s:5:\"class\";s:34:\"Drupal\\user\\Access\\RoleAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"access_check.user.role\";}}\";s:30:\"access_check.user.login_status\";s:168:\"a:3:{s:5:\"class\";s:35:\"Drupal\\user\\Access\\LoginStatusCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"access_check.user.login_status\";}}\";s:26:\"user.authentication.cookie\";s:483:\"a:4:{s:5:\"class\";s:42:\"Drupal\\user\\Authentication\\Provider\\Cookie\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"session_configuration\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"user.authentication.cookie\";}}\";s:9:\"user.data\";s:330:\"a:4:{s:5:\"class\";s:20:\"Drupal\\user\\UserData\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:9:\"user.data\";}}\";s:32:\"user_maintenance_mode_subscriber\";s:500:\"a:4:{s:5:\"class\";s:53:\"Drupal\\user\\EventSubscriber\\MaintenanceModeSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"maintenance_mode\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:32:\"user_maintenance_mode_subscriber\";}}\";s:29:\"user_access_denied_subscriber\";s:491:\"a:4:{s:5:\"class\";s:50:\"Drupal\\user\\EventSubscriber\\AccessDeniedSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"url_generator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"user_access_denied_subscriber\";}}\";s:27:\"user_last_access_subscriber\";s:489:\"a:4:{s:5:\"class\";s:49:\"Drupal\\user\\EventSubscriber\\UserRequestSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"user_last_access_subscriber\";}}\";s:28:\"theme.negotiator.admin_theme\";s:692:\"a:4:{s:5:\"class\";s:33:\"Drupal\\user\\Theme\\AdminNegotiator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"router.admin_context\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"theme.negotiator.admin_theme\";}}\";s:9:\"user.auth\";s:436:\"a:4:{s:5:\"class\";s:20:\"Drupal\\user\\UserAuth\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"password\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:9:\"user.auth\";}}\";s:22:\"user.private_tempstore\";s:687:\"a:4:{s:5:\"class\";s:35:\"Drupal\\user\\PrivateTempStoreFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"keyvalue.expirable\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:4;i:604800;}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"user.private_tempstore\";}}\";s:21:\"user.shared_tempstore\";s:581:\"a:4:{s:5:\"class\";s:34:\"Drupal\\user\\SharedTempStoreFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"keyvalue.expirable\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:3;i:604800;}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:21:\"user.shared_tempstore\";}}\";s:16:\"user.permissions\";s:575:\"a:4:{s:5:\"class\";s:29:\"Drupal\\user\\PermissionHandler\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"user.permissions\";}}\";s:25:\"user.current_user_context\";s:484:\"a:4:{s:5:\"class\";s:46:\"Drupal\\user\\ContextProvider\\CurrentUserContext\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"user.current_user_context\";}}\";s:25:\"user.toolbar_link_builder\";s:362:\"a:4:{s:5:\"class\";s:30:\"Drupal\\user\\ToolbarLinkBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"user.toolbar_link_builder\";}}\";s:23:\"paramconverter.views_ui\";s:457:\"a:4:{s:5:\"class\";s:57:\"Drupal\\views_ui\\ProxyClass\\ParamConverter\\ViewUIConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}i:1;s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"paramconverter.views_ui\";}}\";s:29:\"plugin.manager.workflows.type\";s:593:\"a:4:{s:5:\"class\";s:36:\"Drupal\\workflows\\WorkflowTypeManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"plugin.manager.workflows.type\";}}\";s:35:\"workflows.access_check.delete_state\";s:181:\"a:3:{s:5:\"class\";s:43:\"\\Drupal\\workflows\\WorkflowDeleteAccessCheck\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"workflows.access_check.delete_state\";}}\";s:27:\"plugin.manager.views.access\";s:610:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:6:\"access\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.views.access\";}}\";s:25:\"plugin.manager.views.area\";s:715:\"a:4:{s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\ViewsHandlerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:4:\"area\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"plugin.manager.views.area\";}}\";s:29:\"plugin.manager.views.argument\";s:723:\"a:4:{s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\ViewsHandlerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:8:\"argument\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:29:\"plugin.manager.views.argument\";}}\";s:37:\"plugin.manager.views.argument_default\";s:631:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:16:\"argument_default\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:37:\"plugin.manager.views.argument_default\";}}\";s:39:\"plugin.manager.views.argument_validator\";s:635:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:18:\"argument_validator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:39:\"plugin.manager.views.argument_validator\";}}\";s:26:\"plugin.manager.views.cache\";s:608:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:5:\"cache\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"plugin.manager.views.cache\";}}\";s:37:\"plugin.manager.views.display_extender\";s:631:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:16:\"display_extender\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:37:\"plugin.manager.views.display_extender\";}}\";s:28:\"plugin.manager.views.display\";s:612:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:7:\"display\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:28:\"plugin.manager.views.display\";}}\";s:33:\"plugin.manager.views.exposed_form\";s:623:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:12:\"exposed_form\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"plugin.manager.views.exposed_form\";}}\";s:26:\"plugin.manager.views.field\";s:717:\"a:4:{s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\ViewsHandlerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:5:\"field\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"plugin.manager.views.field\";}}\";s:27:\"plugin.manager.views.filter\";s:719:\"a:4:{s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\ViewsHandlerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:6:\"filter\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.views.filter\";}}\";s:25:\"plugin.manager.views.join\";s:715:\"a:4:{s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\ViewsHandlerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:4:\"join\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"plugin.manager.views.join\";}}\";s:26:\"plugin.manager.views.pager\";s:608:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:5:\"pager\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"plugin.manager.views.pager\";}}\";s:26:\"plugin.manager.views.query\";s:608:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:5:\"query\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"plugin.manager.views.query\";}}\";s:33:\"plugin.manager.views.relationship\";s:732:\"a:4:{s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\ViewsHandlerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:12:\"relationship\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:33:\"plugin.manager.views.relationship\";}}\";s:24:\"plugin.manager.views.row\";s:604:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:3:\"row\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"plugin.manager.views.row\";}}\";s:25:\"plugin.manager.views.sort\";s:715:\"a:4:{s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\ViewsHandlerManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:5:{i:0;s:4:\"sort\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:5;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:25:\"plugin.manager.views.sort\";}}\";s:26:\"plugin.manager.views.style\";s:608:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:5:\"style\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:26:\"plugin.manager.views.style\";}}\";s:27:\"plugin.manager.views.wizard\";s:610:\"a:4:{s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\ViewsPluginManager\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;s:6:\"wizard\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"container.namespaces\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:15:\"cache.discovery\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:27:\"plugin.manager.views.wizard\";}}\";s:16:\"views.views_data\";s:666:\"a:4:{s:5:\"class\";s:22:\"Drupal\\views\\ViewsData\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"cache.default\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"language_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"views.views_data\";}}\";s:23:\"views.views_data_helper\";s:362:\"a:4:{s:5:\"class\";s:28:\"Drupal\\views\\ViewsDataHelper\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:23:\"views.views_data_helper\";}}\";s:16:\"views.executable\";s:683:\"a:4:{s:5:\"class\";s:34:\"Drupal\\views\\ViewExecutableFactory\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"current_user\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"views.views_data\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"router.route_provider\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:16:\"views.executable\";}}\";s:14:\"views.analyzer\";s:344:\"a:4:{s:5:\"class\";s:21:\"Drupal\\views\\Analyzer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"views.analyzer\";}}\";s:22:\"views.route_subscriber\";s:471:\"a:4:{s:5:\"class\";s:44:\"Drupal\\views\\EventSubscriber\\RouteSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:22:\"views.route_subscriber\";}}\";s:24:\"views.exposed_form_cache\";s:156:\"a:3:{s:5:\"class\";s:29:\"Drupal\\views\\ExposedFormCache\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:24:\"views.exposed_form_cache\";}}\";s:30:\"views.entity_schema_subscriber\";s:395:\"a:4:{s:5:\"class\";s:56:\"Drupal\\views\\EventSubscriber\\ViewsEntitySchemaSubscriber\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:30:\"views.entity_schema_subscriber\";}}\";s:14:\"views.date_sql\";s:360:\"a:4:{s:5:\"class\";s:44:\"Drupal\\views\\Plugin\\views\\query\\MysqlDateSql\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:14:\"views.date_sql\";}}\";s:56:\"drupal.proxy_original_service.page_cache_response_policy\";s:2596:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\PageCache\\ChainResponsePolicy\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:56:\"drupal.proxy_original_service.page_cache_response_policy\";}s:5:\"calls\";a:5:{i:0;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"page_cache_kill_switch\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:26:\"page_cache_no_cache_routes\";s:5:\"value\";a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\PageCache\\ResponsePolicy\\DenyNoCacheRoutes\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:26:\"page_cache_no_server_error\";s:5:\"value\";a:3:{s:5:\"class\";s:50:\"Drupal\\Core\\PageCache\\ResponsePolicy\\NoServerError\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:1;}}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__F1OS6M_fMxC2jDEfVZbGJ1Es-a5S2P1N1kq2aotUsfs\";s:5:\"value\";a:4:{s:5:\"class\";s:52:\"Drupal\\image\\PageCache\\DenyPrivateImageStyleDownload\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:0;}}s:7:\"resolve\";b:1;}}i:4;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__tVbzWPF79c92deQsZtUrs_BreTwTssDglbNjnau7aZk\";s:5:\"value\";a:4:{s:5:\"class\";s:37:\"Drupal\\node\\PageCache\\DenyNodePreview\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:0;}}s:7:\"resolve\";b:1;}}}}\";s:46:\"drupal.proxy_original_service.config.installer\";s:832:\"a:4:{s:5:\"class\";s:34:\"Drupal\\Core\\Config\\ConfigInstaller\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.storage\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:12:\"config.typed\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.manager\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:5;s:8:\"standard\";}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:46:\"drupal.proxy_original_service.config.installer\";}}\";s:34:\"drupal.proxy_original_service.cron\";s:1089:\"a:4:{s:5:\"class\";s:16:\"Drupal\\Core\\Cron\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:8:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"queue\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"account_switcher\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"logger.channel.cron\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:27:\"plugin.manager.queue_worker\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"datetime.time\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:8;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"drupal.proxy_original_service.cron\";}}\";s:46:\"drupal.proxy_original_service.module_installer\";s:2100:\"a:5:{s:5:\"class\";s:37:\"Drupal\\Core\\Extension\\ModuleInstaller\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"app.root\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:6:\"kernel\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"router.builder\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:46:\"drupal.proxy_original_service.module_installer\";}s:5:\"calls\";a:5:{i:0;a:2:{i:0;s:21:\"addUninstallValidator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:40:\"entity.bundle_plugin.uninstall_validator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:21:\"addUninstallValidator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:57:\"drupal.proxy_original_service.content_uninstall_validator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:21:\"addUninstallValidator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:65:\"drupal.proxy_original_service.required_module_uninstall_validator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:21:\"addUninstallValidator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:55:\"drupal.proxy_original_service.field.uninstall_validator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:4;a:2:{i:0;s:21:\"addUninstallValidator\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:56:\"drupal.proxy_original_service.filter.uninstall_validator\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}}}\";s:57:\"drupal.proxy_original_service.content_uninstall_validator\";s:520:\"a:4:{s:5:\"class\";s:44:\"Drupal\\Core\\Entity\\ContentUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:57:\"drupal.proxy_original_service.content_uninstall_validator\";}}\";s:65:\"drupal.proxy_original_service.required_module_uninstall_validator\";s:432:\"a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\Extension\\RequiredModuleUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:65:\"drupal.proxy_original_service.required_module_uninstall_validator\";}}\";s:50:\"drupal.proxy_original_service.plugin.cache_clearer\";s:194:\"a:3:{s:5:\"class\";s:41:\"Drupal\\Core\\Plugin\\CachedDiscoveryClearer\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:50:\"drupal.proxy_original_service.plugin.cache_clearer\";}}\";s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";s:423:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\ParamConverter\\MenuLinkPluginConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:24:\"plugin.manager.menu.link\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";}}\";s:34:\"drupal.proxy_original_service.lock\";s:372:\"a:4:{s:5:\"class\";s:36:\"Drupal\\Core\\Lock\\DatabaseLockBackend\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:34:\"drupal.proxy_original_service.lock\";}}\";s:45:\"drupal.proxy_original_service.lock.persistent\";s:393:\"a:4:{s:5:\"class\";s:46:\"Drupal\\Core\\Lock\\PersistentDatabaseLockBackend\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:45:\"drupal.proxy_original_service.lock.persistent\";}}\";s:43:\"drupal.proxy_original_service.router.dumper\";s:474:\"a:4:{s:5:\"class\";s:33:\"Drupal\\Core\\Routing\\MatcherDumper\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:5:\"state\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:43:\"drupal.proxy_original_service.router.dumper\";}}\";s:44:\"drupal.proxy_original_service.router.builder\";s:5225:\"a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Routing\\RouteBuilder\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:6:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"router.dumper\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:4:\"lock\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"event_dispatcher\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"controller_resolver\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:29:\"access_manager.check_provider\";s:5:\"value\";a:4:{s:5:\"class\";s:32:\"Drupal\\Core\\Access\\CheckProvider\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;s:5:\"calls\";a:27:{i:0;a:2:{i:0;s:12:\"setContainer\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"service_container\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:20:\"access_check.default\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:7:\"_access\";}i:3;b:0;}}i:2;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:19:\"access_check.entity\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:14:\"_entity_access\";}i:3;b:0;}}i:3;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:26:\"access_check.entity_create\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_entity_create_access\";}i:3;b:0;}}i:4;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:30:\"access_check.entity_create_any\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:25:\"_entity_create_any_access\";}i:3;b:0;}}i:5;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:35:\"access_check.entity_delete_multiple\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:30:\"_entity_delete_multiple_access\";}i:3;b:0;}}i:6;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:18:\"access_check.theme\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:13:\"_access_theme\";}i:3;b:0;}}i:7;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:19:\"access_check.custom\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:14:\"_custom_access\";}i:3;b:0;}}i:8;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:17:\"access_check.csrf\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:11:\"_csrf_token\";}i:3;b:1;}}i:9;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:24:\"access_check.header.csrf\";i:1;s:6:\"access\";i:2;a:0:{}i:3;b:1;}}i:10;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:29:\"access_check.contact_personal\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:28:\"_access_contact_personal_tab\";}i:3;b:0;}}i:11;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:28:\"access_check.latest_revision\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:34:\"_content_moderation_latest_version\";}i:3;b:0;}}i:12;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:30:\"access_checker.entity_revision\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:23:\"_entity_access_revision\";}i:3;b:0;}}i:13;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:31:\"access_check.field_ui.view_mode\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:26:\"_field_ui_view_mode_access\";}i:3;b:0;}}i:14;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:31:\"access_check.field_ui.form_mode\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:26:\"_field_ui_form_mode_access\";}i:3;b:0;}}i:15;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:26:\"access_check.node.revision\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_access_node_revision\";}i:3;b:0;}}i:16;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:21:\"access_check.node.add\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:16:\"_node_add_access\";}i:3;b:0;}}i:17;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:25:\"access_check.node.preview\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:20:\"_node_preview_access\";}i:3;b:0;}}i:18;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:35:\"access_check.quickedit.entity_field\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:30:\"_access_quickedit_entity_field\";}i:3;b:0;}}i:19;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:17:\"access_check.cron\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:19:\"_access_system_cron\";}i:3;b:0;}}i:20;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:22:\"access_check.db_update\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_access_system_update\";}i:3;b:0;}}i:21;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:34:\"access_check.update.manager_access\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:22:\"_access_update_manager\";}i:3;b:0;}}i:22;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:23:\"access_check.permission\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:11:\"_permission\";}i:3;b:0;}}i:23;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:26:\"access_check.user.register\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:21:\"_access_user_register\";}i:3;b:0;}}i:24;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:22:\"access_check.user.role\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:5:\"_role\";}i:3;b:0;}}i:25;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:30:\"access_check.user.login_status\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:18:\"_user_is_logged_in\";}i:3;b:0;}}i:26;a:2:{i:0;s:15:\"addCheckService\";i:1;a:4:{i:0;s:35:\"workflows.access_check.delete_state\";i:1;s:6:\"access\";i:2;a:1:{i:0;s:29:\"_workflow_state_delete_access\";}i:3;b:0;}}}}s:6:\"shared\";b:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:6;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:44:\"drupal.proxy_original_service.router.builder\";}}\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";s:647:\"a:4:{s:5:\"class\";s:57:\"Drupal\\Core\\ParamConverter\\AdminPathConfigEntityConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"router.admin_context\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:63:\"drupal.proxy_original_service.paramconverter.configentity_admin\";}}\";s:53:\"drupal.proxy_original_service.bare_html_page_renderer\";s:521:\"a:4:{s:5:\"class\";s:39:\"Drupal\\Core\\Render\\BareHtmlPageRenderer\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:35:\"html_response.attachments_processor\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:2;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:53:\"drupal.proxy_original_service.bare_html_page_renderer\";}}\";s:43:\"drupal.proxy_original_service.batch.storage\";s:575:\"a:4:{s:5:\"class\";s:30:\"Drupal\\Core\\Batch\\BatchStorage\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"database\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:7:\"session\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:10:\"csrf_token\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:43:\"drupal.proxy_original_service.batch.storage\";}}\";s:52:\"drupal.proxy_original_service.file.mime_type.guesser\";s:710:\"a:5:{s:5:\"class\";s:41:\"Drupal\\Core\\File\\MimeType\\MimeTypeGuesser\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"stream_wrapper_manager\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:52:\"drupal.proxy_original_service.file.mime_type.guesser\";}s:5:\"calls\";a:1:{i:0;a:2:{i:0;s:10:\"addGuesser\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:2:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:62:\"drupal.proxy_original_service.file.mime_type.guesser.extension\";s:15:\"invalidBehavior\";i:1;}i:1;i:0;}s:7:\"resolve\";b:1;}}}}\";s:62:\"drupal.proxy_original_service.file.mime_type.guesser.extension\";s:421:\"a:4:{s:5:\"class\";s:50:\"Drupal\\Core\\File\\MimeType\\ExtensionMimeTypeGuesser\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:62:\"drupal.proxy_original_service.file.mime_type.guesser.extension\";}}\";s:64:\"drupal.proxy_original_service.dynamic_page_cache_response_policy\";s:2027:\"a:4:{s:5:\"class\";s:41:\"Drupal\\Core\\PageCache\\ChainResponsePolicy\";s:15:\"arguments_count\";i:0;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:64:\"drupal.proxy_original_service.dynamic_page_cache_response_policy\";}s:5:\"calls\";a:4:{i:0;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:22:\"page_cache_kill_switch\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}}i:1;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:26:\"page_cache_no_cache_routes\";s:5:\"value\";a:4:{s:5:\"class\";s:54:\"Drupal\\Core\\PageCache\\ResponsePolicy\\DenyNoCacheRoutes\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:1;}}s:7:\"resolve\";b:1;}}i:2;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:26:\"page_cache_no_server_error\";s:5:\"value\";a:3:{s:5:\"class\";s:50:\"Drupal\\Core\\PageCache\\ResponsePolicy\\NoServerError\";s:6:\"public\";b:0;s:15:\"arguments_count\";i:0;}s:6:\"shared\";b:1;}}s:7:\"resolve\";b:1;}}i:3;a:2:{i:0;s:9:\"addPolicy\";i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__HX5I7sfEFqcrtchl5GWkd90OTCfJaL7qil0Yyt1WSDA\";s:5:\"value\";a:4:{s:5:\"class\";s:66:\"Drupal\\dynamic_page_cache\\PageCache\\ResponsePolicy\\DenyAdminRoutes\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"current_route_match\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;}s:6:\"shared\";b:0;}}s:7:\"resolve\";b:1;}}}}\";s:55:\"drupal.proxy_original_service.field.uninstall_validator\";s:638:\"a:4:{s:5:\"class\";s:36:\"Drupal\\field\\FieldUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:19:\"entity_type.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:31:\"plugin.manager.field.field_type\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:55:\"drupal.proxy_original_service.field.uninstall_validator\";}}\";s:56:\"drupal.proxy_original_service.filter.uninstall_validator\";s:626:\"a:4:{s:5:\"class\";s:38:\"Drupal\\filter\\FilterUninstallValidator\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:3:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:21:\"plugin.manager.filter\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:18:\"string_translation\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:3;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:56:\"drupal.proxy_original_service.filter.uninstall_validator\";}}\";s:42:\"drupal.proxy_original_service.node_preview\";s:401:\"a:4:{s:5:\"class\";s:47:\"Drupal\\node\\ParamConverter\\NodePreviewConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:1:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:17:\"tempstore.private\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:1;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:42:\"drupal.proxy_original_service.node_preview\";}}\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";s:734:\"a:4:{s:5:\"class\";s:46:\"Drupal\\views_ui\\ParamConverter\\ViewUIConverter\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:4:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"entity.manager\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:16:\"tempstore.shared\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:20:\"router.admin_context\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:4;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}\";s:35:\"html_response.attachments_processor\";s:2199:\"a:3:{s:5:\"class\";s:59:\"\\Drupal\\big_pipe\\Render\\BigPipeResponseAttachmentsProcessor\";s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:8:{i:0;O:8:\"stdClass\":4:{s:4:\"type\";s:15:\"private_service\";s:2:\"id\";s:52:\"private__cAMAMpdtJowkmkc_59XqlWEJ9ae1bQcwRuMVqKCB9ZM\";s:5:\"value\";a:5:{s:5:\"class\";s:51:\"Drupal\\Core\\Render\\HtmlResponseAttachmentsProcessor\";s:6:\"public\";b:0;s:9:\"arguments\";O:8:\"stdClass\":3:{s:4:\"type\";s:10:\"collection\";s:5:\"value\";a:7:{i:0;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"asset.resolver\";s:15:\"invalidBehavior\";i:1;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"asset.css.collection_renderer\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"asset.js.collection_renderer\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:7;s:10:\"properties\";a:1:{s:10:\"_serviceId\";s:35:\"html_response.attachments_processor\";}}s:6:\"shared\";b:0;}i:1;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"asset.resolver\";s:15:\"invalidBehavior\";i:1;}i:2;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"config.factory\";s:15:\"invalidBehavior\";i:1;}i:3;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:29:\"asset.css.collection_renderer\";s:15:\"invalidBehavior\";i:1;}i:4;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:28:\"asset.js.collection_renderer\";s:15:\"invalidBehavior\";i:1;}i:5;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:13:\"request_stack\";s:15:\"invalidBehavior\";i:1;}i:6;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:8:\"renderer\";s:15:\"invalidBehavior\";i:1;}i:7;O:8:\"stdClass\":3:{s:4:\"type\";s:7:\"service\";s:2:\"id\";s:14:\"module_handler\";s:15:\"invalidBehavior\";i:1;}}s:7:\"resolve\";b:1;}s:15:\"arguments_count\";i:8;}\";}s:6:\"frozen\";b:1;s:14:\"machine_format\";b:1;}',-1,1540294708.948,1,'','0');
/*!40000 ALTER TABLE `cache_container` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_data`
--

DROP TABLE IF EXISTS `cache_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_data` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_data`
--

LOCK TABLES `cache_data` WRITE;
/*!40000 ALTER TABLE `cache_data` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_data` VALUES ('views:unpack_options:17a64f72240a208b18095eb1009e0af1efcb7b1a2392ac060f5c00b304e04f81:en',_binary 'a:33:{s:5:\"title\";s:8:\"Comments\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"administer comments\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:6:{s:17:\"comment_bulk_form\";s:17:\"comment_bulk_form\";s:7:\"subject\";s:7:\"subject\";s:3:\"uid\";s:3:\"uid\";s:9:\"entity_id\";s:9:\"entity_id\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:6:{s:17:\"comment_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"subject\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"uid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"entity_id\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:22:\"No comments available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:24:\"comment_unpublish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"sorts\";a:1:{s:7:\"changed\";a:13:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:4:\"date\";}}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294709.716,1,'config:views.view.comment','1'),('views:unpack_options:1aa00fc44e4e29c3f90130ec9643d281f2645644926916b7b079f4819b30dcb4:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:46:\"admin/reports/google-analytics-reports/summary\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:24:\"Google Analytics Summary\";s:11:\"description\";s:36:\"View a traffic report for your site.\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:5:\"admin\";s:6:\"parent\";s:20:\"system.admin_reports\";s:7:\"context\";s:1:\"0\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294711.475,1,'config:views.view.ga_summary','1'),('views:unpack_options:1e00ffece93cbf549f14c11bc83b28f9db0279a654d9a56957e64f31c0a37f33:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:0;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:60:\"Google Analytics details for \"{{ arguments.pagePath }}\" page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:45:\"admin/reports/google-analytics-reports/page/%\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294711.451,1,'config:views.view.ga_reports_page','1'),('views:unpack_options:1ee59650777997ea7b2f087995e0435217a6c0d73c05e1b0d65cb80b751ad62e:en',_binary 'a:33:{s:5:\"title\";s:29:\"Google Analytics Reports Page\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:31:\"access google analytics reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:24:\"This page was not viewed\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:33:\"<h2>This page was not viewed</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:7:{s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:15:\"uniquePageviews\";a:30:{s:2:\"id\";s:15:\"uniquePageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:15:\"uniquePageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:16:\"Unique Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:13:\"avgTimeOnPage\";a:25:{s:2:\"id\";s:13:\"avgTimeOnPage\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:13:\"avgTimeOnPage\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:17:\"Avg. Time on Page\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"i:s\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:9:\"entrances\";a:30:{s:2:\"id\";s:9:\"entrances\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"entrances\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Entrances\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:10:\"bounceRate\";a:30:{s:2:\"id\";s:10:\"bounceRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"bounceRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bounce Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:8:\"exitRate\";a:30:{s:2:\"id\";s:8:\"exitRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"exitRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Exit Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:9:\"pageValue\";a:30:{s:2:\"id\";s:9:\"pageValue\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageValue\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Page Value\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:1:\"$\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:39:\"Google Analytics details for front page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:17:\"display_extenders\";a:0:{}}',-1,1540294711.433,1,'config:views.view.ga_reports_page','1'),('views:unpack_options:202bb838db88da230753917b47bd97fc2a511a02f59be952025a9d44d3e5f776:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:30:\"The approved comments listing.\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:21:\"admin/content/comment\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:8:\"Comments\";s:11:\"description\";s:18:\"Comments published\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:5:\"admin\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:1:\"0\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294709.732,1,'config:views.view.comment','1'),('views:unpack_options:27a92d40782dac38f7bb1221769a6da275eb32074128a777586282ea1ec879fe:en',_binary 'a:33:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:6:\"page_1\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:1:{s:20:\"entity_taxonomy_term\";a:12:{s:2:\"id\";s:20:\"entity_taxonomy_term\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:20:\"entity_taxonomy_term\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:1;s:6:\"target\";s:23:\"{{ raw_arguments.tid }}\";s:9:\"view_mode\";s:4:\"full\";s:13:\"bypass_access\";b:0;s:9:\"plugin_id\";s:6:\"entity\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:10:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:8:\"standard\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:11:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:9:\"arguments\";a:1:{s:3:\"tid\";a:23:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:19:\"{{ arguments.tid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:4:{s:6:\"access\";b:1;s:9:\"operation\";s:4:\"view\";s:8:\"multiple\";i:0;s:7:\"bundles\";a:0:{}}s:12:\"break_phrase\";b:0;s:9:\"add_table\";b:0;s:13:\"require_value\";b:0;s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:18:\"taxonomy_index_tid\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:2:{s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}s:6:\"status\";a:14:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"boolean\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294711.527,1,'config:views.view.taxonomy_term','1'),('views:unpack_options:3a9e11c974893b97e8d14e05d767829ce7466d0381e4b9fb3f7ccda9c5d5e9c9:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:0;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:32:\"The unapproved comments listing.\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:22:\"comment_publish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author Name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:30:\"admin/content/comment/approval\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:19:\"Unapproved comments\";s:11:\"description\";s:19:\"Comments unapproved\";s:6:\"weight\";i:1;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:5:\"admin\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:1:\"0\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294709.741,1,'config:views.view.comment','1'),('views:unpack_options:4d067eefa1d9a988a4cac1d0adb6d5665727b536bf614c7d4f0305029b99a584:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:4:\"node\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294711.425,1,'config:views.view.frontpage','1'),('views:unpack_options:55233ad090193d6f31f0a84db0682699f402499a33e2b0c389eccf93ecd9c386:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:0;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:0;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:0;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:1;s:9:\"arguments\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:5:\"title\";s:10:\"File usage\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:12:\"entity_label\";s:12:\"entity_label\";s:4:\"type\";s:4:\"type\";s:6:\"module\";s:6:\"module\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:4:{s:12:\"entity_label\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:6:\"module\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:12:\"entity_label\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:6:\"fields\";a:4:{s:12:\"entity_label\";a:23:{s:2:\"id\";s:12:\"entity_label\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:12:\"entity_label\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Entity\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:14:\"link_to_entity\";b:1;s:9:\"plugin_id\";s:12:\"entity_label\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Entity type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:6:\"module\";a:22:{s:2:\"id\";s:6:\"module\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:6:\"module\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:18:\"Registering module\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Use count\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:1:{s:3:\"fid\";a:23:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:46:\"File usage information for {{ arguments.fid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:9:\"plugin_id\";s:8:\"file_fid\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:27:\"admin/content/files/usage/%\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294709.825,1,'config:views.view.files','1'),('views:unpack_options:56aed3a27a2d5eab84d8952559d748a39034fe2c2e07d34c72ce010e4b53ec04:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:19:\"admin/reports/dblog\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294711.618,1,'config:views.view.watchdog','2'),('views:unpack_options:57242dbd8cece6183c769aa12819fa0acd1d6d82943ebc13f6ce0d145332ec05:en',_binary 'a:33:{s:5:\"title\";s:7:\"Content\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:23:\"access content overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:50;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:14:\"node_bulk_form\";s:14:\"node_bulk_form\";s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:7:\"changed\";s:7:\"changed\";s:9:\"edit_node\";s:9:\"edit_node\";s:11:\"delete_node\";s:11:\"delete_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";s:9:\"timestamp\";s:5:\"title\";}s:4:\"info\";a:10:{s:14:\"node_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"delete_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:21:\"No content available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:6:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:7:{s:14:\"node_bulk_form\";a:14:{s:2:\"id\";s:14:\"node_bulk_form\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:14:\"node_bulk_form\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"node_bulk_form\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:17:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Content type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:17:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:17:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:9:\"Published\";s:19:\"format_custom_false\";s:11:\"Unpublished\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"changed\";a:17:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";}s:10:\"operations\";a:23:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:5:{s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Content type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"bundle\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:16:\"Published status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:9:\"Published\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:11:\"Unpublished\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}s:12:\"status_extra\";a:8:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:12:\"status_extra\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";b:0;s:9:\"plugin_id\";s:11:\"node_status\";s:5:\"group\";i:1;s:11:\"entity_type\";s:4:\"node\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294709.767,1,'config:views.view.content','1'),('views:unpack_options:6191cc011343662a427cf28516ef6fc7cb4587412e5eb618e3600f677e67c0f9:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:0;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:17:\"admin/people/list\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:4:\"List\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:6:\"weight\";i:-10;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:5:\"admin\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:6:\"People\";s:11:\"description\";s:45:\"Manage user accounts, roles, and permissions.\";s:6:\"weight\";i:0;s:9:\"menu_name\";s:5:\"admin\";}}',-1,1540294711.585,1,'config:views.view.user_admin_people','1'),('views:unpack_options:689eabc36a595c8f6505b480f8732e559535706e872e70d633a553d420ac150e:en',_binary 'a:33:{s:5:\"title\";s:19:\"Recent log messages\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:11:\"admin-dblog\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"access site reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:0;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:25:\"{{ type }} {{ severity }}\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:7:\"nothing\";s:7:\"nothing\";s:3:\"wid\";s:3:\"wid\";s:8:\"severity\";s:8:\"severity\";s:4:\"type\";s:4:\"type\";s:9:\"timestamp\";s:9:\"timestamp\";s:7:\"message\";s:7:\"message\";s:4:\"name\";s:4:\"name\";s:4:\"link\";s:4:\"link\";}s:4:\"info\";a:8:{s:7:\"nothing\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:3:\"wid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:8:\"severity\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"message\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:4:\"link\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}}s:7:\"default\";s:3:\"wid\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:26:\"No log messages available.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:26:\"No log messages available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"User\";s:8:\"required\";b:0;s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:8:{s:7:\"nothing\";a:22:{s:2:\"id\";s:7:\"nothing\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"nothing\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"Icon\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:4:\"icon\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:0;s:9:\"plugin_id\";s:6:\"custom\";}s:3:\"wid\";a:22:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"WID\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"severity\";a:23:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Severity\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"machine_name\";b:0;s:9:\"plugin_id\";s:12:\"machine_name\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"timestamp\";a:25:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:9:\"timestamp\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:7:\"message\";a:23:{s:2:\"id\";s:7:\"message\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:7:\"message\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Message\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/reports/dblog/event/{{ wid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:13:\"{{ message }}\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:56;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:1;s:4:\"trim\";b:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"replace_variables\";b:1;s:9:\"plugin_id\";s:13:\"dblog_message\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"User\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"link\";a:22:{s:2:\"id\";s:4:\"link\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:16:\"dblog_operations\";}}s:5:\"sorts\";a:1:{s:3:\"wid\";a:10:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:2:{s:4:\"type\";a:14:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"dblog_types\";}s:8:\"severity\";a:14:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"severity_op\";s:5:\"label\";s:8:\"Severity\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"severity_op\";s:10:\"identifier\";s:8:\"severity\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"in_operator\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294711.594,1,'config:views.view.watchdog','2'),('views:unpack_options:6b799525e75c3dbb2019f8586ba18e9410fdeec07bcd75dfbde2a480b548bf39:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:23:\"admin/content/moderated\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294711.518,1,'config:views.view.moderated_content','1'),('views:unpack_options:77465f8c3dd2fa3971c8834fe33e4255ce78286a758f52a57cada92e9162acc8:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:43:\"admin/reports/google-analytics-reports/page\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294711.442,1,'config:views.view.ga_reports_page','1'),('views:unpack_options:853e4455ee3fecedebba55ed5782e1e10badacf767c19cbfc93adc75c9d51d4e:en',_binary 'a:33:{s:5:\"title\";s:5:\"Files\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:21:\"access files overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:3:\"fid\";s:3:\"fid\";s:8:\"filename\";s:8:\"filename\";s:8:\"filemime\";s:8:\"filemime\";s:8:\"filesize\";s:8:\"filesize\";s:6:\"status\";s:6:\"status\";s:7:\"created\";s:7:\"created\";s:7:\"changed\";s:7:\"changed\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:8:{s:3:\"fid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filename\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filemime\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:8:\"filesize\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:19:\"No files available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:6:\"fields\";a:8:{s:3:\"fid\";a:24:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"Fid\";s:7:\"exclude\";b:1;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}s:8:\"filename\";a:36:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Name\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"file_link\";s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:25:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"MIME type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"file_filemime\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:8:\"filesize\";a:25:{s:2:\"id\";s:8:\"filesize\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filesize\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Size\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"file_size\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filesize\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:19:\"format_custom_false\";s:9:\"Temporary\";s:18:\"format_custom_true\";s:9:\"Permanent\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Upload date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"created\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Changed date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"changed\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:3:\"fid\";s:10:\"group_type\";s:3:\"sum\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Used in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/content/files/usage/{{ fid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:1;s:20:\"format_plural_string\";s:21:\"1 place@count places\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:3:{s:8:\"filename\";a:16:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:8:\"Filename\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filename_op\";s:10:\"identifier\";s:8:\"filename\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:16:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:9:\"MIME type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filemime_op\";s:10:\"identifier\";s:8:\"filemime\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:9:\"status_op\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"file_status\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294709.792,1,'config:views.view.files','1'),('views:unpack_options:8799510baf0a96aadfcd17954f3aa8853a0d4bc8967fd761bbdfae5d3abab47a:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:15:\"taxonomy/term/%\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294711.561,1,'config:views.view.taxonomy_term','1'),('views:unpack_options:89151702ac8376de6a724c7e218fab00e99b365cef00748722bfcd74d1ed1693:en',_binary 'a:33:{s:5:\"title\";s:17:\"Moderated content\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:28:\"view any unpublished content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:5:{s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:4:\"name\";s:4:\"name\";s:16:\"moderation_state\";s:16:\"moderation_state\";s:7:\"changed\";s:7:\"changed\";}s:4:\"info\";a:5:{s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:16:\"moderation_state\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:98:\"No moderated content available. Only pending versions of content, such as drafts, are listed here.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:2:{s:3:\"nid\";a:10:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:47:\"Get the actual content from a content revision.\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"nid\";s:9:\"plugin_id\";s:8:\"standard\";}s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"User\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:6:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:3:\"nid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Content type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:16:\"moderation_state\";a:36:{s:2:\"id\";s:16:\"moderation_state\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:16:\"Moderation state\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:24:\"content_moderation_state\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:6:{s:15:\"latest_revision\";a:15:{s:2:\"id\";s:15:\"latest_revision\";s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:15:\"latest_revision\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:15:\"latest_revision\";}s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:3:\"nid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Content type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:16:\"moderation_state\";a:15:{s:2:\"id\";s:16:\"moderation_state\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:2:{s:15:\"editorial-draft\";s:15:\"editorial-draft\";s:18:\"editorial-archived\";s:18:\"editorial-archived\";}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:19:\"moderation_state_op\";s:5:\"label\";s:16:\"Moderation state\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:19:\"moderation_state_op\";s:10:\"identifier\";s:16:\"moderation_state\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:23:\"moderation_state_filter\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}s:18:\"moderation_state_1\";a:15:{s:2:\"id\";s:18:\"moderation_state_1\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:1:{s:19:\"editorial-published\";s:19:\"editorial-published\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:23:\"moderation_state_filter\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294711.485,1,'config:views.view.moderated_content','1'),('views:unpack_options:8efee275e8680732a3c113a013d8fb1899bab7b55eb87dd75e133e1ac6922c59:en',_binary 'a:33:{s:5:\"title\";s:6:\"People\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:6:\"page_1\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:16:\"administer users\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:8:{s:14:\"user_bulk_form\";s:14:\"user_bulk_form\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:3:\"rid\";s:3:\"rid\";s:7:\"created\";s:7:\"created\";s:6:\"access\";s:6:\"access\";s:9:\"edit_node\";s:9:\"edit_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";}s:4:\"info\";a:8:{s:14:\"user_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:3:\"rid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"access\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"No people available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:8:{s:14:\"user_bulk_form\";a:23:{s:2:\"id\";s:14:\"user_bulk_form\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:14:\"user_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bulk update\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"user_bulk_form\";s:11:\"entity_type\";s:4:\"user\";}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Username\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:6:\"Active\";s:19:\"format_custom_false\";s:7:\"Blocked\";}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:15:\"roles_target_id\";a:24:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Roles\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:9:\"plugin_id\";s:10:\"user_roles\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Member for\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:9:\"@interval\";s:11:\"past_format\";s:9:\"@interval\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}s:6:\"access\";a:26:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Last access\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:15:\"@interval hence\";s:11:\"past_format\";s:13:\"@interval ago\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:4:\"user\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:4:\"mail\";a:37:{s:2:\"id\";s:4:\"mail\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"mail\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"basic_string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"mail\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:6:{s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:22:\"Name or email contains\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:4:\"user\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:4:\"mail\";s:4:\"mail\";}s:9:\"plugin_id\";s:7:\"combine\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:6:\"Active\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:7:\"Blocked\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:15:\"roles_target_id\";a:15:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:18:\"roles_target_id_op\";s:5:\"label\";s:4:\"Role\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:18:\"roles_target_id_op\";s:10:\"identifier\";s:4:\"role\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:10:\"user_roles\";}s:10:\"permission\";a:15:{s:2:\"id\";s:10:\"permission\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:10:\"permission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:13:\"permission_op\";s:5:\"label\";s:10:\"Permission\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:13:\"permission_op\";s:10:\"identifier\";s:10:\"permission\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:16:\"user_permissions\";}s:16:\"default_langcode\";a:16:{s:2:\"id\";s:16:\"default_langcode\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:16:\"default_langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:16:\"default_langcode\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"uid_raw\";a:15:{s:2:\"id\";s:7:\"uid_raw\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"uid_raw\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"!=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:1:\"0\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:1:\"0\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"numeric\";s:11:\"entity_type\";s:4:\"user\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294711.569,1,'config:views.view.user_admin_people','1'),('views:unpack_options:9db81ca6e59c503d500e8ee1ccf074a14f422ccec364cd42399e4eb87575446b:en',_binary 'a:33:{s:5:\"title\";s:20:\"Custom block library\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:17:\"administer blocks\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:4:\"info\";s:4:\"info\";s:4:\"type\";s:4:\"type\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:4:{s:4:\"info\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:2:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:37:\"There are no custom blocks available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}s:27:\"block_content_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:27:\"block_content_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:27:\"block_content_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:13:\"block_content\";s:9:\"plugin_id\";s:27:\"block_content_listing_empty\";s:11:\"entity_type\";s:13:\"block_content\";}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:4:{s:4:\"info\";a:37:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:17:\"Block description\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Block type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:7:\"changed\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:13:\"block_content\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:3:{s:4:\"info\";a:16:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:7:\"info_op\";s:5:\"label\";s:17:\"Block description\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"info_op\";s:10:\"identifier\";s:4:\"info\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:10:\"Block type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:8:\"reusable\";a:16:{s:2:\"id\";s:8:\"reusable\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:8:\"reusable\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:9:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:8:\"reusable\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294709.668,1,'config:views.view.block_content','2'),('views:unpack_options:a55f35fa9025684fbf23bf0c14bcf2d73c0ffa1cb719f32d7d745ef89c72108e:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:35:\"admin/structure/block/block-content\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:20:\"Custom block library\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:5:\"admin\";s:6:\"parent\";s:19:\"block.admin_display\";s:7:\"context\";s:1:\"0\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294709.673,1,'config:views.view.block_content','2'),('views:unpack_options:b6ebae5610532f0a49643501aaa0f8d96166e8020b9a378eb6be2b6449e9320f:en',_binary 'a:33:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:3:{s:16:\"area_text_custom\";a:11:{s:11:\"admin_label\";s:0:\"\";s:7:\"content\";s:181:\"No front page content has been created yet.<br/>Follow the <a target=\"_blank\" href=\"https://www.drupal.org/docs/user_guide/en/index.html\">User Guide</a> to start building your site.\";s:5:\"empty\";b:1;s:5:\"field\";s:16:\"area_text_custom\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:16:\"area_text_custom\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:5:\"views\";s:8:\"tokenize\";b:0;s:9:\"plugin_id\";s:11:\"text_custom\";}s:18:\"node_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:18:\"node_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:18:\"node_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:4:\"node\";s:9:\"plugin_id\";s:18:\"node_listing_empty\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:10:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"title\";s:22:\"Welcome to [site:name]\";s:9:\"plugin_id\";s:5:\"title\";}}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:12:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:7:\"exposed\";b:0;s:5:\"field\";s:6:\"sticky\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"sticky\";}s:7:\"created\";a:13:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";}}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:3:{s:7:\"promote\";a:16:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:10:{s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"operator\";s:0:\"\";s:11:\"operator_id\";s:0:\"\";s:8:\"remember\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:8:\"required\";b:0;s:12:\"use_operator\";b:0;}s:7:\"exposed\";b:0;s:5:\"field\";s:7:\"promote\";s:5:\"group\";i:1;s:10:\"group_info\";a:10:{s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"description\";s:0:\"\";s:11:\"group_items\";a:0:{}s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"optional\";b:1;s:8:\"remember\";b:0;s:6:\"widget\";s:6:\"select\";}s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:7:\"promote\";s:10:\"is_grouped\";b:0;s:8:\"operator\";s:1:\"=\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"promote\";}s:6:\"status\";a:9:{s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"field\";s:6:\"status\";s:5:\"group\";i:1;s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:17:\"display_extenders\";a:0:{}}',-1,1540294709.842,1,'config:views.view.frontpage','1'),('views:unpack_options:ce01936a5d2acb29a606d8c25108340697aebb720859da57835ea1f8d15ff69c:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:0;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:3:\"rss\";}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:7:\"rss.xml\";s:10:\"route_name\";s:0:\"\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:0:\"\";}s:14:\"sitename_title\";b:1;}',-1,1540294709.860,1,'config:views.view.frontpage','1'),('views:unpack_options:d00d1248261079be6e873497e2945374575626d7692feddb3892836175afcc10:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:0;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:0;}}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:19:\"admin/content/files\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:5:\"Files\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:5:\"admin\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:4:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;}}',-1,1540294709.816,1,'config:views.view.files','1'),('views:unpack_options:d49b065ef9bb8606585f41c8b38b9260e5533ffdce2d751624d51c0b6aec939d:en',_binary 'a:33:{s:5:\"title\";s:24:\"Google Analytics Summary\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:32:\"google-analytics-reports-summary\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:31:\"access google analytics reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:7:{s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Sessions\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:5:\"users\";a:30:{s:2:\"id\";s:5:\"users\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:5:\"users\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Users\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:19:\"pageviewsPerSession\";a:30:{s:2:\"id\";s:19:\"pageviewsPerSession\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:19:\"pageviewsPerSession\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:15:\"Pages / Session\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:18:\"avgSessionDuration\";a:25:{s:2:\"id\";s:18:\"avgSessionDuration\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:18:\"avgSessionDuration\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:21:\"Avg. Session Duration\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"i:s\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:10:\"bounceRate\";a:30:{s:2:\"id\";s:10:\"bounceRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"bounceRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bounce Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:18:\"percentNewSessions\";a:30:{s:2:\"id\";s:18:\"percentNewSessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:18:\"percentNewSessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:14:\"% New Sessions\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:17:\"display_extenders\";a:0:{}}',-1,1540294711.459,1,'config:views.view.ga_summary','1'),('views:unpack_options:f176df07d35eeead700e2f7f851e0f58f3f0204f7a03a3c335159beccd1c4177:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:0;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:7:\"default\";}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:20:\"taxonomy/term/%/feed\";s:10:\"route_name\";s:0:\"\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:1:\"0\";}s:14:\"sitename_title\";b:0;}',-1,1540294711.543,1,'config:views.view.taxonomy_term','1'),('views:unpack_options:f6021329de0228f1c1bc89692e1d90af49b3f1f7f18d6d12bccf8ecb143dfe85:en',_binary 'a:38:{s:8:\"defaults\";a:28:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"show_admin_links\";b:1;s:5:\"pager\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";b:1;s:8:\"group_by\";b:1;s:5:\"style\";b:1;s:3:\"row\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:18:\"rendering_language\";s:33:\"***LANGUAGE_entity_translation***\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:0:{}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:0:{}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:18:\"admin/content/node\";s:10:\"route_name\";s:0:\"\";s:4:\"menu\";a:9:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:-10;s:7:\"enabled\";b:1;s:9:\"menu_name\";s:5:\"admin\";s:6:\"parent\";s:0:\"\";s:7:\"context\";s:0:\"\";s:8:\"expanded\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:23:\"Find and manage content\";s:6:\"weight\";i:-10;s:9:\"menu_name\";s:5:\"admin\";}}',-1,1540294709.783,1,'config:views.view.content','1');
/*!40000 ALTER TABLE `cache_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_default`
--

DROP TABLE IF EXISTS `cache_default`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_default` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_default`
--

LOCK TABLES `cache_default` WRITE;
/*!40000 ALTER TABLE `cache_default` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_default` VALUES ('core.extension.list.profile',_binary 'a:12:{s:10:\"demo_umami\";C:31:\"Drupal\\Core\\Extension\\Extension\":1383:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:44:\"core/profiles/demo_umami/demo_umami.info.yml\";s:8:\"filename\";s:18:\"demo_umami.profile\";s:7:\"subpath\";s:19:\"profiles/demo_umami\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:11:{s:4:\"name\";s:40:\"Demo: Umami Food Magazine (Experimental)\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:71:\"Install an example site that shows off some of Drupal’s capabilities.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:7:\"install\";a:38:{i:0;s:4:\"node\";i:1;s:7:\"history\";i:2;s:8:\"big_pipe\";i:3;s:5:\"block\";i:4;s:10:\"breakpoint\";i:5;s:8:\"ckeditor\";i:6;s:5:\"color\";i:7;s:6:\"config\";i:8;s:10:\"contextual\";i:9;s:7:\"contact\";i:10;s:17:\"menu_link_content\";i:11;s:8:\"datetime\";i:12;s:13:\"block_content\";i:13;s:9:\"quickedit\";i:14;s:6:\"editor\";i:15;s:4:\"help\";i:16;s:5:\"image\";i:17;s:5:\"media\";i:18;s:7:\"menu_ui\";i:19;s:7:\"options\";i:20;s:4:\"path\";i:21;s:10:\"page_cache\";i:22;s:18:\"dynamic_page_cache\";i:23;s:8:\"taxonomy\";i:24;s:5:\"dblog\";i:25;s:6:\"search\";i:26;s:8:\"shortcut\";i:27;s:7:\"toolbar\";i:28;s:8:\"field_ui\";i:29;s:4:\"file\";i:30;s:3:\"rdf\";i:31;s:5:\"views\";i:32;s:8:\"views_ui\";i:33;s:4:\"tour\";i:34;s:14:\"automated_cron\";i:35;s:16:\"responsive_image\";i:36;s:18:\"content_moderation\";i:37;s:9:\"workflows\";}s:6:\"themes\";a:2:{i:0;s:5:\"seven\";i:1;s:5:\"umami\";}s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:7:\"minimal\";C:31:\"Drupal\\Core\\Extension\\Extension\":652:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:38:\"core/profiles/minimal/minimal.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:16:\"profiles/minimal\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:11:{s:4:\"name\";s:7:\"Minimal\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:86:\"Build a custom site without pre-configured functionality. Suitable for advanced users.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:7:\"install\";a:5:{i:0;s:4:\"node\";i:1;s:5:\"block\";i:2;s:5:\"dblog\";i:3;s:10:\"page_cache\";i:4;s:18:\"dynamic_page_cache\";}s:6:\"themes\";a:1:{i:0;s:5:\"stark\";}s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:8:\"standard\";C:31:\"Drupal\\Core\\Extension\\Extension\":1244:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:40:\"core/profiles/standard/standard.info.yml\";s:8:\"filename\";s:16:\"standard.profile\";s:7:\"subpath\";s:17:\"profiles/standard\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:11:{s:4:\"name\";s:8:\"Standard\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:7:\"install\";a:35:{i:0;s:4:\"node\";i:1;s:7:\"history\";i:2;s:5:\"block\";i:3;s:10:\"breakpoint\";i:4;s:8:\"ckeditor\";i:5;s:5:\"color\";i:6;s:6:\"config\";i:7;s:7:\"comment\";i:8;s:10:\"contextual\";i:9;s:7:\"contact\";i:10;s:17:\"menu_link_content\";i:11;s:8:\"datetime\";i:12;s:13:\"block_content\";i:13;s:9:\"quickedit\";i:14;s:6:\"editor\";i:15;s:4:\"help\";i:16;s:5:\"image\";i:17;s:7:\"menu_ui\";i:18;s:7:\"options\";i:19;s:4:\"path\";i:20;s:10:\"page_cache\";i:21;s:18:\"dynamic_page_cache\";i:22;s:8:\"big_pipe\";i:23;s:8:\"taxonomy\";i:24;s:5:\"dblog\";i:25;s:6:\"search\";i:26;s:8:\"shortcut\";i:27;s:7:\"toolbar\";i:28;s:8:\"field_ui\";i:29;s:4:\"file\";i:30;s:3:\"rdf\";i:31;s:5:\"views\";i:32;s:8:\"views_ui\";i:33;s:4:\"tour\";i:34;s:14:\"automated_cron\";}s:6:\"themes\";a:2:{i:0;s:6:\"bartik\";i:1;s:5:\"seven\";}s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:7:\"testing\";C:31:\"Drupal\\Core\\Extension\\Extension\":614:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:38:\"core/profiles/testing/testing.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:16:\"profiles/testing\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:12:{s:4:\"name\";s:7:\"Testing\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:77:\"Minimal profile for running tests. Includes absolutely required modules only.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:7:\"install\";a:2:{i:0;s:10:\"page_cache\";i:1;s:18:\"dynamic_page_cache\";}s:6:\"themes\";a:1:{i:0;s:6:\"classy\";}s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:21:\"testing_config_import\";C:31:\"Drupal\\Core\\Extension\\Extension\":604:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:66:\"core/profiles/testing_config_import/testing_config_import.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:30:\"profiles/testing_config_import\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:12:{s:4:\"name\";s:21:\"Testing config import\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:46:\"Tests install profiles in the config importer.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:7:\"install\";a:1:{i:0;s:6:\"syslog\";}s:6:\"themes\";a:1:{i:0;s:5:\"stark\";}s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:24:\"testing_config_overrides\";C:31:\"Drupal\\Core\\Extension\\Extension\":638:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:72:\"core/profiles/testing_config_overrides/testing_config_overrides.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:33:\"profiles/testing_config_overrides\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:11:{s:4:\"name\";s:24:\"Testing config overrides\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:69:\"Minimal profile for running tests with config overrides in a profile.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:7:\"install\";a:3:{i:0;s:6:\"action\";i:1;s:8:\"language\";i:2;s:4:\"tour\";}s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:40:\"testing_install_profile_all_dependencies\";C:31:\"Drupal\\Core\\Extension\\Extension\":712:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:104:\"core/profiles/testing_install_profile_all_dependencies/testing_install_profile_all_dependencies.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:49:\"profiles/testing_install_profile_all_dependencies\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:12:{s:4:\"name\";s:40:\"Testing install profile all dependencies\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:63:\"Profile for testing that install profiles can require a module.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:2:{i:0;s:3:\"ban\";i:1;s:5:\"dblog\";}s:7:\"install\";a:0:{}s:6:\"themes\";a:1:{i:0;s:6:\"classy\";}s:5:\"mtime\";i:1536580207;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:36:\"testing_install_profile_dependencies\";C:31:\"Drupal\\Core\\Extension\\Extension\":695:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:96:\"core/profiles/testing_install_profile_dependencies/testing_install_profile_dependencies.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:45:\"profiles/testing_install_profile_dependencies\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:12:{s:4:\"name\";s:36:\"Testing install profile dependencies\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:63:\"Profile for testing that install profiles can require a module.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:5:\"dblog\";}s:7:\"install\";a:1:{i:0;s:3:\"ban\";}s:6:\"themes\";a:1:{i:0;s:6:\"classy\";}s:5:\"mtime\";i:1536580207;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:39:\"testing_install_profile_dependencies_bc\";C:31:\"Drupal\\Core\\Extension\\Extension\":705:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:102:\"core/profiles/testing_install_profile_dependencies_bc/testing_install_profile_dependencies_bc.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:48:\"profiles/testing_install_profile_dependencies_bc\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:12:{s:4:\"name\";s:45:\"Testing install profile dependencies BC layer\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:54:\"Profile for testing BC layer for profile dependencies.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:0:{}s:6:\"themes\";a:1:{i:0;s:6:\"classy\";}s:7:\"install\";a:2:{i:0;s:5:\"dblog\";i:1;s:3:\"ban\";}s:5:\"mtime\";i:1536580207;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:28:\"testing_missing_dependencies\";C:31:\"Drupal\\Core\\Extension\\Extension\":688:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:80:\"core/profiles/testing_missing_dependencies/testing_missing_dependencies.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:37:\"profiles/testing_missing_dependencies\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:12:{s:4:\"name\";s:28:\"Testing missing dependencies\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:76:\"Minimal profile for running a test when dependencies are listed but missing.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:7:\"install\";a:2:{i:0;s:15:\"missing_module1\";i:1;s:15:\"missing_module2\";}s:12:\"keep_english\";b:1;s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:20:\"testing_multilingual\";C:31:\"Drupal\\Core\\Extension\\Extension\":598:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:64:\"core/profiles/testing_multilingual/testing_multilingual.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:29:\"profiles/testing_multilingual\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:11:{s:4:\"name\";s:20:\"Testing multilingual\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:64:\"Minimal profile for running tests with a multilingual installer.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:7:\"install\";a:2:{i:0;s:6:\"locale\";i:1;s:4:\"tour\";}s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}s:33:\"testing_multilingual_with_english\";C:31:\"Drupal\\Core\\Extension\\Extension\":659:{a:6:{s:4:\"type\";s:7:\"profile\";s:8:\"pathname\";s:90:\"core/profiles/testing_multilingual_with_english/testing_multilingual_with_english.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:42:\"profiles/testing_multilingual_with_english\";s:6:\"origin\";s:4:\"core\";s:4:\"info\";a:12:{s:4:\"name\";s:33:\"Testing multilingual with English\";s:4:\"type\";s:7:\"profile\";s:11:\"description\";s:64:\"Minimal profile for running tests with a multilingual installer.\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:7:\"install\";a:1:{i:0;s:6:\"locale\";}s:12:\"keep_english\";b:1;s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.5.9\";}}}}',-1,1540294708.670,1,'','0'),('views_data:block_content:en',_binary 'a:9:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:24:\"block_content_field_data\";a:3:{s:10:\"left_field\";s:2:\"id\";s:5:\"field\";s:2:\"id\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:13:\"block_content\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:18:\"view_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:18:\"edit_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:20:\"delete_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The custom block UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"The custom block language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:27:\"block_content_listing_empty\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Empty block library behavior\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Provides a link to add a new block.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:27:\"block_content_listing_empty\";}}}',-1,1540294711.275,1,'config:core.extension views_data','96'),('views_data:comment:en',_binary 'a:11:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:17:\"comment_bulk_form\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Comment operations bulk form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"Add a form element that lets you run operations on multiple comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:17:\"comment_bulk_form\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:18:\"comment_field_data\";a:3:{s:10:\"left_field\";s:3:\"cid\";s:5:\"field\";s:3:\"cid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:7:\"comment\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:12:\"view_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:12:\"edit_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:14:\"delete_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:15:\"approve_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Link to approve comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Provide a simple link to approve the comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:20:\"comment_link_approve\";}}s:15:\"replyto_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Link to reply-to comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a simple link to reply to the comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"comment_link_reply\";}}}',-1,1540294711.279,1,'config:core.extension views_data','96'),('views_data:content_moderation_state:en',_binary 'a:4:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:18:\"content_moderation\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:35:\"content_moderation_state_field_data\";a:3:{s:10:\"left_field\";s:2:\"id\";s:5:\"field\";s:2:\"id\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:24:\"content_moderation_state\";}s:4:\"uuid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}}',-1,1540294711.288,1,'config:core.extension views_data','96'),('views_data:en',_binary 'a:80:{s:24:\"block_content_field_data\";a:12:{s:16:\"moderation_state\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:6:{s:2:\"id\";s:8:\"standard\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"@label moderation state\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:35:\"content_moderation_state_field_data\";s:10:\"base field\";s:17:\"content_entity_id\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:22:\"content_entity_type_id\";s:5:\"value\";s:13:\"block_content\";}}}s:5:\"field\";a:3:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:24:\"content_moderation_state\";s:10:\"field_name\";s:16:\"moderation_state\";}s:6:\"filter\";a:2:{s:2:\"id\";s:23:\"moderation_state_filter\";s:11:\"allow empty\";b:1;}}s:5:\"table\";a:6:{s:4:\"base\";a:4:{s:5:\"field\";s:2:\"id\";s:5:\"title\";r:13;s:14:\"cache_contexts\";a:0:{}s:8:\"defaults\";a:2:{s:5:\"field\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";}}s:5:\"group\";r:13;s:8:\"provider\";s:13:\"block_content\";s:15:\"entity revision\";b:0;s:11:\"entity type\";s:13:\"block_content\";s:9:\"wizard_id\";s:13:\"block_content\";}s:2:\"id\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Custom block ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The custom block ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:2:\"id\";}s:11:\"revision_id\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"The revision ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:11:\"revision_id\";}s:4:\"type\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The block type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"bundle\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"type\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"The custom block language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:6:\"status\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:4:\"info\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Block description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"A brief description of your block.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:22:\"link_to_entity default\";b:1;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"info\";}s:7:\"changed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the custom block was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:8:\"reusable\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Reusable\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"A boolean indicating whether this block is reusable.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"reusable\";}s:16:\"default_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:29:\"revision_translation_affected\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:29:\"revision_translation_affected\";}}s:28:\"block_content_field_revision\";a:13:{s:16:\"moderation_state\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:6:{s:2:\"id\";s:8:\"standard\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"@label moderation state\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:39:\"content_moderation_state_field_revision\";s:10:\"base field\";s:26:\"content_entity_revision_id\";s:18:\"relationship field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:22:\"content_entity_type_id\";s:5:\"value\";s:13:\"block_content\";}}}s:5:\"field\";a:3:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:24:\"content_moderation_state\";s:10:\"field_name\";s:16:\"moderation_state\";}s:6:\"filter\";a:2:{s:2:\"id\";s:23:\"moderation_state_filter\";s:11:\"allow empty\";b:1;}}s:5:\"table\";a:6:{s:15:\"entity revision\";b:1;s:4:\"base\";a:4:{s:5:\"field\";s:11:\"revision_id\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@entity_type revisions\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:64:\"Block Content revision is a history of changes to block content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"defaults\";a:1:{s:5:\"title\";s:4:\"info\";}}s:4:\"join\";a:1:{s:24:\"block_content_field_data\";a:3:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:4:\"type\";s:5:\"INNER\";}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"@entity_type revision\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:11:\"entity type\";s:13:\"block_content\";s:8:\"provider\";s:5:\"views\";}s:18:\"view_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:18:\"edit_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:20:\"delete_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:2:\"id\";a:8:{s:5:\"title\";r:46;s:4:\"help\";r:50;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:2:\"id\";s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"block_content_field_data\";s:10:\"base field\";s:2:\"id\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Block Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"Get the actual block content from a block content revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"revision_id\";a:8:{s:5:\"title\";r:64;s:4:\"help\";r:68;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:11:\"revision_id\";s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"block_content_field_data\";s:10:\"base field\";s:11:\"revision_id\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Block Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"Get the actual block content from a block content revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";r:104;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:6:\"status\";a:6:{s:5:\"title\";r:118;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:4:\"info\";a:7:{s:5:\"title\";r:132;s:4:\"help\";r:136;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"info\";}s:7:\"changed\";a:7:{s:5:\"title\";r:151;s:4:\"help\";r:155;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:16:\"default_langcode\";a:7:{s:5:\"title\";r:187;s:4:\"help\";r:191;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:29:\"revision_translation_affected\";a:7:{s:5:\"title\";r:205;s:4:\"help\";r:209;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:29:\"revision_translation_affected\";}}s:15:\"node_field_data\";a:38:{s:16:\"moderation_state\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:6:{s:2:\"id\";s:8:\"standard\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"@label moderation state\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:35:\"content_moderation_state_field_data\";s:10:\"base field\";s:17:\"content_entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:22:\"content_entity_type_id\";s:5:\"value\";s:4:\"node\";}}}s:5:\"field\";a:3:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:24:\"content_moderation_state\";s:10:\"field_name\";s:16:\"moderation_state\";}s:6:\"filter\";a:2:{s:2:\"id\";s:23:\"moderation_state_filter\";s:11:\"allow empty\";b:1;}}s:45:\"reverse__user__field_migrate_example_favbeers\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"@entity using @field_name\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"content\";s:11:\"@field_name\";s:30:\"field_migrate_example_favbeers\";s:7:\"@entity\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:30:\"field_migrate_example_favbeers\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Relate each @entity with a @field_name set to the @label.\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"content\";s:11:\"@field_name\";s:30:\"field_migrate_example_favbeers\";s:7:\"@entity\";r:474;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:16:\"users_field_data\";s:11:\"entity_type\";s:4:\"user\";s:10:\"base field\";s:3:\"uid\";s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"field table\";s:36:\"user__field_migrate_example_favbeers\";s:11:\"field field\";s:40:\"field_migrate_example_favbeers_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:5:\"table\";a:6:{s:4:\"base\";a:6:{s:5:\"field\";s:3:\"nid\";s:5:\"title\";r:448;s:14:\"cache_contexts\";a:1:{i:0;s:21:\"user.node_grants:view\";}s:8:\"defaults\";a:2:{s:5:\"field\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";}s:6:\"weight\";i:-10;s:16:\"access query tag\";s:11:\"node_access\";}s:5:\"group\";r:448;s:8:\"provider\";s:4:\"node\";s:15:\"entity revision\";b:0;s:11:\"entity type\";s:4:\"node\";s:9:\"wizard_id\";s:4:\"node\";}s:3:\"nid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:4:{s:2:\"id\";s:8:\"node_nid\";s:10:\"name field\";s:5:\"title\";s:7:\"numeric\";b:1;s:13:\"validate type\";s:3:\"nid\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"nid\";}s:3:\"vid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"vid\";}s:4:\"type\";a:6:{s:5:\"title\";s:12:\"Content type\";s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:9:\"node_type\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"bundle\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"type\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"The language of the content or translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"status\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:4:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Published status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";s:9:\"use_equal\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:5:\"title\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:5:\"field\";s:26:\"default_formatter_settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:20:\"link_to_node default\";b:1;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:5:\"title\";}s:3:\"uid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:105:\"The user authoring the content. If you need more fields than the uid add the content: author relationship\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"user_name\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:6:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Content author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"Relate content to the user who created it.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:12:\"entity field\";s:3:\"uid\";}s:7:\"created\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored on\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the node was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"created\";}s:7:\"changed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the node was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:7:\"promote\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Promoted to front page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:3:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Promoted to front page status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:7:\"promote\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"A boolean indicating whether the node is visible on the front page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"sticky\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Sticky at top of lists\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:3:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Sticky status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:2:{s:2:\"id\";s:8:\"standard\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:91:\"Whether or not the content is sticky. To list sticky content first, set this to descending.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:12:\"entity field\";s:6:\"sticky\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"A boolean indicating whether the node should sort to the top of content lists.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:16:\"default_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:29:\"revision_translation_affected\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:29:\"revision_translation_affected\";}s:12:\"status_extra\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Published status or admin user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"Filters out unpublished content if the current user cannot view it.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:3:{s:5:\"field\";s:6:\"status\";s:2:\"id\";s:11:\"node_status\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Published status or admin user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"created_fulldate\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date in the form of CCYYMMDD.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:13:\"date_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Created year + month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Date in the form of YYYYMM.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:15:\"date_year_month\";}}s:12:\"created_year\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Date in the form of YYYY.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:9:\"date_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Created month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of MM (01 - 12).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:10:\"date_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Created day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of DD (01 - 31).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:8:\"date_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of WW (01 - 53).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:9:\"date_week\";}}s:16:\"changed_fulldate\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date in the form of CCYYMMDD.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:13:\"date_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Updated year + month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Date in the form of YYYYMM.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:15:\"date_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Date in the form of YYYY.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Updated month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of MM (01 - 12).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:10:\"date_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Updated day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of DD (01 - 31).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:8:\"date_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of WW (01 - 53).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_week\";}}s:12:\"uid_revision\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"User has a revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"All nodes where a certain user has a revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:3:\"nid\";s:6:\"filter\";a:1:{s:2:\"id\";s:17:\"node_uid_revision\";}s:8:\"argument\";a:1:{s:2:\"id\";s:17:\"node_uid_revision\";}}s:13:\"comments_link\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Add comment link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:140:\"Display the standard add comment link used on regular @entity_type, which will only display if the viewing user has access to add a comment.\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";s:4:\"node\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:19:\"comment_entity_link\";}}s:9:\"uid_touch\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"User posted or commented\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"Display nodes only if a user posted the @entity_type or commented on the @entity_type.\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";s:4:\"node\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:16:\"users_field_data\";s:10:\"name field\";s:4:\"name\";s:2:\"id\";s:25:\"argument_comment_user_uid\";s:11:\"no group by\";b:1;s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:3:\"nid\";}s:6:\"filter\";a:6:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:16:\"users_field_data\";s:10:\"name field\";s:4:\"name\";s:2:\"id\";s:16:\"comment_user_uid\";s:11:\"entity_type\";s:4:\"node\";s:9:\"entity_id\";s:3:\"nid\";}}s:11:\"comment_cid\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Comments of the @entity_type using field: @field_name\";s:12:\"\0*\0arguments\";a:2:{s:12:\"@entity_type\";s:4:\"node\";s:11:\"@field_name\";s:7:\"comment\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:159:\"Relate all comments on the @entity_type. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";s:4:\"node\";}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:18:\"comment_field_data\";s:10:\"base field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:2:\"id\";s:8:\"standard\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:2:{s:5:\"field\";s:10:\"field_name\";s:5:\"value\";s:7:\"comment\";}}}}s:18:\"field_comments_cid\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Comments of the @entity_type using field: @field_name\";s:12:\"\0*\0arguments\";a:2:{s:12:\"@entity_type\";s:4:\"node\";s:11:\"@field_name\";s:14:\"field_comments\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:159:\"Relate all comments on the @entity_type. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";s:4:\"node\";}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:18:\"comment_field_data\";s:10:\"base field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:2:\"id\";s:8:\"standard\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:2:{s:5:\"field\";s:10:\"field_name\";s:5:\"value\";s:14:\"field_comments\";}}}}s:34:\"field_migrate_example_comments_cid\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Comments of the @entity_type using field: @field_name\";s:12:\"\0*\0arguments\";a:2:{s:12:\"@entity_type\";s:4:\"node\";s:11:\"@field_name\";s:30:\"field_migrate_example_comments\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:159:\"Relate all comments on the @entity_type. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";s:4:\"node\";}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:18:\"comment_field_data\";s:10:\"base field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:2:\"id\";s:8:\"standard\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:2:{s:5:\"field\";s:10:\"field_name\";s:5:\"value\";s:30:\"field_migrate_example_comments\";}}}}s:13:\"term_node_tid\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Taxonomy terms on node\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:160:\"Relate nodes to taxonomy terms, specifying which vocabulary or vocabularies to use. This relationship will cause duplicated records if there are multiple terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:3:{s:2:\"id\";s:14:\"node_term_data\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:24:\"taxonomy_term_field_data\";}s:5:\"field\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"All taxonomy terms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"Display all taxonomy terms associated with a node from specified vocabularies.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"taxonomy_index_tid\";s:11:\"no group by\";b:1;s:14:\"click sortable\";b:0;}}s:19:\"term_node_tid_depth\";a:4:{s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:175:\"Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:3:\"nid\";s:8:\"argument\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Has taxonomy term ID (with depth)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:24:\"taxonomy_index_tid_depth\";s:21:\"accept depth modifier\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Has taxonomy terms (with depth)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:24:\"taxonomy_index_tid_depth\";}}s:28:\"term_node_tid_depth_modifier\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Has taxonomy term ID depth modifier\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:111:\"Allows the \"depth\" for Taxonomy: Term ID (with depth) to be modified via an additional contextual filter value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:1:{s:2:\"id\";s:33:\"taxonomy_index_tid_depth_modifier\";}}}s:19:\"node_field_revision\";a:20:{s:16:\"moderation_state\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:6:{s:2:\"id\";s:8:\"standard\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"@label moderation state\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:39:\"content_moderation_state_field_revision\";s:10:\"base field\";s:26:\"content_entity_revision_id\";s:18:\"relationship field\";s:3:\"vid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:22:\"content_entity_type_id\";s:5:\"value\";s:4:\"node\";}}}s:5:\"field\";a:3:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:24:\"content_moderation_state\";s:10:\"field_name\";s:16:\"moderation_state\";}s:6:\"filter\";a:2:{s:2:\"id\";s:23:\"moderation_state_filter\";s:11:\"allow empty\";b:1;}}s:5:\"table\";a:7:{s:15:\"entity revision\";b:1;s:4:\"base\";a:4:{s:5:\"field\";s:3:\"vid\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@entity_type revisions\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"Content revision is a history of changes to content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"defaults\";a:1:{s:5:\"title\";s:5:\"title\";}}s:4:\"join\";a:1:{s:15:\"node_field_data\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";s:4:\"type\";s:5:\"INNER\";}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"@entity_type revision\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:11:\"entity type\";s:4:\"node\";s:9:\"wizard_id\";s:19:\"node_field_revision\";s:8:\"provider\";s:5:\"views\";}s:9:\"view_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:9:\"edit_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:11:\"delete_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:3:\"nid\";a:7:{s:5:\"title\";r:521;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:2:{s:2:\"id\";s:8:\"node_nid\";s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"nid\";s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:15:\"node_field_data\";s:10:\"base field\";s:3:\"nid\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Get the actual content from a content revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:3:\"vid\";a:7:{s:8:\"argument\";a:2:{s:2:\"id\";s:8:\"node_vid\";s:7:\"numeric\";b:1;}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:15:\"node_field_data\";s:10:\"base field\";s:3:\"vid\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Get the actual content from a content revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:5:\"title\";r:538;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"vid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"The language of the content or translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"status\";a:6:{s:5:\"title\";r:581;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:4:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";s:9:\"use_equal\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:5:\"title\";a:6:{s:5:\"title\";r:601;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:5:\"title\";}s:3:\"uid\";a:8:{s:5:\"title\";r:618;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The username of the content author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";r:474;s:5:\"title\";r:474;s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uid\";}s:7:\"created\";a:7:{s:5:\"title\";r:652;s:4:\"help\";r:656;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"created\";}s:7:\"changed\";a:7:{s:5:\"title\";r:670;s:4:\"help\";r:674;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:7:\"promote\";a:7:{s:5:\"title\";r:688;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:7:\"promote\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"A boolean indicating whether the node is visible on the front page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"sticky\";a:7:{s:5:\"title\";r:711;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"sticky\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"A boolean indicating whether the node should sort to the top of content lists.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:16:\"default_langcode\";a:7:{s:5:\"title\";r:738;s:4:\"help\";r:742;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:29:\"revision_translation_affected\";a:7:{s:5:\"title\";r:756;s:4:\"help\";r:760;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:29:\"revision_translation_affected\";}s:16:\"link_to_revision\";a:1:{s:5:\"field\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Link to revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Provide a simple link to the revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"node_revision_link\";s:14:\"click sortable\";b:0;}}s:15:\"revert_revision\";a:1:{s:5:\"field\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Link to revert revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a simple link to revert to the revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:25:\"node_revision_link_revert\";s:14:\"click sortable\";b:0;}}s:15:\"delete_revision\";a:1:{s:5:\"field\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Link to delete revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Provide a simple link to delete the content revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:25:\"node_revision_link_delete\";s:14:\"click sortable\";b:0;}}}s:8:\"watchdog\";a:12:{s:5:\"table\";a:4:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Watchdog\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"wizard_id\";s:8:\"watchdog\";s:4:\"base\";a:3:{s:5:\"field\";s:3:\"wid\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Log entries\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Contains a list of log entries.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:8:\"provider\";s:5:\"dblog\";}s:3:\"wid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"WID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Unique watchdog event ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:3:\"uid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"UID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The user ID of the user on which the log entry was written.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:12:\"relationship\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"The user on which the log entry as written.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:2:\"id\";s:8:\"standard\";}}s:4:\"type\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"The type of the log entry, for example \"user\" or \"page not found\".\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:11:\"dblog_types\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:7:\"message\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"The actual message of the log entry.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:13:\"dblog_message\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:9:\"variables\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Variables\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The variables of the log entry in a serialized format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:10:\"serialized\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:8:\"severity\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Severity level\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"The severity level of the event; ranges from 0 (Emergency) to 7 (Debug).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:12:\"machine_name\";s:16:\"options callback\";s:60:\"Drupal\\dblog\\Controller\\DbLogController::getLogLevelClassMap\";}s:6:\"filter\";a:2:{s:2:\"id\";s:11:\"in_operator\";s:16:\"options callback\";s:41:\"Drupal\\Core\\Logger\\RfcLogLevel::getLevels\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:4:\"link\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Operations\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Operation links for the event.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:16:\"dblog_operations\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:8:\"location\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Location\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"URL of the origin of the event.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:7:\"referer\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Referer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"URL of the previous page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:8:\"hostname\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Hostname\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Hostname of the user who triggered the event.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:9:\"timestamp\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date when the event occurred.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:4:\"date\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}}}s:13:\"block_content\";a:9:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:5:{s:5:\"group\";r:13;s:8:\"provider\";s:13:\"block_content\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:24:\"block_content_field_data\";a:3:{s:10:\"left_field\";s:2:\"id\";s:5:\"field\";s:2:\"id\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:13:\"block_content\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:18:\"view_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:18:\"edit_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:20:\"delete_block_content\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The custom block UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";r:104;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:27:\"block_content_listing_empty\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Empty block library behavior\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Provides a link to add a new block.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:27:\"block_content_listing_empty\";}}}s:7:\"comment\";a:11:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:17:\"comment_bulk_form\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Comment operations bulk form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"Add a form element that lets you run operations on multiple comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:17:\"comment_bulk_form\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:18:\"comment_field_data\";a:3:{s:10:\"left_field\";s:3:\"cid\";s:5:\"field\";s:3:\"cid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:7:\"comment\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:12:\"view_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:12:\"edit_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:14:\"delete_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:15:\"approve_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Link to approve comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Provide a simple link to approve the comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:20:\"comment_link_approve\";}}s:15:\"replyto_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Link to reply-to comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a simple link to reply to the comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"comment_link_reply\";}}}s:15:\"contact_message\";a:1:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}}s:24:\"content_moderation_state\";a:4:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:18:\"content_moderation\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:35:\"content_moderation_state_field_data\";a:3:{s:10:\"left_field\";s:2:\"id\";s:5:\"field\";s:2:\"id\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:24:\"content_moderation_state\";}s:4:\"uuid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}}s:12:\"file_managed\";a:18:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:6:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:4:\"base\";a:5:{s:5:\"field\";s:3:\"fid\";s:5:\"title\";r:2018;s:14:\"cache_contexts\";a:0:{}s:8:\"defaults\";a:1:{s:5:\"field\";s:8:\"filename\";}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Files maintained by Drupal and various modules.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:15:\"entity revision\";b:0;s:11:\"entity type\";s:4:\"file\";s:9:\"wizard_id\";s:12:\"file_managed\";}s:3:\"fid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"File ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The file ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:3:{s:2:\"id\";s:8:\"file_fid\";s:10:\"name field\";s:8:\"filename\";s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"fid\";s:12:\"relationship\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"File usage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Relate file entities to their usage.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:10:\"file_usage\";s:10:\"base field\";s:3:\"fid\";s:5:\"field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"File usage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The file UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The file language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:3:\"uid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The user ID of the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"User who uploaded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"User who uploaded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uid\";}s:8:\"filename\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Filename\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Name of the file with no path components.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"filename\";}s:3:\"uri\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The URI to access the file (either local or remote).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:8:\"file_uri\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uri\";}s:8:\"filemime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"File MIME type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The file\'s MIME type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:13:\"file_filemime\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"filemime\";}s:8:\"filesize\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"File size\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The size of the file in bytes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:9:\"file_size\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"filesize\";}s:6:\"status\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The status of the file, temporary (FALSE) and permanent (TRUE).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:26:\"default_formatter_settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Temporary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Permanent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:11:\"file_status\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:7:\"created\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The timestamp that the file was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"created\";}s:7:\"changed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The timestamp that the file was last changed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:9:\"extension\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Extension\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The extension of the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:8:\"filename\";s:5:\"field\";a:5:{s:11:\"entity_type\";s:4:\"file\";s:10:\"field_name\";s:8:\"filename\";s:17:\"default_formatter\";s:14:\"file_extension\";s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}}s:24:\"reverse_field_image_node\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:448;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:11:\"field_image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:448;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"field table\";s:17:\"node__field_image\";s:11:\"field field\";s:21:\"field_image_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:44:\"reverse_field_migrate_example_adv_image_node\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:448;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:31:\"field_migrate_example_adv_image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:448;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"field table\";s:37:\"node__field_migrate_example_adv_image\";s:11:\"field field\";s:41:\"field_migrate_example_adv_image_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:40:\"reverse_field_migrate_example_image_node\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:448;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:27:\"field_migrate_example_image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:448;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"field table\";s:33:\"node__field_migrate_example_image\";s:11:\"field field\";s:37:\"field_migrate_example_image_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:25:\"reverse_user_picture_user\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:474;s:6:\"@field\";s:7:\"Picture\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:12:\"user_picture\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:474;s:6:\"@field\";s:7:\"Picture\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:474;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:16:\"users_field_data\";s:11:\"entity_type\";s:4:\"user\";s:10:\"base field\";s:3:\"uid\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"field table\";s:18:\"user__user_picture\";s:11:\"field field\";s:22:\"user_picture_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:4:\"node\";a:11:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:14:\"node_bulk_form\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Node operations bulk form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Add a form element that lets you run operations on multiple nodes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:14:\"node_bulk_form\";}}s:5:\"table\";a:5:{s:5:\"group\";r:448;s:8:\"provider\";s:4:\"node\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:15:\"node_field_data\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:4:\"node\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:9:\"view_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:9:\"edit_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:11:\"delete_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:18:\"node_listing_empty\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Empty Node Frontpage behavior\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provides a link to the node add overview page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:18:\"node_listing_empty\";}}s:12:\"new_comments\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"New comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The number of new comments on the node.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:17:\"node_new_comments\";s:11:\"no group by\";b:1;}}}s:8:\"shortcut\";a:1:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}}s:18:\"taxonomy_term_data\";a:8:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:24:\"taxonomy_term_field_data\";a:3:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:13:\"taxonomy_term\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:18:\"view_taxonomy_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:18:\"edit_taxonomy_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:20:\"delete_taxonomy_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The term language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}}s:5:\"users\";a:11:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:14:\"user_bulk_form\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Bulk update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Add a form element that lets you run operations on multiple users.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:14:\"user_bulk_form\";}}s:5:\"table\";a:5:{s:5:\"group\";r:474;s:8:\"provider\";s:4:\"user\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:16:\"users_field_data\";a:3:{s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:4:\"user\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:9:\"view_user\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:474;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:474;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:9:\"edit_user\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:474;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:474;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The user UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The user language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:11:\"uid_current\";a:4:{s:10:\"real field\";s:3:\"uid\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Current\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Filter the view to the currently logged in user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:2:{s:2:\"id\";s:12:\"user_current\";s:4:\"type\";s:6:\"yes-no\";}}s:4:\"data\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Data\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Provides access to the user data service.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:3:\"uid\";s:5:\"field\";a:1:{s:2:\"id\";s:9:\"user_data\";}}s:7:\"contact\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide a simple link to the user contact page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:12:\"contact_link\";}}}s:17:\"menu_link_content\";a:1:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}}s:2:\"ga\";a:513:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Google Analytics\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Google Analytics\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"query_id\";s:8:\"ga_query\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Views Google Analytics query builder\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:8:\"provider\";s:10:\"ga_reports\";}s:10:\"start_date\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Start date of report\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Start date of report\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"ga_date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}}s:8:\"end_date\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"End date of report\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"End date of report\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"ga_date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}}s:10:\"profile_id\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Profile ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Profile ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"14dayUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"14 Day Active Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:367:\"Total number of 14-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 14-day period ending on the given date.<br />Type: metric.<br />API name: <code>ga:14dayUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"1dayUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"1 Day Active Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:364:\"Total number of 1-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 1-day period ending on the given date.<br />Type: metric.<br />API name: <code>ga:1dayUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"28dayUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"28 Day Active Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:367:\"Total number of 28-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 28-day period ending on the given date.<br />Type: metric.<br />API name: <code>ga:28dayUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"30dayUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"30 Day Active Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:367:\"Total number of 30-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 30-day period ending on the given date.<br />Type: metric.<br />API name: <code>ga:30dayUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"7dayUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"7 Day Active Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:364:\"Total number of 7-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 7-day period ending on the given date.<br />Type: metric.<br />API name: <code>ga:7dayUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"acquisitionCampaign\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Acquisition Campaign\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:156:\"The campaign through which users were acquired, derived from users\' first session.<br />Type: dimension.<br />API name: <code>ga:acquisitionCampaign</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"acquisitionMedium\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Acquisition Medium\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:152:\"The medium through which users were acquired, derived from users\' first session.<br />Type: dimension.<br />API name: <code>ga:acquisitionMedium</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"acquisitionSource\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Acquisition Source\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:152:\"The source through which users were acquired, derived from users\' first session.<br />Type: dimension.<br />API name: <code>ga:acquisitionSource</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"acquisitionSourceMedium\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Acquisition Source / Medium\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:150:\"The combined value of ga:userAcquisitionSource and ga:acquisitionMedium.<br />Type: dimension.<br />API name: <code>ga:acquisitionSourceMedium</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:25:\"acquisitionTrafficChannel\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Acquisition Channel\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:307:\"Traffic channel through which users were acquired. It is extracted from users\' first session. Traffic channel is computed based on the default channel grouping rules (at view level if available) at the time of user acquisition.<br />Type: dimension.<br />API name: <code>ga:acquisitionTrafficChannel</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"adClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:132:\"Total number of times users have clicked on an ad to reach the property.<br />Type: metric.<br />API name: <code>ga:adClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"adContent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Ad Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:412:\"For manual campaign tracking, it is the value of the utm_content campaign tracking parameter. For AdWords autotagging, it is the first line of the text for the online Ad campaign. If you use mad libs for the AdWords content, it contains the keywords you provided for the mad libs keyword match. If you use none of the above, its value is (not set).<br />Type: dimension.<br />API name: <code>ga:adContent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:6:\"adCost\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Cost\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:156:\"Derived cost for the advertising campaign. Its currency is the one you set in the AdWords account.<br />Type: metric.<br />API name: <code>ga:adCost</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:16:\"adDestinationUrl\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Destination URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:121:\"The URL to which the AdWords ads referred traffic.<br />Type: dimension.<br />API name: <code>ga:adDestinationUrl</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"adDisplayUrl\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Display URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:101:\"The URL the AdWords ads displayed.<br />Type: dimension.<br />API name: <code>ga:adDisplayUrl</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"adDistributionNetwork\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Ad Distribution Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:153:\"The network (Content, Search, Search partners, etc.) used to deliver the ads.<br />Type: dimension.<br />API name: <code>ga:adDistributionNetwork</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"adFormat\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ad Format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:119:\"The AdWords ad format (Text, Image, Flash, Video, etc.).<br />Type: dimension.<br />API name: <code>ga:adFormat</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"adGroup\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Google Ads: Ad Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:95:\"The name of the AdWords ad group.<br />Type: dimension.<br />API name: <code>ga:adGroup</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"adKeywordMatchType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Keyword Match Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:206:\"The match type (Phrase, Exact, or Broad) applied to the keywords. For details, see https://support.google.com/adwords/answer/2472708.<br />Type: dimension.<br />API name: <code>ga:adKeywordMatchType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"adMatchedQuery\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Search Query\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:113:\"The search query that triggered impressions.<br />Type: dimension.<br />API name: <code>ga:adMatchedQuery</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"adMatchType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Query Match Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:279:\"The match type (Phrase, Exact, Broad, etc.) applied for users\' search term. Ads on the content network are identified as \"Content network\". For details, see https://support.google.com/adwords/answer/2472708?hl=en.<br />Type: dimension.<br />API name: <code>ga:adMatchType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"adPlacementDomain\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Placement Domain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:132:\"The domain where the ads on the content network were placed.<br />Type: dimension.<br />API name: <code>ga:adPlacementDomain</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"adPlacementUrl\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Placement URL\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:126:\"The URL where the ads were placed on the content network.<br />Type: dimension.<br />API name: <code>ga:adPlacementUrl</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"adQueryWordCount\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Query Word Count\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:111:\"The number of words in the search query.<br />Type: dimension.<br />API name: <code>ga:adQueryWordCount</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"adsenseAdsClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"AdSense Ads Clicked\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:161:\"The number of times AdSense ads on the site were clicked (requires integration with AdSense).<br />Type: metric.<br />API name: <code>ga:adsenseAdsClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:16:\"adsenseAdsViewed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"AdSense Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:186:\"The number of AdSense ads viewed (requires integration with AdSense). Multiple ads can be displayed within an ad Unit.<br />Type: metric.<br />API name: <code>ga:adsenseAdsViewed</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"adsenseAdUnitsViewed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"AdSense Ad Units Viewed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:304:\"The number of AdSense ad units viewed (requires integration with AdSense). An ad unit is a set of ads displayed as a result of one piece of the AdSense ad code. For details, see https://support.google.com/adsense/answer/32715?hl=en.<br />Type: metric.<br />API name: <code>ga:adsenseAdUnitsViewed</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"adsenseCoverage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"AdSense Coverage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:163:\"The percentage of ad requests that returned at least one ad (requires integration with AdSense).<br />Type: metric.<br />API name: <code>ga:adsenseCoverage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"adsenseCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"AdSense CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:248:\"The percentage of page impressions resulted in a click on an AdSense ad (requires integration with AdSense).<br />Type: metric.<br />Calculation: <code>ga:adsenseAdsClicks/ga:adsensePageImpressions</code>.<br />API name: <code>ga:adsenseCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"adsenseECPM\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"AdSense eCPM\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:285:\"The estimated cost per thousand page impressions (requires integration with AdSense). It is the AdSense Revenue per 1,000 page impressions.<br />Type: metric.<br />Calculation: <code>ga:adsenseRevenue/(ga:adsensePageImpressions/1000)</code>.<br />API name: <code>ga:adsenseECPM</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"adsenseExits\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"AdSense Exits\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"The number of sessions ended due to a user clicking on an AdSense ad (requires integration with AdSense).<br />Type: metric.<br />API name: <code>ga:adsenseExits</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:22:\"adsensePageImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"AdSense Page Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:221:\"The number of pageviews during which an AdSense ad was displayed (requires integration with AdSense). A page impression can have multiple ad Units.<br />Type: metric.<br />API name: <code>ga:adsensePageImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"adsenseRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"AdSense Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:101:\"The total revenue from AdSense ads.<br />Type: metric.<br />API name: <code>ga:adsenseRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:32:\"adsenseViewableImpressionPercent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"AdSense Viewable Impression %\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:159:\"The percentage of viewable impressions (requires integration with AdSense).<br />Type: metric.<br />API name: <code>ga:adsenseViewableImpressionPercent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adsense\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"adSlot\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Google Ads: Ad Slot\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:138:\"The location (Top, RHS, or not set) of the advertisement on the hosting page.<br />Type: dimension.<br />API name: <code>ga:adSlot</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"adTargetingOption\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Placement Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:181:\"It is Automatic placements or Managed placements, indicating how the ads were managed on the content network.<br />Type: dimension.<br />API name: <code>ga:adTargetingOption</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"adTargetingType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Targeting Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:163:\"This (keyword, placement, or vertical targeting) indicates how the AdWords ads were targeted.<br />Type: dimension.<br />API name: <code>ga:adTargetingType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"adwordsAdGroupID\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Google Ads Ad Group ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:94:\"AdWords API AdGroup.id.<br />Type: dimension.<br />API name: <code>ga:adwordsAdGroupID</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"adwordsCampaignID\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Google Ads Campaign ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:96:\"AdWords API Campaign.id.<br />Type: dimension.<br />API name: <code>ga:adwordsCampaignID</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"adwordsCreativeID\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Google Ads Creative ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:90:\"AdWords API Ad.id.<br />Type: dimension.<br />API name: <code>ga:adwordsCreativeID</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"adwordsCriteriaID\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Google Ads Criteria ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:231:\"AdWords API Criterion.id. The geographical targeting Criteria IDs are listed at https://developers.google.com/analytics/devguides/collection/protocol/v1/geoid.<br />Type: dimension.<br />API name: <code>ga:adwordsCriteriaID</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"adwordsCustomerID\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Google Ads Customer ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:147:\"Customer\'s AdWords ID, corresponding to AdWords API AccountInfo.customerId.<br />Type: dimension.<br />API name: <code>ga:adwordsCustomerID</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"adxClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"AdX Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:114:\"The number of times AdX ads were clicked on the site.<br />Type: metric.<br />API name: <code>ga:adxClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"adxCoverage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"AdX Coverage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:288:\"Coverage is the percentage of ad requests that returned at least one ad. Generally, coverage can help identify sites where the Ad Exchange account isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100<br />Type: metric.<br />API name: <code>ga:adxCoverage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"adxCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"AdX CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:132:\"The percentage of pageviews that resulted in a click on an Ad Exchange ad.<br />Type: metric.<br />API name: <code>ga:adxCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:7:\"adxECPM\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"AdX eCPM\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:152:\"The effective cost per thousand pageviews. It is the Ad Exchange revenue per 1,000 pageviews.<br />Type: metric.<br />API name: <code>ga:adxECPM</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"adxImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"AdX Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:249:\"An Ad Exchange ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions.<br />Type: metric.<br />API name: <code>ga:adxImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:24:\"adxImpressionsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"AdX Impressions / Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:176:\"The ratio of Ad Exchange ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions).<br />Type: metric.<br />API name: <code>ga:adxImpressionsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"adxMonetizedPageviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"AdX Monetized Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:248:\"This measures the total number of pageviews on the property that were shown with an ad from the linked Ad Exchange account. Note that a single page can have multiple ad units.<br />Type: metric.<br />API name: <code>ga:adxMonetizedPageviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"adxRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"AdX Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:111:\"The total estimated revenue from Ad Exchange ads.<br />Type: metric.<br />API name: <code>ga:adxRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:25:\"adxRevenuePer1000Sessions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"AdX Revenue / 1000 Sessions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:234:\"The total estimated revenue from Ad Exchange ads per 1,000 Analytics sessions. Note that this metric is based on sessions to the site, not on ad impressions.<br />Type: metric.<br />API name: <code>ga:adxRevenuePer1000Sessions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:29:\"adxViewableImpressionsPercent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"AdX Viewable Impressions %\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:253:\"The percentage of viewable ad impressions. An impression is considered a viewable impression when it has appeared within users\' browsers and has the opportunity to be seen.<br />Type: metric.<br />API name: <code>ga:adxViewableImpressionsPercent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Ad Exchange\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"affiliation\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Affiliation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:150:\"A product affiliation to designate a supplying company or brick and mortar location.<br />Type: dimension.<br />API name: <code>ga:affiliation</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:5:\"appId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"App ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:79:\"The application ID.<br />Type: dimension.<br />API name: <code>ga:appId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"appInstallerId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"App Installer ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:251:\"The ID of the app installer (e.g., Google Play Store) from which the app was downloaded. By default, the app installer ID is set by the PackageManager#getInstallerPackageName method.<br />Type: dimension.<br />API name: <code>ga:appInstallerId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"appName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"App Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:83:\"The application name.<br />Type: dimension.<br />API name: <code>ga:appName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"appVersion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"App Version\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:89:\"The application version.<br />Type: dimension.<br />API name: <code>ga:appVersion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:19:\"avgDomainLookupTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Avg. Domain Lookup Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:220:\"The average time (in seconds) spent in DNS lookup for this page.<br />Type: metric.<br />Calculation: <code>(ga:domainLookupTime / ga:speedMetricsSample / 1000)</code>.<br />API name: <code>ga:avgDomainLookupTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"avgDomContentLoadedTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Avg. Document Content Loaded Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:239:\"The average time (in seconds) the browser takes to parse the document.<br />Type: metric.<br />Calculation: <code>(ga:domContentLoadedTime / ga:domLatencyMetricsSample / 1000)</code>.<br />API name: <code>ga:avgDomContentLoadedTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"avgDomInteractiveTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Avg. Document Interactive Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:356:\"The average time (in seconds), including the network time from users\' locations to the site\'s server, the browser takes to parse the document and execute deferred and parser-inserted scripts.<br />Type: metric.<br />Calculation: <code>(ga:domInteractiveTime / ga:domLatencyMetricsSample / 1000)</code>.<br />API name: <code>ga:avgDomInteractiveTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:13:\"avgEventValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Avg. Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:158:\"The average value of an event.<br />Type: metric.<br />Calculation: <code>ga:eventValue / ga:totalEvents</code>.<br />API name: <code>ga:avgEventValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"avgPageDownloadTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Avg. Page Download Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:208:\"The average time (in seconds) to download this page.<br />Type: metric.<br />Calculation: <code>(ga:pageDownloadTime / ga:speedMetricsSample / 1000)</code>.<br />API name: <code>ga:avgPageDownloadTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"avgPageLoadTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Avg. Page Load Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:311:\"The average time (in seconds) pages from the sample set take to load, from initiation of the pageview (e.g., a click on a page link) to load completion in the browser.<br />Type: metric.<br />Calculation: <code>(ga:pageLoadTime / ga:pageLoadSample / 1000)</code>.<br />API name: <code>ga:avgPageLoadTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"avgRedirectionTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Avg. Redirection Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:267:\"The average time (in seconds) spent in redirects before fetching this page. If there are no redirects, this is 0.<br />Type: metric.<br />Calculation: <code>(ga:redirectionTime / ga:speedMetricsSample / 1000)</code>.<br />API name: <code>ga:avgRedirectionTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"avgScreenviewDuration\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Avg. Time on Screen\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:123:\"Average time (in seconds) users spent on a screen.<br />Type: metric.<br />API name: <code>ga:avgScreenviewDuration</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"avgSearchDepth\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Avg. Search Depth\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:200:\"The average number of pages people viewed after performing a search.<br />Type: metric.<br />Calculation: <code>ga:searchDepth / ga:searchUniques</code>.<br />API name: <code>ga:avgSearchDepth</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"avgSearchDuration\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Time after Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:214:\"The average time (in seconds) users, after searching, spent on the property.<br />Type: metric.<br />Calculation: <code>ga:searchDuration / ga:searchUniques</code>.<br />API name: <code>ga:avgSearchDuration</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"avgSearchResultViews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Results Pageviews / Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:217:\"The average number of times people viewed a page as a result of a search.<br />Type: metric.<br />Calculation: <code>ga:searchResultViews / ga:searchUniques</code>.<br />API name: <code>ga:avgSearchResultViews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"avgServerConnectionTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Avg. Server Connection Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:246:\"The average time (in seconds) spent in establishing a TCP connection to this page.<br />Type: metric.<br />Calculation: <code>(ga:serverConnectionTime / ga:speedMetricsSample / 1000)</code>.<br />API name: <code>ga:avgServerConnectionTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"avgServerResponseTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Avg. Server Response Time (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:312:\"The average time (in seconds) the site\'s server takes to respond to users\' requests; this includes the network time from users\' locations to the server.<br />Type: metric.<br />Calculation: <code>(ga:serverResponseTime / ga:speedMetricsSample / 1000)</code>.<br />API name: <code>ga:avgServerResponseTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"avgSessionDuration\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Avg. Session Duration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:188:\"The average duration (in seconds) of users\' sessions.<br />Type: metric.<br />Calculation: <code>ga:sessionDuration / ga:sessions</code>.<br />API name: <code>ga:avgSessionDuration</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:13:\"avgTimeOnPage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Avg. Time on Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:204:\"The average time users spent viewing this page or a set of pages.<br />Type: metric.<br />Calculation: <code>ga:timeOnPage / (ga:pageviews - ga:exits)</code>.<br />API name: <code>ga:avgTimeOnPage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"avgUserTimingValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Avg. User Timing (sec)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:177:\"The average elapsed time.<br />Type: metric.<br />Calculation: <code>(ga:userTimingValue / ga:userTimingSample / 1000)</code>.<br />API name: <code>ga:avgUserTimingValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"User Timings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"backfillClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"GAM Backfill Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:292:\"The number of times backfill ads were clicked on the site. If AdSense and Ad Exchange are both providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:16:\"backfillCoverage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"GAM Backfill Coverage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:491:\"Backfill Coverage is the percentage of backfill ad requests that returned at least one ad. Generally, coverage can help identify sites where the publisher account isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100. If both AdSense and Ad Exchange are providing backfill ads, this metric is the weighted average of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillCoverage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"backfillCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"GAM Backfill CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:317:\"The percentage of backfill impressions that resulted in a click on an ad. If AdSense and Ad Exchange are both providing backfill ads, this metric is the weighted average of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"backfillECPM\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"GAM Backfill eCPM\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:326:\"The effective cost per thousand pageviews. It is the DFP Backfill Revenue per 1,000 pageviews. If both AdSense and Ad Exchange are providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillECPM</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"backfillImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"GAM Backfill Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:406:\"Backfill Impressions is the sum of all AdSense or Ad Exchance ad impressions served as backfill through DFP. An ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:29:\"backfillImpressionsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"GAM Backfill Impressions / Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:346:\"The ratio of backfill ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions). If both AdSense and Ad Exchange are providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillImpressionsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:26:\"backfillMonetizedPageviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"GAM Backfill Monetized Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:341:\"This measures the total number of pageviews on the property that were shown with at least one ad from the linked backfill account(s). Note that a single monetized pageview can include multiple ad impressions (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillMonetizedPageviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"backfillRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"GAM Backfill Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:281:\"The total estimated revenue from backfill ads. If AdSense and Ad Exchange are both providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:30:\"backfillRevenuePer1000Sessions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"GAM Backfill Revenue / 1000 Sessions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:404:\"The total estimated revenue from backfill ads per 1,000 Analytics sessions. Note that this metric is based on sessions to the site and not ad impressions. If both AdSense and Ad Exchange are providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillRevenuePer1000Sessions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:34:\"backfillViewableImpressionsPercent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"GAM Backfill Viewable Impressions %\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:462:\"The percentage of backfill ad impressions that were viewable. An impression is considered a viewable impression when it has appeared within the users\' browsers and had the opportunity to be seen. If AdSense and Ad Exchange are both providing backfill ads, this metric is the weighted average of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:backfillViewableImpressionsPercent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"bounceRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Bounce Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:231:\"The percentage of single-page session (i.e., session in which the person left the property from the first page).<br />Type: metric.<br />Calculation: <code>ga:bounces / ga:sessions</code>.<br />API name: <code>ga:bounceRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:7:\"bounces\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Bounces\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:145:\"The total number of single page (or single interaction hit) sessions for the property.<br />Type: metric.<br />API name: <code>ga:bounces</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:7:\"browser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Browser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:133:\"The name of users\' browsers, for example, Internet Explorer or Firefox.<br />Type: dimension.<br />API name: <code>ga:browser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"browserSize\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Browser Size\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:261:\"The viewport size of users\' browsers. A session-scoped dimension, browser size captures the initial dimensions of the viewport in pixels and is formatted as width x height, for example, 1920x960.<br />Type: dimension.<br />API name: <code>ga:browserSize</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"browserVersion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Browser Version\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:123:\"The version of users\' browsers, for example, 2.0.0.14.<br />Type: dimension.<br />API name: <code>ga:browserVersion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"buyToDetailRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Buy-to-Detail Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:146:\"Unique purchases divided by views of product detail pages (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:buyToDetailRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"calcMetric_<NAME>\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Calculated Metric\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:360:\"The value of the requested calculated metric, where <NAME> refers to the user-defined name of the calculated metric. Note that the data type of ga:calcMetric_<NAME> can be FLOAT, INTEGER, CURRENCY, TIME, or PERCENT. For details, see https://support.google.com/analytics/answer/6121409.<br />Type: metric.<br />API name: <code>ga:calcMetric_&lt;NAME&gt;</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Custom Variables or Columns\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:8:\"campaign\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Campaign\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:299:\"For manual campaign tracking, it is the value of the utm_campaign campaign tracking parameter. For AdWords autotagging, it is the name(s) of the online ad campaign(s) you use for the property. If you use neither, its value is (not set).<br />Type: dimension.<br />API name: <code>ga:campaign</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"campaignCode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Campaign Code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:155:\"For manual campaign tracking, it is the value of the utm_id campaign tracking parameter.<br />Type: dimension.<br />API name: <code>ga:campaignCode</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"cartToDetailRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Cart-to-Detail Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:138:\"Product adds divided by views of product details (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:cartToDetailRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"channelGrouping\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Default Channel Grouping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:182:\"The Channel Group associated with an end user\'s session for this View (defined by the View\'s Channel Groupings).<br />Type: dimension.<br />API name: <code>ga:channelGrouping</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Channel Grouping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"checkoutOptions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Checkout Options\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:283:\"User options specified during the checkout process, e.g., FedEx, DHL, UPS for delivery options; Visa, MasterCard, AmEx for payment options. This dimension should be used with ga:shoppingStage (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:checkoutOptions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:4:\"city\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"City\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:124:\"Users\' city, derived from their IP addresses or Geographical IDs.<br />Type: dimension.<br />API name: <code>ga:city</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:6:\"cityId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"City ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:264:\"Users\' city ID, derived from their IP addresses or Geographical IDs. The city IDs are the same as the Criteria IDs found at https://developers.google.com/analytics/devguides/collection/protocol/v1/geoid.<br />Type: dimension.<br />API name: <code>ga:cityId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:6:\"cohort\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Cohort\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:236:\"Name of the cohort to which a user belongs. Depending on how cohorts are defined, a user can belong to multiple cohorts, similar to how a user can belong to multiple segments.<br />Type: dimension.<br />API name: <code>ga:cohort</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"cohortActiveUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:534:\"This metric is relevant in the context of ga:cohortNthDay/ga:cohortNthWeek/ga:cohortNthMonth. It indicates the number of users in the cohort who are active in the time window corresponding to the cohort nth day/week/month. For example, for ga:cohortNthWeek = 1, number of users (in the cohort) who are active in week 1. If a request doesn\'t have any of ga:cohortNthDay/ga:cohortNthWeek/ga:cohortNthMonth, this metric will have the same value as ga:cohortTotalUsers.<br />Type: metric.<br />API name: <code>ga:cohortActiveUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"cohortAppviewsPerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Appviews per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"App views per user for a cohort.<br />Type: metric.<br />Calculation: <code>ga:screenviews / ga:cohortTotalUsers</code>.<br />API name: <code>ga:cohortAppviewsPerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:41:\"cohortAppviewsPerUserWithLifetimeCriteria\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Appviews Per User (LTV)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:244:\"App views per user for the acquisition dimension for a cohort.<br />Type: metric.<br />Calculation: <code>ga:screenviews / ga:cohortTotalUsersWithLifetimeCriteria</code>.<br />API name: <code>ga:cohortAppviewsPerUserWithLifetimeCriteria</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:28:\"cohortGoalCompletionsPerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Goal Completions per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:225:\"Goal completions per user for the acquisition dimension for a cohort.<br />Type: metric.<br />Calculation: <code>ga:goalCompletionsAll / ga:cohortTotalUsers</code>.<br />API name: <code>ga:cohortGoalCompletionsPerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:48:\"cohortGoalCompletionsPerUserWithLifetimeCriteria\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Goal Completions Per User (LTV)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:235:\"Goal completions per user for a cohort.<br />Type: metric.<br />Calculation: <code>ga:goalCompletionsAll / ga:cohortTotalUsersWithLifetimeCriteria</code>.<br />API name: <code>ga:cohortGoalCompletionsPerUserWithLifetimeCriteria</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"cohortNthDay\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:251:\"Day offset relative to the cohort definition date. For example, if a cohort is defined with the first visit date as 2015-09-01, then for the date 2015-09-04, ga:cohortNthDay will be 3.<br />Type: dimension.<br />API name: <code>ga:cohortNthDay</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"cohortNthMonth\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:980:\"Month offset relative to the cohort definition date. The semantics of this dimension differs based on whether lifetime value is requested or not. For a cohorts report not requesting lifetime value: This is the week offset from the cohort definition start date. For example, if cohort is defined as 2015-09-01 <= first session date <= 2015-09-30. Then, for 2015-09-01 <= date <= 2015-09-30, ga:cohortNthMonth = 0. 2015-10-01 <= date <= 2015-10-31, ga:cohortNthMonth = 2. and so on. For a cohorts request requesting lifetime value: ga:cohortNthMonth is calculated relative to the users acquisition date. It is not dependent on the cohort definition date. For example, if we define a cohort as 2015-10-01 <= first session date <= 2015-09-30. And a user was acquired on 2015-09-04. Then, for 2015-09-04 <= date <= 2015-10-04, ga:cohortNthMonth = 0 2015-10-04 <= date <= 2015-11-04, ga:cohortNthMonth = 1, and so on.<br />Type: dimension.<br />API name: <code>ga:cohortNthMonth</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"cohortNthWeek\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:954:\"Week offset relative to the cohort definition date. The semantics of this dimension differs based on whether lifetime value is requested or not. For a cohorts report not requesting lifetime value: This is the week offset from the cohort definition start date. For example, if cohort is defined as 2015-09-01 <= first session date <= 2015-09-07. Then, for 2015-09-01 <= date <= 2015-09-07, ga:cohortNthWeek = 0. 2015-09-08 <= date <= 2015-09-14, ga:cohortNthWeek = 1. etc. For a cohorts request requesting lifetime value: ga:cohortNthWeek is calculated relative to the users acquisition date. It is not dependent on the cohort definition date. For example, if we define a cohort as 2015-09-01 <= first session date <= 2015-09-07. And a user was acquired on 2015-09-04. Then, for 2015-09-04 <= date<= 2015-09-10, ga:cohortNthWeek = 0 2015-09-11 <= date <= 2015-09-17, ga:cohortNthWeek = 1<br />Type: dimension.<br />API name: <code>ga:cohortNthWeek</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"cohortPageviewsPerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Pageviews per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:173:\"Pageviews per user for a cohort.<br />Type: metric.<br />Calculation: <code>ga:pageviews / ga:cohortTotalUsers</code>.<br />API name: <code>ga:cohortPageviewsPerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:42:\"cohortPageviewsPerUserWithLifetimeCriteria\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Pageviews Per User (LTV)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:243:\"Pageviews per user for the acquisition dimension for a cohort.<br />Type: metric.<br />Calculation: <code>ga:pageviews / ga:cohortTotalUsersWithLifetimeCriteria</code>.<br />API name: <code>ga:cohortPageviewsPerUserWithLifetimeCriteria</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"cohortRetentionRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"User Retention\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:168:\"Cohort retention rate.<br />Type: metric.<br />Calculation: <code>ga:cohortActiveUsers / ga:cohortTotalUsers</code>.<br />API name: <code>ga:cohortRetentionRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"cohortRevenuePerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Revenue per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:172:\"Revenue per user for a cohort.<br />Type: metric.<br />Calculation: <code>ga:transactions / ga:cohortTotalUsers</code>.<br />API name: <code>ga:cohortRevenuePerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:40:\"cohortRevenuePerUserWithLifetimeCriteria\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Revenue Per User (LTV)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:248:\"Revenue per user for the acquisition dimension for a cohort.<br />Type: metric.<br />Calculation: <code>ga:transactionRevenue / ga:cohortTotalUsersWithLifetimeCriteria</code>.<br />API name: <code>ga:cohortRevenuePerUserWithLifetimeCriteria</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:28:\"cohortSessionDurationPerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Session Duration per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:192:\"Session duration per user for a cohort.<br />Type: metric.<br />Calculation: <code>ga:sessionDuration / ga:cohortTotalUsers</code>.<br />API name: <code>ga:cohortSessionDurationPerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:48:\"cohortSessionDurationPerUserWithLifetimeCriteria\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Session Duration Per User (LTV)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:262:\"Session duration per user for the acquisition dimension for a cohort.<br />Type: metric.<br />Calculation: <code>ga:sessionDuration / ga:cohortTotalUsersWithLifetimeCriteria</code>.<br />API name: <code>ga:cohortSessionDurationPerUserWithLifetimeCriteria</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"cohortSessionsPerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Sessions per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:170:\"Sessions per user for a cohort.<br />Type: metric.<br />Calculation: <code>ga:sessions / ga:cohortTotalUsers</code>.<br />API name: <code>ga:cohortSessionsPerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:41:\"cohortSessionsPerUserWithLifetimeCriteria\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Sessions Per User (LTV)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:240:\"Sessions per user for the acquisition dimension for a cohort.<br />Type: metric.<br />Calculation: <code>ga:sessions / ga:cohortTotalUsersWithLifetimeCriteria</code>.<br />API name: <code>ga:cohortSessionsPerUserWithLifetimeCriteria</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:16:\"cohortTotalUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Total Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:135:\"Number of users belonging to the cohort, also known as cohort size.<br />Type: metric.<br />API name: <code>ga:cohortTotalUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:36:\"cohortTotalUsersWithLifetimeCriteria\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:597:\"This is relevant in the context of a request which has the dimensions ga:acquisitionTrafficChannel/ga:acquisitionSource/ga:acquisitionMedium/ga:acquisitionCampaign. It represents the number of users in the cohorts who are acquired through the current channel/source/medium/campaign. For example, for ga:acquisitionTrafficChannel=Direct, it represents the number users in the cohort, who were acquired directly. If none of these mentioned dimensions are present, then its value is equal to ga:cohortTotalUsers.<br />Type: metric.<br />API name: <code>ga:cohortTotalUsersWithLifetimeCriteria</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Lifetime Value and Cohorts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:25:\"contentGroupUniqueViewsXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Unique Views XX\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:288:\"The number of unique content group views. Content group views in different sessions are counted as unique content group views. Both the pagePath and pageTitle are used to determine content group view uniqueness.<br />Type: metric.<br />API name: <code>ga:contentGroupUniqueViewsXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Content Grouping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"contentGroupXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Group XX\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:266:\"The content group on a property. A content group is a collection of content providing a logical structure that can be determined by tracking code or page title/URL regex match, or predefined rules.<br />Type: dimension.<br />API name: <code>ga:contentGroupXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Content Grouping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"continent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Continent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:135:\"Users\' continent, derived from users\' IP addresses or Geographical IDs.<br />Type: dimension.<br />API name: <code>ga:continent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"continentId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Continent ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:140:\"Users\' continent ID, derived from users\' IP addresses or Geographical IDs.<br />Type: dimension.<br />API name: <code>ga:continentId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"costPerConversion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Cost per Conversion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:243:\"The cost per conversion (including ecommerce and goal conversions) for the property.<br />Type: metric.<br />Calculation: <code>(ga:adCost) / (ga:transactions  +  ga:goalCompletionsAll)</code>.<br />API name: <code>ga:costPerConversion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"costPerGoalConversion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Cost per Goal Conversion\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:189:\"The cost per goal conversion for the property.<br />Type: metric.<br />Calculation: <code>(ga:adCost) / (ga:goalCompletionsAll)</code>.<br />API name: <code>ga:costPerGoalConversion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"costPerTransaction\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Cost per Transaction\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:176:\"The cost per transaction for the property.<br />Type: metric.<br />Calculation: <code>(ga:adCost) / (ga:transactions)</code>.<br />API name: <code>ga:costPerTransaction</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:7:\"country\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Country\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:130:\"Users\' country, derived from their IP addresses or Geographical IDs.<br />Type: dimension.<br />API name: <code>ga:country</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"countryIsoCode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Country ISO Code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:222:\"Users\' country\'s ISO code (in ISO-3166-1 alpha-2 format), derived from their IP addresses or Geographical IDs. For example, BR for Brazil, CA for Canada.<br />Type: dimension.<br />API name: <code>ga:countryIsoCode</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:3:\"CPC\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"CPC\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:140:\"Cost to advertiser per click.<br />Type: metric.<br />Calculation: <code>ga:adCost / ga:adClicks</code>.<br />API name: <code>ga:CPC</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:3:\"CPM\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"CPM\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:153:\"Cost per thousand impressions.<br />Type: metric.<br />Calculation: <code>ga:adCost / (ga:impressions / 1000)</code>.<br />API name: <code>ga:CPM</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:3:\"CTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:311:\"Click-through-rate for the ad. This is equal to the number of clicks divided by the number of impressions for the ad (e.g., how many times users clicked on one of the ads where that ad appeared).<br />Type: metric.<br />Calculation: <code>ga:adClicks / ga:impressions</code>.<br />API name: <code>ga:CTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"currencyCode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Currency Code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:139:\"The local currency code (based on ISO 4217 standard) of the transaction.<br />Type: dimension.<br />API name: <code>ga:currencyCode</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"customVarNameXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Custom Variable (Key XX)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:113:\"The name for the requested custom variable.<br />Type: dimension.<br />API name: <code>ga:customVarNameXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Custom Variables or Columns\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"customVarValueXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Custom Variable (Value XX)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:115:\"The value for the requested custom variable.<br />Type: dimension.<br />API name: <code>ga:customVarValueXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Custom Variables or Columns\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"dataSource\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Data Source\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:270:\"The data source of a hit. By default, hits sent from analytics.js are reported as \"web\" and hits sent from the mobile SDKs are reported as \"app\". These values can be overridden in the Measurement Protocol.<br />Type: dimension.<br />API name: <code>ga:dataSource</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:4:\"date\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:105:\"The date of the session formatted as YYYYMMDD.<br />Type: dimension.<br />API name: <code>ga:date</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"dateHour\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Hour of Day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:125:\"Combined values of ga:date and ga:hour formated as YYYYMMDDHH.<br />Type: dimension.<br />API name: <code>ga:dateHour</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dateHourMinute\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Date Hour and Minute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:144:\"Combined values of ga:date, ga:hour and ga:minute formated as YYYYMMDDHHMM.<br />Type: dimension.<br />API name: <code>ga:dateHourMinute</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:3:\"day\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Day of the month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:113:\"The day of the month, a two-digit number from 01 to 31.<br />Type: dimension.<br />API name: <code>ga:day</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"dayOfWeek\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Day of Week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:132:\"Day of the week, a one-digit number from 0 (Sunday) to 6 (Saturday).<br />Type: dimension.<br />API name: <code>ga:dayOfWeek</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"dayOfWeekName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Day of Week Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:109:\"Name (in English) of the day of the week.<br />Type: dimension.<br />API name: <code>ga:dayOfWeekName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"daysSinceLastSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Days Since Last Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:172:\"The number of days elapsed since users last visited the property, used to calculate user loyalty.<br />Type: dimension.<br />API name: <code>ga:daysSinceLastSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"daysToTransaction\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Days to Transaction\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"The number of days between users\' purchases and the most recent campaign source prior to the purchase.<br />Type: dimension.<br />API name: <code>ga:daysToTransaction</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dbmClickAdvertiser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"DV360 Advertiser (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:200:\"DBM advertiser name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickAdvertiser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dbmClickAdvertiserId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"DV360 Advertiser ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:200:\"DBM advertiser ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickAdvertiserId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dbmClickCreativeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DV360 Creative ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:196:\"DBM creative ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickCreativeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dbmClickExchange\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"DV360 Exchange (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:196:\"DBM exchange name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickExchange</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dbmClickExchangeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DV360 Exchange ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:196:\"DBM exchange ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickExchangeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dbmClickInsertionOrder\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"DV360 Insertion Order (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:209:\"DBM insertion order name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickInsertionOrder</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"dbmClickInsertionOrderId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DV360 Insertion Order ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:209:\"DBM insertion order ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickInsertionOrderId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dbmClickLineItem\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"DV360 Line Item NAME (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:197:\"DBM line item name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickLineItem</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dbmClickLineItemId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"DV360 Line Item ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:197:\"DBM line item ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickLineItemId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"dbmClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"DV360 Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:130:\"DBM Total Clicks (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />API name: <code>ga:dbmClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"dbmClickSite\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"DV360 Site (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:237:\"DBM site name where the DBM creative was shown and clicked on for the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickSite</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dbmClickSiteId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"DV360 Site ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:237:\"DBM site ID where the DBM creative was shown and clicked on for the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmClickSiteId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dbmConversions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"DV360 Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:140:\"DBM Total Conversions (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />API name: <code>ga:dbmConversions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:7:\"dbmCost\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"DV360 Cost\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:120:\"DBM Cost (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />API name: <code>ga:dbmCost</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dbmCPA\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"DV360 eCPA\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:190:\"DBM Revenue eCPA (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />Calculation: <code>ga:dbmCost / ga:dbmConversions</code>.<br />API name: <code>ga:dbmCPA</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dbmCPC\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"DV360 eCPC\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:185:\"DBM Revenue eCPC (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />Calculation: <code>ga:dbmCost / ga:dbmClicks</code>.<br />API name: <code>ga:dbmCPC</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dbmCPM\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"DV360 eCPM\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:199:\"DBM Revenue eCPM (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />Calculation: <code>ga:dbmCost / (ga:dbmImpressions / 1000)</code>.<br />API name: <code>ga:dbmCPM</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dbmCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"DV360 CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:183:\"DBM CTR (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />Calculation: <code>ga:dbmClicks / ga:dbmImpressions</code>.<br />API name: <code>ga:dbmCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"dbmImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"DV360 Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:140:\"DBM Total Impressions (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />API name: <code>ga:dbmImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:22:\"dbmLastEventAdvertiser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"DV360 Advertiser (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:269:\"DBM advertiser name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventAdvertiser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"dbmLastEventAdvertiserId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"DV360 Advertiser ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:269:\"DBM advertiser ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventAdvertiserId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dbmLastEventCreativeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DV360 Creative ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:265:\"DBM creative ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventCreativeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dbmLastEventExchange\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"DV360 Exchange (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:265:\"DBM exchange name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventExchange</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dbmLastEventExchangeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DV360 Exchange ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:265:\"DBM exchange ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventExchangeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:26:\"dbmLastEventInsertionOrder\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"DV360 Insertion Order (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:278:\"DBM insertion order name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventInsertionOrder</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:28:\"dbmLastEventInsertionOrderId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DV360 Insertion Order ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:278:\"DBM insertion order ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventInsertionOrderId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dbmLastEventLineItem\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DV360 Line Item (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:266:\"DBM line item name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventLineItem</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dbmLastEventLineItemId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"DV360 Line Item ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:266:\"DBM line item ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventLineItemId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dbmLastEventSite\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"DV360 Site (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:306:\"DBM site name where the DBM creative was shown and clicked on for the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventSite</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dbmLastEventSiteId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"DV360 Site ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:306:\"DBM site ID where the DBM creative was shown and clicked on for the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).<br />Type: dimension.<br />API name: <code>ga:dbmLastEventSiteId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"dbmROAS\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"DV360 ROAS\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:207:\"DBM ROAS (Analytics 360 only, requires integration with DBM).<br />Type: metric.<br />Calculation: <code>(ga:transactionRevenue + ga:goalValueAll) / ga:dbmCost</code>.<br />API name: <code>ga:dbmROAS</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"DoubleClick Bid Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"dcmClickAd\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"CM Ad (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:153:\"DCM ad name of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickAd</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"dcmClickAdId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"CM Ad ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:153:\"DCM ad ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickAdId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dcmClickAdType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"CM Ad Type (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:162:\"DCM ad type name of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickAdType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dcmClickAdTypeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"CM Ad Type ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:162:\"DCM ad type ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickAdTypeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dcmClickAdvertiser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"CM Advertiser (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"DCM advertiser name of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickAdvertiser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dcmClickAdvertiserId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"CM Advertiser ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"DCM advertiser ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickAdvertiserId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dcmClickCampaign\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"CM Campaign (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:165:\"DCM campaign name of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickCampaign</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dcmClickCampaignId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"CM Campaign ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:165:\"DCM campaign ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickCampaignId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dcmClickCreative\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"CM Creative (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:165:\"DCM creative name of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickCreative</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dcmClickCreativeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"CM Creative ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:165:\"DCM creative ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickCreativeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dcmClickCreativeType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"CM Creative Type (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"DCM creative type name of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickCreativeType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dcmClickCreativeTypeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"CM Creative Type ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"DCM creative type ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickCreativeTypeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"dcmClickCreativeVersion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"CM Creative Version (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:175:\"DCM creative version of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickCreativeVersion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:19:\"dcmClickRenderingId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"CM Rendering ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:167:\"DCM rendering ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickRenderingId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"dcmClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"CM Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:99:\"DCM Total Clicks (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"dcmClickSite\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"CM Site (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:202:\"Site name where the DCM creative was shown and clicked on for the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickSite</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dcmClickSiteId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"CM Site ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:206:\"DCM site ID where the DCM creative was shown and clicked on for the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickSiteId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"dcmClickSitePlacement\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"CM Placement (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:176:\"DCM site placement name of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickSitePlacement</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"dcmClickSitePlacementId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"CM Placement ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:176:\"DCM site placement ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickSitePlacementId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dcmClickSpotId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"CM Floodlight Configuration ID (GA Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:177:\"DCM Floodlight configuration ID of the DCM click matching the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmClickSpotId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"dcmCost\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"CM Cost\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:95:\"DCM Total Cost (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmCost</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dcmCPC\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"CM CPC\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:98:\"DCM Cost Per Click (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmCPC</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dcmCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"CM CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:102:\"DCM Click Through Rate (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"dcmFloodlightActivity\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"CM Activity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:168:\"DCM Floodlight activity name associated with the floodlight conversion (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmFloodlightActivity</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:29:\"dcmFloodlightActivityAndGroup\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"CM Activity and Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:191:\"DCM Floodlight activity name and group name associated with the floodlight conversion (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmFloodlightActivityAndGroup</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:26:\"dcmFloodlightActivityGroup\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"CM Activity Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:179:\"DCM Floodlight activity group name associated with the floodlight conversion (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmFloodlightActivityGroup</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:28:\"dcmFloodlightActivityGroupId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"CM Activity Group ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:179:\"DCM Floodlight activity group ID associated with the floodlight conversion (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmFloodlightActivityGroupId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"dcmFloodlightActivityId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"CM Activity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:168:\"DCM Floodlight activity ID associated with the floodlight conversion (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmFloodlightActivityId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:25:\"dcmFloodlightAdvertiserId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"CM Advertiser ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:172:\"DCM Floodlight advertiser ID associated with the floodlight conversion (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmFloodlightAdvertiserId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"dcmFloodlightQuantity\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"CM Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:135:\"The number of DCM Floodlight conversions (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmFloodlightQuantity</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"dcmFloodlightRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"CM Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:116:\"DCM Floodlight revenue (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmFloodlightRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"dcmFloodlightSpotId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"CM Floodlight Configuration ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"DCM Floodlight configuration ID associated with the floodlight conversion (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmFloodlightSpotId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dcmImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"CM Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:109:\"DCM Total Impressions (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"dcmLastEventAd\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"CM Ad\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:222:\"DCM ad name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventAd</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dcmLastEventAdId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"CM Ad ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:222:\"DCM ad ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventAdId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dcmLastEventAdType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"CM Ad Type (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:231:\"DCM ad type name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventAdType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dcmLastEventAdTypeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"CM Ad Type ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:231:\"DCM ad type ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventAdTypeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dcmLastEventAdvertiser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"CM Advertiser (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:238:\"DCM advertiser name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventAdvertiser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"dcmLastEventAdvertiserId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"CM Advertiser ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:238:\"DCM advertiser ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventAdvertiserId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:27:\"dcmLastEventAttributionType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"CM Attribution Type (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:405:\"There are two possible values: ClickThrough and ViewThrough. If the last DCM event associated with the Google Analytics session was a click, then the value will be ClickThrough. If the last DCM event associated with the Google Analytics session was an ad impression, then the value will be ViewThrough (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventAttributionType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dcmLastEventCampaign\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"CM Campaign (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:234:\"DCM campaign name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventCampaign</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dcmLastEventCampaignId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"CM Campaign ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:234:\"DCM campaign ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventCampaignId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"dcmLastEventCreative\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"CM Creative (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:234:\"DCM creative name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventCreative</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"dcmLastEventCreativeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"CM Creative ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:234:\"DCM creative ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventCreativeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"dcmLastEventCreativeType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"CM Creative Type (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:243:\"DCM creative type name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventCreativeType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:26:\"dcmLastEventCreativeTypeId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"CM Creative Type ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:243:\"DCM creative type ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventCreativeTypeId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:27:\"dcmLastEventCreativeVersion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"CM Creative Version (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:244:\"DCM creative version of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventCreativeVersion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"dcmLastEventRenderingId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"CM Rendering ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:236:\"DCM rendering ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventRenderingId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"dcmLastEventSite\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"CM Site (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:271:\"Site name where the DCM creative was shown and clicked on for the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventSite</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dcmLastEventSiteId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"CM Site ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:275:\"DCM site ID where the DCM creative was shown and clicked on for the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventSiteId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:25:\"dcmLastEventSitePlacement\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"CM Placement (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:245:\"DCM site placement name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventSitePlacement</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:27:\"dcmLastEventSitePlacementId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"CM Placement ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:245:\"DCM site placement ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventSitePlacementId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"dcmLastEventSpotId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"CM Floodlight Configuration ID (CM Model)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:246:\"DCM Floodlight configuration ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).<br />Type: dimension.<br />API name: <code>ga:dcmLastEventSpotId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"dcmROAS\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"CM ROAS\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:110:\"DCM Return On Ad Spend (ROAS) (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmROAS</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dcmRPC\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"CM RPC\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:101:\"DCM Revenue Per Click (Analytics 360 only).<br />Type: metric.<br />API name: <code>ga:dcmRPC</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"DoubleClick Campaign Manager\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"deviceCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Device Category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:116:\"The type of device: desktop, tablet, or mobile.<br />Type: dimension.<br />API name: <code>ga:deviceCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"dfpClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"GAM Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"The number of times DFP ads were clicked on the site (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"dfpCoverage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"GAM Coverage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:336:\"Coverage is the percentage of ad requests that returned at least one ad. Generally, coverage can help identify sites where the DFP account isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100 (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpCoverage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dfpCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"GAM CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:179:\"The percentage of pageviews that resulted in a click on an DFP ad (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:7:\"dfpECPM\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"GAM eCPM\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:199:\"The effective cost per thousand pageviews. It is the DFP revenue per 1,000 pageviews (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpECPM</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"dfpImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"GAM Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:295:\"A DFP ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:24:\"dfpImpressionsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"GAM Impressions / Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:223:\"The ratio of DFP ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions) (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpImpressionsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:13:\"dfpLineItemId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"GAM Line Item Id\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:110:\"The ID of the Google Ad Manager line item.<br />Type: dimension.<br />API name: <code>ga:dfpLineItemId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"dfpLineItemName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"GAM Line Item Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:114:\"The name of the Google Ad Manager line item.<br />Type: dimension.<br />API name: <code>ga:dfpLineItemName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"DoubleClick for Publishers Backfill\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"dfpMonetizedPageviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"GAM Monetized Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:295:\"This measures the total number of pageviews on the property that were shown with an ad from the linked DFP account. Note that a single page can have multiple ad units (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpMonetizedPageviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"dfpRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"GAM Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:196:\"DFP revenue is an estimate of the total ad revenue based on served impressions (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:25:\"dfpRevenuePer1000Sessions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"GAM Revenue / 1000 Sessions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:281:\"The total estimated revenue from DFP ads per 1,000 Analytics sessions. Note that this metric is based on sessions to the site, not on ad impressions (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpRevenuePer1000Sessions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:29:\"dfpViewableImpressionsPercent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"GAM Viewable Impressions %\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:308:\"The percentage of viewable ad impressions. An impression is considered a viewable impression when it has appeared within users\' browsers and has the opportunity to be seen (DFP linking enabled and Hide DFP Revenue not enabled).<br />Type: metric.<br />API name: <code>ga:dfpViewableImpressionsPercent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DoubleClick for Publishers\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"dimensionXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Custom Dimension XX\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"The value of the requested custom dimension, where XX refers to the number or index of the custom dimension.<br />Type: dimension.<br />API name: <code>ga:dimensionXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Custom Variables or Columns\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"domainLookupTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Domain Lookup Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:147:\"The total time (in milliseconds) all samples spent in DNS lookup for this page.<br />Type: metric.<br />API name: <code>ga:domainLookupTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"domContentLoadedTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Document Content Loaded Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:550:\"The time (in milliseconds), including the network time from users\' locations to the site\'s server, the browser takes to parse the document and execute deferred and parser-inserted scripts (DOMContentLoaded). When parsing of the document is finished, the Document Object Model (DOM) is ready, but the referenced style sheets, images, and subframes may not be finished loading. This is often the starting point of Javascript framework execution, e.g., JQuery\'s onready() callback.<br />Type: metric.<br />API name: <code>ga:domContentLoadedTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"domInteractiveTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Document Interactive Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:326:\"The time (in milliseconds), including the network time from users\' locations to the site\'s server, the browser takes to parse the document (DOMInteractive). At this time, users can interact with the Document Object Model even though it is not fully loaded.<br />Type: metric.<br />API name: <code>ga:domInteractiveTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"domLatencyMetricsSample\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"DOM Latency Metrics Sample\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:258:\"Sample set (or count) of pageviews used to calculate the averages for site speed DOM metrics. This metric is used to calculate ga:avgDomContentLoadedTime and ga:avgDomInteractiveTime.<br />Type: metric.<br />API name: <code>ga:domLatencyMetricsSample</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"dsAdGroup\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"SA360 Ad Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:127:\"DS Ad Group (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsAdGroup</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"dsAdGroupId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"SA360 Ad Group ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:132:\"DS Ad Group ID (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsAdGroupId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"dsAdvertiser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"SA360 Advertiser\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:132:\"DS Advertiser (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsAdvertiser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"dsAdvertiserId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"SA360 Advertiser ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:137:\"DS Advertiser ID (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsAdvertiserId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"dsAgency\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"SA360 Agency\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:124:\"DS Agency (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsAgency</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"dsAgencyId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"SA360 Agency ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:129:\"DS Agency ID (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsAgencyId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"dsCampaign\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"SA360 Campaign\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:128:\"DS Campaign (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsCampaign</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"dsCampaignId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"SA360 Campaign ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:133:\"DS Campaign ID (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsCampaignId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"dsClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"SA360 Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:121:\"DS Clicks (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />API name: <code>ga:dsClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"dsCost\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"SA360 Cost\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:117:\"DS Cost (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />API name: <code>ga:dsCost</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:5:\"dsCPC\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"SA360 CPC\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:194:\"DS Cost to advertiser per click (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />Calculation: <code>ga:dsCost/ga:dsClicks</code>.<br />API name: <code>ga:dsCPC</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:5:\"dsCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"SA360 CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:191:\"DS Click Through Rate (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />Calculation: <code>ga:dsClicks/ga:dsImpressions</code>.<br />API name: <code>ga:dsCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"dsEngineAccount\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"SA360 Engine Account\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:139:\"DS Engine Account (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsEngineAccount</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"dsEngineAccountId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"SA360 Engine Account ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:144:\"DS Engine Account ID (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsEngineAccountId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"dsImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"SA360 Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:131:\"DS Impressions (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />API name: <code>ga:dsImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"dsKeyword\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"SA360 Keyword\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:126:\"DS Keyword (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsKeyword</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"dsKeywordId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"SA360 Keyword ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:131:\"DS Keyword ID (Analytics 360 only, requires integration with DS).<br />Type: dimension.<br />API name: <code>ga:dsKeywordId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"dsProfit\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"SA360 Profit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:207:\"DS Profie (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />Calculation: <code>(ga:transactionRevenue + ga:goalValueAll - ga:dsCost)</code>.<br />API name: <code>ga:dsProfit</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"dsReturnOnAdSpend\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"SA360 ROAS\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:228:\"DS Return On Ad Spend (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />Calculation: <code>(ga:transactionRevenue + ga:goalValueAll) / ga:dsCost</code>.<br />API name: <code>ga:dsReturnOnAdSpend</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"dsRevenuePerClick\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"SA360 RPC\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:229:\"DS Revenue Per Click (Analytics 360 only, requires integration with DS).<br />Type: metric.<br />Calculation: <code>(ga:transactionRevenue + ga:goalValueAll) / ga:dsClicks</code>.<br />API name: <code>ga:dsRevenuePerClick</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"DoubleClick Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"entranceRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Entrances / Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:188:\"The percentage of pageviews in which this page was the entrance.<br />Type: metric.<br />Calculation: <code>ga:entrances / ga:pageviews</code>.<br />API name: <code>ga:entranceRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"entrances\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entrances\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:182:\"The number of entrances to the property measured as the first pageview in a session, typically used with landingPagePath.<br />Type: metric.<br />API name: <code>ga:entrances</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"eventAction\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Event Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:79:\"Event action.<br />Type: dimension.<br />API name: <code>ga:eventAction</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"eventCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:87:\"The event category.<br />Type: dimension.<br />API name: <code>ga:eventCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"eventLabel\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Event Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:77:\"Event label.<br />Type: dimension.<br />API name: <code>ga:eventLabel</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:25:\"eventsPerSessionWithEvent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Events / Session with Event\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:199:\"The average number of events per session with event.<br />Type: metric.<br />Calculation: <code>ga:totalEvents / ga:sessionsWithEvent</code>.<br />API name: <code>ga:eventsPerSessionWithEvent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"eventValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Event Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:100:\"Total value of events for the profile.<br />Type: metric.<br />API name: <code>ga:eventValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"exceptionDescription\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Exception Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:109:\"The description for the exception.<br />Type: dimension.<br />API name: <code>ga:exceptionDescription</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Exceptions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"exceptions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Exceptions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:112:\"The number of exceptions sent to Google Analytics.<br />Type: metric.<br />API name: <code>ga:exceptions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Exceptions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"exceptionsPerScreenview\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Exceptions / Screen\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:207:\"The number of exceptions thrown divided by the number of screenviews.<br />Type: metric.<br />Calculation: <code>ga:exceptions / ga:screenviews</code>.<br />API name: <code>ga:exceptionsPerScreenview</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Exceptions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"exitPagePath\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Exit Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:113:\"The last page or exit page in users\' sessions.<br />Type: dimension.<br />API name: <code>ga:exitPagePath</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"exitRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"% Exit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:218:\"The percentage of exits from the property that occurred out of the total pageviews.<br />Type: metric.<br />Calculation: <code>ga:exits / (ga:pageviews + ga:screenviews)</code>.<br />API name: <code>ga:exitRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:5:\"exits\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Exits\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:95:\"The number of exits from the property.<br />Type: metric.<br />API name: <code>ga:exits</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"exitScreenName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Exit Screen\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:127:\"The name of the screen where users exited the application.<br />Type: dimension.<br />API name: <code>ga:exitScreenName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"experimentCombination\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Experiment ID with Variant\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:173:\"The user-scoped ID of the experiment and variant that users were exposed to during an experiment.<br />Type: dimension.<br />API name: <code>ga:experimentCombination</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Content Experiments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"experimentId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Experiment ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:170:\"The user-scoped ID of the content experiment that users were exposed to when the metrics were reported.<br />Type: dimension.<br />API name: <code>ga:experimentId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Content Experiments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"experimentVariant\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Variant\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:172:\"The user-scoped ID of the particular variant that users were exposed to during a content experiment.<br />Type: dimension.<br />API name: <code>ga:experimentVariant</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Content Experiments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"fatalExceptions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Crashes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:121:\"The number of exceptions where isFatal is set to true.<br />Type: metric.<br />API name: <code>ga:fatalExceptions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Exceptions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:28:\"fatalExceptionsPerScreenview\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Crashes / Screen\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:223:\"The number of fatal exceptions thrown divided by the number of screenviews.<br />Type: metric.<br />Calculation: <code>ga:fatalExceptions / ga:screenviews</code>.<br />API name: <code>ga:fatalExceptionsPerScreenview</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Exceptions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"flashVersion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Flash Version\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:144:\"The version of Flash, including minor versions, supported by users\' browsers.<br />Type: dimension.<br />API name: <code>ga:flashVersion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"fullReferrer\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Full Referrer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:122:\"The full referring URL including the hostname and path.<br />Type: dimension.<br />API name: <code>ga:fullReferrer</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"goalAbandonRateAll\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Total Abandonment Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:190:\"Goal abandonment rate.<br />Type: metric.<br />Calculation: <code>((ga:goalStartsAll - ga:goalCompletionsAll)) / (ga:goalStartsAll)</code>.<br />API name: <code>ga:goalAbandonRateAll</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"goalAbandonsAll\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Abandoned Funnels\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:223:\"The overall number of times users started goals without actually completing them.<br />Type: metric.<br />Calculation: <code>(ga:goalStartsAll - ga:goalCompletionsAll)</code>.<br />API name: <code>ga:goalAbandonsAll</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:22:\"goalCompletionLocation\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Goal Completion Location\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:156:\"The page path or screen name that matched any destination type goal completion.<br />Type: dimension.<br />API name: <code>ga:goalCompletionLocation</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"goalCompletionsAll\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Completions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:135:\"Total number of completions for all goals defined in the profile.<br />Type: metric.<br />API name: <code>ga:goalCompletionsAll</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"goalConversionRateAll\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Goal Conversion Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:228:\"The percentage of sessions which resulted in a conversion to at least one of the goals.<br />Type: metric.<br />Calculation: <code>ga:goalCompletionsAll / ga:sessions</code>.<br />API name: <code>ga:goalConversionRateAll</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"goalPreviousStep1\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Goal Previous Step - 1\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:188:\"The page path or screen name that matched any destination type goal, one step prior to the goal completion location.<br />Type: dimension.<br />API name: <code>ga:goalPreviousStep1</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"goalPreviousStep2\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Goal Previous Step - 2\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:189:\"The page path or screen name that matched any destination type goal, two steps prior to the goal completion location.<br />Type: dimension.<br />API name: <code>ga:goalPreviousStep2</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"goalPreviousStep3\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Goal Previous Step - 3\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:191:\"The page path or screen name that matched any destination type goal, three steps prior to the goal completion location.<br />Type: dimension.<br />API name: <code>ga:goalPreviousStep3</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"goalStartsAll\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Goal Starts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:125:\"Total number of starts for all goals defined in the profile.<br />Type: metric.<br />API name: <code>ga:goalStartsAll</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"goalValueAll\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Goal Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:121:\"Total numeric value for all goals defined in the profile.<br />Type: metric.<br />API name: <code>ga:goalValueAll</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"goalValueAllPerSearch\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Per Search Goal Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:175:\"The average goal value of a search.<br />Type: metric.<br />Calculation: <code>ga:goalValueAll / ga:searchUniques</code>.<br />API name: <code>ga:goalValueAllPerSearch</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"goalValuePerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Per Session Goal Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"The average goal value of a session.<br />Type: metric.<br />Calculation: <code>ga:goalValueAll / ga:sessions</code>.<br />API name: <code>ga:goalValuePerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"goalXXAbandonRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Goal XX Abandonment Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:222:\"The rate at which the requested goal number was abandoned.<br />Type: metric.<br />Calculation: <code>((ga:goalXXStarts - ga:goalXXCompletions)) / (ga:goalXXStarts)</code>.<br />API name: <code>ga:goalXXAbandonRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"goalXXAbandons\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Goal XX Abandoned Funnels\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:253:\"The number of times users started conversion activity on the requested goal number without actually completing it.<br />Type: metric.<br />Calculation: <code>(ga:goalXXStarts - ga:goalXXCompletions)</code>.<br />API name: <code>ga:goalXXAbandons</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"goalXXCompletions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Goal XX Completions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:131:\"The total number of completions for the requested goal number.<br />Type: metric.<br />API name: <code>ga:goalXXCompletions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"goalXXConversionRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Goal XX Conversion Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:217:\"Percentage of sessions resulting in a conversion to the requested goal number.<br />Type: metric.<br />Calculation: <code>ga:goalXXCompletions / ga:sessions</code>.<br />API name: <code>ga:goalXXConversionRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"goalXXStarts\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Goal XX Starts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:121:\"The total number of starts for the requested goal number.<br />Type: metric.<br />API name: <code>ga:goalXXStarts</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"goalXXValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Goal XX Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:117:\"The total numeric value for the requested goal number.<br />Type: metric.<br />API name: <code>ga:goalXXValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Goal Conversions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"hasSocialSourceReferral\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Social Source Referral\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:175:\"A boolean, either Yes or No, indicates whether sessions to the property are from a social source.<br />Type: dimension.<br />API name: <code>ga:hasSocialSourceReferral</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:4:\"hits\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Hits\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:316:\"Total number of hits for the view (profile). This metric sums all hit types, including pageview, custom event, ecommerce, and other types. Because this metric is based on the view (profile), not on the property, it is not the same as the property\'s hit volume.<br />Type: metric.<br />API name: <code>ga:hits</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:8:\"hostname\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Hostname\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:117:\"The hostname from which the tracking request was made.<br />Type: dimension.<br />API name: <code>ga:hostname</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:4:\"hour\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Hour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:561:\"A two-digit hour of the day ranging from 00-23 in the timezone configured for the account. This value is also corrected for daylight savings time. If the timezone follows daylight savings time, there will be an apparent bump in the number of sessions during the changeover hour (e.g., between 1:00 and 2:00) for the day per year when that hour repeats. A corresponding hour with zero sessions will occur at the opposite changeover. (Google Analytics does not track user time more precisely than hours.)<br />Type: dimension.<br />API name: <code>ga:hour</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"impressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:100:\"Total number of campaign impressions.<br />Type: metric.<br />API name: <code>ga:impressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:24:\"interestAffinityCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Affinity Category (reach)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"Indicates that users are more likely to be interested in learning about the specified category.<br />Type: dimension.<br />API name: <code>ga:interestAffinityCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Audience\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"interestInMarketCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"In-Market Segment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:187:\"Indicates that users are more likely to be ready to purchase products or services in the specified category.<br />Type: dimension.<br />API name: <code>ga:interestInMarketCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Audience\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"interestOtherCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Other Category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:212:\"Indicates that users are more likely to be interested in learning about the specified category, and more likely to be ready to purchase.<br />Type: dimension.<br />API name: <code>ga:interestOtherCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Audience\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"internalPromotionClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Internal Promotion Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:142:\"The number of clicks on an internal promotion (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:internalPromotionClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:25:\"internalPromotionCreative\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Internal Promotion Creative\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:147:\"The creative content designed for a promotion (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:internalPromotionCreative</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"internalPromotionCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Internal Promotion CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:310:\"The rate at which users clicked through to view the internal promotion (ga:internalPromotionClicks / ga:internalPromotionViews) - (Enhanced Ecommerce).<br />Type: metric.<br />Calculation: <code>ga:internalPromotionClicks / ga:internalPromotionViews</code>.<br />API name: <code>ga:internalPromotionCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"internalPromotionId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Internal Promotion ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:119:\"The ID of the promotion (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:internalPromotionId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"internalPromotionName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Internal Promotion Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:123:\"The name of the promotion (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:internalPromotionName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:25:\"internalPromotionPosition\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Internal Promotion Position\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"The position of the promotion on the web page or application screen (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:internalPromotionPosition</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"internalPromotionViews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Internal Promotion Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:140:\"The number of views of an internal promotion (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:internalPromotionViews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:7:\"isoWeek\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"ISO Week of the Year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:267:\"ISO week number, where each week starts on Monday. For details, see http://en.wikipedia.org/wiki/ISO_week_date. ga:isoWeek should only be used with ga:isoYear because ga:year represents Gregorian calendar.<br />Type: dimension.<br />API name: <code>ga:isoWeek</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"isoYear\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"ISO Year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:245:\"The ISO year of the session. For details, see http://en.wikipedia.org/wiki/ISO_week_date. ga:isoYear should only be used with ga:isoWeek because ga:week represents Gregorian calendar.<br />Type: dimension.<br />API name: <code>ga:isoYear</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"isoYearIsoWeek\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"ISO Week of ISO Year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:114:\"Combined values of ga:isoYear and ga:isoWeek.<br />Type: dimension.<br />API name: <code>ga:isoYearIsoWeek</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"isTrueViewVideoAd\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"TrueView Video Ad\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:152:\"A boolean, Yes or No, indicating whether the ad is an AdWords TrueView video ad.<br />Type: dimension.<br />API name: <code>ga:isTrueViewVideoAd</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"itemQuantity\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Quantity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"Total number of items purchased. For example, if users purchase 2 frisbees and 5 tennis balls, this will be 7.<br />Type: metric.<br />API name: <code>ga:itemQuantity</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"itemRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Product Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:110:\"The total revenue from purchased product items.<br />Type: metric.<br />API name: <code>ga:itemRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:16:\"itemsPerPurchase\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Avg. QTY\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:209:\"The average quantity of this item (or group of items) sold per purchase.<br />Type: metric.<br />Calculation: <code>ga:itemQuantity / ga:uniquePurchases</code>.<br />API name: <code>ga:itemsPerPurchase</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"javaEnabled\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Java Support\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:149:\"A boolean, either Yes or No, indicating whether Java is enabled in users\' browsers.<br />Type: dimension.<br />API name: <code>ga:javaEnabled</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"keyword\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Keyword\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:513:\"For manual campaign tracking, it is the value of the utm_term campaign tracking parameter. For AdWords traffic, it contains the best matching targeting criteria. For the display network, where multiple targeting criteria could have caused the ad to show up, it returns the best matching targeting criteria as selected by Ads. This could be display_keyword, site placement, boomuserlist, user_interest, age, or gender. Otherwise its value is (not set).<br />Type: dimension.<br />API name: <code>ga:keyword</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:21:\"landingContentGroupXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Landing Page Group XX\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:114:\"Content group of users\' landing pages.<br />Type: dimension.<br />API name: <code>ga:landingContentGroupXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Content Grouping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"landingPagePath\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Landing Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:125:\"The first page in users\' sessions, or the landing page.<br />Type: dimension.<br />API name: <code>ga:landingPagePath</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"landingScreenName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Landing Screen\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:108:\"The name of the first viewed screen.<br />Type: dimension.<br />API name: <code>ga:landingScreenName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"language\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:180:\"The language, in ISO-639 code format (e.g., en-gb for British English), provided by the HTTP Request for the browser.<br />Type: dimension.<br />API name: <code>ga:language</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"latitude\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Latitude\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:271:\"The approximate latitude of users\' city, derived from their IP addresses or Geographical IDs. Locations north of the equator have positive latitudes and locations south of the equator have negative latitudes.<br />Type: dimension.<br />API name: <code>ga:latitude</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"localItemRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Local Product Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:102:\"Product revenue in local currency.<br />Type: metric.<br />API name: <code>ga:localItemRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:24:\"localProductRefundAmount\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Local Product Refund Amount\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:149:\"Refund amount in local currency for a given product (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:localProductRefundAmount</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"localRefundAmount\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Local Refund Amount\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:148:\"Total refund amount in local currency for the transaction (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:localRefundAmount</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"localTransactionRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Local Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:113:\"Transaction revenue in local currency.<br />Type: metric.<br />API name: <code>ga:localTransactionRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:24:\"localTransactionShipping\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Local Shipping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:120:\"Transaction shipping cost in local currency.<br />Type: metric.<br />API name: <code>ga:localTransactionShipping</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"localTransactionTax\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Local Tax\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:105:\"Transaction tax in local currency.<br />Type: metric.<br />API name: <code>ga:localTransactionTax</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"longitude\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Longitude\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:287:\"The approximate longitude of users\' city, derived from their IP addresses or Geographical IDs. Locations east of the prime meridian have positive longitudes and locations west of the prime meridian have negative longitudes.<br />Type: dimension.<br />API name: <code>ga:longitude</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:6:\"medium\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Medium\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:440:\"The type of referrals. For manual campaign tracking, it is the value of the utm_medium campaign tracking parameter. For AdWords autotagging, it is cpc. If users came from a search engine detected by Google Analytics, it is organic. If the referrer is not a search engine, it is referral. If users came directly to the property and document.referrer is empty, its value is (none).<br />Type: dimension.<br />API name: <code>ga:medium</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"metricXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Custom Metric XX Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:236:\"The value of the requested custom metric, where XX refers to the number or index of the custom metric. Note that the data type of ga:metricXX can be INTEGER, CURRENCY, or TIME.<br />Type: metric.<br />API name: <code>ga:metricXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Custom Variables or Columns\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:5:\"metro\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Metro\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:120:\"The Designated Market Area (DMA) from where traffic arrived.<br />Type: dimension.<br />API name: <code>ga:metro</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"metroId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Metro Id\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:193:\"The three digit Designated Market Area (DMA) code from where traffic arrived, derived from users\' IP addresses or Geographical IDs.<br />Type: dimension.<br />API name: <code>ga:metroId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:6:\"minute\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Minute\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:113:\"Returns the minutes, between 00 and 59, in the hour.<br />Type: dimension.<br />API name: <code>ga:minute</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"mobileDeviceBranding\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Mobile Device Branding\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:111:\"Mobile manufacturer or branded name.<br />Type: dimension.<br />API name: <code>ga:mobileDeviceBranding</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"mobileDeviceInfo\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Mobile Device Info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:146:\"The branding, model, and marketing name used to identify the mobile device.<br />Type: dimension.<br />API name: <code>ga:mobileDeviceInfo</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:25:\"mobileDeviceMarketingName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Mobile Device Marketing Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:126:\"The marketing name used for the mobile device.<br />Type: dimension.<br />API name: <code>ga:mobileDeviceMarketingName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"mobileDeviceModel\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Mobile Device Model\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:92:\"Mobile device model.<br />Type: dimension.<br />API name: <code>ga:mobileDeviceModel</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:19:\"mobileInputSelector\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Mobile Input Selector\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:159:\"Selector (e.g., touchscreen, joystick, clickwheel, stylus) used on the mobile device.<br />Type: dimension.<br />API name: <code>ga:mobileInputSelector</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:5:\"month\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Month of the year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:116:\"Month of the session, a two digit integer from 01 to 12.<br />Type: dimension.<br />API name: <code>ga:month</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"networkDomain\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Network Domain\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:163:\"The domain name of users\' ISP, derived from the domain name registered to the ISP\'s IP address.<br />Type: dimension.<br />API name: <code>ga:networkDomain</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"networkLocation\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Service Provider\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:277:\"The names of the service providers used to reach the property. For example, if most users of the website come via the major cable internet service providers, its value will be these service providers\' names.<br />Type: dimension.<br />API name: <code>ga:networkLocation</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"newUsers\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"New Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:117:\"The number of sessions marked as a user\'s first sessions.<br />Type: metric.<br />API name: <code>ga:newUsers</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"nthDay\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Day Index\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:216:\"The index for each day in the specified date range. The index for the first day (i.e., start-date) in the date range is 0, for the second day 1, and so on.<br />Type: dimension.<br />API name: <code>ga:nthDay</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"nthHour\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Hour Index\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:235:\"The index for each hour in the specified date range. The index for the first hour of the first day (i.e., start-date) in the date range is 0, for the next hour 1, and so on.<br />Type: dimension.<br />API name: <code>ga:nthHour</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"nthMinute\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Minute Index\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:243:\"The index for each minute in the specified date range. The index for the first minute of the first day (i.e., start-date) in the date range is 0, for the next minute 1, and so on.<br />Type: dimension.<br />API name: <code>ga:nthMinute</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"nthMonth\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Month Index\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:203:\"The index for a month in the specified date range. In the date range, the index for the first month is 0, for the second month 1, and so on.<br />Type: dimension.<br />API name: <code>ga:nthMonth</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:7:\"nthWeek\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Week Index\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:240:\"The index for each week in the specified date range. The index for the first week in the date range is 0, for the second week 1, and so on. The index corresponds to week entries.<br />Type: dimension.<br />API name: <code>ga:nthWeek</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"operatingSystem\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operating System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:142:\"Users\' operating system, for example, Windows, Linux, Macintosh, or iOS.<br />Type: dimension.<br />API name: <code>ga:operatingSystem</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"operatingSystemVersion\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Operating System Version\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:157:\"The version of users\' operating system, i.e., XP for Windows, PPC for Macintosh.<br />Type: dimension.<br />API name: <code>ga:operatingSystemVersion</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Platform or Device\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"orderCouponCode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Order Coupon Code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:123:\"Code for the order-level coupon (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:orderCouponCode</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"organicSearches\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Organic Searches\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:159:\"The number of organic searches happened in a session. This metric is search engine agnostic.<br />Type: metric.<br />API name: <code>ga:organicSearches</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"pageDepth\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Page Depth\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:315:\"The number of pages visited by users during a session. The value is a histogram that counts pageviews across a range of possible values. In this calculation, all sessions will have at least one pageview, and some percentage of sessions will have more.<br />Type: dimension.<br />API name: <code>ga:pageDepth</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"pageDownloadTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Page Download Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:141:\"The total time (in milliseconds) to download this page among all samples.<br />Type: metric.<br />API name: <code>ga:pageDownloadTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"pageLoadSample\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Page Load Sample\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:150:\"The sample set (or count) of pageviews used to calculate the average page load time.<br />Type: metric.<br />API name: <code>ga:pageLoadSample</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"pageLoadTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Page Load Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:231:\"Total time (in milliseconds), from pageview initiation (e.g., a click on a page link) to page load completion in the browser, the pages in the sample set take to load.<br />Type: metric.<br />API name: <code>ga:pageLoadTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:8:\"pagePath\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:178:\"A page on the website specified by path and/or query parameters. Use this with hostname to get the page\'s full URL.<br />Type: dimension.<br />API name: <code>ga:pagePath</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"pagePathLevel1\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Page path level 1\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:156:\"This dimension rolls up all the page paths in the first hierarchical level in pagePath.<br />Type: dimension.<br />API name: <code>ga:pagePathLevel1</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"pagePathLevel2\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Page path level 2\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:157:\"This dimension rolls up all the page paths in the second hierarchical level in pagePath.<br />Type: dimension.<br />API name: <code>ga:pagePathLevel2</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"pagePathLevel3\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Page path level 3\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:156:\"This dimension rolls up all the page paths in the third hierarchical level in pagePath.<br />Type: dimension.<br />API name: <code>ga:pagePathLevel3</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"pagePathLevel4\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Page path level 4\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:264:\"This dimension rolls up all the page paths into hierarchical levels. Up to 4 pagePath levels maybe specified. All additional levels in the pagePath hierarchy are also rolled up in this dimension.<br />Type: dimension.<br />API name: <code>ga:pagePathLevel4</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"pageTitle\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Page Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:128:\"The page\'s title. Multiple pages might have the same page title.<br />Type: dimension.<br />API name: <code>ga:pageTitle</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"pageValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Page Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:190:\"The average value of this page or set of pages, which is equal to (ga:transactionRevenue + ga:goalValueAll) / ga:uniquePageviews.<br />Type: metric.<br />API name: <code>ga:pageValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:9:\"pageviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:108:\"The total number of pageviews for the property.<br />Type: metric.<br />API name: <code>ga:pageviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"pageviewsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Pages / Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:225:\"The average number of pages viewed during a session, including repeated views of a single page.<br />Type: metric.<br />Calculation: <code>ga:pageviews / ga:sessions</code>.<br />API name: <code>ga:pageviewsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"percentNewSessions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"% New Sessions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:206:\"The percentage of sessions by users who had never visited the property before.<br />Type: metric.<br />Calculation: <code>ga:newUsers / ga:sessions</code>.<br />API name: <code>ga:percentNewSessions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:24:\"percentSearchRefinements\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"% Search Refinements\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:279:\"The percentage of the number of times a refinement (i.e., transition) occurs between internal keywords search within a session.<br />Type: metric.<br />Calculation: <code>ga:searchRefinements / ga:searchResultViews</code>.<br />API name: <code>ga:percentSearchRefinements</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:25:\"percentSessionsWithSearch\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"% Sessions with Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:180:\"The percentage of sessions with search.<br />Type: metric.<br />Calculation: <code>ga:searchSessions / ga:sessions</code>.<br />API name: <code>ga:percentSessionsWithSearch</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:22:\"previousContentGroupXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Previous Page Group XX\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:147:\"Refers to content group that was visited before another content group.<br />Type: dimension.<br />API name: <code>ga:previousContentGroupXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Content Grouping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"previousPagePath\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Previous Page Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:171:\"A page visited before another page on the same property, typically used with the pagePath dimension.<br />Type: dimension.<br />API name: <code>ga:previousPagePath</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"productAddsToCart\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Product Adds To Cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:149:\"Number of times the product was added to the shopping cart (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productAddsToCart</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"productBrand\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Product Brand\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:135:\"The brand name under which the product is sold (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:productBrand</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"productCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Product Category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:204:\"Any product variation (size, color) supplied by the ecommerce application for purchased items, not compatible with Enhanced Ecommerce.<br />Type: dimension.<br />API name: <code>ga:productCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"productCategoryHierarchy\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Product Category (Enhanced Ecommerce)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:161:\"The hierarchical category in which the product is classified (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:productCategoryHierarchy</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:22:\"productCategoryLevelXX\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Product Category Level XX\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:167:\"Level (1-5) in the product category hierarchy, starting from the top (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:productCategoryLevelXX</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"productCheckouts\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product Checkouts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:155:\"Number of times the product was included in the check-out process (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productCheckouts</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"productCouponCode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Product Coupon Code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:127:\"Code for the product-level coupon (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:productCouponCode</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"productDetailViews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Product Detail Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:144:\"Number of times users viewed the product-detail page (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productDetailViews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"productListClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Product List Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"Number of times users clicked the product when it appeared in the product list (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productListClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"productListCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Product List CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:282:\"The rate at which users clicked through on the product in a product list (ga:productListClicks / ga:productListViews) - (Enhanced Ecommerce).<br />Type: metric.<br />Calculation: <code>ga:productListClicks / ga:productListViews</code>.<br />API name: <code>ga:productListCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"productListName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Product List Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:149:\"The name of the product list in which the product appears (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:productListName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:19:\"productListPosition\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Product List Position\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:143:\"The position of the product in the product list (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:productListPosition</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"productListViews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Product List Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:144:\"Number of times the product appeared in a product list (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productListViews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"productName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Product\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:152:\"The product name, supplied by the ecommerce tracking application, for purchased items.<br />Type: dimension.<br />API name: <code>ga:productName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:19:\"productRefundAmount\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Product Refund Amount\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:140:\"Total refund amount associated with the product (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productRefundAmount</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"productRefunds\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Product Refunds\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:139:\"Number of times a refund was issued for the product (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productRefunds</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:22:\"productRemovesFromCart\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Product Removes From Cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:158:\"Number of times the product was removed from the shopping cart (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:productRemovesFromCart</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:25:\"productRevenuePerPurchase\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Product Revenue per Purchase\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:284:\"Average product revenue per purchase (commonly used with Product Coupon Code) (ga:itemRevenue / ga:uniquePurchases) - (Enhanced Ecommerce).<br />Type: metric.<br />Calculation: <code>ga:itemRevenue / ga:uniquePurchases</code>.<br />API name: <code>ga:productRevenuePerPurchase</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"productSku\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Product SKU\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:149:\"The product SKU, defined in the ecommerce tracking application, for purchased items.<br />Type: dimension.<br />API name: <code>ga:productSku</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"productVariant\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Product Variant\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:192:\"The specific variation of a product, e.g., XS, S, M, L for size; or Red, Blue, Green, Black for color (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:productVariant</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:19:\"quantityAddedToCart\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Quantity Added To Cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:143:\"Number of product units added to the shopping cart (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:quantityAddedToCart</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"quantityCheckedOut\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Quantity Checked Out\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:137:\"Number of product units included in check out (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:quantityCheckedOut</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:16:\"quantityRefunded\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Quantity Refunded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:122:\"Number of product units refunded (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:quantityRefunded</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"quantityRemovedFromCart\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Quantity Removed From Cart\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:149:\"Number of product units removed from a shopping cart (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:quantityRemovedFromCart</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"redirectionTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Redirection Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:195:\"The total time (in milliseconds) all samples spent in redirects before fetching this page. If there are no redirects, this is 0.<br />Type: metric.<br />API name: <code>ga:redirectionTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"referralPath\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Referral Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:242:\"The path of the referring URL (e.g., document.referrer). If someone places on their webpage a link to the property, this is the path of the page containing the referring link.<br />Type: dimension.<br />API name: <code>ga:referralPath</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"refundAmount\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Refund Amount\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:128:\"Currency amount refunded for a transaction (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:refundAmount</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:6:\"region\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Region\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:181:\"Users\' region, derived from their IP addresses or Geographical IDs. In U.S., a region is a state, New York, for example.<br />Type: dimension.<br />API name: <code>ga:region</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"regionId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Region ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:324:\"Users\' region ID, derived from their IP addresses or Geographical IDs. In U.S., a region is a state, New York, for example. The region IDs are the same as the Criteria IDs listed at https://developers.google.com/analytics/devguides/collection/protocol/v1/geoid.<br />Type: dimension.<br />API name: <code>ga:regionId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"regionIsoCode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Region ISO Code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:165:\"Users\' region ISO code in ISO-3166-2 format, derived from their IP addresses or Geographical IDs.<br />Type: dimension.<br />API name: <code>ga:regionIsoCode</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"revenuePerItem\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Avg. Price\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:160:\"The average revenue per item.<br />Type: metric.<br />Calculation: <code>ga:itemRevenue / ga:itemQuantity</code>.<br />API name: <code>ga:revenuePerItem</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"revenuePerTransaction\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Avg. Order Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:193:\"The average revenue of an ecommerce transaction.<br />Type: metric.<br />Calculation: <code>ga:transactionRevenue / ga:transactions</code>.<br />API name: <code>ga:revenuePerTransaction</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"revenuePerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Revenue per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"The total sale revenue (excluding shipping and tax) of the transaction divided by the total number of users.<br />Type: metric.<br />API name: <code>ga:revenuePerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:4:\"ROAS\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"ROAS\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:252:\"Return On Ad Spend (ROAS) is the total transaction revenue and goal value divided by derived advertising cost.<br />Type: metric.<br />Calculation: <code>(ga:transactionRevenue + ga:goalValueAll) / ga:adCost</code>.<br />API name: <code>ga:ROAS</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:3:\"RPC\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"RPC\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:283:\"RPC or revenue-per-click, the average revenue (from ecommerce sales and/or goal value) you received for each click on one of the search ads.<br />Type: metric.<br />Calculation: <code>(ga:transactionRevenue + ga:goalValueAll) / ga:adClicks</code>.<br />API name: <code>ga:RPC</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Adwords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"screenColors\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Screen Colors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:198:\"The color depth of users\' monitors, retrieved from the DOM of users\' browsers. For example, 4-bit, 8-bit, 24-bit, or undefined-bit.<br />Type: dimension.<br />API name: <code>ga:screenColors</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"screenDepth\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Screen Depth\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:151:\"The number of screenviews (reported as a string) per session, useful for historgrams.<br />Type: dimension.<br />API name: <code>ga:screenDepth</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"screenName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Screen Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:88:\"The name of the screen.<br />Type: dimension.<br />API name: <code>ga:screenName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"screenResolution\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Screen Resolution\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:123:\"Resolution of users\' screens, for example, 1024x738.<br />Type: dimension.<br />API name: <code>ga:screenResolution</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"screenviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Screen Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:95:\"The total number of screenviews.<br />Type: metric.<br />API name: <code>ga:screenviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"screenviewsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Screens / Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:180:\"The average number of screenviews per session.<br />Type: metric.<br />Calculation: <code>ga:screenviews / ga:sessions</code>.<br />API name: <code>ga:screenviewsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:26:\"searchAfterDestinationPage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Search Destination Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:157:\"The page that users visited after performing an internal search on the site.<br />Type: dimension.<br />API name: <code>ga:searchAfterDestinationPage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"searchCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Site Search Category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:239:\"The category used for the internal search if site search categories are enabled in the view. For example, the product category may be electronics, furniture, or clothing.<br />Type: dimension.<br />API name: <code>ga:searchCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:11:\"searchDepth\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Search Depth\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:160:\"The total number of subsequent page views made after a use of the site\'s internal search feature.<br />Type: metric.<br />API name: <code>ga:searchDepth</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"searchDestinationPage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Destination Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:200:\"The page users immediately visited after performing an internal search on the site. This is usually the search results page.<br />Type: dimension.<br />API name: <code>ga:searchDestinationPage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"searchDuration\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Time after Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:135:\"The session duration when the site\'s internal search feature is used.<br />Type: metric.<br />API name: <code>ga:searchDuration</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"searchExitRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"% Search Exits\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:212:\"The percentage of searches that resulted in an immediate exit from the property.<br />Type: metric.<br />Calculation: <code>ga:searchExits / ga:searchUniques</code>.<br />API name: <code>ga:searchExitRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"searchExits\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Search Exits\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:175:\"The number of exits on the site that occurred following a search result from the site\'s internal search feature.<br />Type: metric.<br />API name: <code>ga:searchExits</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:27:\"searchGoalConversionRateAll\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Site Search Goal Conversion Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:297:\"The percentage of search sessions (i.e., sessions that included at least one search) which resulted in a conversion to at least one of the goals.<br />Type: metric.<br />Calculation: <code>ga:goalCompletionsAll / ga:searchUniques</code>.<br />API name: <code>ga:searchGoalConversionRateAll</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:26:\"searchGoalXXConversionRate\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Site Search Goal XX Conversion Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:295:\"The percentage of search sessions (i.e., sessions that included at least one search) which resulted in a conversion to the requested goal number.<br />Type: metric.<br />Calculation: <code>ga:goalXXCompletions / ga:searchUniques</code>.<br />API name: <code>ga:searchGoalXXConversionRate</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:11:\"ga_standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:13:\"searchKeyword\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search Term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:105:\"Search term used within the property.<br />Type: dimension.<br />API name: <code>ga:searchKeyword</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"searchKeywordRefinement\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Refined Keyword\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:172:\"Subsequent keyword search term or string entered by users after a given initial string search.<br />Type: dimension.<br />API name: <code>ga:searchKeywordRefinement</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"searchRefinements\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Search Refinements\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:347:\"The total number of times a refinement (transition) occurs between internal keywords search within a session. For example, if the sequence of keywords is \"shoes\", \"shoes\", \"pants\", \"pants\", this metric will be one because the transition between \"shoes\" and \"pants\" is different.<br />Type: metric.<br />API name: <code>ga:searchRefinements</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"searchResultViews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Results Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:121:\"The number of times a search result page was viewed.<br />Type: metric.<br />API name: <code>ga:searchResultViews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"searchSessions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Sessions with Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:128:\"The total number of sessions that included an internal search.<br />Type: metric.<br />API name: <code>ga:searchSessions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"searchStartPage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Start Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:120:\"The page where users initiated an internal search.<br />Type: dimension.<br />API name: <code>ga:searchStartPage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"searchUniques\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Total Unique Searches\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:231:\"Total number of unique keywords from internal searches within a session. For example, if \"shoes\" was searched for 3 times in a session, it would be counted only once.<br />Type: metric.<br />API name: <code>ga:searchUniques</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"searchUsed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Site Search Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:199:\"A boolean, either Visits With Site Search or Visits Without Site Search, to distinguish whether internal search was used in a session.<br />Type: dimension.<br />API name: <code>ga:searchUsed</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Internal Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:14:\"secondPagePath\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Second Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:104:\"The second page in users\' sessions.<br />Type: dimension.<br />API name: <code>ga:secondPagePath</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"serverConnectionTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Server Connection Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:165:\"Total time (in milliseconds) all samples spent in establishing a TCP connection to this page.<br />Type: metric.<br />API name: <code>ga:serverConnectionTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"serverResponseTime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Server Response Time (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:243:\"The total time (in milliseconds) the site\'s server takes to respond to users\' requests among all samples; this includes the network time from users\' locations to the server.<br />Type: metric.<br />API name: <code>ga:serverResponseTime</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"sessionCount\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Count of Sessions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:391:\"The session index for a user. Each session from a unique user will get its own incremental index starting from 1 for the first session. Subsequent sessions do not change previous session indices. For example, if a user has 4 sessions to the website, sessionCount for that user will have 4 distinct values of \'1\' through \'4\'.<br />Type: dimension.<br />API name: <code>ga:sessionCount</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"sessionDuration\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Session Duration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:114:\"Total duration (in seconds) of users\' sessions.<br />Type: metric.<br />API name: <code>ga:sessionDuration</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"sessionDurationBucket\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Session Duration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:177:\"The length (returned as a string) of a session measured in seconds and reported in second increments.<br />Type: dimension.<br />API name: <code>ga:sessionDurationBucket</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"sessions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Sessions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:89:\"The total number of sessions.<br />Type: metric.<br />API name: <code>ga:sessions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"sessionsPerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Number of Sessions per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:133:\"The total number of sessions divided by the total number of users.<br />Type: metric.<br />API name: <code>ga:sessionsPerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"sessionsToTransaction\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Sessions to Transaction\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:177:\"The number of sessions between users\' purchases and the related campaigns that lead to the purchases.<br />Type: dimension.<br />API name: <code>ga:sessionsToTransaction</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:17:\"sessionsWithEvent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Sessions with Event\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:110:\"The total number of sessions with events.<br />Type: metric.<br />API name: <code>ga:sessionsWithEvent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:13:\"shoppingStage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Shopping Stage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:214:\"Various stages of the shopping experience that users completed in a session, e.g., PRODUCT_VIEW, ADD_TO_CART, CHECKOUT, etc. (Enhanced Ecommerce).<br />Type: dimension.<br />API name: <code>ga:shoppingStage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:20:\"socialEngagementType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Social Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:144:\"Engagement type, either \"Socially Engaged\" or \"Not Socially Engaged\".<br />Type: dimension.<br />API name: <code>ga:socialEngagementType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:23:\"socialInteractionAction\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Social Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:164:\"For social interactions, this is the social action (e.g., +1, bookmark) being tracked.<br />Type: dimension.<br />API name: <code>ga:socialInteractionAction</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"socialInteractionNetwork\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Social Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:153:\"For social interactions, this represents the social network being tracked.<br />Type: dimension.<br />API name: <code>ga:socialInteractionNetwork</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:30:\"socialInteractionNetworkAction\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Social Network and Action (Hit)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:254:\"For social interactions, this is the concatenation of the socialInteractionNetwork and socialInteractionAction action (e.g., Google: +1) being tracked at this hit level.<br />Type: dimension.<br />API name: <code>ga:socialInteractionNetworkAction</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"socialInteractions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Social Actions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:110:\"The total number of social interactions.<br />Type: metric.<br />API name: <code>ga:socialInteractions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:28:\"socialInteractionsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Actions Per Social Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:210:\"The number of social interactions per session.<br />Type: metric.<br />Calculation: <code>ga:socialInteractions / ga:uniqueSocialInteractions</code>.<br />API name: <code>ga:socialInteractionsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:23:\"socialInteractionTarget\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Social Entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"For social interactions, this is the URL (or resource) which receives the social network action.<br />Type: dimension.<br />API name: <code>ga:socialInteractionTarget</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:13:\"socialNetwork\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Social Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:185:\"The social network name. This is related to the referring social network for traffic sources; e.g., Google+, Blogger.<br />Type: dimension.<br />API name: <code>ga:socialNetwork</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:6:\"source\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Source\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:411:\"The source of referrals. For manual campaign tracking, it is the value of the utm_source campaign tracking parameter. For AdWords autotagging, it is google. If you use neither, it is the domain of the source (e.g., document.referrer) referring the users. It may also contain a port address. If users arrived without a referrer, its value is (direct).<br />Type: dimension.<br />API name: <code>ga:source</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:12:\"sourceMedium\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Source / Medium\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:110:\"Combined values of ga:source and ga:medium.<br />Type: dimension.<br />API name: <code>ga:sourceMedium</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Traffic Sources\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:25:\"sourcePropertyDisplayName\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Source Property Display Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:174:\"Source property display name of roll-up properties. This is valid for only roll-up properties.<br />Type: dimension.<br />API name: <code>ga:sourcePropertyDisplayName</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:24:\"sourcePropertyTrackingId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Source Property Tracking ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:172:\"Source property tracking ID of roll-up properties. This is valid for only roll-up properties.<br />Type: dimension.<br />API name: <code>ga:sourcePropertyTrackingId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"speedMetricsSample\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Speed Metrics Sample\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:346:\"The sample set (or count) of pageviews used to calculate the averages of site speed metrics. This metric is used in all site speed average calculations, including avgDomainLookupTime, avgPageDownloadTime, avgRedirectionTime, avgServerConnectionTime, and avgServerResponseTime.<br />Type: metric.<br />API name: <code>ga:speedMetricsSample</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Site Speed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"subContinent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Sub Continent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:184:\"Users\' sub-continent, derived from their IP addresses or Geographical IDs. For example, Polynesia or Northern Europe.<br />Type: dimension.<br />API name: <code>ga:subContinent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"subContinentCode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Sub Continent Code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:225:\"Users\' sub-continent code in UN M.49 format, derived from their IP addresses or Geographical IDs. For example, 061 for Polynesia, 154 for Northern Europe.<br />Type: dimension.<br />API name: <code>ga:subContinentCode</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Geo Network\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"timeOnPage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Time on Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:291:\"Time (in seconds) users spent on a particular page, calculated by subtracting the initial view time for a particular page from the initial view time for a subsequent page. This metric does not apply to exit pages of the property.<br />Type: metric.<br />API name: <code>ga:timeOnPage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"timeOnScreen\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Time on Screen\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:106:\"The time spent viewing the current screen.<br />Type: metric.<br />API name: <code>ga:timeOnScreen</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:4:\"date\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:11:\"totalEvents\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Total Events\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:129:\"The total number of events for the profile, across all categories.<br />Type: metric.<br />API name: <code>ga:totalEvents</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:20:\"totalPublisherClicks\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Publisher Clicks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:173:\"The number of times ads from a linked publisher account (AdSense, AdX, DFP) were clicked on the site.<br />Type: metric.<br />API name: <code>ga:totalPublisherClicks</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:22:\"totalPublisherCoverage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Publisher Coverage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:321:\"Coverage is the percentage of ad requests that returned at least one ad. Generally, coverage can help you identify sites where the publisher account (AdSense, AdX, DFP) isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100<br />Type: metric.<br />API name: <code>ga:totalPublisherCoverage</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"totalPublisherCTR\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Publisher CTR\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:175:\"The percentage of pageviews that resulted in a click on a linked publisher account (AdSense, AdX, DFP) ad.<br />Type: metric.<br />API name: <code>ga:totalPublisherCTR</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"totalPublisherECPM\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Publisher eCPM\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:222:\"The effective cost per thousand pageviews. It is the total estimated revenue from all linked publisher accounts (AdSense, AdX, DFP) per 1,000 pageviews.<br />Type: metric.<br />API name: <code>ga:totalPublisherECPM</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:25:\"totalPublisherImpressions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Publisher Impressions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:248:\"An ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions.<br />Type: metric.<br />API name: <code>ga:totalPublisherImpressions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:35:\"totalPublisherImpressionsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Publisher Impressions / Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:220:\"The ratio of linked publisher account (AdSense, AdX, DFP) ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions).<br />Type: metric.<br />API name: <code>ga:totalPublisherImpressionsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:32:\"totalPublisherMonetizedPageviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Publisher Monetized Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:285:\"This measures the total number of pageviews on the property that were shown with an ad from one of the linked publisher accounts (AdSense, AdX, DFP). Note that a single page can have multiple ad units.<br />Type: metric.<br />API name: <code>ga:totalPublisherMonetizedPageviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:21:\"totalPublisherRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Publisher Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:159:\"The total estimated revenue from all linked publisher account (AdSense, AdX, DFP) ads.<br />Type: metric.<br />API name: <code>ga:totalPublisherRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:36:\"totalPublisherRevenuePer1000Sessions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Publisher Revenue / 1000 Sessions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:200:\"The total estimated revenue from all linked publisher accounts (AdSense, AdX, DFP) per 1,000 Analytics sessions.<br />Type: metric.<br />API name: <code>ga:totalPublisherRevenuePer1000Sessions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:40:\"totalPublisherViewableImpressionsPercent\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Publisher Viewable Impressions %\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:264:\"The percentage of viewable ad impressions. An impression is considered a viewable impression when it has appeared within users\' browsers and has the opportunity to be seen.<br />Type: metric.<br />API name: <code>ga:totalPublisherViewableImpressionsPercent</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Publisher\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"totalRefunds\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Refunds\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:125:\"Number of refunds that have been issued (Enhanced Ecommerce).<br />Type: metric.<br />API name: <code>ga:totalRefunds</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:10:\"totalValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Total Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:212:\"Total value for the property (including total revenue and total goal value).<br />Type: metric.<br />Calculation: <code>(ga:transactionRevenue + ga:goalValueAll)</code>.<br />API name: <code>ga:totalValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:13:\"transactionId\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Transaction ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:169:\"The transaction ID, supplied by the ecommerce tracking method, for the purchase in the shopping cart.<br />Type: dimension.<br />API name: <code>ga:transactionId</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:18:\"transactionRevenue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Revenue\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:141:\"The total sale revenue (excluding shipping and tax) of the transaction.<br />Type: metric.<br />API name: <code>ga:transactionRevenue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:28:\"transactionRevenuePerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Per Session Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:190:\"Average transaction revenue for a session.<br />Type: metric.<br />Calculation: <code>ga:transactionRevenue / ga:sessions</code>.<br />API name: <code>ga:transactionRevenuePerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"transactions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Transactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:97:\"The total number of transactions.<br />Type: metric.<br />API name: <code>ga:transactions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"transactionShipping\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Shipping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:98:\"The total cost of shipping.<br />Type: metric.<br />API name: <code>ga:transactionShipping</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:22:\"transactionsPerSession\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Ecommerce Conversion Rate\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:184:\"The average number of transactions in a session.<br />Type: metric.<br />Calculation: <code>ga:transactions / ga:sessions</code>.<br />API name: <code>ga:transactionsPerSession</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:19:\"transactionsPerUser\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Transactions per User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:133:\"Total number of transactions divided by total number of users.<br />Type: metric.<br />API name: <code>ga:transactionsPerUser</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"transactionTax\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Tax\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:96:\"Total tax for the transaction.<br />Type: metric.<br />API name: <code>ga:transactionTax</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:27:\"uniqueDimensionCombinations\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Unique Dimension Combinations\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:485:\"Unique Dimension Combinations counts the number of unique dimension-value combinations for each dimension in a report. This lets you build combined (concatenated) dimensions post-processing, which allows for more flexible reporting without having to update your tracking implementation or use additional custom-dimension slots. For more information, see https://support.google.com/analytics/answer/7084499.<br />Type: metric.<br />API name: <code>ga:uniqueDimensionCombinations</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:12:\"uniqueEvents\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Unique Events\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:153:\"The number of unique events. Events in different sessions are counted as separate events.<br />Type: metric.<br />API name: <code>ga:uniqueEvents</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Event Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"uniquePageviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Unique Pageviews\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:240:\"Unique Pageviews is the number of sessions during which the specified page was viewed at least once. A unique pageview is counted for each page URL + page title combination.<br />Type: metric.<br />API name: <code>ga:uniquePageviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Page Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"uniquePurchases\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Unique Purchases\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:196:\"The number of product sets purchased. For example, if users purchase 2 frisbees and 5 tennis balls from the site, this will be 2.<br />Type: metric.<br />API name: <code>ga:uniquePurchases</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Ecommerce\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:17:\"uniqueScreenviews\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Unique Screen Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:176:\"The number of unique screen views. Screen views in different sessions are counted as separate screen views.<br />Type: metric.<br />API name: <code>ga:uniqueScreenviews</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"App Tracking\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:24:\"uniqueSocialInteractions\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Unique Social Actions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:293:\"The number of sessions during which the specified social action(s) occurred at least once. This is based on the the unique combination of socialInteractionNetwork, socialInteractionAction, and socialInteractionTarget.<br />Type: metric.<br />API name: <code>ga:uniqueSocialInteractions</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Social Interactions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:14:\"userAgeBracket\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Age\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:90:\"Age bracket of users.<br />Type: dimension.<br />API name: <code>ga:userAgeBracket</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Audience\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"userBucket\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"User Bucket\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:168:\"Randomly assigned users tag to allow A/B testing and splitting of remarketing lists. Ranges from 1-100.<br />Type: dimension.<br />API name: <code>ga:userBucket</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"userDefinedValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"User Defined Value\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:142:\"The value provided when defining custom user segments for the property.<br />Type: dimension.<br />API name: <code>ga:userDefinedValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:10:\"userGender\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Gender\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:81:\"Gender of users.<br />Type: dimension.<br />API name: <code>ga:userGender</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Audience\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:5:\"users\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:113:\"The total number of users for the requested time period.<br />Type: metric.<br />API name: <code>ga:users</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"userTimingCategory\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Timing Category\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:177:\"For easier reporting purposes, this is used to categorize all user timing variables into logical groups.<br />Type: dimension.<br />API name: <code>ga:userTimingCategory</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"User Timings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:15:\"userTimingLabel\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Timing Label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:118:\"The name of the resource\'s action being tracked.<br />Type: dimension.<br />API name: <code>ga:userTimingLabel</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"User Timings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:16:\"userTimingSample\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"User Timing Sample\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:168:\"The number of hits sent for a particular userTimingCategory, userTimingLabel, or userTimingVariable.<br />Type: metric.<br />API name: <code>ga:userTimingSample</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"User Timings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:15:\"userTimingValue\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"User Timing (ms)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:112:\"Total number of milliseconds for user timing.<br />Type: metric.<br />API name: <code>ga:userTimingValue</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"User Timings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:7:\"numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:10:\"ga_numeric\";}}s:18:\"userTimingVariable\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Timing Variable\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:138:\"Used to add flexibility to visualize user timings in the reports.<br />Type: dimension.<br />API name: <code>ga:userTimingVariable</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"User Timings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"userType\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"User Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:160:\"A boolean, either New Visitor or Returning Visitor, indicating if the users are new or returning.<br />Type: dimension.<br />API name: <code>ga:userType</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:4:\"week\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Week of the Year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:145:\"The week of the session, a two-digit number from 01 to 53. Each week starts on Sunday.<br />Type: dimension.<br />API name: <code>ga:week</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:4:\"year\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:132:\"The year of the session, a four-digit year from 2005 to the current year.<br />Type: dimension.<br />API name: <code>ga:year</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:9:\"yearMonth\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Month of Year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:104:\"Combined values of ga:year and ga:month.<br />Type: dimension.<br />API name: <code>ga:yearMonth</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}s:8:\"yearWeek\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Week of Year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:41:\"Drupal\\Component\\Render\\FormattableMarkup\":2:{s:9:\"\0*\0string\";s:102:\"Combined values of ga:year and ga:week.<br />Type: dimension.<br />API name: <code>ga:yearWeek</code>.\";s:12:\"\0*\0arguments\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:8:\"standard\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:11:\"ga_argument\";}s:6:\"filter\";a:1:{s:2:\"id\";s:9:\"ga_string\";}}}s:7:\"history\";a:2:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:7:\"history\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:3:\"uid\";s:5:\"value\";s:18:\"***CURRENT_USER***\";s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:7:\"history\";}s:9:\"timestamp\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Has new content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:22:\"history_user_timestamp\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Show a marker if the content is new or updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:2:{s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Show only content that is new or updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:22:\"history_user_timestamp\";}}}s:18:\"user__user_picture\";a:7:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:16:\"users_field_data\";a:4:{s:5:\"table\";s:18:\"user__user_picture\";s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:12:\"user_picture\";a:5:{s:5:\"group\";r:474;s:5:\"title\";s:7:\"Picture\";s:11:\"title short\";s:7:\"Picture\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:10:\"real field\";s:22:\"user_picture_target_id\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:22:\"user_picture_target_id\";i:4;s:16:\"user_picture_alt\";i:5;s:18:\"user_picture_title\";i:6;s:18:\"user_picture_width\";i:7;s:19:\"user_picture_height\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:22:\"user_picture_target_id\";a:8:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"Picture\";s:5:\"@name\";s:12:\"user_picture\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Picture\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:22:\"user_picture_target_id\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:22:\"user_picture_target_id\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:22:\"user_picture_target_id\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:12:\"file_managed\";s:11:\"entity type\";s:4:\"file\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"image from @field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:12:\"user_picture\";}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"user_picture_alt\";a:7:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"Picture\";s:5:\"@name\";s:12:\"user_picture\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Picture\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:16:\"user_picture_alt\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:16:\"user_picture_alt\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:16:\"user_picture_alt\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";}}s:18:\"user_picture_title\";a:7:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"Picture\";s:5:\"@name\";s:12:\"user_picture\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Picture\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:18:\"user_picture_title\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:18:\"user_picture_title\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:18:\"user_picture_title\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";}}s:18:\"user_picture_width\";a:7:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"Picture\";s:5:\"@name\";s:12:\"user_picture\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Picture\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:18:\"user_picture_width\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:18:\"user_picture_width\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:18:\"user_picture_width\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";}}s:19:\"user_picture_height\";a:7:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"Picture\";s:5:\"@name\";s:12:\"user_picture\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Picture\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:19:\"user_picture_height\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:19:\"user_picture_height\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:19:\"user_picture_height\";s:5:\"table\";s:18:\"user__user_picture\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:22:\"user_picture_target_id\";i:7;s:16:\"user_picture_alt\";i:8;s:18:\"user_picture_title\";i:9;s:18:\"user_picture_width\";i:10;s:19:\"user_picture_height\";}s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";}}}s:34:\"user__field_migrate_example_gender\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:16:\"users_field_data\";a:4:{s:5:\"table\";s:34:\"user__field_migrate_example_gender\";s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:28:\"field_migrate_example_gender\";a:5:{s:5:\"group\";r:474;s:5:\"title\";s:6:\"Gender\";s:11:\"title short\";s:6:\"Gender\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:34:\"user__field_migrate_example_gender\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";s:10:\"real field\";s:34:\"field_migrate_example_gender_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:34:\"field_migrate_example_gender_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:34:\"field_migrate_example_gender_value\";a:7:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:6:\"Gender\";s:5:\"@name\";s:28:\"field_migrate_example_gender\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:6:\"Gender\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:34:\"field_migrate_example_gender_value\";s:5:\"table\";s:34:\"user__field_migrate_example_gender\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:34:\"field_migrate_example_gender_value\";}s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:34:\"field_migrate_example_gender_value\";s:5:\"table\";s:34:\"user__field_migrate_example_gender\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:34:\"field_migrate_example_gender_value\";}s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:34:\"field_migrate_example_gender_value\";s:5:\"table\";s:34:\"user__field_migrate_example_gender\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:34:\"field_migrate_example_gender_value\";}s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";}}}s:36:\"user__field_migrate_example_favbeers\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:16:\"users_field_data\";a:4:{s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:30:\"field_migrate_example_favbeers\";a:6:{s:5:\"group\";r:474;s:5:\"title\";s:14:\"Favorite Beers\";s:11:\"title short\";s:14:\"Favorite Beers\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:10:\"real field\";s:40:\"field_migrate_example_favbeers_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:40:\"field_migrate_example_favbeers_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:448;s:11:\"@field_name\";s:30:\"field_migrate_example_favbeers\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:448;s:11:\"@field_name\";s:30:\"field_migrate_example_favbeers\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:474;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:40:\"field_migrate_example_favbeers_target_id\";}}s:40:\"field_migrate_example_favbeers_target_id\";a:7:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:14:\"Favorite Beers\";s:5:\"@name\";s:30:\"field_migrate_example_favbeers\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:14:\"Favorite Beers\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:40:\"field_migrate_example_favbeers_target_id\";s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_favbeers_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:40:\"field_migrate_example_favbeers_target_id\";s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_favbeers_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:40:\"field_migrate_example_favbeers_target_id\";s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_favbeers_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:474;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:14:\"Favorite Beers\";s:5:\"@name\";s:30:\"field_migrate_example_favbeers\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:14:\"Favorite Beers\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:4:\"user\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_favbeers_target_id\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_favbeers_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:36:\"user__field_migrate_example_favbeers\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_favbeers_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";}}}s:39:\"taxonomy_term__field_variety_attributes\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:24:\"taxonomy_term_field_data\";a:4:{s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:24:\"field_variety_attributes\";a:5:{s:5:\"group\";r:2583;s:5:\"title\";s:10:\"Attributes\";s:11:\"title short\";s:10:\"Attributes\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:30:\"migrate_example_wine_varieties\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:10:\"real field\";s:30:\"field_variety_attributes_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:30:\"field_variety_attributes_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:30:\"field_variety_attributes_value\";a:7:{s:5:\"group\";r:2583;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:10:\"Attributes\";s:5:\"@name\";s:24:\"field_variety_attributes\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:10:\"Attributes\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:30:\"migrate_example_wine_varieties\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:30:\"field_variety_attributes_value\";s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:30:\"field_variety_attributes_value\";}s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:30:\"field_variety_attributes_value\";s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:30:\"field_variety_attributes_value\";}s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:30:\"field_variety_attributes_value\";s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:30:\"field_variety_attributes_value\";}s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:2583;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:10:\"Attributes\";s:5:\"@name\";s:24:\"field_variety_attributes\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:10:\"Attributes\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:30:\"migrate_example_wine_varieties\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:30:\"field_variety_attributes_value\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:30:\"field_variety_attributes_value\";}s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:39:\"taxonomy_term__field_variety_attributes\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:30:\"field_variety_attributes_value\";}s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";}}}s:16:\"node__field_tags\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:16:\"node__field_tags\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:10:\"field_tags\";a:6:{s:5:\"group\";r:448;s:5:\"title\";s:4:\"Tags\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:16:\"node__field_tags\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:20:\"field_tags_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:20:\"field_tags_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:20:\"field_tags_target_id\";}}s:20:\"field_tags_target_id\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Tags\";s:5:\"@name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:20:\"field_tags_target_id\";s:5:\"table\";s:16:\"node__field_tags\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:20:\"field_tags_target_id\";s:5:\"table\";s:16:\"node__field_tags\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:20:\"field_tags_target_id\";s:5:\"table\";s:16:\"node__field_tags\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Tags\";s:5:\"@name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:16:\"node__field_tags\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:16:\"node__field_tags\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:16:\"node__field_tags\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";}}}s:25:\"node_revision__field_tags\";a:5:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:25:\"node_revision__field_tags\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:22:\"field_tags-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:4:\"Tags\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:25:\"node_revision__field_tags\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:32:\"field_tags-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:20:\"field_tags_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:20:\"field_tags_target_id\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:15091;s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:20:\"field_tags_target_id\";s:5:\"table\";s:25:\"node_revision__field_tags\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:20:\"field_tags_target_id\";s:5:\"table\";s:25:\"node_revision__field_tags\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:20:\"field_tags_target_id\";s:5:\"table\";s:25:\"node_revision__field_tags\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:15260;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Tags\";s:5:\"@name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:4:\"Tags\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"node_revision__field_tags\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"node_revision__field_tags\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"node_revision__field_tags\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:20:\"field_tags_target_id\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";}}s:10:\"field_tags\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:20:\"field_tags_target_id\";}}}s:24:\"taxonomy_term_field_data\";a:24:{s:25:\"reverse__node__field_tags\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"@entity using @field_name\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:10:\"field_tags\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:10:\"field_tags\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:2583;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Relate each @entity with a @field_name set to the @label.\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:10:\"field_tags\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"field table\";s:16:\"node__field_tags\";s:11:\"field field\";s:20:\"field_tags_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:45:\"reverse__node__field_migrate_example_wine_var\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"@entity using @field_name\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:30:\"field_migrate_example_wine_var\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:30:\"field_migrate_example_wine_var\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:2583;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Relate each @entity with a @field_name set to the @label.\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:30:\"field_migrate_example_wine_var\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"field table\";s:36:\"node__field_migrate_example_wine_var\";s:11:\"field field\";s:40:\"field_migrate_example_wine_var_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:47:\"reverse__node__field_migrate_example_wine_regio\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"@entity using @field_name\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:32:\"field_migrate_example_wine_regio\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:32:\"field_migrate_example_wine_regio\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:2583;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Relate each @entity with a @field_name set to the @label.\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:32:\"field_migrate_example_wine_regio\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"field table\";s:38:\"node__field_migrate_example_wine_regio\";s:11:\"field field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:46:\"reverse__node__field_migrate_example_wine_best\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"@entity using @field_name\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:31:\"field_migrate_example_wine_best\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:2583;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Relate each @entity with a @field_name set to the @label.\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:31:\"field_migrate_example_wine_best\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"field table\";s:37:\"node__field_migrate_example_wine_best\";s:11:\"field field\";s:41:\"field_migrate_example_wine_best_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:47:\"reverse__node__field_migrate_example_beer_style\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"@entity using @field_name\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:32:\"field_migrate_example_beer_style\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:2583;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Relate each @entity with a @field_name set to the @label.\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:13:\"taxonomy term\";s:11:\"@field_name\";s:32:\"field_migrate_example_beer_style\";s:7:\"@entity\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"field table\";s:38:\"node__field_migrate_example_beer_style\";s:11:\"field field\";s:42:\"field_migrate_example_beer_style_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:5:\"table\";a:7:{s:4:\"base\";a:6:{s:5:\"field\";s:3:\"tid\";s:5:\"title\";r:2583;s:14:\"cache_contexts\";a:0:{}s:8:\"defaults\";a:2:{s:5:\"field\";s:4:\"name\";s:5:\"table\";s:24:\"taxonomy_term_field_data\";}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Taxonomy terms are attached to nodes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"access query tag\";s:20:\"taxonomy_term_access\";}s:5:\"group\";r:2583;s:8:\"provider\";s:8:\"taxonomy\";s:15:\"entity revision\";b:0;s:11:\"entity type\";s:13:\"taxonomy_term\";s:9:\"wizard_id\";s:13:\"taxonomy_term\";s:4:\"join\";a:1:{s:14:\"taxonomy_index\";a:2:{s:5:\"field\";s:3:\"tid\";s:10:\"left_field\";s:3:\"tid\";}}}s:3:\"tid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Term ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The tid of a taxonomy term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:3:{s:2:\"id\";s:8:\"taxonomy\";s:10:\"name field\";s:4:\"name\";s:12:\"zero is null\";b:1;}s:6:\"filter\";a:5:{s:2:\"id\";s:18:\"taxonomy_index_tid\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:56:\"Taxonomy term chosen from autocomplete or select widget.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"hierarchy table\";s:21:\"taxonomy_term__parent\";s:7:\"numeric\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"tid\";}s:3:\"vid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Filter the results of \"Taxonomy: Term\" to a particular vocabulary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The vocabulary name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:8:\"argument\";a:1:{s:2:\"id\";s:14:\"vocabulary_vid\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"bundle\";}s:12:\"entity field\";s:3:\"vid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";r:2669;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:6:\"status\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:4:\"name\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:9:\"term_name\";}s:8:\"argument\";a:3:{s:2:\"id\";s:6:\"string\";s:11:\"many to one\";b:1;s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Uncategorized\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"name\";}s:18:\"description__value\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:5:\"field\";s:6:\"format\";s:19:\"description__format\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:11:\"description\";}s:19:\"description__format\";a:6:{s:5:\"title\";s:20:\"Description (format)\";s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:11:\"description\";}s:6:\"weight\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The weight of this term in relation to other terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"weight\";}s:7:\"changed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The date the term was last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:16:\"default_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:7:\"tid_raw\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Term ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The tid of a taxonomy term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:3:\"tid\";s:6:\"filter\";a:2:{s:2:\"id\";s:7:\"numeric\";s:11:\"allow empty\";b:1;}}s:18:\"tid_representative\";a:1:{s:12:\"relationship\";a:11:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Representative node\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Representative node\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:89:\"Obtains a single representative node for each term, according to a chosen sort criterion.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:13:\"groupwise_max\";s:18:\"relationship field\";s:3:\"tid\";s:11:\"outer field\";s:28:\"taxonomy_term_field_data.tid\";s:14:\"argument table\";s:24:\"taxonomy_term_field_data\";s:14:\"argument field\";s:3:\"tid\";s:4:\"base\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:29:\"node_field_data:term_node_tid\";}}s:16:\"changed_fulldate\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date in the form of CCYYMMDD.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:13:\"date_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Updated year + month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Date in the form of YYYYMM.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:15:\"date_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Date in the form of YYYY.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Updated month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of MM (01 - 12).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:10:\"date_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Updated day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of DD (01 - 31).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:8:\"date_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of WW (01 - 53).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_week\";}}}s:36:\"node__field_migrate_example_wine_var\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:36:\"node__field_migrate_example_wine_var\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:30:\"field_migrate_example_wine_var\";a:6:{s:5:\"group\";r:448;s:5:\"title\";s:30:\"Migrate Example Wine Varieties\";s:11:\"title short\";s:30:\"Migrate Example Wine Varieties\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:36:\"node__field_migrate_example_wine_var\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:40:\"field_migrate_example_wine_var_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:40:\"field_migrate_example_wine_var_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:30:\"field_migrate_example_wine_var\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:30:\"field_migrate_example_wine_var\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:40:\"field_migrate_example_wine_var_target_id\";}}s:40:\"field_migrate_example_wine_var_target_id\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:30:\"Migrate Example Wine Varieties\";s:5:\"@name\";s:30:\"field_migrate_example_wine_var\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:30:\"Migrate Example Wine Varieties\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:40:\"field_migrate_example_wine_var_target_id\";s:5:\"table\";s:36:\"node__field_migrate_example_wine_var\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_wine_var_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:40:\"field_migrate_example_wine_var_target_id\";s:5:\"table\";s:36:\"node__field_migrate_example_wine_var\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_wine_var_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:40:\"field_migrate_example_wine_var_target_id\";s:5:\"table\";s:36:\"node__field_migrate_example_wine_var\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_wine_var_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";}}}s:45:\"node_revision__field_migrate_example_wine_var\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:45:\"node_revision__field_migrate_example_wine_var\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:42:\"field_migrate_example_wine_var-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:30:\"Migrate Example Wine Varieties\";s:11:\"title short\";s:30:\"Migrate Example Wine Varieties\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:45:\"node_revision__field_migrate_example_wine_var\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:52:\"field_migrate_example_wine_var-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:40:\"field_migrate_example_wine_var_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:40:\"field_migrate_example_wine_var_target_id\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:15952;s:11:\"title short\";s:30:\"Migrate Example Wine Varieties\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:40:\"field_migrate_example_wine_var_target_id\";s:5:\"table\";s:45:\"node_revision__field_migrate_example_wine_var\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_wine_var_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:40:\"field_migrate_example_wine_var_target_id\";s:5:\"table\";s:45:\"node_revision__field_migrate_example_wine_var\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_wine_var_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:40:\"field_migrate_example_wine_var_target_id\";s:5:\"table\";s:45:\"node_revision__field_migrate_example_wine_var\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:40:\"field_migrate_example_wine_var_target_id\";}s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";}}s:30:\"field_migrate_example_wine_var\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:30:\"field_migrate_example_wine_var\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:30:\"field_migrate_example_wine_var\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:40:\"field_migrate_example_wine_var_target_id\";}}}s:38:\"node__field_migrate_example_wine_regio\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:5:{s:5:\"table\";s:38:\"node__field_migrate_example_wine_regio\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:3:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}i:2;a:2:{s:5:\"field\";s:6:\"bundle\";s:5:\"value\";a:1:{i:0;s:20:\"migrate_example_wine\";}}}s:7:\"join_id\";s:22:\"field_or_language_join\";}}s:8:\"provider\";s:5:\"views\";}s:32:\"field_migrate_example_wine_regio\";a:6:{s:5:\"group\";r:448;s:5:\"title\";s:28:\"Migrate Example Wine Regions\";s:11:\"title short\";s:28:\"Migrate Example Wine Regions\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:46:\"migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:38:\"node__field_migrate_example_wine_regio\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:42:\"field_migrate_example_wine_regio_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_wine_regio\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_wine_regio\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:46:\"migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:42:\"field_migrate_example_wine_regio_target_id\";}}s:42:\"field_migrate_example_wine_regio_target_id\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:28:\"Migrate Example Wine Regions\";s:5:\"@name\";s:32:\"field_migrate_example_wine_regio\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:28:\"Migrate Example Wine Regions\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:46:\"migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:5:\"table\";s:38:\"node__field_migrate_example_wine_regio\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_wine_regio_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:5:\"table\";s:38:\"node__field_migrate_example_wine_regio\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_wine_regio_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:5:\"table\";s:38:\"node__field_migrate_example_wine_regio\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_wine_regio_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";}}}s:47:\"node_revision__field_migrate_example_wine_regio\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:5:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_regio\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:3:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}i:2;a:2:{s:5:\"value\";a:1:{i:0;s:20:\"migrate_example_wine\";}s:5:\"field\";s:6:\"bundle\";}}s:7:\"join_id\";s:22:\"field_or_language_join\";}}s:8:\"provider\";s:5:\"views\";}s:44:\"field_migrate_example_wine_regio-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:28:\"Migrate Example Wine Regions\";s:11:\"title short\";s:28:\"Migrate Example Wine Regions\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:46:\"migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_regio\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:54:\"field_migrate_example_wine_regio-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:42:\"field_migrate_example_wine_regio_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:42:\"field_migrate_example_wine_regio_target_id\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:16205;s:11:\"title short\";s:28:\"Migrate Example Wine Regions\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:46:\"migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_regio\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_wine_regio_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_regio\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_wine_regio_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:42:\"field_migrate_example_wine_regio_target_id\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_regio\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_wine_regio_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";}}s:32:\"field_migrate_example_wine_regio\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_wine_regio\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_wine_regio\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:46:\"migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:42:\"field_migrate_example_wine_regio_target_id\";}}}s:38:\"node__field_migrate_example_wine_ratin\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:38:\"node__field_migrate_example_wine_ratin\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:32:\"field_migrate_example_wine_ratin\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:6:\"Rating\";s:11:\"title short\";s:6:\"Rating\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:38:\"node__field_migrate_example_wine_ratin\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:38:\"field_migrate_example_wine_ratin_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:38:\"field_migrate_example_wine_ratin_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:38:\"field_migrate_example_wine_ratin_value\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:6:\"Rating\";s:5:\"@name\";s:32:\"field_migrate_example_wine_ratin\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:6:\"Rating\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_wine_ratin_value\";s:5:\"table\";s:38:\"node__field_migrate_example_wine_ratin\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_wine_ratin_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_wine_ratin_value\";s:5:\"table\";s:38:\"node__field_migrate_example_wine_ratin\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_wine_ratin_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:38:\"field_migrate_example_wine_ratin_value\";s:5:\"table\";s:38:\"node__field_migrate_example_wine_ratin\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_wine_ratin_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";}}}s:47:\"node_revision__field_migrate_example_wine_ratin\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_ratin\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:44:\"field_migrate_example_wine_ratin-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:6:\"Rating\";s:11:\"title short\";s:6:\"Rating\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_ratin\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:50:\"field_migrate_example_wine_ratin-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:38:\"field_migrate_example_wine_ratin_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:38:\"field_migrate_example_wine_ratin_value\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:16434;s:11:\"title short\";s:6:\"Rating\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_wine_ratin_value\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_ratin\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_wine_ratin_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_wine_ratin_value\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_ratin\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_wine_ratin_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:38:\"field_migrate_example_wine_ratin_value\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_wine_ratin\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_wine_ratin_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";}}}s:37:\"node__field_migrate_example_wine_best\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:31:\"field_migrate_example_wine_best\";a:6:{s:5:\"group\";r:448;s:5:\"title\";s:30:\"Migrate Example Wine Best With\";s:11:\"title short\";s:30:\"Migrate Example Wine Best With\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:41:\"field_migrate_example_wine_best_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:41:\"field_migrate_example_wine_best_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:41:\"field_migrate_example_wine_best_target_id\";}}s:41:\"field_migrate_example_wine_best_target_id\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:30:\"Migrate Example Wine Best With\";s:5:\"@name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:30:\"Migrate Example Wine Best With\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_wine_best_target_id\";s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_wine_best_target_id\";s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:41:\"field_migrate_example_wine_best_target_id\";s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:30:\"Migrate Example Wine Best With\";s:5:\"@name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:30:\"Migrate Example Wine Best With\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:37:\"node__field_migrate_example_wine_best\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";}}}s:46:\"node_revision__field_migrate_example_wine_best\";a:5:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:43:\"field_migrate_example_wine_best-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:30:\"Migrate Example Wine Best With\";s:11:\"title short\";s:30:\"Migrate Example Wine Best With\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:53:\"field_migrate_example_wine_best-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:41:\"field_migrate_example_wine_best_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:41:\"field_migrate_example_wine_best_target_id\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:16654;s:11:\"title short\";s:30:\"Migrate Example Wine Best With\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_wine_best_target_id\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_wine_best_target_id\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:41:\"field_migrate_example_wine_best_target_id\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:16820;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:30:\"Migrate Example Wine Best With\";s:5:\"@name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:30:\"Migrate Example Wine Best With\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_wine_best\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_wine_best_target_id\";}s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";}}s:31:\"field_migrate_example_wine_best\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:31:\"field_migrate_example_wine_best\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:41:\"field_migrate_example_wine_best_target_id\";}}}s:38:\"node__field_migrate_example_top_vintag\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:32:\"field_migrate_example_top_vintag\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:20:\"Recommended vintages\";s:11:\"title short\";s:20:\"Recommended vintages\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:38:\"field_migrate_example_top_vintag_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:38:\"field_migrate_example_top_vintag_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:38:\"field_migrate_example_top_vintag_value\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:20:\"Recommended vintages\";s:5:\"@name\";s:32:\"field_migrate_example_top_vintag\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:20:\"Recommended vintages\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_top_vintag_value\";s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_top_vintag_value\";s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:38:\"field_migrate_example_top_vintag_value\";s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:20:\"Recommended vintages\";s:5:\"@name\";s:32:\"field_migrate_example_top_vintag\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:20:\"Recommended vintages\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:38:\"node__field_migrate_example_top_vintag\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";}}}s:47:\"node_revision__field_migrate_example_top_vintag\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:44:\"field_migrate_example_top_vintag-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:20:\"Recommended vintages\";s:11:\"title short\";s:20:\"Recommended vintages\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:50:\"field_migrate_example_top_vintag-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:38:\"field_migrate_example_top_vintag_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:38:\"field_migrate_example_top_vintag_value\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:17009;s:11:\"title short\";s:20:\"Recommended vintages\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_top_vintag_value\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_top_vintag_value\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:38:\"field_migrate_example_top_vintag_value\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:17175;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:20:\"Recommended vintages\";s:5:\"@name\";s:32:\"field_migrate_example_top_vintag\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:20:\"Recommended vintages\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_top_vintag\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:38:\"field_migrate_example_top_vintag_value\";}s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";}}}s:33:\"node__field_migrate_example_image\";a:7:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:27:\"field_migrate_example_image\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:37:\"field_migrate_example_image_target_id\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:37:\"field_migrate_example_image_target_id\";i:4;s:31:\"field_migrate_example_image_alt\";i:5;s:33:\"field_migrate_example_image_title\";i:6;s:33:\"field_migrate_example_image_width\";i:7;s:34:\"field_migrate_example_image_height\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:37:\"field_migrate_example_image_target_id\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:27:\"field_migrate_example_image\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_image_target_id\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_image_target_id\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_image_target_id\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:12:\"file_managed\";s:11:\"entity type\";s:4:\"file\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"image from @field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:27:\"field_migrate_example_image\";}s:10:\"\0*\0options\";a:0:{}}}}s:31:\"field_migrate_example_image_alt\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:27:\"field_migrate_example_image\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:31:\"field_migrate_example_image_alt\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:31:\"field_migrate_example_image_alt\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:31:\"field_migrate_example_image_alt\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}s:33:\"field_migrate_example_image_title\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:27:\"field_migrate_example_image\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_title\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_title\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:33:\"field_migrate_example_image_title\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}s:33:\"field_migrate_example_image_width\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:27:\"field_migrate_example_image\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_width\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_width\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:33:\"field_migrate_example_image_width\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}s:34:\"field_migrate_example_image_height\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:27:\"field_migrate_example_image\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:34:\"field_migrate_example_image_height\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:34:\"field_migrate_example_image_height\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:34:\"field_migrate_example_image_height\";s:5:\"table\";s:33:\"node__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}}s:42:\"node_revision__field_migrate_example_image\";a:7:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:39:\"field_migrate_example_image-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:49:\"field_migrate_example_image-revision_id_target_id\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:37:\"field_migrate_example_image_target_id\";i:4;s:31:\"field_migrate_example_image_alt\";i:5;s:33:\"field_migrate_example_image_title\";i:6;s:33:\"field_migrate_example_image_width\";i:7;s:34:\"field_migrate_example_image_height\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:37:\"field_migrate_example_image_target_id\";a:8:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:17343;s:11:\"title short\";r:17350;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_image_target_id\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_image_target_id\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_image_target_id\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:12:\"file_managed\";s:11:\"entity type\";s:4:\"file\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"image from @field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:27:\"field_migrate_example_image\";}s:10:\"\0*\0options\";a:0:{}}}}s:31:\"field_migrate_example_image_alt\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:17432;s:11:\"title short\";r:17439;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:31:\"field_migrate_example_image_alt\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:31:\"field_migrate_example_image_alt\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:31:\"field_migrate_example_image_alt\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}s:33:\"field_migrate_example_image_title\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:17511;s:11:\"title short\";r:17518;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_title\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_title\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:33:\"field_migrate_example_image_title\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}s:33:\"field_migrate_example_image_width\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:17590;s:11:\"title short\";r:17597;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_width\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:33:\"field_migrate_example_image_width\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:33:\"field_migrate_example_image_width\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}s:34:\"field_migrate_example_image_height\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:17669;s:11:\"title short\";r:17676;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:34:\"field_migrate_example_image_height\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:34:\"field_migrate_example_image_height\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:34:\"field_migrate_example_image_height\";s:5:\"table\";s:42:\"node_revision__field_migrate_example_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_image_target_id\";i:7;s:31:\"field_migrate_example_image_alt\";i:8;s:33:\"field_migrate_example_image_title\";i:9;s:33:\"field_migrate_example_image_width\";i:10;s:34:\"field_migrate_example_image_height\";}s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";}}}s:35:\"node__field_migrate_example_country\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:29:\"field_migrate_example_country\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:9:\"Countries\";s:11:\"title short\";s:9:\"Countries\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:35:\"field_migrate_example_country_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:35:\"field_migrate_example_country_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:35:\"field_migrate_example_country_value\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Countries\";s:5:\"@name\";s:29:\"field_migrate_example_country\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:9:\"Countries\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_country_value\";s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_country_value\";s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:35:\"field_migrate_example_country_value\";s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Countries\";s:5:\"@name\";s:29:\"field_migrate_example_country\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:9:\"Countries\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:35:\"node__field_migrate_example_country\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";}}}s:44:\"node_revision__field_migrate_example_country\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:41:\"field_migrate_example_country-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:9:\"Countries\";s:11:\"title short\";s:9:\"Countries\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:47:\"field_migrate_example_country-revision_id_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:35:\"field_migrate_example_country_value\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:35:\"field_migrate_example_country_value\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:18197;s:11:\"title short\";s:9:\"Countries\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_country_value\";s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_country_value\";s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:35:\"field_migrate_example_country_value\";s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:18363;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:9:\"Countries\";s:5:\"@name\";s:29:\"field_migrate_example_country\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:9:\"Countries\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:44:\"node_revision__field_migrate_example_country\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:35:\"field_migrate_example_country_value\";}s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";}}}s:36:\"node__field_migrate_example_comments\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:36:\"node__field_migrate_example_comments\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:30:\"field_migrate_example_comments\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:8:\"Comments\";s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:36:\"node__field_migrate_example_comments\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:37:\"field_migrate_example_comments_status\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:37:\"field_migrate_example_comments_status\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:37:\"field_migrate_example_comments_status\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Comments\";s:5:\"@name\";s:30:\"field_migrate_example_comments\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_comments_status\";s:5:\"table\";s:36:\"node__field_migrate_example_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_comments_status\";}s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_comments_status\";s:5:\"table\";s:36:\"node__field_migrate_example_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_comments_status\";}s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_comments_status\";s:5:\"table\";s:36:\"node__field_migrate_example_comments\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_comments_status\";}s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";}}}s:45:\"node_revision__field_migrate_example_comments\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:45:\"node_revision__field_migrate_example_comments\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:42:\"field_migrate_example_comments-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:8:\"Comments\";s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:45:\"node_revision__field_migrate_example_comments\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:49:\"field_migrate_example_comments-revision_id_status\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:37:\"field_migrate_example_comments_status\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:37:\"field_migrate_example_comments_status\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:18527;s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_comments_status\";s:5:\"table\";s:45:\"node_revision__field_migrate_example_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_comments_status\";}s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_comments_status\";s:5:\"table\";s:45:\"node_revision__field_migrate_example_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_comments_status\";}s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_comments_status\";s:5:\"table\";s:45:\"node_revision__field_migrate_example_comments\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:37:\"field_migrate_example_comments_status\";}s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";}}}s:38:\"node__field_migrate_example_beer_style\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:32:\"field_migrate_example_beer_style\";a:6:{s:5:\"group\";r:448;s:5:\"title\";s:27:\"Migrate Example Beer Styles\";s:11:\"title short\";s:27:\"Migrate Example Beer Styles\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:42:\"field_migrate_example_beer_style_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:42:\"field_migrate_example_beer_style_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:42:\"field_migrate_example_beer_style_target_id\";}}s:42:\"field_migrate_example_beer_style_target_id\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:27:\"Migrate Example Beer Styles\";s:5:\"@name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:27:\"Migrate Example Beer Styles\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_beer_style_target_id\";s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_beer_style_target_id\";s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:42:\"field_migrate_example_beer_style_target_id\";s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:27:\"Migrate Example Beer Styles\";s:5:\"@name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:27:\"Migrate Example Beer Styles\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:38:\"node__field_migrate_example_beer_style\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";}}}s:47:\"node_revision__field_migrate_example_beer_style\";a:5:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:44:\"field_migrate_example_beer_style-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:27:\"Migrate Example Beer Styles\";s:11:\"title short\";s:27:\"Migrate Example Beer Styles\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:54:\"field_migrate_example_beer_style-revision_id_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:42:\"field_migrate_example_beer_style_target_id\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:42:\"field_migrate_example_beer_style_target_id\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:18747;s:11:\"title short\";s:27:\"Migrate Example Beer Styles\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_beer_style_target_id\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:42:\"field_migrate_example_beer_style_target_id\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:2:\"id\";s:18:\"taxonomy_index_tid\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:42:\"field_migrate_example_beer_style_target_id\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";}}s:5:\"delta\";a:8:{s:5:\"group\";r:18913;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:27:\"Migrate Example Beer Styles\";s:5:\"@name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:27:\"Migrate Example Beer Styles\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:47:\"node_revision__field_migrate_example_beer_style\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:42:\"field_migrate_example_beer_style_target_id\";}s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";}}s:32:\"field_migrate_example_beer_style\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"@label referenced from @field_name\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"@field_name: @label\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";r:2583;s:11:\"@field_name\";s:32:\"field_migrate_example_beer_style\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:11:\"entity type\";s:13:\"taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:42:\"field_migrate_example_beer_style_target_id\";}}}s:37:\"node__field_migrate_example_adv_image\";a:8:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:31:\"field_migrate_example_adv_image\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:41:\"field_migrate_example_adv_image_target_id\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:41:\"field_migrate_example_adv_image_target_id\";i:4;s:35:\"field_migrate_example_adv_image_alt\";i:5;s:37:\"field_migrate_example_adv_image_title\";i:6;s:37:\"field_migrate_example_adv_image_width\";i:7;s:38:\"field_migrate_example_adv_image_height\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:41:\"field_migrate_example_adv_image_target_id\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:31:\"field_migrate_example_adv_image\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_adv_image_target_id\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_adv_image_target_id\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:41:\"field_migrate_example_adv_image_target_id\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:12:\"file_managed\";s:11:\"entity type\";s:4:\"file\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"image from @field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:31:\"field_migrate_example_adv_image\";}s:10:\"\0*\0options\";a:0:{}}}}s:5:\"delta\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:31:\"field_migrate_example_adv_image\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:35:\"field_migrate_example_adv_image_alt\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:31:\"field_migrate_example_adv_image\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_adv_image_alt\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_adv_image_alt\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:35:\"field_migrate_example_adv_image_alt\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:37:\"field_migrate_example_adv_image_title\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:31:\"field_migrate_example_adv_image\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_title\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_title\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_title\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:37:\"field_migrate_example_adv_image_width\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:31:\"field_migrate_example_adv_image\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_width\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_width\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_width\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:38:\"field_migrate_example_adv_image_height\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:31:\"field_migrate_example_adv_image\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_adv_image_height\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_adv_image_height\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:38:\"field_migrate_example_adv_image_height\";s:5:\"table\";s:37:\"node__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}}s:46:\"node_revision__field_migrate_example_adv_image\";a:8:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:43:\"field_migrate_example_adv_image-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:53:\"field_migrate_example_adv_image-revision_id_target_id\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:41:\"field_migrate_example_adv_image_target_id\";i:4;s:35:\"field_migrate_example_adv_image_alt\";i:5;s:37:\"field_migrate_example_adv_image_title\";i:6;s:37:\"field_migrate_example_adv_image_width\";i:7;s:38:\"field_migrate_example_adv_image_height\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:41:\"field_migrate_example_adv_image_target_id\";a:8:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:19106;s:11:\"title short\";r:19113;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_adv_image_target_id\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:41:\"field_migrate_example_adv_image_target_id\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:41:\"field_migrate_example_adv_image_target_id\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:12:\"file_managed\";s:11:\"entity type\";s:4:\"file\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"image from @field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:31:\"field_migrate_example_adv_image\";}s:10:\"\0*\0options\";a:0:{}}}}s:5:\"delta\";a:8:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@label (@name:delta)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:31:\"field_migrate_example_adv_image\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"@label:delta\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Delta - Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}s:6:\"filter\";a:7:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:35:\"field_migrate_example_adv_image_alt\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:19274;s:11:\"title short\";r:19281;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_adv_image_alt\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:35:\"field_migrate_example_adv_image_alt\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:35:\"field_migrate_example_adv_image_alt\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:37:\"field_migrate_example_adv_image_title\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:19353;s:11:\"title short\";r:19360;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_title\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_title\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_title\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:37:\"field_migrate_example_adv_image_width\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:19432;s:11:\"title short\";r:19439;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_width\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_width\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:37:\"field_migrate_example_adv_image_width\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}s:38:\"field_migrate_example_adv_image_height\";a:7:{s:5:\"group\";r:19714;s:5:\"title\";r:19511;s:11:\"title short\";r:19518;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_wine\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_adv_image_height\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:38:\"field_migrate_example_adv_image_height\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:38:\"field_migrate_example_adv_image_height\";s:5:\"table\";s:46:\"node_revision__field_migrate_example_adv_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:41:\"field_migrate_example_adv_image_target_id\";i:7;s:35:\"field_migrate_example_adv_image_alt\";i:8;s:37:\"field_migrate_example_adv_image_title\";i:9;s:37:\"field_migrate_example_adv_image_width\";i:10;s:38:\"field_migrate_example_adv_image_height\";}s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";}}}s:17:\"node__field_image\";a:7:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:17:\"node__field_image\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:11:\"field_image\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:21:\"field_image_target_id\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:21:\"field_image_target_id\";i:4;s:15:\"field_image_alt\";i:5;s:17:\"field_image_title\";i:6;s:17:\"field_image_width\";i:7;s:18:\"field_image_height\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:21:\"field_image_target_id\";a:8:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:11:\"field_image\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:9:\"target_id\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:21:\"field_image_target_id\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:21:\"field_image_target_id\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:21:\"field_image_target_id\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:12:\"file_managed\";s:11:\"entity type\";s:4:\"file\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"image from @field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:11:\"field_image\";}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"field_image_alt\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:11:\"field_image\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:3:\"alt\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}s:17:\"field_image_title\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:11:\"field_image\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:5:\"title\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}s:17:\"field_image_width\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:11:\"field_image\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:5:\"width\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}s:18:\"field_image_height\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:5:\"Image\";s:5:\"@name\";s:11:\"field_image\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:5:\"Image\";s:7:\"@column\";s:6:\"height\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:17:\"node__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}}s:26:\"node_revision__field_image\";a:7:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:26:\"node_revision__field_image\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:23:\"field_image-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:33:\"field_image-revision_id_target_id\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:21:\"field_image_target_id\";i:4;s:15:\"field_image_alt\";i:5;s:17:\"field_image_title\";i:6;s:17:\"field_image_width\";i:7;s:18:\"field_image_height\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_image_target_id\";a:8:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:20125;s:11:\"title short\";r:20132;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:21:\"field_image_target_id\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:21:\"field_image_target_id\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:21:\"field_image_target_id\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:12:\"file_managed\";s:11:\"entity type\";s:4:\"file\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"image from @field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:11:\"field_image\";}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"field_image_alt\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:20214;s:11:\"title short\";r:20221;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}s:17:\"field_image_title\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:20293;s:11:\"title short\";r:20300;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}s:17:\"field_image_width\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:20372;s:11:\"title short\";r:20379;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}s:18:\"field_image_height\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:20451;s:11:\"title short\";r:20458;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:26:\"node_revision__field_image\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:11:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_image_target_id\";i:7;s:15:\"field_image_alt\";i:8;s:17:\"field_image_title\";i:9;s:17:\"field_image_width\";i:10;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";}}}s:20:\"node__field_comments\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:20:\"node__field_comments\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:14:\"field_comments\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:8:\"Comments\";s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:20:\"node__field_comments\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:21:\"field_comments_status\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:21:\"field_comments_status\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:21:\"field_comments_status\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Comments\";s:5:\"@name\";s:14:\"field_comments\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:21:\"field_comments_status\";s:5:\"table\";s:20:\"node__field_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_comments_status\";}s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:21:\"field_comments_status\";s:5:\"table\";s:20:\"node__field_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_comments_status\";}s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:21:\"field_comments_status\";s:5:\"table\";s:20:\"node__field_comments\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_comments_status\";}s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";}}}s:29:\"node_revision__field_comments\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:29:\"node_revision__field_comments\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"provider\";s:5:\"views\";}s:26:\"field_comments-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:8:\"Comments\";s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:29:\"node_revision__field_comments\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:33:\"field_comments-revision_id_status\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:21:\"field_comments_status\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:21:\"field_comments_status\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:20982;s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:20:\"migrate_example_beer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:21:\"field_comments_status\";s:5:\"table\";s:29:\"node_revision__field_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_comments_status\";}s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:21:\"field_comments_status\";s:5:\"table\";s:29:\"node_revision__field_comments\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_comments_status\";}s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:21:\"field_comments_status\";s:5:\"table\";s:29:\"node_revision__field_comments\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:21:\"field_comments_status\";}s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";}}}s:13:\"node__comment\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:13:\"node__comment\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:7:\"comment\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:8:\"Comments\";s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:13:\"node__comment\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:14:\"comment_status\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:14:\"comment_status\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:14:\"comment_status\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:8:\"Comments\";s:5:\"@name\";s:7:\"comment\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:14:\"comment_status\";s:5:\"table\";s:13:\"node__comment\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:14:\"comment_status\";}s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:14:\"comment_status\";s:5:\"table\";s:13:\"node__comment\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:14:\"comment_status\";}s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:14:\"comment_status\";s:5:\"table\";s:13:\"node__comment\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:14:\"comment_status\";}s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";}}}s:22:\"node_revision__comment\";a:3:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:22:\"node_revision__comment\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:19:\"comment-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:8:\"Comments\";s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:22:\"node_revision__comment\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:26:\"comment-revision_id_status\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:14:\"comment_status\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:14:\"comment_status\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:21181;s:11:\"title short\";s:8:\"Comments\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:7:\"article\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:14:\"comment_status\";s:5:\"table\";s:22:\"node_revision__comment\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:14:\"comment_status\";}s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:14:\"comment_status\";s:5:\"table\";s:22:\"node_revision__comment\";s:2:\"id\";s:7:\"numeric\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:14:\"comment_status\";}s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:14:\"comment_status\";s:5:\"table\";s:22:\"node_revision__comment\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:7:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:14:\"comment_status\";}s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";}}}s:10:\"node__body\";a:5:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:5:\"table\";s:10:\"node__body\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:4:\"body\";a:5:{s:5:\"group\";r:448;s:5:\"title\";s:4:\"Body\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:10:\"body_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:10:\"body_value\";a:6:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Body\";s:5:\"@name\";s:4:\"body\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:6:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:4:\"Body\";s:5:\"@name\";s:4:\"body\";s:7:\"@column\";s:7:\"summary\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Body\";s:7:\"@column\";s:7:\"summary\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:7:{s:5:\"group\";r:448;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:4:\"Body\";s:5:\"@name\";s:4:\"body\";s:7:\"@column\";s:6:\"format\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Body\";s:7:\"@column\";s:6:\"format\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:10:\"node__body\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";}}}s:19:\"node_revision__body\";a:5:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:4:{s:5:\"table\";s:19:\"node_revision__body\";s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:16:\"body-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:4:\"Body\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:10:\"real field\";s:22:\"body-revision_id_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:10:\"body_value\";a:6:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:21385;s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:6:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:21436;s:11:\"title short\";r:21443;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:21493;s:11:\"title short\";r:21500;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:83:\"page, article, migrate_example_beer, migrate_example_wine, migrate_example_producer\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"node_revision__body\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";}}}s:21:\"comment__comment_body\";a:4:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:18:\"comment_field_data\";a:4:{s:5:\"table\";s:21:\"comment__comment_body\";s:10:\"left_field\";s:3:\"cid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:12:\"comment_body\";a:5:{s:5:\"group\";r:1818;s:5:\"title\";s:7:\"Comment\";s:11:\"title short\";s:7:\"Comment\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:56:\"comment, node_comments, migrate_example_advanced_comment\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:21:\"comment__comment_body\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:10:\"real field\";s:18:\"comment_body_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:18:\"comment_body_value\";i:4;s:19:\"comment_body_format\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:18:\"comment_body_value\";a:6:{s:5:\"group\";r:1818;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Comment\";s:5:\"@name\";s:12:\"comment_body\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:7:\"Comment\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:56:\"comment, node_comments, migrate_example_advanced_comment\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:18:\"comment_body_value\";s:5:\"table\";s:21:\"comment__comment_body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:8:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:18:\"comment_body_value\";i:7;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:18:\"comment_body_value\";s:5:\"table\";s:21:\"comment__comment_body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:8:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:18:\"comment_body_value\";i:7;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:11:\"allow empty\";b:1;}}s:19:\"comment_body_format\";a:7:{s:5:\"group\";r:1818;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:7:\"Comment\";s:5:\"@name\";s:12:\"comment_body\";s:7:\"@column\";s:6:\"format\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:7:\"Comment\";s:7:\"@column\";s:6:\"format\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:56:\"comment, node_comments, migrate_example_advanced_comment\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:21:\"comment__comment_body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:8:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:18:\"comment_body_value\";i:7;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:21:\"comment__comment_body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:8:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:18:\"comment_body_value\";i:7;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:21:\"comment__comment_body\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:8:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:18:\"comment_body_value\";i:7;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";}}}s:19:\"block_content__body\";a:5:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:24:\"block_content_field_data\";a:4:{s:5:\"table\";s:19:\"block_content__body\";s:10:\"left_field\";s:2:\"id\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:4:\"body\";a:5:{s:5:\"group\";r:13;s:5:\"title\";s:4:\"Body\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:9:{s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:10:\"real field\";s:10:\"body_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;s:14:\"click sortable\";b:1;}}s:10:\"body_value\";a:6:{s:5:\"group\";r:13;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label (@name)\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Body\";s:5:\"@name\";s:4:\"body\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:6:{s:5:\"group\";r:13;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:4:\"Body\";s:5:\"@name\";s:4:\"body\";s:7:\"@column\";s:7:\"summary\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Body\";s:7:\"@column\";s:7:\"summary\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:7:{s:5:\"group\";r:13;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@label (@name:@column)\";s:12:\"\0*\0arguments\";a:3:{s:6:\"@label\";s:4:\"Body\";s:5:\"@name\";s:4:\"body\";s:7:\"@column\";s:6:\"format\";}s:10:\"\0*\0options\";a:0:{}}s:11:\"title short\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"@label:@column\";s:12:\"\0*\0arguments\";a:2:{s:6:\"@label\";s:4:\"Body\";s:7:\"@column\";s:6:\"format\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"block_content__body\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";}}}s:28:\"block_content_revision__body\";a:5:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:28:\"block_content_field_revision\";a:4:{s:5:\"table\";s:28:\"block_content_revision__body\";s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}i:1;a:2:{s:10:\"left_field\";s:8:\"langcode\";s:5:\"field\";s:8:\"langcode\";}}}}s:8:\"provider\";s:5:\"views\";}s:16:\"body-revision_id\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";s:4:\"Body\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:8:{s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:5:\"field\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:10:\"real field\";s:22:\"body-revision_id_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"langcode\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:10:\"body_value\";a:6:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:21976;s:11:\"title short\";s:4:\"Body\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:6:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:22027;s:11:\"title short\";r:22034;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:7:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"@group (historical data)\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@group\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:22084;s:11:\"title short\";r:22091;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Appears in: @bundles.\";s:12:\"\0*\0arguments\";a:1:{s:8:\"@bundles\";s:5:\"basic\";}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"- No value -\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:7:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:6:\"string\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:28:\"block_content_revision__body\";s:2:\"id\";s:8:\"standard\";s:17:\"additional fields\";a:9:{i:0;s:6:\"bundle\";i:1;s:7:\"deleted\";i:2;s:9:\"entity_id\";i:3;s:11:\"revision_id\";i:4;s:8:\"langcode\";i:5;s:5:\"delta\";i:6;s:10:\"body_value\";i:7;s:12:\"body_summary\";i:8;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";}}}s:5:\"views\";a:27:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Global\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"join\";a:1:{s:7:\"#global\";a:0:{}}s:8:\"provider\";s:5:\"views\";}s:6:\"random\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Random\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Randomize the display order.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"sort\";a:1:{s:2:\"id\";s:6:\"random\";}}s:4:\"null\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Null\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:213:\"Allow a contextual filter value to be ignored. The query will not be altered by this contextual filter value. Can be used when contextual filter values come from the URL, and a part of the URL needs to be ignored.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"null\";}}s:7:\"nothing\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Custom text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Provide custom text or link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:6:\"custom\";}}s:7:\"counter\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"View result counter\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Displays the actual position of the view result\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"counter\";}}s:4:\"area\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Text area\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Provide markup text for the area.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:4:\"text\";}}s:16:\"area_text_custom\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Unfiltered text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"Add unrestricted, custom text or markup. This is similar to the custom text field.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:11:\"text_custom\";}}s:5:\"title\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Title override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:115:\"Override the default view title for this view. This is useful to display an alternative title when a view is empty.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:2:\"id\";s:5:\"title\";s:8:\"sub_type\";s:5:\"empty\";}}s:4:\"view\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View area\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Insert a view inside an area.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:4:\"view\";}}s:6:\"result\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Result summary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:53:\"Shows result summary, for example the items per page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:6:\"result\";}}s:8:\"messages\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Messages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Displays messages in an area.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:8:\"messages\";}}s:16:\"http_status_code\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Response status code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:88:\"Alter the HTTP response status code used by this view, mostly helpful for empty results.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:16:\"http_status_code\";}}s:7:\"combine\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Combine fields filter\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"Combine multiple fields together and search by them.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"combine\";}}s:10:\"dropbutton\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Dropbutton\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Display fields in a dropbutton.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:10:\"dropbutton\";}}s:12:\"entity_block\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:22522;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:5:\"block\";s:2:\"id\";s:6:\"entity\";}}s:20:\"entity_block_content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:13:\"block_content\";s:2:\"id\";s:6:\"entity\";}}s:14:\"entity_comment\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:1818;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:7:\"comment\";s:2:\"id\";s:6:\"entity\";}}s:22:\"entity_contact_message\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Contact message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:22567;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:15:\"contact_message\";s:2:\"id\";s:6:\"entity\";}}s:31:\"entity_content_moderation_state\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:1964;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:1964;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:24:\"content_moderation_state\";s:2:\"id\";s:6:\"entity\";}}s:11:\"entity_file\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:2018;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:2018;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:4:\"file\";s:2:\"id\";s:6:\"entity\";}}s:11:\"entity_node\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:4:\"node\";s:2:\"id\";s:6:\"entity\";}}s:15:\"entity_shortcut\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Shortcut link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:22626;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:8:\"shortcut\";s:2:\"id\";s:6:\"entity\";}}s:20:\"entity_taxonomy_term\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:2583;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:13:\"taxonomy_term\";s:2:\"id\";s:6:\"entity\";}}s:11:\"entity_tour\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:22657;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:4:\"tour\";s:2:\"id\";s:6:\"entity\";}}s:11:\"entity_user\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:474;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:474;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:4:\"user\";s:2:\"id\";s:6:\"entity\";}}s:24:\"entity_menu_link_content\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Rendered entity - @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Displays a rendered @label entity in an area.\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:22688;}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:2:{s:11:\"entity_type\";s:17:\"menu_link_content\";s:2:\"id\";s:6:\"entity\";}}s:16:\"contextual_links\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Contextual Links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"Display fields in a contextual links menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:16:\"contextual_links\";}}}s:22:\"block_content_revision\";a:8:{s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:5:\"table\";a:4:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"@entity_type revision\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:13;}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:4:\"join\";a:1:{s:28:\"block_content_field_revision\";a:3:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:13:\"block_content\";}s:15:\"latest_revision\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Is Latest Revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:81:\"Restrict the view to only revisions that are the latest revision of their entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:1:{s:2:\"id\";s:15:\"latest_revision\";}}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";r:104;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:13:\"revision_user\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";r:474;s:5:\"title\";r:474;s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:13:\"revision_user\";}s:16:\"revision_created\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:16:\"revision_created\";}s:12:\"revision_log\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The log entry explaining the changes in this revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:12:\"revision_log\";}s:16:\"revision_default\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"revision_default\";}}s:18:\"comment_field_data\";a:32:{s:5:\"table\";a:6:{s:4:\"base\";a:6:{s:5:\"field\";s:3:\"cid\";s:5:\"title\";r:1818;s:14:\"cache_contexts\";a:0:{}s:8:\"defaults\";a:2:{s:5:\"field\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Comments are responses to content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"access query tag\";s:14:\"comment_access\";}s:5:\"group\";r:1818;s:8:\"provider\";s:7:\"comment\";s:15:\"entity revision\";b:0;s:11:\"entity type\";s:7:\"comment\";s:9:\"wizard_id\";s:7:\"comment\";}s:3:\"cid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Comment ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The comment ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"cid\";}s:12:\"comment_type\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"bundle\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:12:\"comment_type\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";r:1904;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:6:\"status\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Approved status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:3:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Approved comment status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"Whether the comment is approved (or still in the moderation queue).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"pid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Parent CID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The parent comment ID if this is a reply to a comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:6:{s:4:\"base\";s:18:\"comment_field_data\";s:10:\"base field\";s:3:\"cid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Parent comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"The parent comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:12:\"entity field\";s:3:\"pid\";}s:9:\"entity_id\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The ID of the entity of which this comment is a reply.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:16:\"commented_entity\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:9:\"entity_id\";}s:7:\"subject\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:17:\"comment_permalink\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:7:\"subject\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The title of the comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:3:\"uid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Author uid\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:73:\"If you need more fields than the uid add the comment: author relationship\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:6:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"The User ID of the comment\'s author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:12:\"entity field\";s:3:\"uid\";}s:4:\"name\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"The name of the comment\'s author. Can be rendered as a link to the author\'s homepage.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:16:\"comment_username\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"name\";}s:4:\"mail\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:88:\"Email of user that posted the comment. Will be empty if the author is a registered user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"mail\";}s:8:\"homepage\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Author\'s website\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:121:\"The website address of the comment\'s author. Can be rendered as a link. Will be empty if the author is a registered user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:6:\"string\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"homepage\";}s:8:\"hostname\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Hostname\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The comment author\'s hostname.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"hostname\";}s:7:\"created\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Post date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Date and time of when the comment was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"created\";}s:7:\"changed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Date and time of when the comment was last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:6:\"thread\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Thread place\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"The alphadecimal representation of the comment\'s place in a thread, consisting of a base 36 string prefixed by an integer indicating its length.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Depth\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Display the depth of the comment if it is threaded.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:13:\"comment_depth\";}s:4:\"sort\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Thread\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:86:\"Sort by the threaded order. This will keep child comments together with their parents.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:14:\"comment_thread\";}s:12:\"entity field\";s:6:\"thread\";}s:11:\"entity_type\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The entity type to which this comment is attached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:11:\"entity_type\";}s:10:\"field_name\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Comment field name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The field name through which this comment was added.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:10:\"field_name\";}s:16:\"default_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:16:\"created_fulldata\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date in the form of CCYYMMDD.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:13:\"date_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Created year + month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Date in the form of YYYYMM.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:15:\"date_year_month\";}}s:12:\"created_year\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Date in the form of YYYY.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:9:\"date_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Created month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of MM (01 - 12).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:10:\"date_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Created day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of DD (01 - 31).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:8:\"date_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of WW (01 - 53).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:9:\"date_week\";}}s:16:\"changed_fulldata\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Changed date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date in the form of CCYYMMDD.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:13:\"date_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Changed year + month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Date in the form of YYYYMM.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:15:\"date_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Changed year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Date in the form of YYYY.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Changed month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of MM (01 - 12).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:10:\"date_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Changed day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of DD (01 - 31).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:8:\"date_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Changed week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of WW (01 - 53).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_week\";}}s:4:\"node\";a:1:{s:12:\"relationship\";a:8:{s:5:\"title\";r:448;s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The @entity_type to which the comment is a reply to.\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:15:\"node_field_data\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:9:\"entity_id\";s:2:\"id\";s:8:\"standard\";s:5:\"label\";r:448;s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";s:5:\"table\";s:18:\"comment_field_data\";}}}}}s:0:\"\";a:2:{s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:5:\"table\";a:2:{s:11:\"entity type\";s:4:\"user\";s:8:\"provider\";s:5:\"views\";}}s:25:\"comment_entity_statistics\";a:9:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Comment Statistics\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:4:\"type\";s:5:\"INNER\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}}}}s:8:\"provider\";s:5:\"views\";}s:22:\"last_comment_timestamp\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Last comment time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"Date and time of when the last comment was posted.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:22:\"comment_last_timestamp\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}}s:17:\"last_comment_name\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Last comment author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The name of the author of the last posted comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:29:\"comment_ces_last_comment_name\";s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:2:\"id\";s:29:\"comment_ces_last_comment_name\";s:11:\"no group by\";b:1;}}s:13:\"comment_count\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Comment count\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The number of comments an entity has.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:12:\"last_updated\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Updated/commented date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"The most recent of last comment posted or entity updated time.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:24:\"comment_ces_last_updated\";s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:2:\"id\";s:24:\"comment_ces_last_updated\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:1:{s:2:\"id\";s:24:\"comment_ces_last_updated\";}}s:3:\"cid\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Last comment CID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Display the last comment of an entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The last comment of an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:2:\"id\";s:8:\"standard\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"last_comment_uid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Last comment uid\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The User ID of the author of the last comment of an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Last comment author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:2:\"id\";s:8:\"standard\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Last comment author\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}}s:11:\"entity_type\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The entity type to which the comment is a reply to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:10:\"field_name\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Comment field name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"The field name from which the comment originated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}}s:35:\"content_moderation_state_field_data\";a:12:{s:5:\"table\";a:5:{s:4:\"base\";a:3:{s:5:\"field\";s:2:\"id\";s:5:\"title\";r:1964;s:14:\"cache_contexts\";a:0:{}}s:5:\"group\";r:1964;s:8:\"provider\";s:18:\"content_moderation\";s:15:\"entity revision\";b:0;s:11:\"entity type\";s:24:\"content_moderation_state\";}s:2:\"id\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:2:\"id\";}s:11:\"revision_id\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:11:\"revision_id\";}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:3:\"uid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The username of the entity creator.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";r:474;s:5:\"title\";r:474;s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uid\";}s:8:\"workflow\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The workflow the moderation state is in.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"workflow\";}s:16:\"moderation_state\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The moderation state of the referenced content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"moderation_state\";}s:22:\"content_entity_type_id\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Content entity type ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The ID of the content entity type this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:22:\"content_entity_type_id\";}s:17:\"content_entity_id\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Content entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"The ID of the content entity this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:17:\"content_entity_id\";}s:26:\"content_entity_revision_id\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Content entity revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"The revision ID of the content entity this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:26:\"content_entity_revision_id\";}s:16:\"default_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:29:\"revision_translation_affected\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:29:\"revision_translation_affected\";}}s:33:\"content_moderation_state_revision\";a:4:{s:5:\"table\";a:4:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"@entity_type revision\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:1964;}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:18:\"content_moderation\";s:4:\"join\";a:1:{s:39:\"content_moderation_state_field_revision\";a:3:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:24:\"content_moderation_state\";}s:15:\"latest_revision\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Is Latest Revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:81:\"Restrict the view to only revisions that are the latest revision of their entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:1:{s:2:\"id\";s:15:\"latest_revision\";}}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:16:\"revision_default\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"revision_default\";}}s:39:\"content_moderation_state_field_revision\";a:12:{s:5:\"table\";a:6:{s:15:\"entity revision\";b:1;s:4:\"base\";a:2:{s:5:\"field\";s:11:\"revision_id\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"@entity_type revisions\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:1964;}s:10:\"\0*\0options\";a:0:{}}}s:4:\"join\";a:1:{s:35:\"content_moderation_state_field_data\";a:3:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:4:\"type\";s:5:\"INNER\";}}s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"@entity_type revision\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:1964;}s:10:\"\0*\0options\";a:0:{}}s:11:\"entity type\";s:24:\"content_moderation_state\";s:8:\"provider\";s:5:\"views\";}s:2:\"id\";a:6:{s:5:\"title\";r:23591;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:2:\"id\";}s:11:\"revision_id\";a:6:{s:5:\"title\";r:23605;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:11:\"revision_id\";}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:3:\"uid\";a:8:{s:5:\"title\";r:23633;s:4:\"help\";r:23637;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";r:474;s:5:\"title\";r:474;s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uid\";}s:8:\"workflow\";a:7:{s:5:\"title\";r:23657;s:4:\"help\";r:23661;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"workflow\";}s:16:\"moderation_state\";a:7:{s:5:\"title\";r:23675;s:4:\"help\";r:23679;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"moderation_state\";}s:22:\"content_entity_type_id\";a:7:{s:5:\"title\";r:23693;s:4:\"help\";r:23697;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:22:\"content_entity_type_id\";}s:17:\"content_entity_id\";a:7:{s:5:\"title\";r:23711;s:4:\"help\";r:23715;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:17:\"content_entity_id\";}s:26:\"content_entity_revision_id\";a:7:{s:5:\"title\";r:23729;s:4:\"help\";r:23733;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:26:\"content_entity_revision_id\";}s:16:\"default_langcode\";a:7:{s:5:\"title\";r:23747;s:4:\"help\";r:23751;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:29:\"revision_translation_affected\";a:7:{s:5:\"title\";r:23765;s:4:\"help\";r:23769;s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:29:\"revision_translation_affected\";}}s:10:\"file_usage\";a:14:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"File Usage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"join\";a:5:{s:12:\"file_managed\";a:2:{s:5:\"field\";s:3:\"fid\";s:10:\"left_field\";s:3:\"fid\";}s:15:\"node_field_data\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"nid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:4:\"node\";}}}s:16:\"users_field_data\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"uid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:4:\"user\";}}}s:7:\"comment\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"cid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:7:\"comment\";}}}s:18:\"taxonomy_term_data\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"tid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:13:\"taxonomy_term\";}}}}s:8:\"provider\";s:5:\"views\";}s:12:\"file_to_node\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:98:\"Content that is associated with this file, usually because this file is in a field on the content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:5:{i:0;s:15:\"node_field_data\";i:1;s:19:\"node_field_revision\";i:2;s:16:\"users_field_data\";i:3;s:18:\"comment_field_data\";i:4;s:24:\"taxonomy_term_field_data\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:15:\"node_field_data\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:4:\"node\";}}}}s:12:\"node_to_file\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"A file that is associated with this node, usually because it is in a field on the node.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:4:{i:0;s:12:\"file_managed\";i:1;s:16:\"users_field_data\";i:2;s:18:\"comment_field_data\";i:3;s:24:\"taxonomy_term_field_data\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:12:\"file_to_user\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"A user that is associated with this file, usually because this file is in a field on the user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:5:{i:0;s:15:\"node_field_data\";i:1;s:19:\"node_field_revision\";i:2;s:16:\"users_field_data\";i:3;s:18:\"comment_field_data\";i:4;s:24:\"taxonomy_term_field_data\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:4:\"user\";}}}}s:12:\"user_to_file\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:87:\"A file that is associated with this user, usually because it is in a field on the user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:5:{i:0;s:12:\"file_managed\";i:1;s:15:\"node_field_data\";i:2;s:19:\"node_field_revision\";i:3;s:18:\"comment_field_data\";i:4;s:24:\"taxonomy_term_field_data\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:15:\"file_to_comment\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"A comment that is associated with this file, usually because this file is in a field on the comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:5:{i:0;s:15:\"node_field_data\";i:1;s:19:\"node_field_revision\";i:2;s:16:\"users_field_data\";i:3;s:18:\"comment_field_data\";i:4;s:24:\"taxonomy_term_field_data\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:18:\"comment_field_data\";s:10:\"base field\";s:3:\"cid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:7:\"comment\";}}}}s:15:\"comment_to_file\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:93:\"A file that is associated with this comment, usually because it is in a field on the comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:5:{i:0;s:12:\"file_managed\";i:1;s:15:\"node_field_data\";i:2;s:19:\"node_field_revision\";i:3;s:16:\"users_field_data\";i:4;s:24:\"taxonomy_term_field_data\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:21:\"file_to_taxonomy_term\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy Term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:112:\"A taxonomy term that is associated with this file, usually because this file is in a field on the taxonomy term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:5:{i:0;s:15:\"node_field_data\";i:1;s:19:\"node_field_revision\";i:2;s:16:\"users_field_data\";i:3;s:18:\"comment_field_data\";i:4;s:24:\"taxonomy_term_field_data\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy Term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy Term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:13:\"taxonomy_term\";}}}}s:21:\"taxonomy_term_to_file\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:105:\"A file that is associated with this taxonomy term, usually because it is in a field on the taxonomy term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";a:5:{i:0;s:12:\"file_managed\";i:1;s:15:\"node_field_data\";i:2;s:19:\"node_field_revision\";i:3;s:16:\"users_field_data\";i:4;s:18:\"comment_field_data\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:6:\"module\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Module\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"The module managing this file relationship.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:4:\"type\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The type of entity that is related to the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:8:\"standard\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:2:\"id\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"The ID of the entity that is related to the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:5:\"count\";a:5:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Use count\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The number of times the file is used by this entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}}s:12:\"entity_label\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Entity label\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The label of the entity that is related to the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:2:\"id\";s:5:\"field\";a:2:{s:2:\"id\";s:12:\"entity_label\";s:17:\"entity type field\";s:4:\"type\";}}}s:13:\"node_revision\";a:8:{s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:5:\"table\";a:4:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"@entity_type revision\";s:12:\"\0*\0arguments\";a:1:{s:12:\"@entity_type\";r:448;}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"node\";s:4:\"join\";a:1:{s:19:\"node_field_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:4:\"node\";}s:15:\"latest_revision\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Is Latest Revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:81:\"Restrict the view to only revisions that are the latest revision of their entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:1:{s:2:\"id\";s:15:\"latest_revision\";}}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:12:\"revision_uid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"Relate a content revision to the user who created the revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:474;s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:12:\"revision_uid\";}s:18:\"revision_timestamp\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:18:\"revision_timestamp\";}s:12:\"revision_log\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Briefly describe the changes you have made.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:12:\"revision_log\";}s:16:\"revision_default\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"revision_default\";}}s:11:\"node_access\";a:2:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Content access\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"join\";a:1:{s:15:\"node_field_data\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}}s:8:\"provider\";s:5:\"views\";}s:3:\"nid\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Access\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Filter by access.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:2:{s:2:\"id\";s:11:\"node_access\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:107:\"Filter for content by view access. <strong>Not necessary if you are using node as your base table.</strong>\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:17:\"node_search_index\";a:3:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"join\";a:1:{s:15:\"node_field_data\";a:4:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"sid\";s:5:\"table\";s:12:\"search_index\";s:5:\"extra\";s:96:\"node_search_index.type = \'node_search\' AND node_search_index.langcode = node_field_data.langcode\";}}s:8:\"provider\";s:5:\"views\";}s:5:\"score\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Score\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:93:\"The score of the search item. This will not be used if the search filter is not also present.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:3:{s:2:\"id\";s:12:\"search_score\";s:5:\"float\";b:1;s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:2:\"id\";s:12:\"search_score\";s:11:\"no group by\";b:1;}}s:4:\"keys\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Search Keywords\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The keywords to search for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:3:{s:2:\"id\";s:15:\"search_keywords\";s:11:\"no group by\";b:1;s:11:\"search_type\";s:11:\"node_search\";}s:8:\"argument\";a:3:{s:2:\"id\";s:6:\"search\";s:11:\"no group by\";b:1;s:11:\"search_type\";s:11:\"node_search\";}}}s:17:\"node_search_total\";a:1:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:17:\"node_search_index\";a:2:{s:10:\"left_field\";s:4:\"word\";s:5:\"field\";s:4:\"word\";}}s:8:\"provider\";s:5:\"views\";}}s:19:\"node_search_dataset\";a:1:{s:5:\"table\";a:2:{s:4:\"join\";a:1:{s:15:\"node_field_data\";a:6:{s:10:\"left_field\";s:3:\"sid\";s:10:\"left_table\";s:17:\"node_search_index\";s:5:\"field\";s:3:\"sid\";s:5:\"table\";s:14:\"search_dataset\";s:5:\"extra\";s:111:\"node_search_index.type = node_search_dataset.type AND node_search_index.langcode = node_search_dataset.langcode\";s:4:\"type\";s:5:\"INNER\";}}s:8:\"provider\";s:5:\"views\";}}s:21:\"taxonomy_term__parent\";a:2:{s:16:\"parent_target_id\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:123:\"The parent term of the term. This can produce duplicate entries if you are using a vocabulary that allows multiple parents.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"taxonomy\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:24:\"taxonomy_term_field_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Parent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";r:2583;s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"parent\";}s:5:\"table\";a:4:{s:5:\"group\";r:2583;s:8:\"provider\";s:8:\"taxonomy\";s:4:\"join\";a:2:{s:24:\"taxonomy_term_field_data\";a:3:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}s:21:\"taxonomy_term__parent\";a:2:{s:10:\"left_field\";s:9:\"entity_id\";s:5:\"field\";s:16:\"parent_target_id\";}}s:11:\"entity type\";s:13:\"taxonomy_term\";}}s:14:\"taxonomy_index\";a:6:{s:5:\"table\";a:3:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"join\";a:3:{s:24:\"taxonomy_term_field_data\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}s:15:\"node_field_data\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}s:21:\"taxonomy_term__parent\";a:2:{s:10:\"left_field\";s:9:\"entity_id\";s:5:\"field\";s:3:\"tid\";}}s:8:\"provider\";s:5:\"views\";}s:3:\"nid\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Content with term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Relate all content tagged with a term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"relationship\";a:5:{s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"node\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"skip base\";s:4:\"node\";}}s:3:\"tid\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Has taxonomy term ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"Display content if it has the selected taxonomy terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:6:{s:2:\"id\";s:18:\"taxonomy_index_tid\";s:10:\"name table\";s:24:\"taxonomy_term_field_data\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Uncategorized\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"numeric\";b:1;s:9:\"skip base\";s:24:\"taxonomy_term_field_data\";}s:6:\"filter\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Has taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"taxonomy_index_tid\";s:15:\"hierarchy table\";s:21:\"taxonomy_term__parent\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:24:\"taxonomy_term_field_data\";s:11:\"allow empty\";b:1;}}s:6:\"status\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Publish status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"Whether or not the content related to a term is published.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:3:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Published status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";}}s:6:\"sticky\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Sticky status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"Whether or not the content related to a term is sticky.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:3:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Sticky status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:2:{s:2:\"id\";s:8:\"standard\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:109:\"Whether or not the content related to a term is sticky. To list sticky content first, set this to descending.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:7:\"created\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Post date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The date the content related to a term was posted.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}}}s:16:\"users_field_data\";a:30:{s:5:\"table\";a:6:{s:4:\"base\";a:5:{s:5:\"field\";s:3:\"uid\";s:5:\"title\";r:474;s:14:\"cache_contexts\";a:0:{}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Users who have created accounts on your site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"access query tag\";s:11:\"user_access\";}s:5:\"group\";r:474;s:8:\"provider\";s:4:\"user\";s:15:\"entity revision\";b:0;s:11:\"entity type\";s:4:\"user\";s:9:\"wizard_id\";s:4:\"user\";}s:3:\"uid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The user ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:4:{s:2:\"id\";s:8:\"user_uid\";s:10:\"name table\";s:16:\"users_field_data\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";s:9:\"Anonymous\";}s:6:\"filter\";a:3:{s:2:\"id\";s:9:\"user_name\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Name (autocomplete)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:119:\"The user or author name. Uses an autocomplete widget to find a user name, the actual filter uses the resulting user ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uid\";s:12:\"relationship\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Content authored\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:126:\"Relate content to the user who created it. This relationship will create one record for each content item created by the user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:15:\"node_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"nodes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Translation language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Language of the translation of user information\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:18:\"preferred_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Preferred language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Preferred language of the user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:18:\"preferred_langcode\";}s:24:\"preferred_admin_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Preferred admin language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Preferred administrative language of the user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:24:\"preferred_admin_langcode\";}s:4:\"name\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The user or author name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:9:\"user_name\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:3:{s:2:\"id\";s:6:\"string\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Name (raw)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:126:\"The user or author name. This filter does not check if the user exists and allows partial matching. Does not use autocomplete.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"name\";}s:4:\"pass\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The password of this user (hashed).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"pass\";}s:4:\"mail\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:104:\"Email address for a given user. This field is normally not shown to users, so be cautious when using it.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"mail\";}s:8:\"timezone\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Timezone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The timezone of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"timezone\";}s:6:\"status\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"User status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Whether the user is active or blocked.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:3:{s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Active\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:7:\"created\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the user was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"created\";}s:7:\"changed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the user was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:6:\"access\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Last access\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The time that the user last accessed the site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:6:\"access\";}s:5:\"login\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Last login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time that the user last logged in.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:5:\"login\";}s:4:\"init\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Initial email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The email address used for initial account creation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"init\";}s:16:\"default_langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"boolean\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:16:\"default_langcode\";}s:7:\"uid_raw\";a:3:{s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The raw numeric user ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:3:\"uid\";s:6:\"filter\";a:2:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"The user ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:7:\"numeric\";}}s:18:\"uid_representative\";a:1:{s:12:\"relationship\";a:11:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Representative node\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Representative node\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:89:\"Obtains a single representative node for each user, according to a chosen sort criterion.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:13:\"groupwise_max\";s:18:\"relationship field\";s:3:\"uid\";s:11:\"outer field\";s:20:\"users_field_data.uid\";s:14:\"argument table\";s:16:\"users_field_data\";s:14:\"argument field\";s:3:\"uid\";s:4:\"base\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:19:\"node_field_data:uid\";}}s:16:\"created_fulldate\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date in the form of CCYYMMDD.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:13:\"date_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Created year + month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Date in the form of YYYYMM.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:15:\"date_year_month\";}}s:12:\"created_year\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Date in the form of YYYY.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:9:\"date_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Created month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of MM (01 - 12).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:10:\"date_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Created day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of DD (01 - 31).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:8:\"date_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Created week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of WW (01 - 53).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:9:\"date_week\";}}s:16:\"changed_fulldate\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Date in the form of CCYYMMDD.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:13:\"date_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Updated year + month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Date in the form of YYYYMM.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:15:\"date_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated year\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Date in the form of YYYY.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Updated month\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of MM (01 - 12).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:10:\"date_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Updated day\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of DD (01 - 31).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:8:\"date_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Updated week\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Date in the form of WW (01 - 53).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:2:\"id\";s:9:\"date_week\";}}}s:11:\"user__roles\";a:3:{s:15:\"roles_target_id\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Roles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The roles the user has.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:10:\"user_roles\";s:11:\"no group by\";b:1;}s:8:\"argument\";a:6:{s:2:\"id\";s:15:\"user__roles_rid\";s:10:\"name table\";s:4:\"role\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"No role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"zero is null\";b:1;s:7:\"numeric\";b:1;}s:6:\"filter\";a:2:{s:2:\"id\";s:10:\"user_roles\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:5:\"roles\";}s:5:\"table\";a:4:{s:5:\"group\";r:474;s:8:\"provider\";s:4:\"user\";s:4:\"join\";a:1:{s:16:\"users_field_data\";a:3:{s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:11:\"entity type\";s:4:\"user\";}s:10:\"permission\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Permission\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The user permissions.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:16:\"user_permissions\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:2:{s:2:\"id\";s:16:\"user_permissions\";s:10:\"real field\";s:15:\"roles_target_id\";}}}s:26:\"views_entity_block_content\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:4:{s:24:\"block_content_field_data\";a:1:{s:10:\"left_table\";s:24:\"block_content_field_data\";}s:28:\"block_content_field_revision\";a:1:{s:10:\"left_table\";s:28:\"block_content_field_revision\";}s:13:\"block_content\";a:1:{s:10:\"left_table\";s:13:\"block_content\";}s:22:\"block_content_revision\";a:1:{s:10:\"left_table\";s:22:\"block_content_revision\";}}s:11:\"entity type\";s:13:\"block_content\";s:5:\"group\";r:13;}}s:17:\"views_entity_node\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:4:{s:15:\"node_field_data\";a:1:{s:10:\"left_table\";s:15:\"node_field_data\";}s:19:\"node_field_revision\";a:1:{s:10:\"left_table\";s:19:\"node_field_revision\";}s:4:\"node\";a:1:{s:10:\"left_table\";s:4:\"node\";}s:13:\"node_revision\";a:1:{s:10:\"left_table\";s:13:\"node_revision\";}}s:11:\"entity type\";s:4:\"node\";s:5:\"group\";r:448;}}s:20:\"views_entity_comment\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:2:{s:7:\"comment\";a:1:{s:10:\"left_table\";s:7:\"comment\";}s:18:\"comment_field_data\";a:1:{s:10:\"left_table\";s:18:\"comment_field_data\";}}s:11:\"entity type\";s:7:\"comment\";s:5:\"group\";r:1818;}}s:37:\"views_entity_content_moderation_state\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:4:{s:24:\"content_moderation_state\";a:1:{s:10:\"left_table\";s:24:\"content_moderation_state\";}s:35:\"content_moderation_state_field_data\";a:1:{s:10:\"left_table\";s:35:\"content_moderation_state_field_data\";}s:33:\"content_moderation_state_revision\";a:1:{s:10:\"left_table\";s:33:\"content_moderation_state_revision\";}s:39:\"content_moderation_state_field_revision\";a:1:{s:10:\"left_table\";s:39:\"content_moderation_state_field_revision\";}}s:11:\"entity type\";s:24:\"content_moderation_state\";s:5:\"group\";r:1964;}}s:17:\"views_entity_file\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:1:{s:12:\"file_managed\";a:1:{s:10:\"left_table\";s:12:\"file_managed\";}}s:11:\"entity type\";s:4:\"file\";s:5:\"group\";r:2018;}}s:26:\"views_entity_taxonomy_term\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:18:\"taxonomy_term_data\";a:1:{s:10:\"left_table\";s:18:\"taxonomy_term_data\";}s:24:\"taxonomy_term_field_data\";a:1:{s:10:\"left_table\";s:24:\"taxonomy_term_field_data\";}s:21:\"taxonomy_term__parent\";a:1:{s:10:\"left_table\";s:21:\"taxonomy_term__parent\";}}s:11:\"entity type\";s:13:\"taxonomy_term\";s:5:\"group\";r:2583;}}s:17:\"views_entity_user\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:4:{s:5:\"users\";a:1:{s:10:\"left_table\";s:5:\"users\";}s:0:\"\";a:1:{s:10:\"left_table\";s:0:\"\";}s:16:\"users_field_data\";a:1:{s:10:\"left_table\";s:16:\"users_field_data\";}s:11:\"user__roles\";a:1:{s:10:\"left_table\";s:11:\"user__roles\";}}s:11:\"entity type\";s:4:\"user\";s:5:\"group\";r:474;}}}',-1,1540294711.030,1,'config:core.extension views_data','96');
INSERT INTO `cache_default` VALUES ('views_data:file_managed:en',_binary 'a:18:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:6:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:4:\"base\";a:5:{s:5:\"field\";s:3:\"fid\";s:5:\"title\";r:14;s:14:\"cache_contexts\";a:0:{}s:8:\"defaults\";a:1:{s:5:\"field\";s:8:\"filename\";}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Files maintained by Drupal and various modules.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:15:\"entity revision\";b:0;s:11:\"entity type\";s:4:\"file\";s:9:\"wizard_id\";s:12:\"file_managed\";}s:3:\"fid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"File ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The file ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:3:{s:2:\"id\";s:8:\"file_fid\";s:10:\"name field\";s:8:\"filename\";s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"fid\";s:12:\"relationship\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"File usage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Relate file entities to their usage.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";s:4:\"base\";s:10:\"file_usage\";s:10:\"base field\";s:3:\"fid\";s:5:\"field\";s:3:\"fid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"File usage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The file UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The file language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:3:\"uid\";a:8:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The user ID of the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"relationship\";a:5:{s:4:\"base\";s:16:\"users_field_data\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"User who uploaded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"User who uploaded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uid\";}s:8:\"filename\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Filename\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Name of the file with no path components.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"filename\";}s:3:\"uri\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The URI to access the file (either local or remote).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:8:\"file_uri\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:3:\"uri\";}s:8:\"filemime\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"File MIME type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The file\'s MIME type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:13:\"file_filemime\";}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"filemime\";}s:8:\"filesize\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"File size\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The size of the file in bytes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:17:\"default_formatter\";s:9:\"file_size\";}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"filesize\";}s:6:\"status\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The status of the file, temporary (FALSE) and permanent (TRUE).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:26:\"default_formatter_settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:19:\"format_custom_false\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Temporary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:18:\"format_custom_true\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Permanent\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:8:\"argument\";a:1:{s:2:\"id\";s:7:\"numeric\";}s:6:\"filter\";a:1:{s:2:\"id\";s:11:\"file_status\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:6:\"status\";}s:7:\"created\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The timestamp that the file was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"created\";}s:7:\"changed\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The timestamp that the file was last changed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:4:\"date\";}s:6:\"filter\";a:1:{s:2:\"id\";s:4:\"date\";}s:4:\"sort\";a:1:{s:2:\"id\";s:4:\"date\";}s:12:\"entity field\";s:7:\"changed\";}s:9:\"extension\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Extension\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The extension of the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:8:\"filename\";s:5:\"field\";a:5:{s:11:\"entity_type\";s:4:\"file\";s:10:\"field_name\";s:8:\"filename\";s:17:\"default_formatter\";s:14:\"file_extension\";s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}}s:24:\"reverse_field_image_node\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:11:\"field_image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:296;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:296;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"field table\";s:17:\"node__field_image\";s:11:\"field field\";s:21:\"field_image_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:44:\"reverse_field_migrate_example_adv_image_node\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:296;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:31:\"field_migrate_example_adv_image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:296;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:296;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"field table\";s:37:\"node__field_migrate_example_adv_image\";s:11:\"field field\";s:41:\"field_migrate_example_adv_image_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:40:\"reverse_field_migrate_example_image_node\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:296;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:27:\"field_migrate_example_image\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:296;s:6:\"@field\";s:5:\"Image\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:296;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:15:\"node_field_data\";s:11:\"entity_type\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"field table\";s:33:\"node__field_migrate_example_image\";s:11:\"field field\";s:37:\"field_migrate_example_image_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:25:\"reverse_user_picture_user\";a:1:{s:12:\"relationship\";a:12:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"@entity using @field\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"@field\";s:7:\"Picture\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"@field_name\";s:12:\"\0*\0arguments\";a:1:{s:11:\"@field_name\";s:12:\"user_picture\";}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Relate each @entity with a @field set to the image.\";s:12:\"\0*\0arguments\";a:2:{s:7:\"@entity\";r:395;s:6:\"@field\";s:7:\"Picture\";}s:10:\"\0*\0options\";a:0:{}}s:5:\"group\";r:395;s:2:\"id\";s:14:\"entity_reverse\";s:4:\"base\";s:16:\"users_field_data\";s:11:\"entity_type\";s:4:\"user\";s:10:\"base field\";s:3:\"uid\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"field table\";s:18:\"user__user_picture\";s:11:\"field field\";s:22:\"user_picture_target_id\";s:10:\"join_extra\";a:1:{i:0;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}',-1,1540294711.305,1,'config:core.extension views_data','96'),('views_data:menu_link_content:en',_binary 'a:1:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}}',-1,1540294711.408,1,'config:core.extension views_data','96'),('views_data:node:en',_binary 'a:11:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:14:\"node_bulk_form\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Node operations bulk form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Add a form element that lets you run operations on multiple nodes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:14:\"node_bulk_form\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"node\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:15:\"node_field_data\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:4:\"node\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:9:\"view_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:9:\"edit_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:11:\"delete_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:6:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:18:\"node_listing_empty\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Empty Node Frontpage behavior\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provides a link to the node add overview page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"area\";a:1:{s:2:\"id\";s:18:\"node_listing_empty\";}}s:12:\"new_comments\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"New comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The number of new comments on the node.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:17:\"node_new_comments\";s:11:\"no group by\";b:1;}}}',-1,1540294711.313,1,'config:core.extension views_data','96'),('views_data:shortcut:en',_binary 'a:1:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}}',-1,1540294711.383,1,'config:core.extension views_data','96'),('views_data:taxonomy_term_data:en',_binary 'a:8:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:24:\"taxonomy_term_field_data\";a:3:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:13:\"taxonomy_term\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:18:\"view_taxonomy_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:18:\"edit_taxonomy_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:20:\"delete_taxonomy_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Link to delete @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provide a delete link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:14;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:18:\"entity_link_delete\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The term language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}}',-1,1540294711.391,1,'config:core.extension views_data','96'),('views_data:users:en',_binary 'a:11:{s:15:\"rendered_entity\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Rendered entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Renders an entity in a view mode.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"rendered_entity\";}}s:14:\"user_bulk_form\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Bulk update\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Add a form element that lets you run operations on multiple users.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:14:\"user_bulk_form\";}}s:5:\"table\";a:5:{s:5:\"group\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:15:\"entity revision\";b:0;s:4:\"join\";a:1:{s:16:\"users_field_data\";a:3:{s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";s:4:\"type\";s:5:\"INNER\";}}s:11:\"entity type\";s:4:\"user\";}s:10:\"operations\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Operations links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Provides links to perform entity operations.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:17:\"entity_operations\";}}s:9:\"view_user\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Link to @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Provide a view link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"entity_link\";}}s:9:\"edit_user\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Link to edit @entity_type_label\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide an edit link to the @entity_type_label.\";s:12:\"\0*\0arguments\";a:1:{s:18:\"@entity_type_label\";r:25;}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_link_edit\";}}s:4:\"uuid\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The user UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:2:{s:2:\"id\";s:5:\"field\";s:14:\"click sortable\";b:0;}s:8:\"argument\";a:1:{s:2:\"id\";s:6:\"string\";}s:6:\"filter\";a:1:{s:2:\"id\";s:6:\"string\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:4:\"uuid\";}s:8:\"langcode\";a:7:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Original language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The user language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"field\";a:1:{s:2:\"id\";s:5:\"field\";}s:8:\"argument\";a:1:{s:2:\"id\";s:8:\"language\";}s:6:\"filter\";a:1:{s:2:\"id\";s:8:\"language\";}s:4:\"sort\";a:1:{s:2:\"id\";s:8:\"standard\";}s:12:\"entity field\";s:8:\"langcode\";}s:11:\"uid_current\";a:4:{s:10:\"real field\";s:3:\"uid\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Current\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Filter the view to the currently logged in user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:6:\"filter\";a:2:{s:2:\"id\";s:12:\"user_current\";s:4:\"type\";s:6:\"yes-no\";}}s:4:\"data\";a:4:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Data\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Provides access to the user data service.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"real field\";s:3:\"uid\";s:5:\"field\";a:1:{s:2:\"id\";s:9:\"user_data\";}}s:7:\"contact\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Provide a simple link to the user contact page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:12:\"contact_link\";}}}',-1,1540294711.399,1,'config:core.extension views_data','96');
/*!40000 ALTER TABLE `cache_default` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_discovery`
--

DROP TABLE IF EXISTS `cache_discovery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_discovery` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_discovery`
--

LOCK TABLES `cache_discovery` WRITE;
/*!40000 ALTER TABLE `cache_discovery` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_discovery` VALUES ('devel_generate_plugins',_binary 'a:5:{s:10:\"vocabulary\";a:9:{s:8:\"settings\";a:3:{s:3:\"num\";i:1;s:12:\"title_length\";i:12;s:4:\"kill\";b:0;}s:13:\"drushSettings\";a:0:{}s:2:\"id\";s:10:\"vocabulary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"vocabularies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"Generate a given number of vocabularies. Optionally delete current vocabularies.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"url\";s:6:\"vocabs\";s:10:\"permission\";s:25:\"administer devel_generate\";s:5:\"class\";s:66:\"Drupal\\devel_generate\\Plugin\\DevelGenerate\\VocabularyDevelGenerate\";s:8:\"provider\";s:14:\"devel_generate\";}s:4:\"term\";a:9:{s:8:\"settings\";a:3:{s:3:\"num\";i:10;s:12:\"title_length\";i:12;s:4:\"kill\";b:0;}s:13:\"drushSettings\";a:0:{}s:2:\"id\";s:4:\"term\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"terms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Generate a given number of terms. Optionally delete current terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"url\";s:4:\"term\";s:10:\"permission\";s:25:\"administer devel_generate\";s:5:\"class\";s:60:\"Drupal\\devel_generate\\Plugin\\DevelGenerate\\TermDevelGenerate\";s:8:\"provider\";s:14:\"devel_generate\";}s:7:\"content\";a:9:{s:8:\"settings\";a:4:{s:3:\"num\";i:50;s:4:\"kill\";b:0;s:12:\"max_comments\";i:0;s:12:\"title_length\";i:4;}s:13:\"drushSettings\";a:0:{}s:2:\"id\";s:7:\"content\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"Generate a given number of content. Optionally delete current content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"url\";s:7:\"content\";s:10:\"permission\";s:25:\"administer devel_generate\";s:5:\"class\";s:63:\"Drupal\\devel_generate\\Plugin\\DevelGenerate\\ContentDevelGenerate\";s:8:\"provider\";s:14:\"devel_generate\";}s:4:\"user\";a:9:{s:8:\"settings\";a:3:{s:3:\"num\";i:50;s:4:\"kill\";b:0;s:4:\"pass\";s:0:\"\";}s:13:\"drushSettings\";a:0:{}s:2:\"id\";s:4:\"user\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Generate a given number of users. Optionally delete current users.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"url\";s:4:\"user\";s:10:\"permission\";s:25:\"administer devel_generate\";s:5:\"class\";s:60:\"Drupal\\devel_generate\\Plugin\\DevelGenerate\\UserDevelGenerate\";s:8:\"provider\";s:14:\"devel_generate\";}s:4:\"menu\";a:9:{s:8:\"settings\";a:5:{s:9:\"num_menus\";i:2;s:9:\"num_links\";i:50;s:12:\"title_length\";i:12;s:9:\"max_width\";i:6;s:4:\"kill\";b:0;}s:13:\"drushSettings\";a:0:{}s:2:\"id\";s:4:\"menu\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"menus\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:81:\"Generate a given number of menus and menu links. Optionally delete current menus.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:3:\"url\";s:4:\"menu\";s:10:\"permission\";s:25:\"administer devel_generate\";s:5:\"class\";s:60:\"Drupal\\devel_generate\\Plugin\\DevelGenerate\\MenuDevelGenerate\";s:8:\"provider\";s:14:\"devel_generate\";}}',-1,1540294709.391,1,'','0'),('entity_base_field_definitions:block_content:en',_binary 'a:16:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Custom block ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The custom block ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:31;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The custom block UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:57;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"The revision ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:86;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"The custom block language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:118;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:18:\"block_content_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The block type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"revision_created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:145;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"revision_created\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:13:\"revision_user\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:168;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:13:\"revision_user\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:12:\"revision_log\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:194;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The log entry explaining the changes in this revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:25;s:8:\"settings\";a:1:{s:4:\"rows\";i:4;}}}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:12:\"revision_log\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:228;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"info\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:259;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:11:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Block description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"A brief description of your block.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:11:\"constraints\";a:1:{s:11:\"UniqueField\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"info\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:295;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the custom block was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:8:\"reusable\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:319;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Reusable\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"A boolean indicating whether this block is reusable.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:0;s:12:\"revisionable\";b:0;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:8:\"reusable\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:354;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:389;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:423;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"moderation_state\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:456;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:12:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The moderation state of this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"computed\";b:1;s:5:\"class\";s:67:\"Drupal\\content_moderation\\Plugin\\Field\\ModerationStateFieldItemList\";s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:6:\"hidden\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:0;}s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:24:\"moderation_state_default\";s:6:\"weight\";i:100;s:8:\"settings\";a:0:{}}s:12:\"configurable\";b:1;}}s:11:\"constraints\";a:1:{s:15:\"ModerationState\";a:0:{}}s:9:\"read-only\";b:0;s:12:\"translatable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"moderation_state\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}}',-1,1540294710.130,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:comment:en',_binary 'a:19:{s:3:\"cid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Comment ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The comment ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"cid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:31;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:57;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:12:\"comment_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:88;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"comment_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:12:\"comment_type\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:115;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:22:\"default_value_callback\";s:47:\"Drupal\\comment\\Entity\\Comment::getDefaultStatus\";s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:3:\"pid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:147;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:7:\"comment\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Parent ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The parent comment ID if this is a reply to a comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"pid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:172;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The ID of the entity of which this comment is a reply.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:7:\"subject\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:198;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:64;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Subject\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"subject\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:226;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The user ID of the comment author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:9:\"target_id\";i:0;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:255;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:60;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment author\'s name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:284;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The comment author\'s email address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"homepage\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"uri\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:307;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:uri\";s:8:\"settings\";a:2:{s:10:\"max_length\";i:255;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Homepage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The comment author\'s home page address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"homepage\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"hostname\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:332;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Hostname\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The comment author\'s hostname.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:22:\"default_value_callback\";s:49:\"Drupal\\comment\\Entity\\Comment::getDefaultHostname\";s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"hostname\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:359;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time that the comment was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:382;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"The time that the comment was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:6:\"thread\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:405;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Thread place\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"The alphadecimal representation of the comment\'s place in a thread, consisting of a base 36 string prefixed by an integer indicating its length.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:6:\"thread\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:11:\"entity_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:430;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The entity type to which this comment is attached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:11:\"entity_type\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:10:\"field_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:455;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Comment field name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The field name through which this comment was added.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:10:\"field_name\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:480;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}}',-1,1540294710.201,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:contact_message:en',_binary 'a:9:{s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The message UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:28;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The message language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:12:\"contact_form\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:58;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"contact_form\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Form ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The ID of the associated form.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:12:\"contact_form\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:85;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The sender\'s name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The name of the person that is sending the contact message.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:110;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"The sender\'s email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"The email of the person that is sending the contact message.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:7:\"subject\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:132;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:100;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Subject\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:7:\"subject\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:7:\"message\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:160;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:4:\"rows\";i:12;}}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:5:\"label\";s:5:\"above\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:7:\"message\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"copy\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:194;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Copy\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"Whether to send a copy of the message to the sender.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"copy\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:9:\"recipient\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:224;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Recipient ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The ID of the recipient user for personal contact messages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:9:\"recipient\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}}',-1,1540294710.274,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:content_moderation_state:en',_binary 'a:13:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:27;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:49;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:74;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:102;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The username of the entity creator.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:73:\"Drupal\\content_moderation\\Entity\\ContentModerationState::getCurrentUserId\";s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:8:\"workflow\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:130;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:8:\"workflow\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The workflow the moderation state is in.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:8:\"workflow\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:16:\"moderation_state\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:157;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The moderation state of the referenced content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"moderation_state\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:22:\"content_entity_type_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:185;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Content entity type ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The ID of the content entity type this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:22:\"content_entity_type_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:17:\"content_entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:212;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Content entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"The ID of the content entity this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:17:\"content_entity_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:26:\"content_entity_revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:242;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Content entity revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"The revision ID of the content entity this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:26:\"content_entity_revision_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:272;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:307;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:341;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;}}}',-1,1540294710.291,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:file:en',_binary 'a:11:{s:3:\"fid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"File ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The file ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"fid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:31;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The file UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:57;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The file language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:87;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The user ID of the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filename\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Filename\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Name of the file with no path components.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filename\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:3:\"uri\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"file_uri\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:137;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:file_uri\";s:8:\"settings\";a:2:{s:10:\"max_length\";i:255;s:14:\"case_sensitive\";b:1;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The URI to access the file (either local or remote).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:13:\"FileUriUnique\";N;}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"uri\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filemime\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:163;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"File MIME type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The file\'s MIME type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filemime\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filesize\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:188;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:3:\"big\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"File size\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The size of the file in bytes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filesize\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:216;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The status of the file, temporary (FALSE) and permanent (TRUE).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:249;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The timestamp that the file was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:271;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The timestamp that the file was last changed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}}',-1,1540294710.309,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:menu_link_content:en',_binary 'a:16:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"The entity ID for this menu link content entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:31;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The content menu link UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:57;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The menu link language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"bundle\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:88;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";s:23:\"Custom menu link bundle\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The content menu link bundle.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"bundle\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"enabled\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:65:\"A flag for whether the link should be enabled in menus or hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:-1;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"enabled\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:158;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Menu link title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The text to be used for this link in the menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:196;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Shown when hovering over the menu link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:9:\"menu_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:232;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Menu name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:93:\"The menu name. All links with the same menu name (such as \"tools\") are part of the same menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"tools\";}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:9:\"menu_name\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:260;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:17;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The location this menu link points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:-2;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"external\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:290;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"External\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:120:\"A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"external\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:10:\"rediscover\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:323;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"Indicates whether the menu link should be rediscovered\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:10:\"rediscover\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:352;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:172:\"Link weight among links in the same menu at the same depth. In the menu, the links with high weight will sink and links with a low weight will be positioned nearer the top.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"number\";s:6:\"weight\";i:20;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"expanded\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:393;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Show as expanded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"If selected and this menu link has children, the menu will always appear expanded.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"expanded\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:437;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Parent plugin ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"The ID of the parent menu link plugin, or empty string when at the top level of the hierarchy.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:462;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The time that the menu link was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:485;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}}',-1,1540294710.384,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:node:en',_binary 'a:20:{s:3:\"nid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"nid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:27;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:3:\"vid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:49;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"vid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:74;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:102;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"node_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:12:\"Content type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:18:\"revision_timestamp\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:122;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:18:\"revision_timestamp\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:12:\"revision_uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:145;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:12:\"revision_uid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:12:\"revision_log\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:171;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Briefly describe the changes you have made.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:25;s:8:\"settings\";a:1:{s:4:\"rows\";i:4;}}}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:12:\"revision_log\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:205;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:120;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:244;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:279;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The username of the content author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:22:\"default_value_callback\";s:41:\"Drupal\\node\\Entity\\Node::getCurrentUserId\";s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"author\";s:6:\"weight\";i:0;}}s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:11:\"placeholder\";s:0:\"\";}}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:322;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored on\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the node was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:357;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the node was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"promote\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:381;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Promoted to front page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:6:\"sticky\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:420;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Sticky at top of lists\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:6:\"sticky\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:459;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:494;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:528;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:16:\"moderation_state\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:561;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:12:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The moderation state of this piece of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"computed\";b:1;s:5:\"class\";s:67:\"Drupal\\content_moderation\\Plugin\\Field\\ModerationStateFieldItemList\";s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:6:\"region\";s:6:\"hidden\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:0;}s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:24:\"moderation_state_default\";s:6:\"weight\";i:100;s:8:\"settings\";a:0:{}}s:12:\"configurable\";b:1;}}s:11:\"constraints\";a:1:{s:15:\"ModerationState\";a:0:{}}s:9:\"read-only\";b:0;s:12:\"translatable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"moderation_state\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"path\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"path\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:605;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:path\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;}s:12:\"configurable\";b:1;}}s:8:\"computed\";b:1;s:8:\"provider\";s:4:\"path\";s:10:\"field_name\";s:4:\"path\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}}',-1,1540294710.242,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:shortcut:en',_binary 'a:8:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The ID of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:31;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The UUID of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:57;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The language code of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:12:\"shortcut_set\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:88;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"shortcut_set\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The bundle of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:12:\"shortcut_set\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:115;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The name of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-10;s:8:\"settings\";a:1:{s:4:\"size\";i:40;}}}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:149;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Weight among shortcuts in the same shortcut set.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:177;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:1;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The location this shortcut points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:208;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}}',-1,1540294710.346,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:taxonomy_term:en',_binary 'a:12:{s:3:\"tid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Term ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The term ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"tid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:31;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:57;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The term language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:3:\"vid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:88;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:19:\"taxonomy_vocabulary\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The vocabulary to which the term is assigned.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"vid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:115;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:5:\"class\";s:22:\"Drupal\\user\\StatusItem\";}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:147;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:181;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:text_long\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:14:\"text_textfield\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:212;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The weight of this term in relation to other terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:243;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:269;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the term was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:292;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"path\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"path\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:327;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:path\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"URL alias\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;}s:12:\"configurable\";b:1;}}s:8:\"computed\";b:1;s:8:\"provider\";s:4:\"path\";s:10:\"field_name\";s:4:\"path\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}}',-1,1540294710.375,1,'entity_field_info entity_types','885'),('entity_base_field_definitions:user:en',_binary 'a:17:{s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The user ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:31;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The user UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:57;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The user language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:18:\"preferred_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:87;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:60:\"Drupal\\user\\Entity\\User::getAllowedConfigurableLanguageCodes\";}s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Preferred language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"The user\'s preferred language code for receiving emails and viewing the site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:18:\"preferred_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:24:\"preferred_admin_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:116;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:60:\"Drupal\\user\\Entity\\User::getAllowedConfigurableLanguageCodes\";}s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Preferred admin language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"The user\'s preferred language code for viewing administration pages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";N;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:24:\"preferred_admin_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:148;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:5:\"class\";s:25:\"\\Drupal\\user\\UserNameItem\";}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The name of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:11:\"constraints\";a:2:{s:8:\"UserName\";a:0:{}s:14:\"UserNameUnique\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"pass\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"password\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:178;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:password\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The password of this user (hashed).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:18:\"ProtectedUserField\";N;}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"pass\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:205;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The email of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:11:\"constraints\";a:3:{s:14:\"UserMailUnique\";N;s:16:\"UserMailRequired\";N;s:18:\"ProtectedUserField\";N;}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:8:\"timezone\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:234;s:13:\"\0*\0definition\";a:4:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:44:\"Drupal\\user\\Entity\\User::getAllowedTimezones\";}}}}s:5:\"class\";s:24:\"Drupal\\user\\TimeZoneItem\";}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Timezone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The timezone of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:8:\"timezone\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:265;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:5:\"class\";s:22:\"Drupal\\user\\StatusItem\";}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"User status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Whether the user is active or blocked.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:299;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the user was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:321;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the user was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:6:\"access\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:344;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Last access\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The time that the user last accessed the site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:6:\"access\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:5:\"login\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:369;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Last login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time that the user last logged in.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:5:\"login\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"init\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:394;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Initial email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The email address used for initial account creation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"init\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:5:\"roles\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:419;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"user_role\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Roles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The roles the user has.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:5:\"roles\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:445;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}}',-1,1540294710.175,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:block_content:basic:en',_binary 'a:1:{s:4:\"body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:24:\"block_content.basic.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:13:\"\0*\0field_type\";s:17:\"text_with_summary\";s:14:\"\0*\0entity_type\";s:13:\"block_content\";s:9:\"\0*\0bundle\";s:5:\"basic\";s:8:\"\0*\0label\";s:4:\"Body\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:1:{s:15:\"display_summary\";b:0;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:24:\"block_content.basic.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"9a2ee506-d13c-486a-8dad-1114bf13ecdd\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"R__6wc-rMfFMO8d7jcgqnqiA92j8spKhcc5MiqecrMc\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:32:\"field.storage.block_content.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}}',-1,1540294710.529,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:comment:comment:en',_binary 'a:2:{s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The ID of the entity of which this comment is a reply.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";}}s:12:\"comment_body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:28:\"comment.comment.comment_body\";s:13:\"\0*\0field_name\";s:12:\"comment_body\";s:13:\"\0*\0field_type\";s:9:\"text_long\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:9:\"\0*\0bundle\";s:7:\"comment\";s:8:\"\0*\0label\";s:7:\"Comment\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:0:{}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:28:\"comment.comment.comment_body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"188c0a73-e905-428e-baa9-63416be401c9\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TmAKjNrJ7RR60YpqvJq_QqEewYe_S8Kd23n8VRCqiWs\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:20:\"comment.type.comment\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}}',-1,1540294710.645,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:comment:migrate_example_advanced_comment:en',_binary 'a:2:{s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The ID of the entity of which this comment is a reply.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:32:\"migrate_example_advanced_comment\";}}s:12:\"comment_body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:53:\"comment.migrate_example_advanced_comment.comment_body\";s:13:\"\0*\0field_name\";s:12:\"comment_body\";s:13:\"\0*\0field_type\";s:9:\"text_long\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:9:\"\0*\0bundle\";s:32:\"migrate_example_advanced_comment\";s:8:\"\0*\0label\";s:7:\"Comment\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:0:{}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:53:\"comment.migrate_example_advanced_comment.comment_body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"05f4283e-ad3e-49c2-970e-f5ede246bd7d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"5irzyp55d3gwt2chUnKWoOF0EBd3ugEZ4xJQI8pZoo0\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:45:\"comment.type.migrate_example_advanced_comment\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}}',-1,1540294710.715,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:comment:node_comments:en',_binary 'a:2:{s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The ID of the entity of which this comment is a reply.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:13:\"node_comments\";}}s:12:\"comment_body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:34:\"comment.node_comments.comment_body\";s:13:\"\0*\0field_name\";s:12:\"comment_body\";s:13:\"\0*\0field_type\";s:9:\"text_long\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:9:\"\0*\0bundle\";s:13:\"node_comments\";s:8:\"\0*\0label\";s:7:\"Comment\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:0:{}s:11:\"\0*\0required\";b:1;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:34:\"comment.node_comments.comment_body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"3d172ace-741f-4ed1-ae61-060febfffbeb\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dWlqg_QGePh1bX60Pg3FuThe4ZKPAqEBBYStmTcBhgc\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"comment.type.node_comments\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}}',-1,1540294710.732,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:menu_link_content:menu_link_content:en',_binary 'a:0:{}',-1,1540294711.892,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:node:article:en',_binary 'a:4:{s:4:\"body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:17:\"node.article.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:13:\"\0*\0field_type\";s:17:\"text_with_summary\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:7:\"article\";s:8:\"\0*\0label\";s:4:\"Body\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:1:{s:15:\"display_summary\";b:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:17:\"node.article.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"25b7e1bf-d194-4422-9906-63492bc85817\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ay3b2hq42cpQTFB_lNu8S2ZxuVIY6-dlBsc7vLeJ-YY\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}s:7:\"comment\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:20:\"node.article.comment\";s:13:\"\0*\0field_name\";s:7:\"comment\";s:13:\"\0*\0field_type\";s:7:\"comment\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:7:\"article\";s:8:\"\0*\0label\";s:8:\"Comments\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:13:\"form_location\";b:1;s:9:\"anonymous\";i:0;s:7:\"preview\";i:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:17:\"last_comment_name\";N;s:22:\"last_comment_timestamp\";i:0;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:20:\"node.article.comment\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"af3a4c23-8dec-4594-bcd8-3168f75a5ed4\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"r-hrxwbKKXBKQnBefGjXNSdU00u2fPvMWEykGRHqd10\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.storage.node.comment\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}}s:11:\"field_image\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:24:\"node.article.field_image\";s:13:\"\0*\0field_name\";s:11:\"field_image\";s:13:\"\0*\0field_type\";s:5:\"image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:7:\"article\";s:8:\"\0*\0label\";s:5:\"Image\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";b:0;s:18:\"alt_field_required\";b:1;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:24:\"node.article.field_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"f425d91a-c5fe-4194-a937-bf2c28379389\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tgJzhA7Swh4M_gWU5FwFe5lPxPj5rebpMbvhpdNrERs\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"field.storage.node.field_image\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}}s:10:\"field_tags\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:23:\"node.article.field_tags\";s:13:\"\0*\0field_name\";s:10:\"field_tags\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:7:\"article\";s:8:\"\0*\0label\";s:4:\"Tags\";s:14:\"\0*\0description\";s:84:\"Enter a comma-separated list. For example: Amsterdam, Mexico City, \"Cleveland, Ohio\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:1;}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:23:\"node.article.field_tags\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"ca9cbb33-7c78-4fc9-b85a-51fa25db81c4\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QdUgf_beeoaPiyKorFv0q1fcJpWH_uZTqe_xoVJacrw\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:29:\"field.storage.node.field_tags\";i:1;s:17:\"node.type.article\";i:2;s:24:\"taxonomy.vocabulary.tags\";}}}}',-1,1540294710.799,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:node:migrate_example_beer:en',_binary 'a:5:{s:4:\"body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:30:\"node.migrate_example_beer.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:13:\"\0*\0field_type\";s:17:\"text_with_summary\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_beer\";s:8:\"\0*\0label\";s:4:\"Body\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:1:{s:15:\"display_summary\";b:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:30:\"node.migrate_example_beer.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"629b21a2-39a2-44ff-b256-9cccb759ad23\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"0wEsWyeweie_9qpPaMIbZ4_vzPZfrFx1RuOVFpIYhCg\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}s:14:\"field_comments\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:40:\"node.migrate_example_beer.field_comments\";s:13:\"\0*\0field_name\";s:14:\"field_comments\";s:13:\"\0*\0field_type\";s:7:\"comment\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_beer\";s:8:\"\0*\0label\";s:8:\"Comments\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:40:\"node.migrate_example_beer.field_comments\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"383e99f5-f45a-4dff-9687-935f48052827\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oQu63YXAvXvSWvIwwACbcmXsta4CGVhjJ9c61AEvbUg\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:33:\"field.storage.node.field_comments\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}}s:32:\"field_migrate_example_beer_style\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:58:\"node.migrate_example_beer.field_migrate_example_beer_style\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_beer_style\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_beer\";s:8:\"\0*\0label\";s:27:\"Migrate Example Beer Styles\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:58:\"node.migrate_example_beer.field_migrate_example_beer_style\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"3f50dbe5-8e5a-447a-88b9-b9d4597d8ce3\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ux7VJdLoguhU4M-c5krgHOWQ-EUzEFKAWXk_8d68S14\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_beer_style\";i:1;s:30:\"node.type.migrate_example_beer\";i:2;s:47:\"taxonomy.vocabulary.migrate_example_beer_styles\";}}}s:29:\"field_migrate_example_country\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:55:\"node.migrate_example_beer.field_migrate_example_country\";s:13:\"\0*\0field_name\";s:29:\"field_migrate_example_country\";s:13:\"\0*\0field_type\";s:6:\"string\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_beer\";s:8:\"\0*\0label\";s:9:\"Countries\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:0:{}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:55:\"node.migrate_example_beer.field_migrate_example_country\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"197b7775-2b8b-4f16-a866-8fafdcc6502a\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"267WOazRYNp4VIbrd7mXDTFpKn2y10nXzvCOETAlCOA\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:48:\"field.storage.node.field_migrate_example_country\";i:1;s:30:\"node.type.migrate_example_beer\";}}}s:27:\"field_migrate_example_image\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:53:\"node.migrate_example_beer.field_migrate_example_image\";s:13:\"\0*\0field_name\";s:27:\"field_migrate_example_image\";s:13:\"\0*\0field_type\";s:5:\"image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_beer\";s:8:\"\0*\0label\";s:5:\"Image\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:12:{s:14:\"file_directory\";s:0:\"\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:0;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:53:\"node.migrate_example_beer.field_migrate_example_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"15c1e1cd-290a-46b5-a3b5-ff79effd05eb\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rTTSbnynVpKFdSUronbULx6m23C0t_BNxQgSinwvpnM\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:46:\"field.storage.node.field_migrate_example_image\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}}}',-1,1540294710.824,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:node:migrate_example_producer:en',_binary 'a:2:{s:4:\"body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:34:\"node.migrate_example_producer.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:13:\"\0*\0field_type\";s:17:\"text_with_summary\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:24:\"migrate_example_producer\";s:8:\"\0*\0label\";s:4:\"Body\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:1:{s:15:\"display_summary\";b:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:34:\"node.migrate_example_producer.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e98961e2-0cec-4ea5-bd07-287701755573\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"JgX7dNn2ZZjdq1XeVaoasaaWggHCSTw1B5UEy_B-_XU\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:34:\"node.type.migrate_example_producer\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}s:32:\"field_migrate_example_wine_regio\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:62:\"node.migrate_example_producer.field_migrate_example_wine_regio\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_wine_regio\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:24:\"migrate_example_producer\";s:8:\"\0*\0label\";s:28:\"Migrate Example Wine Regions\";s:14:\"\0*\0description\";s:38:\"Select the region this wine comes from\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:62:\"node.migrate_example_producer.field_migrate_example_wine_regio\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"98571a36-53c2-4ad0-8fef-d503496cf7f4\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4jQmcEs7K8dHbvrVrKuz76I2J4UJ2UpUNVt0O7kwnhg\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_regio\";i:1;s:34:\"node.type.migrate_example_producer\";i:2;s:48:\"taxonomy.vocabulary.migrate_example_wine_regions\";}}}}',-1,1540294710.849,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:node:migrate_example_wine:en',_binary 'a:8:{s:4:\"body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:30:\"node.migrate_example_wine.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:13:\"\0*\0field_type\";s:17:\"text_with_summary\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:4:\"Body\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:1:{s:15:\"display_summary\";b:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:30:\"node.migrate_example_wine.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"02b0fbcd-2986-44f7-927d-3e62bdd90c62\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vq3DCSKc6pTaZwP7vJB6S75vq2zwxDXxHAG2a82526U\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}s:31:\"field_migrate_example_adv_image\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:57:\"node.migrate_example_wine.field_migrate_example_adv_image\";s:13:\"\0*\0field_name\";s:31:\"field_migrate_example_adv_image\";s:13:\"\0*\0field_type\";s:5:\"image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:5:\"Image\";s:14:\"\0*\0description\";s:37:\"Upload an image to go with this wine.\";s:11:\"\0*\0settings\";a:12:{s:14:\"file_directory\";s:27:\"field/migrate_example/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:0;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:57:\"node.migrate_example_wine.field_migrate_example_adv_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"fea3b469-b569-4529-9189-47b66ece7ed2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dde5g37whYUHPGt2O6lHpPCd4oKV-jKmJChum1XXHSI\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:50:\"field.storage.node.field_migrate_example_adv_image\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}}s:30:\"field_migrate_example_comments\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:56:\"node.migrate_example_wine.field_migrate_example_comments\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_comments\";s:13:\"\0*\0field_type\";s:7:\"comment\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:8:\"Comments\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:56:\"node.migrate_example_wine.field_migrate_example_comments\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"eece7e20-cd5d-4e4c-b4f7-8aea79d5d9f0\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ljjlc3_-z66T0-LFF2z53sK90atzoirmJ9SPNlhcYzc\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:49:\"field.storage.node.field_migrate_example_comments\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}}s:32:\"field_migrate_example_top_vintag\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:58:\"node.migrate_example_wine.field_migrate_example_top_vintag\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_top_vintag\";s:13:\"\0*\0field_type\";s:7:\"integer\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:20:\"Recommended vintages\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:4:{s:3:\"min\";N;s:3:\"max\";N;s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:58:\"node.migrate_example_wine.field_migrate_example_top_vintag\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"c3fa4924-0661-4d6f-a4cb-3d49e11080e1\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"x1l7jyHt74QqCON-PMg05LruTMlDLgfoOkN8A1YU6gY\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:51:\"field.storage.node.field_migrate_example_top_vintag\";i:1;s:30:\"node.type.migrate_example_wine\";}}}s:31:\"field_migrate_example_wine_best\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:57:\"node.migrate_example_wine.field_migrate_example_wine_best\";s:13:\"\0*\0field_name\";s:31:\"field_migrate_example_wine_best\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:30:\"Migrate Example Wine Best With\";s:14:\"\0*\0description\";s:65:\"Enter any foods this wine may be paired with, separated by commas\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:57:\"node.migrate_example_wine.field_migrate_example_wine_best\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b7f2771d-df62-4c67-b7c1-2179ae6e3cb7\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XhPNldNk37gxWD2j9pgrLapzt781hNew8V8YLBsZme4\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:50:\"field.storage.node.field_migrate_example_wine_best\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:50:\"taxonomy.vocabulary.migrate_example_wine_best_with\";}}}s:32:\"field_migrate_example_wine_ratin\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_ratin\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_wine_ratin\";s:13:\"\0*\0field_type\";s:7:\"decimal\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:6:\"Rating\";s:14:\"\0*\0description\";s:23:\"Rating on a 1-100 scale\";s:11:\"\0*\0settings\";a:4:{s:3:\"min\";d:1;s:3:\"max\";d:100;s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_ratin\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"1ee670bc-250c-42be-aa39-8ed00eba65d5\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"f_RIakTCpup3t5_tfuPwr3Il2wvYTXciVBN_LRcg14U\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_ratin\";i:1;s:30:\"node.type.migrate_example_wine\";}}}s:32:\"field_migrate_example_wine_regio\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_regio\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_wine_regio\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:28:\"Migrate Example Wine Regions\";s:14:\"\0*\0description\";s:38:\"Select the region this wine comes from\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_regio\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"7b85b545-1e00-4ff2-bf16-546d82c42d96\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SY0L1xid1zVRqtdbHoMATu_eJDGsXBoULcxzmqWuFXY\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_regio\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:48:\"taxonomy.vocabulary.migrate_example_wine_regions\";}}}s:30:\"field_migrate_example_wine_var\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:56:\"node.migrate_example_wine.field_migrate_example_wine_var\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_wine_var\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:20:\"migrate_example_wine\";s:8:\"\0*\0label\";s:30:\"Migrate Example Wine Varieties\";s:14:\"\0*\0description\";s:31:\"Select the variety of this wine\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:56:\"node.migrate_example_wine.field_migrate_example_wine_var\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"a73f752d-1642-45ea-a85c-8ab426c8ddad\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wUq7WvEbY6a-6yW8OZULmZfSj7OwD1qMpKiS3upiOtI\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:49:\"field.storage.node.field_migrate_example_wine_var\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}}}}',-1,1540294710.875,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:node:page:en',_binary 'a:2:{s:7:\"promote\";O:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\":30:{s:5:\"\0*\0id\";s:17:\"node.page.promote\";s:13:\"\0*\0field_name\";s:7:\"promote\";s:13:\"\0*\0field_type\";s:7:\"boolean\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:4:\"page\";s:8:\"\0*\0label\";s:22:\"Promoted to front page\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:17:\"node.page.promote\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"bc5657f1-35bc-4b89-a06e-1d160e0b66f7\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fPUEnm4T5zfZRr3ttDUqq7yCDd2uW3clWD-pvos4tlQ\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:19:\"base_field_override\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:14:\"node.type.page\";}}}s:4:\"body\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:14:\"node.page.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:13:\"\0*\0field_type\";s:17:\"text_with_summary\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:9:\"\0*\0bundle\";s:4:\"page\";s:8:\"\0*\0label\";s:4:\"Body\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:1:{s:15:\"display_summary\";b:1;}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:14:\"node.page.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b8cf44dd-b10b-40db-9324-26854c19e8de\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rUop-8b6hvxxDYbv-KobTfNIBNbPY9qOPl8f6kBNSpw\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}}}',-1,1540294710.891,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:taxonomy_term:migrate_example_beer_styles:en',_binary 'a:1:{s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:27:\"migrate_example_beer_styles\";}}}',-1,1540294710.919,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:taxonomy_term:migrate_example_wine_best_with:en',_binary 'a:1:{s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:30:\"migrate_example_wine_best_with\";}}}',-1,1540294710.935,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:taxonomy_term:migrate_example_wine_regions:en',_binary 'a:1:{s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:28:\"migrate_example_wine_regions\";}}}',-1,1540294710.952,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:taxonomy_term:migrate_example_wine_varieties:en',_binary 'a:2:{s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:30:\"migrate_example_wine_varieties\";}}s:24:\"field_variety_attributes\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:69:\"taxonomy_term.migrate_example_wine_varieties.field_variety_attributes\";s:13:\"\0*\0field_name\";s:24:\"field_variety_attributes\";s:13:\"\0*\0field_type\";s:6:\"string\";s:14:\"\0*\0entity_type\";s:13:\"taxonomy_term\";s:9:\"\0*\0bundle\";s:30:\"migrate_example_wine_varieties\";s:8:\"\0*\0label\";s:10:\"Attributes\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:0:{}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:69:\"taxonomy_term.migrate_example_wine_varieties.field_variety_attributes\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"038fa040-ae08-4314-b74b-60f3e45a5f47\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6rU_9CZGIOdWqzPHF8GH37JaWcUoQYymrdTuTlUD8r0\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:52:\"field.storage.taxonomy_term.field_variety_attributes\";i:1;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}}}}',-1,1540294710.970,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:taxonomy_term:tags:en',_binary 'a:1:{s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:1:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:4:\"tags\";}}}',-1,1540294710.986,1,'entity_field_info entity_types','885'),('entity_bundle_field_definitions:user:user:en',_binary 'a:3:{s:30:\"field_migrate_example_favbeers\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:40:\"user.user.field_migrate_example_favbeers\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_favbeers\";s:13:\"\0*\0field_type\";s:16:\"entity_reference\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:9:\"\0*\0bundle\";s:4:\"user\";s:8:\"\0*\0label\";s:14:\"Favorite Beers\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:2:{s:7:\"handler\";s:12:\"default:node\";s:16:\"handler_settings\";a:2:{s:14:\"target_bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}s:4:\"sort\";a:2:{s:5:\"field\";s:5:\"title\";s:9:\"direction\";s:3:\"ASC\";}}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:40:\"user.user.field_migrate_example_favbeers\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"c06b3c71-8b56-4b1a-b937-f7022336734e\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"pIDsWln9Pgayq3gsbJPTHTNoEWaq1fFTerjS_EKtFtg\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:49:\"field.storage.user.field_migrate_example_favbeers\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}}s:28:\"field_migrate_example_gender\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:38:\"user.user.field_migrate_example_gender\";s:13:\"\0*\0field_name\";s:28:\"field_migrate_example_gender\";s:13:\"\0*\0field_type\";s:6:\"string\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:9:\"\0*\0bundle\";s:4:\"user\";s:8:\"\0*\0label\";s:6:\"Gender\";s:14:\"\0*\0description\";s:0:\"\";s:11:\"\0*\0settings\";a:0:{}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:0;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:38:\"user.user.field_migrate_example_gender\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"b3f24804-97d4-4400-9102-e06b37d5f75f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-13X2hbfPYQnoVLm2sC5J6tVgYycYRTicNxDqunahwU\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:47:\"field.storage.user.field_migrate_example_gender\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}}s:12:\"user_picture\";O:31:\"Drupal\\field\\Entity\\FieldConfig\":31:{s:10:\"\0*\0deleted\";b:0;s:5:\"\0*\0id\";s:22:\"user.user.user_picture\";s:13:\"\0*\0field_name\";s:12:\"user_picture\";s:13:\"\0*\0field_type\";s:5:\"image\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:9:\"\0*\0bundle\";s:4:\"user\";s:8:\"\0*\0label\";s:7:\"Picture\";s:14:\"\0*\0description\";s:29:\"Your virtual face or picture.\";s:11:\"\0*\0settings\";a:12:{s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:14:\"file_directory\";s:40:\"pictures/[date:custom:Y]-[date:custom:m]\";s:12:\"max_filesize\";s:0:\"\";s:9:\"alt_field\";b:0;s:11:\"title_field\";b:0;s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:18:\"alt_field_required\";b:0;s:20:\"title_field_required\";b:0;s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:11:\"\0*\0required\";b:0;s:15:\"\0*\0translatable\";b:1;s:16:\"\0*\0default_value\";a:0:{}s:25:\"\0*\0default_value_callback\";s:0:\"\";s:14:\"\0*\0constraints\";a:0:{}s:22:\"\0*\0propertyConstraints\";a:0:{}s:13:\"\0*\0originalId\";s:22:\"user.user.user_picture\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"15a8ada2-7804-4a52-b07f-ddb0442179ea\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Iiq0AttdhgbebJwabSFwQQ1ORn64GoGz0xSZ_eyCJ8A\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:12:\"field_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:31:\"field.storage.user.user_picture\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}}}',-1,1540294711.020,1,'entity_field_info entity_types','885'),('entity_bundle_info:en',_binary 'a:40:{s:5:\"block\";a:1:{s:5:\"block\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:18:\"block_content_type\";a:1:{s:18:\"block_content_type\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:13:\"block_content\";a:1:{s:5:\"basic\";a:1:{s:5:\"label\";s:11:\"Basic block\";}}s:12:\"comment_type\";a:1:{s:12:\"comment_type\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:7:\"comment\";a:3:{s:7:\"comment\";a:1:{s:5:\"label\";s:16:\"Default comments\";}s:32:\"migrate_example_advanced_comment\";a:1:{s:5:\"label\";s:13:\"Node comments\";}s:13:\"node_comments\";a:1:{s:5:\"label\";s:13:\"Node comments\";}}s:15:\"contact_message\";a:2:{s:8:\"feedback\";a:1:{s:5:\"label\";s:16:\"Website feedback\";}s:8:\"personal\";a:1:{s:5:\"label\";s:21:\"Personal contact form\";}}s:12:\"contact_form\";a:1:{s:12:\"contact_form\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:24:\"content_moderation_state\";a:1:{s:24:\"content_moderation_state\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:0;}}s:31:\"content_moderation_notification\";a:1:{s:31:\"content_moderation_notification\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Notification\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:6:\"editor\";a:1:{s:6:\"editor\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:20:\"field_storage_config\";a:1:{s:20:\"field_storage_config\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:12:\"field_config\";a:1:{s:12:\"field_config\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"file\";a:1:{s:4:\"file\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:13:\"filter_format\";a:1:{s:13:\"filter_format\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"image_style\";a:1:{s:11:\"image_style\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:9:\"migration\";a:1:{s:9:\"migration\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Migration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:15:\"migration_group\";a:1:{s:15:\"migration_group\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Migration Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"node\";a:5:{s:7:\"article\";a:1:{s:5:\"label\";s:7:\"Article\";}s:20:\"migrate_example_beer\";a:1:{s:5:\"label\";s:4:\"Beer\";}s:24:\"migrate_example_producer\";a:1:{s:5:\"label\";s:13:\"Wine Producer\";}s:20:\"migrate_example_wine\";a:1:{s:5:\"label\";s:4:\"Wine\";}s:4:\"page\";a:1:{s:5:\"label\";s:10:\"Basic page\";}}s:9:\"node_type\";a:1:{s:9:\"node_type\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"rdf_mapping\";a:1:{s:11:\"rdf_mapping\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"RDF mapping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:20:\"rest_resource_config\";a:1:{s:20:\"rest_resource_config\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:11:\"search_page\";a:1:{s:11:\"search_page\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:12:\"shortcut_set\";a:1:{s:12:\"shortcut_set\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:8:\"shortcut\";a:1:{s:7:\"default\";a:1:{s:5:\"label\";s:7:\"Default\";}}s:6:\"action\";a:1:{s:6:\"action\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"menu\";a:1:{s:4:\"menu\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:13:\"taxonomy_term\";a:5:{s:27:\"migrate_example_beer_styles\";a:1:{s:5:\"label\";s:27:\"Migrate Example Beer Styles\";}s:30:\"migrate_example_wine_best_with\";a:1:{s:5:\"label\";s:30:\"Migrate Example Wine Best With\";}s:28:\"migrate_example_wine_regions\";a:1:{s:5:\"label\";s:28:\"Migrate Example Wine Regions\";}s:30:\"migrate_example_wine_varieties\";a:1:{s:5:\"label\";s:30:\"Migrate Example Wine Varieties\";}s:4:\"tags\";a:1:{s:5:\"label\";s:4:\"Tags\";}}s:19:\"taxonomy_vocabulary\";a:1:{s:19:\"taxonomy_vocabulary\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Taxonomy vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"tour\";a:1:{s:4:\"tour\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"user\";a:1:{s:4:\"user\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:9:\"user_role\";a:1:{s:9:\"user_role\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:8:\"workflow\";a:1:{s:8:\"workflow\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:17:\"menu_link_content\";a:1:{s:17:\"menu_link_content\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:4:\"view\";a:1:{s:4:\"view\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}}}s:11:\"date_format\";a:1:{s:11:\"date_format\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"entity_form_mode\";a:1:{s:16:\"entity_form_mode\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:19:\"entity_form_display\";a:1:{s:19:\"entity_form_display\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:16:\"entity_view_mode\";a:1:{s:16:\"entity_view_mode\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:19:\"entity_view_display\";a:1:{s:19:\"entity_view_display\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}s:19:\"base_field_override\";a:1:{s:19:\"base_field_override\";a:1:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}',-1,1540294710.060,1,'entity_bundles entity_types','843'),('entity_field_map',_binary 'a:10:{s:13:\"block_content\";a:17:{s:2:\"id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:11:\"revision_id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:4:\"type\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:16:\"revision_created\";a:2:{s:4:\"type\";s:7:\"created\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:13:\"revision_user\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:12:\"revision_log\";a:2:{s:4:\"type\";s:11:\"string_long\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:6:\"status\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:4:\"info\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:7:\"changed\";a:2:{s:4:\"type\";s:7:\"changed\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:8:\"reusable\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:16:\"revision_default\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:29:\"revision_translation_affected\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:16:\"moderation_state\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}s:4:\"body\";a:2:{s:4:\"type\";s:17:\"text_with_summary\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}}s:7:\"comment\";a:20:{s:3:\"cid\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:12:\"comment_type\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:6:\"status\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:3:\"pid\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:9:\"entity_id\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:7:\"subject\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:3:\"uid\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:4:\"name\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:4:\"mail\";a:2:{s:4:\"type\";s:5:\"email\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:8:\"homepage\";a:2:{s:4:\"type\";s:3:\"uri\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:8:\"hostname\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:7:\"created\";a:2:{s:4:\"type\";s:7:\"created\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:7:\"changed\";a:2:{s:4:\"type\";s:7:\"changed\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:6:\"thread\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:11:\"entity_type\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:10:\"field_name\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";s:13:\"node_comments\";s:13:\"node_comments\";}}s:12:\"comment_body\";a:2:{s:4:\"type\";s:9:\"text_long\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:13:\"node_comments\";s:13:\"node_comments\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";}}}s:15:\"contact_message\";a:9:{s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:12:\"contact_form\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:4:\"name\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:4:\"mail\";a:2:{s:4:\"type\";s:5:\"email\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:7:\"subject\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:7:\"message\";a:2:{s:4:\"type\";s:11:\"string_long\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:4:\"copy\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}s:9:\"recipient\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:2:{s:8:\"feedback\";s:8:\"feedback\";s:8:\"personal\";s:8:\"personal\";}}}s:24:\"content_moderation_state\";a:13:{s:2:\"id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:11:\"revision_id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:3:\"uid\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:8:\"workflow\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:16:\"moderation_state\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:22:\"content_entity_type_id\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:17:\"content_entity_id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:26:\"content_entity_revision_id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:16:\"revision_default\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}s:29:\"revision_translation_affected\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:24:\"content_moderation_state\";s:24:\"content_moderation_state\";}}}s:4:\"file\";a:11:{s:3:\"fid\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:3:\"uid\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:8:\"filename\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:3:\"uri\";a:2:{s:4:\"type\";s:8:\"file_uri\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:8:\"filemime\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:8:\"filesize\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:6:\"status\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:7:\"created\";a:2:{s:4:\"type\";s:7:\"created\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}s:7:\"changed\";a:2:{s:4:\"type\";s:7:\"changed\";s:7:\"bundles\";a:1:{s:4:\"file\";s:4:\"file\";}}}s:4:\"node\";a:35:{s:3:\"nid\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:3:\"vid\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:4:\"type\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:18:\"revision_timestamp\";a:2:{s:4:\"type\";s:7:\"created\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:12:\"revision_uid\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:12:\"revision_log\";a:2:{s:4:\"type\";s:11:\"string_long\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:6:\"status\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:5:\"title\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:3:\"uid\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:7:\"created\";a:2:{s:4:\"type\";s:7:\"created\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:7:\"changed\";a:2:{s:4:\"type\";s:7:\"changed\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:7:\"promote\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:6:\"sticky\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:16:\"revision_default\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:29:\"revision_translation_affected\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:16:\"moderation_state\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:4:\"path\";a:2:{s:4:\"type\";s:4:\"path\";s:7:\"bundles\";a:5:{s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:4:\"page\";s:4:\"page\";}}s:11:\"field_image\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:7:\"article\";s:7:\"article\";}}s:7:\"comment\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:7:\"article\";s:7:\"article\";}}s:10:\"field_tags\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:7:\"article\";s:7:\"article\";}}s:4:\"body\";a:2:{s:4:\"type\";s:17:\"text_with_summary\";s:7:\"bundles\";a:5:{s:4:\"page\";s:4:\"page\";s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";}}s:27:\"field_migrate_example_image\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:29:\"field_migrate_example_country\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:14:\"field_comments\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:32:\"field_migrate_example_beer_style\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:32:\"field_migrate_example_wine_ratin\";a:2:{s:4:\"type\";s:7:\"decimal\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:32:\"field_migrate_example_top_vintag\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:30:\"field_migrate_example_comments\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:31:\"field_migrate_example_adv_image\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:31:\"field_migrate_example_wine_best\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:32:\"field_migrate_example_wine_regio\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:2:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";}}s:30:\"field_migrate_example_wine_var\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}}s:8:\"shortcut\";a:8:{s:2:\"id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:5:\"title\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:6:\"weight\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:4:\"link\";a:2:{s:4:\"type\";s:4:\"link\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:7:\"default\";s:7:\"default\";}}}s:13:\"taxonomy_term\";a:13:{s:3:\"tid\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:3:\"vid\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:6:\"status\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:4:\"name\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:11:\"description\";a:2:{s:4:\"type\";s:9:\"text_long\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:6:\"weight\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:6:\"parent\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:7:\"changed\";a:2:{s:4:\"type\";s:7:\"changed\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:4:\"path\";a:2:{s:4:\"type\";s:4:\"path\";s:7:\"bundles\";a:5:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";s:4:\"tags\";s:4:\"tags\";}}s:24:\"field_variety_attributes\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";}}}s:4:\"user\";a:20:{s:3:\"uid\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:18:\"preferred_langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:24:\"preferred_admin_langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:4:\"name\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:4:\"pass\";a:2:{s:4:\"type\";s:8:\"password\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:4:\"mail\";a:2:{s:4:\"type\";s:5:\"email\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:8:\"timezone\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:6:\"status\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:7:\"created\";a:2:{s:4:\"type\";s:7:\"created\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:7:\"changed\";a:2:{s:4:\"type\";s:7:\"changed\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:6:\"access\";a:2:{s:4:\"type\";s:9:\"timestamp\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:5:\"login\";a:2:{s:4:\"type\";s:9:\"timestamp\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:4:\"init\";a:2:{s:4:\"type\";s:5:\"email\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:5:\"roles\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:12:\"user_picture\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:28:\"field_migrate_example_gender\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:30:\"field_migrate_example_favbeers\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}}s:17:\"menu_link_content\";a:16:{s:2:\"id\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:4:\"uuid\";a:2:{s:4:\"type\";s:4:\"uuid\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:8:\"langcode\";a:2:{s:4:\"type\";s:8:\"language\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:6:\"bundle\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:7:\"enabled\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:5:\"title\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:11:\"description\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:9:\"menu_name\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:4:\"link\";a:2:{s:4:\"type\";s:4:\"link\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:8:\"external\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:10:\"rediscover\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:6:\"weight\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:8:\"expanded\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:6:\"parent\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:7:\"changed\";a:2:{s:4:\"type\";s:7:\"changed\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}s:16:\"default_langcode\";a:2:{s:4:\"type\";s:7:\"boolean\";s:7:\"bundles\";a:1:{s:17:\"menu_link_content\";s:17:\"menu_link_content\";}}}}',-1,1540294710.391,1,'entity_types','422'),('entity_field_storage_definitions:block_content:en',_binary 'a:1:{s:4:\"body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:18:\"block_content.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:14:\"\0*\0entity_type\";s:13:\"block_content\";s:7:\"\0*\0type\";s:17:\"text_with_summary\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:18:\"block_content.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"d224118f-844d-4d9b-8fc5-afa0888f4af1\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eS0snV_L3dx9shtWRTzm5eblwOJ7qKWC9IE-4GMTDFc\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"text\";}}}}',-1,1540294710.165,1,'entity_field_info entity_types','885'),('entity_field_storage_definitions:comment:en',_binary 'a:1:{s:12:\"comment_body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:20:\"comment.comment_body\";s:13:\"\0*\0field_name\";s:12:\"comment_body\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:20:\"comment.comment_body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"ca2a0686-6c75-4895-bb9e-670fa7ef511f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"swYoCch_hY8QO5uwr4FURplfnUCUlpPB4idF8WGVCpw\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"text\";}}}}',-1,1540294710.232,1,'entity_field_info entity_types','885'),('entity_field_storage_definitions:content_moderation_state:en',_binary 'a:0:{}',-1,1540294710.400,1,'entity_field_info entity_types','885'),('entity_field_storage_definitions:file:en',_binary 'a:0:{}',-1,1540294710.410,1,'entity_field_info entity_types','885'),('entity_field_storage_definitions:menu_link_content:en',_binary 'a:0:{}',-1,1540294711.884,1,'entity_field_info entity_types','885'),('entity_field_storage_definitions:node:en',_binary 'a:15:{s:4:\"body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:9:\"node.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:17:\"text_with_summary\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:9:\"node.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"4bd18d5b-1b54-4d93-8809-1f2a2cfbcc80\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EBUo7qOWqaiZaQ_RC9sLY5IoDKphS34v77VIHSACmVY\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}}s:7:\"comment\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:12:\"node.comment\";s:13:\"\0*\0field_name\";s:7:\"comment\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:12:\"node.comment\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"ccf999c7-4756-4fb3-b254-edec33730b53\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ktCna9xmWvYZIUfOCUyDQvedn5RtnS4CRmEIwNmvYjc\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}}s:14:\"field_comments\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:19:\"node.field_comments\";s:13:\"\0*\0field_name\";s:14:\"field_comments\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:13:\"node_comments\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:19:\"node.field_comments\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"cb6e812d-2115-4faf-98d1-e6a4706413c9\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-Fbi4WKTGUpcyPzZFp_Ioroz-Xni60AHP3Rt0VaNYzs\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}}s:11:\"field_image\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:16:\"node.field_image\";s:13:\"\0*\0field_name\";s:11:\"field_image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:16:\"node.field_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"eb5224c0-e6c7-49cf-82b6-229f46ef800b\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SkXIPKZYiIMMtnBmfnxk58RYfbZ8cHSw5NZPY_JByME\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}}s:31:\"field_migrate_example_adv_image\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:36:\"node.field_migrate_example_adv_image\";s:13:\"\0*\0field_name\";s:31:\"field_migrate_example_adv_image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:36:\"node.field_migrate_example_adv_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"64472a0e-1641-463b-8103-ec2ed8f6c5e3\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RwVJ29uGaznr4EjFpnLkdADJBx7DLYwfcu7ti4bVe-c\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}}s:32:\"field_migrate_example_beer_style\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_beer_style\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_beer_style\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_beer_style\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"11b2a4ff-4513-4663-938d-060cda2689e1\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OydFp62jbcZgS1dcDCNzxvhJjx-UDf-ng1or4wTY7-w\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:30:\"field_migrate_example_comments\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:35:\"node.field_migrate_example_comments\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_comments\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:32:\"migrate_example_advanced_comment\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:35:\"node.field_migrate_example_comments\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"5ec526fb-c67f-4c40-80df-1e2b92438662\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GcdoHWF-KMjeae1Roq8JEh7Xr3Onq8_oZAP3B1sRuhA\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}}s:29:\"field_migrate_example_country\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:34:\"node.field_migrate_example_country\";s:13:\"\0*\0field_name\";s:29:\"field_migrate_example_country\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:34:\"node.field_migrate_example_country\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"174d947b-0f2d-4bbc-97a0-ed966f6519d4\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uBaHGWI3rO-tpQurs304h90LTJoBpjWI2JHNhbMY1TM\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}}s:27:\"field_migrate_example_image\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:32:\"node.field_migrate_example_image\";s:13:\"\0*\0field_name\";s:27:\"field_migrate_example_image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:32:\"node.field_migrate_example_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"d57d2d8a-c9f4-4b45-9c8e-f544aa2f818e\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"3SSh1H4dQsPZoZV-d3sjeQK7GPJfi-mo6sgECfiOtn8\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}}s:32:\"field_migrate_example_top_vintag\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_top_vintag\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_top_vintag\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:2:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_top_vintag\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"2245f192-9a68-4931-b960-80ddce78214d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sE33za4WgJVU7T_nG_PZp5CVmEBALuzB_Vn-tfw-q8s\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}}s:31:\"field_migrate_example_wine_best\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:36:\"node.field_migrate_example_wine_best\";s:13:\"\0*\0field_name\";s:31:\"field_migrate_example_wine_best\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:36:\"node.field_migrate_example_wine_best\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"34bb10e9-a28d-459d-9cfe-ce04b8a54387\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9YbUjnyyl-8owZ1KCETbExQGZu4aog3n7l3PHy0dSds\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:32:\"field_migrate_example_wine_ratin\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_wine_ratin\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_wine_ratin\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"decimal\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:2:{s:9:\"precision\";i:10;s:5:\"scale\";i:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_wine_ratin\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"9db1bcab-f817-4886-a5b5-34d700f8848f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_kyPHNTTC5ibCxEq_nKImDTCSdOLFBhkXjobmMN4zJ4\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}}s:32:\"field_migrate_example_wine_regio\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_wine_regio\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_wine_regio\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_wine_regio\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"89bb858a-3fa0-40a3-b7e5-29a286ecbe05\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AJoyPVhHsJ7K3A9G3Ztn6dKHZBZ5ao3c7SdEK2rH3dM\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:30:\"field_migrate_example_wine_var\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:35:\"node.field_migrate_example_wine_var\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_wine_var\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:35:\"node.field_migrate_example_wine_var\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e627ec31-c833-465f-ba31-28b765ab8f37\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TcM1vLCiI-U8EN4bH2-tWOgR-HU8fDhHf3oMVGzrA-8\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:10:\"field_tags\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:15:\"node.field_tags\";s:13:\"\0*\0field_name\";s:10:\"field_tags\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:15:\"node.field_tags\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"73418115-95a0-4170-9dd7-284673acd7d2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WpOE_bs8Bs_HY2ns7n2r__de-xno0-Bxkqep5-MsHAs\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}}',-1,1540294710.436,1,'entity_field_info entity_types','885'),('entity_field_storage_definitions:taxonomy_term:en',_binary 'a:1:{s:24:\"field_variety_attributes\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:38:\"taxonomy_term.field_variety_attributes\";s:13:\"\0*\0field_name\";s:24:\"field_variety_attributes\";s:14:\"\0*\0entity_type\";s:13:\"taxonomy_term\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:38:\"taxonomy_term.field_variety_attributes\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"50da2584-5c3b-41ad-87cb-032fa5039401\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sfP27J9-TcVbjBJviBOAkXgwSpQe1DoGxCc5Ysz_8rc\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}}}',-1,1540294710.458,1,'entity_field_info entity_types','885'),('entity_field_storage_definitions:user:en',_binary 'a:3:{s:30:\"field_migrate_example_favbeers\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:35:\"user.field_migrate_example_favbeers\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_favbeers\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:4:\"node\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:35:\"user.field_migrate_example_favbeers\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"4d9219b4-339a-4759-aaf2-9dcd7a27fb11\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tKsR0YH5ckB1vHHdiiA7gYHhFVOvdwIS6N3-NvAxwqM\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}}s:28:\"field_migrate_example_gender\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:33:\"user.field_migrate_example_gender\";s:13:\"\0*\0field_name\";s:28:\"field_migrate_example_gender\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:33:\"user.field_migrate_example_gender\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"3a033163-ac33-47ae-9186-2aecf22e5a8a\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-qbjvRZ4YV6YRW3_WOy0fiV1K4bHVBlJNA4AC2E9Z8I\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}}s:12:\"user_picture\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:17:\"user.user_picture\";s:13:\"\0*\0field_name\";s:12:\"user_picture\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:17:\"user.user_picture\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"7fa5154f-d1e9-4c85-a43d-2cedc39808c0\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6k-VBFilDLuzgSOT-77CFgHFlcd5D-kqRixtH89EShU\";}s:14:\"\0*\0trustedData\";b:0;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"user\";}}}}',-1,1540294710.504,1,'entity_field_info entity_types','885'),('entity_type',_binary 'a:40:{s:5:\"block\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:5:\"theme\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:2:\"id\";i:1;s:5:\"theme\";i:2;s:6:\"region\";i:3;s:6:\"weight\";i:4;s:8:\"provider\";i:5;s:6:\"plugin\";i:6;s:8:\"settings\";i:7;s:10:\"visibility\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:5:\"block\";s:16:\"\0*\0originalClass\";s:25:\"Drupal\\block\\Entity\\Block\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:38:\"Drupal\\block\\BlockAccessControlHandler\";s:12:\"view_builder\";s:29:\"Drupal\\block\\BlockViewBuilder\";s:12:\"list_builder\";s:29:\"Drupal\\block\\BlockListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:22:\"Drupal\\block\\BlockForm\";s:6:\"delete\";s:33:\"Drupal\\block\\Form\\BlockDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:11:\"delete-form\";s:44:\"/admin/structure/block/manage/{block}/delete\";s:9:\"edit-form\";s:37:\"/admin/structure/block/manage/{block}\";s:6:\"enable\";s:44:\"/admin/structure/block/manage/{block}/enable\";s:7:\"disable\";s:45:\"/admin/structure/block/manage/{block}/disable\";s:10:\"devel-load\";s:20:\"/devel/block/{block}\";s:16:\"devel-definition\";s:31:\"/devel/block/{block}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Blocks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"blocks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:12:\"@count block\";s:6:\"plural\";s:13:\"@count blocks\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:17:\"config:block_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:25:\"Drupal\\block\\Entity\\Block\";s:11:\"\0*\0provider\";s:5:\"block\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:18:\"block_content_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:8:\"revision\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:18:\"block_content_type\";s:16:\"\0*\0originalClass\";s:44:\"Drupal\\block_content\\Entity\\BlockContentType\";s:11:\"\0*\0handlers\";a:5:{s:4:\"form\";a:4:{s:7:\"default\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:3:\"add\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:4:\"edit\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:6:\"delete\";s:52:\"Drupal\\block_content\\Form\\BlockContentTypeDeleteForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:49:\"Drupal\\Core\\Entity\\Routing\\AdminHtmlRouteProvider\";}s:12:\"list_builder\";s:48:\"Drupal\\block_content\\BlockContentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:11:\"delete-form\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/delete\";s:9:\"edit-form\";s:64:\"/admin/structure/block/block-content/manage/{block_content_type}\";s:10:\"collection\";s:42:\"/admin/structure/block/block-content/types\";s:10:\"devel-load\";s:46:\"/devel/block_content_type/{block_content_type}\";s:16:\"devel-definition\";s:57:\"/devel/block_content_type/{block_content_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"block_content\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Custom block library\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"custom block types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:24:\"@count custom block type\";s:6:\"plural\";s:25:\"@count custom block types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:30:\"config:block_content_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:44:\"Drupal\\block_content\\Entity\\BlockContentType\";s:11:\"\0*\0provider\";s:13:\"block_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:13:\"block_content\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:13:\"revision_user\";s:13:\"revision_user\";s:16:\"revision_created\";s:16:\"revision_created\";s:20:\"revision_log_message\";s:12:\"revision_log\";s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:0;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:11:\"revision_id\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:4:\"info\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:9:\"published\";s:6:\"status\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:13:\"block_content\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\block_content\\Entity\\BlockContent\";s:11:\"\0*\0handlers\";a:9:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:6:\"access\";s:53:\"Drupal\\block_content\\BlockContentAccessControlHandler\";s:12:\"list_builder\";s:44:\"Drupal\\block_content\\BlockContentListBuilder\";s:12:\"view_builder\";s:44:\"Drupal\\block_content\\BlockContentViewBuilder\";s:10:\"views_data\";s:42:\"Drupal\\block_content\\BlockContentViewsData\";s:4:\"form\";a:4:{s:3:\"add\";s:37:\"Drupal\\block_content\\BlockContentForm\";s:4:\"edit\";s:37:\"Drupal\\block_content\\BlockContentForm\";s:6:\"delete\";s:48:\"Drupal\\block_content\\Form\\BlockContentDeleteForm\";s:7:\"default\";s:37:\"Drupal\\block_content\\BlockContentForm\";}s:11:\"translation\";s:51:\"Drupal\\block_content\\BlockContentTranslationHandler\";s:10:\"moderation\";s:70:\"Drupal\\content_moderation\\Entity\\Handler\\BlockContentModerationHandler\";s:14:\"route_provider\";a:1:{s:10:\"moderation\";s:70:\"Drupal\\content_moderation\\Entity\\Routing\\EntityModerationRouteProvider\";}}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:9:{s:9:\"canonical\";s:22:\"/block/{block_content}\";s:11:\"delete-form\";s:29:\"/block/{block_content}/delete\";s:9:\"edit-form\";s:22:\"/block/{block_content}\";s:10:\"collection\";s:36:\"/admin/structure/block/block-content\";s:6:\"create\";s:6:\"/block\";s:14:\"latest-version\";s:29:\"/block/{block_content}/latest\";s:10:\"devel-load\";s:36:\"/devel/block_content/{block_content}\";s:12:\"devel-render\";s:43:\"/devel/block_content/{block_content}/render\";s:16:\"devel-definition\";s:47:\"/devel/block_content/{block_content}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:18:\"block_content_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:13:\"block_content\";s:22:\"\0*\0revision_data_table\";s:28:\"block_content_field_revision\";s:17:\"\0*\0revision_table\";s:22:\"block_content_revision\";s:13:\"\0*\0data_table\";s:24:\"block_content_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:1;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Custom blocks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"custom blocks\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count custom block\";s:6:\"plural\";s:20:\"@count custom blocks\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:35:\"entity.block_content_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"block_content_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:40:\"Drupal\\block_content\\Entity\\BlockContent\";s:11:\"\0*\0provider\";s:13:\"block_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:12:\"comment_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:21:\"target_entity_type_id\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"comment_type\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\comment\\Entity\\CommentType\";s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:7:\"default\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:3:\"add\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:4:\"edit\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:6:\"delete\";s:41:\"Drupal\\comment\\Form\\CommentTypeDeleteForm\";}s:12:\"list_builder\";s:37:\"Drupal\\comment\\CommentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer comment types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:11:\"delete-form\";s:53:\"/admin/structure/comment/manage/{comment_type}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/comment/manage/{comment_type}\";s:8:\"add-form\";s:34:\"/admin/structure/comment/types/add\";s:10:\"collection\";s:24:\"/admin/structure/comment\";s:10:\"devel-load\";s:34:\"/devel/comment_type/{comment_type}\";s:16:\"devel-definition\";s:45:\"/devel/comment_type/{comment_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:7:\"comment\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"comment types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count comment type\";s:6:\"plural\";s:20:\"@count comment types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:comment_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\comment\\Entity\\CommentType\";s:11:\"\0*\0provider\";s:7:\"comment\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:7:\"comment\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"cid\";s:6:\"bundle\";s:12:\"comment_type\";s:5:\"label\";s:7:\"subject\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:9:\"published\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:7:\"comment\";s:16:\"\0*\0originalClass\";s:29:\"Drupal\\comment\\Entity\\Comment\";s:11:\"\0*\0handlers\";a:8:{s:7:\"storage\";s:29:\"Drupal\\comment\\CommentStorage\";s:14:\"storage_schema\";s:35:\"Drupal\\comment\\CommentStorageSchema\";s:6:\"access\";s:42:\"Drupal\\comment\\CommentAccessControlHandler\";s:12:\"list_builder\";s:36:\"Drupal\\Core\\Entity\\EntityListBuilder\";s:12:\"view_builder\";s:33:\"Drupal\\comment\\CommentViewBuilder\";s:10:\"views_data\";s:31:\"Drupal\\comment\\CommentViewsData\";s:4:\"form\";a:2:{s:7:\"default\";s:26:\"Drupal\\comment\\CommentForm\";s:6:\"delete\";s:30:\"Drupal\\comment\\Form\\DeleteForm\";}s:11:\"translation\";s:40:\"Drupal\\comment\\CommentTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:9:\"canonical\";s:18:\"/comment/{comment}\";s:11:\"delete-form\";s:25:\"/comment/{comment}/delete\";s:20:\"delete-multiple-form\";s:29:\"/admin/content/comment/delete\";s:9:\"edit-form\";s:23:\"/comment/{comment}/edit\";s:6:\"create\";s:8:\"/comment\";s:10:\"devel-load\";s:24:\"/devel/comment/{comment}\";s:12:\"devel-render\";s:31:\"/devel/comment/{comment}/render\";s:16:\"devel-definition\";s:35:\"/devel/comment/{comment}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"comment_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:7:\"comment\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:18:\"comment_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:14:\"@count comment\";s:6:\"plural\";s:15:\"@count comments\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";s:11:\"comment_uri\";s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:29:\"entity.comment_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:12:\"comment_list\";}s:14:\"\0*\0constraints\";a:3:{s:11:\"CommentName\";a:0:{}s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:29:\"Drupal\\comment\\Entity\\Comment\";s:11:\"\0*\0provider\";s:7:\"comment\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:15:\"contact_message\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:6:\"bundle\";s:12:\"contact_form\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:8:\"langcode\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:15:\"contact_message\";s:16:\"\0*\0originalClass\";s:29:\"Drupal\\contact\\Entity\\Message\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:49:\"Drupal\\contact\\ContactMessageAccessControlHandler\";s:7:\"storage\";s:43:\"Drupal\\Core\\Entity\\ContentEntityNullStorage\";s:12:\"view_builder\";s:33:\"Drupal\\contact\\MessageViewBuilder\";s:4:\"form\";a:1:{s:7:\"default\";s:26:\"Drupal\\contact\\MessageForm\";}}s:19:\"\0*\0admin_permission\";s:24:\"administer contact forms\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"contact_form\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Contact message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Contact messages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"contact message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"contact messages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:22:\"@count contact message\";s:6:\"plural\";s:23:\"@count contact messages\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:29:\"entity.contact_form.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:20:\"contact_message_list\";}s:14:\"\0*\0constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:29:\"Drupal\\contact\\Entity\\Message\";s:11:\"\0*\0provider\";s:7:\"contact\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:12:\"contact_form\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:4:\"form\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:10:\"recipients\";i:3;s:5:\"reply\";i:4;s:6:\"weight\";i:5;s:7:\"message\";i:6;s:8:\"redirect\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"contact_form\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\contact\\Entity\\ContactForm\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:46:\"Drupal\\contact\\ContactFormAccessControlHandler\";s:12:\"list_builder\";s:37:\"Drupal\\contact\\ContactFormListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:4:\"edit\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer contact forms\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:11:\"delete-form\";s:53:\"/admin/structure/contact/manage/{contact_form}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/contact/manage/{contact_form}\";s:10:\"collection\";s:24:\"/admin/structure/contact\";s:9:\"canonical\";s:23:\"/contact/{contact_form}\";s:10:\"devel-load\";s:34:\"/devel/contact_form/{contact_form}\";s:16:\"devel-definition\";s:45:\"/devel/contact_form/{contact_form}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:15:\"contact_message\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Contact forms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"contact forms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count contact form\";s:6:\"plural\";s:20:\"@count contact forms\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:contact_form_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\contact\\Entity\\ContactForm\";s:11:\"\0*\0provider\";s:7:\"contact\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:24:\"content_moderation_state\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:11:\"revision_id\";s:4:\"uuid\";s:4:\"uuid\";s:3:\"uid\";s:3:\"uid\";s:8:\"langcode\";s:8:\"langcode\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:24:\"content_moderation_state\";s:16:\"\0*\0originalClass\";s:55:\"Drupal\\content_moderation\\Entity\\ContentModerationState\";s:11:\"\0*\0handlers\";a:5:{s:14:\"storage_schema\";s:61:\"Drupal\\content_moderation\\ContentModerationStateStorageSchema\";s:10:\"views_data\";s:29:\"\\Drupal\\views\\EntityViewsData\";s:6:\"access\";s:68:\"Drupal\\content_moderation\\ContentModerationStateAccessControlHandler\";s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:24:\"content_moderation_state\";s:22:\"\0*\0revision_data_table\";s:39:\"content_moderation_state_field_revision\";s:17:\"\0*\0revision_table\";s:33:\"content_moderation_state_revision\";s:13:\"\0*\0data_table\";s:35:\"content_moderation_state_field_data\";s:11:\"\0*\0internal\";b:1;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"content moderation states\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:31:\"@count content moderation state\";s:6:\"plural\";s:32:\"@count content moderation states\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:29:\"content_moderation_state_list\";}s:14:\"\0*\0constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:55:\"Drupal\\content_moderation\\Entity\\ContentModerationState\";s:11:\"\0*\0provider\";s:18:\"content_moderation\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:31:\"content_moderation_notification\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:2:\"id\";i:1;s:8:\"workflow\";i:2;s:11:\"transitions\";i:3;s:5:\"roles\";i:4;s:6:\"author\";i:5;s:6:\"emails\";i:6;s:7:\"subject\";i:7;s:4:\"body\";i:8;s:5:\"label\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:31:\"content_moderation_notification\";s:16:\"\0*\0originalClass\";s:76:\"Drupal\\content_moderation_notifications\\Entity\\ContentModerationNotification\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:86:\"Drupal\\content_moderation_notifications\\ContentModerationNotificationsAccessController\";s:12:\"list_builder\";s:92:\"Drupal\\content_moderation_notifications\\Controller\\ContentModerationNotificationsListBuilder\";s:4:\"form\";a:5:{s:3:\"add\";s:82:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsAddForm\";s:4:\"edit\";s:83:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsEditForm\";s:6:\"delete\";s:85:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsDeleteForm\";s:7:\"disable\";s:56:\"Drupal\\content_moderation_notifications\\Form\\DisableForm\";s:6:\"enable\";s:56:\"Drupal\\content_moderation_notifications\\Form\\DisableForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:43:\"administer content moderation notifications\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:8:\"add-form\";s:40:\"/admin/config/workflow/notifications/add\";s:9:\"edit-form\";s:77:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}\";s:11:\"delete-form\";s:84:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/delete\";s:11:\"enable-form\";s:84:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/enable\";s:12:\"disable-form\";s:85:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/disable\";s:10:\"collection\";s:36:\"/admin/config/workflow/notifications\";s:10:\"devel-load\";s:72:\"/devel/content_moderation_notification/{content_moderation_notification}\";s:16:\"devel-definition\";s:83:\"/devel/content_moderation_notification/{content_moderation_notification}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Notification\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Notifications\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"notification\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"notifications\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:43:\"config:content_moderation_notification_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:76:\"Drupal\\content_moderation_notifications\\Entity\\ContentModerationNotification\";s:11:\"\0*\0provider\";s:32:\"content_moderation_notifications\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:6:\"editor\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:6:\"format\";i:1;s:6:\"editor\";i:2;s:8:\"settings\";i:3;s:12:\"image_upload\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:6:\"format\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"editor\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\editor\\Entity\\Editor\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:40:\"Drupal\\editor\\EditorAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text Editors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"text editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"text editors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:18:\"@count text editor\";s:6:\"plural\";s:19:\"@count text editors\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:editor_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\editor\\Entity\\Editor\";s:11:\"\0*\0provider\";s:6:\"editor\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:20:\"field_storage_config\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:7:\"storage\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:4:\"type\";i:4;s:8:\"settings\";i:5;s:6:\"module\";i:6;s:6:\"locked\";i:7;s:11:\"cardinality\";i:8;s:12:\"translatable\";i:9;s:7:\"indexes\";i:10;s:22:\"persist_with_no_fields\";i:11;s:14:\"custom_storage\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"field_storage_config\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\field\\Entity\\FieldStorageConfig\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:51:\"Drupal\\field\\FieldStorageConfigAccessControlHandler\";s:7:\"storage\";s:38:\"Drupal\\field\\FieldStorageConfigStorage\";s:4:\"form\";a:1:{s:4:\"edit\";s:47:\"Drupal\\field_ui\\Form\\FieldStorageConfigEditForm\";}s:12:\"list_builder\";s:45:\"Drupal\\field_ui\\FieldStorageConfigListBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:1:{s:10:\"collection\";s:21:\"/admin/reports/fields\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Field storages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"field storages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:20:\"@count field storage\";s:6:\"plural\";s:21:\"@count field storages\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:field_storage_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:38:\"Drupal\\field\\Entity\\FieldStorageConfig\";s:11:\"\0*\0provider\";s:5:\"field\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:12:\"field_config\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:5:\"field\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"field_config\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\field\\Entity\\FieldConfig\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:44:\"Drupal\\field\\FieldConfigAccessControlHandler\";s:7:\"storage\";s:31:\"Drupal\\field\\FieldConfigStorage\";s:4:\"form\";a:2:{s:4:\"edit\";s:40:\"Drupal\\field_ui\\Form\\FieldConfigEditForm\";s:6:\"delete\";s:42:\"Drupal\\field_ui\\Form\\FieldConfigDeleteForm\";}s:12:\"list_builder\";s:38:\"Drupal\\field_ui\\FieldConfigListBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:12:\"@count field\";s:6:\"plural\";s:13:\"@count fields\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:field_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:31:\"Drupal\\field\\Entity\\FieldConfig\";s:11:\"\0*\0provider\";s:5:\"field\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:4:\"file\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Files\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"file\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"files\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:11:\"@count file\";s:6:\"plural\";s:12:\"@count files\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:13:\"filter_format\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:6:\"format\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:6:\"format\";i:2;s:6:\"weight\";i:3;s:5:\"roles\";i:4;s:7:\"filters\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:6:\"format\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:13:\"filter_format\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\filter\\Entity\\FilterFormat\";s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:3:{s:3:\"add\";s:33:\"Drupal\\filter\\FilterFormatAddForm\";s:4:\"edit\";s:34:\"Drupal\\filter\\FilterFormatEditForm\";s:7:\"disable\";s:36:\"Drupal\\filter\\Form\\FilterDisableForm\";}s:12:\"list_builder\";s:37:\"Drupal\\filter\\FilterFormatListBuilder\";s:6:\"access\";s:46:\"Drupal\\filter\\FilterFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:18:\"administer filters\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"edit-form\";s:52:\"/admin/config/content/formats/manage/{filter_format}\";s:7:\"disable\";s:60:\"/admin/config/content/formats/manage/{filter_format}/disable\";s:10:\"devel-load\";s:36:\"/devel/filter_format/{filter_format}\";s:16:\"devel-definition\";s:47:\"/devel/filter_format/{filter_format}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text formats\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"text formats\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:18:\"@count text format\";s:6:\"plural\";s:19:\"@count text formats\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:25:\"config:filter_format_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\filter\\Entity\\FilterFormat\";s:11:\"\0*\0provider\";s:6:\"filter\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:11:\"image_style\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:5:\"style\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:3:{i:0;s:4:\"name\";i:1;s:5:\"label\";i:2;s:7:\"effects\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:4:\"name\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"image_style\";s:16:\"\0*\0originalClass\";s:30:\"Drupal\\image\\Entity\\ImageStyle\";s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:3:\"add\";s:35:\"Drupal\\image\\Form\\ImageStyleAddForm\";s:4:\"edit\";s:36:\"Drupal\\image\\Form\\ImageStyleEditForm\";s:6:\"delete\";s:38:\"Drupal\\image\\Form\\ImageStyleDeleteForm\";s:5:\"flush\";s:37:\"Drupal\\image\\Form\\ImageStyleFlushForm\";}s:12:\"list_builder\";s:34:\"Drupal\\image\\ImageStyleListBuilder\";s:7:\"storage\";s:30:\"Drupal\\image\\ImageStyleStorage\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";}s:19:\"\0*\0admin_permission\";s:23:\"administer image styles\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:10:\"flush-form\";s:59:\"/admin/config/media/image-styles/manage/{image_style}/flush\";s:9:\"edit-form\";s:53:\"/admin/config/media/image-styles/manage/{image_style}\";s:11:\"delete-form\";s:60:\"/admin/config/media/image-styles/manage/{image_style}/delete\";s:10:\"collection\";s:32:\"/admin/config/media/image-styles\";s:10:\"devel-load\";s:32:\"/devel/image_style/{image_style}\";s:16:\"devel-definition\";s:43:\"/devel/image_style/{image_style}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Image styles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"image styles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:18:\"@count image style\";s:6:\"plural\";s:19:\"@count image styles\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:image_style_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:30:\"Drupal\\image\\Entity\\ImageStyle\";s:11:\"\0*\0provider\";s:5:\"image\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:9:\"migration\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"migration\";s:16:\"\0*\0originalClass\";s:36:\"Drupal\\migrate_plus\\Entity\\Migration\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:12:\"list_builder\";s:52:\"Drupal\\migrate_tools\\Controller\\MigrationListBuilder\";s:4:\"form\";a:2:{s:4:\"edit\";s:43:\"Drupal\\migrate_tools\\Form\\MigrationEditForm\";s:6:\"delete\";s:45:\"Drupal\\migrate_tools\\Form\\MigrationDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:21:\"administer migrations\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:1:{s:9:\"list-form\";s:60:\"/admin/structure/migrate/manage/{migration_group}/migrations\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Migration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:migration_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:36:\"Drupal\\migrate_plus\\Entity\\Migration\";s:11:\"\0*\0provider\";s:12:\"migrate_plus\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:15:\"migration_group\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:15:\"migration_group\";s:16:\"\0*\0originalClass\";s:41:\"Drupal\\migrate_plus\\Entity\\MigrationGroup\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:12:\"list_builder\";s:57:\"Drupal\\migrate_tools\\Controller\\MigrationGroupListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:47:\"Drupal\\migrate_tools\\Form\\MigrationGroupAddForm\";s:4:\"edit\";s:48:\"Drupal\\migrate_tools\\Form\\MigrationGroupEditForm\";s:6:\"delete\";s:50:\"Drupal\\migrate_tools\\Form\\MigrationGroupDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:21:\"administer migrations\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"edit-form\";s:49:\"/admin/structure/migrate/manage/{migration_group}\";s:11:\"delete-form\";s:56:\"/admin/structure/migrate/manage/{migration_group}/delete\";s:10:\"devel-load\";s:40:\"/devel/migration_group/{migration_group}\";s:16:\"devel-definition\";s:51:\"/devel/migration_group/{migration_group}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Migration Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:27:\"config:migration_group_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:6:\"module\";s:12:\"migrate_plus\";}s:8:\"\0*\0class\";s:41:\"Drupal\\migrate_plus\\Entity\\MigrationGroup\";s:11:\"\0*\0provider\";s:12:\"migrate_plus\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:4:\"node\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:13:\"revision_user\";s:12:\"revision_uid\";s:16:\"revision_created\";s:18:\"revision_timestamp\";s:20:\"revision_log_message\";s:12:\"revision_log\";s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:11:{s:2:\"id\";s:3:\"nid\";s:8:\"revision\";s:3:\"vid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"status\";s:6:\"status\";s:9:\"published\";s:6:\"status\";s:3:\"uid\";s:3:\"uid\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:4:\"node\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\node\\Entity\\Node\";s:11:\"\0*\0handlers\";a:10:{s:7:\"storage\";s:23:\"Drupal\\node\\NodeStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\node\\NodeStorageSchema\";s:12:\"view_builder\";s:27:\"Drupal\\node\\NodeViewBuilder\";s:6:\"access\";s:36:\"Drupal\\node\\NodeAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\node\\NodeViewsData\";s:4:\"form\";a:4:{s:7:\"default\";s:20:\"Drupal\\node\\NodeForm\";s:6:\"delete\";s:31:\"Drupal\\node\\Form\\NodeDeleteForm\";s:4:\"edit\";s:20:\"Drupal\\node\\NodeForm\";s:23:\"delete-multiple-confirm\";s:31:\"Drupal\\node\\Form\\DeleteMultiple\";}s:14:\"route_provider\";a:2:{s:4:\"html\";s:36:\"Drupal\\node\\Entity\\NodeRouteProvider\";s:10:\"moderation\";s:70:\"Drupal\\content_moderation\\Entity\\Routing\\EntityModerationRouteProvider\";}s:12:\"list_builder\";s:27:\"Drupal\\node\\NodeListBuilder\";s:11:\"translation\";s:34:\"Drupal\\node\\NodeTranslationHandler\";s:10:\"moderation\";s:62:\"Drupal\\content_moderation\\Entity\\Handler\\NodeModerationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:11:{s:9:\"canonical\";s:12:\"/node/{node}\";s:11:\"delete-form\";s:19:\"/node/{node}/delete\";s:20:\"delete-multiple-form\";s:26:\"/admin/content/node/delete\";s:9:\"edit-form\";s:17:\"/node/{node}/edit\";s:15:\"version-history\";s:22:\"/node/{node}/revisions\";s:8:\"revision\";s:43:\"/node/{node}/revisions/{node_revision}/view\";s:6:\"create\";s:5:\"/node\";s:14:\"latest-version\";s:19:\"/node/{node}/latest\";s:10:\"devel-load\";s:18:\"/devel/node/{node}\";s:12:\"devel-render\";s:25:\"/devel/node/{node}/render\";s:16:\"devel-definition\";s:29:\"/devel/node/{node}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:9:\"node_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:4:\"node\";s:22:\"\0*\0revision_data_table\";s:19:\"node_field_revision\";s:17:\"\0*\0revision_table\";s:13:\"node_revision\";s:13:\"\0*\0data_table\";s:15:\"node_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:1;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"content item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"content items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count content item\";s:6:\"plural\";s:20:\"@count content items\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:26:\"entity.node_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:1:{i:0;s:21:\"user.node_grants:view\";}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"node_list\";}s:14:\"\0*\0constraints\";a:3:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;s:12:\"MenuSettings\";a:0:{}}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\node\\Entity\\Node\";s:11:\"\0*\0provider\";s:4:\"node\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:9:\"node_type\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:4:\"name\";i:1;s:4:\"type\";i:2;s:11:\"description\";i:3;s:4:\"help\";i:4;s:12:\"new_revision\";i:5;s:12:\"preview_mode\";i:6;s:17:\"display_submitted\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:4:\"type\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"node_type\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\node\\Entity\\NodeType\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:40:\"Drupal\\node\\NodeTypeAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:24:\"Drupal\\node\\NodeTypeForm\";s:4:\"edit\";s:24:\"Drupal\\node\\NodeTypeForm\";s:6:\"delete\";s:38:\"Drupal\\node\\Form\\NodeTypeDeleteConfirm\";}s:12:\"list_builder\";s:31:\"Drupal\\node\\NodeTypeListBuilder\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer content types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:9:\"edit-form\";s:41:\"/admin/structure/types/manage/{node_type}\";s:11:\"delete-form\";s:48:\"/admin/structure/types/manage/{node_type}/delete\";s:10:\"collection\";s:22:\"/admin/structure/types\";s:10:\"devel-load\";s:28:\"/devel/node_type/{node_type}\";s:16:\"devel-definition\";s:39:\"/devel/node_type/{node_type}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:4:\"node\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Content types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"content types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count content type\";s:6:\"plural\";s:20:\"@count content types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:node_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\node\\Entity\\NodeType\";s:11:\"\0*\0provider\";s:4:\"node\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:11:\"rdf_mapping\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:7:\"mapping\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:5:\"types\";i:4;s:13:\"fieldMappings\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"rdf_mapping\";s:16:\"\0*\0originalClass\";s:28:\"Drupal\\rdf\\Entity\\RdfMapping\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"RDF mapping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"RDF mapping item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"RDF mappings items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:23:\"@count RDF mapping item\";s:6:\"plural\";s:24:\"@count RDF mapping items\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:rdf_mapping_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:28:\"Drupal\\rdf\\Entity\\RdfMapping\";s:11:\"\0*\0provider\";s:3:\"rdf\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:20:\"rest_resource_config\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:8:\"resource\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:9:\"plugin_id\";i:2;s:11:\"granularity\";i:3;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"rest_resource_config\";s:16:\"\0*\0originalClass\";s:37:\"Drupal\\rest\\Entity\\RestResourceConfig\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:25:\"administer rest resources\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";s:18:\"getLabelFromPlugin\";s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"REST resource configurations\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"REST resource configurations\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:34:\"@count REST resource configuration\";s:6:\"plural\";s:35:\"@count REST resource configurations\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:rest_resource_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:37:\"Drupal\\rest\\Entity\\RestResourceConfig\";s:11:\"\0*\0provider\";s:4:\"rest\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:11:\"search_page\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:4:\"page\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"path\";i:3;s:6:\"weight\";i:4;s:6:\"plugin\";i:5;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"search_page\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\search\\Entity\\SearchPage\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:44:\"Drupal\\search\\SearchPageAccessControlHandler\";s:12:\"list_builder\";s:35:\"Drupal\\search\\SearchPageListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\search\\Form\\SearchPageAddForm\";s:4:\"edit\";s:37:\"Drupal\\search\\Form\\SearchPageEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer search\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:9:\"edit-form\";s:47:\"/admin/config/search/pages/manage/{search_page}\";s:11:\"delete-form\";s:54:\"/admin/config/search/pages/manage/{search_page}/delete\";s:6:\"enable\";s:54:\"/admin/config/search/pages/manage/{search_page}/enable\";s:7:\"disable\";s:55:\"/admin/config/search/pages/manage/{search_page}/disable\";s:11:\"set-default\";s:59:\"/admin/config/search/pages/manage/{search_page}/set-default\";s:10:\"collection\";s:26:\"/admin/config/search/pages\";s:10:\"devel-load\";s:32:\"/devel/search_page/{search_page}\";s:16:\"devel-definition\";s:43:\"/devel/search_page/{search_page}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Search pages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"search pages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:18:\"@count search page\";s:6:\"plural\";s:19:\"@count search pages\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:search_page_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:31:\"Drupal\\search\\Entity\\SearchPage\";s:11:\"\0*\0provider\";s:6:\"search\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:12:\"shortcut_set\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:3:\"set\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:2:{i:0;s:2:\"id\";i:1;s:5:\"label\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"shortcut_set\";s:16:\"\0*\0originalClass\";s:34:\"Drupal\\shortcut\\Entity\\ShortcutSet\";s:11:\"\0*\0handlers\";a:4:{s:7:\"storage\";s:34:\"Drupal\\shortcut\\ShortcutSetStorage\";s:6:\"access\";s:47:\"Drupal\\shortcut\\ShortcutSetAccessControlHandler\";s:12:\"list_builder\";s:38:\"Drupal\\shortcut\\ShortcutSetListBuilder\";s:4:\"form\";a:5:{s:7:\"default\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:3:\"add\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:4:\"edit\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:9:\"customize\";s:33:\"Drupal\\shortcut\\Form\\SetCustomize\";s:6:\"delete\";s:42:\"Drupal\\shortcut\\Form\\ShortcutSetDeleteForm\";}}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:14:\"customize-form\";s:69:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize\";s:11:\"delete-form\";s:66:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete\";s:9:\"edit-form\";s:59:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}\";s:10:\"collection\";s:37:\"/admin/config/user-interface/shortcut\";s:10:\"devel-load\";s:34:\"/devel/shortcut_set/{shortcut_set}\";s:16:\"devel-definition\";s:45:\"/devel/shortcut_set/{shortcut_set}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:8:\"shortcut\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Shortcut sets\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"shortcut sets\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count shortcut set\";s:6:\"plural\";s:20:\"@count shortcut sets\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:shortcut_set_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:34:\"Drupal\\shortcut\\Entity\\ShortcutSet\";s:11:\"\0*\0provider\";s:8:\"shortcut\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:8:\"shortcut\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:12:\"shortcut_set\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:8:\"shortcut\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\shortcut\\Entity\\Shortcut\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:44:\"Drupal\\shortcut\\ShortcutAccessControlHandler\";s:4:\"form\";a:4:{s:7:\"default\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:3:\"add\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:4:\"edit\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:6:\"delete\";s:39:\"Drupal\\shortcut\\Form\\ShortcutDeleteForm\";}s:11:\"translation\";s:52:\"Drupal\\content_translation\\ContentTranslationHandler\";s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:9:\"canonical\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:11:\"delete-form\";s:60:\"/admin/config/user-interface/shortcut/link/{shortcut}/delete\";s:9:\"edit-form\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:10:\"devel-load\";s:26:\"/devel/shortcut/{shortcut}\";s:12:\"devel-render\";s:33:\"/devel/shortcut/{shortcut}/render\";s:16:\"devel-definition\";s:37:\"/devel/shortcut/{shortcut}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"shortcut_set\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:8:\"shortcut\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:19:\"shortcut_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Shortcut link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Shortcut links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"shortcut link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"shortcut links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:20:\"@count shortcut link\";s:6:\"plural\";s:21:\"@count shortcut links\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:shortcut_set_list\";}s:14:\"\0*\0constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:31:\"Drupal\\shortcut\\Entity\\Shortcut\";s:11:\"\0*\0provider\";s:8:\"shortcut\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:6:\"action\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:6:\"plugin\";i:4;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"action\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\system\\Entity\\Action\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:18:\"administer actions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Actions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"actions\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:13:\"@count action\";s:6:\"plural\";s:14:\"@count actions\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:action_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\system\\Entity\\Action\";s:11:\"\0*\0provider\";s:6:\"system\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:4:\"menu\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"description\";i:3;s:6:\"locked\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"menu\";s:16:\"\0*\0originalClass\";s:25:\"Drupal\\system\\Entity\\Menu\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:38:\"Drupal\\system\\MenuAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:3:{s:3:\"add\";s:23:\"Drupal\\menu_ui\\MenuForm\";s:4:\"edit\";s:23:\"Drupal\\menu_ui\\MenuForm\";s:6:\"delete\";s:34:\"Drupal\\menu_ui\\Form\\MenuDeleteForm\";}s:12:\"list_builder\";s:30:\"Drupal\\menu_ui\\MenuListBuilder\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:7:{s:8:\"add-form\";s:25:\"/admin/structure/menu/add\";s:11:\"delete-form\";s:42:\"/admin/structure/menu/manage/{menu}/delete\";s:9:\"edit-form\";s:35:\"/admin/structure/menu/manage/{menu}\";s:13:\"add-link-form\";s:39:\"/admin/structure/menu/manage/{menu}/add\";s:10:\"collection\";s:21:\"/admin/structure/menu\";s:10:\"devel-load\";s:18:\"/devel/menu/{menu}\";s:16:\"devel-definition\";s:29:\"/devel/menu/{menu}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Menus\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"menus\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:11:\"@count menu\";s:6:\"plural\";s:12:\"@count menus\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:menu_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:25:\"Drupal\\system\\Entity\\Menu\";s:11:\"\0*\0provider\";s:6:\"system\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:13:\"taxonomy_term\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"tid\";s:6:\"bundle\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:9:\"published\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:13:\"taxonomy_term\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\taxonomy\\Entity\\Term\";s:11:\"\0*\0handlers\";a:8:{s:7:\"storage\";s:27:\"Drupal\\taxonomy\\TermStorage\";s:14:\"storage_schema\";s:33:\"Drupal\\taxonomy\\TermStorageSchema\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:12:\"list_builder\";s:36:\"Drupal\\Core\\Entity\\EntityListBuilder\";s:6:\"access\";s:40:\"Drupal\\taxonomy\\TermAccessControlHandler\";s:10:\"views_data\";s:29:\"Drupal\\taxonomy\\TermViewsData\";s:4:\"form\";a:2:{s:7:\"default\";s:24:\"Drupal\\taxonomy\\TermForm\";s:6:\"delete\";s:35:\"Drupal\\taxonomy\\Form\\TermDeleteForm\";}s:11:\"translation\";s:38:\"Drupal\\taxonomy\\TermTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:7:{s:9:\"canonical\";s:30:\"/taxonomy/term/{taxonomy_term}\";s:11:\"delete-form\";s:37:\"/taxonomy/term/{taxonomy_term}/delete\";s:9:\"edit-form\";s:35:\"/taxonomy/term/{taxonomy_term}/edit\";s:6:\"create\";s:14:\"/taxonomy/term\";s:10:\"devel-load\";s:36:\"/devel/taxonomy_term/{taxonomy_term}\";s:12:\"devel-render\";s:43:\"/devel/taxonomy_term/{taxonomy_term}/render\";s:16:\"devel-definition\";s:47:\"/devel/taxonomy_term/{taxonomy_term}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:19:\"taxonomy_vocabulary\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:18:\"taxonomy_term_data\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:24:\"taxonomy_term_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Taxonomy terms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"taxonomy terms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:20:\"@count taxonomy term\";s:6:\"plural\";s:21:\"@count taxonomy terms\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";s:17:\"taxonomy_term_uri\";s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:40:\"entity.taxonomy_vocabulary.overview_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"taxonomy_term_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\taxonomy\\Entity\\Term\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:19:\"taxonomy_vocabulary\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:10:\"vocabulary\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:3:\"vid\";i:2;s:11:\"description\";i:3;s:9:\"hierarchy\";i:4;s:6:\"weight\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"taxonomy_vocabulary\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\taxonomy\\Entity\\Vocabulary\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:33:\"Drupal\\taxonomy\\VocabularyStorage\";s:12:\"list_builder\";s:37:\"Drupal\\taxonomy\\VocabularyListBuilder\";s:6:\"access\";s:46:\"Drupal\\taxonomy\\VocabularyAccessControlHandler\";s:4:\"form\";a:4:{s:7:\"default\";s:30:\"Drupal\\taxonomy\\VocabularyForm\";s:5:\"reset\";s:40:\"Drupal\\taxonomy\\Form\\VocabularyResetForm\";s:6:\"delete\";s:41:\"Drupal\\taxonomy\\Form\\VocabularyDeleteForm\";s:8:\"overview\";s:34:\"Drupal\\taxonomy\\Form\\OverviewTerms\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:54:\"Drupal\\taxonomy\\Entity\\Routing\\VocabularyRouteProvider\";}}s:19:\"\0*\0admin_permission\";s:19:\"administer taxonomy\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:8:\"add-form\";s:29:\"/admin/structure/taxonomy/add\";s:11:\"delete-form\";s:61:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete\";s:10:\"reset-form\";s:60:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset\";s:13:\"overview-form\";s:63:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview\";s:9:\"edit-form\";s:54:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}\";s:10:\"collection\";s:25:\"/admin/structure/taxonomy\";s:10:\"devel-load\";s:48:\"/devel/taxonomy_vocabulary/{taxonomy_vocabulary}\";s:16:\"devel-definition\";s:59:\"/devel/taxonomy_vocabulary/{taxonomy_vocabulary}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"taxonomy_term\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Taxonomy vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Taxonomy\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"vocabularies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:17:\"@count vocabulary\";s:6:\"plural\";s:19:\"@count vocabularies\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:taxonomy_vocabulary_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\taxonomy\\Entity\\Vocabulary\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:4:\"tour\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:19:\"routes.*.route_name\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:6:\"routes\";i:4;s:4:\"tips\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"tour\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\tour\\Entity\\Tour\";s:11:\"\0*\0handlers\";a:3:{s:12:\"view_builder\";s:27:\"Drupal\\tour\\TourViewBuilder\";s:6:\"access\";s:36:\"Drupal\\tour\\TourAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Tours\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"tours\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:11:\"@count tour\";s:6:\"plural\";s:12:\"@count tours\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:tour_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\tour\\Entity\\Tour\";s:11:\"\0*\0provider\";s:4:\"tour\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:4:\"user\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:3:\"uid\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:4:\"user\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\user\\Entity\\User\";s:11:\"\0*\0handlers\";a:9:{s:7:\"storage\";s:23:\"Drupal\\user\\UserStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\user\\UserStorageSchema\";s:6:\"access\";s:36:\"Drupal\\user\\UserAccessControlHandler\";s:12:\"list_builder\";s:27:\"Drupal\\user\\UserListBuilder\";s:10:\"views_data\";s:25:\"Drupal\\user\\UserViewsData\";s:14:\"route_provider\";a:1:{s:4:\"html\";s:36:\"Drupal\\user\\Entity\\UserRouteProvider\";}s:4:\"form\";a:3:{s:7:\"default\";s:23:\"Drupal\\user\\ProfileForm\";s:6:\"cancel\";s:31:\"Drupal\\user\\Form\\UserCancelForm\";s:8:\"register\";s:24:\"Drupal\\user\\RegisterForm\";}s:11:\"translation\";s:37:\"Drupal\\user\\ProfileTranslationHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:16:\"administer users\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:9:\"canonical\";s:12:\"/user/{user}\";s:9:\"edit-form\";s:17:\"/user/{user}/edit\";s:11:\"cancel-form\";s:19:\"/user/{user}/cancel\";s:10:\"collection\";s:13:\"/admin/people\";s:12:\"contact-form\";s:20:\"/user/{user}/contact\";s:10:\"devel-load\";s:18:\"/devel/user/{user}\";s:12:\"devel-render\";s:25:\"/devel/user/{user}/render\";s:16:\"devel-definition\";s:29:\"/devel/user/{user}/definition\";}s:17:\"\0*\0label_callback\";s:16:\"user_format_name\";s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:5:\"users\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:16:\"users_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:11:\"@count user\";s:6:\"plural\";s:12:\"@count users\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:22:\"entity.user.admin_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"user_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\user\\Entity\\User\";s:11:\"\0*\0provider\";s:4:\"user\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:9:\"user_role\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:4:\"role\";s:15:\"\0*\0static_cache\";b:1;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"weight\";i:3;s:8:\"is_admin\";i:4;s:11:\"permissions\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:6:\"weight\";s:6:\"weight\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"user_role\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\user\\Entity\\Role\";s:11:\"\0*\0handlers\";a:4:{s:7:\"storage\";s:23:\"Drupal\\user\\RoleStorage\";s:6:\"access\";s:36:\"Drupal\\user\\RoleAccessControlHandler\";s:12:\"list_builder\";s:27:\"Drupal\\user\\RoleListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:20:\"Drupal\\user\\RoleForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:22:\"administer permissions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:11:\"delete-form\";s:45:\"/admin/people/roles/manage/{user_role}/delete\";s:9:\"edit-form\";s:38:\"/admin/people/roles/manage/{user_role}\";s:21:\"edit-permissions-form\";s:37:\"/admin/people/permissions/{user_role}\";s:10:\"collection\";s:19:\"/admin/people/roles\";s:10:\"devel-load\";s:28:\"/devel/user_role/{user_role}\";s:16:\"devel-definition\";s:39:\"/devel/user_role/{user_role}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Roles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"roles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:11:\"@count role\";s:6:\"plural\";s:12:\"@count roles\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:user_role_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\user\\Entity\\Role\";s:11:\"\0*\0provider\";s:4:\"user\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:8:\"workflow\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:8:\"workflow\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:13:\"type_settings\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:8:\"workflow\";s:16:\"\0*\0originalClass\";s:32:\"Drupal\\workflows\\Entity\\Workflow\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:45:\"Drupal\\workflows\\WorkflowAccessControlHandler\";s:12:\"list_builder\";s:36:\"Drupal\\workflows\\WorkflowListBuilder\";s:4:\"form\";a:9:{s:3:\"add\";s:37:\"Drupal\\workflows\\Form\\WorkflowAddForm\";s:4:\"edit\";s:38:\"Drupal\\workflows\\Form\\WorkflowEditForm\";s:6:\"delete\";s:40:\"Drupal\\workflows\\Form\\WorkflowDeleteForm\";s:9:\"add-state\";s:42:\"Drupal\\workflows\\Form\\WorkflowStateAddForm\";s:10:\"edit-state\";s:43:\"Drupal\\workflows\\Form\\WorkflowStateEditForm\";s:12:\"delete-state\";s:45:\"Drupal\\workflows\\Form\\WorkflowStateDeleteForm\";s:14:\"add-transition\";s:47:\"Drupal\\workflows\\Form\\WorkflowTransitionAddForm\";s:15:\"edit-transition\";s:48:\"Drupal\\workflows\\Form\\WorkflowTransitionEditForm\";s:17:\"delete-transition\";s:50:\"Drupal\\workflows\\Form\\WorkflowTransitionDeleteForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:49:\"Drupal\\Core\\Entity\\Routing\\AdminHtmlRouteProvider\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:20:\"administer workflows\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:8:\"add-form\";s:36:\"/admin/config/workflow/workflows/add\";s:9:\"edit-form\";s:50:\"/admin/config/workflow/workflows/manage/{workflow}\";s:11:\"delete-form\";s:57:\"/admin/config/workflow/workflows/manage/{workflow}/delete\";s:14:\"add-state-form\";s:60:\"/admin/config/workflow/workflows/manage/{workflow}/add_state\";s:19:\"add-transition-form\";s:65:\"/admin/config/workflow/workflows/manage/{workflow}/add_transition\";s:10:\"collection\";s:32:\"/admin/config/workflow/workflows\";s:10:\"devel-load\";s:26:\"/devel/workflow/{workflow}\";s:16:\"devel-definition\";s:37:\"/devel/workflow/{workflow}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Workflows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"workflows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:15:\"@count workflow\";s:6:\"plural\";s:16:\"@count workflows\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:20:\"config:workflow_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:32:\"Drupal\\workflows\\Entity\\Workflow\";s:11:\"\0*\0provider\";s:9:\"workflows\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:17:\"menu_link_content\";O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:6:\"bundle\";s:9:\"published\";s:7:\"enabled\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:17:\"menu_link_content\";s:16:\"\0*\0originalClass\";s:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:14:\"storage_schema\";s:53:\"Drupal\\menu_link_content\\MenuLinkContentStorageSchema\";s:6:\"access\";s:60:\"Drupal\\menu_link_content\\MenuLinkContentAccessControlHandler\";s:4:\"form\";a:2:{s:7:\"default\";s:49:\"Drupal\\menu_link_content\\Form\\MenuLinkContentForm\";s:6:\"delete\";s:55:\"Drupal\\menu_link_content\\Form\\MenuLinkContentDeleteForm\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:9:\"canonical\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:9:\"edit-form\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:11:\"delete-form\";s:53:\"/admin/structure/menu/item/{menu_link_content}/delete\";s:10:\"devel-load\";s:44:\"/devel/menu_link_content/{menu_link_content}\";s:12:\"devel-render\";s:51:\"/devel/menu_link_content/{menu_link_content}/render\";s:16:\"devel-definition\";s:55:\"/devel/menu_link_content/{menu_link_content}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:17:\"menu_link_content\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:22:\"menu_link_content_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom menu links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"custom menu links\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:23:\"@count custom menu link\";s:6:\"plural\";s:24:\"@count custom menu links\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:22:\"menu_link_content_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\";s:11:\"\0*\0provider\";s:17:\"menu_link_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:4:\"view\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:11:\"description\";i:4;s:3:\"tag\";i:5;s:10:\"base_table\";i:6;s:10:\"base_field\";i:7;s:4:\"core\";i:8;s:7:\"display\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"view\";s:16:\"\0*\0originalClass\";s:24:\"Drupal\\views\\Entity\\View\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:6:{s:4:\"edit\";s:28:\"Drupal\\views_ui\\ViewEditForm\";s:3:\"add\";s:27:\"Drupal\\views_ui\\ViewAddForm\";s:7:\"preview\";s:31:\"Drupal\\views_ui\\ViewPreviewForm\";s:9:\"duplicate\";s:33:\"Drupal\\views_ui\\ViewDuplicateForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";s:10:\"break_lock\";s:34:\"Drupal\\views_ui\\Form\\BreakLockForm\";}s:12:\"list_builder\";s:31:\"Drupal\\views_ui\\ViewListBuilder\";}s:19:\"\0*\0admin_permission\";s:16:\"administer views\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:11:{s:9:\"edit-form\";s:34:\"/admin/structure/views/view/{view}\";s:17:\"edit-display-form\";s:52:\"/admin/structure/views/view/{view}/edit/{display_id}\";s:12:\"preview-form\";s:55:\"/admin/structure/views/view/{view}/preview/{display_id}\";s:14:\"duplicate-form\";s:44:\"/admin/structure/views/view/{view}/duplicate\";s:11:\"delete-form\";s:41:\"/admin/structure/views/view/{view}/delete\";s:6:\"enable\";s:41:\"/admin/structure/views/view/{view}/enable\";s:7:\"disable\";s:42:\"/admin/structure/views/view/{view}/disable\";s:15:\"break-lock-form\";s:45:\"/admin/structure/views/view/{view}/break-lock\";s:10:\"collection\";s:22:\"/admin/structure/views\";s:10:\"devel-load\";s:18:\"/devel/view/{view}\";s:16:\"devel-definition\";s:29:\"/devel/view/{view}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"view\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:11:\"@count view\";s:6:\"plural\";s:12:\"@count views\";s:7:\"context\";s:16:\"View entity type\";}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:view_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:24:\"Drupal\\views\\Entity\\View\";s:11:\"\0*\0provider\";s:5:\"views\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:11:\"date_format\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"locked\";i:3;s:7:\"pattern\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"date_format\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\Core\\Datetime\\Entity\\DateFormat\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:44:\"Drupal\\system\\DateFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\system\\Form\\DateFormatAddForm\";s:4:\"edit\";s:37:\"Drupal\\system\\Form\\DateFormatEditForm\";s:6:\"delete\";s:39:\"Drupal\\system\\Form\\DateFormatDeleteForm\";}s:12:\"list_builder\";s:35:\"Drupal\\system\\DateFormatListBuilder\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:9:\"edit-form\";s:61:\"/admin/config/regional/date-time/formats/manage/{date_format}\";s:11:\"delete-form\";s:68:\"/admin/config/regional/date-time/formats/manage/{date_format}/delete\";s:10:\"collection\";s:40:\"/admin/config/regional/date-time/formats\";s:10:\"devel-load\";s:32:\"/devel/date_format/{date_format}\";s:16:\"devel-definition\";s:43:\"/devel/date_format/{date_format}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:8:\"rendered\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:38:\"Drupal\\Core\\Datetime\\Entity\\DateFormat\";s:11:\"\0*\0provider\";s:4:\"core\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:16:\"entity_form_mode\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_form_mode\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityFormMode\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:12:\"list_builder\";s:41:\"Drupal\\field_ui\\EntityFormModeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:42:\"Drupal\\field_ui\\Form\\EntityFormModeAddForm\";s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityDisplayModeEditForm\";s:6:\"delete\";s:48:\"Drupal\\field_ui\\Form\\EntityDisplayModeDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:24:\"administer display modes\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:11:\"delete-form\";s:68:\"/admin/structure/display-modes/form/manage/{entity_form_mode}/delete\";s:9:\"edit-form\";s:61:\"/admin/structure/display-modes/form/manage/{entity_form_mode}\";s:8:\"add-form\";s:56:\"/admin/structure/display-modes/form/add/{entity_type_id}\";s:10:\"collection\";s:35:\"/admin/structure/display-modes/form\";s:10:\"devel-load\";s:42:\"/devel/entity_form_mode/{entity_form_mode}\";s:16:\"devel-definition\";s:53:\"/devel/entity_form_mode/{entity_form_mode}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_form_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityFormMode\";s:11:\"\0*\0provider\";s:4:\"core\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:19:\"entity_form_display\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_form_display\";s:16:\"\0*\0originalClass\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\";s:11:\"\0*\0handlers\";a:3:{s:6:\"access\";s:71:\"\\Drupal\\Core\\Entity\\Entity\\Access\\EntityFormDisplayAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:1:{s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityFormDisplayEditForm\";}}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_form_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\";s:11:\"\0*\0provider\";s:4:\"core\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:16:\"entity_view_mode\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_view_mode\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityViewMode\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:12:\"list_builder\";s:44:\"Drupal\\field_ui\\EntityDisplayModeListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:45:\"Drupal\\field_ui\\Form\\EntityDisplayModeAddForm\";s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityDisplayModeEditForm\";s:6:\"delete\";s:48:\"Drupal\\field_ui\\Form\\EntityDisplayModeDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:24:\"administer display modes\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:11:\"delete-form\";s:68:\"/admin/structure/display-modes/view/manage/{entity_view_mode}/delete\";s:9:\"edit-form\";s:61:\"/admin/structure/display-modes/view/manage/{entity_view_mode}\";s:8:\"add-form\";s:56:\"/admin/structure/display-modes/view/add/{entity_type_id}\";s:10:\"collection\";s:35:\"/admin/structure/display-modes/view\";s:10:\"devel-load\";s:42:\"/devel/entity_view_mode/{entity_view_mode}\";s:16:\"devel-definition\";s:53:\"/devel/entity_view_mode/{entity_view_mode}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_view_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityViewMode\";s:11:\"\0*\0provider\";s:4:\"core\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:19:\"entity_view_display\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_view_display\";s:16:\"\0*\0originalClass\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\";s:11:\"\0*\0handlers\";a:3:{s:6:\"access\";s:71:\"\\Drupal\\Core\\Entity\\Entity\\Access\\EntityViewDisplayAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:1:{s:4:\"edit\";s:46:\"Drupal\\field_ui\\Form\\EntityViewDisplayEditForm\";}}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_view_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\";s:11:\"\0*\0provider\";s:4:\"core\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}s:19:\"base_field_override\";O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:19:\"base_field_override\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"base_field_override\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\";s:11:\"\0*\0handlers\";a:2:{s:7:\"storage\";s:42:\"Drupal\\Core\\Field\\BaseFieldOverrideStorage\";s:6:\"access\";s:55:\"Drupal\\Core\\Field\\BaseFieldOverrideAccessControlHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:base_field_override_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\";s:11:\"\0*\0provider\";s:4:\"core\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}}',-1,1540294709.402,1,'entity_types','422'),('field_types_plugins',_binary 'a:29:{s:7:\"comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:8:\"datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:8:\"file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"file\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";}s:5:\"image\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";}s:4:\"link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:10:\"list_float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"list_string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:12:\"list_integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\path\\Plugin\\Field\\FieldType\\PathItem\";s:8:\"provider\";s:4:\"path\";}s:17:\"text_with_summary\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"text_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"text\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:11:\"string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:4:\"uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:8:\"language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:16:\"entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:9:\"timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:3:\"uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:7:\"decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:6:\"string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:5:\"email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}}',-1,1540294709.942,1,'','0'),('search_plugins',_binary 'a:2:{s:11:\"node_search\";a:4:{s:2:\"id\";s:11:\"node_search\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:36:\"Drupal\\node\\Plugin\\Search\\NodeSearch\";s:8:\"provider\";s:4:\"node\";}s:11:\"user_search\";a:4:{s:2:\"id\";s:11:\"user_search\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Users\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:36:\"Drupal\\user\\Plugin\\Search\\UserSearch\";s:8:\"provider\";s:4:\"user\";}}',-1,1540294710.446,1,'','0'),('typed_data_types_plugins',_binary 'a:104:{s:13:\"filter_format\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:13:\"filter_format\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Filter format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:42:\"Drupal\\filter\\Plugin\\DataType\\FilterFormat\";s:8:\"provider\";s:6:\"filter\";}s:6:\"entity\";a:10:{s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"All kind of entities, e.g. nodes, comments or users.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:8:\"provider\";s:4:\"core\";}s:12:\"entity:block\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:25:\"entity:block_content_type\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:20:\"entity:block_content\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:26:\"entity:block_content:basic\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:11:\"Basic block\";s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:19:\"entity:comment_type\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:14:\"entity:comment\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:3:{s:11:\"CommentName\";a:0:{}s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:47:\"entity:comment:migrate_example_advanced_comment\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:13:\"Node comments\";s:11:\"constraints\";a:3:{s:11:\"CommentName\";a:0:{}s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:28:\"entity:comment:node_comments\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:13:\"Node comments\";s:11:\"constraints\";a:3:{s:11:\"CommentName\";a:0:{}s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:22:\"entity:contact_message\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Contact message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:31:\"entity:contact_message:feedback\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:16:\"Website feedback\";s:11:\"constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:31:\"entity:contact_message:personal\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:21:\"Personal contact form\";s:11:\"constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:19:\"entity:contact_form\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:31:\"entity:content_moderation_state\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:1;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:38:\"entity:content_moderation_notification\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Notification\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:13:\"entity:editor\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:27:\"entity:field_storage_config\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:19:\"entity:field_config\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:11:\"entity:file\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:20:\"entity:filter_format\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:18:\"entity:image_style\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:16:\"entity:migration\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Migration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:22:\"entity:migration_group\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Migration Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:11:\"entity:node\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:3:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;s:12:\"MenuSettings\";a:0:{}}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:19:\"entity:node:article\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:7:\"Article\";s:11:\"constraints\";a:3:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;s:12:\"MenuSettings\";a:0:{}}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:32:\"entity:node:migrate_example_beer\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:4:\"Beer\";s:11:\"constraints\";a:3:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;s:12:\"MenuSettings\";a:0:{}}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:36:\"entity:node:migrate_example_producer\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:13:\"Wine Producer\";s:11:\"constraints\";a:3:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;s:12:\"MenuSettings\";a:0:{}}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:32:\"entity:node:migrate_example_wine\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:4:\"Wine\";s:11:\"constraints\";a:3:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;s:12:\"MenuSettings\";a:0:{}}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:16:\"entity:node:page\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:10:\"Basic page\";s:11:\"constraints\";a:3:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;s:12:\"MenuSettings\";a:0:{}}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:16:\"entity:node_type\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:18:\"entity:rdf_mapping\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"RDF mapping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:27:\"entity:rest_resource_config\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:18:\"entity:search_page\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:19:\"entity:shortcut_set\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:15:\"entity:shortcut\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Shortcut link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:23:\"entity:shortcut:default\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:7:\"Default\";s:11:\"constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:13:\"entity:action\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:11:\"entity:menu\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:20:\"entity:taxonomy_term\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:48:\"entity:taxonomy_term:migrate_example_beer_styles\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:27:\"Migrate Example Beer Styles\";s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:51:\"entity:taxonomy_term:migrate_example_wine_best_with\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:30:\"Migrate Example Wine Best With\";s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:49:\"entity:taxonomy_term:migrate_example_wine_regions\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:28:\"Migrate Example Wine Regions\";s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:51:\"entity:taxonomy_term:migrate_example_wine_varieties\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:30:\"Migrate Example Wine Varieties\";s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:25:\"entity:taxonomy_term:tags\";a:11:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";s:4:\"Tags\";s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:26:\"entity:taxonomy_vocabulary\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Taxonomy vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:11:\"entity:tour\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:11:\"entity:user\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:16:\"entity:user_role\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:15:\"entity:workflow\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:24:\"entity:menu_link_content\";a:12:{s:5:\"class\";s:48:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:11:\"entity:view\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:18:\"entity:date_format\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:23:\"entity:entity_form_mode\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:26:\"entity:entity_form_display\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:23:\"entity:entity_view_mode\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:26:\"entity:entity_view_display\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:26:\"entity:base_field_override\";a:12:{s:5:\"class\";s:54:\"Drupal\\Core\\Entity\\Plugin\\DataType\\ConfigEntityAdapter\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:0:{}s:8:\"internal\";b:0;s:16:\"definition_class\";s:50:\"\\Drupal\\Core\\Entity\\TypedData\\EntityDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"entity\";s:11:\"description\";r:24;s:7:\"deriver\";s:57:\"\\Drupal\\Core\\Entity\\Plugin\\DataType\\Deriver\\EntityDeriver\";s:8:\"provider\";s:4:\"core\";}s:16:\"entity_reference\";a:8:{s:16:\"definition_class\";s:46:\"\\Drupal\\Core\\TypedData\\DataReferenceDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:50:\"Drupal\\Core\\Entity\\Plugin\\DataType\\EntityReference\";s:8:\"provider\";s:4:\"core\";}s:18:\"field_item:comment\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:7:\"comment\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:75:\"This field manages configuration and presentation of comments on an entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:36:\"\\Drupal\\comment\\CommentFieldItemList\";s:14:\"default_widget\";s:15:\"comment_default\";s:17:\"default_formatter\";s:15:\"comment_default\";s:11:\"cardinality\";i:1;s:5:\"class\";s:49:\"Drupal\\comment\\Plugin\\Field\\FieldType\\CommentItem\";s:8:\"provider\";s:7:\"comment\";}s:19:\"field_item:datetime\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:8:\"datetime\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Create and store date values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"datetime_default\";s:17:\"default_formatter\";s:16:\"datetime_default\";s:10:\"list_class\";s:61:\"\\Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeFieldItemList\";s:11:\"constraints\";a:1:{s:14:\"DateTimeFormat\";a:0:{}}s:5:\"class\";s:51:\"Drupal\\datetime\\Plugin\\Field\\FieldType\\DateTimeItem\";s:8:\"provider\";s:8:\"datetime\";}s:19:\"field_item:file_uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:8:\"file_uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"File URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"An entity field containing a file URI, and a computed root-relative file URL.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"file_uri\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:46:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileUriItem\";s:8:\"provider\";s:4:\"file\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"field_item:file\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:4:\"file\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:55:\"This field stores the ID of a file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\file\\Plugin\\Field\\FieldType\\FileItem\";s:8:\"provider\";s:4:\"file\";}s:16:\"field_item:image\";a:15:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:5:\"image\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Image\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"This field stores the ID of an image file as an integer value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:13:\"column_groups\";a:3:{s:4:\"file\";a:3:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"columns\";a:3:{i:0;s:9:\"target_id\";i:1;s:5:\"width\";i:2;s:6:\"height\";}s:34:\"require_all_groups_for_translation\";b:1;}s:3:\"alt\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Alt\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}s:5:\"title\";a:2:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;}}s:10:\"list_class\";s:53:\"\\Drupal\\file\\Plugin\\Field\\FieldType\\FileFieldItemList\";s:11:\"constraints\";a:2:{s:15:\"ReferenceAccess\";a:0:{}s:14:\"FileValidation\";a:0:{}}s:5:\"class\";s:45:\"Drupal\\image\\Plugin\\Field\\FieldType\\ImageItem\";s:8:\"provider\";s:5:\"image\";}s:15:\"field_item:link\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:4:\"link\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:100:\"Stores a URL string, optional varchar link text, and optional blob of attributes to assemble a link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:12:\"link_default\";s:17:\"default_formatter\";s:4:\"link\";s:11:\"constraints\";a:4:{s:8:\"LinkType\";a:0:{}s:10:\"LinkAccess\";a:0:{}s:21:\"LinkExternalProtocols\";a:0:{}s:23:\"LinkNotExistingInternal\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\link\\Plugin\\Field\\FieldType\\LinkItem\";s:8:\"provider\";s:4:\"link\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:21:\"field_item:list_float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:10:\"list_float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"List (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:51:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListFloatItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:22:\"field_item:list_string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:11:\"list_string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"List (text)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:52:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListStringItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:23:\"field_item:list_integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:12:\"list_integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"List (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:5:\"class\";s:53:\"Drupal\\options\\Plugin\\Field\\FieldType\\ListIntegerItem\";s:8:\"provider\";s:7:\"options\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"field_item:path\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:4:\"path\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field containing a path alias and related data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:4:\"path\";s:10:\"list_class\";s:53:\"\\Drupal\\path\\Plugin\\Field\\FieldType\\PathFieldItemList\";s:11:\"constraints\";a:1:{s:9:\"PathAlias\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\path\\Plugin\\Field\\FieldType\\PathItem\";s:8:\"provider\";s:4:\"path\";}s:28:\"field_item:text_with_summary\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:17:\"text_with_summary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Text (formatted, long, with summary)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"This field stores long text with a format and an optional summary.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:54:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextWithSummaryItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:20:\"field_item:text_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:9:\"text_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Text (formatted, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"This field stores a long text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:47:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextLongItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"field_item:text\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:4:\"text\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Text (formatted)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"This field stores a text with a text format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:5:\"class\";s:43:\"Drupal\\text\\Plugin\\Field\\FieldType\\TextItem\";s:8:\"provider\";s:4:\"text\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"field_item:integer\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (integer)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"This field stores a number in the database as an integer.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\IntegerItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:22:\"field_item:string_long\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:11:\"string_long\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Text (plain, long)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"A field containing a long string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"string_textarea\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:55:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringLongItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:19:\"field_item:password\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:8:\"password\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"An entity field containing a password value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\PasswordItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:15:\"field_item:uuid\";a:12:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:4:\"uuid\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"An entity field containing a UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:49:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UuidItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:19:\"field_item:language\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"An entity field referencing a language.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:15:\"language_select\";s:17:\"default_formatter\";s:8:\"language\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}s:5:\"class\";s:53:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\LanguageItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"field_item:boolean\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"An entity field containing a boolean value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"boolean_checkbox\";s:17:\"default_formatter\";s:7:\"boolean\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\BooleanItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:14:\"field_item:map\";a:11:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"An entity field for storing a serialized array of values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:10:\"list_class\";s:35:\"\\Drupal\\Core\\Field\\MapFieldItemList\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\MapItem\";s:8:\"provider\";s:4:\"core\";}s:27:\"field_item:entity_reference\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:16:\"entity_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"An entity field containing an entity reference.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:29:\"entity_reference_autocomplete\";s:17:\"default_formatter\";s:22:\"entity_reference_label\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\Field\\EntityReferenceFieldItemList\";s:5:\"class\";s:60:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EntityReferenceItem\";s:8:\"provider\";s:4:\"core\";}s:16:\"field_item:float\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Number (float)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"This field stores a number in the database in a floating point format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\FloatItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"field_item:created\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:7:\"created\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"An entity field containing a UNIX timestamp of when the entity has been created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\CreatedItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:20:\"field_item:timestamp\";a:14:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"An entity field containing a UNIX timestamp value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:5:\"Range\";a:2:{s:3:\"min\";s:11:\"-2147483648\";s:3:\"max\";s:10:\"2147483648\";}}}}s:5:\"class\";s:54:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\TimestampItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"field_item:changed\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:7:\"changed\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Last changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:85:\"An entity field containing a UNIX timestamp of when the entity has been last updated.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:18:\"datetime_timestamp\";s:17:\"default_formatter\";s:9:\"timestamp\";s:10:\"list_class\";s:39:\"\\Drupal\\Core\\Field\\ChangedFieldItemList\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\ChangedItem\";s:8:\"provider\";s:4:\"core\";}s:14:\"field_item:uri\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:1;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"An entity field containing a URI.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"default_formatter\";s:8:\"uri_link\";s:14:\"default_widget\";s:3:\"uri\";s:5:\"class\";s:48:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\UriItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:18:\"field_item:decimal\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Number\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:7:\"decimal\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Number (decimal)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:5:\"class\";s:52:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\DecimalItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:17:\"field_item:string\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Text\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Text (plain)\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"A field containing a plain string value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:16:\"string_textfield\";s:17:\"default_formatter\";s:6:\"string\";s:5:\"class\";s:51:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\StringItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:16:\"field_item:email\";a:13:{s:8:\"category\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"General\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"no_ui\";b:0;s:16:\"definition_class\";s:52:\"\\Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\";s:21:\"list_definition_class\";s:38:\"\\Drupal\\Core\\Field\\BaseFieldDefinition\";s:35:\"unwrap_for_canonical_representation\";b:0;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"An entity field containing an email value.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"default_widget\";s:13:\"email_default\";s:17:\"default_formatter\";s:12:\"basic_string\";s:5:\"class\";s:50:\"Drupal\\Core\\Field\\Plugin\\Field\\FieldType\\EmailItem\";s:8:\"provider\";s:4:\"core\";s:10:\"list_class\";s:32:\"\\Drupal\\Core\\Field\\FieldItemList\";}s:3:\"any\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"any\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Any data\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:41:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\Any\";s:8:\"provider\";s:4:\"core\";}s:3:\"map\";a:8:{s:16:\"definition_class\";s:40:\"\\Drupal\\Core\\TypedData\\MapDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"map\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Map\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:41:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\Map\";s:8:\"provider\";s:4:\"core\";}s:7:\"boolean\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"boolean\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Boolean\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:49:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\BooleanData\";s:8:\"provider\";s:4:\"core\";}s:9:\"timestamp\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:9:\"timestamp\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Timestamp\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:47:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\Timestamp\";s:8:\"provider\";s:4:\"core\";}s:3:\"uri\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:3:\"uri\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:41:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\Uri\";s:8:\"provider\";s:4:\"core\";}s:8:\"language\";a:9:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"language\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"A language object.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:46:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\Language\";s:8:\"provider\";s:4:\"core\";}s:6:\"binary\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"binary\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Binary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\BinaryData\";s:8:\"provider\";s:4:\"core\";}s:16:\"datetime_iso8601\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"datetime_iso8601\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Date\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\DateTimeIso8601\";s:8:\"provider\";s:4:\"core\";}s:5:\"float\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"float\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Float\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:47:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\FloatData\";s:8:\"provider\";s:4:\"core\";}s:5:\"email\";a:9:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:5:\"email\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:5:\"Email\";a:0:{}}s:5:\"class\";s:43:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\Email\";s:8:\"provider\";s:4:\"core\";}s:7:\"integer\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:7:\"integer\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Integer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:49:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\IntegerData\";s:8:\"provider\";s:4:\"core\";}s:6:\"string\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:6:\"string\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"String\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:48:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\StringData\";s:8:\"provider\";s:4:\"core\";}s:16:\"duration_iso8601\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:16:\"duration_iso8601\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Duration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:53:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\DurationIso8601\";s:8:\"provider\";s:4:\"core\";}s:18:\"language_reference\";a:8:{s:16:\"definition_class\";s:46:\"\\Drupal\\Core\\TypedData\\DataReferenceDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:18:\"language_reference\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Language reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:55:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\LanguageReference\";s:8:\"provider\";s:4:\"core\";}s:4:\"list\";a:8:{s:16:\"definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:4:\"list\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"List of items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:46:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:8:\"provider\";s:4:\"core\";}s:8:\"timespan\";a:8:{s:16:\"definition_class\";s:37:\"\\Drupal\\Core\\TypedData\\DataDefinition\";s:10:\"list_class\";s:47:\"\\Drupal\\Core\\TypedData\\Plugin\\DataType\\ItemList\";s:21:\"list_definition_class\";s:41:\"\\Drupal\\Core\\TypedData\\ListDataDefinition\";s:35:\"unwrap_for_canonical_representation\";b:1;s:2:\"id\";s:8:\"timespan\";s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Time span in seconds\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:5:\"class\";s:46:\"Drupal\\Core\\TypedData\\Plugin\\DataType\\TimeSpan\";s:8:\"provider\";s:4:\"core\";}}',-1,1540294710.067,1,'','0'),('views:access',_binary 'a:3:{s:4:\"perm\";a:9:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:6:\"access\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Permission\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:69:\"Access will be granted to users with the specified permission string.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:4:\"perm\";s:5:\"class\";s:42:\"Drupal\\user\\Plugin\\views\\access\\Permission\";s:8:\"provider\";s:4:\"user\";}s:4:\"role\";a:9:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:6:\"access\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:64:\"Access will be granted to users with any of the specified roles.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:4:\"role\";s:5:\"class\";s:36:\"Drupal\\user\\Plugin\\views\\access\\Role\";s:8:\"provider\";s:4:\"user\";}s:4:\"none\";a:9:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:6:\"access\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"None\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Will be available to all users.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:4:\"none\";s:5:\"class\";s:37:\"Drupal\\views\\Plugin\\views\\access\\None\";s:8:\"provider\";s:5:\"views\";}}',-1,1540294709.711,1,'','0'),('views:display',_binary 'a:8:{s:11:\"rest_export\";a:13:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"REST export\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"REST export\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Create a REST export resource.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"rest_export\";s:10:\"uses_route\";b:1;s:16:\"returns_response\";b:1;s:5:\"class\";s:43:\"Drupal\\rest\\Plugin\\views\\display\\RestExport\";s:8:\"provider\";s:4:\"rest\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}s:4:\"feed\";a:13:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Feed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Feed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:4:\"feed\";s:10:\"uses_route\";b:1;s:16:\"returns_response\";b:1;s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Feed\";s:8:\"provider\";s:5:\"views\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}s:5:\"block\";a:14:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:0;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display the view as a block.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:5:\"block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses_hook_block\";b:1;s:26:\"contextual_links_locations\";a:1:{i:0;s:5:\"block\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\display\\Block\";s:8:\"provider\";s:5:\"views\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}s:16:\"entity_reference\";a:14:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:0;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Entity Reference\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Entity Reference Source\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:61:\"Selects referenceable entities for an entity reference field.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_reference\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses_menu_links\";b:0;s:24:\"entity_reference_display\";b:1;s:5:\"class\";s:49:\"Drupal\\views\\Plugin\\views\\display\\EntityReference\";s:8:\"provider\";s:5:\"views\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}s:4:\"page\";a:15:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"Display the view as a page, with a URL and menu links.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:4:\"page\";s:15:\"uses_menu_links\";b:1;s:10:\"uses_route\";b:1;s:26:\"contextual_links_locations\";a:1:{i:0;s:4:\"page\";}s:5:\"theme\";s:10:\"views_view\";s:5:\"class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:8:\"provider\";s:5:\"views\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}s:7:\"default\";a:13:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Master\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Default settings for this view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:7:\"default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no_ui\";b:1;s:5:\"class\";s:48:\"Drupal\\views\\Plugin\\views\\display\\DefaultDisplay\";s:8:\"provider\";s:5:\"views\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}s:5:\"embed\";a:13:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Embed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"Provide a display which can be embedded using the views api.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:5:\"embed\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses_menu_links\";b:0;s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\display\\Embed\";s:8:\"provider\";s:5:\"views\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}s:10:\"attachment\";a:13:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:7:\"display\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Attachment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:5:\"admin\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:79:\"Attachments added to other displays to achieve multiple views in the same view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:10:\"attachment\";s:5:\"theme\";s:10:\"views_view\";s:26:\"contextual_links_locations\";a:1:{i:0;s:0:\"\";}s:5:\"class\";s:44:\"Drupal\\views\\Plugin\\views\\display\\Attachment\";s:8:\"provider\";s:5:\"views\";s:16:\"contextual links\";a:1:{s:21:\"entity.view.edit_form\";a:2:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";s:22:\"route_parameters_names\";a:1:{s:4:\"view\";s:2:\"id\";}}}}}',-1,1540294709.440,1,'','0'),('views:row',_binary 'a:18:{s:11:\"comment_rss\";a:12:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:0;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Display the comment as RSS.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"comment_rss\";s:5:\"theme\";s:18:\"views_view_row_rss\";s:4:\"base\";a:1:{i:0;s:18:\"comment_field_data\";}s:13:\"display_types\";a:1:{i:0;s:4:\"feed\";}s:5:\"class\";s:35:\"Drupal\\comment\\Plugin\\views\\row\\Rss\";s:8:\"provider\";s:7:\"comment\";}s:11:\"entity:node\";a:12:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:11:\"entity:node\";s:5:\"class\";s:36:\"Drupal\\node\\Plugin\\views\\row\\NodeRow\";s:8:\"provider\";s:4:\"node\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:30;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:15:\"node_field_data\";}s:11:\"entity_type\";s:4:\"node\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:11:\"short_title\";s:0:\"\";}s:8:\"node_rss\";a:12:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:0;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Display the content with standard node view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:8:\"node_rss\";s:5:\"theme\";s:18:\"views_view_row_rss\";s:4:\"base\";a:1:{i:0;s:15:\"node_field_data\";}s:13:\"display_types\";a:1:{i:0;s:4:\"feed\";}s:5:\"class\";s:32:\"Drupal\\node\\Plugin\\views\\row\\Rss\";s:8:\"provider\";s:4:\"node\";}s:10:\"data_field\";a:10:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Use fields as row data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:10:\"data_field\";s:13:\"display_types\";a:1:{i:0;s:4:\"data\";}s:5:\"class\";s:41:\"Drupal\\rest\\Plugin\\views\\row\\DataFieldRow\";s:8:\"provider\";s:4:\"rest\";}s:11:\"data_entity\";a:10:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Entity\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Use entities as row data.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"data_entity\";s:13:\"display_types\";a:1:{i:0;s:4:\"data\";}s:5:\"class\";s:42:\"Drupal\\rest\\Plugin\\views\\row\\DataEntityRow\";s:8:\"provider\";s:4:\"rest\";}s:11:\"search_view\";a:9:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Search results\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Provides a row plugin to display search results.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"search_view\";s:5:\"class\";s:40:\"Drupal\\search\\Plugin\\views\\row\\SearchRow\";s:8:\"provider\";s:6:\"search\";}s:11:\"entity:user\";a:12:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:11:\"entity:user\";s:5:\"class\";s:36:\"Drupal\\user\\Plugin\\views\\row\\UserRow\";s:8:\"provider\";s:4:\"user\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:125;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:16:\"users_field_data\";}s:11:\"entity_type\";s:4:\"user\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:11:\"short_title\";s:0:\"\";}s:6:\"fields\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Displays the fields with an optional template.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:6:\"fields\";s:5:\"theme\";s:17:\"views_view_fields\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:36:\"Drupal\\views\\Plugin\\views\\row\\Fields\";s:8:\"provider\";s:5:\"views\";}s:16:\"entity_reference\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:0;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"Entity Reference inline fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Displays the fields with an optional template.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_reference\";s:5:\"theme\";s:17:\"views_view_fields\";s:13:\"display_types\";a:1:{i:0;s:16:\"entity_reference\";}s:5:\"class\";s:45:\"Drupal\\views\\Plugin\\views\\row\\EntityReference\";s:8:\"provider\";s:5:\"views\";}s:20:\"entity:block_content\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:20:\"entity:block_content\";s:8:\"provider\";s:5:\"views\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:184;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:24:\"block_content_field_data\";}s:11:\"entity_type\";s:13:\"block_content\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\EntityRow\";}s:14:\"entity:comment\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:14:\"entity:comment\";s:8:\"provider\";s:5:\"views\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:205;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:18:\"comment_field_data\";}s:11:\"entity_type\";s:7:\"comment\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\EntityRow\";}s:31:\"entity:content_moderation_state\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:31:\"entity:content_moderation_state\";s:8:\"provider\";s:5:\"views\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:226;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:35:\"content_moderation_state_field_data\";}s:11:\"entity_type\";s:24:\"content_moderation_state\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\EntityRow\";}s:11:\"entity:file\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:11:\"entity:file\";s:8:\"provider\";s:5:\"views\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:247;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:12:\"file_managed\";}s:11:\"entity_type\";s:4:\"file\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\EntityRow\";}s:15:\"entity:shortcut\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:15:\"entity:shortcut\";s:8:\"provider\";s:5:\"views\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Shortcut link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:268;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:19:\"shortcut_field_data\";}s:11:\"entity_type\";s:8:\"shortcut\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\EntityRow\";}s:20:\"entity:taxonomy_term\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:20:\"entity:taxonomy_term\";s:8:\"provider\";s:5:\"views\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:289;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:24:\"taxonomy_term_field_data\";}s:11:\"entity_type\";s:13:\"taxonomy_term\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\EntityRow\";}s:24:\"entity:menu_link_content\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:2:\"id\";s:24:\"entity:menu_link_content\";s:8:\"provider\";s:5:\"views\";s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Display the @label\";s:12:\"\0*\0arguments\";a:1:{s:6:\"@label\";r:310;}s:10:\"\0*\0options\";a:0:{}}s:4:\"base\";a:1:{i:0;s:22:\"menu_link_content_data\";}s:11:\"entity_type\";s:17:\"menu_link_content\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\EntityRow\";}s:11:\"opml_fields\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"OPML fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Display fields as OPML items.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:11:\"opml_fields\";s:5:\"theme\";s:19:\"views_view_row_opml\";s:13:\"display_types\";a:1:{i:0;s:4:\"feed\";}s:5:\"class\";s:40:\"Drupal\\views\\Plugin\\views\\row\\OpmlFields\";s:8:\"provider\";s:5:\"views\";}s:10:\"rss_fields\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:3:\"row\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Fields\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Display fields as RSS items.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:10:\"rss_fields\";s:5:\"theme\";s:18:\"views_view_row_rss\";s:13:\"display_types\";a:1:{i:0;s:4:\"feed\";}s:5:\"class\";s:39:\"Drupal\\views\\Plugin\\views\\row\\RssFields\";s:8:\"provider\";s:5:\"views\";}}',-1,1540294711.416,1,'','0'),('views:style',_binary 'a:10:{s:10:\"serializer\";a:10:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Serializer\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:57:\"Serializes views row data using the Serializer component.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:10:\"serializer\";s:13:\"display_types\";a:1:{i:0;s:4:\"data\";}s:5:\"class\";s:41:\"Drupal\\rest\\Plugin\\views\\style\\Serializer\";s:8:\"provider\";s:4:\"rest\";}s:19:\"unformatted_summary\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Unformatted\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"Displays the summary unformatted, with option for one after another or inline.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:19:\"unformatted_summary\";s:5:\"theme\";s:30:\"views_view_summary_unformatted\";s:13:\"display_types\";a:1:{i:0;s:7:\"summary\";}s:5:\"class\";s:50:\"Drupal\\views\\Plugin\\views\\style\\UnformattedSummary\";s:8:\"provider\";s:5:\"views\";}s:16:\"entity_reference\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:0;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Entity Reference list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"Returns results as a PHP array of labels and rendered rows.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:16:\"entity_reference\";s:5:\"theme\";s:22:\"views_view_unformatted\";s:13:\"display_types\";a:1:{i:0;s:16:\"entity_reference\";}s:5:\"class\";s:47:\"Drupal\\views\\Plugin\\views\\style\\EntityReference\";s:8:\"provider\";s:5:\"views\";}s:15:\"default_summary\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"List\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Displays the default summary as a list.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:15:\"default_summary\";s:5:\"theme\";s:18:\"views_view_summary\";s:13:\"display_types\";a:1:{i:0;s:7:\"summary\";}s:5:\"class\";s:46:\"Drupal\\views\\Plugin\\views\\style\\DefaultSummary\";s:8:\"provider\";s:5:\"views\";}s:4:\"opml\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"OPML Feed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Generates an OPML feed from a view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:4:\"opml\";s:5:\"theme\";s:15:\"views_view_opml\";s:13:\"display_types\";a:1:{i:0;s:4:\"feed\";}s:5:\"class\";s:36:\"Drupal\\views\\Plugin\\views\\style\\Opml\";s:8:\"provider\";s:5:\"views\";}s:9:\"html_list\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"HTML List\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Displays rows as HTML list.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:9:\"html_list\";s:5:\"theme\";s:15:\"views_view_list\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:40:\"Drupal\\views\\Plugin\\views\\style\\HtmlList\";s:8:\"provider\";s:5:\"views\";}s:4:\"grid\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Grid\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Displays rows in a grid.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:4:\"grid\";s:5:\"theme\";s:15:\"views_view_grid\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:36:\"Drupal\\views\\Plugin\\views\\style\\Grid\";s:8:\"provider\";s:5:\"views\";}s:5:\"table\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Table\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Displays rows in a table.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:5:\"table\";s:5:\"theme\";s:16:\"views_view_table\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:37:\"Drupal\\views\\Plugin\\views\\style\\Table\";s:8:\"provider\";s:5:\"views\";}s:7:\"default\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Unformatted list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Displays rows one after another.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:7:\"default\";s:5:\"theme\";s:22:\"views_view_unformatted\";s:13:\"display_types\";a:1:{i:0;s:6:\"normal\";}s:5:\"class\";s:44:\"Drupal\\views\\Plugin\\views\\style\\DefaultStyle\";s:8:\"provider\";s:5:\"views\";}s:3:\"rss\";a:11:{s:6:\"parent\";s:6:\"parent\";s:11:\"plugin_type\";s:5:\"style\";s:14:\"register_theme\";b:1;s:5:\"title\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"RSS Feed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"short_title\";s:0:\"\";s:4:\"help\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Generates an RSS feed from a view.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:2:\"id\";s:3:\"rss\";s:5:\"theme\";s:14:\"views_view_rss\";s:13:\"display_types\";a:1:{i:0;s:4:\"feed\";}s:5:\"class\";s:35:\"Drupal\\views\\Plugin\\views\\style\\Rss\";s:8:\"provider\";s:5:\"views\";}}',-1,1540294709.688,1,'','0'),('workflow_type_info',_binary 'a:1:{s:18:\"content_moderation\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Content moderation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"required_states\";a:2:{i:0;s:5:\"draft\";i:1;s:9:\"published\";}s:5:\"forms\";a:2:{s:9:\"configure\";s:62:\"\\Drupal\\content_moderation\\Form\\ContentModerationConfigureForm\";s:5:\"state\";s:58:\"\\Drupal\\content_moderation\\Form\\ContentModerationStateForm\";}s:2:\"id\";s:18:\"content_moderation\";s:5:\"class\";s:63:\"Drupal\\content_moderation\\Plugin\\WorkflowType\\ContentModeration\";s:8:\"provider\";s:18:\"content_moderation\";}}',-1,1540294710.045,1,'workflow_type_plugins','211');
/*!40000 ALTER TABLE `cache_discovery` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_discovery_migration`
--

DROP TABLE IF EXISTS `cache_discovery_migration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_discovery_migration` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_discovery_migration`
--

LOCK TABLES `cache_discovery_migration` WRITE;
/*!40000 ALTER TABLE `cache_discovery_migration` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_discovery_migration` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_dynamic_page_cache`
--

DROP TABLE IF EXISTS `cache_dynamic_page_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_dynamic_page_cache` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_dynamic_page_cache`
--

LOCK TABLES `cache_dynamic_page_cache` WRITE;
/*!40000 ALTER TABLE `cache_dynamic_page_cache` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_dynamic_page_cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_entity`
--

DROP TABLE IF EXISTS `cache_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_entity` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_entity`
--

LOCK TABLES `cache_entity` WRITE;
/*!40000 ALTER TABLE `cache_entity` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_entity` VALUES ('values:menu_link_content:2',_binary 'O:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\":28:{s:15:\"\0*\0insidePlugin\";b:0;s:9:\"\0*\0values\";a:16:{s:2:\"id\";a:1:{s:9:\"x-default\";s:1:\"2\";}s:6:\"bundle\";a:1:{s:9:\"x-default\";s:17:\"menu_link_content\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"568db68d-d4e5-4430-9c6d-4d2af68850a9\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:7:\"enabled\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:5:\"About\";}s:11:\"description\";a:1:{s:9:\"x-default\";N;}s:9:\"menu_name\";a:1:{s:9:\"x-default\";s:4:\"main\";}s:4:\"link\";a:1:{s:9:\"x-default\";a:3:{s:3:\"uri\";s:15:\"internal:#about\";s:5:\"title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";}}s:8:\"external\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:10:\"rediscover\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:6:\"weight\";a:1:{s:9:\"x-default\";s:3:\"-49\";}s:8:\"expanded\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:6:\"parent\";a:1:{s:9:\"x-default\";N;}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1540198620\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:4:{s:6:\"bundle\";s:17:\"menu_link_content\";s:2:\"id\";s:1:\"2\";s:4:\"uuid\";s:36:\"568db68d-d4e5-4430-9c6d-4d2af68850a9\";s:9:\"published\";s:1:\"1\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:5:\"About\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:17:\"menu_link_content\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}',-1,1540294711.893,1,'entity_field_info menu_link_content_values','463'),('values:menu_link_content:3',_binary 'O:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\":28:{s:15:\"\0*\0insidePlugin\";b:0;s:9:\"\0*\0values\";a:16:{s:2:\"id\";a:1:{s:9:\"x-default\";s:1:\"3\";}s:6:\"bundle\";a:1:{s:9:\"x-default\";s:17:\"menu_link_content\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"5bdc6c3b-9fd4-48f9-b9fc-08e999514049\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:7:\"enabled\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:14:\"Practice Areas\";}s:11:\"description\";a:1:{s:9:\"x-default\";N;}s:9:\"menu_name\";a:1:{s:9:\"x-default\";s:4:\"main\";}s:4:\"link\";a:1:{s:9:\"x-default\";a:3:{s:3:\"uri\";s:24:\"internal:#practice-areas\";s:5:\"title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";}}s:8:\"external\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:10:\"rediscover\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:6:\"weight\";a:1:{s:9:\"x-default\";s:3:\"-48\";}s:8:\"expanded\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:6:\"parent\";a:1:{s:9:\"x-default\";N;}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1540199504\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:4:{s:6:\"bundle\";s:17:\"menu_link_content\";s:2:\"id\";s:1:\"3\";s:4:\"uuid\";s:36:\"5bdc6c3b-9fd4-48f9-b9fc-08e999514049\";s:9:\"published\";s:1:\"1\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:14:\"Practice Areas\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:17:\"menu_link_content\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}',-1,1540294711.894,1,'entity_field_info menu_link_content_values','463'),('values:menu_link_content:4',_binary 'O:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\":28:{s:15:\"\0*\0insidePlugin\";b:0;s:9:\"\0*\0values\";a:16:{s:2:\"id\";a:1:{s:9:\"x-default\";s:1:\"4\";}s:6:\"bundle\";a:1:{s:9:\"x-default\";s:17:\"menu_link_content\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"eefbb742-8e21-478b-9b97-1319c8ec15e4\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:7:\"enabled\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:8:\"our team\";}s:11:\"description\";a:1:{s:9:\"x-default\";N;}s:9:\"menu_name\";a:1:{s:9:\"x-default\";s:4:\"main\";}s:4:\"link\";a:1:{s:9:\"x-default\";a:3:{s:3:\"uri\";s:18:\"internal:#our-team\";s:5:\"title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";}}s:8:\"external\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:10:\"rediscover\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:6:\"weight\";a:1:{s:9:\"x-default\";s:3:\"-47\";}s:8:\"expanded\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:6:\"parent\";a:1:{s:9:\"x-default\";N;}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1540201615\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:4:{s:6:\"bundle\";s:17:\"menu_link_content\";s:2:\"id\";s:1:\"4\";s:4:\"uuid\";s:36:\"eefbb742-8e21-478b-9b97-1319c8ec15e4\";s:9:\"published\";s:1:\"1\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:8:\"our team\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:17:\"menu_link_content\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}',-1,1540294711.895,1,'entity_field_info menu_link_content_values','463'),('values:menu_link_content:5',_binary 'O:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\":28:{s:15:\"\0*\0insidePlugin\";b:0;s:9:\"\0*\0values\";a:16:{s:2:\"id\";a:1:{s:9:\"x-default\";s:1:\"5\";}s:6:\"bundle\";a:1:{s:9:\"x-default\";s:17:\"menu_link_content\";}s:4:\"uuid\";a:1:{s:9:\"x-default\";s:36:\"d90984f7-a6c0-47ce-a11c-84f8ca01c9d3\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:7:\"enabled\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:5:\"title\";a:1:{s:9:\"x-default\";s:7:\"Contact\";}s:11:\"description\";a:1:{s:9:\"x-default\";N;}s:9:\"menu_name\";a:1:{s:9:\"x-default\";s:4:\"main\";}s:4:\"link\";a:1:{s:9:\"x-default\";a:3:{s:3:\"uri\";s:17:\"internal:#contact\";s:5:\"title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";}}s:8:\"external\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:10:\"rediscover\";a:1:{s:9:\"x-default\";s:1:\"1\";}s:6:\"weight\";a:1:{s:9:\"x-default\";s:3:\"-46\";}s:8:\"expanded\";a:1:{s:9:\"x-default\";s:1:\"0\";}s:6:\"parent\";a:1:{s:9:\"x-default\";N;}s:7:\"changed\";a:1:{s:9:\"x-default\";s:10:\"1540204429\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:9:\"\0*\0fields\";a:0:{}s:19:\"\0*\0fieldDefinitions\";N;s:12:\"\0*\0languages\";N;s:14:\"\0*\0langcodeKey\";s:8:\"langcode\";s:21:\"\0*\0defaultLangcodeKey\";s:16:\"default_langcode\";s:17:\"\0*\0activeLangcode\";s:9:\"x-default\";s:18:\"\0*\0defaultLangcode\";s:2:\"en\";s:15:\"\0*\0translations\";a:1:{s:9:\"x-default\";a:1:{s:6:\"status\";i:1;}}s:24:\"\0*\0translationInitialize\";b:0;s:14:\"\0*\0newRevision\";b:0;s:20:\"\0*\0isDefaultRevision\";b:1;s:13:\"\0*\0entityKeys\";a:4:{s:6:\"bundle\";s:17:\"menu_link_content\";s:2:\"id\";s:1:\"5\";s:4:\"uuid\";s:36:\"d90984f7-a6c0-47ce-a11c-84f8ca01c9d3\";s:9:\"published\";s:1:\"1\";}s:25:\"\0*\0translatableEntityKeys\";a:3:{s:5:\"label\";a:1:{s:9:\"x-default\";s:7:\"Contact\";}s:8:\"langcode\";a:1:{s:9:\"x-default\";s:2:\"en\";}s:16:\"default_langcode\";a:1:{s:9:\"x-default\";s:1:\"1\";}}s:12:\"\0*\0validated\";b:0;s:21:\"\0*\0validationRequired\";b:0;s:19:\"\0*\0loadedRevisionId\";N;s:33:\"\0*\0revisionTranslationAffectedKey\";s:29:\"revision_translation_affected\";s:37:\"\0*\0enforceRevisionTranslationAffected\";a:0:{}s:15:\"\0*\0entityTypeId\";s:17:\"menu_link_content\";s:15:\"\0*\0enforceIsNew\";N;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}}',-1,1540294711.895,1,'entity_field_info menu_link_content_values','463');
/*!40000 ALTER TABLE `cache_entity` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_menu`
--

DROP TABLE IF EXISTS `cache_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_menu` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_menu`
--

LOCK TABLES `cache_menu` WRITE;
/*!40000 ALTER TABLE `cache_menu` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_menu` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_migrate`
--

DROP TABLE IF EXISTS `cache_migrate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_migrate` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_migrate`
--

LOCK TABLES `cache_migrate` WRITE;
/*!40000 ALTER TABLE `cache_migrate` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_migrate` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_page`
--

DROP TABLE IF EXISTS `cache_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_page` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_page`
--

LOCK TABLES `cache_page` WRITE;
/*!40000 ALTER TABLE `cache_page` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_page` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_render`
--

DROP TABLE IF EXISTS `cache_render`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_render` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_render`
--

LOCK TABLES `cache_render` WRITE;
/*!40000 ALTER TABLE `cache_render` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_render` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_rest`
--

DROP TABLE IF EXISTS `cache_rest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_rest` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_rest`
--

LOCK TABLES `cache_rest` WRITE;
/*!40000 ALTER TABLE `cache_rest` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_rest` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_toolbar`
--

DROP TABLE IF EXISTS `cache_toolbar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_toolbar` (
  `cid` varchar(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or -1 for never.',
  `created` decimal(14,3) NOT NULL DEFAULT '0.000' COMMENT 'A timestamp with millisecond precision indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  `tags` longtext COMMENT 'Space-separated list of cache tags for this entry.',
  `checksum` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The tag invalidation checksum when this entry was saved.',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`),
  KEY `created` (`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Storage for the cache API.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_toolbar`
--

LOCK TABLES `cache_toolbar` WRITE;
/*!40000 ALTER TABLE `cache_toolbar` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_toolbar` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cachetags`
--

DROP TABLE IF EXISTS `cachetags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cachetags` (
  `tag` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Namespace-prefixed tag string.',
  `invalidations` int(11) NOT NULL DEFAULT '0' COMMENT 'Number incremented when the tag is invalidated.',
  PRIMARY KEY (`tag`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Cache table for tracking cache tag invalidations.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cachetags`
--

LOCK TABLES `cachetags` WRITE;
/*!40000 ALTER TABLE `cachetags` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cachetags` VALUES ('4xx-response',427),('block_content:1',1),('block_content:10',9),('block_content:11',2),('block_content:3',3),('block_content:4',2),('block_content:5',8),('block_content:6',5),('block_content:7',3),('block_content:8',2),('block_content:9',2),('block_content_list',49),('block_content_view',1),('breakpoints',373),('comment_view',4),('config:action_list',5),('config:api_key.settings',5),('config:automated_cron.settings',3),('config:block.block.aboutus',13),('config:block.block.address',6),('config:block.block.bartik_account_menu',2),('config:block.block.bartik_branding',2),('config:block.block.bartik_breadcrumbs',2),('config:block.block.bartik_content',2),('config:block.block.bartik_footer',2),('config:block.block.bartik_help',2),('config:block.block.bartik_local_actions',2),('config:block.block.bartik_local_tasks',2),('config:block.block.bartik_main_menu',2),('config:block.block.bartik_messages',2),('config:block.block.bartik_page_title',2),('config:block.block.bartik_powered',2),('config:block.block.bartik_search',2),('config:block.block.bartik_tools',2),('config:block.block.bootstrap_account_menu',2),('config:block.block.bootstrap_branding',2),('config:block.block.bootstrap_breadcrumbs',2),('config:block.block.bootstrap_content',2),('config:block.block.bootstrap_footer',2),('config:block.block.bootstrap_help',2),('config:block.block.bootstrap_local_actions',2),('config:block.block.bootstrap_local_tasks',2),('config:block.block.bootstrap_main_menu',2),('config:block.block.bootstrap_messages',2),('config:block.block.bootstrap_page_title',2),('config:block.block.bootstrap_powered',2),('config:block.block.bootstrap_search',2),('config:block.block.bootstrap_tools',2),('config:block.block.contactblock',9),('config:block.block.contactus',12),('config:block.block.contentinfotitle',7),('config:block.block.cowork_account_menu',12),('config:block.block.cowork_branding',12),('config:block.block.cowork_breadcrumbs',12),('config:block.block.cowork_content',12),('config:block.block.cowork_footer',12),('config:block.block.cowork_help',3),('config:block.block.cowork_local_actions',3),('config:block.block.cowork_local_tasks',3),('config:block.block.cowork_main_menu',3),('config:block.block.cowork_messages',3),('config:block.block.cowork_page_title',3),('config:block.block.cowork_powered',3),('config:block.block.cowork_search',3),('config:block.block.cowork_tools',3),('config:block.block.credit_due_content',1),('config:block.block.credit_due_help',1),('config:block.block.credit_due_local_actions',1),('config:block.block.credit_due_local_tasks',1),('config:block.block.credit_due_messages',1),('config:block.block.credit_due_page_title',1),('config:block.block.footer',4),('config:block.block.gareportshelp',2),('config:block.block.homepagebannertext',12),('config:block.block.justice_account_menu',12),('config:block.block.justice_branding',3),('config:block.block.justice_breadcrumbs',13),('config:block.block.justice_content',14),('config:block.block.justice_footer',5),('config:block.block.justice_help',14),('config:block.block.justice_local_actions',12),('config:block.block.justice_local_tasks',12),('config:block.block.justice_main_menu',11),('config:block.block.justice_messages',14),('config:block.block.justice_page_title',14),('config:block.block.justice_powered',6),('config:block.block.justice_search',15),('config:block.block.justice_tools',12),('config:block.block.mainnavigation',7),('config:block.block.mainnavigation_2',15),('config:block.block.ourteam',10),('config:block.block.pixlar_account_menu',4),('config:block.block.pixlar_branding',4),('config:block.block.pixlar_breadcrumbs',4),('config:block.block.pixlar_content',4),('config:block.block.pixlar_footer',4),('config:block.block.pixlar_help',4),('config:block.block.pixlar_local_actions',4),('config:block.block.pixlar_local_tasks',4),('config:block.block.pixlar_main_menu',4),('config:block.block.pixlar_messages',4),('config:block.block.pixlar_page_title',4),('config:block.block.pixlar_powered',4),('config:block.block.pixlar_search',4),('config:block.block.pixlar_tools',4),('config:block.block.portfolio',3),('config:block.block.powerbycompany',12),('config:block.block.practiceareas',11),('config:block.block.seven_breadcrumbs',1),('config:block.block.seven_content',1),('config:block.block.seven_help',1),('config:block.block.seven_local_actions',1),('config:block.block.seven_login',1),('config:block.block.seven_messages',1),('config:block.block.seven_page_title',1),('config:block.block.seven_primary_local_tasks',1),('config:block.block.seven_secondary_local_tasks',1),('config:block.block.sitebranding',15),('config:block.block.socialmedialink',17),('config:block.block.splashscreenblock',3),('config:block.block.whatiscowork',4),('config:block.block.yg_business_one_account_menu',1),('config:block.block.yg_business_one_branding',1),('config:block.block.yg_business_one_breadcrumbs',1),('config:block.block.yg_business_one_content',1),('config:block.block.yg_business_one_footer',1),('config:block.block.yg_business_one_help',1),('config:block.block.yg_business_one_local_actions',1),('config:block.block.yg_business_one_local_tasks',1),('config:block.block.yg_business_one_main_menu',1),('config:block.block.yg_business_one_messages',1),('config:block.block.yg_business_one_page_title',1),('config:block.block.yg_business_one_powered',1),('config:block.block.yg_business_one_search',1),('config:block.block.yg_business_one_tools',1),('config:block.block.yg_fitness_gym_account_menu',1),('config:block.block.yg_fitness_gym_branding',1),('config:block.block.yg_fitness_gym_breadcrumbs',1),('config:block.block.yg_fitness_gym_content',1),('config:block.block.yg_fitness_gym_footer',1),('config:block.block.yg_fitness_gym_help',1),('config:block.block.yg_fitness_gym_local_actions',1),('config:block.block.yg_fitness_gym_local_tasks',1),('config:block.block.yg_fitness_gym_main_menu',1),('config:block.block.yg_fitness_gym_messages',1),('config:block.block.yg_fitness_gym_page_title',1),('config:block.block.yg_fitness_gym_powered',1),('config:block.block.yg_fitness_gym_search',1),('config:block.block.yg_fitness_gym_tools',1),('config:block_content_type_list',1),('config:block_list',87),('config:bootstrap.settings',1),('config:comment_type_list',3),('config:contact.form.feedback',1),('config:contact_form_list',3),('config:content_moderation_notifications.content_moderation_notification.export_promotions',2),('config:content_moderation_notification_list',3),('config:core.entity_form_display.comment.comment.default',1),('config:core.entity_form_display.comment.migrate_example_advanced_comment.default',1),('config:core.entity_form_display.comment.node_comments.default',1),('config:core.entity_form_display.user.user.default',1),('config:core.entity_view_display.comment.comment.default',1),('config:core.entity_view_display.comment.migrate_example_advanced_comment.default',1),('config:core.entity_view_display.comment.node_comments.default',1),('config:core.entity_view_display.node.article.default',1),('config:core.entity_view_display.node.article.rss',1),('config:core.entity_view_display.node.article.teaser',1),('config:core.entity_view_display.node.migrate_example_beer.default',1),('config:core.entity_view_display.node.migrate_example_beer.teaser',1),('config:core.entity_view_display.node.migrate_example_producer.default',1),('config:core.entity_view_display.node.migrate_example_producer.teaser',1),('config:core.entity_view_display.node.migrate_example_wine.default',1),('config:core.entity_view_display.node.migrate_example_wine.teaser',1),('config:core.entity_view_display.node.page.default',1),('config:core.entity_view_display.node.page.teaser',1),('config:core.entity_view_display.user.user.default',1),('config:core.extension',93),('config:core.menu.static_menu_link_overrides',2),('config:cowork.settings',4),('config:dblog.settings',1),('config:editor.editor.full_html',8),('config:editor_list',9),('config:entity_form_display_list',4),('config:entity_form_mode_list',1),('config:entity_view_display_list',4),('config:entity_view_mode_list',5),('config:filter.format.full_html',8),('config:filter_format_list',10),('config:ga_reports.settings',1),('config:image_style_list',1),('config:menu_list',4),('config:migrate_plus.migration.beer_node',1),('config:migrate_plus.migration.beer_term',1),('config:migrate_plus.migration.beer_user',1),('config:migrate_plus.migration.weather_soap',1),('config:migrate_plus.migration.wine_role_json',2),('config:migrate_plus.migration.wine_role_xml',2),('config:migrate_plus.migration.wine_terms',1),('config:migrate_plus.migration.wine_variety_multi_xml',2),('config:migrate_plus.migration_group.beer',1),('config:migrate_plus.migration_group.wine',1),('config:migration_group_list',4),('config:migration_list',4),('config:node.settings',1),('config:node_type_list',3),('config:pixlar.settings',1),('config:rdf_mapping_list',1),('config:render_example.settings',1),('config:rest.resource.migrate_example_advanced_position',1),('config:rest.resource.migrate_example_advanced_variety_items',1),('config:rest.resource.migrate_example_advanced_variety_list',1),('config:rest.resource.migrate_example_advanced_variety_multiple',1),('config:rest_resource_config_list',2),('config:search_page_list',1),('config:shortcut.set.default',2),('config:shortcut_set_list',3),('config:system.action.comment_delete_action',1),('config:system.action.node_delete_action',1),('config:system.cron',3),('config:system.date',1),('config:system.file',1),('config:system.logging',2),('config:system.menu.account',365),('config:system.menu.admin',366),('config:system.menu.devel',217),('config:system.menu.footer',348),('config:system.menu.main',377),('config:system.menu.tools',362),('config:system.performance',2),('config:system.site',17),('config:system.theme',13),('config:system.theme.global',1),('config:taxonomy_vocabulary_list',3),('config:tour_list',1),('config:update.settings',1),('config:user.role.administrator',8),('config:user.role.anonymous',11),('config:user.role.authenticated',10),('config:user.settings',1),('config:user_role_list',12),('config:views.settings',1),('config:views.view.archive',1),('config:views.view.block_content',2),('config:views.view.comment',1),('config:views.view.comments_recent',1),('config:views.view.content',1),('config:views.view.content_recent',1),('config:views.view.files',1),('config:views.view.frontpage',1),('config:views.view.ga_reports_page',1),('config:views.view.ga_summary',1),('config:views.view.glossary',1),('config:views.view.moderated_content',1),('config:views.view.taxonomy_term',1),('config:views.view.user_admin_people',1),('config:views.view.watchdog',2),('config:views.view.who_s_new',1),('config:views.view.who_s_online',1),('config:view_list',4),('config:workflow_list',1),('contact_message_view',1),('contextual_links_plugins',374),('element_info_build',374),('entity_bundles',421),('entity_field_info',463),('entity_types',422),('file:1',1),('file:2',1),('file:3',1),('file:4',1),('file:5',1),('file:6',1),('file:7',1),('file_list',14),('http_response',366),('link_relation_type',374),('local_action',374),('local_task',395),('menu_link_content:1',1),('menu_link_content:2',3),('menu_link_content:3',2),('menu_link_content:4',2),('menu_link_content:5',2),('menu_link_content_list',12),('migration_plugins',325),('node:1',1),('node_list',2),('node_view',4),('rendered',33),('routes',366),('route_match',382),('search_index:node_search',1),('taxonomy_term_view',2),('theme_registry',92),('user:1',2),('user_list',3),('user_view',3),('views_data',3),('workflow_type_plugins',211);
/*!40000 ALTER TABLE `cachetags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment` (
  `cid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `comment_type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`cid`),
  UNIQUE KEY `comment_field__uuid__value` (`uuid`),
  KEY `comment_field__comment_type__target_id` (`comment_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for comment entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment`
--

LOCK TABLES `comment` WRITE;
/*!40000 ALTER TABLE `comment` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `comment` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `comment__comment_body`
--

DROP TABLE IF EXISTS `comment__comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment__comment_body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext NOT NULL,
  `comment_body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for comment field comment_body.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment__comment_body`
--

LOCK TABLES `comment__comment_body` WRITE;
/*!40000 ALTER TABLE `comment__comment_body` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `comment__comment_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `comment_entity_statistics`
--

DROP TABLE IF EXISTS `comment_entity_statistics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment_entity_statistics` (
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The entity_id of the entity for which the statistics are compiled.',
  `entity_type` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT 'node' COMMENT 'The entity_type of the entity to which this comment is a reply.',
  `field_name` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field_name of the field that was used to add this comment.',
  `cid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid of the last comment.',
  `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.changed.',
  `last_comment_name` varchar(60) DEFAULT NULL COMMENT 'The name of the latest author to post a comment on this node, from comment.name.',
  `last_comment_uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The user ID of the latest author to post a comment on this node, from comment.uid.',
  `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this entity.',
  PRIMARY KEY (`entity_id`,`entity_type`,`field_name`),
  KEY `last_comment_timestamp` (`last_comment_timestamp`),
  KEY `comment_count` (`comment_count`),
  KEY `last_comment_uid` (`last_comment_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maintains statistics of entity and comments posts to show …';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment_entity_statistics`
--

LOCK TABLES `comment_entity_statistics` WRITE;
/*!40000 ALTER TABLE `comment_entity_statistics` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `comment_entity_statistics` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `comment_field_data`
--

DROP TABLE IF EXISTS `comment_field_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment_field_data` (
  `cid` int(10) unsigned NOT NULL,
  `comment_type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `status` tinyint(4) NOT NULL,
  `pid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `entity_id` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `subject` varchar(64) DEFAULT NULL,
  `uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `name` varchar(60) DEFAULT NULL,
  `mail` varchar(254) DEFAULT NULL,
  `homepage` varchar(255) DEFAULT NULL,
  `created` int(11) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `thread` varchar(255) NOT NULL,
  `entity_type` varchar(32) CHARACTER SET ascii DEFAULT NULL,
  `field_name` varchar(32) CHARACTER SET ascii DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `hostname` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`cid`,`langcode`),
  KEY `comment__id__default_langcode__langcode` (`cid`,`default_langcode`,`langcode`),
  KEY `comment_field__comment_type__target_id` (`comment_type`),
  KEY `comment_field__uid__target_id` (`uid`),
  KEY `comment_field__created` (`created`),
  KEY `comment__status_comment_type` (`status`,`comment_type`,`cid`),
  KEY `comment__status_pid` (`pid`,`status`),
  KEY `comment__num_new` (`entity_id`,`entity_type`,`comment_type`,`status`,`created`,`cid`,`thread`(191)),
  KEY `comment__entity_langcode` (`entity_id`,`entity_type`,`comment_type`,`default_langcode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for comment entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment_field_data`
--

LOCK TABLES `comment_field_data` WRITE;
/*!40000 ALTER TABLE `comment_field_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `comment_field_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `config`
--

DROP TABLE IF EXISTS `config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `config` (
  `collection` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Config object collection.',
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Config object name.',
  `data` longblob COMMENT 'A serialized configuration object data.',
  PRIMARY KEY (`collection`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for configuration data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `config`
--

LOCK TABLES `config` WRITE;
/*!40000 ALTER TABLE `config` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `config` VALUES ('','api_key.settings',_binary 'a:1:{s:10:\"siteapikey\";s:10:\"dsaa surya\";}'),('','automated_cron.settings',_binary 'a:2:{s:8:\"interval\";i:10800;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fUksROt4FfkAU9BV4hV2XvhTBSS2nTNrZS4U7S-tKrs\";}}'),('','block.block.aboutus',_binary 'a:12:{s:4:\"uuid\";s:36:\"19bd1239-abdc-48e1-88cd-361de22cf485\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:b2311339-bbd3-476c-a3e0-1ec52517bf54\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:7:\"aboutus\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:8:\"about_us\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:b2311339-bbd3-476c-a3e0-1ec52517bf54\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:b2311339-bbd3-476c-a3e0-1ec52517bf54\";s:5:\"label\";s:8:\"About US\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.bartik_account_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"c9a468ba-c37d-4438-ac97-a98b26cbf506\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:19:\"system.menu.account\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DweBpscQZdG0-fHkSpUzdYucrNH45G_KF7Z82V-oyQM\";}s:2:\"id\";s:19:\"bartik_account_menu\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:14:\"secondary_menu\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:25:\"system_menu_block:account\";s:8:\"settings\";a:6:{s:2:\"id\";s:25:\"system_menu_block:account\";s:5:\"label\";s:17:\"User account menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_branding',_binary 'a:13:{s:4:\"uuid\";s:36:\"bc41e0f1-65b2-4e8d-8fca-8cc98d42043a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NDwadleLD3YVSbDUaakxyYZyINYtkFtOVGShfq4kWy8\";}s:2:\"id\";s:15:\"bartik_branding\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_breadcrumbs',_binary 'a:13:{s:4:\"uuid\";s:36:\"0c14917b-2ced-498e-9fc0-2f02b4517917\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oXUb3JZR2WW5VOdw4HrhRicCsq51mCgLfRyvheG68ck\";}s:2:\"id\";s:18:\"bartik_breadcrumbs\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:10:\"breadcrumb\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"d9f91af5-4a48-40e5-b9f5-0032468739aa\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9EoWV2Lot6FVSr50t4hoKgiz1LIXYWNG-IIPYsWxBqo\";}s:2:\"id\";s:14:\"bartik_content\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_footer',_binary 'a:13:{s:4:\"uuid\";s:36:\"bffa31a0-5cb6-411e-b8f7-671634564c49\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:18:\"system.menu.footer\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kkISXE1LT2FJEoYnqCrCpeFB-2pmGmMxMklVk7rQcfg\";}s:2:\"id\";s:13:\"bartik_footer\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:12:\"footer_fifth\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:24:\"system_menu_block:footer\";s:8:\"settings\";a:6:{s:2:\"id\";s:24:\"system_menu_block:footer\";s:5:\"label\";s:11:\"Footer menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"a737de56-27fb-4d37-8f65-67419bc1b268\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8I8iACSa0sKO3k3jlvUG1ge52rfcKX7USJAQYnzuBgg\";}s:2:\"id\";s:11:\"bartik_help\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_local_actions',_binary 'a:13:{s:4:\"uuid\";s:36:\"2d00ca46-356d-410e-83ac-52a1af2d16c2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"13GQpeITIJsp1kyPniXtWZfyFH87vb1xxJCHifL4UeE\";}s:2:\"id\";s:20:\"bartik_local_actions\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-20;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"bf29a35d-8303-4e72-81a9-6b50c6652eba\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"X9I1OB0W3WlWtrK-CNcg6hNWwa8wficanpH8pYnDZDE\";}s:2:\"id\";s:18:\"bartik_local_tasks\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-40;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:4:\"Tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_main_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"bdb8507f-f9ca-4c0c-8da6-1efead8376cc\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rx9IrdDv7Ldc4kpalZAxdhIPZfYIeOMh1N-qKoQZwHo\";}s:2:\"id\";s:16:\"bartik_main_menu\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:12:\"primary_menu\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:22:\"system_menu_block:main\";s:8:\"settings\";a:6:{s:2:\"id\";s:22:\"system_menu_block:main\";s:5:\"label\";s:15:\"Main navigation\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"3fe30bca-4df3-48e6-921f-47fc8a819f91\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KHQIJ7Vfl25lTjzIc7qIvnuistt-Mw2O0kG4jCofmkI\";}s:2:\"id\";s:15:\"bartik_messages\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"51173fd1-d55e-44c1-8b86-1f2e5c2290ba\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7rR9chwXvdM2H8OYMAYx9Zj3GGlPMrZp_M3ZA4thYTk\";}s:2:\"id\";s:17:\"bartik_page_title\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-50;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_powered',_binary 'a:13:{s:4:\"uuid\";s:36:\"878721c6-46a3-4ad3-a296-ece0f089d3f0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jQQUUWN2Uxr5qZtc9zcJKBCxpKY8orN1u2HPqYYRQDI\";}s:2:\"id\";s:14:\"bartik_powered\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:12:\"footer_fifth\";s:6:\"weight\";i:10;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_powered_by_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_powered_by_block\";s:5:\"label\";s:17:\"Powered by Drupal\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_search',_binary 'a:13:{s:4:\"uuid\";s:36:\"39dc9b33-ab89-4da5-af5e-c5d2b8574148\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"search\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"za-39d5WDUg6XvbyqSnuVYEeq6QM4qKJxW8MnoAha5A\";}s:2:\"id\";s:13:\"bartik_search\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"search_form_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"search_form_block\";s:5:\"label\";s:6:\"Search\";s:8:\"provider\";s:6:\"search\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}'),('','block.block.bartik_tools',_binary 'a:13:{s:4:\"uuid\";s:36:\"8f0dcbbc-0ab1-4035-ac62-47db9b0160dd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:17:\"system.menu.tools\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:6:\"bartik\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NeHSoqm4XFqA7_0bDmR429ZZQt3LRbZMNRJTMsFyOfI\";}s:2:\"id\";s:12:\"bartik_tools\";s:5:\"theme\";s:6:\"bartik\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_menu_block:tools\";s:8:\"settings\";a:6:{s:2:\"id\";s:23:\"system_menu_block:tools\";s:5:\"label\";s:5:\"Tools\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:7:\"visible\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}'),('','block.block.contactblock',_binary 'a:13:{s:4:\"uuid\";s:36:\"30a3d876-55e5-487a-ab67-ee9b2ba6589e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:21:\"contact.form.feedback\";}s:6:\"module\";a:3:{i:0;s:11:\"block_class\";i:1;s:13:\"contact_block\";i:2;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:34:\"col-md-6 col-md-push-6 animate-box\";}}s:2:\"id\";s:12:\"contactblock\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"contact\";s:6:\"weight\";i:-9;s:8:\"provider\";N;s:6:\"plugin\";s:13:\"contact_block\";s:8:\"settings\";a:5:{s:2:\"id\";s:13:\"contact_block\";s:5:\"label\";s:13:\"Contact block\";s:8:\"provider\";s:13:\"contact_block\";s:13:\"label_display\";s:1:\"0\";s:12:\"contact_form\";s:8:\"feedback\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.contactus',_binary 'a:13:{s:4:\"uuid\";s:36:\"89f3d8b2-f40e-426d-86c4-cb3fdf8866c8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:342a6d52-2574-4715-ba9d-33a1b621cb88\";}s:6:\"module\";a:3:{i:0;s:11:\"block_class\";i:1;s:13:\"block_content\";i:2;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:34:\"col-md-4 col-md-pull-6 animate-box\";}}s:2:\"id\";s:9:\"contactus\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"contact\";s:6:\"weight\";i:-8;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:342a6d52-2574-4715-ba9d-33a1b621cb88\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:342a6d52-2574-4715-ba9d-33a1b621cb88\";s:5:\"label\";s:10:\"Contact Us\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.contentinfotitle',_binary 'a:12:{s:4:\"uuid\";s:36:\"48c65ea9-2308-42d4-8edc-7a676f524b87\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:36888687-d0d1-49c9-8bb2-77cac2d2666c\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:16:\"contentinfotitle\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"contact\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:36888687-d0d1-49c9-8bb2-77cac2d2666c\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:36888687-d0d1-49c9-8bb2-77cac2d2666c\";s:5:\"label\";s:18:\"content info title\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.credit_due_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"53d8ed68-0c93-4b3e-98e1-553e9a5167a6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"credit_due\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U5yPOdErIwzR6yUpTwC2pmQ--NrXhgB8dj71jW2kvtk\";}s:2:\"id\";s:18:\"credit_due_content\";s:5:\"theme\";s:10:\"credit_due\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.credit_due_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"21a0f6bf-3750-49f6-a731-34b73470005f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:10:\"credit_due\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uYa53R3ZENpuhKi3hIXI3WpE7Sm8QeKdSEzEGnA5Zqg\";}s:2:\"id\";s:15:\"credit_due_help\";s:5:\"theme\";s:10:\"credit_due\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.credit_due_local_actions',_binary 'a:13:{s:4:\"uuid\";s:36:\"fa34d76f-ba68-4f1d-bdf8-e7bd4b1ccec8\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:10:\"credit_due\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"P8Q7RZEQ7mtRVvk_iUUuiOAR5uIu6cB3OHevqhStpks\";}s:2:\"id\";s:24:\"credit_due_local_actions\";s:5:\"theme\";s:10:\"credit_due\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-20;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.credit_due_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"97148985-f70b-49c3-947b-4913ccd5a594\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:10:\"credit_due\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SH7-nzaCk3HYfo2XI9jCifw8z1iI5D3UhzBGz6OmugU\";}s:2:\"id\";s:22:\"credit_due_local_tasks\";s:5:\"theme\";s:10:\"credit_due\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-40;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:4:\"Tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.credit_due_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"573535ae-eb8e-4634-b40e-42046196da99\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:10:\"credit_due\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lstTbdbRuvnFLz2Ooz3rQ99KpClLoo2YgOl_4ywKGDA\";}s:2:\"id\";s:19:\"credit_due_messages\";s:5:\"theme\";s:10:\"credit_due\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.credit_due_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"d5a20667-e6ee-424f-bba4-6b33564fc234\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:10:\"credit_due\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"JZnvrsiqGE97r-g7k2Pug9BQucug70-j9uuaksNdZhY\";}s:2:\"id\";s:21:\"credit_due_page_title\";s:5:\"theme\";s:10:\"credit_due\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-50;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.homepagebannertext',_binary 'a:12:{s:4:\"uuid\";s:36:\"2fc0a04c-094a-4c24-b349-da9505e28957\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:48f3ff65-fa94-4d14-ac71-9ba2d9ecb411\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:18:\"homepagebannertext\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:16:\"home_page_banner\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:48f3ff65-fa94-4d14-ac71-9ba2d9ecb411\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:48f3ff65-fa94-4d14-ac71-9ba2d9ecb411\";s:5:\"label\";s:22:\"Home Page Banner Text \";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.justice_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"cb53df72-fa2f-4662-84ed-741e0d4f0e59\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fNNLN48MSGSLiqwIFywCuxH2Dk_IxDbaP0kYhg_IPrg\";}s:2:\"id\";s:15:\"justice_content\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.justice_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"89364af3-94dc-4306-bce0-175d4abdf0c6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"MhtNdV__HKRTab0ZPjkPNfYL4Ng4UPBucDLoC7Rg5Eo\";}s:2:\"id\";s:12:\"justice_help\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"top_bar\";s:6:\"weight\";i:-6;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.justice_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"370ed465-768f-409c-a5c6-76e18e59f263\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9RnnTUBcn0WRWXfrGOnId2H0Q31uQUeu_F5TnDxl2yg\";}s:2:\"id\";s:16:\"justice_messages\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"top_bar\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.justice_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"788d55ca-8a56-44d9-9525-2effbcc9c002\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1TQP4b3ZnlzvIH9bj6cpCz_SyUHdJjLQkZnHpikjjhw\";}s:2:\"id\";s:18:\"justice_page_title\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:7:\"top_bar\";s:6:\"weight\";i:-5;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.justice_search',_binary 'a:13:{s:4:\"uuid\";s:36:\"aa7516a1-78b6-41c7-8292-d4adee150209\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:2:{i:0;s:6:\"search\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"F3d5hyAFunLh4PhGviJF019fHn1Z3_zy5gzsQ0tX1K0\";}s:2:\"id\";s:14:\"justice_search\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"search_form_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"search_form_block\";s:5:\"label\";s:6:\"Search\";s:8:\"provider\";s:6:\"search\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:1;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.mainnavigation_2',_binary 'a:12:{s:4:\"uuid\";s:36:\"269853f6-e94c-489b-be6d-b93fd658edf1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:16:\"mainnavigation_2\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:-6;s:8:\"provider\";N;s:6:\"plugin\";s:22:\"system_menu_block:main\";s:8:\"settings\";a:6:{s:2:\"id\";s:22:\"system_menu_block:main\";s:5:\"label\";s:15:\"Main navigation\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}'),('','block.block.ourteam',_binary 'a:12:{s:4:\"uuid\";s:36:\"f20f488a-51d6-4a07-a76b-f8d36a941c2b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:faf60d22-96bd-4cb9-b755-76962ba13b03\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:7:\"ourteam\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:8:\"our_team\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:faf60d22-96bd-4cb9-b755-76962ba13b03\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:faf60d22-96bd-4cb9-b755-76962ba13b03\";s:5:\"label\";s:8:\"Our Team\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.powerbycompany',_binary 'a:13:{s:4:\"uuid\";s:36:\"3a5041d3-b995-4106-b633-b567de5037f9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:1cc39cd6-2ba8-486a-8ee3-ee52fb37c772\";}s:6:\"module\";a:2:{i:0;s:11:\"block_class\";i:1;s:13:\"block_content\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:9:\"pull-left\";}}s:2:\"id\";s:14:\"powerbycompany\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:6:\"footer\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:1cc39cd6-2ba8-486a-8ee3-ee52fb37c772\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:1cc39cd6-2ba8-486a-8ee3-ee52fb37c772\";s:5:\"label\";s:16:\"Power By company\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:0:{}}'),('','block.block.practiceareas',_binary 'a:12:{s:4:\"uuid\";s:36:\"e5488b49-86c8-47fc-8585-c14f5c82b399\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:27c4769c-fa48-4193-8c80-d3167875cca4\";}s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:13:\"practiceareas\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:14:\"practice_areas\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:27c4769c-fa48-4193-8c80-d3167875cca4\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:27c4769c-fa48-4193-8c80-d3167875cca4\";s:5:\"label\";s:14:\"Practice Areas\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:1:{s:12:\"request_path\";a:4:{s:2:\"id\";s:12:\"request_path\";s:5:\"pages\";s:7:\"<front>\";s:6:\"negate\";b:0;s:15:\"context_mapping\";a:0:{}}}}'),('','block.block.seven_breadcrumbs',_binary 'a:13:{s:4:\"uuid\";s:36:\"7d402b08-83ae-4e19-985e-84fd96958d64\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WWu2OQswgCztl9OeXjD1stexIEMZsSgPMYIdC-JHx9c\";}s:2:\"id\";s:17:\"seven_breadcrumbs\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:10:\"breadcrumb\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"21a7dcd0-f294-4dd2-9cce-1d86fd3f3f47\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"YRY68JWkaUiGeZlWMv1nzeIgDm0ZZwXYgpqUpLFzwAY\";}s:2:\"id\";s:13:\"seven_content\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"cd5176e8-5c8d-489a-956a-212e1af9f742\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NU5A_49mwLHfs5xFzMFrZ850w9pgUolxMS9NNF3vv4c\";}s:2:\"id\";s:10:\"seven_help\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:4:\"help\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_local_actions',_binary 'a:13:{s:4:\"uuid\";s:36:\"1761c270-a1e6-47b8-a403-19fd7d2a3764\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"HHryZVJbeKi9WnuBGC8FOhBZmBnk2G1H6KxFuy-rC9A\";}s:2:\"id\";s:19:\"seven_local_actions\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-10;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_login',_binary 'a:13:{s:4:\"uuid\";s:36:\"4f34c925-e599-42df-9c50-153df2d8609e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"IItlF4SKHgxduIysVQdvirDJ_v3HGuAviOkidAOJYRE\";}s:2:\"id\";s:11:\"seven_login\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:10;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"user_login_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"user_login_block\";s:5:\"label\";s:10:\"User login\";s:8:\"provider\";s:4:\"user\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"d799da0e-1a16-4778-bd61-a62887e50e5a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XJqWwLt1LDCnazcEN6QkJmCLjk4R0__-8s0OO9xeNjg\";}s:2:\"id\";s:14:\"seven_messages\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"ab63c563-08ef-4571-88fe-2ff3f51a840f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ZSpc3IoSaLd0PkB02nxjVPBMztIdsTdHek9SiGaqZ_c\";}s:2:\"id\";s:16:\"seven_page_title\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_primary_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"6e4b0270-602b-4a46-ae90-24dfe257b248\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ddy1OsBbWxjwEI8VL1viD4I69qcLHOkul4BxbTqLBTs\";}s:2:\"id\";s:25:\"seven_primary_local_tasks\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:12:\"Primary tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:0;}s:10:\"visibility\";a:0:{}}'),('','block.block.seven_secondary_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"1caa940e-0c1d-409a-8d6b-5391707ce5d1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:5:\"seven\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QeZBeCilQfeET3GeW6ZtJkEiwROADTZktFgKWwPieD4\";}s:2:\"id\";s:27:\"seven_secondary_local_tasks\";s:5:\"theme\";s:5:\"seven\";s:6:\"region\";s:11:\"pre_content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:14:\"Secondary tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:0;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.sitebranding',_binary 'a:12:{s:4:\"uuid\";s:36:\"8f5f2569-87e9-437f-b39f-b9e013558e7e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:2:\"id\";s:12:\"sitebranding\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:-7;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.socialmedialink',_binary 'a:13:{s:4:\"uuid\";s:36:\"7bdc1e2f-1880-4e13-a188-41c30188e4b0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:7:\"content\";a:1:{i:0;s:56:\"block_content:basic:69b28a06-16c3-4192-bdfb-3e8718c35702\";}s:6:\"module\";a:2:{i:0;s:11:\"block_class\";i:1;s:13:\"block_content\";}s:5:\"theme\";a:1:{i:0;s:7:\"justice\";}}s:20:\"third_party_settings\";a:1:{s:11:\"block_class\";a:1:{s:7:\"classes\";s:10:\"pull-right\";}}s:2:\"id\";s:15:\"socialmedialink\";s:5:\"theme\";s:7:\"justice\";s:6:\"region\";s:12:\"social_media\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:50:\"block_content:69b28a06-16c3-4192-bdfb-3e8718c35702\";s:8:\"settings\";a:7:{s:2:\"id\";s:50:\"block_content:69b28a06-16c3-4192-bdfb-3e8718c35702\";s:5:\"label\";s:17:\"Social Media Link\";s:8:\"provider\";s:13:\"block_content\";s:13:\"label_display\";s:1:\"0\";s:6:\"status\";b:1;s:4:\"info\";s:0:\"\";s:9:\"view_mode\";s:4:\"full\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_account_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"866839f6-ef12-414e-95c0-b1a14e6e1578\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:19:\"system.menu.account\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DweBpscQZdG0-fHkSpUzdYucrNH45G_KF7Z82V-oyQM\";}s:2:\"id\";s:28:\"yg_business_one_account_menu\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:25:\"system_menu_block:account\";s:8:\"settings\";a:6:{s:2:\"id\";s:25:\"system_menu_block:account\";s:5:\"label\";s:17:\"User account menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_branding',_binary 'a:13:{s:4:\"uuid\";s:36:\"60e0cb93-e9e2-49ca-bd27-ce460f09429e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NDwadleLD3YVSbDUaakxyYZyINYtkFtOVGShfq4kWy8\";}s:2:\"id\";s:24:\"yg_business_one_branding\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_breadcrumbs',_binary 'a:13:{s:4:\"uuid\";s:36:\"df08bdab-98e6-42ea-aa15-5219d8ec68fe\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oXUb3JZR2WW5VOdw4HrhRicCsq51mCgLfRyvheG68ck\";}s:2:\"id\";s:27:\"yg_business_one_breadcrumbs\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"a59a45fd-998b-4569-8471-35a4a5f60e76\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9EoWV2Lot6FVSr50t4hoKgiz1LIXYWNG-IIPYsWxBqo\";}s:2:\"id\";s:23:\"yg_business_one_content\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_footer',_binary 'a:13:{s:4:\"uuid\";s:36:\"d04001db-c0e9-4e72-a5c8-a83737f60f1a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:18:\"system.menu.footer\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kkISXE1LT2FJEoYnqCrCpeFB-2pmGmMxMklVk7rQcfg\";}s:2:\"id\";s:22:\"yg_business_one_footer\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:24:\"system_menu_block:footer\";s:8:\"settings\";a:6:{s:2:\"id\";s:24:\"system_menu_block:footer\";s:5:\"label\";s:11:\"Footer menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"5b0350ca-0bfa-4665-a3fe-50ce5efa1de0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8I8iACSa0sKO3k3jlvUG1ge52rfcKX7USJAQYnzuBgg\";}s:2:\"id\";s:20:\"yg_business_one_help\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_local_actions',_binary 'a:13:{s:4:\"uuid\";s:36:\"37458a01-44fc-4650-b431-26774c52600b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"13GQpeITIJsp1kyPniXtWZfyFH87vb1xxJCHifL4UeE\";}s:2:\"id\";s:29:\"yg_business_one_local_actions\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-20;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"5c2ee887-f478-4670-b5e6-d81912627ad2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"X9I1OB0W3WlWtrK-CNcg6hNWwa8wficanpH8pYnDZDE\";}s:2:\"id\";s:27:\"yg_business_one_local_tasks\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-40;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:4:\"Tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_main_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"42e969b6-4fc4-4a77-9d5f-8654963b3fa5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rx9IrdDv7Ldc4kpalZAxdhIPZfYIeOMh1N-qKoQZwHo\";}s:2:\"id\";s:25:\"yg_business_one_main_menu\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:12:\"primary_menu\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:22:\"system_menu_block:main\";s:8:\"settings\";a:6:{s:2:\"id\";s:22:\"system_menu_block:main\";s:5:\"label\";s:15:\"Main navigation\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"02ac81a6-599d-4c9b-9f34-ec63727e2c38\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KHQIJ7Vfl25lTjzIc7qIvnuistt-Mw2O0kG4jCofmkI\";}s:2:\"id\";s:24:\"yg_business_one_messages\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"f25f648d-0d40-404c-88f0-71394a3172c6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7rR9chwXvdM2H8OYMAYx9Zj3GGlPMrZp_M3ZA4thYTk\";}s:2:\"id\";s:26:\"yg_business_one_page_title\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-50;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_powered',_binary 'a:13:{s:4:\"uuid\";s:36:\"d02c0494-ee85-475a-8d31-1b0dd18b35a0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jQQUUWN2Uxr5qZtc9zcJKBCxpKY8orN1u2HPqYYRQDI\";}s:2:\"id\";s:23:\"yg_business_one_powered\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:10;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_powered_by_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_powered_by_block\";s:5:\"label\";s:17:\"Powered by Drupal\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_search',_binary 'a:13:{s:4:\"uuid\";s:36:\"8c5a952a-73f7-4d7b-9473-ef6c6f1234e9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"search\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"za-39d5WDUg6XvbyqSnuVYEeq6QM4qKJxW8MnoAha5A\";}s:2:\"id\";s:22:\"yg_business_one_search\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"search_form_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"search_form_block\";s:5:\"label\";s:6:\"Search\";s:8:\"provider\";s:6:\"search\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_business_one_tools',_binary 'a:13:{s:4:\"uuid\";s:36:\"cfef1d77-c2c0-4541-a26d-70486ab9d72d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:17:\"system.menu.tools\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:15:\"yg_business_one\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NeHSoqm4XFqA7_0bDmR429ZZQt3LRbZMNRJTMsFyOfI\";}s:2:\"id\";s:21:\"yg_business_one_tools\";s:5:\"theme\";s:15:\"yg_business_one\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_menu_block:tools\";s:8:\"settings\";a:6:{s:2:\"id\";s:23:\"system_menu_block:tools\";s:5:\"label\";s:5:\"Tools\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:7:\"visible\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_account_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"6304bc02-8b60-4447-8db2-542ba08ba08b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:19:\"system.menu.account\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DweBpscQZdG0-fHkSpUzdYucrNH45G_KF7Z82V-oyQM\";}s:2:\"id\";s:27:\"yg_fitness_gym_account_menu\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:25:\"system_menu_block:account\";s:8:\"settings\";a:6:{s:2:\"id\";s:25:\"system_menu_block:account\";s:5:\"label\";s:17:\"User account menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_branding',_binary 'a:13:{s:4:\"uuid\";s:36:\"9b63e6e4-7456-4a71-96cd-6c872cfa523a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NDwadleLD3YVSbDUaakxyYZyINYtkFtOVGShfq4kWy8\";}s:2:\"id\";s:23:\"yg_fitness_gym_branding\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:6:\"header\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_branding_block\";s:8:\"settings\";a:7:{s:2:\"id\";s:21:\"system_branding_block\";s:5:\"label\";s:13:\"Site branding\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:13:\"use_site_logo\";b:1;s:13:\"use_site_name\";b:1;s:15:\"use_site_slogan\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_breadcrumbs',_binary 'a:13:{s:4:\"uuid\";s:36:\"08291c7c-7b12-4d1d-bafb-786e3fabf054\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oXUb3JZR2WW5VOdw4HrhRicCsq51mCgLfRyvheG68ck\";}s:2:\"id\";s:26:\"yg_fitness_gym_breadcrumbs\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_breadcrumb_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_breadcrumb_block\";s:5:\"label\";s:11:\"Breadcrumbs\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_content',_binary 'a:13:{s:4:\"uuid\";s:36:\"f2cb4a6a-aea0-459f-bc23-ec48f21f6d0c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9EoWV2Lot6FVSr50t4hoKgiz1LIXYWNG-IIPYsWxBqo\";}s:2:\"id\";s:22:\"yg_fitness_gym_content\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"system_main_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"system_main_block\";s:5:\"label\";s:17:\"Main page content\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_footer',_binary 'a:13:{s:4:\"uuid\";s:36:\"9ff7b77b-3379-4dbf-91a7-ac7e15614bac\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:18:\"system.menu.footer\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"kkISXE1LT2FJEoYnqCrCpeFB-2pmGmMxMklVk7rQcfg\";}s:2:\"id\";s:21:\"yg_fitness_gym_footer\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:24:\"system_menu_block:footer\";s:8:\"settings\";a:6:{s:2:\"id\";s:24:\"system_menu_block:footer\";s:5:\"label\";s:11:\"Footer menu\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_help',_binary 'a:13:{s:4:\"uuid\";s:36:\"3591e692-8e02-41c8-ba65-df9d98d0064d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:4:\"help\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8I8iACSa0sKO3k3jlvUG1ge52rfcKX7USJAQYnzuBgg\";}s:2:\"id\";s:19:\"yg_fitness_gym_help\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-30;s:8:\"provider\";N;s:6:\"plugin\";s:10:\"help_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:10:\"help_block\";s:5:\"label\";s:4:\"Help\";s:8:\"provider\";s:4:\"help\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_local_actions',_binary 'a:13:{s:4:\"uuid\";s:36:\"526c6345-17da-4987-850d-72f44812be7d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"13GQpeITIJsp1kyPniXtWZfyFH87vb1xxJCHifL4UeE\";}s:2:\"id\";s:28:\"yg_fitness_gym_local_actions\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-20;s:8:\"provider\";N;s:6:\"plugin\";s:19:\"local_actions_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:19:\"local_actions_block\";s:5:\"label\";s:21:\"Primary admin actions\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_local_tasks',_binary 'a:13:{s:4:\"uuid\";s:36:\"110343ab-d46e-4a81-b733-88b5baa42ab3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"X9I1OB0W3WlWtrK-CNcg6hNWwa8wficanpH8pYnDZDE\";}s:2:\"id\";s:26:\"yg_fitness_gym_local_tasks\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-40;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"local_tasks_block\";s:8:\"settings\";a:6:{s:2:\"id\";s:17:\"local_tasks_block\";s:5:\"label\";s:4:\"Tabs\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";s:7:\"primary\";b:1;s:9:\"secondary\";b:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_main_menu',_binary 'a:13:{s:4:\"uuid\";s:36:\"def1f73c-6e7c-4466-9613-4b388aa0c751\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rx9IrdDv7Ldc4kpalZAxdhIPZfYIeOMh1N-qKoQZwHo\";}s:2:\"id\";s:24:\"yg_fitness_gym_main_menu\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:12:\"primary_menu\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:22:\"system_menu_block:main\";s:8:\"settings\";a:6:{s:2:\"id\";s:22:\"system_menu_block:main\";s:5:\"label\";s:15:\"Main navigation\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";s:5:\"level\";i:1;s:5:\"depth\";i:1;}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_messages',_binary 'a:13:{s:4:\"uuid\";s:36:\"de3ece9c-da2b-4d03-99e8-a056b3600715\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KHQIJ7Vfl25lTjzIc7qIvnuistt-Mw2O0kG4jCofmkI\";}s:2:\"id\";s:23:\"yg_fitness_gym_messages\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:11:\"highlighted\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:21:\"system_messages_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:21:\"system_messages_block\";s:5:\"label\";s:15:\"Status messages\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_page_title',_binary 'a:13:{s:4:\"uuid\";s:36:\"daaa0fb7-1310-4893-bbb7-d49726919226\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7rR9chwXvdM2H8OYMAYx9Zj3GGlPMrZp_M3ZA4thYTk\";}s:2:\"id\";s:25:\"yg_fitness_gym_page_title\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:7:\"content\";s:6:\"weight\";i:-50;s:8:\"provider\";N;s:6:\"plugin\";s:16:\"page_title_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:16:\"page_title_block\";s:5:\"label\";s:10:\"Page title\";s:8:\"provider\";s:4:\"core\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_powered',_binary 'a:13:{s:4:\"uuid\";s:36:\"b512d4ae-7e52-4253-b9f0-1aa0a3067022\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jQQUUWN2Uxr5qZtc9zcJKBCxpKY8orN1u2HPqYYRQDI\";}s:2:\"id\";s:22:\"yg_fitness_gym_powered\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:10:\"navigation\";s:6:\"weight\";i:10;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_powered_by_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:23:\"system_powered_by_block\";s:5:\"label\";s:17:\"Powered by Drupal\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:1:\"0\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_search',_binary 'a:13:{s:4:\"uuid\";s:36:\"85e5339c-c546-44b9-8486-94d54afdd26f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"module\";a:1:{i:0;s:6:\"search\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"za-39d5WDUg6XvbyqSnuVYEeq6QM4qKJxW8MnoAha5A\";}s:2:\"id\";s:21:\"yg_fitness_gym_search\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:-1;s:8:\"provider\";N;s:6:\"plugin\";s:17:\"search_form_block\";s:8:\"settings\";a:4:{s:2:\"id\";s:17:\"search_form_block\";s:5:\"label\";s:6:\"Search\";s:8:\"provider\";s:6:\"search\";s:13:\"label_display\";s:7:\"visible\";}s:10:\"visibility\";a:0:{}}'),('','block.block.yg_fitness_gym_tools',_binary 'a:13:{s:4:\"uuid\";s:36:\"78b2edcf-564c-41e0-bafa-509d3372fee3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:3:{s:6:\"config\";a:1:{i:0;s:17:\"system.menu.tools\";}s:6:\"module\";a:1:{i:0;s:6:\"system\";}s:5:\"theme\";a:1:{i:0;s:14:\"yg_fitness_gym\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NeHSoqm4XFqA7_0bDmR429ZZQt3LRbZMNRJTMsFyOfI\";}s:2:\"id\";s:20:\"yg_fitness_gym_tools\";s:5:\"theme\";s:14:\"yg_fitness_gym\";s:6:\"region\";s:13:\"sidebar_first\";s:6:\"weight\";i:0;s:8:\"provider\";N;s:6:\"plugin\";s:23:\"system_menu_block:tools\";s:8:\"settings\";a:6:{s:2:\"id\";s:23:\"system_menu_block:tools\";s:5:\"label\";s:5:\"Tools\";s:8:\"provider\";s:6:\"system\";s:13:\"label_display\";s:7:\"visible\";s:5:\"level\";i:1;s:5:\"depth\";i:0;}s:10:\"visibility\";a:0:{}}'),('','block_content.type.basic',_binary 'a:9:{s:4:\"uuid\";s:36:\"980a1874-9109-4ca4-8a1a-2615ef7a0ba2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zglzjmYxi0G0ag9MZ02y0LSJOdpWRwJxyP_OvFojFyo\";}s:2:\"id\";s:5:\"basic\";s:5:\"label\";s:11:\"Basic block\";s:8:\"revision\";i:0;s:11:\"description\";s:42:\"A basic block contains a title and a body.\";}'),('','comment.type.comment',_binary 'a:9:{s:4:\"uuid\";s:36:\"05ccd90a-c7b2-45f4-b6cc-cc1136bec740\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"bqZsN31T2n0UjcbyCpOPi9D2iO0sAOHR7FnEs9qMvaA\";}s:2:\"id\";s:7:\"comment\";s:5:\"label\";s:16:\"Default comments\";s:21:\"target_entity_type_id\";s:4:\"node\";s:11:\"description\";s:28:\"Allows commenting on content\";}'),('','comment.type.migrate_example_advanced_comment',_binary 'a:9:{s:4:\"uuid\";s:36:\"1d023fb1-3275-4c7e-aee4-a535f43aa0de\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UVmAi942I-2Z_YDnpwk48PlAQKlKkL3W6wEENgQuqEU\";}s:2:\"id\";s:32:\"migrate_example_advanced_comment\";s:5:\"label\";s:13:\"Node comments\";s:21:\"target_entity_type_id\";s:4:\"node\";s:11:\"description\";s:0:\"\";}'),('','comment.type.node_comments',_binary 'a:9:{s:4:\"uuid\";s:36:\"3ddbde0f-8b00-4ff9-87a0-d999813a1877\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_iidyBpZhk61ekfCNeZlPQe6CTRTRGvu6s0XtxltmQ8\";}s:2:\"id\";s:13:\"node_comments\";s:5:\"label\";s:13:\"Node comments\";s:21:\"target_entity_type_id\";s:4:\"node\";s:11:\"description\";s:0:\"\";}'),('','contact.form.feedback',_binary 'a:12:{s:4:\"uuid\";s:36:\"e9fa7b4d-e502-42d8-ab68-b6aa97c4ef44\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vymHlgJy26BuI5GGj9-IXjwR3dRC5C0tij4BpWJnoqw\";}s:2:\"id\";s:8:\"feedback\";s:5:\"label\";s:16:\"Website feedback\";s:10:\"recipients\";a:1:{i:0;s:15:\"admin@admin.com\";}s:5:\"reply\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"message\";s:27:\"Your message has been sent.\";s:8:\"redirect\";s:0:\"\";}'),('','contact.form.personal',_binary 'a:12:{s:4:\"uuid\";s:36:\"ad8d038d-72e3-4c11-9047-f6e440521081\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jonvgt3CkUM2eMLTFwWfHileWWDC4YtXCuIlCahTk_I\";}s:2:\"id\";s:8:\"personal\";s:5:\"label\";s:21:\"Personal contact form\";s:10:\"recipients\";a:0:{}s:5:\"reply\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"message\";s:27:\"Your message has been sent.\";s:8:\"redirect\";s:0:\"\";}'),('','contact.settings',_binary 'a:4:{s:12:\"default_form\";s:8:\"feedback\";s:5:\"flood\";a:2:{s:5:\"limit\";i:5;s:8:\"interval\";i:3600;}s:20:\"user_default_enabled\";b:1;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U69DBeuvXuNVOC15rVNaBjDPK2fWFbo9v4takdYSSO8\";}}'),('','content_moderation_notifications.content_moderation_notification.export_promotions',_binary 'a:13:{s:4:\"uuid\";s:36:\"266727a7-72fb-44b1-98db-3b99de1caf4a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:2:\"id\";s:17:\"export_promotions\";s:8:\"workflow\";s:9:\"editorial\";s:11:\"transitions\";a:1:{s:16:\"create_new_draft\";s:16:\"create_new_draft\";}s:5:\"roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"author\";b:1;s:6:\"emails\";s:15:\"surya@gmail.com\";s:7:\"subject\";s:19:\"Test approved email\";s:4:\"body\";a:2:{s:5:\"value\";s:47:\"<p>Test approved emailTest approved email</p>\r\n\";s:6:\"format\";s:10:\"basic_html\";}s:5:\"label\";s:17:\"Export Promotions\";}'),('','core.base_field_override.node.page.promote',_binary 'a:17:{s:4:\"uuid\";s:36:\"bc5657f1-35bc-4b89-a06e-1d160e0b66f7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:1:{i:0;s:14:\"node.type.page\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fPUEnm4T5zfZRr3ttDUqq7yCDd2uW3clWD-pvos4tlQ\";}s:2:\"id\";s:17:\"node.page.promote\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:5:\"label\";s:22:\"Promoted to front page\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:8:\"on_label\";s:2:\"On\";s:9:\"off_label\";s:3:\"Off\";}s:10:\"field_type\";s:7:\"boolean\";}'),('','core.date_format.fallback',_binary 'a:9:{s:4:\"uuid\";s:36:\"23bc8670-ecc4-43f7-b186-0c8103f74fe6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7klS5IWXrwzVaPpYZFAs6wcx8U2FF1X73OfrtTsvuvE\";}s:2:\"id\";s:8:\"fallback\";s:5:\"label\";s:20:\"Fallback date format\";s:6:\"locked\";b:1;s:7:\"pattern\";s:14:\"D, m/d/Y - H:i\";}'),('','core.date_format.html_date',_binary 'a:9:{s:4:\"uuid\";s:36:\"0ff8c3bf-bc45-4ed2-ab69-578ad1b8d435\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EOQltUQPmgc6UQ2rcJ4Xi_leCEJj5ui0TR-12duS-Tk\";}s:2:\"id\";s:9:\"html_date\";s:5:\"label\";s:9:\"HTML Date\";s:6:\"locked\";b:1;s:7:\"pattern\";s:5:\"Y-m-d\";}'),('','core.date_format.html_datetime',_binary 'a:9:{s:4:\"uuid\";s:36:\"e3009314-4cf1-46e8-8a2d-ec80f540c18f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jxfClwZIRXIdcvMrE--WkcZxDGUVoOIE3Sm2NRZlFuE\";}s:2:\"id\";s:13:\"html_datetime\";s:5:\"label\";s:13:\"HTML Datetime\";s:6:\"locked\";b:1;s:7:\"pattern\";s:13:\"Y-m-d\\TH:i:sO\";}'),('','core.date_format.html_month',_binary 'a:9:{s:4:\"uuid\";s:36:\"5e019a16-c840-47d6-b110-a79aad65ade7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Z7KuCUwM_WdTNvLcoltuX3_8d-s-8FZkTN6KgNwF0eM\";}s:2:\"id\";s:10:\"html_month\";s:5:\"label\";s:10:\"HTML Month\";s:6:\"locked\";b:1;s:7:\"pattern\";s:3:\"Y-m\";}'),('','core.date_format.html_time',_binary 'a:9:{s:4:\"uuid\";s:36:\"206c5ae9-42d7-4cab-9190-aef48a969d7a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"M7yqicYkU36hRy5p9drAaGBBihhUD1OyujFrAaQ93ZE\";}s:2:\"id\";s:9:\"html_time\";s:5:\"label\";s:9:\"HTML Time\";s:6:\"locked\";b:1;s:7:\"pattern\";s:5:\"H:i:s\";}'),('','core.date_format.html_week',_binary 'a:9:{s:4:\"uuid\";s:36:\"6c19692f-60f1-4b73-9947-a5c69e5d8496\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wKD4WsoV_wFgv2vgI4mcAAFSIzrye17ykzdwrnApkfY\";}s:2:\"id\";s:9:\"html_week\";s:5:\"label\";s:9:\"HTML Week\";s:6:\"locked\";b:1;s:7:\"pattern\";s:5:\"Y-\\WW\";}'),('','core.date_format.html_year',_binary 'a:9:{s:4:\"uuid\";s:36:\"1940c7f5-3522-4e39-8570-78022b9a2360\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OjekiQuX9RbVQ2_8jOHBL94RgYLePqX7wpfNGgcQzrk\";}s:2:\"id\";s:9:\"html_year\";s:5:\"label\";s:9:\"HTML Year\";s:6:\"locked\";b:1;s:7:\"pattern\";s:1:\"Y\";}'),('','core.date_format.html_yearless_date',_binary 'a:9:{s:4:\"uuid\";s:36:\"7f46b867-1992-4322-80ed-fe854dd8aaca\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"5VpawMrKPEPCkoO4YpPa0TDFO2dgiIHfTziJtwlmUxc\";}s:2:\"id\";s:18:\"html_yearless_date\";s:5:\"label\";s:18:\"HTML Yearless date\";s:6:\"locked\";b:1;s:7:\"pattern\";s:3:\"m-d\";}'),('','core.date_format.long',_binary 'a:9:{s:4:\"uuid\";s:36:\"61aaefc2-86ec-4577-b107-6251703e735b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"og8sWXhBuHbLMw3CoiBEZjgqSyhFBFmcbUW_wLcfNbo\";}s:2:\"id\";s:4:\"long\";s:5:\"label\";s:17:\"Default long date\";s:6:\"locked\";b:0;s:7:\"pattern\";s:15:\"l, F j, Y - H:i\";}'),('','core.date_format.medium',_binary 'a:9:{s:4:\"uuid\";s:36:\"ac893bcb-4079-4b27-acd7-1c731b528577\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nzL5d024NjXIX_8TlT6uFAu973lmfkmHklJC-2i9rAE\";}s:2:\"id\";s:6:\"medium\";s:5:\"label\";s:19:\"Default medium date\";s:6:\"locked\";b:0;s:7:\"pattern\";s:14:\"D, m/d/Y - H:i\";}'),('','core.date_format.short',_binary 'a:9:{s:4:\"uuid\";s:36:\"2fce3e37-2751-4c97-b03a-800aa8edd68d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AlzeyytA8InBgxIG9H2UDJYs3CG98Zj6yRsDKmlbZwA\";}s:2:\"id\";s:5:\"short\";s:5:\"label\";s:18:\"Default short date\";s:6:\"locked\";b:0;s:7:\"pattern\";s:11:\"m/d/Y - H:i\";}'),('','core.entity_form_display.block_content.basic.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"99ffeb39-17d5-4ddf-a852-ab5261c53d08\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:36:\"field.field.block_content.basic.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"e1Nu5xXAuF_QplbBUhQBPLnYWvHtDX0MkZnpuCiY8uM\";}s:2:\"id\";s:27:\"block_content.basic.default\";s:16:\"targetEntityType\";s:13:\"block_content\";s:6:\"bundle\";s:5:\"basic\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:-4;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:4:\"info\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.comment.comment.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"580e87b2-b13d-4815-954f-e8e2e7690d2a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:20:\"comment.type.comment\";i:1;s:40:\"field.field.comment.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"I0Pa0aQvT_jawlPo9oz4FE3h_ickc55dYKTPl6gILes\";}s:2:\"id\";s:23:\"comment.comment.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:6:\"author\";a:4:{s:6:\"weight\";i:-2;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"comment_body\";a:5:{s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:11;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:7:\"subject\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:10;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.comment.migrate_example_advanced_comment.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"beeaa2e9-fac4-45f0-9bb0-42505861a53d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:45:\"comment.type.migrate_example_advanced_comment\";i:1;s:65:\"field.field.comment.migrate_example_advanced_comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"93uGcJnlRMq4Ab9V0jkMfEEbZ9uuDj4S-rKsRyzrvrA\";}s:2:\"id\";s:48:\"comment.migrate_example_advanced_comment.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:32:\"migrate_example_advanced_comment\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:6:\"author\";a:4:{s:6:\"weight\";i:-2;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"comment_body\";a:5:{s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:11;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"subject\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:10;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.comment.node_comments.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"2b3176af-d082-48af-b56c-290441ae1417\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"comment.type.node_comments\";i:1;s:46:\"field.field.comment.node_comments.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"xUzw_szm2sUvxozC_NChDqYbQadgcHM0p13H8Q48qmc\";}s:2:\"id\";s:29:\"comment.node_comments.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:13:\"node_comments\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:6:\"author\";a:4:{s:6:\"weight\";i:-2;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"comment_body\";a:5:{s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:11;s:8:\"settings\";a:2:{s:4:\"rows\";i:5;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"subject\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:10;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.node.article.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"574b195d-c94f-44ff-8bd7-388421f48749\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:29:\"field.field.node.article.body\";i:1;s:32:\"field.field.node.article.comment\";i:2;s:36:\"field.field.node.article.field_image\";i:3;s:35:\"field.field.node.article.field_tags\";i:4;s:21:\"image.style.thumbnail\";i:5;s:17:\"node.type.article\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"path\";i:3;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vPb_yvhA-xuNoV_yOmOwYxGuHNRIH1CoMK2qi7BSga0\";}s:2:\"id\";s:20:\"node.article.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:11:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:7:\"comment\";a:5:{s:4:\"type\";s:15:\"comment_default\";s:6:\"weight\";i:20;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_image\";a:5:{s:4:\"type\";s:11:\"image_image\";s:6:\"weight\";i:4;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:20:\"third_party_settings\";a:0:{}}s:10:\"field_tags\";a:5:{s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"weight\";i:3;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:120;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.node.migrate_example_beer.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"01e6626c-7e8a-4c9c-bec0-c8de81ec5a1a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:42:\"field.field.node.migrate_example_beer.body\";i:1;s:52:\"field.field.node.migrate_example_beer.field_comments\";i:2;s:70:\"field.field.node.migrate_example_beer.field_migrate_example_beer_style\";i:3;s:67:\"field.field.node.migrate_example_beer.field_migrate_example_country\";i:4;s:65:\"field.field.node.migrate_example_beer.field_migrate_example_image\";i:5;s:21:\"image.style.thumbnail\";i:6;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"path\";i:3;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"e2RcqaxB9XN-NXEXZBabiDn_yvNwD4JfTWGaWzwTtJQ\";}s:2:\"id\";s:33:\"node.migrate_example_beer.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:12:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:6;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"field_comments\";a:5:{s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_beer_style\";a:5:{s:6:\"weight\";i:7;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"region\";s:7:\"content\";}s:29:\"field_migrate_example_country\";a:5:{s:6:\"weight\";i:8;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:16:\"string_textfield\";s:6:\"region\";s:7:\"content\";}s:27:\"field_migrate_example_image\";a:5:{s:6:\"weight\";i:9;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:11:\"image_image\";s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:3;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:120;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:4;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:1;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.node.migrate_example_producer.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"9b363d87-220b-4008-8f12-9bc1f464da44\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:46:\"field.field.node.migrate_example_producer.body\";i:1;s:74:\"field.field.node.migrate_example_producer.field_migrate_example_wine_regio\";i:2;s:34:\"node.type.migrate_example_producer\";}s:6:\"module\";a:2:{i:0;s:4:\"path\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"85rWPzPKWYL9YqvuPkcoQoDslfluxksLBxMCjDbSHyU\";}s:2:\"id\";s:37:\"node.migrate_example_producer.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:24:\"migrate_example_producer\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:9:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:31;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_wine_regio\";a:5:{s:6:\"weight\";i:32;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:120;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.node.migrate_example_wine.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"ac5ddce0-7240-41c2-9ae9-81ae29242dae\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:10:{i:0;s:42:\"field.field.node.migrate_example_wine.body\";i:1;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_adv_image\";i:2;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_comments\";i:3;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_top_vintag\";i:4;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_wine_best\";i:5;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_ratin\";i:6;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_regio\";i:7;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_wine_var\";i:8;s:21:\"image.style.thumbnail\";i:9;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"path\";i:3;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"N4ElxvmkSmGBOtfBuBnWm7GnJg3u8zheiOQX1JlOFAk\";}s:2:\"id\";s:33:\"node.migrate_example_wine.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:15:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:31;s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:31:\"field_migrate_example_adv_image\";a:5:{s:6:\"weight\";i:35;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:11:\"image_image\";s:6:\"region\";s:7:\"content\";}s:30:\"field_migrate_example_comments\";a:5:{s:6:\"weight\";i:38;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_top_vintag\";a:5:{s:6:\"weight\";i:37;s:8:\"settings\";a:1:{s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"number\";s:6:\"region\";s:7:\"content\";}s:31:\"field_migrate_example_wine_best\";a:5:{s:6:\"weight\";i:34;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:34:\"entity_reference_autocomplete_tags\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_wine_ratin\";a:5:{s:6:\"weight\";i:36;s:8:\"settings\";a:1:{s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"number\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_wine_regio\";a:5:{s:6:\"weight\";i:33;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"region\";s:7:\"content\";}s:30:\"field_migrate_example_wine_var\";a:5:{s:6:\"weight\";i:32;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:120;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.node.page.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"fcbb4b97-9dfe-44ae-bfbf-46840867cfc0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.field.node.page.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:2:{i:0;s:4:\"path\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sb0qCkzU_8mNq29NehYAU8jCBXWPLeX0UN8sYFVGVcw\";}s:2:\"id\";s:17:\"node.page.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:8:{s:4:\"body\";a:5:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:6:\"weight\";i:31;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:4:\"rows\";i:9;s:12:\"summary_rows\";i:3;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:7:\"created\";a:5:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:30;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:7:\"promote\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:6:\"status\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:120;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:6:\"sticky\";a:5:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;s:6:\"region\";s:7:\"content\";s:20:\"third_party_settings\";a:0:{}}s:5:\"title\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}s:3:\"uid\";a:5:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.taxonomy_term.migrate_example_wine_varieties.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"c459d029-ea99-4cc0-8d69-7b060b06ffa4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:81:\"field.field.taxonomy_term.migrate_example_wine_varieties.field_variety_attributes\";i:1;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}s:6:\"module\";a:2:{i:0;s:4:\"path\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"HSSL2UFUgt1a88Yce3b_Hqcbf3pmVIugkwXbsTsgLU4\";}s:2:\"id\";s:52:\"taxonomy_term.migrate_example_wine_varieties.default\";s:16:\"targetEntityType\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:30:\"migrate_example_wine_varieties\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:4:{s:11:\"description\";a:5:{s:4:\"type\";s:13:\"text_textarea\";s:6:\"weight\";i:1;s:8:\"settings\";a:2:{s:11:\"placeholder\";s:0:\"\";s:4:\"rows\";i:5;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:24:\"field_variety_attributes\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:3;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"name\";a:5:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:11:\"placeholder\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:4:\"path\";a:5:{s:4:\"type\";s:4:\"path\";s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_form_display.user.user.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"b28a7e1b-9691-4fb6-9080-c6eb80ce7ca9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:52:\"field.field.user.user.field_migrate_example_favbeers\";i:1;s:50:\"field.field.user.user.field_migrate_example_gender\";i:2;s:34:\"field.field.user.user.user_picture\";i:3;s:21:\"image.style.thumbnail\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"K-1rBM8mTIkFp9RqOC2tMRUukOQ1xbRCfSKK8dEddnA\";}s:2:\"id\";s:17:\"user.user.default\";s:16:\"targetEntityType\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:5:{s:7:\"account\";a:4:{s:6:\"weight\";i:-10;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:7:\"contact\";a:4:{s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:8:\"language\";a:4:{s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:8:\"timezone\";a:4:{s:6:\"weight\";i:6;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"user_picture\";a:5:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:20:\"third_party_settings\";a:0:{}s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:2:{s:30:\"field_migrate_example_favbeers\";b:1;s:28:\"field_migrate_example_gender\";b:1;}}'),('','core.entity_form_mode.user.register',_binary 'a:9:{s:4:\"uuid\";s:36:\"e5b51cad-a868-49bf-938b-0d96e409608d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"flXhTcp55yLcyy7ZLOhPGKGZobZQJdkAFVWV3LseiuI\";}s:2:\"id\";s:13:\"user.register\";s:5:\"label\";s:8:\"Register\";s:16:\"targetEntityType\";s:4:\"user\";s:5:\"cache\";b:1;}'),('','core.entity_view_display.block_content.basic.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"b86e5a48-15b2-4471-9399-fdec9884da15\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:36:\"field.field.block_content.basic.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"orJpHUlAc_wiQLMUjIgEJXGeiqylGHMPcmNRjGtct-M\";}s:2:\"id\";s:27:\"block_content.basic.default\";s:16:\"targetEntityType\";s:13:\"block_content\";s:6:\"bundle\";s:5:\"basic\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:1:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.comment.comment.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"671c47ff-0a18-4b55-b213-e5e68071b6ef\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:20:\"comment.type.comment\";i:1;s:40:\"field.field.comment.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"77Ye1kR-P6AaiGfEO8mnXNSr7nqtnP3PiiVBwJeGGMI\";}s:2:\"id\";s:23:\"comment.comment.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:12:\"comment_body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.comment.migrate_example_advanced_comment.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"847f9e5d-0e9f-4c11-9cfd-c12843f49c49\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:45:\"comment.type.migrate_example_advanced_comment\";i:1;s:65:\"field.field.comment.migrate_example_advanced_comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"LqDo_NRXWedT3_M3btWzMvA50Lzar0lxn1Oq9fj0BdI\";}s:2:\"id\";s:48:\"comment.migrate_example_advanced_comment.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:32:\"migrate_example_advanced_comment\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:12:\"comment_body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.comment.node_comments.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"ac2d80ab-9393-46c2-95fc-ed4b899cdb42\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"comment.type.node_comments\";i:1;s:46:\"field.field.comment.node_comments.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OWEB911eXSBNMCUWQXyfziz_RNErjgkLsnJRumk0n9k\";}s:2:\"id\";s:29:\"comment.node_comments.default\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:13:\"node_comments\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:12:\"comment_body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.node.article.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"f262a8e3-0d0b-4df0-8e3f-c6d686448da2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:48:\"core.entity_view_display.comment.comment.default\";i:1;s:29:\"field.field.node.article.body\";i:2;s:32:\"field.field.node.article.comment\";i:3;s:36:\"field.field.node.article.field_image\";i:4;s:35:\"field.field.node.article.field_tags\";i:5;s:17:\"image.style.large\";i:6;s:17:\"node.type.article\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ChmU3AVqDKU32A_fyChG0W9dTRKmVBR58B6OClCLvZI\";}s:2:\"id\";s:20:\"node.article.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:5:{s:4:\"body\";a:6:{s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";}s:7:\"comment\";a:6:{s:4:\"type\";s:15:\"comment_default\";s:6:\"weight\";i:110;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}}s:11:\"field_image\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";}s:10:\"field_tags\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:10;s:6:\"region\";s:7:\"content\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.node.article.rss',_binary 'a:11:{s:4:\"uuid\";s:36:\"0cb03c52-b691-4b09-ba52-47313d7545de\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:6:{i:0;s:30:\"core.entity_view_mode.node.rss\";i:1;s:29:\"field.field.node.article.body\";i:2;s:32:\"field.field.node.article.comment\";i:3;s:36:\"field.field.node.article.field_image\";i:4;s:35:\"field.field.node.article.field_tags\";i:5;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2rIr6K5Q0UQ9khg0zE_CK-PtJH76UL-BDDZcZnZzwCc\";}s:2:\"id\";s:16:\"node.article.rss\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:3:\"rss\";s:7:\"content\";a:1:{s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:4:{s:4:\"body\";b:1;s:7:\"comment\";b:1;s:11:\"field_image\";b:1;s:10:\"field_tags\";b:1;}}'),('','core.entity_view_display.node.article.teaser',_binary 'a:11:{s:4:\"uuid\";s:36:\"965c2596-b4ba-4bdf-af87-119ff41f636c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:29:\"field.field.node.article.body\";i:2;s:32:\"field.field.node.article.comment\";i:3;s:36:\"field.field.node.article.field_image\";i:4;s:35:\"field.field.node.article.field_tags\";i:5;s:18:\"image.style.medium\";i:6;s:17:\"node.type.article\";}s:6:\"module\";a:3:{i:0;s:5:\"image\";i:1;s:4:\"text\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4NcL2hSQZBpJbYtNuh5jC6kyQTcAc1m5bQpTegEWEso\";}s:2:\"id\";s:19:\"node.article.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:4:{s:4:\"body\";a:6:{s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";}s:11:\"field_image\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:-1;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";}s:10:\"field_tags\";a:6:{s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"weight\";i:10;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:5:\"above\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:3:{s:7:\"comment\";b:1;s:11:\"field_image\";b:1;s:10:\"field_tags\";b:1;}}'),('','core.entity_view_display.node.migrate_example_beer.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"6791e69a-e54b-47a3-8de7-2e038c8ff459\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:54:\"core.entity_view_display.comment.node_comments.default\";i:1;s:42:\"field.field.node.migrate_example_beer.body\";i:2;s:52:\"field.field.node.migrate_example_beer.field_comments\";i:3;s:70:\"field.field.node.migrate_example_beer.field_migrate_example_beer_style\";i:4;s:67:\"field.field.node.migrate_example_beer.field_migrate_example_country\";i:5;s:65:\"field.field.node.migrate_example_beer.field_migrate_example_image\";i:6;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"R6fryUQbasJMRmjWRVb7AZMks4v24VHv4QXng4ZHZHs\";}s:2:\"id\";s:33:\"node.migrate_example_beer.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:6:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:2;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:14:\"field_comments\";a:6:{s:6:\"weight\";i:5;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_beer_style\";a:6:{s:6:\"weight\";i:3;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:29:\"field_migrate_example_country\";a:6:{s:6:\"weight\";i:4;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:6:\"string\";s:6:\"region\";s:7:\"content\";}s:27:\"field_migrate_example_image\";a:6:{s:6:\"weight\";i:1;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:5:\"image\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.node.migrate_example_beer.teaser',_binary 'a:11:{s:4:\"uuid\";s:36:\"44f24e22-3939-4e88-ba2f-30ef7e88decd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:7:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:42:\"field.field.node.migrate_example_beer.body\";i:2;s:52:\"field.field.node.migrate_example_beer.field_comments\";i:3;s:70:\"field.field.node.migrate_example_beer.field_migrate_example_beer_style\";i:4;s:67:\"field.field.node.migrate_example_beer.field_migrate_example_country\";i:5;s:65:\"field.field.node.migrate_example_beer.field_migrate_example_image\";i:6;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"hEXlzklNc5w9sVnnzuYZLZL5v0D6GN0TJ-unO2fYPyo\";}s:2:\"id\";s:32:\"node.migrate_example_beer.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:1;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:4:{s:14:\"field_comments\";b:1;s:32:\"field_migrate_example_beer_style\";b:1;s:29:\"field_migrate_example_country\";b:1;s:27:\"field_migrate_example_image\";b:1;}}'),('','core.entity_view_display.node.migrate_example_producer.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"e0a48cf8-2715-47d7-928d-52ae1990951a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:46:\"field.field.node.migrate_example_producer.body\";i:1;s:74:\"field.field.node.migrate_example_producer.field_migrate_example_wine_regio\";i:2;s:34:\"node.type.migrate_example_producer\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7dhRminbLjRBpTOIyk88jjZgsewWAqqAfjlIcqPDgkU\";}s:2:\"id\";s:37:\"node.migrate_example_producer.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:24:\"migrate_example_producer\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:3:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:101;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_wine_regio\";a:6:{s:6:\"weight\";i:102;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.node.migrate_example_producer.teaser',_binary 'a:11:{s:4:\"uuid\";s:36:\"22b30bc0-e575-49ef-bf77-7f1a552f2f5f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:46:\"field.field.node.migrate_example_producer.body\";i:2;s:74:\"field.field.node.migrate_example_producer.field_migrate_example_wine_regio\";i:3;s:34:\"node.type.migrate_example_producer\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XcPK8-uBDHduWSPYtnW6HMqjno0GqZGGne54JlAfqCc\";}s:2:\"id\";s:36:\"node.migrate_example_producer.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:24:\"migrate_example_producer\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:101;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:1:{s:32:\"field_migrate_example_wine_regio\";b:1;}}'),('','core.entity_view_display.node.migrate_example_wine.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"a5a8fbb9-8e6c-436b-8fed-2a987c16fbd3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:10:{i:0;s:73:\"core.entity_view_display.comment.migrate_example_advanced_comment.default\";i:1;s:42:\"field.field.node.migrate_example_wine.body\";i:2;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_adv_image\";i:3;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_comments\";i:4;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_top_vintag\";i:5;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_wine_best\";i:6;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_ratin\";i:7;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_regio\";i:8;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_wine_var\";i:9;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:4:{i:0;s:7:\"comment\";i:1;s:5:\"image\";i:2;s:4:\"text\";i:3;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"0tOsA4kXFtFXXH51SF-eWaP_5foZldxoThuA_v7iRi0\";}s:2:\"id\";s:33:\"node.migrate_example_wine.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:9:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:101;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:31:\"field_migrate_example_adv_image\";a:6:{s:6:\"weight\";i:105;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:5:\"image\";s:6:\"region\";s:7:\"content\";}s:30:\"field_migrate_example_comments\";a:6:{s:6:\"weight\";i:108;s:5:\"label\";s:6:\"hidden\";s:8:\"settings\";a:1:{s:8:\"pager_id\";i:0;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:15:\"comment_default\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_top_vintag\";a:6:{s:6:\"weight\";i:107;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:2:{s:18:\"thousand_separator\";s:0:\"\";s:13:\"prefix_suffix\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"number_integer\";s:6:\"region\";s:7:\"content\";}s:31:\"field_migrate_example_wine_best\";a:6:{s:6:\"weight\";i:104;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_wine_ratin\";a:6:{s:6:\"weight\";i:106;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:14:\"number_decimal\";s:6:\"region\";s:7:\"content\";}s:32:\"field_migrate_example_wine_regio\";a:6:{s:6:\"weight\";i:103;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:30:\"field_migrate_example_wine_var\";a:6:{s:6:\"weight\";i:102;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:20:\"third_party_settings\";a:0:{}s:4:\"type\";s:22:\"entity_reference_label\";s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.node.migrate_example_wine.teaser',_binary 'a:11:{s:4:\"uuid\";s:36:\"e65f74fc-1e65-464d-9024-141746514c4c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:10:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:42:\"field.field.node.migrate_example_wine.body\";i:2;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_adv_image\";i:3;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_comments\";i:4;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_top_vintag\";i:5;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_wine_best\";i:6;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_ratin\";i:7;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_regio\";i:8;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_wine_var\";i:9;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"5LNkFYLoef3UGYMJ0V3IZxIqCY-Ug8-nf7CcuhtBnLs\";}s:2:\"id\";s:32:\"node.migrate_example_wine.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:101;s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:5:\"links\";a:4:{s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:7:{s:31:\"field_migrate_example_adv_image\";b:1;s:30:\"field_migrate_example_comments\";b:1;s:32:\"field_migrate_example_top_vintag\";b:1;s:31:\"field_migrate_example_wine_best\";b:1;s:32:\"field_migrate_example_wine_ratin\";b:1;s:32:\"field_migrate_example_wine_regio\";b:1;s:30:\"field_migrate_example_wine_var\";b:1;}}'),('','core.entity_view_display.node.page.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"9767e0fb-2d6d-4490-aab1-07f0af7b91a7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.field.node.page.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"g1S3_GLaxq4l3I9RIca5Mlz02MxI2KmOquZpHw59akM\";}s:2:\"id\";s:17:\"node.page.default\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:5:\"links\";a:4:{s:6:\"weight\";i:101;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.node.page.teaser',_binary 'a:11:{s:4:\"uuid\";s:36:\"91f8aa36-6b1d-4fd5-9ad3-edff0391c659\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:33:\"core.entity_view_mode.node.teaser\";i:1;s:26:\"field.field.node.page.body\";i:2;s:14:\"node.type.page\";}s:6:\"module\";a:2:{i:0;s:4:\"text\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cSv5lDnbIgDug475Hdz3woED2XMqYv3awI-J9u1JLbY\";}s:2:\"id\";s:16:\"node.page.teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:4:\"mode\";s:6:\"teaser\";s:7:\"content\";a:2:{s:4:\"body\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";i:100;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:20:\"third_party_settings\";a:0:{}}s:5:\"links\";a:4:{s:6:\"weight\";i:101;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.taxonomy_term.migrate_example_wine_varieties.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"7b6e2d81-8ea9-467c-8497-fc629fc9340c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:81:\"field.field.taxonomy_term.migrate_example_wine_varieties.field_variety_attributes\";i:1;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"aE5r_a1dFCxP95MWmfDqw0Voru15vc7nfX6bvVzEdsw\";}s:2:\"id\";s:52:\"taxonomy_term.migrate_example_wine_varieties.default\";s:16:\"targetEntityType\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:30:\"migrate_example_wine_varieties\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:11:\"description\";a:6:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}s:24:\"field_variety_attributes\";a:6:{s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:5:\"label\";s:6:\"inline\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:20:\"third_party_settings\";a:0:{}s:6:\"region\";s:7:\"content\";}}s:6:\"hidden\";a:0:{}}'),('','core.entity_view_display.user.user.compact',_binary 'a:11:{s:4:\"uuid\";s:36:\"cbbf1c29-06dc-4828-9a0f-5eaa094bc549\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:3:{i:0;s:34:\"core.entity_view_mode.user.compact\";i:1;s:34:\"field.field.user.user.user_picture\";i:2;s:21:\"image.style.thumbnail\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-cLsS3M3JycipXQt9rEb81_HxKneReoGuRh8ijcOPXs\";}s:2:\"id\";s:17:\"user.user.compact\";s:16:\"targetEntityType\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:4:\"mode\";s:7:\"compact\";s:7:\"content\";a:1:{s:12:\"user_picture\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:9:\"thumbnail\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";}}s:6:\"hidden\";a:1:{s:10:\"member_for\";b:1;}}'),('','core.entity_view_display.user.user.default',_binary 'a:11:{s:4:\"uuid\";s:36:\"653f396d-6bd3-4071-bb70-5c4dc57e92b3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:4:{i:0;s:52:\"field.field.user.user.field_migrate_example_favbeers\";i:1;s:50:\"field.field.user.user.field_migrate_example_gender\";i:2;s:34:\"field.field.user.user.user_picture\";i:3;s:21:\"image.style.thumbnail\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"V51QPCKkgNREKtSmB9Iu2wmAMEpktVpnzklWaZV8UYo\";}s:2:\"id\";s:17:\"user.user.default\";s:16:\"targetEntityType\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:4:\"mode\";s:7:\"default\";s:7:\"content\";a:2:{s:10:\"member_for\";a:4:{s:6:\"weight\";i:5;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:0:{}s:20:\"third_party_settings\";a:0:{}}s:12:\"user_picture\";a:6:{s:4:\"type\";s:5:\"image\";s:6:\"weight\";i:0;s:6:\"region\";s:7:\"content\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:9:\"thumbnail\";s:10:\"image_link\";s:7:\"content\";}s:20:\"third_party_settings\";a:0:{}s:5:\"label\";s:6:\"hidden\";}}s:6:\"hidden\";a:2:{s:30:\"field_migrate_example_favbeers\";b:1;s:28:\"field_migrate_example_gender\";b:1;}}'),('','core.entity_view_mode.block_content.full',_binary 'a:9:{s:4:\"uuid\";s:36:\"6a080af7-8f76-4958-aa6a-952bc5788fac\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:13:\"block_content\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4tedlMuvQjDOdvHdw86_e-2Rt78aR7TGFMfOK8Ejppg\";}s:2:\"id\";s:18:\"block_content.full\";s:5:\"label\";s:4:\"Full\";s:16:\"targetEntityType\";s:13:\"block_content\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.comment.full',_binary 'a:9:{s:4:\"uuid\";s:36:\"fa021419-b735-4781-9389-75529fc27a88\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"K7eNlfU7NEUajz01wItywZklr2oaPgL6s1_97fmDXLA\";}s:2:\"id\";s:12:\"comment.full\";s:5:\"label\";s:12:\"Full comment\";s:16:\"targetEntityType\";s:7:\"comment\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.node.full',_binary 'a:9:{s:4:\"uuid\";s:36:\"ab24d59d-b92d-4f50-aa2c-28cd263fb31f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ElrtInxGjZd7GaapJ5O9n-ugi2hG2IxFivtgn0tHOsk\";}s:2:\"id\";s:9:\"node.full\";s:5:\"label\";s:12:\"Full content\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.node.rss',_binary 'a:9:{s:4:\"uuid\";s:36:\"9cd5e564-cbfd-4d39-a7ac-92942256b668\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vlYzr-rp2f9NMp-Qlr4sFjlqRq-90mco5-afLNGwCrU\";}s:2:\"id\";s:8:\"node.rss\";s:5:\"label\";s:3:\"RSS\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.node.search_index',_binary 'a:9:{s:4:\"uuid\";s:36:\"75d02fee-3dde-48fd-95ea-da2157b13104\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fVFfJv_GzBRE-wpRHbfD5a3VjnhbEOXG6lvRd3uaccY\";}s:2:\"id\";s:17:\"node.search_index\";s:5:\"label\";s:12:\"Search index\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.node.search_result',_binary 'a:9:{s:4:\"uuid\";s:36:\"719431ec-c443-4a9e-afd5-23bbd5faaa79\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6GCOQ-jP2RbdbHA5YWQ6bT8CfGbqrBYKOSC_XY4E3ZM\";}s:2:\"id\";s:18:\"node.search_result\";s:5:\"label\";s:32:\"Search result highlighting input\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.node.teaser',_binary 'a:9:{s:4:\"uuid\";s:36:\"2574d84a-638f-47ee-938f-8ca19f3a7335\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Mz9qWr1kUYK0mjRAGDsr5XS6PvtZ24en_7ndt-pyWe4\";}s:2:\"id\";s:11:\"node.teaser\";s:5:\"label\";s:6:\"Teaser\";s:16:\"targetEntityType\";s:4:\"node\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.taxonomy_term.full',_binary 'a:9:{s:4:\"uuid\";s:36:\"09792c66-7c08-4df3-bf42-2d42e2218573\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-PPKjsNQPvoIDjOuUAvlLocYD976MNjb9Zpgyz5_BWE\";}s:2:\"id\";s:18:\"taxonomy_term.full\";s:5:\"label\";s:18:\"Taxonomy term page\";s:16:\"targetEntityType\";s:13:\"taxonomy_term\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.user.compact',_binary 'a:9:{s:4:\"uuid\";s:36:\"5d360bcc-23f0-4010-939a-4ef97cc428bb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"71CSAr_LNPcgu6D6jI4INl1KATkahmeyUFBETAWya8g\";}s:2:\"id\";s:12:\"user.compact\";s:5:\"label\";s:7:\"Compact\";s:16:\"targetEntityType\";s:4:\"user\";s:5:\"cache\";b:1;}'),('','core.entity_view_mode.user.full',_binary 'a:9:{s:4:\"uuid\";s:36:\"12dec011-ce38-4dda-bb96-609268f6b144\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"mQIF_foYjmnVSr9MpcD4CTaJE_FpO1AyDd_DskztGhM\";}s:2:\"id\";s:9:\"user.full\";s:5:\"label\";s:12:\"User account\";s:16:\"targetEntityType\";s:4:\"user\";s:5:\"cache\";b:1;}'),('','core.extension',_binary 'a:4:{s:6:\"module\";a:64:{s:13:\"admin_toolbar\";i:0;s:14:\"automated_cron\";i:0;s:8:\"big_pipe\";i:0;s:5:\"block\";i:0;s:11:\"block_class\";i:0;s:13:\"block_content\";i:0;s:10:\"breakpoint\";i:0;s:8:\"ckeditor\";i:0;s:5:\"color\";i:0;s:7:\"comment\";i:0;s:6:\"config\";i:0;s:7:\"contact\";i:0;s:13:\"contact_block\";i:0;s:18:\"content_moderation\";i:0;s:32:\"content_moderation_notifications\";i:0;s:10:\"contextual\";i:0;s:8:\"datetime\";i:0;s:5:\"dblog\";i:0;s:5:\"devel\";i:0;s:14:\"devel_generate\";i:0;s:18:\"dynamic_page_cache\";i:0;s:6:\"editor\";i:0;s:6:\"entity\";i:0;s:5:\"field\";i:0;s:8:\"field_ui\";i:0;s:4:\"file\";i:0;s:6:\"filter\";i:0;s:10:\"ga_reports\";i:0;s:4:\"help\";i:0;s:7:\"history\";i:0;s:5:\"image\";i:0;s:4:\"kint\";i:0;s:4:\"link\";i:0;s:7:\"menu_ui\";i:0;s:7:\"migrate\";i:0;s:14:\"migrate_drupal\";i:0;s:27:\"migrate_drupal_multilingual\";i:0;s:17:\"migrate_drupal_ui\";i:0;s:12:\"migrate_plus\";i:0;s:13:\"migrate_tools\";i:0;s:15:\"migrate_upgrade\";i:0;s:4:\"node\";i:0;s:7:\"options\";i:0;s:10:\"page_cache\";i:0;s:4:\"path\";i:0;s:9:\"quickedit\";i:0;s:3:\"rdf\";i:0;s:4:\"rest\";i:0;s:6:\"search\";i:0;s:13:\"serialization\";i:0;s:8:\"shortcut\";i:0;s:6:\"system\";i:0;s:8:\"taxonomy\";i:0;s:4:\"text\";i:0;s:7:\"toolbar\";i:0;s:4:\"tour\";i:0;s:6:\"twilio\";i:0;s:6:\"update\";i:0;s:4:\"user\";i:0;s:8:\"views_ui\";i:0;s:9:\"workflows\";i:0;s:17:\"menu_link_content\";i:1;s:5:\"views\";i:10;s:8:\"standard\";i:1000;}s:5:\"theme\";a:8:{s:6:\"stable\";i:0;s:6:\"classy\";i:0;s:6:\"bartik\";i:0;s:5:\"seven\";i:0;s:10:\"credit_due\";i:0;s:15:\"yg_business_one\";i:0;s:14:\"yg_fitness_gym\";i:0;s:7:\"justice\";i:0;}s:7:\"profile\";s:8:\"standard\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"R4IF-ClDHXxblLcG0L7MgsLvfBIMAvi_skumNFQwkDc\";}}'),('','core.menu.static_menu_link_overrides',_binary 'a:2:{s:11:\"definitions\";a:2:{s:18:\"contact__site_page\";a:5:{s:7:\"enabled\";b:1;s:9:\"menu_name\";s:6:\"footer\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:8:\"expanded\";b:0;}s:20:\"standard__front_page\";a:5:{s:6:\"weight\";i:-50;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";s:8:\"expanded\";b:0;s:7:\"enabled\";b:1;}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"jdY7AU0tU-QsjmiOw3W8vwpYMb-By--_MSFgbqKUTYM\";}}'),('','dblog.settings',_binary 'a:2:{s:9:\"row_limit\";i:1000;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"e883aGsrt1wFrsydlYU584PZONCSfRy0DtkZ9KzHb58\";}}'),('','devel.settings',_binary 'a:8:{s:10:\"page_alter\";b:0;s:9:\"raw_names\";b:0;s:14:\"error_handlers\";a:1:{i:1;i:1;}s:13:\"rebuild_theme\";b:0;s:22:\"debug_mail_file_format\";s:31:\"%to-%subject-%datetime.mail.txt\";s:20:\"debug_mail_directory\";s:23:\"temporary://devel-mails\";s:12:\"devel_dumper\";s:7:\"default\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"8SYa5OOpQGdg4wnttb0LFNuG6GmivsS2qNv9sTH9gDI\";}}'),('','devel.toolbar.settings',_binary 'a:2:{s:13:\"toolbar_items\";a:8:{i:0;s:25:\"devel.admin_settings_link\";i:1;s:17:\"devel.cache_clear\";i:2;s:28:\"devel.container_info.service\";i:3;s:17:\"devel.execute_php\";i:4;s:18:\"devel.menu_rebuild\";i:5;s:15:\"devel.reinstall\";i:6;s:16:\"devel.route_info\";i:7;s:14:\"devel.run_cron\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ysHEvvazIuaJ5BdY0dUw2_my_Q5hM8ypdXwFfaIrvMw\";}}'),('','editor.editor.basic_html',_binary 'a:9:{s:4:\"uuid\";s:36:\"17ab1bf8-6584-413d-9437-6269a731114e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:24:\"filter.format.basic_html\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AqlPmO16LvJI4D0Ih6u4GFQIzqr5OnLgAUSjcUGWk2g\";}s:6:\"format\";s:10:\"basic_html\";s:6:\"editor\";s:8:\"ckeditor\";s:8:\"settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:6:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:2:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";}}i:1;a:2:{s:4:\"name\";s:7:\"Linking\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:2:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";}}i:4;a:2:{s:4:\"name\";s:16:\"Block Formatting\";s:5:\"items\";a:1:{i:0;s:6:\"Format\";}}i:5;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:1:{i:0;s:6:\"Source\";}}}}}s:7:\"plugins\";a:1:{s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:12:\"image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";i:0;s:6:\"height\";i:0;}}}'),('','editor.editor.full_html',_binary 'a:9:{s:4:\"uuid\";s:36:\"75dc1307-6e12-4d1f-99a0-c7448b1e712f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"filter.format.full_html\";}s:6:\"module\";a:1:{i:0;s:8:\"ckeditor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"967ijj7p6i7rwrYl7r08WQFeCY_c23YAh0h8u-w_CXM\";}s:6:\"format\";s:9:\"full_html\";s:6:\"editor\";s:8:\"ckeditor\";s:8:\"settings\";a:2:{s:7:\"toolbar\";a:1:{s:4:\"rows\";a:1:{i:0;a:6:{i:0;a:2:{s:4:\"name\";s:10:\"Formatting\";s:5:\"items\";a:7:{i:0;s:4:\"Bold\";i:1;s:6:\"Italic\";i:2;s:6:\"Strike\";i:3;s:11:\"Superscript\";i:4;s:9:\"Subscript\";i:5;s:1:\"-\";i:6;s:12:\"RemoveFormat\";}}i:1;a:2:{s:4:\"name\";s:7:\"Linking\";s:5:\"items\";a:2:{i:0;s:10:\"DrupalLink\";i:1;s:12:\"DrupalUnlink\";}}i:2;a:2:{s:4:\"name\";s:5:\"Lists\";s:5:\"items\";a:2:{i:0;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";}}i:3;a:2:{s:4:\"name\";s:5:\"Media\";s:5:\"items\";a:4:{i:0;s:10:\"Blockquote\";i:1;s:11:\"DrupalImage\";i:2;s:5:\"Table\";i:3;s:14:\"HorizontalRule\";}}i:4;a:2:{s:4:\"name\";s:16:\"Block Formatting\";s:5:\"items\";a:1:{i:0;s:6:\"Format\";}}i:5;a:2:{s:4:\"name\";s:5:\"Tools\";s:5:\"items\";a:2:{i:0;s:10:\"ShowBlocks\";i:1;s:6:\"Source\";}}}}}s:7:\"plugins\";a:2:{s:8:\"language\";a:1:{s:13:\"language_list\";s:2:\"un\";}s:11:\"stylescombo\";a:1:{s:6:\"styles\";s:0:\"\";}}}s:12:\"image_upload\";a:5:{s:6:\"status\";b:1;s:6:\"scheme\";s:6:\"public\";s:9:\"directory\";s:13:\"inline-images\";s:8:\"max_size\";s:0:\"\";s:14:\"max_dimensions\";a:2:{s:5:\"width\";N;s:6:\"height\";N;}}}'),('','field.field.block_content.basic.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"9a2ee506-d13c-486a-8dad-1114bf13ecdd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:24:\"block_content.type.basic\";i:1;s:32:\"field.storage.block_content.body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"R__6wc-rMfFMO8d7jcgqnqiA92j8spKhcc5MiqecrMc\";}s:2:\"id\";s:24:\"block_content.basic.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";s:5:\"basic\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:0;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),('','field.field.comment.comment.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"188c0a73-e905-428e-baa9-63416be401c9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:20:\"comment.type.comment\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TmAKjNrJ7RR60YpqvJq_QqEewYe_S8Kd23n8VRCqiWs\";}s:2:\"id\";s:28:\"comment.comment.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}'),('','field.field.comment.migrate_example_advanced_comment.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"05f4283e-ad3e-49c2-970e-f5ede246bd7d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:45:\"comment.type.migrate_example_advanced_comment\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"5irzyp55d3gwt2chUnKWoOF0EBd3ugEZ4xJQI8pZoo0\";}s:2:\"id\";s:53:\"comment.migrate_example_advanced_comment.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:32:\"migrate_example_advanced_comment\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}'),('','field.field.comment.node_comments.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"3d172ace-741f-4ed1-ae61-060febfffbeb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"comment.type.node_comments\";i:1;s:34:\"field.storage.comment.comment_body\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dWlqg_QGePh1bX60Pg3FuThe4ZKPAqEBBYStmTcBhgc\";}s:2:\"id\";s:34:\"comment.node_comments.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:13:\"node_comments\";s:5:\"label\";s:7:\"Comment\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:9:\"text_long\";}'),('','field.field.node.article.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"25b7e1bf-d194-4422-9906-63492bc85817\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ay3b2hq42cpQTFB_lNu8S2ZxuVIY6-dlBsc7vLeJ-YY\";}s:2:\"id\";s:17:\"node.article.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),('','field.field.node.article.comment',_binary 'a:17:{s:4:\"uuid\";s:36:\"af3a4c23-8dec-4594-bcd8-3168f75a5ed4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:26:\"field.storage.node.comment\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"r-hrxwbKKXBKQnBefGjXNSdU00u2fPvMWEykGRHqd10\";}s:2:\"id\";s:20:\"node.article.comment\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:17:\"last_comment_name\";N;s:22:\"last_comment_timestamp\";i:0;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:13:\"form_location\";b:1;s:9:\"anonymous\";i:0;s:7:\"preview\";i:1;}s:10:\"field_type\";s:7:\"comment\";}'),('','field.field.node.article.field_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"f425d91a-c5fe-4194-a937-bf2c28379389\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"field.storage.node.field_image\";i:1;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tgJzhA7Swh4M_gWU5FwFe5lPxPj5rebpMbvhpdNrERs\";}s:2:\"id\";s:24:\"node.article.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:31:\"[date:custom:Y]-[date:custom:m]\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";b:0;s:18:\"alt_field_required\";b:1;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),('','field.field.node.article.field_tags',_binary 'a:17:{s:4:\"uuid\";s:36:\"ca9cbb33-7c78-4fc9-b85a-51fa25db81c4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:29:\"field.storage.node.field_tags\";i:1;s:17:\"node.type.article\";i:2;s:24:\"taxonomy.vocabulary.tags\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"QdUgf_beeoaPiyKorFv0q1fcJpWH_uZTqe_xoVJacrw\";}s:2:\"id\";s:23:\"node.article.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:84:\"Enter a comma-separated list. For example: Amsterdam, Mexico City, \"Cleveland, Ohio\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:1;}}s:10:\"field_type\";s:16:\"entity_reference\";}'),('','field.field.node.migrate_example_beer.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"629b21a2-39a2-44ff-b256-9cccb759ad23\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"0wEsWyeweie_9qpPaMIbZ4_vzPZfrFx1RuOVFpIYhCg\";}s:2:\"id\";s:30:\"node.migrate_example_beer.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),('','field.field.node.migrate_example_beer.field_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"383e99f5-f45a-4dff-9687-935f48052827\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:33:\"field.storage.node.field_comments\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"oQu63YXAvXvSWvIwwACbcmXsta4CGVhjJ9c61AEvbUg\";}s:2:\"id\";s:40:\"node.migrate_example_beer.field_comments\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:1;}s:10:\"field_type\";s:7:\"comment\";}'),('','field.field.node.migrate_example_beer.field_migrate_example_beer_style',_binary 'a:17:{s:4:\"uuid\";s:36:\"3f50dbe5-8e5a-447a-88b9-b9d4597d8ce3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_beer_style\";i:1;s:30:\"node.type.migrate_example_beer\";i:2;s:47:\"taxonomy.vocabulary.migrate_example_beer_styles\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ux7VJdLoguhU4M-c5krgHOWQ-EUzEFKAWXk_8d68S14\";}s:2:\"id\";s:58:\"node.migrate_example_beer.field_migrate_example_beer_style\";s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:27:\"Migrate Example Beer Styles\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:27:\"migrate_example_beer_styles\";s:27:\"migrate_example_beer_styles\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}'),('','field.field.node.migrate_example_beer.field_migrate_example_country',_binary 'a:17:{s:4:\"uuid\";s:36:\"197b7775-2b8b-4f16-a866-8fafdcc6502a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:48:\"field.storage.node.field_migrate_example_country\";i:1;s:30:\"node.type.migrate_example_beer\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"267WOazRYNp4VIbrd7mXDTFpKn2y10nXzvCOETAlCOA\";}s:2:\"id\";s:55:\"node.migrate_example_beer.field_migrate_example_country\";s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:9:\"Countries\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),('','field.field.node.migrate_example_beer.field_migrate_example_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"15c1e1cd-290a-46b5-a3b5-ff79effd05eb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:46:\"field.storage.node.field_migrate_example_image\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rTTSbnynVpKFdSUronbULx6m23C0t_BNxQgSinwvpnM\";}s:2:\"id\";s:53:\"node.migrate_example_beer.field_migrate_example_image\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_beer\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:0:\"\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:0;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),('','field.field.node.migrate_example_producer.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"e98961e2-0cec-4ea5-bd07-287701755573\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:34:\"node.type.migrate_example_producer\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"JgX7dNn2ZZjdq1XeVaoasaaWggHCSTw1B5UEy_B-_XU\";}s:2:\"id\";s:34:\"node.migrate_example_producer.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:24:\"migrate_example_producer\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),('','field.field.node.migrate_example_producer.field_migrate_example_wine_regio',_binary 'a:17:{s:4:\"uuid\";s:36:\"98571a36-53c2-4ad0-8fef-d503496cf7f4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_regio\";i:1;s:34:\"node.type.migrate_example_producer\";i:2;s:48:\"taxonomy.vocabulary.migrate_example_wine_regions\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4jQmcEs7K8dHbvrVrKuz76I2J4UJ2UpUNVt0O7kwnhg\";}s:2:\"id\";s:62:\"node.migrate_example_producer.field_migrate_example_wine_regio\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:24:\"migrate_example_producer\";s:5:\"label\";s:28:\"Migrate Example Wine Regions\";s:11:\"description\";s:38:\"Select the region this wine comes from\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}'),('','field.field.node.migrate_example_wine.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"02b0fbcd-2986-44f7-927d-3e62bdd90c62\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"vq3DCSKc6pTaZwP7vJB6S75vq2zwxDXxHAG2a82526U\";}s:2:\"id\";s:30:\"node.migrate_example_wine.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),('','field.field.node.migrate_example_wine.field_migrate_example_adv_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"fea3b469-b569-4529-9189-47b66ece7ed2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:50:\"field.storage.node.field_migrate_example_adv_image\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:5:\"image\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dde5g37whYUHPGt2O6lHpPCd4oKV-jKmJChum1XXHSI\";}s:2:\"id\";s:57:\"node.migrate_example_wine.field_migrate_example_adv_image\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:37:\"Upload an image to go with this wine.\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:14:\"file_directory\";s:27:\"field/migrate_example/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:18:\"alt_field_required\";b:0;s:11:\"title_field\";b:0;s:20:\"title_field_required\";b:0;s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),('','field.field.node.migrate_example_wine.field_migrate_example_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"eece7e20-cd5d-4e4c-b4f7-8aea79d5d9f0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:49:\"field.storage.node.field_migrate_example_comments\";i:1;s:30:\"node.type.migrate_example_wine\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Ljjlc3_-z66T0-LFF2z53sK90atzoirmJ9SPNlhcYzc\";}s:2:\"id\";s:56:\"node.migrate_example_wine.field_migrate_example_comments\";s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:8:\"Comments\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:1:{i:0;a:6:{s:6:\"status\";i:2;s:3:\"cid\";i:0;s:22:\"last_comment_timestamp\";i:0;s:17:\"last_comment_name\";N;s:16:\"last_comment_uid\";i:0;s:13:\"comment_count\";i:0;}}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:5:{s:12:\"default_mode\";i:1;s:8:\"per_page\";i:50;s:9:\"anonymous\";i:0;s:13:\"form_location\";b:1;s:7:\"preview\";i:1;}s:10:\"field_type\";s:7:\"comment\";}'),('','field.field.node.migrate_example_wine.field_migrate_example_top_vintag',_binary 'a:17:{s:4:\"uuid\";s:36:\"c3fa4924-0661-4d6f-a4cb-3d49e11080e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:51:\"field.storage.node.field_migrate_example_top_vintag\";i:1;s:30:\"node.type.migrate_example_wine\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"x1l7jyHt74QqCON-PMg05LruTMlDLgfoOkN8A1YU6gY\";}s:2:\"id\";s:58:\"node.migrate_example_wine.field_migrate_example_top_vintag\";s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:20:\"Recommended vintages\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:4:{s:3:\"min\";N;s:3:\"max\";N;s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"field_type\";s:7:\"integer\";}'),('','field.field.node.migrate_example_wine.field_migrate_example_wine_best',_binary 'a:17:{s:4:\"uuid\";s:36:\"b7f2771d-df62-4c67-b7c1-2179ae6e3cb7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:50:\"field.storage.node.field_migrate_example_wine_best\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:50:\"taxonomy.vocabulary.migrate_example_wine_best_with\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"XhPNldNk37gxWD2j9pgrLapzt781hNew8V8YLBsZme4\";}s:2:\"id\";s:57:\"node.migrate_example_wine.field_migrate_example_wine_best\";s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:30:\"Migrate Example Wine Best With\";s:11:\"description\";s:65:\"Enter any foods this wine may be paired with, separated by commas\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_best_with\";s:30:\"migrate_example_wine_best_with\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}'),('','field.field.node.migrate_example_wine.field_migrate_example_wine_ratin',_binary 'a:17:{s:4:\"uuid\";s:36:\"1ee670bc-250c-42be-aa39-8ed00eba65d5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_ratin\";i:1;s:30:\"node.type.migrate_example_wine\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"f_RIakTCpup3t5_tfuPwr3Il2wvYTXciVBN_LRcg14U\";}s:2:\"id\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_ratin\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:6:\"Rating\";s:11:\"description\";s:23:\"Rating on a 1-100 scale\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:4:{s:3:\"min\";d:1;s:3:\"max\";d:100;s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"field_type\";s:7:\"decimal\";}'),('','field.field.node.migrate_example_wine.field_migrate_example_wine_regio',_binary 'a:17:{s:4:\"uuid\";s:36:\"7b85b545-1e00-4ff2-bf16-546d82c42d96\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_regio\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:48:\"taxonomy.vocabulary.migrate_example_wine_regions\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SY0L1xid1zVRqtdbHoMATu_eJDGsXBoULcxzmqWuFXY\";}s:2:\"id\";s:58:\"node.migrate_example_wine.field_migrate_example_wine_regio\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:28:\"Migrate Example Wine Regions\";s:11:\"description\";s:38:\"Select the region this wine comes from\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:28:\"migrate_example_wine_regions\";s:28:\"migrate_example_wine_regions\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}'),('','field.field.node.migrate_example_wine.field_migrate_example_wine_var',_binary 'a:17:{s:4:\"uuid\";s:36:\"a73f752d-1642-45ea-a85c-8ab426c8ddad\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:3:{i:0;s:49:\"field.storage.node.field_migrate_example_wine_var\";i:1;s:30:\"node.type.migrate_example_wine\";i:2;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wUq7WvEbY6a-6yW8OZULmZfSj7OwD1qMpKiS3upiOtI\";}s:2:\"id\";s:56:\"node.migrate_example_wine.field_migrate_example_wine_var\";s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:20:\"migrate_example_wine\";s:5:\"label\";s:30:\"Migrate Example Wine Varieties\";s:11:\"description\";s:31:\"Select the variety of this wine\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:21:\"default:taxonomy_term\";s:16:\"handler_settings\";a:3:{s:14:\"target_bundles\";a:1:{s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:0;}}s:10:\"field_type\";s:16:\"entity_reference\";}'),('','field.field.node.page.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"b8cf44dd-b10b-40db-9324-26854c19e8de\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:23:\"field.storage.node.body\";i:1;s:14:\"node.type.page\";}s:6:\"module\";a:1:{i:0;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rUop-8b6hvxxDYbv-KobTfNIBNbPY9qOPl8f6kBNSpw\";}s:2:\"id\";s:14:\"node.page.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:5:\"label\";s:4:\"Body\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:1:{s:15:\"display_summary\";b:1;}s:10:\"field_type\";s:17:\"text_with_summary\";}'),('','field.field.taxonomy_term.migrate_example_wine_varieties.field_variety_attributes',_binary 'a:17:{s:4:\"uuid\";s:36:\"038fa040-ae08-4314-b74b-60f3e45a5f47\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"config\";a:2:{i:0;s:52:\"field.storage.taxonomy_term.field_variety_attributes\";i:1;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6rU_9CZGIOdWqzPHF8GH37JaWcUoQYymrdTuTlUD8r0\";}s:2:\"id\";s:69:\"taxonomy_term.migrate_example_wine_varieties.field_variety_attributes\";s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:30:\"migrate_example_wine_varieties\";s:5:\"label\";s:10:\"Attributes\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),('','field.field.user.user.field_migrate_example_favbeers',_binary 'a:17:{s:4:\"uuid\";s:36:\"c06b3c71-8b56-4b1a-b937-f7022336734e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:49:\"field.storage.user.field_migrate_example_favbeers\";i:1;s:30:\"node.type.migrate_example_beer\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"pIDsWln9Pgayq3gsbJPTHTNoEWaq1fFTerjS_EKtFtg\";}s:2:\"id\";s:40:\"user.user.field_migrate_example_favbeers\";s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:14:\"Favorite Beers\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:2:{s:7:\"handler\";s:12:\"default:node\";s:16:\"handler_settings\";a:2:{s:14:\"target_bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}s:4:\"sort\";a:2:{s:5:\"field\";s:5:\"title\";s:9:\"direction\";s:3:\"ASC\";}}}s:10:\"field_type\";s:16:\"entity_reference\";}'),('','field.field.user.user.field_migrate_example_gender',_binary 'a:17:{s:4:\"uuid\";s:36:\"b3f24804-97d4-4400-9102-e06b37d5f75f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:47:\"field.storage.user.field_migrate_example_gender\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-13X2hbfPYQnoVLm2sC5J6tVgYycYRTicNxDqunahwU\";}s:2:\"id\";s:38:\"user.user.field_migrate_example_gender\";s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:6:\"Gender\";s:11:\"description\";s:0:\"\";s:8:\"required\";b:0;s:12:\"translatable\";b:0;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:0:{}s:10:\"field_type\";s:6:\"string\";}'),('','field.field.user.user.user_picture',_binary 'a:17:{s:4:\"uuid\";s:36:\"15a8ada2-7804-4a52-b07f-ddb0442179ea\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:31:\"field.storage.user.user_picture\";}s:6:\"module\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Iiq0AttdhgbebJwabSFwQQ1ORn64GoGz0xSZ_eyCJ8A\";}s:2:\"id\";s:22:\"user.user.user_picture\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"label\";s:7:\"Picture\";s:11:\"description\";s:29:\"Your virtual face or picture.\";s:8:\"required\";b:0;s:12:\"translatable\";b:1;s:13:\"default_value\";a:0:{}s:22:\"default_value_callback\";s:0:\"\";s:8:\"settings\";a:12:{s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:14:\"file_directory\";s:40:\"pictures/[date:custom:Y]-[date:custom:m]\";s:12:\"max_filesize\";s:0:\"\";s:9:\"alt_field\";b:0;s:11:\"title_field\";b:0;s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:18:\"alt_field_required\";b:0;s:20:\"title_field_required\";b:0;s:7:\"handler\";s:12:\"default:file\";s:16:\"handler_settings\";a:0:{}}s:10:\"field_type\";s:5:\"image\";}'),('','field.settings',_binary 'a:2:{s:16:\"purge_batch_size\";i:50;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nJk0TAQBzlNo52ehiHI7bIEPLGi0BYqZvPdEn7Chfu0\";}}'),('','field.storage.block_content.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"d224118f-844d-4d9b-8fc5-afa0888f4af1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eS0snV_L3dx9shtWRTzm5eblwOJ7qKWC9IE-4GMTDFc\";}s:2:\"id\";s:18:\"block_content.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:13:\"block_content\";s:4:\"type\";s:17:\"text_with_summary\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}'),('','field.storage.comment.comment_body',_binary 'a:17:{s:4:\"uuid\";s:36:\"ca2a0686-6c75-4895-bb9e-670fa7ef511f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"swYoCch_hY8QO5uwr4FURplfnUCUlpPB4idF8WGVCpw\";}s:2:\"id\";s:20:\"comment.comment_body\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:4:\"type\";s:9:\"text_long\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.body',_binary 'a:17:{s:4:\"uuid\";s:36:\"4bd18d5b-1b54-4d93-8809-1f2a2cfbcc80\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EBUo7qOWqaiZaQ_RC9sLY5IoDKphS34v77VIHSACmVY\";}s:2:\"id\";s:9:\"node.body\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:17:\"text_with_summary\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.comment',_binary 'a:17:{s:4:\"uuid\";s:36:\"ccf999c7-4756-4fb3-b254-edec33730b53\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ktCna9xmWvYZIUfOCUyDQvedn5RtnS4CRmEIwNmvYjc\";}s:2:\"id\";s:12:\"node.comment\";s:10:\"field_name\";s:7:\"comment\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"cb6e812d-2115-4faf-98d1-e6a4706413c9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-Fbi4WKTGUpcyPzZFp_Ioroz-Xni60AHP3Rt0VaNYzs\";}s:2:\"id\";s:19:\"node.field_comments\";s:10:\"field_name\";s:14:\"field_comments\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:13:\"node_comments\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"eb5224c0-e6c7-49cf-82b6-229f46ef800b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SkXIPKZYiIMMtnBmfnxk58RYfbZ8cHSw5NZPY_JByME\";}s:2:\"id\";s:16:\"node.field_image\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_adv_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"64472a0e-1641-463b-8103-ec2ed8f6c5e3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RwVJ29uGaznr4EjFpnLkdADJBx7DLYwfcu7ti4bVe-c\";}s:2:\"id\";s:36:\"node.field_migrate_example_adv_image\";s:10:\"field_name\";s:31:\"field_migrate_example_adv_image\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_beer_style',_binary 'a:17:{s:4:\"uuid\";s:36:\"11b2a4ff-4513-4663-938d-060cda2689e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OydFp62jbcZgS1dcDCNzxvhJjx-UDf-ng1or4wTY7-w\";}s:2:\"id\";s:37:\"node.field_migrate_example_beer_style\";s:10:\"field_name\";s:32:\"field_migrate_example_beer_style\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_comments',_binary 'a:17:{s:4:\"uuid\";s:36:\"5ec526fb-c67f-4c40-80df-1e2b92438662\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GcdoHWF-KMjeae1Roq8JEh7Xr3Onq8_oZAP3B1sRuhA\";}s:2:\"id\";s:35:\"node.field_migrate_example_comments\";s:10:\"field_name\";s:30:\"field_migrate_example_comments\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"comment\";s:8:\"settings\";a:1:{s:12:\"comment_type\";s:32:\"migrate_example_advanced_comment\";}s:6:\"module\";s:7:\"comment\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_country',_binary 'a:17:{s:4:\"uuid\";s:36:\"174d947b-0f2d-4bbc-97a0-ed966f6519d4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uBaHGWI3rO-tpQurs304h90LTJoBpjWI2JHNhbMY1TM\";}s:2:\"id\";s:34:\"node.field_migrate_example_country\";s:10:\"field_name\";s:29:\"field_migrate_example_country\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_image',_binary 'a:17:{s:4:\"uuid\";s:36:\"d57d2d8a-c9f4-4b45-9c8e-f544aa2f818e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"3SSh1H4dQsPZoZV-d3sjeQK7GPJfi-mo6sgECfiOtn8\";}s:2:\"id\";s:32:\"node.field_migrate_example_image\";s:10:\"field_name\";s:27:\"field_migrate_example_image\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_top_vintag',_binary 'a:17:{s:4:\"uuid\";s:36:\"2245f192-9a68-4931-b960-80ddce78214d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sE33za4WgJVU7T_nG_PZp5CVmEBALuzB_Vn-tfw-q8s\";}s:2:\"id\";s:37:\"node.field_migrate_example_top_vintag\";s:10:\"field_name\";s:32:\"field_migrate_example_top_vintag\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"integer\";s:8:\"settings\";a:2:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_wine_best',_binary 'a:17:{s:4:\"uuid\";s:36:\"34bb10e9-a28d-459d-9cfe-ce04b8a54387\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9YbUjnyyl-8owZ1KCETbExQGZu4aog3n7l3PHy0dSds\";}s:2:\"id\";s:36:\"node.field_migrate_example_wine_best\";s:10:\"field_name\";s:31:\"field_migrate_example_wine_best\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_wine_ratin',_binary 'a:17:{s:4:\"uuid\";s:36:\"9db1bcab-f817-4886-a5b5-34d700f8848f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_kyPHNTTC5ibCxEq_nKImDTCSdOLFBhkXjobmMN4zJ4\";}s:2:\"id\";s:37:\"node.field_migrate_example_wine_ratin\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_ratin\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:7:\"decimal\";s:8:\"settings\";a:2:{s:9:\"precision\";i:10;s:5:\"scale\";i:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_wine_regio',_binary 'a:17:{s:4:\"uuid\";s:36:\"89bb858a-3fa0-40a3-b7e5-29a286ecbe05\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AJoyPVhHsJ7K3A9G3Ztn6dKHZBZ5ao3c7SdEK2rH3dM\";}s:2:\"id\";s:37:\"node.field_migrate_example_wine_regio\";s:10:\"field_name\";s:32:\"field_migrate_example_wine_regio\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_migrate_example_wine_var',_binary 'a:17:{s:4:\"uuid\";s:36:\"e627ec31-c833-465f-ba31-28b765ab8f37\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TcM1vLCiI-U8EN4bH2-tWOgR-HU8fDhHf3oMVGzrA-8\";}s:2:\"id\";s:35:\"node.field_migrate_example_wine_var\";s:10:\"field_name\";s:30:\"field_migrate_example_wine_var\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.node.field_tags',_binary 'a:17:{s:4:\"uuid\";s:36:\"73418115-95a0-4170-9dd7-284673acd7d2\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WpOE_bs8Bs_HY2ns7n2r__de-xno0-Bxkqep5-MsHAs\";}s:2:\"id\";s:15:\"node.field_tags\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.taxonomy_term.field_variety_attributes',_binary 'a:17:{s:4:\"uuid\";s:36:\"50da2584-5c3b-41ad-87cb-032fa5039401\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sfP27J9-TcVbjBJviBOAkXgwSpQe1DoGxCc5Ysz_8rc\";}s:2:\"id\";s:38:\"taxonomy_term.field_variety_attributes\";s:10:\"field_name\";s:24:\"field_variety_attributes\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.user.field_migrate_example_favbeers',_binary 'a:17:{s:4:\"uuid\";s:36:\"4d9219b4-339a-4759-aaf2-9dcd7a27fb11\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tKsR0YH5ckB1vHHdiiA7gYHhFVOvdwIS6N3-NvAxwqM\";}s:2:\"id\";s:35:\"user.field_migrate_example_favbeers\";s:10:\"field_name\";s:30:\"field_migrate_example_favbeers\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:16:\"entity_reference\";s:8:\"settings\";a:1:{s:11:\"target_type\";s:4:\"node\";}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:-1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.user.field_migrate_example_gender',_binary 'a:17:{s:4:\"uuid\";s:36:\"3a033163-ac33-47ae-9186-2aecf22e5a8a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-qbjvRZ4YV6YRW3_WOy0fiV1K4bHVBlJNA4AC2E9Z8I\";}s:2:\"id\";s:33:\"user.field_migrate_example_gender\";s:10:\"field_name\";s:28:\"field_migrate_example_gender\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:6:\"module\";s:4:\"core\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:0:{}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field.storage.user.user_picture',_binary 'a:17:{s:4:\"uuid\";s:36:\"7fa5154f-d1e9-4c85-a43d-2cedc39808c0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6k-VBFilDLuzgSOT-77CFgHFlcd5D-kqRixtH89EShU\";}s:2:\"id\";s:17:\"user.user_picture\";s:10:\"field_name\";s:12:\"user_picture\";s:11:\"entity_type\";s:4:\"user\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:6:\"module\";s:5:\"image\";s:6:\"locked\";b:0;s:11:\"cardinality\";i:1;s:12:\"translatable\";b:1;s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:22:\"persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;}'),('','field_ui.settings',_binary 'a:2:{s:12:\"field_prefix\";s:6:\"field_\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Q1nMi90W6YQxKzZAgJQw7Ag9U4JrsEUwkomF0lhvbIM\";}}'),('','file.settings',_binary 'a:4:{s:11:\"description\";a:2:{s:4:\"type\";s:9:\"textfield\";s:6:\"length\";i:128;}s:4:\"icon\";a:1:{s:9:\"directory\";s:23:\"core/modules/file/icons\";}s:35:\"make_unused_managed_files_temporary\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"0aMkoXYnax5_tHI9C9zHs-K48KJ6K75PHtD9x-0nbgM\";}}'),('','filter.format.basic_html',_binary 'a:9:{s:4:\"uuid\";s:36:\"16b41f45-b3df-43de-b81a-58bc067ae0e6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:6:\"editor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"P8ddpAIKtawJDi5SzOwCzVnnNYqONewSTJ6Xn0dW_aQ\";}s:4:\"name\";s:10:\"Basic HTML\";s:6:\"format\";s:10:\"basic_html\";s:6:\"weight\";i:0;s:7:\"filters\";a:5:{s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:250:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <p> <br> <span> <img src alt height width data-entity-type data-entity-uuid data-align data-caption>\";s:16:\"filter_html_help\";b:0;s:20:\"filter_html_nofollow\";b:0;}}s:12:\"filter_align\";a:5:{s:2:\"id\";s:12:\"filter_align\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:7;s:8:\"settings\";a:0:{}}s:14:\"filter_caption\";a:5:{s:2:\"id\";s:14:\"filter_caption\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:8;s:8:\"settings\";a:0:{}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:9;s:8:\"settings\";a:0:{}}s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:11;s:8:\"settings\";a:0:{}}}}'),('','filter.format.full_html',_binary 'a:9:{s:4:\"uuid\";s:36:\"c614a838-4cb0-42cf-b62e-9c4e4380a7ce\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:6:\"editor\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"hewPmBgni9jlDK_IjLxUx1HsTbinK-hdl0lOwjbteIY\";}s:4:\"name\";s:9:\"Full HTML\";s:6:\"format\";s:9:\"full_html\";s:6:\"weight\";i:1;s:7:\"filters\";a:9:{s:12:\"filter_align\";a:5:{s:2:\"id\";s:12:\"filter_align\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-50;s:8:\"settings\";a:0:{}}s:14:\"filter_caption\";a:5:{s:2:\"id\";s:14:\"filter_caption\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-49;s:8:\"settings\";a:0:{}}s:20:\"filter_htmlcorrector\";a:5:{s:2:\"id\";s:20:\"filter_htmlcorrector\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-48;s:8:\"settings\";a:0:{}}s:21:\"editor_file_reference\";a:5:{s:2:\"id\";s:21:\"editor_file_reference\";s:8:\"provider\";s:6:\"editor\";s:6:\"status\";b:1;s:6:\"weight\";i:-47;s:8:\"settings\";a:0:{}}s:18:\"filter_html_escape\";a:5:{s:2:\"id\";s:18:\"filter_html_escape\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-45;s:8:\"settings\";a:0:{}}s:12:\"filter_autop\";a:5:{s:2:\"id\";s:12:\"filter_autop\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-44;s:8:\"settings\";a:0:{}}s:24:\"filter_html_image_secure\";a:5:{s:2:\"id\";s:24:\"filter_html_image_secure\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-42;s:8:\"settings\";a:0:{}}s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-46;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:322:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id> <s> <sup> <sub> <img src alt data-entity-type data-entity-uuid data-align data-caption> <table> <caption> <tbody> <thead> <tfoot> <th> <td> <tr> <hr> <p> <h1> <pre><i><div>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:1;}}s:10:\"filter_url\";a:5:{s:2:\"id\";s:10:\"filter_url\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:0;s:6:\"weight\";i:-43;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}}}}'),('','filter.format.plain_text',_binary 'a:9:{s:4:\"uuid\";s:36:\"0403a3a3-3497-4742-a34e-f6a8da2ad328\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"NIKBt6kw_uPhNI0qtR2DnRf7mSOgAQdx7Q94SKMjXbQ\";}s:4:\"name\";s:10:\"Plain text\";s:6:\"format\";s:10:\"plain_text\";s:6:\"weight\";i:10;s:7:\"filters\";a:3:{s:18:\"filter_html_escape\";a:5:{s:2:\"id\";s:18:\"filter_html_escape\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-10;s:8:\"settings\";a:0:{}}s:10:\"filter_url\";a:5:{s:2:\"id\";s:10:\"filter_url\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}}s:12:\"filter_autop\";a:5:{s:2:\"id\";s:12:\"filter_autop\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}}}'),('','filter.format.restricted_html',_binary 'a:9:{s:4:\"uuid\";s:36:\"e7bc7f5d-5be5-4a00-bd41-6d29c590524b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KUjJ8Ti_ZJSlhGM88E_mhJP-8mmQRNUB6RFof615Kt0\";}s:4:\"name\";s:15:\"Restricted HTML\";s:6:\"format\";s:15:\"restricted_html\";s:6:\"weight\";i:0;s:7:\"filters\";a:3:{s:11:\"filter_html\";a:5:{s:2:\"id\";s:11:\"filter_html\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:-10;s:8:\"settings\";a:3:{s:12:\"allowed_html\";s:149:\"<a href hreflang> <em> <strong> <cite> <blockquote cite> <code> <ul type> <ol start type> <li> <dl> <dt> <dd> <h2 id> <h3 id> <h4 id> <h5 id> <h6 id>\";s:16:\"filter_html_help\";b:1;s:20:\"filter_html_nofollow\";b:0;}}s:12:\"filter_autop\";a:5:{s:2:\"id\";s:12:\"filter_autop\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}}s:10:\"filter_url\";a:5:{s:2:\"id\";s:10:\"filter_url\";s:8:\"provider\";s:6:\"filter\";s:6:\"status\";b:1;s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:17:\"filter_url_length\";i:72;}}}}'),('','filter.settings',_binary 'a:3:{s:15:\"fallback_format\";s:10:\"plain_text\";s:27:\"always_show_fallback_choice\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"FiPjM3WdB__ruFA7B6TLwni_UcZbmek5G4b2dxQItxA\";}}'),('','ga_reports.settings',_binary 'a:12:{s:13:\"metadata_etag\";s:57:\"\"sUgUYPc8DJXIhBC1gy7fx9uXwOc/VeJwiWZatppAyYHrY6NDiQj-E-4\"\";s:18:\"metadata_last_time\";s:10:\"1539240142\";s:12:\"access_token\";s:0:\"\";s:12:\"cache_length\";i:259200;s:9:\"client_id\";s:0:\"\";s:13:\"client_secret\";s:0:\"\";s:12:\"default_page\";s:0:\"\";s:10:\"expires_at\";i:0;s:10:\"profile_id\";i:0;s:12:\"redirect_uri\";s:0:\"\";s:13:\"refresh_token\";s:0:\"\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ZUOFCdFWBWkqS-ntcmgf7Tpr9lemXhUyYMMMjJ8fwEQ\";}}'),('','image.settings',_binary 'a:4:{s:13:\"preview_image\";s:29:\"core/modules/image/sample.png\";s:26:\"allow_insecure_derivatives\";b:0;s:20:\"suppress_itok_output\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"k-yDFHbqNfpe-Srg4sdCSqaosCl2D8uwyEY5esF8gEw\";}}'),('','image.style.large',_binary 'a:8:{s:4:\"uuid\";s:36:\"201a0bb1-03a3-4747-a968-ebf780afc231\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"J2n0RpFzS0-bgSyxjs6rSdgxB1rb-bTAgqywNx_964M\";}s:4:\"name\";s:5:\"large\";s:5:\"label\";s:16:\"Large (480×480)\";s:7:\"effects\";a:1:{s:36:\"ddd73aa7-4bd6-4c85-b600-bdf2b1628d1d\";a:4:{s:4:\"uuid\";s:36:\"ddd73aa7-4bd6-4c85-b600-bdf2b1628d1d\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:0;s:4:\"data\";a:3:{s:5:\"width\";i:480;s:6:\"height\";i:480;s:7:\"upscale\";b:0;}}}}'),('','image.style.medium',_binary 'a:8:{s:4:\"uuid\";s:36:\"9763a674-a0e7-4092-892a-7000ec93d550\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Y9NmnZHQq20ASSyTNA6JnwtWrJJiSajOehGDtmUFdM0\";}s:4:\"name\";s:6:\"medium\";s:5:\"label\";s:17:\"Medium (220×220)\";s:7:\"effects\";a:1:{s:36:\"bddf0d06-42f9-4c75-a700-a33cafa25ea0\";a:4:{s:4:\"uuid\";s:36:\"bddf0d06-42f9-4c75-a700-a33cafa25ea0\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:0;s:4:\"data\";a:3:{s:5:\"width\";i:220;s:6:\"height\";i:220;s:7:\"upscale\";b:0;}}}}'),('','image.style.thumbnail',_binary 'a:8:{s:4:\"uuid\";s:36:\"d783129a-aa55-4ad3-a437-b07c106fc966\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cCiWdBHgLwj5omG35lsKc4LkW4MBdmcctkVop4ol5x0\";}s:4:\"name\";s:9:\"thumbnail\";s:5:\"label\";s:20:\"Thumbnail (100×100)\";s:7:\"effects\";a:1:{s:36:\"1cfec298-8620-4749-b100-ccb6c4500779\";a:4:{s:4:\"uuid\";s:36:\"1cfec298-8620-4749-b100-ccb6c4500779\";s:2:\"id\";s:11:\"image_scale\";s:6:\"weight\";i:0;s:4:\"data\";a:3:{s:5:\"width\";i:100;s:6:\"height\";i:100;s:7:\"upscale\";b:0;}}}}'),('','menu_ui.settings',_binary 'a:2:{s:24:\"override_parent_selector\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SqMarzIjxC3F8dZo9FEOxfqDKD_sdW1tbcFTV1BA2zU\";}}'),('','migrate_drupal.settings',_binary 'a:3:{s:26:\"enforce_source_module_tags\";a:2:{i:0;s:8:\"Drupal 6\";i:1;s:8:\"Drupal 7\";}s:24:\"follow_up_migration_tags\";a:1:{i:0;s:19:\"Follow-up migration\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1daEO2inZc1i3d0Sn-ADIq9mUIU7tSLCxn579NT6f2g\";}}'),('','node.settings',_binary 'a:2:{s:15:\"use_admin_theme\";b:1;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2OMXCScXUOLSYID9-phjO4q36nnnaMWNUlDxEqZzG1U\";}}'),('','node.type.article',_binary 'a:12:{s:4:\"uuid\";s:36:\"570dc409-91e0-48b4-a412-def16b756fd7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AeW1SEDgb1OTQACAWGhzvMknMYAJlcZu0jljfeU3oso\";}s:4:\"name\";s:7:\"Article\";s:4:\"type\";s:7:\"article\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:1;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}'),('','node.type.migrate_example_beer',_binary 'a:12:{s:4:\"uuid\";s:36:\"5b8a080b-4883-4eef-9e9b-451db02d8bc5\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U_maKgojQ2WxF-bkAntFDvaXHU4jYMvALeeGQHMCPnQ\";}s:4:\"name\";s:4:\"Beer\";s:4:\"type\";s:20:\"migrate_example_beer\";s:11:\"description\";s:22:\"Beer is what we drink.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}'),('','node.type.migrate_example_producer',_binary 'a:12:{s:4:\"uuid\";s:36:\"942256f1-1a4c-4828-995d-d1aec2ca115f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OHHNffqa__jzWnLEnKqyHnMSmftu2Ynj7LPIUJQl_js\";}s:4:\"name\";s:13:\"Wine Producer\";s:4:\"type\";s:24:\"migrate_example_producer\";s:11:\"description\";s:41:\"Wineries, vineyards, and large producers.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}'),('','node.type.migrate_example_wine',_binary 'a:12:{s:4:\"uuid\";s:36:\"e70c6013-aa35-47e9-8c2b-df483f60588f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"al1Ui692C2r_G8Nj3LLNVk5TYFjFouP8FipmWiCDFC8\";}s:4:\"name\";s:4:\"Wine\";s:4:\"type\";s:20:\"migrate_example_wine\";s:11:\"description\";s:22:\"Wine is what we drink.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:0;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:1;}'),('','node.type.page',_binary 'a:12:{s:4:\"uuid\";s:36:\"5ee98c60-03db-4240-8408-7d1a9adc8a8d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"KuyA4NHPXcmKAjRtwa0vQc2ZcyrUJy6IlS2TAyMNRbc\";}s:4:\"name\";s:10:\"Basic page\";s:4:\"type\";s:4:\"page\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:4:\"help\";s:0:\"\";s:12:\"new_revision\";b:1;s:12:\"preview_mode\";i:1;s:17:\"display_submitted\";b:0;}'),('','rdf.mapping.comment.comment',_binary 'a:10:{s:4:\"uuid\";s:36:\"bb66fbda-2d1b-442d-9428-74a6e92bf15a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:20:\"comment.type.comment\";}s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uETe6XupRGKDForx2MpY0pMOEu6CzGgdCAZZOKkbgmk\";}s:2:\"id\";s:15:\"comment.comment\";s:16:\"targetEntityType\";s:7:\"comment\";s:6:\"bundle\";s:7:\"comment\";s:5:\"types\";a:1:{i:0;s:14:\"schema:Comment\";}s:13:\"fieldMappings\";a:5:{s:7:\"subject\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:name\";}}s:7:\"created\";a:2:{s:10:\"properties\";a:1:{i:0;s:18:\"schema:dateCreated\";}s:17:\"datatype_callback\";a:1:{s:8:\"callable\";s:48:\"Drupal\\rdf\\CommonDataConverter::dateIso8601Value\";}}s:7:\"changed\";a:2:{s:10:\"properties\";a:1:{i:0;s:19:\"schema:dateModified\";}s:17:\"datatype_callback\";a:1:{s:8:\"callable\";s:48:\"Drupal\\rdf\\CommonDataConverter::dateIso8601Value\";}}s:12:\"comment_body\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:text\";}}s:3:\"uid\";a:2:{s:10:\"properties\";a:1:{i:0;s:13:\"schema:author\";}s:12:\"mapping_type\";s:3:\"rel\";}}}'),('','rdf.mapping.node.article',_binary 'a:10:{s:4:\"uuid\";s:36:\"41ee14a8-6904-4495-b680-2efb83b258ae\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:17:\"node.type.article\";}s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"IdobJe379eDudt7-bXFfJjF7pDqFl-kYxVFtpWrgkro\";}s:2:\"id\";s:12:\"node.article\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:5:\"types\";a:1:{i:0;s:14:\"schema:Article\";}s:13:\"fieldMappings\";a:9:{s:5:\"title\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:name\";}}s:7:\"created\";a:2:{s:10:\"properties\";a:1:{i:0;s:18:\"schema:dateCreated\";}s:17:\"datatype_callback\";a:1:{s:8:\"callable\";s:48:\"Drupal\\rdf\\CommonDataConverter::dateIso8601Value\";}}s:7:\"changed\";a:2:{s:10:\"properties\";a:1:{i:0;s:19:\"schema:dateModified\";}s:17:\"datatype_callback\";a:1:{s:8:\"callable\";s:48:\"Drupal\\rdf\\CommonDataConverter::dateIso8601Value\";}}s:4:\"body\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:text\";}}s:3:\"uid\";a:1:{s:10:\"properties\";a:1:{i:0;s:13:\"schema:author\";}}s:7:\"comment\";a:2:{s:10:\"properties\";a:1:{i:0;s:14:\"schema:comment\";}s:12:\"mapping_type\";s:3:\"rel\";}s:13:\"comment_count\";a:2:{s:10:\"properties\";a:1:{i:0;s:23:\"schema:interactionCount\";}s:17:\"datatype_callback\";a:2:{s:8:\"callable\";s:51:\"Drupal\\rdf\\SchemaOrgDataConverter::interactionCount\";s:9:\"arguments\";a:1:{s:16:\"interaction_type\";s:12:\"UserComments\";}}}s:11:\"field_image\";a:1:{s:10:\"properties\";a:1:{i:0;s:12:\"schema:image\";}}s:10:\"field_tags\";a:1:{s:10:\"properties\";a:1:{i:0;s:12:\"schema:about\";}}}}'),('','rdf.mapping.node.page',_binary 'a:10:{s:4:\"uuid\";s:36:\"9d97cccd-ba17-42be-a940-793cc5ad5430\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:14:\"node.type.page\";}s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"32LxRnl4Wesvzqyfp7HnD0-U9-wxrLBn76pqY5XGNAE\";}s:2:\"id\";s:9:\"node.page\";s:16:\"targetEntityType\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:5:\"types\";a:1:{i:0;s:14:\"schema:WebPage\";}s:13:\"fieldMappings\";a:6:{s:5:\"title\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:name\";}}s:7:\"created\";a:2:{s:10:\"properties\";a:1:{i:0;s:18:\"schema:dateCreated\";}s:17:\"datatype_callback\";a:1:{s:8:\"callable\";s:48:\"Drupal\\rdf\\CommonDataConverter::dateIso8601Value\";}}s:7:\"changed\";a:2:{s:10:\"properties\";a:1:{i:0;s:19:\"schema:dateModified\";}s:17:\"datatype_callback\";a:1:{s:8:\"callable\";s:48:\"Drupal\\rdf\\CommonDataConverter::dateIso8601Value\";}}s:4:\"body\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:text\";}}s:3:\"uid\";a:2:{s:10:\"properties\";a:1:{i:0;s:13:\"schema:author\";}s:12:\"mapping_type\";s:3:\"rel\";}s:13:\"comment_count\";a:2:{s:10:\"properties\";a:1:{i:0;s:23:\"schema:interactionCount\";}s:17:\"datatype_callback\";a:2:{s:8:\"callable\";s:51:\"Drupal\\rdf\\SchemaOrgDataConverter::interactionCount\";s:9:\"arguments\";a:1:{s:16:\"interaction_type\";s:12:\"UserComments\";}}}}}'),('','rdf.mapping.taxonomy_term.tags',_binary 'a:10:{s:4:\"uuid\";s:36:\"28d43243-a226-4db5-bfe5-58011b758cea\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:24:\"taxonomy.vocabulary.tags\";}s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"o5duwyS1CTHx3tYOZhuu91kspe8VQjQsnwZjAJv9njk\";}s:2:\"id\";s:18:\"taxonomy_term.tags\";s:16:\"targetEntityType\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:4:\"tags\";s:5:\"types\";a:1:{i:0;s:12:\"schema:Thing\";}s:13:\"fieldMappings\";a:2:{s:4:\"name\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:name\";}}s:11:\"description\";a:1:{s:10:\"properties\";a:1:{i:0;s:18:\"schema:description\";}}}}'),('','rdf.mapping.user.user',_binary 'a:10:{s:4:\"uuid\";s:36:\"c485a710-d9e6-412a-bc7a-9cfe679f4c2b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TGTlmpYAtXxjtYMFA_A0vosE2c4R5MCQwLviIA5HUM0\";}s:2:\"id\";s:9:\"user.user\";s:16:\"targetEntityType\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";s:5:\"types\";a:1:{i:0;s:13:\"schema:Person\";}s:13:\"fieldMappings\";a:1:{s:4:\"name\";a:1:{s:10:\"properties\";a:1:{i:0;s:11:\"schema:name\";}}}}'),('','rest.settings',_binary 'a:2:{s:30:\"bc_entity_resource_permissions\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Jg3_yqsTIZ51KOKp3OV2KDVVrlx3N3OCEfniEse09KE\";}}'),('','search.page.node_search',_binary 'a:11:{s:4:\"uuid\";s:36:\"c4bb8f59-527e-4bb9-99d3-c6109c3cef5d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"97tvtzGOa8_flb22CzSjgtm_YkiGMHvEBO-6q2K9V_U\";}s:2:\"id\";s:11:\"node_search\";s:5:\"label\";s:7:\"Content\";s:4:\"path\";s:4:\"node\";s:6:\"weight\";i:-10;s:6:\"plugin\";s:11:\"node_search\";s:13:\"configuration\";a:1:{s:8:\"rankings\";a:0:{}}}'),('','search.page.user_search',_binary 'a:11:{s:4:\"uuid\";s:36:\"bdd6728c-1758-4580-a896-098f2403cabd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"k3aUaZXGDuhkek2TZIee0PApOPTvYZLadziekdyHA5A\";}s:2:\"id\";s:11:\"user_search\";s:5:\"label\";s:5:\"Users\";s:4:\"path\";s:4:\"user\";s:6:\"weight\";i:0;s:6:\"plugin\";s:11:\"user_search\";s:13:\"configuration\";a:0:{}}'),('','search.settings',_binary 'a:5:{s:12:\"and_or_limit\";i:7;s:12:\"default_page\";s:11:\"node_search\";s:5:\"index\";a:4:{s:10:\"cron_limit\";i:100;s:11:\"overlap_cjk\";b:1;s:17:\"minimum_word_size\";i:3;s:11:\"tag_weights\";a:12:{s:2:\"h1\";i:25;s:2:\"h2\";i:18;s:2:\"h3\";i:15;s:2:\"h4\";i:14;s:2:\"h5\";i:9;s:2:\"h6\";i:6;s:1:\"u\";i:3;s:1:\"b\";i:3;s:1:\"i\";i:3;s:6:\"strong\";i:3;s:2:\"em\";i:3;s:1:\"a\";i:10;}}s:7:\"logging\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"hvVxL1G-ZCxaq32IZws0YsfuhvaDiQE_np-0g35KjUk\";}}'),('','serialization.settings',_binary 'a:3:{s:24:\"bc_primitives_as_strings\";b:0;s:28:\"bc_timestamp_normalizer_unix\";b:0;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6A1rmsmNf4SJrwCEt_aZyO_kPYuFnIOPC2n5lJiIftA\";}}'),('','seven.settings',_binary 'a:1:{s:20:\"third_party_settings\";a:1:{s:8:\"shortcut\";a:1:{s:11:\"module_link\";b:1;}}}'),('','shortcut.set.default',_binary 'a:7:{s:4:\"uuid\";s:36:\"29cc33d0-f17d-4e92-ab21-a709f2d740e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"U5VlGjd_SfV0Qm_EfnaynOfc549cNscFAx48JfYoMRI\";}s:2:\"id\";s:7:\"default\";s:5:\"label\";s:7:\"Default\";}'),('','system.action.comment_delete_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"8cd78467-3aa6-4642-a795-cc3cbd214493\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"VetuwpecspsjqMCd8e7wKyr2l-AZEh1UNYWNtNywHXM\";}s:2:\"id\";s:21:\"comment_delete_action\";s:5:\"label\";s:14:\"Delete comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:28:\"entity:delete_action:comment\";s:13:\"configuration\";a:0:{}}'),('','system.action.comment_publish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"2d5637bf-26b3-41ba-9d8d-740bbd679ee7\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"C00dyL_W_5M0nFlgUB3lWUTUs96jn51Jw1MLHVEHZD0\";}s:2:\"id\";s:22:\"comment_publish_action\";s:5:\"label\";s:15:\"Publish comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:29:\"entity:publish_action:comment\";s:13:\"configuration\";a:0:{}}'),('','system.action.comment_save_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"c3af90be-2491-4050-b1ea-5e0706449649\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lfyE_snmvfg_EQ3VDyhUtGAXgmqtEiqa46I3bTMg8DU\";}s:2:\"id\";s:19:\"comment_save_action\";s:5:\"label\";s:12:\"Save comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:26:\"entity:save_action:comment\";s:13:\"configuration\";a:0:{}}'),('','system.action.comment_unpublish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"a71a6d49-8f5b-46ad-bf21-2066215da09d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:7:\"comment\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tWOIjSMobEWOFZddMkNqb9JySbOVwE1diC6NRqcfLTk\";}s:2:\"id\";s:24:\"comment_unpublish_action\";s:5:\"label\";s:17:\"Unpublish comment\";s:4:\"type\";s:7:\"comment\";s:6:\"plugin\";s:31:\"entity:unpublish_action:comment\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_delete_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"2829ed55-ae83-413f-8152-d5fd5bc7297a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Zx0jD1Klh5tZaGJy8uOeR_2MCu9FDM4xg7TaUJUEbkI\";}s:2:\"id\";s:18:\"node_delete_action\";s:5:\"label\";s:14:\"Delete content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:25:\"entity:delete_action:node\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_make_sticky_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"f9d82e49-e281-4865-b089-7568d6e5e9ba\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sOb26JSy3fGpWkvR0WYN6_hMqj_6d1rvbvrkzp1yya0\";}s:2:\"id\";s:23:\"node_make_sticky_action\";s:5:\"label\";s:19:\"Make content sticky\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:23:\"node_make_sticky_action\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_make_unsticky_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"c62d0d8a-2d20-45cc-87fa-c0f243532223\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lDM9mvIGAu8Sw8rt-uCO4Sr7yX5VPrDPxYcawkbKd6k\";}s:2:\"id\";s:25:\"node_make_unsticky_action\";s:5:\"label\";s:21:\"Make content unsticky\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:25:\"node_make_unsticky_action\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_promote_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"92aec9d7-7996-4297-8492-8763768657e1\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"N0RDBTqiK4dKoN4p4oW2j0SGWycdHyALUe9M-Ofp89U\";}s:2:\"id\";s:19:\"node_promote_action\";s:5:\"label\";s:29:\"Promote content to front page\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:19:\"node_promote_action\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_publish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"b926720c-f69d-4b38-8a89-8b07a36077e9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2B9uF8NL5gutNKSdPRAhhAsDWFZZG1PJOBmx0aBGd_0\";}s:2:\"id\";s:19:\"node_publish_action\";s:5:\"label\";s:15:\"Publish content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:26:\"entity:publish_action:node\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_save_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"937a38cd-6717-45fd-b62a-bdbdeb7c6d0d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"LhdsoZPL_pFas2fjaAWue4zvrQ_tEVofLYtcNec-JGM\";}s:2:\"id\";s:16:\"node_save_action\";s:5:\"label\";s:12:\"Save content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:23:\"entity:save_action:node\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_unpromote_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"0c73ca87-df28-4bad-93cb-fe172680de60\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"JBptjnfuOMtsdKygklXxoOgeOCTMtQxlkymjnnj-cC0\";}s:2:\"id\";s:21:\"node_unpromote_action\";s:5:\"label\";s:30:\"Remove content from front page\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:21:\"node_unpromote_action\";s:13:\"configuration\";a:0:{}}'),('','system.action.node_unpublish_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"713d1349-e6b2-499e-bb0e-f46ed358c79f\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"C7X8h9FWlwkQ9y5mnU2JzgaZICAdc6HFbPVbhvjlAYE\";}s:2:\"id\";s:21:\"node_unpublish_action\";s:5:\"label\";s:17:\"Unpublish content\";s:4:\"type\";s:4:\"node\";s:6:\"plugin\";s:28:\"entity:unpublish_action:node\";s:13:\"configuration\";a:0:{}}'),('','system.action.user_add_role_action.administrator',_binary 'a:9:{s:4:\"uuid\";s:36:\"3070619a-a245-45ea-95c9-e4ec02516863\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"user.role.administrator\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:34:\"user_add_role_action.administrator\";s:5:\"label\";s:50:\"Add the Administrator role to the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:20:\"user_add_role_action\";s:13:\"configuration\";a:1:{s:3:\"rid\";s:13:\"administrator\";}}'),('','system.action.user_block_user_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"b159d6cd-eeca-41d7-a86f-1a171ef1441e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"DyypzTfThX10FFQw-399qPfEbLLyrhXgQrKPVsmAoJ4\";}s:2:\"id\";s:22:\"user_block_user_action\";s:5:\"label\";s:26:\"Block the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:22:\"user_block_user_action\";s:13:\"configuration\";a:0:{}}'),('','system.action.user_cancel_user_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"342f19e7-4fcc-43c3-be06-077b2ff1c27d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"nvrL9bFilzBvm2bjO9rQnFDpBA7dBBUjShSSt6NS-DU\";}s:2:\"id\";s:23:\"user_cancel_user_action\";s:5:\"label\";s:35:\"Cancel the selected user account(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:23:\"user_cancel_user_action\";s:13:\"configuration\";a:0:{}}'),('','system.action.user_remove_role_action.administrator',_binary 'a:9:{s:4:\"uuid\";s:36:\"76a2a0e3-51b6-4a14-a8eb-3eebb78d8cb3\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:23:\"user.role.administrator\";}s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:2:\"id\";s:37:\"user_remove_role_action.administrator\";s:5:\"label\";s:55:\"Remove the Administrator role from the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:23:\"user_remove_role_action\";s:13:\"configuration\";a:1:{s:3:\"rid\";s:13:\"administrator\";}}'),('','system.action.user_unblock_user_action',_binary 'a:10:{s:4:\"uuid\";s:36:\"8768000c-4a49-4700-9512-dd545e53405d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SPsUXsR3Rc8d1y3gewzaAKWa1ncea_ywXX3f7LTn7k0\";}s:2:\"id\";s:24:\"user_unblock_user_action\";s:5:\"label\";s:28:\"Unblock the selected user(s)\";s:4:\"type\";s:4:\"user\";s:6:\"plugin\";s:24:\"user_unblock_user_action\";s:13:\"configuration\";a:0:{}}'),('','system.authorize',_binary 'a:2:{s:20:\"filetransfer_default\";N;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"z63ds8M4zPrylEgFRkRcOlfcsXWwfITzjD4cj1kRdfg\";}}'),('','system.cron',_binary 'a:3:{s:9:\"threshold\";a:2:{s:20:\"requirements_warning\";i:172800;s:18:\"requirements_error\";i:1209600;}s:7:\"logging\";i:1;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"5Pw921y1EPfFN98wykliBBLArm51pC-SmrXeYCe7d0Y\";}}'),('','system.date',_binary 'a:4:{s:7:\"country\";a:1:{s:7:\"default\";s:2:\"IN\";}s:9:\"first_day\";i:0;s:8:\"timezone\";a:2:{s:7:\"default\";s:3:\"UTC\";s:4:\"user\";a:3:{s:12:\"configurable\";b:1;s:4:\"warn\";b:0;s:7:\"default\";i:0;}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"V9UurX2GPT05NWKG9f2GWQqFG2TRG8vczidwjpy7Woo\";}}'),('','system.diff',_binary 'a:2:{s:7:\"context\";a:2:{s:13:\"lines_leading\";i:2;s:14:\"lines_trailing\";i:2;}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1WanmaEhxW_vM8_5Ktsdntj8MaO9UBHXg0lN603PsWM\";}}'),('','system.file',_binary 'a:5:{s:22:\"allow_insecure_uploads\";b:0;s:14:\"default_scheme\";s:6:\"public\";s:4:\"path\";a:1:{s:9:\"temporary\";s:4:\"/tmp\";}s:21:\"temporary_maximum_age\";i:21600;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"t48gCU9DzYfjb3bAOIqHLzhL0ChBlXh6_5B5Pyo9t8g\";}}'),('','system.image',_binary 'a:2:{s:7:\"toolkit\";s:2:\"gd\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"durWHaKeBaq4d9Wpi4RqwADj1OufDepcnJuhVLmKN24\";}}'),('','system.image.gd',_binary 'a:2:{s:12:\"jpeg_quality\";i:75;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eNXaHfkJJUThHeF0nvkoXyPLRrKYGxgHRjORvT4F5rQ\";}}'),('','system.logging',_binary 'a:2:{s:11:\"error_level\";s:3:\"all\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"u3-njszl92FaxjrCMiq0yDcjAfcdx72w1zT1O9dx6aA\";}}'),('','system.mail',_binary 'a:2:{s:9:\"interface\";a:1:{s:7:\"default\";s:8:\"php_mail\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rYgt7uhPafP2ngaN_ZUPFuyI4KdE0zU868zLNSlzKoE\";}}'),('','system.maintenance',_binary 'a:3:{s:7:\"message\";s:93:\"@site is currently under maintenance. We should be back shortly. Thank you for your patience.\";s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Z5MXifrF77GEAgx0GQ6iWT8wStjFuY8BD9OruofWTJ8\";}}'),('','system.menu.account',_binary 'a:9:{s:4:\"uuid\";s:36:\"49eb0318-e9b0-4776-8a3b-7343719aa935\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"M_Bh81osDyUQ4wV0GgU_NdBNqkzM87sLxjaCdFj9mnw\";}s:2:\"id\";s:7:\"account\";s:5:\"label\";s:17:\"User account menu\";s:11:\"description\";s:40:\"Links related to the active user account\";s:6:\"locked\";b:1;}'),('','system.menu.admin',_binary 'a:9:{s:4:\"uuid\";s:36:\"ffdd0567-c401-4542-8098-7886137167bd\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sapEi2YDGoI9yQIT_WgIV2vUdQ6DScH0V3fAyTadAL0\";}s:2:\"id\";s:5:\"admin\";s:5:\"label\";s:14:\"Administration\";s:11:\"description\";s:25:\"Administrative task links\";s:6:\"locked\";b:1;}'),('','system.menu.devel',_binary 'a:9:{s:4:\"uuid\";s:36:\"96b3f6ab-f74a-4076-9cde-d709f219e8c0\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:8:\"enforced\";a:1:{s:6:\"module\";a:1:{i:0;s:5:\"devel\";}}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"mYceWZ4FHflXMWwxiO7ePCeXvKMl9F-ARIQ9p4IpvWE\";}s:2:\"id\";s:5:\"devel\";s:5:\"label\";s:11:\"Development\";s:11:\"description\";s:30:\"Links related to Devel module.\";s:6:\"locked\";b:1;}'),('','system.menu.footer',_binary 'a:9:{s:4:\"uuid\";s:36:\"e668dd2a-9385-4dfd-b05d-2c0e479ac191\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"7yrlW5z9zdg2eBucB2GPqXKSMQfH9lSRSO4DbWF7AFc\";}s:2:\"id\";s:6:\"footer\";s:5:\"label\";s:6:\"Footer\";s:11:\"description\";s:22:\"Site information links\";s:6:\"locked\";b:1;}'),('','system.menu.main',_binary 'a:9:{s:4:\"uuid\";s:36:\"b12f73b0-d01d-4853-af6e-9c316c0c2cfb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Q2Ra3jfoIVk0f3SjxJX61byRQFVBAbpzYDQOiY-kno8\";}s:2:\"id\";s:4:\"main\";s:5:\"label\";s:15:\"Main navigation\";s:11:\"description\";s:18:\"Site section links\";s:6:\"locked\";b:1;}'),('','system.menu.tools',_binary 'a:9:{s:4:\"uuid\";s:36:\"58a468f7-6939-42e7-84d7-5cfb079f8731\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"BCM-vV1zzRaLHN18dqAR_CuGOj8AFJvTx7BKl_8Gcxc\";}s:2:\"id\";s:5:\"tools\";s:5:\"label\";s:5:\"Tools\";s:11:\"description\";s:39:\"User tool links, often added by modules\";s:6:\"locked\";b:1;}'),('','system.performance',_binary 'a:7:{s:5:\"cache\";a:1:{s:4:\"page\";a:2:{s:7:\"max_age\";i:0;s:12:\"use_internal\";b:0;}}s:3:\"css\";a:2:{s:10:\"preprocess\";b:0;s:4:\"gzip\";b:0;}s:8:\"fast_404\";a:4:{s:7:\"enabled\";b:1;s:5:\"paths\";s:69:\"/\\.(?:txt|png|gif|jpe?g|css|js|ico|swf|flv|cgi|bat|pl|dll|exe|asp)$/i\";s:13:\"exclude_paths\";s:27:\"/\\/(?:styles|imagecache)\\//\";s:4:\"html\";s:162:\"<!DOCTYPE html><html><head><title>404 Not Found</title></head><body><h1>Not Found</h1><p>The requested URL \"@path\" was not found on this server.</p></body></html>\";}s:2:\"js\";a:2:{s:10:\"preprocess\";b:0;s:4:\"gzip\";b:0;}s:20:\"stale_file_threshold\";i:2592000;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"b2cssrj-lOmATIbdehfCqfCFgVR0qCdxxWhwqa2KBVQ\";}s:8:\"response\";a:1:{s:4:\"gzip\";b:0;}}'),('','system.rss',_binary 'a:4:{s:7:\"channel\";a:1:{s:11:\"description\";s:0:\"\";}s:5:\"items\";a:2:{s:5:\"limit\";i:10;s:9:\"view_mode\";s:3:\"rss\";}s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TlH7NNk46phfxu1mSUfwg1C0YqaGsUCeD4l9JQnQlDU\";}}'),('','system.site',_binary 'a:10:{s:4:\"uuid\";s:36:\"58e1ea03-22f6-49d7-81a4-fb5abf097336\";s:4:\"name\";s:19:\"Justice HTML5 Theme\";s:4:\"mail\";s:15:\"admin@admin.com\";s:6:\"slogan\";s:19:\"Justice HTML5 Theme\";s:4:\"page\";a:3:{i:403;s:0:\"\";i:404;s:0:\"\";s:5:\"front\";s:5:\"/node\";}s:18:\"admin_compact_mode\";b:0;s:17:\"weight_select_max\";i:100;s:8:\"langcode\";s:2:\"en\";s:16:\"default_langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"yXadRE77Va-G6dxhd2kPYapAvbnSvTF6hO4oXiOEynI\";}}'),('','system.theme',_binary 'a:3:{s:5:\"admin\";s:5:\"seven\";s:7:\"default\";s:7:\"justice\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"fOjer9hADYYnbCJVZMFZIIM1azTFWyg84ZkFDHfAbUg\";}}'),('','system.theme.global',_binary 'a:4:{s:7:\"favicon\";a:4:{s:8:\"mimetype\";s:24:\"image/vnd.microsoft.icon\";s:4:\"path\";s:0:\"\";s:3:\"url\";s:0:\"\";s:11:\"use_default\";b:1;}s:8:\"features\";a:4:{s:20:\"comment_user_picture\";b:1;s:25:\"comment_user_verification\";b:1;s:7:\"favicon\";b:1;s:17:\"node_user_picture\";b:1;}s:4:\"logo\";a:3:{s:4:\"path\";s:0:\"\";s:3:\"url\";s:0:\"\";s:11:\"use_default\";b:1;}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9rAU4Pku7eMBQxauQqAgjzlcicFZ2As6zEa6zvTlCB8\";}}'),('','taxonomy.settings',_binary 'a:4:{s:20:\"maintain_index_table\";b:1;s:17:\"override_selector\";b:0;s:20:\"terms_per_page_admin\";i:100;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"zKpaWT6cJc1tVQQaTqatGELaCqU_oyRym6zTl27Yias\";}}'),('','taxonomy.vocabulary.migrate_example_beer_styles',_binary 'a:10:{s:4:\"uuid\";s:36:\"11c2f626-3a04-4f09-bf65-36ef6620dadb\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gDVMNhIaN-Ev0gqPyZU5Y7yUCwRfMlA-cv2gHC01hl4\";}s:4:\"name\";s:27:\"Migrate Example Beer Styles\";s:3:\"vid\";s:27:\"migrate_example_beer_styles\";s:11:\"description\";s:58:\"Use tags to group beers on similar topics into categories.\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}'),('','taxonomy.vocabulary.migrate_example_wine_best_with',_binary 'a:10:{s:4:\"uuid\";s:36:\"55a19acc-deb2-4c76-aaa3-03cd390feab6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Um5-fw3xl_sy7j8TL2BdvXxYGTZk5fWXvZM_d3j_5HI\";}s:4:\"name\";s:30:\"Migrate Example Wine Best With\";s:3:\"vid\";s:30:\"migrate_example_wine_best_with\";s:11:\"description\";s:29:\"Foods the wine goes best with\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}'),('','taxonomy.vocabulary.migrate_example_wine_regions',_binary 'a:10:{s:4:\"uuid\";s:36:\"35a776b4-9412-46b9-b8cc-1f5c2e473fb9\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EtlAQvGtTNN6MaeLyMkoK4gCOyQxe2cMD4rblLAzoyY\";}s:4:\"name\";s:28:\"Migrate Example Wine Regions\";s:3:\"vid\";s:28:\"migrate_example_wine_regions\";s:11:\"description\";s:12:\"Wine regions\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}'),('','taxonomy.vocabulary.migrate_example_wine_varieties',_binary 'a:10:{s:4:\"uuid\";s:36:\"d6b0d5dc-57b7-447c-8aef-2fdaa810601b\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"4wp7G-IhzYtgI33DfQlm4mNx9UleyBZ2sAlaXu0Gke4\";}s:4:\"name\";s:30:\"Migrate Example Wine Varieties\";s:3:\"vid\";s:30:\"migrate_example_wine_varieties\";s:11:\"description\";s:14:\"Wine varieties\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}'),('','taxonomy.vocabulary.tags',_binary 'a:10:{s:4:\"uuid\";s:36:\"5e143112-8b1f-406b-8e42-9e932a410678\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"lO5ziR5dVI1PpEeHZsSOfQ-Y7NWihSDKW8-MMf6uoms\";}s:4:\"name\";s:4:\"Tags\";s:3:\"vid\";s:4:\"tags\";s:11:\"description\";s:61:\"Use tags to group articles on similar topics into categories.\";s:9:\"hierarchy\";i:0;s:6:\"weight\";i:0;}'),('','text.settings',_binary 'a:2:{s:22:\"default_summary_length\";i:600;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Bkewb77RBOK3_aXMPsp8p87gbc03NvmC5gBLzPl7hVA\";}}'),('','tour.tour.views-ui',_binary 'a:10:{s:4:\"uuid\";s:36:\"290c93bf-ce9b-40ea-8c58-90217b312670\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"views_ui\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"c-HMyZwgeP8H6AITDcq4hznePkd7azpe8xl_WTnx2O0\";}s:2:\"id\";s:8:\"views-ui\";s:5:\"label\";s:14:\"View edit page\";s:6:\"module\";s:8:\"views_ui\";s:6:\"routes\";a:2:{i:0;a:1:{s:10:\"route_name\";s:21:\"entity.view.edit_form\";}i:1;a:1:{s:10:\"route_name\";s:29:\"entity.view.edit_display_form\";}}s:4:\"tips\";a:10:{s:10:\"views-main\";a:5:{s:2:\"id\";s:10:\"views-main\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:20:\"Manage view settings\";s:4:\"body\";s:31:\"View or edit the configuration.\";s:6:\"weight\";i:1;}s:17:\"views-ui-displays\";a:6:{s:2:\"id\";s:17:\"views-ui-displays\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:21:\"Displays in this view\";s:4:\"body\";s:169:\"A display is a way of outputting the results, e.g., as a page or a block. A view can contain multiple displays, which are listed here. The active display is highlighted.\";s:6:\"weight\";i:2;s:10:\"attributes\";a:1:{s:7:\"data-id\";s:17:\"views-display-top\";}}s:19:\"views-ui-view-admin\";a:7:{s:2:\"id\";s:19:\"views-ui-view-admin\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:19:\"View administration\";s:4:\"body\";s:140:\"Perform administrative tasks, including adding a description and creating a clone. Click the drop-down button to view the available options.\";s:6:\"weight\";i:3;s:8:\"location\";s:4:\"left\";s:10:\"attributes\";a:1:{s:7:\"data-id\";s:27:\"views-display-extra-actions\";}}s:15:\"views-ui-format\";a:6:{s:2:\"id\";s:15:\"views-ui-format\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Output format\";s:4:\"body\";s:325:\"Choose how to output results. E.g., choose <em>Content</em> to output each item completely, using your configured display settings. Or choose <em>Fields</em>, which allows you to output only specific fields for each result. Additional formats can be added by installing modules to <em>extend</em> Drupal\'s base functionality.\";s:6:\"weight\";i:4;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:34:\"views-ui-display-tab-bucket.format\";}}s:15:\"views-ui-fields\";a:6:{s:2:\"id\";s:15:\"views-ui-fields\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:6:\"Fields\";s:4:\"body\";s:89:\"If this view uses fields, they are listed here. You can click on a field to configure it.\";s:6:\"weight\";i:5;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:33:\"views-ui-display-tab-bucket.field\";}}s:15:\"views-ui-filter\";a:6:{s:2:\"id\";s:15:\"views-ui-filter\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:16:\"Filter your view\";s:4:\"body\";s:173:\"Add filters to limit the results in the output. E.g., to only show content that is <em>published</em>, you would add a filter for <em>Published</em> and select <em>Yes</em>.\";s:6:\"weight\";i:6;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:34:\"views-ui-display-tab-bucket.filter\";}}s:26:\"views-ui-filter-operations\";a:6:{s:2:\"id\";s:26:\"views-ui-filter-operations\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:14:\"Filter actions\";s:4:\"body\";s:33:\"Add, rearrange or remove filters.\";s:6:\"weight\";i:7;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:53:\"views-ui-display-tab-bucket.filter .dropbutton-widget\";}}s:14:\"views-ui-sorts\";a:6:{s:2:\"id\";s:14:\"views-ui-sorts\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:13:\"Sort Criteria\";s:4:\"body\";s:96:\"Control the order in which the results are output. Click on an active sort rule to configure it.\";s:6:\"weight\";i:8;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:32:\"views-ui-display-tab-bucket.sort\";}}s:25:\"views-ui-sorts-operations\";a:6:{s:2:\"id\";s:25:\"views-ui-sorts-operations\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:12:\"Sort actions\";s:4:\"body\";s:39:\"Add, rearrange or remove sorting rules.\";s:6:\"weight\";i:9;s:10:\"attributes\";a:1:{s:10:\"data-class\";s:51:\"views-ui-display-tab-bucket.sort .dropbutton-widget\";}}s:16:\"views-ui-preview\";a:7:{s:2:\"id\";s:16:\"views-ui-preview\";s:6:\"plugin\";s:4:\"text\";s:5:\"label\";s:7:\"Preview\";s:4:\"body\";s:34:\"Show a preview of the view output.\";s:6:\"weight\";i:10;s:8:\"location\";s:4:\"left\";s:10:\"attributes\";a:1:{s:7:\"data-id\";s:14:\"preview-submit\";}}}}'),('','twilio.settings',_binary 'a:11:{s:7:\"account\";s:34:\"AC71eaf0485a204a7e654b195d442a9e5f\";s:5:\"token\";s:32:\"9f5e3a3291273ac08a8c198fa46c81de\";s:6:\"number\";s:10:\"7046523780\";s:8:\"long_sms\";s:1:\"1\";s:17:\"registration_form\";N;s:30:\"twilio_country_codes_container\";a:1:{s:13:\"country_codes\";a:206:{i:91;s:2:\"91\";i:1;i:0;i:93;i:0;i:355;i:0;i:213;i:0;i:376;i:0;i:244;i:0;i:1264;i:0;i:1268;i:0;i:54;i:0;i:374;i:0;i:297;i:0;i:61;i:0;i:43;i:0;i:994;i:0;i:1242;i:0;i:973;i:0;i:880;i:0;i:1246;i:0;i:375;i:0;i:32;i:0;i:501;i:0;i:229;i:0;i:1441;i:0;i:975;i:0;i:591;i:0;i:387;i:0;i:267;i:0;i:55;i:0;i:1284;i:0;i:673;i:0;i:359;i:0;i:226;i:0;i:257;i:0;i:855;i:0;i:237;i:0;i:34;i:0;i:238;i:0;i:1345;i:0;i:236;i:0;i:235;i:0;i:56;i:0;i:86;i:0;i:57;i:0;i:269;i:0;i:242;i:0;i:243;i:0;i:682;i:0;i:385;i:0;i:53;i:0;i:357;i:0;i:420;i:0;i:45;i:0;i:253;i:0;i:1767;i:0;i:670;i:0;i:593;i:0;i:20;i:0;i:503;i:0;i:240;i:0;i:372;i:0;i:251;i:0;i:500;i:0;i:298;i:0;i:679;i:0;i:358;i:0;i:33;i:0;i:594;i:0;i:689;i:0;i:241;i:0;i:220;i:0;i:995;i:0;i:49;i:0;i:233;i:0;i:350;i:0;i:881;i:0;i:30;i:0;i:299;i:0;i:1473;i:0;i:590;i:0;i:1671;i:0;i:502;i:0;i:224;i:0;i:592;i:0;i:509;i:0;i:504;i:0;i:852;i:0;i:36;i:0;i:354;i:0;i:62;i:0;i:98;i:0;i:964;i:0;i:353;i:0;i:972;i:0;i:39;i:0;i:225;i:0;i:1876;i:0;i:81;i:0;i:962;i:0;i:254;i:0;i:82;i:0;i:965;i:0;i:996;i:0;i:856;i:0;i:371;i:0;i:961;i:0;i:266;i:0;i:231;i:0;i:218;i:0;i:423;i:0;i:370;i:0;i:352;i:0;i:853;i:0;i:389;i:0;i:261;i:0;i:265;i:0;i:60;i:0;i:960;i:0;i:223;i:0;i:356;i:0;i:596;i:0;i:222;i:0;i:230;i:0;i:52;i:0;i:373;i:0;i:377;i:0;i:976;i:0;i:382;i:0;i:1664;i:0;i:212;i:0;i:258;i:0;i:95;i:0;i:264;i:0;i:977;i:0;i:31;i:0;i:599;i:0;i:687;i:0;i:64;i:0;i:505;i:0;i:227;i:0;i:234;i:0;i:47;i:0;i:968;i:0;i:92;i:0;i:970;i:0;i:9725;i:0;i:507;i:0;i:675;i:0;i:595;i:0;i:51;i:0;i:63;i:0;i:48;i:0;i:351;i:0;i:974;i:0;i:262;i:0;i:40;i:0;i:7;i:0;i:250;i:0;i:1670;i:0;i:1684;i:0;i:685;i:0;i:378;i:0;i:882;i:0;i:966;i:0;i:221;i:0;i:381;i:0;i:248;i:0;i:232;i:0;i:65;i:0;i:421;i:0;i:386;i:0;i:252;i:0;i:27;i:0;i:94;i:0;i:1869;i:0;i:1758;i:0;i:1784;i:0;i:249;i:0;i:597;i:0;i:268;i:0;i:46;i:0;i:41;i:0;i:963;i:0;i:886;i:0;i:992;i:0;i:255;i:0;i:66;i:0;i:228;i:0;i:676;i:0;i:1868;i:0;i:216;i:0;i:90;i:0;i:993;i:0;i:1649;i:0;i:256;i:0;i:44;i:0;i:380;i:0;i:971;i:0;i:598;i:0;i:998;i:0;i:678;i:0;i:58;i:0;i:84;i:0;i:967;i:0;i:260;i:0;i:263;i:0;}}s:25:\"twilio_callback_container\";N;s:7:\"actions\";N;s:13:\"form_build_id\";s:48:\"form-zGiRyLu86RJw9cwgLG6Mc9Oa4jrE2xyrW1ygIZ3KVI0\";s:10:\"form_token\";s:43:\"UDX1KarJUlo20xqlCtRb_nsosLEZjOey8rR5a9rYlrE\";s:7:\"form_id\";s:17:\"twilio_admin_form\";}'),('','update.settings',_binary 'a:4:{s:5:\"check\";a:2:{s:19:\"disabled_extensions\";b:0;s:13:\"interval_days\";i:1;}s:5:\"fetch\";a:3:{s:3:\"url\";s:0:\"\";s:12:\"max_attempts\";i:2;s:7:\"timeout\";i:30;}s:12:\"notification\";a:2:{s:6:\"emails\";a:1:{i:0;s:15:\"admin@admin.com\";}s:9:\"threshold\";s:3:\"all\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"2QzULf0zovJQx3J06Y9rufzzfi-CY2CTTlEfJJh2Qyw\";}}'),('','user.flood',_binary 'a:6:{s:8:\"uid_only\";b:0;s:8:\"ip_limit\";i:50;s:9:\"ip_window\";i:3600;s:10:\"user_limit\";i:5;s:11:\"user_window\";i:21600;s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"UYfMzeP1S8jKm9PSvxf7nQNe8DsNS-3bc2WSNNXBQWs\";}}'),('','user.mail',_binary 'a:11:{s:14:\"cancel_confirm\";a:2:{s:4:\"body\";s:377:\"[user:display-name],\n\nA request to cancel your account has been made at [site:name].\n\nYou may now cancel your account on [site:url-brief] by clicking this link or copying and pasting it into your browser:\n\n[user:cancel-url]\n\nNOTE: The cancellation of your account is not reversible.\n\nThis link expires in one day and nothing will happen if it is not used.\n\n--  [site:name] team\";s:7:\"subject\";s:67:\"Account cancellation request for [user:display-name] at [site:name]\";}s:14:\"password_reset\";a:2:{s:4:\"body\";s:407:\"[user:display-name],\n\nA request to reset the password for your account has been made at [site:name].\n\nYou may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password. It expires after one day and nothing will happen if it\'s not used.\n\n--  [site:name] team\";s:7:\"subject\";s:68:\"Replacement login information for [user:display-name] at [site:name]\";}s:22:\"register_admin_created\";a:2:{s:4:\"body\";s:473:\"[user:display-name],\n\nA site administrator at [site:name] has created an account for you. You may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password.\n\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\n\nusername: [user:name]\npassword: Your password\n\n--  [site:name] team\";s:7:\"subject\";s:58:\"An administrator created an account for you at [site:name]\";}s:29:\"register_no_approval_required\";a:2:{s:4:\"body\";s:447:\"[user:display-name],\n\nThank you for registering at [site:name]. You may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password.\n\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\n\nusername: [user:name]\npassword: Your password\n\n--  [site:name] team\";s:7:\"subject\";s:54:\"Account details for [user:display-name] at [site:name]\";}s:25:\"register_pending_approval\";a:2:{s:4:\"body\";s:289:\"[user:display-name],\n\nThank you for registering at [site:name]. Your application for an account is currently pending approval. Once it has been approved, you will receive another email containing information about how to log in, set your password, and other details.\n\n\n--  [site:name] team\";s:7:\"subject\";s:79:\"Account details for [user:display-name] at [site:name] (pending admin approval)\";}s:31:\"register_pending_approval_admin\";a:2:{s:4:\"body\";s:64:\"[user:display-name] has applied for an account.\n\n[user:edit-url]\";s:7:\"subject\";s:79:\"Account details for [user:display-name] at [site:name] (pending admin approval)\";}s:16:\"status_activated\";a:2:{s:4:\"body\";s:462:\"[user:display-name],\n\nYour account at [site:name] has been activated.\n\nYou may now log in by clicking this link or copying and pasting it into your browser:\n\n[user:one-time-login-url]\n\nThis link can only be used once to log in and will lead you to a page where you can set your password.\n\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\n\nusername: [user:account-name]\npassword: Your password\n\n--  [site:name] team\";s:7:\"subject\";s:65:\"Account details for [user:display-name] at [site:name] (approved)\";}s:14:\"status_blocked\";a:2:{s:4:\"body\";s:89:\"[user:display-name],\n\nYour account on [site:name] has been blocked.\n\n--  [site:name] team\";s:7:\"subject\";s:64:\"Account details for [user:display-name] at [site:name] (blocked)\";}s:15:\"status_canceled\";a:2:{s:4:\"body\";s:90:\"[user:display-name],\n\nYour account on [site:name] has been canceled.\n\n--  [site:name] team\";s:7:\"subject\";s:65:\"Account details for [user:display-name] at [site:name] (canceled)\";}s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"m4J3ROov32OEquRYGLbx3SpdDGuqx9l_zJtNvihqdCg\";}}'),('','user.role.administrator',_binary 'a:10:{s:4:\"uuid\";s:36:\"382c102a-ac11-4f94-90aa-3310bf725e14\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Om6FEO7vZZMkPIbVvfxtdkWerQ2PvQM4sWUd6Q3ZnfI\";}s:2:\"id\";s:13:\"administrator\";s:5:\"label\";s:13:\"Administrator\";s:6:\"weight\";i:2;s:8:\"is_admin\";b:1;s:11:\"permissions\";a:0:{}}'),('','user.role.anonymous',_binary 'a:10:{s:4:\"uuid\";s:36:\"b60f3e54-d77d-4b61-88d0-0db6596bf556\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"j5zLMOdJBqC0bMvSdth5UebkprJB8g_2FXHqhfpJzow\";}s:2:\"id\";s:9:\"anonymous\";s:5:\"label\";s:14:\"Anonymous user\";s:6:\"weight\";i:0;s:8:\"is_admin\";b:0;s:11:\"permissions\";a:6:{i:0;s:15:\"access comments\";i:1;s:14:\"access content\";i:2;s:11:\"access kint\";i:3;s:29:\"access site-wide contact form\";i:4;s:14:\"search content\";i:5;s:31:\"use text format restricted_html\";}}'),('','user.role.authenticated',_binary 'a:10:{s:4:\"uuid\";s:36:\"08eb6f79-361f-47e6-bc46-acb5c724076a\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:0:{}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"dJ0L2DNSj5q6XVZAGsuVDpJTh5UeYkIPwKrUOOpr8YI\";}s:2:\"id\";s:13:\"authenticated\";s:5:\"label\";s:18:\"Authenticated user\";s:6:\"weight\";i:1;s:8:\"is_admin\";b:0;s:11:\"permissions\";a:8:{i:0;s:15:\"access comments\";i:1;s:14:\"access content\";i:2;s:16:\"access shortcuts\";i:3;s:29:\"access site-wide contact form\";i:4;s:13:\"post comments\";i:5;s:14:\"search content\";i:6;s:21:\"skip comment approval\";i:7;s:26:\"use text format basic_html\";}}'),('','user.settings',_binary 'a:9:{s:9:\"anonymous\";s:9:\"Anonymous\";s:11:\"verify_mail\";b:1;s:6:\"notify\";a:8:{s:14:\"cancel_confirm\";b:1;s:14:\"password_reset\";b:1;s:16:\"status_activated\";b:1;s:14:\"status_blocked\";b:0;s:15:\"status_canceled\";b:0;s:22:\"register_admin_created\";b:1;s:29:\"register_no_approval_required\";b:1;s:25:\"register_pending_approval\";b:1;}s:8:\"register\";s:23:\"visitors_admin_approval\";s:13:\"cancel_method\";s:17:\"user_cancel_block\";s:22:\"password_reset_timeout\";i:86400;s:17:\"password_strength\";b:1;s:8:\"langcode\";s:2:\"en\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"r4kwhOM0IWXVMUZDz744Yc16EOh37ZhYbA8kGOhSmLk\";}}'),('','views.settings',_binary 'a:6:{s:17:\"display_extenders\";a:0:{}s:10:\"skip_cache\";b:0;s:13:\"sql_signature\";b:0;s:2:\"ui\";a:3:{s:4:\"show\";a:7:{s:18:\"additional_queries\";b:0;s:15:\"advanced_column\";b:0;s:14:\"master_display\";b:0;s:22:\"performance_statistics\";b:1;s:19:\"preview_information\";b:1;s:9:\"sql_query\";a:2:{s:7:\"enabled\";b:1;s:5:\"where\";s:5:\"above\";}s:13:\"display_embed\";b:0;}s:19:\"always_live_preview\";b:1;s:24:\"exposed_filter_any_label\";s:7:\"old_any\";}s:22:\"field_rewrite_elements\";a:29:{s:3:\"div\";s:3:\"DIV\";s:4:\"span\";s:4:\"SPAN\";s:2:\"h1\";s:2:\"H1\";s:2:\"h2\";s:2:\"H2\";s:2:\"h3\";s:2:\"H3\";s:2:\"h4\";s:2:\"H4\";s:2:\"h5\";s:2:\"H5\";s:2:\"h6\";s:2:\"H6\";s:1:\"p\";s:1:\"P\";s:6:\"header\";s:6:\"HEADER\";s:6:\"footer\";s:6:\"FOOTER\";s:7:\"article\";s:7:\"ARTICLE\";s:7:\"section\";s:7:\"SECTION\";s:5:\"aside\";s:5:\"ASIDE\";s:7:\"details\";s:7:\"DETAILS\";s:10:\"blockquote\";s:10:\"BLOCKQUOTE\";s:6:\"figure\";s:6:\"FIGURE\";s:7:\"address\";s:7:\"ADDRESS\";s:4:\"code\";s:4:\"CODE\";s:3:\"pre\";s:3:\"PRE\";s:3:\"var\";s:3:\"VAR\";s:4:\"samp\";s:4:\"SAMP\";s:3:\"kbd\";s:3:\"KBD\";s:6:\"strong\";s:6:\"STRONG\";s:2:\"em\";s:2:\"EM\";s:3:\"del\";s:3:\"DEL\";s:3:\"ins\";s:3:\"INS\";s:1:\"q\";s:1:\"Q\";s:1:\"s\";s:1:\"S\";}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RaRd9EIcwA4u3qCSRLL8EnCicbda1kV__ASmVbyehvQ\";}}'),('','views.view.archive',_binary 'a:14:{s:4:\"uuid\";s:36:\"969da648-5dfb-4525-b549-1f4491e0cbf4\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SRH1EhxAiIRj01P9xYv0h_LfIfWxjll0Yq-eDfjziFI\";}s:2:\"id\";s:7:\"archive\";s:5:\"label\";s:7:\"Archive\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:22:\"All content, by month.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";}}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:13:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:12:\"title_enable\";b:1;s:5:\"title\";s:34:\"{{ arguments.created_year_month }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:10:\"sort_order\";s:4:\"desc\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:2:{s:8:\"override\";b:1;s:14:\"items_per_page\";i:30;}s:18:\"specify_validation\";b:1;s:9:\"plugin_id\";s:15:\"date_year_month\";s:11:\"entity_type\";s:4:\"node\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:13:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:12:\"title_enable\";b:1;s:5:\"title\";s:34:\"{{ arguments.created_year_month }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";i:30;}s:18:\"specify_validation\";b:1;s:9:\"plugin_id\";s:15:\"date_year_month\";s:11:\"entity_type\";s:4:\"node\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:2;s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"archive\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.block_content',_binary 'a:14:{s:4:\"uuid\";s:36:\"509e5844-fc48-4698-880e-985b043c408e\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"gkRJCqHr3uSO8ALHLatX-7YKfX0lWEgkC5qMBtCf_Sg\";}s:2:\"id\";s:13:\"block_content\";s:5:\"label\";s:20:\"Custom block library\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:30:\"Find and manage custom blocks.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:24:\"block_content_field_data\";s:10:\"base_field\";s:2:\"id\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:17:\"administer blocks\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:4:\"info\";s:4:\"info\";s:4:\"type\";s:4:\"type\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:4:{s:4:\"info\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:4:{s:4:\"info\";a:37:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:17:\"Block description\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";N;s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Block type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:7:\"changed\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:13:\"block_content\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:13:\"block_content\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:3:{s:4:\"info\";a:16:{s:2:\"id\";s:4:\"info\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"info\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:7:\"info_op\";s:5:\"label\";s:17:\"Block description\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"info_op\";s:10:\"identifier\";s:4:\"info\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"info\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:10:\"Block type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:8:\"reusable\";a:16:{s:2:\"id\";s:8:\"reusable\";s:5:\"table\";s:24:\"block_content_field_data\";s:5:\"field\";s:8:\"reusable\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:9:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:13:\"block_content\";s:12:\"entity_field\";s:8:\"reusable\";s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:20:\"Custom block library\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:2:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:37:\"There are no custom blocks available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}s:27:\"block_content_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:27:\"block_content_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:27:\"block_content_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:13:\"block_content\";s:9:\"plugin_id\";s:27:\"block_content_listing_empty\";s:11:\"entity_type\";s:13:\"block_content\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:35:\"admin/structure/block/block-content\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:20:\"Custom block library\";s:11:\"description\";s:0:\"\";s:6:\"parent\";s:19:\"block.admin_display\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.comment',_binary 'a:14:{s:4:\"uuid\";s:36:\"44e54189-22c3-4dd6-aecd-2cc361466496\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cCq1vjj1qmyd39oBIUyOe8YPDsobJ5fZRhp2Xy5O7lA\";}s:2:\"id\";s:7:\"comment\";s:5:\"label\";s:8:\"Comments\";s:6:\"module\";s:7:\"comment\";s:11:\"description\";s:25:\"Find and manage comments.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:18:\"comment_field_data\";s:10:\"base_field\";s:3:\"cid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:26:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"administer comments\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:5:\"first\";s:8:\"« first\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:6:{s:17:\"comment_bulk_form\";s:17:\"comment_bulk_form\";s:7:\"subject\";s:7:\"subject\";s:3:\"uid\";s:3:\"uid\";s:9:\"entity_id\";s:9:\"entity_id\";s:7:\"changed\";s:7:\"changed\";s:10:\"operations\";s:10:\"operations\";}s:4:\"info\";a:6:{s:17:\"comment_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"subject\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:3:\"uid\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"entity_id\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"operations\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:24:\"comment_unpublish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:5:\"sorts\";a:1:{s:7:\"changed\";a:13:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:8:\"Comments\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:22:\"No comments available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:4:\"more\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"group_by\";b:0;s:9:\"css_class\";s:0:\"\";s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:14:\"page_published\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:14:\"page_published\";s:13:\"display_title\";s:18:\"Published comments\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:21:\"admin/content/comment\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:8:\"Comments\";s:11:\"description\";s:18:\"Comments published\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}s:19:\"display_description\";s:30:\"The approved comments listing.\";s:17:\"display_extenders\";a:0:{}s:13:\"exposed_block\";b:0;s:15:\"display_comment\";s:0:\"\";}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:15:\"page_unapproved\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:15:\"page_unapproved\";s:13:\"display_title\";s:19:\"Unapproved comments\";s:8:\"position\";i:2;s:15:\"display_options\";a:8:{s:4:\"path\";s:30:\"admin/content/comment/approval\";s:4:\"menu\";a:7:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:19:\"Unapproved comments\";s:11:\"description\";s:19:\"Comments unapproved\";s:6:\"parent\";s:0:\"\";s:6:\"weight\";i:1;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}s:19:\"display_description\";s:32:\"The unapproved comments listing.\";s:7:\"filters\";a:4:{s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"subject\";a:16:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"subject_op\";s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"subject_op\";s:10:\"identifier\";s:7:\"subject\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:6:\"string\";}s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:11:\"Author Name\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:11:\"author_name\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:6:\"name_1\";s:6:\"name_1\";}s:9:\"plugin_id\";s:7:\"combine\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:8:\"defaults\";a:3:{s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;}s:17:\"display_extenders\";a:0:{}s:6:\"fields\";a:8:{s:17:\"comment_bulk_form\";a:26:{s:2:\"id\";s:17:\"comment_bulk_form\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:17:\"comment_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"action_title\";s:6:\"Action\";s:15:\"include_exclude\";s:7:\"include\";s:16:\"selected_actions\";a:2:{i:0;s:21:\"comment_delete_action\";i:1;s:22:\"comment_publish_action\";}s:9:\"plugin_id\";s:17:\"comment_bulk_form\";s:11:\"entity_type\";s:7:\"comment\";}s:7:\"subject\";a:37:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Subject\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:17:\"comment_permalink\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";s:9:\"plugin_id\";s:5:\"field\";}s:3:\"uid\";a:37:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:9:\"{{ uid }}\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:16:\"comment_username\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:9:\"entity_id\";a:37:{s:2:\"id\";s:9:\"entity_id\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:9:\"entity_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Posted in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:1;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:9:\"entity_id\";s:9:\"plugin_id\";s:16:\"commented_entity\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:6:\"name_1\";a:37:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:0;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:4:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:9:\"cacheable\";b:0;s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),('','views.view.comments_recent',_binary 'a:14:{s:4:\"uuid\";s:36:\"e1d6c846-7e7f-45e2-8242-2bd70c6eed1c\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:7:\"comment\";i:1;s:4:\"node\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"HacS-nsDH7uyoKhQHNyV_MNRClmPVuhU_fWZgNuEyIs\";}s:2:\"id\";s:15:\"comments_recent\";s:5:\"label\";s:15:\"Recent comments\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:16:\"Recent comments.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:18:\"comment_field_data\";s:10:\"base_field\";s:3:\"cid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:14:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:15:\"access comments\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:2:{s:22:\"default_field_elements\";b:1;s:10:\"hide_empty\";b:0;}}s:13:\"relationships\";a:1:{s:4:\"node\";a:5:{s:5:\"field\";s:4:\"node\";s:2:\"id\";s:4:\"node\";s:5:\"table\";s:18:\"comment_field_data\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:6:\"fields\";a:2:{s:7:\"subject\";a:26:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"subject\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:9:\"plugin_id\";s:5:\"field\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:15:\"@interval hence\";s:11:\"past_format\";s:13:\"@interval ago\";s:11:\"granularity\";i:2;}s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"changed\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:9:\"plugin_id\";s:7:\"boolean\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:6:\"status\";}s:11:\"status_node\";a:10:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"node\";s:2:\"id\";s:11:\"status_node\";s:9:\"plugin_id\";s:7:\"boolean\";s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"group\";i:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}}s:5:\"sorts\";a:2:{s:7:\"created\";a:12:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:7:\"created\";}s:3:\"cid\";a:11:{s:2:\"id\";s:3:\"cid\";s:5:\"table\";s:18:\"comment_field_data\";s:5:\"field\";s:3:\"cid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:7:\"comment\";s:12:\"entity_field\";s:3:\"cid\";}}s:5:\"title\";s:15:\"Recent comments\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:11:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:7:\"content\";s:22:\"No comments available.\";s:8:\"tokenize\";b:0;s:9:\"plugin_id\";s:11:\"text_custom\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:17:\"block_description\";s:15:\"Recent comments\";s:14:\"block_category\";s:13:\"Lists (Views)\";s:5:\"allow\";a:1:{s:14:\"items_per_page\";b:1;}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.content',_binary 'a:14:{s:4:\"uuid\";s:36:\"b41b4bd4-c008-45ad-9078-affdc821f445\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tS8PbpJX90aRFC3-UTgXzdqkq7_2frk2pz4TMijEebM\";}s:2:\"id\";s:7:\"content\";s:5:\"label\";s:7:\"Content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:24:\"Find and manage content.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:23:\"access content overview\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:50;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:10:{s:14:\"node_bulk_form\";s:14:\"node_bulk_form\";s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:7:\"changed\";s:7:\"changed\";s:9:\"edit_node\";s:9:\"edit_node\";s:11:\"delete_node\";s:11:\"delete_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";s:9:\"timestamp\";s:5:\"title\";}s:4:\"info\";a:10:{s:14:\"node_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:11:\"delete_node\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:7:{s:14:\"node_bulk_form\";a:14:{s:2:\"id\";s:14:\"node_bulk_form\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:14:\"node_bulk_form\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"node_bulk_form\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:17:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Content type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:17:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:17:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:9:\"Published\";s:19:\"format_custom_false\";s:11:\"Unpublished\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"changed\";a:17:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:1:{s:10:\"alter_text\";b:0;}s:13:\"element_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";}s:10:\"operations\";a:23:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:5:{s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Content type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"bundle\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:16:\"Published status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:9:\"Published\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:11:\"Unpublished\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}s:12:\"status_extra\";a:8:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:12:\"status_extra\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";b:0;s:9:\"plugin_id\";s:11:\"node_status\";s:5:\"group\";i:1;s:11:\"entity_type\";s:4:\"node\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:7:\"Content\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:21:\"No content available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"uid\";a:6:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}}s:16:\"show_admin_links\";b:0;s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:2:\"id\";s:7:\"default\";s:8:\"position\";i:0;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:21:\"user.node_grants:view\";i:6;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:15:\"display_options\";a:4:{s:4:\"path\";s:18:\"admin/content/node\";s:4:\"menu\";a:6:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:0:\"\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:7:\"Content\";s:11:\"description\";s:23:\"Find and manage content\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:2:\"id\";s:6:\"page_1\";s:8:\"position\";i:1;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:7:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:4:\"user\";i:5;s:21:\"user.node_grants:view\";i:6;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),('','views.view.content_recent',_binary 'a:14:{s:4:\"uuid\";s:36:\"bdd50755-73e5-47be-976b-ae900ccabe94\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sqwEJaSgef4rCaRMf-JdNAdV_kCICU1SfQh5Wl2sUrc\";}s:2:\"id\";s:14:\"content_recent\";s:5:\"label\";s:14:\"Recent content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:15:\"Recent content.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:22:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:2:{s:5:\"title\";a:26:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}}s:7:\"filters\";a:2:{s:12:\"status_extra\";a:15:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:12:\"status_extra\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";b:0;s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:11:\"node_status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}}s:5:\"sorts\";a:1:{s:7:\"changed\";a:13:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:4:\"date\";}}s:5:\"title\";s:14:\"Recent content\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:21:\"No content available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"More\";s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:1:\"0\";}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:4:\"user\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:1;s:15:\"display_options\";a:1:{s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:4:\"user\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.files',_binary 'a:14:{s:4:\"uuid\";s:36:\"0435a20c-c8f6-4a0b-9685-ac4cc90a84d6\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"file\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"rRWxAX-IQkJ5viACQRovRkC784EyCl9493GU_G23n2Q\";}s:2:\"id\";s:5:\"files\";s:5:\"label\";s:5:\"Files\";s:6:\"module\";s:4:\"file\";s:11:\"description\";s:22:\"Find and manage files.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:12:\"file_managed\";s:10:\"base_field\";s:3:\"fid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:21:\"access files overview\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:3:\"fid\";s:3:\"fid\";s:8:\"filename\";s:8:\"filename\";s:8:\"filemime\";s:8:\"filemime\";s:8:\"filesize\";s:8:\"filesize\";s:6:\"status\";s:6:\"status\";s:7:\"created\";s:7:\"created\";s:7:\"changed\";s:7:\"changed\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:8:{s:3:\"fid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filename\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:8:\"filemime\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:8:\"filesize\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:3:\"fid\";a:24:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"Fid\";s:7:\"exclude\";b:1;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}s:8:\"filename\";a:36:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Name\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"file_link\";s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:25:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"MIME type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"file_filemime\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:8:\"filesize\";a:25:{s:2:\"id\";s:8:\"filesize\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filesize\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Size\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"file_size\";s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filesize\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:19:\"format_custom_false\";s:9:\"Temporary\";s:18:\"format_custom_true\";s:9:\"Permanent\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Upload date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"created\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Changed date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:6:\"medium\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:7:\"changed\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:3:\"fid\";s:10:\"group_type\";s:3:\"sum\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Used in\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/content/files/usage/{{ fid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:1;s:20:\"format_plural_string\";s:21:\"1 place@count places\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:3:{s:8:\"filename\";a:16:{s:2:\"id\";s:8:\"filename\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filename\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:8:\"Filename\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filename_op\";s:10:\"identifier\";s:8:\"filename\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filename\";}s:8:\"filemime\";a:16:{s:2:\"id\";s:8:\"filemime\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:8:\"filemime\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:4:\"word\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:11:\"filemime_op\";s:5:\"label\";s:9:\"MIME type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"filemime_op\";s:10:\"identifier\";s:8:\"filemime\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:6:\"string\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:8:\"filemime\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:9:\"status_op\";s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"file_status\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:6:\"status\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:5:\"Files\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:19:\"No files available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:9:\"arguments\";a:0:{}s:8:\"group_by\";b:1;s:16:\"show_admin_links\";b:1;s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:14:\"Files overview\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:19:\"admin/content/files\";s:4:\"menu\";a:6:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:5:\"Files\";s:11:\"description\";s:0:\"\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:0;s:7:\"context\";s:0:\"\";}s:19:\"display_description\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"pager\";b:1;s:13:\"relationships\";b:0;}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:0;}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_2\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:10:\"File usage\";s:8:\"position\";i:2;s:15:\"display_options\";a:15:{s:19:\"display_description\";s:0:\"\";s:4:\"path\";s:27:\"admin/content/files/usage/%\";s:5:\"empty\";a:0:{}s:8:\"defaults\";a:11:{s:5:\"empty\";b:0;s:5:\"pager\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"fields\";b:0;s:8:\"group_by\";b:0;s:5:\"title\";b:0;s:9:\"arguments\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:13:\"relationships\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:2:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:7:\"filters\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:0:{}}s:6:\"fields\";a:4:{s:12:\"entity_label\";a:23:{s:2:\"id\";s:12:\"entity_label\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:12:\"entity_label\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Entity\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:14:\"link_to_entity\";b:1;s:9:\"plugin_id\";s:12:\"entity_label\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Entity type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:6:\"module\";a:22:{s:2:\"id\";s:6:\"module\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:6:\"module\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:18:\"Registering module\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:5:\"count\";a:30:{s:2:\"id\";s:5:\"count\";s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:5:\"count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Use count\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"group_by\";b:0;s:5:\"title\";s:10:\"File usage\";s:9:\"arguments\";a:1:{s:3:\"fid\";a:23:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:46:\"File usage information for {{ arguments.fid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:3:\"not\";b:0;s:9:\"plugin_id\";s:8:\"file_fid\";s:11:\"entity_type\";s:4:\"file\";s:12:\"entity_field\";s:3:\"fid\";}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:4:{s:12:\"entity_label\";s:12:\"entity_label\";s:4:\"type\";s:4:\"type\";s:6:\"module\";s:6:\"module\";s:5:\"count\";s:5:\"count\";}s:4:\"info\";a:4:{s:12:\"entity_label\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:6:\"module\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:5:\"count\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:12:\"entity_label\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:13:\"relationships\";a:1:{s:3:\"fid\";a:7:{s:2:\"id\";s:3:\"fid\";s:5:\"table\";s:12:\"file_managed\";s:5:\"field\";s:3:\"fid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:10:\"File usage\";s:8:\"required\";b:1;}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.frontpage',_binary 'a:14:{s:4:\"uuid\";s:36:\"13ca1035-59fd-489b-987d-488b35db0447\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:2:{i:0;s:30:\"core.entity_view_mode.node.rss\";i:1;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ezK5Dw8P_4bqJdDQIiecSAJak9p1Wf1yDwHzTutGFuQ\";}s:2:\"id\";s:9:\"frontpage\";s:5:\"label\";s:9:\"Frontpage\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:39:\"All content promoted to the front page.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"empty\";a:3:{s:16:\"area_text_custom\";a:11:{s:11:\"admin_label\";s:0:\"\";s:7:\"content\";s:181:\"No front page content has been created yet.<br/>Follow the <a target=\"_blank\" href=\"https://www.drupal.org/docs/user_guide/en/index.html\">User Guide</a> to start building your site.\";s:5:\"empty\";b:1;s:5:\"field\";s:16:\"area_text_custom\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:16:\"area_text_custom\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:5:\"views\";s:8:\"tokenize\";b:0;s:9:\"plugin_id\";s:11:\"text_custom\";}s:18:\"node_listing_empty\";a:10:{s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"field\";s:18:\"node_listing_empty\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:18:\"node_listing_empty\";s:5:\"label\";s:0:\"\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:4:\"node\";s:9:\"plugin_id\";s:18:\"node_listing_empty\";s:11:\"entity_type\";s:4:\"node\";}s:5:\"title\";a:10:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:5:\"empty\";b:1;s:5:\"title\";s:22:\"Welcome to [site:name]\";s:9:\"plugin_id\";s:5:\"title\";}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:7:\"filters\";a:3:{s:7:\"promote\";a:16:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:10:{s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"operator\";s:0:\"\";s:11:\"operator_id\";s:0:\"\";s:8:\"remember\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:8:\"required\";b:0;s:12:\"use_operator\";b:0;}s:7:\"exposed\";b:0;s:5:\"field\";s:7:\"promote\";s:5:\"group\";i:1;s:10:\"group_info\";a:10:{s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"description\";s:0:\"\";s:11:\"group_items\";a:0:{}s:10:\"identifier\";s:0:\"\";s:5:\"label\";s:0:\"\";s:8:\"multiple\";b:0;s:8:\"optional\";b:1;s:8:\"remember\";b:0;s:6:\"widget\";s:6:\"select\";}s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:7:\"promote\";s:10:\"is_grouped\";b:0;s:8:\"operator\";s:1:\"=\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"promote\";}s:6:\"status\";a:9:{s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}s:5:\"field\";s:6:\"status\";s:5:\"group\";i:1;s:2:\"id\";s:6:\"status\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"value\";s:1:\"1\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"status\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:8:\"quantity\";i:9;}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:12:{s:11:\"admin_label\";s:0:\"\";s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:7:\"exposed\";b:0;s:5:\"field\";s:6:\"sticky\";s:10:\"group_type\";s:5:\"group\";s:2:\"id\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:12:\"relationship\";s:4:\"none\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:6:\"sticky\";}s:7:\"created\";a:13:{s:5:\"field\";s:7:\"created\";s:2:\"id\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:5:\"table\";s:15:\"node_field_data\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:5:\"title\";s:0:\"\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:2:\"id\";s:7:\"default\";s:8:\"position\";i:0;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:14:\"url.query_args\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"feed_1\";a:6:{s:14:\"display_plugin\";s:4:\"feed\";s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:14:\"sitename_title\";b:1;s:4:\"path\";s:7:\"rss.xml\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:0:\"\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:3:\"rss\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:21:\"user.node_grants:view\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:15:\"display_options\";a:2:{s:4:\"path\";s:4:\"node\";s:17:\"display_extenders\";a:0:{}}s:14:\"display_plugin\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:2:\"id\";s:6:\"page_1\";s:8:\"position\";i:1;s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:14:\"url.query_args\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.ga_reports_page',_binary 'a:14:{s:4:\"uuid\";s:36:\"64a1de1e-195f-4d38-8c57-14a4bc8a9181\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:10:\"ga_reports\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"qcRlAYMa4PKQeB5UugTcREIac_H8F7fJyJBo1EBUyhQ\";}s:2:\"id\";s:15:\"ga_reports_page\";s:5:\"label\";s:16:\"Google Analytics\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:35:\"Display Google Analytics Statistics\";s:3:\"tag\";s:16:\"Google Analytics\";s:10:\"base_table\";s:2:\"ga\";s:10:\"base_field\";s:0:\"\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:6:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:31:\"access google analytics reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:5:\"table\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:7:{s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:15:\"uniquePageviews\";a:30:{s:2:\"id\";s:15:\"uniquePageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:15:\"uniquePageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:16:\"Unique Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:13:\"avgTimeOnPage\";a:25:{s:2:\"id\";s:13:\"avgTimeOnPage\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:13:\"avgTimeOnPage\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:17:\"Avg. Time on Page\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"i:s\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:9:\"entrances\";a:30:{s:2:\"id\";s:9:\"entrances\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"entrances\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Entrances\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:10:\"bounceRate\";a:30:{s:2:\"id\";s:10:\"bounceRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"bounceRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bounce Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:8:\"exitRate\";a:30:{s:2:\"id\";s:8:\"exitRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"exitRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Exit Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:9:\"pageValue\";a:30:{s:2:\"id\";s:9:\"pageValue\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageValue\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Page Value\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:1:\"$\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:29:\"Google Analytics Reports Page\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:24:\"This page was not viewed\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:33:\"<h2>This page was not viewed</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:39:\"Google Analytics details for front page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:23:\"attachment_top_keywords\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:23:\"attachment_top_keywords\";s:13:\"display_title\";s:12:\"Top Keywords\";s:8:\"position\";i:4;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:8:\"defaults\";a:9:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"sorts\";b:0;s:5:\"empty\";b:0;s:9:\"arguments\";b:0;s:6:\"header\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:6:\"fields\";a:2:{s:7:\"keyword\";a:22:{s:2:\"id\";s:7:\"keyword\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:7:\"keyword\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:8:\"displays\";a:2:{s:10:\"page_front\";s:10:\"page_front\";s:11:\"page_others\";s:11:\"page_others\";}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:18:\"Keywords not found\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:19:\"Keywords not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:38:\"Google Analytics details for \"%1\" page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:12:\"Top Keywords\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:21:\"<h2>Top Keywords</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:24:\"attachment_top_referrals\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:24:\"attachment_top_referrals\";s:13:\"display_title\";s:13:\"Top Referrals\";s:8:\"position\";i:4;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:8:\"defaults\";a:9:{s:5:\"style\";b:0;s:3:\"row\";b:0;s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"sorts\";b:0;s:5:\"empty\";b:0;s:9:\"arguments\";b:0;s:6:\"header\";b:0;}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:6:\"fields\";a:2:{s:6:\"source\";a:22:{s:2:\"id\";s:6:\"source\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"source\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:6:\"strong\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:1:\"0\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:1:\"0\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:1:\"0\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:3:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:6:\"medium\";a:14:{s:2:\"id\";s:6:\"medium\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"medium\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:8:\"referral\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:9:\"ga_string\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:8:\"displays\";a:2:{s:10:\"page_front\";s:10:\"page_front\";s:11:\"page_others\";s:11:\"page_others\";}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:19:\"Referrals not found\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"Referrals not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:38:\"Google Analytics details for \"%1\" page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:13:\"Top Referrals\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:22:\"<h2>Top Referrals</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:5:\"block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:6;s:15:\"display_options\";a:9:{s:17:\"display_extenders\";a:0:{}s:19:\"display_description\";s:0:\"\";s:5:\"title\";s:34:\"Page traffic over the past 30 days\";s:8:\"defaults\";a:5:{s:5:\"title\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:9:\"arguments\";b:0;s:5:\"empty\";b:0;}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:3:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:0:{}}s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:21:\"default_argument_type\";s:7:\"ga_path\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:33:\"Page doesn\'t have any statistics.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:17:\"block_description\";s:35:\"Google Analytics Reports Page Block\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:10:\"page_front\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:10:\"page_front\";s:13:\"display_title\";s:12:\"Page - Front\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:43:\"admin/reports/google-analytics-reports/page\";s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:11:\"page_others\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:11:\"page_others\";s:13:\"display_title\";s:13:\"Page - Others\";s:8:\"position\";i:3;s:15:\"display_options\";a:5:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:45:\"admin/reports/google-analytics-reports/page/%\";s:19:\"display_description\";s:0:\"\";s:9:\"arguments\";a:1:{s:8:\"pagePath\";a:19:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:60:\"Google Analytics details for \"{{ arguments.pagePath }}\" page\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"/\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:9:\"plugin_id\";s:11:\"ga_argument\";}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:3:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),('','views.view.ga_summary',_binary 'a:14:{s:4:\"uuid\";s:36:\"fs5ek9f7-ffd8-4bb4-a4b6-323187899236\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:17:\"system.menu.admin\";}s:6:\"module\";a:2:{i:0;s:10:\"ga_reports\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"cMHSU3DaAgwZnhwWwbba07iBHGBv5SiMazN3JSB9hl4\";}s:2:\"id\";s:10:\"ga_summary\";s:5:\"label\";s:24:\"Google Analytics Summary\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:74:\"Display summary statistic information about website from Google Analytics.\";s:3:\"tag\";s:24:\"Google Analytics Reports\";s:10:\"base_table\";s:2:\"ga\";s:10:\"base_field\";s:0:\"\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:6:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:31:\"access google analytics reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:1:{s:4:\"type\";s:11:\"views_query\";}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:5:\"table\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:7:{s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Sessions\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:5:\"users\";a:30:{s:2:\"id\";s:5:\"users\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:5:\"users\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Users\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:9:\"Pageviews\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:19:\"pageviewsPerSession\";a:30:{s:2:\"id\";s:19:\"pageviewsPerSession\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:19:\"pageviewsPerSession\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:15:\"Pages / Session\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:9:\"plugin_id\";s:7:\"numeric\";}s:18:\"avgSessionDuration\";a:25:{s:2:\"id\";s:18:\"avgSessionDuration\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:18:\"avgSessionDuration\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:21:\"Avg. Session Duration\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:3:\"i:s\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:10:\"bounceRate\";a:30:{s:2:\"id\";s:10:\"bounceRate\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"bounceRate\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bounce Rate\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}s:18:\"percentNewSessions\";a:30:{s:2:\"id\";s:18:\"percentNewSessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:18:\"percentNewSessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:14:\"% New Sessions\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:1:\"-\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:1;s:9:\"precision\";i:2;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:1:\"%\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:7:\"filters\";a:2:{s:10:\"start_date\";a:6:{s:2:\"id\";s:10:\"start_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:10:\"start_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:7:\"-31 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}s:8:\"end_date\";a:6:{s:2:\"id\";s:8:\"end_date\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"end_date\";s:5:\"value\";a:2:{s:4:\"type\";s:6:\"offset\";s:5:\"value\";s:6:\"-1 day\";}s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";s:0:\"\";}}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:24:\"Google Analytics Summary\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:9:\"css_class\";s:32:\"google-analytics-reports-summary\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:23:\"attachment_top_keywords\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:23:\"attachment_top_keywords\";s:13:\"display_title\";s:12:\"Top Keywords\";s:8:\"position\";i:4;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:8:\"displays\";a:1:{s:6:\"page_1\";s:6:\"page_1\";}s:6:\"fields\";a:2:{s:7:\"keyword\";a:22:{s:2:\"id\";s:7:\"keyword\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:7:\"keyword\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:30:\"<strong>{{ keyword }}</strong>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:8:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;}s:5:\"title\";s:0:\"\";s:9:\"css_class\";s:78:\"google-analytics-reports-summary google-analytics-reports-summary-top-keywords\";s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:16:\"Pages not found.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:16:\"Pages not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:12:\"Top Keywords\";s:5:\"empty\";b:0;s:8:\"tokenize\";b:0;s:7:\"content\";s:21:\"<h2>Top Keywords</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:20:\"attachment_top_pages\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:20:\"attachment_top_pages\";s:13:\"display_title\";s:9:\"Top Pages\";s:8:\"position\";i:2;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:8:\"displays\";a:1:{s:6:\"page_1\";s:6:\"page_1\";}s:6:\"fields\";a:3:{s:8:\"pagePath\";a:22:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageTitle\";a:22:{s:2:\"id\";s:9:\"pageTitle\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageTitle\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:44:\"<a href=\"{{ pagePath }}\">{{ pageTitle }}</a>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:6:\" views\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:8:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;}s:5:\"title\";s:0:\"\";s:9:\"css_class\";s:75:\"google-analytics-reports-summary google-analytics-reports-summary-top-pages\";s:5:\"sorts\";a:1:{s:9:\"pageviews\";a:10:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:16:\"Pages not found.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:16:\"Pages not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:9:\"Top Pages\";s:5:\"empty\";b:0;s:8:\"tokenize\";b:0;s:7:\"content\";s:18:\"<h2>Top Pages</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:22:\"attachment_top_sources\";a:6:{s:14:\"display_plugin\";s:10:\"attachment\";s:2:\"id\";s:22:\"attachment_top_sources\";s:13:\"display_title\";s:11:\"Top Sources\";s:8:\"position\";i:3;s:15:\"display_options\";a:14:{s:17:\"display_extenders\";a:0:{}s:8:\"displays\";a:1:{s:6:\"page_1\";s:6:\"page_1\";}s:6:\"fields\";a:3:{s:6:\"source\";a:22:{s:2:\"id\";s:6:\"source\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"source\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:32:\"<strong>{{ source }}</strong> - \";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:6:\"medium\";a:22:{s:2:\"id\";s:6:\"medium\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:6:\"medium\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"sessions\";a:30:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:2:\"- \";s:6:\"suffix\";s:9:\" sessions\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:8:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;}s:5:\"title\";s:0:\"\";s:9:\"css_class\";s:77:\"google-analytics-reports-summary google-analytics-reports-summary-top-sources\";s:5:\"sorts\";a:1:{s:8:\"sessions\";a:10:{s:2:\"id\";s:8:\"sessions\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"sessions\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:19:\"attachment_position\";s:5:\"after\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:16:\"Pages not found.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:16:\"Pages not found.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:11:\"Top Sources\";s:5:\"empty\";b:0;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"<h2>Top Sources</h2>\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:5:\"Block\";s:8:\"position\";i:5;s:15:\"display_options\";a:17:{s:17:\"display_extenders\";a:0:{}s:6:\"fields\";a:3:{s:8:\"pagePath\";a:22:{s:2:\"id\";s:8:\"pagePath\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:8:\"pagePath\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageTitle\";a:22:{s:2:\"id\";s:9:\"pageTitle\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageTitle\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:44:\"<a href=\"{{ pagePath }}\">{{ pageTitle }}</a>\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"pageviews\";a:30:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:1;s:10:\"empty_zero\";b:1;s:16:\"hide_alter_empty\";b:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\" \";s:13:\"format_plural\";b:0;s:20:\"format_plural_string\";s:8:\"1@count\";s:6:\"prefix\";s:3:\" - \";s:6:\"suffix\";s:6:\" views\";s:9:\"plugin_id\";s:7:\"numeric\";}}s:8:\"defaults\";a:14:{s:6:\"fields\";b:0;s:5:\"title\";b:0;s:9:\"css_class\";b:0;s:5:\"sorts\";b:0;s:5:\"style\";b:0;s:3:\"row\";b:0;s:5:\"empty\";b:0;s:6:\"header\";b:0;s:5:\"pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";b:0;s:12:\"link_display\";b:0;s:8:\"link_url\";b:0;}s:5:\"title\";s:31:\"Top pages over the last 30 days\";s:9:\"css_class\";s:38:\"google-analytics-reports-summary-block\";s:5:\"sorts\";a:1:{s:9:\"pageviews\";a:10:{s:2:\"id\";s:9:\"pageviews\";s:5:\"table\";s:2:\"ga\";s:5:\"field\";s:9:\"pageviews\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ol\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:22:\"default_field_elements\";b:0;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:5;s:6:\"offset\";i:0;}}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:33:\"Site doesn\'t have any statistics.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:33:\"Site doesn\'t have any statistics.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:6:\"header\";a:0:{}s:19:\"display_description\";s:0:\"\";s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:11:\"Full report\";s:12:\"link_display\";s:6:\"page_1\";s:8:\"link_url\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:46:\"admin/reports/google-analytics-reports/summary\";s:4:\"menu\";a:8:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:24:\"Google Analytics Summary\";s:11:\"description\";s:36:\"View a traffic report for your site.\";s:8:\"expanded\";b:0;s:6:\"parent\";s:20:\"system.admin_reports\";s:6:\"weight\";i:0;s:7:\"context\";s:1:\"0\";s:9:\"menu_name\";s:5:\"admin\";}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:2:{i:0;s:28:\"languages:language_interface\";i:1;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),('','views.view.glossary',_binary 'a:14:{s:4:\"uuid\";s:36:\"bbbb06c0-2d37-4f22-9554-be4d562c4786\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:0;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:16:\"system.menu.main\";}s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_12Vkw1VGBz_s0_W_LLVCrBPpioNSnB6zcd1lUAQubM\";}s:2:\"id\";s:8:\"glossary\";s:5:\"label\";s:8:\"Glossary\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:23:\"All content, by letter.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:8:\"use_ajax\";b:1;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:36;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:6:\"fields\";a:3:{s:5:\"title\";a:24:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:6:\"Author\";s:12:\"relationship\";s:3:\"uid\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:7:\"changed\";a:26:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:11:\"Last update\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:4:\"long\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:9:\"plugin_id\";s:5:\"field\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";}}s:9:\"arguments\";a:1:{s:5:\"title\";a:27:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"glossary\";b:1;s:5:\"limit\";i:1;s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";b:0;s:9:\"plugin_id\";s:6:\"string\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:0:{}s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:6:\"author\";s:8:\"required\";b:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:7:\"columns\";a:3:{s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:7:\"changed\";s:7:\"changed\";}s:7:\"default\";s:5:\"title\";s:4:\"info\";a:3:{s:5:\"title\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}s:7:\"changed\";a:2:{s:8:\"sortable\";b:1;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;s:5:\"order\";s:3:\"asc\";s:7:\"summary\";s:0:\"\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:6:\"fields\";s:7:\"options\";a:4:{s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";b:0;s:22:\"default_field_elements\";b:1;}}s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:5:\"sorts\";a:0:{}s:7:\"filters\";a:1:{s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:12:\"attachment_1\";a:6:{s:2:\"id\";s:12:\"attachment_1\";s:13:\"display_title\";s:10:\"Attachment\";s:14:\"display_plugin\";s:10:\"attachment\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:0;}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:5:\"title\";a:27:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";b:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:19:\"unformatted_summary\";}s:15:\"summary_options\";a:3:{s:14:\"items_per_page\";i:25;s:6:\"inline\";b:1;s:9:\"separator\";s:3:\" | \";}s:18:\"specify_validation\";b:1;s:8:\"glossary\";b:1;s:5:\"limit\";i:1;s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";b:0;s:9:\"plugin_id\";s:6:\"string\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:0:\"\";s:25:\"default_argument_skip_url\";b:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:12:\"break_phrase\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";}}s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:6:\"page_1\";s:6:\"page_1\";}s:17:\"inherit_arguments\";b:0;s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"glossary\";s:4:\"menu\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Glossary\";s:6:\"weight\";i:0;s:9:\"menu_name\";s:4:\"main\";s:6:\"parent\";s:0:\"\";}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.moderated_content',_binary 'a:14:{s:4:\"uuid\";s:36:\"f6f3c9f5-4596-47b7-84af-492bc8409347\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:18:\"content_moderation\";i:1;s:4:\"node\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"1UIjNd6iIhogbx50cJPDN7Me8cUQx2xCP2IBgrKG6Ms\";}s:2:\"id\";s:17:\"moderated_content\";s:5:\"label\";s:17:\"Moderated content\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:26:\"Find and moderate content.\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:19:\"node_field_revision\";s:10:\"base_field\";s:3:\"vid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:28:\"view any unpublished content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:5:{s:5:\"title\";s:5:\"title\";s:4:\"type\";s:4:\"type\";s:4:\"name\";s:4:\"name\";s:16:\"moderation_state\";s:16:\"moderation_state\";s:7:\"changed\";s:7:\"changed\";}s:4:\"info\";a:5:{s:5:\"title\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:16:\"moderation_state\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:7:\"changed\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"changed\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:6:{s:5:\"title\";a:37:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Title\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:6:\"string\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"type\";a:37:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:3:\"nid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:12:\"Content type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:9:\"target_id\";s:4:\"type\";s:22:\"entity_reference_label\";s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:12:\"group_column\";s:9:\"target_id\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Author\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:16:\"moderation_state\";a:36:{s:2:\"id\";s:16:\"moderation_state\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:16:\"Moderation state\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:24:\"content_moderation_state\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:5:\"field\";}s:7:\"changed\";a:37:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:7:\"changed\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Updated\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"timestamp\";s:8:\"settings\";a:3:{s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:7:\"changed\";s:9:\"plugin_id\";s:5:\"field\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:17:\"entity_operations\";}}s:7:\"filters\";a:6:{s:15:\"latest_revision\";a:15:{s:2:\"id\";s:15:\"latest_revision\";s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:15:\"latest_revision\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:15:\"latest_revision\";}s:5:\"title\";a:16:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:8:\"title_op\";s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:8:\"title_op\";s:10:\"identifier\";s:5:\"title\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:5:\"title\";s:9:\"plugin_id\";s:6:\"string\";}s:4:\"type\";a:16:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:3:\"nid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Content type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:4:\"type\";s:9:\"plugin_id\";s:6:\"bundle\";}s:16:\"moderation_state\";a:15:{s:2:\"id\";s:16:\"moderation_state\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:2:{s:15:\"editorial-draft\";s:15:\"editorial-draft\";s:18:\"editorial-archived\";s:18:\"editorial-archived\";}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:19:\"moderation_state_op\";s:5:\"label\";s:16:\"Moderation state\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:19:\"moderation_state_op\";s:10:\"identifier\";s:16:\"moderation_state\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:1;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:23:\"moderation_state_filter\";}s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"langcode_op\";s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"langcode_op\";s:10:\"identifier\";s:8:\"langcode\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";s:9:\"plugin_id\";s:8:\"language\";}s:18:\"moderation_state_1\";a:15:{s:2:\"id\";s:18:\"moderation_state_1\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:16:\"moderation_state\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:6:\"not in\";s:5:\"value\";a:1:{s:19:\"editorial-published\";s:19:\"editorial-published\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"node\";s:9:\"plugin_id\";s:23:\"moderation_state_filter\";}}s:5:\"sorts\";a:0:{}s:5:\"title\";s:17:\"Moderated content\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:98:\"No moderated content available. Only pending versions of content, such as drafts, are listed here.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:2:{s:3:\"nid\";a:10:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:3:\"nid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:47:\"Get the actual content from a content revision.\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"nid\";s:9:\"plugin_id\";s:8:\"standard\";}s:3:\"uid\";a:10:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:19:\"node_field_revision\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"User\";s:8:\"required\";b:0;s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:3:\"uid\";s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:20:\"config:workflow_list\";}}}s:17:\"moderated_content\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:17:\"moderated_content\";s:13:\"display_title\";s:17:\"Moderated content\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:23:\"admin/content/moderated\";s:19:\"display_description\";s:0:\"\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:6:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:21:\"user.node_grants:view\";i:5;s:16:\"user.permissions\";}s:4:\"tags\";a:1:{i:0;s:20:\"config:workflow_list\";}}}}}'),('','views.view.taxonomy_term',_binary 'a:14:{s:4:\"uuid\";s:36:\"c9844857-b656-434f-9b2e-b4fbe1a98e68\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:2:{s:6:\"config\";a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}s:6:\"module\";a:3:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";i:2;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"Gy5PaLdfFhtFSRqJxV-DBTF5AocKgNA2CsCNNEbvx4c\";}s:2:\"id\";s:13:\"taxonomy_term\";s:5:\"label\";s:13:\"Taxonomy term\";s:6:\"module\";s:8:\"taxonomy\";s:11:\"description\";s:45:\"Content belonging to a certain taxonomy term.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:15:\"node_field_data\";s:10:\"base_field\";s:3:\"nid\";s:4:\"core\";s:1:\"8\";s:7:\"display\";a:3:{s:7:\"default\";a:6:{s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;s:15:\"display_options\";a:18:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:13:\"query_comment\";s:0:\"\";s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:10:\"query_tags\";a:0:{}}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:10:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:8:\"standard\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:11:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";s:9:\"plugin_id\";s:4:\"date\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";}}s:9:\"arguments\";a:1:{s:3:\"tid\";a:23:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:3:\"tid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:3:{s:5:\"value\";s:0:\"\";s:12:\"title_enable\";b:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";b:1;s:5:\"title\";s:19:\"{{ arguments.tid }}\";s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:0:\"\";}s:25:\"default_argument_skip_url\";b:0;s:15:\"summary_options\";a:4:{s:9:\"base_path\";s:0:\"\";s:5:\"count\";b:1;s:14:\"items_per_page\";i:25;s:8:\"override\";b:0;}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:4:{s:6:\"access\";b:1;s:9:\"operation\";s:4:\"view\";s:8:\"multiple\";i:0;s:7:\"bundles\";a:0:{}}s:12:\"break_phrase\";b:0;s:9:\"add_table\";b:0;s:13:\"require_value\";b:0;s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:18:\"taxonomy_index_tid\";}}s:7:\"filters\";a:2:{s:8:\"langcode\";a:16:{s:2:\"id\";s:8:\"langcode\";s:5:\"table\";s:15:\"node_field_data\";s:5:\"field\";s:8:\"langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:31:\"***LANGUAGE_language_content***\";s:31:\"***LANGUAGE_language_content***\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:8:\"language\";s:11:\"entity_type\";s:4:\"node\";s:12:\"entity_field\";s:8:\"langcode\";}s:6:\"status\";a:14:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"boolean\";}}s:5:\"style\";a:2:{s:4:\"type\";s:7:\"default\";s:7:\"options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:7:\"options\";a:1:{s:9:\"view_mode\";s:6:\"teaser\";}}s:6:\"header\";a:1:{s:20:\"entity_taxonomy_term\";a:12:{s:2:\"id\";s:20:\"entity_taxonomy_term\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:20:\"entity_taxonomy_term\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:1;s:6:\"target\";s:23:\"{{ raw_arguments.tid }}\";s:9:\"view_mode\";s:4:\"full\";s:13:\"bypass_access\";b:0;s:9:\"plugin_id\";s:6:\"entity\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:17:\"display_extenders\";a:0:{}s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:6:\"page_1\";}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"feed_1\";a:6:{s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:2;s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:4:\"path\";s:20:\"taxonomy/term/%/feed\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";s:1:\"0\";}s:5:\"style\";a:2:{s:4:\"type\";s:3:\"rss\";s:7:\"options\";a:3:{s:11:\"description\";s:0:\"\";s:8:\"grouping\";a:0:{}s:11:\"uses_fields\";b:0;}}s:3:\"row\";a:2:{s:4:\"type\";s:8:\"node_rss\";s:7:\"options\";a:2:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:7:\"default\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:4:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:21:\"user.node_grants:view\";i:3;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"taxonomy/term/%\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:28:\"languages:language_interface\";i:1;s:3:\"url\";i:2;s:14:\"url.query_args\";i:3;s:21:\"user.node_grants:view\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.user_admin_people',_binary 'a:14:{s:4:\"uuid\";s:36:\"3aa0a697-db85-4dd5-8e95-ec0beebce912\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"wTJRNzsLVTenCALONNlVfgm_pBOlqucSPuVFLOD56ck\";}s:2:\"id\";s:17:\"user_admin_people\";s:5:\"label\";s:6:\"People\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:25:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:16:\"administer users\";}}s:5:\"cache\";a:1:{s:4:\"type\";s:3:\"tag\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";i:0;s:4:\"tags\";a:4:{s:8:\"previous\";s:12:\"‹ Previous\";s:4:\"next\";s:8:\"Next ›\";s:5:\"first\";s:8:\"« First\";s:4:\"last\";s:7:\"Last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:8:\"quantity\";i:9;}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:10:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"summary\";s:0:\"\";s:7:\"columns\";a:8:{s:14:\"user_bulk_form\";s:14:\"user_bulk_form\";s:4:\"name\";s:4:\"name\";s:6:\"status\";s:6:\"status\";s:3:\"rid\";s:3:\"rid\";s:7:\"created\";s:7:\"created\";s:6:\"access\";s:6:\"access\";s:9:\"edit_node\";s:9:\"edit_node\";s:10:\"dropbutton\";s:10:\"dropbutton\";}s:4:\"info\";a:8:{s:14:\"user_bulk_form\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:6:\"status\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:3:\"rid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"created\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:6:\"access\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:9:\"edit_node\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:10:\"dropbutton\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}}s:7:\"default\";s:7:\"created\";s:11:\"empty_table\";b:1;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:14:\"user_bulk_form\";a:23:{s:2:\"id\";s:14:\"user_bulk_form\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:14:\"user_bulk_form\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Bulk update\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:14:\"user_bulk_form\";s:11:\"entity_type\";s:4:\"user\";}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Username\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}s:6:\"status\";a:26:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:6:\"Status\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:7:\"boolean\";s:8:\"settings\";a:3:{s:6:\"format\";s:6:\"custom\";s:18:\"format_custom_true\";s:6:\"Active\";s:19:\"format_custom_false\";s:7:\"Blocked\";}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:15:\"roles_target_id\";a:24:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:5:\"Roles\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:9:\"plugin_id\";s:10:\"user_roles\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Member for\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:9:\"@interval\";s:11:\"past_format\";s:9:\"@interval\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}s:6:\"access\";a:26:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:11:\"Last access\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:4:\"type\";s:13:\"timestamp_ago\";s:8:\"settings\";a:3:{s:13:\"future_format\";s:15:\"@interval hence\";s:11:\"past_format\";s:13:\"@interval ago\";s:11:\"granularity\";i:2;}s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}s:10:\"operations\";a:24:{s:2:\"id\";s:10:\"operations\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:10:\"operations\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"destination\";b:1;s:11:\"entity_type\";s:4:\"user\";s:9:\"plugin_id\";s:17:\"entity_operations\";}s:4:\"mail\";a:37:{s:2:\"id\";s:4:\"mail\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"mail\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"basic_string\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:9:\"plugin_id\";s:5:\"field\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"mail\";}}s:7:\"filters\";a:6:{s:7:\"combine\";a:15:{s:2:\"id\";s:7:\"combine\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"combine\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:8:\"contains\";s:5:\"value\";s:0:\"\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:10:\"combine_op\";s:5:\"label\";s:22:\"Name or email contains\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:10:\"combine_op\";s:10:\"identifier\";s:4:\"user\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:6:\"fields\";a:2:{s:4:\"name\";s:4:\"name\";s:4:\"mail\";s:4:\"mail\";}s:9:\"plugin_id\";s:7:\"combine\";}s:6:\"status\";a:16:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"status_op\";s:10:\"identifier\";s:6:\"status\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:1;s:10:\"group_info\";a:10:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:6:\"status\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:2:{i:1;a:3:{s:5:\"title\";s:6:\"Active\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";}i:2;a:3:{s:5:\"title\";s:7:\"Blocked\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"0\";}}}s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:15:\"roles_target_id\";a:15:{s:2:\"id\";s:15:\"roles_target_id\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:15:\"roles_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:18:\"roles_target_id_op\";s:5:\"label\";s:4:\"Role\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:18:\"roles_target_id_op\";s:10:\"identifier\";s:4:\"role\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:10:\"user_roles\";}s:10:\"permission\";a:15:{s:2:\"id\";s:10:\"permission\";s:5:\"table\";s:11:\"user__roles\";s:5:\"field\";s:10:\"permission\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"or\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:13:\"permission_op\";s:5:\"label\";s:10:\"Permission\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:13:\"permission_op\";s:10:\"identifier\";s:10:\"permission\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:17:\"reduce_duplicates\";b:0;s:9:\"plugin_id\";s:16:\"user_permissions\";}s:16:\"default_langcode\";a:16:{s:2:\"id\";s:16:\"default_langcode\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:16:\"default_langcode\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:0:\"\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:16:\"default_langcode\";s:9:\"plugin_id\";s:7:\"boolean\";}s:7:\"uid_raw\";a:15:{s:2:\"id\";s:7:\"uid_raw\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"uid_raw\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"!=\";s:5:\"value\";a:3:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:1:\"0\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:1:\"0\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:7:\"numeric\";s:11:\"entity_type\";s:4:\"user\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"title\";s:6:\"People\";s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:20:\"No people available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:15:\"display_comment\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"show_admin_links\";b:1;s:8:\"group_by\";b:0;s:8:\"link_url\";s:0:\"\";s:12:\"link_display\";s:6:\"page_1\";s:9:\"css_class\";s:0:\"\";s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}s:6:\"page_1\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:6:{s:4:\"path\";s:17:\"admin/people/list\";s:16:\"show_admin_links\";b:0;s:4:\"menu\";a:6:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:4:\"List\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:-10;s:7:\"context\";s:0:\"\";}s:11:\"tab_options\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:6:\"People\";s:11:\"description\";s:45:\"Manage user accounts, roles, and permissions.\";s:9:\"menu_name\";s:5:\"admin\";s:6:\"weight\";i:0;}s:8:\"defaults\";a:1:{s:16:\"show_admin_links\";b:0;}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:7:\"max-age\";i:0;s:4:\"tags\";a:0:{}}}}}'),('','views.view.watchdog',_binary 'a:14:{s:4:\"uuid\";s:36:\"8e979f14-95c2-44a5-afc5-ccfc2417086d\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:5:\"dblog\";i:1;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"3QZ9apklK6mQ7BzodmxzOxqO---2BCPtOLE3k9eQ0Is\";}s:2:\"id\";s:8:\"watchdog\";s:5:\"label\";s:8:\"Watchdog\";s:6:\"module\";s:5:\"views\";s:11:\"description\";s:19:\"Recent log messages\";s:3:\"tag\";s:0:\"\";s:10:\"base_table\";s:8:\"watchdog\";s:10:\"base_field\";s:3:\"wid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:19:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:19:\"access site reports\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:6:\"Filter\";s:12:\"reset_button\";b:1;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:0;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"mini\";s:7:\"options\";a:6:{s:14:\"items_per_page\";i:50;s:6:\"offset\";i:0;s:2:\"id\";i:0;s:11:\"total_pages\";N;s:6:\"expose\";a:7:{s:14:\"items_per_page\";b:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:13:\"5, 10, 25, 50\";s:26:\"items_per_page_options_all\";b:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";b:0;s:12:\"offset_label\";s:6:\"Offset\";}s:4:\"tags\";a:2:{s:8:\"previous\";s:6:\"‹‹\";s:4:\"next\";s:6:\"››\";}}}s:5:\"style\";a:2:{s:4:\"type\";s:5:\"table\";s:7:\"options\";a:12:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:25:\"{{ type }} {{ severity }}\";s:17:\"default_row_class\";b:1;s:8:\"override\";b:1;s:6:\"sticky\";b:0;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"columns\";a:8:{s:7:\"nothing\";s:7:\"nothing\";s:3:\"wid\";s:3:\"wid\";s:8:\"severity\";s:8:\"severity\";s:4:\"type\";s:4:\"type\";s:9:\"timestamp\";s:9:\"timestamp\";s:7:\"message\";s:7:\"message\";s:4:\"name\";s:4:\"name\";s:4:\"link\";s:4:\"link\";}s:4:\"info\";a:8:{s:7:\"nothing\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:3:\"wid\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:8:\"severity\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:4:\"type\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:9:\"timestamp\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}s:7:\"message\";a:6:{s:8:\"sortable\";b:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:0:\"\";}s:4:\"name\";a:6:{s:8:\"sortable\";b:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:15:\"priority-medium\";}s:4:\"link\";a:4:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";b:0;s:10:\"responsive\";s:12:\"priority-low\";}}s:7:\"default\";s:3:\"wid\";s:11:\"empty_table\";b:0;}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:8:{s:7:\"nothing\";a:22:{s:2:\"id\";s:7:\"nothing\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:7:\"nothing\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"Icon\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:1;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:4:\"icon\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:0;s:9:\"plugin_id\";s:6:\"custom\";}s:3:\"wid\";a:22:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:3:\"WID\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:8:\"severity\";a:23:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:8:\"Severity\";s:7:\"exclude\";b:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:12:\"machine_name\";b:0;s:9:\"plugin_id\";s:12:\"machine_name\";}s:4:\"type\";a:22:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Type\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:8:\"standard\";}s:9:\"timestamp\";a:25:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:9:\"timestamp\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"Date\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:8:\"timezone\";s:0:\"\";s:9:\"plugin_id\";s:4:\"date\";}s:7:\"message\";a:23:{s:2:\"id\";s:7:\"message\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:7:\"message\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:7:\"Message\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:1;s:4:\"path\";s:35:\"admin/reports/dblog/event/{{ wid }}\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:13:\"{{ message }}\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:56;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:1;s:4:\"trim\";b:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"replace_variables\";b:1;s:9:\"plugin_id\";s:13:\"dblog_message\";}s:4:\"name\";a:37:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:4:\"User\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:9:\"user_name\";s:8:\"settings\";a:1:{s:14:\"link_to_entity\";b:1;}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";i:0;s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";b:0;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";s:9:\"plugin_id\";s:5:\"field\";}s:4:\"link\";a:22:{s:2:\"id\";s:4:\"link\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"label\";s:10:\"Operations\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";b:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";b:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";b:0;s:10:\"max_length\";i:0;s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:9:\"plugin_id\";s:16:\"dblog_operations\";}}s:7:\"filters\";a:2:{s:4:\"type\";a:14:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:4:\"Type\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"dblog_types\";}s:8:\"severity\";a:14:{s:2:\"id\";s:8:\"severity\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:8:\"severity\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:0:{}s:5:\"group\";i:1;s:7:\"exposed\";b:1;s:6:\"expose\";a:11:{s:11:\"operator_id\";s:11:\"severity_op\";s:5:\"label\";s:8:\"Severity\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:11:\"severity_op\";s:10:\"identifier\";s:8:\"severity\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:1;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:11:\"in_operator\";}}s:5:\"sorts\";a:1:{s:3:\"wid\";a:10:{s:2:\"id\";s:3:\"wid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"wid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:9:\"plugin_id\";s:8:\"standard\";}}s:5:\"title\";s:19:\"Recent log messages\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:4:\"area\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:26:\"No log messages available.\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:26:\"No log messages available.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:8:\"watchdog\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:4:\"User\";s:8:\"required\";b:0;s:9:\"plugin_id\";s:8:\"standard\";}}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:9:\"css_class\";s:11:\"admin-dblog\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}s:4:\"page\";a:6:{s:14:\"display_plugin\";s:4:\"page\";s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:8:\"position\";i:1;s:15:\"display_options\";a:2:{s:17:\"display_extenders\";a:0:{}s:4:\"path\";s:19:\"admin/reports/dblog\";}s:14:\"cache_metadata\";a:3:{s:7:\"max-age\";i:-1;s:8:\"contexts\";a:5:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:3:\"url\";i:3;s:14:\"url.query_args\";i:4;s:16:\"user.permissions\";}s:4:\"tags\";a:0:{}}}}}'),('','views.view.who_s_new',_binary 'a:14:{s:4:\"uuid\";s:36:\"248c0cf4-3881-404a-bc41-3269e0302465\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"o_8fSWHZOVIbydZACGsSX09DtuJhqkRmNOzcVj-4bQI\";}s:2:\"id\";s:9:\"who_s_new\";s:5:\"label\";s:9:\"Who\'s new\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:53:\"Shows a list of the newest user accounts on the site.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:14:\"access content\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:5;s:6:\"offset\";i:0;}}s:5:\"style\";a:1:{s:4:\"type\";s:9:\"html_list\";}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:0:\"\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:5:\"group\";i:1;s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:6:\"access\";a:16:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:1:\">\";s:5:\"value\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:10:\"1970-01-01\";s:4:\"type\";s:4:\"date\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:1:\"0\";s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{s:13:\"authenticated\";s:13:\"authenticated\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:13:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:7:\"created\";}}s:5:\"title\";s:9:\"Who\'s new\";s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:7:\"block_1\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:9:\"Who\'s new\";s:8:\"position\";i:1;s:15:\"display_options\";a:4:{s:19:\"display_description\";s:19:\"A list of new users\";s:17:\"block_description\";s:9:\"Who\'s new\";s:14:\"block_category\";s:4:\"User\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','views.view.who_s_online',_binary 'a:14:{s:4:\"uuid\";s:36:\"510cbdf1-d2b7-4bc9-96e9-c372ecb6d545\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"m0vmYmhrzMR6S_IC0UlK0Cl-q5lEvL8-EbxbbcDtk34\";}s:2:\"id\";s:12:\"who_s_online\";s:5:\"label\";s:18:\"Who\'s online block\";s:6:\"module\";s:4:\"user\";s:11:\"description\";s:93:\"Shows the user names of the most recently active users, and the total number of active users.\";s:3:\"tag\";s:7:\"default\";s:10:\"base_table\";s:16:\"users_field_data\";s:10:\"base_field\";s:3:\"uid\";s:4:\"core\";s:3:\"8.x\";s:7:\"display\";a:2:{s:7:\"default\";a:6:{s:14:\"display_plugin\";s:7:\"default\";s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:8:\"position\";i:0;s:15:\"display_options\";a:17:{s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:7:\"options\";a:1:{s:4:\"perm\";s:20:\"access user profiles\";}}s:5:\"cache\";a:2:{s:4:\"type\";s:3:\"tag\";s:7:\"options\";a:0:{}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:5:{s:19:\"disable_sql_rewrite\";b:0;s:8:\"distinct\";b:0;s:7:\"replica\";b:0;s:13:\"query_comment\";s:0:\"\";s:10:\"query_tags\";a:0:{}}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:7:{s:13:\"submit_button\";s:5:\"Apply\";s:12:\"reset_button\";b:0;s:18:\"reset_button_label\";s:5:\"Reset\";s:19:\"exposed_sorts_label\";s:7:\"Sort by\";s:17:\"expose_sort_order\";b:1;s:14:\"sort_asc_label\";s:3:\"Asc\";s:15:\"sort_desc_label\";s:4:\"Desc\";}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;}}s:5:\"style\";a:2:{s:4:\"type\";s:9:\"html_list\";s:7:\"options\";a:6:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";b:1;s:4:\"type\";s:2:\"ul\";s:13:\"wrapper_class\";s:9:\"item-list\";s:5:\"class\";s:0:\"\";}}s:3:\"row\";a:1:{s:4:\"type\";s:6:\"fields\";}s:6:\"fields\";a:1:{s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:0:\"\";s:9:\"plugin_id\";s:5:\"field\";s:4:\"type\";s:9:\"user_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";b:0;s:9:\"make_link\";b:0;s:8:\"absolute\";b:0;s:4:\"trim\";b:0;s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;s:10:\"strip_tags\";b:0;s:4:\"html\";b:0;}s:10:\"hide_empty\";b:0;s:10:\"empty_zero\";b:0;s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exclude\";b:0;s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:1;s:5:\"empty\";s:0:\"\";s:16:\"hide_alter_empty\";b:1;s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:4:\"name\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:5:\"value\";s:1:\"1\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";s:1:\"0\";}s:5:\"group\";i:1;s:9:\"plugin_id\";s:7:\"boolean\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"status\";}s:6:\"access\";a:16:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:8:\"operator\";s:2:\">=\";s:5:\"value\";a:4:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:5:\"value\";s:11:\"-15 minutes\";s:4:\"type\";s:6:\"offset\";}s:5:\"group\";i:1;s:7:\"exposed\";b:0;s:6:\"expose\";a:10:{s:11:\"operator_id\";s:9:\"access_op\";s:5:\"label\";s:11:\"Last access\";s:11:\"description\";s:77:\"A user is considered online for this long after they have last viewed a page.\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:9:\"access_op\";s:10:\"identifier\";s:6:\"access\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:3:{s:13:\"authenticated\";s:13:\"authenticated\";s:9:\"anonymous\";s:1:\"0\";s:13:\"administrator\";s:1:\"0\";}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";b:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"sorts\";a:1:{s:6:\"access\";a:13:{s:2:\"id\";s:6:\"access\";s:5:\"table\";s:16:\"users_field_data\";s:5:\"field\";s:6:\"access\";s:5:\"order\";s:4:\"DESC\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}s:11:\"granularity\";s:6:\"second\";s:9:\"plugin_id\";s:4:\"date\";s:11:\"entity_type\";s:4:\"user\";s:12:\"entity_field\";s:6:\"access\";}}s:5:\"title\";s:12:\"Who\'s online\";s:6:\"header\";a:1:{s:6:\"result\";a:9:{s:2:\"id\";s:6:\"result\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:6:\"result\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:0;s:7:\"content\";s:40:\"There are currently @total users online.\";s:9:\"plugin_id\";s:6:\"result\";}}s:6:\"footer\";a:0:{}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:10:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:11:\"admin_label\";s:0:\"\";s:5:\"empty\";b:1;s:8:\"tokenize\";b:0;s:7:\"content\";s:35:\"There are currently 0 users online.\";s:9:\"plugin_id\";s:11:\"text_custom\";}}s:13:\"relationships\";a:0:{}s:9:\"arguments\";a:0:{}s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}s:18:\"who_s_online_block\";a:6:{s:14:\"display_plugin\";s:5:\"block\";s:2:\"id\";s:18:\"who_s_online_block\";s:13:\"display_title\";s:12:\"Who\'s online\";s:8:\"position\";i:1;s:15:\"display_options\";a:3:{s:17:\"block_description\";s:12:\"Who\'s online\";s:19:\"display_description\";s:45:\"A list of users that are currently logged in.\";s:17:\"display_extenders\";a:0:{}}s:14:\"cache_metadata\";a:3:{s:8:\"contexts\";a:3:{i:0;s:26:\"languages:language_content\";i:1;s:28:\"languages:language_interface\";i:2;s:16:\"user.permissions\";}s:7:\"max-age\";i:-1;s:4:\"tags\";a:0:{}}}}}'),('','workflows.workflow.editorial',_binary 'a:9:{s:4:\"uuid\";s:36:\"20c79df6-385e-4ffd-bb07-65f3bb58d891\";s:8:\"langcode\";s:2:\"en\";s:6:\"status\";b:1;s:12:\"dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:18:\"content_moderation\";}}s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"T_JxNjYlfoRBi7Bj1zs5Xv9xv1btuBkKp5C1tNrjMhI\";}s:2:\"id\";s:9:\"editorial\";s:5:\"label\";s:9:\"Editorial\";s:4:\"type\";s:18:\"content_moderation\";s:13:\"type_settings\";a:3:{s:6:\"states\";a:3:{s:8:\"archived\";a:4:{s:5:\"label\";s:8:\"Archived\";s:6:\"weight\";i:5;s:9:\"published\";b:0;s:16:\"default_revision\";b:1;}s:5:\"draft\";a:4:{s:5:\"label\";s:5:\"Draft\";s:9:\"published\";b:0;s:16:\"default_revision\";b:0;s:6:\"weight\";i:-5;}s:9:\"published\";a:4:{s:5:\"label\";s:9:\"Published\";s:9:\"published\";b:1;s:16:\"default_revision\";b:1;s:6:\"weight\";i:0;}}s:11:\"transitions\";a:5:{s:7:\"archive\";a:4:{s:5:\"label\";s:7:\"Archive\";s:4:\"from\";a:1:{i:0;s:9:\"published\";}s:2:\"to\";s:8:\"archived\";s:6:\"weight\";i:2;}s:14:\"archived_draft\";a:4:{s:5:\"label\";s:16:\"Restore to Draft\";s:4:\"from\";a:1:{i:0;s:8:\"archived\";}s:2:\"to\";s:5:\"draft\";s:6:\"weight\";i:3;}s:18:\"archived_published\";a:4:{s:5:\"label\";s:7:\"Restore\";s:4:\"from\";a:1:{i:0;s:8:\"archived\";}s:2:\"to\";s:9:\"published\";s:6:\"weight\";i:4;}s:16:\"create_new_draft\";a:4:{s:5:\"label\";s:16:\"Create New Draft\";s:2:\"to\";s:5:\"draft\";s:6:\"weight\";i:0;s:4:\"from\";a:2:{i:0;s:5:\"draft\";i:1;s:9:\"published\";}}s:7:\"publish\";a:4:{s:5:\"label\";s:7:\"Publish\";s:2:\"to\";s:9:\"published\";s:6:\"weight\";i:1;s:4:\"from\";a:2:{i:0;s:5:\"draft\";i:1;s:9:\"published\";}}}s:12:\"entity_types\";a:0:{}}}'),('','yg_business_one.settings',_binary 'a:11:{s:4:\"logo\";a:2:{s:4:\"path\";s:31:\"themes/yg_business_one/logo.png\";s:11:\"use_default\";b:0;}s:8:\"facebook\";s:24:\"https://www.facebook.com\";s:7:\"twitter\";s:23:\"https://www.twitter.com\";s:10:\"googleplus\";s:23:\"https://plus.google.com\";s:9:\"instagram\";s:25:\"https://www.instagram.com\";s:8:\"linkedin\";s:24:\"https://www.linkedin.com\";s:8:\"pintrest\";s:25:\"https://www.pinterest.com\";s:24:\"yg_business_one_Template\";s:1:\"#\";s:17:\"drupal_developers\";s:39:\"https://www.drupaldevelopersstudio.com/\";s:11:\"youngglobes\";s:28:\"https://www.youngglobes.com/\";s:5:\"_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eL_ntRe9iEHJgGqLrM7zOUw16rde-BDRWgsbYndvtaQ\";}}');
/*!40000 ALTER TABLE `config` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `content_moderation_state`
--

DROP TABLE IF EXISTS `content_moderation_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `content_moderation_state` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `revision_id` int(10) unsigned DEFAULT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `content_moderation_state_field__uuid__value` (`uuid`),
  UNIQUE KEY `content_moderation_state__revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for content_moderation_state entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `content_moderation_state`
--

LOCK TABLES `content_moderation_state` WRITE;
/*!40000 ALTER TABLE `content_moderation_state` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `content_moderation_state` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `content_moderation_state_field_data`
--

DROP TABLE IF EXISTS `content_moderation_state_field_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `content_moderation_state_field_data` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `workflow` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `moderation_state` varchar(255) DEFAULT NULL,
  `content_entity_type_id` varchar(32) DEFAULT NULL,
  `content_entity_id` int(11) DEFAULT NULL,
  `content_entity_revision_id` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`id`,`langcode`),
  UNIQUE KEY `content_moderation_state__lookup` (`content_entity_type_id`,`content_entity_id`,`content_entity_revision_id`,`workflow`,`langcode`),
  KEY `content_moderation_state__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `content_moderation_state__revision_id` (`revision_id`),
  KEY `content_moderation_state_field__uid__target_id` (`uid`),
  KEY `content_moderation_state__09628d8dbc` (`workflow`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for content_moderation_state entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `content_moderation_state_field_data`
--

LOCK TABLES `content_moderation_state_field_data` WRITE;
/*!40000 ALTER TABLE `content_moderation_state_field_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `content_moderation_state_field_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `content_moderation_state_field_revision`
--

DROP TABLE IF EXISTS `content_moderation_state_field_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `content_moderation_state_field_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `workflow` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The ID of the target entity.',
  `moderation_state` varchar(255) DEFAULT NULL,
  `content_entity_type_id` varchar(32) DEFAULT NULL,
  `content_entity_id` int(11) DEFAULT NULL,
  `content_entity_revision_id` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`revision_id`,`langcode`),
  UNIQUE KEY `content_moderation_state__lookup` (`content_entity_type_id`,`content_entity_id`,`content_entity_revision_id`,`workflow`,`langcode`),
  KEY `content_moderation_state__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `content_moderation_state_field__uid__target_id` (`uid`),
  KEY `content_moderation_state__09628d8dbc` (`workflow`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision data table for content_moderation_state…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `content_moderation_state_field_revision`
--

LOCK TABLES `content_moderation_state_field_revision` WRITE;
/*!40000 ALTER TABLE `content_moderation_state_field_revision` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `content_moderation_state_field_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `content_moderation_state_revision`
--

DROP TABLE IF EXISTS `content_moderation_state_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `content_moderation_state_revision` (
  `id` int(10) unsigned NOT NULL,
  `revision_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `revision_default` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`revision_id`),
  KEY `content_moderation_state__id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for content_moderation_state entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `content_moderation_state_revision`
--

LOCK TABLES `content_moderation_state_revision` WRITE;
/*!40000 ALTER TABLE `content_moderation_state_revision` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `content_moderation_state_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `file_managed`
--

DROP TABLE IF EXISTS `file_managed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_managed` (
  `fid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `filename` varchar(255) DEFAULT NULL,
  `uri` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_bin NOT NULL,
  `filemime` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `filesize` bigint(20) unsigned DEFAULT NULL,
  `status` tinyint(4) NOT NULL,
  `created` int(11) DEFAULT NULL,
  `changed` int(11) NOT NULL,
  PRIMARY KEY (`fid`),
  UNIQUE KEY `file_field__uuid__value` (`uuid`),
  KEY `file_field__uid__target_id` (`uid`),
  KEY `file_field__uri` (`uri`(191)),
  KEY `file_field__status` (`status`),
  KEY `file_field__changed` (`changed`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for file entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_managed`
--

LOCK TABLES `file_managed` WRITE;
/*!40000 ALTER TABLE `file_managed` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `file_managed` VALUES (1,'03a7c1e8-cdea-4f7c-94ab-f44d55687eab','en',1,'logo_w.png','public://2018-08/logo_w.png','image/png',6544,1,1534758915,1534758928),(3,'1c56a1ad-c2ad-4aa4-98ec-f4648e51fece','en',1,'about_1.jpg','public://inline-images/about_1.jpg','image/jpeg',58806,1,1538573762,1538573979),(4,'f51a3df9-bfc6-451e-b38d-7523930719ec','en',1,'img_1.jpg','public://inline-images/img_1.jpg','image/jpeg',150751,1,1540192320,1540192381),(5,'4346c3bb-8bc4-4c61-b2fc-bca96d3a9f45','en',1,'scale.png','public://inline-images/scale.png','image/png',2206,1,1540199780,1540199860),(6,'f8c9d2a8-165a-439d-9624-20e7b600dfe1','en',1,'img_team_1.jpg','public://inline-images/img_team_1.jpg','image/jpeg',89297,1,1540200756,1540200865),(7,'aa57822e-ae19-42c8-8b78-1358c1b16b9c','en',1,'img_team_2.jpg','public://inline-images/img_team_2_0.jpg','image/jpeg',140572,1,1540202035,1540202076);
/*!40000 ALTER TABLE `file_managed` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `file_usage`
--

DROP TABLE IF EXISTS `file_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_usage` (
  `fid` int(10) unsigned NOT NULL COMMENT 'File ID.',
  `module` varchar(50) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The name of the module that is using the file.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The name of the object type in which the file is used.',
  `id` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '0' COMMENT 'The primary key of the object using the file.',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The number of times this file is used by this object.',
  PRIMARY KEY (`fid`,`type`,`id`,`module`),
  KEY `type_id` (`type`,`id`),
  KEY `fid_count` (`fid`,`count`),
  KEY `fid_module` (`fid`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Track where a file is used.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_usage`
--

LOCK TABLES `file_usage` WRITE;
/*!40000 ALTER TABLE `file_usage` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `file_usage` VALUES (3,'editor','block_content','4',4),(4,'editor','block_content','7',1),(5,'editor','block_content','8',5),(6,'editor','block_content','9',2),(7,'editor','block_content','9',1);
/*!40000 ALTER TABLE `file_usage` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `flood`
--

DROP TABLE IF EXISTS `flood`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flood` (
  `fid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique flood event ID.',
  `event` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Name of event (e.g. contact).',
  `identifier` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Identifier of the visitor, such as an IP address or hostname.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of the event.',
  `expiration` int(11) NOT NULL DEFAULT '0' COMMENT 'Expiration timestamp. Expired events are purged on cron run.',
  PRIMARY KEY (`fid`),
  KEY `allow` (`event`,`identifier`,`timestamp`),
  KEY `purge` (`expiration`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Flood controls the threshold of events, such as the number…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flood`
--

LOCK TABLES `flood` WRITE;
/*!40000 ALTER TABLE `flood` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `flood` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ga_reports_fields`
--

DROP TABLE IF EXISTS `ga_reports_fields`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ga_reports_fields` (
  `gaid` varchar(128) NOT NULL DEFAULT '' COMMENT 'The primary identifier for a column.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The type of column.',
  `data_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The type of data this column represents.',
  `column_group` varchar(128) NOT NULL DEFAULT '' COMMENT 'The dimensions/metrics group the column belongs to.',
  `ui_name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The name/label of the column used in user interfaces (UI).',
  `description` mediumtext COMMENT 'The full description of the column.',
  `calculation` varchar(128) DEFAULT NULL COMMENT 'This shows how the metric is calculated. Only available for calculated metrics.',
  PRIMARY KEY (`gaid`),
  UNIQUE KEY `gaid` (`gaid`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Dimensions and metrics from Google Analytics.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ga_reports_fields`
--

LOCK TABLES `ga_reports_fields` WRITE;
/*!40000 ALTER TABLE `ga_reports_fields` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `ga_reports_fields` VALUES ('14dayUsers','metric','integer','User','14 Day Active Users','Total number of 14-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 14-day period ending on the given date.',NULL),('1dayUsers','metric','integer','User','1 Day Active Users','Total number of 1-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 1-day period ending on the given date.',NULL),('28dayUsers','metric','integer','User','28 Day Active Users','Total number of 28-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 28-day period ending on the given date.',NULL),('30dayUsers','metric','integer','User','30 Day Active Users','Total number of 30-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 30-day period ending on the given date.',NULL),('7dayUsers','metric','integer','User','7 Day Active Users','Total number of 7-day active users for each day in the requested time period. At least one of ga:nthDay, ga:date, or ga:day must be specified as a dimension to query this metric. For a given date, the returned value will be the total number of unique users for the 7-day period ending on the given date.',NULL),('acquisitionCampaign','dimension','string','Lifetime Value and Cohorts','Acquisition Campaign','The campaign through which users were acquired, derived from users\' first session.',NULL),('acquisitionMedium','dimension','string','Lifetime Value and Cohorts','Acquisition Medium','The medium through which users were acquired, derived from users\' first session.',NULL),('acquisitionSource','dimension','string','Lifetime Value and Cohorts','Acquisition Source','The source through which users were acquired, derived from users\' first session.',NULL),('acquisitionSourceMedium','dimension','string','Lifetime Value and Cohorts','Acquisition Source / Medium','The combined value of ga:userAcquisitionSource and ga:acquisitionMedium.',NULL),('acquisitionTrafficChannel','dimension','string','Lifetime Value and Cohorts','Acquisition Channel','Traffic channel through which users were acquired. It is extracted from users\' first session. Traffic channel is computed based on the default channel grouping rules (at view level if available) at the time of user acquisition.',NULL),('adClicks','metric','integer','Adwords','Clicks','Total number of times users have clicked on an ad to reach the property.',NULL),('adContent','dimension','string','Traffic Sources','Ad Content','For manual campaign tracking, it is the value of the utm_content campaign tracking parameter. For AdWords autotagging, it is the first line of the text for the online Ad campaign. If you use mad libs for the AdWords content, it contains the keywords you provided for the mad libs keyword match. If you use none of the above, its value is (not set).',NULL),('adCost','metric','currency','Adwords','Cost','Derived cost for the advertising campaign. Its currency is the one you set in the AdWords account.',NULL),('adDestinationUrl','dimension','string','Adwords','Destination URL','The URL to which the AdWords ads referred traffic.',NULL),('adDisplayUrl','dimension','string','Adwords','Display URL','The URL the AdWords ads displayed.',NULL),('adDistributionNetwork','dimension','string','Adwords','Ad Distribution Network','The network (Content, Search, Search partners, etc.) used to deliver the ads.',NULL),('adFormat','dimension','string','Adwords','Ad Format','The AdWords ad format (Text, Image, Flash, Video, etc.).',NULL),('adGroup','dimension','string','Adwords','Google Ads: Ad Group','The name of the AdWords ad group.',NULL),('adKeywordMatchType','dimension','string','Adwords','Keyword Match Type','The match type (Phrase, Exact, or Broad) applied to the keywords. For details, see https://support.google.com/adwords/answer/2472708.',NULL),('adMatchedQuery','dimension','string','Adwords','Search Query','The search query that triggered impressions.',NULL),('adMatchType','dimension','string','Adwords','Query Match Type','The match type (Phrase, Exact, Broad, etc.) applied for users\' search term. Ads on the content network are identified as \"Content network\". For details, see https://support.google.com/adwords/answer/2472708?hl=en.',NULL),('adPlacementDomain','dimension','string','Adwords','Placement Domain','The domain where the ads on the content network were placed.',NULL),('adPlacementUrl','dimension','string','Adwords','Placement URL','The URL where the ads were placed on the content network.',NULL),('adQueryWordCount','dimension','string','Adwords','Query Word Count','The number of words in the search query.',NULL),('adsenseAdsClicks','metric','integer','Adsense','AdSense Ads Clicked','The number of times AdSense ads on the site were clicked (requires integration with AdSense).',NULL),('adsenseAdsViewed','metric','integer','Adsense','AdSense Impressions','The number of AdSense ads viewed (requires integration with AdSense). Multiple ads can be displayed within an ad Unit.',NULL),('adsenseAdUnitsViewed','metric','integer','Adsense','AdSense Ad Units Viewed','The number of AdSense ad units viewed (requires integration with AdSense). An ad unit is a set of ads displayed as a result of one piece of the AdSense ad code. For details, see https://support.google.com/adsense/answer/32715?hl=en.',NULL),('adsenseCoverage','metric','percent','Adsense','AdSense Coverage','The percentage of ad requests that returned at least one ad (requires integration with AdSense).',NULL),('adsenseCTR','metric','percent','Adsense','AdSense CTR','The percentage of page impressions resulted in a click on an AdSense ad (requires integration with AdSense).','ga:adsenseAdsClicks/ga:adsensePageImpressions'),('adsenseECPM','metric','currency','Adsense','AdSense eCPM','The estimated cost per thousand page impressions (requires integration with AdSense). It is the AdSense Revenue per 1,000 page impressions.','ga:adsenseRevenue/(ga:adsensePageImpressions/1000)'),('adsenseExits','metric','integer','Adsense','AdSense Exits','The number of sessions ended due to a user clicking on an AdSense ad (requires integration with AdSense).',NULL),('adsensePageImpressions','metric','integer','Adsense','AdSense Page Impressions','The number of pageviews during which an AdSense ad was displayed (requires integration with AdSense). A page impression can have multiple ad Units.',NULL),('adsenseRevenue','metric','currency','Adsense','AdSense Revenue','The total revenue from AdSense ads.',NULL),('adsenseViewableImpressionPercent','metric','percent','Adsense','AdSense Viewable Impression %','The percentage of viewable impressions (requires integration with AdSense).',NULL),('adSlot','dimension','string','Adwords','Google Ads: Ad Slot','The location (Top, RHS, or not set) of the advertisement on the hosting page.',NULL),('adTargetingOption','dimension','string','Adwords','Placement Type','It is Automatic placements or Managed placements, indicating how the ads were managed on the content network.',NULL),('adTargetingType','dimension','string','Adwords','Targeting Type','This (keyword, placement, or vertical targeting) indicates how the AdWords ads were targeted.',NULL),('adwordsAdGroupID','dimension','string','Adwords','Google Ads Ad Group ID','AdWords API AdGroup.id.',NULL),('adwordsCampaignID','dimension','string','Adwords','Google Ads Campaign ID','AdWords API Campaign.id.',NULL),('adwordsCreativeID','dimension','string','Adwords','Google Ads Creative ID','AdWords API Ad.id.',NULL),('adwordsCriteriaID','dimension','string','Adwords','Google Ads Criteria ID','AdWords API Criterion.id. The geographical targeting Criteria IDs are listed at https://developers.google.com/analytics/devguides/collection/protocol/v1/geoid.',NULL),('adwordsCustomerID','dimension','string','Adwords','Google Ads Customer ID','Customer\'s AdWords ID, corresponding to AdWords API AccountInfo.customerId.',NULL),('adxClicks','metric','integer','Ad Exchange','AdX Clicks','The number of times AdX ads were clicked on the site.',NULL),('adxCoverage','metric','percent','Ad Exchange','AdX Coverage','Coverage is the percentage of ad requests that returned at least one ad. Generally, coverage can help identify sites where the Ad Exchange account isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100',NULL),('adxCTR','metric','percent','Ad Exchange','AdX CTR','The percentage of pageviews that resulted in a click on an Ad Exchange ad.',NULL),('adxECPM','metric','currency','Ad Exchange','AdX eCPM','The effective cost per thousand pageviews. It is the Ad Exchange revenue per 1,000 pageviews.',NULL),('adxImpressions','metric','integer','Ad Exchange','AdX Impressions','An Ad Exchange ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions.',NULL),('adxImpressionsPerSession','metric','float','Ad Exchange','AdX Impressions / Session','The ratio of Ad Exchange ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions).',NULL),('adxMonetizedPageviews','metric','integer','Ad Exchange','AdX Monetized Pageviews','This measures the total number of pageviews on the property that were shown with an ad from the linked Ad Exchange account. Note that a single page can have multiple ad units.',NULL),('adxRevenue','metric','currency','Ad Exchange','AdX Revenue','The total estimated revenue from Ad Exchange ads.',NULL),('adxRevenuePer1000Sessions','metric','currency','Ad Exchange','AdX Revenue / 1000 Sessions','The total estimated revenue from Ad Exchange ads per 1,000 Analytics sessions. Note that this metric is based on sessions to the site, not on ad impressions.',NULL),('adxViewableImpressionsPercent','metric','percent','Ad Exchange','AdX Viewable Impressions %','The percentage of viewable ad impressions. An impression is considered a viewable impression when it has appeared within users\' browsers and has the opportunity to be seen.',NULL),('affiliation','dimension','string','Ecommerce','Affiliation','A product affiliation to designate a supplying company or brick and mortar location.',NULL),('appId','dimension','string','App Tracking','App ID','The application ID.',NULL),('appInstallerId','dimension','string','App Tracking','App Installer ID','The ID of the app installer (e.g., Google Play Store) from which the app was downloaded. By default, the app installer ID is set by the PackageManager#getInstallerPackageName method.',NULL),('appName','dimension','string','App Tracking','App Name','The application name.',NULL),('appVersion','dimension','string','App Tracking','App Version','The application version.',NULL),('avgDomainLookupTime','metric','float','Site Speed','Avg. Domain Lookup Time (sec)','The average time (in seconds) spent in DNS lookup for this page.','(ga:domainLookupTime / ga:speedMetricsSample / 1000)'),('avgDomContentLoadedTime','metric','float','Site Speed','Avg. Document Content Loaded Time (sec)','The average time (in seconds) the browser takes to parse the document.','(ga:domContentLoadedTime / ga:domLatencyMetricsSample / 1000)'),('avgDomInteractiveTime','metric','float','Site Speed','Avg. Document Interactive Time (sec)','The average time (in seconds), including the network time from users\' locations to the site\'s server, the browser takes to parse the document and execute deferred and parser-inserted scripts.','(ga:domInteractiveTime / ga:domLatencyMetricsSample / 1000)'),('avgEventValue','metric','float','Event Tracking','Avg. Value','The average value of an event.','ga:eventValue / ga:totalEvents'),('avgPageDownloadTime','metric','float','Site Speed','Avg. Page Download Time (sec)','The average time (in seconds) to download this page.','(ga:pageDownloadTime / ga:speedMetricsSample / 1000)'),('avgPageLoadTime','metric','float','Site Speed','Avg. Page Load Time (sec)','The average time (in seconds) pages from the sample set take to load, from initiation of the pageview (e.g., a click on a page link) to load completion in the browser.','(ga:pageLoadTime / ga:pageLoadSample / 1000)'),('avgRedirectionTime','metric','float','Site Speed','Avg. Redirection Time (sec)','The average time (in seconds) spent in redirects before fetching this page. If there are no redirects, this is 0.','(ga:redirectionTime / ga:speedMetricsSample / 1000)'),('avgScreenviewDuration','metric','time','App Tracking','Avg. Time on Screen','Average time (in seconds) users spent on a screen.',NULL),('avgSearchDepth','metric','float','Internal Search','Avg. Search Depth','The average number of pages people viewed after performing a search.','ga:searchDepth / ga:searchUniques'),('avgSearchDuration','metric','time','Internal Search','Time after Search','The average time (in seconds) users, after searching, spent on the property.','ga:searchDuration / ga:searchUniques'),('avgSearchResultViews','metric','float','Internal Search','Results Pageviews / Search','The average number of times people viewed a page as a result of a search.','ga:searchResultViews / ga:searchUniques'),('avgServerConnectionTime','metric','float','Site Speed','Avg. Server Connection Time (sec)','The average time (in seconds) spent in establishing a TCP connection to this page.','(ga:serverConnectionTime / ga:speedMetricsSample / 1000)'),('avgServerResponseTime','metric','float','Site Speed','Avg. Server Response Time (sec)','The average time (in seconds) the site\'s server takes to respond to users\' requests; this includes the network time from users\' locations to the server.','(ga:serverResponseTime / ga:speedMetricsSample / 1000)'),('avgSessionDuration','metric','time','Session','Avg. Session Duration','The average duration (in seconds) of users\' sessions.','ga:sessionDuration / ga:sessions'),('avgTimeOnPage','metric','time','Page Tracking','Avg. Time on Page','The average time users spent viewing this page or a set of pages.','ga:timeOnPage / (ga:pageviews - ga:exits)'),('avgUserTimingValue','metric','float','User Timings','Avg. User Timing (sec)','The average elapsed time.','(ga:userTimingValue / ga:userTimingSample / 1000)'),('backfillClicks','metric','integer','DoubleClick for Publishers Backfill','GAM Backfill Clicks','The number of times backfill ads were clicked on the site. If AdSense and Ad Exchange are both providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillCoverage','metric','percent','DoubleClick for Publishers Backfill','GAM Backfill Coverage','Backfill Coverage is the percentage of backfill ad requests that returned at least one ad. Generally, coverage can help identify sites where the publisher account isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100. If both AdSense and Ad Exchange are providing backfill ads, this metric is the weighted average of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillCTR','metric','percent','DoubleClick for Publishers Backfill','GAM Backfill CTR','The percentage of backfill impressions that resulted in a click on an ad. If AdSense and Ad Exchange are both providing backfill ads, this metric is the weighted average of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillECPM','metric','currency','DoubleClick for Publishers Backfill','GAM Backfill eCPM','The effective cost per thousand pageviews. It is the DFP Backfill Revenue per 1,000 pageviews. If both AdSense and Ad Exchange are providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillImpressions','metric','integer','DoubleClick for Publishers Backfill','GAM Backfill Impressions','Backfill Impressions is the sum of all AdSense or Ad Exchance ad impressions served as backfill through DFP. An ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillImpressionsPerSession','metric','float','DoubleClick for Publishers Backfill','GAM Backfill Impressions / Session','The ratio of backfill ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions). If both AdSense and Ad Exchange are providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillMonetizedPageviews','metric','integer','DoubleClick for Publishers Backfill','GAM Backfill Monetized Pageviews','This measures the total number of pageviews on the property that were shown with at least one ad from the linked backfill account(s). Note that a single monetized pageview can include multiple ad impressions (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillRevenue','metric','currency','DoubleClick for Publishers Backfill','GAM Backfill Revenue','The total estimated revenue from backfill ads. If AdSense and Ad Exchange are both providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillRevenuePer1000Sessions','metric','currency','DoubleClick for Publishers Backfill','GAM Backfill Revenue / 1000 Sessions','The total estimated revenue from backfill ads per 1,000 Analytics sessions. Note that this metric is based on sessions to the site and not ad impressions. If both AdSense and Ad Exchange are providing backfill ads, this metric is the sum of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('backfillViewableImpressionsPercent','metric','percent','DoubleClick for Publishers Backfill','GAM Backfill Viewable Impressions %','The percentage of backfill ad impressions that were viewable. An impression is considered a viewable impression when it has appeared within the users\' browsers and had the opportunity to be seen. If AdSense and Ad Exchange are both providing backfill ads, this metric is the weighted average of the two backfill accounts (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('bounceRate','metric','percent','Session','Bounce Rate','The percentage of single-page session (i.e., session in which the person left the property from the first page).','ga:bounces / ga:sessions'),('bounces','metric','integer','Session','Bounces','The total number of single page (or single interaction hit) sessions for the property.',NULL),('browser','dimension','string','Platform or Device','Browser','The name of users\' browsers, for example, Internet Explorer or Firefox.',NULL),('browserSize','dimension','string','Platform or Device','Browser Size','The viewport size of users\' browsers. A session-scoped dimension, browser size captures the initial dimensions of the viewport in pixels and is formatted as width x height, for example, 1920x960.',NULL),('browserVersion','dimension','string','Platform or Device','Browser Version','The version of users\' browsers, for example, 2.0.0.14.',NULL),('buyToDetailRate','metric','percent','Ecommerce','Buy-to-Detail Rate','Unique purchases divided by views of product detail pages (Enhanced Ecommerce).',NULL),('calcMetric_<NAME>','metric','integer','Custom Variables or Columns','Calculated Metric','The value of the requested calculated metric, where <NAME> refers to the user-defined name of the calculated metric. Note that the data type of ga:calcMetric_<NAME> can be FLOAT, INTEGER, CURRENCY, TIME, or PERCENT. For details, see https://support.google.com/analytics/answer/6121409.',NULL),('campaign','dimension','string','Traffic Sources','Campaign','For manual campaign tracking, it is the value of the utm_campaign campaign tracking parameter. For AdWords autotagging, it is the name(s) of the online ad campaign(s) you use for the property. If you use neither, its value is (not set).',NULL),('campaignCode','dimension','string','Traffic Sources','Campaign Code','For manual campaign tracking, it is the value of the utm_id campaign tracking parameter.',NULL),('cartToDetailRate','metric','percent','Ecommerce','Cart-to-Detail Rate','Product adds divided by views of product details (Enhanced Ecommerce).',NULL),('channelGrouping','dimension','string','Channel Grouping','Default Channel Grouping','The Channel Group associated with an end user\'s session for this View (defined by the View\'s Channel Groupings).',NULL),('checkoutOptions','dimension','string','Ecommerce','Checkout Options','User options specified during the checkout process, e.g., FedEx, DHL, UPS for delivery options; Visa, MasterCard, AmEx for payment options. This dimension should be used with ga:shoppingStage (Enhanced Ecommerce).',NULL),('city','dimension','string','Geo Network','City','Users\' city, derived from their IP addresses or Geographical IDs.',NULL),('cityId','dimension','string','Geo Network','City ID','Users\' city ID, derived from their IP addresses or Geographical IDs. The city IDs are the same as the Criteria IDs found at https://developers.google.com/analytics/devguides/collection/protocol/v1/geoid.',NULL),('cohort','dimension','string','Lifetime Value and Cohorts','Cohort','Name of the cohort to which a user belongs. Depending on how cohorts are defined, a user can belong to multiple cohorts, similar to how a user can belong to multiple segments.',NULL),('cohortActiveUsers','metric','integer','Lifetime Value and Cohorts','Users','This metric is relevant in the context of ga:cohortNthDay/ga:cohortNthWeek/ga:cohortNthMonth. It indicates the number of users in the cohort who are active in the time window corresponding to the cohort nth day/week/month. For example, for ga:cohortNthWeek = 1, number of users (in the cohort) who are active in week 1. If a request doesn\'t have any of ga:cohortNthDay/ga:cohortNthWeek/ga:cohortNthMonth, this metric will have the same value as ga:cohortTotalUsers.',NULL),('cohortAppviewsPerUser','metric','float','Lifetime Value and Cohorts','Appviews per User','App views per user for a cohort.','ga:screenviews / ga:cohortTotalUsers'),('cohortAppviewsPerUserWithLifetimeCriteria','metric','float','Lifetime Value and Cohorts','Appviews Per User (LTV)','App views per user for the acquisition dimension for a cohort.','ga:screenviews / ga:cohortTotalUsersWithLifetimeCriteria'),('cohortGoalCompletionsPerUser','metric','float','Lifetime Value and Cohorts','Goal Completions per User','Goal completions per user for the acquisition dimension for a cohort.','ga:goalCompletionsAll / ga:cohortTotalUsers'),('cohortGoalCompletionsPerUserWithLifetimeCriteria','metric','float','Lifetime Value and Cohorts','Goal Completions Per User (LTV)','Goal completions per user for a cohort.','ga:goalCompletionsAll / ga:cohortTotalUsersWithLifetimeCriteria'),('cohortNthDay','dimension','string','Lifetime Value and Cohorts','Day','Day offset relative to the cohort definition date. For example, if a cohort is defined with the first visit date as 2015-09-01, then for the date 2015-09-04, ga:cohortNthDay will be 3.',NULL),('cohortNthMonth','dimension','string','Lifetime Value and Cohorts','Month','Month offset relative to the cohort definition date. The semantics of this dimension differs based on whether lifetime value is requested or not. For a cohorts report not requesting lifetime value: This is the week offset from the cohort definition start date. For example, if cohort is defined as 2015-09-01 <= first session date <= 2015-09-30. Then, for 2015-09-01 <= date <= 2015-09-30, ga:cohortNthMonth = 0. 2015-10-01 <= date <= 2015-10-31, ga:cohortNthMonth = 2. and so on. For a cohorts request requesting lifetime value: ga:cohortNthMonth is calculated relative to the users acquisition date. It is not dependent on the cohort definition date. For example, if we define a cohort as 2015-10-01 <= first session date <= 2015-09-30. And a user was acquired on 2015-09-04. Then, for 2015-09-04 <= date <= 2015-10-04, ga:cohortNthMonth = 0 2015-10-04 <= date <= 2015-11-04, ga:cohortNthMonth = 1, and so on.',NULL),('cohortNthWeek','dimension','string','Lifetime Value and Cohorts','Week','Week offset relative to the cohort definition date. The semantics of this dimension differs based on whether lifetime value is requested or not. For a cohorts report not requesting lifetime value: This is the week offset from the cohort definition start date. For example, if cohort is defined as 2015-09-01 <= first session date <= 2015-09-07. Then, for 2015-09-01 <= date <= 2015-09-07, ga:cohortNthWeek = 0. 2015-09-08 <= date <= 2015-09-14, ga:cohortNthWeek = 1. etc. For a cohorts request requesting lifetime value: ga:cohortNthWeek is calculated relative to the users acquisition date. It is not dependent on the cohort definition date. For example, if we define a cohort as 2015-09-01 <= first session date <= 2015-09-07. And a user was acquired on 2015-09-04. Then, for 2015-09-04 <= date<= 2015-09-10, ga:cohortNthWeek = 0 2015-09-11 <= date <= 2015-09-17, ga:cohortNthWeek = 1',NULL),('cohortPageviewsPerUser','metric','float','Lifetime Value and Cohorts','Pageviews per User','Pageviews per user for a cohort.','ga:pageviews / ga:cohortTotalUsers'),('cohortPageviewsPerUserWithLifetimeCriteria','metric','float','Lifetime Value and Cohorts','Pageviews Per User (LTV)','Pageviews per user for the acquisition dimension for a cohort.','ga:pageviews / ga:cohortTotalUsersWithLifetimeCriteria'),('cohortRetentionRate','metric','percent','Lifetime Value and Cohorts','User Retention','Cohort retention rate.','ga:cohortActiveUsers / ga:cohortTotalUsers'),('cohortRevenuePerUser','metric','currency','Lifetime Value and Cohorts','Revenue per User','Revenue per user for a cohort.','ga:transactions / ga:cohortTotalUsers'),('cohortRevenuePerUserWithLifetimeCriteria','metric','currency','Lifetime Value and Cohorts','Revenue Per User (LTV)','Revenue per user for the acquisition dimension for a cohort.','ga:transactionRevenue / ga:cohortTotalUsersWithLifetimeCriteria'),('cohortSessionDurationPerUser','metric','time','Lifetime Value and Cohorts','Session Duration per User','Session duration per user for a cohort.','ga:sessionDuration / ga:cohortTotalUsers'),('cohortSessionDurationPerUserWithLifetimeCriteria','metric','time','Lifetime Value and Cohorts','Session Duration Per User (LTV)','Session duration per user for the acquisition dimension for a cohort.','ga:sessionDuration / ga:cohortTotalUsersWithLifetimeCriteria'),('cohortSessionsPerUser','metric','float','Lifetime Value and Cohorts','Sessions per User','Sessions per user for a cohort.','ga:sessions / ga:cohortTotalUsers'),('cohortSessionsPerUserWithLifetimeCriteria','metric','float','Lifetime Value and Cohorts','Sessions Per User (LTV)','Sessions per user for the acquisition dimension for a cohort.','ga:sessions / ga:cohortTotalUsersWithLifetimeCriteria'),('cohortTotalUsers','metric','integer','Lifetime Value and Cohorts','Total Users','Number of users belonging to the cohort, also known as cohort size.',NULL),('cohortTotalUsersWithLifetimeCriteria','metric','integer','Lifetime Value and Cohorts','Users','This is relevant in the context of a request which has the dimensions ga:acquisitionTrafficChannel/ga:acquisitionSource/ga:acquisitionMedium/ga:acquisitionCampaign. It represents the number of users in the cohorts who are acquired through the current channel/source/medium/campaign. For example, for ga:acquisitionTrafficChannel=Direct, it represents the number users in the cohort, who were acquired directly. If none of these mentioned dimensions are present, then its value is equal to ga:cohortTotalUsers.',NULL),('contentGroupUniqueViewsXX','metric','integer','Content Grouping','Unique Views XX','The number of unique content group views. Content group views in different sessions are counted as unique content group views. Both the pagePath and pageTitle are used to determine content group view uniqueness.',NULL),('contentGroupXX','dimension','string','Content Grouping','Page Group XX','The content group on a property. A content group is a collection of content providing a logical structure that can be determined by tracking code or page title/URL regex match, or predefined rules.',NULL),('continent','dimension','string','Geo Network','Continent','Users\' continent, derived from users\' IP addresses or Geographical IDs.',NULL),('continentId','dimension','string','Geo Network','Continent ID','Users\' continent ID, derived from users\' IP addresses or Geographical IDs.',NULL),('costPerConversion','metric','currency','Adwords','Cost per Conversion','The cost per conversion (including ecommerce and goal conversions) for the property.','(ga:adCost) / (ga:transactions  +  ga:goalCompletionsAll)'),('costPerGoalConversion','metric','currency','Adwords','Cost per Goal Conversion','The cost per goal conversion for the property.','(ga:adCost) / (ga:goalCompletionsAll)'),('costPerTransaction','metric','currency','Adwords','Cost per Transaction','The cost per transaction for the property.','(ga:adCost) / (ga:transactions)'),('country','dimension','string','Geo Network','Country','Users\' country, derived from their IP addresses or Geographical IDs.',NULL),('countryIsoCode','dimension','string','Geo Network','Country ISO Code','Users\' country\'s ISO code (in ISO-3166-1 alpha-2 format), derived from their IP addresses or Geographical IDs. For example, BR for Brazil, CA for Canada.',NULL),('CPC','metric','currency','Adwords','CPC','Cost to advertiser per click.','ga:adCost / ga:adClicks'),('CPM','metric','currency','Adwords','CPM','Cost per thousand impressions.','ga:adCost / (ga:impressions / 1000)'),('CTR','metric','percent','Adwords','CTR','Click-through-rate for the ad. This is equal to the number of clicks divided by the number of impressions for the ad (e.g., how many times users clicked on one of the ads where that ad appeared).','ga:adClicks / ga:impressions'),('currencyCode','dimension','string','Ecommerce','Currency Code','The local currency code (based on ISO 4217 standard) of the transaction.',NULL),('customVarNameXX','dimension','string','Custom Variables or Columns','Custom Variable (Key XX)','The name for the requested custom variable.',NULL),('customVarValueXX','dimension','string','Custom Variables or Columns','Custom Variable (Value XX)','The value for the requested custom variable.',NULL),('dataSource','dimension','string','Platform or Device','Data Source','The data source of a hit. By default, hits sent from analytics.js are reported as \"web\" and hits sent from the mobile SDKs are reported as \"app\". These values can be overridden in the Measurement Protocol.',NULL),('date','dimension','string','Time','Date','The date of the session formatted as YYYYMMDD.',NULL),('dateHour','dimension','string','Time','Hour of Day','Combined values of ga:date and ga:hour formated as YYYYMMDDHH.',NULL),('dateHourMinute','dimension','string','Time','Date Hour and Minute','Combined values of ga:date, ga:hour and ga:minute formated as YYYYMMDDHHMM.',NULL),('day','dimension','string','Time','Day of the month','The day of the month, a two-digit number from 01 to 31.',NULL),('dayOfWeek','dimension','string','Time','Day of Week','Day of the week, a one-digit number from 0 (Sunday) to 6 (Saturday).',NULL),('dayOfWeekName','dimension','string','Time','Day of Week Name','Name (in English) of the day of the week.',NULL),('daysSinceLastSession','dimension','string','User','Days Since Last Session','The number of days elapsed since users last visited the property, used to calculate user loyalty.',NULL),('daysToTransaction','dimension','string','Ecommerce','Days to Transaction','The number of days between users\' purchases and the most recent campaign source prior to the purchase.',NULL),('dbmClickAdvertiser','dimension','string','DoubleClick Bid Manager','DV360 Advertiser (GA Model)','DBM advertiser name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickAdvertiserId','dimension','string','DoubleClick Bid Manager','DV360 Advertiser ID (GA Model)','DBM advertiser ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickCreativeId','dimension','string','DoubleClick Bid Manager','DV360 Creative ID (GA Model)','DBM creative ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickExchange','dimension','string','DoubleClick Bid Manager','DV360 Exchange (GA Model)','DBM exchange name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickExchangeId','dimension','string','DoubleClick Bid Manager','DV360 Exchange ID (GA Model)','DBM exchange ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickInsertionOrder','dimension','string','DoubleClick Bid Manager','DV360 Insertion Order (GA Model)','DBM insertion order name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickInsertionOrderId','dimension','string','DoubleClick Bid Manager','DV360 Insertion Order ID (GA Model)','DBM insertion order ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickLineItem','dimension','string','DoubleClick Bid Manager','DV360 Line Item NAME (GA Model)','DBM line item name of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickLineItemId','dimension','string','DoubleClick Bid Manager','DV360 Line Item ID (GA Model)','DBM line item ID of the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClicks','metric','integer','DoubleClick Bid Manager','DV360 Clicks','DBM Total Clicks (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickSite','dimension','string','DoubleClick Bid Manager','DV360 Site (GA Model)','DBM site name where the DBM creative was shown and clicked on for the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmClickSiteId','dimension','string','DoubleClick Bid Manager','DV360 Site ID (GA Model)','DBM site ID where the DBM creative was shown and clicked on for the DBM click matching the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmConversions','metric','integer','DoubleClick Bid Manager','DV360 Conversions','DBM Total Conversions (Analytics 360 only, requires integration with DBM).',NULL),('dbmCost','metric','currency','DoubleClick Bid Manager','DV360 Cost','DBM Cost (Analytics 360 only, requires integration with DBM).',NULL),('dbmCPA','metric','currency','DoubleClick Bid Manager','DV360 eCPA','DBM Revenue eCPA (Analytics 360 only, requires integration with DBM).','ga:dbmCost / ga:dbmConversions'),('dbmCPC','metric','currency','DoubleClick Bid Manager','DV360 eCPC','DBM Revenue eCPC (Analytics 360 only, requires integration with DBM).','ga:dbmCost / ga:dbmClicks'),('dbmCPM','metric','currency','DoubleClick Bid Manager','DV360 eCPM','DBM Revenue eCPM (Analytics 360 only, requires integration with DBM).','ga:dbmCost / (ga:dbmImpressions / 1000)'),('dbmCTR','metric','percent','DoubleClick Bid Manager','DV360 CTR','DBM CTR (Analytics 360 only, requires integration with DBM).','ga:dbmClicks / ga:dbmImpressions'),('dbmImpressions','metric','integer','DoubleClick Bid Manager','DV360 Impressions','DBM Total Impressions (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventAdvertiser','dimension','string','DoubleClick Bid Manager','DV360 Advertiser (CM Model)','DBM advertiser name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventAdvertiserId','dimension','string','DoubleClick Bid Manager','DV360 Advertiser ID (CM Model)','DBM advertiser ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventCreativeId','dimension','string','DoubleClick Bid Manager','DV360 Creative ID (CM Model)','DBM creative ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventExchange','dimension','string','DoubleClick Bid Manager','DV360 Exchange (CM Model)','DBM exchange name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventExchangeId','dimension','string','DoubleClick Bid Manager','DV360 Exchange ID (CM Model)','DBM exchange ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventInsertionOrder','dimension','string','DoubleClick Bid Manager','DV360 Insertion Order (CM Model)','DBM insertion order name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventInsertionOrderId','dimension','string','DoubleClick Bid Manager','DV360 Insertion Order ID (CM Model)','DBM insertion order ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventLineItem','dimension','string','DoubleClick Bid Manager','DV360 Line Item (CM Model)','DBM line item name of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventLineItemId','dimension','string','DoubleClick Bid Manager','DV360 Line Item ID (CM Model)','DBM line item ID of the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventSite','dimension','string','DoubleClick Bid Manager','DV360 Site (CM Model)','DBM site name where the DBM creative was shown and clicked on for the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmLastEventSiteId','dimension','string','DoubleClick Bid Manager','DV360 Site ID (CM Model)','DBM site ID where the DBM creative was shown and clicked on for the last DBM event (impression or click within the DBM lookback window) associated with the Google Analytics session (Analytics 360 only, requires integration with DBM).',NULL),('dbmROAS','metric','percent','DoubleClick Bid Manager','DV360 ROAS','DBM ROAS (Analytics 360 only, requires integration with DBM).','(ga:transactionRevenue + ga:goalValueAll) / ga:dbmCost'),('dcmClickAd','dimension','string','DoubleClick Campaign Manager','CM Ad (GA Model)','DCM ad name of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickAdId','dimension','string','DoubleClick Campaign Manager','CM Ad ID (GA Model)','DCM ad ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickAdType','dimension','string','DoubleClick Campaign Manager','CM Ad Type (GA Model)','DCM ad type name of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickAdTypeId','dimension','string','DoubleClick Campaign Manager','CM Ad Type ID','DCM ad type ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickAdvertiser','dimension','string','DoubleClick Campaign Manager','CM Advertiser (GA Model)','DCM advertiser name of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickAdvertiserId','dimension','string','DoubleClick Campaign Manager','CM Advertiser ID (GA Model)','DCM advertiser ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickCampaign','dimension','string','DoubleClick Campaign Manager','CM Campaign (GA Model)','DCM campaign name of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickCampaignId','dimension','string','DoubleClick Campaign Manager','CM Campaign ID (GA Model)','DCM campaign ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickCreative','dimension','string','DoubleClick Campaign Manager','CM Creative (GA Model)','DCM creative name of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickCreativeId','dimension','string','DoubleClick Campaign Manager','CM Creative ID (GA Model)','DCM creative ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickCreativeType','dimension','string','DoubleClick Campaign Manager','CM Creative Type (GA Model)','DCM creative type name of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickCreativeTypeId','dimension','string','DoubleClick Campaign Manager','CM Creative Type ID (GA Model)','DCM creative type ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickCreativeVersion','dimension','string','DoubleClick Campaign Manager','CM Creative Version (GA Model)','DCM creative version of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickRenderingId','dimension','string','DoubleClick Campaign Manager','CM Rendering ID (GA Model)','DCM rendering ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClicks','metric','integer','DoubleClick Campaign Manager','CM Clicks','DCM Total Clicks (Analytics 360 only).',NULL),('dcmClickSite','dimension','string','DoubleClick Campaign Manager','CM Site (GA Model)','Site name where the DCM creative was shown and clicked on for the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickSiteId','dimension','string','DoubleClick Campaign Manager','CM Site ID (GA Model)','DCM site ID where the DCM creative was shown and clicked on for the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickSitePlacement','dimension','string','DoubleClick Campaign Manager','CM Placement (GA Model)','DCM site placement name of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickSitePlacementId','dimension','string','DoubleClick Campaign Manager','CM Placement ID (GA Model)','DCM site placement ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmClickSpotId','dimension','string','DoubleClick Campaign Manager','CM Floodlight Configuration ID (GA Model)','DCM Floodlight configuration ID of the DCM click matching the Google Analytics session (Analytics 360 only).',NULL),('dcmCost','metric','currency','DoubleClick Campaign Manager','CM Cost','DCM Total Cost (Analytics 360 only).',NULL),('dcmCPC','metric','currency','DoubleClick Campaign Manager','CM CPC','DCM Cost Per Click (Analytics 360 only).',NULL),('dcmCTR','metric','percent','DoubleClick Campaign Manager','CM CTR','DCM Click Through Rate (Analytics 360 only).',NULL),('dcmFloodlightActivity','dimension','string','DoubleClick Campaign Manager','CM Activity','DCM Floodlight activity name associated with the floodlight conversion (Analytics 360 only).',NULL),('dcmFloodlightActivityAndGroup','dimension','string','DoubleClick Campaign Manager','CM Activity and Group','DCM Floodlight activity name and group name associated with the floodlight conversion (Analytics 360 only).',NULL),('dcmFloodlightActivityGroup','dimension','string','DoubleClick Campaign Manager','CM Activity Group','DCM Floodlight activity group name associated with the floodlight conversion (Analytics 360 only).',NULL),('dcmFloodlightActivityGroupId','dimension','string','DoubleClick Campaign Manager','CM Activity Group ID','DCM Floodlight activity group ID associated with the floodlight conversion (Analytics 360 only).',NULL),('dcmFloodlightActivityId','dimension','string','DoubleClick Campaign Manager','CM Activity ID','DCM Floodlight activity ID associated with the floodlight conversion (Analytics 360 only).',NULL),('dcmFloodlightAdvertiserId','dimension','string','DoubleClick Campaign Manager','CM Advertiser ID','DCM Floodlight advertiser ID associated with the floodlight conversion (Analytics 360 only).',NULL),('dcmFloodlightQuantity','metric','integer','DoubleClick Campaign Manager','CM Conversions','The number of DCM Floodlight conversions (Analytics 360 only).',NULL),('dcmFloodlightRevenue','metric','currency','DoubleClick Campaign Manager','CM Revenue','DCM Floodlight revenue (Analytics 360 only).',NULL),('dcmFloodlightSpotId','dimension','string','DoubleClick Campaign Manager','CM Floodlight Configuration ID','DCM Floodlight configuration ID associated with the floodlight conversion (Analytics 360 only).',NULL),('dcmImpressions','metric','integer','DoubleClick Campaign Manager','CM Impressions','DCM Total Impressions (Analytics 360 only).',NULL),('dcmLastEventAd','dimension','string','DoubleClick Campaign Manager','CM Ad','DCM ad name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventAdId','dimension','string','DoubleClick Campaign Manager','CM Ad ID (CM Model)','DCM ad ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventAdType','dimension','string','DoubleClick Campaign Manager','CM Ad Type (CM Model)','DCM ad type name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventAdTypeId','dimension','string','DoubleClick Campaign Manager','CM Ad Type ID (CM Model)','DCM ad type ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventAdvertiser','dimension','string','DoubleClick Campaign Manager','CM Advertiser (CM Model)','DCM advertiser name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventAdvertiserId','dimension','string','DoubleClick Campaign Manager','CM Advertiser ID (CM Model)','DCM advertiser ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventAttributionType','dimension','string','DoubleClick Campaign Manager','CM Attribution Type (CM Model)','There are two possible values: ClickThrough and ViewThrough. If the last DCM event associated with the Google Analytics session was a click, then the value will be ClickThrough. If the last DCM event associated with the Google Analytics session was an ad impression, then the value will be ViewThrough (Analytics 360 only).',NULL),('dcmLastEventCampaign','dimension','string','DoubleClick Campaign Manager','CM Campaign (CM Model)','DCM campaign name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventCampaignId','dimension','string','DoubleClick Campaign Manager','CM Campaign ID (CM Model)','DCM campaign ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventCreative','dimension','string','DoubleClick Campaign Manager','CM Creative (CM Model)','DCM creative name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventCreativeId','dimension','string','DoubleClick Campaign Manager','CM Creative ID (CM Model)','DCM creative ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventCreativeType','dimension','string','DoubleClick Campaign Manager','CM Creative Type (CM Model)','DCM creative type name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventCreativeTypeId','dimension','string','DoubleClick Campaign Manager','CM Creative Type ID (CM Model)','DCM creative type ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventCreativeVersion','dimension','string','DoubleClick Campaign Manager','CM Creative Version (CM Model)','DCM creative version of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventRenderingId','dimension','string','DoubleClick Campaign Manager','CM Rendering ID (CM Model)','DCM rendering ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventSite','dimension','string','DoubleClick Campaign Manager','CM Site (CM Model)','Site name where the DCM creative was shown and clicked on for the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventSiteId','dimension','string','DoubleClick Campaign Manager','CM Site ID (CM Model)','DCM site ID where the DCM creative was shown and clicked on for the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventSitePlacement','dimension','string','DoubleClick Campaign Manager','CM Placement (CM Model)','DCM site placement name of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventSitePlacementId','dimension','string','DoubleClick Campaign Manager','CM Placement ID (CM Model)','DCM site placement ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmLastEventSpotId','dimension','string','DoubleClick Campaign Manager','CM Floodlight Configuration ID (CM Model)','DCM Floodlight configuration ID of the last DCM event (impression or click within the DCM lookback window) associated with the Google Analytics session (Analytics 360 only).',NULL),('dcmROAS','metric','percent','DoubleClick Campaign Manager','CM ROAS','DCM Return On Ad Spend (ROAS) (Analytics 360 only).',NULL),('dcmRPC','metric','currency','DoubleClick Campaign Manager','CM RPC','DCM Revenue Per Click (Analytics 360 only).',NULL),('deviceCategory','dimension','string','Platform or Device','Device Category','The type of device: desktop, tablet, or mobile.',NULL),('dfpClicks','metric','integer','DoubleClick for Publishers','GAM Clicks','The number of times DFP ads were clicked on the site (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpCoverage','metric','percent','DoubleClick for Publishers','GAM Coverage','Coverage is the percentage of ad requests that returned at least one ad. Generally, coverage can help identify sites where the DFP account isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100 (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpCTR','metric','percent','DoubleClick for Publishers','GAM CTR','The percentage of pageviews that resulted in a click on an DFP ad (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpECPM','metric','currency','DoubleClick for Publishers','GAM eCPM','The effective cost per thousand pageviews. It is the DFP revenue per 1,000 pageviews (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpImpressions','metric','integer','DoubleClick for Publishers','GAM Impressions','A DFP ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpImpressionsPerSession','metric','float','DoubleClick for Publishers','GAM Impressions / Session','The ratio of DFP ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions) (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpLineItemId','dimension','string','DoubleClick for Publishers Backfill','GAM Line Item Id','The ID of the Google Ad Manager line item.',NULL),('dfpLineItemName','dimension','string','DoubleClick for Publishers Backfill','GAM Line Item Name','The name of the Google Ad Manager line item.',NULL),('dfpMonetizedPageviews','metric','integer','DoubleClick for Publishers','GAM Monetized Pageviews','This measures the total number of pageviews on the property that were shown with an ad from the linked DFP account. Note that a single page can have multiple ad units (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpRevenue','metric','currency','DoubleClick for Publishers','GAM Revenue','DFP revenue is an estimate of the total ad revenue based on served impressions (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpRevenuePer1000Sessions','metric','currency','DoubleClick for Publishers','GAM Revenue / 1000 Sessions','The total estimated revenue from DFP ads per 1,000 Analytics sessions. Note that this metric is based on sessions to the site, not on ad impressions (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dfpViewableImpressionsPercent','metric','percent','DoubleClick for Publishers','GAM Viewable Impressions %','The percentage of viewable ad impressions. An impression is considered a viewable impression when it has appeared within users\' browsers and has the opportunity to be seen (DFP linking enabled and Hide DFP Revenue not enabled).',NULL),('dimensionXX','dimension','string','Custom Variables or Columns','Custom Dimension XX','The value of the requested custom dimension, where XX refers to the number or index of the custom dimension.',NULL),('domainLookupTime','metric','integer','Site Speed','Domain Lookup Time (ms)','The total time (in milliseconds) all samples spent in DNS lookup for this page.',NULL),('domContentLoadedTime','metric','integer','Site Speed','Document Content Loaded Time (ms)','The time (in milliseconds), including the network time from users\' locations to the site\'s server, the browser takes to parse the document and execute deferred and parser-inserted scripts (DOMContentLoaded). When parsing of the document is finished, the Document Object Model (DOM) is ready, but the referenced style sheets, images, and subframes may not be finished loading. This is often the starting point of Javascript framework execution, e.g., JQuery\'s onready() callback.',NULL),('domInteractiveTime','metric','integer','Site Speed','Document Interactive Time (ms)','The time (in milliseconds), including the network time from users\' locations to the site\'s server, the browser takes to parse the document (DOMInteractive). At this time, users can interact with the Document Object Model even though it is not fully loaded.',NULL),('domLatencyMetricsSample','metric','integer','Site Speed','DOM Latency Metrics Sample','Sample set (or count) of pageviews used to calculate the averages for site speed DOM metrics. This metric is used to calculate ga:avgDomContentLoadedTime and ga:avgDomInteractiveTime.',NULL),('dsAdGroup','dimension','string','DoubleClick Search','SA360 Ad Group','DS Ad Group (Analytics 360 only, requires integration with DS).',NULL),('dsAdGroupId','dimension','string','DoubleClick Search','SA360 Ad Group ID','DS Ad Group ID (Analytics 360 only, requires integration with DS).',NULL),('dsAdvertiser','dimension','string','DoubleClick Search','SA360 Advertiser','DS Advertiser (Analytics 360 only, requires integration with DS).',NULL),('dsAdvertiserId','dimension','string','DoubleClick Search','SA360 Advertiser ID','DS Advertiser ID (Analytics 360 only, requires integration with DS).',NULL),('dsAgency','dimension','string','DoubleClick Search','SA360 Agency','DS Agency (Analytics 360 only, requires integration with DS).',NULL),('dsAgencyId','dimension','string','DoubleClick Search','SA360 Agency ID','DS Agency ID (Analytics 360 only, requires integration with DS).',NULL),('dsCampaign','dimension','string','DoubleClick Search','SA360 Campaign','DS Campaign (Analytics 360 only, requires integration with DS).',NULL),('dsCampaignId','dimension','string','DoubleClick Search','SA360 Campaign ID','DS Campaign ID (Analytics 360 only, requires integration with DS).',NULL),('dsClicks','metric','integer','DoubleClick Search','SA360 Clicks','DS Clicks (Analytics 360 only, requires integration with DS).',NULL),('dsCost','metric','currency','DoubleClick Search','SA360 Cost','DS Cost (Analytics 360 only, requires integration with DS).',NULL),('dsCPC','metric','currency','DoubleClick Search','SA360 CPC','DS Cost to advertiser per click (Analytics 360 only, requires integration with DS).','ga:dsCost/ga:dsClicks'),('dsCTR','metric','percent','DoubleClick Search','SA360 CTR','DS Click Through Rate (Analytics 360 only, requires integration with DS).','ga:dsClicks/ga:dsImpressions'),('dsEngineAccount','dimension','string','DoubleClick Search','SA360 Engine Account','DS Engine Account (Analytics 360 only, requires integration with DS).',NULL),('dsEngineAccountId','dimension','string','DoubleClick Search','SA360 Engine Account ID','DS Engine Account ID (Analytics 360 only, requires integration with DS).',NULL),('dsImpressions','metric','integer','DoubleClick Search','SA360 Impressions','DS Impressions (Analytics 360 only, requires integration with DS).',NULL),('dsKeyword','dimension','string','DoubleClick Search','SA360 Keyword','DS Keyword (Analytics 360 only, requires integration with DS).',NULL),('dsKeywordId','dimension','string','DoubleClick Search','SA360 Keyword ID','DS Keyword ID (Analytics 360 only, requires integration with DS).',NULL),('dsProfit','metric','currency','DoubleClick Search','SA360 Profit','DS Profie (Analytics 360 only, requires integration with DS).','(ga:transactionRevenue + ga:goalValueAll - ga:dsCost)'),('dsReturnOnAdSpend','metric','percent','DoubleClick Search','SA360 ROAS','DS Return On Ad Spend (Analytics 360 only, requires integration with DS).','(ga:transactionRevenue + ga:goalValueAll) / ga:dsCost'),('dsRevenuePerClick','metric','currency','DoubleClick Search','SA360 RPC','DS Revenue Per Click (Analytics 360 only, requires integration with DS).','(ga:transactionRevenue + ga:goalValueAll) / ga:dsClicks'),('entranceRate','metric','percent','Page Tracking','Entrances / Pageviews','The percentage of pageviews in which this page was the entrance.','ga:entrances / ga:pageviews'),('entrances','metric','integer','Page Tracking','Entrances','The number of entrances to the property measured as the first pageview in a session, typically used with landingPagePath.',NULL),('eventAction','dimension','string','Event Tracking','Event Action','Event action.',NULL),('eventCategory','dimension','string','Event Tracking','Event Category','The event category.',NULL),('eventLabel','dimension','string','Event Tracking','Event Label','Event label.',NULL),('eventsPerSessionWithEvent','metric','float','Event Tracking','Events / Session with Event','The average number of events per session with event.','ga:totalEvents / ga:sessionsWithEvent'),('eventValue','metric','integer','Event Tracking','Event Value','Total value of events for the profile.',NULL),('exceptionDescription','dimension','string','Exceptions','Exception Description','The description for the exception.',NULL),('exceptions','metric','integer','Exceptions','Exceptions','The number of exceptions sent to Google Analytics.',NULL),('exceptionsPerScreenview','metric','percent','Exceptions','Exceptions / Screen','The number of exceptions thrown divided by the number of screenviews.','ga:exceptions / ga:screenviews'),('exitPagePath','dimension','string','Page Tracking','Exit Page','The last page or exit page in users\' sessions.',NULL),('exitRate','metric','percent','Page Tracking','% Exit','The percentage of exits from the property that occurred out of the total pageviews.','ga:exits / (ga:pageviews + ga:screenviews)'),('exits','metric','integer','Page Tracking','Exits','The number of exits from the property.',NULL),('exitScreenName','dimension','string','App Tracking','Exit Screen','The name of the screen where users exited the application.',NULL),('experimentCombination','dimension','string','Content Experiments','Experiment ID with Variant','The user-scoped ID of the experiment and variant that users were exposed to during an experiment.',NULL),('experimentId','dimension','string','Content Experiments','Experiment ID','The user-scoped ID of the content experiment that users were exposed to when the metrics were reported.',NULL),('experimentVariant','dimension','string','Content Experiments','Variant','The user-scoped ID of the particular variant that users were exposed to during a content experiment.',NULL),('fatalExceptions','metric','integer','Exceptions','Crashes','The number of exceptions where isFatal is set to true.',NULL),('fatalExceptionsPerScreenview','metric','percent','Exceptions','Crashes / Screen','The number of fatal exceptions thrown divided by the number of screenviews.','ga:fatalExceptions / ga:screenviews'),('flashVersion','dimension','string','System','Flash Version','The version of Flash, including minor versions, supported by users\' browsers.',NULL),('fullReferrer','dimension','string','Traffic Sources','Full Referrer','The full referring URL including the hostname and path.',NULL),('goalAbandonRateAll','metric','percent','Goal Conversions','Total Abandonment Rate','Goal abandonment rate.','((ga:goalStartsAll - ga:goalCompletionsAll)) / (ga:goalStartsAll)'),('goalAbandonsAll','metric','integer','Goal Conversions','Abandoned Funnels','The overall number of times users started goals without actually completing them.','(ga:goalStartsAll - ga:goalCompletionsAll)'),('goalCompletionLocation','dimension','string','Goal Conversions','Goal Completion Location','The page path or screen name that matched any destination type goal completion.',NULL),('goalCompletionsAll','metric','integer','Goal Conversions','Goal Completions','Total number of completions for all goals defined in the profile.',NULL),('goalConversionRateAll','metric','percent','Goal Conversions','Goal Conversion Rate','The percentage of sessions which resulted in a conversion to at least one of the goals.','ga:goalCompletionsAll / ga:sessions'),('goalPreviousStep1','dimension','string','Goal Conversions','Goal Previous Step - 1','The page path or screen name that matched any destination type goal, one step prior to the goal completion location.',NULL),('goalPreviousStep2','dimension','string','Goal Conversions','Goal Previous Step - 2','The page path or screen name that matched any destination type goal, two steps prior to the goal completion location.',NULL),('goalPreviousStep3','dimension','string','Goal Conversions','Goal Previous Step - 3','The page path or screen name that matched any destination type goal, three steps prior to the goal completion location.',NULL),('goalStartsAll','metric','integer','Goal Conversions','Goal Starts','Total number of starts for all goals defined in the profile.',NULL),('goalValueAll','metric','currency','Goal Conversions','Goal Value','Total numeric value for all goals defined in the profile.',NULL),('goalValueAllPerSearch','metric','currency','Internal Search','Per Search Goal Value','The average goal value of a search.','ga:goalValueAll / ga:searchUniques'),('goalValuePerSession','metric','currency','Goal Conversions','Per Session Goal Value','The average goal value of a session.','ga:goalValueAll / ga:sessions'),('goalXXAbandonRate','metric','percent','Goal Conversions','Goal XX Abandonment Rate','The rate at which the requested goal number was abandoned.','((ga:goalXXStarts - ga:goalXXCompletions)) / (ga:goalXXStarts)'),('goalXXAbandons','metric','integer','Goal Conversions','Goal XX Abandoned Funnels','The number of times users started conversion activity on the requested goal number without actually completing it.','(ga:goalXXStarts - ga:goalXXCompletions)'),('goalXXCompletions','metric','integer','Goal Conversions','Goal XX Completions','The total number of completions for the requested goal number.',NULL),('goalXXConversionRate','metric','percent','Goal Conversions','Goal XX Conversion Rate','Percentage of sessions resulting in a conversion to the requested goal number.','ga:goalXXCompletions / ga:sessions'),('goalXXStarts','metric','integer','Goal Conversions','Goal XX Starts','The total number of starts for the requested goal number.',NULL),('goalXXValue','metric','currency','Goal Conversions','Goal XX Value','The total numeric value for the requested goal number.',NULL),('hasSocialSourceReferral','dimension','string','Traffic Sources','Social Source Referral','A boolean, either Yes or No, indicates whether sessions to the property are from a social source.',NULL),('hits','metric','integer','Session','Hits','Total number of hits for the view (profile). This metric sums all hit types, including pageview, custom event, ecommerce, and other types. Because this metric is based on the view (profile), not on the property, it is not the same as the property\'s hit volume.',NULL),('hostname','dimension','string','Page Tracking','Hostname','The hostname from which the tracking request was made.',NULL),('hour','dimension','string','Time','Hour','A two-digit hour of the day ranging from 00-23 in the timezone configured for the account. This value is also corrected for daylight savings time. If the timezone follows daylight savings time, there will be an apparent bump in the number of sessions during the changeover hour (e.g., between 1:00 and 2:00) for the day per year when that hour repeats. A corresponding hour with zero sessions will occur at the opposite changeover. (Google Analytics does not track user time more precisely than hours.)',NULL),('impressions','metric','integer','Adwords','Impressions','Total number of campaign impressions.',NULL),('interestAffinityCategory','dimension','string','Audience','Affinity Category (reach)','Indicates that users are more likely to be interested in learning about the specified category.',NULL),('interestInMarketCategory','dimension','string','Audience','In-Market Segment','Indicates that users are more likely to be ready to purchase products or services in the specified category.',NULL),('interestOtherCategory','dimension','string','Audience','Other Category','Indicates that users are more likely to be interested in learning about the specified category, and more likely to be ready to purchase.',NULL),('internalPromotionClicks','metric','integer','Ecommerce','Internal Promotion Clicks','The number of clicks on an internal promotion (Enhanced Ecommerce).',NULL),('internalPromotionCreative','dimension','string','Ecommerce','Internal Promotion Creative','The creative content designed for a promotion (Enhanced Ecommerce).',NULL),('internalPromotionCTR','metric','percent','Ecommerce','Internal Promotion CTR','The rate at which users clicked through to view the internal promotion (ga:internalPromotionClicks / ga:internalPromotionViews) - (Enhanced Ecommerce).','ga:internalPromotionClicks / ga:internalPromotionViews'),('internalPromotionId','dimension','string','Ecommerce','Internal Promotion ID','The ID of the promotion (Enhanced Ecommerce).',NULL),('internalPromotionName','dimension','string','Ecommerce','Internal Promotion Name','The name of the promotion (Enhanced Ecommerce).',NULL),('internalPromotionPosition','dimension','string','Ecommerce','Internal Promotion Position','The position of the promotion on the web page or application screen (Enhanced Ecommerce).',NULL),('internalPromotionViews','metric','integer','Ecommerce','Internal Promotion Views','The number of views of an internal promotion (Enhanced Ecommerce).',NULL),('isoWeek','dimension','string','Time','ISO Week of the Year','ISO week number, where each week starts on Monday. For details, see http://en.wikipedia.org/wiki/ISO_week_date. ga:isoWeek should only be used with ga:isoYear because ga:year represents Gregorian calendar.',NULL),('isoYear','dimension','string','Time','ISO Year','The ISO year of the session. For details, see http://en.wikipedia.org/wiki/ISO_week_date. ga:isoYear should only be used with ga:isoWeek because ga:week represents Gregorian calendar.',NULL),('isoYearIsoWeek','dimension','string','Time','ISO Week of ISO Year','Combined values of ga:isoYear and ga:isoWeek.',NULL),('isTrueViewVideoAd','dimension','string','Adwords','TrueView Video Ad','A boolean, Yes or No, indicating whether the ad is an AdWords TrueView video ad.',NULL),('itemQuantity','metric','integer','Ecommerce','Quantity','Total number of items purchased. For example, if users purchase 2 frisbees and 5 tennis balls, this will be 7.',NULL),('itemRevenue','metric','currency','Ecommerce','Product Revenue','The total revenue from purchased product items.',NULL),('itemsPerPurchase','metric','float','Ecommerce','Avg. QTY','The average quantity of this item (or group of items) sold per purchase.','ga:itemQuantity / ga:uniquePurchases'),('javaEnabled','dimension','string','System','Java Support','A boolean, either Yes or No, indicating whether Java is enabled in users\' browsers.',NULL),('keyword','dimension','string','Traffic Sources','Keyword','For manual campaign tracking, it is the value of the utm_term campaign tracking parameter. For AdWords traffic, it contains the best matching targeting criteria. For the display network, where multiple targeting criteria could have caused the ad to show up, it returns the best matching targeting criteria as selected by Ads. This could be display_keyword, site placement, boomuserlist, user_interest, age, or gender. Otherwise its value is (not set).',NULL),('landingContentGroupXX','dimension','string','Content Grouping','Landing Page Group XX','Content group of users\' landing pages.',NULL),('landingPagePath','dimension','string','Page Tracking','Landing Page','The first page in users\' sessions, or the landing page.',NULL),('landingScreenName','dimension','string','App Tracking','Landing Screen','The name of the first viewed screen.',NULL),('language','dimension','string','System','Language','The language, in ISO-639 code format (e.g., en-gb for British English), provided by the HTTP Request for the browser.',NULL),('latitude','dimension','string','Geo Network','Latitude','The approximate latitude of users\' city, derived from their IP addresses or Geographical IDs. Locations north of the equator have positive latitudes and locations south of the equator have negative latitudes.',NULL),('localItemRevenue','metric','currency','Ecommerce','Local Product Revenue','Product revenue in local currency.',NULL),('localProductRefundAmount','metric','currency','Ecommerce','Local Product Refund Amount','Refund amount in local currency for a given product (Enhanced Ecommerce).',NULL),('localRefundAmount','metric','currency','Ecommerce','Local Refund Amount','Total refund amount in local currency for the transaction (Enhanced Ecommerce).',NULL),('localTransactionRevenue','metric','currency','Ecommerce','Local Revenue','Transaction revenue in local currency.',NULL),('localTransactionShipping','metric','currency','Ecommerce','Local Shipping','Transaction shipping cost in local currency.',NULL),('localTransactionTax','metric','currency','Ecommerce','Local Tax','Transaction tax in local currency.',NULL),('longitude','dimension','string','Geo Network','Longitude','The approximate longitude of users\' city, derived from their IP addresses or Geographical IDs. Locations east of the prime meridian have positive longitudes and locations west of the prime meridian have negative longitudes.',NULL),('medium','dimension','string','Traffic Sources','Medium','The type of referrals. For manual campaign tracking, it is the value of the utm_medium campaign tracking parameter. For AdWords autotagging, it is cpc. If users came from a search engine detected by Google Analytics, it is organic. If the referrer is not a search engine, it is referral. If users came directly to the property and document.referrer is empty, its value is (none).',NULL),('metricXX','metric','integer','Custom Variables or Columns','Custom Metric XX Value','The value of the requested custom metric, where XX refers to the number or index of the custom metric. Note that the data type of ga:metricXX can be INTEGER, CURRENCY, or TIME.',NULL),('metro','dimension','string','Geo Network','Metro','The Designated Market Area (DMA) from where traffic arrived.',NULL),('metroId','dimension','string','Geo Network','Metro Id','The three digit Designated Market Area (DMA) code from where traffic arrived, derived from users\' IP addresses or Geographical IDs.',NULL),('minute','dimension','string','Time','Minute','Returns the minutes, between 00 and 59, in the hour.',NULL),('mobileDeviceBranding','dimension','string','Platform or Device','Mobile Device Branding','Mobile manufacturer or branded name.',NULL),('mobileDeviceInfo','dimension','string','Platform or Device','Mobile Device Info','The branding, model, and marketing name used to identify the mobile device.',NULL),('mobileDeviceMarketingName','dimension','string','Platform or Device','Mobile Device Marketing Name','The marketing name used for the mobile device.',NULL),('mobileDeviceModel','dimension','string','Platform or Device','Mobile Device Model','Mobile device model.',NULL),('mobileInputSelector','dimension','string','Platform or Device','Mobile Input Selector','Selector (e.g., touchscreen, joystick, clickwheel, stylus) used on the mobile device.',NULL),('month','dimension','string','Time','Month of the year','Month of the session, a two digit integer from 01 to 12.',NULL),('networkDomain','dimension','string','Geo Network','Network Domain','The domain name of users\' ISP, derived from the domain name registered to the ISP\'s IP address.',NULL),('networkLocation','dimension','string','Geo Network','Service Provider','The names of the service providers used to reach the property. For example, if most users of the website come via the major cable internet service providers, its value will be these service providers\' names.',NULL),('newUsers','metric','integer','User','New Users','The number of sessions marked as a user\'s first sessions.',NULL),('nthDay','dimension','string','Time','Day Index','The index for each day in the specified date range. The index for the first day (i.e., start-date) in the date range is 0, for the second day 1, and so on.',NULL),('nthHour','dimension','string','Time','Hour Index','The index for each hour in the specified date range. The index for the first hour of the first day (i.e., start-date) in the date range is 0, for the next hour 1, and so on.',NULL),('nthMinute','dimension','string','Time','Minute Index','The index for each minute in the specified date range. The index for the first minute of the first day (i.e., start-date) in the date range is 0, for the next minute 1, and so on.',NULL),('nthMonth','dimension','string','Time','Month Index','The index for a month in the specified date range. In the date range, the index for the first month is 0, for the second month 1, and so on.',NULL),('nthWeek','dimension','string','Time','Week Index','The index for each week in the specified date range. The index for the first week in the date range is 0, for the second week 1, and so on. The index corresponds to week entries.',NULL),('operatingSystem','dimension','string','Platform or Device','Operating System','Users\' operating system, for example, Windows, Linux, Macintosh, or iOS.',NULL),('operatingSystemVersion','dimension','string','Platform or Device','Operating System Version','The version of users\' operating system, i.e., XP for Windows, PPC for Macintosh.',NULL),('orderCouponCode','dimension','string','Ecommerce','Order Coupon Code','Code for the order-level coupon (Enhanced Ecommerce).',NULL),('organicSearches','metric','integer','Traffic Sources','Organic Searches','The number of organic searches happened in a session. This metric is search engine agnostic.',NULL),('pageDepth','dimension','string','Page Tracking','Page Depth','The number of pages visited by users during a session. The value is a histogram that counts pageviews across a range of possible values. In this calculation, all sessions will have at least one pageview, and some percentage of sessions will have more.',NULL),('pageDownloadTime','metric','integer','Site Speed','Page Download Time (ms)','The total time (in milliseconds) to download this page among all samples.',NULL),('pageLoadSample','metric','integer','Site Speed','Page Load Sample','The sample set (or count) of pageviews used to calculate the average page load time.',NULL),('pageLoadTime','metric','integer','Site Speed','Page Load Time (ms)','Total time (in milliseconds), from pageview initiation (e.g., a click on a page link) to page load completion in the browser, the pages in the sample set take to load.',NULL),('pagePath','dimension','string','Page Tracking','Page','A page on the website specified by path and/or query parameters. Use this with hostname to get the page\'s full URL.',NULL),('pagePathLevel1','dimension','string','Page Tracking','Page path level 1','This dimension rolls up all the page paths in the first hierarchical level in pagePath.',NULL),('pagePathLevel2','dimension','string','Page Tracking','Page path level 2','This dimension rolls up all the page paths in the second hierarchical level in pagePath.',NULL),('pagePathLevel3','dimension','string','Page Tracking','Page path level 3','This dimension rolls up all the page paths in the third hierarchical level in pagePath.',NULL),('pagePathLevel4','dimension','string','Page Tracking','Page path level 4','This dimension rolls up all the page paths into hierarchical levels. Up to 4 pagePath levels maybe specified. All additional levels in the pagePath hierarchy are also rolled up in this dimension.',NULL),('pageTitle','dimension','string','Page Tracking','Page Title','The page\'s title. Multiple pages might have the same page title.',NULL),('pageValue','metric','currency','Page Tracking','Page Value','The average value of this page or set of pages, which is equal to (ga:transactionRevenue + ga:goalValueAll) / ga:uniquePageviews.',NULL),('pageviews','metric','integer','Page Tracking','Pageviews','The total number of pageviews for the property.',NULL),('pageviewsPerSession','metric','float','Page Tracking','Pages / Session','The average number of pages viewed during a session, including repeated views of a single page.','ga:pageviews / ga:sessions'),('percentNewSessions','metric','percent','User','% New Sessions','The percentage of sessions by users who had never visited the property before.','ga:newUsers / ga:sessions'),('percentSearchRefinements','metric','percent','Internal Search','% Search Refinements','The percentage of the number of times a refinement (i.e., transition) occurs between internal keywords search within a session.','ga:searchRefinements / ga:searchResultViews'),('percentSessionsWithSearch','metric','percent','Internal Search','% Sessions with Search','The percentage of sessions with search.','ga:searchSessions / ga:sessions'),('previousContentGroupXX','dimension','string','Content Grouping','Previous Page Group XX','Refers to content group that was visited before another content group.',NULL),('previousPagePath','dimension','string','Page Tracking','Previous Page Path','A page visited before another page on the same property, typically used with the pagePath dimension.',NULL),('productAddsToCart','metric','integer','Ecommerce','Product Adds To Cart','Number of times the product was added to the shopping cart (Enhanced Ecommerce).',NULL),('productBrand','dimension','string','Ecommerce','Product Brand','The brand name under which the product is sold (Enhanced Ecommerce).',NULL),('productCategory','dimension','string','Ecommerce','Product Category','Any product variation (size, color) supplied by the ecommerce application for purchased items, not compatible with Enhanced Ecommerce.',NULL),('productCategoryHierarchy','dimension','string','Ecommerce','Product Category (Enhanced Ecommerce)','The hierarchical category in which the product is classified (Enhanced Ecommerce).',NULL),('productCategoryLevelXX','dimension','string','Ecommerce','Product Category Level XX','Level (1-5) in the product category hierarchy, starting from the top (Enhanced Ecommerce).',NULL),('productCheckouts','metric','integer','Ecommerce','Product Checkouts','Number of times the product was included in the check-out process (Enhanced Ecommerce).',NULL),('productCouponCode','dimension','string','Ecommerce','Product Coupon Code','Code for the product-level coupon (Enhanced Ecommerce).',NULL),('productDetailViews','metric','integer','Ecommerce','Product Detail Views','Number of times users viewed the product-detail page (Enhanced Ecommerce).',NULL),('productListClicks','metric','integer','Ecommerce','Product List Clicks','Number of times users clicked the product when it appeared in the product list (Enhanced Ecommerce).',NULL),('productListCTR','metric','percent','Ecommerce','Product List CTR','The rate at which users clicked through on the product in a product list (ga:productListClicks / ga:productListViews) - (Enhanced Ecommerce).','ga:productListClicks / ga:productListViews'),('productListName','dimension','string','Ecommerce','Product List Name','The name of the product list in which the product appears (Enhanced Ecommerce).',NULL),('productListPosition','dimension','string','Ecommerce','Product List Position','The position of the product in the product list (Enhanced Ecommerce).',NULL),('productListViews','metric','integer','Ecommerce','Product List Views','Number of times the product appeared in a product list (Enhanced Ecommerce).',NULL),('productName','dimension','string','Ecommerce','Product','The product name, supplied by the ecommerce tracking application, for purchased items.',NULL),('productRefundAmount','metric','currency','Ecommerce','Product Refund Amount','Total refund amount associated with the product (Enhanced Ecommerce).',NULL),('productRefunds','metric','integer','Ecommerce','Product Refunds','Number of times a refund was issued for the product (Enhanced Ecommerce).',NULL),('productRemovesFromCart','metric','integer','Ecommerce','Product Removes From Cart','Number of times the product was removed from the shopping cart (Enhanced Ecommerce).',NULL),('productRevenuePerPurchase','metric','currency','Ecommerce','Product Revenue per Purchase','Average product revenue per purchase (commonly used with Product Coupon Code) (ga:itemRevenue / ga:uniquePurchases) - (Enhanced Ecommerce).','ga:itemRevenue / ga:uniquePurchases'),('productSku','dimension','string','Ecommerce','Product SKU','The product SKU, defined in the ecommerce tracking application, for purchased items.',NULL),('productVariant','dimension','string','Ecommerce','Product Variant','The specific variation of a product, e.g., XS, S, M, L for size; or Red, Blue, Green, Black for color (Enhanced Ecommerce).',NULL),('quantityAddedToCart','metric','integer','Ecommerce','Quantity Added To Cart','Number of product units added to the shopping cart (Enhanced Ecommerce).',NULL),('quantityCheckedOut','metric','integer','Ecommerce','Quantity Checked Out','Number of product units included in check out (Enhanced Ecommerce).',NULL),('quantityRefunded','metric','integer','Ecommerce','Quantity Refunded','Number of product units refunded (Enhanced Ecommerce).',NULL),('quantityRemovedFromCart','metric','integer','Ecommerce','Quantity Removed From Cart','Number of product units removed from a shopping cart (Enhanced Ecommerce).',NULL),('redirectionTime','metric','integer','Site Speed','Redirection Time (ms)','The total time (in milliseconds) all samples spent in redirects before fetching this page. If there are no redirects, this is 0.',NULL),('referralPath','dimension','string','Traffic Sources','Referral Path','The path of the referring URL (e.g., document.referrer). If someone places on their webpage a link to the property, this is the path of the page containing the referring link.',NULL),('refundAmount','metric','currency','Ecommerce','Refund Amount','Currency amount refunded for a transaction (Enhanced Ecommerce).',NULL),('region','dimension','string','Geo Network','Region','Users\' region, derived from their IP addresses or Geographical IDs. In U.S., a region is a state, New York, for example.',NULL),('regionId','dimension','string','Geo Network','Region ID','Users\' region ID, derived from their IP addresses or Geographical IDs. In U.S., a region is a state, New York, for example. The region IDs are the same as the Criteria IDs listed at https://developers.google.com/analytics/devguides/collection/protocol/v1/geoid.',NULL),('regionIsoCode','dimension','string','Geo Network','Region ISO Code','Users\' region ISO code in ISO-3166-2 format, derived from their IP addresses or Geographical IDs.',NULL),('revenuePerItem','metric','currency','Ecommerce','Avg. Price','The average revenue per item.','ga:itemRevenue / ga:itemQuantity'),('revenuePerTransaction','metric','currency','Ecommerce','Avg. Order Value','The average revenue of an ecommerce transaction.','ga:transactionRevenue / ga:transactions'),('revenuePerUser','metric','currency','Ecommerce','Revenue per User','The total sale revenue (excluding shipping and tax) of the transaction divided by the total number of users.',NULL),('ROAS','metric','percent','Adwords','ROAS','Return On Ad Spend (ROAS) is the total transaction revenue and goal value divided by derived advertising cost.','(ga:transactionRevenue + ga:goalValueAll) / ga:adCost'),('RPC','metric','currency','Adwords','RPC','RPC or revenue-per-click, the average revenue (from ecommerce sales and/or goal value) you received for each click on one of the search ads.','(ga:transactionRevenue + ga:goalValueAll) / ga:adClicks'),('screenColors','dimension','string','System','Screen Colors','The color depth of users\' monitors, retrieved from the DOM of users\' browsers. For example, 4-bit, 8-bit, 24-bit, or undefined-bit.',NULL),('screenDepth','dimension','string','App Tracking','Screen Depth','The number of screenviews (reported as a string) per session, useful for historgrams.',NULL),('screenName','dimension','string','App Tracking','Screen Name','The name of the screen.',NULL),('screenResolution','dimension','string','System','Screen Resolution','Resolution of users\' screens, for example, 1024x738.',NULL),('screenviews','metric','integer','App Tracking','Screen Views','The total number of screenviews.',NULL),('screenviewsPerSession','metric','float','App Tracking','Screens / Session','The average number of screenviews per session.','ga:screenviews / ga:sessions'),('searchAfterDestinationPage','dimension','string','Internal Search','Search Destination Page','The page that users visited after performing an internal search on the site.',NULL),('searchCategory','dimension','string','Internal Search','Site Search Category','The category used for the internal search if site search categories are enabled in the view. For example, the product category may be electronics, furniture, or clothing.',NULL),('searchDepth','metric','integer','Internal Search','Search Depth','The total number of subsequent page views made after a use of the site\'s internal search feature.',NULL),('searchDestinationPage','dimension','string','Internal Search','Destination Page','The page users immediately visited after performing an internal search on the site. This is usually the search results page.',NULL),('searchDuration','metric','time','Internal Search','Time after Search','The session duration when the site\'s internal search feature is used.',NULL),('searchExitRate','metric','percent','Internal Search','% Search Exits','The percentage of searches that resulted in an immediate exit from the property.','ga:searchExits / ga:searchUniques'),('searchExits','metric','integer','Internal Search','Search Exits','The number of exits on the site that occurred following a search result from the site\'s internal search feature.',NULL),('searchGoalConversionRateAll','metric','percent','Internal Search','Site Search Goal Conversion Rate','The percentage of search sessions (i.e., sessions that included at least one search) which resulted in a conversion to at least one of the goals.','ga:goalCompletionsAll / ga:searchUniques'),('searchGoalXXConversionRate','metric','percent','Internal Search','Site Search Goal XX Conversion Rate','The percentage of search sessions (i.e., sessions that included at least one search) which resulted in a conversion to the requested goal number.','ga:goalXXCompletions / ga:searchUniques'),('searchKeyword','dimension','string','Internal Search','Search Term','Search term used within the property.',NULL),('searchKeywordRefinement','dimension','string','Internal Search','Refined Keyword','Subsequent keyword search term or string entered by users after a given initial string search.',NULL),('searchRefinements','metric','integer','Internal Search','Search Refinements','The total number of times a refinement (transition) occurs between internal keywords search within a session. For example, if the sequence of keywords is \"shoes\", \"shoes\", \"pants\", \"pants\", this metric will be one because the transition between \"shoes\" and \"pants\" is different.',NULL),('searchResultViews','metric','integer','Internal Search','Results Pageviews','The number of times a search result page was viewed.',NULL),('searchSessions','metric','integer','Internal Search','Sessions with Search','The total number of sessions that included an internal search.',NULL),('searchStartPage','dimension','string','Internal Search','Start Page','The page where users initiated an internal search.',NULL),('searchUniques','metric','integer','Internal Search','Total Unique Searches','Total number of unique keywords from internal searches within a session. For example, if \"shoes\" was searched for 3 times in a session, it would be counted only once.',NULL),('searchUsed','dimension','string','Internal Search','Site Search Status','A boolean, either Visits With Site Search or Visits Without Site Search, to distinguish whether internal search was used in a session.',NULL),('secondPagePath','dimension','string','Page Tracking','Second Page','The second page in users\' sessions.',NULL),('serverConnectionTime','metric','integer','Site Speed','Server Connection Time (ms)','Total time (in milliseconds) all samples spent in establishing a TCP connection to this page.',NULL),('serverResponseTime','metric','integer','Site Speed','Server Response Time (ms)','The total time (in milliseconds) the site\'s server takes to respond to users\' requests among all samples; this includes the network time from users\' locations to the server.',NULL),('sessionCount','dimension','string','User','Count of Sessions','The session index for a user. Each session from a unique user will get its own incremental index starting from 1 for the first session. Subsequent sessions do not change previous session indices. For example, if a user has 4 sessions to the website, sessionCount for that user will have 4 distinct values of \'1\' through \'4\'.',NULL),('sessionDuration','metric','time','Session','Session Duration','Total duration (in seconds) of users\' sessions.',NULL),('sessionDurationBucket','dimension','string','Session','Session Duration','The length (returned as a string) of a session measured in seconds and reported in second increments.',NULL),('sessions','metric','integer','Session','Sessions','The total number of sessions.',NULL),('sessionsPerUser','metric','float','User','Number of Sessions per User','The total number of sessions divided by the total number of users.',NULL),('sessionsToTransaction','dimension','string','Ecommerce','Sessions to Transaction','The number of sessions between users\' purchases and the related campaigns that lead to the purchases.',NULL),('sessionsWithEvent','metric','integer','Event Tracking','Sessions with Event','The total number of sessions with events.',NULL),('shoppingStage','dimension','string','Ecommerce','Shopping Stage','Various stages of the shopping experience that users completed in a session, e.g., PRODUCT_VIEW, ADD_TO_CART, CHECKOUT, etc. (Enhanced Ecommerce).',NULL),('socialEngagementType','dimension','string','Social Interactions','Social Type','Engagement type, either \"Socially Engaged\" or \"Not Socially Engaged\".',NULL),('socialInteractionAction','dimension','string','Social Interactions','Social Action','For social interactions, this is the social action (e.g., +1, bookmark) being tracked.',NULL),('socialInteractionNetwork','dimension','string','Social Interactions','Social Network','For social interactions, this represents the social network being tracked.',NULL),('socialInteractionNetworkAction','dimension','string','Social Interactions','Social Network and Action (Hit)','For social interactions, this is the concatenation of the socialInteractionNetwork and socialInteractionAction action (e.g., Google: +1) being tracked at this hit level.',NULL),('socialInteractions','metric','integer','Social Interactions','Social Actions','The total number of social interactions.',NULL),('socialInteractionsPerSession','metric','float','Social Interactions','Actions Per Social Session','The number of social interactions per session.','ga:socialInteractions / ga:uniqueSocialInteractions'),('socialInteractionTarget','dimension','string','Social Interactions','Social Entity','For social interactions, this is the URL (or resource) which receives the social network action.',NULL),('socialNetwork','dimension','string','Traffic Sources','Social Network','The social network name. This is related to the referring social network for traffic sources; e.g., Google+, Blogger.',NULL),('source','dimension','string','Traffic Sources','Source','The source of referrals. For manual campaign tracking, it is the value of the utm_source campaign tracking parameter. For AdWords autotagging, it is google. If you use neither, it is the domain of the source (e.g., document.referrer) referring the users. It may also contain a port address. If users arrived without a referrer, its value is (direct).',NULL),('sourceMedium','dimension','string','Traffic Sources','Source / Medium','Combined values of ga:source and ga:medium.',NULL),('sourcePropertyDisplayName','dimension','string','System','Source Property Display Name','Source property display name of roll-up properties. This is valid for only roll-up properties.',NULL),('sourcePropertyTrackingId','dimension','string','System','Source Property Tracking ID','Source property tracking ID of roll-up properties. This is valid for only roll-up properties.',NULL),('speedMetricsSample','metric','integer','Site Speed','Speed Metrics Sample','The sample set (or count) of pageviews used to calculate the averages of site speed metrics. This metric is used in all site speed average calculations, including avgDomainLookupTime, avgPageDownloadTime, avgRedirectionTime, avgServerConnectionTime, and avgServerResponseTime.',NULL),('subContinent','dimension','string','Geo Network','Sub Continent','Users\' sub-continent, derived from their IP addresses or Geographical IDs. For example, Polynesia or Northern Europe.',NULL),('subContinentCode','dimension','string','Geo Network','Sub Continent Code','Users\' sub-continent code in UN M.49 format, derived from their IP addresses or Geographical IDs. For example, 061 for Polynesia, 154 for Northern Europe.',NULL),('timeOnPage','metric','time','Page Tracking','Time on Page','Time (in seconds) users spent on a particular page, calculated by subtracting the initial view time for a particular page from the initial view time for a subsequent page. This metric does not apply to exit pages of the property.',NULL),('timeOnScreen','metric','time','App Tracking','Time on Screen','The time spent viewing the current screen.',NULL),('totalEvents','metric','integer','Event Tracking','Total Events','The total number of events for the profile, across all categories.',NULL),('totalPublisherClicks','metric','integer','Publisher','Publisher Clicks','The number of times ads from a linked publisher account (AdSense, AdX, DFP) were clicked on the site.',NULL),('totalPublisherCoverage','metric','percent','Publisher','Publisher Coverage','Coverage is the percentage of ad requests that returned at least one ad. Generally, coverage can help you identify sites where the publisher account (AdSense, AdX, DFP) isn\'t able to provide targeted ads. (Ad Impressions / Total Ad Requests) * 100',NULL),('totalPublisherCTR','metric','percent','Publisher','Publisher CTR','The percentage of pageviews that resulted in a click on a linked publisher account (AdSense, AdX, DFP) ad.',NULL),('totalPublisherECPM','metric','currency','Publisher','Publisher eCPM','The effective cost per thousand pageviews. It is the total estimated revenue from all linked publisher accounts (AdSense, AdX, DFP) per 1,000 pageviews.',NULL),('totalPublisherImpressions','metric','integer','Publisher','Publisher Impressions','An ad impression is reported whenever an individual ad is displayed on the website. For example, if a page with two ad units is viewed once, we\'ll display two impressions.',NULL),('totalPublisherImpressionsPerSession','metric','float','Publisher','Publisher Impressions / Session','The ratio of linked publisher account (AdSense, AdX, DFP) ad impressions to Analytics sessions (Ad Impressions / Analytics Sessions).',NULL),('totalPublisherMonetizedPageviews','metric','integer','Publisher','Publisher Monetized Pageviews','This measures the total number of pageviews on the property that were shown with an ad from one of the linked publisher accounts (AdSense, AdX, DFP). Note that a single page can have multiple ad units.',NULL),('totalPublisherRevenue','metric','currency','Publisher','Publisher Revenue','The total estimated revenue from all linked publisher account (AdSense, AdX, DFP) ads.',NULL),('totalPublisherRevenuePer1000Sessions','metric','currency','Publisher','Publisher Revenue / 1000 Sessions','The total estimated revenue from all linked publisher accounts (AdSense, AdX, DFP) per 1,000 Analytics sessions.',NULL),('totalPublisherViewableImpressionsPercent','metric','percent','Publisher','Publisher Viewable Impressions %','The percentage of viewable ad impressions. An impression is considered a viewable impression when it has appeared within users\' browsers and has the opportunity to be seen.',NULL),('totalRefunds','metric','integer','Ecommerce','Refunds','Number of refunds that have been issued (Enhanced Ecommerce).',NULL),('totalValue','metric','currency','Ecommerce','Total Value','Total value for the property (including total revenue and total goal value).','(ga:transactionRevenue + ga:goalValueAll)'),('transactionId','dimension','string','Ecommerce','Transaction ID','The transaction ID, supplied by the ecommerce tracking method, for the purchase in the shopping cart.',NULL),('transactionRevenue','metric','currency','Ecommerce','Revenue','The total sale revenue (excluding shipping and tax) of the transaction.',NULL),('transactionRevenuePerSession','metric','currency','Ecommerce','Per Session Value','Average transaction revenue for a session.','ga:transactionRevenue / ga:sessions'),('transactions','metric','integer','Ecommerce','Transactions','The total number of transactions.',NULL),('transactionShipping','metric','currency','Ecommerce','Shipping','The total cost of shipping.',NULL),('transactionsPerSession','metric','percent','Ecommerce','Ecommerce Conversion Rate','The average number of transactions in a session.','ga:transactions / ga:sessions'),('transactionsPerUser','metric','float','Ecommerce','Transactions per User','Total number of transactions divided by total number of users.',NULL),('transactionTax','metric','currency','Ecommerce','Tax','Total tax for the transaction.',NULL),('uniqueDimensionCombinations','metric','integer','Session','Unique Dimension Combinations','Unique Dimension Combinations counts the number of unique dimension-value combinations for each dimension in a report. This lets you build combined (concatenated) dimensions post-processing, which allows for more flexible reporting without having to update your tracking implementation or use additional custom-dimension slots. For more information, see https://support.google.com/analytics/answer/7084499.',NULL),('uniqueEvents','metric','integer','Event Tracking','Unique Events','The number of unique events. Events in different sessions are counted as separate events.',NULL),('uniquePageviews','metric','integer','Page Tracking','Unique Pageviews','Unique Pageviews is the number of sessions during which the specified page was viewed at least once. A unique pageview is counted for each page URL + page title combination.',NULL),('uniquePurchases','metric','integer','Ecommerce','Unique Purchases','The number of product sets purchased. For example, if users purchase 2 frisbees and 5 tennis balls from the site, this will be 2.',NULL),('uniqueScreenviews','metric','integer','App Tracking','Unique Screen Views','The number of unique screen views. Screen views in different sessions are counted as separate screen views.',NULL),('uniqueSocialInteractions','metric','integer','Social Interactions','Unique Social Actions','The number of sessions during which the specified social action(s) occurred at least once. This is based on the the unique combination of socialInteractionNetwork, socialInteractionAction, and socialInteractionTarget.',NULL),('userAgeBracket','dimension','string','Audience','Age','Age bracket of users.',NULL),('userBucket','dimension','string','User','User Bucket','Randomly assigned users tag to allow A/B testing and splitting of remarketing lists. Ranges from 1-100.',NULL),('userDefinedValue','dimension','string','User','User Defined Value','The value provided when defining custom user segments for the property.',NULL),('userGender','dimension','string','Audience','Gender','Gender of users.',NULL),('users','metric','integer','User','Users','The total number of users for the requested time period.',NULL),('userTimingCategory','dimension','string','User Timings','Timing Category','For easier reporting purposes, this is used to categorize all user timing variables into logical groups.',NULL),('userTimingLabel','dimension','string','User Timings','Timing Label','The name of the resource\'s action being tracked.',NULL),('userTimingSample','metric','integer','User Timings','User Timing Sample','The number of hits sent for a particular userTimingCategory, userTimingLabel, or userTimingVariable.',NULL),('userTimingValue','metric','integer','User Timings','User Timing (ms)','Total number of milliseconds for user timing.',NULL),('userTimingVariable','dimension','string','User Timings','Timing Variable','Used to add flexibility to visualize user timings in the reports.',NULL),('userType','dimension','string','User','User Type','A boolean, either New Visitor or Returning Visitor, indicating if the users are new or returning.',NULL),('week','dimension','string','Time','Week of the Year','The week of the session, a two-digit number from 01 to 53. Each week starts on Sunday.',NULL),('year','dimension','string','Time','Year','The year of the session, a four-digit year from 2005 to the current year.',NULL),('yearMonth','dimension','string','Time','Month of Year','Combined values of ga:year and ga:month.',NULL),('yearWeek','dimension','string','Time','Week of Year','Combined values of ga:year and ga:week.',NULL);
/*!40000 ALTER TABLE `ga_reports_fields` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `history` (
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that read the node nid.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that was read.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp at which the read occurred.',
  PRIMARY KEY (`uid`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='A record of which users have read which nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `history`
--

LOCK TABLES `history` WRITE;
/*!40000 ALTER TABLE `history` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `history` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `key_value`
--

DROP TABLE IF EXISTS `key_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `key_value` (
  `collection` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'A named collection of key and value pairs.',
  `name` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The key of the key-value pair. As KEY is a SQL reserved keyword, name was chosen instead.',
  `value` longblob NOT NULL COMMENT 'The value.',
  PRIMARY KEY (`collection`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Generic key-value storage table. See the state system for…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `key_value`
--

LOCK TABLES `key_value` WRITE;
/*!40000 ALTER TABLE `key_value` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `key_value` VALUES ('config.entity.key_store.action','uuid:0c73ca87-df28-4bad-93cb-fe172680de60',_binary 'a:1:{i:0;s:35:\"system.action.node_unpromote_action\";}'),('config.entity.key_store.action','uuid:2829ed55-ae83-413f-8152-d5fd5bc7297a',_binary 'a:1:{i:0;s:32:\"system.action.node_delete_action\";}'),('config.entity.key_store.action','uuid:2d5637bf-26b3-41ba-9d8d-740bbd679ee7',_binary 'a:1:{i:0;s:36:\"system.action.comment_publish_action\";}'),('config.entity.key_store.action','uuid:3070619a-a245-45ea-95c9-e4ec02516863',_binary 'a:1:{i:0;s:48:\"system.action.user_add_role_action.administrator\";}'),('config.entity.key_store.action','uuid:342f19e7-4fcc-43c3-be06-077b2ff1c27d',_binary 'a:1:{i:0;s:37:\"system.action.user_cancel_user_action\";}'),('config.entity.key_store.action','uuid:713d1349-e6b2-499e-bb0e-f46ed358c79f',_binary 'a:1:{i:0;s:35:\"system.action.node_unpublish_action\";}'),('config.entity.key_store.action','uuid:76a2a0e3-51b6-4a14-a8eb-3eebb78d8cb3',_binary 'a:1:{i:0;s:51:\"system.action.user_remove_role_action.administrator\";}'),('config.entity.key_store.action','uuid:8768000c-4a49-4700-9512-dd545e53405d',_binary 'a:1:{i:0;s:38:\"system.action.user_unblock_user_action\";}'),('config.entity.key_store.action','uuid:8cd78467-3aa6-4642-a795-cc3cbd214493',_binary 'a:1:{i:0;s:35:\"system.action.comment_delete_action\";}'),('config.entity.key_store.action','uuid:92aec9d7-7996-4297-8492-8763768657e1',_binary 'a:1:{i:0;s:33:\"system.action.node_promote_action\";}'),('config.entity.key_store.action','uuid:937a38cd-6717-45fd-b62a-bdbdeb7c6d0d',_binary 'a:1:{i:0;s:30:\"system.action.node_save_action\";}'),('config.entity.key_store.action','uuid:a71a6d49-8f5b-46ad-bf21-2066215da09d',_binary 'a:1:{i:0;s:38:\"system.action.comment_unpublish_action\";}'),('config.entity.key_store.action','uuid:b159d6cd-eeca-41d7-a86f-1a171ef1441e',_binary 'a:1:{i:0;s:36:\"system.action.user_block_user_action\";}'),('config.entity.key_store.action','uuid:b926720c-f69d-4b38-8a89-8b07a36077e9',_binary 'a:1:{i:0;s:33:\"system.action.node_publish_action\";}'),('config.entity.key_store.action','uuid:c3af90be-2491-4050-b1ea-5e0706449649',_binary 'a:1:{i:0;s:33:\"system.action.comment_save_action\";}'),('config.entity.key_store.action','uuid:c62d0d8a-2d20-45cc-87fa-c0f243532223',_binary 'a:1:{i:0;s:39:\"system.action.node_make_unsticky_action\";}'),('config.entity.key_store.action','uuid:f9d82e49-e281-4865-b089-7568d6e5e9ba',_binary 'a:1:{i:0;s:37:\"system.action.node_make_sticky_action\";}'),('config.entity.key_store.base_field_override','uuid:bc5657f1-35bc-4b89-a06e-1d160e0b66f7',_binary 'a:1:{i:0;s:42:\"core.base_field_override.node.page.promote\";}'),('config.entity.key_store.block','theme:bartik',_binary 'a:14:{i:0;s:32:\"block.block.bartik_local_actions\";i:1;s:30:\"block.block.bartik_local_tasks\";i:2;s:29:\"block.block.bartik_page_title\";i:3;s:23:\"block.block.bartik_help\";i:4;s:25:\"block.block.bartik_search\";i:5;s:26:\"block.block.bartik_powered\";i:6;s:27:\"block.block.bartik_messages\";i:7;s:26:\"block.block.bartik_content\";i:8;s:30:\"block.block.bartik_breadcrumbs\";i:9;s:27:\"block.block.bartik_branding\";i:10;s:31:\"block.block.bartik_account_menu\";i:11;s:25:\"block.block.bartik_footer\";i:12;s:28:\"block.block.bartik_main_menu\";i:13;s:24:\"block.block.bartik_tools\";}'),('config.entity.key_store.block','theme:credit_due',_binary 'a:6:{i:0;s:33:\"block.block.credit_due_page_title\";i:1;s:34:\"block.block.credit_due_local_tasks\";i:2;s:36:\"block.block.credit_due_local_actions\";i:3;s:27:\"block.block.credit_due_help\";i:4;s:31:\"block.block.credit_due_messages\";i:5;s:30:\"block.block.credit_due_content\";}'),('config.entity.key_store.block','theme:justice',_binary 'a:16:{i:3;s:27:\"block.block.justice_content\";i:5;s:24:\"block.block.justice_help\";i:9;s:28:\"block.block.justice_messages\";i:10;s:30:\"block.block.justice_page_title\";i:12;s:26:\"block.block.justice_search\";i:14;s:24:\"block.block.sitebranding\";i:15;s:28:\"block.block.mainnavigation_2\";i:16;s:30:\"block.block.homepagebannertext\";i:17;s:27:\"block.block.socialmedialink\";i:18;s:26:\"block.block.powerbycompany\";i:19;s:19:\"block.block.aboutus\";i:20;s:25:\"block.block.practiceareas\";i:21;s:19:\"block.block.ourteam\";i:22;s:21:\"block.block.contactus\";i:23;s:24:\"block.block.contactblock\";i:24;s:28:\"block.block.contentinfotitle\";}'),('config.entity.key_store.block','theme:seven',_binary 'a:9:{i:0;s:39:\"block.block.seven_secondary_local_tasks\";i:1;s:37:\"block.block.seven_primary_local_tasks\";i:2;s:28:\"block.block.seven_page_title\";i:3;s:31:\"block.block.seven_local_actions\";i:4;s:22:\"block.block.seven_help\";i:5;s:26:\"block.block.seven_messages\";i:6;s:25:\"block.block.seven_content\";i:7;s:29:\"block.block.seven_breadcrumbs\";i:8;s:23:\"block.block.seven_login\";}'),('config.entity.key_store.block','theme:yg_business_one',_binary 'a:14:{i:0;s:40:\"block.block.yg_business_one_account_menu\";i:1;s:36:\"block.block.yg_business_one_branding\";i:2;s:39:\"block.block.yg_business_one_breadcrumbs\";i:3;s:35:\"block.block.yg_business_one_content\";i:4;s:34:\"block.block.yg_business_one_footer\";i:5;s:32:\"block.block.yg_business_one_help\";i:6;s:41:\"block.block.yg_business_one_local_actions\";i:7;s:39:\"block.block.yg_business_one_local_tasks\";i:8;s:37:\"block.block.yg_business_one_main_menu\";i:9;s:36:\"block.block.yg_business_one_messages\";i:10;s:38:\"block.block.yg_business_one_page_title\";i:11;s:35:\"block.block.yg_business_one_powered\";i:12;s:34:\"block.block.yg_business_one_search\";i:13;s:33:\"block.block.yg_business_one_tools\";}'),('config.entity.key_store.block','theme:yg_fitness_gym',_binary 'a:14:{i:0;s:39:\"block.block.yg_fitness_gym_account_menu\";i:1;s:35:\"block.block.yg_fitness_gym_branding\";i:2;s:38:\"block.block.yg_fitness_gym_breadcrumbs\";i:3;s:34:\"block.block.yg_fitness_gym_content\";i:4;s:33:\"block.block.yg_fitness_gym_footer\";i:5;s:31:\"block.block.yg_fitness_gym_help\";i:6;s:40:\"block.block.yg_fitness_gym_local_actions\";i:7;s:38:\"block.block.yg_fitness_gym_local_tasks\";i:8;s:36:\"block.block.yg_fitness_gym_main_menu\";i:9;s:35:\"block.block.yg_fitness_gym_messages\";i:10;s:37:\"block.block.yg_fitness_gym_page_title\";i:11;s:34:\"block.block.yg_fitness_gym_powered\";i:12;s:33:\"block.block.yg_fitness_gym_search\";i:13;s:32:\"block.block.yg_fitness_gym_tools\";}'),('config.entity.key_store.block','uuid:02ac81a6-599d-4c9b-9f34-ec63727e2c38',_binary 'a:1:{i:0;s:36:\"block.block.yg_business_one_messages\";}'),('config.entity.key_store.block','uuid:08291c7c-7b12-4d1d-bafb-786e3fabf054',_binary 'a:1:{i:0;s:38:\"block.block.yg_fitness_gym_breadcrumbs\";}'),('config.entity.key_store.block','uuid:0c14917b-2ced-498e-9fc0-2f02b4517917',_binary 'a:1:{i:0;s:30:\"block.block.bartik_breadcrumbs\";}'),('config.entity.key_store.block','uuid:110343ab-d46e-4a81-b733-88b5baa42ab3',_binary 'a:1:{i:0;s:38:\"block.block.yg_fitness_gym_local_tasks\";}'),('config.entity.key_store.block','uuid:1761c270-a1e6-47b8-a403-19fd7d2a3764',_binary 'a:1:{i:0;s:31:\"block.block.seven_local_actions\";}'),('config.entity.key_store.block','uuid:19bd1239-abdc-48e1-88cd-361de22cf485',_binary 'a:1:{i:0;s:19:\"block.block.aboutus\";}'),('config.entity.key_store.block','uuid:1caa940e-0c1d-409a-8d6b-5391707ce5d1',_binary 'a:1:{i:0;s:39:\"block.block.seven_secondary_local_tasks\";}'),('config.entity.key_store.block','uuid:21a0f6bf-3750-49f6-a731-34b73470005f',_binary 'a:1:{i:0;s:27:\"block.block.credit_due_help\";}'),('config.entity.key_store.block','uuid:21a7dcd0-f294-4dd2-9cce-1d86fd3f3f47',_binary 'a:1:{i:0;s:25:\"block.block.seven_content\";}'),('config.entity.key_store.block','uuid:269853f6-e94c-489b-be6d-b93fd658edf1',_binary 'a:1:{i:0;s:28:\"block.block.mainnavigation_2\";}'),('config.entity.key_store.block','uuid:2d00ca46-356d-410e-83ac-52a1af2d16c2',_binary 'a:1:{i:0;s:32:\"block.block.bartik_local_actions\";}'),('config.entity.key_store.block','uuid:2fc0a04c-094a-4c24-b349-da9505e28957',_binary 'a:1:{i:0;s:30:\"block.block.homepagebannertext\";}'),('config.entity.key_store.block','uuid:30a3d876-55e5-487a-ab67-ee9b2ba6589e',_binary 'a:1:{i:0;s:24:\"block.block.contactblock\";}'),('config.entity.key_store.block','uuid:3591e692-8e02-41c8-ba65-df9d98d0064d',_binary 'a:1:{i:0;s:31:\"block.block.yg_fitness_gym_help\";}'),('config.entity.key_store.block','uuid:370ed465-768f-409c-a5c6-76e18e59f263',_binary 'a:1:{i:0;s:28:\"block.block.justice_messages\";}'),('config.entity.key_store.block','uuid:37458a01-44fc-4650-b431-26774c52600b',_binary 'a:1:{i:0;s:41:\"block.block.yg_business_one_local_actions\";}'),('config.entity.key_store.block','uuid:39dc9b33-ab89-4da5-af5e-c5d2b8574148',_binary 'a:1:{i:0;s:25:\"block.block.bartik_search\";}'),('config.entity.key_store.block','uuid:3a5041d3-b995-4106-b633-b567de5037f9',_binary 'a:1:{i:0;s:26:\"block.block.powerbycompany\";}'),('config.entity.key_store.block','uuid:3fe30bca-4df3-48e6-921f-47fc8a819f91',_binary 'a:1:{i:0;s:27:\"block.block.bartik_messages\";}'),('config.entity.key_store.block','uuid:42e969b6-4fc4-4a77-9d5f-8654963b3fa5',_binary 'a:1:{i:0;s:37:\"block.block.yg_business_one_main_menu\";}'),('config.entity.key_store.block','uuid:48c65ea9-2308-42d4-8edc-7a676f524b87',_binary 'a:1:{i:0;s:28:\"block.block.contentinfotitle\";}'),('config.entity.key_store.block','uuid:4f34c925-e599-42df-9c50-153df2d8609e',_binary 'a:1:{i:0;s:23:\"block.block.seven_login\";}'),('config.entity.key_store.block','uuid:51173fd1-d55e-44c1-8b86-1f2e5c2290ba',_binary 'a:1:{i:0;s:29:\"block.block.bartik_page_title\";}'),('config.entity.key_store.block','uuid:526c6345-17da-4987-850d-72f44812be7d',_binary 'a:1:{i:0;s:40:\"block.block.yg_fitness_gym_local_actions\";}'),('config.entity.key_store.block','uuid:53d8ed68-0c93-4b3e-98e1-553e9a5167a6',_binary 'a:1:{i:0;s:30:\"block.block.credit_due_content\";}'),('config.entity.key_store.block','uuid:573535ae-eb8e-4634-b40e-42046196da99',_binary 'a:1:{i:0;s:31:\"block.block.credit_due_messages\";}'),('config.entity.key_store.block','uuid:5b0350ca-0bfa-4665-a3fe-50ce5efa1de0',_binary 'a:1:{i:0;s:32:\"block.block.yg_business_one_help\";}'),('config.entity.key_store.block','uuid:5c2ee887-f478-4670-b5e6-d81912627ad2',_binary 'a:1:{i:0;s:39:\"block.block.yg_business_one_local_tasks\";}'),('config.entity.key_store.block','uuid:60e0cb93-e9e2-49ca-bd27-ce460f09429e',_binary 'a:1:{i:0;s:36:\"block.block.yg_business_one_branding\";}'),('config.entity.key_store.block','uuid:6304bc02-8b60-4447-8db2-542ba08ba08b',_binary 'a:1:{i:0;s:39:\"block.block.yg_fitness_gym_account_menu\";}'),('config.entity.key_store.block','uuid:6e4b0270-602b-4a46-ae90-24dfe257b248',_binary 'a:1:{i:0;s:37:\"block.block.seven_primary_local_tasks\";}'),('config.entity.key_store.block','uuid:788d55ca-8a56-44d9-9525-2effbcc9c002',_binary 'a:1:{i:0;s:30:\"block.block.justice_page_title\";}'),('config.entity.key_store.block','uuid:78b2edcf-564c-41e0-bafa-509d3372fee3',_binary 'a:1:{i:0;s:32:\"block.block.yg_fitness_gym_tools\";}'),('config.entity.key_store.block','uuid:7bdc1e2f-1880-4e13-a188-41c30188e4b0',_binary 'a:1:{i:0;s:27:\"block.block.socialmedialink\";}'),('config.entity.key_store.block','uuid:7d402b08-83ae-4e19-985e-84fd96958d64',_binary 'a:1:{i:0;s:29:\"block.block.seven_breadcrumbs\";}'),('config.entity.key_store.block','uuid:85e5339c-c546-44b9-8486-94d54afdd26f',_binary 'a:1:{i:0;s:33:\"block.block.yg_fitness_gym_search\";}'),('config.entity.key_store.block','uuid:866839f6-ef12-414e-95c0-b1a14e6e1578',_binary 'a:1:{i:0;s:40:\"block.block.yg_business_one_account_menu\";}'),('config.entity.key_store.block','uuid:878721c6-46a3-4ad3-a296-ece0f089d3f0',_binary 'a:1:{i:0;s:26:\"block.block.bartik_powered\";}'),('config.entity.key_store.block','uuid:89364af3-94dc-4306-bce0-175d4abdf0c6',_binary 'a:1:{i:0;s:24:\"block.block.justice_help\";}'),('config.entity.key_store.block','uuid:89f3d8b2-f40e-426d-86c4-cb3fdf8866c8',_binary 'a:1:{i:0;s:21:\"block.block.contactus\";}'),('config.entity.key_store.block','uuid:8c5a952a-73f7-4d7b-9473-ef6c6f1234e9',_binary 'a:1:{i:0;s:34:\"block.block.yg_business_one_search\";}'),('config.entity.key_store.block','uuid:8f0dcbbc-0ab1-4035-ac62-47db9b0160dd',_binary 'a:1:{i:0;s:24:\"block.block.bartik_tools\";}'),('config.entity.key_store.block','uuid:8f5f2569-87e9-437f-b39f-b9e013558e7e',_binary 'a:1:{i:0;s:24:\"block.block.sitebranding\";}'),('config.entity.key_store.block','uuid:97148985-f70b-49c3-947b-4913ccd5a594',_binary 'a:1:{i:0;s:34:\"block.block.credit_due_local_tasks\";}'),('config.entity.key_store.block','uuid:9b63e6e4-7456-4a71-96cd-6c872cfa523a',_binary 'a:1:{i:0;s:35:\"block.block.yg_fitness_gym_branding\";}'),('config.entity.key_store.block','uuid:9ff7b77b-3379-4dbf-91a7-ac7e15614bac',_binary 'a:1:{i:0;s:33:\"block.block.yg_fitness_gym_footer\";}'),('config.entity.key_store.block','uuid:a59a45fd-998b-4569-8471-35a4a5f60e76',_binary 'a:1:{i:0;s:35:\"block.block.yg_business_one_content\";}'),('config.entity.key_store.block','uuid:a737de56-27fb-4d37-8f65-67419bc1b268',_binary 'a:1:{i:0;s:23:\"block.block.bartik_help\";}'),('config.entity.key_store.block','uuid:aa7516a1-78b6-41c7-8292-d4adee150209',_binary 'a:1:{i:0;s:26:\"block.block.justice_search\";}'),('config.entity.key_store.block','uuid:ab63c563-08ef-4571-88fe-2ff3f51a840f',_binary 'a:1:{i:0;s:28:\"block.block.seven_page_title\";}'),('config.entity.key_store.block','uuid:b512d4ae-7e52-4253-b9f0-1aa0a3067022',_binary 'a:1:{i:0;s:34:\"block.block.yg_fitness_gym_powered\";}'),('config.entity.key_store.block','uuid:bc41e0f1-65b2-4e8d-8fca-8cc98d42043a',_binary 'a:1:{i:0;s:27:\"block.block.bartik_branding\";}'),('config.entity.key_store.block','uuid:bdb8507f-f9ca-4c0c-8da6-1efead8376cc',_binary 'a:1:{i:0;s:28:\"block.block.bartik_main_menu\";}'),('config.entity.key_store.block','uuid:bf29a35d-8303-4e72-81a9-6b50c6652eba',_binary 'a:1:{i:0;s:30:\"block.block.bartik_local_tasks\";}'),('config.entity.key_store.block','uuid:bffa31a0-5cb6-411e-b8f7-671634564c49',_binary 'a:1:{i:0;s:25:\"block.block.bartik_footer\";}'),('config.entity.key_store.block','uuid:c9a468ba-c37d-4438-ac97-a98b26cbf506',_binary 'a:1:{i:0;s:31:\"block.block.bartik_account_menu\";}'),('config.entity.key_store.block','uuid:cb53df72-fa2f-4662-84ed-741e0d4f0e59',_binary 'a:1:{i:0;s:27:\"block.block.justice_content\";}'),('config.entity.key_store.block','uuid:cd5176e8-5c8d-489a-956a-212e1af9f742',_binary 'a:1:{i:0;s:22:\"block.block.seven_help\";}'),('config.entity.key_store.block','uuid:cfef1d77-c2c0-4541-a26d-70486ab9d72d',_binary 'a:1:{i:0;s:33:\"block.block.yg_business_one_tools\";}'),('config.entity.key_store.block','uuid:d02c0494-ee85-475a-8d31-1b0dd18b35a0',_binary 'a:1:{i:0;s:35:\"block.block.yg_business_one_powered\";}'),('config.entity.key_store.block','uuid:d04001db-c0e9-4e72-a5c8-a83737f60f1a',_binary 'a:1:{i:0;s:34:\"block.block.yg_business_one_footer\";}'),('config.entity.key_store.block','uuid:d5a20667-e6ee-424f-bba4-6b33564fc234',_binary 'a:1:{i:0;s:33:\"block.block.credit_due_page_title\";}'),('config.entity.key_store.block','uuid:d799da0e-1a16-4778-bd61-a62887e50e5a',_binary 'a:1:{i:0;s:26:\"block.block.seven_messages\";}'),('config.entity.key_store.block','uuid:d9f91af5-4a48-40e5-b9f5-0032468739aa',_binary 'a:1:{i:0;s:26:\"block.block.bartik_content\";}'),('config.entity.key_store.block','uuid:daaa0fb7-1310-4893-bbb7-d49726919226',_binary 'a:1:{i:0;s:37:\"block.block.yg_fitness_gym_page_title\";}'),('config.entity.key_store.block','uuid:de3ece9c-da2b-4d03-99e8-a056b3600715',_binary 'a:1:{i:0;s:35:\"block.block.yg_fitness_gym_messages\";}'),('config.entity.key_store.block','uuid:def1f73c-6e7c-4466-9613-4b388aa0c751',_binary 'a:1:{i:0;s:36:\"block.block.yg_fitness_gym_main_menu\";}'),('config.entity.key_store.block','uuid:df08bdab-98e6-42ea-aa15-5219d8ec68fe',_binary 'a:1:{i:0;s:39:\"block.block.yg_business_one_breadcrumbs\";}'),('config.entity.key_store.block','uuid:e5488b49-86c8-47fc-8585-c14f5c82b399',_binary 'a:1:{i:0;s:25:\"block.block.practiceareas\";}'),('config.entity.key_store.block','uuid:f20f488a-51d6-4a07-a76b-f8d36a941c2b',_binary 'a:1:{i:0;s:19:\"block.block.ourteam\";}'),('config.entity.key_store.block','uuid:f25f648d-0d40-404c-88f0-71394a3172c6',_binary 'a:1:{i:0;s:38:\"block.block.yg_business_one_page_title\";}'),('config.entity.key_store.block','uuid:f2cb4a6a-aea0-459f-bc23-ec48f21f6d0c',_binary 'a:1:{i:0;s:34:\"block.block.yg_fitness_gym_content\";}'),('config.entity.key_store.block','uuid:fa34d76f-ba68-4f1d-bdf8-e7bd4b1ccec8',_binary 'a:1:{i:0;s:36:\"block.block.credit_due_local_actions\";}'),('config.entity.key_store.block_content_type','uuid:980a1874-9109-4ca4-8a1a-2615ef7a0ba2',_binary 'a:1:{i:0;s:24:\"block_content.type.basic\";}'),('config.entity.key_store.comment_type','uuid:05ccd90a-c7b2-45f4-b6cc-cc1136bec740',_binary 'a:1:{i:0;s:20:\"comment.type.comment\";}'),('config.entity.key_store.comment_type','uuid:1d023fb1-3275-4c7e-aee4-a535f43aa0de',_binary 'a:1:{i:0;s:45:\"comment.type.migrate_example_advanced_comment\";}'),('config.entity.key_store.comment_type','uuid:3ddbde0f-8b00-4ff9-87a0-d999813a1877',_binary 'a:1:{i:0;s:26:\"comment.type.node_comments\";}'),('config.entity.key_store.contact_form','uuid:ad8d038d-72e3-4c11-9047-f6e440521081',_binary 'a:1:{i:0;s:21:\"contact.form.personal\";}'),('config.entity.key_store.contact_form','uuid:e9fa7b4d-e502-42d8-ab68-b6aa97c4ef44',_binary 'a:1:{i:0;s:21:\"contact.form.feedback\";}'),('config.entity.key_store.content_moderation_notification','uuid:266727a7-72fb-44b1-98db-3b99de1caf4a',_binary 'a:1:{i:0;s:82:\"content_moderation_notifications.content_moderation_notification.export_promotions\";}'),('config.entity.key_store.date_format','uuid:0ff8c3bf-bc45-4ed2-ab69-578ad1b8d435',_binary 'a:1:{i:0;s:26:\"core.date_format.html_date\";}'),('config.entity.key_store.date_format','uuid:1940c7f5-3522-4e39-8570-78022b9a2360',_binary 'a:1:{i:0;s:26:\"core.date_format.html_year\";}'),('config.entity.key_store.date_format','uuid:206c5ae9-42d7-4cab-9190-aef48a969d7a',_binary 'a:1:{i:0;s:26:\"core.date_format.html_time\";}'),('config.entity.key_store.date_format','uuid:23bc8670-ecc4-43f7-b186-0c8103f74fe6',_binary 'a:1:{i:0;s:25:\"core.date_format.fallback\";}'),('config.entity.key_store.date_format','uuid:2fce3e37-2751-4c97-b03a-800aa8edd68d',_binary 'a:1:{i:0;s:22:\"core.date_format.short\";}'),('config.entity.key_store.date_format','uuid:5e019a16-c840-47d6-b110-a79aad65ade7',_binary 'a:1:{i:0;s:27:\"core.date_format.html_month\";}'),('config.entity.key_store.date_format','uuid:61aaefc2-86ec-4577-b107-6251703e735b',_binary 'a:1:{i:0;s:21:\"core.date_format.long\";}'),('config.entity.key_store.date_format','uuid:6c19692f-60f1-4b73-9947-a5c69e5d8496',_binary 'a:1:{i:0;s:26:\"core.date_format.html_week\";}'),('config.entity.key_store.date_format','uuid:7f46b867-1992-4322-80ed-fe854dd8aaca',_binary 'a:1:{i:0;s:35:\"core.date_format.html_yearless_date\";}'),('config.entity.key_store.date_format','uuid:ac893bcb-4079-4b27-acd7-1c731b528577',_binary 'a:1:{i:0;s:23:\"core.date_format.medium\";}'),('config.entity.key_store.date_format','uuid:e3009314-4cf1-46e8-8a2d-ec80f540c18f',_binary 'a:1:{i:0;s:30:\"core.date_format.html_datetime\";}'),('config.entity.key_store.editor','uuid:17ab1bf8-6584-413d-9437-6269a731114e',_binary 'a:1:{i:0;s:24:\"editor.editor.basic_html\";}'),('config.entity.key_store.editor','uuid:75dc1307-6e12-4d1f-99a0-c7448b1e712f',_binary 'a:1:{i:0;s:23:\"editor.editor.full_html\";}'),('config.entity.key_store.entity_form_display','uuid:01e6626c-7e8a-4c9c-bec0-c8de81ec5a1a',_binary 'a:1:{i:0;s:58:\"core.entity_form_display.node.migrate_example_beer.default\";}'),('config.entity.key_store.entity_form_display','uuid:2b3176af-d082-48af-b56c-290441ae1417',_binary 'a:1:{i:0;s:54:\"core.entity_form_display.comment.node_comments.default\";}'),('config.entity.key_store.entity_form_display','uuid:574b195d-c94f-44ff-8bd7-388421f48749',_binary 'a:1:{i:0;s:45:\"core.entity_form_display.node.article.default\";}'),('config.entity.key_store.entity_form_display','uuid:580e87b2-b13d-4815-954f-e8e2e7690d2a',_binary 'a:1:{i:0;s:48:\"core.entity_form_display.comment.comment.default\";}'),('config.entity.key_store.entity_form_display','uuid:99ffeb39-17d5-4ddf-a852-ab5261c53d08',_binary 'a:1:{i:0;s:52:\"core.entity_form_display.block_content.basic.default\";}'),('config.entity.key_store.entity_form_display','uuid:9b363d87-220b-4008-8f12-9bc1f464da44',_binary 'a:1:{i:0;s:62:\"core.entity_form_display.node.migrate_example_producer.default\";}'),('config.entity.key_store.entity_form_display','uuid:ac5ddce0-7240-41c2-9ae9-81ae29242dae',_binary 'a:1:{i:0;s:58:\"core.entity_form_display.node.migrate_example_wine.default\";}'),('config.entity.key_store.entity_form_display','uuid:b28a7e1b-9691-4fb6-9080-c6eb80ce7ca9',_binary 'a:1:{i:0;s:42:\"core.entity_form_display.user.user.default\";}'),('config.entity.key_store.entity_form_display','uuid:beeaa2e9-fac4-45f0-9bb0-42505861a53d',_binary 'a:1:{i:0;s:73:\"core.entity_form_display.comment.migrate_example_advanced_comment.default\";}'),('config.entity.key_store.entity_form_display','uuid:c459d029-ea99-4cc0-8d69-7b060b06ffa4',_binary 'a:1:{i:0;s:77:\"core.entity_form_display.taxonomy_term.migrate_example_wine_varieties.default\";}'),('config.entity.key_store.entity_form_display','uuid:fcbb4b97-9dfe-44ae-bfbf-46840867cfc0',_binary 'a:1:{i:0;s:42:\"core.entity_form_display.node.page.default\";}'),('config.entity.key_store.entity_form_mode','uuid:e5b51cad-a868-49bf-938b-0d96e409608d',_binary 'a:1:{i:0;s:35:\"core.entity_form_mode.user.register\";}'),('config.entity.key_store.entity_view_display','uuid:0cb03c52-b691-4b09-ba52-47313d7545de',_binary 'a:1:{i:0;s:41:\"core.entity_view_display.node.article.rss\";}'),('config.entity.key_store.entity_view_display','uuid:22b30bc0-e575-49ef-bf77-7f1a552f2f5f',_binary 'a:1:{i:0;s:61:\"core.entity_view_display.node.migrate_example_producer.teaser\";}'),('config.entity.key_store.entity_view_display','uuid:44f24e22-3939-4e88-ba2f-30ef7e88decd',_binary 'a:1:{i:0;s:57:\"core.entity_view_display.node.migrate_example_beer.teaser\";}'),('config.entity.key_store.entity_view_display','uuid:653f396d-6bd3-4071-bb70-5c4dc57e92b3',_binary 'a:1:{i:0;s:42:\"core.entity_view_display.user.user.default\";}'),('config.entity.key_store.entity_view_display','uuid:671c47ff-0a18-4b55-b213-e5e68071b6ef',_binary 'a:1:{i:0;s:48:\"core.entity_view_display.comment.comment.default\";}'),('config.entity.key_store.entity_view_display','uuid:6791e69a-e54b-47a3-8de7-2e038c8ff459',_binary 'a:1:{i:0;s:58:\"core.entity_view_display.node.migrate_example_beer.default\";}'),('config.entity.key_store.entity_view_display','uuid:7b6e2d81-8ea9-467c-8497-fc629fc9340c',_binary 'a:1:{i:0;s:77:\"core.entity_view_display.taxonomy_term.migrate_example_wine_varieties.default\";}'),('config.entity.key_store.entity_view_display','uuid:847f9e5d-0e9f-4c11-9cfd-c12843f49c49',_binary 'a:1:{i:0;s:73:\"core.entity_view_display.comment.migrate_example_advanced_comment.default\";}'),('config.entity.key_store.entity_view_display','uuid:91f8aa36-6b1d-4fd5-9ad3-edff0391c659',_binary 'a:1:{i:0;s:41:\"core.entity_view_display.node.page.teaser\";}'),('config.entity.key_store.entity_view_display','uuid:965c2596-b4ba-4bdf-af87-119ff41f636c',_binary 'a:1:{i:0;s:44:\"core.entity_view_display.node.article.teaser\";}'),('config.entity.key_store.entity_view_display','uuid:9767e0fb-2d6d-4490-aab1-07f0af7b91a7',_binary 'a:1:{i:0;s:42:\"core.entity_view_display.node.page.default\";}'),('config.entity.key_store.entity_view_display','uuid:a5a8fbb9-8e6c-436b-8fed-2a987c16fbd3',_binary 'a:1:{i:0;s:58:\"core.entity_view_display.node.migrate_example_wine.default\";}'),('config.entity.key_store.entity_view_display','uuid:ac2d80ab-9393-46c2-95fc-ed4b899cdb42',_binary 'a:1:{i:0;s:54:\"core.entity_view_display.comment.node_comments.default\";}'),('config.entity.key_store.entity_view_display','uuid:b86e5a48-15b2-4471-9399-fdec9884da15',_binary 'a:1:{i:0;s:52:\"core.entity_view_display.block_content.basic.default\";}'),('config.entity.key_store.entity_view_display','uuid:cbbf1c29-06dc-4828-9a0f-5eaa094bc549',_binary 'a:1:{i:0;s:42:\"core.entity_view_display.user.user.compact\";}'),('config.entity.key_store.entity_view_display','uuid:e0a48cf8-2715-47d7-928d-52ae1990951a',_binary 'a:1:{i:0;s:62:\"core.entity_view_display.node.migrate_example_producer.default\";}'),('config.entity.key_store.entity_view_display','uuid:e65f74fc-1e65-464d-9024-141746514c4c',_binary 'a:1:{i:0;s:57:\"core.entity_view_display.node.migrate_example_wine.teaser\";}'),('config.entity.key_store.entity_view_display','uuid:f262a8e3-0d0b-4df0-8e3f-c6d686448da2',_binary 'a:1:{i:0;s:45:\"core.entity_view_display.node.article.default\";}'),('config.entity.key_store.entity_view_mode','uuid:09792c66-7c08-4df3-bf42-2d42e2218573',_binary 'a:1:{i:0;s:40:\"core.entity_view_mode.taxonomy_term.full\";}'),('config.entity.key_store.entity_view_mode','uuid:12dec011-ce38-4dda-bb96-609268f6b144',_binary 'a:1:{i:0;s:31:\"core.entity_view_mode.user.full\";}'),('config.entity.key_store.entity_view_mode','uuid:2574d84a-638f-47ee-938f-8ca19f3a7335',_binary 'a:1:{i:0;s:33:\"core.entity_view_mode.node.teaser\";}'),('config.entity.key_store.entity_view_mode','uuid:5d360bcc-23f0-4010-939a-4ef97cc428bb',_binary 'a:1:{i:0;s:34:\"core.entity_view_mode.user.compact\";}'),('config.entity.key_store.entity_view_mode','uuid:6a080af7-8f76-4958-aa6a-952bc5788fac',_binary 'a:1:{i:0;s:40:\"core.entity_view_mode.block_content.full\";}'),('config.entity.key_store.entity_view_mode','uuid:719431ec-c443-4a9e-afd5-23bbd5faaa79',_binary 'a:1:{i:0;s:40:\"core.entity_view_mode.node.search_result\";}'),('config.entity.key_store.entity_view_mode','uuid:75d02fee-3dde-48fd-95ea-da2157b13104',_binary 'a:1:{i:0;s:39:\"core.entity_view_mode.node.search_index\";}'),('config.entity.key_store.entity_view_mode','uuid:9cd5e564-cbfd-4d39-a7ac-92942256b668',_binary 'a:1:{i:0;s:30:\"core.entity_view_mode.node.rss\";}'),('config.entity.key_store.entity_view_mode','uuid:ab24d59d-b92d-4f50-aa2c-28cd263fb31f',_binary 'a:1:{i:0;s:31:\"core.entity_view_mode.node.full\";}'),('config.entity.key_store.entity_view_mode','uuid:fa021419-b735-4781-9389-75529fc27a88',_binary 'a:1:{i:0;s:34:\"core.entity_view_mode.comment.full\";}'),('config.entity.key_store.field_config','uuid:02b0fbcd-2986-44f7-927d-3e62bdd90c62',_binary 'a:1:{i:0;s:42:\"field.field.node.migrate_example_wine.body\";}'),('config.entity.key_store.field_config','uuid:038fa040-ae08-4314-b74b-60f3e45a5f47',_binary 'a:1:{i:0;s:81:\"field.field.taxonomy_term.migrate_example_wine_varieties.field_variety_attributes\";}'),('config.entity.key_store.field_config','uuid:05f4283e-ad3e-49c2-970e-f5ede246bd7d',_binary 'a:1:{i:0;s:65:\"field.field.comment.migrate_example_advanced_comment.comment_body\";}'),('config.entity.key_store.field_config','uuid:15a8ada2-7804-4a52-b07f-ddb0442179ea',_binary 'a:1:{i:0;s:34:\"field.field.user.user.user_picture\";}'),('config.entity.key_store.field_config','uuid:15c1e1cd-290a-46b5-a3b5-ff79effd05eb',_binary 'a:1:{i:0;s:65:\"field.field.node.migrate_example_beer.field_migrate_example_image\";}'),('config.entity.key_store.field_config','uuid:188c0a73-e905-428e-baa9-63416be401c9',_binary 'a:1:{i:0;s:40:\"field.field.comment.comment.comment_body\";}'),('config.entity.key_store.field_config','uuid:197b7775-2b8b-4f16-a866-8fafdcc6502a',_binary 'a:1:{i:0;s:67:\"field.field.node.migrate_example_beer.field_migrate_example_country\";}'),('config.entity.key_store.field_config','uuid:1ee670bc-250c-42be-aa39-8ed00eba65d5',_binary 'a:1:{i:0;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_ratin\";}'),('config.entity.key_store.field_config','uuid:25b7e1bf-d194-4422-9906-63492bc85817',_binary 'a:1:{i:0;s:29:\"field.field.node.article.body\";}'),('config.entity.key_store.field_config','uuid:383e99f5-f45a-4dff-9687-935f48052827',_binary 'a:1:{i:0;s:52:\"field.field.node.migrate_example_beer.field_comments\";}'),('config.entity.key_store.field_config','uuid:3d172ace-741f-4ed1-ae61-060febfffbeb',_binary 'a:1:{i:0;s:46:\"field.field.comment.node_comments.comment_body\";}'),('config.entity.key_store.field_config','uuid:3f50dbe5-8e5a-447a-88b9-b9d4597d8ce3',_binary 'a:1:{i:0;s:70:\"field.field.node.migrate_example_beer.field_migrate_example_beer_style\";}'),('config.entity.key_store.field_config','uuid:629b21a2-39a2-44ff-b256-9cccb759ad23',_binary 'a:1:{i:0;s:42:\"field.field.node.migrate_example_beer.body\";}'),('config.entity.key_store.field_config','uuid:7b85b545-1e00-4ff2-bf16-546d82c42d96',_binary 'a:1:{i:0;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_wine_regio\";}'),('config.entity.key_store.field_config','uuid:98571a36-53c2-4ad0-8fef-d503496cf7f4',_binary 'a:1:{i:0;s:74:\"field.field.node.migrate_example_producer.field_migrate_example_wine_regio\";}'),('config.entity.key_store.field_config','uuid:9a2ee506-d13c-486a-8dad-1114bf13ecdd',_binary 'a:1:{i:0;s:36:\"field.field.block_content.basic.body\";}'),('config.entity.key_store.field_config','uuid:a73f752d-1642-45ea-a85c-8ab426c8ddad',_binary 'a:1:{i:0;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_wine_var\";}'),('config.entity.key_store.field_config','uuid:af3a4c23-8dec-4594-bcd8-3168f75a5ed4',_binary 'a:1:{i:0;s:32:\"field.field.node.article.comment\";}'),('config.entity.key_store.field_config','uuid:b3f24804-97d4-4400-9102-e06b37d5f75f',_binary 'a:1:{i:0;s:50:\"field.field.user.user.field_migrate_example_gender\";}'),('config.entity.key_store.field_config','uuid:b7f2771d-df62-4c67-b7c1-2179ae6e3cb7',_binary 'a:1:{i:0;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_wine_best\";}'),('config.entity.key_store.field_config','uuid:b8cf44dd-b10b-40db-9324-26854c19e8de',_binary 'a:1:{i:0;s:26:\"field.field.node.page.body\";}'),('config.entity.key_store.field_config','uuid:c06b3c71-8b56-4b1a-b937-f7022336734e',_binary 'a:1:{i:0;s:52:\"field.field.user.user.field_migrate_example_favbeers\";}'),('config.entity.key_store.field_config','uuid:c3fa4924-0661-4d6f-a4cb-3d49e11080e1',_binary 'a:1:{i:0;s:70:\"field.field.node.migrate_example_wine.field_migrate_example_top_vintag\";}'),('config.entity.key_store.field_config','uuid:ca9cbb33-7c78-4fc9-b85a-51fa25db81c4',_binary 'a:1:{i:0;s:35:\"field.field.node.article.field_tags\";}'),('config.entity.key_store.field_config','uuid:e98961e2-0cec-4ea5-bd07-287701755573',_binary 'a:1:{i:0;s:46:\"field.field.node.migrate_example_producer.body\";}'),('config.entity.key_store.field_config','uuid:eece7e20-cd5d-4e4c-b4f7-8aea79d5d9f0',_binary 'a:1:{i:0;s:68:\"field.field.node.migrate_example_wine.field_migrate_example_comments\";}'),('config.entity.key_store.field_config','uuid:f425d91a-c5fe-4194-a937-bf2c28379389',_binary 'a:1:{i:0;s:36:\"field.field.node.article.field_image\";}'),('config.entity.key_store.field_config','uuid:fea3b469-b569-4529-9189-47b66ece7ed2',_binary 'a:1:{i:0;s:69:\"field.field.node.migrate_example_wine.field_migrate_example_adv_image\";}'),('config.entity.key_store.field_storage_config','uuid:11b2a4ff-4513-4663-938d-060cda2689e1',_binary 'a:1:{i:0;s:51:\"field.storage.node.field_migrate_example_beer_style\";}'),('config.entity.key_store.field_storage_config','uuid:174d947b-0f2d-4bbc-97a0-ed966f6519d4',_binary 'a:1:{i:0;s:48:\"field.storage.node.field_migrate_example_country\";}'),('config.entity.key_store.field_storage_config','uuid:2245f192-9a68-4931-b960-80ddce78214d',_binary 'a:1:{i:0;s:51:\"field.storage.node.field_migrate_example_top_vintag\";}'),('config.entity.key_store.field_storage_config','uuid:34bb10e9-a28d-459d-9cfe-ce04b8a54387',_binary 'a:1:{i:0;s:50:\"field.storage.node.field_migrate_example_wine_best\";}'),('config.entity.key_store.field_storage_config','uuid:3a033163-ac33-47ae-9186-2aecf22e5a8a',_binary 'a:1:{i:0;s:47:\"field.storage.user.field_migrate_example_gender\";}'),('config.entity.key_store.field_storage_config','uuid:4bd18d5b-1b54-4d93-8809-1f2a2cfbcc80',_binary 'a:1:{i:0;s:23:\"field.storage.node.body\";}'),('config.entity.key_store.field_storage_config','uuid:4d9219b4-339a-4759-aaf2-9dcd7a27fb11',_binary 'a:1:{i:0;s:49:\"field.storage.user.field_migrate_example_favbeers\";}'),('config.entity.key_store.field_storage_config','uuid:50da2584-5c3b-41ad-87cb-032fa5039401',_binary 'a:1:{i:0;s:52:\"field.storage.taxonomy_term.field_variety_attributes\";}'),('config.entity.key_store.field_storage_config','uuid:5ec526fb-c67f-4c40-80df-1e2b92438662',_binary 'a:1:{i:0;s:49:\"field.storage.node.field_migrate_example_comments\";}'),('config.entity.key_store.field_storage_config','uuid:64472a0e-1641-463b-8103-ec2ed8f6c5e3',_binary 'a:1:{i:0;s:50:\"field.storage.node.field_migrate_example_adv_image\";}'),('config.entity.key_store.field_storage_config','uuid:73418115-95a0-4170-9dd7-284673acd7d2',_binary 'a:1:{i:0;s:29:\"field.storage.node.field_tags\";}'),('config.entity.key_store.field_storage_config','uuid:7fa5154f-d1e9-4c85-a43d-2cedc39808c0',_binary 'a:1:{i:0;s:31:\"field.storage.user.user_picture\";}'),('config.entity.key_store.field_storage_config','uuid:89bb858a-3fa0-40a3-b7e5-29a286ecbe05',_binary 'a:1:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_regio\";}'),('config.entity.key_store.field_storage_config','uuid:9db1bcab-f817-4886-a5b5-34d700f8848f',_binary 'a:1:{i:0;s:51:\"field.storage.node.field_migrate_example_wine_ratin\";}'),('config.entity.key_store.field_storage_config','uuid:ca2a0686-6c75-4895-bb9e-670fa7ef511f',_binary 'a:1:{i:0;s:34:\"field.storage.comment.comment_body\";}'),('config.entity.key_store.field_storage_config','uuid:cb6e812d-2115-4faf-98d1-e6a4706413c9',_binary 'a:1:{i:0;s:33:\"field.storage.node.field_comments\";}'),('config.entity.key_store.field_storage_config','uuid:ccf999c7-4756-4fb3-b254-edec33730b53',_binary 'a:1:{i:0;s:26:\"field.storage.node.comment\";}'),('config.entity.key_store.field_storage_config','uuid:d224118f-844d-4d9b-8fc5-afa0888f4af1',_binary 'a:1:{i:0;s:32:\"field.storage.block_content.body\";}'),('config.entity.key_store.field_storage_config','uuid:d57d2d8a-c9f4-4b45-9c8e-f544aa2f818e',_binary 'a:1:{i:0;s:46:\"field.storage.node.field_migrate_example_image\";}'),('config.entity.key_store.field_storage_config','uuid:e627ec31-c833-465f-ba31-28b765ab8f37',_binary 'a:1:{i:0;s:49:\"field.storage.node.field_migrate_example_wine_var\";}'),('config.entity.key_store.field_storage_config','uuid:eb5224c0-e6c7-49cf-82b6-229f46ef800b',_binary 'a:1:{i:0;s:30:\"field.storage.node.field_image\";}'),('config.entity.key_store.filter_format','uuid:0403a3a3-3497-4742-a34e-f6a8da2ad328',_binary 'a:1:{i:0;s:24:\"filter.format.plain_text\";}'),('config.entity.key_store.filter_format','uuid:16b41f45-b3df-43de-b81a-58bc067ae0e6',_binary 'a:1:{i:0;s:24:\"filter.format.basic_html\";}'),('config.entity.key_store.filter_format','uuid:c614a838-4cb0-42cf-b62e-9c4e4380a7ce',_binary 'a:1:{i:0;s:23:\"filter.format.full_html\";}'),('config.entity.key_store.filter_format','uuid:e7bc7f5d-5be5-4a00-bd41-6d29c590524b',_binary 'a:1:{i:0;s:29:\"filter.format.restricted_html\";}'),('config.entity.key_store.image_style','uuid:201a0bb1-03a3-4747-a968-ebf780afc231',_binary 'a:1:{i:0;s:17:\"image.style.large\";}'),('config.entity.key_store.image_style','uuid:9763a674-a0e7-4092-892a-7000ec93d550',_binary 'a:1:{i:0;s:18:\"image.style.medium\";}'),('config.entity.key_store.image_style','uuid:d783129a-aa55-4ad3-a437-b07c106fc966',_binary 'a:1:{i:0;s:21:\"image.style.thumbnail\";}'),('config.entity.key_store.menu','uuid:49eb0318-e9b0-4776-8a3b-7343719aa935',_binary 'a:1:{i:0;s:19:\"system.menu.account\";}'),('config.entity.key_store.menu','uuid:58a468f7-6939-42e7-84d7-5cfb079f8731',_binary 'a:1:{i:0;s:17:\"system.menu.tools\";}'),('config.entity.key_store.menu','uuid:96b3f6ab-f74a-4076-9cde-d709f219e8c0',_binary 'a:1:{i:0;s:17:\"system.menu.devel\";}'),('config.entity.key_store.menu','uuid:b12f73b0-d01d-4853-af6e-9c316c0c2cfb',_binary 'a:1:{i:0;s:16:\"system.menu.main\";}'),('config.entity.key_store.menu','uuid:e668dd2a-9385-4dfd-b05d-2c0e479ac191',_binary 'a:1:{i:0;s:18:\"system.menu.footer\";}'),('config.entity.key_store.menu','uuid:ffdd0567-c401-4542-8098-7886137167bd',_binary 'a:1:{i:0;s:17:\"system.menu.admin\";}'),('config.entity.key_store.node_type','uuid:570dc409-91e0-48b4-a412-def16b756fd7',_binary 'a:1:{i:0;s:17:\"node.type.article\";}'),('config.entity.key_store.node_type','uuid:5b8a080b-4883-4eef-9e9b-451db02d8bc5',_binary 'a:1:{i:0;s:30:\"node.type.migrate_example_beer\";}'),('config.entity.key_store.node_type','uuid:5ee98c60-03db-4240-8408-7d1a9adc8a8d',_binary 'a:1:{i:0;s:14:\"node.type.page\";}'),('config.entity.key_store.node_type','uuid:942256f1-1a4c-4828-995d-d1aec2ca115f',_binary 'a:1:{i:0;s:34:\"node.type.migrate_example_producer\";}'),('config.entity.key_store.node_type','uuid:e70c6013-aa35-47e9-8c2b-df483f60588f',_binary 'a:1:{i:0;s:30:\"node.type.migrate_example_wine\";}'),('config.entity.key_store.rdf_mapping','uuid:28d43243-a226-4db5-bfe5-58011b758cea',_binary 'a:1:{i:0;s:30:\"rdf.mapping.taxonomy_term.tags\";}'),('config.entity.key_store.rdf_mapping','uuid:41ee14a8-6904-4495-b680-2efb83b258ae',_binary 'a:1:{i:0;s:24:\"rdf.mapping.node.article\";}'),('config.entity.key_store.rdf_mapping','uuid:9d97cccd-ba17-42be-a940-793cc5ad5430',_binary 'a:1:{i:0;s:21:\"rdf.mapping.node.page\";}'),('config.entity.key_store.rdf_mapping','uuid:bb66fbda-2d1b-442d-9428-74a6e92bf15a',_binary 'a:1:{i:0;s:27:\"rdf.mapping.comment.comment\";}'),('config.entity.key_store.rdf_mapping','uuid:c485a710-d9e6-412a-bc7a-9cfe679f4c2b',_binary 'a:1:{i:0;s:21:\"rdf.mapping.user.user\";}'),('config.entity.key_store.search_page','uuid:bdd6728c-1758-4580-a896-098f2403cabd',_binary 'a:1:{i:0;s:23:\"search.page.user_search\";}'),('config.entity.key_store.search_page','uuid:c4bb8f59-527e-4bb9-99d3-c6109c3cef5d',_binary 'a:1:{i:0;s:23:\"search.page.node_search\";}'),('config.entity.key_store.shortcut_set','uuid:29cc33d0-f17d-4e92-ab21-a709f2d740e1',_binary 'a:1:{i:0;s:20:\"shortcut.set.default\";}'),('config.entity.key_store.taxonomy_vocabulary','uuid:11c2f626-3a04-4f09-bf65-36ef6620dadb',_binary 'a:1:{i:0;s:47:\"taxonomy.vocabulary.migrate_example_beer_styles\";}'),('config.entity.key_store.taxonomy_vocabulary','uuid:35a776b4-9412-46b9-b8cc-1f5c2e473fb9',_binary 'a:1:{i:0;s:48:\"taxonomy.vocabulary.migrate_example_wine_regions\";}'),('config.entity.key_store.taxonomy_vocabulary','uuid:55a19acc-deb2-4c76-aaa3-03cd390feab6',_binary 'a:1:{i:0;s:50:\"taxonomy.vocabulary.migrate_example_wine_best_with\";}'),('config.entity.key_store.taxonomy_vocabulary','uuid:5e143112-8b1f-406b-8e42-9e932a410678',_binary 'a:1:{i:0;s:24:\"taxonomy.vocabulary.tags\";}'),('config.entity.key_store.taxonomy_vocabulary','uuid:d6b0d5dc-57b7-447c-8aef-2fdaa810601b',_binary 'a:1:{i:0;s:50:\"taxonomy.vocabulary.migrate_example_wine_varieties\";}'),('config.entity.key_store.tour','routes.*.route_name:entity.view.edit_display_form',_binary 'a:1:{i:0;s:18:\"tour.tour.views-ui\";}'),('config.entity.key_store.tour','routes.*.route_name:entity.view.edit_form',_binary 'a:1:{i:0;s:18:\"tour.tour.views-ui\";}'),('config.entity.key_store.tour','uuid:290c93bf-ce9b-40ea-8c58-90217b312670',_binary 'a:1:{i:0;s:18:\"tour.tour.views-ui\";}'),('config.entity.key_store.user_role','uuid:08eb6f79-361f-47e6-bc46-acb5c724076a',_binary 'a:1:{i:0;s:23:\"user.role.authenticated\";}'),('config.entity.key_store.user_role','uuid:382c102a-ac11-4f94-90aa-3310bf725e14',_binary 'a:1:{i:0;s:23:\"user.role.administrator\";}'),('config.entity.key_store.user_role','uuid:b60f3e54-d77d-4b61-88d0-0db6596bf556',_binary 'a:1:{i:0;s:19:\"user.role.anonymous\";}'),('config.entity.key_store.view','uuid:0435a20c-c8f6-4a0b-9685-ac4cc90a84d6',_binary 'a:1:{i:0;s:16:\"views.view.files\";}'),('config.entity.key_store.view','uuid:13ca1035-59fd-489b-987d-488b35db0447',_binary 'a:1:{i:0;s:20:\"views.view.frontpage\";}'),('config.entity.key_store.view','uuid:248c0cf4-3881-404a-bc41-3269e0302465',_binary 'a:1:{i:0;s:20:\"views.view.who_s_new\";}'),('config.entity.key_store.view','uuid:3aa0a697-db85-4dd5-8e95-ec0beebce912',_binary 'a:1:{i:0;s:28:\"views.view.user_admin_people\";}'),('config.entity.key_store.view','uuid:44e54189-22c3-4dd6-aecd-2cc361466496',_binary 'a:1:{i:0;s:18:\"views.view.comment\";}'),('config.entity.key_store.view','uuid:509e5844-fc48-4698-880e-985b043c408e',_binary 'a:1:{i:0;s:24:\"views.view.block_content\";}'),('config.entity.key_store.view','uuid:510cbdf1-d2b7-4bc9-96e9-c372ecb6d545',_binary 'a:1:{i:0;s:23:\"views.view.who_s_online\";}'),('config.entity.key_store.view','uuid:64a1de1e-195f-4d38-8c57-14a4bc8a9181',_binary 'a:1:{i:0;s:26:\"views.view.ga_reports_page\";}'),('config.entity.key_store.view','uuid:8e979f14-95c2-44a5-afc5-ccfc2417086d',_binary 'a:1:{i:0;s:19:\"views.view.watchdog\";}'),('config.entity.key_store.view','uuid:969da648-5dfb-4525-b549-1f4491e0cbf4',_binary 'a:1:{i:0;s:18:\"views.view.archive\";}'),('config.entity.key_store.view','uuid:b41b4bd4-c008-45ad-9078-affdc821f445',_binary 'a:1:{i:0;s:18:\"views.view.content\";}'),('config.entity.key_store.view','uuid:bbbb06c0-2d37-4f22-9554-be4d562c4786',_binary 'a:1:{i:0;s:19:\"views.view.glossary\";}'),('config.entity.key_store.view','uuid:bdd50755-73e5-47be-976b-ae900ccabe94',_binary 'a:1:{i:0;s:25:\"views.view.content_recent\";}'),('config.entity.key_store.view','uuid:c9844857-b656-434f-9b2e-b4fbe1a98e68',_binary 'a:1:{i:0;s:24:\"views.view.taxonomy_term\";}'),('config.entity.key_store.view','uuid:e1d6c846-7e7f-45e2-8242-2bd70c6eed1c',_binary 'a:1:{i:0;s:26:\"views.view.comments_recent\";}'),('config.entity.key_store.view','uuid:f6f3c9f5-4596-47b7-84af-492bc8409347',_binary 'a:1:{i:0;s:28:\"views.view.moderated_content\";}'),('config.entity.key_store.view','uuid:fs5ek9f7-ffd8-4bb4-a4b6-323187899236',_binary 'a:1:{i:0;s:21:\"views.view.ga_summary\";}'),('config.entity.key_store.workflow','uuid:20c79df6-385e-4ffd-bb07-65f3bb58d891',_binary 'a:1:{i:0;s:28:\"workflows.workflow.editorial\";}'),('entity.definitions.bundle_field_map','block_content',_binary 'a:1:{s:4:\"body\";a:2:{s:4:\"type\";s:17:\"text_with_summary\";s:7:\"bundles\";a:1:{s:5:\"basic\";s:5:\"basic\";}}}'),('entity.definitions.bundle_field_map','comment',_binary 'a:1:{s:12:\"comment_body\";a:2:{s:4:\"type\";s:9:\"text_long\";s:7:\"bundles\";a:3:{s:7:\"comment\";s:7:\"comment\";s:13:\"node_comments\";s:13:\"node_comments\";s:32:\"migrate_example_advanced_comment\";s:32:\"migrate_example_advanced_comment\";}}}'),('entity.definitions.bundle_field_map','node',_binary 'a:15:{s:11:\"field_image\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:7:\"article\";s:7:\"article\";}}s:7:\"comment\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:7:\"article\";s:7:\"article\";}}s:10:\"field_tags\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:7:\"article\";s:7:\"article\";}}s:4:\"body\";a:2:{s:4:\"type\";s:17:\"text_with_summary\";s:7:\"bundles\";a:5:{s:4:\"page\";s:4:\"page\";s:7:\"article\";s:7:\"article\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";}}s:27:\"field_migrate_example_image\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:29:\"field_migrate_example_country\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:14:\"field_comments\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:32:\"field_migrate_example_beer_style\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_beer\";s:20:\"migrate_example_beer\";}}s:32:\"field_migrate_example_wine_ratin\";a:2:{s:4:\"type\";s:7:\"decimal\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:32:\"field_migrate_example_top_vintag\";a:2:{s:4:\"type\";s:7:\"integer\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:30:\"field_migrate_example_comments\";a:2:{s:4:\"type\";s:7:\"comment\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:31:\"field_migrate_example_adv_image\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:31:\"field_migrate_example_wine_best\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}s:32:\"field_migrate_example_wine_regio\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:2:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";s:24:\"migrate_example_producer\";s:24:\"migrate_example_producer\";}}s:30:\"field_migrate_example_wine_var\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:20:\"migrate_example_wine\";s:20:\"migrate_example_wine\";}}}'),('entity.definitions.bundle_field_map','taxonomy_term',_binary 'a:1:{s:24:\"field_variety_attributes\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:30:\"migrate_example_wine_varieties\";s:30:\"migrate_example_wine_varieties\";}}}'),('entity.definitions.bundle_field_map','user',_binary 'a:3:{s:12:\"user_picture\";a:2:{s:4:\"type\";s:5:\"image\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:28:\"field_migrate_example_gender\";a:2:{s:4:\"type\";s:6:\"string\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}s:30:\"field_migrate_example_favbeers\";a:2:{s:4:\"type\";s:16:\"entity_reference\";s:7:\"bundles\";a:1:{s:4:\"user\";s:4:\"user\";}}}'),('entity.definitions.installed','action.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:6:\"plugin\";i:4;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"action\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\system\\Entity\\Action\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:18:\"administer actions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Action\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:action_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\system\\Entity\\Action\";s:11:\"\0*\0provider\";s:6:\"system\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','base_field_override.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:19:\"base_field_override\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"base_field_override\";s:16:\"\0*\0originalClass\";s:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\";s:11:\"\0*\0handlers\";a:2:{s:7:\"storage\";s:42:\"Drupal\\Core\\Field\\BaseFieldOverrideStorage\";s:6:\"access\";s:55:\"Drupal\\Core\\Field\\BaseFieldOverrideAccessControlHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Base field override\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:base_field_override_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:42:\"Drupal\\Core\\Field\\Entity\\BaseFieldOverride\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','block.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:5:\"theme\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:8:{i:0;s:2:\"id\";i:1;s:5:\"theme\";i:2;s:6:\"region\";i:3;s:6:\"weight\";i:4;s:8:\"provider\";i:5;s:6:\"plugin\";i:6;s:8:\"settings\";i:7;s:10:\"visibility\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:5:\"block\";s:16:\"\0*\0originalClass\";s:25:\"Drupal\\block\\Entity\\Block\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:38:\"Drupal\\block\\BlockAccessControlHandler\";s:12:\"view_builder\";s:29:\"Drupal\\block\\BlockViewBuilder\";s:12:\"list_builder\";s:29:\"Drupal\\block\\BlockListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:22:\"Drupal\\block\\BlockForm\";s:6:\"delete\";s:33:\"Drupal\\block\\Form\\BlockDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:44:\"/admin/structure/block/manage/{block}/delete\";s:9:\"edit-form\";s:37:\"/admin/structure/block/manage/{block}\";s:6:\"enable\";s:44:\"/admin/structure/block/manage/{block}/enable\";s:7:\"disable\";s:45:\"/admin/structure/block/manage/{block}/disable\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:17:\"config:block_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:25:\"Drupal\\block\\Entity\\Block\";s:11:\"\0*\0provider\";s:5:\"block\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','block_content.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:13:\"revision_user\";s:13:\"revision_user\";s:16:\"revision_created\";s:16:\"revision_created\";s:20:\"revision_log_message\";s:12:\"revision_log\";s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:0;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:11:\"revision_id\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:4:\"info\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:9:\"published\";s:6:\"status\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:13:\"block_content\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\block_content\\Entity\\BlockContent\";s:11:\"\0*\0handlers\";a:7:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:6:\"access\";s:53:\"Drupal\\block_content\\BlockContentAccessControlHandler\";s:12:\"list_builder\";s:44:\"Drupal\\block_content\\BlockContentListBuilder\";s:12:\"view_builder\";s:44:\"Drupal\\block_content\\BlockContentViewBuilder\";s:10:\"views_data\";s:42:\"Drupal\\block_content\\BlockContentViewsData\";s:4:\"form\";a:4:{s:3:\"add\";s:37:\"Drupal\\block_content\\BlockContentForm\";s:4:\"edit\";s:37:\"Drupal\\block_content\\BlockContentForm\";s:6:\"delete\";s:48:\"Drupal\\block_content\\Form\\BlockContentDeleteForm\";s:7:\"default\";s:37:\"Drupal\\block_content\\BlockContentForm\";}s:11:\"translation\";s:51:\"Drupal\\block_content\\BlockContentTranslationHandler\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:5:{s:9:\"canonical\";s:22:\"/block/{block_content}\";s:11:\"delete-form\";s:29:\"/block/{block_content}/delete\";s:9:\"edit-form\";s:22:\"/block/{block_content}\";s:10:\"collection\";s:36:\"/admin/structure/block/block-content\";s:6:\"create\";s:6:\"/block\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:18:\"block_content_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:13:\"block_content\";s:22:\"\0*\0revision_data_table\";s:28:\"block_content_field_revision\";s:17:\"\0*\0revision_table\";s:22:\"block_content_revision\";s:13:\"\0*\0data_table\";s:24:\"block_content_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:1;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Custom block\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:35:\"entity.block_content_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"block_content_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:40:\"Drupal\\block_content\\Entity\\BlockContent\";s:11:\"\0*\0provider\";s:13:\"block_content\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','block_content.field_storage_definitions',_binary 'a:16:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Custom block ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"The custom block ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The custom block UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"The revision ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"The custom block language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:151;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:18:\"block_content_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The block type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"revision_created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:188;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"revision_created\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:13:\"revision_user\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:217;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:13:\"revision_user\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:12:\"revision_log\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:253;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The log entry explaining the changes in this revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:25;s:8:\"settings\";a:1:{s:4:\"rows\";i:4;}}}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:12:\"revision_log\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:294;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"info\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:332;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:11:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Block description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"A brief description of your block.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:11:\"constraints\";a:1:{s:11:\"UniqueField\";a:0:{}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:4:\"info\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:376;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the custom block was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:406;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:448;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:489;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:13:\"block_content\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:13:\"block_content\";s:6:\"bundle\";N;}}s:4:\"body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:18:\"block_content.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:14:\"\0*\0entity_type\";s:13:\"block_content\";s:7:\"\0*\0type\";s:17:\"text_with_summary\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:18:\"block_content.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"d224118f-844d-4d9b-8fc5-afa0888f4af1\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"eS0snV_L3dx9shtWRTzm5eblwOJ7qKWC9IE-4GMTDFc\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:13:\"block_content\";i:1;s:4:\"text\";}}}s:8:\"reusable\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:563;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Reusable\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"A boolean indicating whether this block is reusable.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:0;s:12:\"revisionable\";b:0;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:8:\"reusable\";s:11:\"entity_type\";s:13:\"block_content\";s:8:\"provider\";s:13:\"block_content\";s:6:\"bundle\";N;}}}'),('entity.definitions.installed','block_content_type.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:8:\"revision\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:18:\"block_content_type\";s:16:\"\0*\0originalClass\";s:44:\"Drupal\\block_content\\Entity\\BlockContentType\";s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:7:\"default\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:3:\"add\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:4:\"edit\";s:41:\"Drupal\\block_content\\BlockContentTypeForm\";s:6:\"delete\";s:52:\"Drupal\\block_content\\Form\\BlockContentTypeDeleteForm\";}s:12:\"list_builder\";s:48:\"Drupal\\block_content\\BlockContentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer blocks\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:11:\"delete-form\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/delete\";s:9:\"edit-form\";s:64:\"/admin/structure/block/block-content/manage/{block_content_type}\";s:10:\"collection\";s:42:\"/admin/structure/block/block-content/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"block_content\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Custom block type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:30:\"config:block_content_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:44:\"Drupal\\block_content\\Entity\\BlockContentType\";s:11:\"\0*\0provider\";s:13:\"block_content\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','comment.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"cid\";s:6:\"bundle\";s:12:\"comment_type\";s:5:\"label\";s:7:\"subject\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:9:\"published\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:7:\"comment\";s:16:\"\0*\0originalClass\";s:29:\"Drupal\\comment\\Entity\\Comment\";s:11:\"\0*\0handlers\";a:8:{s:7:\"storage\";s:29:\"Drupal\\comment\\CommentStorage\";s:14:\"storage_schema\";s:35:\"Drupal\\comment\\CommentStorageSchema\";s:6:\"access\";s:42:\"Drupal\\comment\\CommentAccessControlHandler\";s:12:\"list_builder\";s:36:\"Drupal\\Core\\Entity\\EntityListBuilder\";s:12:\"view_builder\";s:33:\"Drupal\\comment\\CommentViewBuilder\";s:10:\"views_data\";s:31:\"Drupal\\comment\\CommentViewsData\";s:4:\"form\";a:2:{s:7:\"default\";s:26:\"Drupal\\comment\\CommentForm\";s:6:\"delete\";s:30:\"Drupal\\comment\\Form\\DeleteForm\";}s:11:\"translation\";s:40:\"Drupal\\comment\\CommentTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"canonical\";s:18:\"/comment/{comment}\";s:11:\"delete-form\";s:25:\"/comment/{comment}/delete\";s:9:\"edit-form\";s:23:\"/comment/{comment}/edit\";s:6:\"create\";s:8:\"/comment\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"comment_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:7:\"comment\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:18:\"comment_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"comment\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:14:\"@count comment\";s:6:\"plural\";s:15:\"@count comments\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";s:11:\"comment_uri\";s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:29:\"entity.comment_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:12:\"comment_list\";}s:14:\"\0*\0constraints\";a:3:{s:11:\"CommentName\";a:0:{}s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:29:\"Drupal\\comment\\Entity\\Comment\";s:11:\"\0*\0provider\";s:7:\"comment\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','comment.field_storage_definitions',_binary 'a:20:{s:3:\"cid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Comment ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"The comment ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"cid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:12:\"comment_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:113;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"comment_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment Type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The comment type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:12:\"comment_type\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:150;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:22:\"default_value_callback\";s:47:\"Drupal\\comment\\Entity\\Comment::getDefaultStatus\";s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:3:\"pid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:189;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:7:\"comment\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Parent ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The parent comment ID if this is a reply to a comment.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"pid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:9:\"entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:224;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"The ID of the entity of which this comment is a reply.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:9:\"entity_id\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:7:\"subject\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:260;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:64;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Subject\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"subject\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:296;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The user ID of the comment author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:9:\"target_id\";i:0;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:335;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:60;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The comment author\'s name.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:372;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The comment author\'s email address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"homepage\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:3:\"uri\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:402;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:14:\"field_item:uri\";s:8:\"settings\";a:2:{s:10:\"max_length\";i:255;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Homepage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The comment author\'s home page address.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"homepage\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:8:\"hostname\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:435;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Hostname\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The comment author\'s hostname.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:8:\"hostname\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;s:22:\"default_value_callback\";s:49:\"Drupal\\comment\\Entity\\Comment::getDefaultHostname\";s:13:\"initial_value\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:471;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time that the comment was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:500;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:42:\"The time that the comment was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:6:\"thread\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:529;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Thread place\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:144:\"The alphadecimal representation of the comment\'s place in a thread, consisting of a base 36 string prefixed by an integer indicating its length.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:6:\"thread\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:11:\"entity_type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:562;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The entity type to which this comment is attached.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:11:\"entity_type\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:10:\"field_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:595;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Comment field name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The field name through which this comment was added.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:10:\"field_name\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:628;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:7:\"comment\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";N;}}s:12:\"comment_body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:20:\"comment.comment_body\";s:13:\"\0*\0field_name\";s:12:\"comment_body\";s:14:\"\0*\0entity_type\";s:7:\"comment\";s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:20:\"comment.comment_body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"ca2a0686-6c75-4895-bb9e-670fa7ef511f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"swYoCch_hY8QO5uwr4FURplfnUCUlpPB4idF8WGVCpw\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"text\";}}}}'),('entity.definitions.installed','comment_type.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:21:\"target_entity_type_id\";i:3;s:11:\"description\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"comment_type\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\comment\\Entity\\CommentType\";s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:7:\"default\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:3:\"add\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:4:\"edit\";s:30:\"Drupal\\comment\\CommentTypeForm\";s:6:\"delete\";s:41:\"Drupal\\comment\\Form\\CommentTypeDeleteForm\";}s:12:\"list_builder\";s:37:\"Drupal\\comment\\CommentTypeListBuilder\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer comment types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:53:\"/admin/structure/comment/manage/{comment_type}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/comment/manage/{comment_type}\";s:8:\"add-form\";s:34:\"/admin/structure/comment/types/add\";s:10:\"collection\";s:24:\"/admin/structure/comment\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:7:\"comment\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"comment type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"comment types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count comment type\";s:6:\"plural\";s:20:\"@count comment types\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:comment_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\comment\\Entity\\CommentType\";s:11:\"\0*\0provider\";s:7:\"comment\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','contact_form.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:4:\"form\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:10:\"recipients\";i:3;s:5:\"reply\";i:4;s:6:\"weight\";i:5;s:7:\"message\";i:6;s:8:\"redirect\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"contact_form\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\contact\\Entity\\ContactForm\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:46:\"Drupal\\contact\\ContactFormAccessControlHandler\";s:12:\"list_builder\";s:37:\"Drupal\\contact\\ContactFormListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:4:\"edit\";s:34:\"Drupal\\contact\\ContactFormEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer contact forms\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:53:\"/admin/structure/contact/manage/{contact_form}/delete\";s:9:\"edit-form\";s:46:\"/admin/structure/contact/manage/{contact_form}\";s:10:\"collection\";s:24:\"/admin/structure/contact\";s:9:\"canonical\";s:23:\"/contact/{contact_form}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:15:\"contact_message\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:contact_form_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\contact\\Entity\\ContactForm\";s:11:\"\0*\0provider\";s:7:\"contact\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','contact_message.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:6:{s:6:\"bundle\";s:12:\"contact_form\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:8:\"langcode\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:15:\"contact_message\";s:16:\"\0*\0originalClass\";s:29:\"Drupal\\contact\\Entity\\Message\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:49:\"Drupal\\contact\\ContactMessageAccessControlHandler\";s:7:\"storage\";s:43:\"Drupal\\Core\\Entity\\ContentEntityNullStorage\";s:12:\"view_builder\";s:33:\"Drupal\\contact\\MessageViewBuilder\";s:4:\"form\";a:1:{s:7:\"default\";s:26:\"Drupal\\contact\\MessageForm\";}}s:19:\"\0*\0admin_permission\";s:24:\"administer contact forms\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"contact_form\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Contact form\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Contact message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:29:\"entity.contact_form.edit_form\";s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:20:\"contact_message_list\";}s:14:\"\0*\0constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:29:\"Drupal\\contact\\Entity\\Message\";s:11:\"\0*\0provider\";s:7:\"contact\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','contact_message.field_storage_definitions',_binary 'a:9:{s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The message UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:28;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The message language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:12:\"contact_form\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:58;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"contact_form\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Form ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The ID of the associated form.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:12:\"contact_form\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:85;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"The sender\'s name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The name of the person that is sending the contact message.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:110;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"The sender\'s email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:60:\"The email of the person that is sending the contact message.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:7:\"subject\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:132;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:100;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Subject\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:7:\"subject\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:7:\"message\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:160;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:0;s:8:\"settings\";a:1:{s:4:\"rows\";i:12;}}s:12:\"configurable\";b:1;}s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;s:5:\"label\";s:5:\"above\";}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:7:\"message\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:4:\"copy\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:194;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Copy\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"Whether to send a copy of the message to the sender.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:4:\"copy\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}s:9:\"recipient\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";N;s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:224;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Recipient ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"The ID of the recipient user for personal contact messages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:7:\"contact\";s:10:\"field_name\";s:9:\"recipient\";s:11:\"entity_type\";s:15:\"contact_message\";s:6:\"bundle\";N;}}}'),('entity.definitions.installed','content_moderation_notification.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:2:\"id\";i:1;s:8:\"workflow\";i:2;s:11:\"transitions\";i:3;s:5:\"roles\";i:4;s:6:\"author\";i:5;s:6:\"emails\";i:6;s:7:\"subject\";i:7;s:4:\"body\";i:8;s:5:\"label\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:31:\"content_moderation_notification\";s:16:\"\0*\0originalClass\";s:76:\"Drupal\\content_moderation_notifications\\Entity\\ContentModerationNotification\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:86:\"Drupal\\content_moderation_notifications\\ContentModerationNotificationsAccessController\";s:12:\"list_builder\";s:92:\"Drupal\\content_moderation_notifications\\Controller\\ContentModerationNotificationsListBuilder\";s:4:\"form\";a:5:{s:3:\"add\";s:82:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsAddForm\";s:4:\"edit\";s:83:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsEditForm\";s:6:\"delete\";s:85:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsDeleteForm\";s:7:\"disable\";s:56:\"Drupal\\content_moderation_notifications\\Form\\DisableForm\";s:6:\"enable\";s:56:\"Drupal\\content_moderation_notifications\\Form\\DisableForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:43:\"administer content moderation notifications\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:8:\"add-form\";s:40:\"/admin/config/workflow/notifications/add\";s:9:\"edit-form\";s:77:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}\";s:11:\"delete-form\";s:84:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/delete\";s:11:\"enable-form\";s:84:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/enable\";s:12:\"disable-form\";s:85:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/disable\";s:10:\"collection\";s:36:\"/admin/config/workflow/notifications\";s:10:\"devel-load\";s:72:\"/devel/content_moderation_notification/{content_moderation_notification}\";s:16:\"devel-definition\";s:83:\"/devel/content_moderation_notification/{content_moderation_notification}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Notification\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Notifications\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"notification\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"notifications\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:43:\"config:content_moderation_notification_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:76:\"Drupal\\content_moderation_notifications\\Entity\\ContentModerationNotification\";s:11:\"\0*\0provider\";s:32:\"content_moderation_notifications\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','content_moderation_state.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:11:\"revision_id\";s:4:\"uuid\";s:4:\"uuid\";s:3:\"uid\";s:3:\"uid\";s:8:\"langcode\";s:8:\"langcode\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:24:\"content_moderation_state\";s:16:\"\0*\0originalClass\";s:55:\"Drupal\\content_moderation\\Entity\\ContentModerationState\";s:11:\"\0*\0handlers\";a:5:{s:14:\"storage_schema\";s:61:\"Drupal\\content_moderation\\ContentModerationStateStorageSchema\";s:10:\"views_data\";s:29:\"\\Drupal\\views\\EntityViewsData\";s:6:\"access\";s:68:\"Drupal\\content_moderation\\ContentModerationStateAccessControlHandler\";s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:24:\"content_moderation_state\";s:22:\"\0*\0revision_data_table\";s:39:\"content_moderation_state_field_revision\";s:17:\"\0*\0revision_table\";s:33:\"content_moderation_state_revision\";s:13:\"\0*\0data_table\";s:35:\"content_moderation_state_field_data\";s:11:\"\0*\0internal\";b:1;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"content moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"content moderation states\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:31:\"@count content moderation state\";s:6:\"plural\";s:32:\"@count content moderation states\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:29:\"content_moderation_state_list\";}s:14:\"\0*\0constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:55:\"Drupal\\content_moderation\\Entity\\ContentModerationState\";s:11:\"\0*\0provider\";s:18:\"content_moderation\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','content_moderation_state.field_storage_definitions',_binary 'a:13:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:36;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:11:\"revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:69;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:11:\"revision_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:103;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:139;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The username of the entity creator.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:22:\"default_value_callback\";s:73:\"Drupal\\content_moderation\\Entity\\ContentModerationState::getCurrentUserId\";s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:8:\"workflow\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:178;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:8:\"workflow\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The workflow the moderation state is in.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:8:\"workflow\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:16:\"moderation_state\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:216;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Moderation state\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The moderation state of the referenced content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"moderation_state\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:22:\"content_entity_type_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:253;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Content entity type ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The ID of the content entity type this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:22:\"content_entity_type_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:17:\"content_entity_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:289;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Content entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"The ID of the content entity this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:17:\"content_entity_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:26:\"content_entity_revision_id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:328;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Content entity revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"The revision ID of the content entity this moderation state is for.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:26:\"content_entity_revision_id\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:367;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:410;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:11:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:452;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:18:\"content_moderation\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:24:\"content_moderation_state\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}}'),('entity.definitions.installed','date_format.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"locked\";i:3;s:7:\"pattern\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"date_format\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\Core\\Datetime\\Entity\\DateFormat\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:44:\"Drupal\\system\\DateFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\system\\Form\\DateFormatAddForm\";s:4:\"edit\";s:37:\"Drupal\\system\\Form\\DateFormatEditForm\";s:6:\"delete\";s:39:\"Drupal\\system\\Form\\DateFormatDeleteForm\";}s:12:\"list_builder\";s:35:\"Drupal\\system\\DateFormatListBuilder\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:61:\"/admin/config/regional/date-time/formats/manage/{date_format}\";s:11:\"delete-form\";s:68:\"/admin/config/regional/date-time/formats/manage/{date_format}/delete\";s:10:\"collection\";s:40:\"/admin/config/regional/date-time/formats\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Date format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:8:\"rendered\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:38:\"Drupal\\Core\\Datetime\\Entity\\DateFormat\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','editor.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:6:\"format\";i:1;s:6:\"editor\";i:2;s:8:\"settings\";i:3;s:12:\"image_upload\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:6:\"format\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:6:\"editor\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\editor\\Entity\\Editor\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:40:\"Drupal\\editor\\EditorAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text Editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"config:editor_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\editor\\Entity\\Editor\";s:11:\"\0*\0provider\";s:6:\"editor\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','entity_form_display.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_form_display\";s:16:\"\0*\0originalClass\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:71:\"\\Drupal\\Core\\Entity\\Entity\\Access\\EntityFormDisplayAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity form display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_form_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityFormDisplay\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','entity_form_mode.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:10:{s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:8:\"langcode\";s:6:\"status\";s:6:\"status\";s:12:\"dependencies\";s:12:\"dependencies\";s:20:\"third_party_settings\";s:20:\"third_party_settings\";s:5:\"_core\";s:5:\"_core\";s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:16:\"targetEntityType\";s:16:\"targetEntityType\";s:5:\"cache\";s:5:\"cache\";}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_form_mode\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityFormMode\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Form mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_form_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityFormMode\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','entity_view_display.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:4:\"mode\";i:4;s:7:\"content\";i:5;s:6:\"hidden\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"entity_view_display\";s:16:\"\0*\0originalClass\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:71:\"\\Drupal\\Core\\Entity\\Entity\\Access\\EntityViewDisplayAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Entity view display\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:entity_view_display_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:43:\"Drupal\\Core\\Entity\\Entity\\EntityViewDisplay\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','entity_view_mode.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:16:\"targetEntityType\";i:3;s:5:\"cache\";}s:21:\"\0*\0mergedConfigExport\";a:10:{s:4:\"uuid\";s:4:\"uuid\";s:8:\"langcode\";s:8:\"langcode\";s:6:\"status\";s:6:\"status\";s:12:\"dependencies\";s:12:\"dependencies\";s:20:\"third_party_settings\";s:20:\"third_party_settings\";s:5:\"_core\";s:5:\"_core\";s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:16:\"targetEntityType\";s:16:\"targetEntityType\";s:5:\"cache\";s:5:\"cache\";}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:16:\"entity_view_mode\";s:16:\"\0*\0originalClass\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityViewMode\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"View mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:28:\"config:entity_view_mode_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:40:\"Drupal\\Core\\Entity\\Entity\\EntityViewMode\";s:11:\"\0*\0provider\";s:4:\"core\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','field_config.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:5:\"field\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:6:\"bundle\";i:4;s:5:\"label\";i:5;s:11:\"description\";i:6;s:8:\"required\";i:7;s:12:\"translatable\";i:8;s:13:\"default_value\";i:9;s:22:\"default_value_callback\";i:10;s:8:\"settings\";i:11;s:10:\"field_type\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"field_config\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\field\\Entity\\FieldConfig\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:44:\"Drupal\\field\\FieldConfigAccessControlHandler\";s:7:\"storage\";s:31:\"Drupal\\field\\FieldConfigStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Field\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:field_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:31:\"Drupal\\field\\Entity\\FieldConfig\";s:11:\"\0*\0provider\";s:5:\"field\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','field_storage_config.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:7:\"storage\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:12:{i:0;s:2:\"id\";i:1;s:10:\"field_name\";i:2;s:11:\"entity_type\";i:3;s:4:\"type\";i:4;s:8:\"settings\";i:5;s:6:\"module\";i:6;s:6:\"locked\";i:7;s:11:\"cardinality\";i:8;s:12:\"translatable\";i:9;s:7:\"indexes\";i:10;s:22:\"persist_with_no_fields\";i:11;s:14:\"custom_storage\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"field_storage_config\";s:16:\"\0*\0originalClass\";s:38:\"Drupal\\field\\Entity\\FieldStorageConfig\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:51:\"Drupal\\field\\FieldStorageConfigAccessControlHandler\";s:7:\"storage\";s:38:\"Drupal\\field\\FieldStorageConfigStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Field storage\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:field_storage_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:38:\"Drupal\\field\\Entity\\FieldStorageConfig\";s:11:\"\0*\0provider\";s:5:\"field\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','file.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:4:\"file\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:23:\"Drupal\\file\\FileStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\file\\FileStorageSchema\";s:6:\"access\";s:36:\"Drupal\\file\\FileAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\file\\FileViewsData\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:12:\"file_managed\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"File\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"file_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\file\\Entity\\File\";s:11:\"\0*\0provider\";s:4:\"file\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','file.field_storage_definitions',_binary 'a:11:{s:3:\"fid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"File ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The file ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"fid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The file UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The file language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"The user ID of the file.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filename\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:147;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Filename\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"Name of the file with no path components.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filename\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:3:\"uri\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"file_uri\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:1;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:180;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:file_uri\";s:8:\"settings\";a:2:{s:10:\"max_length\";i:255;s:14:\"case_sensitive\";b:1;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"URI\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The URI to access the file (either local or remote).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:13:\"FileUriUnique\";N;}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:3:\"uri\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filemime\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:214;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"File MIME type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"The file\'s MIME type.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filemime\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:8:\"filesize\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:247;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:3:\"big\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"File size\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:30:\"The size of the file in bytes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:8:\"filesize\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:283;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:63:\"The status of the file, temporary (FALSE) and permanent (TRUE).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:323;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"The timestamp that the file was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:351;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The timestamp that the file was last changed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"file\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"file\";s:6:\"bundle\";N;}}}'),('entity.definitions.installed','filter_format.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:6:\"format\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:6:\"format\";i:2;s:6:\"weight\";i:3;s:5:\"roles\";i:4;s:7:\"filters\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:6:\"format\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:13:\"filter_format\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\filter\\Entity\\FilterFormat\";s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:3:{s:3:\"add\";s:33:\"Drupal\\filter\\FilterFormatAddForm\";s:4:\"edit\";s:34:\"Drupal\\filter\\FilterFormatEditForm\";s:7:\"disable\";s:36:\"Drupal\\filter\\Form\\FilterDisableForm\";}s:12:\"list_builder\";s:37:\"Drupal\\filter\\FilterFormatListBuilder\";s:6:\"access\";s:46:\"Drupal\\filter\\FilterFormatAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:18:\"administer filters\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:2:{s:9:\"edit-form\";s:52:\"/admin/config/content/formats/manage/{filter_format}\";s:7:\"disable\";s:60:\"/admin/config/content/formats/manage/{filter_format}/disable\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Text format\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:25:\"config:filter_format_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\filter\\Entity\\FilterFormat\";s:11:\"\0*\0provider\";s:6:\"filter\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','image_style.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:5:\"style\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:3:{i:0;s:4:\"name\";i:1;s:5:\"label\";i:2;s:7:\"effects\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:4:\"name\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"image_style\";s:16:\"\0*\0originalClass\";s:30:\"Drupal\\image\\Entity\\ImageStyle\";s:11:\"\0*\0handlers\";a:4:{s:4:\"form\";a:4:{s:3:\"add\";s:35:\"Drupal\\image\\Form\\ImageStyleAddForm\";s:4:\"edit\";s:36:\"Drupal\\image\\Form\\ImageStyleEditForm\";s:6:\"delete\";s:38:\"Drupal\\image\\Form\\ImageStyleDeleteForm\";s:5:\"flush\";s:37:\"Drupal\\image\\Form\\ImageStyleFlushForm\";}s:12:\"list_builder\";s:34:\"Drupal\\image\\ImageStyleListBuilder\";s:7:\"storage\";s:30:\"Drupal\\image\\ImageStyleStorage\";s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";}s:19:\"\0*\0admin_permission\";s:23:\"administer image styles\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:10:\"flush-form\";s:59:\"/admin/config/media/image-styles/manage/{image_style}/flush\";s:9:\"edit-form\";s:53:\"/admin/config/media/image-styles/manage/{image_style}\";s:11:\"delete-form\";s:60:\"/admin/config/media/image-styles/manage/{image_style}/delete\";s:10:\"collection\";s:32:\"/admin/config/media/image-styles\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Image style\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:image_style_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:30:\"Drupal\\image\\Entity\\ImageStyle\";s:11:\"\0*\0provider\";s:5:\"image\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','menu.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:11:\"description\";i:3;s:6:\"locked\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"menu\";s:16:\"\0*\0originalClass\";s:25:\"Drupal\\system\\Entity\\Menu\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:38:\"Drupal\\system\\MenuAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:menu_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:25:\"Drupal\\system\\Entity\\Menu\";s:11:\"\0*\0provider\";s:6:\"system\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','menu_link_content.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:6:\"bundle\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:9:\"published\";s:7:\"enabled\";}s:5:\"\0*\0id\";s:17:\"menu_link_content\";s:16:\"\0*\0originalClass\";s:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:14:\"storage_schema\";s:53:\"Drupal\\menu_link_content\\MenuLinkContentStorageSchema\";s:6:\"access\";s:60:\"Drupal\\menu_link_content\\MenuLinkContentAccessControlHandler\";s:4:\"form\";a:2:{s:7:\"default\";s:49:\"Drupal\\menu_link_content\\Form\\MenuLinkContentForm\";s:6:\"delete\";s:55:\"Drupal\\menu_link_content\\Form\\MenuLinkContentDeleteForm\";}s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:15:\"administer menu\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:9:\"edit-form\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:11:\"delete-form\";s:53:\"/admin/structure/menu/item/{menu_link_content}/delete\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:17:\"menu_link_content\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:22:\"menu_link_content_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Custom menu link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:22:\"menu_link_content_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:47:\"Drupal\\menu_link_content\\Entity\\MenuLinkContent\";s:11:\"\0*\0provider\";s:17:\"menu_link_content\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','menu_link_content.field_storage_definitions',_binary 'a:16:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Entity ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"The entity ID for this menu link content entity.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The content menu link UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"The menu link language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"bundle\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:113;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";s:23:\"Custom menu link bundle\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"The content menu link bundle.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"bundle\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:145;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Menu link title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The text to be used for this link in the menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:191;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Shown when hovering over the menu link.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:9:\"menu_name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:235;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Menu name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:93:\"The menu name. All links with the same menu name (such as \"tools\") are part of the same menu.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:5:\"tools\";}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:9:\"menu_name\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:3:{s:3:\"uri\";a:3:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;}s:5:\"title\";a:3:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:7:\"options\";a:4:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:1:{s:3:\"uri\";a:1:{i:0;a:2:{i:0;s:3:\"uri\";i:1;i:30;}}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:271;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:17;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The location this menu link points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:-2;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"external\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:322;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"External\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:120:\"A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"external\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:10:\"rediscover\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:362;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:54:\"Indicates whether the menu link should be rediscovered\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:10:\"rediscover\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:398;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:172:\"Link weight among links in the same menu at the same depth. In the menu, the links with high weight will sink and links with a low weight will be positioned nearer the top.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:14:\"number_integer\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:6:\"number\";s:6:\"weight\";i:20;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:8:\"expanded\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:447;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Show as expanded\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"If selected and this menu link has children, the menu will always appear expanded.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:0;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:8:\"expanded\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"enabled\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:498;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Enabled\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:65:\"A flag for whether the link should be enabled in menus or hidden.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:7:\"boolean\";s:6:\"weight\";i:0;}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:-1;}}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"enabled\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;s:13:\"initial_value\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:550;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Parent plugin ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:94:\"The ID of the parent menu link plugin, or empty string when at the top level of the hierarchy.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:583;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"The time that the menu link was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:612;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:17:\"menu_link_content\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:17:\"menu_link_content\";s:6:\"bundle\";N;}}}'),('entity.definitions.installed','migration.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"migration\";s:16:\"\0*\0originalClass\";s:36:\"Drupal\\migrate_plus\\Entity\\Migration\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Migration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:migration_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:36:\"Drupal\\migrate_plus\\Entity\\Migration\";s:11:\"\0*\0provider\";s:12:\"migrate_plus\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','migration_group.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:0:{}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:15:\"migration_group\";s:16:\"\0*\0originalClass\";s:41:\"Drupal\\migrate_plus\\Entity\\MigrationGroup\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:15:\"Migration Group\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:27:\"config:migration_group_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:1:{s:6:\"module\";s:12:\"migrate_plus\";}s:8:\"\0*\0class\";s:41:\"Drupal\\migrate_plus\\Entity\\MigrationGroup\";s:11:\"\0*\0provider\";s:12:\"migrate_plus\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','node.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:4:{s:13:\"revision_user\";s:12:\"revision_uid\";s:16:\"revision_created\";s:18:\"revision_timestamp\";s:20:\"revision_log_message\";s:12:\"revision_log\";s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:11:{s:2:\"id\";s:3:\"nid\";s:8:\"revision\";s:3:\"vid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"status\";s:6:\"status\";s:9:\"published\";s:6:\"status\";s:3:\"uid\";s:3:\"uid\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:4:\"node\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\node\\Entity\\Node\";s:11:\"\0*\0handlers\";a:9:{s:7:\"storage\";s:23:\"Drupal\\node\\NodeStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\node\\NodeStorageSchema\";s:12:\"view_builder\";s:27:\"Drupal\\node\\NodeViewBuilder\";s:6:\"access\";s:36:\"Drupal\\node\\NodeAccessControlHandler\";s:10:\"views_data\";s:25:\"Drupal\\node\\NodeViewsData\";s:4:\"form\";a:3:{s:7:\"default\";s:20:\"Drupal\\node\\NodeForm\";s:6:\"delete\";s:31:\"Drupal\\node\\Form\\NodeDeleteForm\";s:4:\"edit\";s:20:\"Drupal\\node\\NodeForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:36:\"Drupal\\node\\Entity\\NodeRouteProvider\";}s:12:\"list_builder\";s:27:\"Drupal\\node\\NodeListBuilder\";s:11:\"translation\";s:34:\"Drupal\\node\\NodeTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:6:{s:9:\"canonical\";s:12:\"/node/{node}\";s:11:\"delete-form\";s:19:\"/node/{node}/delete\";s:9:\"edit-form\";s:17:\"/node/{node}/edit\";s:15:\"version-history\";s:22:\"/node/{node}/revisions\";s:8:\"revision\";s:43:\"/node/{node}/revisions/{node_revision}/view\";s:6:\"create\";s:5:\"/node\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:9:\"node_type\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:4:\"node\";s:22:\"\0*\0revision_data_table\";s:19:\"node_field_revision\";s:17:\"\0*\0revision_table\";s:13:\"node_revision\";s:13:\"\0*\0data_table\";s:15:\"node_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:1;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"content item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"content items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:19:\"@count content item\";s:6:\"plural\";s:20:\"@count content items\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:26:\"entity.node_type.edit_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:1:{i:0;s:21:\"user.node_grants:view\";}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"node_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\node\\Entity\\Node\";s:11:\"\0*\0provider\";s:4:\"node\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','node.field_storage_definitions',_binary 'a:33:{s:3:\"nid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"nid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:35;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:3:\"vid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:67;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Revision ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"vid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:100;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"type\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:135;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"node_type\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";s:12:\"Content type\";s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:4:\"type\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:18:\"revision_timestamp\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:165;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision create time\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"The time that the current revision was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:18:\"revision_timestamp\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:12:\"revision_uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:194;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Revision user\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:50:\"The user ID of the author of the current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:12:\"revision_uid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:12:\"revision_log\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:11:\"string_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:230;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:22:\"field_item:string_long\";s:8:\"settings\";a:1:{s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Revision log message\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Briefly describe the changes you have made.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:15:\"string_textarea\";s:6:\"weight\";i:25;s:8:\"settings\";a:1:{s:4:\"rows\";i:4;}}}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:12:\"revision_log\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:271;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Published\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:120;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:317;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Title\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:360;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"user\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored by\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The username of the content author.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:22:\"default_value_callback\";s:41:\"Drupal\\node\\Entity\\Node::getCurrentUserId\";s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"author\";s:6:\"weight\";i:0;}}s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:29:\"entity_reference_autocomplete\";s:6:\"weight\";i:5;s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";s:2:\"60\";s:11:\"placeholder\";s:0:\"\";}}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:413;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Authored on\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the node was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:9:\"timestamp\";s:6:\"weight\";i:0;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:18:\"datetime_timestamp\";s:6:\"weight\";i:10;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:454;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the node was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:7:\"promote\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:484;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Promoted to front page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:15;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:7:\"promote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:6:\"sticky\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:530;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"Sticky at top of lists\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"boolean_checkbox\";s:8:\"settings\";a:1:{s:13:\"display_label\";b:1;}s:6:\"weight\";i:16;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:6:\"sticky\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:576;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:16:\"revision_default\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:618;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Default revision\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"A flag indicating whether this was a default revision when it was saved.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:16:\"storage_required\";b:1;s:8:\"internal\";b:1;s:12:\"translatable\";b:0;s:12:\"revisionable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:16:\"revision_default\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:29:\"revision_translation_affected\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:659;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Revision translation affected\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:72:\"Indicates if the last edit of a translation belongs to current revision.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"node\";s:10:\"field_name\";s:29:\"revision_translation_affected\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";N;}}s:4:\"body\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:9:\"node.body\";s:13:\"\0*\0field_name\";s:4:\"body\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:17:\"text_with_summary\";s:9:\"\0*\0module\";s:4:\"text\";s:11:\"\0*\0settings\";a:0:{}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:1;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:9:\"node.body\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"4bd18d5b-1b54-4d93-8809-1f2a2cfbcc80\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"EBUo7qOWqaiZaQ_RC9sLY5IoDKphS34v77VIHSACmVY\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"text\";}}}s:11:\"field_image\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:16:\"node.field_image\";s:13:\"\0*\0field_name\";s:11:\"field_image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:16:\"node.field_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"eb5224c0-e6c7-49cf-82b6-229f46ef800b\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"SkXIPKZYiIMMtnBmfnxk58RYfbZ8cHSw5NZPY_JByME\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}}s:7:\"comment\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:12:\"node.comment\";s:13:\"\0*\0field_name\";s:7:\"comment\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:7:\"comment\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:12:\"node.comment\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"ccf999c7-4756-4fb3-b254-edec33730b53\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"ktCna9xmWvYZIUfOCUyDQvedn5RtnS4CRmEIwNmvYjc\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}}s:10:\"field_tags\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:15:\"node.field_tags\";s:13:\"\0*\0field_name\";s:10:\"field_tags\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:15:\"node.field_tags\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"73418115-95a0-4170-9dd7-284673acd7d2\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"WpOE_bs8Bs_HY2ns7n2r__de-xno0-Bxkqep5-MsHAs\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:27:\"field_migrate_example_image\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:32:\"node.field_migrate_example_image\";s:13:\"\0*\0field_name\";s:27:\"field_migrate_example_image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:32:\"node.field_migrate_example_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"d57d2d8a-c9f4-4b45-9c8e-f544aa2f818e\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"3SSh1H4dQsPZoZV-d3sjeQK7GPJfi-mo6sgECfiOtn8\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}}s:29:\"field_migrate_example_country\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:34:\"node.field_migrate_example_country\";s:13:\"\0*\0field_name\";s:29:\"field_migrate_example_country\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:34:\"node.field_migrate_example_country\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"174d947b-0f2d-4bbc-97a0-ed966f6519d4\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"uBaHGWI3rO-tpQurs304h90LTJoBpjWI2JHNhbMY1TM\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}}s:14:\"field_comments\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:19:\"node.field_comments\";s:13:\"\0*\0field_name\";s:14:\"field_comments\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:13:\"node_comments\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:19:\"node.field_comments\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"cb6e812d-2115-4faf-98d1-e6a4706413c9\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-Fbi4WKTGUpcyPzZFp_Ioroz-Xni60AHP3Rt0VaNYzs\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}}s:32:\"field_migrate_example_beer_style\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_beer_style\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_beer_style\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_beer_style\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"11b2a4ff-4513-4663-938d-060cda2689e1\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"OydFp62jbcZgS1dcDCNzxvhJjx-UDf-ng1or4wTY7-w\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:32:\"field_migrate_example_wine_ratin\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_wine_ratin\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_wine_ratin\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"decimal\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:2:{s:9:\"precision\";i:10;s:5:\"scale\";i:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_wine_ratin\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"9db1bcab-f817-4886-a5b5-34d700f8848f\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"_kyPHNTTC5ibCxEq_nKImDTCSdOLFBhkXjobmMN4zJ4\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}}s:32:\"field_migrate_example_top_vintag\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_top_vintag\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_top_vintag\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:2:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_top_vintag\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"2245f192-9a68-4931-b960-80ddce78214d\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sE33za4WgJVU7T_nG_PZp5CVmEBALuzB_Vn-tfw-q8s\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"node\";}}}s:30:\"field_migrate_example_comments\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:35:\"node.field_migrate_example_comments\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_comments\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:7:\"comment\";s:9:\"\0*\0module\";s:7:\"comment\";s:11:\"\0*\0settings\";a:1:{s:12:\"comment_type\";s:32:\"migrate_example_advanced_comment\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:35:\"node.field_migrate_example_comments\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"5ec526fb-c67f-4c40-80df-1e2b92438662\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"GcdoHWF-KMjeae1Roq8JEh7Xr3Onq8_oZAP3B1sRuhA\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:7:\"comment\";i:1;s:4:\"node\";}}}s:31:\"field_migrate_example_adv_image\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:36:\"node.field_migrate_example_adv_image\";s:13:\"\0*\0field_name\";s:31:\"field_migrate_example_adv_image\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:36:\"node.field_migrate_example_adv_image\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"64472a0e-1641-463b-8103-ec2ed8f6c5e3\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"RwVJ29uGaznr4EjFpnLkdADJBx7DLYwfcu7ti4bVe-c\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"node\";}}}s:30:\"field_migrate_example_wine_var\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:35:\"node.field_migrate_example_wine_var\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_wine_var\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:35:\"node.field_migrate_example_wine_var\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"e627ec31-c833-465f-ba31-28b765ab8f37\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"TcM1vLCiI-U8EN4bH2-tWOgR-HU8fDhHf3oMVGzrA-8\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:32:\"field_migrate_example_wine_regio\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:37:\"node.field_migrate_example_wine_regio\";s:13:\"\0*\0field_name\";s:32:\"field_migrate_example_wine_regio\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:37:\"node.field_migrate_example_wine_regio\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"89bb858a-3fa0-40a3-b7e5-29a286ecbe05\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"AJoyPVhHsJ7K3A9G3Ztn6dKHZBZ5ao3c7SdEK2rH3dM\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}s:31:\"field_migrate_example_wine_best\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:36:\"node.field_migrate_example_wine_best\";s:13:\"\0*\0field_name\";s:31:\"field_migrate_example_wine_best\";s:14:\"\0*\0entity_type\";s:4:\"node\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:13:\"taxonomy_term\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:36:\"node.field_migrate_example_wine_best\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"34bb10e9-a28d-459d-9cfe-ce04b8a54387\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"9YbUjnyyl-8owZ1KCETbExQGZu4aog3n7l3PHy0dSds\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:8:\"taxonomy\";}}}}'),('entity.definitions.installed','node_type.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:4:\"type\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:7:{i:0;s:4:\"name\";i:1;s:4:\"type\";i:2;s:11:\"description\";i:3;s:4:\"help\";i:4;s:12:\"new_revision\";i:5;s:12:\"preview_mode\";i:6;s:17:\"display_submitted\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:4:\"type\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"node_type\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\node\\Entity\\NodeType\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:40:\"Drupal\\node\\NodeTypeAccessControlHandler\";s:4:\"form\";a:3:{s:3:\"add\";s:24:\"Drupal\\node\\NodeTypeForm\";s:4:\"edit\";s:24:\"Drupal\\node\\NodeTypeForm\";s:6:\"delete\";s:38:\"Drupal\\node\\Form\\NodeTypeDeleteConfirm\";}s:12:\"list_builder\";s:31:\"Drupal\\node\\NodeTypeListBuilder\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:24:\"administer content types\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"edit-form\";s:41:\"/admin/structure/types/manage/{node_type}\";s:11:\"delete-form\";s:48:\"/admin/structure/types/manage/{node_type}/delete\";s:10:\"collection\";s:22:\"/admin/structure/types\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:4:\"node\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Content type\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:node_type_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\node\\Entity\\NodeType\";s:11:\"\0*\0provider\";s:4:\"node\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','rdf_mapping.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:7:\"mapping\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:16:\"targetEntityType\";i:2;s:6:\"bundle\";i:3;s:5:\"types\";i:4;s:13:\"fieldMappings\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"rdf_mapping\";s:16:\"\0*\0originalClass\";s:28:\"Drupal\\rdf\\Entity\\RdfMapping\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"RDF mapping\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"RDF mapping item\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"RDF mappings items\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:23:\"@count RDF mapping item\";s:6:\"plural\";s:24:\"@count RDF mapping items\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:rdf_mapping_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:28:\"Drupal\\rdf\\Entity\\RdfMapping\";s:11:\"\0*\0provider\";s:3:\"rdf\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','rest_resource_config.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:8:\"resource\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:9:\"plugin_id\";i:2;s:11:\"granularity\";i:3;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:2:\"id\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:20:\"rest_resource_config\";s:16:\"\0*\0originalClass\";s:37:\"Drupal\\rest\\Entity\\RestResourceConfig\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:25:\"administer rest resources\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";s:18:\"getLabelFromPlugin\";s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"REST resource configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:32:\"config:rest_resource_config_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:37:\"Drupal\\rest\\Entity\\RestResourceConfig\";s:11:\"\0*\0provider\";s:4:\"rest\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','search_page.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:4:\"page\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:6:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"path\";i:3;s:6:\"weight\";i:4;s:6:\"plugin\";i:5;s:13:\"configuration\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:10:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"weight\";s:6:\"weight\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:11:\"search_page\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\search\\Entity\\SearchPage\";s:11:\"\0*\0handlers\";a:4:{s:6:\"access\";s:44:\"Drupal\\search\\SearchPageAccessControlHandler\";s:12:\"list_builder\";s:35:\"Drupal\\search\\SearchPageListBuilder\";s:4:\"form\";a:3:{s:3:\"add\";s:36:\"Drupal\\search\\Form\\SearchPageAddForm\";s:4:\"edit\";s:37:\"Drupal\\search\\Form\\SearchPageEditForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:17:\"administer search\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:9:\"edit-form\";s:47:\"/admin/config/search/pages/manage/{search_page}\";s:11:\"delete-form\";s:54:\"/admin/config/search/pages/manage/{search_page}/delete\";s:6:\"enable\";s:54:\"/admin/config/search/pages/manage/{search_page}/enable\";s:7:\"disable\";s:55:\"/admin/config/search/pages/manage/{search_page}/disable\";s:11:\"set-default\";s:59:\"/admin/config/search/pages/manage/{search_page}/set-default\";s:10:\"collection\";s:26:\"/admin/config/search/pages\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Search page\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:23:\"config:search_page_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:31:\"Drupal\\search\\Entity\\SearchPage\";s:11:\"\0*\0provider\";s:6:\"search\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','shortcut.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:4:\"uuid\";s:4:\"uuid\";s:6:\"bundle\";s:12:\"shortcut_set\";s:5:\"label\";s:5:\"title\";s:8:\"langcode\";s:8:\"langcode\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:8:\"shortcut\";s:16:\"\0*\0originalClass\";s:31:\"Drupal\\shortcut\\Entity\\Shortcut\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:44:\"Drupal\\shortcut\\ShortcutAccessControlHandler\";s:4:\"form\";a:4:{s:7:\"default\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:3:\"add\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:4:\"edit\";s:28:\"Drupal\\shortcut\\ShortcutForm\";s:6:\"delete\";s:39:\"Drupal\\shortcut\\Form\\ShortcutDeleteForm\";}s:11:\"translation\";s:52:\"Drupal\\content_translation\\ContentTranslationHandler\";s:7:\"storage\";s:46:\"Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:3:{s:9:\"canonical\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:11:\"delete-form\";s:60:\"/admin/config/user-interface/shortcut/link/{shortcut}/delete\";s:9:\"edit-form\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:12:\"shortcut_set\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:8:\"shortcut\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:19:\"shortcut_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Shortcut link\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:shortcut_set_list\";}s:14:\"\0*\0constraints\";a:1:{s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:31:\"Drupal\\shortcut\\Entity\\Shortcut\";s:11:\"\0*\0provider\";s:8:\"shortcut\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','shortcut.field_storage_definitions',_binary 'a:8:{s:2:\"id\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The ID of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:2:\"id\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The UUID of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"The language code of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:12:\"shortcut_set\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:113;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:12:\"shortcut_set\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"The bundle of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:12:\"shortcut_set\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:5:\"title\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:150;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The name of the shortcut.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:12:\"translatable\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:1:{s:7:\"options\";a:3:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-10;s:8:\"settings\";a:1:{s:4:\"size\";i:40;}}}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:5:\"title\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:192;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Weight among shortcuts in the same shortcut set.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:4:\"link\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"link\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:3:{s:3:\"uri\";a:3:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;}s:5:\"title\";a:3:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:7:\"options\";a:4:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:1:{s:3:\"uri\";a:1:{i:0;a:2:{i:0;s:3:\"uri\";i:1;i:30;}}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:228;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:link\";s:8:\"settings\";a:2:{s:5:\"title\";i:0;s:9:\"link_type\";i:1;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Path\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"The location this shortcut points to.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:12:\"link_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:4:\"link\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:280;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"shortcut\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:8:\"shortcut\";s:6:\"bundle\";N;}}}'),('entity.definitions.installed','shortcut_set.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:3:\"set\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:2:{i:0;s:2:\"id\";i:1;s:5:\"label\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:12:\"shortcut_set\";s:16:\"\0*\0originalClass\";s:34:\"Drupal\\shortcut\\Entity\\ShortcutSet\";s:11:\"\0*\0handlers\";a:4:{s:7:\"storage\";s:34:\"Drupal\\shortcut\\ShortcutSetStorage\";s:6:\"access\";s:47:\"Drupal\\shortcut\\ShortcutSetAccessControlHandler\";s:12:\"list_builder\";s:38:\"Drupal\\shortcut\\ShortcutSetListBuilder\";s:4:\"form\";a:5:{s:7:\"default\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:3:\"add\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:4:\"edit\";s:31:\"Drupal\\shortcut\\ShortcutSetForm\";s:9:\"customize\";s:33:\"Drupal\\shortcut\\Form\\SetCustomize\";s:6:\"delete\";s:42:\"Drupal\\shortcut\\Form\\ShortcutSetDeleteForm\";}}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:14:\"customize-form\";s:69:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize\";s:11:\"delete-form\";s:66:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete\";s:9:\"edit-form\";s:59:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}\";s:10:\"collection\";s:37:\"/admin/config/user-interface/shortcut\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:8:\"shortcut\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Shortcut set\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:24:\"config:shortcut_set_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:34:\"Drupal\\shortcut\\Entity\\ShortcutSet\";s:11:\"\0*\0provider\";s:8:\"shortcut\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','taxonomy_term.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":42:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"tid\";s:6:\"bundle\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:9:\"published\";s:6:\"status\";}s:5:\"\0*\0id\";s:13:\"taxonomy_term\";s:16:\"\0*\0originalClass\";s:27:\"Drupal\\taxonomy\\Entity\\Term\";s:11:\"\0*\0handlers\";a:8:{s:7:\"storage\";s:27:\"Drupal\\taxonomy\\TermStorage\";s:14:\"storage_schema\";s:33:\"Drupal\\taxonomy\\TermStorageSchema\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";s:12:\"list_builder\";s:36:\"Drupal\\Core\\Entity\\EntityListBuilder\";s:6:\"access\";s:40:\"Drupal\\taxonomy\\TermAccessControlHandler\";s:10:\"views_data\";s:29:\"Drupal\\taxonomy\\TermViewsData\";s:4:\"form\";a:2:{s:7:\"default\";s:24:\"Drupal\\taxonomy\\TermForm\";s:6:\"delete\";s:35:\"Drupal\\taxonomy\\Form\\TermDeleteForm\";}s:11:\"translation\";s:38:\"Drupal\\taxonomy\\TermTranslationHandler\";}s:19:\"\0*\0admin_permission\";N;s:25:\"\0*\0permission_granularity\";s:6:\"bundle\";s:8:\"\0*\0links\";a:4:{s:9:\"canonical\";s:30:\"/taxonomy/term/{taxonomy_term}\";s:11:\"delete-form\";s:37:\"/taxonomy/term/{taxonomy_term}/delete\";s:9:\"edit-form\";s:35:\"/taxonomy/term/{taxonomy_term}/edit\";s:6:\"create\";s:14:\"/taxonomy/term\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";s:19:\"taxonomy_vocabulary\";s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"\0*\0base_table\";s:18:\"taxonomy_term_data\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:24:\"taxonomy_term_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Taxonomy term\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";s:17:\"taxonomy_term_uri\";s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:40:\"entity.taxonomy_vocabulary.overview_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:18:\"taxonomy_term_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:27:\"Drupal\\taxonomy\\Entity\\Term\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','taxonomy_term.field_storage_definitions',_binary 'a:12:{s:3:\"tid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Term ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The term ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"tid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The term UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:2:{s:4:\"type\";s:15:\"language_select\";s:6:\"weight\";i:2;}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The term language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:3:\"vid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:113;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:19:\"taxonomy_vocabulary\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"The vocabulary to which the term is assigned.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:3:\"vid\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:150;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"required\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"string\";s:6:\"weight\";i:-5;}}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:16:\"string_textfield\";s:6:\"weight\";i:-5;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:11:\"description\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"text_long\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:2:{s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";}s:6:\"format\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:192;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:text_long\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Description\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:7:\"display\";a:2:{s:4:\"view\";a:2:{s:7:\"options\";a:3:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}s:4:\"form\";a:2:{s:7:\"options\";a:2:{s:4:\"type\";s:14:\"text_textfield\";s:6:\"weight\";i:0;}s:12:\"configurable\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:11:\"description\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"weight\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:235;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Weight\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"The weight of this term in relation to other terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"weight\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:6:\"parent\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:274;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:13:\"taxonomy_term\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Term Parents\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"The parents of this term.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:14:\"custom_storage\";b:0;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:6:\"parent\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:311;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the term was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:340;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:8:\"taxonomy\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}s:24:\"field_variety_attributes\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:38:\"taxonomy_term.field_variety_attributes\";s:13:\"\0*\0field_name\";s:24:\"field_variety_attributes\";s:14:\"\0*\0entity_type\";s:13:\"taxonomy_term\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:38:\"taxonomy_term.field_variety_attributes\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"50da2584-5c3b-41ad-87cb-032fa5039401\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"sfP27J9-TcVbjBJviBOAkXgwSpQe1DoGxCc5Ysz_8rc\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:8:\"taxonomy\";}}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:418;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:10:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Publishing status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:41:\"A boolean indicating the published state.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"revisionable\";b:1;s:12:\"translatable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:13:\"initial_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:13:\"taxonomy_term\";s:8:\"provider\";s:13:\"taxonomy_term\";s:6:\"bundle\";N;}}}'),('entity.definitions.installed','taxonomy_vocabulary.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:10:\"vocabulary\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:4:\"name\";i:1;s:3:\"vid\";i:2;s:11:\"description\";i:3;s:9:\"hierarchy\";i:4;s:6:\"weight\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:6:\"weight\";s:6:\"weight\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:19:\"taxonomy_vocabulary\";s:16:\"\0*\0originalClass\";s:33:\"Drupal\\taxonomy\\Entity\\Vocabulary\";s:11:\"\0*\0handlers\";a:5:{s:7:\"storage\";s:33:\"Drupal\\taxonomy\\VocabularyStorage\";s:12:\"list_builder\";s:37:\"Drupal\\taxonomy\\VocabularyListBuilder\";s:6:\"access\";s:46:\"Drupal\\taxonomy\\VocabularyAccessControlHandler\";s:4:\"form\";a:4:{s:7:\"default\";s:30:\"Drupal\\taxonomy\\VocabularyForm\";s:5:\"reset\";s:40:\"Drupal\\taxonomy\\Form\\VocabularyResetForm\";s:6:\"delete\";s:41:\"Drupal\\taxonomy\\Form\\VocabularyDeleteForm\";s:8:\"overview\";s:34:\"Drupal\\taxonomy\\Form\\OverviewTerms\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:54:\"Drupal\\taxonomy\\Entity\\Routing\\VocabularyRouteProvider\";}}s:19:\"\0*\0admin_permission\";s:19:\"administer taxonomy\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:6:{s:8:\"add-form\";s:29:\"/admin/structure/taxonomy/add\";s:11:\"delete-form\";s:61:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete\";s:10:\"reset-form\";s:60:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset\";s:13:\"overview-form\";s:63:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview\";s:9:\"edit-form\";s:54:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}\";s:10:\"collection\";s:25:\"/admin/structure/taxonomy\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";s:13:\"taxonomy_term\";s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Taxonomy vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Taxonomy\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"vocabulary\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"vocabularies\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:17:\"@count vocabulary\";s:6:\"plural\";s:19:\"@count vocabularies\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:31:\"config:taxonomy_vocabulary_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:33:\"Drupal\\taxonomy\\Entity\\Vocabulary\";s:11:\"\0*\0provider\";s:8:\"taxonomy\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','tour.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:2:{i:0;s:19:\"routes.*.route_name\";i:1;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:6:\"routes\";i:4;s:4:\"tips\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"tour\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\tour\\Entity\\Tour\";s:11:\"\0*\0handlers\";a:3:{s:12:\"view_builder\";s:27:\"Drupal\\tour\\TourViewBuilder\";s:6:\"access\";s:36:\"Drupal\\tour\\TourAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:29:\"administer site configuration\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Tour\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:tour_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\tour\\Entity\\Tour\";s:11:\"\0*\0provider\";s:4:\"tour\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','user.entity_type',_binary 'O:36:\"Drupal\\Core\\Entity\\ContentEntityType\":40:{s:25:\"\0*\0revision_metadata_keys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:31:\"\0*\0requiredRevisionMetadataKeys\";a:1:{s:16:\"revision_default\";s:16:\"revision_default\";}s:15:\"\0*\0static_cache\";b:1;s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:7:{s:2:\"id\";s:3:\"uid\";s:8:\"langcode\";s:8:\"langcode\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:4:\"user\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\user\\Entity\\User\";s:11:\"\0*\0handlers\";a:9:{s:7:\"storage\";s:23:\"Drupal\\user\\UserStorage\";s:14:\"storage_schema\";s:29:\"Drupal\\user\\UserStorageSchema\";s:6:\"access\";s:36:\"Drupal\\user\\UserAccessControlHandler\";s:12:\"list_builder\";s:27:\"Drupal\\user\\UserListBuilder\";s:10:\"views_data\";s:25:\"Drupal\\user\\UserViewsData\";s:14:\"route_provider\";a:1:{s:4:\"html\";s:36:\"Drupal\\user\\Entity\\UserRouteProvider\";}s:4:\"form\";a:3:{s:7:\"default\";s:23:\"Drupal\\user\\ProfileForm\";s:6:\"cancel\";s:31:\"Drupal\\user\\Form\\UserCancelForm\";s:8:\"register\";s:24:\"Drupal\\user\\RegisterForm\";}s:11:\"translation\";s:37:\"Drupal\\user\\ProfileTranslationHandler\";s:12:\"view_builder\";s:36:\"Drupal\\Core\\Entity\\EntityViewBuilder\";}s:19:\"\0*\0admin_permission\";s:16:\"administer users\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:9:\"canonical\";s:12:\"/user/{user}\";s:9:\"edit-form\";s:17:\"/user/{user}/edit\";s:11:\"cancel-form\";s:19:\"/user/{user}/cancel\";s:10:\"collection\";s:13:\"/admin/people\";}s:17:\"\0*\0label_callback\";s:16:\"user_format_name\";s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";s:5:\"users\";s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";s:16:\"users_field_data\";s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:1;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"User\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:7:\"content\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";s:22:\"entity.user.admin_form\";s:26:\"\0*\0common_reference_target\";b:1;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:9:\"user_list\";}s:14:\"\0*\0constraints\";a:2:{s:13:\"EntityChanged\";N;s:26:\"EntityUntranslatableFields\";N;}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\user\\Entity\\User\";s:11:\"\0*\0provider\";s:4:\"user\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','user.field_storage_definitions',_binary 'a:20:{s:3:\"uid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"integer\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:2;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:integer\";s:8:\"settings\";a:6:{s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"User ID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"The user ID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:3:\"uid\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"uuid\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:4:\"uuid\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:39;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:15:\"field_item:uuid\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:128;s:8:\"is_ascii\";b:1;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"UUID\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"read-only\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"The user UUID.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"uuid\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:8:\"langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:75;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:7:\"display\";a:2:{s:4:\"view\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}s:4:\"form\";a:1:{s:7:\"options\";a:1:{s:6:\"region\";s:6:\"hidden\";}}}s:12:\"translatable\";b:1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The user language code.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:8:\"langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:18:\"preferred_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:112;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:60:\"Drupal\\user\\Entity\\User::getAllowedConfigurableLanguageCodes\";}s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"Preferred language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"The user\'s preferred language code for receiving emails and viewing the site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:18:\"preferred_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:24:\"preferred_admin_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"language\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:148;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:19:\"field_item:language\";s:8:\"settings\";a:0:{}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:2:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:60:\"Drupal\\user\\Entity\\User::getAllowedConfigurableLanguageCodes\";}s:6:\"Length\";a:1:{s:3:\"max\";i:12;}}}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Preferred admin language code\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:68:\"The user\'s preferred language code for viewing administration pages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";N;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:24:\"preferred_admin_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"name\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:187;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:5:\"class\";s:25:\"\\Drupal\\user\\UserNameItem\";}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Name\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:22:\"The name of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"required\";b:1;s:11:\"constraints\";a:2:{s:8:\"UserName\";a:0:{}s:14:\"UserNameUnique\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"name\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"pass\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:8:\"password\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:225;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:19:\"field_item:password\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Password\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The password of this user (hashed).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"constraints\";a:1:{s:18:\"ProtectedUserField\";N;}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"pass\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"mail\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:260;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:8:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The email of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:11:\"constraints\";a:3:{s:14:\"UserMailUnique\";N;s:16:\"UserMailRequired\";N;s:18:\"ProtectedUserField\";N;}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"mail\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:8:\"timezone\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:6:\"binary\";b:0;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:296;s:13:\"\0*\0definition\";a:4:{s:4:\"type\";s:17:\"field_item:string\";s:8:\"settings\";a:3:{s:10:\"max_length\";i:32;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:11:\"constraints\";a:1:{s:11:\"ComplexData\";a:1:{s:5:\"value\";a:1:{s:13:\"AllowedValues\";a:1:{s:8:\"callback\";s:44:\"Drupal\\user\\Entity\\User::getAllowedTimezones\";}}}}s:5:\"class\";s:24:\"Drupal\\user\\TimeZoneItem\";}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Timezone\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"The timezone of this user.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:8:\"timezone\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:6:\"status\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:335;s:13:\"\0*\0definition\";a:3:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:5:\"class\";s:22:\"Drupal\\user\\StatusItem\";}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"User status\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Whether the user is active or blocked.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:6:\"status\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:7:\"created\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"created\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:376;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:created\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:6:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Created\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"The time that the user was created.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:7:\"created\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:7:\"changed\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"changed\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:404;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:changed\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Changed\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"The time that the user was last edited.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:7:\"changed\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:6:\"access\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:433;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Last access\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"The time that the user last accessed the site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:6:\"access\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:5:\"login\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:9:\"timestamp\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:1:{s:4:\"type\";s:3:\"int\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:464;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:20:\"field_item:timestamp\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Last login\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"The time that the user last logged in.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:5:\"login\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:4:\"init\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:5:\"email\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:495;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:16:\"field_item:email\";s:8:\"settings\";a:0:{}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Initial email\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"The email address used for initial account creation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";s:0:\"\";}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:4:\"init\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:5:\"roles\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:9:\"target_id\";a:3:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;}}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:11:\"unique keys\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:527;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:27:\"field_item:entity_reference\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:9:\"user_role\";s:7:\"handler\";s:7:\"default\";s:16:\"handler_settings\";a:0:{}}}}s:13:\"\0*\0definition\";a:7:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Roles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"cardinality\";i:-1;s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:23:\"The roles the user has.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:5:\"roles\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:16:\"default_langcode\";O:37:\"Drupal\\Core\\Field\\BaseFieldDefinition\":5:{s:7:\"\0*\0type\";s:7:\"boolean\";s:9:\"\0*\0schema\";a:4:{s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"unique keys\";a:0:{}s:7:\"indexes\";a:0:{}s:12:\"foreign keys\";a:0:{}}s:10:\"\0*\0indexes\";a:0:{}s:17:\"\0*\0itemDefinition\";O:51:\"Drupal\\Core\\Field\\TypedData\\FieldItemDataDefinition\":2:{s:18:\"\0*\0fieldDefinition\";r:563;s:13:\"\0*\0definition\";a:2:{s:4:\"type\";s:18:\"field_item:boolean\";s:8:\"settings\";a:2:{s:8:\"on_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:2:\"On\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:9:\"off_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:3:\"Off\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}}}s:13:\"\0*\0definition\";a:9:{s:5:\"label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Default translation\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:11:\"description\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:58:\"A flag indicating whether this is the default translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"translatable\";b:1;s:12:\"revisionable\";b:1;s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";b:1;}}s:8:\"provider\";s:4:\"user\";s:10:\"field_name\";s:16:\"default_langcode\";s:11:\"entity_type\";s:4:\"user\";s:6:\"bundle\";N;}}s:12:\"user_picture\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:17:\"user.user_picture\";s:13:\"\0*\0field_name\";s:12:\"user_picture\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:5:\"image\";s:9:\"\0*\0module\";s:5:\"image\";s:11:\"\0*\0settings\";a:5:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";a:5:{s:4:\"uuid\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";s:0:\"\";s:5:\"width\";N;s:6:\"height\";N;}s:11:\"target_type\";s:4:\"file\";s:13:\"display_field\";b:0;s:15:\"display_default\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:17:\"user.user_picture\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"7fa5154f-d1e9-4c85-a43d-2cedc39808c0\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"6k-VBFilDLuzgSOT-77CFgHFlcd5D-kqRixtH89EShU\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:3:{i:0;s:4:\"file\";i:1;s:5:\"image\";i:2;s:4:\"user\";}}}s:28:\"field_migrate_example_gender\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:33:\"user.field_migrate_example_gender\";s:13:\"\0*\0field_name\";s:28:\"field_migrate_example_gender\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:6:\"string\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:3:{s:10:\"max_length\";i:255;s:8:\"is_ascii\";b:0;s:14:\"case_sensitive\";b:0;}s:14:\"\0*\0cardinality\";i:1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:33:\"user.field_migrate_example_gender\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"3a033163-ac33-47ae-9186-2aecf22e5a8a\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"-qbjvRZ4YV6YRW3_WOy0fiV1K4bHVBlJNA4AC2E9Z8I\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:1:{i:0;s:4:\"user\";}}}s:30:\"field_migrate_example_favbeers\";O:38:\"Drupal\\field\\Entity\\FieldStorageConfig\":29:{s:5:\"\0*\0id\";s:35:\"user.field_migrate_example_favbeers\";s:13:\"\0*\0field_name\";s:30:\"field_migrate_example_favbeers\";s:14:\"\0*\0entity_type\";s:4:\"user\";s:7:\"\0*\0type\";s:16:\"entity_reference\";s:9:\"\0*\0module\";s:4:\"core\";s:11:\"\0*\0settings\";a:1:{s:11:\"target_type\";s:4:\"node\";}s:14:\"\0*\0cardinality\";i:-1;s:15:\"\0*\0translatable\";b:1;s:9:\"\0*\0locked\";b:0;s:25:\"\0*\0persist_with_no_fields\";b:0;s:14:\"custom_storage\";b:0;s:10:\"\0*\0indexes\";a:0:{}s:10:\"\0*\0deleted\";b:0;s:13:\"\0*\0originalId\";s:35:\"user.field_migrate_example_favbeers\";s:9:\"\0*\0status\";b:1;s:7:\"\0*\0uuid\";s:36:\"4d9219b4-339a-4759-aaf2-9dcd7a27fb11\";s:11:\"\0*\0langcode\";s:2:\"en\";s:23:\"\0*\0third_party_settings\";a:0:{}s:8:\"\0*\0_core\";a:1:{s:19:\"default_config_hash\";s:43:\"tKsR0YH5ckB1vHHdiiA7gYHhFVOvdwIS6N3-NvAxwqM\";}s:14:\"\0*\0trustedData\";b:1;s:15:\"\0*\0entityTypeId\";s:20:\"field_storage_config\";s:15:\"\0*\0enforceIsNew\";b:1;s:12:\"\0*\0typedData\";N;s:16:\"\0*\0cacheContexts\";a:0:{}s:12:\"\0*\0cacheTags\";a:0:{}s:14:\"\0*\0cacheMaxAge\";i:-1;s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:15:\"\0*\0dependencies\";a:1:{s:6:\"module\";a:2:{i:0;s:4:\"node\";i:1;s:4:\"user\";}}}}'),('entity.definitions.installed','user_role.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";s:4:\"role\";s:15:\"\0*\0static_cache\";b:1;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:5:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"weight\";i:3;s:8:\"is_admin\";i:4;s:11:\"permissions\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:6:\"weight\";s:6:\"weight\";s:5:\"label\";s:5:\"label\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:9:\"user_role\";s:16:\"\0*\0originalClass\";s:23:\"Drupal\\user\\Entity\\Role\";s:11:\"\0*\0handlers\";a:4:{s:7:\"storage\";s:23:\"Drupal\\user\\RoleStorage\";s:6:\"access\";s:36:\"Drupal\\user\\RoleAccessControlHandler\";s:12:\"list_builder\";s:27:\"Drupal\\user\\RoleListBuilder\";s:4:\"form\";a:2:{s:7:\"default\";s:20:\"Drupal\\user\\RoleForm\";s:6:\"delete\";s:35:\"Drupal\\Core\\Entity\\EntityDeleteForm\";}}s:19:\"\0*\0admin_permission\";s:22:\"administer permissions\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:4:{s:11:\"delete-form\";s:45:\"/admin/people/roles/manage/{user_role}/delete\";s:9:\"edit-form\";s:38:\"/admin/people/roles/manage/{user_role}\";s:21:\"edit-permissions-form\";s:37:\"/admin/people/permissions/{user_role}\";s:10:\"collection\";s:19:\"/admin/people/roles\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Role\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:21:\"config:user_role_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:23:\"Drupal\\user\\Entity\\Role\";s:11:\"\0*\0provider\";s:4:\"user\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','view.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":42:{s:16:\"\0*\0config_prefix\";N;s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:9:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:6:\"module\";i:3;s:11:\"description\";i:4;s:3:\"tag\";i:5;s:10:\"base_table\";i:6;s:10:\"base_field\";i:7;s:4:\"core\";i:8;s:7:\"display\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:9:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:6:\"status\";s:6:\"status\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";s:4:\"uuid\";s:4:\"uuid\";}s:5:\"\0*\0id\";s:4:\"view\";s:16:\"\0*\0originalClass\";s:24:\"Drupal\\views\\Entity\\View\";s:11:\"\0*\0handlers\";a:2:{s:6:\"access\";s:45:\"Drupal\\Core\\Entity\\EntityAccessControlHandler\";s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:16:\"administer views\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:0:{}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"View\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:16:\"View entity type\";}}s:19:\"\0*\0label_collection\";s:0:\"\";s:17:\"\0*\0label_singular\";s:0:\"\";s:15:\"\0*\0label_plural\";s:0:\"\";s:14:\"\0*\0label_count\";a:0:{}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:16:\"config:view_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:24:\"Drupal\\views\\Entity\\View\";s:11:\"\0*\0provider\";s:5:\"views\";s:20:\"\0*\0stringTranslation\";N;}'),('entity.definitions.installed','workflow.entity_type',_binary 'O:42:\"Drupal\\Core\\Config\\Entity\\ConfigEntityType\":44:{s:16:\"\0*\0config_prefix\";s:8:\"workflow\";s:15:\"\0*\0static_cache\";b:0;s:14:\"\0*\0lookup_keys\";a:1:{i:0;s:4:\"uuid\";}s:16:\"\0*\0config_export\";a:4:{i:0;s:2:\"id\";i:1;s:5:\"label\";i:2;s:4:\"type\";i:3;s:13:\"type_settings\";}s:21:\"\0*\0mergedConfigExport\";a:0:{}s:15:\"\0*\0render_cache\";b:1;s:19:\"\0*\0persistent_cache\";b:1;s:14:\"\0*\0entity_keys\";a:8:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:5:\"label\";s:4:\"uuid\";s:4:\"uuid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";s:8:\"langcode\";s:8:\"langcode\";s:16:\"default_langcode\";s:16:\"default_langcode\";s:29:\"revision_translation_affected\";s:29:\"revision_translation_affected\";}s:5:\"\0*\0id\";s:8:\"workflow\";s:16:\"\0*\0originalClass\";s:32:\"Drupal\\workflows\\Entity\\Workflow\";s:11:\"\0*\0handlers\";a:5:{s:6:\"access\";s:45:\"Drupal\\workflows\\WorkflowAccessControlHandler\";s:12:\"list_builder\";s:36:\"Drupal\\workflows\\WorkflowListBuilder\";s:4:\"form\";a:9:{s:3:\"add\";s:37:\"Drupal\\workflows\\Form\\WorkflowAddForm\";s:4:\"edit\";s:38:\"Drupal\\workflows\\Form\\WorkflowEditForm\";s:6:\"delete\";s:40:\"Drupal\\workflows\\Form\\WorkflowDeleteForm\";s:9:\"add-state\";s:42:\"Drupal\\workflows\\Form\\WorkflowStateAddForm\";s:10:\"edit-state\";s:43:\"Drupal\\workflows\\Form\\WorkflowStateEditForm\";s:12:\"delete-state\";s:45:\"Drupal\\workflows\\Form\\WorkflowStateDeleteForm\";s:14:\"add-transition\";s:47:\"Drupal\\workflows\\Form\\WorkflowTransitionAddForm\";s:15:\"edit-transition\";s:48:\"Drupal\\workflows\\Form\\WorkflowTransitionEditForm\";s:17:\"delete-transition\";s:50:\"Drupal\\workflows\\Form\\WorkflowTransitionDeleteForm\";}s:14:\"route_provider\";a:1:{s:4:\"html\";s:49:\"Drupal\\Core\\Entity\\Routing\\AdminHtmlRouteProvider\";}s:7:\"storage\";s:45:\"Drupal\\Core\\Config\\Entity\\ConfigEntityStorage\";}s:19:\"\0*\0admin_permission\";s:20:\"administer workflows\";s:25:\"\0*\0permission_granularity\";s:11:\"entity_type\";s:8:\"\0*\0links\";a:8:{s:8:\"add-form\";s:36:\"/admin/config/workflow/workflows/add\";s:9:\"edit-form\";s:50:\"/admin/config/workflow/workflows/manage/{workflow}\";s:11:\"delete-form\";s:57:\"/admin/config/workflow/workflows/manage/{workflow}/delete\";s:14:\"add-state-form\";s:60:\"/admin/config/workflow/workflows/manage/{workflow}/add_state\";s:19:\"add-transition-form\";s:65:\"/admin/config/workflow/workflows/manage/{workflow}/add_transition\";s:10:\"collection\";s:32:\"/admin/config/workflow/workflows\";s:10:\"devel-load\";s:26:\"/devel/workflow/{workflow}\";s:16:\"devel-definition\";s:37:\"/devel/workflow/{workflow}/definition\";}s:17:\"\0*\0label_callback\";N;s:21:\"\0*\0bundle_entity_type\";N;s:12:\"\0*\0bundle_of\";N;s:15:\"\0*\0bundle_label\";N;s:13:\"\0*\0base_table\";N;s:22:\"\0*\0revision_data_table\";N;s:17:\"\0*\0revision_table\";N;s:13:\"\0*\0data_table\";N;s:11:\"\0*\0internal\";b:0;s:15:\"\0*\0translatable\";b:0;s:19:\"\0*\0show_revision_ui\";b:0;s:8:\"\0*\0label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:19:\"\0*\0label_collection\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Workflows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:17:\"\0*\0label_singular\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:15:\"\0*\0label_plural\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"workflows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:14:\"\0*\0label_count\";a:3:{s:8:\"singular\";s:15:\"@count workflow\";s:6:\"plural\";s:16:\"@count workflows\";s:7:\"context\";N;}s:15:\"\0*\0uri_callback\";N;s:8:\"\0*\0group\";s:13:\"configuration\";s:14:\"\0*\0group_label\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:1:{s:7:\"context\";s:17:\"Entity type group\";}}s:22:\"\0*\0field_ui_base_route\";N;s:26:\"\0*\0common_reference_target\";b:0;s:22:\"\0*\0list_cache_contexts\";a:0:{}s:18:\"\0*\0list_cache_tags\";a:1:{i:0;s:20:\"config:workflow_list\";}s:14:\"\0*\0constraints\";a:0:{}s:13:\"\0*\0additional\";a:0:{}s:8:\"\0*\0class\";s:32:\"Drupal\\workflows\\Entity\\Workflow\";s:11:\"\0*\0provider\";s:9:\"workflows\";s:14:\"\0*\0_serviceIds\";a:0:{}s:18:\"\0*\0_entityStorages\";a:0:{}s:20:\"\0*\0stringTranslation\";N;}'),('entity.storage_schema.sql','block_content.entity_schema_data',_binary 'a:4:{s:13:\"block_content\";a:2:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:26:\"block_content__revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:22:\"block_content_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:17:\"block_content__id\";a:1:{i:0;s:2:\"id\";}}}s:24:\"block_content_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:2:\"id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:45:\"block_content__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:26:\"block_content__revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:26:\"block_content__status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:2:\"id\";}}}s:28:\"block_content_field_revision\";a:2:{s:11:\"primary key\";a:2:{i:0;s:11:\"revision_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:45:\"block_content__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.body',_binary 'a:2:{s:19:\"block_content__body\";a:4:{s:11:\"description\";s:42:\"Data storage for block_content field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}s:28:\"block_content_revision__body\";a:4:{s:11:\"description\";s:54:\"Revision archive storage for block_content field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.changed',_binary 'a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.default_langcode',_binary 'a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.id',_binary 'a:4:{s:13:\"block_content\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.info',_binary 'a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"info\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:4:\"info\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.langcode',_binary 'a:4:{s:13:\"block_content\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.reusable',_binary 'a:1:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"reusable\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.revision_created',_binary 'a:1:{s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.revision_default',_binary 'a:1:{s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.revision_id',_binary 'a:4:{s:13:\"block_content\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.revision_log',_binary 'a:1:{s:22:\"block_content_revision\";a:1:{s:6:\"fields\";a:1:{s:12:\"revision_log\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.revision_translation_affected',_binary 'a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.revision_user',_binary 'a:1:{s:22:\"block_content_revision\";a:2:{s:6:\"fields\";a:1:{s:13:\"revision_user\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:45:\"block_content_field__revision_user__target_id\";a:1:{i:0;s:13:\"revision_user\";}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.status',_binary 'a:2:{s:24:\"block_content_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:28:\"block_content_field_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.type',_binary 'a:2:{s:13:\"block_content\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:36:\"block_content_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}s:24:\"block_content_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:36:\"block_content_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),('entity.storage_schema.sql','block_content.field_schema_data.uuid',_binary 'a:1:{s:13:\"block_content\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:32:\"block_content_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','comment.entity_schema_data',_binary 'a:2:{s:7:\"comment\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}}s:18:\"comment_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"cid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:5:{s:39:\"comment__id__default_langcode__langcode\";a:3:{i:0;s:3:\"cid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:28:\"comment__status_comment_type\";a:3:{i:0;s:6:\"status\";i:1;s:12:\"comment_type\";i:2;s:3:\"cid\";}s:19:\"comment__status_pid\";a:2:{i:0;s:3:\"pid\";i:1;s:6:\"status\";}s:16:\"comment__num_new\";a:7:{i:0;s:9:\"entity_id\";i:1;s:11:\"entity_type\";i:2;s:12:\"comment_type\";i:3;s:6:\"status\";i:4;s:7:\"created\";i:5;s:3:\"cid\";i:6;s:6:\"thread\";}s:24:\"comment__entity_langcode\";a:4:{i:0;s:9:\"entity_id\";i:1;s:11:\"entity_type\";i:2;s:12:\"comment_type\";i:3;s:16:\"default_langcode\";}}}}'),('entity.storage_schema.sql','comment.field_schema_data.changed',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.cid',_binary 'a:2:{s:7:\"comment\";a:1:{s:6:\"fields\";a:1:{s:3:\"cid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"cid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.comment_body',_binary 'a:1:{s:21:\"comment__comment_body\";a:4:{s:11:\"description\";s:44:\"Data storage for comment field comment_body.\";s:6:\"fields\";a:8:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:18:\"comment_body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:19:\"comment_body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:19:\"comment_body_format\";a:1:{i:0;s:19:\"comment_body_format\";}}}}'),('entity.storage_schema.sql','comment.field_schema_data.comment_type',_binary 'a:2:{s:7:\"comment\";a:2:{s:6:\"fields\";a:1:{s:12:\"comment_type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:38:\"comment_field__comment_type__target_id\";a:1:{i:0;s:12:\"comment_type\";}}}s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:12:\"comment_type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:38:\"comment_field__comment_type__target_id\";a:1:{i:0;s:12:\"comment_type\";}}}}'),('entity.storage_schema.sql','comment.field_schema_data.created',_binary 'a:1:{s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:22:\"comment_field__created\";a:1:{i:0;s:7:\"created\";}}}}'),('entity.storage_schema.sql','comment.field_schema_data.default_langcode',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.entity_id',_binary 'a:1:{s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:9:\"entity_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:0:{}}}'),('entity.storage_schema.sql','comment.field_schema_data.entity_type',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.field_name',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:10:\"field_name\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.homepage',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"homepage\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.hostname',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.langcode',_binary 'a:2:{s:7:\"comment\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.mail',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.name',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.pid',_binary 'a:1:{s:18:\"comment_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"pid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:0:{}}}'),('entity.storage_schema.sql','comment.field_schema_data.status',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.subject',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"subject\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.thread',_binary 'a:1:{s:18:\"comment_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"thread\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','comment.field_schema_data.uid',_binary 'a:1:{s:18:\"comment_field_data\";a:3:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:29:\"comment_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}s:12:\"foreign keys\";a:1:{s:18:\"comment_field__uid\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}}}'),('entity.storage_schema.sql','comment.field_schema_data.uuid',_binary 'a:1:{s:7:\"comment\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:26:\"comment_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','content_moderation_state.entity_schema_data',_binary 'a:4:{s:24:\"content_moderation_state\";a:2:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:37:\"content_moderation_state__revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:33:\"content_moderation_state_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:28:\"content_moderation_state__id\";a:1:{i:0;s:2:\"id\";}}}s:35:\"content_moderation_state_field_data\";a:3:{s:11:\"primary key\";a:2:{i:0;s:2:\"id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:56:\"content_moderation_state__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:37:\"content_moderation_state__revision_id\";a:1:{i:0;s:11:\"revision_id\";}}s:11:\"unique keys\";a:1:{s:32:\"content_moderation_state__lookup\";a:5:{i:0;s:22:\"content_entity_type_id\";i:1;s:17:\"content_entity_id\";i:2;s:26:\"content_entity_revision_id\";i:3;s:8:\"workflow\";i:4;s:8:\"langcode\";}}}s:39:\"content_moderation_state_field_revision\";a:3:{s:11:\"primary key\";a:2:{i:0;s:11:\"revision_id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:56:\"content_moderation_state__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}s:11:\"unique keys\";a:1:{s:32:\"content_moderation_state__lookup\";a:5:{i:0;s:22:\"content_entity_type_id\";i:1;s:17:\"content_entity_id\";i:2;s:26:\"content_entity_revision_id\";i:3;s:8:\"workflow\";i:4;s:8:\"langcode\";}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.content_entity_id',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:17:\"content_entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:17:\"content_entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.content_entity_revision_id',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:26:\"content_entity_revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:26:\"content_entity_revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.content_entity_type_id',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:22:\"content_entity_type_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:22:\"content_entity_type_id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.default_langcode',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.id',_binary 'a:4:{s:24:\"content_moderation_state\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:33:\"content_moderation_state_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.langcode',_binary 'a:4:{s:24:\"content_moderation_state\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:33:\"content_moderation_state_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.moderation_state',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"moderation_state\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"moderation_state\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.revision_default',_binary 'a:1:{s:33:\"content_moderation_state_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.revision_id',_binary 'a:4:{s:24:\"content_moderation_state\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:33:\"content_moderation_state_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.revision_translation_affected',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:39:\"content_moderation_state_field_revision\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.uid',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:46:\"content_moderation_state_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}s:39:\"content_moderation_state_field_revision\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:46:\"content_moderation_state_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.uuid',_binary 'a:1:{s:24:\"content_moderation_state\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:43:\"content_moderation_state_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','content_moderation_state.field_schema_data.workflow',_binary 'a:2:{s:35:\"content_moderation_state_field_data\";a:2:{s:6:\"fields\";a:1:{s:8:\"workflow\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:36:\"content_moderation_state__09628d8dbc\";a:1:{i:0;s:8:\"workflow\";}}}s:39:\"content_moderation_state_field_revision\";a:2:{s:6:\"fields\";a:1:{s:8:\"workflow\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:36:\"content_moderation_state__09628d8dbc\";a:1:{i:0;s:8:\"workflow\";}}}}'),('entity.storage_schema.sql','file.entity_schema_data',_binary 'a:1:{s:12:\"file_managed\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}}}'),('entity.storage_schema.sql','file.field_schema_data.changed',_binary 'a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"file_field__changed\";a:1:{i:0;s:7:\"changed\";}}}}'),('entity.storage_schema.sql','file.field_schema_data.created',_binary 'a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','file.field_schema_data.fid',_binary 'a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:3:\"fid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','file.field_schema_data.filemime',_binary 'a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"filemime\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','file.field_schema_data.filename',_binary 'a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"filename\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','file.field_schema_data.filesize',_binary 'a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"filesize\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','file.field_schema_data.langcode',_binary 'a:1:{s:12:\"file_managed\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','file.field_schema_data.status',_binary 'a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:18:\"file_field__status\";a:1:{i:0;s:6:\"status\";}}}}'),('entity.storage_schema.sql','file.field_schema_data.uid',_binary 'a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:26:\"file_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),('entity.storage_schema.sql','file.field_schema_data.uri',_binary 'a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:3:\"uri\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:15:\"file_field__uri\";a:1:{i:0;s:3:\"uri\";}}}}'),('entity.storage_schema.sql','file.field_schema_data.uuid',_binary 'a:1:{s:12:\"file_managed\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:23:\"file_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','menu_link_content.entity_schema_data',_binary 'a:2:{s:17:\"menu_link_content\";a:1:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}}s:22:\"menu_link_content_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:2:\"id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:49:\"menu_link_content__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:33:\"menu_link_content__enabled_bundle\";a:3:{i:0;s:7:\"enabled\";i:1;s:6:\"bundle\";i:2;s:2:\"id\";}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.bundle',_binary 'a:2:{s:17:\"menu_link_content\";a:1:{s:6:\"fields\";a:1:{s:6:\"bundle\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"bundle\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.changed',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.default_langcode',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.description',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:11:\"description\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.enabled',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"enabled\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.expanded',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"expanded\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.external',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"external\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.id',_binary 'a:2:{s:17:\"menu_link_content\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.langcode',_binary 'a:2:{s:17:\"menu_link_content\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.link',_binary 'a:1:{s:22:\"menu_link_content_data\";a:2:{s:6:\"fields\";a:3:{s:9:\"link__uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:11:\"link__title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:13:\"link__options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:34:\"menu_link_content_field__link__uri\";a:1:{i:0;a:2:{i:0;s:9:\"link__uri\";i:1;i:30;}}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.menu_name',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.parent',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"parent\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.rediscover',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:10:\"rediscover\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.title',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.uuid',_binary 'a:1:{s:17:\"menu_link_content\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:36:\"menu_link_content_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','menu_link_content.field_schema_data.weight',_binary 'a:1:{s:22:\"menu_link_content_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.entity_schema_data',_binary 'a:4:{s:4:\"node\";a:2:{s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:11:\"unique keys\";a:1:{s:9:\"node__vid\";a:1:{i:0;s:3:\"vid\";}}}s:13:\"node_revision\";a:2:{s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:7:\"indexes\";a:1:{s:9:\"node__nid\";a:1:{i:0;s:3:\"nid\";}}}s:15:\"node_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:5:{s:36:\"node__id__default_langcode__langcode\";a:3:{i:0;s:3:\"nid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:9:\"node__vid\";a:1:{i:0;s:3:\"vid\";}s:17:\"node__status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:15:\"node__frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:16:\"node__title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}}}s:19:\"node_field_revision\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"vid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:36:\"node__id__default_langcode__langcode\";a:3:{i:0;s:3:\"nid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.body',_binary 'a:2:{s:10:\"node__body\";a:4:{s:11:\"description\";s:33:\"Data storage for node field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}s:19:\"node_revision__body\";a:4:{s:11:\"description\";s:45:\"Revision archive storage for node field body.\";s:6:\"fields\";a:9:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.changed',_binary 'a:2:{s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"node_field__changed\";a:1:{i:0;s:7:\"changed\";}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.comment',_binary 'a:2:{s:13:\"node__comment\";a:4:{s:11:\"description\";s:36:\"Data storage for node field comment.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:14:\"comment_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:22:\"node_revision__comment\";a:4:{s:11:\"description\";s:48:\"Revision archive storage for node field comment.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:14:\"comment_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.created',_binary 'a:2:{s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"node_field__created\";a:1:{i:0;s:7:\"created\";}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.default_langcode',_binary 'a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_comments',_binary 'a:2:{s:20:\"node__field_comments\";a:4:{s:11:\"description\";s:43:\"Data storage for node field field_comments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_comments_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:29:\"node_revision__field_comments\";a:4:{s:11:\"description\";s:55:\"Revision archive storage for node field field_comments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_comments_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_image',_binary 'a:2:{s:17:\"node__field_image\";a:5:{s:11:\"description\";s:40:\"Data storage for node field field_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:17:\"field_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:17:\"field_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:18:\"field_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:21:\"field_image_target_id\";a:1:{i:0;s:21:\"field_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:21:\"field_image_target_id\";s:3:\"fid\";}}}}s:26:\"node_revision__field_image\";a:5:{s:11:\"description\";s:52:\"Revision archive storage for node field field_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:21:\"field_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:17:\"field_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:17:\"field_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:18:\"field_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:21:\"field_image_target_id\";a:1:{i:0;s:21:\"field_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:21:\"field_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:21:\"field_image_target_id\";s:3:\"fid\";}}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_adv_image',_binary 'a:2:{s:37:\"node__field_migrate_example_adv_image\";a:5:{s:11:\"description\";s:60:\"Data storage for node field field_migrate_example_adv_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:41:\"field_migrate_example_adv_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_migrate_example_adv_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:37:\"field_migrate_example_adv_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:37:\"field_migrate_example_adv_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:38:\"field_migrate_example_adv_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:41:\"field_migrate_example_adv_image_target_id\";a:1:{i:0;s:41:\"field_migrate_example_adv_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:41:\"field_migrate_example_adv_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:41:\"field_migrate_example_adv_image_target_id\";s:3:\"fid\";}}}}s:46:\"node_revision__field_migrate_example_adv_image\";a:5:{s:11:\"description\";s:72:\"Revision archive storage for node field field_migrate_example_adv_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:41:\"field_migrate_example_adv_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:35:\"field_migrate_example_adv_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:37:\"field_migrate_example_adv_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:37:\"field_migrate_example_adv_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:38:\"field_migrate_example_adv_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:41:\"field_migrate_example_adv_image_target_id\";a:1:{i:0;s:41:\"field_migrate_example_adv_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:41:\"field_migrate_example_adv_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:41:\"field_migrate_example_adv_image_target_id\";s:3:\"fid\";}}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_beer_style',_binary 'a:2:{s:38:\"node__field_migrate_example_beer_style\";a:4:{s:11:\"description\";s:61:\"Data storage for node field field_migrate_example_beer_style.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:42:\"field_migrate_example_beer_style_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:42:\"field_migrate_example_beer_style_target_id\";a:1:{i:0;s:42:\"field_migrate_example_beer_style_target_id\";}}}s:47:\"node_revision__field_migrate_example_beer_style\";a:4:{s:11:\"description\";s:73:\"Revision archive storage for node field field_migrate_example_beer_style.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:42:\"field_migrate_example_beer_style_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:42:\"field_migrate_example_beer_style_target_id\";a:1:{i:0;s:42:\"field_migrate_example_beer_style_target_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_comments',_binary 'a:2:{s:36:\"node__field_migrate_example_comments\";a:4:{s:11:\"description\";s:59:\"Data storage for node field field_migrate_example_comments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:37:\"field_migrate_example_comments_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:45:\"node_revision__field_migrate_example_comments\";a:4:{s:11:\"description\";s:71:\"Revision archive storage for node field field_migrate_example_comments.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:37:\"field_migrate_example_comments_status\";a:4:{s:11:\"description\";s:99:\"Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_country',_binary 'a:2:{s:35:\"node__field_migrate_example_country\";a:4:{s:11:\"description\";s:58:\"Data storage for node field field_migrate_example_country.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:35:\"field_migrate_example_country_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:44:\"node_revision__field_migrate_example_country\";a:4:{s:11:\"description\";s:70:\"Revision archive storage for node field field_migrate_example_country.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:35:\"field_migrate_example_country_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_image',_binary 'a:2:{s:33:\"node__field_migrate_example_image\";a:5:{s:11:\"description\";s:56:\"Data storage for node field field_migrate_example_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:37:\"field_migrate_example_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_migrate_example_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:33:\"field_migrate_example_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:33:\"field_migrate_example_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:34:\"field_migrate_example_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:37:\"field_migrate_example_image_target_id\";a:1:{i:0;s:37:\"field_migrate_example_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:37:\"field_migrate_example_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:37:\"field_migrate_example_image_target_id\";s:3:\"fid\";}}}}s:42:\"node_revision__field_migrate_example_image\";a:5:{s:11:\"description\";s:68:\"Revision archive storage for node field field_migrate_example_image.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:37:\"field_migrate_example_image_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:31:\"field_migrate_example_image_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:33:\"field_migrate_example_image_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:33:\"field_migrate_example_image_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:34:\"field_migrate_example_image_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:37:\"field_migrate_example_image_target_id\";a:1:{i:0;s:37:\"field_migrate_example_image_target_id\";}}s:12:\"foreign keys\";a:1:{s:37:\"field_migrate_example_image_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:37:\"field_migrate_example_image_target_id\";s:3:\"fid\";}}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_top_vintag',_binary 'a:2:{s:38:\"node__field_migrate_example_top_vintag\";a:4:{s:11:\"description\";s:61:\"Data storage for node field field_migrate_example_top_vintag.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:38:\"field_migrate_example_top_vintag_value\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:47:\"node_revision__field_migrate_example_top_vintag\";a:4:{s:11:\"description\";s:73:\"Revision archive storage for node field field_migrate_example_top_vintag.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:38:\"field_migrate_example_top_vintag_value\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_wine_best',_binary 'a:2:{s:37:\"node__field_migrate_example_wine_best\";a:4:{s:11:\"description\";s:60:\"Data storage for node field field_migrate_example_wine_best.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:41:\"field_migrate_example_wine_best_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:41:\"field_migrate_example_wine_best_target_id\";a:1:{i:0;s:41:\"field_migrate_example_wine_best_target_id\";}}}s:46:\"node_revision__field_migrate_example_wine_best\";a:4:{s:11:\"description\";s:72:\"Revision archive storage for node field field_migrate_example_wine_best.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:41:\"field_migrate_example_wine_best_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:41:\"field_migrate_example_wine_best_target_id\";a:1:{i:0;s:41:\"field_migrate_example_wine_best_target_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_wine_ratin',_binary 'a:2:{s:38:\"node__field_migrate_example_wine_ratin\";a:4:{s:11:\"description\";s:61:\"Data storage for node field field_migrate_example_wine_ratin.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:38:\"field_migrate_example_wine_ratin_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:10;s:5:\"scale\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}s:47:\"node_revision__field_migrate_example_wine_ratin\";a:4:{s:11:\"description\";s:73:\"Revision archive storage for node field field_migrate_example_wine_ratin.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:38:\"field_migrate_example_wine_ratin_value\";a:4:{s:4:\"type\";s:7:\"numeric\";s:9:\"precision\";i:10;s:5:\"scale\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_wine_regio',_binary 'a:2:{s:38:\"node__field_migrate_example_wine_regio\";a:4:{s:11:\"description\";s:61:\"Data storage for node field field_migrate_example_wine_regio.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:42:\"field_migrate_example_wine_regio_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:42:\"field_migrate_example_wine_regio_target_id\";a:1:{i:0;s:42:\"field_migrate_example_wine_regio_target_id\";}}}s:47:\"node_revision__field_migrate_example_wine_regio\";a:4:{s:11:\"description\";s:73:\"Revision archive storage for node field field_migrate_example_wine_regio.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:42:\"field_migrate_example_wine_regio_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:42:\"field_migrate_example_wine_regio_target_id\";a:1:{i:0;s:42:\"field_migrate_example_wine_regio_target_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_migrate_example_wine_var',_binary 'a:2:{s:36:\"node__field_migrate_example_wine_var\";a:4:{s:11:\"description\";s:59:\"Data storage for node field field_migrate_example_wine_var.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:40:\"field_migrate_example_wine_var_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:40:\"field_migrate_example_wine_var_target_id\";a:1:{i:0;s:40:\"field_migrate_example_wine_var_target_id\";}}}s:45:\"node_revision__field_migrate_example_wine_var\";a:4:{s:11:\"description\";s:71:\"Revision archive storage for node field field_migrate_example_wine_var.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:40:\"field_migrate_example_wine_var_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:40:\"field_migrate_example_wine_var_target_id\";a:1:{i:0;s:40:\"field_migrate_example_wine_var_target_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.field_tags',_binary 'a:2:{s:16:\"node__field_tags\";a:4:{s:11:\"description\";s:39:\"Data storage for node field field_tags.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_tags_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:20:\"field_tags_target_id\";a:1:{i:0;s:20:\"field_tags_target_id\";}}}s:25:\"node_revision__field_tags\";a:4:{s:11:\"description\";s:51:\"Revision archive storage for node field field_tags.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:47:\"The entity revision id this data is attached to\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:20:\"field_tags_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:9:\"entity_id\";i:1;s:11:\"revision_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:20:\"field_tags_target_id\";a:1:{i:0;s:20:\"field_tags_target_id\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.langcode',_binary 'a:4:{s:4:\"node\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:13:\"node_revision\";a:2:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:20:\"node_field__langcode\";a:1:{i:0;s:8:\"langcode\";}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','node.field_schema_data.nid',_binary 'a:4:{s:4:\"node\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','node.field_schema_data.promote',_binary 'a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.revision_default',_binary 'a:1:{s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:16:\"revision_default\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.revision_log',_binary 'a:1:{s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:12:\"revision_log\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.revision_timestamp',_binary 'a:1:{s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:18:\"revision_timestamp\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.revision_translation_affected',_binary 'a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:29:\"revision_translation_affected\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.revision_uid',_binary 'a:1:{s:13:\"node_revision\";a:3:{s:6:\"fields\";a:1:{s:12:\"revision_uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:35:\"node_field__revision_uid__target_id\";a:1:{i:0;s:12:\"revision_uid\";}}s:12:\"foreign keys\";a:1:{s:24:\"node_field__revision_uid\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:12:\"revision_uid\";s:3:\"uid\";}}}}}'),('entity.storage_schema.sql','node.field_schema_data.status',_binary 'a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','node.field_schema_data.sticky',_binary 'a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.title',_binary 'a:2:{s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','node.field_schema_data.type',_binary 'a:2:{s:4:\"node\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:27:\"node_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"type\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:27:\"node_field__type__target_id\";a:1:{i:0;s:4:\"type\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.uid',_binary 'a:2:{s:15:\"node_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:26:\"node_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}s:19:\"node_field_revision\";a:2:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:26:\"node_field__uid__target_id\";a:1:{i:0;s:3:\"uid\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.uuid',_binary 'a:1:{s:4:\"node\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:23:\"node_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','node.field_schema_data.vid',_binary 'a:4:{s:4:\"node\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}s:15:\"node_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:13:\"node_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:19:\"node_field_revision\";a:1:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','shortcut.entity_schema_data',_binary 'a:2:{s:8:\"shortcut\";a:1:{s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}}s:19:\"shortcut_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:2:\"id\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:40:\"shortcut__id__default_langcode__langcode\";a:3:{i:0;s:2:\"id\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.default_langcode',_binary 'a:1:{s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.id',_binary 'a:2:{s:8:\"shortcut\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.langcode',_binary 'a:2:{s:8:\"shortcut\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.link',_binary 'a:1:{s:19:\"shortcut_field_data\";a:2:{s:6:\"fields\";a:3:{s:9:\"link__uri\";a:4:{s:11:\"description\";s:20:\"The URI of the link.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;}s:11:\"link__title\";a:4:{s:11:\"description\";s:14:\"The link text.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:13:\"link__options\";a:5:{s:11:\"description\";s:41:\"Serialized array of options for the link.\";s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:25:\"shortcut_field__link__uri\";a:1:{i:0;a:2:{i:0;s:9:\"link__uri\";i:1;i:30;}}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.shortcut_set',_binary 'a:2:{s:8:\"shortcut\";a:2:{s:6:\"fields\";a:1:{s:12:\"shortcut_set\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:39:\"shortcut_field__shortcut_set__target_id\";a:1:{i:0;s:12:\"shortcut_set\";}}}s:19:\"shortcut_field_data\";a:2:{s:6:\"fields\";a:1:{s:12:\"shortcut_set\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:39:\"shortcut_field__shortcut_set__target_id\";a:1:{i:0;s:12:\"shortcut_set\";}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.title',_binary 'a:1:{s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.uuid',_binary 'a:1:{s:8:\"shortcut\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:27:\"shortcut_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','shortcut.field_schema_data.weight',_binary 'a:1:{s:19:\"shortcut_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','taxonomy_term.entity_schema_data',_binary 'a:3:{s:18:\"taxonomy_term_data\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"tid\";}}s:24:\"taxonomy_term_field_data\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"tid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:4:{s:45:\"taxonomy_term__id__default_langcode__langcode\";a:3:{i:0;s:3:\"tid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}s:25:\"taxonomy_term__status_vid\";a:3:{i:0;s:6:\"status\";i:1;s:3:\"vid\";i:2;s:3:\"tid\";}s:19:\"taxonomy_term__tree\";a:3:{i:0;s:3:\"vid\";i:1;s:6:\"weight\";i:2;s:4:\"name\";}s:23:\"taxonomy_term__vid_name\";a:2:{i:0;s:3:\"vid\";i:1;s:4:\"name\";}}}s:14:\"taxonomy_index\";a:2:{s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"tid\";}s:7:\"indexes\";a:1:{s:9:\"term_node\";a:4:{i:0;s:3:\"tid\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.changed',_binary 'a:1:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.default_langcode',_binary 'a:1:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.description',_binary 'a:1:{s:24:\"taxonomy_term_field_data\";a:2:{s:6:\"fields\";a:2:{s:18:\"description__value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"description__format\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:0:{}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.field_variety_attributes',_binary 'a:1:{s:39:\"taxonomy_term__field_variety_attributes\";a:4:{s:11:\"description\";s:62:\"Data storage for taxonomy_term field field_variety_attributes.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:30:\"field_variety_attributes_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.langcode',_binary 'a:2:{s:18:\"taxonomy_term_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.name',_binary 'a:1:{s:24:\"taxonomy_term_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:25:\"taxonomy_term_field__name\";a:1:{i:0;s:4:\"name\";}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.parent',_binary 'a:1:{s:21:\"taxonomy_term__parent\";a:4:{s:11:\"description\";s:44:\"Data storage for taxonomy_term field parent.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:16:\"parent_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:16:\"parent_target_id\";a:1:{i:0;s:16:\"parent_target_id\";}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.status',_binary 'a:1:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.tid',_binary 'a:2:{s:18:\"taxonomy_term_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.uuid',_binary 'a:1:{s:18:\"taxonomy_term_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:32:\"taxonomy_term_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.vid',_binary 'a:2:{s:18:\"taxonomy_term_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:35:\"taxonomy_term_field__vid__target_id\";a:1:{i:0;s:3:\"vid\";}}}s:24:\"taxonomy_term_field_data\";a:2:{s:6:\"fields\";a:1:{s:3:\"vid\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:7:\"indexes\";a:0:{}}}'),('entity.storage_schema.sql','taxonomy_term.field_schema_data.weight',_binary 'a:1:{s:24:\"taxonomy_term_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','user.entity_schema_data',_binary 'a:2:{s:5:\"users\";a:1:{s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}}s:16:\"users_field_data\";a:3:{s:11:\"primary key\";a:2:{i:0;s:3:\"uid\";i:1;s:8:\"langcode\";}s:7:\"indexes\";a:1:{s:36:\"user__id__default_langcode__langcode\";a:3:{i:0;s:3:\"uid\";i:1;s:16:\"default_langcode\";i:2;s:8:\"langcode\";}}s:11:\"unique keys\";a:1:{s:10:\"user__name\";a:2:{i:0;s:4:\"name\";i:1;s:8:\"langcode\";}}}}'),('entity.storage_schema.sql','user.field_schema_data.access',_binary 'a:1:{s:16:\"users_field_data\";a:2:{s:6:\"fields\";a:1:{s:6:\"access\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:18:\"user_field__access\";a:1:{i:0;s:6:\"access\";}}}}'),('entity.storage_schema.sql','user.field_schema_data.changed',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:7:\"changed\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.created',_binary 'a:1:{s:16:\"users_field_data\";a:2:{s:6:\"fields\";a:1:{s:7:\"created\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:19:\"user_field__created\";a:1:{i:0;s:7:\"created\";}}}}'),('entity.storage_schema.sql','user.field_schema_data.default_langcode',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:16:\"default_langcode\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','user.field_schema_data.field_migrate_example_favbeers',_binary 'a:1:{s:36:\"user__field_migrate_example_favbeers\";a:4:{s:11:\"description\";s:59:\"Data storage for user field field_migrate_example_favbeers.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:40:\"field_migrate_example_favbeers_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:40:\"field_migrate_example_favbeers_target_id\";a:1:{i:0;s:40:\"field_migrate_example_favbeers_target_id\";}}}}'),('entity.storage_schema.sql','user.field_schema_data.field_migrate_example_gender',_binary 'a:1:{s:34:\"user__field_migrate_example_gender\";a:4:{s:11:\"description\";s:57:\"Data storage for user field field_migrate_example_gender.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:34:\"field_migrate_example_gender_value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:2:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}}}'),('entity.storage_schema.sql','user.field_schema_data.init',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"init\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.langcode',_binary 'a:2:{s:5:\"users\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','user.field_schema_data.login',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:5:\"login\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.mail',_binary 'a:1:{s:16:\"users_field_data\";a:2:{s:6:\"fields\";a:1:{s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:16:\"user_field__mail\";a:1:{i:0;s:4:\"mail\";}}}}'),('entity.storage_schema.sql','user.field_schema_data.name',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','user.field_schema_data.pass',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.preferred_admin_langcode',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:24:\"preferred_admin_langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.preferred_langcode',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:18:\"preferred_langcode\";a:3:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:12;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.roles',_binary 'a:1:{s:11:\"user__roles\";a:4:{s:11:\"description\";s:34:\"Data storage for user field roles.\";s:6:\"fields\";a:7:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:15:\"roles_target_id\";a:4:{s:11:\"description\";s:28:\"The ID of the target entity.\";s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:15:\"roles_target_id\";a:1:{i:0;s:15:\"roles_target_id\";}}}}'),('entity.storage_schema.sql','user.field_schema_data.status',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.timezone',_binary 'a:1:{s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:8:\"timezone\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:6:\"binary\";b:0;s:8:\"not null\";b:0;}}}}'),('entity.storage_schema.sql','user.field_schema_data.uid',_binary 'a:2:{s:5:\"users\";a:1:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}s:16:\"users_field_data\";a:1:{s:6:\"fields\";a:1:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}}}}'),('entity.storage_schema.sql','user.field_schema_data.user_picture',_binary 'a:1:{s:18:\"user__user_picture\";a:5:{s:11:\"description\";s:41:\"Data storage for user field user_picture.\";s:6:\"fields\";a:11:{s:6:\"bundle\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:88:\"The field instance bundle to which this row belongs, used when deleting a field instance\";}s:7:\"deleted\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:60:\"A boolean indicating whether this data item has been deleted\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:38:\"The entity id this data is attached to\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:114:\"The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id\";}s:8:\"langcode\";a:5:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:37:\"The language code for this data item.\";}s:5:\"delta\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:11:\"description\";s:67:\"The sequence number for this data item, used for multi-value fields\";}s:22:\"user_picture_target_id\";a:4:{s:11:\"description\";s:26:\"The ID of the file entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:16:\"user_picture_alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:18:\"user_picture_title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:18:\"user_picture_width\";a:4:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:19:\"user_picture_height\";a:4:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:4:{i:0;s:9:\"entity_id\";i:1;s:7:\"deleted\";i:2;s:5:\"delta\";i:3;s:8:\"langcode\";}s:7:\"indexes\";a:3:{s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:22:\"user_picture_target_id\";a:1:{i:0;s:22:\"user_picture_target_id\";}}s:12:\"foreign keys\";a:1:{s:22:\"user_picture_target_id\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:22:\"user_picture_target_id\";s:3:\"fid\";}}}}}'),('entity.storage_schema.sql','user.field_schema_data.uuid',_binary 'a:1:{s:5:\"users\";a:2:{s:6:\"fields\";a:1:{s:4:\"uuid\";a:4:{s:4:\"type\";s:13:\"varchar_ascii\";s:6:\"length\";i:128;s:6:\"binary\";b:0;s:8:\"not null\";b:1;}}s:11:\"unique keys\";a:1:{s:23:\"user_field__uuid__value\";a:1:{i:0;s:4:\"uuid\";}}}}'),('entity_autocomplete','5R8qmBy0kIbzIYCI2t0mNqA6TMOJZqDicCHWkewvUjo',_binary 'a:0:{}'),('entity_autocomplete','ldEveIdqICCUvHRh5cDOzFedE3C3mXmyszMhQlQh7rg',_binary 'a:1:{s:17:\"include_anonymous\";b:0;}'),('entity_autocomplete','LVHtZOmIq4u_35Acl82QidEcagQzUNIMI6Jimydrtk4',_binary 'a:1:{s:14:\"match_operator\";s:8:\"CONTAINS\";}'),('entity_autocomplete','tB8sfjtR4rcsiv59DEoVyxgXEy5C2cPksUeXZpnOhOI',_binary 'a:4:{s:14:\"target_bundles\";a:1:{s:4:\"tags\";s:4:\"tags\";}s:4:\"sort\";a:1:{s:5:\"field\";s:5:\"_none\";}s:11:\"auto_create\";b:1;s:14:\"match_operator\";s:8:\"CONTAINS\";}'),('post_update','existing_updates',_binary 'a:46:{i:0;s:48:\"system_post_update_add_region_to_entity_displays\";i:1;s:40:\"system_post_update_change_action_plugins\";i:2;s:41:\"system_post_update_classy_message_library\";i:3;s:48:\"system_post_update_field_formatter_entity_schema\";i:4;s:37:\"system_post_update_field_type_plugins\";i:5;s:37:\"system_post_update_hashes_clear_cache\";i:6;s:64:\"system_post_update_recalculate_configuration_entity_dependencies\";i:7;s:36:\"system_post_update_timestamp_plugins\";i:8;s:45:\"user_post_update_enforce_order_of_permissions\";i:9;s:43:\"field_post_update_email_widget_size_setting\";i:10;s:50:\"field_post_update_entity_reference_handler_setting\";i:11;s:47:\"field_post_update_remove_handler_submit_setting\";i:12;s:46:\"field_post_update_save_custom_storage_property\";i:13;s:54:\"block_post_update_disable_blocks_with_missing_contexts\";i:14;s:40:\"block_post_update_disabled_region_update\";i:15;s:42:\"block_post_update_fix_negate_in_conditions\";i:16;s:46:\"node_post_update_configure_status_field_widget\";i:17;s:56:\"editor_post_update_clear_cache_for_file_reference_filter\";i:18;s:45:\"comment_post_update_enable_comment_admin_view\";i:19;s:62:\"contact_post_update_add_message_redirect_field_to_contact_form\";i:20;s:49:\"dblog_post_update_convert_recent_messages_to_view\";i:21;s:42:\"image_post_update_image_style_dependencies\";i:22;s:39:\"views_post_update_boolean_filter_values\";i:23;s:34:\"views_post_update_bulk_field_moved\";i:24;s:46:\"views_post_update_cleanup_duplicate_views_data\";i:25;s:33:\"views_post_update_entity_link_url\";i:26;s:46:\"views_post_update_field_formatter_dependencies\";i:27;s:41:\"views_post_update_filter_placeholder_text\";i:28;s:33:\"views_post_update_grouped_filters\";i:29;s:42:\"views_post_update_revision_metadata_fields\";i:30;s:41:\"views_post_update_serializer_dependencies\";i:31;s:45:\"views_post_update_table_display_cache_max_age\";i:32;s:36:\"views_post_update_taxonomy_index_tid\";i:33;s:46:\"views_post_update_update_cacheability_metadata\";i:34;s:47:\"views_post_update_views_data_table_dependencies\";i:35;s:53:\"rest_post_update_create_rest_resource_config_entities\";i:36;s:37:\"rest_post_update_resource_granularity\";i:37;s:51:\"block_content_post_update_add_views_reusable_filter\";i:38;s:50:\"image_post_update_scale_and_crop_effect_add_anchor\";i:39;s:47:\"system_post_update_change_delete_action_plugins\";i:40;s:31:\"system_post_update_extra_fields\";i:41;s:41:\"system_post_update_language_item_callback\";i:42;s:64:\"taxonomy_post_update_clear_entity_bundle_field_definitions_cache\";i:43;s:43:\"taxonomy_post_update_clear_views_data_cache\";i:44;s:63:\"taxonomy_post_update_handle_publishing_status_addition_in_views\";i:45;s:59:\"content_moderation_post_update_update_cms_default_revisions\";}'),('state','comment.maintain_entity_statistics',_binary 'b:1;'),('state','comment.node_comment_statistics_scale',_binary 'd:1;'),('state','install_task',_binary 's:4:\"done\";'),('state','install_time',_binary 'i:1533820457;'),('state','node.min_max_update_time',_binary 'a:2:{s:11:\"min_created\";N;s:11:\"max_created\";N;}'),('state','router.path_roots',_binary 'a:34:{i:0;s:8:\"big_pipe\";i:1;s:5:\"admin\";i:2;s:14:\"block-category\";i:3;s:5:\"block\";i:4;s:7:\"comment\";i:5;s:8:\"comments\";i:6;s:7:\"contact\";i:7;s:4:\"user\";i:8;s:10:\"contextual\";i:9;s:5:\"devel\";i:10;s:6:\"editor\";i:11;s:4:\"file\";i:12;s:6:\"filter\";i:13;s:7:\"history\";i:14;s:5:\"sites\";i:15;s:6:\"system\";i:16;s:9:\"quickedit\";i:17;s:7:\"upgrade\";i:18;s:4:\"node\";i:19;s:4:\"rest\";i:20;s:6:\"search\";i:21;s:4:\"cron\";i:22;s:12:\"machine_name\";i:23;s:0:\"\";i:24;s:9:\"<current>\";i:25;s:5:\"batch\";i:26;s:10:\"update.php\";i:27;s:29:\"entity_reference_autocomplete\";i:28;s:7:\"session\";i:29;s:8:\"taxonomy\";i:30;s:7:\"toolbar\";i:31;s:6:\"twilio\";i:32;s:7:\"rss.xml\";i:33;s:5:\"views\";}'),('state','routing.menu_masks.router',_binary 'a:43:{i:0;i:501;i:1;i:493;i:2;i:491;i:3;i:464;i:4;i:253;i:5;i:252;i:6;i:251;i:7;i:250;i:8;i:247;i:9;i:246;i:10;i:245;i:11;i:232;i:12;i:224;i:13;i:126;i:14;i:125;i:15;i:123;i:16;i:122;i:17;i:116;i:18;i:96;i:19;i:63;i:20;i:62;i:21;i:61;i:22;i:60;i:23;i:49;i:24;i:42;i:25;i:32;i:26;i:31;i:27;i:30;i:28;i:28;i:29;i:24;i:30;i:21;i:31;i:15;i:32;i:14;i:33;i:13;i:34;i:12;i:35;i:11;i:36;i:8;i:37;i:7;i:38;i:6;i:39;i:5;i:40;i:3;i:41;i:2;i:42;i:1;}'),('state','routing.non_admin_routes',_binary 'a:189:{i:0;s:13:\"big_pipe.nojs\";i:1;s:27:\"block.category_autocomplete\";i:2;s:22:\"block_content.add_page\";i:3;s:22:\"block_content.add_form\";i:4;s:30:\"entity.block_content.canonical\";i:5;s:30:\"entity.block_content.edit_form\";i:6;s:32:\"entity.block_content.delete_form\";i:7;s:24:\"entity.comment.edit_form\";i:8;s:15:\"comment.approve\";i:9;s:24:\"entity.comment.canonical\";i:10;s:26:\"entity.comment.delete_form\";i:11;s:13:\"comment.reply\";i:12;s:31:\"comment.new_comments_node_links\";i:13;s:21:\"comment.node_redirect\";i:14;s:17:\"contact.site_page\";i:15;s:29:\"entity.contact_form.canonical\";i:16;s:24:\"entity.user.contact_form\";i:17;s:17:\"contextual.render\";i:18;s:15:\"devel.reinstall\";i:19;s:18:\"devel.menu_rebuild\";i:20;s:18:\"devel.configs_list\";i:21;s:17:\"devel.config_edit\";i:22;s:23:\"devel.state_system_page\";i:23;s:23:\"devel.system_state_edit\";i:24;s:20:\"devel.theme_registry\";i:25;s:21:\"devel.field_info_page\";i:26;s:17:\"devel.execute_php\";i:27;s:13:\"devel.session\";i:28;s:12:\"devel.switch\";i:29;s:17:\"devel.cache_clear\";i:30;s:14:\"devel.run_cron\";i:31;s:28:\"devel.container_info.service\";i:32;s:35:\"devel.container_info.service.detail\";i:33;s:30:\"devel.container_info.parameter\";i:34;s:37:\"devel.container_info.parameter.detail\";i:35;s:16:\"devel.route_info\";i:36;s:21:\"devel.route_info.item\";i:37;s:16:\"devel.event_info\";i:38;s:19:\"devel.elements_page\";i:39;s:26:\"devel.elements_page.detail\";i:40;s:22:\"devel.entity_info_page\";i:41;s:29:\"devel.entity_info_page.detail\";i:42;s:17:\"editor.filter_xss\";i:43;s:31:\"editor.field_untransformed_text\";i:44;s:19:\"editor.image_dialog\";i:45;s:18:\"editor.link_dialog\";i:46;s:18:\"file.ajax_progress\";i:47;s:15:\"filter.tips_all\";i:48;s:11:\"filter.tips\";i:49;s:26:\"history.get_last_node_view\";i:50;s:17:\"history.read_node\";i:51;s:18:\"image.style_public\";i:52;s:19:\"image.style_private\";i:53;s:12:\"image.upload\";i:54;s:10:\"image.info\";i:55;s:25:\"migrate_drupal_ui.upgrade\";i:56;s:37:\"migrate_drupal_ui.upgrade_incremental\";i:57;s:36:\"migrate_drupal_ui.upgrade_credential\";i:58;s:36:\"migrate_drupal_ui.upgrade_idconflict\";i:59;s:32:\"migrate_drupal_ui.upgrade_review\";i:60;s:13:\"node.add_page\";i:61;s:8:\"node.add\";i:62;s:19:\"entity.node.preview\";i:63;s:27:\"entity.node.version_history\";i:64;s:20:\"entity.node.revision\";i:65;s:28:\"node.revision_revert_confirm\";i:66;s:40:\"node.revision_revert_translation_confirm\";i:67;s:28:\"node.revision_delete_confirm\";i:68;s:18:\"quickedit.metadata\";i:69;s:21:\"quickedit.attachments\";i:70;s:20:\"quickedit.field_form\";i:71;s:21:\"quickedit.entity_save\";i:72;s:14:\"rest.csrftoken\";i:73;s:11:\"search.view\";i:74;s:23:\"search.view_node_search\";i:75;s:23:\"search.help_node_search\";i:76;s:23:\"search.view_user_search\";i:77;s:23:\"search.help_user_search\";i:78;s:19:\"shortcut.set_switch\";i:79;s:10:\"system.401\";i:80;s:10:\"system.403\";i:81;s:10:\"system.404\";i:82;s:10:\"system.4xx\";i:83;s:11:\"system.cron\";i:84;s:33:\"system.machine_name_transliterate\";i:85;s:12:\"system.files\";i:86;s:28:\"system.private_file_download\";i:87;s:16:\"system.temporary\";i:88;s:7:\"<front>\";i:89;s:6:\"<none>\";i:90;s:8:\"<nolink>\";i:91;s:9:\"<current>\";i:92;s:15:\"system.timezone\";i:93;s:22:\"system.batch_page.html\";i:94;s:22:\"system.batch_page.json\";i:95;s:16:\"system.db_update\";i:96;s:26:\"system.entity_autocomplete\";i:97;s:16:\"system.csrftoken\";i:98;s:30:\"entity.taxonomy_term.edit_form\";i:99;s:32:\"entity.taxonomy_term.delete_form\";i:100;s:16:\"toolbar.subtrees\";i:101;s:22:\"twilio.receive_message\";i:102;s:20:\"twilio.receive_voice\";i:103;s:13:\"user.register\";i:104;s:11:\"user.logout\";i:105;s:9:\"user.pass\";i:106;s:14:\"user.pass.http\";i:107;s:9:\"user.page\";i:108;s:10:\"user.login\";i:109;s:15:\"user.login.http\";i:110;s:22:\"user.login_status.http\";i:111;s:16:\"user.logout.http\";i:112;s:19:\"user.cancel_confirm\";i:113;s:16:\"user.reset.login\";i:114;s:10:\"user.reset\";i:115;s:15:\"user.reset.form\";i:116;s:21:\"view.frontpage.feed_1\";i:117;s:21:\"view.frontpage.page_1\";i:118;s:25:\"view.taxonomy_term.feed_1\";i:119;s:25:\"view.taxonomy_term.page_1\";i:120;s:10:\"views.ajax\";i:121;s:35:\"entity.block_content.latest_version\";i:122;s:21:\"entity.node.canonical\";i:123;s:23:\"entity.node.delete_form\";i:124;s:21:\"entity.node.edit_form\";i:125;s:26:\"entity.node.latest_version\";i:126;s:21:\"entity.user.canonical\";i:127;s:21:\"entity.user.edit_form\";i:128;s:23:\"entity.user.cancel_form\";i:129;s:23:\"entity.block.devel_load\";i:130;s:29:\"entity.block.devel_definition\";i:131;s:36:\"entity.block_content_type.devel_load\";i:132;s:42:\"entity.block_content_type.devel_definition\";i:133;s:31:\"entity.block_content.devel_load\";i:134;s:33:\"entity.block_content.devel_render\";i:135;s:37:\"entity.block_content.devel_definition\";i:136;s:30:\"entity.comment_type.devel_load\";i:137;s:36:\"entity.comment_type.devel_definition\";i:138;s:25:\"entity.comment.devel_load\";i:139;s:27:\"entity.comment.devel_render\";i:140;s:31:\"entity.comment.devel_definition\";i:141;s:30:\"entity.contact_form.devel_load\";i:142;s:36:\"entity.contact_form.devel_definition\";i:143;s:49:\"entity.content_moderation_notification.devel_load\";i:144;s:55:\"entity.content_moderation_notification.devel_definition\";i:145;s:31:\"entity.filter_format.devel_load\";i:146;s:37:\"entity.filter_format.devel_definition\";i:147;s:29:\"entity.image_style.devel_load\";i:148;s:35:\"entity.image_style.devel_definition\";i:149;s:33:\"entity.migration_group.devel_load\";i:150;s:39:\"entity.migration_group.devel_definition\";i:151;s:22:\"entity.node.devel_load\";i:152;s:24:\"entity.node.devel_render\";i:153;s:28:\"entity.node.devel_definition\";i:154;s:27:\"entity.node_type.devel_load\";i:155;s:33:\"entity.node_type.devel_definition\";i:156;s:29:\"entity.search_page.devel_load\";i:157;s:35:\"entity.search_page.devel_definition\";i:158;s:30:\"entity.shortcut_set.devel_load\";i:159;s:36:\"entity.shortcut_set.devel_definition\";i:160;s:26:\"entity.shortcut.devel_load\";i:161;s:28:\"entity.shortcut.devel_render\";i:162;s:32:\"entity.shortcut.devel_definition\";i:163;s:22:\"entity.menu.devel_load\";i:164;s:28:\"entity.menu.devel_definition\";i:165;s:31:\"entity.taxonomy_term.devel_load\";i:166;s:33:\"entity.taxonomy_term.devel_render\";i:167;s:37:\"entity.taxonomy_term.devel_definition\";i:168;s:37:\"entity.taxonomy_vocabulary.devel_load\";i:169;s:43:\"entity.taxonomy_vocabulary.devel_definition\";i:170;s:22:\"entity.user.devel_load\";i:171;s:24:\"entity.user.devel_render\";i:172;s:28:\"entity.user.devel_definition\";i:173;s:27:\"entity.user_role.devel_load\";i:174;s:33:\"entity.user_role.devel_definition\";i:175;s:26:\"entity.workflow.devel_load\";i:176;s:32:\"entity.workflow.devel_definition\";i:177;s:35:\"entity.menu_link_content.devel_load\";i:178;s:37:\"entity.menu_link_content.devel_render\";i:179;s:41:\"entity.menu_link_content.devel_definition\";i:180;s:22:\"entity.view.devel_load\";i:181;s:28:\"entity.view.devel_definition\";i:182;s:29:\"entity.date_format.devel_load\";i:183;s:35:\"entity.date_format.devel_definition\";i:184;s:34:\"entity.entity_form_mode.devel_load\";i:185;s:40:\"entity.entity_form_mode.devel_definition\";i:186;s:34:\"entity.entity_view_mode.devel_load\";i:187;s:40:\"entity.entity_view_mode.devel_definition\";i:188;s:30:\"entity.taxonomy_term.canonical\";}'),('state','system.cron_key',_binary 's:74:\"NLKZSJ-HItzr0e5QcC3-TP_8qPppfH55bDMnGX1eeT7izJJPLx5TS0ZOtmi9ZzlLB_YqqBtqgg\";'),('state','system.cron_last',_binary 'i:1540283840;'),('state','system.css_js_query_string',_binary 's:6:\"ph1v02\";'),('state','system.maintenance_mode',_binary 'N;'),('state','system.private_key',_binary 's:74:\"SPwVoJdMTrKLiqbRwIqGxJEqAeBP52cFB7CvLOp3RHIdAzPwhIHbVX1-5O7LxdgPNGOwrRUvSQ\";'),('state','system.profile.files',_binary 'a:12:{s:10:\"demo_umami\";s:44:\"core/profiles/demo_umami/demo_umami.info.yml\";s:7:\"minimal\";s:38:\"core/profiles/minimal/minimal.info.yml\";s:8:\"standard\";s:40:\"core/profiles/standard/standard.info.yml\";s:7:\"testing\";s:38:\"core/profiles/testing/testing.info.yml\";s:21:\"testing_config_import\";s:66:\"core/profiles/testing_config_import/testing_config_import.info.yml\";s:24:\"testing_config_overrides\";s:72:\"core/profiles/testing_config_overrides/testing_config_overrides.info.yml\";s:40:\"testing_install_profile_all_dependencies\";s:104:\"core/profiles/testing_install_profile_all_dependencies/testing_install_profile_all_dependencies.info.yml\";s:36:\"testing_install_profile_dependencies\";s:96:\"core/profiles/testing_install_profile_dependencies/testing_install_profile_dependencies.info.yml\";s:39:\"testing_install_profile_dependencies_bc\";s:102:\"core/profiles/testing_install_profile_dependencies_bc/testing_install_profile_dependencies_bc.info.yml\";s:28:\"testing_missing_dependencies\";s:80:\"core/profiles/testing_missing_dependencies/testing_missing_dependencies.info.yml\";s:20:\"testing_multilingual\";s:64:\"core/profiles/testing_multilingual/testing_multilingual.info.yml\";s:33:\"testing_multilingual_with_english\";s:90:\"core/profiles/testing_multilingual_with_english/testing_multilingual_with_english.info.yml\";}'),('state','system.theme.data',_binary 'a:5:{s:6:\"bartik\";C:31:\"Drupal\\Core\\Extension\\Extension\":2338:{a:16:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:34:\"core/themes/bartik/bartik.info.yml\";s:8:\"filename\";s:12:\"bartik.theme\";s:7:\"subpath\";s:13:\"themes/bartik\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:17:{s:4:\"name\";s:6:\"Bartik\";s:4:\"type\";s:5:\"theme\";s:10:\"base theme\";s:6:\"classy\";s:11:\"description\";s:86:\"A flexible, recolorable theme with many regions and a responsive, mobile-first layout.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:9:\"libraries\";a:1:{i:0;s:21:\"bartik/global-styling\";}s:20:\"ckeditor_stylesheets\";a:4:{i:0;s:21:\"css/base/elements.css\";i:1;s:27:\"css/components/captions.css\";i:2;s:24:\"css/components/table.css\";i:3;s:33:\"css/components/text-formatted.css\";}s:7:\"regions\";a:19:{s:6:\"header\";s:6:\"Header\";s:12:\"primary_menu\";s:12:\"Primary menu\";s:14:\"secondary_menu\";s:14:\"Secondary menu\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:12:\"featured_top\";s:12:\"Featured top\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:21:\"featured_bottom_first\";s:21:\"Featured bottom first\";s:22:\"featured_bottom_second\";s:22:\"Featured bottom second\";s:21:\"featured_bottom_third\";s:21:\"Featured bottom third\";s:12:\"footer_first\";s:12:\"Footer first\";s:13:\"footer_second\";s:13:\"Footer second\";s:12:\"footer_third\";s:12:\"Footer third\";s:13:\"footer_fourth\";s:13:\"Footer fourth\";s:12:\"footer_fifth\";s:12:\"Footer fifth\";}s:6:\"engine\";s:4:\"twig\";s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:33:\"core/themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1536580207;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"classy\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:0:{}s:8:\"requires\";a:2:{s:6:\"classy\";a:1:{s:4:\"name\";s:6:\"classy\";}s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-2;s:11:\"base_themes\";a:2:{s:6:\"stable\";s:6:\"Stable\";s:6:\"classy\";s:6:\"Classy\";}s:9:\"libraries\";a:1:{i:0;s:21:\"bartik/global-styling\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"classy\";}}s:6:\"classy\";C:31:\"Drupal\\Core\\Extension\\Extension\":2362:{a:17:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:34:\"core/themes/classy/classy.info.yml\";s:8:\"filename\";N;s:7:\"subpath\";s:13:\"themes/classy\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Classy\";s:4:\"type\";s:5:\"theme\";s:11:\"description\";s:176:\"A base theme with sensible default CSS classes added. Learn how to use Classy as a base theme in the <a href=\"https://www.drupal.org/docs/8/theming\">Drupal 8 Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:9:\"libraries\";a:3:{i:0;s:11:\"classy/base\";i:1;s:15:\"classy/messages\";i:2;s:14:\"core/normalize\";}s:16:\"libraries-extend\";a:5:{s:16:\"user/drupal.user\";a:1:{i:0;s:11:\"classy/user\";}s:22:\"core/drupal.dropbutton\";a:1:{i:0;s:17:\"classy/dropbutton\";}s:18:\"core/drupal.dialog\";a:1:{i:0;s:13:\"classy/dialog\";}s:16:\"file/drupal.file\";a:1:{i:0;s:11:\"classy/file\";}s:20:\"core/drupal.progress\";a:1:{i:0;s:15:\"classy/progress\";}}s:6:\"engine\";s:4:\"twig\";s:10:\"base theme\";s:6:\"stable\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:12:\"primary_menu\";s:12:\"Primary menu\";s:14:\"secondary_menu\";s:14:\"Secondary menu\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";}s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:33:\"core/themes/classy/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1536580207;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"stable\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:2:{s:6:\"bartik\";a:1:{s:4:\"name\";s:6:\"classy\";}s:5:\"seven\";a:1:{s:4:\"name\";s:6:\"classy\";}}s:8:\"requires\";a:1:{s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-1;s:10:\"sub_themes\";a:2:{s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:11:\"base_themes\";a:1:{s:6:\"stable\";s:6:\"Stable\";}s:9:\"libraries\";a:3:{i:0;s:11:\"classy/base\";i:1;s:15:\"classy/messages\";i:2;s:14:\"core/normalize\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"stable\";}}s:5:\"seven\";C:31:\"Drupal\\Core\\Extension\\Extension\":3224:{a:16:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:32:\"core/themes/seven/seven.info.yml\";s:8:\"filename\";s:11:\"seven.theme\";s:7:\"subpath\";s:12:\"themes/seven\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:20:{s:4:\"name\";s:5:\"Seven\";s:4:\"type\";s:5:\"theme\";s:10:\"base theme\";s:6:\"classy\";s:11:\"description\";s:153:\"The default administration theme for Drupal 8 was designed with clean lines, simple blocks, and sans-serif font to emphasize the tools and tasks at hand.\";s:8:\"alt text\";s:77:\"Default administration theme for Drupal 8 with simple blocks and clean lines.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:9:\"libraries\";a:1:{i:0;s:20:\"seven/global-styling\";}s:18:\"libraries-override\";a:6:{s:11:\"system/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:3:{s:67:\"/core/themes/stable/css/system/components/system-status-counter.css\";s:40:\"css/components/system-status-counter.css\";s:75:\"/core/themes/stable/css/system/components/system-status-report-counters.css\";s:48:\"css/components/system-status-report-counters.css\";s:79:\"/core/themes/stable/css/system/components/system-status-report-general-info.css\";s:52:\"css/components/system-status-report-general-info.css\";}}}s:25:\"core/drupal.vertical-tabs\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"misc/vertical-tabs.css\";b:0;}}}s:14:\"core/jquery.ui\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:45:\"assets/vendor/jquery.ui/themes/base/theme.css\";b:0;}}}s:21:\"core/jquery.ui.dialog\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:46:\"assets/vendor/jquery.ui/themes/base/dialog.css\";b:0;}}}s:13:\"classy/dialog\";s:25:\"seven/seven.drupal.dialog\";s:11:\"classy/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:26:\"css/components/details.css\";b:0;}}}}s:16:\"libraries-extend\";a:4:{s:13:\"core/ckeditor\";a:1:{i:0;s:21:\"seven/ckeditor-dialog\";}s:25:\"core/drupal.vertical-tabs\";a:1:{i:0;s:19:\"seven/vertical-tabs\";}s:14:\"core/jquery.ui\";a:1:{i:0;s:21:\"seven/seven.jquery.ui\";}s:17:\"tour/tour-styling\";a:1:{i:0;s:18:\"seven/tour-styling\";}}s:21:\"quickedit_stylesheets\";a:1:{i:0;s:28:\"css/components/quickedit.css\";}s:7:\"regions\";a:9:{s:6:\"header\";s:6:\"Header\";s:11:\"pre_content\";s:11:\"Pre-content\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:6:\"engine\";s:4:\"twig\";s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:32:\"core/themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1536580207;s:12:\"dependencies\";a:1:{i:0;s:6:\"classy\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:0:{}s:8:\"requires\";a:2:{s:6:\"classy\";a:1:{s:4:\"name\";s:6:\"classy\";}s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-3;s:11:\"base_themes\";a:2:{s:6:\"stable\";s:6:\"Stable\";s:6:\"classy\";s:6:\"Classy\";}s:9:\"libraries\";a:1:{i:0;s:20:\"seven/global-styling\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"classy\";}}s:6:\"stable\";C:31:\"Drupal\\Core\\Extension\\Extension\":13206:{a:14:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:34:\"core/themes/stable/stable.info.yml\";s:8:\"filename\";s:12:\"stable.theme\";s:7:\"subpath\";s:13:\"themes/stable\";s:6:\"origin\";s:4:\"core\";s:6:\"status\";i:1;s:4:\"info\";a:16:{s:4:\"name\";s:6:\"Stable\";s:4:\"type\";s:5:\"theme\";s:11:\"description\";s:62:\"A default base theme using Drupal 8.0.0\'s core markup and CSS.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:4:\"core\";s:3:\"8.x\";s:6:\"hidden\";b:1;s:18:\"libraries-override\";a:48:{s:24:\"block/drupal.block.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:19:\"css/block.admin.css\";s:25:\"css/block/block.admin.css\";}}}s:24:\"ckeditor/drupal.ckeditor\";a:1:{s:3:\"css\";a:1:{s:5:\"state\";a:1:{s:16:\"css/ckeditor.css\";s:25:\"css/ckeditor/ckeditor.css\";}}}s:51:\"ckeditor/drupal.ckeditor.plugins.drupalimagecaption\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:62:\"css/plugins/drupalimagecaption/ckeditor.drupalimagecaption.css\";s:71:\"css/ckeditor/plugins/drupalimagecaption/ckeditor.drupalimagecaption.css\";}}}s:41:\"ckeditor/drupal.ckeditor.plugins.language\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:42:\"css/plugins/language/ckeditor.language.css\";s:51:\"css/ckeditor/plugins/language/ckeditor.language.css\";}}}s:30:\"ckeditor/drupal.ckeditor.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:22:\"css/ckeditor.admin.css\";s:31:\"css/ckeditor/ckeditor.admin.css\";}}}s:11:\"color/admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:19:\"css/color.admin.css\";s:25:\"css/color/color.admin.css\";}}}s:50:\"config_translation/drupal.config_translation.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:32:\"css/config_translation.admin.css\";s:51:\"css/config_translation/config_translation.admin.css\";}}}s:52:\"content_translation/drupal.content_translation.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:33:\"css/content_translation.admin.css\";s:53:\"css/content_translation/content_translation.admin.css\";}}}s:37:\"content_moderation/content_moderation\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:33:\"css/content_moderation.module.css\";s:52:\"css/content_moderation/content_moderation.module.css\";}s:5:\"theme\";a:1:{s:32:\"css/content_moderation.theme.css\";s:51:\"css/content_moderation/content_moderation.theme.css\";}}}s:34:\"contextual/drupal.contextual-links\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:25:\"css/contextual.module.css\";s:36:\"css/contextual/contextual.module.css\";}s:5:\"theme\";a:2:{s:24:\"css/contextual.theme.css\";s:35:\"css/contextual/contextual.theme.css\";s:30:\"css/contextual.icons.theme.css\";s:41:\"css/contextual/contextual.icons.theme.css\";}}}s:36:\"contextual/drupal.contextual-toolbar\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:26:\"css/contextual.toolbar.css\";s:37:\"css/contextual/contextual.toolbar.css\";}}}s:29:\"core/drupal.dialog.off_canvas\";a:1:{s:3:\"css\";a:2:{s:4:\"base\";a:4:{s:32:\"misc/dialog/off-canvas.reset.css\";s:36:\"css/core/dialog/off-canvas.reset.css\";s:31:\"misc/dialog/off-canvas.base.css\";s:35:\"css/core/dialog/off-canvas.base.css\";s:26:\"misc/dialog/off-canvas.css\";s:30:\"css/core/dialog/off-canvas.css\";s:32:\"misc/dialog/off-canvas.theme.css\";s:36:\"css/core/dialog/off-canvas.theme.css\";}s:9:\"component\";a:8:{s:33:\"misc/dialog/off-canvas.motion.css\";s:37:\"css/core/dialog/off-canvas.motion.css\";s:33:\"misc/dialog/off-canvas.button.css\";s:37:\"css/core/dialog/off-canvas.button.css\";s:31:\"misc/dialog/off-canvas.form.css\";s:35:\"css/core/dialog/off-canvas.form.css\";s:32:\"misc/dialog/off-canvas.table.css\";s:36:\"css/core/dialog/off-canvas.table.css\";s:34:\"misc/dialog/off-canvas.details.css\";s:38:\"css/core/dialog/off-canvas.details.css\";s:36:\"misc/dialog/off-canvas.tabledrag.css\";s:40:\"css/core/dialog/off-canvas.tabledrag.css\";s:37:\"misc/dialog/off-canvas.dropbutton.css\";s:41:\"css/core/dialog/off-canvas.dropbutton.css\";s:33:\"misc/dialog/off-canvas.layout.css\";s:37:\"css/core/dialog/off-canvas.layout.css\";}}}s:22:\"core/drupal.dropbutton\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:30:\"misc/dropbutton/dropbutton.css\";s:34:\"css/core/dropbutton/dropbutton.css\";}}}s:25:\"core/drupal.vertical-tabs\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"misc/vertical-tabs.css\";s:26:\"css/core/vertical-tabs.css\";}}}s:18:\"dblog/drupal.dblog\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:20:\"css/dblog.module.css\";s:26:\"css/dblog/dblog.module.css\";}}}s:24:\"field_ui/drupal.field_ui\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:22:\"css/field_ui.admin.css\";s:31:\"css/field_ui/field_ui.admin.css\";}}}s:16:\"file/drupal.file\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:18:\"css/file.admin.css\";s:23:\"css/file/file.admin.css\";}}}s:26:\"filter/drupal.filter.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/filter.admin.css\";s:27:\"css/filter/filter.admin.css\";}}}s:20:\"filter/drupal.filter\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/filter.admin.css\";s:27:\"css/filter/filter.admin.css\";}}}s:14:\"filter/caption\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"css/filter.caption.css\";s:29:\"css/filter/filter.caption.css\";}}}s:11:\"image/admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:19:\"css/image.admin.css\";s:25:\"css/image/image.admin.css\";}}}s:35:\"image/quickedit.inPlaceEditor.image\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:21:\"css/editors/image.css\";s:27:\"css/image/editors/image.css\";}s:5:\"theme\";a:1:{s:27:\"css/editors/image.theme.css\";s:33:\"css/image/editors/image.theme.css\";}}}s:30:\"language/drupal.language.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:22:\"css/language.admin.css\";s:31:\"css/language/language.admin.css\";}}}s:26:\"locale/drupal.locale.admin\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:20:\"css/locale.admin.css\";s:27:\"css/locale/locale.admin.css\";}}}s:33:\"menu_ui/drupal.menu_ui.adminforms\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:21:\"css/menu_ui.admin.css\";s:29:\"css/menu_ui/menu_ui.admin.css\";}}}s:22:\"migrate_drupal_ui/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:49:\"css/components/upgrade-analysis-report-tables.css\";s:67:\"css/migrate_drupal_ui/components/upgrade-analysis-report-tables.css\";}}}s:16:\"node/drupal.node\";a:1:{s:3:\"css\";a:1:{s:6:\"layout\";a:1:{s:19:\"css/node.module.css\";s:24:\"css/node/node.module.css\";}}}s:24:\"node/drupal.node.preview\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/node.preview.css\";s:25:\"css/node/node.preview.css\";}}}s:9:\"node/form\";a:1:{s:3:\"css\";a:1:{s:6:\"layout\";a:1:{s:19:\"css/node.module.css\";s:24:\"css/node/node.module.css\";}}}s:22:\"node/drupal.node.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:18:\"css/node.admin.css\";s:23:\"css/node/node.admin.css\";}}}s:19:\"quickedit/quickedit\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:24:\"css/quickedit.module.css\";s:34:\"css/quickedit/quickedit.module.css\";}s:5:\"theme\";a:2:{s:23:\"css/quickedit.theme.css\";s:33:\"css/quickedit/quickedit.theme.css\";s:29:\"css/quickedit.icons.theme.css\";s:39:\"css/quickedit/quickedit.icons.theme.css\";}}}s:34:\"settings_tray/drupal.settings_tray\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:3:{s:28:\"css/settings_tray.module.css\";s:42:\"css/settings_tray/settings_tray.module.css\";s:28:\"css/settings_tray.motion.css\";s:42:\"css/settings_tray/settings_tray.motion.css\";s:29:\"css/settings_tray.toolbar.css\";s:43:\"css/settings_tray/settings_tray.toolbar.css\";}s:5:\"theme\";a:1:{s:27:\"css/settings_tray.theme.css\";s:41:\"css/settings_tray/settings_tray.theme.css\";}}}s:24:\"shortcut/drupal.shortcut\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:2:{s:22:\"css/shortcut.theme.css\";s:31:\"css/shortcut/shortcut.theme.css\";s:28:\"css/shortcut.icons.theme.css\";s:37:\"css/shortcut/shortcut.icons.theme.css\";}}}s:28:\"simpletest/drupal.simpletest\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:25:\"css/simpletest.module.css\";s:36:\"css/simpletest/simpletest.module.css\";}}}s:11:\"system/base\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:22:{s:39:\"css/components/ajax-progress.module.css\";s:46:\"css/system/components/ajax-progress.module.css\";s:31:\"css/components/align.module.css\";s:38:\"css/system/components/align.module.css\";s:46:\"css/components/autocomplete-loading.module.css\";s:53:\"css/system/components/autocomplete-loading.module.css\";s:36:\"css/components/fieldgroup.module.css\";s:43:\"css/system/components/fieldgroup.module.css\";s:42:\"css/components/container-inline.module.css\";s:49:\"css/system/components/container-inline.module.css\";s:34:\"css/components/clearfix.module.css\";s:41:\"css/system/components/clearfix.module.css\";s:33:\"css/components/details.module.css\";s:40:\"css/system/components/details.module.css\";s:32:\"css/components/hidden.module.css\";s:39:\"css/system/components/hidden.module.css\";s:35:\"css/components/item-list.module.css\";s:42:\"css/system/components/item-list.module.css\";s:28:\"css/components/js.module.css\";s:35:\"css/system/components/js.module.css\";s:32:\"css/components/nowrap.module.css\";s:39:\"css/system/components/nowrap.module.css\";s:44:\"css/components/position-container.module.css\";s:51:\"css/system/components/position-container.module.css\";s:34:\"css/components/progress.module.css\";s:41:\"css/system/components/progress.module.css\";s:42:\"css/components/reset-appearance.module.css\";s:49:\"css/system/components/reset-appearance.module.css\";s:32:\"css/components/resize.module.css\";s:39:\"css/system/components/resize.module.css\";s:39:\"css/components/sticky-header.module.css\";s:46:\"css/system/components/sticky-header.module.css\";s:40:\"css/components/system-status-counter.css\";s:47:\"css/system/components/system-status-counter.css\";s:48:\"css/components/system-status-report-counters.css\";s:55:\"css/system/components/system-status-report-counters.css\";s:52:\"css/components/system-status-report-general-info.css\";s:59:\"css/system/components/system-status-report-general-info.css\";s:35:\"css/components/tabledrag.module.css\";s:42:\"css/system/components/tabledrag.module.css\";s:35:\"css/components/tablesort.module.css\";s:42:\"css/system/components/tablesort.module.css\";s:36:\"css/components/tree-child.module.css\";s:43:\"css/system/components/tree-child.module.css\";}}}s:12:\"system/admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:20:\"css/system.admin.css\";s:27:\"css/system/system.admin.css\";}}}s:18:\"system/maintenance\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:26:\"css/system.maintenance.css\";s:33:\"css/system/system.maintenance.css\";}}}s:11:\"system/diff\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:19:\"css/system.diff.css\";s:26:\"css/system/system.diff.css\";}}}s:24:\"taxonomy/drupal.taxonomy\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:22:\"css/taxonomy.theme.css\";s:31:\"css/taxonomy/taxonomy.theme.css\";}}}s:15:\"toolbar/toolbar\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:22:\"css/toolbar.module.css\";s:30:\"css/toolbar/toolbar.module.css\";}s:5:\"theme\";a:2:{s:21:\"css/toolbar.theme.css\";s:29:\"css/toolbar/toolbar.theme.css\";s:27:\"css/toolbar.icons.theme.css\";s:35:\"css/toolbar/toolbar.icons.theme.css\";}}}s:20:\"toolbar/toolbar.menu\";a:1:{s:3:\"css\";a:1:{s:5:\"state\";a:1:{s:20:\"css/toolbar.menu.css\";s:28:\"css/toolbar/toolbar.menu.css\";}}}s:17:\"tour/tour-styling\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:19:\"css/tour.module.css\";s:24:\"css/tour/tour.module.css\";}}}s:26:\"update/drupal.update.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:26:\"css/update.admin.theme.css\";s:33:\"css/update/update.admin.theme.css\";}}}s:16:\"user/drupal.user\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:19:\"css/user.module.css\";s:24:\"css/user/user.module.css\";}}}s:22:\"user/drupal.user.admin\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:18:\"css/user.admin.css\";s:23:\"css/user/user.admin.css\";}}}s:22:\"user/drupal.user.icons\";a:1:{s:3:\"css\";a:1:{s:5:\"theme\";a:1:{s:24:\"css/user.icons.admin.css\";s:29:\"css/user/user.icons.admin.css\";}}}s:18:\"views/views.module\";a:1:{s:3:\"css\";a:1:{s:9:\"component\";a:1:{s:20:\"css/views.module.css\";s:26:\"css/views/views.module.css\";}}}s:22:\"views_ui/admin.styling\";a:1:{s:3:\"css\";a:2:{s:9:\"component\";a:1:{s:22:\"css/views_ui.admin.css\";s:31:\"css/views_ui/views_ui.admin.css\";}s:5:\"theme\";a:2:{s:28:\"css/views_ui.admin.theme.css\";s:37:\"css/views_ui/views_ui.admin.theme.css\";s:27:\"css/views_ui.contextual.css\";s:36:\"css/views_ui/views_ui.contextual.css\";}}}}s:6:\"engine\";s:4:\"twig\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:12:\"primary_menu\";s:12:\"Primary menu\";s:14:\"secondary_menu\";s:14:\"Secondary menu\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:10:\"breadcrumb\";s:10:\"Breadcrumb\";}s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:33:\"core/themes/stable/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:9:\"libraries\";a:0:{}s:5:\"mtime\";i:1536580207;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:5:{s:6:\"classy\";a:1:{s:4:\"name\";s:6:\"stable\";}s:6:\"bartik\";a:1:{s:4:\"name\";s:6:\"stable\";}s:5:\"seven\";a:1:{s:4:\"name\";s:6:\"stable\";}s:6:\"cowork\";a:1:{s:4:\"name\";s:6:\"stable\";}s:7:\"justice\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:8:\"requires\";a:0:{}s:4:\"sort\";i:0;s:10:\"sub_themes\";a:5:{s:6:\"bartik\";s:6:\"Bartik\";s:6:\"classy\";s:6:\"Classy\";s:5:\"seven\";s:5:\"Seven\";s:6:\"cowork\";s:35:\"Cowork One Page Responsive Template\";s:7:\"justice\";s:7:\"justice\";}s:6:\"engine\";s:4:\"twig\";}}s:7:\"justice\";C:31:\"Drupal\\Core\\Extension\\Extension\":1869:{a:16:{s:4:\"type\";s:5:\"theme\";s:8:\"pathname\";s:38:\"themes/custom/justice/justice.info.yml\";s:8:\"filename\";s:13:\"justice.theme\";s:7:\"subpath\";s:21:\"themes/custom/justice\";s:6:\"origin\";s:0:\"\";s:6:\"status\";i:1;s:4:\"info\";a:18:{s:4:\"name\";s:7:\"justice\";s:4:\"type\";s:5:\"theme\";s:11:\"description\";s:48:\"Justice is a one page Bootstrap HTML5 base theme\";s:7:\"package\";s:7:\"theming\";s:9:\"libraries\";a:2:{i:0;s:22:\"justice/global-styling\";i:1;s:23:\"justice/justice-styling\";}s:7:\"regions\";a:13:{s:8:\"branding\";s:13:\"Site Branding\";s:10:\"navigation\";s:10:\"Navigation\";s:7:\"top_bar\";s:7:\"Top Bar\";s:16:\"home_page_banner\";s:15:\"Home Page Banne\";s:8:\"about_us\";s:8:\"About Us\";s:14:\"practice_areas\";s:14:\"Practice Areas\";s:8:\"our_team\";s:8:\"Our Team\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar First\";s:14:\"sidebar_second\";s:14:\"Sidebar Second\";s:7:\"contact\";s:7:\"Contact\";s:6:\"footer\";s:6:\"Footer\";s:12:\"social_media\";s:12:\"Social Media\";}s:7:\"version\";s:11:\"8.x-5.x-dev\";s:4:\"core\";s:3:\"8.x\";s:7:\"project\";s:7:\"justice\";s:9:\"datestamp\";i:1526042904;s:6:\"engine\";s:4:\"twig\";s:10:\"base theme\";s:6:\"stable\";s:8:\"features\";a:5:{i:0;s:7:\"favicon\";i:1;s:4:\"logo\";i:2;s:17:\"node_user_picture\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";}s:10:\"screenshot\";s:36:\"themes/custom/justice/screenshot.png\";s:3:\"php\";s:5:\"5.5.9\";s:5:\"mtime\";i:1540291313;s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"stable\";}}s:5:\"owner\";s:36:\"core/themes/engines/twig/twig.engine\";s:6:\"prefix\";s:4:\"twig\";s:11:\"required_by\";a:0:{}s:8:\"requires\";a:1:{s:6:\"stable\";a:1:{s:4:\"name\";s:6:\"stable\";}}s:4:\"sort\";i:-5;s:11:\"base_themes\";a:1:{s:6:\"stable\";s:6:\"Stable\";}s:9:\"libraries\";a:2:{i:0;s:22:\"justice/global-styling\";i:1;s:23:\"justice/justice-styling\";}s:6:\"engine\";s:4:\"twig\";s:10:\"base_theme\";s:6:\"stable\";}}}'),('state','system.theme.files',_binary 'a:9:{s:6:\"bartik\";s:34:\"core/themes/bartik/bartik.info.yml\";s:6:\"classy\";s:34:\"core/themes/classy/classy.info.yml\";s:5:\"seven\";s:32:\"core/themes/seven/seven.info.yml\";s:6:\"stable\";s:34:\"core/themes/stable/stable.info.yml\";s:5:\"stark\";s:32:\"core/themes/stark/stark.info.yml\";s:9:\"bootstrap\";s:35:\"themes/bootstrap/bootstrap.info.yml\";s:6:\"cowork\";s:36:\"themes/custom/cowork/cowork.info.yml\";s:7:\"justice\";s:38:\"themes/custom/justice/justice.info.yml\";s:6:\"pixlar\";s:36:\"themes/custom/pixlar/pixlar.info.yml\";}'),('state','system.theme_engine.files',_binary 'a:1:{s:4:\"twig\";s:38:\"core/themes/engines/twig/twig.info.yml\";}'),('state','update.last_check',_binary 'i:1540283846;'),('state','update.last_email_notification',_binary 'i:1540283840;'),('state','views.view_route_names',_binary 'a:16:{s:13:\"watchdog.page\";s:14:\"dblog.overview\";s:24:\"user_admin_people.page_1\";s:22:\"entity.user.collection\";s:20:\"taxonomy_term.page_1\";s:30:\"entity.taxonomy_term.canonical\";s:35:\"moderated_content.moderated_content\";s:42:\"content_moderation.admin_moderated_content\";s:14:\"content.page_1\";s:20:\"system.admin_content\";s:23:\"comment.page_unapproved\";s:22:\"comment.admin_approval\";s:22:\"comment.page_published\";s:13:\"comment.admin\";s:20:\"block_content.page_1\";s:31:\"entity.block_content.collection\";s:12:\"files.page_1\";s:17:\"view.files.page_1\";s:12:\"files.page_2\";s:17:\"view.files.page_2\";s:16:\"frontpage.feed_1\";s:21:\"view.frontpage.feed_1\";s:16:\"frontpage.page_1\";s:21:\"view.frontpage.page_1\";s:26:\"ga_reports_page.page_front\";s:31:\"view.ga_reports_page.page_front\";s:27:\"ga_reports_page.page_others\";s:32:\"view.ga_reports_page.page_others\";s:17:\"ga_summary.page_1\";s:22:\"view.ga_summary.page_1\";s:20:\"taxonomy_term.feed_1\";s:25:\"view.taxonomy_term.feed_1\";}'),('system.schema','admin_toolbar',_binary 'i:8000;'),('system.schema','automated_cron',_binary 'i:8000;'),('system.schema','big_pipe',_binary 'i:8000;'),('system.schema','block',_binary 's:4:\"8003\";'),('system.schema','block_class',_binary 'i:8000;'),('system.schema','block_content',_binary 'i:8600;'),('system.schema','breakpoint',_binary 'i:8000;'),('system.schema','ckeditor',_binary 'i:8000;'),('system.schema','color',_binary 'i:8000;'),('system.schema','comment',_binary 'i:8600;'),('system.schema','config',_binary 'i:8000;'),('system.schema','contact',_binary 'i:8000;'),('system.schema','contact_block',_binary 'i:8000;'),('system.schema','content_moderation',_binary 's:4:\"8401\";'),('system.schema','content_moderation_notifications',_binary 'i:8000;'),('system.schema','contextual',_binary 'i:8000;'),('system.schema','datetime',_binary 'i:8000;'),('system.schema','dblog',_binary 'i:8600;'),('system.schema','devel',_binary 's:4:\"8002\";'),('system.schema','devel_generate',_binary 'i:8000;'),('system.schema','dynamic_page_cache',_binary 'i:8000;'),('system.schema','editor',_binary 's:4:\"8001\";'),('system.schema','entity',_binary 'i:8000;'),('system.schema','field',_binary 's:4:\"8500\";'),('system.schema','field_ui',_binary 'i:8000;'),('system.schema','file',_binary 's:4:\"8300\";'),('system.schema','filter',_binary 'i:8000;'),('system.schema','ga_reports',_binary 'i:8000;'),('system.schema','help',_binary 'i:8000;'),('system.schema','history',_binary 's:4:\"8101\";'),('system.schema','image',_binary 's:4:\"8201\";'),('system.schema','kint',_binary 'i:8000;'),('system.schema','link',_binary 'i:8000;'),('system.schema','menu_link_content',_binary 'i:8601;'),('system.schema','menu_ui',_binary 'i:8000;'),('system.schema','migrate',_binary 's:4:\"8001\";'),('system.schema','migrate_drupal',_binary 'i:8601;'),('system.schema','migrate_drupal_multilingual',_binary 'i:8000;'),('system.schema','migrate_drupal_ui',_binary 'i:8000;'),('system.schema','migrate_plus',_binary 's:4:\"8100\";'),('system.schema','migrate_tools',_binary 'i:8000;'),('system.schema','migrate_upgrade',_binary 'i:8000;'),('system.schema','node',_binary 's:4:\"8401\";'),('system.schema','options',_binary 'i:8000;'),('system.schema','page_cache',_binary 'i:8000;'),('system.schema','path',_binary 's:4:\"8200\";'),('system.schema','quickedit',_binary 'i:8000;'),('system.schema','rdf',_binary 'i:8000;'),('system.schema','rest',_binary 's:4:\"8401\";'),('system.schema','search',_binary 'i:8000;'),('system.schema','serialization',_binary 's:4:\"8401\";'),('system.schema','shortcut',_binary 'i:8000;'),('system.schema','standard',_binary 'i:8000;'),('system.schema','system',_binary 's:4:\"8501\";'),('system.schema','taxonomy',_binary 'i:8601;'),('system.schema','text',_binary 'i:8000;'),('system.schema','toolbar',_binary 'i:8000;'),('system.schema','tour',_binary 'i:8000;'),('system.schema','twilio',_binary 'i:8000;'),('system.schema','update',_binary 's:4:\"8001\";'),('system.schema','user',_binary 's:4:\"8100\";'),('system.schema','views',_binary 's:4:\"8500\";'),('system.schema','views_ui',_binary 'i:8000;'),('system.schema','workflows',_binary 'i:8000;'),('update_fetch_task','block_class',_binary 'a:6:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";i:1531440825;s:16:\"_info_file_ctime\";i:1540189886;}s:9:\"datestamp\";i:1531440825;s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}'),('update_fetch_task','justice',_binary 'a:6:{s:4:\"name\";s:7:\"justice\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"justice\";s:7:\"package\";s:7:\"theming\";s:7:\"version\";s:11:\"8.x-5.x-dev\";s:7:\"project\";s:7:\"justice\";s:9:\"datestamp\";i:1526042904;s:16:\"_info_file_ctime\";i:1540291313;}s:9:\"datestamp\";i:1526042904;s:8:\"includes\";a:1:{s:7:\"justice\";s:7:\"justice\";}s:12:\"project_type\";s:5:\"theme\";s:14:\"project_status\";b:1;}');
/*!40000 ALTER TABLE `key_value` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `key_value_expire`
--

DROP TABLE IF EXISTS `key_value_expire`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `key_value_expire` (
  `collection` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'A named collection of key and value pairs.',
  `name` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The key of the key/value pair.',
  `value` longblob NOT NULL COMMENT 'The value of the key/value pair.',
  `expire` int(11) NOT NULL DEFAULT '2147483647' COMMENT 'The time since Unix epoch in seconds when this item expires. Defaults to the maximum possible time.',
  PRIMARY KEY (`collection`,`name`),
  KEY `all` (`name`,`collection`,`expire`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Generic key/value storage table with an expiration.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `key_value_expire`
--

LOCK TABLES `key_value_expire` WRITE;
/*!40000 ALTER TABLE `key_value_expire` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `key_value_expire` VALUES ('update','update_project_data',_binary 'a:11:{s:6:\"drupal\";a:17:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Automated Cron\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:7:\"project\";s:6:\"drupal\";s:16:\"_info_file_ctime\";i:1539669628;s:9:\"datestamp\";i:0;}s:9:\"datestamp\";i:0;s:8:\"includes\";a:50:{s:14:\"automated_cron\";s:14:\"Automated Cron\";s:8:\"big_pipe\";s:7:\"BigPipe\";s:5:\"block\";s:5:\"Block\";s:13:\"block_content\";s:12:\"Custom Block\";s:10:\"breakpoint\";s:10:\"Breakpoint\";s:8:\"ckeditor\";s:8:\"CKEditor\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:6:\"config\";s:21:\"Configuration Manager\";s:7:\"contact\";s:7:\"Contact\";s:18:\"content_moderation\";s:18:\"Content Moderation\";s:10:\"contextual\";s:16:\"Contextual Links\";s:8:\"datetime\";s:8:\"Datetime\";s:5:\"dblog\";s:16:\"Database Logging\";s:18:\"dynamic_page_cache\";s:27:\"Internal Dynamic Page Cache\";s:6:\"editor\";s:11:\"Text Editor\";s:5:\"field\";s:5:\"Field\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:4:\"help\";s:4:\"Help\";s:7:\"history\";s:7:\"History\";s:5:\"image\";s:5:\"Image\";s:4:\"link\";s:4:\"Link\";s:17:\"menu_link_content\";s:17:\"Custom Menu Links\";s:7:\"menu_ui\";s:7:\"Menu UI\";s:7:\"migrate\";s:7:\"Migrate\";s:14:\"migrate_drupal\";s:14:\"Migrate Drupal\";s:27:\"migrate_drupal_multilingual\";s:27:\"Migrate Drupal Multilingual\";s:17:\"migrate_drupal_ui\";s:17:\"Migrate Drupal UI\";s:4:\"node\";s:4:\"Node\";s:7:\"options\";s:7:\"Options\";s:10:\"page_cache\";s:19:\"Internal Page Cache\";s:4:\"path\";s:4:\"Path\";s:9:\"quickedit\";s:10:\"Quick Edit\";s:3:\"rdf\";s:3:\"RDF\";s:4:\"rest\";s:20:\"RESTful Web Services\";s:6:\"search\";s:6:\"Search\";s:13:\"serialization\";s:13:\"Serialization\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:7:\"toolbar\";s:7:\"Toolbar\";s:4:\"tour\";s:4:\"Tour\";s:6:\"update\";s:14:\"Update Manager\";s:4:\"user\";s:4:\"User\";s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";s:9:\"workflows\";s:9:\"Workflows\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:5:\"8.6.1\";s:14:\"existing_major\";s:1:\"8\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Drupal core\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:14:\"latest_version\";s:5:\"8.6.2\";s:8:\"releases\";a:2:{s:5:\"8.6.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.2\";s:7:\"version\";s:5:\"8.6.2\";s:3:\"tag\";s:5:\"8.6.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.2.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"46a42d70047dafd4b05e3dd050cea887\";s:8:\"filesize\";s:8:\"16240694\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.7.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.7.x-dev\";s:7:\"version\";s:9:\"8.7.x-dev\";s:3:\"tag\";s:5:\"8.7.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.7.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.7.x-dev.tar.gz\";s:4:\"date\";s:10:\"1540204981\";s:6:\"mdhash\";s:32:\"6baf799022611f3e7f26c90a999d9498\";s:8:\"filesize\";s:8:\"20577693\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:5:\"8.6.2\";s:16:\"security updates\";a:2:{i:0;a:15:{s:4:\"name\";s:12:\"drupal 8.6.2\";s:7:\"version\";s:5:\"8.6.2\";s:3:\"tag\";s:5:\"8.6.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.2.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"46a42d70047dafd4b05e3dd050cea887\";s:8:\"filesize\";s:8:\"16240694\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}i:1;a:15:{s:4:\"name\";s:12:\"drupal 8.5.8\";s:7:\"version\";s:5:\"8.5.8\";s:3:\"tag\";s:5:\"8.5.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.8.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"9642e018a0b0ed7bd8a3472fa0b64ccd\";s:8:\"filesize\";s:8:\"15794648\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:6:\"status\";i:1;s:11:\"dev_version\";s:9:\"8.7.x-dev\";}s:10:\"ga_reports\";a:16:{s:4:\"name\";s:10:\"ga_reports\";s:4:\"info\";a:6:{s:4:\"name\";s:31:\"Xelium Google Analytics Reports\";s:7:\"package\";s:10:\"Statistics\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:7:\"project\";s:10:\"ga_reports\";s:9:\"datestamp\";i:1539083044;s:16:\"_info_file_ctime\";i:1539669617;}s:9:\"datestamp\";i:1539083044;s:8:\"includes\";a:1:{s:10:\"ga_reports\";s:31:\"Xelium Google Analytics Reports\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:13:\"8.x-1.0-beta1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"GA Reports\";s:4:\"link\";s:41:\"https://www.drupal.org/project/ga_reports\";s:14:\"latest_version\";s:11:\"8.x-1.x-dev\";s:8:\"releases\";a:1:{s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"ga_reports 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ga_reports/releases/8.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ga_reports-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1539683884\";s:6:\"mdhash\";s:32:\"54042685b16c2b0bd77b965b82755801\";s:8:\"filesize\";s:5:\"37428\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:11:\"dev_version\";s:11:\"8.x-1.x-dev\";s:11:\"recommended\";s:11:\"8.x-1.x-dev\";s:6:\"status\";i:4;}s:13:\"admin_toolbar\";a:15:{s:4:\"name\";s:13:\"admin_toolbar\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Admin Toolbar\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:8:\"8.x-1.24\";s:7:\"project\";s:13:\"admin_toolbar\";s:9:\"datestamp\";i:1527522484;s:16:\"_info_file_ctime\";i:1539669617;}s:9:\"datestamp\";i:1527522484;s:8:\"includes\";a:1:{s:13:\"admin_toolbar\";s:13:\"Admin Toolbar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:8:\"8.x-1.24\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Admin Toolbar\";s:4:\"link\";s:44:\"https://www.drupal.org/project/admin_toolbar\";s:14:\"latest_version\";s:8:\"8.x-1.24\";s:8:\"releases\";a:1:{s:8:\"8.x-1.24\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.24\";s:7:\"version\";s:8:\"8.x-1.24\";s:3:\"tag\";s:8:\"8.x-1.24\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.24\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.24.tar.gz\";s:4:\"date\";s:10:\"1527522480\";s:6:\"mdhash\";s:32:\"90f0c3552293b49a5d5c83ea2c0d7ed9\";s:8:\"filesize\";s:5:\"28647\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"8.x-1.24\";s:6:\"status\";i:5;}s:11:\"block_class\";a:11:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";i:1531440825;s:16:\"_info_file_ctime\";i:1540189886;}s:9:\"datestamp\";i:1531440825;s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:6:\"status\";i:-2;s:6:\"reason\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"No available releases found\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}}s:13:\"contact_block\";a:15:{s:4:\"name\";s:13:\"contact_block\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Contact Block\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"8.x-1.4\";s:7:\"project\";s:13:\"contact_block\";s:9:\"datestamp\";i:1493036946;s:16:\"_info_file_ctime\";i:1540208608;}s:9:\"datestamp\";i:1493036946;s:8:\"includes\";a:1:{s:13:\"contact_block\";s:13:\"Contact Block\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.4\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Contact Block\";s:4:\"link\";s:44:\"https://www.drupal.org/project/contact_block\";s:14:\"latest_version\";s:7:\"8.x-1.4\";s:8:\"releases\";a:1:{s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:21:\"contact_block 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/contact_block/releases/8.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/contact_block-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1493036943\";s:6:\"mdhash\";s:32:\"1b11308c29b35bed565bcdcf989fbe4c\";s:8:\"filesize\";s:5:\"10160\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.4\";s:6:\"status\";i:5;}s:5:\"devel\";a:15:{s:4:\"name\";s:5:\"devel\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Devel\";s:7:\"package\";s:11:\"Development\";s:7:\"version\";s:7:\"8.x-1.2\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";i:1507197848;s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1507197848;s:8:\"includes\";a:3:{s:5:\"devel\";s:5:\"Devel\";s:14:\"devel_generate\";s:14:\"Devel generate\";s:4:\"kint\";s:10:\"Devel Kint\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Devel\";s:4:\"link\";s:36:\"https://www.drupal.org/project/devel\";s:14:\"latest_version\";s:7:\"8.x-1.2\";s:8:\"releases\";a:1:{s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:13:\"devel 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/8.x-1.2\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1507197844\";s:6:\"mdhash\";s:32:\"2e43e3f78d37fbe5de88966414867c22\";s:8:\"filesize\";s:6:\"230684\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-1.2\";s:6:\"status\";i:5;}s:6:\"entity\";a:15:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Entity\";s:7:\"version\";s:13:\"8.x-1.0-beta4\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";i:1528452194;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1528452194;s:8:\"includes\";a:1:{s:6:\"entity\";s:6:\"Entity\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:13:\"8.x-1.0-beta4\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Entity API\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:14:\"latest_version\";s:11:\"8.x-1.0-rc1\";s:8:\"releases\";a:1:{s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:18:\"entity 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1539272580\";s:6:\"mdhash\";s:32:\"e8531123563e45cee816f4e3ac8a39c3\";s:8:\"filesize\";s:5:\"50152\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:11:\"8.x-1.0-rc1\";s:6:\"status\";i:4;}s:12:\"migrate_plus\";a:15:{s:4:\"name\";s:12:\"migrate_plus\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"Migrate Plus\";s:7:\"package\";s:9:\"Migration\";s:7:\"version\";s:11:\"8.x-4.0-rc1\";s:7:\"project\";s:12:\"migrate_plus\";s:9:\"datestamp\";i:1535381293;s:16:\"_info_file_ctime\";i:1539669617;}s:9:\"datestamp\";i:1535381293;s:8:\"includes\";a:1:{s:12:\"migrate_plus\";s:12:\"Migrate Plus\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-4.0-rc1\";s:14:\"existing_major\";s:1:\"4\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:12:\"Migrate Plus\";s:4:\"link\";s:43:\"https://www.drupal.org/project/migrate_plus\";s:14:\"latest_version\";s:7:\"8.x-4.0\";s:8:\"releases\";a:1:{s:7:\"8.x-4.0\";a:14:{s:4:\"name\";s:20:\"migrate_plus 8.x-4.0\";s:7:\"version\";s:7:\"8.x-4.0\";s:3:\"tag\";s:7:\"8.x-4.0\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/migrate_plus/releases/8.x-4.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-4.0.tar.gz\";s:4:\"date\";s:10:\"1536264180\";s:6:\"mdhash\";s:32:\"6262276f7225ffae8a33f1f8ed4c461e\";s:8:\"filesize\";s:5:\"71381\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}}s:11:\"recommended\";s:7:\"8.x-4.0\";s:6:\"status\";i:4;}s:13:\"migrate_tools\";a:15:{s:4:\"name\";s:13:\"migrate_tools\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Migrate Tools\";s:7:\"package\";s:9:\"Migration\";s:7:\"version\";s:7:\"8.x-4.0\";s:7:\"project\";s:13:\"migrate_tools\";s:9:\"datestamp\";i:1535380087;s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1535380087;s:8:\"includes\";a:1:{s:13:\"migrate_tools\";s:13:\"Migrate Tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:7:\"8.x-4.0\";s:14:\"existing_major\";s:1:\"4\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Migrate Tools\";s:4:\"link\";s:44:\"https://www.drupal.org/project/migrate_tools\";s:14:\"latest_version\";s:7:\"8.x-4.0\";s:8:\"releases\";a:1:{s:7:\"8.x-4.0\";a:14:{s:4:\"name\";s:21:\"migrate_tools 8.x-4.0\";s:7:\"version\";s:7:\"8.x-4.0\";s:3:\"tag\";s:7:\"8.x-4.0\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/migrate_tools/releases/8.x-4.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-4.0.tar.gz\";s:4:\"date\";s:10:\"1535380084\";s:6:\"mdhash\";s:32:\"a12f7698a3b8df73976fdba5c98cf555\";s:8:\"filesize\";s:5:\"39510\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"8.x-4.0\";s:6:\"status\";i:5;}s:15:\"migrate_upgrade\";a:15:{s:4:\"name\";s:15:\"migrate_upgrade\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Drupal Upgrade\";s:7:\"package\";s:9:\"Migration\";s:7:\"version\";s:11:\"8.x-3.0-rc5\";s:7:\"project\";s:15:\"migrate_upgrade\";s:9:\"datestamp\";i:1535381590;s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1535381590;s:8:\"includes\";a:1:{s:15:\"migrate_upgrade\";s:14:\"Drupal Upgrade\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-3.0-rc5\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Migrate Upgrade\";s:4:\"link\";s:46:\"https://www.drupal.org/project/migrate_upgrade\";s:14:\"latest_version\";s:11:\"8.x-3.0-rc5\";s:8:\"releases\";a:1:{s:11:\"8.x-3.0-rc5\";a:15:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-3.0-rc5\";s:7:\"version\";s:11:\"8.x-3.0-rc5\";s:3:\"tag\";s:11:\"8.x-3.0-rc5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.0-rc5\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1535381580\";s:6:\"mdhash\";s:32:\"bccdc054440da462299db175608d8c0e\";s:8:\"filesize\";s:5:\"17272\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:11:\"8.x-3.0-rc5\";s:6:\"status\";i:5;}s:7:\"justice\";a:12:{s:4:\"name\";s:7:\"justice\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"justice\";s:7:\"package\";s:7:\"theming\";s:7:\"version\";s:11:\"8.x-5.x-dev\";s:7:\"project\";s:7:\"justice\";s:9:\"datestamp\";i:1526042904;s:16:\"_info_file_ctime\";i:1540291313;}s:9:\"datestamp\";i:1526042904;s:8:\"includes\";a:1:{s:7:\"justice\";s:7:\"justice\";}s:12:\"project_type\";s:5:\"theme\";s:14:\"project_status\";b:1;s:16:\"existing_version\";s:11:\"8.x-5.x-dev\";s:14:\"existing_major\";s:1:\"5\";s:12:\"install_type\";s:3:\"dev\";s:6:\"status\";i:-4;s:6:\"reason\";O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"No available update data\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}s:12:\"fetch_status\";i:-4;}}',1540297212),('update','update_project_projects',_binary 'a:11:{s:6:\"drupal\";a:6:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Automated Cron\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:5:\"8.6.1\";s:7:\"project\";s:6:\"drupal\";s:16:\"_info_file_ctime\";i:1539669628;s:9:\"datestamp\";i:0;}s:9:\"datestamp\";i:0;s:8:\"includes\";a:50:{s:14:\"automated_cron\";s:14:\"Automated Cron\";s:8:\"big_pipe\";s:7:\"BigPipe\";s:5:\"block\";s:5:\"Block\";s:13:\"block_content\";s:12:\"Custom Block\";s:10:\"breakpoint\";s:10:\"Breakpoint\";s:8:\"ckeditor\";s:8:\"CKEditor\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:6:\"config\";s:21:\"Configuration Manager\";s:7:\"contact\";s:7:\"Contact\";s:18:\"content_moderation\";s:18:\"Content Moderation\";s:10:\"contextual\";s:16:\"Contextual Links\";s:8:\"datetime\";s:8:\"Datetime\";s:5:\"dblog\";s:16:\"Database Logging\";s:18:\"dynamic_page_cache\";s:27:\"Internal Dynamic Page Cache\";s:6:\"editor\";s:11:\"Text Editor\";s:5:\"field\";s:5:\"Field\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:4:\"help\";s:4:\"Help\";s:7:\"history\";s:7:\"History\";s:5:\"image\";s:5:\"Image\";s:4:\"link\";s:4:\"Link\";s:17:\"menu_link_content\";s:17:\"Custom Menu Links\";s:7:\"menu_ui\";s:7:\"Menu UI\";s:7:\"migrate\";s:7:\"Migrate\";s:14:\"migrate_drupal\";s:14:\"Migrate Drupal\";s:27:\"migrate_drupal_multilingual\";s:27:\"Migrate Drupal Multilingual\";s:17:\"migrate_drupal_ui\";s:17:\"Migrate Drupal UI\";s:4:\"node\";s:4:\"Node\";s:7:\"options\";s:7:\"Options\";s:10:\"page_cache\";s:19:\"Internal Page Cache\";s:4:\"path\";s:4:\"Path\";s:9:\"quickedit\";s:10:\"Quick Edit\";s:3:\"rdf\";s:3:\"RDF\";s:4:\"rest\";s:20:\"RESTful Web Services\";s:6:\"search\";s:6:\"Search\";s:13:\"serialization\";s:13:\"Serialization\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:7:\"toolbar\";s:7:\"Toolbar\";s:4:\"tour\";s:4:\"Tour\";s:6:\"update\";s:14:\"Update Manager\";s:4:\"user\";s:4:\"User\";s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";s:9:\"workflows\";s:9:\"Workflows\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;}s:10:\"ga_reports\";a:6:{s:4:\"name\";s:10:\"ga_reports\";s:4:\"info\";a:6:{s:4:\"name\";s:31:\"Xelium Google Analytics Reports\";s:7:\"package\";s:10:\"Statistics\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:7:\"project\";s:10:\"ga_reports\";s:9:\"datestamp\";i:1539083044;s:16:\"_info_file_ctime\";i:1539669617;}s:9:\"datestamp\";i:1539083044;s:8:\"includes\";a:1:{s:10:\"ga_reports\";s:31:\"Xelium Google Analytics Reports\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:13:\"admin_toolbar\";a:6:{s:4:\"name\";s:13:\"admin_toolbar\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Admin Toolbar\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:8:\"8.x-1.24\";s:7:\"project\";s:13:\"admin_toolbar\";s:9:\"datestamp\";i:1527522484;s:16:\"_info_file_ctime\";i:1539669617;}s:9:\"datestamp\";i:1527522484;s:8:\"includes\";a:1:{s:13:\"admin_toolbar\";s:13:\"Admin Toolbar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:11:\"block_class\";a:6:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";i:1531440825;s:16:\"_info_file_ctime\";i:1540189886;}s:9:\"datestamp\";i:1531440825;s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:13:\"contact_block\";a:6:{s:4:\"name\";s:13:\"contact_block\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Contact Block\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"8.x-1.4\";s:7:\"project\";s:13:\"contact_block\";s:9:\"datestamp\";i:1493036946;s:16:\"_info_file_ctime\";i:1540208608;}s:9:\"datestamp\";i:1493036946;s:8:\"includes\";a:1:{s:13:\"contact_block\";s:13:\"Contact Block\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:5:\"devel\";a:6:{s:4:\"name\";s:5:\"devel\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Devel\";s:7:\"package\";s:11:\"Development\";s:7:\"version\";s:7:\"8.x-1.2\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";i:1507197848;s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1507197848;s:8:\"includes\";a:3:{s:5:\"devel\";s:5:\"Devel\";s:14:\"devel_generate\";s:14:\"Devel generate\";s:4:\"kint\";s:10:\"Devel Kint\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:6:\"entity\";a:6:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Entity\";s:7:\"version\";s:13:\"8.x-1.0-beta4\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";i:1528452194;s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1528452194;s:8:\"includes\";a:1:{s:6:\"entity\";s:6:\"Entity\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:12:\"migrate_plus\";a:6:{s:4:\"name\";s:12:\"migrate_plus\";s:4:\"info\";a:6:{s:4:\"name\";s:12:\"Migrate Plus\";s:7:\"package\";s:9:\"Migration\";s:7:\"version\";s:11:\"8.x-4.0-rc1\";s:7:\"project\";s:12:\"migrate_plus\";s:9:\"datestamp\";i:1535381293;s:16:\"_info_file_ctime\";i:1539669617;}s:9:\"datestamp\";i:1535381293;s:8:\"includes\";a:1:{s:12:\"migrate_plus\";s:12:\"Migrate Plus\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:13:\"migrate_tools\";a:6:{s:4:\"name\";s:13:\"migrate_tools\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Migrate Tools\";s:7:\"package\";s:9:\"Migration\";s:7:\"version\";s:7:\"8.x-4.0\";s:7:\"project\";s:13:\"migrate_tools\";s:9:\"datestamp\";i:1535380087;s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1535380087;s:8:\"includes\";a:1:{s:13:\"migrate_tools\";s:13:\"Migrate Tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:15:\"migrate_upgrade\";a:6:{s:4:\"name\";s:15:\"migrate_upgrade\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Drupal Upgrade\";s:7:\"package\";s:9:\"Migration\";s:7:\"version\";s:11:\"8.x-3.0-rc5\";s:7:\"project\";s:15:\"migrate_upgrade\";s:9:\"datestamp\";i:1535381590;s:16:\"_info_file_ctime\";i:1539669618;}s:9:\"datestamp\";i:1535381590;s:8:\"includes\";a:1:{s:15:\"migrate_upgrade\";s:14:\"Drupal Upgrade\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}s:7:\"justice\";a:6:{s:4:\"name\";s:7:\"justice\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"justice\";s:7:\"package\";s:7:\"theming\";s:7:\"version\";s:11:\"8.x-5.x-dev\";s:7:\"project\";s:7:\"justice\";s:9:\"datestamp\";i:1526042904;s:16:\"_info_file_ctime\";i:1540291313;}s:9:\"datestamp\";i:1526042904;s:8:\"includes\";a:1:{s:7:\"justice\";s:7:\"justice\";}s:12:\"project_type\";s:5:\"theme\";s:14:\"project_status\";b:1;}}',1540297212),('update_available_releases','admin_toolbar',_binary 'a:12:{s:5:\"title\";s:13:\"Admin Toolbar\";s:10:\"short_name\";s:13:\"admin_toolbar\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/admin_toolbar\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:26:{s:8:\"8.x-1.24\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.24\";s:7:\"version\";s:8:\"8.x-1.24\";s:3:\"tag\";s:8:\"8.x-1.24\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.24\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.24.tar.gz\";s:4:\"date\";s:10:\"1527522480\";s:6:\"mdhash\";s:32:\"90f0c3552293b49a5d5c83ea2c0d7ed9\";s:8:\"filesize\";s:5:\"28647\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.23\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.23\";s:7:\"version\";s:8:\"8.x-1.23\";s:3:\"tag\";s:8:\"8.x-1.23\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.23\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.23.tar.gz\";s:4:\"date\";s:10:\"1517936581\";s:6:\"mdhash\";s:32:\"e41453b57d5c4a674f1e0b3ef32e5f43\";s:8:\"filesize\";s:5:\"27642\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.22\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.22\";s:7:\"version\";s:8:\"8.x-1.22\";s:3:\"tag\";s:8:\"8.x-1.22\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.22\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.22.tar.gz\";s:4:\"date\";s:10:\"1514888585\";s:6:\"mdhash\";s:32:\"577c1c22202d7a96b4111be0a5345a6d\";s:8:\"filesize\";s:5:\"27919\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.21\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.21\";s:7:\"version\";s:8:\"8.x-1.21\";s:3:\"tag\";s:8:\"8.x-1.21\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.21\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.21.tar.gz\";s:4:\"date\";s:10:\"1511190785\";s:6:\"mdhash\";s:32:\"18fa6c2ee3188e88decb0f87f3d63017\";s:8:\"filesize\";s:5:\"28430\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.20\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.20\";s:7:\"version\";s:8:\"8.x-1.20\";s:3:\"tag\";s:8:\"8.x-1.20\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.20\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.20.tar.gz\";s:4:\"date\";s:10:\"1505199844\";s:6:\"mdhash\";s:32:\"9aea30bce87ba104ae5866cea15be36a\";s:8:\"filesize\";s:5:\"20056\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.19\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.19\";s:7:\"version\";s:8:\"8.x-1.19\";s:3:\"tag\";s:8:\"8.x-1.19\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.19\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.19.tar.gz\";s:4:\"date\";s:10:\"1491487683\";s:6:\"mdhash\";s:32:\"285aa36877c62fd0ef7fdd13e0f374f6\";s:8:\"filesize\";s:5:\"17480\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.18\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.18\";s:7:\"version\";s:8:\"8.x-1.18\";s:3:\"tag\";s:8:\"8.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.18\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1480614184\";s:6:\"mdhash\";s:32:\"1d8c9725b32542175c061e90a46ae136\";s:8:\"filesize\";s:5:\"17333\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.17\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.17\";s:7:\"version\";s:8:\"8.x-1.17\";s:3:\"tag\";s:8:\"8.x-1.17\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.17\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.17.tar.gz\";s:4:\"date\";s:10:\"1472585039\";s:6:\"mdhash\";s:32:\"7927faff05a639b9f060f3ac9d876325\";s:8:\"filesize\";s:5:\"17298\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.16\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.16\";s:7:\"version\";s:8:\"8.x-1.16\";s:3:\"tag\";s:8:\"8.x-1.16\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.16\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.16.tar.gz\";s:4:\"date\";s:10:\"1469715839\";s:6:\"mdhash\";s:32:\"ed4987fe25797d0eb3169e0796edad4c\";s:8:\"filesize\";s:5:\"56888\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.15\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.15\";s:7:\"version\";s:8:\"8.x-1.15\";s:3:\"tag\";s:8:\"8.x-1.15\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.15\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.15.tar.gz\";s:4:\"date\";s:10:\"1464016832\";s:6:\"mdhash\";s:32:\"be65f31814b05a7206a055ec3a770cac\";s:8:\"filesize\";s:5:\"56304\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.14\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.14\";s:7:\"version\";s:8:\"8.x-1.14\";s:3:\"tag\";s:8:\"8.x-1.14\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.14\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.14.tar.gz\";s:4:\"date\";s:10:\"1454942939\";s:6:\"mdhash\";s:32:\"a6279a5c0abef11bbaffed25ee2ff64c\";s:8:\"filesize\";s:5:\"55563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.13\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.13\";s:7:\"version\";s:8:\"8.x-1.13\";s:3:\"tag\";s:8:\"8.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.13\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1454405939\";s:6:\"mdhash\";s:32:\"105229e87e356865adb7230c5f6a0c71\";s:8:\"filesize\";s:5:\"55578\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.12\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.12\";s:7:\"version\";s:8:\"8.x-1.12\";s:3:\"tag\";s:8:\"8.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.12\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1454402339\";s:6:\"mdhash\";s:32:\"e95e8b66c6a9764bdf0a298fc57cf647\";s:8:\"filesize\";s:5:\"54209\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.11\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.11\";s:7:\"version\";s:8:\"8.x-1.11\";s:3:\"tag\";s:8:\"8.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.11\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1449833341\";s:6:\"mdhash\";s:32:\"42d44819ed5814df82424bae93673ec8\";s:8:\"filesize\";s:5:\"53738\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"8.x-1.10\";a:14:{s:4:\"name\";s:22:\"admin_toolbar 8.x-1.10\";s:7:\"version\";s:8:\"8.x-1.10\";s:3:\"tag\";s:8:\"8.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.10\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1445350439\";s:6:\"mdhash\";s:32:\"8f9ece0f632a05f4fd27cf5d5625d584\";s:8:\"filesize\";s:5:\"53195\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.9\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.9\";s:7:\"version\";s:7:\"8.x-1.9\";s:3:\"tag\";s:7:\"8.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.9\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1438248239\";s:6:\"mdhash\";s:32:\"df66ec9d7f5a883d254959dafe20b2cc\";s:8:\"filesize\";s:5:\"53178\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.8\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.8\";s:7:\"version\";s:7:\"8.x-1.8\";s:3:\"tag\";s:7:\"8.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.8\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1437400139\";s:6:\"mdhash\";s:32:\"6c02ba9325a609f21f8ff5d9d81ac43d\";s:8:\"filesize\";s:5:\"55024\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.7\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.7\";s:7:\"version\";s:7:\"8.x-1.7\";s:3:\"tag\";s:7:\"8.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1434972483\";s:6:\"mdhash\";s:32:\"f67f8e5bb956a265b36cc630972bbbbc\";s:8:\"filesize\";s:5:\"55033\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.6\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.6\";s:7:\"version\";s:7:\"8.x-1.6\";s:3:\"tag\";s:7:\"8.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1433331481\";s:6:\"mdhash\";s:32:\"75d94008fd65df0285a0a8a77bdf43ca\";s:8:\"filesize\";s:5:\"54544\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.5\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.5\";s:7:\"version\";s:7:\"8.x-1.5\";s:3:\"tag\";s:7:\"8.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1433329681\";s:6:\"mdhash\";s:32:\"917b4da157022c27304e3f5d14acc196\";s:8:\"filesize\";s:5:\"54555\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1432141381\";s:6:\"mdhash\";s:32:\"009fbd126930d4743dc7b8e666bdfe2d\";s:8:\"filesize\";s:5:\"54164\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1432129285\";s:6:\"mdhash\";s:32:\"ceba69c98e70a4554ee328cdcba0f167\";s:8:\"filesize\";s:5:\"54186\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1432129285\";s:6:\"mdhash\";s:32:\"53d90b123cc2e5c44f5233b91fdb6cf0\";s:8:\"filesize\";s:5:\"54184\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1432048381\";s:6:\"mdhash\";s:32:\"251d1ba9c6bf596ceefaaaab12f5ab2a\";s:8:\"filesize\";s:5:\"54382\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:21:\"admin_toolbar 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1431018181\";s:6:\"mdhash\";s:32:\"f3612aa4b0e10f9a064f01babfc1c0b5\";s:8:\"filesize\";s:5:\"51544\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"admin_toolbar 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/admin_toolbar/releases/8.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/admin_toolbar-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1537883280\";s:6:\"mdhash\";s:32:\"05a705e8939bde16e26ac0ac07820f0d\";s:8:\"filesize\";s:5:\"28826\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1540283842;}',1540370242),('update_available_releases','block_class',_binary 'a:12:{s:5:\"title\";s:11:\"Block Class\";s:10:\"short_name\";s:11:\"block_class\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/block_class\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:3:{s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:19:\"block_class 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/8.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1531440821\";s:6:\"mdhash\";s:32:\"26061ade0f8e41d01d7458eaeededc23\";s:8:\"filesize\";s:5:\"10030\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:26:\"block_class 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/block_class/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/block_class-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1475623439\";s:6:\"mdhash\";s:32:\"74200c27a48432fc3f5857454cc9411e\";s:8:\"filesize\";s:4:\"8794\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"block_class 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/block_class/releases/8.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/block_class-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1538522580\";s:6:\"mdhash\";s:32:\"44ba1a9463a91a1380f432721817f57f\";s:8:\"filesize\";s:5:\"10061\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1540197541;}',1540283941),('update_available_releases','contact_block',_binary 'a:12:{s:5:\"title\";s:13:\"Contact Block\";s:10:\"short_name\";s:13:\"contact_block\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/contact_block\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:7:\"8.x-1.4\";a:14:{s:4:\"name\";s:21:\"contact_block 8.x-1.4\";s:7:\"version\";s:7:\"8.x-1.4\";s:3:\"tag\";s:7:\"8.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/contact_block/releases/8.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/contact_block-8.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1493036943\";s:6:\"mdhash\";s:32:\"1b11308c29b35bed565bcdcf989fbe4c\";s:8:\"filesize\";s:5:\"10160\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.3\";a:14:{s:4:\"name\";s:21:\"contact_block 8.x-1.3\";s:7:\"version\";s:7:\"8.x-1.3\";s:3:\"tag\";s:7:\"8.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/contact_block/releases/8.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/contact_block-8.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1481007784\";s:6:\"mdhash\";s:32:\"fae6c889fbc2fa7c0c1f90bd2b7f92c3\";s:8:\"filesize\";s:5:\"10130\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:21:\"contact_block 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/contact_block/releases/8.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/contact_block-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1464603239\";s:6:\"mdhash\";s:32:\"9aecd15244fcefed266ec5c5f96e7f85\";s:8:\"filesize\";s:4:\"9810\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:21:\"contact_block 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/contact_block/releases/8.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/contact_block-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1447085939\";s:6:\"mdhash\";s:32:\"c752558afa6716899898a605149c7783\";s:8:\"filesize\";s:4:\"9693\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:21:\"contact_block 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/contact_block/releases/8.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/contact_block-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1446470339\";s:6:\"mdhash\";s:32:\"0fe48013a47bc434347c7a9040abbcdc\";s:8:\"filesize\";s:4:\"8971\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"contact_block 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/contact_block/releases/8.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/contact_block-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1521190384\";s:6:\"mdhash\";s:32:\"0b8d92b811b9a2ecb61b398c8fe146c0\";s:8:\"filesize\";s:5:\"10156\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1540270599;}',1540356999),('update_available_releases','cowork',_binary 'a:1:{s:10:\"last_fetch\";i:1540283845;}',1540370245),('update_available_releases','devel',_binary 'a:12:{s:5:\"title\";s:5:\"Devel\";s:10:\"short_name\";s:5:\"devel\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/devel\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:8:{s:7:\"8.x-1.2\";a:14:{s:4:\"name\";s:13:\"devel 8.x-1.2\";s:7:\"version\";s:7:\"8.x-1.2\";s:3:\"tag\";s:7:\"8.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/8.x-1.2\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-8.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1507197844\";s:6:\"mdhash\";s:32:\"2e43e3f78d37fbe5de88966414867c22\";s:8:\"filesize\";s:6:\"230684\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.1\";a:14:{s:4:\"name\";s:13:\"devel 8.x-1.1\";s:7:\"version\";s:7:\"8.x-1.1\";s:3:\"tag\";s:7:\"8.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/8.x-1.1\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-8.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1507195143\";s:6:\"mdhash\";s:32:\"de948273b54e5ca5236b9ed06da42f6e\";s:8:\"filesize\";s:6:\"230706\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:13:\"devel 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/devel/releases/8.x-1.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1502732044\";s:6:\"mdhash\";s:32:\"7e66dfa095003c3fe3ffff51bc9e7ac3\";s:8:\"filesize\";s:6:\"231010\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.0-rc2\";a:15:{s:4:\"name\";s:17:\"devel 8.x-1.0-rc2\";s:7:\"version\";s:11:\"8.x-1.0-rc2\";s:3:\"tag\";s:11:\"8.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/8.x-1.0-rc2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1492989244\";s:6:\"mdhash\";s:32:\"3fb7787ae517aee72b2b50c152a8fea7\";s:8:\"filesize\";s:6:\"224806\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:17:\"devel 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1484837884\";s:6:\"mdhash\";s:32:\"fbe2662a425e20b16dd2b505fbc64ede\";s:8:\"filesize\";s:6:\"223924\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:19:\"devel 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/devel/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1480796583\";s:6:\"mdhash\";s:32:\"f5500c66cb0deb4ebaf6cdb82b68dc1d\";s:8:\"filesize\";s:6:\"209615\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:20:\"devel 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/devel/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/devel-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1466777163\";s:6:\"mdhash\";s:32:\"88747fd4b074c0440cfe9c53b3f4f801\";s:8:\"filesize\";s:6:\"224157\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:17:\"devel 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/devel/releases/8.x-1.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/devel-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1539845580\";s:6:\"mdhash\";s:32:\"c2369f9d972cd8bcae1b4e76ab8d35fd\";s:8:\"filesize\";s:6:\"234028\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1540283843;}',1540370243),('update_available_releases','drupal',_binary 'a:12:{s:5:\"title\";s:11:\"Drupal core\";s:10:\"short_name\";s:6:\"drupal\";s:4:\"type\";s:12:\"project_core\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"8\";s:16:\"supported_majors\";s:1:\"8\";s:13:\"default_major\";s:1:\"8\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:121:{s:5:\"8.6.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.2\";s:7:\"version\";s:5:\"8.6.2\";s:3:\"tag\";s:5:\"8.6.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.2.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"46a42d70047dafd4b05e3dd050cea887\";s:8:\"filesize\";s:8:\"16240694\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.1\";s:7:\"version\";s:5:\"8.6.1\";s:3:\"tag\";s:5:\"8.6.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.1.tar.gz\";s:4:\"date\";s:10:\"1536585780\";s:6:\"mdhash\";s:32:\"fad034b129695c5066e892cd7cb02a11\";s:8:\"filesize\";s:8:\"16236559\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.6.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.6.0\";s:7:\"version\";s:5:\"8.6.0\";s:3:\"tag\";s:5:\"8.6.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.6.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.6.0.tar.gz\";s:4:\"date\";s:10:\"1536186480\";s:6:\"mdhash\";s:32:\"6d457c7e478574a5125f608f3d6b7fa5\";s:8:\"filesize\";s:8:\"16233161\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.6.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.6.0-rc1\";s:7:\"version\";s:9:\"8.6.0-rc1\";s:3:\"tag\";s:9:\"8.6.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.6.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1534532580\";s:6:\"mdhash\";s:32:\"5e842303187242e79b766a36160c0389\";s:8:\"filesize\";s:8:\"16230072\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.6.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.6.0-beta2\";s:7:\"version\";s:11:\"8.6.0-beta2\";s:3:\"tag\";s:11:\"8.6.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.6.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1533298080\";s:6:\"mdhash\";s:32:\"2387284145e34a19fc45e03c258a2831\";s:8:\"filesize\";s:8:\"16209911\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.6.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.6.0-beta1\";s:7:\"version\";s:11:\"8.6.0-beta1\";s:3:\"tag\";s:11:\"8.6.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.6.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1533270485\";s:6:\"mdhash\";s:32:\"3d70ae568dd8f7100082b8c58bc8d1fe\";s:8:\"filesize\";s:8:\"16209123\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.6.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.6.0-alpha1\";s:7:\"version\";s:12:\"8.6.0-alpha1\";s:3:\"tag\";s:12:\"8.6.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.6.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.6.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1532033881\";s:6:\"mdhash\";s:32:\"15cda0cacdf2287dfa44649d3fc590ef\";s:8:\"filesize\";s:8:\"16089229\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:5:\"8.5.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.8\";s:7:\"version\";s:5:\"8.5.8\";s:3:\"tag\";s:5:\"8.5.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.8.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"9642e018a0b0ed7bd8a3472fa0b64ccd\";s:8:\"filesize\";s:8:\"15794648\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.7\";s:7:\"version\";s:5:\"8.5.7\";s:3:\"tag\";s:5:\"8.5.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.7.tar.gz\";s:4:\"date\";s:10:\"1536187080\";s:6:\"mdhash\";s:32:\"a5f35336995ed209a917a4370e0c34d7\";s:8:\"filesize\";s:8:\"15797062\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.6\";s:7:\"version\";s:5:\"8.5.6\";s:3:\"tag\";s:5:\"8.5.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.6.tar.gz\";s:4:\"date\";s:10:\"1533156780\";s:6:\"mdhash\";s:32:\"1e789adb03cf2a82a9c3bced67c02328\";s:8:\"filesize\";s:8:\"15789509\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.5\";s:7:\"version\";s:5:\"8.5.5\";s:3:\"tag\";s:5:\"8.5.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.5.tar.gz\";s:4:\"date\";s:10:\"1530738820\";s:6:\"mdhash\";s:32:\"4fee1348bbac85cae82d6634e7296b9f\";s:8:\"filesize\";s:8:\"15786935\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.4\";s:7:\"version\";s:5:\"8.5.4\";s:3:\"tag\";s:5:\"8.5.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.4.tar.gz\";s:4:\"date\";s:10:\"1528319584\";s:6:\"mdhash\";s:32:\"4237ee4c5384bd90ed8dc4fa0ed3bb0c\";s:8:\"filesize\";s:8:\"15779939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.3\";s:7:\"version\";s:5:\"8.5.3\";s:3:\"tag\";s:5:\"8.5.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.3.tar.gz\";s:4:\"date\";s:10:\"1524672780\";s:6:\"mdhash\";s:32:\"aedc6598b71c5393d30242b8e14385e5\";s:8:\"filesize\";s:8:\"15527015\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.2\";s:7:\"version\";s:5:\"8.5.2\";s:3:\"tag\";s:5:\"8.5.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.2.tar.gz\";s:4:\"date\";s:10:\"1524073147\";s:6:\"mdhash\";s:32:\"c85c6ec800100d458fad6b9469e2fd8b\";s:8:\"filesize\";s:8:\"15527091\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.1\";s:7:\"version\";s:5:\"8.5.1\";s:3:\"tag\";s:5:\"8.5.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.1.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"23e18afbdd031d0cd7c519c4e9baff71\";s:8:\"filesize\";s:8:\"15537139\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.5.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.5.0\";s:7:\"version\";s:5:\"8.5.0\";s:3:\"tag\";s:5:\"8.5.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.5.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.5.0.tar.gz\";s:4:\"date\";s:10:\"1520457780\";s:6:\"mdhash\";s:32:\"5679d3fa188fb80368ee46ab40acdb6b\";s:8:\"filesize\";s:8:\"15535794\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.5.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.5.0-rc1\";s:7:\"version\";s:9:\"8.5.0-rc1\";s:3:\"tag\";s:9:\"8.5.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.5.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.5.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1519234680\";s:6:\"mdhash\";s:32:\"21048fe325b090df60620e5882ed39ab\";s:8:\"filesize\";s:8:\"15563019\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.5.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.5.0-beta1\";s:7:\"version\";s:11:\"8.5.0-beta1\";s:3:\"tag\";s:11:\"8.5.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.5.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.5.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1518211380\";s:6:\"mdhash\";s:32:\"981177d250839fdf325001c12b4e20ba\";s:8:\"filesize\";s:8:\"15545344\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.5.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.5.0-alpha1\";s:7:\"version\";s:12:\"8.5.0-alpha1\";s:3:\"tag\";s:12:\"8.5.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.5.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.5.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1516320484\";s:6:\"mdhash\";s:32:\"415dda1360f95c376870d2a3786483c7\";s:8:\"filesize\";s:8:\"13783860\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:5:\"8.4.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.8\";s:7:\"version\";s:5:\"8.4.8\";s:3:\"tag\";s:5:\"8.4.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.8.tar.gz\";s:4:\"date\";s:10:\"1524672780\";s:6:\"mdhash\";s:32:\"f922c5fead1e05ecf155cfd63983fcf1\";s:8:\"filesize\";s:8:\"13381772\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.7\";s:7:\"version\";s:5:\"8.4.7\";s:3:\"tag\";s:5:\"8.4.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.7.tar.gz\";s:4:\"date\";s:10:\"1524073147\";s:6:\"mdhash\";s:32:\"965b59360079fab9020fffce8c09a994\";s:8:\"filesize\";s:8:\"13381183\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.6\";s:7:\"version\";s:5:\"8.4.6\";s:3:\"tag\";s:5:\"8.4.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.6.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"e4b17dc542724f6298435dca81a84f8d\";s:8:\"filesize\";s:8:\"13413996\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.5\";s:7:\"version\";s:5:\"8.4.5\";s:3:\"tag\";s:5:\"8.4.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.5.tar.gz\";s:4:\"date\";s:10:\"1519234680\";s:6:\"mdhash\";s:32:\"e866ae73a2ce13eb803cd24c68ef94c7\";s:8:\"filesize\";s:8:\"13414036\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.4\";s:7:\"version\";s:5:\"8.4.4\";s:3:\"tag\";s:5:\"8.4.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.4.tar.gz\";s:4:\"date\";s:10:\"1515021185\";s:6:\"mdhash\";s:32:\"cfce3fb9293d8fe146f4c000505cb9b6\";s:8:\"filesize\";s:8:\"13410566\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.3\";s:7:\"version\";s:5:\"8.4.3\";s:3:\"tag\";s:5:\"8.4.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.3.tar.gz\";s:4:\"date\";s:10:\"1512600784\";s:6:\"mdhash\";s:32:\"55a53cb43284b3d710a2742d458fc1da\";s:8:\"filesize\";s:8:\"13399420\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.2\";s:7:\"version\";s:5:\"8.4.2\";s:3:\"tag\";s:5:\"8.4.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.2.tar.gz\";s:4:\"date\";s:10:\"1509719885\";s:6:\"mdhash\";s:32:\"a2b294d82ce751f93ba600f2de7884f4\";s:8:\"filesize\";s:8:\"13393043\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.1\";s:7:\"version\";s:5:\"8.4.1\";s:3:\"tag\";s:5:\"8.4.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.1.tar.gz\";s:4:\"date\";s:10:\"1509562384\";s:6:\"mdhash\";s:32:\"1c1db36ac5217f315bf9c03d64529f10\";s:8:\"filesize\";s:8:\"13407476\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.4.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.4.0\";s:7:\"version\";s:5:\"8.4.0\";s:3:\"tag\";s:5:\"8.4.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.4.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.4.0.tar.gz\";s:4:\"date\";s:10:\"1507146244\";s:6:\"mdhash\";s:32:\"074795a2f5fc0b599a7dcfb9d1fb03f5\";s:8:\"filesize\";s:8:\"13379442\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.4.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.4.0-rc2\";s:7:\"version\";s:9:\"8.4.0-rc2\";s:3:\"tag\";s:9:\"8.4.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.4.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1505911444\";s:6:\"mdhash\";s:32:\"50730355dd1a82d988e484c2b4eff422\";s:8:\"filesize\";s:8:\"13377433\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.4.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.4.0-rc1\";s:7:\"version\";s:9:\"8.4.0-rc1\";s:3:\"tag\";s:9:\"8.4.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.4.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1504733043\";s:6:\"mdhash\";s:32:\"28f7b802ddf81f6a5f50a1400766d913\";s:8:\"filesize\";s:8:\"13353640\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.4.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.4.0-beta1\";s:7:\"version\";s:11:\"8.4.0-beta1\";s:3:\"tag\";s:11:\"8.4.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.4.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1502992144\";s:6:\"mdhash\";s:32:\"8df2388ddd79d63d4b506463c1e173f8\";s:8:\"filesize\";s:8:\"13334632\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.4.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.4.0-alpha1\";s:7:\"version\";s:12:\"8.4.0-alpha1\";s:3:\"tag\";s:12:\"8.4.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.4.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.4.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1501790944\";s:6:\"mdhash\";s:32:\"540c951999e8cac74d1d5ff70a81157f\";s:8:\"filesize\";s:8:\"13153571\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:5:\"8.3.9\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.9\";s:7:\"version\";s:5:\"8.3.9\";s:3:\"tag\";s:5:\"8.3.9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.9.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"b53f505b0243d608b6a6550ae664bc75\";s:8:\"filesize\";s:8:\"12743287\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.8\";s:7:\"version\";s:5:\"8.3.8\";s:3:\"tag\";s:5:\"8.3.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.8.tar.gz\";s:4:\"date\";s:10:\"1520881985\";s:6:\"mdhash\";s:32:\"94cc223abff93a33762041a1fb2f7c3a\";s:8:\"filesize\";s:8:\"12741296\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.7\";s:7:\"version\";s:5:\"8.3.7\";s:3:\"tag\";s:5:\"8.3.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.7.tar.gz\";s:4:\"date\";s:10:\"1502903903\";s:6:\"mdhash\";s:32:\"e7b1f382d6bd2b18d4b4aca01d335bc0\";s:8:\"filesize\";s:8:\"12739663\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.6\";s:7:\"version\";s:5:\"8.3.6\";s:3:\"tag\";s:5:\"8.3.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.6.tar.gz\";s:4:\"date\";s:10:\"1501688043\";s:6:\"mdhash\";s:32:\"de7ceedf9391c4b52c1c5a7f66809129\";s:8:\"filesize\";s:8:\"12735564\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.5\";s:7:\"version\";s:5:\"8.3.5\";s:3:\"tag\";s:5:\"8.3.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.5.tar.gz\";s:4:\"date\";s:10:\"1499274843\";s:6:\"mdhash\";s:32:\"23832fcfe0c6398727d24e582042f149\";s:8:\"filesize\";s:8:\"12734016\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.4\";s:7:\"version\";s:5:\"8.3.4\";s:3:\"tag\";s:5:\"8.3.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.4.tar.gz\";s:4:\"date\";s:10:\"1498069442\";s:6:\"mdhash\";s:32:\"243a2e10032abaf55c10a96555315727\";s:8:\"filesize\";s:8:\"12721299\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.3\";s:7:\"version\";s:5:\"8.3.3\";s:3:\"tag\";s:5:\"8.3.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.3.tar.gz\";s:4:\"date\";s:10:\"1496858041\";s:6:\"mdhash\";s:32:\"eafff06bbe636b526ab17c064fdc5422\";s:8:\"filesize\";s:8:\"12718563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.2\";s:7:\"version\";s:5:\"8.3.2\";s:3:\"tag\";s:5:\"8.3.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.2.tar.gz\";s:4:\"date\";s:10:\"1493834585\";s:6:\"mdhash\";s:32:\"d1fce1ec78ca1bcde4a346f4c06531b4\";s:8:\"filesize\";s:8:\"12698347\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.1\";s:7:\"version\";s:5:\"8.3.1\";s:3:\"tag\";s:5:\"8.3.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.1.tar.gz\";s:4:\"date\";s:10:\"1492622946\";s:6:\"mdhash\";s:32:\"0287dcda619e440f6d41b1cc48a81e56\";s:8:\"filesize\";s:8:\"12663939\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.3.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.3.0\";s:7:\"version\";s:5:\"8.3.0\";s:3:\"tag\";s:5:\"8.3.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.3.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.3.0.tar.gz\";s:4:\"date\";s:10:\"1491439084\";s:6:\"mdhash\";s:32:\"1dcce599eddba07eb00e8879937525c3\";s:8:\"filesize\";s:8:\"12665617\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.3.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.3.0-rc2\";s:7:\"version\";s:9:\"8.3.0-rc2\";s:3:\"tag\";s:9:\"8.3.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.3.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1489613583\";s:6:\"mdhash\";s:32:\"3bcddc9a48801f7035c7cb0e6f02f6d0\";s:8:\"filesize\";s:8:\"12320512\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.3.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.3.0-rc1\";s:7:\"version\";s:9:\"8.3.0-rc1\";s:3:\"tag\";s:9:\"8.3.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.3.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1488383284\";s:6:\"mdhash\";s:32:\"0acd6c49d5626cd47077eb2650a409cb\";s:8:\"filesize\";s:8:\"12324498\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.3.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.3.0-beta1\";s:7:\"version\";s:11:\"8.3.0-beta1\";s:3:\"tag\";s:11:\"8.3.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.3.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1487175783\";s:6:\"mdhash\";s:32:\"7c5b312098fd5573d6e1420cfe86275e\";s:8:\"filesize\";s:8:\"12283857\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.3.0-alpha1\";a:16:{s:4:\"name\";s:19:\"drupal 8.3.0-alpha1\";s:7:\"version\";s:12:\"8.3.0-alpha1\";s:3:\"tag\";s:12:\"8.3.0-alpha1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.3.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1485968583\";s:6:\"mdhash\";s:32:\"601f931d5a3281214917e3eabfd86408\";s:8:\"filesize\";s:8:\"12249792\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:5:\"8.2.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.8\";s:7:\"version\";s:5:\"8.2.8\";s:3:\"tag\";s:5:\"8.2.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.8.tar.gz\";s:4:\"date\";s:10:\"1492622852\";s:6:\"mdhash\";s:32:\"039507247f3712c3fb022805eb13faf4\";s:8:\"filesize\";s:8:\"12092176\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.7\";s:7:\"version\";s:5:\"8.2.7\";s:3:\"tag\";s:5:\"8.2.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.7.tar.gz\";s:4:\"date\";s:10:\"1489609638\";s:6:\"mdhash\";s:32:\"10b1669f750a9996096e76059c157b9a\";s:8:\"filesize\";s:8:\"12090872\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.6\";s:7:\"version\";s:5:\"8.2.6\";s:3:\"tag\";s:5:\"8.2.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.6.tar.gz\";s:4:\"date\";s:10:\"1485975485\";s:6:\"mdhash\";s:32:\"57526a827771ea8a06db1792f1602a85\";s:8:\"filesize\";s:8:\"12091847\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.5\";s:7:\"version\";s:5:\"8.2.5\";s:3:\"tag\";s:5:\"8.2.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.5.tar.gz\";s:4:\"date\";s:10:\"1483529942\";s:6:\"mdhash\";s:32:\"4bfd35c34ce1b4ba5bac2d18e0d6b5c9\";s:8:\"filesize\";s:8:\"12064201\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.4\";s:7:\"version\";s:5:\"8.2.4\";s:3:\"tag\";s:5:\"8.2.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.4.tar.gz\";s:4:\"date\";s:10:\"1481136784\";s:6:\"mdhash\";s:32:\"288aa9978b5027e26f20df93b6295f6c\";s:8:\"filesize\";s:8:\"12051590\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.3\";s:7:\"version\";s:5:\"8.2.3\";s:3:\"tag\";s:5:\"8.2.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.3.tar.gz\";s:4:\"date\";s:10:\"1479322439\";s:6:\"mdhash\";s:32:\"683ddc33077bb1f7cc795607d114144e\";s:8:\"filesize\";s:8:\"12129681\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.2\";s:7:\"version\";s:5:\"8.2.2\";s:3:\"tag\";s:5:\"8.2.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.2.tar.gz\";s:4:\"date\";s:10:\"1478106542\";s:6:\"mdhash\";s:32:\"63d69922376a69068efb46ab4059dc34\";s:8:\"filesize\";s:8:\"12900949\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.1\";s:7:\"version\";s:5:\"8.2.1\";s:3:\"tag\";s:5:\"8.2.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.1.tar.gz\";s:4:\"date\";s:10:\"1476181439\";s:6:\"mdhash\";s:32:\"ad5ab19697ee0f7d786184ceaa7ddf6a\";s:8:\"filesize\";s:8:\"12871054\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.2.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.2.0\";s:7:\"version\";s:5:\"8.2.0\";s:3:\"tag\";s:5:\"8.2.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.2.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.2.0.tar.gz\";s:4:\"date\";s:10:\"1475660639\";s:6:\"mdhash\";s:32:\"5d0c57d2fd6338d60a5e311acc188b44\";s:8:\"filesize\";s:8:\"12867786\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.2.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.2.0-rc2\";s:7:\"version\";s:9:\"8.2.0-rc2\";s:3:\"tag\";s:9:\"8.2.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.2.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1474484358\";s:6:\"mdhash\";s:32:\"e6e7d9bb669fd82a8dd730ef0e47377d\";s:8:\"filesize\";s:8:\"12873257\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.2.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.2.0-rc1\";s:7:\"version\";s:9:\"8.2.0-rc1\";s:3:\"tag\";s:9:\"8.2.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.2.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1473285089\";s:6:\"mdhash\";s:32:\"c1f7f5f0d3cf742f97799497fd56af3e\";s:8:\"filesize\";s:8:\"12854953\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.2.0-beta3\";a:16:{s:4:\"name\";s:18:\"drupal 8.2.0-beta3\";s:7:\"version\";s:11:\"8.2.0-beta3\";s:3:\"tag\";s:11:\"8.2.0-beta3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.2.0-beta3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1472222475\";s:6:\"mdhash\";s:32:\"be99e1bc4050587b5cf414a9ab947356\";s:8:\"filesize\";s:8:\"12847824\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.2.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.2.0-beta2\";s:7:\"version\";s:11:\"8.2.0-beta2\";s:3:\"tag\";s:11:\"8.2.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.2.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1471710839\";s:6:\"mdhash\";s:32:\"973a20c9b0673cee724befe9762dd7c2\";s:8:\"filesize\";s:8:\"12826433\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.2.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.2.0-beta1\";s:7:\"version\";s:11:\"8.2.0-beta1\";s:3:\"tag\";s:11:\"8.2.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.2.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1470230639\";s:6:\"mdhash\";s:32:\"35fed9378c738d6bf420399f56e740c9\";s:8:\"filesize\";s:8:\"12751366\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:6:\"8.1.10\";a:15:{s:4:\"name\";s:13:\"drupal 8.1.10\";s:7:\"version\";s:6:\"8.1.10\";s:3:\"tag\";s:6:\"8.1.10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/drupal/releases/8.1.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/drupal-8.1.10.tar.gz\";s:4:\"date\";s:10:\"1474478939\";s:6:\"mdhash\";s:32:\"ce373a1a7a075ff9035b1c95f54170a4\";s:8:\"filesize\";s:8:\"12651446\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.9\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.9\";s:7:\"version\";s:5:\"8.1.9\";s:3:\"tag\";s:5:\"8.1.9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.9.tar.gz\";s:4:\"date\";s:10:\"1473276313\";s:6:\"mdhash\";s:32:\"4de7c001ecbd5c27e5837c97e40facc2\";s:8:\"filesize\";s:8:\"12648210\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.8\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.8\";s:7:\"version\";s:5:\"8.1.8\";s:3:\"tag\";s:5:\"8.1.8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.8.tar.gz\";s:4:\"date\";s:10:\"1470233647\";s:6:\"mdhash\";s:32:\"7c00b318590a22f2df7a18cf70df06dc\";s:8:\"filesize\";s:8:\"12634223\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.7\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.7\";s:7:\"version\";s:5:\"8.1.7\";s:3:\"tag\";s:5:\"8.1.7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.7.tar.gz\";s:4:\"date\";s:10:\"1468855358\";s:6:\"mdhash\";s:32:\"19e95079e50dd3c19222b91ef1b57036\";s:8:\"filesize\";s:8:\"12601662\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.6\";s:7:\"version\";s:5:\"8.1.6\";s:3:\"tag\";s:5:\"8.1.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.6.tar.gz\";s:4:\"date\";s:10:\"1468242539\";s:6:\"mdhash\";s:32:\"f3fdd2f9266938c2c7afc091e8d6e6d1\";s:8:\"filesize\";s:8:\"12595889\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.5\";s:7:\"version\";s:5:\"8.1.5\";s:3:\"tag\";s:5:\"8.1.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.5.tar.gz\";s:4:\"date\";s:10:\"1467884639\";s:6:\"mdhash\";s:32:\"0b30a3711d922c5348d6119e5124243b\";s:8:\"filesize\";s:8:\"12596430\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.4\";s:7:\"version\";s:5:\"8.1.4\";s:3:\"tag\";s:5:\"8.1.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.4.tar.gz\";s:4:\"date\";s:10:\"1467810839\";s:6:\"mdhash\";s:32:\"8c07b855ffd028124eb8848526abf4d9\";s:8:\"filesize\";s:8:\"12595731\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.3\";s:7:\"version\";s:5:\"8.1.3\";s:3:\"tag\";s:5:\"8.1.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.3.tar.gz\";s:4:\"date\";s:10:\"1466021480\";s:6:\"mdhash\";s:32:\"f2eef421c2a0610b32519f8f2e094b7c\";s:8:\"filesize\";s:8:\"12552870\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.2\";s:7:\"version\";s:5:\"8.1.2\";s:3:\"tag\";s:5:\"8.1.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.2.tar.gz\";s:4:\"date\";s:10:\"1464824339\";s:6:\"mdhash\";s:32:\"91fdfbd1c28512e41f2a61bf69214900\";s:8:\"filesize\";s:8:\"12553455\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.1\";s:7:\"version\";s:5:\"8.1.1\";s:3:\"tag\";s:5:\"8.1.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.1.tar.gz\";s:4:\"date\";s:10:\"1462361039\";s:6:\"mdhash\";s:32:\"529f3d72964c612695f68e0a6078b8ae\";s:8:\"filesize\";s:8:\"12533960\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.1.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.1.0\";s:7:\"version\";s:5:\"8.1.0\";s:3:\"tag\";s:5:\"8.1.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.1.0.tar.gz\";s:4:\"date\";s:10:\"1461118190\";s:6:\"mdhash\";s:32:\"a6bf3c366ba9ee5e0af3f2a80e274240\";s:8:\"filesize\";s:8:\"12520120\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.1.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.1.0-rc1\";s:7:\"version\";s:9:\"8.1.0-rc1\";s:3:\"tag\";s:9:\"8.1.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.1.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1459976639\";s:6:\"mdhash\";s:32:\"337de1b28e915e865a5385818ca82603\";s:8:\"filesize\";s:8:\"12459083\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.1.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.1.0-beta2\";s:7:\"version\";s:11:\"8.1.0-beta2\";s:3:\"tag\";s:11:\"8.1.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.1.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1458699840\";s:6:\"mdhash\";s:32:\"e916a10fb2dedaf3ebd88ddc010031be\";s:8:\"filesize\";s:8:\"12426385\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.1.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.1.0-beta1\";s:7:\"version\";s:11:\"8.1.0-beta1\";s:3:\"tag\";s:11:\"8.1.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.1.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1456975758\";s:6:\"mdhash\";s:32:\"3dc3b2354c54e35070052a175b957da0\";s:8:\"filesize\";s:8:\"11906519\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:5:\"8.0.6\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.6\";s:7:\"version\";s:5:\"8.0.6\";s:3:\"tag\";s:5:\"8.0.6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.6.tar.gz\";s:4:\"date\";s:10:\"1459900439\";s:6:\"mdhash\";s:32:\"952c14d46f0b02bcb29de5c3349c19ee\";s:8:\"filesize\";s:8:\"11782652\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.5\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.5\";s:7:\"version\";s:5:\"8.0.5\";s:3:\"tag\";s:5:\"8.0.5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.5.tar.gz\";s:4:\"date\";s:10:\"1456914839\";s:6:\"mdhash\";s:32:\"c13a69b0f99d70ecb6415d77f484bc7f\";s:8:\"filesize\";s:8:\"11770913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.4\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.4\";s:7:\"version\";s:5:\"8.0.4\";s:3:\"tag\";s:5:\"8.0.4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.4.tar.gz\";s:4:\"date\";s:10:\"1456341749\";s:6:\"mdhash\";s:32:\"7516dd4c18415020f80f000035e970ce\";s:8:\"filesize\";s:8:\"11746172\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.3\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.3\";s:7:\"version\";s:5:\"8.0.3\";s:3:\"tag\";s:5:\"8.0.3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.3.tar.gz\";s:4:\"date\";s:10:\"1454489043\";s:6:\"mdhash\";s:32:\"7d5f5278a870b8f4a29cda4fe915d619\";s:8:\"filesize\";s:8:\"11741502\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.2\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.2\";s:7:\"version\";s:5:\"8.0.2\";s:3:\"tag\";s:5:\"8.0.2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.2.tar.gz\";s:4:\"date\";s:10:\"1452119939\";s:6:\"mdhash\";s:32:\"9c39dec82c6d1a6d2004c30b11fb052e\";s:8:\"filesize\";s:8:\"11720487\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.1\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.1\";s:7:\"version\";s:5:\"8.0.1\";s:3:\"tag\";s:5:\"8.0.1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.1.tar.gz\";s:4:\"date\";s:10:\"1449066839\";s:6:\"mdhash\";s:32:\"423cc4d28da066d099986ac0844f6abb\";s:8:\"filesize\";s:8:\"11697695\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:5:\"8.0.0\";a:15:{s:4:\"name\";s:12:\"drupal 8.0.0\";s:7:\"version\";s:5:\"8.0.0\";s:3:\"tag\";s:5:\"8.0.0\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/drupal/releases/8.0.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/drupal-8.0.0.tar.gz\";s:4:\"date\";s:10:\"1447941840\";s:6:\"mdhash\";s:32:\"92ce9a54fa926b58032a4e39b0f9a9f1\";s:8:\"filesize\";s:8:\"11692820\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:9:\"8.0.0-rc4\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc4\";s:7:\"version\";s:9:\"8.0.0-rc4\";s:3:\"tag\";s:9:\"8.0.0-rc4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1447413840\";s:6:\"mdhash\";s:32:\"33a4738989e4b571176e47d26443cb26\";s:8:\"filesize\";s:8:\"11687995\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.0.0-rc3\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc3\";s:7:\"version\";s:9:\"8.0.0-rc3\";s:3:\"tag\";s:9:\"8.0.0-rc3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1446633239\";s:6:\"mdhash\";s:32:\"dedd68b8f39002d64fe64a0c5085e573\";s:8:\"filesize\";s:8:\"11557156\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.0.0-rc2\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc2\";s:7:\"version\";s:9:\"8.0.0-rc2\";s:3:\"tag\";s:9:\"8.0.0-rc2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1445468639\";s:6:\"mdhash\";s:32:\"66f0032af1350410a502f3a8cde5ab3f\";s:8:\"filesize\";s:8:\"10728216\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"8.0.0-rc1\";a:16:{s:4:\"name\";s:16:\"drupal 8.0.0-rc1\";s:7:\"version\";s:9:\"8.0.0-rc1\";s:3:\"tag\";s:9:\"8.0.0-rc1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1444253039\";s:6:\"mdhash\";s:32:\"58841f02728a85c105ce988e5605e4e5\";s:8:\"filesize\";s:8:\"11498104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta16\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta16\";s:7:\"version\";s:12:\"8.0.0-beta16\";s:3:\"tag\";s:12:\"8.0.0-beta16\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta16\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta16.tar.gz\";s:4:\"date\";s:10:\"1443746640\";s:6:\"mdhash\";s:32:\"3204db355d8163616f10263074285aee\";s:8:\"filesize\";s:8:\"11433695\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta15\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta15\";s:7:\"version\";s:12:\"8.0.0-beta15\";s:3:\"tag\";s:12:\"8.0.0-beta15\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta15\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta15.tar.gz\";s:4:\"date\";s:10:\"1441357140\";s:6:\"mdhash\";s:32:\"727e700eab75395663d6c5dbd20fe6ee\";s:8:\"filesize\";s:8:\"11273890\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta14\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta14\";s:7:\"version\";s:12:\"8.0.0-beta14\";s:3:\"tag\";s:12:\"8.0.0-beta14\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta14\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta14.tar.gz\";s:4:\"date\";s:10:\"1438593539\";s:6:\"mdhash\";s:32:\"ace8bfa17488faf80b6181cf9fb8035a\";s:8:\"filesize\";s:8:\"10493263\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta13\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta13\";s:7:\"version\";s:12:\"8.0.0-beta13\";s:3:\"tag\";s:12:\"8.0.0-beta13\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta13\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta13.tar.gz\";s:4:\"date\";s:10:\"1438194539\";s:6:\"mdhash\";s:32:\"1e872066cc6bf8c072341740825ff141\";s:8:\"filesize\";s:8:\"10481509\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta12\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta12\";s:7:\"version\";s:12:\"8.0.0-beta12\";s:3:\"tag\";s:12:\"8.0.0-beta12\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta12\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta12.tar.gz\";s:4:\"date\";s:10:\"1435601583\";s:6:\"mdhash\";s:32:\"7714744da283b70c14a2aa7fbb50eeeb\";s:8:\"filesize\";s:8:\"10662165\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta11\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta11\";s:7:\"version\";s:12:\"8.0.0-beta11\";s:3:\"tag\";s:12:\"8.0.0-beta11\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta11\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1432758481\";s:6:\"mdhash\";s:32:\"885500fef1a692d0598daa27134a440a\";s:8:\"filesize\";s:8:\"10500627\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:12:\"8.0.0-beta10\";a:16:{s:4:\"name\";s:19:\"drupal 8.0.0-beta10\";s:7:\"version\";s:12:\"8.0.0-beta10\";s:3:\"tag\";s:12:\"8.0.0-beta10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta10\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1430314681\";s:6:\"mdhash\";s:32:\"cfe68b642776818a9df71211495fbb44\";s:8:\"filesize\";s:8:\"10296679\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta9\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta9\";s:7:\"version\";s:11:\"8.0.0-beta9\";s:3:\"tag\";s:11:\"8.0.0-beta9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta9\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1427299981\";s:6:\"mdhash\";s:32:\"109172962c779f26528f697604695bec\";s:8:\"filesize\";s:8:\"10044027\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta7\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta7\";s:7:\"version\";s:11:\"8.0.0-beta7\";s:3:\"tag\";s:11:\"8.0.0-beta7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta7\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1424875381\";s:6:\"mdhash\";s:32:\"b730108fbdd33ffe57fb94e94d293ebe\";s:8:\"filesize\";s:7:\"9694970\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta6\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta6\";s:7:\"version\";s:11:\"8.0.0-beta6\";s:3:\"tag\";s:11:\"8.0.0-beta6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta6\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1422443800\";s:6:\"mdhash\";s:32:\"b2470e3e2ab4fa6adce0e9152d6ad4b9\";s:8:\"filesize\";s:7:\"9562882\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta4\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta4\";s:7:\"version\";s:11:\"8.0.0-beta4\";s:3:\"tag\";s:11:\"8.0.0-beta4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta4\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1418825280\";s:6:\"mdhash\";s:32:\"66cf899e456bd27b7ff9beaf61dcf45f\";s:8:\"filesize\";s:7:\"9555745\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta3\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta3\";s:7:\"version\";s:11:\"8.0.0-beta3\";s:3:\"tag\";s:11:\"8.0.0-beta3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1415797380\";s:6:\"mdhash\";s:32:\"89eb46c597eb9c8ef7423783aef7f340\";s:8:\"filesize\";s:7:\"9445245\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta2\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta2\";s:7:\"version\";s:11:\"8.0.0-beta2\";s:3:\"tag\";s:11:\"8.0.0-beta2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1413394161\";s:6:\"mdhash\";s:32:\"5130f44ed3c0b3fa709eb1d92e7def33\";s:8:\"filesize\";s:7:\"9480603\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:8:\"Insecure\";i:1;s:15:\"Security update\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.0.0-beta1\";a:16:{s:4:\"name\";s:18:\"drupal 8.0.0-beta1\";s:7:\"version\";s:11:\"8.0.0-beta1\";s:3:\"tag\";s:11:\"8.0.0-beta1\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1412147030\";s:6:\"mdhash\";s:32:\"9efea37c74bed8208133dc1aae76e53f\";s:8:\"filesize\";s:7:\"9389838\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.0.0-alpha15\";a:16:{s:4:\"name\";s:20:\"drupal 8.0.0-alpha15\";s:7:\"version\";s:13:\"8.0.0-alpha15\";s:3:\"tag\";s:13:\"8.0.0-alpha15\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/drupal/releases/8.0.0-alpha15\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-alpha15.tar.gz\";s:4:\"date\";s:10:\"1411139628\";s:6:\"mdhash\";s:32:\"a5ea2deb1776a3703315e90772d9ec58\";s:8:\"filesize\";s:7:\"9344566\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:13:\"8.0.0-alpha14\";a:16:{s:4:\"name\";s:20:\"drupal 8.0.0-alpha14\";s:7:\"version\";s:13:\"8.0.0-alpha14\";s:3:\"tag\";s:13:\"8.0.0-alpha14\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/drupal/releases/8.0.0-alpha14\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/drupal-8.0.0-alpha14.tar.gz\";s:4:\"date\";s:10:\"1407344628\";s:6:\"mdhash\";s:32:\"9d71afdd0ce541f2ff5ca2fbbca00df7\";s:8:\"filesize\";s:7:\"9172832\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha13\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha13\";s:7:\"version\";s:11:\"8.0-alpha13\";s:3:\"tag\";s:11:\"8.0-alpha13\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha13\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha13.tar.gz\";s:4:\"date\";s:10:\"1404296627\";s:6:\"mdhash\";s:32:\"6fb0325f937b870fbfab2f9526dd6e14\";s:8:\"filesize\";s:7:\"9089848\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha12\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha12\";s:7:\"version\";s:11:\"8.0-alpha12\";s:3:\"tag\";s:11:\"8.0-alpha12\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha12\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha12.tar.gz\";s:4:\"date\";s:10:\"1401293627\";s:6:\"mdhash\";s:32:\"fdf022c5375e77c59bd35a61e6ec68e5\";s:8:\"filesize\";s:7:\"8792935\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha11\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha11\";s:7:\"version\";s:11:\"8.0-alpha11\";s:3:\"tag\";s:11:\"8.0-alpha11\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha11\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha11.tar.gz\";s:4:\"date\";s:10:\"1398249227\";s:6:\"mdhash\";s:32:\"3b1a74ec242b145c7a6fa0fe5070a4ee\";s:8:\"filesize\";s:7:\"8613989\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"8.0-alpha10\";a:15:{s:4:\"name\";s:18:\"drupal 8.0-alpha10\";s:7:\"version\";s:11:\"8.0-alpha10\";s:3:\"tag\";s:11:\"8.0-alpha10\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/drupal/releases/8.0-alpha10\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha10.tar.gz\";s:4:\"date\";s:10:\"1395231556\";s:6:\"mdhash\";s:32:\"b542bd467beeb7ea3c63c8f0027a3439\";s:8:\"filesize\";s:7:\"8109552\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha9\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha9\";s:7:\"version\";s:10:\"8.0-alpha9\";s:3:\"tag\";s:10:\"8.0-alpha9\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha9\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha9.tar.gz\";s:4:\"date\";s:10:\"1392806005\";s:6:\"mdhash\";s:32:\"cb5af8f8fe865a7f834b99d421e23839\";s:8:\"filesize\";s:7:\"8105277\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha8\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha8\";s:7:\"version\";s:10:\"8.0-alpha8\";s:3:\"tag\";s:10:\"8.0-alpha8\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha8\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha8.tar.gz\";s:4:\"date\";s:10:\"1390393105\";s:6:\"mdhash\";s:32:\"5c970df83a2f4027b0377fbcf890eb79\";s:8:\"filesize\";s:7:\"8037378\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha7\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha7\";s:7:\"version\";s:10:\"8.0-alpha7\";s:3:\"tag\";s:10:\"8.0-alpha7\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1387399705\";s:6:\"mdhash\";s:32:\"49228c4537941eb1f63f5bf0eb742d1f\";s:8:\"filesize\";s:7:\"7913974\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha6\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha6\";s:7:\"version\";s:10:\"8.0-alpha6\";s:3:\"tag\";s:10:\"8.0-alpha6\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1385153305\";s:6:\"mdhash\";s:32:\"6fb6eb93826c9f75cbc2bf62fa61f28d\";s:8:\"filesize\";s:7:\"7914981\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha5\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha5\";s:7:\"version\";s:10:\"8.0-alpha5\";s:3:\"tag\";s:10:\"8.0-alpha5\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1384850305\";s:6:\"mdhash\";s:32:\"4b3c1a6ab88a68ca17482035dbde8f4f\";s:8:\"filesize\";s:7:\"7883692\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha4\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha4\";s:7:\"version\";s:10:\"8.0-alpha4\";s:3:\"tag\";s:10:\"8.0-alpha4\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1382092313\";s:6:\"mdhash\";s:32:\"793447ac11e240b1f1743adf33239ed6\";s:8:\"filesize\";s:7:\"7804215\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha3\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha3\";s:7:\"version\";s:10:\"8.0-alpha3\";s:3:\"tag\";s:10:\"8.0-alpha3\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1378303307\";s:6:\"mdhash\";s:32:\"c786a027b87428fef5ddd7a946dcf07c\";s:8:\"filesize\";s:7:\"7647641\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"8.0-alpha2\";a:15:{s:4:\"name\";s:17:\"drupal 8.0-alpha2\";s:7:\"version\";s:10:\"8.0-alpha2\";s:3:\"tag\";s:10:\"8.0-alpha2\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/8.0-alpha2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-8.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1372069563\";s:6:\"mdhash\";s:32:\"01f5589dcfd851c7d65c040f455bad19\";s:8:\"filesize\";s:7:\"7319631\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:8:\"Insecure\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:9:\"8.7.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.7.x-dev\";s:7:\"version\";s:9:\"8.7.x-dev\";s:3:\"tag\";s:5:\"8.7.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"7\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.7.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.7.x-dev.tar.gz\";s:4:\"date\";s:10:\"1540204981\";s:6:\"mdhash\";s:32:\"6baf799022611f3e7f26c90a999d9498\";s:8:\"filesize\";s:8:\"20577693\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:9:\"8.6.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.6.x-dev\";s:7:\"version\";s:9:\"8.6.x-dev\";s:3:\"tag\";s:5:\"8.6.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"6\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.6.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.6.x-dev.tar.gz\";s:4:\"date\";s:10:\"1540204981\";s:6:\"mdhash\";s:32:\"b231a7a96632eaebf765dbeaa1a53613\";s:8:\"filesize\";s:8:\"20595513\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:9:\"8.5.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.5.x-dev\";s:7:\"version\";s:9:\"8.5.x-dev\";s:3:\"tag\";s:5:\"8.5.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"5\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.5.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.5.x-dev.tar.gz\";s:4:\"date\";s:10:\"1539816180\";s:6:\"mdhash\";s:32:\"f16c386f6159ded1d75c31cdb83873d5\";s:8:\"filesize\";s:8:\"17074621\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.4.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.4.x-dev\";s:7:\"version\";s:9:\"8.4.x-dev\";s:3:\"tag\";s:5:\"8.4.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"4\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.4.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.4.x-dev.tar.gz\";s:4:\"date\";s:10:\"1533047880\";s:6:\"mdhash\";s:32:\"5e310607e224d9264504cdd05c5fb0b1\";s:8:\"filesize\";s:8:\"14600045\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.3.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.3.x-dev\";s:7:\"version\";s:9:\"8.3.x-dev\";s:3:\"tag\";s:5:\"8.3.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.3.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1522263480\";s:6:\"mdhash\";s:32:\"439e0b9754d00d2026c98f3d3b852b1e\";s:8:\"filesize\";s:8:\"13923638\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.2.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.2.x-dev\";s:7:\"version\";s:9:\"8.2.x-dev\";s:3:\"tag\";s:5:\"8.2.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.2.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1492624982\";s:6:\"mdhash\";s:32:\"f9fc5edc65b138c8bc12e8335f092cde\";s:8:\"filesize\";s:8:\"12873229\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.1.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.1.x-dev\";s:7:\"version\";s:9:\"8.1.x-dev\";s:3:\"tag\";s:5:\"8.1.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1474478393\";s:6:\"mdhash\";s:32:\"72a40cdf2595fd9d60414df63639f3e8\";s:8:\"filesize\";s:8:\"12654097\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:9:\"8.0.x-dev\";a:15:{s:4:\"name\";s:16:\"drupal 8.0.x-dev\";s:7:\"version\";s:9:\"8.0.x-dev\";s:3:\"tag\";s:5:\"8.0.x\";s:13:\"version_major\";s:1:\"8\";s:13:\"version_minor\";s:1:\"0\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/8.0.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-8.0.x-dev.tar.gz\";s:4:\"date\";s:10:\"1459900439\";s:6:\"mdhash\";s:32:\"8265a5c9ac0b4f1d90ae55c2f389265d\";s:8:\"filesize\";s:8:\"11792185\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1540283840;}',1540370240),('update_available_releases','entity',_binary 'a:12:{s:5:\"title\";s:10:\"Entity API\";s:10:\"short_name\";s:6:\"entity\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:11:\"8.x-1.0-rc1\";a:15:{s:4:\"name\";s:18:\"entity 8.x-1.0-rc1\";s:7:\"version\";s:11:\"8.x-1.0-rc1\";s:3:\"tag\";s:11:\"8.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.0-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1539272580\";s:6:\"mdhash\";s:32:\"e8531123563e45cee816f4e3ac8a39c3\";s:8:\"filesize\";s:5:\"50152\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta4\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta4\";s:7:\"version\";s:13:\"8.x-1.0-beta4\";s:3:\"tag\";s:13:\"8.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1528452184\";s:6:\"mdhash\";s:32:\"874c0a5c1915275c637f6692cba316d7\";s:8:\"filesize\";s:5:\"38765\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"8.x-1.0-beta3\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta3\";s:7:\"version\";s:13:\"8.x-1.0-beta3\";s:3:\"tag\";s:13:\"8.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1520958485\";s:6:\"mdhash\";s:32:\"216df1d41d4efa5502baac08155ad208\";s:8:\"filesize\";s:5:\"38749\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta2\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta2\";s:7:\"version\";s:13:\"8.x-1.0-beta2\";s:3:\"tag\";s:13:\"8.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1520873280\";s:6:\"mdhash\";s:32:\"d6fb195f0c94f39c9e3fdb5960e8edfe\";s:8:\"filesize\";s:5:\"37165\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:20:\"entity 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1505895844\";s:6:\"mdhash\";s:32:\"2c218cdcc59a996f3b3289869c61dfcc\";s:8:\"filesize\";s:5:\"35871\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha4\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha4\";s:7:\"version\";s:14:\"8.x-1.0-alpha4\";s:3:\"tag\";s:14:\"8.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1481194983\";s:6:\"mdhash\";s:32:\"2dad14c347eed3694cf931921c912022\";s:8:\"filesize\";s:5:\"27365\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"8.x-1.0-alpha3\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha3\";s:7:\"version\";s:14:\"8.x-1.0-alpha3\";s:3:\"tag\";s:14:\"8.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1461748139\";s:6:\"mdhash\";s:32:\"0083ff3d127f2508345d0dfd6c7a323a\";s:8:\"filesize\";s:5:\"22815\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha2\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha2\";s:7:\"version\";s:14:\"8.x-1.0-alpha2\";s:3:\"tag\";s:14:\"8.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1459289340\";s:6:\"mdhash\";s:32:\"9600a45053b0b564a18b92014e179182\";s:8:\"filesize\";s:5:\"22313\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"8.x-1.0-alpha1\";a:15:{s:4:\"name\";s:21:\"entity 8.x-1.0-alpha1\";s:7:\"version\";s:14:\"8.x-1.0-alpha1\";s:3:\"tag\";s:14:\"8.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/8.x-1.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-8.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1452761939\";s:6:\"mdhash\";s:32:\"284cceace9420bd1e1f384649fec221d\";s:8:\"filesize\";s:5:\"22735\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:7:\"8.x-0.1\";a:14:{s:4:\"name\";s:14:\"entity 8.x-0.1\";s:7:\"version\";s:7:\"8.x-0.1\";s:3:\"tag\";s:7:\"8.x-0.1\";s:13:\"version_major\";s:1:\"0\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/8.x-0.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-8.x-0.1.tar.gz\";s:4:\"date\";s:10:\"1459284240\";s:6:\"mdhash\";s:32:\"3b03c9e33064bdbf0e0b7d4512fc95ff\";s:8:\"filesize\";s:5:\"32843\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"entity 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1539272580\";s:6:\"mdhash\";s:32:\"9b03fa9e7a4e021d1b6eae7c8a56f12f\";s:8:\"filesize\";s:5:\"50177\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-0.x-dev\";a:14:{s:4:\"name\";s:18:\"entity 8.x-0.x-dev\";s:7:\"version\";s:11:\"8.x-0.x-dev\";s:3:\"tag\";s:7:\"8.x-0.x\";s:13:\"version_major\";s:1:\"0\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/8.x-0.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-8.x-0.x-dev.tar.gz\";s:4:\"date\";s:10:\"1459283939\";s:6:\"mdhash\";s:32:\"f26553bcc0e221151d4bba1ac675696a\";s:8:\"filesize\";s:5:\"32852\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1540283843;}',1540370243),('update_available_releases','ga_reports',_binary 'a:11:{s:5:\"title\";s:10:\"GA Reports\";s:10:\"short_name\";s:10:\"ga_reports\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/ga_reports\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:1:{s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"ga_reports 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/ga_reports/releases/8.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/ga_reports-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1539683884\";s:6:\"mdhash\";s:32:\"54042685b16c2b0bd77b965b82755801\";s:8:\"filesize\";s:5:\"37428\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1540283842;}',1540370242),('update_available_releases','justice',_binary 'a:1:{s:10:\"last_fetch\";i:1540208418;}',1540294818),('update_available_releases','migrate_plus',_binary 'a:12:{s:5:\"title\";s:12:\"Migrate Plus\";s:10:\"short_name\";s:12:\"migrate_plus\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"4\";s:16:\"supported_majors\";s:1:\"4\";s:13:\"default_major\";s:1:\"4\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:43:\"https://www.drupal.org/project/migrate_plus\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:17:{s:7:\"8.x-4.0\";a:14:{s:4:\"name\";s:20:\"migrate_plus 8.x-4.0\";s:7:\"version\";s:7:\"8.x-4.0\";s:3:\"tag\";s:7:\"8.x-4.0\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/migrate_plus/releases/8.x-4.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-4.0.tar.gz\";s:4:\"date\";s:10:\"1536264180\";s:6:\"mdhash\";s:32:\"6262276f7225ffae8a33f1f8ed4c461e\";s:8:\"filesize\";s:5:\"71381\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"8.x-4.0-rc1\";a:15:{s:4:\"name\";s:24:\"migrate_plus 8.x-4.0-rc1\";s:7:\"version\";s:11:\"8.x-4.0-rc1\";s:3:\"tag\";s:11:\"8.x-4.0-rc1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/migrate_plus/releases/8.x-4.0-rc1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-4.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1535381280\";s:6:\"mdhash\";s:32:\"91c1a796fa5ed7f0625295867274ae74\";s:8:\"filesize\";s:5:\"71383\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-4.0-beta3\";a:15:{s:4:\"name\";s:26:\"migrate_plus 8.x-4.0-beta3\";s:7:\"version\";s:13:\"8.x-4.0-beta3\";s:3:\"tag\";s:13:\"8.x-4.0-beta3\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/migrate_plus/releases/8.x-4.0-beta3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-4.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1519400592\";s:6:\"mdhash\";s:32:\"951d7a40a80c88c9e45df77b63c7ef64\";s:8:\"filesize\";s:5:\"67213\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-4.0-beta2\";a:15:{s:4:\"name\";s:26:\"migrate_plus 8.x-4.0-beta2\";s:7:\"version\";s:13:\"8.x-4.0-beta2\";s:3:\"tag\";s:13:\"8.x-4.0-beta2\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/migrate_plus/releases/8.x-4.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-4.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1513088288\";s:6:\"mdhash\";s:32:\"edad38b635489383e4b261bd75dddba3\";s:8:\"filesize\";s:5:\"65814\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-4.0-beta1\";a:15:{s:4:\"name\";s:26:\"migrate_plus 8.x-4.0-beta1\";s:7:\"version\";s:13:\"8.x-4.0-beta1\";s:3:\"tag\";s:13:\"8.x-4.0-beta1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/migrate_plus/releases/8.x-4.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-4.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1494450185\";s:6:\"mdhash\";s:32:\"d23819f825408b4d8a27fbcae64869c1\";s:8:\"filesize\";s:5:\"62497\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.0-rc1\";a:15:{s:4:\"name\";s:24:\"migrate_plus 8.x-3.0-rc1\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:3:\"tag\";s:11:\"8.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/migrate_plus/releases/8.x-3.0-rc1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1494450485\";s:6:\"mdhash\";s:32:\"c26ef2ead565b667d255ac44f2a14c42\";s:8:\"filesize\";s:5:\"62112\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:26:\"migrate_plus 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/migrate_plus/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1476307739\";s:6:\"mdhash\";s:32:\"436f5beb2f5a4e75a4bdcd4f96a9fa83\";s:8:\"filesize\";s:5:\"61073\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-2.0\";a:14:{s:4:\"name\";s:20:\"migrate_plus 8.x-2.0\";s:7:\"version\";s:7:\"8.x-2.0\";s:3:\"tag\";s:7:\"8.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/migrate_plus/releases/8.x-2.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1490130783\";s:6:\"mdhash\";s:32:\"df3fd6fa4fdbc84786655602f217e6fb\";s:8:\"filesize\";s:5:\"59999\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-2.0-rc1\";a:15:{s:4:\"name\";s:24:\"migrate_plus 8.x-2.0-rc1\";s:7:\"version\";s:11:\"8.x-2.0-rc1\";s:3:\"tag\";s:11:\"8.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/migrate_plus/releases/8.x-2.0-rc1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1476307439\";s:6:\"mdhash\";s:32:\"6a71e58aed7bf099aaac7cf13a134c54\";s:8:\"filesize\";s:5:\"60882\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta2\";a:15:{s:4:\"name\";s:26:\"migrate_plus 8.x-2.0-beta2\";s:7:\"version\";s:13:\"8.x-2.0-beta2\";s:3:\"tag\";s:13:\"8.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/migrate_plus/releases/8.x-2.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1470428639\";s:6:\"mdhash\";s:32:\"5af87dd3d06174f3d4289cd5fab68ba2\";s:8:\"filesize\";s:5:\"53907\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta1\";a:15:{s:4:\"name\";s:26:\"migrate_plus 8.x-2.0-beta1\";s:7:\"version\";s:13:\"8.x-2.0-beta1\";s:3:\"tag\";s:13:\"8.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/migrate_plus/releases/8.x-2.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1461251039\";s:6:\"mdhash\";s:32:\"226cce8081f42d0120380180bfe64b44\";s:8:\"filesize\";s:5:\"46747\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:20:\"migrate_plus 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/migrate_plus/releases/8.x-1.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1458167758\";s:6:\"mdhash\";s:32:\"77b9c9dfd5fafc4151be3a6667622d22\";s:8:\"filesize\";s:5:\"43611\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:26:\"migrate_plus 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/migrate_plus/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1447788840\";s:6:\"mdhash\";s:32:\"f626f8ea8ad7206ee85e5cb61bf60134\";s:8:\"filesize\";s:5:\"34274\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-4.x-dev\";a:14:{s:4:\"name\";s:24:\"migrate_plus 8.x-4.x-dev\";s:7:\"version\";s:11:\"8.x-4.x-dev\";s:3:\"tag\";s:7:\"8.x-4.x\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/migrate_plus/releases/8.x-4.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-4.x-dev.tar.gz\";s:4:\"date\";s:10:\"1540243980\";s:6:\"mdhash\";s:32:\"55cadc3a75ec5b604e0b7b051b7636b1\";s:8:\"filesize\";s:5:\"77963\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.x-dev\";a:14:{s:4:\"name\";s:24:\"migrate_plus 8.x-3.x-dev\";s:7:\"version\";s:11:\"8.x-3.x-dev\";s:3:\"tag\";s:7:\"8.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/migrate_plus/releases/8.x-3.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1494424085\";s:6:\"mdhash\";s:32:\"996684d992a99826dce38832b323a7f4\";s:8:\"filesize\";s:5:\"62144\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:24:\"migrate_plus 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/migrate_plus/releases/8.x-2.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1494424085\";s:6:\"mdhash\";s:32:\"a3e45bf7d617039b16792c5ad6a594d1\";s:8:\"filesize\";s:5:\"59980\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:24:\"migrate_plus 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/migrate_plus/releases/8.x-1.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/migrate_plus-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1461184739\";s:6:\"mdhash\";s:32:\"75a0265340ea1a35ebc0c578ebb7c181\";s:8:\"filesize\";s:5:\"43628\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1540283843;}',1540370243),('update_available_releases','migrate_tools',_binary 'a:12:{s:5:\"title\";s:13:\"Migrate Tools\";s:10:\"short_name\";s:13:\"migrate_tools\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"4\";s:16:\"supported_majors\";s:1:\"4\";s:13:\"default_major\";s:1:\"4\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/migrate_tools\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:16:{s:7:\"8.x-4.0\";a:14:{s:4:\"name\";s:21:\"migrate_tools 8.x-4.0\";s:7:\"version\";s:7:\"8.x-4.0\";s:3:\"tag\";s:7:\"8.x-4.0\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/migrate_tools/releases/8.x-4.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-4.0.tar.gz\";s:4:\"date\";s:10:\"1535380084\";s:6:\"mdhash\";s:32:\"a12f7698a3b8df73976fdba5c98cf555\";s:8:\"filesize\";s:5:\"39510\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-4.0-rc1\";a:15:{s:4:\"name\";s:25:\"migrate_tools 8.x-4.0-rc1\";s:7:\"version\";s:11:\"8.x-4.0-rc1\";s:3:\"tag\";s:11:\"8.x-4.0-rc1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/migrate_tools/releases/8.x-4.0-rc1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-4.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1531143824\";s:6:\"mdhash\";s:32:\"eec03ff1d17a73a6463d9d8309627e75\";s:8:\"filesize\";s:5:\"38946\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-4.0-beta3\";a:15:{s:4:\"name\";s:27:\"migrate_tools 8.x-4.0-beta3\";s:7:\"version\";s:13:\"8.x-4.0-beta3\";s:3:\"tag\";s:13:\"8.x-4.0-beta3\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_tools/releases/8.x-4.0-beta3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-4.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1519400285\";s:6:\"mdhash\";s:32:\"e12983471521a9188217ba64f6263f51\";s:8:\"filesize\";s:5:\"33691\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-4.0-beta2\";a:15:{s:4:\"name\";s:27:\"migrate_tools 8.x-4.0-beta2\";s:7:\"version\";s:13:\"8.x-4.0-beta2\";s:3:\"tag\";s:13:\"8.x-4.0-beta2\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_tools/releases/8.x-4.0-beta2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-4.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1511790485\";s:6:\"mdhash\";s:32:\"bb29e3cd31554f83322a97ba583048e8\";s:8:\"filesize\";s:5:\"33424\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"8.x-4.0-beta1\";a:15:{s:4:\"name\";s:27:\"migrate_tools 8.x-4.0-beta1\";s:7:\"version\";s:13:\"8.x-4.0-beta1\";s:3:\"tag\";s:13:\"8.x-4.0-beta1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_tools/releases/8.x-4.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-4.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1494450185\";s:6:\"mdhash\";s:32:\"075a2a4494245698cd412f165392039b\";s:8:\"filesize\";s:5:\"21686\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.0-rc1\";a:15:{s:4:\"name\";s:25:\"migrate_tools 8.x-3.0-rc1\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:3:\"tag\";s:11:\"8.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/migrate_tools/releases/8.x-3.0-rc1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1494450485\";s:6:\"mdhash\";s:32:\"9dbe6f8f0e5f338b1d73c4e00bf851de\";s:8:\"filesize\";s:5:\"21586\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:27:\"migrate_tools 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_tools/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1476313439\";s:6:\"mdhash\";s:32:\"0b91df84b688b157bb506f60a3071195\";s:8:\"filesize\";s:5:\"21498\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-2.0\";a:14:{s:4:\"name\";s:21:\"migrate_tools 8.x-2.0\";s:7:\"version\";s:7:\"8.x-2.0\";s:3:\"tag\";s:7:\"8.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/migrate_tools/releases/8.x-2.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1490130783\";s:6:\"mdhash\";s:32:\"dbaefa28978cb3177fb61667db968fcf\";s:8:\"filesize\";s:5:\"21586\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-2.0-rc1\";a:15:{s:4:\"name\";s:25:\"migrate_tools 8.x-2.0-rc1\";s:7:\"version\";s:11:\"8.x-2.0-rc1\";s:3:\"tag\";s:11:\"8.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/migrate_tools/releases/8.x-2.0-rc1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1476313439\";s:6:\"mdhash\";s:32:\"a49fc8b710f4fb3cf84f61a53cc4a137\";s:8:\"filesize\";s:5:\"21502\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta1\";a:15:{s:4:\"name\";s:27:\"migrate_tools 8.x-2.0-beta1\";s:7:\"version\";s:13:\"8.x-2.0-beta1\";s:3:\"tag\";s:13:\"8.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_tools/releases/8.x-2.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1462489439\";s:6:\"mdhash\";s:32:\"52798341ad80d05c2078dab7de6939ab\";s:8:\"filesize\";s:5:\"19402\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:21:\"migrate_tools 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/migrate_tools/releases/8.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1458167758\";s:6:\"mdhash\";s:32:\"a7f412a89e074f9ead3762d01c832aca\";s:8:\"filesize\";s:5:\"19214\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"8.x-1.0-beta1\";a:15:{s:4:\"name\";s:27:\"migrate_tools 8.x-1.0-beta1\";s:7:\"version\";s:13:\"8.x-1.0-beta1\";s:3:\"tag\";s:13:\"8.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_tools/releases/8.x-1.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1447788540\";s:6:\"mdhash\";s:32:\"bb6c9ab28da864739f7a451b2f9b5dbb\";s:8:\"filesize\";s:5:\"18733\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"8.x-4.x-dev\";a:14:{s:4:\"name\";s:25:\"migrate_tools 8.x-4.x-dev\";s:7:\"version\";s:11:\"8.x-4.x-dev\";s:3:\"tag\";s:7:\"8.x-4.x\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/migrate_tools/releases/8.x-4.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-4.x-dev.tar.gz\";s:4:\"date\";s:10:\"1540225680\";s:6:\"mdhash\";s:32:\"b0019c2ec6ceb907fae7b270338c9137\";s:8:\"filesize\";s:5:\"40084\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.x-dev\";a:14:{s:4:\"name\";s:25:\"migrate_tools 8.x-3.x-dev\";s:7:\"version\";s:11:\"8.x-3.x-dev\";s:3:\"tag\";s:7:\"8.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/migrate_tools/releases/8.x-3.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1499874842\";s:6:\"mdhash\";s:32:\"98942813f8d10521862c8ffd7e5fee31\";s:8:\"filesize\";s:5:\"21671\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"migrate_tools 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/migrate_tools/releases/8.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1476313139\";s:6:\"mdhash\";s:32:\"87116bd90bdafea660a411b7b60ab8f2\";s:8:\"filesize\";s:5:\"21511\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"migrate_tools 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/migrate_tools/releases/8.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/migrate_tools-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1458160439\";s:6:\"mdhash\";s:32:\"ae4e641ebdc915178dd234a37b9ee72d\";s:8:\"filesize\";s:5:\"19225\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1540283844;}',1540370244),('update_available_releases','migrate_upgrade',_binary 'a:12:{s:5:\"title\";s:15:\"Migrate Upgrade\";s:10:\"short_name\";s:15:\"migrate_upgrade\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"8.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/migrate_upgrade\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:13:{s:11:\"8.x-3.0-rc5\";a:15:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-3.0-rc5\";s:7:\"version\";s:11:\"8.x-3.0-rc5\";s:3:\"tag\";s:11:\"8.x-3.0-rc5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.0-rc5\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1535381580\";s:6:\"mdhash\";s:32:\"bccdc054440da462299db175608d8c0e\";s:8:\"filesize\";s:5:\"17272\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.0-rc4\";a:15:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-3.0-rc4\";s:7:\"version\";s:11:\"8.x-3.0-rc4\";s:3:\"tag\";s:11:\"8.x-3.0-rc4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.0-rc4\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1519400285\";s:6:\"mdhash\";s:32:\"e681a0eb9cdf841489b1ac02d35828ce\";s:8:\"filesize\";s:5:\"15601\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.0-rc3\";a:15:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-3.0-rc3\";s:7:\"version\";s:11:\"8.x-3.0-rc3\";s:3:\"tag\";s:11:\"8.x-3.0-rc3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.0-rc3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1513177684\";s:6:\"mdhash\";s:32:\"cbd9a2e990ba3daed6b82fc0aee4535d\";s:8:\"filesize\";s:5:\"14662\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.0-rc2\";a:15:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-3.0-rc2\";s:7:\"version\";s:11:\"8.x-3.0-rc2\";s:3:\"tag\";s:11:\"8.x-3.0-rc2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.0-rc2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1504384144\";s:6:\"mdhash\";s:32:\"06623774b5a3db8c6d89cff1060b86fe\";s:8:\"filesize\";s:5:\"14659\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"8.x-3.0-rc1\";a:15:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-3.0-rc1\";s:7:\"version\";s:11:\"8.x-3.0-rc1\";s:3:\"tag\";s:11:\"8.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.0-rc1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1476200639\";s:6:\"mdhash\";s:32:\"bb3b8cd64e8fefc3e3f63547e720d826\";s:8:\"filesize\";s:5:\"12874\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-3.0-beta1\";a:15:{s:4:\"name\";s:29:\"migrate_upgrade 8.x-3.0-beta1\";s:7:\"version\";s:13:\"8.x-3.0-beta1\";s:3:\"tag\";s:13:\"8.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1472771939\";s:6:\"mdhash\";s:32:\"5eca3b6a095086730c574619ae43b11c\";s:8:\"filesize\";s:5:\"12453\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-2.0\";a:14:{s:4:\"name\";s:23:\"migrate_upgrade 8.x-2.0\";s:7:\"version\";s:7:\"8.x-2.0\";s:3:\"tag\";s:7:\"8.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-2.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1476200639\";s:6:\"mdhash\";s:32:\"2925d6bd719093e43639f274f6519500\";s:8:\"filesize\";s:5:\"12853\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-2.0-rc1\";a:15:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-2.0-rc1\";s:7:\"version\";s:11:\"8.x-2.0-rc1\";s:3:\"tag\";s:11:\"8.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-2.0-rc1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1472752139\";s:6:\"mdhash\";s:32:\"e91b79742b4b879480e2e516166f5b2e\";s:8:\"filesize\";s:5:\"12442\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"8.x-2.0-beta1\";a:15:{s:4:\"name\";s:29:\"migrate_upgrade 8.x-2.0-beta1\";s:7:\"version\";s:13:\"8.x-2.0-beta1\";s:3:\"tag\";s:13:\"8.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-2.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1460667539\";s:6:\"mdhash\";s:32:\"69fefd64c7e3217c94282e3d09aee89c\";s:8:\"filesize\";s:5:\"12012\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"8.x-1.0\";a:14:{s:4:\"name\";s:23:\"migrate_upgrade 8.x-1.0\";s:7:\"version\";s:7:\"8.x-1.0\";s:3:\"tag\";s:7:\"8.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-1.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1457207339\";s:6:\"mdhash\";s:32:\"22bfb6ffe95b14f40cadf63bcbdbd7f0\";s:8:\"filesize\";s:5:\"23820\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"8.x-3.x-dev\";a:14:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-3.x-dev\";s:7:\"version\";s:11:\"8.x-3.x-dev\";s:3:\"tag\";s:7:\"8.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-3.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1540220580\";s:6:\"mdhash\";s:32:\"0f1c97c63b73f9c353db990f49491f1a\";s:8:\"filesize\";s:5:\"17864\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-2.x-dev\";a:14:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-2.x-dev\";s:7:\"version\";s:11:\"8.x-2.x-dev\";s:3:\"tag\";s:7:\"8.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-2.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1476200039\";s:6:\"mdhash\";s:32:\"715eff046231e26df02c17fa2270e1cd\";s:8:\"filesize\";s:5:\"12862\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"8.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"migrate_upgrade 8.x-1.x-dev\";s:7:\"version\";s:11:\"8.x-1.x-dev\";s:3:\"tag\";s:7:\"8.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/migrate_upgrade/releases/8.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/migrate_upgrade-8.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1457206439\";s:6:\"mdhash\";s:32:\"4e150d23083da6c340b1a75202f422ef\";s:8:\"filesize\";s:5:\"23820\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}s:10:\"last_fetch\";i:1540283844;}',1540370244),('update_available_releases','pixlar',_binary 'a:1:{s:10:\"last_fetch\";i:1540283846;}',1540370246),('update_available_releases','timber',_binary 'a:11:{s:5:\"title\";s:24:\"Timber One Page Template\";s:10:\"short_name\";s:6:\"timber\";s:4:\"type\";s:20:\"project_distribution\";s:11:\"api_version\";s:3:\"8.x\";s:16:\"supported_majors\";s:1:\"5\";s:13:\"default_major\";s:1:\"5\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/timber\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:1:{s:11:\"8.x-5.x-dev\";a:14:{s:4:\"name\";s:18:\"timber 8.x-5.x-dev\";s:7:\"version\";s:11:\"8.x-5.x-dev\";s:3:\"tag\";s:7:\"8.x-5.x\";s:13:\"version_major\";s:1:\"5\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/timber/releases/8.x-5.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/timber-8.x-5.x-dev.tar.gz\";s:4:\"date\";s:10:\"1526042884\";s:6:\"mdhash\";s:32:\"7a987fdeaf7783306cfd89bc5c5fa264\";s:8:\"filesize\";s:8:\"35496971\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}s:10:\"last_fetch\";i:1540283845;}',1540370245);
/*!40000 ALTER TABLE `key_value_expire` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_link_content`
--

DROP TABLE IF EXISTS `menu_link_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_link_content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `bundle` varchar(32) CHARACTER SET ascii NOT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `menu_link_content_field__uuid__value` (`uuid`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for menu_link_content entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_link_content`
--

LOCK TABLES `menu_link_content` WRITE;
/*!40000 ALTER TABLE `menu_link_content` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_link_content` VALUES (2,'menu_link_content','568db68d-d4e5-4430-9c6d-4d2af68850a9','en'),(3,'menu_link_content','5bdc6c3b-9fd4-48f9-b9fc-08e999514049','en'),(4,'menu_link_content','eefbb742-8e21-478b-9b97-1319c8ec15e4','en'),(5,'menu_link_content','d90984f7-a6c0-47ce-a11c-84f8ca01c9d3','en');
/*!40000 ALTER TABLE `menu_link_content` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_link_content_data`
--

DROP TABLE IF EXISTS `menu_link_content_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_link_content_data` (
  `id` int(10) unsigned NOT NULL,
  `bundle` varchar(32) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `menu_name` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `link__uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `link__title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `link__options` longblob COMMENT 'Serialized array of options for the link.',
  `external` tinyint(4) DEFAULT NULL,
  `rediscover` tinyint(4) DEFAULT NULL,
  `weight` int(11) DEFAULT NULL,
  `expanded` tinyint(4) DEFAULT NULL,
  `parent` varchar(255) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `enabled` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`,`langcode`),
  KEY `menu_link_content__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `menu_link_content_field__link__uri` (`link__uri`(30)),
  KEY `menu_link_content__enabled_bundle` (`enabled`,`bundle`,`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for menu_link_content entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_link_content_data`
--

LOCK TABLES `menu_link_content_data` WRITE;
/*!40000 ALTER TABLE `menu_link_content_data` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_link_content_data` VALUES (2,'menu_link_content','en','About',NULL,'main','internal:#about','',_binary 'a:0:{}',0,1,-49,0,NULL,1540198620,1,1),(3,'menu_link_content','en','Practice Areas',NULL,'main','internal:#practice-areas','',_binary 'a:0:{}',0,1,-48,0,NULL,1540199504,1,1),(4,'menu_link_content','en','our team',NULL,'main','internal:#our-team','',_binary 'a:0:{}',0,1,-47,0,NULL,1540201615,1,1),(5,'menu_link_content','en','Contact',NULL,'main','internal:#contact','',_binary 'a:0:{}',0,1,-46,0,NULL,1540204429,1,1);
/*!40000 ALTER TABLE `menu_link_content_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_tree`
--

DROP TABLE IF EXISTS `menu_tree`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_tree` (
  `menu_name` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ''tools'') are part of the same menu.',
  `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',
  `id` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'Unique machine name: the plugin ID.',
  `parent` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The plugin ID for the parent of this link.',
  `route_name` varchar(255) CHARACTER SET ascii DEFAULT NULL COMMENT 'The machine name of a defined Symfony Route this menu item represents.',
  `route_param_key` varchar(255) DEFAULT NULL COMMENT 'An encoded string of route parameters for loading by route.',
  `route_parameters` longblob COMMENT 'Serialized array of route parameters of this menu link.',
  `url` varchar(255) NOT NULL DEFAULT '' COMMENT 'The external path this link points to (when not using a route).',
  `title` longblob COMMENT 'The serialized title for the link. May be a TranslatableMarkup.',
  `description` longblob COMMENT 'The serialized description of this link - used for admin pages and title attribute. May be a TranslatableMarkup.',
  `class` text COMMENT 'The class for this link plugin.',
  `options` longblob COMMENT 'A serialized array of URL options, such as a query string or HTML attributes.',
  `provider` varchar(50) CHARACTER SET ascii NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `enabled` smallint(6) NOT NULL DEFAULT '1' COMMENT 'A flag for whether the link should be rendered in menus. (0 = a disabled menu item that may be shown on admin screens, 1 = a normal, visible link)',
  `discovered` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link was discovered, so can be purged on rebuild',
  `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `metadata` longblob COMMENT 'A serialized array of data that may be used by the plugin instance.',
  `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any enabled links have this link as a parent (1 = enabled children exist, 0 = no enabled children).',
  `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with empty parent will have depth == 1.',
  `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the parent link mlid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `form_class` varchar(255) DEFAULT NULL COMMENT 'meh',
  PRIMARY KEY (`mlid`),
  UNIQUE KEY `id` (`id`),
  KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),
  KEY `menu_parent_expand_child` (`menu_name`,`expanded`,`has_children`,`parent`(16)),
  KEY `route_values` (`route_name`(32),`route_param_key`(16))
) ENGINE=InnoDB AUTO_INCREMENT=105 DEFAULT CHARSET=utf8mb4 COMMENT='Contains the menu tree hierarchy.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_tree`
--

LOCK TABLES `menu_tree` WRITE;
/*!40000 ALTER TABLE `menu_tree` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_tree` VALUES ('admin',1,'system.admin','','system.admin','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Administration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,9,_binary 'a:0:{}',1,1,1,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',2,'system.admin_content','system.admin','system.admin_content','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Find and manage content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-10,_binary 'a:0:{}',1,2,1,2,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',3,'system.admin_structure','system.admin','system.admin_structure','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Structure\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Administer blocks, content types, menus, etc.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-8,_binary 'a:0:{}',1,2,1,3,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',4,'system.themes_page','system.admin','system.themes_page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Appearance\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Select and configure themes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-6,_binary 'a:0:{}',0,2,1,4,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',5,'system.modules_list','system.admin','system.modules_list','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Extend\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:52:\"Add and enable modules to extend site functionality.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-2,_binary 'a:0:{}',0,2,1,5,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',6,'system.admin_config','system.admin','system.admin_config','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Configuration\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Administer settings.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,0,_binary 'a:0:{}',1,2,1,6,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',7,'system.admin_config_media','system.admin_config','system.admin_config_media','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Media\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-10,_binary 'a:0:{}',1,3,1,6,7,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',8,'system.file_system_settings','system.admin_config_media','system.file_system_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"File system\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"Configure the location of uploaded files and how they are accessed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,0,_binary 'a:0:{}',0,4,1,6,7,8,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',9,'system.image_toolkit_settings','system.admin_config_media','system.image_toolkit_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Image toolkit\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,20,_binary 'a:0:{}',0,4,1,6,7,9,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',10,'system.admin_config_services','system.admin_config','system.admin_config_services','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Web services\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,0,_binary 'a:0:{}',1,3,1,6,10,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',11,'system.rss_feeds_settings','system.admin_config_services','system.rss_feeds_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"RSS publishing\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:115:\"Configure the site description, the number of items per feed, and whether feeds should be titles/teasers/full-text.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,0,_binary 'a:0:{}',0,4,1,6,10,11,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',12,'system.admin_config_development','system.admin_config','system.admin_config_development','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Development\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"Configure and use development tools.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-10,_binary 'a:0:{}',1,3,1,6,12,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',13,'system.site_maintenance_mode','system.admin_config_development','system.site_maintenance_mode','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Maintenance mode\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:62:\"Take the site offline for updates and other maintenance tasks.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-10,_binary 'a:0:{}',0,4,1,6,12,13,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',14,'system.performance_settings','system.admin_config_development','system.performance_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Performance\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Configure caching and bandwidth optimization.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-20,_binary 'a:0:{}',0,4,1,6,12,14,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',15,'system.logging_settings','system.admin_config_development','system.logging_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Logging and errors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:61:\"Configure the display of error messages and database logging.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-15,_binary 'a:0:{}',0,4,1,6,12,15,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',16,'system.admin_config_regional','system.admin_config','system.admin_config_regional','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Regional and language\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"Configure regional settings, localization, and translation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-5,_binary 'a:0:{}',1,3,1,6,16,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',17,'system.regional_settings','system.admin_config_regional','system.regional_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Regional settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Configure the locale and timezone settings.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-20,_binary 'a:0:{}',0,4,1,6,16,17,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',18,'entity.date_format.collection','system.admin_config_regional','entity.date_format.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"Date and time formats\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Configure how dates and times are displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-9,_binary 'a:0:{}',0,4,1,6,16,18,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',19,'system.admin_config_search','system.admin_config','system.admin_config_search','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Search and metadata\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:64:\"Configure site search, metadata, and search engine optimization.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-10,_binary 'a:0:{}',1,3,1,6,19,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',20,'system.admin_config_system','system.admin_config','system.admin_config_system','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"System\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"Configure basic site settings, actions, and cron.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-20,_binary 'a:0:{}',1,3,1,6,20,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',21,'system.site_information_settings','system.admin_config_system','system.site_information_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Basic site settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:77:\"Change site name, email address, slogan, default front page, and error pages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-20,_binary 'a:0:{}',0,4,1,6,20,21,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',22,'system.cron_settings','system.admin_config_system','system.cron_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Cron\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:40:\"Manage automatic site maintenance tasks.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,20,_binary 'a:0:{}',0,4,1,6,20,22,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',23,'system.admin_config_ui','system.admin_config','system.admin_config_ui','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"User interface\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:44:\"Configure the administrative user interface.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-15,_binary 'a:0:{}',1,3,1,6,23,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',24,'system.admin_config_workflow','system.admin_config','system.admin_config_workflow','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Workflow\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Manage the content workflow.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,5,_binary 'a:0:{}',1,3,1,6,24,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',25,'system.admin_config_content','system.admin_config','system.admin_config_content','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Content authoring\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"Configure content formatting and authoring.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,-15,_binary 'a:0:{}',1,3,1,6,25,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',26,'system.admin_reports','system.admin','system.admin_reports','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Reports\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"View reports, updates, and errors.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,5,_binary 'a:0:{}',1,2,1,26,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',27,'system.status','system.admin_reports','system.status','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Status report\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Get a status report about your site\'s operation.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','system',1,1,0,0,_binary 'a:0:{}',0,3,1,26,27,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',28,'user.admin_index','system.admin_config','user.admin_index','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"People\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Configure user accounts.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','user',1,1,0,-20,_binary 'a:0:{}',1,3,1,6,28,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',29,'entity.user.admin_form','user.admin_index','entity.user.admin_form','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:16:\"Account settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:105:\"Configure default user account settings, including fields, registration requirements, and email messages.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','user',1,1,0,-10,_binary 'a:0:{}',0,4,1,6,28,29,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',30,'entity.user.collection','system.admin','entity.user.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"People\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:45:\"Manage user accounts, roles, and permissions.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','user',1,1,0,4,_binary 'a:0:{}',0,2,1,30,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('account',31,'user.page','','user.page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"My account\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','user',1,1,0,-10,_binary 'a:0:{}',0,1,31,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('account',32,'user.logout','','','',_binary 'a:0:{}','',_binary 's:0:\"\";',_binary 's:0:\"\";','Drupal\\user\\Plugin\\Menu\\LoginLogoutMenuLink',_binary 'a:0:{}','user',1,1,0,10,_binary 'a:0:{}',0,1,32,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('main',33,'standard.front_page','','<front>','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Home\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','standard',1,1,0,-50,_binary 'a:0:{}',0,1,33,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('tools',34,'filter.tips_all','','filter.tips_all','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Compose tips\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','filter',0,1,0,0,_binary 'a:0:{}',0,1,34,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',35,'filter.admin_overview','system.admin_config_content','filter.admin_overview','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:24:\"Text formats and editors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"Select and configure text editors, and how content is filtered when displayed.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','filter',1,1,0,0,_binary 'a:0:{}',0,4,1,6,25,35,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',36,'block.admin_display','system.admin_structure','block.admin_display','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Block layout\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','block',1,1,0,0,_binary 'a:0:{}',0,3,1,3,36,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('tools',37,'node.add_page','','node.add_page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Add content\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','node',1,1,0,0,_binary 'a:0:{}',0,1,37,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',38,'entity.node_type.collection','system.admin_structure','entity.node_type.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Content types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:71:\"Create and manage fields, forms, and display settings for your content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','node',1,1,0,0,_binary 'a:0:{}',0,3,1,3,38,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',39,'comment.admin','system.admin_content','comment.admin','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Comments\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:59:\"List and edit site comments and the comment approval queue.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','comment',1,1,0,0,_binary 'a:0:{}',0,3,1,2,39,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',40,'entity.comment_type.collection','system.admin_structure','entity.comment_type.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Comment types\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:46:\"Manage form and displays settings of comments.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','comment',1,1,0,0,_binary 'a:0:{}',0,3,1,3,40,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',41,'config.sync','system.admin_config_development','config.sync','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Configuration synchronization\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:37:\"Import and export your configuration.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','config',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,41,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',42,'entity.contact_form.collection','system.admin_structure','entity.contact_form.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Contact forms\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Create and manage contact forms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','contact',1,1,0,0,_binary 'a:0:{}',0,3,1,3,42,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('footer',43,'contact.site_page','','contact.site_page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Contact\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','contact',1,1,0,0,_binary 'a:0:{}',0,1,43,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',44,'dblog.overview','system.admin_reports','dblog.overview','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Recent log messages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:43:\"View events that have recently been logged.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','dblog',1,1,0,-1,_binary 'a:0:{}',0,3,1,26,44,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',45,'dblog.page_not_found','system.admin_reports','dblog.page_not_found','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Top \'page not found\' errors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:36:\"View \'page not found\' errors (404s).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','dblog',1,1,0,0,_binary 'a:0:{}',0,3,1,26,45,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',46,'dblog.access_denied','system.admin_reports','dblog.access_denied','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:26:\"Top \'access denied\' errors\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"View \'access denied\' errors (403s).\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','dblog',1,1,0,0,_binary 'a:0:{}',0,3,1,26,46,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',47,'field_ui.display_mode','system.admin_structure','field_ui.display_mode','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Display modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:65:\"Configure what displays are available for your content and forms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','field_ui',1,1,0,0,_binary 'a:0:{}',1,3,1,3,47,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',48,'entity.entity_view_mode.collection','field_ui.display_mode','entity.entity_view_mode.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"View modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Manage custom view modes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','field_ui',1,1,0,0,_binary 'a:0:{}',0,4,1,3,47,48,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',49,'entity.entity_form_mode.collection','field_ui.display_mode','entity.entity_form_mode.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Form modes\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Manage custom form modes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','field_ui',1,1,0,0,_binary 'a:0:{}',0,4,1,3,47,49,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',50,'entity.field_storage_config.collection','system.admin_reports','entity.field_storage_config.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Field list\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:39:\"Overview of fields on all entity types.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','field_ui',1,1,0,0,_binary 'a:0:{}',0,3,1,26,50,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',51,'entity.taxonomy_vocabulary.collection','system.admin_structure','entity.taxonomy_vocabulary.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Taxonomy\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:67:\"Manage tagging, categorization, and classification of your content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','taxonomy',1,1,0,0,_binary 'a:0:{}',0,3,1,3,51,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',52,'help.main','system.admin','help.main','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:4:\"Help\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:48:\"Reference for usage, configuration, and modules.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','help',1,1,0,9,_binary 'a:0:{}',0,2,1,52,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',53,'entity.image_style.collection','system.admin_config_media','entity.image_style.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Image styles\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:78:\"Configure styles that can be used for resizing or adjusting images on display.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','image',1,1,0,0,_binary 'a:0:{}',0,4,1,6,7,53,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',54,'entity.menu.collection','system.admin_structure','entity.menu.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Menus\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:28:\"Manage menus and menu links.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','menu_ui',1,1,0,0,_binary 'a:0:{}',0,3,1,3,54,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',55,'path.admin_overview','system.admin_config_search','path.admin_overview','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"URL aliases\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:34:\"Add custom URLs to existing paths.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','path',1,1,0,-5,_binary 'a:0:{}',0,4,1,6,19,55,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',56,'entity.search_page.collection','system.admin_config_search','entity.search_page.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Search pages\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:51:\"Configure search pages and search indexing options.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','search',1,1,0,-10,_binary 'a:0:{}',0,4,1,6,19,56,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',57,'dblog.search','system.admin_reports','dblog.search','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Top search phrases\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"View most popular search phrases.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','',1,1,0,0,_binary 'a:0:{}',0,3,1,26,57,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('tools',58,'search.view','','search.view','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Search\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','search',0,1,0,0,_binary 'a:0:{}',0,1,58,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',59,'entity.shortcut_set.collection','system.admin_config_ui','entity.shortcut_set.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Shortcuts\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:29:\"Add and modify shortcut sets.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','shortcut',1,1,0,0,_binary 'a:0:{}',0,4,1,6,23,59,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',60,'entity.view.collection','system.admin_structure','entity.view.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:5:\"Views\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:35:\"Manage customized lists of content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','views_ui',1,1,0,0,_binary 'a:0:{}',0,3,1,3,60,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',61,'views_ui.reports_plugins','system.admin_reports','views_ui.reports_plugins','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Views plugins\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:38:\"Overview of plugins used in all views.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','views_ui',1,1,0,0,_binary 'a:0:{}',0,3,1,26,61,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',62,'update.status','system.admin_reports','update.status','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Available updates\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:82:\"Get a status report about available updates for your installed modules and themes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','update',1,1,0,-50,_binary 'a:0:{}',0,3,1,26,62,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',67,'migrate_drupal_ui.upgrade','system.admin_config_development','migrate_drupal_ui.upgrade','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:7:\"Upgrade\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:76:\"Upgrade content and configuration from either a Drupal 6 or a Drupal 7 site.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','migrate_drupal_ui',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,67,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',68,'migrate_drupal_ui.log','system.admin_reports','migrate_drupal_ui.log','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Upgrade log\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:21:\"View the upgrade log.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','migrate_drupal_ui',1,1,0,0,_binary 'a:0:{}',0,3,1,26,68,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',69,'migrate_tools.menu','system.admin_structure','entity.migration_group.list','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Migrations\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:27:\"Manage migration processes.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','migrate_tools',1,1,0,0,_binary 'a:0:{}',0,3,1,3,69,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('main',71,'menu_link_content:568db68d-d4e5-4430-9c6d-4d2af68850a9','','<none>','',_binary 'a:0:{}','',_binary 's:5:\"About\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent',_binary 'a:1:{s:8:\"fragment\";s:5:\"about\";}','menu_link_content',1,1,0,-49,_binary 'a:1:{s:9:\"entity_id\";s:1:\"2\";}',0,1,71,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),('main',72,'menu_link_content:5bdc6c3b-9fd4-48f9-b9fc-08e999514049','','<none>','',_binary 'a:0:{}','',_binary 's:14:\"Practice Areas\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent',_binary 'a:1:{s:8:\"fragment\";s:14:\"practice-areas\";}','menu_link_content',1,1,0,-48,_binary 'a:1:{s:9:\"entity_id\";s:1:\"3\";}',0,1,72,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),('main',73,'menu_link_content:eefbb742-8e21-478b-9b97-1319c8ec15e4','','<none>','',_binary 'a:0:{}','',_binary 's:8:\"our team\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent',_binary 'a:1:{s:8:\"fragment\";s:8:\"our-team\";}','menu_link_content',1,1,0,-47,_binary 'a:1:{s:9:\"entity_id\";s:1:\"4\";}',0,1,73,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),('main',74,'menu_link_content:d90984f7-a6c0-47ce-a11c-84f8ca01c9d3','','<none>','',_binary 'a:0:{}','',_binary 's:7:\"Contact\";',NULL,'Drupal\\menu_link_content\\Plugin\\Menu\\MenuLinkContent',_binary 'a:1:{s:8:\"fragment\";s:7:\"contact\";}','menu_link_content',1,1,0,-46,_binary 'a:1:{s:9:\"entity_id\";s:1:\"5\";}',0,1,74,0,0,0,0,0,0,0,0,'\\Drupal\\menu_link_content\\Form\\MenuLinkContentForm'),('admin',75,'twilio.admin_form','system.admin_config_system','twilio.admin_form','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:6:\"Twilio\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:31:\"Administer your twilio settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','twilio',1,1,0,0,_binary 'a:0:{}',0,4,1,6,20,75,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',76,'ga_reports.settings','system.admin_config_services','ga_reports.settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:33:\"Google Analytics Reports Settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:47:\"Configure Google Analytics account and reports.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','ga_reports',1,1,0,0,_binary 'a:0:{}',0,4,1,6,10,76,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',77,'views_view:views.ga_summary.page_1','system.admin_reports','view.ga_summary.page_1','',_binary 'a:0:{}','',_binary 's:24:\"Google Analytics Summary\";',_binary 's:36:\"View a traffic report for your site.\";','Drupal\\views\\Plugin\\Menu\\ViewsMenuLink',_binary 'a:0:{}','views',1,1,0,0,_binary 'a:2:{s:7:\"view_id\";s:10:\"ga_summary\";s:10:\"display_id\";s:6:\"page_1\";}',0,3,1,26,77,0,0,0,0,0,0,'Drupal\\views\\Plugin\\Menu\\Form\\ViewsMenuLinkForm'),('devel',78,'devel.admin_settings_link','','devel.admin_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Devel settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:131:\"Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the block administration page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,78,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',79,'devel.configs_list','','devel.configs_list','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:13:\"Config editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:19:\"Edit configuration.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,79,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',80,'devel.reinstall','','devel.reinstall','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:17:\"Reinstall Modules\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','\\Drupal\\devel\\Plugin\\Menu\\DestinationMenuLink',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,80,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',81,'devel.menu_rebuild','','devel.menu_rebuild','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Rebuild Menu\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','\\Drupal\\devel\\Plugin\\Menu\\DestinationMenuLink',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,81,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',82,'devel.state_system_page','','devel.state_system_page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"State editor\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:25:\"Edit state system values.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,82,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',83,'devel.theme_registry','','devel.theme_registry','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Theme registry\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,83,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',84,'devel.entity_info_page','','devel.entity_info_page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Entity Info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,84,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',85,'devel.field_info_page','','devel.field_info_page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:10:\"Field Info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,85,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',86,'devel.phpinfo','','system.php','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"PHPinfo()\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,86,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',87,'devel.execute_php','','devel.execute_php','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Execute PHP\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,87,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',88,'devel.session','','devel.session','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"View Session\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,88,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',89,'devel.elements_page','','devel.elements_page','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:12:\"Element Info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,89,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',90,'devel.cache_clear','','devel.cache_clear','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Cache clear\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','\\Drupal\\devel\\Plugin\\Menu\\DestinationMenuLink',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,90,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',91,'devel.run_cron','','devel.run_cron','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:8:\"Run cron\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','\\Drupal\\devel\\Plugin\\Menu\\DestinationMenuLink',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,91,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',92,'devel.container_info.service','','devel.container_info.service','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Container Info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,92,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',93,'devel.route_info','','devel.route_info','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Routes Info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,93,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',94,'devel.route_info.item','','devel.route_info.item','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:18:\"Current route info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','\\Drupal\\devel\\Plugin\\Menu\\RouteDetailMenuLink',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,94,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('devel',95,'devel.event_info','','devel.event_info','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:11:\"Events Info\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,1,95,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',96,'devel.admin_settings','system.admin_config_development','devel.admin_settings','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:14:\"Devel settings\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:131:\"Helper functions, pages, and blocks to assist Drupal developers. The devel blocks can be managed via the block administration page.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','devel',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,96,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',97,'devel_generate.vocabulary','system.admin_config_development','devel_generate.vocabulary','',_binary 'a:0:{}','',_binary 's:21:\"Generate vocabularies\";',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:80:\"Generate a given number of vocabularies. Optionally delete current vocabularies.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,97,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',98,'devel_generate.term','system.admin_config_development','devel_generate.term','',_binary 'a:0:{}','',_binary 's:14:\"Generate terms\";',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Generate a given number of terms. Optionally delete current terms.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,98,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',99,'devel_generate.content','system.admin_config_development','devel_generate.content','',_binary 'a:0:{}','',_binary 's:16:\"Generate content\";',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:70:\"Generate a given number of content. Optionally delete current content.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,99,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',100,'devel_generate.user','system.admin_config_development','devel_generate.user','',_binary 'a:0:{}','',_binary 's:14:\"Generate users\";',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:66:\"Generate a given number of users. Optionally delete current users.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,100,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',101,'devel_generate.menu','system.admin_config_development','devel_generate.menu','',_binary 'a:0:{}','',_binary 's:14:\"Generate menus\";',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:81:\"Generate a given number of menus and menu links. Optionally delete current menus.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','',1,1,0,0,_binary 'a:0:{}',0,4,1,6,12,101,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('tools',102,'content_moderation_notifications.menu','','entity.content_moderation_notification.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Content Moderation Notifications\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 's:0:\"\";','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','content_moderation_notifications',1,1,0,0,_binary 'a:0:{}',0,1,102,0,0,0,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',103,'entity.moderation_state_notifications.collection','system.admin_config_workflow','entity.content_moderation_notification.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:32:\"Content moderation notifications\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:49:\"Administer moderation states email notifications.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','content_moderation_notifications',1,1,0,21,_binary 'a:0:{}',0,4,1,6,24,103,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm'),('admin',104,'entity.workflow.collection','system.admin_config_workflow','entity.workflow.collection','',_binary 'a:0:{}','',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:9:\"Workflows\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}',_binary 'O:48:\"Drupal\\Core\\StringTranslation\\TranslatableMarkup\":3:{s:9:\"\0*\0string\";s:20:\"Configure workflows.\";s:12:\"\0*\0arguments\";a:0:{}s:10:\"\0*\0options\";a:0:{}}','Drupal\\Core\\Menu\\MenuLinkDefault',_binary 'a:0:{}','workflows',1,1,0,0,_binary 'a:0:{}',0,4,1,6,24,104,0,0,0,0,0,'Drupal\\Core\\Menu\\Form\\MenuLinkDefaultForm');
/*!40000 ALTER TABLE `menu_tree` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node`
--

DROP TABLE IF EXISTS `node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node` (
  `nid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `vid` int(10) unsigned DEFAULT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`nid`),
  UNIQUE KEY `node_field__uuid__value` (`uuid`),
  UNIQUE KEY `node__vid` (`vid`),
  KEY `node_field__type__target_id` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for node entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node`
--

LOCK TABLES `node` WRITE;
/*!40000 ALTER TABLE `node` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__body`
--

DROP TABLE IF EXISTS `node__body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field body.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__body`
--

LOCK TABLES `node__body` WRITE;
/*!40000 ALTER TABLE `node__body` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__comment`
--

DROP TABLE IF EXISTS `node__comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__comment` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field comment.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__comment`
--

LOCK TABLES `node__comment` WRITE;
/*!40000 ALTER TABLE `node__comment` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__comment` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_comments`
--

DROP TABLE IF EXISTS `node__field_comments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_comments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_comments_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_comments.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_comments`
--

LOCK TABLES `node__field_comments` WRITE;
/*!40000 ALTER TABLE `node__field_comments` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_comments` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_image`
--

DROP TABLE IF EXISTS `node__field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_image_target_id` (`field_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_image.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_image`
--

LOCK TABLES `node__field_image` WRITE;
/*!40000 ALTER TABLE `node__field_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_adv_image`
--

DROP TABLE IF EXISTS `node__field_migrate_example_adv_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_adv_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_adv_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_migrate_example_adv_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_migrate_example_adv_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_migrate_example_adv_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_migrate_example_adv_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_adv_image_target_id` (`field_migrate_example_adv_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_adv_image.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_adv_image`
--

LOCK TABLES `node__field_migrate_example_adv_image` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_adv_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_adv_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_beer_style`
--

DROP TABLE IF EXISTS `node__field_migrate_example_beer_style`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_beer_style` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_beer_style_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_beer_style_target_id` (`field_migrate_example_beer_style_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_beer…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_beer_style`
--

LOCK TABLES `node__field_migrate_example_beer_style` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_beer_style` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_beer_style` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_comments`
--

DROP TABLE IF EXISTS `node__field_migrate_example_comments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_comments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_comments_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_comments.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_comments`
--

LOCK TABLES `node__field_migrate_example_comments` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_comments` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_comments` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_country`
--

DROP TABLE IF EXISTS `node__field_migrate_example_country`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_country` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_country_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_country.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_country`
--

LOCK TABLES `node__field_migrate_example_country` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_country` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_country` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_image`
--

DROP TABLE IF EXISTS `node__field_migrate_example_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_migrate_example_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_migrate_example_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_migrate_example_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_migrate_example_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_image_target_id` (`field_migrate_example_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_image.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_image`
--

LOCK TABLES `node__field_migrate_example_image` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_top_vintag`
--

DROP TABLE IF EXISTS `node__field_migrate_example_top_vintag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_top_vintag` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_top_vintag_value` int(11) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_top…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_top_vintag`
--

LOCK TABLES `node__field_migrate_example_top_vintag` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_top_vintag` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_top_vintag` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_wine_best`
--

DROP TABLE IF EXISTS `node__field_migrate_example_wine_best`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_wine_best` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_best_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_wine_best_target_id` (`field_migrate_example_wine_best_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_wine_best.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_wine_best`
--

LOCK TABLES `node__field_migrate_example_wine_best` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_best` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_best` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_wine_ratin`
--

DROP TABLE IF EXISTS `node__field_migrate_example_wine_ratin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_wine_ratin` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_ratin_value` decimal(10,0) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_wine…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_wine_ratin`
--

LOCK TABLES `node__field_migrate_example_wine_ratin` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_ratin` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_ratin` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_wine_regio`
--

DROP TABLE IF EXISTS `node__field_migrate_example_wine_regio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_wine_regio` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_regio_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_wine_regio_target_id` (`field_migrate_example_wine_regio_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_wine…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_wine_regio`
--

LOCK TABLES `node__field_migrate_example_wine_regio` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_regio` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_regio` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_migrate_example_wine_var`
--

DROP TABLE IF EXISTS `node__field_migrate_example_wine_var`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_migrate_example_wine_var` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_var_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_wine_var_target_id` (`field_migrate_example_wine_var_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_migrate_example_wine_var.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_migrate_example_wine_var`
--

LOCK TABLES `node__field_migrate_example_wine_var` WRITE;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_var` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_migrate_example_wine_var` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node__field_tags`
--

DROP TABLE IF EXISTS `node__field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node__field_tags` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_tags_target_id` (`field_tags_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for node field field_tags.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node__field_tags`
--

LOCK TABLES `node__field_tags` WRITE;
/*!40000 ALTER TABLE `node__field_tags` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node__field_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_access`
--

DROP TABLE IF EXISTS `node_access`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_access` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record affects.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language.langcode of this node.',
  `fallback` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether this record should be used as a fallback if a language condition is not provided.',
  `gid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The grant ID a user must possess in the specified realm to gain this row''s privileges on the node.',
  `realm` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The realm in which the user must possess the grant ID. Modules can define one or more realms by implementing hook_node_grants().',
  `grant_view` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can view this node.',
  `grant_update` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can edit this node.',
  `grant_delete` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can delete this node.',
  PRIMARY KEY (`nid`,`gid`,`realm`,`langcode`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Identifies which realm/grant pairs a user must possess in…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_access`
--

LOCK TABLES `node_access` WRITE;
/*!40000 ALTER TABLE `node_access` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_access` VALUES (0,'',1,0,'all',1,0,0);
/*!40000 ALTER TABLE `node_access` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_field_data`
--

DROP TABLE IF EXISTS `node_field_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_field_data` (
  `nid` int(10) unsigned NOT NULL,
  `vid` int(10) unsigned NOT NULL,
  `type` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `status` tinyint(4) NOT NULL,
  `title` varchar(255) NOT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `created` int(11) NOT NULL,
  `changed` int(11) NOT NULL,
  `promote` tinyint(4) NOT NULL,
  `sticky` tinyint(4) NOT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`nid`,`langcode`),
  KEY `node__id__default_langcode__langcode` (`nid`,`default_langcode`,`langcode`),
  KEY `node__vid` (`vid`),
  KEY `node_field__type__target_id` (`type`),
  KEY `node_field__uid__target_id` (`uid`),
  KEY `node_field__created` (`created`),
  KEY `node_field__changed` (`changed`),
  KEY `node__status_type` (`status`,`type`,`nid`),
  KEY `node__frontpage` (`promote`,`status`,`sticky`,`created`),
  KEY `node__title_type` (`title`(191),`type`(4))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for node entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_field_data`
--

LOCK TABLES `node_field_data` WRITE;
/*!40000 ALTER TABLE `node_field_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_field_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_field_revision`
--

DROP TABLE IF EXISTS `node_field_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_field_revision` (
  `nid` int(10) unsigned NOT NULL,
  `vid` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `status` tinyint(4) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `uid` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  `created` int(11) DEFAULT NULL,
  `changed` int(11) DEFAULT NULL,
  `promote` tinyint(4) DEFAULT NULL,
  `sticky` tinyint(4) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  `revision_translation_affected` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`vid`,`langcode`),
  KEY `node__id__default_langcode__langcode` (`nid`,`default_langcode`,`langcode`),
  KEY `node_field__uid__target_id` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision data table for node entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_field_revision`
--

LOCK TABLES `node_field_revision` WRITE;
/*!40000 ALTER TABLE `node_field_revision` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_field_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision`
--

DROP TABLE IF EXISTS `node_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision` (
  `nid` int(10) unsigned NOT NULL,
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `revision_uid` int(10) unsigned DEFAULT NULL COMMENT 'The ID of the target entity.',
  `revision_timestamp` int(11) DEFAULT NULL,
  `revision_log` longtext,
  `revision_default` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`vid`),
  KEY `node__nid` (`nid`),
  KEY `node_field__langcode` (`langcode`),
  KEY `node_field__revision_uid__target_id` (`revision_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The revision table for node entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision`
--

LOCK TABLES `node_revision` WRITE;
/*!40000 ALTER TABLE `node_revision` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__body`
--

DROP TABLE IF EXISTS `node_revision__body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__body` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext NOT NULL,
  `body_summary` longtext,
  `body_format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field body.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__body`
--

LOCK TABLES `node_revision__body` WRITE;
/*!40000 ALTER TABLE `node_revision__body` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__comment`
--

DROP TABLE IF EXISTS `node_revision__comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__comment` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field comment.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__comment`
--

LOCK TABLES `node_revision__comment` WRITE;
/*!40000 ALTER TABLE `node_revision__comment` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__comment` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_comments`
--

DROP TABLE IF EXISTS `node_revision__field_comments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_comments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_comments_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_comments.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_comments`
--

LOCK TABLES `node_revision__field_comments` WRITE;
/*!40000 ALTER TABLE `node_revision__field_comments` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_comments` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_image`
--

DROP TABLE IF EXISTS `node_revision__field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_image_target_id` (`field_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_image.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_image`
--

LOCK TABLES `node_revision__field_image` WRITE;
/*!40000 ALTER TABLE `node_revision__field_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_adv_image`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_adv_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_adv_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_adv_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_migrate_example_adv_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_migrate_example_adv_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_migrate_example_adv_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_migrate_example_adv_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_adv_image_target_id` (`field_migrate_example_adv_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_adv_image`
--

LOCK TABLES `node_revision__field_migrate_example_adv_image` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_adv_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_adv_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_beer_style`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_beer_style`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_beer_style` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_beer_style_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_beer_style_target_id` (`field_migrate_example_beer_style_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_beer_style`
--

LOCK TABLES `node_revision__field_migrate_example_beer_style` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_beer_style` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_beer_style` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_comments`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_comments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_comments` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_comments_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this entity: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_comments`
--

LOCK TABLES `node_revision__field_migrate_example_comments` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_comments` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_comments` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_country`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_country`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_country` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_country_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_country`
--

LOCK TABLES `node_revision__field_migrate_example_country` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_country` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_country` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_image`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_image` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_image_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `field_migrate_example_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `field_migrate_example_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `field_migrate_example_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_migrate_example_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_image_target_id` (`field_migrate_example_image_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_image`
--

LOCK TABLES `node_revision__field_migrate_example_image` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_top_vintag`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_top_vintag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_top_vintag` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_top_vintag_value` int(11) NOT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_top_vintag`
--

LOCK TABLES `node_revision__field_migrate_example_top_vintag` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_top_vintag` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_top_vintag` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_wine_best`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_wine_best`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_wine_best` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_best_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_wine_best_target_id` (`field_migrate_example_wine_best_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_wine_best`
--

LOCK TABLES `node_revision__field_migrate_example_wine_best` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_best` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_best` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_wine_ratin`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_wine_ratin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_wine_ratin` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_ratin_value` decimal(10,0) NOT NULL,
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_wine_ratin`
--

LOCK TABLES `node_revision__field_migrate_example_wine_ratin` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_ratin` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_ratin` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_wine_regio`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_wine_regio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_wine_regio` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_regio_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_wine_regio_target_id` (`field_migrate_example_wine_regio_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_wine_regio`
--

LOCK TABLES `node_revision__field_migrate_example_wine_regio` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_regio` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_regio` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_migrate_example_wine_var`
--

DROP TABLE IF EXISTS `node_revision__field_migrate_example_wine_var`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_migrate_example_wine_var` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_wine_var_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_wine_var_target_id` (`field_migrate_example_wine_var_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_migrate…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_migrate_example_wine_var`
--

LOCK TABLES `node_revision__field_migrate_example_wine_var` WRITE;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_var` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_migrate_example_wine_var` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision__field_tags`
--

DROP TABLE IF EXISTS `node_revision__field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision__field_tags` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`revision_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_tags_target_id` (`field_tags_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Revision archive storage for node field field_tags.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision__field_tags`
--

LOCK TABLES `node_revision__field_tags` WRITE;
/*!40000 ALTER TABLE `node_revision__field_tags` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `node_revision__field_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `queue`
--

DROP TABLE IF EXISTS `queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The queue name.',
  `data` longblob COMMENT 'The arbitrary data for the item.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the claim lease expires on the item.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',
  PRIMARY KEY (`item_id`),
  KEY `name_created` (`name`,`created`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB AUTO_INCREMENT=41 DEFAULT CHARSET=utf8mb4 COMMENT='Stores items in queues.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue`
--

LOCK TABLES `queue` WRITE;
/*!40000 ALTER TABLE `queue` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `queue` VALUES (39,'update_fetch_tasks',_binary 'a:6:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"package\";s:5:\"Other\";s:7:\"version\";s:7:\"8.x-1.0\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";i:1531440825;s:16:\"_info_file_ctime\";i:1540189886;}s:9:\"datestamp\";i:1531440825;s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;}',0,1540287206),(40,'update_fetch_tasks',_binary 'a:6:{s:4:\"name\";s:7:\"justice\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"justice\";s:7:\"package\";s:7:\"theming\";s:7:\"version\";s:11:\"8.x-5.x-dev\";s:7:\"project\";s:7:\"justice\";s:9:\"datestamp\";i:1526042904;s:16:\"_info_file_ctime\";i:1540291313;}s:9:\"datestamp\";i:1526042904;s:8:\"includes\";a:1:{s:7:\"justice\";s:7:\"justice\";}s:12:\"project_type\";s:5:\"theme\";s:14:\"project_status\";b:1;}',0,1540292951);
/*!40000 ALTER TABLE `queue` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `router`
--

DROP TABLE IF EXISTS `router`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `router` (
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Machine name of this route',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The path for this URI',
  `pattern_outline` varchar(255) NOT NULL DEFAULT '' COMMENT 'The pattern',
  `fit` int(11) NOT NULL DEFAULT '0' COMMENT 'A numeric representation of how specific the path is.',
  `route` longblob COMMENT 'A serialized Route object',
  `number_parts` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Number of parts in this router path.',
  PRIMARY KEY (`name`),
  KEY `pattern_outline_parts` (`pattern_outline`(191),`number_parts`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maps paths to various callbacks (access, page and title)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `router`
--

LOCK TABLES `router` WRITE;
/*!40000 ALTER TABLE `router` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `router` VALUES ('<current>','/<current>','/<current>',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":666:{a:9:{s:4:\"path\";s:10:\"/<current>\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:0:{}s:12:\"requirements\";a:0:{}s:7:\"options\";a:1:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":328:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/\\<current\\>$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/<current>\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:10:\"/<current>\";s:8:\"numParts\";i:1;}}}}',1),('<front>','/','/',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":733:{a:9:{s:4:\"path\";s:1:\"/\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:6:\"_title\";s:4:\"Home\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":296:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:7:\"#^/$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:1:\"/\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:1:\"/\";s:8:\"numParts\";i:1;}}}}',1),('<nolink>','/','/',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":728:{a:9:{s:4:\"path\";s:1:\"/\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:0:{}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"_no_path\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":296:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:7:\"#^/$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:1:\"/\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:1:\"/\";s:8:\"numParts\";i:1;}}}}',1),('<none>','/','/',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":728:{a:9:{s:4:\"path\";s:1:\"/\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:0:{}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"_no_path\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":296:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:7:\"#^/$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:1:\"/\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:1:\"/\";s:8:\"numParts\";i:1;}}}}',1),('big_pipe.nojs','/big_pipe/no-js','/big_pipe/no-js',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":915:{a:9:{s:4:\"path\";s:15:\"/big_pipe/no-js\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:59:\"\\Drupal\\big_pipe\\Controller\\BigPipeController:setNoJsCookie\";s:6:\"_title\";s:19:\"BigPipe no-JS check\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"no_cache\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":342:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:22:\"#^/big_pipe/no\\-js$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/big_pipe/no-js\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:15:\"/big_pipe/no-js\";s:8:\"numParts\";i:2;}}}}',2),('block.admin_add','/admin/structure/block/add/{plugin_id}/{theme}','/admin/structure/block/add/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1294:{a:9:{s:4:\"path\";s:46:\"/admin/structure/block/add/{plugin_id}/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:66:\"\\Drupal\\block\\Controller\\BlockAddController::blockAddConfigureForm\";s:5:\"theme\";N;s:6:\"_title\";s:15:\"Configure block\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":646:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"plugin_id\";i:1;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/block/add/(?P<plugin_id>[^/]++)(?:/(?P<theme>[^/]++))?$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"plugin_id\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/block/add\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"plugin_id\";i:1;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/structure/block/add/%\";s:8:\"numParts\";i:6;}}}}',6),('block.admin_demo','/admin/structure/block/demo/{theme}','/admin/structure/block/demo/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1185:{a:9:{s:4:\"path\";s:35:\"/admin/structure/block/demo/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:46:\"\\Drupal\\block\\Controller\\BlockController::demo\";s:15:\"_title_callback\";s:21:\"theme_handler:getName\";}s:12:\"requirements\";a:2:{s:13:\"_access_theme\";s:4:\"TRUE\";s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:0;s:14:\"_access_checks\";a:2:{i:0;s:18:\"access_check.theme\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":504:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/structure/block/demo/(?P<theme>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/block/demo\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:29:\"/admin/structure/block/demo/%\";s:8:\"numParts\";i:5;}}}}',5),('block.admin_display','/admin/structure/block','/admin/structure/block',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":956:{a:9:{s:4:\"path\";s:22:\"/admin/structure/block\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:53:\"\\Drupal\\block\\Controller\\BlockListController::listing\";s:6:\"_title\";s:12:\"Block layout\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/structure/block$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/block\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/structure/block\";s:8:\"numParts\";i:3;}}}}',3),('block.admin_display_theme','/admin/structure/block/list/{theme}','/admin/structure/block/list/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1173:{a:9:{s:4:\"path\";s:35:\"/admin/structure/block/list/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:53:\"\\Drupal\\block\\Controller\\BlockListController::listing\";s:6:\"_title\";s:12:\"Block layout\";}s:12:\"requirements\";a:2:{s:13:\"_access_theme\";s:4:\"TRUE\";s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:18:\"access_check.theme\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":504:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/structure/block/list/(?P<theme>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/block/list\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:29:\"/admin/structure/block/list/%\";s:8:\"numParts\";i:5;}}}}',5),('block.admin_library','/admin/structure/block/library/{theme}','/admin/structure/block/library/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1190:{a:9:{s:4:\"path\";s:38:\"/admin/structure/block/library/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:59:\"\\Drupal\\block\\Controller\\BlockLibraryController::listBlocks\";s:6:\"_title\";s:11:\"Place block\";}s:12:\"requirements\";a:2:{s:13:\"_access_theme\";s:4:\"TRUE\";s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:18:\"access_check.theme\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":513:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/structure/block/library/(?P<theme>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/structure/block/library\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:32:\"/admin/structure/block/library/%\";s:8:\"numParts\";i:5;}}}}',5),('block.category_autocomplete','/block-category/autocomplete','/block-category/autocomplete',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":940:{a:9:{s:4:\"path\";s:28:\"/block-category/autocomplete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:69:\"\\Drupal\\block\\Controller\\CategoryAutocompleteController::autocomplete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/block\\-category/autocomplete$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/block-category/autocomplete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:28:\"/block-category/autocomplete\";s:8:\"numParts\";i:2;}}}}',2),('block_content.add_form','/block/add/{block_content_type}','/block/add/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1344:{a:9:{s:4:\"path\";s:31:\"/block/add/{block_content_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:64:\"\\Drupal\\block_content\\Controller\\BlockContentController::addForm\";s:15:\"_title_callback\";s:71:\"Drupal\\block_content\\Controller\\BlockContentController::getAddFormTitle\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":507:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/block/add/(?P<block_content_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/block/add\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:12:\"/block/add/%\";s:8:\"numParts\";i:3;}}}}',3),('block_content.add_page','/block/add','/block/add',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":919:{a:9:{s:4:\"path\";s:10:\"/block/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\block_content\\Controller\\BlockContentController::add\";s:6:\"_title\";s:16:\"Add custom block\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":326:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:16:\"#^/block/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/block/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:10:\"/block/add\";s:8:\"numParts\";i:2;}}}}',2),('block_content.type_add','/admin/structure/block/block-content/types/add','/admin/structure/block/block-content/types/add',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1014:{a:9:{s:4:\"path\";s:46:\"/admin/structure/block/block-content/types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:22:\"block_content_type.add\";s:6:\"_title\";s:3:\"Add\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":436:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/structure/block/block\\-content/types/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/structure/block/block-content/types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:46:\"/admin/structure/block/block-content/types/add\";s:8:\"numParts\";i:6;}}}}',6),('comment.admin','/admin/content/comment','/admin/content/comment',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1277:{a:9:{s:4:\"path\";s:22:\"/admin/content/comment\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:14:\"page_published\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/content/comment$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/content/comment\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/content/comment\";s:8:\"numParts\";i:3;}}}}',3),('comment.admin_approval','/admin/content/comment/approval','/admin/content/comment/approval',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1315:{a:9:{s:4:\"path\";s:31:\"/admin/content/comment/approval\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:15:\"page_unapproved\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":390:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/content/comment/approval$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/content/comment/approval\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/content/comment/approval\";s:8:\"numParts\";i:4;}}}}',4),('comment.approve','/comment/{comment}/approve','/comment/%/approve',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1326:{a:9:{s:4:\"path\";s:26:\"/comment/{comment}/approve\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:7:\"Approve\";s:11:\"_controller\";s:60:\"\\Drupal\\comment\\Controller\\CommentController::commentApprove\";s:11:\"entity_type\";s:7:\"comment\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:15:\"comment.approve\";s:11:\"_csrf_token\";s:4:\"TRUE\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":507:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/comment/(?P<comment>\\d+)/approve$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/approve\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:18:\"/comment/%/approve\";s:8:\"numParts\";i:3;}}}}',3),('comment.multiple_delete_confirm','/admin/content/comment/delete','/admin/content/comment/delete',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1016:{a:9:{s:4:\"path\";s:29:\"/admin/content/comment/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:6:\"Delete\";s:5:\"_form\";s:42:\"\\Drupal\\comment\\Form\\ConfirmDeleteMultiple\";s:14:\"entity_type_id\";s:7:\"comment\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:7:\"comment\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/content/comment/delete$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/content/comment/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/content/comment/delete\";s:8:\"numParts\";i:4;}}}}',4),('comment.new_comments_node_links','/comments/render_new_comments_node_links','/comments/render_new_comments_node_links',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":987:{a:9:{s:4:\"path\";s:40:\"/comments/render_new_comments_node_links\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:72:\"\\Drupal\\comment\\Controller\\CommentController::renderNewCommentsNodeLinks\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":416:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/comments/render_new_comments_node_links$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/comments/render_new_comments_node_links\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:40:\"/comments/render_new_comments_node_links\";s:8:\"numParts\";i:2;}}}}',2),('comment.node_redirect','/comment/{node}/reply','/comment/%/reply',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1204:{a:9:{s:4:\"path\";s:21:\"/comment/{node}/reply\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:57:\"Drupal\\comment\\Controller\\CommentController::redirectNode\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:9:\"node.view\";s:20:\"_module_dependencies\";s:4:\"node\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":489:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/comment/(?P<node>\\d+)/reply$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/reply\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:16:\"/comment/%/reply\";s:8:\"numParts\";i:3;}}}}',3),('comment.reply','/comment/reply/{entity_type}/{entity}/{field_name}/{pid}','/comment/reply/%/%/%',24,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1696:{a:9:{s:4:\"path\";s:56:\"/comment/reply/{entity_type}/{entity}/{field_name}/{pid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:58:\"\\Drupal\\comment\\Controller\\CommentController::getReplyForm\";s:6:\"_title\";s:15:\"Add new comment\";s:3:\"pid\";N;}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:61:\"\\Drupal\\comment\\Controller\\CommentController::replyFormAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":893:{a:11:{s:4:\"vars\";a:4:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:3:\"pid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/comment/reply/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)(?:/(?P<pid>[^/]++))?$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"pid\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/comment/reply\";}}s:9:\"path_vars\";a:4:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:3:\"pid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:24;s:14:\"patternOutline\";s:20:\"/comment/reply/%/%/%\";s:8:\"numParts\";i:6;}}}}',6),('config.diff','/admin/config/development/configuration/sync/diff/{source_name}/{target_name}','/admin/config/development/configuration/sync/diff/%',126,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1395:{a:9:{s:4:\"path\";s:77:\"/admin/config/development/configuration/sync/diff/{source_name}/{target_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\config\\Controller\\ConfigController::diff\";s:11:\"target_name\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"synchronize configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":755:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"source_name\";i:1;s:11:\"target_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:108:\"#^/admin/config/development/configuration/sync/diff/(?P<source_name>[^/]++)(?:/(?P<target_name>[^/]++))?$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"target_name\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"source_name\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:49:\"/admin/config/development/configuration/sync/diff\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"source_name\";i:1;s:11:\"target_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:126;s:14:\"patternOutline\";s:51:\"/admin/config/development/configuration/sync/diff/%\";s:8:\"numParts\";i:8;}}}}',8),('config.diff_collection','/admin/config/development/configuration/sync/diff_collection/{collection}/{source_name}/{target_name}','/admin/config/development/configuration/sync/diff_collection/%/%',252,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1602:{a:9:{s:4:\"path\";s:101:\"/admin/config/development/configuration/sync/diff_collection/{collection}/{source_name}/{target_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\config\\Controller\\ConfigController::diff\";s:11:\"target_name\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"synchronize configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":937:{a:11:{s:4:\"vars\";a:3:{i:0;s:10:\"collection\";i:1;s:11:\"source_name\";i:2;s:11:\"target_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:142:\"#^/admin/config/development/configuration/sync/diff_collection/(?P<collection>[^/]++)/(?P<source_name>[^/]++)(?:/(?P<target_name>[^/]++))?$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"target_name\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"source_name\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"collection\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:60:\"/admin/config/development/configuration/sync/diff_collection\";}}s:9:\"path_vars\";a:3:{i:0;s:10:\"collection\";i:1;s:11:\"source_name\";i:2;s:11:\"target_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:252;s:14:\"patternOutline\";s:64:\"/admin/config/development/configuration/sync/diff_collection/%/%\";s:8:\"numParts\";i:9;}}}}',9),('config.export_download','/admin/config/development/configuration/full/export-download','/admin/config/development/configuration/full/export-download',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1085:{a:9:{s:4:\"path\";s:60:\"/admin/config/development/configuration/full/export-download\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\config\\Controller\\ConfigController::downloadExport\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"export configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":478:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/config/development/configuration/full/export\\-download$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:60:\"/admin/config/development/configuration/full/export-download\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:60:\"/admin/config/development/configuration/full/export-download\";s:8:\"numParts\";i:6;}}}}',6),('config.export_full','/admin/config/development/configuration/full/export','/admin/config/development/configuration/full/export',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1045:{a:9:{s:4:\"path\";s:51:\"/admin/config/development/configuration/full/export\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"\\Drupal\\config\\Form\\ConfigExportForm\";s:6:\"_title\";s:6:\"Export\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"export configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":450:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/config/development/configuration/full/export$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:51:\"/admin/config/development/configuration/full/export\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:51:\"/admin/config/development/configuration/full/export\";s:8:\"numParts\";i:6;}}}}',6),('config.export_single','/admin/config/development/configuration/single/export/{config_type}/{config_name}','/admin/config/development/configuration/single/export',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1450:{a:9:{s:4:\"path\";s:81:\"/admin/config/development/configuration/single/export/{config_type}/{config_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:6:\"_title\";s:13:\"Single export\";s:5:\"_form\";s:42:\"\\Drupal\\config\\Form\\ConfigSingleExportForm\";s:11:\"config_type\";N;s:11:\"config_name\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"export configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":769:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"config_type\";i:1;s:11:\"config_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:117:\"#^/admin/config/development/configuration/single/export(?:/(?P<config_type>[^/]++)(?:/(?P<config_name>[^/]++))?)?$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"config_name\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"config_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:53:\"/admin/config/development/configuration/single/export\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"config_type\";i:1;s:11:\"config_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:53:\"/admin/config/development/configuration/single/export\";s:8:\"numParts\";i:8;}}}}',8),('config.import_full','/admin/config/development/configuration/full/import','/admin/config/development/configuration/full/import',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1045:{a:9:{s:4:\"path\";s:51:\"/admin/config/development/configuration/full/import\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"\\Drupal\\config\\Form\\ConfigImportForm\";s:6:\"_title\";s:6:\"Import\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"import configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":450:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/config/development/configuration/full/import$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:51:\"/admin/config/development/configuration/full/import\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:51:\"/admin/config/development/configuration/full/import\";s:8:\"numParts\";i:6;}}}}',6),('config.import_single','/admin/config/development/configuration/single/import','/admin/config/development/configuration/single/import',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1067:{a:9:{s:4:\"path\";s:53:\"/admin/config/development/configuration/single/import\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:13:\"Single import\";s:5:\"_form\";s:42:\"\\Drupal\\config\\Form\\ConfigSingleImportForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"import configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":456:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/admin/config/development/configuration/single/import$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:53:\"/admin/config/development/configuration/single/import\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:53:\"/admin/config/development/configuration/single/import\";s:8:\"numParts\";i:6;}}}}',6),('config.sync','/admin/config/development/configuration','/admin/config/development/configuration',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1002:{a:9:{s:4:\"path\";s:39:\"/admin/config/development/configuration\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:30:\"\\Drupal\\config\\Form\\ConfigSync\";s:6:\"_title\";s:11:\"Synchronize\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"synchronize configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":414:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/development/configuration$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/development/configuration\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:39:\"/admin/config/development/configuration\";s:8:\"numParts\";i:4;}}}}',4),('contact.form_add','/admin/structure/contact/add','/admin/structure/contact/add',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":956:{a:9:{s:4:\"path\";s:28:\"/admin/structure/contact/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"contact_form.add\";s:6:\"_title\";s:16:\"Add contact form\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer contact forms\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/structure/contact/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/contact/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/structure/contact/add\";s:8:\"numParts\";i:4;}}}}',4),('contact.site_page','/contact','/contact',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1051:{a:9:{s:4:\"path\";s:8:\"/contact\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:7:\"Contact\";s:11:\"_controller\";s:61:\"\\Drupal\\contact\\Controller\\ContactController::contactSitePage\";s:12:\"contact_form\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"access site-wide contact form\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":318:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:14:\"#^/contact$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/contact\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:8:\"/contact\";s:8:\"numParts\";i:1;}}}}',1),('content_moderation.admin_moderated_content','/admin/content/moderated','/admin/content/moderated',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1318:{a:9:{s:4:\"path\";s:24:\"/admin/content/moderated\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:17:\"Moderated content\";s:7:\"view_id\";s:17:\"moderated_content\";s:10:\"display_id\";s:17:\"moderated_content\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:28:\"view any unpublished content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":368:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/admin/content/moderated$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/content/moderated\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/content/moderated\";s:8:\"numParts\";i:3;}}}}',3),('content_moderation.workflow_type_edit_form','/admin/config/workflow/workflows/manage/{workflow}/type/{entity_type_id}','/admin/config/workflow/workflows/manage/%/type/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1643:{a:9:{s:4:\"path\";s:72:\"/admin/config/workflow/workflows/manage/{workflow}/type/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:73:\"\\Drupal\\content_moderation\\Form\\ContentModerationConfigureEntityTypesForm\";s:15:\"_title_callback\";s:83:\"\\Drupal\\content_moderation\\Form\\ContentModerationConfigureEntityTypesForm::getTitle\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer workflows\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":769:{a:11:{s:4:\"vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/type/(?P<entity_type_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/type\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:48:\"/admin/config/workflow/workflows/manage/%/type/%\";s:8:\"numParts\";i:8;}}}}',8),('contextual.render','/contextual/render','/contextual/render',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":883:{a:9:{s:4:\"path\";s:18:\"/contextual/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:47:\"\\Drupal\\contextual\\ContextualController::render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"access contextual links\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":350:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/contextual/render$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/contextual/render\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:18:\"/contextual/render\";s:8:\"numParts\";i:2;}}}}',2),('dblog.access_denied','/admin/reports/access-denied','/admin/reports/access-denied',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1032:{a:9:{s:4:\"path\";s:28:\"/admin/reports/access-denied\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:26:\"Top \'access denied\' errors\";s:11:\"_controller\";s:56:\"\\Drupal\\dblog\\Controller\\DbLogController::topLogMessages\";s:4:\"type\";s:13:\"access denied\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/reports/access\\-denied$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/access-denied\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:28:\"/admin/reports/access-denied\";s:8:\"numParts\";i:3;}}}}',3),('dblog.confirm','/admin/reports/dblog/confirm','/admin/reports/dblog/confirm',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":988:{a:9:{s:4:\"path\";s:28:\"/admin/reports/dblog/confirm\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\dblog\\Form\\DblogClearLogConfirmForm\";s:6:\"_title\";s:34:\"Confirm delete recent log messages\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/reports/dblog/confirm$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/dblog/confirm\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/reports/dblog/confirm\";s:8:\"numParts\";i:4;}}}}',4),('dblog.event','/admin/reports/dblog/event/{event_id}','/admin/reports/dblog/event/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1119:{a:9:{s:4:\"path\";s:37:\"/admin/reports/dblog/event/{event_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\dblog\\Controller\\DbLogController::eventDetails\";s:6:\"_title\";s:7:\"Details\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":513:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"event_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/reports/dblog/event/(?P<event_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"event_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/reports/dblog/event\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"event_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/reports/dblog/event/%\";s:8:\"numParts\";i:5;}}}}',5),('dblog.overview','/admin/reports/dblog','/admin/reports/dblog',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1271:{a:9:{s:4:\"path\";s:20:\"/admin/reports/dblog\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:19:\"Recent log messages\";s:7:\"view_id\";s:8:\"watchdog\";s:10:\"display_id\";s:4:\"page\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"access site reports\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/reports/dblog$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/reports/dblog\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/reports/dblog\";s:8:\"numParts\";i:3;}}}}',3),('dblog.page_not_found','/admin/reports/page-not-found','/admin/reports/page-not-found',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1039:{a:9:{s:4:\"path\";s:29:\"/admin/reports/page-not-found\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:27:\"Top \'page not found\' errors\";s:11:\"_controller\";s:56:\"\\Drupal\\dblog\\Controller\\DbLogController::topLogMessages\";s:4:\"type\";s:14:\"page not found\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":385:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/reports/page\\-not\\-found$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/reports/page-not-found\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:29:\"/admin/reports/page-not-found\";s:8:\"numParts\";i:3;}}}}',3),('dblog.search','/admin/reports/search','/admin/reports/search',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1028:{a:9:{s:4:\"path\";s:21:\"/admin/reports/search\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:56:\"\\Drupal\\dblog\\Controller\\DbLogController::topLogMessages\";s:6:\"_title\";s:18:\"Top search phrases\";s:4:\"type\";s:6:\"search\";}s:12:\"requirements\";a:2:{s:20:\"_module_dependencies\";s:6:\"search\";s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":359:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/reports/search$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/reports/search\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/reports/search\";s:8:\"numParts\";i:3;}}}}',3),('devel.admin_settings','/admin/config/development/devel','/admin/config/development/devel',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":978:{a:9:{s:4:\"path\";s:31:\"/admin/config/development/devel\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"\\Drupal\\devel\\Form\\SettingsForm\";s:6:\"_title\";s:14:\"Devel settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":390:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/config/development/devel$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/config/development/devel\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/config/development/devel\";s:8:\"numParts\";i:4;}}}}',4),('devel.cache_clear','/devel/cache/clear','/devel/cache/clear',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1004:{a:9:{s:4:\"path\";s:18:\"/devel/cache/clear\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:52:\"\\Drupal\\devel\\Controller\\DevelController::cacheClear\";s:6:\"_title\";s:11:\"Clear cache\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:24:\"access devel information\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":350:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/devel/cache/clear$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/cache/clear\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:18:\"/devel/cache/clear\";s:8:\"numParts\";i:3;}}}}',3),('devel.configs_list','/devel/config/{filter}','/devel/config',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1065:{a:9:{s:4:\"path\";s:22:\"/devel/config/{filter}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:30:\"\\Drupal\\devel\\Form\\ConfigsList\";s:6:\"_title\";s:13:\"Config editor\";s:6:\"filter\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":468:{a:11:{s:4:\"vars\";a:1:{i:0;s:6:\"filter\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/devel/config(?:/(?P<filter>[^/]++))?$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"filter\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/devel/config\";}}s:9:\"path_vars\";a:1:{i:0;s:6:\"filter\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/devel/config\";s:8:\"numParts\";i:3;}}}}',3),('devel.config_edit','/devel/config/edit/{config_name}','/devel/config/edit/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1118:{a:9:{s:4:\"path\";s:32:\"/devel/config/edit/{config_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"\\Drupal\\devel\\Form\\ConfigEditor\";s:6:\"_title\";s:39:\"Edit configuration object: @config_name\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":504:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"config_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/devel/config/edit/(?P<config_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"config_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/config/edit\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"config_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:20:\"/devel/config/edit/%\";s:8:\"numParts\";i:4;}}}}',4),('devel.container_info.parameter','/devel/container/parameter','/devel/container/parameter',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":997:{a:9:{s:4:\"path\";s:26:\"/devel/container/parameter\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:63:\"\\Drupal\\devel\\Controller\\ContainerInfoController::parameterList\";s:6:\"_title\";s:20:\"Container parameters\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":374:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/devel/container/parameter$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/devel/container/parameter\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:26:\"/devel/container/parameter\";s:8:\"numParts\";i:3;}}}}',3),('devel.container_info.parameter.detail','/devel/container/parameter/{parameter_name}','/devel/container/parameter/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1193:{a:9:{s:4:\"path\";s:43:\"/devel/container/parameter/{parameter_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:65:\"\\Drupal\\devel\\Controller\\ContainerInfoController::parameterDetail\";s:6:\"_title\";s:31:\"Parameter @parameter_name value\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":540:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"parameter_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/devel/container/parameter/(?P<parameter_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"parameter_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/devel/container/parameter\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"parameter_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:28:\"/devel/container/parameter/%\";s:8:\"numParts\";i:4;}}}}',4),('devel.container_info.service','/devel/container/service','/devel/container/service',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":985:{a:9:{s:4:\"path\";s:24:\"/devel/container/service\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:61:\"\\Drupal\\devel\\Controller\\ContainerInfoController::serviceList\";s:6:\"_title\";s:18:\"Container services\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":368:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/devel/container/service$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/devel/container/service\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/devel/container/service\";s:8:\"numParts\";i:3;}}}}',3),('devel.container_info.service.detail','/devel/container/service/{service_id}','/devel/container/service/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1158:{a:9:{s:4:\"path\";s:37:\"/devel/container/service/{service_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:63:\"\\Drupal\\devel\\Controller\\ContainerInfoController::serviceDetail\";s:6:\"_title\";s:26:\"Service @service_id detail\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":518:{a:11:{s:4:\"vars\";a:1:{i:0;s:10:\"service_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/devel/container/service/(?P<service_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"service_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/devel/container/service\";}}s:9:\"path_vars\";a:1:{i:0;s:10:\"service_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:26:\"/devel/container/service/%\";s:8:\"numParts\";i:4;}}}}',4),('devel.elements_page','/devel/elements','/devel/elements',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":941:{a:9:{s:4:\"path\";s:15:\"/devel/elements\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:59:\"\\Drupal\\devel\\Controller\\ElementInfoController::elementList\";s:6:\"_title\";s:12:\"Element Info\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":341:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/devel/elements$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/elements\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:15:\"/devel/elements\";s:8:\"numParts\";i:2;}}}}',2),('devel.elements_page.detail','/devel/elements/{element_name}','/devel/elements/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1124:{a:9:{s:4:\"path\";s:30:\"/devel/elements/{element_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:61:\"\\Drupal\\devel\\Controller\\ElementInfoController::elementDetail\";s:6:\"_title\";s:21:\"Element @element_name\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":498:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"element_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/devel/elements/(?P<element_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"element_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/elements\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"element_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:17:\"/devel/elements/%\";s:8:\"numParts\";i:3;}}}}',3),('devel.entity_info_page','/devel/entity/info','/devel/entity/info',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":958:{a:9:{s:4:\"path\";s:18:\"/devel/entity/info\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:65:\"\\Drupal\\devel\\Controller\\EntityTypeInfoController::entityTypeList\";s:6:\"_title\";s:11:\"Entity info\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":350:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/devel/entity/info$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/entity/info\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:18:\"/devel/entity/info\";s:8:\"numParts\";i:3;}}}}',3),('devel.entity_info_page.detail','/devel/entity/info/{entity_type_id}','/devel/entity/info/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1159:{a:9:{s:4:\"path\";s:35:\"/devel/entity/info/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:67:\"\\Drupal\\devel\\Controller\\EntityTypeInfoController::entityTypeDetail\";s:6:\"_title\";s:27:\"Entity type @entity_type_id\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":516:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/devel/entity/info/(?P<entity_type_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/entity/info\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:20:\"/devel/entity/info/%\";s:8:\"numParts\";i:4;}}}}',4),('devel.event_info','/devel/events','/devel/events',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":922:{a:9:{s:4:\"path\";s:13:\"/devel/events\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\devel\\Controller\\EventInfoController::eventList\";s:6:\"_title\";s:6:\"Events\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":335:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/devel/events$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/devel/events\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/devel/events\";s:8:\"numParts\";i:2;}}}}',2),('devel.execute_php','/devel/php','/devel/php',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":880:{a:9:{s:4:\"path\";s:10:\"/devel/php\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:29:\"\\Drupal\\devel\\Form\\ExecutePHP\";s:6:\"_title\";s:16:\"Execute PHP code\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"execute php code\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":326:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:16:\"#^/devel/php$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/devel/php\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:10:\"/devel/php\";s:8:\"numParts\";i:2;}}}}',2),('devel.field_info_page','/devel/field/info','/devel/field/info',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":943:{a:9:{s:4:\"path\";s:17:\"/devel/field/info\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\devel\\Controller\\DevelController::fieldInfoPage\";s:6:\"_title\";s:10:\"Field info\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":347:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/devel/field/info$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/devel/field/info\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/devel/field/info\";s:8:\"numParts\";i:3;}}}}',3),('devel.menu_rebuild','/devel/menu/reset','/devel/menu/reset',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":933:{a:9:{s:4:\"path\";s:17:\"/devel/menu/reset\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\devel\\Form\\RouterRebuildConfirmForm\";s:6:\"_title\";s:14:\"Rebuild router\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":347:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/devel/menu/reset$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/devel/menu/reset\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/devel/menu/reset\";s:8:\"numParts\";i:3;}}}}',3),('devel.reinstall','/devel/reinstall','/devel/reinstall',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":922:{a:9:{s:4:\"path\";s:16:\"/devel/reinstall\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:33:\"\\Drupal\\devel\\Form\\DevelReinstall\";s:6:\"_title\";s:17:\"Reinstall modules\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":344:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:22:\"#^/devel/reinstall$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/devel/reinstall\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:16:\"/devel/reinstall\";s:8:\"numParts\";i:2;}}}}',2),('devel.route_info','/devel/routes','/devel/routes',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":922:{a:9:{s:4:\"path\";s:13:\"/devel/routes\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\devel\\Controller\\RouteInfoController::routeList\";s:6:\"_title\";s:6:\"Routes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":335:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/devel/routes$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/devel/routes\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/devel/routes\";s:8:\"numParts\";i:2;}}}}',2),('devel.route_info.item','/devel/routes/item','/devel/routes/item',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":951:{a:9:{s:4:\"path\";s:18:\"/devel/routes/item\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:57:\"\\Drupal\\devel\\Controller\\RouteInfoController::routeDetail\";s:6:\"_title\";s:12:\"Route detail\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":350:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/devel/routes/item$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/routes/item\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:18:\"/devel/routes/item\";s:8:\"numParts\";i:3;}}}}',3),('devel.run_cron','/devel/run-cron','/devel/run-cron',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":984:{a:9:{s:4:\"path\";s:15:\"/devel/run-cron\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:42:\"\\Drupal\\system\\CronController::runManually\";s:6:\"_title\";s:8:\"Run cron\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":342:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:22:\"#^/devel/run\\-cron$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/run-cron\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:15:\"/devel/run-cron\";s:8:\"numParts\";i:2;}}}}',2),('devel.session','/devel/session','/devel/session',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":929:{a:9:{s:4:\"path\";s:14:\"/devel/session\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\devel\\Controller\\DevelController::session\";s:6:\"_title\";s:14:\"Session viewer\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/devel/session$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/devel/session\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/devel/session\";s:8:\"numParts\";i:2;}}}}',2),('devel.state_system_page','/devel/state','/devel/state',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":927:{a:9:{s:4:\"path\";s:12:\"/devel/state\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:57:\"\\Drupal\\devel\\Controller\\DevelController::stateSystemPage\";s:6:\"_title\";s:12:\"State editor\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":332:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/devel/state$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/devel/state\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/devel/state\";s:8:\"numParts\";i:2;}}}}',2),('devel.switch','/devel/switch/{name}','/devel/switch',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1127:{a:9:{s:4:\"path\";s:20:\"/devel/switch/{name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:57:\"\\Drupal\\devel\\Controller\\SwitchUserController::switchUser\";s:6:\"_title\";s:11:\"Switch user\";s:4:\"name\";s:0:\"\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:12:\"switch users\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":460:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/devel/switch(?:/(?P<name>[^/]++))?$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/devel/switch\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/devel/switch\";s:8:\"numParts\";i:3;}}}}',3),('devel.system_state_edit','/devel/state/edit/{state_name}','/devel/state/edit/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1105:{a:9:{s:4:\"path\";s:30:\"/devel/state/edit/{state_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:34:\"\\Drupal\\devel\\Form\\SystemStateEdit\";s:6:\"_title\";s:32:\"Edit state variable: @state_name\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":497:{a:11:{s:4:\"vars\";a:1:{i:0;s:10:\"state_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/devel/state/edit/(?P<state_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"state_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/devel/state/edit\";}}s:9:\"path_vars\";a:1:{i:0;s:10:\"state_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:19:\"/devel/state/edit/%\";s:8:\"numParts\";i:4;}}}}',4),('devel.theme_registry','/devel/theme/registry','/devel/theme/registry',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":963:{a:9:{s:4:\"path\";s:21:\"/devel/theme/registry\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\devel\\Controller\\DevelController::themeRegistry\";s:6:\"_title\";s:14:\"Theme registry\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":359:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/devel/theme/registry$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/devel/theme/registry\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/devel/theme/registry\";s:8:\"numParts\";i:3;}}}}',3),('devel.toolbar.settings_form','/admin/config/development/devel/toolbar','/admin/config/development/devel/toolbar',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1067:{a:9:{s:4:\"path\";s:39:\"/admin/config/development/devel/toolbar\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"\\Drupal\\devel\\Form\\ToolbarSettingsForm\";s:6:\"_title\";s:22:\"Devel Toolbar Settings\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:20:\"_module_dependencies\";s:7:\"toolbar\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":414:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/development/devel/toolbar$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/development/devel/toolbar\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/config/development/devel/toolbar\";s:8:\"numParts\";i:5;}}}}',5),('devel_generate.content','/admin/config/development/generate/content','/admin/config/development/generate/content',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1066:{a:9:{s:4:\"path\";s:42:\"/admin/config/development/generate/content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:45:\"\\Drupal\\devel_generate\\Form\\DevelGenerateForm\";s:6:\"_title\";s:16:\"Generate content\";s:10:\"_plugin_id\";s:7:\"content\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer devel_generate\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":423:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/admin/config/development/generate/content$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/development/generate/content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:42:\"/admin/config/development/generate/content\";s:8:\"numParts\";i:5;}}}}',5),('devel_generate.menu','/admin/config/development/generate/menu','/admin/config/development/generate/menu',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1049:{a:9:{s:4:\"path\";s:39:\"/admin/config/development/generate/menu\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:45:\"\\Drupal\\devel_generate\\Form\\DevelGenerateForm\";s:6:\"_title\";s:14:\"Generate menus\";s:10:\"_plugin_id\";s:4:\"menu\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer devel_generate\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":414:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/development/generate/menu$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/development/generate/menu\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/config/development/generate/menu\";s:8:\"numParts\";i:5;}}}}',5),('devel_generate.term','/admin/config/development/generate/term','/admin/config/development/generate/term',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1049:{a:9:{s:4:\"path\";s:39:\"/admin/config/development/generate/term\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:45:\"\\Drupal\\devel_generate\\Form\\DevelGenerateForm\";s:6:\"_title\";s:14:\"Generate terms\";s:10:\"_plugin_id\";s:4:\"term\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer devel_generate\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":414:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/development/generate/term$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/development/generate/term\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/config/development/generate/term\";s:8:\"numParts\";i:5;}}}}',5),('devel_generate.user','/admin/config/development/generate/user','/admin/config/development/generate/user',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1049:{a:9:{s:4:\"path\";s:39:\"/admin/config/development/generate/user\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:45:\"\\Drupal\\devel_generate\\Form\\DevelGenerateForm\";s:6:\"_title\";s:14:\"Generate users\";s:10:\"_plugin_id\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer devel_generate\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":414:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/admin/config/development/generate/user$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/development/generate/user\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/config/development/generate/user\";s:8:\"numParts\";i:5;}}}}',5),('devel_generate.vocabulary','/admin/config/development/generate/vocabs','/admin/config/development/generate/vocabs',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1071:{a:9:{s:4:\"path\";s:41:\"/admin/config/development/generate/vocabs\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:45:\"\\Drupal\\devel_generate\\Form\\DevelGenerateForm\";s:6:\"_title\";s:21:\"Generate vocabularies\";s:10:\"_plugin_id\";s:10:\"vocabulary\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer devel_generate\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":420:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/config/development/generate/vocabs$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:41:\"/admin/config/development/generate/vocabs\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:41:\"/admin/config/development/generate/vocabs\";s:8:\"numParts\";i:5;}}}}',5),('editor.field_untransformed_text','/editor/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}','/editor/%/%/%/%/%',32,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1868:{a:9:{s:4:\"path\";s:69:\"/editor/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:53:\"\\Drupal\\editor\\EditorController::getUntransformedText\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access in-place editing\";s:30:\"_access_quickedit_entity_field\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:35:\"access_check.quickedit.entity_field\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1045:{a:11:{s:4:\"vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:125:\"#^/editor/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)/(?P<langcode>[^/]++)/(?P<view_mode_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/editor\";}}s:9:\"path_vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:32;s:14:\"patternOutline\";s:17:\"/editor/%/%/%/%/%\";s:8:\"numParts\";i:6;}}}}',6),('editor.filter_xss','/editor/filter_xss/{filter_format}','/editor/filter_xss/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1192:{a:9:{s:4:\"path\";s:34:\"/editor/filter_xss/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:42:\"\\Drupal\\editor\\EditorController::filterXss\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"filter_format.use\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":511:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/editor/filter_xss/(?P<filter_format>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/editor/filter_xss\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:20:\"/editor/filter_xss/%\";s:8:\"numParts\";i:3;}}}}',3),('editor.image_dialog','/editor/dialog/image/{editor}','/editor/dialog/image/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1162:{a:9:{s:4:\"path\";s:29:\"/editor/dialog/image/{editor}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\editor\\Form\\EditorImageDialog\";s:6:\"_title\";s:12:\"Upload image\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:10:\"editor.use\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"editor\";a:2:{s:4:\"type\";s:13:\"entity:editor\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":487:{a:11:{s:4:\"vars\";a:1:{i:0;s:6:\"editor\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/editor/dialog/image/(?P<editor>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"editor\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/editor/dialog/image\";}}s:9:\"path_vars\";a:1:{i:0;s:6:\"editor\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:22:\"/editor/dialog/image/%\";s:8:\"numParts\";i:4;}}}}',4),('editor.link_dialog','/editor/dialog/link/{editor}','/editor/dialog/link/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1152:{a:9:{s:4:\"path\";s:28:\"/editor/dialog/link/{editor}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"\\Drupal\\editor\\Form\\EditorLinkDialog\";s:6:\"_title\";s:8:\"Add link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:10:\"editor.use\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"editor\";a:2:{s:4:\"type\";s:13:\"entity:editor\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":484:{a:11:{s:4:\"vars\";a:1:{i:0;s:6:\"editor\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/editor/dialog/link/(?P<editor>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"editor\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/editor/dialog/link\";}}s:9:\"path_vars\";a:1:{i:0;s:6:\"editor\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:21:\"/editor/dialog/link/%\";s:8:\"numParts\";i:4;}}}}',4),('entity.block.delete_form','/admin/structure/block/manage/{block}/delete','/admin/structure/block/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1270:{a:9:{s:4:\"path\";s:44:\"/admin/structure/block/manage/{block}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"block.delete\";s:6:\"_title\";s:12:\"Delete block\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":567:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:60:\"#^/admin/structure/block/manage/(?P<block>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/block/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.block.devel_definition','/devel/block/{block}/definition','/devel/block/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1303:{a:9:{s:4:\"path\";s:31:\"/devel/block/{block}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:5:\"block\";s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":529:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/devel/block/(?P<block>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/devel/block\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:25:\"/devel/block/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.block.devel_load','/devel/block/{block}','/devel/block/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1199:{a:9:{s:4:\"path\";s:20:\"/devel/block/{block}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:5:\"block\";s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":458:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/devel/block/(?P<block>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/devel/block\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:14:\"/devel/block/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.block.disable','/admin/structure/block/manage/{block}/disable','/admin/structure/block/manage/%/disable',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1363:{a:9:{s:4:\"path\";s:45:\"/admin/structure/block/manage/{block}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\block\\Controller\\BlockController::performOperation\";s:2:\"op\";s:7:\"disable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:13:\"block.disable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":570:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/admin/structure/block/manage/(?P<block>[^/]++)/disable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:39:\"/admin/structure/block/manage/%/disable\";s:8:\"numParts\";i:6;}}}}',6),('entity.block.edit_form','/admin/structure/block/manage/{block}','/admin/structure/block/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1204:{a:9:{s:4:\"path\";s:37:\"/admin/structure/block/manage/{block}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"block.default\";s:6:\"_title\";s:15:\"Configure block\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:12:\"block.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":510:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/structure/block/manage/(?P<block>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:31:\"/admin/structure/block/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.block.enable','/admin/structure/block/manage/{block}/enable','/admin/structure/block/manage/%/enable',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1357:{a:9:{s:4:\"path\";s:44:\"/admin/structure/block/manage/{block}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\block\\Controller\\BlockController::performOperation\";s:2:\"op\";s:6:\"enable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:12:\"block.enable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:5:\"block\";a:2:{s:4:\"type\";s:12:\"entity:block\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":567:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"block\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:60:\"#^/admin/structure/block/manage/(?P<block>[^/]++)/enable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"block\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/block/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"block\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/block/manage/%/enable\";s:8:\"numParts\";i:6;}}}}',6),('entity.block_content.canonical','/block/{block_content}','/block/%',2,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1171:{a:9:{s:4:\"path\";s:22:\"/block/{block_content}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:18:\"block_content.edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"block_content.update\";s:13:\"block_content\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":467:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/block/(?P<block_content>\\d+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"block_content\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/block\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:8:\"/block/%\";s:8:\"numParts\";i:2;}}}}',2),('entity.block_content.collection','/admin/structure/block/block-content','/admin/structure/block/block-content',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1344:{a:9:{s:4:\"path\";s:36:\"/admin/structure/block/block-content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:20:\"Custom block library\";s:7:\"view_id\";s:13:\"block_content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer blocks\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":406:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/structure/block/block\\-content$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/structure/block/block-content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:36:\"/admin/structure/block/block-content\";s:8:\"numParts\";i:4;}}}}',4),('entity.block_content.delete_form','/block/{block_content}/delete','/block/%/delete',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1264:{a:9:{s:4:\"path\";s:29:\"/block/{block_content}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"block_content.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"block_content.delete\";s:13:\"block_content\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":525:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/block/(?P<block_content>\\d+)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"block_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/block\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/block/%/delete\";s:8:\"numParts\";i:3;}}}}',3),('entity.block_content.devel_definition','/devel/block_content/{block_content}/definition','/devel/block_content/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1404:{a:9:{s:4:\"path\";s:47:\"/devel/block_content/{block_content}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"block_content\";s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":588:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/devel/block_content/(?P<block_content>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"block_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/block_content\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:33:\"/devel/block_content/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.block_content.devel_load','/devel/block_content/{block_content}','/devel/block_content/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1300:{a:9:{s:4:\"path\";s:36:\"/devel/block_content/{block_content}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"block_content\";s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":517:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/devel/block_content/(?P<block_content>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"block_content\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/block_content\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:22:\"/devel/block_content/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.block_content.devel_render','/devel/block_content/{block_content}/render','/devel/block_content/%/render',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1369:{a:9:{s:4:\"path\";s:43:\"/devel/block_content/{block_content}/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityRender\";s:6:\"_title\";s:12:\"Devel Render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"block_content\";s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":575:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/devel/block_content/(?P<block_content>[^/]++)/render$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/render\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"block_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/block_content\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:29:\"/devel/block_content/%/render\";s:8:\"numParts\";i:4;}}}}',4),('entity.block_content.edit_form','/block/{block_content}','/block/%',2,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1171:{a:9:{s:4:\"path\";s:22:\"/block/{block_content}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:18:\"block_content.edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"block_content.update\";s:13:\"block_content\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:13:\"block_content\";a:2:{s:4:\"type\";s:20:\"entity:block_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":467:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/block/(?P<block_content>\\d+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"block_content\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/block\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:8:\"/block/%\";s:8:\"numParts\";i:2;}}}}',2),('entity.block_content.field_ui_fields','/admin/structure/block/block-content/manage/{block_content_type}/fields','/admin/structure/block/block-content/manage/%/fields',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1541:{a:9:{s:4:\"path\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer block_content fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":666:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:52:\"/admin/structure/block/block-content/manage/%/fields\";s:8:\"numParts\";i:7;}}}}',7),('entity.block_content.latest_version','/block/{block_content}/latest','/block/%/latest',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1480:{a:9:{s:4:\"path\";s:29:\"/block/{block_content}/latest\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:18:\"block_content.full\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:18:\"block_content.view\";s:34:\"_content_moderation_latest_version\";s:4:\"TRUE\";s:13:\"block_content\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:31:\"_content_moderation_entity_type\";s:13:\"block_content\";s:10:\"parameters\";a:1:{s:13:\"block_content\";a:3:{s:4:\"type\";s:20:\"entity:block_content\";s:20:\"load_latest_revision\";b:1;s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:28:\"access_check.latest_revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":525:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"block_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/block/(?P<block_content>\\d+)/latest$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/latest\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"block_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/block\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"block_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/block/%/latest\";s:8:\"numParts\";i:3;}}}}',3),('entity.block_content_type.collection','/admin/structure/block/block-content/types','/admin/structure/block/block-content/types',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1071:{a:9:{s:4:\"path\";s:42:\"/admin/structure/block/block-content/types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:18:\"block_content_type\";s:6:\"_title\";s:20:\"Custom block library\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer blocks\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":424:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/admin/structure/block/block\\-content/types$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/block/block-content/types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:42:\"/admin/structure/block/block-content/types\";s:8:\"numParts\";i:5;}}}}',5),('entity.block_content_type.delete_form','/admin/structure/block/block-content/manage/{block_content_type}/delete','/admin/structure/block/block-content/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1501:{a:9:{s:4:\"path\";s:71:\"/admin/structure/block/block-content/manage/{block_content_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"block_content_type.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"block_content_type.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":666:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:52:\"/admin/structure/block/block-content/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.block_content_type.devel_definition','/devel/block_content_type/{block_content_type}/definition','/devel/block_content_type/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1464:{a:9:{s:4:\"path\";s:57:\"/devel/block_content_type/{block_content_type}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:18:\"block_content_type\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":623:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:73:\"#^/devel/block_content_type/(?P<block_content_type>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/devel/block_content_type\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:38:\"/devel/block_content_type/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.block_content_type.devel_load','/devel/block_content_type/{block_content_type}','/devel/block_content_type/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1360:{a:9:{s:4:\"path\";s:46:\"/devel/block_content_type/{block_content_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:18:\"block_content_type\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":552:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:62:\"#^/devel/block_content_type/(?P<block_content_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/devel/block_content_type\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:27:\"/devel/block_content_type/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.block_content_type.edit_form','/admin/structure/block/block-content/manage/{block_content_type}','/admin/structure/block/block-content/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1432:{a:9:{s:4:\"path\";s:64:\"/admin/structure/block/block-content/manage/{block_content_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"block_content_type.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:25:\"block_content_type.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":608:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:45:\"/admin/structure/block/block-content/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.comment.canonical','/comment/{comment}','/comment/%',2,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1236:{a:9:{s:4:\"path\";s:18:\"/comment/{comment}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:15:\"_title_callback\";s:67:\"\\Drupal\\comment\\Controller\\CommentController::commentPermalinkTitle\";s:11:\"_controller\";s:62:\"\\Drupal\\comment\\Controller\\CommentController::commentPermalink\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:12:\"comment.view\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":447:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/comment/(?P<comment>\\d+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/comment/%\";s:8:\"numParts\";i:2;}}}}',2),('entity.comment.delete_form','/comment/{comment}/delete','/comment/%/delete',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1183:{a:9:{s:4:\"path\";s:25:\"/comment/{comment}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:6:\"Delete\";s:12:\"_entity_form\";s:14:\"comment.delete\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"comment.delete\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":504:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/comment/(?P<comment>\\d+)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/comment/%/delete\";s:8:\"numParts\";i:3;}}}}',3),('entity.comment.delete_multiple_form','/admin/content/comment/delete','/admin/content/comment/delete',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1016:{a:9:{s:4:\"path\";s:29:\"/admin/content/comment/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:6:\"Delete\";s:5:\"_form\";s:42:\"\\Drupal\\comment\\Form\\ConfirmDeleteMultiple\";s:14:\"entity_type_id\";s:7:\"comment\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:7:\"comment\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/content/comment/delete$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/content/comment/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/content/comment/delete\";s:8:\"numParts\";i:4;}}}}',4),('entity.comment.devel_definition','/devel/comment/{comment}/definition','/devel/comment/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1327:{a:9:{s:4:\"path\";s:35:\"/devel/comment/{comment}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:7:\"comment\";s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":543:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/devel/comment/(?P<comment>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"comment\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/devel/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:27:\"/devel/comment/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.comment.devel_load','/devel/comment/{comment}','/devel/comment/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1223:{a:9:{s:4:\"path\";s:24:\"/devel/comment/{comment}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:7:\"comment\";s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":472:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/devel/comment/(?P<comment>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"comment\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/devel/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/devel/comment/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.comment.devel_render','/devel/comment/{comment}/render','/devel/comment/%/render',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1292:{a:9:{s:4:\"path\";s:31:\"/devel/comment/{comment}/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityRender\";s:6:\"_title\";s:12:\"Devel Render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:7:\"comment\";s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":530:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/devel/comment/(?P<comment>[^/]++)/render$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/render\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:7:\"comment\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/devel/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:23:\"/devel/comment/%/render\";s:8:\"numParts\";i:4;}}}}',4),('entity.comment.edit_form','/comment/{comment}/edit','/comment/%/edit',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1174:{a:9:{s:4:\"path\";s:23:\"/comment/{comment}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:4:\"Edit\";s:12:\"_entity_form\";s:15:\"comment.default\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:14:\"comment.update\";s:7:\"comment\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:7:\"comment\";a:2:{s:4:\"type\";s:14:\"entity:comment\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":498:{a:11:{s:4:\"vars\";a:1:{i:0;s:7:\"comment\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/comment/(?P<comment>\\d+)/edit$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:7:\"comment\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/comment\";}}s:9:\"path_vars\";a:1:{i:0;s:7:\"comment\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/comment/%/edit\";s:8:\"numParts\";i:3;}}}}',3),('entity.comment.field_ui_fields','/admin/structure/comment/manage/{comment_type}/fields','/admin/structure/comment/manage/%/fields',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1436:{a:9:{s:4:\"path\";s:53:\"/admin/structure/comment/manage/{comment_type}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer comment fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":604:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/comment/manage/%/fields\";s:8:\"numParts\";i:6;}}}}',6),('entity.comment_type.add_form','/admin/structure/comment/types/add','/admin/structure/comment/types/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":980:{a:9:{s:4:\"path\";s:34:\"/admin/structure/comment/types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"comment_type.add\";s:6:\"_title\";s:16:\"Add comment type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer comment types\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":399:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/structure/comment/types/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/structure/comment/types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/structure/comment/types/add\";s:8:\"numParts\";i:5;}}}}',5),('entity.comment_type.collection','/admin/structure/comment','/admin/structure/comment',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":932:{a:9:{s:4:\"path\";s:24:\"/admin/structure/comment\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:12:\"comment_type\";s:6:\"_title\";s:13:\"Comment types\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer comment types\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":368:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/admin/structure/comment$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/structure/comment\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/structure/comment\";s:8:\"numParts\";i:3;}}}}',3),('entity.comment_type.delete_form','/admin/structure/comment/manage/{comment_type}/delete','/admin/structure/comment/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1332:{a:9:{s:4:\"path\";s:53:\"/admin/structure/comment/manage/{comment_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"comment_type.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"comment_type.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":604:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/comment/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.comment_type.devel_definition','/devel/comment_type/{comment_type}/definition','/devel/comment_type/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1392:{a:9:{s:4:\"path\";s:45:\"/devel/comment_type/{comment_type}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:12:\"comment_type\";s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":581:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/devel/comment_type/(?P<comment_type>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/devel/comment_type\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:32:\"/devel/comment_type/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.comment_type.devel_load','/devel/comment_type/{comment_type}','/devel/comment_type/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1288:{a:9:{s:4:\"path\";s:34:\"/devel/comment_type/{comment_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:12:\"comment_type\";s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":510:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/devel/comment_type/(?P<comment_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/devel/comment_type\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:21:\"/devel/comment_type/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.comment_type.edit_form','/admin/structure/comment/manage/{comment_type}','/admin/structure/comment/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1264:{a:9:{s:4:\"path\";s:46:\"/admin/structure/comment/manage/{comment_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"comment_type.edit\";s:6:\"_title\";s:4:\"Edit\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"comment_type.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":547:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:62:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/structure/comment/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.contact_form.canonical','/contact/{contact_form}','/contact/%',2,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1190:{a:9:{s:4:\"path\";s:23:\"/contact/{contact_form}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:7:\"Contact\";s:11:\"_controller\";s:61:\"\\Drupal\\contact\\Controller\\ContactController::contactSitePage\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"contact_form.view\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":476:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/contact/(?P<contact_form>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/contact\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:10:\"/contact/%\";s:8:\"numParts\";i:2;}}}}',2),('entity.contact_form.collection','/admin/structure/contact','/admin/structure/contact',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":932:{a:9:{s:4:\"path\";s:24:\"/admin/structure/contact\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:12:\"contact_form\";s:6:\"_title\";s:13:\"Contact forms\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer contact forms\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":368:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/admin/structure/contact$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/structure/contact\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/structure/contact\";s:8:\"numParts\";i:3;}}}}',3),('entity.contact_form.delete_form','/admin/structure/contact/manage/{contact_form}/delete','/admin/structure/contact/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1332:{a:9:{s:4:\"path\";s:53:\"/admin/structure/contact/manage/{contact_form}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"contact_form.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"contact_form.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":604:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/contact/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.contact_form.devel_definition','/devel/contact_form/{contact_form}/definition','/devel/contact_form/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1392:{a:9:{s:4:\"path\";s:45:\"/devel/contact_form/{contact_form}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:12:\"contact_form\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":581:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/devel/contact_form/(?P<contact_form>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/devel/contact_form\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:32:\"/devel/contact_form/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.contact_form.devel_load','/devel/contact_form/{contact_form}','/devel/contact_form/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1288:{a:9:{s:4:\"path\";s:34:\"/devel/contact_form/{contact_form}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:12:\"contact_form\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":510:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/devel/contact_form/(?P<contact_form>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/devel/contact_form\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:21:\"/devel/contact_form/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.contact_form.edit_form','/admin/structure/contact/manage/{contact_form}','/admin/structure/contact/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1278:{a:9:{s:4:\"path\";s:46:\"/admin/structure/contact/manage/{contact_form}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"contact_form.edit\";s:6:\"_title\";s:17:\"Edit contact form\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"contact_form.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":547:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:62:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/structure/contact/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.contact_message.field_ui_fields','/admin/structure/contact/manage/{contact_form}/fields','/admin/structure/contact/manage/%/fields',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1453:{a:9:{s:4:\"path\";s:53:\"/admin/structure/contact/manage/{contact_form}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer contact_message fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":604:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/contact/manage/%/fields\";s:8:\"numParts\";i:6;}}}}',6),('entity.content_moderation_notification.add_form','/admin/config/workflow/notifications/add','/admin/config/workflow/notifications/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1043:{a:9:{s:4:\"path\";s:40:\"/admin/config/workflow/notifications/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:16:\"Add notification\";s:12:\"_entity_form\";s:35:\"content_moderation_notification.add\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:31:\"content_moderation_notification\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":417:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/config/workflow/notifications/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/config/workflow/notifications/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/config/workflow/notifications/add\";s:8:\"numParts\";i:5;}}}}',5),('entity.content_moderation_notification.collection','/admin/config/workflow/notifications','/admin/config/workflow/notifications',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1038:{a:9:{s:4:\"path\";s:36:\"/admin/config/workflow/notifications\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:31:\"content_moderation_notification\";s:6:\"_title\";s:32:\"Content Moderation Notifications\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:43:\"administer content moderation notifications\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":405:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/config/workflow/notifications$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/workflow/notifications\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:36:\"/admin/config/workflow/notifications\";s:8:\"numParts\";i:4;}}}}',4),('entity.content_moderation_notification.delete_form','/admin/config/workflow/notifications/manage/{content_moderation_notification}/delete','/admin/config/workflow/notifications/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1567:{a:9:{s:4:\"path\";s:84:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:19:\"Delete notification\";s:12:\"_entity_form\";s:38:\"content_moderation_notification.delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:38:\"content_moderation_notification.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"content_moderation_notification\";a:2:{s:4:\"type\";s:38:\"entity:content_moderation_notification\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":718:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:100:\"#^/admin/config/workflow/notifications/manage/(?P<content_moderation_notification>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"content_moderation_notification\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/config/workflow/notifications/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:52:\"/admin/config/workflow/notifications/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.content_moderation_notification.devel_definition','/devel/content_moderation_notification/{content_moderation_notification}/definition','/devel/content_moderation_notification/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1620:{a:9:{s:4:\"path\";s:83:\"/devel/content_moderation_notification/{content_moderation_notification}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:31:\"content_moderation_notification\";s:10:\"parameters\";a:1:{s:31:\"content_moderation_notification\";a:2:{s:4:\"type\";s:38:\"entity:content_moderation_notification\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":714:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/devel/content_moderation_notification/(?P<content_moderation_notification>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"content_moderation_notification\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/devel/content_moderation_notification\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:51:\"/devel/content_moderation_notification/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.content_moderation_notification.devel_load','/devel/content_moderation_notification/{content_moderation_notification}','/devel/content_moderation_notification/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1516:{a:9:{s:4:\"path\";s:72:\"/devel/content_moderation_notification/{content_moderation_notification}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:31:\"content_moderation_notification\";s:10:\"parameters\";a:1:{s:31:\"content_moderation_notification\";a:2:{s:4:\"type\";s:38:\"entity:content_moderation_notification\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":643:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:88:\"#^/devel/content_moderation_notification/(?P<content_moderation_notification>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"content_moderation_notification\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:38:\"/devel/content_moderation_notification\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:40:\"/devel/content_moderation_notification/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.content_moderation_notification.disable_form','/admin/config/workflow/notifications/manage/{content_moderation_notification}/disable','/admin/config/workflow/notifications/manage/%/disable',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1573:{a:9:{s:4:\"path\";s:85:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:20:\"Disable notification\";s:12:\"_entity_form\";s:39:\"content_moderation_notification.disable\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:38:\"content_moderation_notification.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"content_moderation_notification\";a:2:{s:4:\"type\";s:38:\"entity:content_moderation_notification\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":721:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/config/workflow/notifications/manage/(?P<content_moderation_notification>[^/]++)/disable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"content_moderation_notification\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/config/workflow/notifications/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:53:\"/admin/config/workflow/notifications/manage/%/disable\";s:8:\"numParts\";i:7;}}}}',7),('entity.content_moderation_notification.edit_form','/admin/config/workflow/notifications/manage/{content_moderation_notification}','/admin/config/workflow/notifications/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1497:{a:9:{s:4:\"path\";s:77:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:17:\"Edit notification\";s:12:\"_entity_form\";s:36:\"content_moderation_notification.edit\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:38:\"content_moderation_notification.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"content_moderation_notification\";a:2:{s:4:\"type\";s:38:\"entity:content_moderation_notification\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":659:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:93:\"#^/admin/config/workflow/notifications/manage/(?P<content_moderation_notification>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"content_moderation_notification\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/config/workflow/notifications/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:45:\"/admin/config/workflow/notifications/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.content_moderation_notification.enable_form','/admin/config/workflow/notifications/manage/{content_moderation_notification}/enable','/admin/config/workflow/notifications/manage/%/enable',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1567:{a:9:{s:4:\"path\";s:84:\"/admin/config/workflow/notifications/manage/{content_moderation_notification}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:19:\"Enable notification\";s:12:\"_entity_form\";s:38:\"content_moderation_notification.enable\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:38:\"content_moderation_notification.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:31:\"content_moderation_notification\";a:2:{s:4:\"type\";s:38:\"entity:content_moderation_notification\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":718:{a:11:{s:4:\"vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:100:\"#^/admin/config/workflow/notifications/manage/(?P<content_moderation_notification>[^/]++)/enable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:31:\"content_moderation_notification\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/config/workflow/notifications/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:31:\"content_moderation_notification\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:52:\"/admin/config/workflow/notifications/manage/%/enable\";s:8:\"numParts\";i:7;}}}}',7),('entity.date_format.collection','/admin/config/regional/date-time','/admin/config/regional/date-time',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":978:{a:9:{s:4:\"path\";s:32:\"/admin/config/regional/date-time\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:11:\"date_format\";s:6:\"_title\";s:21:\"Date and time formats\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/config/regional/date\\-time$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/regional/date-time\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/config/regional/date-time\";s:8:\"numParts\";i:4;}}}}',4),('entity.date_format.delete_form','/admin/config/regional/date-time/formats/manage/{date_format}/delete','/admin/config/regional/date-time/formats/manage/%/delete',253,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1402:{a:9:{s:4:\"path\";s:68:\"/admin/config/regional/date-time/formats/manage/{date_format}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"date_format.delete\";s:6:\"_title\";s:18:\"Delete date format\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"date_format.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"date_format\";a:2:{s:4:\"type\";s:18:\"entity:date_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":650:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"date_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/admin/config/regional/date\\-time/formats/manage/(?P<date_format>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"date_format\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:47:\"/admin/config/regional/date-time/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"date_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:253;s:14:\"patternOutline\";s:56:\"/admin/config/regional/date-time/formats/manage/%/delete\";s:8:\"numParts\";i:8;}}}}',8),('entity.date_format.devel_definition','/devel/date_format/{date_format}/definition','/devel/date_format/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1380:{a:9:{s:4:\"path\";s:43:\"/devel/date_format/{date_format}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:11:\"date_format\";s:10:\"parameters\";a:1:{s:11:\"date_format\";a:2:{s:4:\"type\";s:18:\"entity:date_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":574:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"date_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/devel/date_format/(?P<date_format>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"date_format\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/date_format\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"date_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:31:\"/devel/date_format/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.date_format.devel_load','/devel/date_format/{date_format}','/devel/date_format/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1276:{a:9:{s:4:\"path\";s:32:\"/devel/date_format/{date_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:11:\"date_format\";s:10:\"parameters\";a:1:{s:11:\"date_format\";a:2:{s:4:\"type\";s:18:\"entity:date_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":503:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"date_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/devel/date_format/(?P<date_format>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"date_format\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/date_format\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"date_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:20:\"/devel/date_format/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.date_format.edit_form','/admin/config/regional/date-time/formats/manage/{date_format}','/admin/config/regional/date-time/formats/manage/%',126,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1334:{a:9:{s:4:\"path\";s:61:\"/admin/config/regional/date-time/formats/manage/{date_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"date_format.edit\";s:6:\"_title\";s:16:\"Edit date format\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"date_format.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"date_format\";a:2:{s:4:\"type\";s:18:\"entity:date_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":593:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"date_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/config/regional/date\\-time/formats/manage/(?P<date_format>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"date_format\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:47:\"/admin/config/regional/date-time/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"date_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:126;s:14:\"patternOutline\";s:49:\"/admin/config/regional/date-time/formats/manage/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_form_display.block_content.default','/admin/structure/block/block-content/manage/{block_content_type}/form-display','/admin/structure/block/block-content/manage/%/form-display',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1601:{a:9:{s:4:\"path\";s:77:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer block_content form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":686:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:95:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:58:\"/admin/structure/block/block-content/manage/%/form-display\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_form_display.block_content.form_mode','/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}','/admin/structure/block/block-content/manage/%/form-display/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1748:{a:9:{s:4:\"path\";s:94:\"/admin/structure/block/block-content/manage/{block_content_type}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer block_content form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":852:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:122:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:60:\"/admin/structure/block/block-content/manage/%/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),('entity.entity_form_display.comment.default','/admin/structure/comment/manage/{comment_type}/form-display','/admin/structure/comment/manage/%/form-display',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1496:{a:9:{s:4:\"path\";s:59:\"/admin/structure/comment/manage/{comment_type}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:31:\"administer comment form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":624:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/structure/comment/manage/%/form-display\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_form_display.comment.form_mode','/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}','/admin/structure/comment/manage/%/form-display/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1644:{a:9:{s:4:\"path\";s:76:\"/admin/structure/comment/manage/{comment_type}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:31:\"administer comment form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":791:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:103:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:48:\"/admin/structure/comment/manage/%/form-display/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_form_display.contact_message.default','/admin/structure/contact/manage/{contact_form}/form-display','/admin/structure/contact/manage/%/form-display',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1513:{a:9:{s:4:\"path\";s:59:\"/admin/structure/contact/manage/{contact_form}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":624:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:46:\"/admin/structure/contact/manage/%/form-display\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_form_display.contact_message.form_mode','/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}','/admin/structure/contact/manage/%/form-display/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1661:{a:9:{s:4:\"path\";s:76:\"/admin/structure/contact/manage/{contact_form}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:39:\"administer contact_message form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":791:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:103:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:48:\"/admin/structure/contact/manage/%/form-display/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_form_display.node.default','/admin/structure/types/manage/{node_type}/form-display','/admin/structure/types/manage/%/form-display',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1457:{a:9:{s:4:\"path\";s:54:\"/admin/structure/types/manage/{node_type}/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer node form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":603:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:44:\"/admin/structure/types/manage/%/form-display\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_form_display.node.form_mode','/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}','/admin/structure/types/manage/%/form-display/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1604:{a:9:{s:4:\"path\";s:71:\"/admin/structure/types/manage/{node_type}/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer node form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":769:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/form\\-display/(?P<form_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/form-display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:46:\"/admin/structure/types/manage/%/form-display/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_form_display.taxonomy_term.default','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display','/admin/structure/taxonomy/manage/%/overview/form-display',123,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1599:{a:9:{s:4:\"path\";s:76:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":683:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:93:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/overview/form-display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:56:\"/admin/structure/taxonomy/manage/%/overview/form-display\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_form_display.taxonomy_term.form_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}','/admin/structure/taxonomy/manage/%/overview/form-display/%',246,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1746:{a:9:{s:4:\"path\";s:93:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:37:\"administer taxonomy_term form display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":849:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:120:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/form\\-display/(?P<form_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/overview/form-display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:58:\"/admin/structure/taxonomy/manage/%/overview/form-display/%\";s:8:\"numParts\";i:8;}}}}',8),('entity.entity_form_display.user.default','/admin/config/people/accounts/form-display','/admin/config/people/accounts/form-display',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1135:{a:9:{s:4:\"path\";s:42:\"/admin/config/people/accounts/form-display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"form_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer user form display\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":424:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/admin/config/people/accounts/form\\-display$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/people/accounts/form-display\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:42:\"/admin/config/people/accounts/form-display\";s:8:\"numParts\";i:5;}}}}',5),('entity.entity_form_display.user.form_mode','/admin/config/people/accounts/form-display/{form_mode_name}','/admin/config/people/accounts/form-display/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1281:{a:9:{s:4:\"path\";s:59:\"/admin/config/people/accounts/form-display/{form_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_form_display.edit\";s:6:\"_title\";s:19:\"Manage form display\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_form_mode_access\";s:28:\"administer user form display\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.form_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":589:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"form_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/config/people/accounts/form\\-display/(?P<form_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"form_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/people/accounts/form-display\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"form_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/config/people/accounts/form-display/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_form_mode.add_form','/admin/structure/display-modes/form/add/{entity_type_id}','/admin/structure/display-modes/form/add/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1184:{a:9:{s:4:\"path\";s:56:\"/admin/structure/display-modes/form/add/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"entity_form_mode.add\";s:6:\"_title\";s:13:\"Add form mode\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":580:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:73:\"#^/admin/structure/display\\-modes/form/add/(?P<entity_type_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/form/add\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:41:\"/admin/structure/display-modes/form/add/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_form_mode.collection','/admin/structure/display-modes/form','/admin/structure/display-modes/form',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":979:{a:9:{s:4:\"path\";s:35:\"/admin/structure/display-modes/form\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:16:\"entity_form_mode\";s:6:\"_title\";s:10:\"Form modes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":403:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/structure/display\\-modes/form$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/admin/structure/display-modes/form\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:35:\"/admin/structure/display-modes/form\";s:8:\"numParts\";i:4;}}}}',4),('entity.entity_form_mode.delete_form','/admin/structure/display-modes/form/manage/{entity_form_mode}/delete','/admin/structure/display-modes/form/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1425:{a:9:{s:4:\"path\";s:68:\"/admin/structure/display-modes/form/manage/{entity_form_mode}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"entity_form_mode.delete\";s:6:\"_title\";s:16:\"Delete form mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_form_mode.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"entity_form_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_form_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":655:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/admin/structure/display\\-modes/form/manage/(?P<entity_form_mode>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_form_mode\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/form/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/structure/display-modes/form/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_form_mode.devel_definition','/devel/entity_form_mode/{entity_form_mode}/definition','/devel/entity_form_mode/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1440:{a:9:{s:4:\"path\";s:53:\"/devel/entity_form_mode/{entity_form_mode}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:16:\"entity_form_mode\";s:10:\"parameters\";a:1:{s:16:\"entity_form_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_form_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":609:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/devel/entity_form_mode/(?P<entity_form_mode>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_form_mode\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/devel/entity_form_mode\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:36:\"/devel/entity_form_mode/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.entity_form_mode.devel_load','/devel/entity_form_mode/{entity_form_mode}','/devel/entity_form_mode/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1336:{a:9:{s:4:\"path\";s:42:\"/devel/entity_form_mode/{entity_form_mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:16:\"entity_form_mode\";s:10:\"parameters\";a:1:{s:16:\"entity_form_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_form_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":538:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/devel/entity_form_mode/(?P<entity_form_mode>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_form_mode\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/devel/entity_form_mode\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:25:\"/devel/entity_form_mode/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.entity_form_mode.edit_form','/admin/structure/display-modes/form/manage/{entity_form_mode}','/admin/structure/display-modes/form/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1356:{a:9:{s:4:\"path\";s:61:\"/admin/structure/display-modes/form/manage/{entity_form_mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"entity_form_mode.edit\";s:6:\"_title\";s:14:\"Edit form mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_form_mode.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"entity_form_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_form_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":597:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/structure/display\\-modes/form/manage/(?P<entity_form_mode>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_form_mode\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/form/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_form_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/structure/display-modes/form/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_view_display.block_content.default','/admin/structure/block/block-content/manage/{block_content_type}/display','/admin/structure/block/block-content/manage/%/display',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1569:{a:9:{s:4:\"path\";s:72:\"/admin/structure/block/block-content/manage/{block_content_type}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer block_content display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":669:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:53:\"/admin/structure/block/block-content/manage/%/display\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_view_display.block_content.view_mode','/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}','/admin/structure/block/block-content/manage/%/display/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1716:{a:9:{s:4:\"path\";s:89:\"/admin/structure/block/block-content/manage/{block_content_type}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer block_content display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":835:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:116:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:55:\"/admin/structure/block/block-content/manage/%/display/%\";s:8:\"numParts\";i:8;}}}}',8),('entity.entity_view_display.comment.default','/admin/structure/comment/manage/{comment_type}/display','/admin/structure/comment/manage/%/display',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1464:{a:9:{s:4:\"path\";s:54:\"/admin/structure/comment/manage/{comment_type}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:26:\"administer comment display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":607:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/structure/comment/manage/%/display\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_view_display.comment.view_mode','/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}','/admin/structure/comment/manage/%/display/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1611:{a:9:{s:4:\"path\";s:71:\"/admin/structure/comment/manage/{comment_type}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:26:\"administer comment display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":773:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:43:\"/admin/structure/comment/manage/%/display/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_view_display.contact_message.default','/admin/structure/contact/manage/{contact_form}/display','/admin/structure/contact/manage/%/display',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1481:{a:9:{s:4:\"path\";s:54:\"/admin/structure/contact/manage/{contact_form}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:34:\"administer contact_message display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":607:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/structure/contact/manage/%/display\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_view_display.contact_message.view_mode','/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}','/admin/structure/contact/manage/%/display/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1628:{a:9:{s:4:\"path\";s:71:\"/admin/structure/contact/manage/{contact_form}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:34:\"administer contact_message display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":773:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:43:\"/admin/structure/contact/manage/%/display/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_view_display.node.default','/admin/structure/types/manage/{node_type}/display','/admin/structure/types/manage/%/display',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1425:{a:9:{s:4:\"path\";s:49:\"/admin/structure/types/manage/{node_type}/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer node display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":586:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:39:\"/admin/structure/types/manage/%/display\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_view_display.node.view_mode','/admin/structure/types/manage/{node_type}/display/{view_mode_name}','/admin/structure/types/manage/%/display/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1572:{a:9:{s:4:\"path\";s:66:\"/admin/structure/types/manage/{node_type}/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer node display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":752:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:92:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/display/(?P<view_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:41:\"/admin/structure/types/manage/%/display/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_view_display.taxonomy_term.default','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display','/admin/structure/taxonomy/manage/%/overview/display',123,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1568:{a:9:{s:4:\"path\";s:71:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":667:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:87:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/overview/display\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:51:\"/admin/structure/taxonomy/manage/%/overview/display\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_view_display.taxonomy_term.view_mode','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}','/admin/structure/taxonomy/manage/%/overview/display/%',246,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1715:{a:9:{s:4:\"path\";s:88:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:32:\"administer taxonomy_term display\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":833:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:114:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/display/(?P<view_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/overview/display\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:53:\"/admin/structure/taxonomy/manage/%/overview/display/%\";s:8:\"numParts\";i:8;}}}}',8),('entity.entity_view_display.user.default','/admin/config/people/accounts/display','/admin/config/people/accounts/display',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1104:{a:9:{s:4:\"path\";s:37:\"/admin/config/people/accounts/display\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"view_mode_name\";s:7:\"default\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer user display\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":408:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/people/accounts/display$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/people/accounts/display\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:37:\"/admin/config/people/accounts/display\";s:8:\"numParts\";i:5;}}}}',5),('entity.entity_view_display.user.view_mode','/admin/config/people/accounts/display/{view_mode_name}','/admin/config/people/accounts/display/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1250:{a:9:{s:4:\"path\";s:54:\"/admin/config/people/accounts/display/{view_mode_name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:24:\"entity_view_display.edit\";s:6:\"_title\";s:14:\"Manage display\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:26:\"_field_ui_view_mode_access\";s:23:\"administer user display\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:31:\"access_check.field_ui.view_mode\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":573:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"view_mode_name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/config/people/accounts/display/(?P<view_mode_name>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"view_mode_name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/people/accounts/display\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"view_mode_name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:39:\"/admin/config/people/accounts/display/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_view_mode.add_form','/admin/structure/display-modes/view/add/{entity_type_id}','/admin/structure/display-modes/view/add/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1184:{a:9:{s:4:\"path\";s:56:\"/admin/structure/display-modes/view/add/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"entity_view_mode.add\";s:6:\"_title\";s:13:\"Add view mode\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":580:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:73:\"#^/admin/structure/display\\-modes/view/add/(?P<entity_type_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/view/add\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:41:\"/admin/structure/display-modes/view/add/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.entity_view_mode.collection','/admin/structure/display-modes/view','/admin/structure/display-modes/view',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":979:{a:9:{s:4:\"path\";s:35:\"/admin/structure/display-modes/view\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:16:\"entity_view_mode\";s:6:\"_title\";s:10:\"View modes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":403:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/structure/display\\-modes/view$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:35:\"/admin/structure/display-modes/view\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:35:\"/admin/structure/display-modes/view\";s:8:\"numParts\";i:4;}}}}',4),('entity.entity_view_mode.delete_form','/admin/structure/display-modes/view/manage/{entity_view_mode}/delete','/admin/structure/display-modes/view/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1425:{a:9:{s:4:\"path\";s:68:\"/admin/structure/display-modes/view/manage/{entity_view_mode}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"entity_view_mode.delete\";s:6:\"_title\";s:16:\"Delete view mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_view_mode.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"entity_view_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_view_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":655:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:85:\"#^/admin/structure/display\\-modes/view/manage/(?P<entity_view_mode>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_view_mode\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/view/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/structure/display-modes/view/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.entity_view_mode.devel_definition','/devel/entity_view_mode/{entity_view_mode}/definition','/devel/entity_view_mode/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1440:{a:9:{s:4:\"path\";s:53:\"/devel/entity_view_mode/{entity_view_mode}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:16:\"entity_view_mode\";s:10:\"parameters\";a:1:{s:16:\"entity_view_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_view_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":609:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/devel/entity_view_mode/(?P<entity_view_mode>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_view_mode\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/devel/entity_view_mode\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:36:\"/devel/entity_view_mode/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.entity_view_mode.devel_load','/devel/entity_view_mode/{entity_view_mode}','/devel/entity_view_mode/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1336:{a:9:{s:4:\"path\";s:42:\"/devel/entity_view_mode/{entity_view_mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:16:\"entity_view_mode\";s:10:\"parameters\";a:1:{s:16:\"entity_view_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_view_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":538:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/devel/entity_view_mode/(?P<entity_view_mode>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_view_mode\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/devel/entity_view_mode\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:25:\"/devel/entity_view_mode/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.entity_view_mode.edit_form','/admin/structure/display-modes/view/manage/{entity_view_mode}','/admin/structure/display-modes/view/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1356:{a:9:{s:4:\"path\";s:61:\"/admin/structure/display-modes/view/manage/{entity_view_mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"entity_view_mode.edit\";s:6:\"_title\";s:14:\"Edit view mode\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:23:\"entity_view_mode.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"entity_view_mode\";a:2:{s:4:\"type\";s:23:\"entity:entity_view_mode\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":597:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/admin/structure/display\\-modes/view/manage/(?P<entity_view_mode>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"entity_view_mode\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/structure/display-modes/view/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"entity_view_mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/structure/display-modes/view/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.field_config.block_content_field_delete_form','/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/delete','/admin/structure/block/block-content/manage/%/fields/%/delete',501,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1807:{a:9:{s:4:\"path\";s:93:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":881:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:120:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:61:\"/admin/structure/block/block-content/manage/%/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),('entity.field_config.block_content_field_edit_form','/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}','/admin/structure/block/block-content/manage/%/fields/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1823:{a:9:{s:4:\"path\";s:86:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":824:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:113:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/(?P<field_config>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:54:\"/admin/structure/block/block-content/manage/%/fields/%\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.block_content_storage_edit_form','/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/storage','/admin/structure/block/block-content/manage/%/fields/%/storage',501,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1712:{a:9:{s:4:\"path\";s:94:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer block_content fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":884:{a:11:{s:4:\"vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:121:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:18:\"block_content_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:62:\"/admin/structure/block/block-content/manage/%/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),('entity.field_config.comment_field_delete_form','/admin/structure/comment/manage/{comment_type}/fields/{field_config}/delete','/admin/structure/comment/manage/%/fields/%/delete',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1709:{a:9:{s:4:\"path\";s:75:\"/admin/structure/comment/manage/{comment_type}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":820:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:49:\"/admin/structure/comment/manage/%/fields/%/delete\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.comment_field_edit_form','/admin/structure/comment/manage/{comment_type}/fields/{field_config}','/admin/structure/comment/manage/%/fields/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1724:{a:9:{s:4:\"path\";s:68:\"/admin/structure/comment/manage/{comment_type}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":762:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:94:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/(?P<field_config>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:42:\"/admin/structure/comment/manage/%/fields/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.field_config.comment_storage_edit_form','/admin/structure/comment/manage/{comment_type}/fields/{field_config}/storage','/admin/structure/comment/manage/%/fields/%/storage',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1608:{a:9:{s:4:\"path\";s:76:\"/admin/structure/comment/manage/{comment_type}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer comment fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":823:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"comment_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/comment/manage/%/fields/%/storage\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.contact_message_field_delete_form','/admin/structure/contact/manage/{contact_form}/fields/{field_config}/delete','/admin/structure/contact/manage/%/fields/%/delete',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1718:{a:9:{s:4:\"path\";s:75:\"/admin/structure/contact/manage/{contact_form}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":820:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:101:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:49:\"/admin/structure/contact/manage/%/fields/%/delete\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.contact_message_field_edit_form','/admin/structure/contact/manage/{contact_form}/fields/{field_config}','/admin/structure/contact/manage/%/fields/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1733:{a:9:{s:4:\"path\";s:68:\"/admin/structure/contact/manage/{contact_form}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":762:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:94:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/(?P<field_config>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:42:\"/admin/structure/contact/manage/%/fields/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.field_config.contact_message_storage_edit_form','/admin/structure/contact/manage/{contact_form}/fields/{field_config}/storage','/admin/structure/contact/manage/%/fields/%/storage',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1625:{a:9:{s:4:\"path\";s:76:\"/admin/structure/contact/manage/{contact_form}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer contact_message fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":823:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:102:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"contact_form\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:50:\"/admin/structure/contact/manage/%/fields/%/storage\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.node_field_delete_form','/admin/structure/types/manage/{node_type}/fields/{field_config}/delete','/admin/structure/types/manage/%/fields/%/delete',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1672:{a:9:{s:4:\"path\";s:70:\"/admin/structure/types/manage/{node_type}/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":798:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:96:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/(?P<field_config>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:47:\"/admin/structure/types/manage/%/fields/%/delete\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.node_field_edit_form','/admin/structure/types/manage/{node_type}/fields/{field_config}','/admin/structure/types/manage/%/fields/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1688:{a:9:{s:4:\"path\";s:63:\"/admin/structure/types/manage/{node_type}/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":741:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/(?P<field_config>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:40:\"/admin/structure/types/manage/%/fields/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.field_config.node_storage_edit_form','/admin/structure/types/manage/{node_type}/fields/{field_config}/storage','/admin/structure/types/manage/%/fields/%/storage',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1568:{a:9:{s:4:\"path\";s:71:\"/admin/structure/types/manage/{node_type}/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer node fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":801:{a:11:{s:4:\"vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/(?P<field_config>[^/]++)/storage$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:9:\"node_type\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:48:\"/admin/structure/types/manage/%/fields/%/storage\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.taxonomy_term_field_delete_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/delete','/admin/structure/taxonomy/manage/%/overview/fields/%/delete',493,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1806:{a:9:{s:4:\"path\";s:92:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":879:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:118:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/(?P<field_config>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:59:\"/admin/structure/taxonomy/manage/%/overview/fields/%/delete\";s:8:\"numParts\";i:9;}}}}',9),('entity.field_config.taxonomy_term_field_edit_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}','/admin/structure/taxonomy/manage/%/overview/fields/%',246,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1822:{a:9:{s:4:\"path\";s:85:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":822:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:111:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/(?P<field_config>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:246;s:14:\"patternOutline\";s:52:\"/admin/structure/taxonomy/manage/%/overview/fields/%\";s:8:\"numParts\";i:8;}}}}',8),('entity.field_config.taxonomy_term_storage_edit_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/storage','/admin/structure/taxonomy/manage/%/overview/fields/%/storage',493,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1711:{a:9:{s:4:\"path\";s:93:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer taxonomy_term fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":882:{a:11:{s:4:\"vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:119:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/(?P<field_config>[^/]++)/storage$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:493;s:14:\"patternOutline\";s:60:\"/admin/structure/taxonomy/manage/%/overview/fields/%/storage\";s:8:\"numParts\";i:9;}}}}',9),('entity.field_config.user_field_delete_form','/admin/config/people/accounts/fields/{field_config}/delete','/admin/config/people/accounts/fields/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1375:{a:9:{s:4:\"path\";s:58:\"/admin/config/people/accounts/fields/{field_config}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:19:\"field_config.delete\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":620:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/admin/config/people/accounts/fields/(?P<field_config>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:45:\"/admin/config/people/accounts/fields/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.field_config.user_field_edit_form','/admin/config/people/accounts/fields/{field_config}','/admin/config/people/accounts/fields/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1390:{a:9:{s:4:\"path\";s:51:\"/admin/config/people/accounts/fields/{field_config}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_form\";s:17:\"field_config.edit\";s:15:\"_title_callback\";s:51:\"\\Drupal\\field_ui\\Form\\FieldConfigEditForm::getTitle\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"field_config.update\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:10:\"parameters\";a:1:{s:12:\"field_config\";a:2:{s:4:\"type\";s:19:\"entity:field_config\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":562:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/config/people/accounts/fields/(?P<field_config>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:38:\"/admin/config/people/accounts/fields/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.field_config.user_storage_edit_form','/admin/config/people/accounts/fields/{field_config}/storage','/admin/config/people/accounts/fields/%/storage',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1247:{a:9:{s:4:\"path\";s:59:\"/admin/config/people/accounts/fields/{field_config}/storage\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:25:\"field_storage_config.edit\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer user fields\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":623:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"field_config\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/config/people/accounts/fields/(?P<field_config>[^/]++)/storage$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/storage\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"field_config\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"field_config\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:46:\"/admin/config/people/accounts/fields/%/storage\";s:8:\"numParts\";i:7;}}}}',7),('entity.field_storage_config.collection','/admin/reports/fields','/admin/reports/fields',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":925:{a:9:{s:4:\"path\";s:21:\"/admin/reports/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:20:\"field_storage_config\";s:6:\"_title\";s:10:\"Field list\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":359:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/reports/fields$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/reports/fields\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/reports/fields\";s:8:\"numParts\";i:3;}}}}',3),('entity.filter_format.devel_definition','/devel/filter_format/{filter_format}/definition','/devel/filter_format/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1404:{a:9:{s:4:\"path\";s:47:\"/devel/filter_format/{filter_format}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"filter_format\";s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":588:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/devel/filter_format/(?P<filter_format>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/filter_format\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:33:\"/devel/filter_format/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.filter_format.devel_load','/devel/filter_format/{filter_format}','/devel/filter_format/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1300:{a:9:{s:4:\"path\";s:36:\"/devel/filter_format/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"filter_format\";s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":517:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/devel/filter_format/(?P<filter_format>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/filter_format\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:22:\"/devel/filter_format/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.filter_format.disable','/admin/config/content/formats/manage/{filter_format}/disable','/admin/config/content/formats/manage/%/disable',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1382:{a:9:{s:4:\"path\";s:60:\"/admin/config/content/formats/manage/{filter_format}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"filter_format.disable\";s:6:\"_title\";s:19:\"Disable text format\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:21:\"filter_format.disable\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":627:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/config/content/formats/manage/(?P<filter_format>[^/]++)/disable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:46:\"/admin/config/content/formats/manage/%/disable\";s:8:\"numParts\";i:7;}}}}',7),('entity.filter_format.edit_form','/admin/config/content/formats/manage/{filter_format}','/admin/config/content/formats/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:52:\"/admin/config/content/formats/manage/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"filter_format.edit\";s:15:\"_title_callback\";s:52:\"\\Drupal\\filter\\Controller\\FilterController::getLabel\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:20:\"filter_format.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":566:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/admin/config/content/formats/manage/(?P<filter_format>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/content/formats/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:38:\"/admin/config/content/formats/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.image_style.collection','/admin/config/media/image-styles','/admin/config/media/image-styles',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":963:{a:9:{s:4:\"path\";s:32:\"/admin/config/media/image-styles\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:11:\"image_style\";s:6:\"_title\";s:12:\"Image styles\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":394:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/config/media/image\\-styles$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/media/image-styles\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/config/media/image-styles\";s:8:\"numParts\";i:4;}}}}',4),('entity.image_style.delete_form','/admin/config/media/image-styles/manage/{image_style}/delete','/admin/config/media/image-styles/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1363:{a:9:{s:4:\"path\";s:60:\"/admin/config/media/image-styles/manage/{image_style}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"image_style.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":626:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:48:\"/admin/config/media/image-styles/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.image_style.devel_definition','/devel/image_style/{image_style}/definition','/devel/image_style/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1380:{a:9:{s:4:\"path\";s:43:\"/devel/image_style/{image_style}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:11:\"image_style\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":574:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/devel/image_style/(?P<image_style>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/image_style\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:31:\"/devel/image_style/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.image_style.devel_load','/devel/image_style/{image_style}','/devel/image_style/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1276:{a:9:{s:4:\"path\";s:32:\"/devel/image_style/{image_style}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:11:\"image_style\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":503:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/devel/image_style/(?P<image_style>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/image_style\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:20:\"/devel/image_style/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.image_style.edit_form','/admin/config/media/image-styles/manage/{image_style}','/admin/config/media/image-styles/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1301:{a:9:{s:4:\"path\";s:53:\"/admin/config/media/image-styles/manage/{image_style}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"image_style.edit\";s:6:\"_title\";s:10:\"Edit style\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":568:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:41:\"/admin/config/media/image-styles/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.image_style.flush_form','/admin/config/media/image-styles/manage/{image_style}/flush','/admin/config/media/image-styles/manage/%/flush',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1357:{a:9:{s:4:\"path\";s:59:\"/admin/config/media/image-styles/manage/{image_style}/flush\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"image_style.flush\";s:6:\"_title\";s:5:\"Flush\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":623:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"image_style\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/flush$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/flush\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"image_style\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:47:\"/admin/config/media/image-styles/manage/%/flush\";s:8:\"numParts\";i:7;}}}}',7),('entity.menu.add_form','/admin/structure/menu/add','/admin/structure/menu/add',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":918:{a:9:{s:4:\"path\";s:25:\"/admin/structure/menu/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:8:\"menu.add\";s:6:\"_title\";s:8:\"Add menu\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:4:\"menu\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/structure/menu/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/structure/menu/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/structure/menu/add\";s:8:\"numParts\";i:4;}}}}',4),('entity.menu.add_link_form','/admin/structure/menu/manage/{menu}/add','/admin/structure/menu/manage/%/add',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1308:{a:9:{s:4:\"path\";s:39:\"/admin/structure/menu/manage/{menu}/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\menu_link_content\\Controller\\MenuController::addLink\";s:6:\"_title\";s:13:\"Add menu link\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:17:\"menu_link_content\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":551:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/admin/structure/menu/manage/(?P<menu>[^/]++)/add$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:4:\"/add\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/menu/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:34:\"/admin/structure/menu/manage/%/add\";s:8:\"numParts\";i:6;}}}}',6),('entity.menu.collection','/admin/structure/menu','/admin/structure/menu',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":893:{a:9:{s:4:\"path\";s:21:\"/admin/structure/menu\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:4:\"menu\";s:6:\"_title\";s:5:\"Menus\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:15:\"administer menu\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":359:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/structure/menu$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/structure/menu\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/structure/menu\";s:8:\"numParts\";i:3;}}}}',3),('entity.menu.delete_form','/admin/structure/menu/manage/{menu}/delete','/admin/structure/menu/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1250:{a:9:{s:4:\"path\";s:42:\"/admin/structure/menu/manage/{menu}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:11:\"menu.delete\";s:6:\"_title\";s:11:\"Delete menu\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"menu.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":560:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/structure/menu/manage/(?P<menu>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/menu/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:37:\"/admin/structure/menu/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.menu.devel_definition','/devel/menu/{menu}/definition','/devel/menu/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1291:{a:9:{s:4:\"path\";s:29:\"/devel/menu/{menu}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"menu\";s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":522:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/devel/menu/(?P<menu>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/menu\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:24:\"/devel/menu/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.menu.devel_load','/devel/menu/{menu}','/devel/menu/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1187:{a:9:{s:4:\"path\";s:18:\"/devel/menu/{menu}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"menu\";s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":451:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/devel/menu/(?P<menu>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/menu\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/devel/menu/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.menu.edit_form','/admin/structure/menu/manage/{menu}','/admin/structure/menu/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1234:{a:9:{s:4:\"path\";s:35:\"/admin/structure/menu/manage/{menu}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:9:\"menu.edit\";s:15:\"_title_callback\";s:52:\"\\Drupal\\menu_ui\\Controller\\MenuController::menuTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"menu.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"menu\";a:2:{s:4:\"type\";s:11:\"entity:menu\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":503:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"menu\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/structure/menu/manage/(?P<menu>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"menu\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/menu/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"menu\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:30:\"/admin/structure/menu/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.menu_link_content.canonical','/admin/structure/menu/item/{menu_link_content}/edit','/admin/structure/menu/item/%/edit',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1359:{a:9:{s:4:\"path\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"menu_link_content.default\";s:6:\"_title\";s:14:\"Edit menu link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"menu_link_content.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":603:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/structure/menu/item/(?P<menu_link_content>[^/]++)/edit$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/item\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:33:\"/admin/structure/menu/item/%/edit\";s:8:\"numParts\";i:6;}}}}',6),('entity.menu_link_content.delete_form','/admin/structure/menu/item/{menu_link_content}/delete','/admin/structure/menu/item/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1368:{a:9:{s:4:\"path\";s:53:\"/admin/structure/menu/item/{menu_link_content}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"menu_link_content.delete\";s:6:\"_title\";s:16:\"Delete menu link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"menu_link_content.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":609:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/admin/structure/menu/item/(?P<menu_link_content>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/item\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:35:\"/admin/structure/menu/item/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.menu_link_content.devel_definition','/devel/menu_link_content/{menu_link_content}/definition','/devel/menu_link_content/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1452:{a:9:{s:4:\"path\";s:55:\"/devel/menu_link_content/{menu_link_content}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:17:\"menu_link_content\";s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":616:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/devel/menu_link_content/(?P<menu_link_content>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/devel/menu_link_content\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:37:\"/devel/menu_link_content/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.menu_link_content.devel_load','/devel/menu_link_content/{menu_link_content}','/devel/menu_link_content/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1348:{a:9:{s:4:\"path\";s:44:\"/devel/menu_link_content/{menu_link_content}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:17:\"menu_link_content\";s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":545:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:60:\"#^/devel/menu_link_content/(?P<menu_link_content>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/devel/menu_link_content\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:26:\"/devel/menu_link_content/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.menu_link_content.devel_render','/devel/menu_link_content/{menu_link_content}/render','/devel/menu_link_content/%/render',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1417:{a:9:{s:4:\"path\";s:51:\"/devel/menu_link_content/{menu_link_content}/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityRender\";s:6:\"_title\";s:12:\"Devel Render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:17:\"menu_link_content\";s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":603:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/devel/menu_link_content/(?P<menu_link_content>[^/]++)/render$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/render\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/devel/menu_link_content\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:33:\"/devel/menu_link_content/%/render\";s:8:\"numParts\";i:4;}}}}',4),('entity.menu_link_content.edit_form','/admin/structure/menu/item/{menu_link_content}/edit','/admin/structure/menu/item/%/edit',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1359:{a:9:{s:4:\"path\";s:51:\"/admin/structure/menu/item/{menu_link_content}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"menu_link_content.default\";s:6:\"_title\";s:14:\"Edit menu link\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:24:\"menu_link_content.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:17:\"menu_link_content\";a:2:{s:4:\"type\";s:24:\"entity:menu_link_content\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":603:{a:11:{s:4:\"vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/structure/menu/item/(?P<menu_link_content>[^/]++)/edit$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"menu_link_content\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/item\";}}s:9:\"path_vars\";a:1:{i:0;s:17:\"menu_link_content\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:33:\"/admin/structure/menu/item/%/edit\";s:8:\"numParts\";i:6;}}}}',6),('entity.migration.delete_form','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/delete','/admin/structure/migrate/manage/%/migrations/%/delete',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1732:{a:9:{s:4:\"path\";s:79:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:16:\"Delete migration\";s:12:\"_entity_form\";s:16:\"migration.delete\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"migration.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":830:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/migrate/manage/%/migrations/%/delete\";s:8:\"numParts\";i:8;}}}}',8),('entity.migration.destination','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/destination','/admin/structure/migrate/manage/%/migrations/%/destination',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1802:{a:9:{s:4:\"path\";s:84:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/destination\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:65:\"\\Drupal\\migrate_tools\\Controller\\MigrationController::destination\";s:6:\"_title\";s:11:\"Destination\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":846:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:110:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/destination$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/destination\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:58:\"/admin/structure/migrate/manage/%/migrations/%/destination\";s:8:\"numParts\";i:8;}}}}',8),('entity.migration.edit_form','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/edit','/admin/structure/migrate/manage/%/migrations/%/edit',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1720:{a:9:{s:4:\"path\";s:77:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:14:\"Edit migration\";s:12:\"_entity_form\";s:14:\"migration.edit\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"migration.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":824:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:103:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/edit$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:51:\"/admin/structure/migrate/manage/%/migrations/%/edit\";s:8:\"numParts\";i:8;}}}}',8),('entity.migration.list','/admin/structure/migrate/manage/{migration_group}/migrations','/admin/structure/migrate/manage/%/migrations',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1219:{a:9:{s:4:\"path\";s:60:\"/admin/structure/migrate/manage/{migration_group}/migrations\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:9:\"migration\";s:6:\"_title\";s:10:\"Migrations\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":629:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"migration_group\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"migration_group\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:44:\"/admin/structure/migrate/manage/%/migrations\";s:8:\"numParts\";i:6;}}}}',6),('entity.migration.overview','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}','/admin/structure/migrate/manage/%/migrations/%',122,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1720:{a:9:{s:4:\"path\";s:72:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:62:\"\\Drupal\\migrate_tools\\Controller\\MigrationController::overview\";s:6:\"_title\";s:18:\"Migration overview\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":772:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:98:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:122;s:14:\"patternOutline\";s:46:\"/admin/structure/migrate/manage/%/migrations/%\";s:8:\"numParts\";i:7;}}}}',7),('entity.migration.process','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/process','/admin/structure/migrate/manage/%/migrations/%/process',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1776:{a:9:{s:4:\"path\";s:80:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/process\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:61:\"\\Drupal\\migrate_tools\\Controller\\MigrationController::process\";s:6:\"_title\";s:7:\"Process\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":833:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/process$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/process\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:54:\"/admin/structure/migrate/manage/%/migrations/%/process\";s:8:\"numParts\";i:8;}}}}',8),('entity.migration.process.run','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/process/run','/admin/structure/migrate/manage/%/migrations/%/process/run',491,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1785:{a:9:{s:4:\"path\";s:84:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/process/run\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:57:\"\\Drupal\\migrate_tools\\Controller\\MigrationController::run\";s:6:\"_title\";s:3:\"Run\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":846:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:110:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/process/run$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/process/run\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:491;s:14:\"patternOutline\";s:58:\"/admin/structure/migrate/manage/%/migrations/%/process/run\";s:8:\"numParts\";i:9;}}}}',9),('entity.migration.source','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/source','/admin/structure/migrate/manage/%/migrations/%/source',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1770:{a:9:{s:4:\"path\";s:79:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/source\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:60:\"\\Drupal\\migrate_tools\\Controller\\MigrationController::source\";s:6:\"_title\";s:6:\"Source\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":830:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:105:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/source$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/source\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:53:\"/admin/structure/migrate/manage/%/migrations/%/source\";s:8:\"numParts\";i:8;}}}}',8),('entity.migration_group.add_form','/admin/structure/migrate/add','/admin/structure/migrate/add',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":966:{a:9:{s:4:\"path\";s:28:\"/admin/structure/migrate/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:19:\"Add migration group\";s:12:\"_entity_form\";s:19:\"migration_group.add\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:15:\"migration_group\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/structure/migrate/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/structure/migrate/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/structure/migrate/add\";s:8:\"numParts\";i:4;}}}}',4),('entity.migration_group.delete_form','/admin/structure/migrate/manage/{migration_group}/delete','/admin/structure/migrate/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1376:{a:9:{s:4:\"path\";s:56:\"/admin/structure/migrate/manage/{migration_group}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:22:\"Delete migration group\";s:12:\"_entity_form\";s:22:\"migration_group.delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:22:\"migration_group.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":616:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"migration_group\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"migration_group\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/migrate/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.migration_group.devel_definition','/devel/migration_group/{migration_group}/definition','/devel/migration_group/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1428:{a:9:{s:4:\"path\";s:51:\"/devel/migration_group/{migration_group}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:15:\"migration_group\";s:10:\"parameters\";a:1:{s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":602:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"migration_group\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/devel/migration_group/(?P<migration_group>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/devel/migration_group\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"migration_group\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:35:\"/devel/migration_group/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.migration_group.devel_load','/devel/migration_group/{migration_group}','/devel/migration_group/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1324:{a:9:{s:4:\"path\";s:40:\"/devel/migration_group/{migration_group}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:15:\"migration_group\";s:10:\"parameters\";a:1:{s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":531:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"migration_group\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:56:\"#^/devel/migration_group/(?P<migration_group>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/devel/migration_group\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"migration_group\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:24:\"/devel/migration_group/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.migration_group.edit_form','/admin/structure/migrate/manage/{migration_group}','/admin/structure/migrate/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1308:{a:9:{s:4:\"path\";s:49:\"/admin/structure/migrate/manage/{migration_group}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:20:\"Edit migration group\";s:12:\"_entity_form\";s:20:\"migration_group.edit\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:22:\"migration_group.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":559:{a:11:{s:4:\"vars\";a:1:{i:0;s:15:\"migration_group\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:15:\"migration_group\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/structure/migrate/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.migration_group.list','/admin/structure/migrate','/admin/structure/migrate',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":929:{a:9:{s:4:\"path\";s:24:\"/admin/structure/migrate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:15:\"migration_group\";s:6:\"_title\";s:10:\"Migrations\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":368:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/admin/structure/migrate$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/structure/migrate\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/structure/migrate\";s:8:\"numParts\";i:3;}}}}',3),('entity.node.canonical','/node/{node}','/node/%',2,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1163:{a:9:{s:4:\"path\";s:12:\"/node/{node}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\node\\Controller\\NodeViewController::view\";s:15:\"_title_callback\";s:49:\"\\Drupal\\node\\Controller\\NodeViewController::title\";}s:12:\"requirements\";a:2:{s:4:\"node\";s:3:\"\\d+\";s:14:\"_entity_access\";s:9:\"node.view\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":425:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/node/(?P<node>\\d+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:7:\"/node/%\";s:8:\"numParts\";i:2;}}}}',2),('entity.node.delete_form','/node/{node}/delete','/node/%/delete',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1198:{a:9:{s:4:\"path\";s:19:\"/node/{node}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:11:\"node.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:2:{s:4:\"node\";s:3:\"\\d+\";s:14:\"_entity_access\";s:11:\"node.delete\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":483:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/node/(?P<node>\\d+)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:14:\"/node/%/delete\";s:8:\"numParts\";i:3;}}}}',3),('entity.node.delete_multiple_form','/admin/content/node/delete','/admin/content/node/delete',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":962:{a:9:{s:4:\"path\";s:26:\"/admin/content/node/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:32:\"\\Drupal\\node\\Form\\DeleteMultiple\";s:14:\"entity_type_id\";s:4:\"node\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:4:\"node\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/content/node/delete$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/content/node/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/content/node/delete\";s:8:\"numParts\";i:4;}}}}',4),('entity.node.devel_definition','/devel/node/{node}/definition','/devel/node/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1291:{a:9:{s:4:\"path\";s:29:\"/devel/node/{node}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"node\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":522:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/devel/node/(?P<node>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:24:\"/devel/node/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.node.devel_load','/devel/node/{node}','/devel/node/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1187:{a:9:{s:4:\"path\";s:18:\"/devel/node/{node}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"node\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":451:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/devel/node/(?P<node>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/devel/node/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.node.devel_render','/devel/node/{node}/render','/devel/node/%/render',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1256:{a:9:{s:4:\"path\";s:25:\"/devel/node/{node}/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityRender\";s:6:\"_title\";s:12:\"Devel Render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"node\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":509:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/devel/node/(?P<node>[^/]++)/render$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/render\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:20:\"/devel/node/%/render\";s:8:\"numParts\";i:4;}}}}',4),('entity.node.edit_form','/node/{node}/edit','/node/%/edit',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1161:{a:9:{s:4:\"path\";s:17:\"/node/{node}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:12:\"_entity_form\";s:9:\"node.edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"node.update\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":477:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/node/(?P<node>\\d+)/edit$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:12:\"/node/%/edit\";s:8:\"numParts\";i:3;}}}}',3),('entity.node.field_ui_fields','/admin/structure/types/manage/{node_type}/fields','/admin/structure/types/manage/%/fields',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1397:{a:9:{s:4:\"path\";s:48:\"/admin/structure/types/manage/{node_type}/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer node fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":583:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/fields\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/types/manage/%/fields\";s:8:\"numParts\";i:6;}}}}',6),('entity.node.latest_version','/node/{node}/latest','/node/%/latest',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1369:{a:9:{s:4:\"path\";s:19:\"/node/{node}/latest\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:9:\"node.full\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:9:\"node.view\";s:34:\"_content_moderation_latest_version\";s:4:\"TRUE\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:31:\"_content_moderation_entity_type\";s:4:\"node\";s:10:\"parameters\";a:1:{s:4:\"node\";a:3:{s:4:\"type\";s:11:\"entity:node\";s:20:\"load_latest_revision\";b:1;s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:28:\"access_check.latest_revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":483:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/node/(?P<node>\\d+)/latest$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/latest\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:14:\"/node/%/latest\";s:8:\"numParts\";i:3;}}}}',3),('entity.node.preview','/node/preview/{node_preview}/{view_mode_id}','/node/preview/%/%',12,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1444:{a:9:{s:4:\"path\";s:43:\"/node/preview/{node_preview}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:51:\"\\Drupal\\node\\Controller\\NodePreviewController::view\";s:15:\"_title_callback\";s:52:\"\\Drupal\\node\\Controller\\NodePreviewController::title\";}s:12:\"requirements\";a:1:{s:20:\"_node_preview_access\";s:14:\"{node_preview}\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"node_preview\";a:2:{s:4:\"type\";s:12:\"node_preview\";s:9:\"converter\";s:42:\"drupal.proxy_original_service.node_preview\";}}s:14:\"_access_checks\";a:1:{i:0;s:25:\"access_check.node.preview\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":650:{a:11:{s:4:\"vars\";a:2:{i:0;s:12:\"node_preview\";i:1;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/node/preview/(?P<node_preview>[^/]++)/(?P<view_mode_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"node_preview\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/node/preview\";}}s:9:\"path_vars\";a:2:{i:0;s:12:\"node_preview\";i:1;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:12;s:14:\"patternOutline\";s:17:\"/node/preview/%/%\";s:8:\"numParts\";i:4;}}}}',4),('entity.node.revision','/node/{node}/revisions/{node_revision}/view','/node/%/revisions/%/view',21,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1371:{a:9:{s:4:\"path\";s:43:\"/node/{node}/revisions/{node_revision}/view\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:52:\"\\Drupal\\node\\Controller\\NodeController::revisionShow\";s:15:\"_title_callback\";s:57:\"\\Drupal\\node\\Controller\\NodeController::revisionPageTitle\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:4:\"view\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":706:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:66:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/view$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/view\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:24:\"/node/%/revisions/%/view\";s:8:\"numParts\";i:5;}}}}',5),('entity.node.version_history','/node/{node}/revisions','/node/%/revisions',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1264:{a:9:{s:4:\"path\";s:22:\"/node/{node}/revisions\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:9:\"Revisions\";s:11:\"_controller\";s:56:\"\\Drupal\\node\\Controller\\NodeController::revisionOverview\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:4:\"view\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":493:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/node/(?P<node>\\d+)/revisions$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/node/%/revisions\";s:8:\"numParts\";i:3;}}}}',3),('entity.node_type.collection','/admin/structure/types','/admin/structure/types',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":920:{a:9:{s:4:\"path\";s:22:\"/admin/structure/types\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:9:\"node_type\";s:6:\"_title\";s:13:\"Content types\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/structure/types$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/types\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/structure/types\";s:8:\"numParts\";i:3;}}}}',3),('entity.node_type.delete_form','/admin/structure/types/manage/{node_type}/delete','/admin/structure/types/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1293:{a:9:{s:4:\"path\";s:48:\"/admin/structure/types/manage/{node_type}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"node_type.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"node_type.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":583:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/types/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.node_type.devel_definition','/devel/node_type/{node_type}/definition','/devel/node_type/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1351:{a:9:{s:4:\"path\";s:39:\"/devel/node_type/{node_type}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:9:\"node_type\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":557:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/devel/node_type/(?P<node_type>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/devel/node_type\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:29:\"/devel/node_type/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.node_type.devel_load','/devel/node_type/{node_type}','/devel/node_type/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1247:{a:9:{s:4:\"path\";s:28:\"/devel/node_type/{node_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:9:\"node_type\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":486:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/devel/node_type/(?P<node_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/devel/node_type\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:18:\"/devel/node_type/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.node_type.edit_form','/admin/structure/types/manage/{node_type}','/admin/structure/types/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1295:{a:9:{s:4:\"path\";s:41:\"/admin/structure/types/manage/{node_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:14:\"node_type.edit\";s:15:\"_title_callback\";s:54:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::title\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":526:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:31:\"/admin/structure/types/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.search_page.collection','/admin/config/search/pages','/admin/config/search/pages',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":932:{a:9:{s:4:\"path\";s:26:\"/admin/config/search/pages\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:11:\"search_page\";s:6:\"_title\";s:12:\"Search pages\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer search\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/config/search/pages$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/config/search/pages\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/config/search/pages\";s:8:\"numParts\";i:4;}}}}',4),('entity.search_page.delete_form','/admin/config/search/pages/manage/{search_page}/delete','/admin/config/search/pages/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1332:{a:9:{s:4:\"path\";s:54:\"/admin/config/search/pages/manage/{search_page}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"search_page.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"search_page.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":607:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:42:\"/admin/config/search/pages/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.search_page.devel_definition','/devel/search_page/{search_page}/definition','/devel/search_page/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1380:{a:9:{s:4:\"path\";s:43:\"/devel/search_page/{search_page}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:11:\"search_page\";s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":574:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/devel/search_page/(?P<search_page>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/search_page\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:31:\"/devel/search_page/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.search_page.devel_load','/devel/search_page/{search_page}','/devel/search_page/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1276:{a:9:{s:4:\"path\";s:32:\"/devel/search_page/{search_page}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:11:\"search_page\";s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":503:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/devel/search_page/(?P<search_page>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/devel/search_page\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:20:\"/devel/search_page/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.search_page.disable','/admin/config/search/pages/manage/{search_page}/disable','/admin/config/search/pages/manage/%/disable',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1434:{a:9:{s:4:\"path\";s:55:\"/admin/config/search/pages/manage/{search_page}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\search\\Controller\\SearchController::performOperation\";s:2:\"op\";s:7:\"disable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:19:\"search_page.disable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":610:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:71:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/disable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:43:\"/admin/config/search/pages/manage/%/disable\";s:8:\"numParts\";i:7;}}}}',7),('entity.search_page.edit_form','/admin/config/search/pages/manage/{search_page}','/admin/config/search/pages/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1323:{a:9:{s:4:\"path\";s:47:\"/admin/config/search/pages/manage/{search_page}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"search_page.edit\";s:15:\"_title_callback\";s:53:\"\\Drupal\\search\\Controller\\SearchController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:18:\"search_page.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":549:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:35:\"/admin/config/search/pages/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.search_page.enable','/admin/config/search/pages/manage/{search_page}/enable','/admin/config/search/pages/manage/%/enable',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1428:{a:9:{s:4:\"path\";s:54:\"/admin/config/search/pages/manage/{search_page}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\search\\Controller\\SearchController::performOperation\";s:2:\"op\";s:6:\"enable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:18:\"search_page.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":607:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/enable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:42:\"/admin/config/search/pages/manage/%/enable\";s:8:\"numParts\";i:7;}}}}',7),('entity.search_page.set_default','/admin/config/search/pages/manage/{search_page}/set-default','/admin/config/search/pages/manage/%/set-default',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1424:{a:9:{s:4:\"path\";s:59:\"/admin/config/search/pages/manage/{search_page}/set-default\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\search\\Controller\\SearchController::setAsDefault\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:18:\"search_page.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"search_page\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":624:{a:11:{s:4:\"vars\";a:1:{i:0;s:11:\"search_page\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/config/search/pages/manage/(?P<search_page>[^/]++)/set\\-default$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/set-default\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"search_page\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/search/pages/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:11:\"search_page\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:47:\"/admin/config/search/pages/manage/%/set-default\";s:8:\"numParts\";i:7;}}}}',7),('entity.shortcut.canonical','/admin/config/user-interface/shortcut/link/{shortcut}','/admin/config/user-interface/shortcut/link/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1291:{a:9:{s:4:\"path\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"shortcut.default\";s:6:\"_title\";s:4:\"Edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:15:\"shortcut.update\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":556:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/config/user-interface/shortcut/link/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.shortcut.delete_form','/admin/config/user-interface/shortcut/link/{shortcut}/delete','/admin/config/user-interface/shortcut/link/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1357:{a:9:{s:4:\"path\";s:60:\"/admin/config/user-interface/shortcut/link/{shortcut}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"shortcut.delete\";s:6:\"_title\";s:6:\"Delete\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:15:\"shortcut.delete\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":614:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/config/user-interface/shortcut/link/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.shortcut.devel_definition','/devel/shortcut/{shortcut}/definition','/devel/shortcut/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1339:{a:9:{s:4:\"path\";s:37:\"/devel/shortcut/{shortcut}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:8:\"shortcut\";s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":550:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/devel/shortcut/(?P<shortcut>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"shortcut\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/shortcut\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:28:\"/devel/shortcut/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.shortcut.devel_load','/devel/shortcut/{shortcut}','/devel/shortcut/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1235:{a:9:{s:4:\"path\";s:26:\"/devel/shortcut/{shortcut}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:8:\"shortcut\";s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":479:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/devel/shortcut/(?P<shortcut>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"shortcut\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/shortcut\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:17:\"/devel/shortcut/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.shortcut.devel_render','/devel/shortcut/{shortcut}/render','/devel/shortcut/%/render',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1304:{a:9:{s:4:\"path\";s:33:\"/devel/shortcut/{shortcut}/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityRender\";s:6:\"_title\";s:12:\"Devel Render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:8:\"shortcut\";s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":537:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:49:\"#^/devel/shortcut/(?P<shortcut>[^/]++)/render$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/render\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"shortcut\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/shortcut\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:24:\"/devel/shortcut/%/render\";s:8:\"numParts\";i:4;}}}}',4),('entity.shortcut.edit_form','/admin/config/user-interface/shortcut/link/{shortcut}','/admin/config/user-interface/shortcut/link/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1291:{a:9:{s:4:\"path\";s:53:\"/admin/config/user-interface/shortcut/link/{shortcut}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"shortcut.default\";s:6:\"_title\";s:4:\"Edit\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:15:\"shortcut.update\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":556:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:44:\"/admin/config/user-interface/shortcut/link/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.shortcut.link_delete_inline','/admin/config/user-interface/shortcut/link/{shortcut}/delete-inline','/admin/config/user-interface/shortcut/link/%/delete-inline',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1475:{a:9:{s:4:\"path\";s:67:\"/admin/config/user-interface/shortcut/link/{shortcut}/delete-inline\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:71:\"Drupal\\shortcut\\Controller\\ShortcutController::deleteShortcutLinkInline\";}s:12:\"requirements\";a:3:{s:14:\"_entity_access\";s:15:\"shortcut.delete\";s:11:\"_csrf_token\";s:4:\"TRUE\";s:8:\"shortcut\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"shortcut\";a:2:{s:4:\"type\";s:15:\"entity:shortcut\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":637:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"shortcut\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:82:\"#^/admin/config/user\\-interface/shortcut/link/(?P<shortcut>\\d+)/delete\\-inline$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/delete-inline\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:8:\"shortcut\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:42:\"/admin/config/user-interface/shortcut/link\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"shortcut\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:58:\"/admin/config/user-interface/shortcut/link/%/delete-inline\";s:8:\"numParts\";i:7;}}}}',7),('entity.shortcut_set.collection','/admin/config/user-interface/shortcut','/admin/config/user-interface/shortcut',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":977:{a:9:{s:4:\"path\";s:37:\"/admin/config/user-interface/shortcut\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:12:\"shortcut_set\";s:6:\"_title\";s:9:\"Shortcuts\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer shortcuts\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/user\\-interface/shortcut$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/user-interface/shortcut\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/user-interface/shortcut\";s:8:\"numParts\";i:4;}}}}',4),('entity.shortcut_set.customize_form','/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize','/admin/config/user-interface/shortcut/manage/%/customize',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1407:{a:9:{s:4:\"path\";s:69:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/customize\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:22:\"shortcut_set.customize\";s:6:\"_title\";s:10:\"List links\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"shortcut_set.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":655:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/customize$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/customize\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:56:\"/admin/config/user-interface/shortcut/manage/%/customize\";s:8:\"numParts\";i:7;}}}}',7),('entity.shortcut_set.delete_form','/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete','/admin/config/user-interface/shortcut/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1400:{a:9:{s:4:\"path\";s:66:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"shortcut_set.delete\";s:6:\"_title\";s:19:\"Delete shortcut set\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"shortcut_set.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":645:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:83:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:53:\"/admin/config/user-interface/shortcut/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.shortcut_set.devel_definition','/devel/shortcut_set/{shortcut_set}/definition','/devel/shortcut_set/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1392:{a:9:{s:4:\"path\";s:45:\"/devel/shortcut_set/{shortcut_set}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:12:\"shortcut_set\";s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":581:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/devel/shortcut_set/(?P<shortcut_set>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/devel/shortcut_set\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:32:\"/devel/shortcut_set/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.shortcut_set.devel_load','/devel/shortcut_set/{shortcut_set}','/devel/shortcut_set/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1288:{a:9:{s:4:\"path\";s:34:\"/devel/shortcut_set/{shortcut_set}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:12:\"shortcut_set\";s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":510:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/devel/shortcut_set/(?P<shortcut_set>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/devel/shortcut_set\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:21:\"/devel/shortcut_set/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.shortcut_set.edit_form','/admin/config/user-interface/shortcut/manage/{shortcut_set}','/admin/config/user-interface/shortcut/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1331:{a:9:{s:4:\"path\";s:59:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"shortcut_set.edit\";s:6:\"_title\";s:17:\"Edit shortcut set\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:19:\"shortcut_set.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":587:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:46:\"/admin/config/user-interface/shortcut/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.taxonomy_term.add_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/add','/admin/structure/taxonomy/manage/%/add',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1440:{a:9:{s:4:\"path\";s:58:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\taxonomy\\Controller\\TaxonomyController::addForm\";s:6:\"_title\";s:8:\"Add term\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:35:\"taxonomy_term:{taxonomy_vocabulary}\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":626:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:74:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/add$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:4:\"/add\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:38:\"/admin/structure/taxonomy/manage/%/add\";s:8:\"numParts\";i:6;}}}}',6),('entity.taxonomy_term.canonical','/taxonomy/term/{taxonomy_term}','/taxonomy/term/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1648:{a:9:{s:4:\"path\";s:30:\"/taxonomy/term/{taxonomy_term}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:6:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:13:\"taxonomy_term\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;s:15:\"_title_callback\";s:57:\"\\Drupal\\taxonomy\\Controller\\TaxonomyController::termTitle\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:13:\"taxonomy_term\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":499:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/taxonomy/term/(?P<taxonomy_term>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"taxonomy_term\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/taxonomy/term/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.taxonomy_term.delete_form','/taxonomy/term/{taxonomy_term}/delete','/taxonomy/term/%/delete',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1304:{a:9:{s:4:\"path\";s:37:\"/taxonomy/term/{taxonomy_term}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:20:\"taxonomy_term.delete\";s:6:\"_title\";s:11:\"Delete term\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"taxonomy_term.delete\";s:13:\"taxonomy_term\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":551:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/taxonomy/term/(?P<taxonomy_term>\\d+)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"taxonomy_term\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:23:\"/taxonomy/term/%/delete\";s:8:\"numParts\";i:4;}}}}',4),('entity.taxonomy_term.devel_definition','/devel/taxonomy_term/{taxonomy_term}/definition','/devel/taxonomy_term/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1404:{a:9:{s:4:\"path\";s:47:\"/devel/taxonomy_term/{taxonomy_term}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"taxonomy_term\";s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":588:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:63:\"#^/devel/taxonomy_term/(?P<taxonomy_term>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"taxonomy_term\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/taxonomy_term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:33:\"/devel/taxonomy_term/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.taxonomy_term.devel_load','/devel/taxonomy_term/{taxonomy_term}','/devel/taxonomy_term/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1300:{a:9:{s:4:\"path\";s:36:\"/devel/taxonomy_term/{taxonomy_term}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"taxonomy_term\";s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":517:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/devel/taxonomy_term/(?P<taxonomy_term>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"taxonomy_term\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/taxonomy_term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:22:\"/devel/taxonomy_term/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.taxonomy_term.devel_render','/devel/taxonomy_term/{taxonomy_term}/render','/devel/taxonomy_term/%/render',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1369:{a:9:{s:4:\"path\";s:43:\"/devel/taxonomy_term/{taxonomy_term}/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityRender\";s:6:\"_title\";s:12:\"Devel Render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:13:\"taxonomy_term\";s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":575:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:59:\"#^/devel/taxonomy_term/(?P<taxonomy_term>[^/]++)/render$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/render\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"taxonomy_term\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/devel/taxonomy_term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:29:\"/devel/taxonomy_term/%/render\";s:8:\"numParts\";i:4;}}}}',4),('entity.taxonomy_term.edit_form','/taxonomy/term/{taxonomy_term}/edit','/taxonomy/term/%/edit',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1294:{a:9:{s:4:\"path\";s:35:\"/taxonomy/term/{taxonomy_term}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:21:\"taxonomy_term.default\";s:6:\"_title\";s:9:\"Edit term\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:20:\"taxonomy_term.update\";s:13:\"taxonomy_term\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:13:\"taxonomy_term\";a:2:{s:4:\"type\";s:20:\"entity:taxonomy_term\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":545:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:48:\"#^/taxonomy/term/(?P<taxonomy_term>\\d+)/edit$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:13:\"taxonomy_term\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"taxonomy_term\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:21:\"/taxonomy/term/%/edit\";s:8:\"numParts\";i:4;}}}}',4),('entity.taxonomy_term.field_ui_fields','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields','/admin/structure/taxonomy/manage/%/overview/fields',123,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1540:{a:9:{s:4:\"path\";s:70:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer taxonomy_term fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":664:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/overview/fields\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/structure/taxonomy/manage/%/overview/fields\";s:8:\"numParts\";i:7;}}}}',7),('entity.taxonomy_vocabulary.add_form','/admin/structure/taxonomy/add','/admin/structure/taxonomy/add',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1078:{a:9:{s:4:\"path\";s:29:\"/admin/structure/taxonomy/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:27:\"taxonomy_vocabulary.default\";s:14:\"entity_type_id\";s:19:\"taxonomy_vocabulary\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:19:\"taxonomy_vocabulary\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/structure/taxonomy/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/taxonomy/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/structure/taxonomy/add\";s:8:\"numParts\";i:4;}}}}',4),('entity.taxonomy_vocabulary.collection','/admin/structure/taxonomy','/admin/structure/taxonomy',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1016:{a:9:{s:4:\"path\";s:25:\"/admin/structure/taxonomy\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:19:\"taxonomy_vocabulary\";s:6:\"_title\";s:8:\"Taxonomy\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:44:\"access taxonomy overview+administer taxonomy\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":371:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/structure/taxonomy$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/structure/taxonomy\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/structure/taxonomy\";s:8:\"numParts\";i:3;}}}}',3),('entity.taxonomy_vocabulary.delete_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete','/admin/structure/taxonomy/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1464:{a:9:{s:4:\"path\";s:61:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:26:\"taxonomy_vocabulary.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"taxonomy_vocabulary.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":635:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:77:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:41:\"/admin/structure/taxonomy/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.taxonomy_vocabulary.devel_definition','/devel/taxonomy_vocabulary/{taxonomy_vocabulary}/definition','/devel/taxonomy_vocabulary/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1476:{a:9:{s:4:\"path\";s:59:\"/devel/taxonomy_vocabulary/{taxonomy_vocabulary}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:19:\"taxonomy_vocabulary\";s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":630:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/devel/taxonomy_vocabulary/(?P<taxonomy_vocabulary>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/devel/taxonomy_vocabulary\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:39:\"/devel/taxonomy_vocabulary/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.taxonomy_vocabulary.devel_load','/devel/taxonomy_vocabulary/{taxonomy_vocabulary}','/devel/taxonomy_vocabulary/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1372:{a:9:{s:4:\"path\";s:48:\"/devel/taxonomy_vocabulary/{taxonomy_vocabulary}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:19:\"taxonomy_vocabulary\";s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":559:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/devel/taxonomy_vocabulary/(?P<taxonomy_vocabulary>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/devel/taxonomy_vocabulary\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:28:\"/devel/taxonomy_vocabulary/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.taxonomy_vocabulary.edit_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}','/admin/structure/taxonomy/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1399:{a:9:{s:4:\"path\";s:54:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:27:\"taxonomy_vocabulary.default\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:26:\"taxonomy_vocabulary.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":578:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:34:\"/admin/structure/taxonomy/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.taxonomy_vocabulary.overview_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview','/admin/structure/taxonomy/manage/%/overview',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1492:{a:9:{s:4:\"path\";s:63:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:15:\"_title_callback\";s:62:\"Drupal\\taxonomy\\Controller\\TaxonomyController::vocabularyTitle\";s:5:\"_form\";s:34:\"Drupal\\taxonomy\\Form\\OverviewTerms\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:44:\"taxonomy_vocabulary.access taxonomy overview\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":641:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:79:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/overview\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:43:\"/admin/structure/taxonomy/manage/%/overview\";s:8:\"numParts\";i:6;}}}}',6),('entity.taxonomy_vocabulary.reset_form','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset','/admin/structure/taxonomy/manage/%/reset',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1387:{a:9:{s:4:\"path\";s:60:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/reset\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:25:\"taxonomy_vocabulary.reset\";s:6:\"_title\";s:5:\"Reset\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"administer taxonomy\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":632:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/reset$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/reset\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/taxonomy/manage/%/reset\";s:8:\"numParts\";i:6;}}}}',6),('entity.user.admin_form','/admin/config/people/accounts','/admin/config/people/accounts',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":971:{a:9:{s:4:\"path\";s:29:\"/admin/config/people/accounts\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:32:\"\\Drupal\\user\\AccountSettingsForm\";s:6:\"_title\";s:16:\"Account settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"administer account settings\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/config/people/accounts$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/config/people/accounts\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/config/people/accounts\";s:8:\"numParts\";i:4;}}}}',4),('entity.user.cancel_form','/user/{user}/cancel','/user/%/cancel',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1174:{a:9:{s:4:\"path\";s:19:\"/user/{user}/cancel\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:14:\"Cancel account\";s:12:\"_entity_form\";s:11:\"user.cancel\";}s:12:\"requirements\";a:2:{s:4:\"user\";s:3:\"\\d+\";s:14:\"_entity_access\";s:11:\"user.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":483:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/user/(?P<user>\\d+)/cancel$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/cancel\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:14:\"/user/%/cancel\";s:8:\"numParts\";i:3;}}}}',3),('entity.user.canonical','/user/{user}','/user/%',2,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1123:{a:9:{s:4:\"path\";s:12:\"/user/{user}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_view\";s:9:\"user.full\";s:15:\"_title_callback\";s:48:\"Drupal\\user\\Controller\\UserController::userTitle\";}s:12:\"requirements\";a:2:{s:4:\"user\";s:3:\"\\d+\";s:14:\"_entity_access\";s:9:\"user.view\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":425:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/user/(?P<user>\\d+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:7:\"/user/%\";s:8:\"numParts\";i:2;}}}}',2),('entity.user.collection','/admin/people','/admin/people',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1238:{a:9:{s:4:\"path\";s:13:\"/admin/people\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"People\";s:7:\"view_id\";s:17:\"user_admin_people\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:16:\"administer users\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":335:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/admin/people$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/admin/people\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/admin/people\";s:8:\"numParts\";i:2;}}}}',2),('entity.user.contact_form','/user/{user}/contact','/user/%/contact',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1215:{a:9:{s:4:\"path\";s:20:\"/user/{user}/contact\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:7:\"Contact\";s:11:\"_controller\";s:65:\"\\Drupal\\contact\\Controller\\ContactController::contactPersonalPage\";}s:12:\"requirements\";a:2:{s:28:\"_access_contact_personal_tab\";s:4:\"TRUE\";s:4:\"user\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:29:\"access_check.contact_personal\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":486:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/user/(?P<user>\\d+)/contact$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/contact\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/user/%/contact\";s:8:\"numParts\";i:3;}}}}',3),('entity.user.devel_definition','/devel/user/{user}/definition','/devel/user/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1291:{a:9:{s:4:\"path\";s:29:\"/devel/user/{user}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"user\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":522:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/devel/user/(?P<user>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:24:\"/devel/user/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.user.devel_load','/devel/user/{user}','/devel/user/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1187:{a:9:{s:4:\"path\";s:18:\"/devel/user/{user}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"user\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":451:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/devel/user/(?P<user>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/devel/user/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.user.devel_render','/devel/user/{user}/render','/devel/user/%/render',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1256:{a:9:{s:4:\"path\";s:25:\"/devel/user/{user}/render\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityRender\";s:6:\"_title\";s:12:\"Devel Render\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"user\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":509:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/devel/user/(?P<user>[^/]++)/render$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/render\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:20:\"/devel/user/%/render\";s:8:\"numParts\";i:4;}}}}',4),('entity.user.edit_form','/user/{user}/edit','/user/%/edit',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1211:{a:9:{s:4:\"path\";s:17:\"/user/{user}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"user.default\";s:15:\"_title_callback\";s:48:\"Drupal\\user\\Controller\\UserController::userTitle\";}s:12:\"requirements\";a:2:{s:4:\"user\";s:3:\"\\d+\";s:14:\"_entity_access\";s:11:\"user.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":477:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/user/(?P<user>\\d+)/edit$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:12:\"/user/%/edit\";s:8:\"numParts\";i:3;}}}}',3),('entity.user.field_ui_fields','/admin/config/people/accounts/fields','/admin/config/people/accounts/fields',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1076:{a:9:{s:4:\"path\";s:36:\"/admin/config/people/accounts/fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:62:\"\\Drupal\\field_ui\\Controller\\FieldConfigListController::listing\";s:6:\"_title\";s:13:\"Manage fields\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer user fields\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":405:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/config/people/accounts/fields$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/people/accounts/fields\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:36:\"/admin/config/people/accounts/fields\";s:8:\"numParts\";i:5;}}}}',5),('entity.user_role.collection','/admin/people/roles','/admin/people/roles',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":897:{a:9:{s:4:\"path\";s:19:\"/admin/people/roles\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:9:\"user_role\";s:6:\"_title\";s:5:\"Roles\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer permissions\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":353:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/admin/people/roles$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/people/roles\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/people/roles\";s:8:\"numParts\";i:3;}}}}',3),('entity.user_role.delete_form','/admin/people/roles/manage/{user_role}/delete','/admin/people/roles/manage/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1287:{a:9:{s:4:\"path\";s:45:\"/admin/people/roles/manage/{user_role}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"user_role.delete\";s:6:\"_title\";s:11:\"Delete role\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"user_role.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":574:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:61:\"#^/admin/people/roles/manage/(?P<user_role>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/people/roles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:35:\"/admin/people/roles/manage/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.user_role.devel_definition','/devel/user_role/{user_role}/definition','/devel/user_role/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1351:{a:9:{s:4:\"path\";s:39:\"/devel/user_role/{user_role}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:9:\"user_role\";s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":557:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/devel/user_role/(?P<user_role>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/devel/user_role\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:29:\"/devel/user_role/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.user_role.devel_load','/devel/user_role/{user_role}','/devel/user_role/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1247:{a:9:{s:4:\"path\";s:28:\"/devel/user_role/{user_role}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:9:\"user_role\";s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":486:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/devel/user_role/(?P<user_role>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/devel/user_role\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:18:\"/devel/user_role/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.user_role.edit_form','/admin/people/roles/manage/{user_role}','/admin/people/roles/manage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1221:{a:9:{s:4:\"path\";s:38:\"/admin/people/roles/manage/{user_role}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"user_role.default\";s:6:\"_title\";s:9:\"Edit role\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"user_role.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":517:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/people/roles/manage/(?P<user_role>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/people/roles/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/people/roles/manage/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.user_role.edit_permissions_form','/admin/people/permissions/{user_role}','/admin/people/permissions/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1241:{a:9:{s:4:\"path\";s:37:\"/admin/people/permissions/{user_role}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:49:\"\\Drupal\\user\\Form\\UserPermissionsRoleSpecificForm\";s:6:\"_title\";s:9:\"Edit role\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:16:\"user_role.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"user_role\";a:2:{s:4:\"type\";s:16:\"entity:user_role\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":514:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"user_role\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/people/permissions/(?P<user_role>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"user_role\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/people/permissions\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"user_role\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:27:\"/admin/people/permissions/%\";s:8:\"numParts\";i:4;}}}}',4),('entity.view.break_lock_form','/admin/structure/views/view/{view}/break-lock','/admin/structure/views/view/%/break-lock',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1271:{a:9:{s:4:\"path\";s:45:\"/admin/structure/views/view/{view}/break-lock\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"view.break_lock\";s:6:\"_title\";s:10:\"Break lock\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:15:\"view.break-lock\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":571:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:62:\"#^/admin/structure/views/view/(?P<view>[^/]++)/break\\-lock$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/break-lock\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:40:\"/admin/structure/views/view/%/break-lock\";s:8:\"numParts\";i:6;}}}}',6),('entity.view.collection','/admin/structure/views','/admin/structure/views',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":898:{a:9:{s:4:\"path\";s:22:\"/admin/structure/views\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:4:\"view\";s:6:\"_title\";s:5:\"Views\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/structure/views$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/structure/views\";s:8:\"numParts\";i:3;}}}}',3),('entity.view.delete_form','/admin/structure/views/view/{view}/delete','/admin/structure/views/view/%/delete',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1246:{a:9:{s:4:\"path\";s:41:\"/admin/structure/views/view/{view}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:11:\"view.delete\";s:6:\"_title\";s:11:\"Delete view\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"view.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":557:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/structure/views/view/(?P<view>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:36:\"/admin/structure/views/view/%/delete\";s:8:\"numParts\";i:6;}}}}',6),('entity.view.devel_definition','/devel/view/{view}/definition','/devel/view/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1291:{a:9:{s:4:\"path\";s:29:\"/devel/view/{view}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"view\";s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":522:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:45:\"#^/devel/view/(?P<view>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:24:\"/devel/view/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.view.devel_load','/devel/view/{view}','/devel/view/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1187:{a:9:{s:4:\"path\";s:18:\"/devel/view/{view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:4:\"view\";s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":451:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/devel/view/(?P<view>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/devel/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/devel/view/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.view.disable','/admin/structure/views/view/{view}/disable','/admin/structure/views/view/%/disable',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1349:{a:9:{s:4:\"path\";s:42:\"/admin/structure/views/view/{view}/disable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::ajaxOperation\";s:2:\"op\";s:7:\"disable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:12:\"view.disable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":560:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:58:\"#^/admin/structure/views/view/(?P<view>[^/]++)/disable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/disable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:37:\"/admin/structure/views/view/%/disable\";s:8:\"numParts\";i:6;}}}}',6),('entity.view.duplicate_form','/admin/structure/views/view/{view}/duplicate','/admin/structure/views/view/%/duplicate',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1268:{a:9:{s:4:\"path\";s:44:\"/admin/structure/views/view/{view}/duplicate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:14:\"view.duplicate\";s:6:\"_title\";s:14:\"Duplicate view\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:14:\"view.duplicate\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":567:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:60:\"#^/admin/structure/views/view/(?P<view>[^/]++)/duplicate$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/duplicate\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:39:\"/admin/structure/views/view/%/duplicate\";s:8:\"numParts\";i:6;}}}}',6),('entity.view.edit_display_form','/admin/structure/views/view/{view}/edit/{display_id}','/admin/structure/views/view/%/edit',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1473:{a:9:{s:4:\"path\";s:52:\"/admin/structure/views/view/{view}/edit/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::edit\";s:10:\"display_id\";N;}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"view.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":703:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:83:\"#^/admin/structure/views/view/(?P<view>[^/]++)/edit(?:/(?P<display_id>[^/]++))?$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:34:\"/admin/structure/views/view/%/edit\";s:8:\"numParts\";i:7;}}}}',7),('entity.view.edit_form','/admin/structure/views/view/{view}','/admin/structure/views/view/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1232:{a:9:{s:4:\"path\";s:34:\"/admin/structure/views/view/{view}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::edit\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:11:\"view.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":500:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/admin/structure/views/view/(?P<view>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:29:\"/admin/structure/views/view/%\";s:8:\"numParts\";i:5;}}}}',5),('entity.view.enable','/admin/structure/views/view/{view}/enable','/admin/structure/views/view/%/enable',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1343:{a:9:{s:4:\"path\";s:41:\"/admin/structure/views/view/{view}/enable\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::ajaxOperation\";s:2:\"op\";s:6:\"enable\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.enable\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:2:{s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":557:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"view\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:57:\"#^/admin/structure/views/view/(?P<view>[^/]++)/enable$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/enable\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"view\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:36:\"/admin/structure/views/view/%/enable\";s:8:\"numParts\";i:6;}}}}',6),('entity.view.preview_form','/admin/structure/views/view/{view}/preview/{display_id}','/admin/structure/views/view/%/preview',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1453:{a:9:{s:4:\"path\";s:55:\"/admin/structure/views/view/{view}/preview/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:12:\"view.preview\";s:10:\"display_id\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":712:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/structure/views/view/(?P<view>[^/]++)/preview(?:/(?P<display_id>[^/]++))?$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/preview\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/structure/views/view\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"view\";i:1;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:37:\"/admin/structure/views/view/%/preview\";s:8:\"numParts\";i:7;}}}}',7),('entity.workflow.add_form','/admin/config/workflow/workflows/add','/admin/config/workflow/workflows/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1067:{a:9:{s:4:\"path\";s:36:\"/admin/config/workflow/workflows/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:12:\"_entity_form\";s:12:\"workflow.add\";s:14:\"entity_type_id\";s:8:\"workflow\";s:15:\"_title_callback\";s:56:\"Drupal\\Core\\Entity\\Controller\\EntityController::addTitle\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:8:\"workflow\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":405:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/config/workflow/workflows/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/workflow/workflows/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:36:\"/admin/config/workflow/workflows/add\";s:8:\"numParts\";i:5;}}}}',5),('entity.workflow.add_state_form','/admin/config/workflow/workflows/manage/{workflow}/add_state','/admin/config/workflow/workflows/manage/%/add_state',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1342:{a:9:{s:4:\"path\";s:60:\"/admin/config/workflow/workflows/manage/{workflow}/add_state\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:18:\"workflow.add-state\";s:6:\"_title\";s:9:\"Add state\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:13:\"workflow.edit\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":620:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"workflow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/add_state$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/add_state\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"workflow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:51:\"/admin/config/workflow/workflows/manage/%/add_state\";s:8:\"numParts\";i:7;}}}}',7),('entity.workflow.add_transition_form','/admin/config/workflow/workflows/manage/{workflow}/add_transition','/admin/config/workflow/workflows/manage/%/add_transition',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1373:{a:9:{s:4:\"path\";s:65:\"/admin/config/workflow/workflows/manage/{workflow}/add_transition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:23:\"workflow.add-transition\";s:6:\"_title\";s:14:\"Add transition\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:13:\"workflow.edit\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":635:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"workflow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:81:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/add_transition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/add_transition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"workflow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:56:\"/admin/config/workflow/workflows/manage/%/add_transition\";s:8:\"numParts\";i:7;}}}}',7),('entity.workflow.collection','/admin/config/workflow/workflows','/admin/config/workflow/workflows',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1010:{a:9:{s:4:\"path\";s:32:\"/admin/config/workflow/workflows\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:12:\"_entity_list\";s:8:\"workflow\";s:6:\"_title\";s:9:\"Workflows\";s:16:\"_title_arguments\";a:0:{}s:14:\"_title_context\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:20:\"administer workflows\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":393:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/config/workflow/workflows$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/workflow/workflows\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/config/workflow/workflows\";s:8:\"numParts\";i:4;}}}}',4),('entity.workflow.delete_form','/admin/config/workflow/workflows/manage/{workflow}/delete','/admin/config/workflow/workflows/manage/%/delete',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1390:{a:9:{s:4:\"path\";s:57:\"/admin/config/workflow/workflows/manage/{workflow}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"workflow.delete\";s:15:\"_title_callback\";s:60:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::deleteTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:15:\"workflow.delete\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":610:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"workflow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:73:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"workflow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:48:\"/admin/config/workflow/workflows/manage/%/delete\";s:8:\"numParts\";i:7;}}}}',7),('entity.workflow.delete_state_form','/admin/config/workflow/workflows/manage/{workflow}/state/{workflow_state}/delete','/admin/config/workflow/workflows/manage/%/state/%/delete',501,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1617:{a:9:{s:4:\"path\";s:80:\"/admin/config/workflow/workflows/manage/{workflow}/state/{workflow_state}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:46:\"\\Drupal\\workflows\\Form\\WorkflowStateDeleteForm\";s:6:\"_title\";s:12:\"Delete state\";}s:12:\"requirements\";a:1:{s:29:\"_workflow_state_delete_access\";s:4:\"true\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"workflows.access_check.delete_state\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":830:{a:11:{s:4:\"vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:14:\"workflow_state\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/state/(?P<workflow_state>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"workflow_state\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/state\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:14:\"workflow_state\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:56:\"/admin/config/workflow/workflows/manage/%/state/%/delete\";s:8:\"numParts\";i:9;}}}}',9),('entity.workflow.delete_transition_form','/admin/config/workflow/workflows/manage/{workflow}/transition/{workflow_transition}/delete','/admin/config/workflow/workflows/manage/%/transition/%/delete',501,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1652:{a:9:{s:4:\"path\";s:90:\"/admin/config/workflow/workflows/manage/{workflow}/transition/{workflow_transition}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:51:\"\\Drupal\\workflows\\Form\\WorkflowTransitionDeleteForm\";s:6:\"_title\";s:17:\"Delete transition\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:13:\"workflow.edit\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":866:{a:11:{s:4:\"vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:19:\"workflow_transition\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:116:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/transition/(?P<workflow_transition>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"workflow_transition\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/transition\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:19:\"workflow_transition\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:61:\"/admin/config/workflow/workflows/manage/%/transition/%/delete\";s:8:\"numParts\";i:9;}}}}',9),('entity.workflow.devel_definition','/devel/workflow/{workflow}/definition','/devel/workflow/%/definition',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1339:{a:9:{s:4:\"path\";s:37:\"/devel/workflow/{workflow}/definition\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityTypeDefinition\";s:6:\"_title\";s:22:\"Entity type definition\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:8:\"workflow\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":550:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"workflow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/devel/workflow/(?P<workflow>[^/]++)/definition$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/definition\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/workflow\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"workflow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:28:\"/devel/workflow/%/definition\";s:8:\"numParts\";i:4;}}}}',4),('entity.workflow.devel_load','/devel/workflow/{workflow}','/devel/workflow/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1235:{a:9:{s:4:\"path\";s:26:\"/devel/workflow/{workflow}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:58:\"\\Drupal\\devel\\Controller\\EntityDebugController::entityLoad\";s:6:\"_title\";s:10:\"Devel Load\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"access devel information\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:21:\"_devel_entity_type_id\";s:8:\"workflow\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":479:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"workflow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/devel/workflow/(?P<workflow>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/devel/workflow\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"workflow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:17:\"/devel/workflow/%\";s:8:\"numParts\";i:3;}}}}',3),('entity.workflow.edit_form','/admin/config/workflow/workflows/manage/{workflow}','/admin/config/workflow/workflows/manage/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1321:{a:9:{s:4:\"path\";s:50:\"/admin/config/workflow/workflows/manage/{workflow}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"workflow.edit\";s:15:\"_title_callback\";s:58:\"\\Drupal\\Core\\Entity\\Controller\\EntityController::editTitle\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:15:\"workflow.update\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":552:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"workflow\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:66:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"workflow\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:41:\"/admin/config/workflow/workflows/manage/%\";s:8:\"numParts\";i:6;}}}}',6),('entity.workflow.edit_state_form','/admin/config/workflow/workflows/manage/{workflow}/state/{workflow_state}','/admin/config/workflow/workflows/manage/%/state/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1510:{a:9:{s:4:\"path\";s:73:\"/admin/config/workflow/workflows/manage/{workflow}/state/{workflow_state}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:19:\"workflow.edit-state\";s:6:\"_title\";s:10:\"Edit state\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:13:\"workflow.edit\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":772:{a:11:{s:4:\"vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:14:\"workflow_state\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/state/(?P<workflow_state>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"workflow_state\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/state\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:14:\"workflow_state\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:49:\"/admin/config/workflow/workflows/manage/%/state/%\";s:8:\"numParts\";i:8;}}}}',8),('entity.workflow.edit_transition_form','/admin/config/workflow/workflows/manage/{workflow}/transition/{workflow_transition}','/admin/config/workflow/workflows/manage/%/transition/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1567:{a:9:{s:4:\"path\";s:83:\"/admin/config/workflow/workflows/manage/{workflow}/transition/{workflow_transition}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:24:\"workflow.edit-transition\";s:6:\"_title\";s:15:\"Edit transition\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:13:\"workflow.edit\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:8:\"workflow\";a:2:{s:4:\"type\";s:15:\"entity:workflow\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":809:{a:11:{s:4:\"vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:19:\"workflow_transition\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:109:\"#^/admin/config/workflow/workflows/manage/(?P<workflow>[^/]++)/transition/(?P<workflow_transition>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"workflow_transition\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/transition\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"workflow\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/workflow/workflows/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:8:\"workflow\";i:1;s:19:\"workflow_transition\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:54:\"/admin/config/workflow/workflows/manage/%/transition/%\";s:8:\"numParts\";i:8;}}}}',8),('field_ui.display_mode','/admin/structure/display-modes','/admin/structure/display-modes',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1012:{a:9:{s:4:\"path\";s:30:\"/admin/structure/display-modes\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:13:\"Display modes\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":387:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/structure/display\\-modes$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/structure/display-modes\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:30:\"/admin/structure/display-modes\";s:8:\"numParts\";i:3;}}}}',3),('field_ui.entity_form_mode_add','/admin/structure/display-modes/form/add','/admin/structure/display-modes/form/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1074:{a:9:{s:4:\"path\";s:39:\"/admin/structure/display-modes/form/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:78:\"\\Drupal\\field_ui\\Controller\\EntityDisplayModeController::formModeTypeSelection\";s:6:\"_title\";s:28:\"Choose form mode entity type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":415:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/structure/display\\-modes/form/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/form/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/structure/display-modes/form/add\";s:8:\"numParts\";i:5;}}}}',5),('field_ui.entity_view_mode_add','/admin/structure/display-modes/view/add','/admin/structure/display-modes/view/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1074:{a:9:{s:4:\"path\";s:39:\"/admin/structure/display-modes/view/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:78:\"\\Drupal\\field_ui\\Controller\\EntityDisplayModeController::viewModeTypeSelection\";s:6:\"_title\";s:28:\"Choose view mode entity type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer display modes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":415:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/structure/display\\-modes/view/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/structure/display-modes/view/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:39:\"/admin/structure/display-modes/view/add\";s:8:\"numParts\";i:5;}}}}',5),('field_ui.field_storage_config_add_block_content','/admin/structure/block/block-content/manage/{block_content_type}/fields/add-field','/admin/structure/block/block-content/manage/%/fields/add-field',251,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1550:{a:9:{s:4:\"path\";s:81:\"/admin/structure/block/block-content/manage/{block_content_type}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:13:\"block_content\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer block_content fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:18:\"block_content_type\";a:2:{s:4:\"type\";s:25:\"entity:block_content_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":698:{a:11:{s:4:\"vars\";a:1:{i:0;s:18:\"block_content_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/admin/structure/block/block\\-content/manage/(?P<block_content_type>[^/]++)/fields/add\\-field$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:18:\"block_content_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:43:\"/admin/structure/block/block-content/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:18:\"block_content_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:251;s:14:\"patternOutline\";s:62:\"/admin/structure/block/block-content/manage/%/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),('field_ui.field_storage_config_add_comment','/admin/structure/comment/manage/{comment_type}/fields/add-field','/admin/structure/comment/manage/%/fields/add-field',123,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1446:{a:9:{s:4:\"path\";s:63:\"/admin/structure/comment/manage/{comment_type}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:7:\"comment\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer comment fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:12:\"comment_type\";a:2:{s:4:\"type\";s:19:\"entity:comment_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":637:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"comment_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/admin/structure/comment/manage/(?P<comment_type>[^/]++)/fields/add\\-field$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"comment_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/comment/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"comment_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/structure/comment/manage/%/fields/add-field\";s:8:\"numParts\";i:7;}}}}',7),('field_ui.field_storage_config_add_contact_message','/admin/structure/contact/manage/{contact_form}/fields/add-field','/admin/structure/contact/manage/%/fields/add-field',123,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1463:{a:9:{s:4:\"path\";s:63:\"/admin/structure/contact/manage/{contact_form}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:15:\"contact_message\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:33:\"administer contact_message fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"contact_form\";a:2:{s:4:\"type\";s:19:\"entity:contact_form\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":637:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"contact_form\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:80:\"#^/admin/structure/contact/manage/(?P<contact_form>[^/]++)/fields/add\\-field$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"contact_form\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/contact/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"contact_form\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:50:\"/admin/structure/contact/manage/%/fields/add-field\";s:8:\"numParts\";i:7;}}}}',7),('field_ui.field_storage_config_add_node','/admin/structure/types/manage/{node_type}/fields/add-field','/admin/structure/types/manage/%/fields/add-field',123,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1407:{a:9:{s:4:\"path\";s:58:\"/admin/structure/types/manage/{node_type}/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:4:\"node\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer node fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:9:\"node_type\";a:2:{s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":616:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/structure/types/manage/(?P<node_type>[^/]++)/fields/add\\-field$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/fields/add-field\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/types/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:123;s:14:\"patternOutline\";s:48:\"/admin/structure/types/manage/%/fields/add-field\";s:8:\"numParts\";i:7;}}}}',7),('field_ui.field_storage_config_add_taxonomy_term','/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/add-field','/admin/structure/taxonomy/manage/%/overview/fields/add-field',247,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1548:{a:9:{s:4:\"path\";s:80:\"/admin/structure/taxonomy/manage/{taxonomy_vocabulary}/overview/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:13:\"taxonomy_term\";s:6:\"bundle\";s:0:\"\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:31:\"administer taxonomy_term fields\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:10:\"parameters\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:4:\"type\";s:26:\"entity:taxonomy_vocabulary\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:9:\"_field_ui\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":695:{a:11:{s:4:\"vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:97:\"#^/admin/structure/taxonomy/manage/(?P<taxonomy_vocabulary>[^/]++)/overview/fields/add\\-field$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/overview/fields/add-field\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:19:\"taxonomy_vocabulary\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/structure/taxonomy/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:19:\"taxonomy_vocabulary\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:247;s:14:\"patternOutline\";s:60:\"/admin/structure/taxonomy/manage/%/overview/fields/add-field\";s:8:\"numParts\";i:8;}}}}',8),('field_ui.field_storage_config_add_user','/admin/config/people/accounts/fields/add-field','/admin/config/people/accounts/fields/add-field',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1084:{a:9:{s:4:\"path\";s:46:\"/admin/config/people/accounts/fields/add-field\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:5:\"_form\";s:41:\"\\Drupal\\field_ui\\Form\\FieldStorageAddForm\";s:6:\"_title\";s:9:\"Add field\";s:14:\"entity_type_id\";s:4:\"user\";s:6:\"bundle\";s:4:\"user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer user fields\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:9:\"_field_ui\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":436:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/config/people/accounts/fields/add\\-field$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:46:\"/admin/config/people/accounts/fields/add-field\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:46:\"/admin/config/people/accounts/fields/add-field\";s:8:\"numParts\";i:6;}}}}',6),('file.ajax_progress','/file/progress/{key}','/file/progress/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":993:{a:9:{s:4:\"path\";s:20:\"/file/progress/{key}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\file\\Controller\\FileWidgetAjaxController::progress\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":456:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/file/progress/(?P<key>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/file/progress\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/file/progress/%\";s:8:\"numParts\";i:3;}}}}',3),('filter.admin_overview','/admin/config/content/formats','/admin/config/content/formats',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":959:{a:9:{s:4:\"path\";s:29:\"/admin/config/content/formats\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_list\";s:13:\"filter_format\";s:6:\"_title\";s:24:\"Text formats and editors\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer filters\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/config/content/formats$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/config/content/formats\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/config/content/formats\";s:8:\"numParts\";i:4;}}}}',4),('filter.format_add','/admin/config/content/formats/add','/admin/config/content/formats/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":978:{a:9:{s:4:\"path\";s:33:\"/admin/config/content/formats/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"filter_format.add\";s:6:\"_title\";s:15:\"Add text format\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:13:\"filter_format\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":396:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/config/content/formats/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/content/formats/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:33:\"/admin/config/content/formats/add\";s:8:\"numParts\";i:5;}}}}',5),('filter.tips','/filter/tips/{filter_format}','/filter/tips/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1213:{a:9:{s:4:\"path\";s:28:\"/filter/tips/{filter_format}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\filter\\Controller\\FilterController::filterTips\";s:6:\"_title\";s:12:\"Compose tips\";}s:12:\"requirements\";a:1:{s:14:\"_entity_access\";s:17:\"filter_format.use\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":493:{a:11:{s:4:\"vars\";a:1:{i:0;s:13:\"filter_format\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/filter/tips/(?P<filter_format>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"filter_format\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/filter/tips\";}}s:9:\"path_vars\";a:1:{i:0;s:13:\"filter_format\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:14:\"/filter/tips/%\";s:8:\"numParts\";i:3;}}}}',3),('filter.tips_all','/filter/tips','/filter/tips',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1015:{a:9:{s:4:\"path\";s:12:\"/filter/tips\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\filter\\Controller\\FilterController::filterTips\";s:6:\"_title\";s:12:\"Compose tips\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:13:\"filter_format\";a:2:{s:4:\"type\";s:20:\"entity:filter_format\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":332:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/filter/tips$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/filter/tips\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/filter/tips\";s:8:\"numParts\";i:2;}}}}',2),('ga_reports.help','/admin/ga-report/help','/admin/ga-report/help',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":982:{a:9:{s:4:\"path\";s:21:\"/admin/ga-report/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:57:\"\\Drupal\\ga_reports\\Controller\\GARepotsController::content\";s:6:\"_title\";s:29:\"Google Analytics Reports Help\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer GA reports api\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":360:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/ga\\-report/help$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/ga-report/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/ga-report/help\";s:8:\"numParts\";i:3;}}}}',3),('ga_reports.settings','/admin/config/services/ga-settings','/admin/config/services/ga-settings',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1018:{a:9:{s:4:\"path\";s:34:\"/admin/config/services/ga-settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:52:\"Drupal\\ga_reports\\Form\\GaReportsApiAdminSettingsForm\";s:6:\"_title\";s:24:\"Google Analytics Reports\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:25:\"administer GA reports api\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/config/services/ga\\-settings$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/services/ga-settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:34:\"/admin/config/services/ga-settings\";s:8:\"numParts\";i:4;}}}}',4),('help.main','/admin/help','/admin/help',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":908:{a:9:{s:4:\"path\";s:11:\"/admin/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\help\\Controller\\HelpController::helpMain\";s:6:\"_title\";s:4:\"Help\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/admin/help$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/admin/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/admin/help\";s:8:\"numParts\";i:2;}}}}',2),('help.page','/admin/help/{name}','/admin/help/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1037:{a:9:{s:4:\"path\";s:18:\"/admin/help/{name}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\help\\Controller\\HelpController::helpPage\";s:6:\"_title\";s:4:\"Help\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":451:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"name\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/help/(?P<name>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"name\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/admin/help\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"name\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/admin/help/%\";s:8:\"numParts\";i:3;}}}}',3),('history.get_last_node_view','/history/get_node_read_timestamps','/history/get_node_read_timestamps',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":954:{a:9:{s:4:\"path\";s:33:\"/history/get_node_read_timestamps\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:67:\"\\Drupal\\history\\Controller\\HistoryController::getNodeReadTimestamps\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":395:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/history/get_node_read_timestamps$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/history/get_node_read_timestamps\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:33:\"/history/get_node_read_timestamps\";s:8:\"numParts\";i:2;}}}}',2),('history.read_node','/history/{node}/read','/history/%/read',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1158:{a:9:{s:4:\"path\";s:20:\"/history/{node}/read\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:54:\"\\Drupal\\history\\Controller\\HistoryController::readNode\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:9:\"node.view\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"node\";a:2:{s:4:\"type\";s:11:\"entity:node\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":486:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"node\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/history/(?P<node>\\d+)/read$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/read\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/history\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"node\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:15:\"/history/%/read\";s:8:\"numParts\";i:3;}}}}',3),('image.effect_add_form','/admin/config/media/image-styles/manage/{image_style}/add/{image_effect}','/admin/config/media/image-styles/manage/%/add/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1545:{a:9:{s:4:\"path\";s:72:\"/admin/config/media/image-styles/manage/{image_style}/add/{image_effect}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\image\\Form\\ImageEffectAddForm\";s:6:\"_title\";s:16:\"Add image effect\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":774:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:99:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/add/(?P<image_effect>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"image_effect\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:4:\"/add\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:47:\"/admin/config/media/image-styles/manage/%/add/%\";s:8:\"numParts\";i:8;}}}}',8),('image.effect_delete','/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}/delete','/admin/config/media/image-styles/manage/%/effects/%/delete',501,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1632:{a:9:{s:4:\"path\";s:83:\"/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\image\\Form\\ImageEffectDeleteForm\";s:6:\"_title\";s:19:\"Delete image effect\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":844:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:110:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/effects/(?P<image_effect>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"image_effect\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/effects\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:501;s:14:\"patternOutline\";s:58:\"/admin/config/media/image-styles/manage/%/effects/%/delete\";s:8:\"numParts\";i:9;}}}}',9),('image.effect_edit_form','/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}','/admin/config/media/image-styles/manage/%/effects/%',250,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1564:{a:9:{s:4:\"path\";s:76:\"/admin/config/media/image-styles/manage/{image_style}/effects/{image_effect}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"\\Drupal\\image\\Form\\ImageEffectEditForm\";s:6:\"_title\";s:17:\"Edit image effect\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":787:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:103:\"#^/admin/config/media/image\\-styles/manage/(?P<image_style>[^/]++)/effects/(?P<image_effect>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"image_effect\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/effects\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:39:\"/admin/config/media/image-styles/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:12:\"image_effect\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:250;s:14:\"patternOutline\";s:51:\"/admin/config/media/image-styles/manage/%/effects/%\";s:8:\"numParts\";i:8;}}}}',8),('image.info','/quickedit/image/info/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}','/quickedit/image/info/%/%/%/%/%',224,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1955:{a:9:{s:4:\"path\";s:83:\"/quickedit/image/info/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\image\\Controller\\QuickEditImageController::getInfo\";}s:12:\"requirements\";a:3:{s:11:\"_permission\";s:23:\"access in-place editing\";s:30:\"_access_quickedit_entity_field\";s:4:\"TRUE\";s:7:\"_method\";s:3:\"GET\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:35:\"access_check.quickedit.entity_field\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1089:{a:11:{s:4:\"vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:139:\"#^/quickedit/image/info/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)/(?P<langcode>[^/]++)/(?P<view_mode_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/quickedit/image/info\";}}s:9:\"path_vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:224;s:14:\"patternOutline\";s:31:\"/quickedit/image/info/%/%/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),('image.style_add','/admin/config/media/image-styles/add','/admin/config/media/image-styles/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":986:{a:9:{s:4:\"path\";s:36:\"/admin/config/media/image-styles/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"image_style.add\";s:6:\"_title\";s:15:\"Add image style\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"administer image styles\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":406:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/media/image\\-styles/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/config/media/image-styles/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:36:\"/admin/config/media/image-styles/add\";s:8:\"numParts\";i:5;}}}}',5),('image.style_private','/system/files/styles/{image_style}/{scheme}','/system/files/styles/%/%',28,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1325:{a:9:{s:4:\"path\";s:43:\"/system/files/styles/{image_style}/{scheme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:62:\"\\Drupal\\image\\Controller\\ImageStyleDownloadController::deliver\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":640:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:69:\"#^/system/files/styles/(?P<image_style>[^/]++)/(?P<scheme>[^/]++)$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"scheme\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/system/files/styles\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:28;s:14:\"patternOutline\";s:24:\"/system/files/styles/%/%\";s:8:\"numParts\";i:5;}}}}',5),('image.style_public','/sites/default/files/styles/{image_style}/{scheme}','/sites/default/files/styles/%/%',60,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1352:{a:9:{s:4:\"path\";s:50:\"/sites/default/files/styles/{image_style}/{scheme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:61:\"Drupal\\image\\Controller\\ImageStyleDownloadController::deliver\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:11:\"image_style\";a:2:{s:4:\"type\";s:18:\"entity:image_style\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":661:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:76:\"#^/sites/default/files/styles/(?P<image_style>[^/]++)/(?P<scheme>[^/]++)$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"scheme\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"image_style\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/sites/default/files/styles\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"image_style\";i:1;s:6:\"scheme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:60;s:14:\"patternOutline\";s:31:\"/sites/default/files/styles/%/%\";s:8:\"numParts\";i:6;}}}}',6),('image.upload','/quickedit/image/upload/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}','/quickedit/image/upload/%/%/%/%/%',224,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1963:{a:9:{s:4:\"path\";s:85:\"/quickedit/image/upload/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:57:\"\\Drupal\\image\\Controller\\QuickEditImageController::upload\";}s:12:\"requirements\";a:3:{s:11:\"_permission\";s:23:\"access in-place editing\";s:30:\"_access_quickedit_entity_field\";s:4:\"TRUE\";s:7:\"_method\";s:4:\"POST\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:35:\"access_check.quickedit.entity_field\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1095:{a:11:{s:4:\"vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:141:\"#^/quickedit/image/upload/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)/(?P<langcode>[^/]++)/(?P<view_mode_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/quickedit/image/upload\";}}s:9:\"path_vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:224;s:14:\"patternOutline\";s:33:\"/quickedit/image/upload/%/%/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),('menu_ui.link_edit','/admin/structure/menu/link/{menu_link_plugin}/edit','/admin/structure/menu/link/%/edit',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1364:{a:9:{s:4:\"path\";s:50:\"/admin/structure/menu/link/{menu_link_plugin}/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:36:\"Drupal\\menu_ui\\Form\\MenuLinkEditForm\";s:6:\"_title\";s:14:\"Edit menu link\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:15:\"administer menu\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"menu_link_plugin\";a:2:{s:4:\"type\";s:16:\"menu_link_plugin\";s:9:\"converter\";s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":599:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:66:\"#^/admin/structure/menu/link/(?P<menu_link_plugin>[^/]++)/edit$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"menu_link_plugin\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/link\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:33:\"/admin/structure/menu/link/%/edit\";s:8:\"numParts\";i:6;}}}}',6),('menu_ui.link_reset','/admin/structure/menu/link/{menu_link_plugin}/reset','/admin/structure/menu/link/%/reset',61,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1487:{a:9:{s:4:\"path\";s:51:\"/admin/structure/menu/link/{menu_link_plugin}/reset\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"Drupal\\menu_ui\\Form\\MenuLinkResetForm\";s:6:\"_title\";s:15:\"Reset menu link\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:15:\"administer menu\";s:14:\"_custom_access\";s:56:\"\\Drupal\\menu_ui\\Form\\MenuLinkResetForm::linkIsResettable\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:16:\"menu_link_plugin\";a:2:{s:4:\"type\";s:16:\"menu_link_plugin\";s:9:\"converter\";s:54:\"drupal.proxy_original_service.paramconverter.menu_link\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":602:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:67:\"#^/admin/structure/menu/link/(?P<menu_link_plugin>[^/]++)/reset$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/reset\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"menu_link_plugin\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/menu/link\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"menu_link_plugin\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:61;s:14:\"patternOutline\";s:34:\"/admin/structure/menu/link/%/reset\";s:8:\"numParts\";i:6;}}}}',6),('menu_ui.parent_options_js','/admin/structure/menu/parents','/admin/structure/menu/parents',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":956:{a:9:{s:4:\"path\";s:29:\"/admin/structure/menu/parents\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:59:\"\\Drupal\\menu_ui\\Controller\\MenuController::getParentOptions\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:15:\"administer menu\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/structure/menu/parents$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/structure/menu/parents\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/structure/menu/parents\";s:8:\"numParts\";i:4;}}}}',4),('migrate_drupal_ui.log','/admin/reports/upgrade','/admin/reports/upgrade',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":972:{a:9:{s:4:\"path\";s:22:\"/admin/reports/upgrade\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:63:\"\\Drupal\\migrate_drupal_ui\\Controller\\MigrateController::showLog\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:57:\"\\Drupal\\migrate_drupal_ui\\MigrateAccessCheck::checkAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/reports/upgrade$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/reports/upgrade\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/reports/upgrade\";s:8:\"numParts\";i:3;}}}}',3),('migrate_drupal_ui.upgrade','/upgrade','/upgrade',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":913:{a:9:{s:4:\"path\";s:8:\"/upgrade\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\migrate_drupal_ui\\Form\\OverviewForm\";s:6:\"_title\";s:7:\"Upgrade\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:57:\"\\Drupal\\migrate_drupal_ui\\MigrateAccessCheck::checkAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":318:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:14:\"#^/upgrade$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/upgrade\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:8:\"/upgrade\";s:8:\"numParts\";i:1;}}}}',1),('migrate_drupal_ui.upgrade_credential','/upgrade/credentials','/upgrade/credentials',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":966:{a:9:{s:4:\"path\";s:20:\"/upgrade/credentials\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:45:\"\\Drupal\\migrate_drupal_ui\\Form\\CredentialForm\";s:6:\"_title\";s:7:\"Upgrade\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:57:\"\\Drupal\\migrate_drupal_ui\\MigrateAccessCheck::checkAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/upgrade/credentials$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/upgrade/credentials\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:20:\"/upgrade/credentials\";s:8:\"numParts\";i:2;}}}}',2),('migrate_drupal_ui.upgrade_idconflict','/upgrade/idconflict','/upgrade/idconflict',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":962:{a:9:{s:4:\"path\";s:19:\"/upgrade/idconflict\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:45:\"\\Drupal\\migrate_drupal_ui\\Form\\IdConflictForm\";s:6:\"_title\";s:7:\"Upgrade\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:57:\"\\Drupal\\migrate_drupal_ui\\MigrateAccessCheck::checkAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":353:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/upgrade/idconflict$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/upgrade/idconflict\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:19:\"/upgrade/idconflict\";s:8:\"numParts\";i:2;}}}}',2),('migrate_drupal_ui.upgrade_incremental','/upgrade/incremental','/upgrade/incremental',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":967:{a:9:{s:4:\"path\";s:20:\"/upgrade/incremental\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:46:\"\\Drupal\\migrate_drupal_ui\\Form\\IncrementalForm\";s:6:\"_title\";s:7:\"Upgrade\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:57:\"\\Drupal\\migrate_drupal_ui\\MigrateAccessCheck::checkAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/upgrade/incremental$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/upgrade/incremental\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:20:\"/upgrade/incremental\";s:8:\"numParts\";i:2;}}}}',2),('migrate_drupal_ui.upgrade_review','/upgrade/review','/upgrade/review',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":942:{a:9:{s:4:\"path\";s:15:\"/upgrade/review\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:41:\"\\Drupal\\migrate_drupal_ui\\Form\\ReviewForm\";s:6:\"_title\";s:7:\"Upgrade\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:57:\"\\Drupal\\migrate_drupal_ui\\MigrateAccessCheck::checkAccess\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":341:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:21:\"#^/upgrade/review$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/upgrade/review\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:15:\"/upgrade/review\";s:8:\"numParts\";i:2;}}}}',2),('migrate_tools.execute','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/execute','/admin/structure/migrate/manage/%/migrations/%/execute',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1766:{a:9:{s:4:\"path\";s:80:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/execute\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:5:\"_form\";s:47:\"\\Drupal\\migrate_tools\\Form\\MigrationExecuteForm\";s:6:\"_title\";s:17:\"Execute migration\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":833:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:106:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/execute$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/execute\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:54:\"/admin/structure/migrate/manage/%/migrations/%/execute\";s:8:\"numParts\";i:8;}}}}',8),('migrate_tools.messages','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/messages','/admin/structure/migrate/manage/%/migrations/%/messages',245,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1780:{a:9:{s:4:\"path\";s:81:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/messages\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:60:\"\\Drupal\\migrate_tools\\Controller\\MessageController::overview\";s:6:\"_title\";s:8:\"Messages\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:21:\"administer migrations\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":836:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:107:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/messages$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/messages\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:245;s:14:\"patternOutline\";s:55:\"/admin/structure/migrate/manage/%/migrations/%/messages\";s:8:\"numParts\";i:8;}}}}',8),('migrate_tools.source_csv','/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/source/edit','/admin/structure/migrate/manage/%/migrations/%/source/edit',491,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1845:{a:9:{s:4:\"path\";s:84:\"/admin/structure/migrate/manage/{migration_group}/migrations/{migration}/source/edit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"Drupal\\migrate_tools\\Form\\SourceCsvForm\";s:14:\"_migrate_group\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:21:\"administer migrations\";s:14:\"_custom_access\";s:47:\"Drupal\\migrate_tools\\Form\\SourceCsvForm::access\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:2:{s:9:\"migration\";a:2:{s:4:\"type\";s:16:\"entity:migration\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}s:15:\"migration_group\";a:2:{s:4:\"type\";s:22:\"entity:migration_group\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":846:{a:11:{s:4:\"vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:110:\"#^/admin/structure/migrate/manage/(?P<migration_group>[^/]++)/migrations/(?P<migration>[^/]++)/source/edit$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/source/edit\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"migration\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/migrations\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:15:\"migration_group\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/migrate/manage\";}}s:9:\"path_vars\";a:2:{i:0;s:15:\"migration_group\";i:1;s:9:\"migration\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:491;s:14:\"patternOutline\";s:58:\"/admin/structure/migrate/manage/%/migrations/%/source/edit\";s:8:\"numParts\";i:9;}}}}',9),('node.add','/node/add/{node_type}','/node/add/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1300:{a:9:{s:4:\"path\";s:21:\"/node/add/{node_type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:43:\"\\Drupal\\node\\Controller\\NodeController::add\";s:15:\"_title_callback\";s:52:\"\\Drupal\\node\\Controller\\NodeController::addPageTitle\";}s:12:\"requirements\";a:1:{s:16:\"_node_add_access\";s:16:\"node:{node_type}\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:10:\"parameters\";a:1:{s:9:\"node_type\";a:3:{s:21:\"with_config_overrides\";b:1;s:4:\"type\";s:16:\"entity:node_type\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:21:\"access_check.node.add\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":464:{a:11:{s:4:\"vars\";a:1:{i:0;s:9:\"node_type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/node/add/(?P<node_type>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"node_type\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/node/add\";}}s:9:\"path_vars\";a:1:{i:0;s:9:\"node_type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:11:\"/node/add/%\";s:8:\"numParts\";i:3;}}}}',3),('node.add_page','/node/add','/node/add',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":916:{a:9:{s:4:\"path\";s:9:\"/node/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:11:\"Add content\";s:11:\"_controller\";s:47:\"\\Drupal\\node\\Controller\\NodeController::addPage\";}s:12:\"requirements\";a:1:{s:16:\"_node_add_access\";s:4:\"node\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:21:\"access_check.node.add\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":321:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:15:\"#^/node/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/node/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:9:\"/node/add\";s:8:\"numParts\";i:2;}}}}',2),('node.configure_rebuild_confirm','/admin/reports/status/rebuild','/admin/reports/status/rebuild',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":941:{a:9:{s:4:\"path\";s:29:\"/admin/reports/status/rebuild\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:5:\"_form\";s:39:\"Drupal\\node\\Form\\RebuildPermissionsForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/reports/status/rebuild$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/reports/status/rebuild\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/reports/status/rebuild\";s:8:\"numParts\";i:4;}}}}',4),('node.multiple_delete_confirm','/admin/content/node/delete','/admin/content/node/delete',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":962:{a:9:{s:4:\"path\";s:26:\"/admin/content/node/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:32:\"\\Drupal\\node\\Form\\DeleteMultiple\";s:14:\"entity_type_id\";s:4:\"node\";}s:12:\"requirements\";a:1:{s:30:\"_entity_delete_multiple_access\";s:4:\"node\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:35:\"access_check.entity_delete_multiple\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/content/node/delete$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/content/node/delete\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/content/node/delete\";s:8:\"numParts\";i:4;}}}}',4),('node.revision_delete_confirm','/node/{node}/revisions/{node_revision}/delete','/node/%/revisions/%/delete',21,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1375:{a:9:{s:4:\"path\";s:45:\"/node/{node}/revisions/{node_revision}/delete\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\node\\Form\\NodeRevisionDeleteForm\";s:6:\"_title\";s:23:\"Delete earlier revision\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:6:\"delete\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":712:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/delete$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/delete\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:26:\"/node/%/revisions/%/delete\";s:8:\"numParts\";i:5;}}}}',5),('node.revision_revert_confirm','/node/{node}/revisions/{node_revision}/revert','/node/%/revisions/%/revert',21,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1378:{a:9:{s:4:\"path\";s:45:\"/node/{node}/revisions/{node_revision}/revert\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\node\\Form\\NodeRevisionRevertForm\";s:6:\"_title\";s:26:\"Revert to earlier revision\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:6:\"update\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":712:{a:11:{s:4:\"vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:68:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/revert$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/revert\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:2:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:21;s:14:\"patternOutline\";s:26:\"/node/%/revisions/%/revert\";s:8:\"numParts\";i:5;}}}}',5),('node.revision_revert_translation_confirm','/node/{node}/revisions/{node_revision}/revert/{langcode}','/node/%/revisions/%/revert/%',42,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1555:{a:9:{s:4:\"path\";s:56:\"/node/{node}/revisions/{node_revision}/revert/{langcode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:51:\"\\Drupal\\node\\Form\\NodeRevisionRevertTranslationForm\";s:6:\"_title\";s:43:\"Revert to earlier revision of a translation\";}s:12:\"requirements\";a:2:{s:21:\"_access_node_revision\";s:6:\"update\";s:4:\"node\";s:3:\"\\d+\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:21:\"_node_operation_route\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.node.revision\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":850:{a:11:{s:4:\"vars\";a:3:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:8:\"langcode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:89:\"#^/node/(?P<node>\\d+)/revisions/(?P<node_revision>[^/]++)/revert/(?P<langcode>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/revert\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:13:\"node_revision\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/revisions\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"node\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:3:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:8:\"langcode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:42;s:14:\"patternOutline\";s:28:\"/node/%/revisions/%/revert/%\";s:8:\"numParts\";i:6;}}}}',6),('node.type_add','/admin/structure/types/add','/admin/structure/types/add',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":945:{a:9:{s:4:\"path\";s:26:\"/admin/structure/types/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"node_type.add\";s:6:\"_title\";s:16:\"Add content type\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:24:\"administer content types\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/structure/types/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/types/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/structure/types/add\";s:8:\"numParts\";i:4;}}}}',4),('path.admin_add','/admin/config/search/path/add','/admin/config/search/path/add',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":951:{a:9:{s:4:\"path\";s:29:\"/admin/config/search/path/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:9:\"Add alias\";s:5:\"_form\";s:25:\"\\Drupal\\path\\Form\\AddForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/config/search/path/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/config/search/path/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:29:\"/admin/config/search/path/add\";s:8:\"numParts\";i:5;}}}}',5),('path.admin_edit','/admin/config/search/path/edit/{pid}','/admin/config/search/path/edit/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1082:{a:9:{s:4:\"path\";s:36:\"/admin/config/search/path/edit/{pid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:10:\"Edit alias\";s:5:\"_form\";s:26:\"\\Drupal\\path\\Form\\EditForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":505:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"pid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:52:\"#^/admin/config/search/path/edit/(?P<pid>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"pid\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/config/search/path/edit\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"pid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:32:\"/admin/config/search/path/edit/%\";s:8:\"numParts\";i:6;}}}}',6),('path.admin_overview','/admin/config/search/path','/admin/config/search/path',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":986:{a:9:{s:4:\"path\";s:25:\"/admin/config/search/path\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:11:\"URL aliases\";s:11:\"_controller\";s:53:\"\\Drupal\\path\\Controller\\PathController::adminOverview\";s:4:\"keys\";N;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/config/search/path$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/config/search/path\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/config/search/path\";s:8:\"numParts\";i:4;}}}}',4),('path.admin_overview_filter','/admin/config/search/path/filter','/admin/config/search/path/filter',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1001:{a:9:{s:4:\"path\";s:32:\"/admin/config/search/path/filter\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:11:\"URL aliases\";s:11:\"_controller\";s:53:\"\\Drupal\\path\\Controller\\PathController::adminOverview\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":393:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/config/search/path/filter$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/search/path/filter\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:32:\"/admin/config/search/path/filter\";s:8:\"numParts\";i:5;}}}}',5),('path.delete','/admin/config/search/path/delete/{pid}','/admin/config/search/path/delete/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1094:{a:9:{s:4:\"path\";s:38:\"/admin/config/search/path/delete/{pid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:28:\"\\Drupal\\path\\Form\\DeleteForm\";s:6:\"_title\";s:12:\"Delete alias\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer url aliases\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":511:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"pid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:54:\"#^/admin/config/search/path/delete/(?P<pid>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"pid\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/search/path/delete\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"pid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:34:\"/admin/config/search/path/delete/%\";s:8:\"numParts\";i:6;}}}}',6),('quickedit.attachments','/quickedit/attachments','/quickedit/attachments',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":902:{a:9:{s:4:\"path\";s:22:\"/quickedit/attachments\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:50:\"\\Drupal\\quickedit\\QuickEditController::attachments\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"access in-place editing\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/quickedit/attachments$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/quickedit/attachments\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:22:\"/quickedit/attachments\";s:8:\"numParts\";i:2;}}}}',2),('quickedit.entity_save','/quickedit/entity/{entity_type}/{entity}','/quickedit/entity/%/%',12,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1398:{a:9:{s:4:\"path\";s:40:\"/quickedit/entity/{entity_type}/{entity}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:49:\"\\Drupal\\quickedit\\QuickEditController::entitySave\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access in-place editing\";s:14:\"_entity_access\";s:13:\"entity.update\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":631:{a:11:{s:4:\"vars\";a:2:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:66:\"#^/quickedit/entity/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/quickedit/entity\";}}s:9:\"path_vars\";a:2:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:12;s:14:\"patternOutline\";s:21:\"/quickedit/entity/%/%\";s:8:\"numParts\";i:4;}}}}',4),('quickedit.field_form','/quickedit/form/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}','/quickedit/form/%/%/%/%/%',96,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1896:{a:9:{s:4:\"path\";s:77:\"/quickedit/form/{entity_type}/{entity}/{field_name}/{langcode}/{view_mode_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:48:\"\\Drupal\\quickedit\\QuickEditController::fieldForm\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access in-place editing\";s:30:\"_access_quickedit_entity_field\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:20:\"entity:{entity_type}\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:35:\"access_check.quickedit.entity_field\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1070:{a:11:{s:4:\"vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:133:\"#^/quickedit/form/(?P<entity_type>[^/]++)/(?P<entity>[^/]++)/(?P<field_name>[^/]++)/(?P<langcode>[^/]++)/(?P<view_mode_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"view_mode_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:8:\"langcode\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"field_name\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"entity\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"entity_type\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/quickedit/form\";}}s:9:\"path_vars\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"entity\";i:2;s:10:\"field_name\";i:3;s:8:\"langcode\";i:4;s:12:\"view_mode_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:96;s:14:\"patternOutline\";s:25:\"/quickedit/form/%/%/%/%/%\";s:8:\"numParts\";i:7;}}}}',7),('quickedit.metadata','/quickedit/metadata','/quickedit/metadata',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":887:{a:9:{s:4:\"path\";s:19:\"/quickedit/metadata\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:47:\"\\Drupal\\quickedit\\QuickEditController::metadata\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:23:\"access in-place editing\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":353:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/quickedit/metadata$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/quickedit/metadata\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:19:\"/quickedit/metadata\";s:8:\"numParts\";i:2;}}}}',2),('rest.csrftoken','/rest/session/token','/rest/session/token',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":868:{a:9:{s:4:\"path\";s:19:\"/rest/session/token\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\system\\Controller\\CsrfTokenController::csrfToken\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":353:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/rest/session/token$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/rest/session/token\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/rest/session/token\";s:8:\"numParts\";i:3;}}}}',3),('search.add_type','/admin/config/search/pages/add/{search_plugin_id}','/admin/config/search/pages/add/%',62,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1158:{a:9:{s:4:\"path\";s:49:\"/admin/config/search/pages/add/{search_plugin_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"search_page.add\";s:6:\"_title\";s:19:\"Add new search page\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:11:\"search_page\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":560:{a:11:{s:4:\"vars\";a:1:{i:0;s:16:\"search_plugin_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:65:\"#^/admin/config/search/pages/add/(?P<search_plugin_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:16:\"search_plugin_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/config/search/pages/add\";}}s:9:\"path_vars\";a:1:{i:0;s:16:\"search_plugin_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:62;s:14:\"patternOutline\";s:32:\"/admin/config/search/pages/add/%\";s:8:\"numParts\";i:6;}}}}',6),('search.help_node_search','/search/node/help','/search/node/help',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1146:{a:9:{s:4:\"path\";s:17:\"/search/node/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:53:\"Drupal\\search\\Controller\\SearchController::searchHelp\";s:6:\"_title\";s:11:\"Search help\";s:6:\"entity\";s:11:\"node_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":347:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/search/node/help$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/search/node/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/search/node/help\";s:8:\"numParts\";i:3;}}}}',3),('search.help_user_search','/search/user/help','/search/user/help',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1146:{a:9:{s:4:\"path\";s:17:\"/search/user/help\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:53:\"Drupal\\search\\Controller\\SearchController::searchHelp\";s:6:\"_title\";s:11:\"Search help\";s:6:\"entity\";s:11:\"user_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":347:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/search/user/help$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/search/user/help\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:17:\"/search/user/help\";s:8:\"numParts\";i:3;}}}}',3),('search.reindex_confirm','/admin/config/search/pages/reindex','/admin/config/search/pages/reindex',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":978:{a:9:{s:4:\"path\";s:34:\"/admin/config/search/pages/reindex\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:34:\"\\Drupal\\search\\Form\\ReindexConfirm\";s:6:\"_title\";s:11:\"Clear index\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer search\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":399:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/config/search/pages/reindex$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/config/search/pages/reindex\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/config/search/pages/reindex\";s:8:\"numParts\";i:5;}}}}',5),('search.view','/search','/search',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1105:{a:9:{s:4:\"path\";s:7:\"/search\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:61:\"Drupal\\search\\Controller\\SearchController::redirectSearchPage\";s:6:\"_title\";s:6:\"Search\";s:6:\"entity\";s:11:\"node_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":315:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:13:\"#^/search$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:7:\"/search\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:7:\"/search\";s:8:\"numParts\";i:1;}}}}',1),('search.view_node_search','/search/node','/search/node',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1114:{a:9:{s:4:\"path\";s:12:\"/search/node\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:47:\"Drupal\\search\\Controller\\SearchController::view\";s:6:\"_title\";s:6:\"Search\";s:6:\"entity\";s:11:\"node_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":332:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/search/node$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/search/node\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/search/node\";s:8:\"numParts\";i:2;}}}}',2),('search.view_user_search','/search/user','/search/user',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1114:{a:9:{s:4:\"path\";s:12:\"/search/user\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:47:\"Drupal\\search\\Controller\\SearchController::view\";s:6:\"_title\";s:6:\"Search\";s:6:\"entity\";s:11:\"user_search\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"entity.view\";s:11:\"_permission\";s:14:\"search content\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:6:\"entity\";a:2:{s:4:\"type\";s:18:\"entity:search_page\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":332:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/search/user$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/search/user\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/search/user\";s:8:\"numParts\";i:2;}}}}',2),('shortcut.link_add','/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link','/admin/config/user-interface/shortcut/manage/%/add-link',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1450:{a:9:{s:4:\"path\";s:68:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:55:\"\\Drupal\\shortcut\\Controller\\ShortcutController::addForm\";s:6:\"_title\";s:8:\"Add link\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:23:\"shortcut:{shortcut_set}\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":652:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:86:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/add\\-link$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:9:\"/add-link\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:55:\"/admin/config/user-interface/shortcut/manage/%/add-link\";s:8:\"numParts\";i:7;}}}}',7),('shortcut.link_add_inline','/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link-inline','/admin/config/user-interface/shortcut/manage/%/add-link-inline',125,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1509:{a:9:{s:4:\"path\";s:75:\"/admin/config/user-interface/shortcut/manage/{shortcut_set}/add-link-inline\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:71:\"Drupal\\shortcut\\Controller\\ShortcutSetController::addShortcutLinkInline\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:19:\"shortcut_set.update\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:12:\"shortcut_set\";a:2:{s:4:\"type\";s:19:\"entity:shortcut_set\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:19:\"access_check.entity\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":675:{a:11:{s:4:\"vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:94:\"#^/admin/config/user\\-interface/shortcut/manage/(?P<shortcut_set>[^/]++)/add\\-link\\-inline$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/add-link-inline\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"shortcut_set\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/user-interface/shortcut/manage\";}}s:9:\"path_vars\";a:1:{i:0;s:12:\"shortcut_set\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:125;s:14:\"patternOutline\";s:62:\"/admin/config/user-interface/shortcut/manage/%/add-link-inline\";s:8:\"numParts\";i:7;}}}}',7),('shortcut.set_add','/admin/config/user-interface/shortcut/add-set','/admin/config/user-interface/shortcut/add-set',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1027:{a:9:{s:4:\"path\";s:45:\"/admin/config/user-interface/shortcut/add-set\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:16:\"shortcut_set.add\";s:6:\"_title\";s:16:\"Add shortcut set\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:12:\"shortcut_set\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":434:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:53:\"#^/admin/config/user\\-interface/shortcut/add\\-set$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:45:\"/admin/config/user-interface/shortcut/add-set\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:45:\"/admin/config/user-interface/shortcut/add-set\";s:8:\"numParts\";i:5;}}}}',5),('shortcut.set_switch','/user/{user}/shortcuts','/user/%/shortcuts',5,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1246:{a:9:{s:4:\"path\";s:22:\"/user/{user}/shortcuts\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"Drupal\\shortcut\\Form\\SwitchShortcutSet\";s:6:\"_title\";s:9:\"Shortcuts\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:51:\"Drupal\\shortcut\\Form\\SwitchShortcutSet::checkAccess\";}s:7:\"options\";a:5:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:4:\"user\";s:3:\"\\d+\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":499:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"user\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/user/(?P<user>[^/]++)/shortcuts$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/shortcuts\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"user\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"user\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:5;s:14:\"patternOutline\";s:17:\"/user/%/shortcuts\";s:8:\"numParts\";i:3;}}}}',3),('system.401','/system/401','/system/401',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":862:{a:9:{s:4:\"path\";s:11:\"/system/401\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on401\";s:6:\"_title\";s:12:\"Unauthorized\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/system/401$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/401\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/401\";s:8:\"numParts\";i:2;}}}}',2),('system.403','/system/403','/system/403',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":863:{a:9:{s:4:\"path\";s:11:\"/system/403\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on403\";s:6:\"_title\";s:13:\"Access denied\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/system/403$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/403\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/403\";s:8:\"numParts\";i:2;}}}}',2),('system.404','/system/404','/system/404',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":864:{a:9:{s:4:\"path\";s:11:\"/system/404\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on404\";s:6:\"_title\";s:14:\"Page not found\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/system/404$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/404\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/404\";s:8:\"numParts\";i:2;}}}}',2),('system.4xx','/system/4xx','/system/4xx',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":862:{a:9:{s:4:\"path\";s:11:\"/system/4xx\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\system\\Controller\\Http4xxController:on4xx\";s:6:\"_title\";s:12:\"Client error\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/system/4xx$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/system/4xx\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/system/4xx\";s:8:\"numParts\";i:2;}}}}',2),('system.admin','/admin','/admin',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":916:{a:9:{s:4:\"path\";s:6:\"/admin\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:14:\"Administration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":312:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:12:\"#^/admin$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/admin\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:6:\"/admin\";s:8:\"numParts\";i:1;}}}}',1),('system.admin_compact_page','/admin/compact/{mode}','/admin/compact',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1055:{a:9:{s:4:\"path\";s:21:\"/admin/compact/{mode}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"Drupal\\system\\Controller\\SystemController::compactPage\";s:4:\"mode\";s:3:\"off\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":463:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"mode\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:42:\"#^/admin/compact(?:/(?P<mode>[^/]++))?$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"mode\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/compact\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"mode\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/compact\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config','/admin/config','/admin/config',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":971:{a:9:{s:4:\"path\";s:13:\"/admin/config\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:11:\"_controller\";s:52:\"\\Drupal\\system\\Controller\\SystemController::overview\";s:7:\"link_id\";s:19:\"system.admin_config\";s:6:\"_title\";s:13:\"Configuration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":335:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/admin/config$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/admin/config\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/admin/config\";s:8:\"numParts\";i:2;}}}}',2),('system.admin_config_content','/admin/config/content','/admin/config/content',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":982:{a:9:{s:4:\"path\";s:21:\"/admin/config/content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:17:\"Content authoring\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":359:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/config/content$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/config/content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/config/content\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_development','/admin/config/development','/admin/config/development',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":992:{a:9:{s:4:\"path\";s:25:\"/admin/config/development\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:11:\"Development\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":371:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/config/development$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/config/development\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/config/development\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_media','/admin/config/media','/admin/config/media',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":961:{a:9:{s:4:\"path\";s:19:\"/admin/config/media\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:5:\"Media\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":353:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/admin/config/media$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/config/media\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/config/media\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_regional','/admin/config/regional','/admin/config/regional',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":990:{a:9:{s:4:\"path\";s:22:\"/admin/config/regional\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:21:\"Regional and language\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/config/regional$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/config/regional\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/config/regional\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_search','/admin/config/search','/admin/config/search',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":980:{a:9:{s:4:\"path\";s:20:\"/admin/config/search\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:19:\"Search and metadata\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/config/search$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/config/search\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/config/search\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_services','/admin/config/services','/admin/config/services',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":981:{a:9:{s:4:\"path\";s:22:\"/admin/config/services\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:12:\"Web services\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/config/services$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/config/services\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/config/services\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_system','/admin/config/system','/admin/config/system',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":966:{a:9:{s:4:\"path\";s:20:\"/admin/config/system\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:6:\"System\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/config/system$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/config/system\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/config/system\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_ui','/admin/config/user-interface','/admin/config/user-interface',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1008:{a:9:{s:4:\"path\";s:28:\"/admin/config/user-interface\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:14:\"User interface\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/config/user\\-interface$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/config/user-interface\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:28:\"/admin/config/user-interface\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_config_workflow','/admin/config/workflow','/admin/config/workflow',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":976:{a:9:{s:4:\"path\";s:22:\"/admin/config/workflow\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:8:\"Workflow\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/config/workflow$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/config/workflow\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/config/workflow\";s:8:\"numParts\";i:3;}}}}',3),('system.admin_content','/admin/content','/admin/content',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1239:{a:9:{s:4:\"path\";s:14:\"/admin/content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:7:\"Content\";s:7:\"view_id\";s:7:\"content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access content overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:0:{}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/admin/content$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/content\";s:8:\"numParts\";i:2;}}}}',2),('system.admin_index','/admin/index','/admin/index',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":923:{a:9:{s:4:\"path\";s:12:\"/admin/index\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\system\\Controller\\AdminController::index\";s:6:\"_title\";s:14:\"Administration\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":332:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/admin/index$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/admin/index\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/admin/index\";s:8:\"numParts\";i:2;}}}}',2),('system.admin_reports','/admin/reports','/admin/reports',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":935:{a:9:{s:4:\"path\";s:14:\"/admin/reports\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:7:\"Reports\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:19:\"access site reports\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/admin/reports$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/reports\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/reports\";s:8:\"numParts\";i:2;}}}}',2),('system.admin_structure','/admin/structure','/admin/structure',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":953:{a:9:{s:4:\"path\";s:16:\"/admin/structure\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:9:\"Structure\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":344:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:22:\"#^/admin/structure$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/admin/structure\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:16:\"/admin/structure\";s:8:\"numParts\";i:2;}}}}',2),('system.batch_page.html','/batch','/batch',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":970:{a:9:{s:4:\"path\";s:6:\"/batch\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:52:\"\\Drupal\\system\\Controller\\BatchController::batchPage\";s:15:\"_title_callback\";s:57:\"\\Drupal\\system\\Controller\\BatchController::batchPageTitle\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:12:\"_no_big_pipe\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":312:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:12:\"#^/batch$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/batch\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:6:\"/batch\";s:8:\"numParts\";i:1;}}}}',1),('system.batch_page.json','/batch','/batch',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":858:{a:9:{s:4:\"path\";s:6:\"/batch\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:52:\"\\Drupal\\system\\Controller\\BatchController::batchPage\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:4:\"json\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":312:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:12:\"#^/batch$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/batch\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:6:\"/batch\";s:8:\"numParts\";i:1;}}}}',1),('system.cron','/cron/{key}','/cron/%',2,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":941:{a:9:{s:4:\"path\";s:11:\"/cron/{key}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:34:\"\\Drupal\\system\\CronController::run\";}s:12:\"requirements\";a:1:{s:19:\"_access_system_cron\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"no_cache\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:17:\"access_check.cron\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":427:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/cron/(?P<key>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"key\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/cron\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:2;s:14:\"patternOutline\";s:7:\"/cron/%\";s:8:\"numParts\";i:2;}}}}',2),('system.cron_settings','/admin/config/system/cron','/admin/config/system/cron',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":939:{a:9:{s:4:\"path\";s:25:\"/admin/config/system/cron\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:27:\"Drupal\\system\\Form\\CronForm\";s:6:\"_title\";s:4:\"Cron\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/config/system/cron$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/config/system/cron\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/config/system/cron\";s:8:\"numParts\";i:4;}}}}',4),('system.csrftoken','/session/token','/session/token',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":848:{a:9:{s:4:\"path\";s:14:\"/session/token\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\system\\Controller\\CsrfTokenController::csrfToken\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/session/token$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/session/token\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/session/token\";s:8:\"numParts\";i:2;}}}}',2),('system.date_format_add','/admin/config/regional/date-time/formats/add','/admin/config/regional/date-time/formats/add',63,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1024:{a:9:{s:4:\"path\";s:44:\"/admin/config/regional/date-time/formats/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:15:\"date_format.add\";s:6:\"_title\";s:15:\"Add date format\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":430:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:51:\"#^/admin/config/regional/date\\-time/formats/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/config/regional/date-time/formats/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:63;s:14:\"patternOutline\";s:44:\"/admin/config/regional/date-time/formats/add\";s:8:\"numParts\";i:6;}}}}',6),('system.db_update','/update.php/{op}','/update.php',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":973:{a:9:{s:4:\"path\";s:16:\"/update.php/{op}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:2:\"op\";s:4:\"info\";}s:12:\"requirements\";a:1:{s:21:\"_access_system_update\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"default_url_options\";a:1:{s:15:\"path_processing\";b:0;}s:14:\"_access_checks\";a:1:{i:0;s:22:\"access_check.db_update\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":447:{a:11:{s:4:\"vars\";a:1:{i:0;s:2:\"op\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/update\\.php(?:/(?P<op>[^/]++))?$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"op\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/update.php\";}}s:9:\"path_vars\";a:1:{i:0;s:2:\"op\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:11:\"/update.php\";s:8:\"numParts\";i:2;}}}}',2),('system.entity_autocomplete','/entity_reference_autocomplete/{target_type}/{selection_handler}/{selection_settings_key}','/entity_reference_autocomplete/%/%/%',8,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1517:{a:9:{s:4:\"path\";s:89:\"/entity_reference_autocomplete/{target_type}/{selection_handler}/{selection_settings_key}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:74:\"\\Drupal\\system\\Controller\\EntityAutocompleteController::handleAutocomplete\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":914:{a:11:{s:4:\"vars\";a:3:{i:0;s:11:\"target_type\";i:1;s:17:\"selection_handler\";i:2;s:22:\"selection_settings_key\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:125:\"#^/entity_reference_autocomplete/(?P<target_type>[^/]++)/(?P<selection_handler>[^/]++)/(?P<selection_settings_key>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:22:\"selection_settings_key\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:17:\"selection_handler\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"target_type\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/entity_reference_autocomplete\";}}s:9:\"path_vars\";a:3:{i:0;s:11:\"target_type\";i:1;s:17:\"selection_handler\";i:2;s:22:\"selection_settings_key\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:8;s:14:\"patternOutline\";s:36:\"/entity_reference_autocomplete/%/%/%\";s:8:\"numParts\";i:4;}}}}',4),('system.files','/system/files/{scheme}','/system/files',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1003:{a:9:{s:4:\"path\";s:22:\"/system/files/{scheme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:46:\"Drupal\\system\\FileDownloadController::download\";s:6:\"scheme\";s:7:\"private\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":468:{a:11:{s:4:\"vars\";a:1:{i:0;s:6:\"scheme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/system/files(?:/(?P<scheme>[^/]++))?$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"scheme\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/system/files\";}}s:9:\"path_vars\";a:1:{i:0;s:6:\"scheme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/system/files\";s:8:\"numParts\";i:3;}}}}',3),('system.file_system_settings','/admin/config/media/file-system','/admin/config/media/file-system',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":978:{a:9:{s:4:\"path\";s:31:\"/admin/config/media/file-system\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:33:\"Drupal\\system\\Form\\FileSystemForm\";s:6:\"_title\";s:11:\"File system\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":391:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/config/media/file\\-system$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/config/media/file-system\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/config/media/file-system\";s:8:\"numParts\";i:4;}}}}',4),('system.image_toolkit_settings','/admin/config/media/image-toolkit','/admin/config/media/image-toolkit',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":990:{a:9:{s:4:\"path\";s:33:\"/admin/config/media/image-toolkit\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:35:\"Drupal\\system\\Form\\ImageToolkitForm\";s:6:\"_title\";s:13:\"Image toolkit\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":397:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/config/media/image\\-toolkit$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/media/image-toolkit\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:33:\"/admin/config/media/image-toolkit\";s:8:\"numParts\";i:4;}}}}',4),('system.logging_settings','/admin/config/development/logging','/admin/config/development/logging',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":989:{a:9:{s:4:\"path\";s:33:\"/admin/config/development/logging\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:30:\"Drupal\\system\\Form\\LoggingForm\";s:6:\"_title\";s:18:\"Logging and errors\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":396:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:39:\"#^/admin/config/development/logging$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:33:\"/admin/config/development/logging\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:33:\"/admin/config/development/logging\";s:8:\"numParts\";i:4;}}}}',4),('system.machine_name_transliterate','/machine_name/transliterate','/machine_name/transliterate',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":914:{a:9:{s:4:\"path\";s:27:\"/machine_name/transliterate\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\system\\MachineNameController::transliterate\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":377:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/machine_name/transliterate$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/machine_name/transliterate\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:27:\"/machine_name/transliterate\";s:8:\"numParts\";i:2;}}}}',2),('system.modules_list','/admin/modules','/admin/modules',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":961:{a:9:{s:4:\"path\";s:14:\"/admin/modules\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:3:{s:6:\"_title\";s:6:\"Extend\";s:14:\"_title_context\";s:15:\"With components\";s:5:\"_form\";s:34:\"Drupal\\system\\Form\\ModulesListForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_no_big_pipe\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/admin/modules$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/modules\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/modules\";s:8:\"numParts\";i:2;}}}}',2),('system.modules_list_confirm','/admin/modules/list/confirm','/admin/modules/list/confirm',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":984:{a:9:{s:4:\"path\";s:27:\"/admin/modules/list/confirm\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:41:\"Drupal\\system\\Form\\ModulesListConfirmForm\";s:6:\"_title\";s:37:\"Some required modules must be enabled\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":378:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/modules/list/confirm$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/modules/list/confirm\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:27:\"/admin/modules/list/confirm\";s:8:\"numParts\";i:4;}}}}',4),('system.modules_list_experimental_confirm','/admin/modules/list/confirm-experimental','/admin/modules/list/confirm-experimental',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1032:{a:9:{s:4:\"path\";s:40:\"/admin/modules/list/confirm-experimental\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:53:\"Drupal\\system\\Form\\ModulesListExperimentalConfirmForm\";s:6:\"_title\";s:20:\"Experimental modules\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":418:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:47:\"#^/admin/modules/list/confirm\\-experimental$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/modules/list/confirm-experimental\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:40:\"/admin/modules/list/confirm-experimental\";s:8:\"numParts\";i:4;}}}}',4),('system.modules_uninstall','/admin/modules/uninstall','/admin/modules/uninstall',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":940:{a:9:{s:4:\"path\";s:24:\"/admin/modules/uninstall\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"Drupal\\system\\Form\\ModulesUninstallForm\";s:6:\"_title\";s:9:\"Uninstall\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":368:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/admin/modules/uninstall$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/modules/uninstall\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/modules/uninstall\";s:8:\"numParts\";i:3;}}}}',3),('system.modules_uninstall_confirm','/admin/modules/uninstall/confirm','/admin/modules/uninstall/confirm',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":989:{a:9:{s:4:\"path\";s:32:\"/admin/modules/uninstall/confirm\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:46:\"Drupal\\system\\Form\\ModulesUninstallConfirmForm\";s:6:\"_title\";s:17:\"Confirm uninstall\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":393:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/modules/uninstall/confirm$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/modules/uninstall/confirm\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:32:\"/admin/modules/uninstall/confirm\";s:8:\"numParts\";i:4;}}}}',4),('system.performance_settings','/admin/config/development/performance','/admin/config/development/performance',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1002:{a:9:{s:4:\"path\";s:37:\"/admin/config/development/performance\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:34:\"Drupal\\system\\Form\\PerformanceForm\";s:6:\"_title\";s:11:\"Performance\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":408:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/development/performance$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/development/performance\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/development/performance\";s:8:\"numParts\";i:4;}}}}',4),('system.php','/admin/reports/status/php','/admin/reports/status/php',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":945:{a:9:{s:4:\"path\";s:25:\"/admin/reports/status/php\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:50:\"Drupal\\system\\Controller\\SystemInfoController::php\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":372:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/reports/status/php$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/reports/status/php\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:25:\"/admin/reports/status/php\";s:8:\"numParts\";i:4;}}}}',4),('system.prepare_modules_entity_uninstall','/admin/modules/uninstall/entity/{entity_type_id}','/admin/modules/uninstall/entity/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1231:{a:9:{s:4:\"path\";s:48:\"/admin/modules/uninstall/entity/{entity_type_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:53:\"\\Drupal\\system\\Form\\PrepareModulesEntityUninstallForm\";s:15:\"_title_callback\";s:64:\"\\Drupal\\system\\Form\\PrepareModulesEntityUninstallForm::formTitle\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:18:\"administer modules\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":555:{a:11:{s:4:\"vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:64:\"#^/admin/modules/uninstall/entity/(?P<entity_type_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:14:\"entity_type_id\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/modules/uninstall/entity\";}}s:9:\"path_vars\";a:1:{i:0;s:14:\"entity_type_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:33:\"/admin/modules/uninstall/entity/%\";s:8:\"numParts\";i:5;}}}}',5),('system.private_file_download','/system/files/{filepath}','/system/files/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":999:{a:9:{s:4:\"path\";s:24:\"/system/files/{filepath}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:46:\"Drupal\\system\\FileDownloadController::download\";}s:12:\"requirements\";a:2:{s:8:\"filepath\";s:2:\".+\";s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":465:{a:11:{s:4:\"vars\";a:1:{i:0;s:8:\"filepath\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/system/files/(?P<filepath>.+)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:2:\".+\";i:3;s:8:\"filepath\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/system/files\";}}s:9:\"path_vars\";a:1:{i:0;s:8:\"filepath\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:15:\"/system/files/%\";s:8:\"numParts\";i:3;}}}}',3),('system.regional_settings','/admin/config/regional/settings','/admin/config/regional/settings',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":981:{a:9:{s:4:\"path\";s:31:\"/admin/config/regional/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"Drupal\\system\\Form\\RegionalForm\";s:6:\"_title\";s:17:\"Regional settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":390:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/config/regional/settings$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/config/regional/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/config/regional/settings\";s:8:\"numParts\";i:4;}}}}',4),('system.rss_feeds_settings','/admin/config/services/rss-publishing','/admin/config/services/rss-publishing',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1003:{a:9:{s:4:\"path\";s:37:\"/admin/config/services/rss-publishing\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"Drupal\\system\\Form\\RssFeedsForm\";s:6:\"_title\";s:14:\"RSS publishing\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/services/rss\\-publishing$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/services/rss-publishing\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/services/rss-publishing\";s:8:\"numParts\";i:4;}}}}',4),('system.run_cron','/admin/reports/status/run-cron','/admin/reports/status/run-cron',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1036:{a:9:{s:4:\"path\";s:30:\"/admin/reports/status/run-cron\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:42:\"\\Drupal\\system\\CronController::runManually\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:8:\"no_cache\";b:1;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":388:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/reports/status/run\\-cron$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/reports/status/run-cron\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:30:\"/admin/reports/status/run-cron\";s:8:\"numParts\";i:4;}}}}',4),('system.site_information_settings','/admin/config/system/site-information','/admin/config/system/site-information',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1015:{a:9:{s:4:\"path\";s:37:\"/admin/config/system/site-information\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:38:\"Drupal\\system\\Form\\SiteInformationForm\";s:6:\"_title\";s:19:\"Basic site settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":409:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:44:\"#^/admin/config/system/site\\-information$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/system/site-information\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/system/site-information\";s:8:\"numParts\";i:4;}}}}',4),('system.site_maintenance_mode','/admin/config/development/maintenance','/admin/config/development/maintenance',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1015:{a:9:{s:4:\"path\";s:37:\"/admin/config/development/maintenance\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:42:\"Drupal\\system\\Form\\SiteMaintenanceModeForm\";s:6:\"_title\";s:16:\"Maintenance mode\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":408:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/config/development/maintenance$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:37:\"/admin/config/development/maintenance\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:37:\"/admin/config/development/maintenance\";s:8:\"numParts\";i:4;}}}}',4),('system.status','/admin/reports/status','/admin/reports/status',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":966:{a:9:{s:4:\"path\";s:21:\"/admin/reports/status\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\system\\Controller\\SystemInfoController::status\";s:6:\"_title\";s:13:\"Status report\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":359:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/reports/status$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/reports/status\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/reports/status\";s:8:\"numParts\";i:3;}}}}',3),('system.temporary','/system/temporary','/system/temporary',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":880:{a:9:{s:4:\"path\";s:17:\"/system/temporary\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:47:\"\\Drupal\\system\\FileDownloadController::download\";s:6:\"scheme\";s:9:\"temporary\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":347:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/system/temporary$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/system/temporary\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:17:\"/system/temporary\";s:8:\"numParts\";i:2;}}}}',2),('system.themes_page','/admin/appearance','/admin/appearance',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":935:{a:9:{s:4:\"path\";s:17:\"/admin/appearance\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:10:\"Appearance\";s:11:\"_controller\";s:54:\"\\Drupal\\system\\Controller\\SystemController::themesPage\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer themes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":347:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:23:\"#^/admin/appearance$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/admin/appearance\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:17:\"/admin/appearance\";s:8:\"numParts\";i:2;}}}}',2),('system.theme_install','/admin/appearance/install','/admin/appearance/install',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":990:{a:9:{s:4:\"path\";s:25:\"/admin/appearance/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:49:\"Drupal\\system\\Controller\\ThemeController::install\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer themes\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":371:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/appearance/install$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/appearance/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/appearance/install\";s:8:\"numParts\";i:3;}}}}',3),('system.theme_settings','/admin/appearance/settings','/admin/appearance/settings',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":956:{a:9:{s:4:\"path\";s:26:\"/admin/appearance/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\system\\Form\\ThemeSettingsForm\";s:6:\"_title\";s:19:\"Appearance settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer themes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":374:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/appearance/settings$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/appearance/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:26:\"/admin/appearance/settings\";s:8:\"numParts\";i:3;}}}}',3),('system.theme_settings_theme','/admin/appearance/settings/{theme}','/admin/appearance/settings/%',14,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1103:{a:9:{s:4:\"path\";s:34:\"/admin/appearance/settings/{theme}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\system\\Form\\ThemeSettingsForm\";s:15:\"_title_callback\";s:21:\"theme_handler:getName\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer themes\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":501:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"theme\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/admin/appearance/settings/(?P<theme>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"theme\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/appearance/settings\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"theme\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:14;s:14:\"patternOutline\";s:28:\"/admin/appearance/settings/%\";s:8:\"numParts\";i:4;}}}}',4),('system.theme_set_default','/admin/appearance/default','/admin/appearance/default',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1040:{a:9:{s:4:\"path\";s:25:\"/admin/appearance/default\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:20:\"Set as default theme\";s:11:\"_controller\";s:58:\"\\Drupal\\system\\Controller\\ThemeController::setDefaultTheme\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer themes\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":371:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/appearance/default$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/appearance/default\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/appearance/default\";s:8:\"numParts\";i:3;}}}}',3),('system.theme_uninstall','/admin/appearance/uninstall','/admin/appearance/uninstall',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1000:{a:9:{s:4:\"path\";s:27:\"/admin/appearance/uninstall\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"Drupal\\system\\Controller\\ThemeController::uninstall\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer themes\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":377:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/appearance/uninstall$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/appearance/uninstall\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:27:\"/admin/appearance/uninstall\";s:8:\"numParts\";i:3;}}}}',3),('system.timezone','/system/timezone/{abbreviation}/{offset}/{is_daylight_saving_time}','/system/timezone',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1483:{a:9:{s:4:\"path\";s:66:\"/system/timezone/{abbreviation}/{offset}/{is_daylight_saving_time}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:11:\"_controller\";s:57:\"\\Drupal\\system\\Controller\\TimezoneController::getTimezone\";s:12:\"abbreviation\";s:0:\"\";s:6:\"offset\";i:-1;s:23:\"is_daylight_saving_time\";N;}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":842:{a:11:{s:4:\"vars\";a:3:{i:0;s:12:\"abbreviation\";i:1;s:6:\"offset\";i:2;s:23:\"is_daylight_saving_time\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:117:\"#^/system/timezone(?:/(?P<abbreviation>[^/]++)(?:/(?P<offset>[^/]++)(?:/(?P<is_daylight_saving_time>[^/]++))?)?)?$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:23:\"is_daylight_saving_time\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:6:\"offset\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:12:\"abbreviation\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:16:\"/system/timezone\";}}s:9:\"path_vars\";a:3:{i:0;s:12:\"abbreviation\";i:1;s:6:\"offset\";i:2;s:23:\"is_daylight_saving_time\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:16:\"/system/timezone\";s:8:\"numParts\";i:5;}}}}',5),('toolbar.subtrees','/toolbar/subtrees/{hash}','/toolbar/subtrees/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1059:{a:9:{s:4:\"path\";s:24:\"/toolbar/subtrees/{hash}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\toolbar\\Controller\\ToolbarController::subtreesAjax\";}s:12:\"requirements\";a:1:{s:14:\"_custom_access\";s:64:\"\\Drupal\\toolbar\\Controller\\ToolbarController::checkSubTreeAccess\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.custom\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":469:{a:11:{s:4:\"vars\";a:1:{i:0;s:4:\"hash\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/toolbar/subtrees/(?P<hash>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"hash\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/toolbar/subtrees\";}}s:9:\"path_vars\";a:1:{i:0;s:4:\"hash\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:19:\"/toolbar/subtrees/%\";s:8:\"numParts\";i:3;}}}}',3),('twilio.admin_form','/admin/config/system/twilio','/admin/config/system/twilio',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":945:{a:9:{s:4:\"path\";s:27:\"/admin/config/system/twilio\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:6:\"Twilio\";s:5:\"_form\";s:35:\"\\Drupal\\twilio\\Form\\TwilioAdminForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer twilio\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":378:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/admin/config/system/twilio$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:27:\"/admin/config/system/twilio\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:27:\"/admin/config/system/twilio\";s:8:\"numParts\";i:4;}}}}',4),('twilio.admin_test_form','/admin/config/system/twilio/test','/admin/config/system/twilio/test',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":985:{a:9:{s:4:\"path\";s:32:\"/admin/config/system/twilio/test\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:21:\"Send Test SMS message\";s:5:\"_form\";s:39:\"\\Drupal\\twilio\\Form\\TwilioAdminTestForm\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:17:\"administer twilio\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":393:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/admin/config/system/twilio/test$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:32:\"/admin/config/system/twilio/test\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:32:\"/admin/config/system/twilio/test\";s:8:\"numParts\";i:5;}}}}',5),('twilio.receive_message','/twilio/sms','/twilio/sms',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":838:{a:9:{s:4:\"path\";s:11:\"/twilio/sms\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:58:\"\\Drupal\\twilio\\Controller\\TwilioController::receiveMessage\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"true\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/twilio/sms$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/twilio/sms\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/twilio/sms\";s:8:\"numParts\";i:2;}}}}',2),('twilio.receive_voice','/twilio/voice','/twilio/voice',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":844:{a:9:{s:4:\"path\";s:13:\"/twilio/voice\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:56:\"\\Drupal\\twilio\\Controller\\TwilioController::receiveVoice\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"true\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":335:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/twilio/voice$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/twilio/voice\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/twilio/voice\";s:8:\"numParts\";i:2;}}}}',2),('update.confirmation_page','/admin/update/ready','/admin/update/ready',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1015:{a:9:{s:4:\"path\";s:19:\"/admin/update/ready\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"\\Drupal\\update\\Form\\UpdateReady\";s:6:\"_title\";s:15:\"Ready to update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":353:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/admin/update/ready$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/update/ready\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/update/ready\";s:8:\"numParts\";i:3;}}}}',3),('update.manual_status','/admin/reports/updates/check','/admin/reports/updates/check',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1070:{a:9:{s:4:\"path\";s:28:\"/admin/reports/updates/check\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:6:\"_title\";s:19:\"Manual update check\";s:11:\"_controller\";s:64:\"\\Drupal\\update\\Controller\\UpdateController::updateStatusManually\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:29:\"administer site configuration\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:34:\"#^/admin/reports/updates/check$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/updates/check\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:28:\"/admin/reports/updates/check\";s:8:\"numParts\";i:4;}}}}',4),('update.module_install','/admin/modules/install','/admin/modules/install',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1039:{a:9:{s:4:\"path\";s:22:\"/admin/modules/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\update\\Form\\UpdateManagerInstall\";s:6:\"_title\";s:18:\"Install new module\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/modules/install$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/modules/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/modules/install\";s:8:\"numParts\";i:3;}}}}',3),('update.module_update','/admin/modules/update','/admin/modules/update',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1021:{a:9:{s:4:\"path\";s:21:\"/admin/modules/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\update\\Form\\UpdateManagerUpdate\";s:6:\"_title\";s:6:\"Update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":359:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:27:\"#^/admin/modules/update$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:21:\"/admin/modules/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:21:\"/admin/modules/update\";s:8:\"numParts\";i:3;}}}}',3),('update.report_install','/admin/reports/updates/install','/admin/reports/updates/install',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1060:{a:9:{s:4:\"path\";s:30:\"/admin/reports/updates/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\update\\Form\\UpdateManagerInstall\";s:6:\"_title\";s:7:\"Install\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":387:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:36:\"#^/admin/reports/updates/install$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:30:\"/admin/reports/updates/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:30:\"/admin/reports/updates/install\";s:8:\"numParts\";i:4;}}}}',4),('update.report_update','/admin/reports/updates/update','/admin/reports/updates/update',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1054:{a:9:{s:4:\"path\";s:29:\"/admin/reports/updates/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\update\\Form\\UpdateManagerUpdate\";s:6:\"_title\";s:6:\"Update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":384:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/reports/updates/update$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:29:\"/admin/reports/updates/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:29:\"/admin/reports/updates/update\";s:8:\"numParts\";i:4;}}}}',4),('update.settings','/admin/reports/updates/settings','/admin/reports/updates/settings',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":989:{a:9:{s:4:\"path\";s:31:\"/admin/reports/updates/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:33:\"\\Drupal\\update\\UpdateSettingsForm\";s:6:\"_title\";s:23:\"Update Manager settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":390:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/reports/updates/settings$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/reports/updates/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/reports/updates/settings\";s:8:\"numParts\";i:4;}}}}',4),('update.status','/admin/reports/updates','/admin/reports/updates',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":976:{a:9:{s:4:\"path\";s:22:\"/admin/reports/updates\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:56:\"\\Drupal\\update\\Controller\\UpdateController::updateStatus\";s:6:\"_title\";s:17:\"Available updates\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:29:\"administer site configuration\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/reports/updates$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/reports/updates\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/reports/updates\";s:8:\"numParts\";i:3;}}}}',3),('update.theme_install','/admin/theme/install','/admin/theme/install',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1030:{a:9:{s:4:\"path\";s:20:\"/admin/theme/install\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:40:\"\\Drupal\\update\\Form\\UpdateManagerInstall\";s:6:\"_title\";s:17:\"Install new theme\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/theme/install$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/theme/install\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/theme/install\";s:8:\"numParts\";i:3;}}}}',3),('update.theme_update','/admin/theme/update','/admin/theme/update',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1013:{a:9:{s:4:\"path\";s:19:\"/admin/theme/update\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\update\\Form\\UpdateManagerUpdate\";s:6:\"_title\";s:6:\"Update\";}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:27:\"administer software updates\";s:22:\"_access_update_manager\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:2:{i:0;s:23:\"access_check.permission\";i:1;s:34:\"access_check.update.manager_access\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":353:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:25:\"#^/admin/theme/update$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:19:\"/admin/theme/update\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:19:\"/admin/theme/update\";s:8:\"numParts\";i:3;}}}}',3),('user.admin_create','/admin/people/create','/admin/people/create',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":903:{a:9:{s:4:\"path\";s:20:\"/admin/people/create\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"user.register\";s:6:\"_title\";s:8:\"Add user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer users\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/people/create$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/people/create\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/people/create\";s:8:\"numParts\";i:3;}}}}',3),('user.admin_index','/admin/config/people','/admin/config/people',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":966:{a:9:{s:4:\"path\";s:20:\"/admin/config/people\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:68:\"\\Drupal\\system\\Controller\\SystemController::systemAdminMenuBlockPage\";s:6:\"_title\";s:6:\"People\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:27:\"access administration pages\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/config/people$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/config/people\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/config/people\";s:8:\"numParts\";i:3;}}}}',3),('user.admin_permissions','/admin/people/permissions','/admin/people/permissions',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":949:{a:9:{s:4:\"path\";s:25:\"/admin/people/permissions\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:37:\"\\Drupal\\user\\Form\\UserPermissionsForm\";s:6:\"_title\";s:11:\"Permissions\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer permissions\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":371:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:31:\"#^/admin/people/permissions$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:25:\"/admin/people/permissions\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:25:\"/admin/people/permissions\";s:8:\"numParts\";i:3;}}}}',3),('user.cancel_confirm','/user/{user}/cancel/confirm/{timestamp}/{hashed_pass}','/user/%/cancel/confirm',11,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1612:{a:9:{s:4:\"path\";s:53:\"/user/{user}/cancel/confirm/{timestamp}/{hashed_pass}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:4:{s:6:\"_title\";s:28:\"Confirm account cancellation\";s:11:\"_controller\";s:53:\"\\Drupal\\user\\Controller\\UserController::confirmCancel\";s:9:\"timestamp\";i:0;s:11:\"hashed_pass\";s:0:\"\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"user.delete\";s:4:\"user\";s:3:\"\\d+\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"user\";a:2:{s:4:\"type\";s:11:\"entity:user\";s:9:\"converter\";s:30:\"paramconverter.latest_revision\";}}s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":810:{a:11:{s:4:\"vars\";a:3:{i:0;s:4:\"user\";i:1;s:9:\"timestamp\";i:2;s:11:\"hashed_pass\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:96:\"#^/user/(?P<user>\\d+)/cancel/confirm(?:/(?P<timestamp>[^/]++)(?:/(?P<hashed_pass>[^/]++))?)?$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:11:\"hashed_pass\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"timestamp\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:15:\"/cancel/confirm\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:3:\"\\d+\";i:3;s:4:\"user\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:3:{i:0;s:4:\"user\";i:1;s:9:\"timestamp\";i:2;s:11:\"hashed_pass\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:11;s:14:\"patternOutline\";s:22:\"/user/%/cancel/confirm\";s:8:\"numParts\";i:6;}}}}',6),('user.login','/user/login','/user/login',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":884:{a:9:{s:4:\"path\";s:11:\"/user/login\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:31:\"\\Drupal\\user\\Form\\UserLoginForm\";s:6:\"_title\";s:6:\"Log in\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/user/login$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/login\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/user/login\";s:8:\"numParts\";i:2;}}}}',2),('user.login.http','/user/login','/user/login',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":877:{a:9:{s:4:\"path\";s:11:\"/user/login\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:59:\"\\Drupal\\user\\Controller\\UserAuthenticationController::login\";}s:12:\"requirements\";a:2:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";s:7:\"_format\";s:8:\"json|xml\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/user/login$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/login\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/user/login\";s:8:\"numParts\";i:2;}}}}',2),('user.login_status.http','/user/login_status','/user/login_status',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":887:{a:9:{s:4:\"path\";s:18:\"/user/login_status\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:65:\"\\Drupal\\user\\Controller\\UserAuthenticationController::loginStatus\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:8:\"json|xml\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:3:\"GET\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":350:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:24:\"#^/user/login_status$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:18:\"/user/login_status\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:18:\"/user/login_status\";s:8:\"numParts\";i:2;}}}}',2),('user.logout','/user/logout','/user/logout',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":852:{a:9:{s:4:\"path\";s:12:\"/user/logout\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:46:\"\\Drupal\\user\\Controller\\UserController::logout\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":332:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/user/logout$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/user/logout\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/user/logout\";s:8:\"numParts\";i:2;}}}}',2),('user.logout.http','/user/logout','/user/logout',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":940:{a:9:{s:4:\"path\";s:12:\"/user/logout\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:60:\"\\Drupal\\user\\Controller\\UserAuthenticationController::logout\";}s:12:\"requirements\";a:3:{s:18:\"_user_is_logged_in\";s:4:\"TRUE\";s:7:\"_format\";s:8:\"json|xml\";s:11:\"_csrf_token\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:2:{i:0;s:30:\"access_check.user.login_status\";i:1;s:17:\"access_check.csrf\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":332:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:18:\"#^/user/logout$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/user/logout\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:12:\"/user/logout\";s:8:\"numParts\";i:2;}}}}',2),('user.multiple_cancel_confirm','/admin/people/cancel','/admin/people/cancel',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":929:{a:9:{s:4:\"path\";s:20:\"/admin/people/cancel\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:43:\"\\Drupal\\user\\Form\\UserMultipleCancelConfirm\";s:6:\"_title\";s:11:\"Cancel user\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer users\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/people/cancel$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/people/cancel\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/people/cancel\";s:8:\"numParts\";i:3;}}}}',3),('user.page','/user','/user',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":854:{a:9:{s:4:\"path\";s:5:\"/user\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:48:\"\\Drupal\\user\\Controller\\UserController::userPage\";s:6:\"_title\";s:10:\"My account\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":309:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:11:\"#^/user$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/user\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:5:\"/user\";s:8:\"numParts\";i:1;}}}}',1),('user.pass','/user/password','/user/password',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":890:{a:9:{s:4:\"path\";s:14:\"/user/password\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:34:\"\\Drupal\\user\\Form\\UserPasswordForm\";s:6:\"_title\";s:19:\"Reset your password\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/user/password$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/user/password\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/user/password\";s:8:\"numParts\";i:2;}}}}',2),('user.pass.http','/user/password','/user/password',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":874:{a:9:{s:4:\"path\";s:14:\"/user/password\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:67:\"\\Drupal\\user\\Controller\\UserAuthenticationController::resetPassword\";}s:12:\"requirements\";a:2:{s:7:\"_access\";s:4:\"TRUE\";s:7:\"_format\";s:8:\"json|xml\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:1:{i:0;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/user/password$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/user/password\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/user/password\";s:8:\"numParts\";i:2;}}}}',2),('user.register','/user/register','/user/register',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":866:{a:9:{s:4:\"path\";s:14:\"/user/register\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:13:\"user.register\";s:6:\"_title\";s:18:\"Create new account\";}s:12:\"requirements\";a:1:{s:21:\"_access_user_register\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.user.register\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/user/register$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/user/register\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/user/register\";s:8:\"numParts\";i:2;}}}}',2),('user.reset','/user/reset/{uid}/{timestamp}/{hash}','/user/reset/%/%/%',24,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1322:{a:9:{s:4:\"path\";s:36:\"/user/reset/{uid}/{timestamp}/{hash}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:49:\"\\Drupal\\user\\Controller\\UserController::resetPass\";s:6:\"_title\";s:14:\"Reset password\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:8:\"no_cache\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":712:{a:11:{s:4:\"vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:72:\"#^/user/reset/(?P<uid>[^/]++)/(?P<timestamp>[^/]++)/(?P<hash>[^/]++)$#sD\";s:11:\"path_tokens\";a:4:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"hash\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"timestamp\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"uid\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/reset\";}}s:9:\"path_vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:24;s:14:\"patternOutline\";s:17:\"/user/reset/%/%/%\";s:8:\"numParts\";i:5;}}}}',5),('user.reset.form','/user/reset/{uid}','/user/reset/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1068:{a:9:{s:4:\"path\";s:17:\"/user/reset/{uid}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:56:\"\\Drupal\\user\\Controller\\UserController::getResetPassForm\";s:6:\"_title\";s:14:\"Reset password\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:8:\"no_cache\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":447:{a:11:{s:4:\"vars\";a:1:{i:0;s:3:\"uid\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:33:\"#^/user/reset/(?P<uid>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"uid\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/reset\";}}s:9:\"path_vars\";a:1:{i:0;s:3:\"uid\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:13:\"/user/reset/%\";s:8:\"numParts\";i:3;}}}}',3),('user.reset.login','/user/reset/{uid}/{timestamp}/{hash}/login','/user/reset/%/%/%/login',49,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1410:{a:9:{s:4:\"path\";s:42:\"/user/reset/{uid}/{timestamp}/{hash}/login\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\user\\Controller\\UserController::resetPassLogin\";s:6:\"_title\";s:14:\"Reset password\";}s:12:\"requirements\";a:1:{s:18:\"_user_is_logged_in\";s:5:\"FALSE\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:19:\"_maintenance_access\";b:1;s:8:\"no_cache\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:30:\"access_check.user.login_status\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":766:{a:11:{s:4:\"vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:78:\"#^/user/reset/(?P<uid>[^/]++)/(?P<timestamp>[^/]++)/(?P<hash>[^/]++)/login$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:6:\"/login\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"hash\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:9:\"timestamp\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:3:\"uid\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/user/reset\";}}s:9:\"path_vars\";a:3:{i:0;s:3:\"uid\";i:1;s:9:\"timestamp\";i:2;s:4:\"hash\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:49;s:14:\"patternOutline\";s:23:\"/user/reset/%/%/%/login\";s:8:\"numParts\";i:6;}}}}',6),('user.role_add','/admin/people/roles/add','/admin/people/roles/add',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":926:{a:9:{s:4:\"path\";s:23:\"/admin/people/roles/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:17:\"user_role.default\";s:6:\"_title\";s:8:\"Add role\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:22:\"administer permissions\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":366:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:29:\"#^/admin/people/roles/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:23:\"/admin/people/roles/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:23:\"/admin/people/roles/add\";s:8:\"numParts\";i:4;}}}}',4),('view.block_content.page_1','/admin/structure/block/block-content','/admin/structure/block/block-content',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1373:{a:9:{s:4:\"path\";s:36:\"/admin/structure/block/block-content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:20:\"Custom block library\";s:7:\"view_id\";s:13:\"block_content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:17:\"administer blocks\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":406:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/admin/structure/block/block\\-content$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:36:\"/admin/structure/block/block-content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:36:\"/admin/structure/block/block-content\";s:8:\"numParts\";i:4;}}}}',4),('view.comment.page_published','/admin/content/comment','/admin/content/comment',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1306:{a:9:{s:4:\"path\";s:22:\"/admin/content/comment\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:14:\"page_published\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":362:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:28:\"#^/admin/content/comment$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/content/comment\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:22:\"/admin/content/comment\";s:8:\"numParts\";i:3;}}}}',3),('view.comment.page_unapproved','/admin/content/comment/approval','/admin/content/comment/approval',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1344:{a:9:{s:4:\"path\";s:31:\"/admin/content/comment/approval\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:8:\"Comments\";s:7:\"view_id\";s:7:\"comment\";s:10:\"display_id\";s:15:\"page_unapproved\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"administer comments\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":390:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/content/comment/approval$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/content/comment/approval\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/content/comment/approval\";s:8:\"numParts\";i:4;}}}}',4),('view.content.page_1','/admin/content','/admin/content',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1268:{a:9:{s:4:\"path\";s:14:\"/admin/content\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:7:\"Content\";s:7:\"view_id\";s:7:\"content\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:23:\"access content overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":338:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:20:\"#^/admin/content$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/admin/content\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:14:\"/admin/content\";s:8:\"numParts\";i:2;}}}}',2),('view.files.page_1','/admin/content/files','/admin/content/files',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1286:{a:9:{s:4:\"path\";s:20:\"/admin/content/files\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:5:\"Files\";s:7:\"view_id\";s:5:\"files\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:21:\"access files overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/content/files$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/content/files\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/content/files\";s:8:\"numParts\";i:3;}}}}',3),('view.files.page_2','/admin/content/files/usage/{arg_0}','/admin/content/files/usage/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1475:{a:9:{s:4:\"path\";s:34:\"/admin/content/files/usage/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:10:\"File usage\";s:7:\"view_id\";s:5:\"files\";s:10:\"display_id\";s:6:\"page_2\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:21:\"access files overview\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":501:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:50:\"#^/admin/content/files/usage/(?P<arg_0>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/content/files/usage\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:28:\"/admin/content/files/usage/%\";s:8:\"numParts\";i:5;}}}}',5),('view.frontpage.feed_1','/rss.xml','/rss.xml',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1179:{a:9:{s:4:\"path\";s:8:\"/rss.xml\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:9:\"frontpage\";s:10:\"display_id\";s:6:\"feed_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:7:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"feed\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Feed\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":319:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:15:\"#^/rss\\.xml$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/rss.xml\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:8:\"/rss.xml\";s:8:\"numParts\";i:1;}}}}',1),('view.frontpage.page_1','/node','/node',1,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1191:{a:9:{s:4:\"path\";s:5:\"/node\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:9:\"frontpage\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:7:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":309:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:11:\"#^/node$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/node\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:1;s:14:\"patternOutline\";s:5:\"/node\";s:8:\"numParts\";i:1;}}}}',1),('view.ga_reports_page.page_front','/admin/reports/google-analytics-reports/page/{arg_0}','/admin/reports/google-analytics-reports/page',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1611:{a:9:{s:4:\"path\";s:52:\"/admin/reports/google-analytics-reports/page/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:6:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:29:\"Google Analytics Reports Page\";s:7:\"view_id\";s:15:\"ga_reports_page\";s:10:\"display_id\";s:10:\"page_front\";s:30:\"_view_display_show_admin_links\";b:1;s:5:\"arg_0\";N;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:31:\"access google analytics reports\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":560:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:75:\"#^/admin/reports/google\\-analytics\\-reports/page(?:/(?P<arg_0>[^/]++))?$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/reports/google-analytics-reports/page\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:44:\"/admin/reports/google-analytics-reports/page\";s:8:\"numParts\";i:5;}}}}',5),('view.ga_reports_page.page_others','/admin/reports/google-analytics-reports/page/{arg_0}','/admin/reports/google-analytics-reports/page/%',30,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1595:{a:9:{s:4:\"path\";s:52:\"/admin/reports/google-analytics-reports/page/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:29:\"Google Analytics Reports Page\";s:7:\"view_id\";s:15:\"ga_reports_page\";s:10:\"display_id\";s:11:\"page_others\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:31:\"access google analytics reports\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":557:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:70:\"#^/admin/reports/google\\-analytics\\-reports/page/(?P<arg_0>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:44:\"/admin/reports/google-analytics-reports/page\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:30;s:14:\"patternOutline\";s:46:\"/admin/reports/google-analytics-reports/page/%\";s:8:\"numParts\";i:5;}}}}',5),('view.ga_summary.page_1','/admin/reports/google-analytics-reports/summary','/admin/reports/google-analytics-reports/summary',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1433:{a:9:{s:4:\"path\";s:47:\"/admin/reports/google-analytics-reports/summary\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:24:\"Google Analytics Summary\";s:7:\"view_id\";s:10:\"ga_summary\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:31:\"access google analytics reports\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":440:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:55:\"#^/admin/reports/google\\-analytics\\-reports/summary$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:47:\"/admin/reports/google-analytics-reports/summary\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:47:\"/admin/reports/google-analytics-reports/summary\";s:8:\"numParts\";i:4;}}}}',4),('view.moderated_content.moderated_content','/admin/content/moderated','/admin/content/moderated',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1347:{a:9:{s:4:\"path\";s:24:\"/admin/content/moderated\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:17:\"Moderated content\";s:7:\"view_id\";s:17:\"moderated_content\";s:10:\"display_id\";s:17:\"moderated_content\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:28:\"view any unpublished content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":368:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:30:\"#^/admin/content/moderated$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:24:\"/admin/content/moderated\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:24:\"/admin/content/moderated\";s:8:\"numParts\";i:3;}}}}',3),('view.taxonomy_term.feed_1','/taxonomy/term/{arg_0}/feed','/taxonomy/term/%/feed',13,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1425:{a:9:{s:4:\"path\";s:27:\"/taxonomy/term/{arg_0}/feed\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:13:\"taxonomy_term\";s:10:\"display_id\";s:6:\"feed_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:14:\"access content\";}s:7:\"options\";a:7:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"feed\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Feed\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":516:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:43:\"#^/taxonomy/term/(?P<arg_0>[^/]++)/feed$#sD\";s:11:\"path_tokens\";a:3:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:5:\"/feed\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:13;s:14:\"patternOutline\";s:21:\"/taxonomy/term/%/feed\";s:8:\"numParts\";i:4;}}}}',4),('view.taxonomy_term.page_1','/taxonomy/term/{arg_0}','/taxonomy/term/%',6,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1393:{a:9:{s:4:\"path\";s:22:\"/taxonomy/term/{arg_0}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:0:\"\";s:7:\"view_id\";s:13:\"taxonomy_term\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:14:\"access content\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:7:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:1:{s:5:\"arg_0\";s:5:\"arg_0\";}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":464:{a:11:{s:4:\"vars\";a:1:{i:0;s:5:\"arg_0\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:38:\"#^/taxonomy/term/(?P<arg_0>[^/]++)$#sD\";s:11:\"path_tokens\";a:2:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:5:\"arg_0\";}i:1;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/taxonomy/term\";}}s:9:\"path_vars\";a:1:{i:0;s:5:\"arg_0\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:6;s:14:\"patternOutline\";s:16:\"/taxonomy/term/%\";s:8:\"numParts\";i:3;}}}}',3),('view.user_admin_people.page_1','/admin/people','/admin/people',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1267:{a:9:{s:4:\"path\";s:13:\"/admin/people\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:6:\"People\";s:7:\"view_id\";s:17:\"user_admin_people\";s:10:\"display_id\";s:6:\"page_1\";s:30:\"_view_display_show_admin_links\";b:0;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:16:\"administer users\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:0;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":335:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:19:\"#^/admin/people$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/admin/people\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:13:\"/admin/people\";s:8:\"numParts\";i:2;}}}}',2),('view.watchdog.page','/admin/reports/dblog','/admin/reports/dblog',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1300:{a:9:{s:4:\"path\";s:20:\"/admin/reports/dblog\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:5:{s:11:\"_controller\";s:47:\"Drupal\\views\\Routing\\ViewPageController::handle\";s:6:\"_title\";s:19:\"Recent log messages\";s:7:\"view_id\";s:8:\"watchdog\";s:10:\"display_id\";s:4:\"page\";s:30:\"_view_display_show_admin_links\";b:1;}s:12:\"requirements\";a:2:{s:11:\"_permission\";s:19:\"access site reports\";s:7:\"_format\";s:4:\"html\";}s:7:\"options\";a:8:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:18:\"_view_argument_map\";a:0:{}s:23:\"_view_display_plugin_id\";s:4:\"page\";s:26:\"_view_display_plugin_class\";s:38:\"Drupal\\views\\Plugin\\views\\display\\Page\";s:30:\"_view_display_show_admin_links\";b:1;s:16:\"returns_response\";b:0;s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":356:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:26:\"#^/admin/reports/dblog$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:20:\"/admin/reports/dblog\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:20:\"/admin/reports/dblog\";s:8:\"numParts\";i:3;}}}}',3),('views.ajax','/views/ajax','/views/ajax',3,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":833:{a:9:{s:4:\"path\";s:11:\"/views/ajax\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:53:\"\\Drupal\\views\\Controller\\ViewAjaxController::ajaxView\";}s:12:\"requirements\";a:1:{s:7:\"_access\";s:4:\"TRUE\";}s:7:\"options\";a:2:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:14:\"_access_checks\";a:1:{i:0;s:20:\"access_check.default\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":329:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:17:\"#^/views/ajax$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:11:\"/views/ajax\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:3;s:14:\"patternOutline\";s:11:\"/views/ajax\";s:8:\"numParts\";i:2;}}}}',2),('views_ui.add','/admin/structure/views/add','/admin/structure/views/add',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":922:{a:9:{s:4:\"path\";s:26:\"/admin/structure/views/add\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:12:\"_entity_form\";s:8:\"view.add\";s:6:\"_title\";s:8:\"Add view\";}s:12:\"requirements\";a:1:{s:21:\"_entity_create_access\";s:4:\"view\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:26:\"access_check.entity_create\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":375:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:32:\"#^/admin/structure/views/add$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:26:\"/admin/structure/views/add\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:26:\"/admin/structure/views/add\";s:8:\"numParts\";i:4;}}}}',4),('views_ui.autocomplete','/admin/views/ajax/autocomplete/tag','/admin/views/ajax/autocomplete/tag',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":980:{a:9:{s:4:\"path\";s:34:\"/admin/views/ajax/autocomplete/tag\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:62:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::autocompleteTag\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":399:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:40:\"#^/admin/views/ajax/autocomplete/tag$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/views/ajax/autocomplete/tag\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:34:\"/admin/views/ajax/autocomplete/tag\";s:8:\"numParts\";i:5;}}}}',5),('views_ui.form_add_handler','/admin/structure/views/{js}/add-handler/{view}/{display_id}/{type}','/admin/structure/views/%/add-handler/%/%/%',232,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1736:{a:9:{s:4:\"path\";s:66:\"/admin/structure/views/{js}/add-handler/{view}/{display_id}/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:46:\"\\Drupal\\views_ui\\Form\\Ajax\\AddHandler::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":952:{a:11:{s:4:\"vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:116:\"#^/admin/structure/views/(?P<js>nojs|ajax)/add\\-handler/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:12:\"/add-handler\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:232;s:14:\"patternOutline\";s:42:\"/admin/structure/views/%/add-handler/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),('views_ui.form_analyze','/admin/structure/views/{js}/analyze/{view}/{display_id}','/admin/structure/views/%/analyze/%/%',116,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1585:{a:9:{s:4:\"path\";s:55:\"/admin/structure/views/{js}/analyze/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:43:\"\\Drupal\\views_ui\\Form\\Ajax\\Analyze::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":815:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:94:\"#^/admin/structure/views/(?P<js>nojs|ajax)/analyze/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/analyze\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:36:\"/admin/structure/views/%/analyze/%/%\";s:8:\"numParts\";i:7;}}}}',7),('views_ui.form_display','/admin/structure/views/{js}/display/{view}/{display_id}/{type}','/admin/structure/views/%/display/%/%/%',232,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1715:{a:9:{s:4:\"path\";s:62:\"/admin/structure/views/{js}/display/{view}/{display_id}/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:43:\"\\Drupal\\views_ui\\Form\\Ajax\\Display::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":938:{a:11:{s:4:\"vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:111:\"#^/admin/structure/views/(?P<js>nojs|ajax)/display/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/display\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:232;s:14:\"patternOutline\";s:38:\"/admin/structure/views/%/display/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),('views_ui.form_edit_details','/admin/structure/views/{js}/edit-details/{view}/{display_id}','/admin/structure/views/%/edit-details/%/%',116,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1612:{a:9:{s:4:\"path\";s:60:\"/admin/structure/views/{js}/edit-details/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:47:\"\\Drupal\\views_ui\\Form\\Ajax\\EditDetails::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":833:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:100:\"#^/admin/structure/views/(?P<js>nojs|ajax)/edit\\-details/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:13:\"/edit-details\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:41:\"/admin/structure/views/%/edit-details/%/%\";s:8:\"numParts\";i:7;}}}}',7),('views_ui.form_handler','/admin/structure/views/{js}/handler/{view}/{display_id}/{type}/{id}','/admin/structure/views/%/handler/%/%/%/%',464,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1841:{a:9:{s:4:\"path\";s:67:\"/admin/structure/views/{js}/handler/{view}/{display_id}/{type}/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:49:\"\\Drupal\\views_ui\\Form\\Ajax\\ConfigHandler::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1052:{a:11:{s:4:\"vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:126:\"#^/admin/structure/views/(?P<js>nojs|ajax)/handler/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)/(?P<id>[^/]++)$#sD\";s:11:\"path_tokens\";a:7:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:8:\"/handler\";}i:5;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:6;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:464;s:14:\"patternOutline\";s:40:\"/admin/structure/views/%/handler/%/%/%/%\";s:8:\"numParts\";i:9;}}}}',9),('views_ui.form_handler_extra','/admin/structure/views/{js}/handler-extra/{view}/{display_id}/{type}/{id}','/admin/structure/views/%/handler-extra/%/%/%/%',464,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1872:{a:9:{s:4:\"path\";s:73:\"/admin/structure/views/{js}/handler-extra/{view}/{display_id}/{type}/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:54:\"\\Drupal\\views_ui\\Form\\Ajax\\ConfigHandlerExtra::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1072:{a:11:{s:4:\"vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:133:\"#^/admin/structure/views/(?P<js>nojs|ajax)/handler\\-extra/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)/(?P<id>[^/]++)$#sD\";s:11:\"path_tokens\";a:7:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/handler-extra\";}i:5;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:6;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:464;s:14:\"patternOutline\";s:46:\"/admin/structure/views/%/handler-extra/%/%/%/%\";s:8:\"numParts\";i:9;}}}}',9),('views_ui.form_handler_group','/admin/structure/views/{js}/handler-group/{view}/{display_id}/{type}/{id}','/admin/structure/views/%/handler-group/%/%/%/%',464,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1892:{a:9:{s:4:\"path\";s:73:\"/admin/structure/views/{js}/handler-group/{view}/{display_id}/{type}/{id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:54:\"\\Drupal\\views_ui\\Form\\Ajax\\ConfigHandlerGroup::getForm\";s:10:\"form_state\";N;}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":1072:{a:11:{s:4:\"vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:133:\"#^/admin/structure/views/(?P<js>nojs|ajax)/handler\\-group/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)/(?P<id>[^/]++)$#sD\";s:11:\"path_tokens\";a:7:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:2:\"id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:14:\"/handler-group\";}i:5;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:6;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:5:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";i:4;s:2:\"id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:464;s:14:\"patternOutline\";s:46:\"/admin/structure/views/%/handler-group/%/%/%/%\";s:8:\"numParts\";i:9;}}}}',9),('views_ui.form_rearrange','/admin/structure/views/{js}/rearrange/{view}/{display_id}/{type}','/admin/structure/views/%/rearrange/%/%/%',232,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1726:{a:9:{s:4:\"path\";s:64:\"/admin/structure/views/{js}/rearrange/{view}/{display_id}/{type}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:45:\"\\Drupal\\views_ui\\Form\\Ajax\\Rearrange::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":945:{a:11:{s:4:\"vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:113:\"#^/admin/structure/views/(?P<js>nojs|ajax)/rearrange/(?P<view>[^/]++)/(?P<display_id>[^/]++)/(?P<type>[^/]++)$#sD\";s:11:\"path_tokens\";a:6:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"type\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:2;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:3;a:2:{i:0;s:4:\"text\";i:1;s:10:\"/rearrange\";}i:4;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:5;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:4:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";i:3;s:4:\"type\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:232;s:14:\"patternOutline\";s:40:\"/admin/structure/views/%/rearrange/%/%/%\";s:8:\"numParts\";i:8;}}}}',8),('views_ui.form_rearrange_filter','/admin/structure/views/{js}/rearrange-filter/{view}/{display_id}','/admin/structure/views/%/rearrange-filter/%/%',116,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1632:{a:9:{s:4:\"path\";s:64:\"/admin/structure/views/{js}/rearrange-filter/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Form\\Ajax\\RearrangeFilter::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/structure/views/(?P<js>nojs|ajax)/rearrange\\-filter/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/rearrange-filter\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:45:\"/admin/structure/views/%/rearrange-filter/%/%\";s:8:\"numParts\";i:7;}}}}',7),('views_ui.form_reorder_displays','/admin/structure/views/{js}/reorder-displays/{view}/{display_id}','/admin/structure/views/%/reorder-displays/%/%',116,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1632:{a:9:{s:4:\"path\";s:64:\"/admin/structure/views/{js}/reorder-displays/{view}/{display_id}\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:1:{s:11:\"_controller\";s:51:\"\\Drupal\\views_ui\\Form\\Ajax\\ReorderDisplays::getForm\";}s:12:\"requirements\";a:2:{s:14:\"_entity_access\";s:11:\"view.update\";s:2:\"js\";s:9:\"nojs|ajax\";}s:7:\"options\";a:4:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:10:\"parameters\";a:1:{s:4:\"view\";a:3:{s:9:\"tempstore\";b:1;s:4:\"type\";s:11:\"entity:view\";s:9:\"converter\";s:53:\"drupal.proxy_original_service.paramconverter.views_ui\";}}s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:19:\"access_check.entity\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":845:{a:11:{s:4:\"vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:104:\"#^/admin/structure/views/(?P<js>nojs|ajax)/reorder\\-displays/(?P<view>[^/]++)/(?P<display_id>[^/]++)$#sD\";s:11:\"path_tokens\";a:5:{i:0;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:10:\"display_id\";}i:1;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:6:\"[^/]++\";i:3;s:4:\"view\";}i:2;a:2:{i:0;s:4:\"text\";i:1;s:17:\"/reorder-displays\";}i:3;a:4:{i:0;s:8:\"variable\";i:1;s:1:\"/\";i:2;s:9:\"nojs|ajax\";i:3;s:2:\"js\";}i:4;a:2:{i:0;s:4:\"text\";i:1;s:22:\"/admin/structure/views\";}}s:9:\"path_vars\";a:3:{i:0;s:2:\"js\";i:1;s:4:\"view\";i:2;s:10:\"display_id\";}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:116;s:14:\"patternOutline\";s:45:\"/admin/structure/views/%/reorder-displays/%/%\";s:8:\"numParts\";i:7;}}}}',7),('views_ui.reports_fields','/admin/reports/fields/views-fields','/admin/reports/fields/views-fields',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1012:{a:9:{s:4:\"path\";s:34:\"/admin/reports/fields/views-fields\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:59:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::reportFields\";s:6:\"_title\";s:13:\"Used in views\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":400:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:41:\"#^/admin/reports/fields/views\\-fields$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:34:\"/admin/reports/fields/views-fields\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:34:\"/admin/reports/fields/views-fields\";s:8:\"numParts\";i:4;}}}}',4),('views_ui.reports_plugins','/admin/reports/views-plugins','/admin/reports/views-plugins',7,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":988:{a:9:{s:4:\"path\";s:28:\"/admin/reports/views-plugins\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:11:\"_controller\";s:60:\"\\Drupal\\views_ui\\Controller\\ViewsUIController::reportPlugins\";s:6:\"_title\";s:13:\"Views plugins\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":381:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:35:\"#^/admin/reports/views\\-plugins$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:28:\"/admin/reports/views-plugins\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:7;s:14:\"patternOutline\";s:28:\"/admin/reports/views-plugins\";s:8:\"numParts\";i:3;}}}}',3),('views_ui.settings_advanced','/admin/structure/views/settings/advanced','/admin/structure/views/settings/advanced',31,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":1021:{a:9:{s:4:\"path\";s:40:\"/admin/structure/views/settings/advanced\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:42:\"\\Drupal\\views_ui\\Form\\AdvancedSettingsForm\";s:6:\"_title\";s:23:\"Advanced Views settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":417:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:46:\"#^/admin/structure/views/settings/advanced$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:40:\"/admin/structure/views/settings/advanced\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:31;s:14:\"patternOutline\";s:40:\"/admin/structure/views/settings/advanced\";s:8:\"numParts\";i:5;}}}}',5),('views_ui.settings_basic','/admin/structure/views/settings','/admin/structure/views/settings',15,_binary 'C:31:\"Symfony\\Component\\Routing\\Route\":973:{a:9:{s:4:\"path\";s:31:\"/admin/structure/views/settings\";s:4:\"host\";s:0:\"\";s:8:\"defaults\";a:2:{s:5:\"_form\";s:39:\"\\Drupal\\views_ui\\Form\\BasicSettingsForm\";s:6:\"_title\";s:14:\"Views settings\";}s:12:\"requirements\";a:1:{s:11:\"_permission\";s:16:\"administer views\";}s:7:\"options\";a:3:{s:14:\"compiler_class\";s:34:\"\\Drupal\\Core\\Routing\\RouteCompiler\";s:12:\"_admin_route\";b:1;s:14:\"_access_checks\";a:1:{i:0;s:23:\"access_check.permission\";}}s:7:\"schemes\";a:0:{}s:7:\"methods\";a:2:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";}s:9:\"condition\";s:0:\"\";s:8:\"compiled\";C:33:\"Drupal\\Core\\Routing\\CompiledRoute\":390:{a:11:{s:4:\"vars\";a:0:{}s:11:\"path_prefix\";s:0:\"\";s:10:\"path_regex\";s:37:\"#^/admin/structure/views/settings$#sD\";s:11:\"path_tokens\";a:1:{i:0;a:2:{i:0;s:4:\"text\";i:1;s:31:\"/admin/structure/views/settings\";}}s:9:\"path_vars\";a:0:{}s:10:\"host_regex\";N;s:11:\"host_tokens\";a:0:{}s:9:\"host_vars\";a:0:{}s:3:\"fit\";i:15;s:14:\"patternOutline\";s:31:\"/admin/structure/views/settings\";s:8:\"numParts\";i:4;}}}}',4);
/*!40000 ALTER TABLE `router` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_dataset`
--

DROP TABLE IF EXISTS `search_dataset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_dataset` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Search item ID, e.g. node ID for nodes.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The languages.langcode of the item variant.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL COMMENT 'Type of item, e.g. node.',
  `data` longtext NOT NULL COMMENT 'List of space-separated words from the item.',
  `reindex` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Set to force node reindexing.',
  PRIMARY KEY (`sid`,`langcode`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores items that will be searched.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_dataset`
--

LOCK TABLES `search_dataset` WRITE;
/*!40000 ALTER TABLE `search_dataset` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_dataset` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_index`
--

DROP TABLE IF EXISTS `search_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_index` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'The search_total.word that is associated with the search item.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item to which the word belongs.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The languages.langcode of the item variant.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL COMMENT 'The search_dataset.type of the searchable item to which the word belongs.',
  `score` float DEFAULT NULL COMMENT 'The numeric score of the word, higher being more important.',
  PRIMARY KEY (`word`,`sid`,`langcode`,`type`),
  KEY `sid_type` (`sid`,`langcode`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores the search index, associating words, items and…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_index`
--

LOCK TABLES `search_index` WRITE;
/*!40000 ALTER TABLE `search_index` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_total`
--

DROP TABLE IF EXISTS `search_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_total` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique word in the search index.',
  `count` float DEFAULT NULL COMMENT 'The count of the word in the index using Zipf''s law to equalize the probability distribution.',
  PRIMARY KEY (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores search totals for words.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_total`
--

LOCK TABLES `search_total` WRITE;
/*!40000 ALTER TABLE `search_total` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_total` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `semaphore`
--

DROP TABLE IF EXISTS `semaphore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `semaphore` (
  `name` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique name.',
  `value` varchar(255) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'A value for the semaphore.',
  `expire` double NOT NULL COMMENT 'A Unix timestamp with microseconds indicating when the semaphore should expire.',
  PRIMARY KEY (`name`),
  KEY `value` (`value`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Table for holding semaphores, locks, flags, etc. that…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `semaphore`
--

LOCK TABLES `semaphore` WRITE;
/*!40000 ALTER TABLE `semaphore` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `semaphore` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `sequences`
--

DROP TABLE IF EXISTS `sequences`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sequences` (
  `value` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The value of the sequence.',
  PRIMARY KEY (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4 COMMENT='Stores IDs.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequences`
--

LOCK TABLES `sequences` WRITE;
/*!40000 ALTER TABLE `sequences` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `sequences` VALUES (4);
/*!40000 ALTER TABLE `sequences` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sessions` (
  `uid` int(10) unsigned NOT NULL COMMENT 'The users.uid corresponding to a session, or 0 for anonymous user.',
  `sid` varchar(128) CHARACTER SET ascii NOT NULL COMMENT 'A session ID (hashed). The value is generated by Drupal''s session handlers.',
  `hostname` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The IP address that last used this session ID (sid).',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this session last requested a page. Old records are purged by PHP automatically.',
  `session` longblob COMMENT 'The serialized contents of $_SESSION, an array of name/value pairs that persists across page requests by this session ID. Drupal loads $_SESSION from here at the start of each request and saves it at the end.',
  PRIMARY KEY (`sid`),
  KEY `timestamp` (`timestamp`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Drupal''s session handlers read and write into the sessions…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `sessions` VALUES (0,'AYUPsIFH130qpmg7yzpzSKj-yXfKrmpBMDQ62z3x8fQ','127.0.0.1',1540289375,_binary '_symfony_flashes|a:1:{s:5:\"error\";a:21:{i:0;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:232:\"<em class=\"placeholder\">Notice</em>: Undefined index: attributes in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:1;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:232:\"<em class=\"placeholder\">Notice</em>: Undefined index: attributes in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:2;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:232:\"<em class=\"placeholder\">Notice</em>: Undefined index: attributes in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:3;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:232:\"<em class=\"placeholder\">Notice</em>: Undefined index: attributes in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:4;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:232:\"<em class=\"placeholder\">Notice</em>: Undefined index: attributes in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:5;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:232:\"<em class=\"placeholder\">Notice</em>: Undefined index: attributes in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:6;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:232:\"<em class=\"placeholder\">Notice</em>: Undefined index: attributes in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:7;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:8;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:9;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:10;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:11;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:12;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:13;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:14;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:15;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:16;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:17;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:18;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:19;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}i:20;O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:230:\"<em class=\"placeholder\">Notice</em>: Undefined variable: field in <em class=\"placeholder\">justice_preprocess_input()</em> (line <em class=\"placeholder\">306</em> of <em class=\"placeholder\">themes/custom/justice/justice.theme</em>).\";}}}_sf2_meta|a:3:{s:1:\"u\";i:1540289375;s:1:\"c\";i:1540275803;s:1:\"l\";s:7:\"2000000\";}'),(1,'E4kewwl0nHuX3qQvJCynIpNxNQLzGCVW0S577Re7-9s','127.0.0.1',1540293696,_binary '_sf2_meta|a:4:{s:1:\"u\";i:1540293579;s:1:\"c\";i:1540270611;s:1:\"l\";s:7:\"2000000\";s:1:\"s\";s:43:\"V_OTl3z8h9msqLKDW0Qv3YWXwehQv4EKoAxIA-j2WN8\";}_sf2_attributes|a:1:{s:3:\"uid\";s:1:\"1\";}'),(1,'GIRzzpWZlwSWWhxAsCzcY2wrEvQzJmtrpQnWMEIs13A','127.0.0.1',1540193044,_binary '_sf2_attributes|a:1:{s:3:\"uid\";s:1:\"1\";}_sf2_meta|a:4:{s:1:\"u\";i:1540193004;s:1:\"c\";i:1540193004;s:1:\"l\";s:7:\"2000000\";s:1:\"s\";s:43:\"6N4ACqVFxscs8MagloJJnIDJkz2-Yy6LszmLhhSPvmQ\";}');
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `shortcut`
--

DROP TABLE IF EXISTS `shortcut`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `shortcut_set` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `shortcut_field__uuid__value` (`uuid`),
  KEY `shortcut_field__shortcut_set__target_id` (`shortcut_set`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='The base table for shortcut entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut`
--

LOCK TABLES `shortcut` WRITE;
/*!40000 ALTER TABLE `shortcut` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `shortcut` VALUES (1,'default','6288e651-470d-402d-bdbb-259409e625d2','en'),(2,'default','7ce742eb-e4cf-45fd-9e8d-2db60d39fd4d','en'),(3,'default','0a149017-64a4-46fb-9f69-77c76e54a2e3','en');
/*!40000 ALTER TABLE `shortcut` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `shortcut_field_data`
--

DROP TABLE IF EXISTS `shortcut_field_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_field_data` (
  `id` int(10) unsigned NOT NULL,
  `shortcut_set` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `weight` int(11) DEFAULT NULL,
  `link__uri` varchar(2048) DEFAULT NULL COMMENT 'The URI of the link.',
  `link__title` varchar(255) DEFAULT NULL COMMENT 'The link text.',
  `link__options` longblob COMMENT 'Serialized array of options for the link.',
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`,`langcode`),
  KEY `shortcut__id__default_langcode__langcode` (`id`,`default_langcode`,`langcode`),
  KEY `shortcut_field__shortcut_set__target_id` (`shortcut_set`),
  KEY `shortcut_field__link__uri` (`link__uri`(30))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for shortcut entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_field_data`
--

LOCK TABLES `shortcut_field_data` WRITE;
/*!40000 ALTER TABLE `shortcut_field_data` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `shortcut_field_data` VALUES (1,'default','en','Add content',-20,'internal:/node/add',NULL,_binary 'a:0:{}',1),(2,'default','en','All content',-19,'internal:/admin/content',NULL,_binary 'a:0:{}',1),(3,'default','en','Configuration',NULL,'internal:/admin/config',NULL,_binary 'a:0:{}',1);
/*!40000 ALTER TABLE `shortcut_field_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `shortcut_set_users`
--

DROP TABLE IF EXISTS `shortcut_set_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set_users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid for this set.',
  `set_name` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The shortcut_set.set_name that will be displayed for this user.',
  PRIMARY KEY (`uid`),
  KEY `set_name` (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maps users to shortcut sets.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set_users`
--

LOCK TABLES `shortcut_set_users` WRITE;
/*!40000 ALTER TABLE `shortcut_set_users` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `shortcut_set_users` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_index`
--

DROP TABLE IF EXISTS `taxonomy_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_index` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node is published (visible to non-administrators).',
  `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  PRIMARY KEY (`nid`,`tid`),
  KEY `term_node` (`tid`,`status`,`sticky`,`created`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Maintains denormalized information about node/term…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_index`
--

LOCK TABLES `taxonomy_index` WRITE;
/*!40000 ALTER TABLE `taxonomy_index` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `taxonomy_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term__field_variety_attributes`
--

DROP TABLE IF EXISTS `taxonomy_term__field_variety_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term__field_variety_attributes` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_variety_attributes_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for taxonomy_term field field_variety…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term__field_variety_attributes`
--

LOCK TABLES `taxonomy_term__field_variety_attributes` WRITE;
/*!40000 ALTER TABLE `taxonomy_term__field_variety_attributes` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `taxonomy_term__field_variety_attributes` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term__parent`
--

DROP TABLE IF EXISTS `taxonomy_term__parent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term__parent` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `parent_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `parent_target_id` (`parent_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for taxonomy_term field parent.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term__parent`
--

LOCK TABLES `taxonomy_term__parent` WRITE;
/*!40000 ALTER TABLE `taxonomy_term__parent` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `taxonomy_term__parent` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term_data`
--

DROP TABLE IF EXISTS `taxonomy_term_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_data` (
  `tid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `vid` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`tid`),
  UNIQUE KEY `taxonomy_term_field__uuid__value` (`uuid`),
  KEY `taxonomy_term_field__vid__target_id` (`vid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for taxonomy_term entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_data`
--

LOCK TABLES `taxonomy_term_data` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `taxonomy_term_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term_field_data`
--

DROP TABLE IF EXISTS `taxonomy_term_field_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_field_data` (
  `tid` int(10) unsigned NOT NULL,
  `vid` varchar(32) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `status` tinyint(4) NOT NULL,
  `name` varchar(255) NOT NULL,
  `description__value` longtext,
  `description__format` varchar(255) CHARACTER SET ascii DEFAULT NULL,
  `weight` int(11) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`tid`,`langcode`),
  KEY `taxonomy_term__id__default_langcode__langcode` (`tid`,`default_langcode`,`langcode`),
  KEY `taxonomy_term_field__name` (`name`(191)),
  KEY `taxonomy_term__tree` (`vid`,`weight`,`name`(191)),
  KEY `taxonomy_term__vid_name` (`vid`,`name`(191)),
  KEY `taxonomy_term__status_vid` (`status`,`vid`,`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for taxonomy_term entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_field_data`
--

LOCK TABLES `taxonomy_term_field_data` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_field_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `taxonomy_term_field_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `url_alias`
--

DROP TABLE IF EXISTS `url_alias`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `url_alias` (
  `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'A unique path alias identifier.',
  `source` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path this alias is for. e.g. node/12.',
  `alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'The alias for this path. e.g. title-of-the-story.',
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code this alias is for. if ''und'', the alias will be used for unknown languages. Each Drupal path can have an alias for each supported language.',
  PRIMARY KEY (`pid`),
  KEY `alias_langcode_pid` (`alias`(191),`langcode`,`pid`),
  KEY `source_langcode_pid` (`source`(191),`langcode`,`pid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='A list of URL aliases for Drupal paths. a user may visit…';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `url_alias`
--

LOCK TABLES `url_alias` WRITE;
/*!40000 ALTER TABLE `url_alias` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `url_alias` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `user__field_migrate_example_favbeers`
--

DROP TABLE IF EXISTS `user__field_migrate_example_favbeers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user__field_migrate_example_favbeers` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_favbeers_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `field_migrate_example_favbeers_target_id` (`field_migrate_example_favbeers_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for user field field_migrate_example_favbeers.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user__field_migrate_example_favbeers`
--

LOCK TABLES `user__field_migrate_example_favbeers` WRITE;
/*!40000 ALTER TABLE `user__field_migrate_example_favbeers` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `user__field_migrate_example_favbeers` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `user__field_migrate_example_gender`
--

DROP TABLE IF EXISTS `user__field_migrate_example_gender`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user__field_migrate_example_gender` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_migrate_example_gender_value` varchar(255) NOT NULL,
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for user field field_migrate_example_gender.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user__field_migrate_example_gender`
--

LOCK TABLES `user__field_migrate_example_gender` WRITE;
/*!40000 ALTER TABLE `user__field_migrate_example_gender` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `user__field_migrate_example_gender` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `user__roles`
--

DROP TABLE IF EXISTS `user__roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user__roles` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `roles_target_id` varchar(255) CHARACTER SET ascii NOT NULL COMMENT 'The ID of the target entity.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `roles_target_id` (`roles_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for user field roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user__roles`
--

LOCK TABLES `user__roles` WRITE;
/*!40000 ALTER TABLE `user__roles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `user__roles` VALUES ('user',0,1,1,'en',0,'administrator');
/*!40000 ALTER TABLE `user__roles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `user__user_picture`
--

DROP TABLE IF EXISTS `user__user_picture`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user__user_picture` (
  `bundle` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to, which for an unversioned entity type is the same as the entity id',
  `langcode` varchar(32) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The language code for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `user_picture_target_id` int(10) unsigned NOT NULL COMMENT 'The ID of the file entity.',
  `user_picture_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image''s ''alt'' attribute.',
  `user_picture_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image''s ''title'' attribute.',
  `user_picture_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `user_picture_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_id`,`deleted`,`delta`,`langcode`),
  KEY `bundle` (`bundle`),
  KEY `revision_id` (`revision_id`),
  KEY `user_picture_target_id` (`user_picture_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Data storage for user field user_picture.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user__user_picture`
--

LOCK TABLES `user__user_picture` WRITE;
/*!40000 ALTER TABLE `user__user_picture` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `user__user_picture` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `uid` int(10) unsigned NOT NULL,
  `uuid` varchar(128) CHARACTER SET ascii NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  PRIMARY KEY (`uid`),
  UNIQUE KEY `user_field__uuid__value` (`uuid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The base table for user entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `users` VALUES (0,'1c8f5c7d-e8ac-4197-b95b-b3cf77cd5c11','en'),(1,'2259501f-a9d4-460a-8d1a-81793643fffd','en');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `users_data`
--

DROP TABLE IF EXISTS `users_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users_data` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary key: users.uid for user.',
  `module` varchar(50) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The name of the module declaring the variable.',
  `name` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'The identifier of the data.',
  `value` longblob COMMENT 'The value.',
  `serialized` tinyint(3) unsigned DEFAULT '0' COMMENT 'Whether value is serialized.',
  PRIMARY KEY (`uid`,`module`,`name`),
  KEY `module` (`module`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='Stores module data as key/value pairs per user.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users_data`
--

LOCK TABLES `users_data` WRITE;
/*!40000 ALTER TABLE `users_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `users_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `users_field_data`
--

DROP TABLE IF EXISTS `users_field_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users_field_data` (
  `uid` int(10) unsigned NOT NULL,
  `langcode` varchar(12) CHARACTER SET ascii NOT NULL,
  `preferred_langcode` varchar(12) CHARACTER SET ascii DEFAULT NULL,
  `preferred_admin_langcode` varchar(12) CHARACTER SET ascii DEFAULT NULL,
  `name` varchar(60) NOT NULL,
  `pass` varchar(255) DEFAULT NULL,
  `mail` varchar(254) DEFAULT NULL,
  `timezone` varchar(32) DEFAULT NULL,
  `status` tinyint(4) DEFAULT NULL,
  `created` int(11) NOT NULL,
  `changed` int(11) DEFAULT NULL,
  `access` int(11) NOT NULL,
  `login` int(11) DEFAULT NULL,
  `init` varchar(254) DEFAULT NULL,
  `default_langcode` tinyint(4) NOT NULL,
  PRIMARY KEY (`uid`,`langcode`),
  UNIQUE KEY `user__name` (`name`,`langcode`),
  KEY `user__id__default_langcode__langcode` (`uid`,`default_langcode`,`langcode`),
  KEY `user_field__mail` (`mail`(191)),
  KEY `user_field__created` (`created`),
  KEY `user_field__access` (`access`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='The data table for user entities.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users_field_data`
--

LOCK TABLES `users_field_data` WRITE;
/*!40000 ALTER TABLE `users_field_data` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `users_field_data` VALUES (0,'en','en',NULL,'',NULL,NULL,'',0,1533819342,1533819342,0,0,NULL,1),(1,'en','en',NULL,'admin','$S$EWSQr../ehTBmwvAInRqbqKz.FCTzQLN2y3.eZoJ7IiS4XwrBjz0','admin@admin.com','UTC',1,1533819342,1533820457,1540293696,1540292930,'admin@admin.com',1);
/*!40000 ALTER TABLE `users_field_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `watchdog`
--

DROP TABLE IF EXISTS `watchdog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `watchdog` (
  `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique watchdog event ID.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',
  `type` varchar(64) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Type of log message, for example "user" or "page not found."',
  `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',
  `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',
  `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event. ranges from 0 (Emergency) to 7 (Debug)',
  `link` text COMMENT 'Link to view the result of the event.',
  `location` text NOT NULL COMMENT 'URL of the origin of the event.',
  `referer` text COMMENT 'URL of referring page.',
  `hostname` varchar(128) CHARACTER SET ascii NOT NULL DEFAULT '' COMMENT 'Hostname of the user who triggered the event.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',
  PRIMARY KEY (`wid`),
  KEY `type` (`type`),
  KEY `uid` (`uid`),
  KEY `severity` (`severity`)
) ENGINE=InnoDB AUTO_INCREMENT=1256 DEFAULT CHARSET=utf8mb4 COMMENT='Table that contains logs of all system events.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `watchdog`
--

LOCK TABLES `watchdog` WRITE;
/*!40000 ALTER TABLE `watchdog` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `watchdog` VALUES (193,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6608:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547718),(194,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5858:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#35 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547718),(195,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547718),(196,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547718),(197,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5932:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryParser.php(394): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryParser.php(85): Drupal\\Core\\Asset\\LibraryDiscoveryParser->drupalGetPath(\'theme\', \'timber\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryCollector.php(87): Drupal\\Core\\Asset\\LibraryDiscoveryParser->buildByExtension(\'timber\')\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryCollector.php(66): Drupal\\Core\\Asset\\LibraryDiscoveryCollector->getLibraryDefinitions(\'timber\')\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/CacheCollector.php(149): Drupal\\Core\\Asset\\LibraryDiscoveryCollector->resolveCacheMiss(\'timber\')\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscovery.php(44): Drupal\\Core\\Cache\\CacheCollector->get(\'timber\')\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscovery.php(58): Drupal\\Core\\Asset\\LibraryDiscovery->getLibrariesByExtension(\'timber\')\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDependencyResolver.php(54): Drupal\\Core\\Asset\\LibraryDiscovery->getLibraryByName(\'timber\', \'global-styling\')\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDependencyResolver.php(31): Drupal\\Core\\Asset\\LibraryDependencyResolver->doGetDependencies(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/AssetResolver.php(104): Drupal\\Core\\Asset\\LibraryDependencyResolver->getLibrariesWithDependencies(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/AssetResolver.php(116): Drupal\\Core\\Asset\\AssetResolver->getLibrariesToLoad(Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/HtmlResponseAttachmentsProcessor.php(291): Drupal\\Core\\Asset\\AssetResolver->getCssAssets(Object(Drupal\\Core\\Asset\\AttachedAssets), false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/HtmlResponseAttachmentsProcessor.php(161): Drupal\\Core\\Render\\HtmlResponseAttachmentsProcessor->processAssetLibraries(Object(Drupal\\Core\\Asset\\AttachedAssets), Array)\n#17 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponseAttachmentsProcessor.php(94): Drupal\\Core\\Render\\HtmlResponseAttachmentsProcessor->processAttachments(Object(Drupal\\Core\\Render\\HtmlResponse))\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/HtmlResponseSubscriber.php(45): Drupal\\big_pipe\\Render\\BigPipeResponseAttachmentsProcessor->processAttachments(Object(Drupal\\Core\\Render\\HtmlResponse))\n#19 [internal function]: Drupal\\Core\\EventSubscriber\\HtmlResponseSubscriber->onRespond(Object(Symfony\\Component\\HttpKernel\\Event\\FilterResponseEvent), \'kernel.response\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\FilterResponseEvent), \'kernel.response\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(191): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.response\', Object(Symfony\\Component\\HttpKernel\\Event\\FilterResponseEvent))\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(173): Symfony\\Component\\HttpKernel\\HttpKernel->filterResponse(Object(Drupal\\Core\\Render\\HtmlResponse), Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#33 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547718),(198,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547718),(199,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547718),(200,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547718),(201,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547718),(202,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547718),(203,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547728),(204,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547728),(205,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547728),(206,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547728),(207,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547728),(208,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547728),(209,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547728),(210,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547728),(211,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547755),(212,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547755),(213,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5ba8b86872c75_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/_KUkY2BnkZJGAP4YfrSmTs-2ozHPhQU6RQgGZCe8JAk.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547755),(214,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547755),(215,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4812:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'views_view\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#14 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#17 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#27 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(216,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6245:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Wj6J6FXOkK1e3d0bS2pIq58mNar3X9VjCi3FuS6d47g.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#24 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#27 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#37 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(217,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6123:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'pager\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'pager\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Wj6J6FXOkK1e3d0bS2pIq58mNar3X9VjCi3FuS6d47g.php(95): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#36 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(218,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6254:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'feed_icon\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'feed_icon\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Wj6J6FXOkK1e3d0bS2pIq58mNar3X9VjCi3FuS6d47g.php(123): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#24 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#27 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#37 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(219,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4688:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'container\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'container\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(220,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(221,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(222,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547785),(223,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(224,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(225,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6746:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#29 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#32 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#42 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(226,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6616:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'container\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'container\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(227,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6608:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(228,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6608:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(229,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5858:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#35 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(230,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(231,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(232,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5932:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryParser.php(394): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryParser.php(85): Drupal\\Core\\Asset\\LibraryDiscoveryParser->drupalGetPath(\'theme\', \'timber\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryCollector.php(87): Drupal\\Core\\Asset\\LibraryDiscoveryParser->buildByExtension(\'timber\')\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscoveryCollector.php(66): Drupal\\Core\\Asset\\LibraryDiscoveryCollector->getLibraryDefinitions(\'timber\')\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/CacheCollector.php(149): Drupal\\Core\\Asset\\LibraryDiscoveryCollector->resolveCacheMiss(\'timber\')\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscovery.php(44): Drupal\\Core\\Cache\\CacheCollector->get(\'timber\')\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDiscovery.php(58): Drupal\\Core\\Asset\\LibraryDiscovery->getLibrariesByExtension(\'timber\')\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDependencyResolver.php(54): Drupal\\Core\\Asset\\LibraryDiscovery->getLibraryByName(\'timber\', \'global-styling\')\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/LibraryDependencyResolver.php(31): Drupal\\Core\\Asset\\LibraryDependencyResolver->doGetDependencies(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/AssetResolver.php(104): Drupal\\Core\\Asset\\LibraryDependencyResolver->getLibrariesWithDependencies(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/AssetResolver.php(116): Drupal\\Core\\Asset\\AssetResolver->getLibrariesToLoad(Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/HtmlResponseAttachmentsProcessor.php(291): Drupal\\Core\\Asset\\AssetResolver->getCssAssets(Object(Drupal\\Core\\Asset\\AttachedAssets), false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/HtmlResponseAttachmentsProcessor.php(161): Drupal\\Core\\Render\\HtmlResponseAttachmentsProcessor->processAssetLibraries(Object(Drupal\\Core\\Asset\\AttachedAssets), Array)\n#17 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponseAttachmentsProcessor.php(94): Drupal\\Core\\Render\\HtmlResponseAttachmentsProcessor->processAttachments(Object(Drupal\\Core\\Render\\HtmlResponse))\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/HtmlResponseSubscriber.php(45): Drupal\\big_pipe\\Render\\BigPipeResponseAttachmentsProcessor->processAttachments(Object(Drupal\\Core\\Render\\HtmlResponse))\n#19 [internal function]: Drupal\\Core\\EventSubscriber\\HtmlResponseSubscriber->onRespond(Object(Symfony\\Component\\HttpKernel\\Event\\FilterResponseEvent), \'kernel.response\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\FilterResponseEvent), \'kernel.response\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(191): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.response\', Object(Symfony\\Component\\HttpKernel\\Event\\FilterResponseEvent))\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(173): Symfony\\Component\\HttpKernel\\HttpKernel->filterResponse(Object(Drupal\\Core\\Render\\HtmlResponse), Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#33 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(233,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547786),(234,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547787),(235,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547787),(236,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547787),(237,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538547787),(238,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547794),(239,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547794),(240,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4604926371_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/SmQ77vxQRMbmpXygwmILP1CLINkzVpL3Zv9LLt21hWE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547794),(241,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538547794),(242,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4812:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'views_view\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#14 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#17 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#27 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(243,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6245:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#24 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#27 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#37 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(244,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6123:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'pager\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'pager\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(95): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#36 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(245,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6254:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'feed_icon\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'feed_icon\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(123): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#24 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#27 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#37 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(246,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4688:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'container\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'container\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(247,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(248,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(249,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548197),(250,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(251,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(252,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6746:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#29 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#32 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#42 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(253,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6616:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'container\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'container\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(254,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6608:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(255,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6608:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(256,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5858:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#35 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(257,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(258,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(259,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548198),(260,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548199),(261,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548199),(262,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548199),(263,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548199),(264,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548210),(265,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548210),(266,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548210),(267,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548210),(268,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548210),(269,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548210),(270,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548210),(271,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548210),(272,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548219),(273,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548219),(274,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548219),(275,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548219),(276,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548220),(277,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548220),(278,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548220),(279,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548220),(280,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/admin','127.0.0.1',1538548228),(281,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/admin','127.0.0.1',1538548228),(282,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/admin','127.0.0.1',1538548228),(283,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/admin','127.0.0.1',1538548229),(284,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548229),(285,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548229),(286,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548229),(287,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548229),(288,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5019:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'views_view\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#14 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#17 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#28 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548243),(289,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6330:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'pager\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'pager\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(95): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#37 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548243),(290,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6461:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'feed_icon\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'feed_icon\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(123): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#24 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#27 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#38 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548243),(291,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4895:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'container\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'container\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#27 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548243),(292,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4628:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548243),(293,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5937:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#35 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548243),(294,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5965:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#35 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548244),(295,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4812:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'views_view\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#14 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#17 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#27 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(296,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6245:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#24 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#27 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#37 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(297,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6123:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'pager\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'pager\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(95): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#36 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(298,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6254:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'feed_icon\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'feed_icon\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_views-view.html.twig_DvYiNrJ32rkHu44NRQwzu6e3y/Mqgc9pSVn8rEs3-ujP3feudNUIWEESyZMMECCUhZjfE.php(123): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_d79be6a91d6cb87bf2dd4560cf9bff68dc775873ce45b89f996e64013ae1d297->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#24 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#26 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#27 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#37 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(299,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4688:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'container\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'container\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(300,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(301,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(302,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(303,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(304,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:8160:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(339): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 [internal function]: _toolbar_do_get_rendered_subtrees(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(\'_toolbar_do_get...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(309): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#19 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(367): toolbar_get_rendered_subtrees()\n#20 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(167): _toolbar_get_subtrees_hash()\n#21 [internal function]: toolbar_toolbar()\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'toolbar_toolbar\', Array)\n#23 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#24 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(305,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6746:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'menu__toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#11 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#29 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#32 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#42 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(306,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6616:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'container\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'container\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(307,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6608:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(308,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:6608:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/modules/toolbar/toolbar.module(93): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): template_preprocess_toolbar(Array, \'toolbar\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#20 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#28 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(309,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5858:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'toolbar\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'toolbar\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(87): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#22 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#25 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#35 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(310,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(311,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(312,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1538548873),(313,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:4421:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'html\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548873),(314,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5730:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'page\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548873),(315,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:5758:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'off_canvas_page...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'off_canvas_page...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb461e55f1c8_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/g4RnQUj1diYOLChAU7g6b216UIVu4Fw9HZOlx-hDkos.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#21 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#24 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#34 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548873),(316,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:12:\"User warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"The following theme is missing from the file system: timber\";}s:9:\"%function\";s:21:\"drupal_get_filename()\";s:5:\"%file\";s:53:\"/var/www/html/drupal8/web/core/includes/bootstrap.inc\";s:5:\"%line\";i:276;s:17:\"@backtrace_string\";s:2439:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#1 [internal function]: _drupal_error_handler(512, \'The following t...\', \'/var/www/html/d...\', 276, Array)\n#2 /var/www/html/drupal8/web/core/includes/bootstrap.inc(276): trigger_error(\'The following t...\', 512)\n#3 /var/www/html/drupal8/web/core/includes/bootstrap.inc(293): drupal_get_filename(\'theme\', \'timber\')\n#4 /var/www/html/drupal8/web/themes/custom/cowork/cowork.theme(161): drupal_get_path(\'theme\', \'timber\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): cowork_preprocess(Array, \'links\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'links\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(151): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(152): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(166): Drupal\\Core\\Render\\Renderer->renderPlain(Array)\n#12 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(696): Drupal\\Core\\Render\\Renderer->renderPlaceholder(\'callback=user.t...\', Array)\n#13 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(550): Drupal\\big_pipe\\Render\\BigPipe->renderPlaceholder(\'callback=user.t...\', Array)\n#14 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipe.php(305): Drupal\\big_pipe\\Render\\BigPipe->sendPlaceholders(Array, Array, Object(Drupal\\Core\\Asset\\AttachedAssets))\n#15 /var/www/html/drupal8/web/core/modules/big_pipe/src/Render/BigPipeResponse.php(112): Drupal\\big_pipe\\Render\\BigPipe->sendContent(Object(Drupal\\big_pipe\\Render\\BigPipeResponse))\n#16 /var/www/html/drupal8/vendor/symfony/http-foundation/Response.php(373): Drupal\\big_pipe\\Render\\BigPipeResponse->sendContent()\n#17 /var/www/html/drupal8/web/index.php(20): Symfony\\Component\\HttpFoundation\\Response->send()\n#18 {main}\";}',4,'','http://drupal-cms.com/','http://drupal-cms.com/','127.0.0.1',1538548873),(317,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:30:\"/themes/custom/cowork/logo.svg\";}',4,'','http://drupal-cms.com/themes/custom/cowork/logo.svg','http://drupal-cms.com/','127.0.0.1',1538551160),(318,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:30:\"/themes/custom/cowork/logo.svg\";}',4,'','http://drupal-cms.com/themes/custom/cowork/logo.svg','http://drupal-cms.com/','127.0.0.1',1538551164),(319,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:30:\"/themes/custom/cowork/logo.svg\";}',4,'','http://drupal-cms.com/themes/custom/cowork/logo.svg','http://drupal-cms.com/','127.0.0.1',1538551166),(320,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:30:\"/themes/custom/cowork/logo.svg\";}',4,'','http://drupal-cms.com/themes/custom/cowork/logo.svg','http://drupal-cms.com/','127.0.0.1',1538551166),(321,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:30:\"/themes/custom/cowork/logo.svg\";}',4,'','http://drupal-cms.com/themes/custom/cowork/logo.svg','http://drupal-cms.com/','127.0.0.1',1538551215),(322,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:30:\"/themes/custom/cowork/logo.svg\";}',4,'','http://drupal-cms.com/themes/custom/cowork/logo.svg','http://drupal-cms.com/','127.0.0.1',1538551227),(323,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538551233),(324,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538551233),(325,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538551233),(326,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538551233),(327,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538551233),(328,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538551233),(329,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538551569),(330,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538551569),(331,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538551569),(332,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538551569),(333,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538551569),(334,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538551569),(335,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555926),(336,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555949),(337,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555951),(338,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555951),(339,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555951),(340,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555952),(341,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555952),(342,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555952),(343,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555953),(344,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555954),(345,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555968),(346,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/yeJC3T87EflVXo5TRZBU3thCjr4wLGjmAO28LBmplA0.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/o9CjgnSvKADJcjvaFFORiEMz_cQmWEXnVkm11PD7fPk.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb480161f017_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/NU1in8YUMI_xggyYH6J1TRIha-8e-HKksdIuVv84BCE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538555969),(347,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538556218),(348,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538556218),(349,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538556218),(350,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538556218),(351,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538556218),(352,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538556218),(353,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7824:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/0DU9mpW0QYnI882Gwp2WVE1eaSTeKZR5bWvSPqqzScY.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/dTP85qrcYgxz29fHYmXJxLecwQU1XuzMBjY0N_--EC0.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/Af9tXaKyQdf-SztJesbC3S6i5mugDzxIyWiLLb0kOtE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#46 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556284),(354,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/0DU9mpW0QYnI882Gwp2WVE1eaSTeKZR5bWvSPqqzScY.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/dTP85qrcYgxz29fHYmXJxLecwQU1XuzMBjY0N_--EC0.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/Af9tXaKyQdf-SztJesbC3S6i5mugDzxIyWiLLb0kOtE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556648),(355,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/0DU9mpW0QYnI882Gwp2WVE1eaSTeKZR5bWvSPqqzScY.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/dTP85qrcYgxz29fHYmXJxLecwQU1XuzMBjY0N_--EC0.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/Af9tXaKyQdf-SztJesbC3S6i5mugDzxIyWiLLb0kOtE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556866),(356,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/0DU9mpW0QYnI882Gwp2WVE1eaSTeKZR5bWvSPqqzScY.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/dTP85qrcYgxz29fHYmXJxLecwQU1XuzMBjY0N_--EC0.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb4817bb1f38_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/Af9tXaKyQdf-SztJesbC3S6i5mugDzxIyWiLLb0kOtE.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556911),(357,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556968),(358,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556979),(359,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556988),(360,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538556991),(361,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538557190),(362,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538557215),(363,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538557216),(364,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Loader\";s:8:\"@message\";s:139:\"Template \"block--bare.html.twig\" is not defined in \"themes/custom/cowork/templates/block/block--system-branding-block.html.twig\" at line 1.\";s:9:\"%function\";s:32:\"Twig_Loader_Chain->getCacheKey()\";s:5:\"%file\";s:64:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Loader/Chain.php\";s:5:\"%line\";i:129;s:17:\"@backtrace_string\";s:7617:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigEnvironment.php(140): Twig_Loader_Chain->getCacheKey(\'block--bare.htm...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(424): Drupal\\Core\\Template\\TwigEnvironment->getTemplateClass(\'block--bare.htm...\')\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(366): Twig_Environment->loadTemplate(\'block--bare.htm...\', NULL)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_block--system-branding-bl_Eyr2gZqFdJt9Ly_ycdfy_CHza/TsVwDnHBnLwjrpZrnAwetMBKQGbAXe090Cj45h8lc5Q.php(11): Twig_Template->loadTemplate(\'block--bare.htm...\', \'themes/custom/c...\', 1)\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(487): __TwigTemplate_28d6b1b6fd8da0b6e8f5df92ae1698dbbd5105bd9ee3c0c5f5ccf3be3a74ede2->__construct(Object(Drupal\\Core\\Template\\TwigEnvironment))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/c...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_page--front.html.twig_I-zV7frzNK9QH0qUP2QO94ruj/SmFhomv_-Sy1_v6IVQUaceF_aSc3FZ6-W7WEymCMD08.php(49): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_aab6376c3a003cc6e7b1ae2337d1f046396b68f7236d9bc257caa65883f67729->doDisplay(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#15 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bb48426b5b0a_html.html.twig_UlEh7F0OD6TvLzbzw30UPfFSs/e9VwQuujUaF9yChtRayG3RrtJFNILLCXb3q0OktcbCs.php(91): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_3ec3fc26b3364af5b5a0a71f310cbbfa36f39dd228ccd8c664dd374618831dcc->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/c...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#32 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#34 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#35 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#45 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1538557364),(365,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538557532),(366,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538557532),(367,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538557532),(368,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538557532),(369,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538557532),(370,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538557532),(371,1,'system','%theme theme installed.',_binary 'a:1:{s:6:\"%theme\";s:6:\"cowork\";}',6,'','http://drupal-cms.com/admin/appearance/default?theme=cowork&token=MnWAo9_MDNxto1I3Lh0mK-nC30HOn1jITFYTgEbW05E','http://drupal-cms.com/admin/appearance','127.0.0.1',1538558064),(372,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:41:\"Drupal\\Core\\Entity\\EntityStorageException\";s:8:\"@message\";s:54:\"\'block\' entity with ID \'cowork_footer\' already exists.\";s:9:\"%function\";s:49:\"Drupal\\Core\\Entity\\EntityStorageBase->doPreSave()\";s:5:\"%file\";s:75:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php\";s:5:\"%line\";i:462;s:17:\"@backtrace_string\";s:4507:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(426): Drupal\\Core\\Entity\\EntityStorageBase->doPreSave(Object(Drupal\\block\\Entity\\Block))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(263): Drupal\\Core\\Entity\\EntityStorageBase->save(Object(Drupal\\block\\Entity\\Block))\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/Entity.php(390): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->save(Object(Drupal\\block\\Entity\\Block))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityBase.php(632): Drupal\\Core\\Entity\\Entity->save()\n#4 /var/www/html/drupal8/web/core/modules/block/block.module(130): Drupal\\Core\\Config\\Entity\\ConfigEntityBase->save()\n#5 /var/www/html/drupal8/web/core/modules/block/block.module(93): block_theme_initialize(\'cowork\')\n#6 [internal function]: block_themes_installed(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'block_themes_in...\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ThemeInstaller.php(211): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'themes_installe...\', Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ThemeHandler.php(166): Drupal\\Core\\Extension\\ThemeInstaller->install(Array, true)\n#10 /var/www/html/drupal8/web/core/modules/system/src/Controller/ThemeController.php(162): Drupal\\Core\\Extension\\ThemeHandler->install(Array)\n#11 [internal function]: Drupal\\system\\Controller\\ThemeController->setDefaultTheme(Object(Symfony\\Component\\HttpFoundation\\Request))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#17 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#27 {main}\";}',3,'','http://drupal-cms.com/admin/appearance/default?theme=cowork&token=MnWAo9_MDNxto1I3Lh0mK-nC30HOn1jITFYTgEbW05E','http://drupal-cms.com/admin/appearance','127.0.0.1',1538558065),(373,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538558159),(374,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538558159),(375,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538558159),(376,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538558159),(377,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538558159),(378,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538558159),(379,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538558343),(380,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538558344),(381,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538558344),(382,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538558344),(383,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538558344),(384,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538558344),(385,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538558367),(386,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538558367),(387,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538558367),(388,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538558367),(389,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538558367),(390,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538558367),(391,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538558574),(392,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(393,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"16.22ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(394,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:6:\"8.75ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(395,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"12.58ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(396,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"35.69ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(397,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.38ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(398,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"14.71ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(399,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"5.16ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(400,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"31.58ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558574),(401,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"1034.69ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558575),(402,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538558575),(403,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538558909),(404,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538558909),(405,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538558909),(406,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538558909),(407,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538558909),(408,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538558909),(409,1,'menu_link_content','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:16:\"custom menu link\";s:6:\"%label\";s:4:\"Home\";}',5,'','http://drupal-cms.com/admin/structure/menu/item/1/delete?destination=%2Fadmin%2Fstructure%2Fmenu','http://drupal-cms.com/admin/structure/menu/item/1/delete?destination=/admin/structure/menu','127.0.0.1',1538560507),(410,1,'menu','Menu %label has been updated.',_binary 'a:1:{s:6:\"%label\";s:15:\"Main navigation\";}',5,'<a href=\"/admin/structure/menu/manage/main\">Edit</a>','http://drupal-cms.com/admin/structure/menu/manage/main?destination=%2Fadmin%2Fstructure%2Fmenu','http://drupal-cms.com/admin/structure/menu/manage/main?destination=/admin/structure/menu','127.0.0.1',1538560530),(411,1,'menu','Menu %label has been updated.',_binary 'a:1:{s:6:\"%label\";s:15:\"Main navigation\";}',5,'<a href=\"/admin/structure/menu/manage/main\">Edit</a>','http://drupal-cms.com/admin/structure/menu/manage/main?destination=%2Fadmin%2Fstructure%2Fmenu','http://drupal-cms.com/admin/structure/menu/manage/main?destination=/admin/structure/menu','127.0.0.1',1538560536),(412,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538560638),(413,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538560638),(414,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538560638),(415,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538560638),(416,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538560638),(417,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538560638),(418,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538560655),(419,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538560655),(420,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538560655),(421,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538560655),(422,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538560655),(423,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538560655),(424,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538560856),(425,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538560856),(426,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538560856),(427,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538560856),(428,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538560856),(429,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538560856),(430,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538561273),(431,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538561273),(432,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538561273),(433,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538561273),(434,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538561273),(435,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538561273),(436,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538561552),(437,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538561553),(438,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538561553),(439,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538561553),(440,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538561553),(441,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538561553),(442,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538562179),(443,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538562179),(444,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538562179),(445,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538562179),(446,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538562179),(447,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538562179),(448,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538562292),(449,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538562292),(450,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538562292),(451,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538562292),(452,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538562292),(453,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538562292),(454,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538562484),(455,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538562484),(456,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538562484),(457,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538562484),(458,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538562484),(459,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538562484),(460,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538563746),(461,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538563746),(462,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538563746),(463,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538563746),(464,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538563746),(465,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538563746),(466,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538563898),(467,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538563898),(468,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538563899),(469,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538563899),(470,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538563899),(471,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538563899),(472,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538564035),(473,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538564035),(474,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538564035),(475,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538564035),(476,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538564035),(477,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538564035),(478,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538564090),(479,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538564090),(480,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538564090),(481,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538564090),(482,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538564090),(483,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538564090),(484,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538564150),(485,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538564150),(486,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538564150),(487,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538564150),(488,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538564150),(489,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538564150),(490,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538564235),(491,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538564235),(492,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538564235),(493,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538564235),(494,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538564235),(495,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538564235),(496,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:17:\"Social Media Link\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538564567),(497,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:17:\"Social Media Link\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/socialmedialink/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/socialmedialink/delete?destination=/admin/structure/block','127.0.0.1',1538564680),(498,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538564708),(499,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538564708),(500,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538564708),(501,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538564708),(502,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538564708),(503,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538564977),(504,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538564977),(505,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538564977),(506,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538564977),(507,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538564977),(508,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538564977),(509,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538565040),(510,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538565041),(511,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538565041),(512,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538565041),(513,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538565041),(514,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538565041),(515,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/block/images/about_4.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(516,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/block/images/about_2.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(517,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/block/images/about_3.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(518,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(519,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"16.17ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(520,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"10.03ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(521,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"10.33ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(522,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"22.34ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(523,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.47ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(524,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"17.24ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(525,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:5:\"4.5ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(526,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"43.09ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569399),(527,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"868.98ms\";}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569400),(528,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/block/images/about_1.jpg','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569400),(529,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:15:\"What is Cowork?\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1538569412),(530,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538570981),(531,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538570981),(532,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538570981),(533,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538570981),(534,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538570981),(535,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538570981),(536,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538573163),(537,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538573163),(538,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538573163),(539,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538573163),(540,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538573163),(541,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538573163),(542,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538573224),(543,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538573224),(544,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538573224),(545,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538573224),(546,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538573224),(547,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538573224),(548,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1538573330),(549,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1538573330),(550,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1538573330),(551,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1538573330),(552,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1538573330),(553,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1538573330),(554,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:15:\"What is Cowork?\";}',5,'','http://drupal-cms.com/block/4?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/4?destination=/admin/structure/block/block-content','127.0.0.1',1538573658),(555,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:15:\"What is Cowork?\";}',5,'','http://drupal-cms.com/block/4?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/4?destination=/admin/structure/block/block-content','127.0.0.1',1538573979),(556,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(557,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"15.35ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(558,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"15.98ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(559,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"9.25ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(560,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:8:\"106.01ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(561,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"7.81ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(562,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"22.45ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(563,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"25.16ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(564,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"53.04ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(565,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"120.53ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(566,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1538629209),(567,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/cowork/css/micons/micons.css','http://drupal-cms.com/','127.0.0.1',1538979898),(568,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(569,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"67.93ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(570,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"25.74ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(571,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"39.25ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(572,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"95.44ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(573,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:7:\"15.74ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(574,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"66.09ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(575,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"57.79ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(576,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:8:\"142.72ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979898),(577,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"2973.49ms\";}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979901),(578,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/themes/custom/cowork/css/font-awesome/css/fontawesome-all.css','http://drupal-cms.com/','127.0.0.1',1538979901),(579,0,'user','Login attempt failed for %user.',_binary 'a:1:{s:5:\"%user\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1538979919),(580,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1538979922),(581,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:6:\"twilio\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1538982674),(582,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:39:\"Invalid argument supplied for foreach()\";}s:9:\"%function\";s:54:\"Drupal\\Core\\Render\\Element\\Checkboxes::valueCallback()\";s:5:\"%file\";s:76:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Element/Checkboxes.php\";s:5:\"%line\";i:100;s:17:\"@backtrace_string\";s:4737:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'Invalid argumen...\', \'/var/www/html/d...\', 100, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Element/Checkboxes.php(100): _drupal_error_handler(2, \'Invalid argumen...\', \'/var/www/html/d...\', 100, Array)\n#2 [internal function]: Drupal\\Core\\Render\\Element\\Checkboxes::valueCallback(Array, false, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1273): call_user_func_array(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(990): Drupal\\Core\\Form\\FormBuilder->handleInputElement(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(561): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_fo...\', Object(Drupal\\Core\\Form\\FormState))\n#10 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/twilio','','127.0.0.1',1538982889),(583,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:58:\"array_filter() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:61:\"Drupal\\twilio\\Controller\\TwilioController::countryDialCodes()\";s:5:\"%file\";s:84:\"/var/www/html/drupal8/web/modules/contrib/twilio/src/Controller/TwilioController.php\";s:5:\"%line\";i:342;s:17:\"@backtrace_string\";s:4181:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_filter() ...\', \'/var/www/html/d...\', 342, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_filter() ...\', \'/var/www/html/d...\', 342, Array)\n#2 /var/www/html/drupal8/web/modules/contrib/twilio/src/Controller/TwilioController.php(342): array_filter(NULL)\n#3 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(53): Drupal\\twilio\\Controller\\TwilioController::countryDialCodes(false)\n#4 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#8 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio','127.0.0.1',1538983432),(584,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:39:\"Invalid argument supplied for foreach()\";}s:9:\"%function\";s:54:\"Drupal\\Core\\Render\\Element\\Checkboxes::valueCallback()\";s:5:\"%file\";s:76:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Element/Checkboxes.php\";s:5:\"%line\";i:100;s:17:\"@backtrace_string\";s:4737:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'Invalid argumen...\', \'/var/www/html/d...\', 100, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Element/Checkboxes.php(100): _drupal_error_handler(2, \'Invalid argumen...\', \'/var/www/html/d...\', 100, Array)\n#2 [internal function]: Drupal\\Core\\Render\\Element\\Checkboxes::valueCallback(Array, false, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1273): call_user_func_array(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(990): Drupal\\Core\\Form\\FormBuilder->handleInputElement(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(561): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_fo...\', Object(Drupal\\Core\\Form\\FormState))\n#10 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/twilio','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538983436);
INSERT INTO `watchdog` VALUES (585,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:61:\"Use of undefined constant CURLOPT_URL - assumed \'CURLOPT_URL\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(111): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(586,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:67:\"Use of undefined constant CURLOPT_HEADER - assumed \'CURLOPT_HEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:112;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(112): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(587,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:83:\"Use of undefined constant CURLOPT_RETURNTRANSFER - assumed \'CURLOPT_RETURNTRANSFER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:113;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(113): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(588,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_INFILESIZE - assumed \'CURLOPT_INFILESIZE\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(114): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(589,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:115;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(115): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(590,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:69:\"Use of undefined constant CURLOPT_TIMEOUT - assumed \'CURLOPT_TIMEOUT\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(116): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(591,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(592,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(593,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(594,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(595,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:124;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(124): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(596,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:63:\"Use of undefined constant CURLOPT_POST - assumed \'CURLOPT_POST\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:137;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(137): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(597,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_POSTFIELDS - assumed \'CURLOPT_POSTFIELDS\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:138;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(138): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(598,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:50:\"Call to undefined function Twilio\\Http\\curl_init()\";s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->request()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:32;s:17:\"@backtrace_string\";s:5217:\"#0 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#5 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#6 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#7 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#13 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#18 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#29 {main}\";}',3,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538988957),(599,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:10:\"/info.phph\";}',4,'','http://drupal-cms.com/info.phph','','127.0.0.1',1538989002),(600,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:9:\"/info.php\";}',4,'','http://drupal-cms.com/info.php','','127.0.0.1',1538989004),(601,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:61:\"Use of undefined constant CURLOPT_URL - assumed \'CURLOPT_URL\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(111): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(602,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:67:\"Use of undefined constant CURLOPT_HEADER - assumed \'CURLOPT_HEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:112;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(112): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(603,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:83:\"Use of undefined constant CURLOPT_RETURNTRANSFER - assumed \'CURLOPT_RETURNTRANSFER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:113;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(113): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(604,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_INFILESIZE - assumed \'CURLOPT_INFILESIZE\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(114): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(605,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:115;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(115): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(606,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:69:\"Use of undefined constant CURLOPT_TIMEOUT - assumed \'CURLOPT_TIMEOUT\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(116): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(607,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(608,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(609,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(610,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(611,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:124;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(124): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(612,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:63:\"Use of undefined constant CURLOPT_POST - assumed \'CURLOPT_POST\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:137;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(137): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(613,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_POSTFIELDS - assumed \'CURLOPT_POSTFIELDS\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:138;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(138): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(614,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:50:\"Call to undefined function Twilio\\Http\\curl_init()\";s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->request()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:32;s:17:\"@backtrace_string\";s:5217:\"#0 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#5 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#6 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#7 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#13 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#18 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#29 {main}\";}',3,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538989572),(615,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:61:\"Use of undefined constant CURLOPT_URL - assumed \'CURLOPT_URL\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(111): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(616,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:67:\"Use of undefined constant CURLOPT_HEADER - assumed \'CURLOPT_HEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:112;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(112): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(617,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:83:\"Use of undefined constant CURLOPT_RETURNTRANSFER - assumed \'CURLOPT_RETURNTRANSFER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:113;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(113): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(618,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_INFILESIZE - assumed \'CURLOPT_INFILESIZE\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(114): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(619,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:115;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(115): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(620,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:69:\"Use of undefined constant CURLOPT_TIMEOUT - assumed \'CURLOPT_TIMEOUT\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(116): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(621,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(622,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(623,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(624,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(625,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:124;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(124): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(626,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:63:\"Use of undefined constant CURLOPT_POST - assumed \'CURLOPT_POST\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:137;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(137): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(627,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_POSTFIELDS - assumed \'CURLOPT_POSTFIELDS\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:138;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(138): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(628,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:50:\"Call to undefined function Twilio\\Http\\curl_init()\";s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->request()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:32;s:17:\"@backtrace_string\";s:5217:\"#0 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#5 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#6 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#7 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#13 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#18 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#29 {main}\";}',3,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538990438),(629,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(630,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"16.17ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(631,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:6:\"1.35ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(632,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"1.71ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(633,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:6:\"6.19ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(634,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.35ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(635,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"16.91ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(636,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"7.94ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(637,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"65.57ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(638,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:5:\"2.6ms\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(639,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','','127.0.0.1',1538991691),(640,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:61:\"Use of undefined constant CURLOPT_URL - assumed \'CURLOPT_URL\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(111): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(641,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:67:\"Use of undefined constant CURLOPT_HEADER - assumed \'CURLOPT_HEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:112;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(112): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(642,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:83:\"Use of undefined constant CURLOPT_RETURNTRANSFER - assumed \'CURLOPT_RETURNTRANSFER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:113;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(113): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(643,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_INFILESIZE - assumed \'CURLOPT_INFILESIZE\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(114): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(644,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:115;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(115): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(645,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:69:\"Use of undefined constant CURLOPT_TIMEOUT - assumed \'CURLOPT_TIMEOUT\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(116): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(646,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(647,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(648,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(649,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(650,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:124;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(124): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(651,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:63:\"Use of undefined constant CURLOPT_POST - assumed \'CURLOPT_POST\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:137;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(137): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(652,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_POSTFIELDS - assumed \'CURLOPT_POSTFIELDS\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:138;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(138): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(653,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:50:\"Call to undefined function Twilio\\Http\\curl_init()\";s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->request()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:32;s:17:\"@backtrace_string\";s:5217:\"#0 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#5 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#6 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#7 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#13 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#18 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#29 {main}\";}',3,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538991697),(654,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:61:\"Use of undefined constant CURLOPT_URL - assumed \'CURLOPT_URL\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(111): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(655,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:67:\"Use of undefined constant CURLOPT_HEADER - assumed \'CURLOPT_HEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:112;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(112): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(656,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:83:\"Use of undefined constant CURLOPT_RETURNTRANSFER - assumed \'CURLOPT_RETURNTRANSFER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:113;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(113): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(657,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_INFILESIZE - assumed \'CURLOPT_INFILESIZE\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(114): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(658,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:115;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(115): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(659,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:69:\"Use of undefined constant CURLOPT_TIMEOUT - assumed \'CURLOPT_TIMEOUT\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(116): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(660,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(661,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(662,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(663,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(664,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:124;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(124): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(665,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:63:\"Use of undefined constant CURLOPT_POST - assumed \'CURLOPT_POST\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:137;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(137): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(666,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_POSTFIELDS - assumed \'CURLOPT_POSTFIELDS\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:138;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(138): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(667,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:50:\"Call to undefined function Twilio\\Http\\curl_init()\";s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->request()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:32;s:17:\"@backtrace_string\";s:5217:\"#0 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#5 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#6 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#7 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#13 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#18 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#29 {main}\";}',3,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538994006),(668,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:61:\"Use of undefined constant CURLOPT_URL - assumed \'CURLOPT_URL\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(111): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(669,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:67:\"Use of undefined constant CURLOPT_HEADER - assumed \'CURLOPT_HEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:112;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(112): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(670,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:83:\"Use of undefined constant CURLOPT_RETURNTRANSFER - assumed \'CURLOPT_RETURNTRANSFER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:113;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(113): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(671,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_INFILESIZE - assumed \'CURLOPT_INFILESIZE\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(114): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(672,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:115;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(115): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(673,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:69:\"Use of undefined constant CURLOPT_TIMEOUT - assumed \'CURLOPT_TIMEOUT\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(116): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(674,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(675,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(676,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(677,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(678,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:124;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(124): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(679,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:63:\"Use of undefined constant CURLOPT_POST - assumed \'CURLOPT_POST\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:137;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(137): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(680,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_POSTFIELDS - assumed \'CURLOPT_POSTFIELDS\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:138;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(138): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(681,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:50:\"Call to undefined function Twilio\\Http\\curl_init()\";s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->request()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:32;s:17:\"@backtrace_string\";s:5217:\"#0 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#5 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#6 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#7 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#13 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#18 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#29 {main}\";}',3,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538995888),(682,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:61:\"Use of undefined constant CURLOPT_URL - assumed \'CURLOPT_URL\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(111): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(683,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:67:\"Use of undefined constant CURLOPT_HEADER - assumed \'CURLOPT_HEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:112;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(112): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 112, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(684,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:83:\"Use of undefined constant CURLOPT_RETURNTRANSFER - assumed \'CURLOPT_RETURNTRANSFER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:113;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(113): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 113, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(685,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_INFILESIZE - assumed \'CURLOPT_INFILESIZE\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(114): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(686,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:115;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(115): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 115, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(687,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:69:\"Use of undefined constant CURLOPT_TIMEOUT - assumed \'CURLOPT_TIMEOUT\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:116;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(116): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 116, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(688,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(689,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(690,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(691,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:120;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(120): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 120, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(692,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_HTTPHEADER - assumed \'CURLOPT_HTTPHEADER\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:124;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(124): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 124, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(693,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:63:\"Use of undefined constant CURLOPT_POST - assumed \'CURLOPT_POST\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:137;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(137): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 137, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(694,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:75:\"Use of undefined constant CURLOPT_POSTFIELDS - assumed \'CURLOPT_POSTFIELDS\'\";}s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->options()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:138;s:17:\"@backtrace_string\";s:5732:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(138): _drupal_error_handler(8, \'Use of undefine...\', \'/var/www/html/d...\', 138, Array)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php(26): Twilio\\Http\\CurlClient->options(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', 60)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#5 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#6 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#7 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#8 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#9 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#10 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#16 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#32 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(695,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:50:\"Call to undefined function Twilio\\Http\\curl_init()\";s:9:\"%function\";s:33:\"Twilio\\Http\\CurlClient->request()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twilio/sdk/Twilio/Http/CurlClient.php\";s:5:\"%line\";i:32;s:17:\"@backtrace_string\";s:5217:\"#0 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Client.php(211): Twilio\\Http\\CurlClient->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#1 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Domain.php(69): Twilio\\Rest\\Client->request(\'POST\', \'https://api.twi...\', Array, Array, Array, \'AC71eaf0485a204...\', \'9f5e3a3291273ac...\', NULL)\n#2 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(63): Twilio\\Domain->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#3 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Version.php(215): Twilio\\Version->request(\'POST\', \'2010-04-01/Acco...\', Array, Array, Array, NULL, NULL, NULL)\n#4 /var/www/html/drupal8/vendor/twilio/sdk/Twilio/Rest/Api/V2010/Account/MessageList.php(69): Twilio\\Version->create(\'POST\', \'/Accounts/AC71e...\', Array, Array)\n#5 /var/www/html/drupal8/web/modules/contrib/twilio/src/Services/Command.php(94): Twilio\\Rest\\Api\\V2010\\Account\\MessageList->create(\'8882426915\', Object(Twilio\\Values))\n#6 /var/www/html/drupal8/web/modules/contrib/twilio/src/Form/TwilioAdminTestForm.php(102): Drupal\\twilio\\Services\\Command->messageSend(\'8882426915\', Array)\n#7 [internal function]: Drupal\\twilio\\Form\\TwilioAdminTestForm->submitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'twilio_admin_te...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'twilio_admin_te...\', Object(Drupal\\Core\\Form\\FormState))\n#13 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#18 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#19 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#29 {main}\";}',3,'','http://drupal-cms.com/admin/config/system/twilio/test','http://drupal-cms.com/admin/config/system/twilio/test','127.0.0.1',1538999063),(696,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(697,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"32.15ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(698,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"20.22ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(699,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"16.32ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(700,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"19.85ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(701,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"8.21ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(702,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"31.24ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(703,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"23.48ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(704,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"60.19ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004826),(705,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"156.12ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004827),(706,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539004827),(707,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(708,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"18.05ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(709,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"28.01ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(710,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"25.38ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(711,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"34.81ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(712,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:7:\"42.54ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(713,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"72.48ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(714,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"54.24ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(715,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"72.04ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064237),(716,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"474.29ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064238),(717,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539064238),(718,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(719,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"14.87ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(720,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:6:\"1.08ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(721,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"1.66ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(722,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:6:\"6.31ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(723,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.41ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(724,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"18.08ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(725,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"10.46ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(726,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"30.54ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086804),(727,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"2920.3ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086807),(728,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539086807),(729,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(730,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"17.88ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(731,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:5:\"1.3ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(732,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:5:\"7.7ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(733,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"45.41ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(734,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.51ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(735,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"79.19ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(736,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"26.06ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(737,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:4:\"58ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239667),(738,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/','','127.0.0.1',1539239669),(739,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/contextual/render','http://drupal-cms.com/','127.0.0.1',1539239669),(740,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"3224.85ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239670),(741,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539239670),(742,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:10:\"ga_reports\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1539240147),(743,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:131:\"unlink(/var/www/html/drupal8/web/sites/default/files/css/css_1Vs-se15DhDFHRhxIEwgG9PQN6dfdJOpBMSoiTWSv9Q.css.gz): Permission denied\";}s:9:\"%function\";s:37:\"Drupal\\Core\\File\\FileSystem->unlink()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5060:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'/var/www/html/d...\')\n#3 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'/var/www/html/d...\', NULL)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StreamWrapper/LocalStream.php(377): drupal_unlink(\'/var/www/html/d...\')\n#5 [internal function]: Drupal\\Core\\StreamWrapper\\LocalStream->unlink(\'public://css/cs...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'public://css/cs...\')\n#7 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'public://css/cs...\', NULL)\n#8 /var/www/html/drupal8/web/core/includes/file.inc(864): drupal_unlink(\'public://css/cs...\')\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/CssCollectionOptimizer.php(181): file_unmanaged_delete(\'public://css/cs...\')\n#10 /var/www/html/drupal8/web/core/includes/file.inc(1074): Drupal\\Core\\Asset\\CssCollectionOptimizer->Drupal\\Core\\Asset\\{closure}(\'public://css/cs...\')\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/CssCollectionOptimizer.php(184): file_scan_directory(\'public://css\', \'/.*/\', Array)\n#12 /var/www/html/drupal8/web/core/includes/common.inc(1108): Drupal\\Core\\Asset\\CssCollectionOptimizer->deleteAll()\n#13 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/GaReports.php(167): drupal_flush_all_caches()\n#14 /var/www/html/drupal8/web/core/includes/batch.inc(456): Drupal\\ga_reports\\GaReports::importFieldsFinished(true, Array, Array, \'8 sec\')\n#15 /var/www/html/drupal8/web/core/includes/batch.inc(98): _batch_finished()\n#16 /var/www/html/drupal8/web/core/modules/system/src/Controller/BatchController.php(55): _batch_page(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 [internal function]: Drupal\\system\\Controller\\BatchController->batchPage(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#33 {main}\";}',4,'','http://drupal-cms.com/batch?id=4&op=do_nojs&op=finished','http://drupal-cms.com/batch?id=4&op=start','127.0.0.1',1539240164),(744,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:128:\"unlink(/var/www/html/drupal8/web/sites/default/files/css/css_1Vs-se15DhDFHRhxIEwgG9PQN6dfdJOpBMSoiTWSv9Q.css): Permission denied\";}s:9:\"%function\";s:37:\"Drupal\\Core\\File\\FileSystem->unlink()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5060:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'/var/www/html/d...\')\n#3 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'/var/www/html/d...\', NULL)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StreamWrapper/LocalStream.php(377): drupal_unlink(\'/var/www/html/d...\')\n#5 [internal function]: Drupal\\Core\\StreamWrapper\\LocalStream->unlink(\'public://css/cs...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'public://css/cs...\')\n#7 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'public://css/cs...\', NULL)\n#8 /var/www/html/drupal8/web/core/includes/file.inc(864): drupal_unlink(\'public://css/cs...\')\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/CssCollectionOptimizer.php(181): file_unmanaged_delete(\'public://css/cs...\')\n#10 /var/www/html/drupal8/web/core/includes/file.inc(1074): Drupal\\Core\\Asset\\CssCollectionOptimizer->Drupal\\Core\\Asset\\{closure}(\'public://css/cs...\')\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/CssCollectionOptimizer.php(184): file_scan_directory(\'public://css\', \'/.*/\', Array)\n#12 /var/www/html/drupal8/web/core/includes/common.inc(1108): Drupal\\Core\\Asset\\CssCollectionOptimizer->deleteAll()\n#13 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/GaReports.php(167): drupal_flush_all_caches()\n#14 /var/www/html/drupal8/web/core/includes/batch.inc(456): Drupal\\ga_reports\\GaReports::importFieldsFinished(true, Array, Array, \'8 sec\')\n#15 /var/www/html/drupal8/web/core/includes/batch.inc(98): _batch_finished()\n#16 /var/www/html/drupal8/web/core/modules/system/src/Controller/BatchController.php(55): _batch_page(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 [internal function]: Drupal\\system\\Controller\\BatchController->batchPage(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#33 {main}\";}',4,'','http://drupal-cms.com/batch?id=4&op=do_nojs&op=finished','http://drupal-cms.com/batch?id=4&op=start','127.0.0.1',1539240164),(745,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:128:\"unlink(/var/www/html/drupal8/web/sites/default/files/js/js_GIlDG7cVFq0_v_SESToXsOYafNxrX_a6mLEUXX-9K8A.js.gz): Permission denied\";}s:9:\"%function\";s:37:\"Drupal\\Core\\File\\FileSystem->unlink()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5055:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'/var/www/html/d...\')\n#3 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'/var/www/html/d...\', NULL)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StreamWrapper/LocalStream.php(377): drupal_unlink(\'/var/www/html/d...\')\n#5 [internal function]: Drupal\\Core\\StreamWrapper\\LocalStream->unlink(\'public://js/js_...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'public://js/js_...\')\n#7 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'public://js/js_...\', NULL)\n#8 /var/www/html/drupal8/web/core/includes/file.inc(864): drupal_unlink(\'public://js/js_...\')\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/JsCollectionOptimizer.php(183): file_unmanaged_delete(\'public://js/js_...\')\n#10 /var/www/html/drupal8/web/core/includes/file.inc(1074): Drupal\\Core\\Asset\\JsCollectionOptimizer->Drupal\\Core\\Asset\\{closure}(\'public://js/js_...\')\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/JsCollectionOptimizer.php(186): file_scan_directory(\'public://js\', \'/.*/\', Array)\n#12 /var/www/html/drupal8/web/core/includes/common.inc(1109): Drupal\\Core\\Asset\\JsCollectionOptimizer->deleteAll()\n#13 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/GaReports.php(167): drupal_flush_all_caches()\n#14 /var/www/html/drupal8/web/core/includes/batch.inc(456): Drupal\\ga_reports\\GaReports::importFieldsFinished(true, Array, Array, \'8 sec\')\n#15 /var/www/html/drupal8/web/core/includes/batch.inc(98): _batch_finished()\n#16 /var/www/html/drupal8/web/core/modules/system/src/Controller/BatchController.php(55): _batch_page(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 [internal function]: Drupal\\system\\Controller\\BatchController->batchPage(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#33 {main}\";}',4,'','http://drupal-cms.com/batch?id=4&op=do_nojs&op=finished','http://drupal-cms.com/batch?id=4&op=start','127.0.0.1',1539240164),(746,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:125:\"unlink(/var/www/html/drupal8/web/sites/default/files/js/js_GIlDG7cVFq0_v_SESToXsOYafNxrX_a6mLEUXX-9K8A.js): Permission denied\";}s:9:\"%function\";s:37:\"Drupal\\Core\\File\\FileSystem->unlink()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php\";s:5:\"%line\";i:114;s:17:\"@backtrace_string\";s:5055:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#1 [internal function]: _drupal_error_handler(2, \'unlink(/var/www...\', \'/var/www/html/d...\', 114, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'/var/www/html/d...\')\n#3 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'/var/www/html/d...\', NULL)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StreamWrapper/LocalStream.php(377): drupal_unlink(\'/var/www/html/d...\')\n#5 [internal function]: Drupal\\Core\\StreamWrapper\\LocalStream->unlink(\'public://js/js_...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/File/FileSystem.php(114): unlink(\'public://js/js_...\')\n#7 /var/www/html/drupal8/web/core/includes/file.inc(1135): Drupal\\Core\\File\\FileSystem->unlink(\'public://js/js_...\', NULL)\n#8 /var/www/html/drupal8/web/core/includes/file.inc(864): drupal_unlink(\'public://js/js_...\')\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/JsCollectionOptimizer.php(183): file_unmanaged_delete(\'public://js/js_...\')\n#10 /var/www/html/drupal8/web/core/includes/file.inc(1074): Drupal\\Core\\Asset\\JsCollectionOptimizer->Drupal\\Core\\Asset\\{closure}(\'public://js/js_...\')\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Asset/JsCollectionOptimizer.php(186): file_scan_directory(\'public://js\', \'/.*/\', Array)\n#12 /var/www/html/drupal8/web/core/includes/common.inc(1109): Drupal\\Core\\Asset\\JsCollectionOptimizer->deleteAll()\n#13 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/GaReports.php(167): drupal_flush_all_caches()\n#14 /var/www/html/drupal8/web/core/includes/batch.inc(456): Drupal\\ga_reports\\GaReports::importFieldsFinished(true, Array, Array, \'8 sec\')\n#15 /var/www/html/drupal8/web/core/includes/batch.inc(98): _batch_finished()\n#16 /var/www/html/drupal8/web/core/modules/system/src/Controller/BatchController.php(55): _batch_page(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 [internal function]: Drupal\\system\\Controller\\BatchController->batchPage(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#33 {main}\";}',4,'','http://drupal-cms.com/batch?id=4&op=do_nojs&op=finished','http://drupal-cms.com/batch?id=4&op=start','127.0.0.1',1539240164),(747,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:65:\"htmlspecialchars() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:39:\"Drupal\\Component\\Utility\\Html::escape()\";s:5:\"%file\";s:68:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Html.php\";s:5:\"%line\";i:424;s:17:\"@backtrace_string\";s:6965:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'htmlspecialchar...\', \'/var/www/html/d...\', 424, Array)\n#1 [internal function]: _drupal_error_handler(2, \'htmlspecialchar...\', \'/var/www/html/d...\', 424, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Html.php(424): htmlspecialchars(Object(Drupal\\Core\\Link), 11, \'UTF-8\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php(265): Drupal\\Component\\Utility\\Html::escape(Object(Drupal\\Core\\Link))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php(206): Drupal\\Component\\Render\\FormattableMarkup::placeholderEscape(Object(Drupal\\Core\\Link))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StringTranslation/TranslatableMarkup.php(195): Drupal\\Component\\Render\\FormattableMarkup::placeholderFormat(\'You must @link ...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/ToStringTrait.php(15): Drupal\\Core\\StringTranslation\\TranslatableMarkup->render()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Messenger/Messenger.php(54): Drupal\\Core\\StringTranslation\\TranslatableMarkup->__toString()\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Messenger/LegacyMessenger.php(50): Drupal\\Core\\Messenger\\Messenger->addMessage(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup), \'status\', false)\n#9 /var/www/html/drupal8/web/core/includes/bootstrap.inc(489): Drupal\\Core\\Messenger\\LegacyMessenger->addMessage(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup), \'status\', false)\n#10 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Plugin/views/query/GaQuery.php(323): drupal_set_message(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup))\n#11 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1426): Drupal\\ga_reports\\Plugin\\views\\query\\GaQuery->execute(Object(Drupal\\views\\ViewExecutable))\n#12 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1454): Drupal\\views\\ViewExecutable->execute(NULL)\n#13 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(2402): Drupal\\views\\ViewExecutable->render()\n#14 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1662): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->preview()\n#15 /var/www/html/drupal8/web/core/modules/views_ui/src/ViewUI.php(601): Drupal\\views\\ViewExecutable->preview(\'page_front\', Array)\n#16 /var/www/html/drupal8/web/core/modules/views_ui/src/ViewPreviewForm.php(62): Drupal\\views_ui\\ViewUI->renderPreview(\'page_front\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityForm.php(117): Drupal\\views_ui\\ViewPreviewForm->form(Array, Object(Drupal\\Core\\Form\\FormState))\n#18 /var/www/html/drupal8/web/core/modules/views_ui/src/ViewFormBase.php(41): Drupal\\Core\\Entity\\EntityForm->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#19 [internal function]: Drupal\\views_ui\\ViewFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState), \'page_front\')\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(368): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'view_preview_fo...\', Object(Drupal\\Core\\Form\\FormState))\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(625): Drupal\\Core\\Form\\FormBuilder->rebuildForm(\'view_preview_fo...\', Object(Drupal\\Core\\Form\\FormState), Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'view_preview_fo...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'view_preview_fo...\', Object(Drupal\\Core\\Form\\FormState))\n#25 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#30 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#31 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#34 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#35 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#38 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#40 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#41 {main}\";}',4,'','http://drupal-cms.com/admin/structure/views/view/ga_reports_page/preview/page_front?_wrapper_format=drupal_ajax','http://drupal-cms.com/admin/structure/views/view/ga_reports_page?destination=/admin/structure/views','127.0.0.1',1539240202),(748,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:65:\"htmlspecialchars() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:39:\"Drupal\\Component\\Utility\\Html::escape()\";s:5:\"%file\";s:68:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Html.php\";s:5:\"%line\";i:424;s:17:\"@backtrace_string\";s:9772:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'htmlspecialchar...\', \'/var/www/html/d...\', 424, Array)\n#1 [internal function]: _drupal_error_handler(2, \'htmlspecialchar...\', \'/var/www/html/d...\', 424, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Html.php(424): htmlspecialchars(Object(Drupal\\Core\\Link), 11, \'UTF-8\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php(265): Drupal\\Component\\Utility\\Html::escape(Object(Drupal\\Core\\Link))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php(206): Drupal\\Component\\Render\\FormattableMarkup::placeholderEscape(Object(Drupal\\Core\\Link))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StringTranslation/TranslatableMarkup.php(195): Drupal\\Component\\Render\\FormattableMarkup::placeholderFormat(\'You must @link ...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/ToStringTrait.php(15): Drupal\\Core\\StringTranslation\\TranslatableMarkup->render()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Messenger/Messenger.php(54): Drupal\\Core\\StringTranslation\\TranslatableMarkup->__toString()\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Messenger/LegacyMessenger.php(50): Drupal\\Core\\Messenger\\Messenger->addMessage(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup), \'status\', false)\n#9 /var/www/html/drupal8/web/core/includes/bootstrap.inc(489): Drupal\\Core\\Messenger\\LegacyMessenger->addMessage(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup), \'status\', false)\n#10 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Plugin/views/query/GaQuery.php(323): drupal_set_message(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup))\n#11 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1426): Drupal\\ga_reports\\Plugin\\views\\query\\GaQuery->execute(Object(Drupal\\views\\ViewExecutable))\n#12 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1454): Drupal\\views\\ViewExecutable->execute(\'attachment_top_...\')\n#13 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/Attachment.php(48): Drupal\\views\\ViewExecutable->render(\'attachment_top_...\')\n#14 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1630): Drupal\\views\\Plugin\\views\\display\\Attachment->execute()\n#15 /var/www/html/drupal8/web/core/modules/views/src/Element/View.php(77): Drupal\\views\\ViewExecutable->executeDisplay(\'attachment_top_...\', Array)\n#16 [internal function]: Drupal\\views\\Element\\View::preRenderViewElement(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#21 /var/www/html/drupal8/web/sites/default/files/php/twig/5bbef0e98ed49_views-ui-view-preview-sec_nt2AwRksug_gAjZb0RIz2hht4/KF-1CqNSc-aaCiUf1HrSiOK8yUgq9JT5OyvX_NyDsaE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_87ec8a3537e0d9eec5ad2e405775c1a8e1232cf178ce00f702f3017ec270e7bd->doDisplay(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#25 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_ui_view_p...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bbef0e98ed49_views-view.html.twig_My8wCKNyJv0eBmdCJ1uPxYt8x/4Ux03_3IGn3A6HVVyjNVM93umeM-us1b5eiQotzUi48.php(147): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_0b39505df84b691c5a3640573ee0790767231d2654971965753660bef51abd95->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/cla...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#44 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/AjaxRenderer.php(83): drupal_render_root(Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/AjaxRenderer.php(62): Drupal\\Core\\Render\\MainContent\\AjaxRenderer->drupalRenderRoot(Array)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\AjaxRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#48 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#50 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#51 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#61 {main}\";}',4,'','http://drupal-cms.com/admin/structure/views/view/ga_reports_page/preview/page_front?_wrapper_format=drupal_ajax','http://drupal-cms.com/admin/structure/views/view/ga_reports_page?destination=/admin/structure/views','127.0.0.1',1539240202),(749,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:65:\"htmlspecialchars() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:39:\"Drupal\\Component\\Utility\\Html::escape()\";s:5:\"%file\";s:68:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Html.php\";s:5:\"%line\";i:424;s:17:\"@backtrace_string\";s:9772:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'htmlspecialchar...\', \'/var/www/html/d...\', 424, Array)\n#1 [internal function]: _drupal_error_handler(2, \'htmlspecialchar...\', \'/var/www/html/d...\', 424, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Html.php(424): htmlspecialchars(Object(Drupal\\Core\\Link), 11, \'UTF-8\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php(265): Drupal\\Component\\Utility\\Html::escape(Object(Drupal\\Core\\Link))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php(206): Drupal\\Component\\Render\\FormattableMarkup::placeholderEscape(Object(Drupal\\Core\\Link))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StringTranslation/TranslatableMarkup.php(195): Drupal\\Component\\Render\\FormattableMarkup::placeholderFormat(\'You must @link ...\', Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/ToStringTrait.php(15): Drupal\\Core\\StringTranslation\\TranslatableMarkup->render()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Messenger/Messenger.php(54): Drupal\\Core\\StringTranslation\\TranslatableMarkup->__toString()\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Messenger/LegacyMessenger.php(50): Drupal\\Core\\Messenger\\Messenger->addMessage(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup), \'status\', false)\n#9 /var/www/html/drupal8/web/core/includes/bootstrap.inc(489): Drupal\\Core\\Messenger\\LegacyMessenger->addMessage(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup), \'status\', false)\n#10 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Plugin/views/query/GaQuery.php(323): drupal_set_message(Object(Drupal\\Core\\StringTranslation\\TranslatableMarkup))\n#11 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1426): Drupal\\ga_reports\\Plugin\\views\\query\\GaQuery->execute(Object(Drupal\\views\\ViewExecutable))\n#12 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1454): Drupal\\views\\ViewExecutable->execute(\'attachment_top_...\')\n#13 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/Attachment.php(48): Drupal\\views\\ViewExecutable->render(\'attachment_top_...\')\n#14 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1630): Drupal\\views\\Plugin\\views\\display\\Attachment->execute()\n#15 /var/www/html/drupal8/web/core/modules/views/src/Element/View.php(77): Drupal\\views\\ViewExecutable->executeDisplay(\'attachment_top_...\', Array)\n#16 [internal function]: Drupal\\views\\Element\\View::preRenderViewElement(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#21 /var/www/html/drupal8/web/sites/default/files/php/twig/5bbef0e98ed49_views-ui-view-preview-sec_nt2AwRksug_gAjZb0RIz2hht4/KF-1CqNSc-aaCiUf1HrSiOK8yUgq9JT5OyvX_NyDsaE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_87ec8a3537e0d9eec5ad2e405775c1a8e1232cf178ce00f702f3017ec270e7bd->doDisplay(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#25 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_ui_view_p...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bbef0e98ed49_views-view.html.twig_My8wCKNyJv0eBmdCJ1uPxYt8x/4Ux03_3IGn3A6HVVyjNVM93umeM-us1b5eiQotzUi48.php(147): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_0b39505df84b691c5a3640573ee0790767231d2654971965753660bef51abd95->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/cla...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'views_view\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#44 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/AjaxRenderer.php(83): drupal_render_root(Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/AjaxRenderer.php(62): Drupal\\Core\\Render\\MainContent\\AjaxRenderer->drupalRenderRoot(Array)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\AjaxRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#48 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#50 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#51 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#61 {main}\";}',4,'','http://drupal-cms.com/admin/structure/views/view/ga_reports_page/preview/page_front?_wrapper_format=drupal_ajax','http://drupal-cms.com/admin/structure/views/view/ga_reports_page?destination=/admin/structure/views','127.0.0.1',1539240202),(750,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:10:\"User error\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:506:\"Invalid placeholder (\n            :webpropertyid) in string: This ID is unique to each site you want to \n        track separately, and is in the form of UA-xxxxxxx-yy. To get a Web \n        Property ID, <a href=\":analytics\">register your site with Google \n        Analytics</a>, or if you already have registered your site, go to your \n        Google Analytics Settings page to see the ID next to every site profile.\n        <a href=\":webpropertyid\">Find more information in the documentation\n        </a>.\";}s:9:\"%function\";s:62:\"Drupal\\Component\\Render\\FormattableMarkup::placeholderFormat()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php\";s:5:\"%line\";i:241;s:17:\"@backtrace_string\";s:5835:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(256, \'Invalid placeho...\', \'/var/www/html/d...\', 241, Array)\n#1 [internal function]: _drupal_error_handler(256, \'Invalid placeho...\', \'/var/www/html/d...\', 241, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/FormattableMarkup.php(241): trigger_error(\'Invalid placeho...\', 256)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/StringTranslation/TranslatableMarkup.php(195): Drupal\\Component\\Render\\FormattableMarkup::placeholderFormat(\'This ID is uniq...\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/ToStringTrait.php(15): Drupal\\Core\\StringTranslation\\TranslatableMarkup->render()\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bbef14170530_form-element.html.twig_dJcTIbdx1y7B0dbOtEyyZSSZ1/ovFBz8XYmUfELySPZCbzVF4MJWNDCnrTru9EFN29bzc.php(133): Drupal\\Core\\StringTranslation\\TranslatableMarkup->__toString()\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_c1b0dc1db824b50c20b0a69e9a06081882039643c0740c44451d14fd9e353519->doDisplay(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#9 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/cla...\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'form_element\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#20 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#22 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#23 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#32 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#33 {main}\";}',3,'','http://drupal-cms.com/admin/config/services/ga-settings','http://drupal-cms.com/admin/config','127.0.0.1',1539240257),(751,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(752,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"16.73ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(753,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"10.16ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(754,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"9.74ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(755,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"19.01ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(756,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"1.57ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(757,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"24.56ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(758,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"1.84ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(759,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"30.18ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250689),(760,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"668.81ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250690),(761,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539250690),(762,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','http://drupal-cms.com/','127.0.0.1',1539257350),(763,0,'access denied','@uri',_binary 'a:1:{s:4:\"@uri\";s:12:\"/user/logout\";}',4,'','http://drupal-cms.com/user/logout','http://drupal-cms.com/','127.0.0.1',1539257353),(764,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539257371),(765,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257749),(766,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257750),(767,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257751),(768,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257751),(769,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257751),(770,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257751),(771,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257751),(772,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:50:\"/admin/ga-report/help?_wrapper_format=drupal_modal\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257765),(773,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257816),(774,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257817),(775,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257864),(776,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257866),(777,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257866),(778,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:9063:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {cache_config} (cid, expire, created, tags, checksum, data, serialized) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2, :db_insert_placeholder_3, :db_insert_placeholder_4, :db_insert_placeholder_5, :db_insert_placeholder_6), (:db_insert_placeholder_7, :db_insert_placeholder_8, :db_insert_placeholder_9, :db_insert_placeholder_10, :db_insert_placeholder_11, :db_insert_placeholder_12, :db_insert_placeholder_13), (:db_insert_placeholder_14, :db_insert_placeholder_15, :db_insert_placeholder_16, :db_insert_placeholder_17, :db_insert_placeholder_18, :db_insert_placeholder_19, :db_insert_placeholder_20), (:db_insert_placeholder_21, :db_insert_placeholder_22, :db_insert_placeholder_23, :db_insert_placeholder_24, :db_insert_placeholder_25, :db_insert_placeholder_26, :db_insert_placeholder_27), (:db_insert_placeholder_28, :db_insert_placeholder_29, :db_insert_placeholder_30, :db_insert_placeholder_31, :db_insert_placeholder_32, :db_insert_placeholder_33, :db_insert_placeholder_34), (:db_insert_placeholder_35, :db_insert_placeholder_36, :db_insert_placeholder_37, :db_insert_placeholder_38, :db_insert_placeholder_39, :db_insert_placeholder_40, :db_insert_placeholder_41), (:db_insert_placeholder_42, :db_insert_placeholder_43, :db_insert_placeholder_44, :db_insert_placeholder_45, :db_insert_placeholder_46, :db_insert_placeholder_47, :db_insert_placeholder_48), (:db_insert_placeholder_49, :db_insert_placeholder_50, :db_insert_placeholder_51, :db_insert_placeholder_52, :db_insert_placeholder_53, :db_insert_placeholder_54, :db_insert_placeholder_55), (:db_insert_placeholder_56, :db_insert_placeholder_57, :db_insert_placeholder_58, :db_insert_placeholder_59, :db_insert_placeholder_60, :db_insert_placeholder_61, :db_insert_placeholder_62), (:db_insert_placeholder_63, :db_insert_placeholder_64, :db_insert_placeholder_65, :db_insert_placeholder_66, :db_insert_placeholder_67, :db_insert_placeholder_68, :db_insert_placeholder_69), (:db_insert_placeholder_70, :db_insert_placeholder_71, :db_insert_placeholder_72, :db_insert_placeholder_73, :db_insert_placeholder_74, :db_insert_placeholder_75, :db_insert_placeholder_76), (:db_insert_placeholder_77, :db_insert_placeholder_78, :db_insert_placeholder_79, :db_insert_placeholder_80, :db_insert_placeholder_81, :db_insert_placeholder_82, :db_insert_placeholder_83), (:db_insert_placeholder_84, :db_insert_placeholder_85, :db_insert_placeholder_86, :db_insert_placeholder_87, :db_insert_placeholder_88, :db_insert_placeholder_89, :db_insert_placeholder_90), (:db_insert_placeholder_91, :db_insert_placeholder_92, :db_insert_placeholder_93, :db_insert_placeholder_94, :db_insert_placeholder_95, :db_insert_placeholder_96, :db_insert_placeholder_97), (:db_insert_placeholder_98, :db_insert_placeholder_99, :db_insert_placeholder_100, :db_insert_placeholder_101, :db_insert_placeholder_102, :db_insert_placeholder_103, :db_insert_placeholder_104), (:db_insert_placeholder_105, :db_insert_placeholder_106, :db_insert_placeholder_107, :db_insert_placeholder_108, :db_insert_placeholder_109, :db_insert_placeholder_110, :db_insert_placeholder_111), (:db_insert_placeholder_112, :db_insert_placeholder_113, :db_insert_placeholder_114, :db_insert_placeholder_115, :db_insert_placeholder_116, :db_insert_placeholder_117, :db_insert_placeholder_118) ON DUPLICATE KEY UPDATE cid = VALUES(cid), expire = VALUES(expire), created = VALUES(created), tags = VALUES(tags), checksum = VALUES(checksum), data = VALUES(data), serialized = VALUES(serialized); Array\n(\n    [:db_insert_placeholder_0] => core.base_field_override.user.user.uid\n    [:db_insert_placeholder_1] => -1\n    [:db_insert_placeholder_2] => 1539257948.273\n    [:db_insert_placeholder_3] => \n    [:db_insert_placeholder_4] => 0\n    [:db_insert_placeholder_5] => b:0;\n    [:db_insert_placeholder_6] => 1\n    [:db_insert_placeholder_7] => core.base_field_override.user.user.uuid\n    [:db_insert_placeholder_8] => -1\n    [:db_insert_placeholder_9] => 1539257948.273\n    [:db_insert_placeholder_10] => \n    [:db_insert_placeholder_11] => 0\n    [:db_insert_placeholder_12] => b:0;\n    [:db_insert_placeholder_13] => 1\n    [:db_insert_placeholder_14] => core.base_field_override.user.user.langcode\n    [:db_insert_placeholder_15] => -1\n    [:db_insert_placeholder_16] => 1539257948.273\n    [:db_insert_placeholder_17] => \n    [:db_insert_placeholder_18] => 0\n    [:db_insert_placeholder_19] => b:0;\n    [:db_insert_placeholder_20] => 1\n    [:db_insert_placeholder_21] => core.base_field_override.user.user.preferred_langcode\n    [:db_insert_placeholder_22] => -1\n    [:db_insert_placeholder_23] => 1539257948.273\n    [:db_insert_placeholder_24] => \n    [:db_insert_placeholder_25] => 0\n    [:db_insert_placeholder_26] => b:0;\n    [:db_insert_placeholder_27] => 1\n    [:db_insert_placeholder_28] => core.base_field_override.user.user.preferred_admin_langcode\n    [:db_insert_placeholder_29] => -1\n    [:db_insert_placeholder_30] => 1539257948.273\n    [:db_insert_placeholder_31] => \n    [:db_insert_placeholder_32] => 0\n    [:db_insert_placeholder_33] => b:0;\n    [:db_insert_placeholder_34] => 1\n    [:db_insert_placeholder_35] => core.base_field_override.user.user.name\n    [:db_insert_placeholder_36] => -1\n    [:db_insert_placeholder_37] => 1539257948.273\n    [:db_insert_placeholder_38] => \n    [:db_insert_placeholder_39] => 0\n    [:db_insert_placeholder_40] => b:0;\n    [:db_insert_placeholder_41] => 1\n    [:db_insert_placeholder_42] => core.base_field_override.user.user.pass\n    [:db_insert_placeholder_43] => -1\n    [:db_insert_placeholder_44] => 1539257948.273\n    [:db_insert_placeholder_45] => \n    [:db_insert_placeholder_46] => 0\n    [:db_insert_placeholder_47] => b:0;\n    [:db_insert_placeholder_48] => 1\n    [:db_insert_placeholder_49] => core.base_field_override.user.user.mail\n    [:db_insert_placeholder_50] => -1\n    [:db_insert_placeholder_51] => 1539257948.273\n    [:db_insert_placeholder_52] => \n    [:db_insert_placeholder_53] => 0\n    [:db_insert_placeholder_54] => b:0;\n    [:db_insert_placeholder_55] => 1\n    [:db_insert_placeholder_56] => core.base_field_override.user.user.timezone\n    [:db_insert_placeholder_57] => -1\n    [:db_insert_placeholder_58] => 1539257948.273\n    [:db_insert_placeholder_59] => \n    [:db_insert_placeholder_60] => 0\n    [:db_insert_placeholder_61] => b:0;\n    [:db_insert_placeholder_62] => 1\n    [:db_insert_placeholder_63] => core.base_field_override.user.user.status\n    [:db_insert_placeholder_64] => -1\n    [:db_insert_placeholder_65] => 1539257948.273\n    [:db_insert_placeholder_66] => \n    [:db_insert_placeholder_67] => 0\n    [:db_insert_placeholder_68] => b:0;\n    [:db_insert_placeholder_69] => 1\n    [:db_insert_placeholder_70] => core.base_field_override.user.user.created\n    [:db_insert_placeholder_71] => -1\n    [:db_insert_placeholder_72] => 1539257948.273\n    [:db_insert_placeholder_73] => \n    [:db_insert_placeholder_74] => 0\n    [:db_insert_placeholder_75] => b:0;\n    [:db_insert_placeholder_76] => 1\n    [:db_insert_placeholder_77] => core.base_field_override.user.user.changed\n    [:db_insert_placeholder_78] => -1\n    [:db_insert_placeholder_79] => 1539257948.273\n    [:db_insert_placeholder_80] => \n    [:db_insert_placeholder_81] => 0\n    [:db_insert_placeholder_82] => b:0;\n    [:db_insert_placeholder_83] => 1\n    [:db_insert_placeholder_84] => core.base_field_override.user.user.access\n    [:db_insert_placeholder_85] => -1\n    [:db_insert_placeholder_86] => 1539257948.273\n    [:db_insert_placeholder_87] => \n    [:db_insert_placeholder_88] => 0\n    [:db_insert_placeholder_89] => b:0;\n    [:db_insert_placeholder_90] => 1\n    [:db_insert_placeholder_91] => core.base_field_override.user.user.login\n    [:db_insert_placeholder_92] => -1\n    [:db_insert_placeholder_93] => 1539257948.273\n    [:db_insert_placeholder_94] => \n    [:db_insert_placeholder_95] => 0\n    [:db_insert_placeholder_96] => b:0;\n    [:db_insert_placeholder_97] => 1\n    [:db_insert_placeholder_98] => core.base_field_override.user.user.init\n    [:db_insert_placeholder_99] => -1\n    [:db_insert_placeholder_100] => 1539257948.273\n    [:db_insert_placeholder_101] => \n    [:db_insert_placeholder_102] => 0\n    [:db_insert_placeholder_103] => b:0;\n    [:db_insert_placeholder_104] => 1\n    [:db_insert_placeholder_105] => core.base_field_override.user.user.roles\n    [:db_insert_placeholder_106] => -1\n    [:db_insert_placeholder_107] => 1539257948.273\n    [:db_insert_placeholder_108] => \n    [:db_insert_placeholder_109] => 0\n    [:db_insert_placeholder_110] => b:0;\n    [:db_insert_placeholder_111] => 1\n    [:db_insert_placeholder_112] => core.base_field_override.user.user.default_langcode\n    [:db_insert_placeholder_113] => -1\n    [:db_insert_placeholder_114] => 1539257948.273\n    [:db_insert_placeholder_115] => \n    [:db_insert_placeholder_116] => 0\n    [:db_insert_placeholder_117] => b:0;\n    [:db_insert_placeholder_118] => 1\n)\n\";s:9:\"%function\";s:48:\"Drupal\\Core\\Config\\CachedStorage->readMultiple()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php\";s:5:\"%line\";i:105;s:17:\"@backtrace_string\";s:9233:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {ca...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Query/Upsert.php(106): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(263): Drupal\\Core\\Database\\Query\\Upsert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(193): Drupal\\Core\\Cache\\DatabaseBackend->doSetMultiple(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php(105): Drupal\\Core\\Cache\\DatabaseBackend->setMultiple(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(165): Drupal\\Core\\Config\\CachedStorage->readMultiple(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(136): Drupal\\Core\\Config\\ConfigFactory->doLoadMultiple(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(188): Drupal\\Core\\Config\\ConfigFactory->loadMultiple(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->doLoadMultiple(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(369): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(329): Drupal\\Core\\Entity\\EntityFieldManager->buildBundleFieldDefinitions(\'user\', \'user\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityManager.php(195): Drupal\\Core\\Entity\\EntityFieldManager->getFieldDefinitions(\'user\', \'user\')\n#13 /var/www/html/drupal8/web/core/modules/views/views.views.inc(252): Drupal\\Core\\Entity\\EntityManager->getFieldDefinitions(\'user\', \'user\')\n#14 /var/www/html/drupal8/web/core/modules/views/views.views.inc(495): views_entity_field_label(\'user\', \'field_migrate_e...\')\n#15 /var/www/html/drupal8/web/core/modules/views/views.views.inc(760): views_field_default_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#16 [internal function]: core_field_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'core_field_view...\', Array)\n#18 /var/www/html/drupal8/web/core/modules/views/views.views.inc(183): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'core\', \'field_views_dat...\', Array)\n#19 [internal function]: views_views_data()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'views_views_dat...\', Array)\n#21 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(243): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'views\', \'views_data\')\n#22 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(160): Drupal\\views\\ViewsData->getData()\n#23 /var/www/html/drupal8/web/core/modules/views/src/Plugin/Derivative/ViewsEntityRow.php(91): Drupal\\views\\ViewsData->get(\'block_content\')\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Component/Plugin/Discovery/DerivativeDiscoveryDecorator.php(101): Drupal\\views\\Plugin\\Derivative\\ViewsEntityRow->getDerivativeDefinitions(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/Plugin/Discovery/DerivativeDiscoveryDecorator.php(87): Drupal\\Component\\Plugin\\Discovery\\DerivativeDiscoveryDecorator->getDerivatives(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Plugin/DefaultPluginManager.php(284): Drupal\\Component\\Plugin\\Discovery\\DerivativeDiscoveryDecorator->getDefinitions()\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Plugin/DefaultPluginManager.php(175): Drupal\\Core\\Plugin\\DefaultPluginManager->findDefinitions()\n#28 /var/www/html/drupal8/web/core/modules/views/views.module(147): Drupal\\Core\\Plugin\\DefaultPluginManager->getDefinitions()\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(447): views_theme(Array, \'module\', \'views\', \'core/modules/vi...\')\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(334): Drupal\\Core\\Theme\\Registry->processExtension(Array, \'views\', \'module\', \'views\', \'core/modules/vi...\')\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(233): Drupal\\Core\\Theme\\Registry->build()\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Utility/ThemeRegistry.php(86): Drupal\\Core\\Theme\\Registry->get()\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Utility/ThemeRegistry.php(67): Drupal\\Core\\Utility\\ThemeRegistry->initializeRegistry()\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(253): Drupal\\Core\\Utility\\ThemeRegistry->__construct(\'theme_registry:...\', Object(Drupal\\Core\\Cache\\DatabaseBackend), Object(Drupal\\Core\\ProxyClass\\Lock\\DatabaseLockBackend), Array, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(142): Drupal\\Core\\Theme\\Registry->getRuntime()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(Array, Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539257948),(779,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257985),(780,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257987),(781,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257987),(782,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257987),(783,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:94:\"Unable to parse the controller name \"Drupal\\ga_reports\\Controller\\GARepotsController\\content\".\";s:9:\"%function\";s:61:\"Drupal\\Core\\Controller\\ControllerResolver->createController()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php\";s:5:\"%line\";i:119;s:17:\"@backtrace_string\";s:2449:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(74): Drupal\\Core\\Controller\\ControllerResolver->createController(\'Drupal\\\\ga_repor...\')\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/ControllerResolver.php(90): Drupal\\Core\\Controller\\ControllerResolver->getControllerFromDefinition(\'Drupal\\\\ga_repor...\', \'/admin/ga-repor...\')\n#2 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(134): Drupal\\Core\\Controller\\ControllerResolver->getController(Object(Symfony\\Component\\HttpFoundation\\Request))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#13 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539257988),(784,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:16:\"RuntimeException\";s:8:\"@message\";s:298:\"Controller \"Drupal\\ga_reports\\Controller\\GARepotsController::content()\" requires that you provide a value for the \"$request\" argument. Either the argument is nullable and no null value has been provided, no default value has been provided or because there is a non optional argument after this one.\";s:9:\"%function\";s:72:\"Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver->getArguments()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/vendor/symfony/http-kernel/Controller/ArgumentResolver.php\";s:5:\"%line\";i:78;s:17:\"@backtrace_string\";s:2933:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(94): Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver->getArguments(Object(Symfony\\Component\\HttpFoundation\\Request), Array)\n#1 [internal function]: Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->onController(Object(Symfony\\Component\\HttpKernel\\Event\\FilterControllerEvent), \'kernel.controll...\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\FilterControllerEvent), \'kernel.controll...\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(139): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.controll...\', Object(Symfony\\Component\\HttpKernel\\Event\\FilterControllerEvent))\n#4 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#14 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539258045),(785,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:16:\"RuntimeException\";s:8:\"@message\";s:298:\"Controller \"Drupal\\ga_reports\\Controller\\GARepotsController::content()\" requires that you provide a value for the \"$request\" argument. Either the argument is nullable and no null value has been provided, no default value has been provided or because there is a non optional argument after this one.\";s:9:\"%function\";s:72:\"Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver->getArguments()\";s:5:\"%file\";s:80:\"/var/www/html/drupal8/vendor/symfony/http-kernel/Controller/ArgumentResolver.php\";s:5:\"%line\";i:78;s:17:\"@backtrace_string\";s:2933:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(94): Symfony\\Component\\HttpKernel\\Controller\\ArgumentResolver->getArguments(Object(Symfony\\Component\\HttpFoundation\\Request), Array)\n#1 [internal function]: Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->onController(Object(Symfony\\Component\\HttpKernel\\Event\\FilterControllerEvent), \'kernel.controll...\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\FilterControllerEvent), \'kernel.controll...\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#3 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(139): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.controll...\', Object(Symfony\\Component\\HttpKernel\\Event\\FilterControllerEvent))\n#4 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#14 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539258125),(786,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: build\";}s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:15;s:17:\"@backtrace_string\";s:3301:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 15, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php(15): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 15, Array)\n#2 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#7 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#8 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539258224),(787,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:14:\"LogicException\";s:8:\"@message\";s:122:\"The controller must return a response (null given). Did you forget to add a return statement somewhere in your controller?\";s:9:\"%function\";s:52:\"Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw()\";s:5:\"%file\";s:63:\"/var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php\";s:5:\"%line\";i:169;s:17:\"@backtrace_string\";s:1889:\"#0 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#3 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#4 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#10 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539258224),(788,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: build\";}s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:16;s:17:\"@backtrace_string\";s:3301:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 16, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php(16): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 16, Array)\n#2 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#7 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#8 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539258442),(789,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: build\";}s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:16;s:17:\"@backtrace_string\";s:3301:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 16, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php(16): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 16, Array)\n#2 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#7 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#8 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539258455),(790,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:5:\"devel\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1539258756),(791,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:14:\"devel_generate\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1539258757),(792,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:4:\"kint\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1539258758),(793,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:15:\"Ga Reports Help\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/gareportshelp/delete?destination=%2Fadmin%2Fstructure%2Fblock%2Flist%2Fbootstrap%3Fblock-placement%3Dgareportshelp','http://drupal-cms.com/admin/structure/block/manage/gareportshelp/delete?destination=/admin/structure/block/list/bootstrap%3Fblock-placement%3Dgareportshelp','127.0.0.1',1539258982),(794,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:59:\"Class \'Drupal\\ga_reports\\Controller\\BlockContent\' not found\";s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:13;s:17:\"@backtrace_string\";s:2972:\"#0 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#5 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#16 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539259808),(795,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:9:\"TypeError\";s:8:\"@message\";s:258:\"Argument 1 passed to Drupal\\block_content\\BlockContentViewBuilder::view() must implement interface Drupal\\Core\\Entity\\EntityInterface, null given, called in /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php on line 17\";s:9:\"%function\";s:52:\"Drupal\\block_content\\BlockContentViewBuilder->view()\";s:5:\"%file\";s:84:\"/var/www/html/drupal8/web/core/modules/block_content/src/BlockContentViewBuilder.php\";s:5:\"%line\";i:16;s:17:\"@backtrace_string\";s:3129:\"#0 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php(17): Drupal\\block_content\\BlockContentViewBuilder->view(NULL)\n#1 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#6 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539259925),(796,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:9:\"TypeError\";s:8:\"@message\";s:258:\"Argument 1 passed to Drupal\\block_content\\BlockContentViewBuilder::view() must implement interface Drupal\\Core\\Entity\\EntityInterface, null given, called in /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php on line 17\";s:9:\"%function\";s:52:\"Drupal\\block_content\\BlockContentViewBuilder->view()\";s:5:\"%file\";s:84:\"/var/www/html/drupal8/web/core/modules/block_content/src/BlockContentViewBuilder.php\";s:5:\"%line\";i:16;s:17:\"@backtrace_string\";s:3129:\"#0 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php(17): Drupal\\block_content\\BlockContentViewBuilder->view(NULL)\n#1 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#6 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#17 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539259926),(797,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(798,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"11.29ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(799,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:6:\"8.18ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(800,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"8.72ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(801,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:4:\"12ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(802,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.46ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(803,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"26.24ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(804,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"3.32ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(805,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"21.32ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261506),(806,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"1068.6ms\";}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261507),(807,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/admin/config/services/ga-settings','','127.0.0.1',1539261507),(808,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: build\";}s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:16;s:17:\"@backtrace_string\";s:3301:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 16, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php(16): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 16, Array)\n#2 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#7 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#8 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#18 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261516),(809,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:51:\"Class \'Drupal\\ga_reports\\Controller\\Link\' not found\";s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:15;s:17:\"@backtrace_string\";s:2972:\"#0 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#5 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#16 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261562),(810,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:51:\"Class \'Drupal\\ga_reports\\Controller\\Link\' not found\";s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:15;s:17:\"@backtrace_string\";s:2972:\"#0 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#5 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#16 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261563),(811,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:51:\"Class \'Drupal\\ga_reports\\Controller\\Link\' not found\";s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:15;s:17:\"@backtrace_string\";s:2972:\"#0 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#5 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#16 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261563),(812,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:51:\"Class \'Drupal\\ga_reports\\Controller\\Link\' not found\";s:9:\"%function\";s:58:\"Drupal\\ga_reports\\Controller\\GARepotsController->content()\";s:5:\"%file\";s:90:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/src/Controller/GARepotsController.php\";s:5:\"%line\";i:15;s:17:\"@backtrace_string\";s:2972:\"#0 [internal function]: Drupal\\ga_reports\\Controller\\GARepotsController->content()\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#5 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#6 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#16 {main}\";}',3,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261571),(813,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strlen() expects parameter 1 to be string, array given\";}s:9:\"%function\";s:48:\"Drupal\\Component\\Utility\\Unicode::validateUtf8()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Unicode.php\";s:5:\"%line\";i:599;s:17:\"@backtrace_string\";s:4513:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strlen() expect...\', \'/var/www/html/d...\', 599, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strlen() expect...\', \'/var/www/html/d...\', 599, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Unicode.php(599): strlen(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Xss.php(63): Drupal\\Component\\Utility\\Unicode::validateUtf8(Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(753): Drupal\\Component\\Utility\\Xss::filter(Array, Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(384): Drupal\\Core\\Render\\Renderer->ensureMarkupIsSafe(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#10 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/ModalRenderer.php(22): drupal_render_root(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\ModalRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261780),(814,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:26:\"Array to string conversion\";}s:9:\"%function\";s:38:\"Drupal\\Component\\Utility\\Xss::filter()\";s:5:\"%file\";s:67:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Xss.php\";s:5:\"%line\";i:69;s:17:\"@backtrace_string\";s:4410:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Array to string...\', \'/var/www/html/d...\', 69, Array)\n#1 [internal function]: _drupal_error_handler(8, \'Array to string...\', \'/var/www/html/d...\', 69, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Xss.php(69): preg_replace(\'%&\\\\s*\\\\{[^}]*(\\\\}...\', \'\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(753): Drupal\\Component\\Utility\\Xss::filter(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(384): Drupal\\Core\\Render\\Renderer->ensureMarkupIsSafe(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#9 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/ModalRenderer.php(22): drupal_render_root(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\ModalRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261780),(815,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:26:\"Array to string conversion\";}s:9:\"%function\";s:35:\"Drupal\\Core\\Render\\Markup::create()\";s:5:\"%file\";s:74:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Render/MarkupTrait.php\";s:5:\"%line\";i:36;s:17:\"@backtrace_string\";s:4333:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Array to string...\', \'/var/www/html/d...\', 36, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/MarkupTrait.php(36): _drupal_error_handler(8, \'Array to string...\', \'/var/www/html/d...\', 36, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(753): Drupal\\Core\\Render\\Markup::create(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(384): Drupal\\Core\\Render\\Renderer->ensureMarkupIsSafe(Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/ModalRenderer.php(22): drupal_render_root(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\ModalRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#11 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261780),(816,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strlen() expects parameter 1 to be string, array given\";}s:9:\"%function\";s:48:\"Drupal\\Component\\Utility\\Unicode::validateUtf8()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Unicode.php\";s:5:\"%line\";i:599;s:17:\"@backtrace_string\";s:4513:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strlen() expect...\', \'/var/www/html/d...\', 599, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strlen() expect...\', \'/var/www/html/d...\', 599, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Unicode.php(599): strlen(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Xss.php(63): Drupal\\Component\\Utility\\Unicode::validateUtf8(Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(753): Drupal\\Component\\Utility\\Xss::filter(Array, Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(384): Drupal\\Core\\Render\\Renderer->ensureMarkupIsSafe(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#10 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/ModalRenderer.php(22): drupal_render_root(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\ModalRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#13 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',4,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261784),(817,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:26:\"Array to string conversion\";}s:9:\"%function\";s:38:\"Drupal\\Component\\Utility\\Xss::filter()\";s:5:\"%file\";s:67:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Xss.php\";s:5:\"%line\";i:69;s:17:\"@backtrace_string\";s:4410:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Array to string...\', \'/var/www/html/d...\', 69, Array)\n#1 [internal function]: _drupal_error_handler(8, \'Array to string...\', \'/var/www/html/d...\', 69, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Component/Utility/Xss.php(69): preg_replace(\'%&\\\\s*\\\\{[^}]*(\\\\}...\', \'\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(753): Drupal\\Component\\Utility\\Xss::filter(Array, Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(384): Drupal\\Core\\Render\\Renderer->ensureMarkupIsSafe(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#9 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/ModalRenderer.php(22): drupal_render_root(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\ModalRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#12 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#25 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261784),(818,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:26:\"Array to string conversion\";}s:9:\"%function\";s:35:\"Drupal\\Core\\Render\\Markup::create()\";s:5:\"%file\";s:74:\"/var/www/html/drupal8/web/core/lib/Drupal/Component/Render/MarkupTrait.php\";s:5:\"%line\";i:36;s:17:\"@backtrace_string\";s:4333:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Array to string...\', \'/var/www/html/d...\', 36, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Component/Render/MarkupTrait.php(36): _drupal_error_handler(8, \'Array to string...\', \'/var/www/html/d...\', 36, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(753): Drupal\\Core\\Render\\Markup::create(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(384): Drupal\\Core\\Render\\Renderer->ensureMarkupIsSafe(Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, true)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(139): Drupal\\Core\\Render\\Renderer->render(Array, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\Renderer->Drupal\\Core\\Render\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(140): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/includes/common.inc(868): Drupal\\Core\\Render\\Renderer->renderRoot(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/ModalRenderer.php(22): drupal_render_root(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\ModalRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#11 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/ga-report/help?_wrapper_format=drupal_modal','http://drupal-cms.com/admin/config/services/ga-settings','127.0.0.1',1539261784),(819,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:49:\"/admin/config/system/google-analytics-reports-api\";}',4,'','http://drupal-cms.com/admin/config/system/google-analytics-reports-api','','127.0.0.1',1539266081),(820,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335876),(821,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"21.29ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335876),(822,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"42.92ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335877),(823,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"9.48ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335877),(824,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"17.65ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335877),(825,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"2.23ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335877),(826,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"55.24ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335877),(827,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"37.8ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335877),(828,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:8:\"143.21ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335877),(829,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:15:\"/u/gangwarsurya\";}',4,'','http://drupal-cms.com/u/gangwarsurya','','127.0.0.1',1539335883),(830,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"5792.51ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335883),(831,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539335883),(832,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:4505:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {cache_config} (cid, expire, created, tags, checksum, data, serialized) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2, :db_insert_placeholder_3, :db_insert_placeholder_4, :db_insert_placeholder_5, :db_insert_placeholder_6), (:db_insert_placeholder_7, :db_insert_placeholder_8, :db_insert_placeholder_9, :db_insert_placeholder_10, :db_insert_placeholder_11, :db_insert_placeholder_12, :db_insert_placeholder_13), (:db_insert_placeholder_14, :db_insert_placeholder_15, :db_insert_placeholder_16, :db_insert_placeholder_17, :db_insert_placeholder_18, :db_insert_placeholder_19, :db_insert_placeholder_20), (:db_insert_placeholder_21, :db_insert_placeholder_22, :db_insert_placeholder_23, :db_insert_placeholder_24, :db_insert_placeholder_25, :db_insert_placeholder_26, :db_insert_placeholder_27), (:db_insert_placeholder_28, :db_insert_placeholder_29, :db_insert_placeholder_30, :db_insert_placeholder_31, :db_insert_placeholder_32, :db_insert_placeholder_33, :db_insert_placeholder_34), (:db_insert_placeholder_35, :db_insert_placeholder_36, :db_insert_placeholder_37, :db_insert_placeholder_38, :db_insert_placeholder_39, :db_insert_placeholder_40, :db_insert_placeholder_41), (:db_insert_placeholder_42, :db_insert_placeholder_43, :db_insert_placeholder_44, :db_insert_placeholder_45, :db_insert_placeholder_46, :db_insert_placeholder_47, :db_insert_placeholder_48), (:db_insert_placeholder_49, :db_insert_placeholder_50, :db_insert_placeholder_51, :db_insert_placeholder_52, :db_insert_placeholder_53, :db_insert_placeholder_54, :db_insert_placeholder_55) ON DUPLICATE KEY UPDATE cid = VALUES(cid), expire = VALUES(expire), created = VALUES(created), tags = VALUES(tags), checksum = VALUES(checksum), data = VALUES(data), serialized = VALUES(serialized); Array\n(\n    [:db_insert_placeholder_0] => core.base_field_override.shortcut.default.id\n    [:db_insert_placeholder_1] => -1\n    [:db_insert_placeholder_2] => 1539586017.417\n    [:db_insert_placeholder_3] => \n    [:db_insert_placeholder_4] => 0\n    [:db_insert_placeholder_5] => b:0;\n    [:db_insert_placeholder_6] => 1\n    [:db_insert_placeholder_7] => core.base_field_override.shortcut.default.uuid\n    [:db_insert_placeholder_8] => -1\n    [:db_insert_placeholder_9] => 1539586017.417\n    [:db_insert_placeholder_10] => \n    [:db_insert_placeholder_11] => 0\n    [:db_insert_placeholder_12] => b:0;\n    [:db_insert_placeholder_13] => 1\n    [:db_insert_placeholder_14] => core.base_field_override.shortcut.default.langcode\n    [:db_insert_placeholder_15] => -1\n    [:db_insert_placeholder_16] => 1539586017.417\n    [:db_insert_placeholder_17] => \n    [:db_insert_placeholder_18] => 0\n    [:db_insert_placeholder_19] => b:0;\n    [:db_insert_placeholder_20] => 1\n    [:db_insert_placeholder_21] => core.base_field_override.shortcut.default.shortcut_set\n    [:db_insert_placeholder_22] => -1\n    [:db_insert_placeholder_23] => 1539586017.417\n    [:db_insert_placeholder_24] => \n    [:db_insert_placeholder_25] => 0\n    [:db_insert_placeholder_26] => b:0;\n    [:db_insert_placeholder_27] => 1\n    [:db_insert_placeholder_28] => core.base_field_override.shortcut.default.title\n    [:db_insert_placeholder_29] => -1\n    [:db_insert_placeholder_30] => 1539586017.417\n    [:db_insert_placeholder_31] => \n    [:db_insert_placeholder_32] => 0\n    [:db_insert_placeholder_33] => b:0;\n    [:db_insert_placeholder_34] => 1\n    [:db_insert_placeholder_35] => core.base_field_override.shortcut.default.weight\n    [:db_insert_placeholder_36] => -1\n    [:db_insert_placeholder_37] => 1539586017.417\n    [:db_insert_placeholder_38] => \n    [:db_insert_placeholder_39] => 0\n    [:db_insert_placeholder_40] => b:0;\n    [:db_insert_placeholder_41] => 1\n    [:db_insert_placeholder_42] => core.base_field_override.shortcut.default.link\n    [:db_insert_placeholder_43] => -1\n    [:db_insert_placeholder_44] => 1539586017.417\n    [:db_insert_placeholder_45] => \n    [:db_insert_placeholder_46] => 0\n    [:db_insert_placeholder_47] => b:0;\n    [:db_insert_placeholder_48] => 1\n    [:db_insert_placeholder_49] => core.base_field_override.shortcut.default.default_langcode\n    [:db_insert_placeholder_50] => -1\n    [:db_insert_placeholder_51] => 1539586017.417\n    [:db_insert_placeholder_52] => \n    [:db_insert_placeholder_53] => 0\n    [:db_insert_placeholder_54] => b:0;\n    [:db_insert_placeholder_55] => 1\n)\n\";s:9:\"%function\";s:48:\"Drupal\\Core\\Config\\CachedStorage->readMultiple()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php\";s:5:\"%line\";i:105;s:17:\"@backtrace_string\";s:8908:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {ca...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Query/Upsert.php(106): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(263): Drupal\\Core\\Database\\Query\\Upsert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(193): Drupal\\Core\\Cache\\DatabaseBackend->doSetMultiple(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php(105): Drupal\\Core\\Cache\\DatabaseBackend->setMultiple(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(165): Drupal\\Core\\Config\\CachedStorage->readMultiple(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(136): Drupal\\Core\\Config\\ConfigFactory->doLoadMultiple(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(188): Drupal\\Core\\Config\\ConfigFactory->loadMultiple(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->doLoadMultiple(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(369): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(329): Drupal\\Core\\Entity\\EntityFieldManager->buildBundleFieldDefinitions(\'shortcut\', \'default\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityManager.php(195): Drupal\\Core\\Entity\\EntityFieldManager->getFieldDefinitions(\'shortcut\', \'default\')\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/Sql/SqlContentEntityStorage.php(1119): Drupal\\Core\\Entity\\EntityManager->getFieldDefinitions(\'shortcut\', \'default\')\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/Sql/SqlContentEntityStorage.php(465): Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage->loadFromDedicatedTables(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/Sql/SqlContentEntityStorage.php(393): Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage->mapFromStorageRecords(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/Sql/SqlContentEntityStorage.php(359): Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage->getFromStorage(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Entity\\Sql\\SqlContentEntityStorage->doLoadMultiple(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(542): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#19 /var/www/html/drupal8/web/core/modules/shortcut/src/Entity/ShortcutSet.php(126): Drupal\\Core\\Entity\\EntityStorageBase->loadByProperties(Array)\n#20 /var/www/html/drupal8/web/core/modules/shortcut/shortcut.module(266): Drupal\\shortcut\\Entity\\ShortcutSet->getShortcuts()\n#21 /var/www/html/drupal8/web/core/modules/shortcut/shortcut.module(392): shortcut_renderable_links()\n#22 [internal function]: shortcut_toolbar()\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(403): call_user_func_array(\'shortcut_toolba...\', Array)\n#24 /var/www/html/drupal8/web/core/modules/toolbar/src/Element/Toolbar.php(81): Drupal\\Core\\Extension\\ModuleHandler->invokeAll(\'toolbar\')\n#25 [internal function]: Drupal\\toolbar\\Element\\Toolbar::preRenderToolbar(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bc437e082123_html.html.twig_tBE6E1WQI0YjBbRBCGuuxwRVw/WkYwDt1H3uv2aRTu7P0pc8LIJdfaN4Qfg_KS6Pyi0gs.php(86): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e1a9dbb34caa1c133cb544a7069db1587b57988d97401f143244d11a5c570367->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/bootstra...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#42 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#55 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(833,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(834,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"25.88ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(835,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"61.36ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(836,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"36.88ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(837,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"41.05ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(838,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:7:\"15.09ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(839,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"67.83ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586017),(840,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"15.39ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586018),(841,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"80.57ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586018),(842,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/','','127.0.0.1',1539586020),(843,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/contextual/render','http://drupal-cms.com/','127.0.0.1',1539586020),(844,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"3379.45ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586021),(845,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539586021),(846,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined variable: message\";}s:9:\"%function\";s:21:\"api_key_form_submit()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:563;s:17:\"@backtrace_string\";s:4300:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 563, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(563): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 563, Array)\n#2 [internal function]: api_key_form_submit(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(\'api_key_form_su...\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#8 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586201),(847,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:10:\"ParseError\";s:8:\"@message\";s:44:\"syntax error, unexpected \'return\' (T_RETURN)\";s:9:\"%function\";s:39:\"Drupal\\Core\\Extension\\Extension->load()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:556;s:17:\"@backtrace_string\";s:1891:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(128): Drupal\\Core\\Extension\\Extension->load()\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(141): Drupal\\Core\\Extension\\ModuleHandler->load(\'ga_reports\')\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(557): Drupal\\Core\\Extension\\ModuleHandler->loadAll()\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(45): Drupal\\Core\\DrupalKernel->preHandle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#4 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#5 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#8 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#10 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#11 {main}\";}',3,'','','','',1539586412),(848,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586453),(849,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586453),(850,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586459),(851,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586459),(852,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586488),(853,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586488),(854,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586520),(855,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586533),(856,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586558),(857,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:91:\"call_user_func_array() expects parameter 1 to be a valid callback, no array or string given\";}s:9:\"%function\";s:55:\"Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers()\";s:5:\"%file\";s:69:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php\";s:5:\"%line\";i:111;s:17:\"@backtrace_string\";s:4140:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'call_user_func_...\', \'/var/www/html/d...\', 111, Array)\n#1 [internal function]: _drupal_error_handler(2, \'call_user_func_...\', \'/var/www/html/d...\', 111, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(NULL, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586558),(858,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:554;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 554, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(554): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586558),(859,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586795),(860,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586819),(861,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586858),(862,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586872),(863,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586872),(864,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586891),(865,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586891),(866,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586898),(867,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586898),(868,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','','127.0.0.1',1539586945),(869,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586955),(870,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:59:\"array_unshift() expects parameter 1 to be array, null given\";}s:9:\"%function\";s:56:\"ga_reports_form_system_site_information_settings_alter()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:555;s:17:\"@backtrace_string\";s:4206:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#1 [internal function]: _drupal_error_handler(2, \'array_unshift()...\', \'/var/www/html/d...\', 555, Array)\n#2 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(555): array_unshift(NULL, \'api_key_form_su...\')\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(539): ga_reports_form_system_site_information_settings_alter(Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(834): Drupal\\Core\\Extension\\ModuleHandler->alter(\'form\', Array, Object(Drupal\\Core\\Form\\FormState), \'system_site_inf...\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(276): Drupal\\Core\\Form\\FormBuilder->prepareForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#7 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#12 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#23 {main}\";}',4,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586955),(871,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined variable: message\";}s:9:\"%function\";s:21:\"api_key_form_submit()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:565;s:17:\"@backtrace_string\";s:4300:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(565): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#2 [internal function]: api_key_form_submit(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(\'api_key_form_su...\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#8 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539586969),(872,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined variable: message\";}s:9:\"%function\";s:21:\"api_key_form_submit()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:565;s:17:\"@backtrace_string\";s:4300:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(565): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#2 [internal function]: api_key_form_submit(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(\'api_key_form_su...\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#8 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539587096),(873,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined variable: message\";}s:9:\"%function\";s:21:\"api_key_form_submit()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:565;s:17:\"@backtrace_string\";s:4300:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(565): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#2 [internal function]: api_key_form_submit(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(\'api_key_form_su...\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#8 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539587105),(874,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined variable: message\";}s:9:\"%function\";s:21:\"api_key_form_submit()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:565;s:17:\"@backtrace_string\";s:4300:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(565): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#2 [internal function]: api_key_form_submit(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(\'api_key_form_su...\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#8 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539587115),(875,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined variable: message\";}s:9:\"%function\";s:21:\"api_key_form_submit()\";s:5:\"%file\";s:70:\"/var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module\";s:5:\"%line\";i:565;s:17:\"@backtrace_string\";s:4300:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#1 /var/www/html/drupal8/web/modules/ custom/ga_reports/ga_reports.module(565): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 565, Array)\n#2 [internal function]: api_key_form_submit(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(111): call_user_func_array(\'api_key_form_su...\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormSubmitter.php(51): Drupal\\Core\\Form\\FormSubmitter->executeSubmitHandlers(Array, Object(Drupal\\Core\\Form\\FormState))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(589): Drupal\\Core\\Form\\FormSubmitter->doSubmitForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'system_site_inf...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'system_site_inf...\', Object(Drupal\\Core\\Form\\FormState))\n#8 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#13 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#14 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#24 {main}\";}',5,'','http://drupal-cms.com/admin/config/system/site-information','http://drupal-cms.com/admin/config/system/site-information','127.0.0.1',1539587122),(876,0,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539682216),(877,0,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539682216),(878,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(879,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:6:\"54.5ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(880,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"51.51ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(881,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"10.32ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(882,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"45.09ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(883,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"7.47ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(884,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"29.01ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(885,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"15.87ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(886,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"73.63ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682220),(887,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"2025.96ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682222),(888,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539682222),(889,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539682228),(890,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(891,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(892,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"24.27ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(893,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:6:\"34.3ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(894,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"16.05ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(895,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"40.33ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(896,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"7.98ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(897,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"51.15ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(898,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"38.05ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(899,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"70.36ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760684),(900,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"183.17ms\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760685),(901,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539760685),(902,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:9:\"workflows\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1539760715),(903,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:18:\"content_moderation\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1539760717),(904,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:32:\"content_moderation_notifications\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1539760718),(905,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','http://drupal-cms.com/admin/config/workflow/notifications','127.0.0.1',1539760756);
INSERT INTO `watchdog` VALUES (906,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539760759),(907,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539760760),(908,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539760761),(909,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539760761),(910,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539760762),(911,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539760762),(912,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539760763),(913,0,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539761641),(914,0,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539761641),(915,0,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539761643),(916,0,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539761643),(917,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539761653),(918,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','http://drupal-cms.com/admin/config/workflow/notifications','127.0.0.1',1539761662),(919,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539761665),(920,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539761666),(921,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539761667),(922,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539761668),(923,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:75:\"Call to undefined method Drupal\\workflows\\Entity\\Workflow::getTransitions()\";s:9:\"%function\";s:96:\"Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm()\";s:5:\"%file\";s:126:\"/var/www/html/drupal8/web/modules/contrib/content_moderation_notifications/src/Form/ContentModerationNotificationsFormBase.php\";s:5:\"%line\";i:144;s:17:\"@backtrace_string\";s:3698:\"#0 [internal function]: Drupal\\content_moderation_notifications\\Form\\ContentModerationNotificationsFormBase->buildForm(Array, Object(Drupal\\Core\\Form\\FormState))\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(518): call_user_func_array(Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(275): Drupal\\Core\\Form\\FormBuilder->retrieveForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'content_moderat...\', Object(Drupal\\Core\\Form\\FormState))\n#4 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#9 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#13 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#14 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#17 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#20 {main}\";}',3,'','http://drupal-cms.com/admin/config/workflow/notifications/add','','127.0.0.1',1539761671),(924,1,'content_moderation_notifications','Notification has been added.',_binary 'a:1:{s:6:\"%label\";s:17:\"Export Promotions\";}',5,'','http://drupal-cms.com/admin/config/workflow/notifications/add','http://drupal-cms.com/admin/config/workflow/notifications/add','127.0.0.1',1539761893),(925,1,'content_moderation_notifications','Notification has been updated.',_binary 'a:1:{s:6:\"%label\";s:17:\"Export Promotions\";}',5,'','http://drupal-cms.com/admin/config/workflow/notifications/manage/export_promotions','http://drupal-cms.com/admin/config/workflow/notifications/manage/export_promotions','127.0.0.1',1539761902),(926,1,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539766152),(927,1,'file','The file permissions could not be set on %uri.',_binary 'a:1:{s:4:\"%uri\";s:27:\"public://bootstrap/provider\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1539766152),(928,1,'content_moderation_notifications','Notification has been updated.',_binary 'a:1:{s:6:\"%label\";s:17:\"Export Promotions\";}',5,'','http://drupal-cms.com/admin/config/workflow/notifications/manage/export_promotions?destination=%2Fadmin%2Fconfig%2Fworkflow%2Fnotifications','http://drupal-cms.com/admin/config/workflow/notifications/manage/export_promotions?destination=/admin/config/workflow/notifications','127.0.0.1',1539766214),(929,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858403),(930,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"17.83ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858403),(931,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:8:\"111.46ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858404),(932,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"17.89ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858404),(933,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:8:\"124.67ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858404),(934,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"14.8ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858404),(935,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"51.69ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858404),(936,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:7:\"41.03ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858404),(937,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:8:\"104.91ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858404),(938,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/admin','http://drupal-cms.com/','127.0.0.1',1539858410),(939,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"6394.28ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858410),(940,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1539858410),(941,1,'system','%theme theme installed.',_binary 'a:1:{s:6:\"%theme\";s:7:\"justice\";}',6,'','http://drupal-cms.com/admin/appearance/default?theme=justice&token=DyJ9vprBjQOQp472Eja6ErsRhXv2nPIq1vqpaikAnTI','http://drupal-cms.com/admin/appearance','127.0.0.1',1539858437),(942,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','','127.0.0.1',1539858661),(943,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1539858677),(944,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1539858685),(945,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1539858685),(946,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1539858685),(947,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1539858685),(948,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1539858685),(949,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1539858685),(950,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/base.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/base.css.map','','127.0.0.1',1539858703),(951,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/cowork/css/vendor.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/vendor.css.map','','127.0.0.1',1539858703),(952,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:39:\"/themes/custom/cowork/css/fonts.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/fonts.css.map','','127.0.0.1',1539858703),(953,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:47:\"/themes/custom/cowork/css/bootstrap.min.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/bootstrap.min.css.map','','127.0.0.1',1539858703),(954,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:38:\"/themes/custom/cowork/css/main.css.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/css/main.css.map','','127.0.0.1',1539858703),(955,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:35:\"/themes/custom/cowork/js/aos.js.map\";}',4,'','http://drupal-cms.com/themes/custom/cowork/js/aos.js.map','','127.0.0.1',1539858703),(956,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','','127.0.0.1',1539858892),(957,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:13:\"Site branding\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_branding/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/justice_branding/delete?destination=/admin/structure/block','127.0.0.1',1539859015),(958,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1539866043),(959,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186717),(960,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"15.01ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186717),(961,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"63.15ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186717),(962,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"12.46ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186717),(963,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/justice/css/flexslider.css?pgspa6','','127.0.0.1',1540186717),(964,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/justice/css/owl.carousel.min.css?pgspa6','','127.0.0.1',1540186717),(965,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:8:\"128.19ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186717),(966,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"7.43ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186717),(967,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"35.52ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186717),(968,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"40.3ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186718),(969,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"64.33ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186718),(970,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"3676.77ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186721),(971,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1540186721),(972,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540187592),(973,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540187937),(974,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540188431),(975,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540188457),(976,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540188544),(977,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540188644),(978,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540188821),(979,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540188933),(980,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:22:\"Home Page Banner Text \";}',5,'','http://drupal-cms.com/block/5?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/5?destination=/admin/structure/block/block-content','127.0.0.1',1540189042),(981,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:11:\"Footer menu\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_footer/delete?destination=%2Fadmin%2Fstructure%2Fblock%2Flist%2Fjustice%3Fblock-placement%3Dsocialmedialink','http://drupal-cms.com/admin/structure/block/manage/justice_footer/delete?destination=/admin/structure/block/list/justice%3Fblock-placement%3Dsocialmedialink','127.0.0.1',1540189449),(982,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:17:\"Social Media Link\";}',5,'','http://drupal-cms.com/block/3?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/3?destination=/admin/structure/block/block-content','127.0.0.1',1540189572),(983,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:17:\"Powered by Drupal\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_powered/delete?destination=%2Fadmin%2Fstructure%2Fblock%2Flist%2Fjustice%3Fblock-placement%3Dsocialmedialink','http://drupal-cms.com/admin/structure/block/manage/justice_powered/delete?destination=/admin/structure/block/list/justice%3Fblock-placement%3Dsocialmedialink','127.0.0.1',1540189655),(984,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:16:\"Power By company\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540189714),(985,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:11:\"block_class\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1540190616),(986,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540190687),(987,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:16:\"Power By company\";}',5,'','http://drupal-cms.com/block/6?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/6?destination=/admin/structure/block/block-content','127.0.0.1',1540190963),(988,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:16:\"Power By company\";}',5,'','http://drupal-cms.com/block/6?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/6?destination=/admin/structure/block/block-content','127.0.0.1',1540190972),(989,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:16:\"Power By company\";}',5,'','http://drupal-cms.com/block/6?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/6?destination=/admin/structure/block/block-content','127.0.0.1',1540191033),(990,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:17:\"Social Media Link\";}',5,'','http://drupal-cms.com/block/3?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/3?destination=/admin/structure/block/block-content','127.0.0.1',1540191113),(991,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:16:\"Power By company\";}',5,'','http://drupal-cms.com/block/6?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/6?destination=/admin/structure/block/block-content','127.0.0.1',1540191205),(992,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:16:\"Power By company\";}',5,'','http://drupal-cms.com/block/6?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/6?destination=/admin/structure/block/block-content','127.0.0.1',1540191224),(993,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:17:\"Social Media Link\";}',5,'','http://drupal-cms.com/block/3?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/3?destination=/admin/structure/block/block-content','127.0.0.1',1540191254),(994,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:28:\"Undefined index: #field_name\";}s:9:\"%function\";s:31:\"file_managed_file_save_upload()\";s:5:\"%file\";s:55:\"/var/www/html/drupal8/web/core/modules/file/file.module\";s:5:\"%line\";i:1339;s:17:\"@backtrace_string\";s:4681:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#1 /var/www/html/drupal8/web/core/modules/file/file.module(1339): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#2 /var/www/html/drupal8/web/core/modules/file/src/Element/ManagedFile.php(74): file_managed_file_save_upload(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 [internal function]: Drupal\\file\\Element\\ManagedFile::valueCallback(Array, Array, Object(Drupal\\Core\\Form\\FormState))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1254): call_user_func_array(Array, Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(990): Drupal\\Core\\Form\\FormBuilder->handleInputElement(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(561): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'editor_image_di...\', Object(Drupal\\Core\\Form\\FormState))\n#10 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_modal&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192045),(995,1,'file','The upload directory %directory for the file field %name could not be created or is not accessible. A newly uploaded file could not be saved in this directory as a consequence, and the upload was canceled.',_binary 'a:2:{s:10:\"%directory\";s:22:\"public://inline-images\";s:5:\"%name\";N;}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_modal&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192045),(996,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:28:\"Undefined index: #field_name\";}s:9:\"%function\";s:31:\"file_managed_file_save_upload()\";s:5:\"%file\";s:55:\"/var/www/html/drupal8/web/core/modules/file/file.module\";s:5:\"%line\";i:1339;s:17:\"@backtrace_string\";s:4681:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#1 /var/www/html/drupal8/web/core/modules/file/file.module(1339): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#2 /var/www/html/drupal8/web/core/modules/file/src/Element/ManagedFile.php(74): file_managed_file_save_upload(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 [internal function]: Drupal\\file\\Element\\ManagedFile::valueCallback(Array, Array, Object(Drupal\\Core\\Form\\FormState))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1254): call_user_func_array(Array, Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(990): Drupal\\Core\\Form\\FormBuilder->handleInputElement(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(561): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'editor_image_di...\', Object(Drupal\\Core\\Form\\FormState))\n#10 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_ajax&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192053),(997,1,'file','The upload directory %directory for the file field %name could not be created or is not accessible. A newly uploaded file could not be saved in this directory as a consequence, and the upload was canceled.',_binary 'a:2:{s:10:\"%directory\";s:22:\"public://inline-images\";s:5:\"%name\";N;}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_ajax&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192053),(998,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:28:\"Undefined index: #field_name\";}s:9:\"%function\";s:31:\"file_managed_file_save_upload()\";s:5:\"%file\";s:55:\"/var/www/html/drupal8/web/core/modules/file/file.module\";s:5:\"%line\";i:1339;s:17:\"@backtrace_string\";s:4681:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#1 /var/www/html/drupal8/web/core/modules/file/file.module(1339): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#2 /var/www/html/drupal8/web/core/modules/file/src/Element/ManagedFile.php(74): file_managed_file_save_upload(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 [internal function]: Drupal\\file\\Element\\ManagedFile::valueCallback(Array, Array, Object(Drupal\\Core\\Form\\FormState))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1254): call_user_func_array(Array, Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(990): Drupal\\Core\\Form\\FormBuilder->handleInputElement(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(561): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'editor_image_di...\', Object(Drupal\\Core\\Form\\FormState))\n#10 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_ajax&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192067),(999,1,'file','The upload directory %directory for the file field %name could not be created or is not accessible. A newly uploaded file could not be saved in this directory as a consequence, and the upload was canceled.',_binary 'a:2:{s:10:\"%directory\";s:22:\"public://inline-images\";s:5:\"%name\";N;}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_ajax&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192067),(1000,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:28:\"Undefined index: #field_name\";}s:9:\"%function\";s:31:\"file_managed_file_save_upload()\";s:5:\"%file\";s:55:\"/var/www/html/drupal8/web/core/modules/file/file.module\";s:5:\"%line\";i:1339;s:17:\"@backtrace_string\";s:4681:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#1 /var/www/html/drupal8/web/core/modules/file/file.module(1339): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 1339, Array)\n#2 /var/www/html/drupal8/web/core/modules/file/src/Element/ManagedFile.php(74): file_managed_file_save_upload(Array, Object(Drupal\\Core\\Form\\FormState))\n#3 [internal function]: Drupal\\file\\Element\\ManagedFile::valueCallback(Array, Array, Object(Drupal\\Core\\Form\\FormState))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1254): call_user_func_array(Array, Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(990): Drupal\\Core\\Form\\FormBuilder->handleInputElement(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(1060): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(561): Drupal\\Core\\Form\\FormBuilder->doBuildForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Form/FormBuilder.php(318): Drupal\\Core\\Form\\FormBuilder->processForm(\'editor_image_di...\', Array, Object(Drupal\\Core\\Form\\FormState))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Controller/FormController.php(93): Drupal\\Core\\Form\\FormBuilder->buildForm(\'editor_image_di...\', Object(Drupal\\Core\\Form\\FormState))\n#10 [internal function]: Drupal\\Core\\Controller\\FormController->getContentResult(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\RouteMatch))\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(123): call_user_func_array(Array, Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(124): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/EarlyRenderingControllerWrapperSubscriber.php(97): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->wrapControllerExecutionInRenderContext(Array, Array)\n#15 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(151): Drupal\\Core\\EventSubscriber\\EarlyRenderingControllerWrapperSubscriber->Drupal\\Core\\EventSubscriber\\{closure}()\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#26 {main}\";}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_modal&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192095),(1001,1,'file','The upload directory %directory for the file field %name could not be created or is not accessible. A newly uploaded file could not be saved in this directory as a consequence, and the upload was canceled.',_binary 'a:2:{s:10:\"%directory\";s:22:\"public://inline-images\";s:5:\"%name\";N;}',5,'','http://drupal-cms.com/editor/dialog/image/full_html?_wrapper_format=drupal_ajax&_wrapper_format=drupal_modal&ajax_form=1&element_parents=fid','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192095),(1002,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:8:\"About US\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540192381),(1003,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:8:\"About US\";}',5,'','http://drupal-cms.com/block/7?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/7?destination=/admin/structure/block/block-content','127.0.0.1',1540192807),(1004,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1540193004),(1005,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dae06547_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ifQyQ-RiAv3xXqqReK1VSdOjyKykE5cLMTpuy9HXnbI.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dae06547_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ifQyQ-RiAv3xXqqReK1VSdOjyKykE5cLMTpuy9HXnbI.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dae06547_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/kvskuJuzlUozBJ8jN9vXHa67rQONPXFTA3KKnI80YNg.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dae06547_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/K9W6I9JuUiAQ9WGC0Zy-AtgxtQcjsoF8lixj2VaGnV0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540193711),(1006,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dc7b586f_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/tMjuMEf7CskUHLHyIj6ZwjvNPONG_dZAarvsG96uO2o.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dc7b586f_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/tMjuMEf7CskUHLHyIj6ZwjvNPONG_dZAarvsG96uO2o.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dc7b586f_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/qUUkX_q4oZaleJPlAnq9EwYA2w08CRMb5vkYx4k1_U0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd7dc7b586f_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/ZWJilLFTiuzI2aVV-bia4Nm_KC-CNiykIbyLTRFUMVQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540193737),(1007,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/BK3YaVMegL9ipI2Huv2sIk8ODcv_dkM4Ia4Gg78HkWY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/BK3YaVMegL9ipI2Huv2sIk8ODcv_dkM4Ia4Gg78HkWY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Up8FZx4W7lvXtpRvpiDofZY_633LkwKwe5jx-is1ebU.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/g8AfDivQ5GKBe3p1YCKGsBT2c8WmwmxA6L5vb5TzMkE.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540197080),(1008,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/BK3YaVMegL9ipI2Huv2sIk8ODcv_dkM4Ia4Gg78HkWY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/BK3YaVMegL9ipI2Huv2sIk8ODcv_dkM4Ia4Gg78HkWY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Up8FZx4W7lvXtpRvpiDofZY_633LkwKwe5jx-is1ebU.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/g8AfDivQ5GKBe3p1YCKGsBT2c8WmwmxA6L5vb5TzMkE.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540197425),(1009,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/BK3YaVMegL9ipI2Huv2sIk8ODcv_dkM4Ia4Gg78HkWY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/BK3YaVMegL9ipI2Huv2sIk8ODcv_dkM4Ia4Gg78HkWY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Up8FZx4W7lvXtpRvpiDofZY_633LkwKwe5jx-is1ebU.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ad75e0a2_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/g8AfDivQ5GKBe3p1YCKGsBT2c8WmwmxA6L5vb5TzMkE.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540197426),(1010,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540197539),(1011,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1012,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:6:\"8.13ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1013,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"16.36ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1014,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"8.82ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1015,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"19.38ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1016,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.33ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1017,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"16.62ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1018,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"2.33ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1019,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"16.46ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197540),(1020,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"1196.99ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197541),(1021,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1540197541),(1022,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540197543),(1023,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197562),(1024,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197562),(1025,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197562),(1026,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197562),(1027,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9968:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#60 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197569),(1028,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9968:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#60 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197569),(1029,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9968:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#60 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197569),(1030,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9968:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/F1q7biZMUitOtmBD8zGdJ7DGbFQB-L1WUH-x3VDD7mo.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/ITJOSSsmU3-MSXZ00y6VT6YGKlKnX6je7J55De1Ptjk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/sG5mih2WoEB6KIFapqwbvxi14WMbiUfxaWT4SNfUP1I.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8ca25cec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/5WjfOvA0bEPdQgpgS-J-V2m42v8yfCQmM4KdMNOT64c.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#60 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197569),(1031,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/aRmESeIfLZAJ_mlX9NAwf1gl-6xVVM4ckHNsBJAffzE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/tQvbxGHyOM_dg6PiUlL9_XDK9PPg7_QwGu-KpFTP_l8.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197654),(1032,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/aRmESeIfLZAJ_mlX9NAwf1gl-6xVVM4ckHNsBJAffzE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/tQvbxGHyOM_dg6PiUlL9_XDK9PPg7_QwGu-KpFTP_l8.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197654),(1033,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/aRmESeIfLZAJ_mlX9NAwf1gl-6xVVM4ckHNsBJAffzE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/tQvbxGHyOM_dg6PiUlL9_XDK9PPg7_QwGu-KpFTP_l8.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197654),(1034,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/08HL3B0ASDisuhq0FqmXwuLs1O-MM0CcTdb6FZWYWZw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/EZsQ5wELKhkrF0NAqvNGBagSPmyLyFXxZPkKRKV4zQE.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/aRmESeIfLZAJ_mlX9NAwf1gl-6xVVM4ckHNsBJAffzE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d157cb42_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/tQvbxGHyOM_dg6PiUlL9_XDK9PPg7_QwGu-KpFTP_l8.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197654),(1035,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/fyex0gVzrXCS_Mx6fjSPQqtFSxQeNHZ6E_D6FUiMn3Y.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/44PoHz_wweaSfNuMso6t22-RcFwQfbOysW1O6DmHBuI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197725),(1036,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/fyex0gVzrXCS_Mx6fjSPQqtFSxQeNHZ6E_D6FUiMn3Y.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/44PoHz_wweaSfNuMso6t22-RcFwQfbOysW1O6DmHBuI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197725),(1037,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/fyex0gVzrXCS_Mx6fjSPQqtFSxQeNHZ6E_D6FUiMn3Y.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/44PoHz_wweaSfNuMso6t22-RcFwQfbOysW1O6DmHBuI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197725),(1038,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/Q2mP6d2kkE1ubb2HlFvzg8Yix515T3fRSWOZYMNlGQI.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3kU4BwhiRXV44YK-Kt80URjjIULZW_ixxFTZfoifGOA.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/fyex0gVzrXCS_Mx6fjSPQqtFSxQeNHZ6E_D6FUiMn3Y.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d5d2a4ed_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/44PoHz_wweaSfNuMso6t22-RcFwQfbOysW1O6DmHBuI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197725),(1039,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197753),(1040,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197753),(1041,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197753),(1042,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197753),(1043,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197755),(1044,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197755),(1045,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197755),(1046,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/bFC8seMuJXnivtTwTMF1kGcjQu6_nXtr3UCe6CvJtxw.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/TWR41DgiHAg9HhNtVeg5iGvbQPW74pvC1joOdUZBmdk.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/Ec8NoImWfDA9-JSweQ1NLimlm0q45pUGhKbuqK47yPE.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d786808e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/Ur8QcxDUcg8kbbLGUkO3BmDfQTJ3h9MbHcEti5PrNCs.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197755),(1047,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/BA8Un2UkQcyNstjsrEpTV3WUaUCZLRZkyA0IPb9gWVg.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/8ugdJJFh7rBW9EGSDy8bFBfMgBBQFZEKKUxZIetjQj4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197771),(1048,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/BA8Un2UkQcyNstjsrEpTV3WUaUCZLRZkyA0IPb9gWVg.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/8ugdJJFh7rBW9EGSDy8bFBfMgBBQFZEKKUxZIetjQj4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197771),(1049,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/BA8Un2UkQcyNstjsrEpTV3WUaUCZLRZkyA0IPb9gWVg.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/8ugdJJFh7rBW9EGSDy8bFBfMgBBQFZEKKUxZIetjQj4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197771),(1050,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/DQSbDOy6J3VVhcv4zDRCOM0F1dQXyvYb4Quydm1ynHE.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/6syryhYp_qfzhAEg-Pwg18Sf79vRR_NsZnV4-NUwUzw.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/BA8Un2UkQcyNstjsrEpTV3WUaUCZLRZkyA0IPb9gWVg.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8d8ae0b74_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/8ugdJJFh7rBW9EGSDy8bFBfMgBBQFZEKKUxZIetjQj4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197771),(1051,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/u_igGlT8lUhYm-ZVwuxu-lUZshHSvfmkJLyjgR94Bp8.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/UEjGc0_kkiYGm7bSm6ChdvLwyREuI3WMX5ke9rYyD24.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197798),(1052,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/u_igGlT8lUhYm-ZVwuxu-lUZshHSvfmkJLyjgR94Bp8.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/UEjGc0_kkiYGm7bSm6ChdvLwyREuI3WMX5ke9rYyD24.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197798),(1053,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/u_igGlT8lUhYm-ZVwuxu-lUZshHSvfmkJLyjgR94Bp8.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/UEjGc0_kkiYGm7bSm6ChdvLwyREuI3WMX5ke9rYyD24.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197798),(1054,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:54:\"strtr() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:21:\"twig_replace_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:486;s:17:\"@backtrace_string\";s:9761:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#1 [internal function]: _drupal_error_handler(2, \'strtr() expects...\', \'/var/www/html/d...\', 486, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(486): strtr(Object(Drupal\\Core\\Url), Array)\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(140): twig_replace_filter(Object(Drupal\\Core\\Url), Array)\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/fYIxs29KC3nOLGaCo7yRaVIlEoMjD44k55_t-FhzFf4.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/1kYcHDmqYduskru0nuzQJSIkop-7LvBua7eOSCNiy-s.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/u_igGlT8lUhYm-ZVwuxu-lUZshHSvfmkJLyjgR94Bp8.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd8da5608a5_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/UEjGc0_kkiYGm7bSm6ChdvLwyREuI3WMX5ke9rYyD24.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540197798),(1055,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91022daad_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/pB5vVd-KjJaECzUjxrvGd2l895AFOQWjj8zIfzTS25c.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91022daad_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/pB5vVd-KjJaECzUjxrvGd2l895AFOQWjj8zIfzTS25c.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91022daad_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/XUwX8mUYya76nYkoSIugTKPZT84yqRMYZxp43HVU5HY.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91022daad_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/C1SlrriD8kbzSV4qCUAEVzh987rWBPO_GeaJORDdYiE.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198658),(1056,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd911c5e38f_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3Cn6_jGf_ZgUIOLlpnieIwc_DLeDTzRU2Q5CvxqaeLs.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd911c5e38f_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/3Cn6_jGf_ZgUIOLlpnieIwc_DLeDTzRU2Q5CvxqaeLs.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd911c5e38f_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/OcsEt3WdSjXJUxV5_PqbIJIPG4WmBB4uRqoiYR5mVSs.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd911c5e38f_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/ZewEQffp5R1orYTQTuv-rxIpwGu-XaUGPyROOXwWprg.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198684),(1057,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/I0SWJD6dH4F_ScRJTjdJF30b-YFcQLW3PkrQwsHLQX0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/TGs6hv91UZQGtGvjl1JegtO-6wQmRQCBobHuqZGTSOQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198763),(1058,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/I0SWJD6dH4F_ScRJTjdJF30b-YFcQLW3PkrQwsHLQX0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/TGs6hv91UZQGtGvjl1JegtO-6wQmRQCBobHuqZGTSOQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198765),(1059,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/I0SWJD6dH4F_ScRJTjdJF30b-YFcQLW3PkrQwsHLQX0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/TGs6hv91UZQGtGvjl1JegtO-6wQmRQCBobHuqZGTSOQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198766),(1060,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/I0SWJD6dH4F_ScRJTjdJF30b-YFcQLW3PkrQwsHLQX0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/TGs6hv91UZQGtGvjl1JegtO-6wQmRQCBobHuqZGTSOQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198766),(1061,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/I0SWJD6dH4F_ScRJTjdJF30b-YFcQLW3PkrQwsHLQX0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/TGs6hv91UZQGtGvjl1JegtO-6wQmRQCBobHuqZGTSOQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198767),(1062,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/I0SWJD6dH4F_ScRJTjdJF30b-YFcQLW3PkrQwsHLQX0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/TGs6hv91UZQGtGvjl1JegtO-6wQmRQCBobHuqZGTSOQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198767),(1063,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:15:\"Unexpected \"}\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:49;s:17:\"@backtrace_string\";s:9020:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(216): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(122): Twig_Lexer->lexBlock()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#12 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/CTUqdiYOQjnA8XFMiY8KBRweqvrhHM1_g6zPsMEENFM.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#22 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/I0SWJD6dH4F_ScRJTjdJF30b-YFcQLW3PkrQwsHLQX0.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#26 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#31 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd916a2222b_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/TGs6hv91UZQGtGvjl1JegtO-6wQmRQCBobHuqZGTSOQ.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#35 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#56 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540198768),(1064,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198789),(1065,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198789),(1066,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198789),(1067,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198789),(1068,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198794),(1069,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198794),(1070,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198794),(1071,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:7:\"Warning\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:53:\"trim() expects parameter 1 to be string, object given\";}s:9:\"%function\";s:18:\"twig_trim_filter()\";s:5:\"%file\";s:66:\"/var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php\";s:5:\"%line\";i:962;s:17:\"@backtrace_string\";s:9760:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#1 [internal function]: _drupal_error_handler(2, \'trim() expects ...\', \'/var/www/html/d...\', 962, Array)\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Extension/Core.php(962): trim(Object(Drupal\\Core\\Url), \' \\t\\n\\r\\x00\\v\')\n#3 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(137): twig_trim_filter(Object(Drupal\\Core\\Url))\n#4 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_menu--main.html.twig_3fat6zE4XEWeiygDDyrdtW6ht/9IR2Bj-Z6Z4nQ3pQsP6sReXVB4PkeBBy5DyKe7O7-50.php(48): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->getmenu_links(Array, Object(Drupal\\Core\\Template\\Attribute), 0)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_6f3c49e27fded772c785c78b7b7e8a3e35f56eb4a7590c5580356bcf51b9b822->doDisplay(Array, Array)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#8 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#15 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/eVVpTTdpc1Xq470WFdYh6pO1BVMuglVDb2jCzfXLrHY.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#19 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#25 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/hVjg-wdoT1lFVeDzq6W1tfQqgCO-4qipCyxu1CwsbW4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#29 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#34 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcd91845e596_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/WuljGlbyFzszYT8qiPBxj3cnvmjpccCJf0FxSUZzhm4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#37 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#38 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#46 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#48 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#49 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#59 {main}\";}',4,'','http://drupal-cms.com/','','127.0.0.1',1540198794),(1072,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1540199151),(1073,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:14:\"Practice Areas\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540199453),(1074,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','','127.0.0.1',1540199533),(1075,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:14:\"Practice Areas\";}',5,'','http://drupal-cms.com/block/8?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/8?destination=/admin/structure/block/block-content','127.0.0.1',1540199861),(1076,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:14:\"Practice Areas\";}',5,'','http://drupal-cms.com/block/8?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/8?destination=/admin/structure/block/block-content','127.0.0.1',1540199912),(1077,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:8:\"About US\";}',5,'','http://drupal-cms.com/block/7?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/7?destination=/admin/structure/block/block-content','127.0.0.1',1540199952),(1078,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:8:\"About US\";}',5,'','http://drupal-cms.com/block/7?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/7?destination=/admin/structure/block/block-content','127.0.0.1',1540200201),(1079,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:8:\"Our Team\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540200865),(1080,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:460:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {semaphore} (name, value, expire) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2); Array\n(\n    [:db_insert_placeholder_0] => block_content_uuid:Drupal\\Core\\Cache\\CacheCollector\n    [:db_insert_placeholder_1] => 20792881845bcd9a3056fbf4.77021967\n    [:db_insert_placeholder_2] => 1540201038.4065\n)\n\";s:9:\"%function\";s:47:\"Drupal\\Core\\Cache\\CacheCollector->updateCache()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/CacheCollector.php\";s:5:\"%line\";i:233;s:17:\"@backtrace_string\";s:2658:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {se...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {se...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Insert.php(32): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {se...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Lock/DatabaseLockBackend.php(77): Drupal\\Core\\Database\\Driver\\mysql\\Insert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/ProxyClass/Lock/DatabaseLockBackend.php(75): Drupal\\Core\\Lock\\DatabaseLockBackend->acquire(\'block_content_u...\', 30)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/CacheCollector.php(233): Drupal\\Core\\ProxyClass\\Lock\\DatabaseLockBackend->acquire(\'block_content_u...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/CacheCollector.php(327): Drupal\\Core\\Cache\\CacheCollector->updateCache()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/KernelDestructionSubscriber.php(51): Drupal\\Core\\Cache\\CacheCollector->destruct()\n#8 [internal function]: Drupal\\Core\\EventSubscriber\\KernelDestructionSubscriber->onKernelTerminate(Object(Symfony\\Component\\HttpKernel\\Event\\PostResponseEvent), \'kernel.terminat...\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\PostResponseEvent), \'kernel.terminat...\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#10 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(88): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.terminat...\', Object(Symfony\\Component\\HttpKernel\\Event\\PostResponseEvent))\n#11 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(32): Symfony\\Component\\HttpKernel\\HttpKernel->terminate(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Render\\HtmlResponse))\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(643): Stack\\StackedHttpKernel->terminate(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Render\\HtmlResponse))\n#13 /var/www/html/drupal8/web/index.php(22): Drupal\\Core\\DrupalKernel->terminate(Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Render\\HtmlResponse))\n#14 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540201008),(1081,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540201980),(1082,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:8:\"Our Team\";}',5,'','http://drupal-cms.com/block/9?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/9?destination=/admin/structure/block/block-content','127.0.0.1',1540202076),(1083,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:8:\"Our Team\";}',5,'','http://drupal-cms.com/block/9?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/9?destination=/admin/structure/block/block-content','127.0.0.1',1540202132),(1084,0,'access denied','@uri',_binary 'a:1:{s:4:\"@uri\";s:16:\"/admin/structure\";}',4,'','http://drupal-cms.com/admin/structure','http://drupal-cms.com/admin/structure','127.0.0.1',1540203604),(1085,0,'access denied','@uri',_binary 'a:1:{s:4:\"@uri\";s:22:\"/admin/structure/block\";}',4,'','http://drupal-cms.com/admin/structure/block','http://drupal-cms.com/admin/structure','127.0.0.1',1540203605),(1086,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540203714),(1087,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:7:\"Address\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540203799),(1088,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:7:\"Address\";}',5,'','http://drupal-cms.com/block/11?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/11?destination=/admin/structure/block/block-content','127.0.0.1',1540203948),(1089,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540204279),(1090,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:7:\"Address\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/address/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/address/delete?destination=/admin/structure/block','127.0.0.1',1540204340),(1091,1,'block_content','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:12:\"custom block\";s:6:\"%label\";s:7:\"Address\";}',5,'','http://drupal-cms.com/block/11/delete?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/11/delete?destination=/admin/structure/block/block-content','127.0.0.1',1540204356),(1092,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540204369),(1093,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:54:\"Unexpected token \"end of statement block\" of value \"\".\";s:9:\"%function\";s:47:\"Twig_ExpressionParser->parsePrimaryExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:52;s:17:\"@backtrace_string\";s:10521:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(102): Twig_ExpressionParser->parsePrimaryExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(55): Twig_ExpressionParser->getPrimary()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/If.php(49): Twig_ExpressionParser->parseExpression()\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_If->parse(Object(Twig_Token))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/If.php(45): Twig_Parser->subparse(Array)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_If->parse(Object(Twig_Token))\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/For.php(42): Twig_Parser->subparse(Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_For->parse(Object(Twig_Token))\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/If.php(36): Twig_Parser->subparse(Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_If->parse(Object(Twig_Token))\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/Macro.php(35): Twig_Parser->subparse(Array, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_Macro->parse(Object(Twig_Token))\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(105): Twig_Parser->subparse(NULL, false)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(716): Twig_Parser->parse(Object(Twig_TokenStream))\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->parse(Object(Twig_TokenStream))\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#21 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/DvjmXz0ZeKs8uptE1xcm90ogiVMpbHgc3Ni_tWo-KV4.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#23 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/DvjmXz0ZeKs8uptE1xcm90ogiVMpbHgc3Ni_tWo-KV4.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#27 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#33 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/YNE7ZvjxQGpVnip-ikatHk6xuonvtgBJ3_eO__cONm4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#37 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#42 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/mAF3exfYTEeyqXglq5oZNckOgwNqH_c3a2CezC0a1hg.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#43 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#44 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#45 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#46 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#54 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#56 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#57 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#64 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#65 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#66 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#67 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#68 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540205010),(1094,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:54:\"Unexpected token \"end of statement block\" of value \"\".\";s:9:\"%function\";s:47:\"Twig_ExpressionParser->parsePrimaryExpression()\";s:5:\"%file\";s:83:\"/var/www/html/drupal8/web/themes/custom/justice/templates/menu/menu--main.html.twig\";s:5:\"%line\";i:52;s:17:\"@backtrace_string\";s:10521:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(102): Twig_ExpressionParser->parsePrimaryExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(55): Twig_ExpressionParser->getPrimary()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/If.php(49): Twig_ExpressionParser->parseExpression()\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_If->parse(Object(Twig_Token))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/If.php(45): Twig_Parser->subparse(Array)\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_If->parse(Object(Twig_Token))\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/For.php(42): Twig_Parser->subparse(Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_For->parse(Object(Twig_Token))\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/If.php(36): Twig_Parser->subparse(Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_If->parse(Object(Twig_Token))\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/Macro.php(35): Twig_Parser->subparse(Array, true)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_Macro->parse(Object(Twig_Token))\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(105): Twig_Parser->subparse(NULL, false)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(716): Twig_Parser->parse(Object(Twig_TokenStream))\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->parse(Object(Twig_TokenStream))\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#16 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'menu__main\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#21 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/DvjmXz0ZeKs8uptE1xcm90ogiVMpbHgc3Ni_tWo-KV4.php(90): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->block_content(Array, Array)\n#23 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_block--system-menu-block._oU3h3B30MaV88C3HsZIHq6JK5/DvjmXz0ZeKs8uptE1xcm90ogiVMpbHgc3Ni_tWo-KV4.php(79): Twig_Template->displayBlock(\'content\', Array, Array)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_2a511074bc4da006bd5680c315d03fa976f5742778cd5851ff71d04db4123a5a->doDisplay(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#27 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#33 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/YNE7ZvjxQGpVnip-ikatHk6xuonvtgBJ3_eO__cONm4.php(57): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#36 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#37 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#42 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcda9d1c1d93_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/mAF3exfYTEeyqXglq5oZNckOgwNqH_c3a2CezC0a1hg.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#43 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#44 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#45 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#46 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#54 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#56 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#57 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#64 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#65 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#66 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#67 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#68 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540205067),(1095,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1096,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"15.98ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1097,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"24.56ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1098,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"8.86ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1099,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:5:\"0.7ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1100,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.47ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1101,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"15.83ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1102,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"1.13ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1103,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"38.26ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208418),(1104,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"771.29ms\";}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208419),(1105,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/admin/config','http://drupal-cms.com/admin/structure/block','127.0.0.1',1540208419),(1106,1,'system','%module module installed.',_binary 'a:1:{s:7:\"%module\";s:13:\"contact_block\";}',6,'','http://drupal-cms.com/admin/modules','http://drupal-cms.com/admin/modules','127.0.0.1',1540210051),(1107,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:25:\"Unexpected character \";\".\";s:9:\"%function\";s:27:\"Twig_Lexer->lexExpression()\";s:5:\"%file\";s:79:\"/var/www/html/drupal8/web/themes/custom/justice/templates/input/input.html.twig\";s:5:\"%line\";i:23;s:17:\"@backtrace_string\";s:9323:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(227): Twig_Lexer->lexExpression()\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Lexer.php(126): Twig_Lexer->lexVar()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(677): Twig_Lexer->tokenize(Object(Twig_Source))\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->tokenize(Object(Twig_Source))\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#5 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#11 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdc5d443e66_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/cSrAKYWephjgBotDMyoogiQfPcyePAUaGUA08Zau1ac.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#13 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdc5d443e66_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/cSrAKYWephjgBotDMyoogiQfPcyePAUaGUA08Zau1ac.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#14 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#15 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#16 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#17 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#21 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#23 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdc5d443e66_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/-t0mYDAewTMFdhbYtPhBwogPsOwQY6gFcO4dtLJ4EUY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#24 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#25 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#26 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#27 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#32 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdc5d443e66_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/3KA0U1pQ3AGTWEo7P8MOxStNHzGY0vWEi7a5ahhHKZI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#34 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#35 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#36 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#44 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#47 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#58 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540212181),(1108,1,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:17:\"Twig_Error_Syntax\";s:8:\"@message\";s:133:\"An array element must be followed by a comma. Unexpected token \"string\" of value \"form-item\" (\"punctuation\" expected with value \",\").\";s:9:\"%function\";s:26:\"Twig_TokenStream->expect()\";s:5:\"%file\";s:86:\"/var/www/html/drupal8/web/themes/custom/justice/templates/input/form-element.html.twig\";s:5:\"%line\";i:53;s:17:\"@backtrace_string\";s:9913:\"#0 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(255): Twig_TokenStream->expect(9, \',\', \'An array elemen...\')\n#1 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(205): Twig_ExpressionParser->parseArrayExpression()\n#2 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(102): Twig_ExpressionParser->parsePrimaryExpression()\n#3 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(55): Twig_ExpressionParser->getPrimary()\n#4 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/ExpressionParser.php(587): Twig_ExpressionParser->parseExpression()\n#5 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/TokenParser/Set.php(41): Twig_ExpressionParser->parseMultitargetExpression()\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(192): Twig_TokenParser_Set->parse(Object(Twig_Token))\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Parser.php(105): Twig_Parser->subparse(NULL, false)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(716): Twig_Parser->parse(Object(Twig_TokenStream))\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(774): Twig_Environment->parse(Object(Twig_TokenStream))\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Environment.php(452): Twig_Environment->compileSource(Object(Twig_Source))\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Environment->loadTemplate(\'themes/custom/j...\')\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'form_element\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdd7e66c41d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/M_aGBUYMNmhNPUViwLCaeXBVBmvIIm2sQJ7aGmE8Umk.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdd7e66c41d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/M_aGBUYMNmhNPUViwLCaeXBVBmvIIm2sQJ7aGmE8Umk.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdd7e66c41d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ekR4Jz9ExhzdMHt4Ah7iVt0jQ0TQedPxGId0Qxlm1l4.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcdd7e66c41d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/0QqQkvm3fWKFN9pXbghRwPfsbPSj8QSTbm05RMxabxk.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#39 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#42 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#50 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#63 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540216808),(1109,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:22:\"Undefined index: title\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:308;s:17:\"@backtrace_string\";s:10320:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(308): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/O9nUMT7SL1D8g06GpPJtpt_i4wFAcaXe9xNzrxvLwhI.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/Rc0kE-3b-qVuQMyRG16v5v2AqVnAYpggjj4B07G1reQ.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/Rc0kE-3b-qVuQMyRG16v5v2AqVnAYpggjj4B07G1reQ.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/u4YE7460CabuynBa_9ADvvRlPN4OExCITI9VSp0XO6E.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/NwcRAretLqmBHZ2CmOk-8uTnOv7yqdVuC4QMgM3hKNI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#64 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270598),(1110,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/justice/css/flexslider.css?ph1ce8','','127.0.0.1',1540270599),(1111,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/justice/css/owl.carousel.min.css?ph1ce8','','127.0.0.1',1540270599),(1112,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1113,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"55.34ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1114,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"50.03ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1115,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:6:\"4.02ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1116,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:7:\"15.43ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1117,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"2.22ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1118,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"28.18ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1119,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"2.88ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1120,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"99.07ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270599),(1121,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:8:\"970.74ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270600),(1122,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270600),(1123,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:22:\"Undefined index: title\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:308;s:17:\"@backtrace_string\";s:8949:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(308): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/Rc0kE-3b-qVuQMyRG16v5v2AqVnAYpggjj4B07G1reQ.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/Rc0kE-3b-qVuQMyRG16v5v2AqVnAYpggjj4B07G1reQ.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/u4YE7460CabuynBa_9ADvvRlPN4OExCITI9VSp0XO6E.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/NwcRAretLqmBHZ2CmOk-8uTnOv7yqdVuC4QMgM3hKNI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270611),(1124,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:22:\"Undefined index: title\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:308;s:17:\"@backtrace_string\";s:10527:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(308): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/O9nUMT7SL1D8g06GpPJtpt_i4wFAcaXe9xNzrxvLwhI.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/Rc0kE-3b-qVuQMyRG16v5v2AqVnAYpggjj4B07G1reQ.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/Rc0kE-3b-qVuQMyRG16v5v2AqVnAYpggjj4B07G1reQ.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/u4YE7460CabuynBa_9ADvvRlPN4OExCITI9VSp0XO6E.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaa04b574e_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/NwcRAretLqmBHZ2CmOk-8uTnOv7yqdVuC4QMgM3hKNI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#64 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#65 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270611),(1125,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:10:\"ParseError\";s:8:\"@message\";s:50:\"syntax error, unexpected \'$variables\' (T_VARIABLE)\";s:9:\"%function\";s:39:\"Drupal\\Core\\Extension\\Extension->load()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:310;s:17:\"@backtrace_string\";s:4653:\"#0 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(35): Drupal\\Core\\Extension\\Extension->load()\n#1 [internal function]: twig_init(Object(Drupal\\Core\\Extension\\Extension))\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeInitialization.php(146): call_user_func(\'twig_init\', Object(Drupal\\Core\\Extension\\Extension))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeInitialization.php(74): Drupal\\Core\\Theme\\ThemeInitialization->loadActiveTheme(Object(Drupal\\Core\\Theme\\ActiveTheme))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(406): Drupal\\Core\\Theme\\ThemeInitialization->initTheme(\'justice\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(96): Drupal\\Core\\Theme\\ThemeManager->initTheme(Object(Drupal\\Core\\Routing\\RouteMatch))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/Context/ThemeCacheContext.php(43): Drupal\\Core\\Theme\\ThemeManager->getActiveTheme()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/Context/CacheContextsManager.php(118): Drupal\\Core\\Cache\\Context\\ThemeCacheContext->getContext(NULL)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/RenderCache.php(307): Drupal\\Core\\Cache\\Context\\CacheContextsManager->convertTokensToKeys(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/RenderCache.php(66): Drupal\\Core\\Render\\RenderCache->createCacheID(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/PlaceholderingRenderCache.php(109): Drupal\\Core\\Render\\RenderCache->get(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/RenderCache.php(77): Drupal\\Core\\Render\\PlaceholderingRenderCache->get(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/PlaceholderingRenderCache.php(109): Drupal\\Core\\Render\\RenderCache->get(Array)\n#13 /var/www/html/drupal8/web/core/modules/dynamic_page_cache/src/EventSubscriber/DynamicPageCacheSubscriber.php(137): Drupal\\Core\\Render\\PlaceholderingRenderCache->get(Array)\n#14 [internal function]: Drupal\\dynamic_page_cache\\EventSubscriber\\DynamicPageCacheSubscriber->onRequest(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseEvent), \'kernel.request\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseEvent), \'kernel.request\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#16 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(127): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.request\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseEvent))\n#17 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#20 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#21 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#27 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540270795),(1126,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:22:\"Undefined index: title\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:308;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(308): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 308, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaaf103981_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/n5FmFmde6WNLOwOB_P5H6d6M6zigW4Y3sSeeTIgVXLU.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaaf103981_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/n5FmFmde6WNLOwOB_P5H6d6M6zigW4Y3sSeeTIgVXLU.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaaf103981_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/6m1_YA7zCWAJluBvQSCj4NkyfjX3B9pSUqWdpYbd3iU.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceaaf103981_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/x7LVj6HJRDIzkupkeiJ5w7qO884Rf5ZrsXY-GMIBO7I.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540270833),(1127,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:10320:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(309): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/hLBVcToe1B_RZa3bd1CBzl1PuP_nqHcXKw51WaozvOE.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#64 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540272596),(1128,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:10017:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/hLBVcToe1B_RZa3bd1CBzl1PuP_nqHcXKw51WaozvOE.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#7 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#9 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#16 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#17 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#22 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#38 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#39 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#41 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#49 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#51 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#52 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#62 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540272596),(1129,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(309): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540272599),(1130,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8439:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#30 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#51 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540272599),(1131,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(309): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540272603),(1132,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8439:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#30 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#51 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540272603),(1133,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:310;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 310, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(310): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 310, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540272620),(1134,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:310;s:17:\"@backtrace_string\";s:8439:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#30 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#51 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540272620),(1135,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:310;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 310, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(310): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 310, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540272623),(1136,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:310;s:17:\"@backtrace_string\";s:8439:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#30 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#51 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540272623),(1137,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:310;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 310, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(310): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 310, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540272623),(1138,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:310;s:17:\"@backtrace_string\";s:8439:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/MhtL0Eksxos6Uqi3W-KLhcKjqqh2VF5_b33HovoF9xc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/tbZ1x6ve_kXz1m9S7-xOahh3nWS_6W0ukpfmNXCtLcI.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb1d2d8654_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/uksQ7iXamt6rNfZJOV7S3d4ms3o7cx4S3yjUOXZMOK4.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#30 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#51 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540272623),(1139,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(309): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/yFJKH9EdxOxtv8dVZV7y8zq0LcGckqZWI7dSM8t1bKc.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/0CKOEGtmi5SoWiB9iAaYtHDWYN6EVFVjEC_22sK6sbI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540273925),(1140,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8439:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/yFJKH9EdxOxtv8dVZV7y8zq0LcGckqZWI7dSM8t1bKc.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/0CKOEGtmi5SoWiB9iAaYtHDWYN6EVFVjEC_22sK6sbI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#30 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#51 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540273925),(1141,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(309): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 309, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/yFJKH9EdxOxtv8dVZV7y8zq0LcGckqZWI7dSM8t1bKc.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/0CKOEGtmi5SoWiB9iAaYtHDWYN6EVFVjEC_22sK6sbI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540274009),(1142,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:5:\"Error\";s:8:\"@message\";s:48:\"Call to a member function setAttribute() on null\";s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:309;s:17:\"@backtrace_string\";s:8439:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#5 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#6 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/aNINZ3MerDJ2yf560tl6nBIRYGOBvLObwpaDpldaa7w.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#17 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/yFJKH9EdxOxtv8dVZV7y8zq0LcGckqZWI7dSM8t1bKc.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#18 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#21 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#26 /var/www/html/drupal8/web/sites/default/files/php/twig/5bceb70487edd_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/0CKOEGtmi5SoWiB9iAaYtHDWYN6EVFVjEC_22sK6sbI.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#27 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#28 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#30 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#51 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540274009),(1143,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1540274035),(1144,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:10320:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/RDjnrdr0bWIBL7ZZmmS921O1apvT9KqV76SSgu09eF0.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#64 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275791),(1145,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275792),(1146,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275792),(1147,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275792),(1148,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275792),(1149,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275792),(1150,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275792),(1151,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:10320:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/RDjnrdr0bWIBL7ZZmmS921O1apvT9KqV76SSgu09eF0.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#64 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275793),(1152,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275794),(1153,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275794);
INSERT INTO `watchdog` VALUES (1154,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275794),(1155,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275794),(1156,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275794),(1157,1,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275794),(1158,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','','127.0.0.1',1540275803),(1159,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8949:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275803),(1160,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8949:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275803),(1161,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:10527:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/RDjnrdr0bWIBL7ZZmmS921O1apvT9KqV76SSgu09eF0.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#64 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#65 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275803),(1162,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8949:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275803),(1163,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8949:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275803),(1164,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:9071:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#55 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275803),(1165,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:27:\"Undefined index: attributes\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:9071:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined index...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/nyvfygLyFOINTEfUnyiJ2DfTl_cA5Cfztmj-pQLJtdc.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/65mE6OpoCwOgHwWIWIeHQN8QqnjDv8yYGPb-dXgCrIM.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcebe4e15ec8_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/YhLLWYhmV_lMuxvAnUl-5IiWwLA3tthwP3udPU9wNLM.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#55 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540275803),(1166,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540276171),(1167,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540276246),(1168,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540276375),(1169,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1170,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1171,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1172,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1173,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:10320:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/5W71Kp1k7NwzT5HKW4B0LGLk3CjlJvMhRm6A9rVjudc.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#64 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1174,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:10320:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_field-multiple-value-form_AE4shxHeMuGjoxGtgyp8_vTAw/5W71Kp1k7NwzT5HKW4B0LGLk3CjlJvMhRm6A9rVjudc.php(81): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e002ef461775b9fda3b69464d60d25fc67554047dcd6e51124d464740ad9074d->doDisplay(Array, Array)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#11 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'field_multiple_...\', Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#18 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#19 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#30 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#33 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#34 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#39 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#40 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#41 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#42 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#43 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#51 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#53 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#54 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#57 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#58 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#59 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#60 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#61 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#62 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#63 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#64 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1175,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1176,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1177,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1178,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8742:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#7 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#8 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#9 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#10 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#13 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#19 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#20 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#23 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#28 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#29 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#32 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#40 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#53 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1179,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1180,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1181,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1182,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"@message\";O:25:\"Drupal\\Core\\Render\\Markup\":1:{s:9:\"\0*\0string\";s:25:\"Undefined variable: field\";}s:9:\"%function\";s:26:\"justice_preprocess_input()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:306;s:17:\"@backtrace_string\";s:8864:\"#0 /var/www/html/drupal8/web/core/includes/bootstrap.inc(584): _drupal_error_handler_real(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#1 /var/www/html/drupal8/web/themes/custom/justice/justice.theme(306): _drupal_error_handler(8, \'Undefined varia...\', \'/var/www/html/d...\', 306, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(287): justice_preprocess_input(Array, \'input\', Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(493): Drupal\\Core\\Theme\\ThemeManager->render(\'input\', Array)\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#8 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(79): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#9 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(215): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->block_content(Array, Array)\n#10 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_block.html.twig_FmBbhY3dBW1vciXPiNALtJe17/li9I4moEjfNJP3OWHsp6le0Jg8JpI_d6xq0WrlBPHFo.php(68): Twig_Template->displayBlock(\'content\', Array, Array)\n#11 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_e47724b3e70c0c53ec221fdc6e0e78a0ab9b471db9940170095e19129ec5f5d1->doDisplay(Array, Array)\n#12 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#13 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#14 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'core/themes/sta...\', Array)\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'block\', Array)\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(450): Drupal\\Core\\Render\\Renderer->doRender(Array)\n#18 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#20 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_page--front.html.twig_eFiGd4jvivSifsWimuYSREVjN/ueoklHu5F1CA9-_00t22GVbiHJmFyokUG0Vl7ZpZhXY.php(103): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#21 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_018c5c03eaf80eb13868cd2fadae3b82594e7009494437bd5c0517a316d12994->doDisplay(Array, Array)\n#22 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#23 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#24 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'page\', Array)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#28 /var/www/html/drupal8/web/core/lib/Drupal/Core/Template/TwigExtension.php(490): Drupal\\Core\\Render\\Renderer->render(Array)\n#29 /var/www/html/drupal8/web/sites/default/files/php/twig/5bcec8d109c8d_html.html.twig_5mGQ4EvbjumnSoVmKepIahC5C/j3XgU5phUQvR6iBvm6eCsmLPWzkJ21P3ikakbOxcWL0.php(93): Drupal\\Core\\Template\\TwigExtension->escapeFilter(Object(Drupal\\Core\\Template\\TwigEnvironment), Array, \'html\', NULL, true)\n#30 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(432): __TwigTemplate_de65680053d373b3ce37e8fcbf9bdd2c3cb7efd4fc30b2af0eced9255a4e00c2->doDisplay(Array, Array)\n#31 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(403): Twig_Template->displayWithErrorHandling(Array, Array)\n#32 /var/www/html/drupal8/vendor/twig/twig/lib/Twig/Template.php(411): Twig_Template->display(Array)\n#33 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(64): Twig_Template->render(Array)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(384): twig_render_template(\'themes/custom/j...\', Array)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(\'html\', Array)\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(147): Drupal\\Core\\Render\\Renderer->render(Array)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(148): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#41 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#43 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#44 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#54 {main}\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540278482),(1183,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:10718:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {cache_config} (cid, expire, created, tags, checksum, data, serialized) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2, :db_insert_placeholder_3, :db_insert_placeholder_4, :db_insert_placeholder_5, :db_insert_placeholder_6), (:db_insert_placeholder_7, :db_insert_placeholder_8, :db_insert_placeholder_9, :db_insert_placeholder_10, :db_insert_placeholder_11, :db_insert_placeholder_12, :db_insert_placeholder_13), (:db_insert_placeholder_14, :db_insert_placeholder_15, :db_insert_placeholder_16, :db_insert_placeholder_17, :db_insert_placeholder_18, :db_insert_placeholder_19, :db_insert_placeholder_20), (:db_insert_placeholder_21, :db_insert_placeholder_22, :db_insert_placeholder_23, :db_insert_placeholder_24, :db_insert_placeholder_25, :db_insert_placeholder_26, :db_insert_placeholder_27), (:db_insert_placeholder_28, :db_insert_placeholder_29, :db_insert_placeholder_30, :db_insert_placeholder_31, :db_insert_placeholder_32, :db_insert_placeholder_33, :db_insert_placeholder_34), (:db_insert_placeholder_35, :db_insert_placeholder_36, :db_insert_placeholder_37, :db_insert_placeholder_38, :db_insert_placeholder_39, :db_insert_placeholder_40, :db_insert_placeholder_41), (:db_insert_placeholder_42, :db_insert_placeholder_43, :db_insert_placeholder_44, :db_insert_placeholder_45, :db_insert_placeholder_46, :db_insert_placeholder_47, :db_insert_placeholder_48), (:db_insert_placeholder_49, :db_insert_placeholder_50, :db_insert_placeholder_51, :db_insert_placeholder_52, :db_insert_placeholder_53, :db_insert_placeholder_54, :db_insert_placeholder_55), (:db_insert_placeholder_56, :db_insert_placeholder_57, :db_insert_placeholder_58, :db_insert_placeholder_59, :db_insert_placeholder_60, :db_insert_placeholder_61, :db_insert_placeholder_62), (:db_insert_placeholder_63, :db_insert_placeholder_64, :db_insert_placeholder_65, :db_insert_placeholder_66, :db_insert_placeholder_67, :db_insert_placeholder_68, :db_insert_placeholder_69), (:db_insert_placeholder_70, :db_insert_placeholder_71, :db_insert_placeholder_72, :db_insert_placeholder_73, :db_insert_placeholder_74, :db_insert_placeholder_75, :db_insert_placeholder_76), (:db_insert_placeholder_77, :db_insert_placeholder_78, :db_insert_placeholder_79, :db_insert_placeholder_80, :db_insert_placeholder_81, :db_insert_placeholder_82, :db_insert_placeholder_83), (:db_insert_placeholder_84, :db_insert_placeholder_85, :db_insert_placeholder_86, :db_insert_placeholder_87, :db_insert_placeholder_88, :db_insert_placeholder_89, :db_insert_placeholder_90), (:db_insert_placeholder_91, :db_insert_placeholder_92, :db_insert_placeholder_93, :db_insert_placeholder_94, :db_insert_placeholder_95, :db_insert_placeholder_96, :db_insert_placeholder_97), (:db_insert_placeholder_98, :db_insert_placeholder_99, :db_insert_placeholder_100, :db_insert_placeholder_101, :db_insert_placeholder_102, :db_insert_placeholder_103, :db_insert_placeholder_104), (:db_insert_placeholder_105, :db_insert_placeholder_106, :db_insert_placeholder_107, :db_insert_placeholder_108, :db_insert_placeholder_109, :db_insert_placeholder_110, :db_insert_placeholder_111), (:db_insert_placeholder_112, :db_insert_placeholder_113, :db_insert_placeholder_114, :db_insert_placeholder_115, :db_insert_placeholder_116, :db_insert_placeholder_117, :db_insert_placeholder_118), (:db_insert_placeholder_119, :db_insert_placeholder_120, :db_insert_placeholder_121, :db_insert_placeholder_122, :db_insert_placeholder_123, :db_insert_placeholder_124, :db_insert_placeholder_125), (:db_insert_placeholder_126, :db_insert_placeholder_127, :db_insert_placeholder_128, :db_insert_placeholder_129, :db_insert_placeholder_130, :db_insert_placeholder_131, :db_insert_placeholder_132), (:db_insert_placeholder_133, :db_insert_placeholder_134, :db_insert_placeholder_135, :db_insert_placeholder_136, :db_insert_placeholder_137, :db_insert_placeholder_138, :db_insert_placeholder_139) ON DUPLICATE KEY UPDATE cid = VALUES(cid), expire = VALUES(expire), created = VALUES(created), tags = VALUES(tags), checksum = VALUES(checksum), data = VALUES(data), serialized = VALUES(serialized); Array\n(\n    [:db_insert_placeholder_0] => core.base_field_override.node.article.nid\n    [:db_insert_placeholder_1] => -1\n    [:db_insert_placeholder_2] => 1540278925.868\n    [:db_insert_placeholder_3] => \n    [:db_insert_placeholder_4] => 0\n    [:db_insert_placeholder_5] => b:0;\n    [:db_insert_placeholder_6] => 1\n    [:db_insert_placeholder_7] => core.base_field_override.node.article.uuid\n    [:db_insert_placeholder_8] => -1\n    [:db_insert_placeholder_9] => 1540278925.868\n    [:db_insert_placeholder_10] => \n    [:db_insert_placeholder_11] => 0\n    [:db_insert_placeholder_12] => b:0;\n    [:db_insert_placeholder_13] => 1\n    [:db_insert_placeholder_14] => core.base_field_override.node.article.vid\n    [:db_insert_placeholder_15] => -1\n    [:db_insert_placeholder_16] => 1540278925.868\n    [:db_insert_placeholder_17] => \n    [:db_insert_placeholder_18] => 0\n    [:db_insert_placeholder_19] => b:0;\n    [:db_insert_placeholder_20] => 1\n    [:db_insert_placeholder_21] => core.base_field_override.node.article.langcode\n    [:db_insert_placeholder_22] => -1\n    [:db_insert_placeholder_23] => 1540278925.868\n    [:db_insert_placeholder_24] => \n    [:db_insert_placeholder_25] => 0\n    [:db_insert_placeholder_26] => b:0;\n    [:db_insert_placeholder_27] => 1\n    [:db_insert_placeholder_28] => core.base_field_override.node.article.type\n    [:db_insert_placeholder_29] => -1\n    [:db_insert_placeholder_30] => 1540278925.868\n    [:db_insert_placeholder_31] => \n    [:db_insert_placeholder_32] => 0\n    [:db_insert_placeholder_33] => b:0;\n    [:db_insert_placeholder_34] => 1\n    [:db_insert_placeholder_35] => core.base_field_override.node.article.revision_timestamp\n    [:db_insert_placeholder_36] => -1\n    [:db_insert_placeholder_37] => 1540278925.868\n    [:db_insert_placeholder_38] => \n    [:db_insert_placeholder_39] => 0\n    [:db_insert_placeholder_40] => b:0;\n    [:db_insert_placeholder_41] => 1\n    [:db_insert_placeholder_42] => core.base_field_override.node.article.revision_uid\n    [:db_insert_placeholder_43] => -1\n    [:db_insert_placeholder_44] => 1540278925.868\n    [:db_insert_placeholder_45] => \n    [:db_insert_placeholder_46] => 0\n    [:db_insert_placeholder_47] => b:0;\n    [:db_insert_placeholder_48] => 1\n    [:db_insert_placeholder_49] => core.base_field_override.node.article.revision_log\n    [:db_insert_placeholder_50] => -1\n    [:db_insert_placeholder_51] => 1540278925.868\n    [:db_insert_placeholder_52] => \n    [:db_insert_placeholder_53] => 0\n    [:db_insert_placeholder_54] => b:0;\n    [:db_insert_placeholder_55] => 1\n    [:db_insert_placeholder_56] => core.base_field_override.node.article.status\n    [:db_insert_placeholder_57] => -1\n    [:db_insert_placeholder_58] => 1540278925.868\n    [:db_insert_placeholder_59] => \n    [:db_insert_placeholder_60] => 0\n    [:db_insert_placeholder_61] => b:0;\n    [:db_insert_placeholder_62] => 1\n    [:db_insert_placeholder_63] => core.base_field_override.node.article.title\n    [:db_insert_placeholder_64] => -1\n    [:db_insert_placeholder_65] => 1540278925.868\n    [:db_insert_placeholder_66] => \n    [:db_insert_placeholder_67] => 0\n    [:db_insert_placeholder_68] => b:0;\n    [:db_insert_placeholder_69] => 1\n    [:db_insert_placeholder_70] => core.base_field_override.node.article.uid\n    [:db_insert_placeholder_71] => -1\n    [:db_insert_placeholder_72] => 1540278925.868\n    [:db_insert_placeholder_73] => \n    [:db_insert_placeholder_74] => 0\n    [:db_insert_placeholder_75] => b:0;\n    [:db_insert_placeholder_76] => 1\n    [:db_insert_placeholder_77] => core.base_field_override.node.article.created\n    [:db_insert_placeholder_78] => -1\n    [:db_insert_placeholder_79] => 1540278925.868\n    [:db_insert_placeholder_80] => \n    [:db_insert_placeholder_81] => 0\n    [:db_insert_placeholder_82] => b:0;\n    [:db_insert_placeholder_83] => 1\n    [:db_insert_placeholder_84] => core.base_field_override.node.article.changed\n    [:db_insert_placeholder_85] => -1\n    [:db_insert_placeholder_86] => 1540278925.868\n    [:db_insert_placeholder_87] => \n    [:db_insert_placeholder_88] => 0\n    [:db_insert_placeholder_89] => b:0;\n    [:db_insert_placeholder_90] => 1\n    [:db_insert_placeholder_91] => core.base_field_override.node.article.promote\n    [:db_insert_placeholder_92] => -1\n    [:db_insert_placeholder_93] => 1540278925.868\n    [:db_insert_placeholder_94] => \n    [:db_insert_placeholder_95] => 0\n    [:db_insert_placeholder_96] => b:0;\n    [:db_insert_placeholder_97] => 1\n    [:db_insert_placeholder_98] => core.base_field_override.node.article.sticky\n    [:db_insert_placeholder_99] => -1\n    [:db_insert_placeholder_100] => 1540278925.868\n    [:db_insert_placeholder_101] => \n    [:db_insert_placeholder_102] => 0\n    [:db_insert_placeholder_103] => b:0;\n    [:db_insert_placeholder_104] => 1\n    [:db_insert_placeholder_105] => core.base_field_override.node.article.default_langcode\n    [:db_insert_placeholder_106] => -1\n    [:db_insert_placeholder_107] => 1540278925.868\n    [:db_insert_placeholder_108] => \n    [:db_insert_placeholder_109] => 0\n    [:db_insert_placeholder_110] => b:0;\n    [:db_insert_placeholder_111] => 1\n    [:db_insert_placeholder_112] => core.base_field_override.node.article.revision_default\n    [:db_insert_placeholder_113] => -1\n    [:db_insert_placeholder_114] => 1540278925.868\n    [:db_insert_placeholder_115] => \n    [:db_insert_placeholder_116] => 0\n    [:db_insert_placeholder_117] => b:0;\n    [:db_insert_placeholder_118] => 1\n    [:db_insert_placeholder_119] => core.base_field_override.node.article.revision_translation_affected\n    [:db_insert_placeholder_120] => -1\n    [:db_insert_placeholder_121] => 1540278925.868\n    [:db_insert_placeholder_122] => \n    [:db_insert_placeholder_123] => 0\n    [:db_insert_placeholder_124] => b:0;\n    [:db_insert_placeholder_125] => 1\n    [:db_insert_placeholder_126] => core.base_field_override.node.article.moderation_state\n    [:db_insert_placeholder_127] => -1\n    [:db_insert_placeholder_128] => 1540278925.869\n    [:db_insert_placeholder_129] => \n    [:db_insert_placeholder_130] => 0\n    [:db_insert_placeholder_131] => b:0;\n    [:db_insert_placeholder_132] => 1\n    [:db_insert_placeholder_133] => core.base_field_override.node.article.path\n    [:db_insert_placeholder_134] => -1\n    [:db_insert_placeholder_135] => 1540278925.869\n    [:db_insert_placeholder_136] => \n    [:db_insert_placeholder_137] => 0\n    [:db_insert_placeholder_138] => b:0;\n    [:db_insert_placeholder_139] => 1\n)\n\";s:9:\"%function\";s:48:\"Drupal\\Core\\Config\\CachedStorage->readMultiple()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php\";s:5:\"%line\";i:105;s:17:\"@backtrace_string\";s:8015:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {ca...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Query/Upsert.php(106): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(263): Drupal\\Core\\Database\\Query\\Upsert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(193): Drupal\\Core\\Cache\\DatabaseBackend->doSetMultiple(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php(105): Drupal\\Core\\Cache\\DatabaseBackend->setMultiple(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(165): Drupal\\Core\\Config\\CachedStorage->readMultiple(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(136): Drupal\\Core\\Config\\ConfigFactory->doLoadMultiple(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(188): Drupal\\Core\\Config\\ConfigFactory->loadMultiple(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->doLoadMultiple(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(369): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(329): Drupal\\Core\\Entity\\EntityFieldManager->buildBundleFieldDefinitions(\'node\', \'article\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityManager.php(195): Drupal\\Core\\Entity\\EntityFieldManager->getFieldDefinitions(\'node\', \'article\')\n#13 /var/www/html/drupal8/web/core/modules/views/views.views.inc(252): Drupal\\Core\\Entity\\EntityManager->getFieldDefinitions(\'node\', \'article\')\n#14 /var/www/html/drupal8/web/core/modules/views/views.views.inc(495): views_entity_field_label(\'node\', \'body\')\n#15 /var/www/html/drupal8/web/core/modules/views/views.views.inc(185): views_field_default_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#16 [internal function]: views_views_data()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'views_views_dat...\', Array)\n#18 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(243): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'views\', \'views_data\')\n#19 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(160): Drupal\\views\\ViewsData->getData()\n#20 /var/www/html/drupal8/web/core/modules/views/src/Plugin/ViewsHandlerManager.php(85): Drupal\\views\\ViewsData->get(\'node_field_data\')\n#21 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(889): Drupal\\views\\Plugin\\ViewsHandlerManager->getHandler(Array, NULL)\n#22 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1040): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->getHandlers(\'sort\')\n#23 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(898): Drupal\\views\\ViewExecutable->_initHandler(\'sort\', Array)\n#24 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(2267): Drupal\\views\\ViewExecutable->initHandlers()\n#25 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1692): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->preExecute()\n#26 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1627): Drupal\\views\\ViewExecutable->preExecute(Array)\n#27 /var/www/html/drupal8/web/core/modules/views/src/Element/View.php(77): Drupal\\views\\ViewExecutable->executeDisplay(\'page_1\', Array)\n#28 [internal function]: Drupal\\views\\Element\\View::preRenderViewElement(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#36 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#38 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#39 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#49 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540278925),(1184,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:10978:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {cache_config} (cid, expire, created, tags, checksum, data, serialized) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2, :db_insert_placeholder_3, :db_insert_placeholder_4, :db_insert_placeholder_5, :db_insert_placeholder_6), (:db_insert_placeholder_7, :db_insert_placeholder_8, :db_insert_placeholder_9, :db_insert_placeholder_10, :db_insert_placeholder_11, :db_insert_placeholder_12, :db_insert_placeholder_13), (:db_insert_placeholder_14, :db_insert_placeholder_15, :db_insert_placeholder_16, :db_insert_placeholder_17, :db_insert_placeholder_18, :db_insert_placeholder_19, :db_insert_placeholder_20), (:db_insert_placeholder_21, :db_insert_placeholder_22, :db_insert_placeholder_23, :db_insert_placeholder_24, :db_insert_placeholder_25, :db_insert_placeholder_26, :db_insert_placeholder_27), (:db_insert_placeholder_28, :db_insert_placeholder_29, :db_insert_placeholder_30, :db_insert_placeholder_31, :db_insert_placeholder_32, :db_insert_placeholder_33, :db_insert_placeholder_34), (:db_insert_placeholder_35, :db_insert_placeholder_36, :db_insert_placeholder_37, :db_insert_placeholder_38, :db_insert_placeholder_39, :db_insert_placeholder_40, :db_insert_placeholder_41), (:db_insert_placeholder_42, :db_insert_placeholder_43, :db_insert_placeholder_44, :db_insert_placeholder_45, :db_insert_placeholder_46, :db_insert_placeholder_47, :db_insert_placeholder_48), (:db_insert_placeholder_49, :db_insert_placeholder_50, :db_insert_placeholder_51, :db_insert_placeholder_52, :db_insert_placeholder_53, :db_insert_placeholder_54, :db_insert_placeholder_55), (:db_insert_placeholder_56, :db_insert_placeholder_57, :db_insert_placeholder_58, :db_insert_placeholder_59, :db_insert_placeholder_60, :db_insert_placeholder_61, :db_insert_placeholder_62), (:db_insert_placeholder_63, :db_insert_placeholder_64, :db_insert_placeholder_65, :db_insert_placeholder_66, :db_insert_placeholder_67, :db_insert_placeholder_68, :db_insert_placeholder_69), (:db_insert_placeholder_70, :db_insert_placeholder_71, :db_insert_placeholder_72, :db_insert_placeholder_73, :db_insert_placeholder_74, :db_insert_placeholder_75, :db_insert_placeholder_76), (:db_insert_placeholder_77, :db_insert_placeholder_78, :db_insert_placeholder_79, :db_insert_placeholder_80, :db_insert_placeholder_81, :db_insert_placeholder_82, :db_insert_placeholder_83), (:db_insert_placeholder_84, :db_insert_placeholder_85, :db_insert_placeholder_86, :db_insert_placeholder_87, :db_insert_placeholder_88, :db_insert_placeholder_89, :db_insert_placeholder_90), (:db_insert_placeholder_91, :db_insert_placeholder_92, :db_insert_placeholder_93, :db_insert_placeholder_94, :db_insert_placeholder_95, :db_insert_placeholder_96, :db_insert_placeholder_97), (:db_insert_placeholder_98, :db_insert_placeholder_99, :db_insert_placeholder_100, :db_insert_placeholder_101, :db_insert_placeholder_102, :db_insert_placeholder_103, :db_insert_placeholder_104), (:db_insert_placeholder_105, :db_insert_placeholder_106, :db_insert_placeholder_107, :db_insert_placeholder_108, :db_insert_placeholder_109, :db_insert_placeholder_110, :db_insert_placeholder_111), (:db_insert_placeholder_112, :db_insert_placeholder_113, :db_insert_placeholder_114, :db_insert_placeholder_115, :db_insert_placeholder_116, :db_insert_placeholder_117, :db_insert_placeholder_118), (:db_insert_placeholder_119, :db_insert_placeholder_120, :db_insert_placeholder_121, :db_insert_placeholder_122, :db_insert_placeholder_123, :db_insert_placeholder_124, :db_insert_placeholder_125), (:db_insert_placeholder_126, :db_insert_placeholder_127, :db_insert_placeholder_128, :db_insert_placeholder_129, :db_insert_placeholder_130, :db_insert_placeholder_131, :db_insert_placeholder_132), (:db_insert_placeholder_133, :db_insert_placeholder_134, :db_insert_placeholder_135, :db_insert_placeholder_136, :db_insert_placeholder_137, :db_insert_placeholder_138, :db_insert_placeholder_139) ON DUPLICATE KEY UPDATE cid = VALUES(cid), expire = VALUES(expire), created = VALUES(created), tags = VALUES(tags), checksum = VALUES(checksum), data = VALUES(data), serialized = VALUES(serialized); Array\n(\n    [:db_insert_placeholder_0] => core.base_field_override.node.migrate_example_beer.nid\n    [:db_insert_placeholder_1] => -1\n    [:db_insert_placeholder_2] => 1540278925.903\n    [:db_insert_placeholder_3] => \n    [:db_insert_placeholder_4] => 0\n    [:db_insert_placeholder_5] => b:0;\n    [:db_insert_placeholder_6] => 1\n    [:db_insert_placeholder_7] => core.base_field_override.node.migrate_example_beer.uuid\n    [:db_insert_placeholder_8] => -1\n    [:db_insert_placeholder_9] => 1540278925.903\n    [:db_insert_placeholder_10] => \n    [:db_insert_placeholder_11] => 0\n    [:db_insert_placeholder_12] => b:0;\n    [:db_insert_placeholder_13] => 1\n    [:db_insert_placeholder_14] => core.base_field_override.node.migrate_example_beer.vid\n    [:db_insert_placeholder_15] => -1\n    [:db_insert_placeholder_16] => 1540278925.903\n    [:db_insert_placeholder_17] => \n    [:db_insert_placeholder_18] => 0\n    [:db_insert_placeholder_19] => b:0;\n    [:db_insert_placeholder_20] => 1\n    [:db_insert_placeholder_21] => core.base_field_override.node.migrate_example_beer.langcode\n    [:db_insert_placeholder_22] => -1\n    [:db_insert_placeholder_23] => 1540278925.903\n    [:db_insert_placeholder_24] => \n    [:db_insert_placeholder_25] => 0\n    [:db_insert_placeholder_26] => b:0;\n    [:db_insert_placeholder_27] => 1\n    [:db_insert_placeholder_28] => core.base_field_override.node.migrate_example_beer.type\n    [:db_insert_placeholder_29] => -1\n    [:db_insert_placeholder_30] => 1540278925.903\n    [:db_insert_placeholder_31] => \n    [:db_insert_placeholder_32] => 0\n    [:db_insert_placeholder_33] => b:0;\n    [:db_insert_placeholder_34] => 1\n    [:db_insert_placeholder_35] => core.base_field_override.node.migrate_example_beer.revision_timestamp\n    [:db_insert_placeholder_36] => -1\n    [:db_insert_placeholder_37] => 1540278925.903\n    [:db_insert_placeholder_38] => \n    [:db_insert_placeholder_39] => 0\n    [:db_insert_placeholder_40] => b:0;\n    [:db_insert_placeholder_41] => 1\n    [:db_insert_placeholder_42] => core.base_field_override.node.migrate_example_beer.revision_uid\n    [:db_insert_placeholder_43] => -1\n    [:db_insert_placeholder_44] => 1540278925.903\n    [:db_insert_placeholder_45] => \n    [:db_insert_placeholder_46] => 0\n    [:db_insert_placeholder_47] => b:0;\n    [:db_insert_placeholder_48] => 1\n    [:db_insert_placeholder_49] => core.base_field_override.node.migrate_example_beer.revision_log\n    [:db_insert_placeholder_50] => -1\n    [:db_insert_placeholder_51] => 1540278925.903\n    [:db_insert_placeholder_52] => \n    [:db_insert_placeholder_53] => 0\n    [:db_insert_placeholder_54] => b:0;\n    [:db_insert_placeholder_55] => 1\n    [:db_insert_placeholder_56] => core.base_field_override.node.migrate_example_beer.status\n    [:db_insert_placeholder_57] => -1\n    [:db_insert_placeholder_58] => 1540278925.903\n    [:db_insert_placeholder_59] => \n    [:db_insert_placeholder_60] => 0\n    [:db_insert_placeholder_61] => b:0;\n    [:db_insert_placeholder_62] => 1\n    [:db_insert_placeholder_63] => core.base_field_override.node.migrate_example_beer.title\n    [:db_insert_placeholder_64] => -1\n    [:db_insert_placeholder_65] => 1540278925.903\n    [:db_insert_placeholder_66] => \n    [:db_insert_placeholder_67] => 0\n    [:db_insert_placeholder_68] => b:0;\n    [:db_insert_placeholder_69] => 1\n    [:db_insert_placeholder_70] => core.base_field_override.node.migrate_example_beer.uid\n    [:db_insert_placeholder_71] => -1\n    [:db_insert_placeholder_72] => 1540278925.903\n    [:db_insert_placeholder_73] => \n    [:db_insert_placeholder_74] => 0\n    [:db_insert_placeholder_75] => b:0;\n    [:db_insert_placeholder_76] => 1\n    [:db_insert_placeholder_77] => core.base_field_override.node.migrate_example_beer.created\n    [:db_insert_placeholder_78] => -1\n    [:db_insert_placeholder_79] => 1540278925.903\n    [:db_insert_placeholder_80] => \n    [:db_insert_placeholder_81] => 0\n    [:db_insert_placeholder_82] => b:0;\n    [:db_insert_placeholder_83] => 1\n    [:db_insert_placeholder_84] => core.base_field_override.node.migrate_example_beer.changed\n    [:db_insert_placeholder_85] => -1\n    [:db_insert_placeholder_86] => 1540278925.903\n    [:db_insert_placeholder_87] => \n    [:db_insert_placeholder_88] => 0\n    [:db_insert_placeholder_89] => b:0;\n    [:db_insert_placeholder_90] => 1\n    [:db_insert_placeholder_91] => core.base_field_override.node.migrate_example_beer.promote\n    [:db_insert_placeholder_92] => -1\n    [:db_insert_placeholder_93] => 1540278925.903\n    [:db_insert_placeholder_94] => \n    [:db_insert_placeholder_95] => 0\n    [:db_insert_placeholder_96] => b:0;\n    [:db_insert_placeholder_97] => 1\n    [:db_insert_placeholder_98] => core.base_field_override.node.migrate_example_beer.sticky\n    [:db_insert_placeholder_99] => -1\n    [:db_insert_placeholder_100] => 1540278925.903\n    [:db_insert_placeholder_101] => \n    [:db_insert_placeholder_102] => 0\n    [:db_insert_placeholder_103] => b:0;\n    [:db_insert_placeholder_104] => 1\n    [:db_insert_placeholder_105] => core.base_field_override.node.migrate_example_beer.default_langcode\n    [:db_insert_placeholder_106] => -1\n    [:db_insert_placeholder_107] => 1540278925.903\n    [:db_insert_placeholder_108] => \n    [:db_insert_placeholder_109] => 0\n    [:db_insert_placeholder_110] => b:0;\n    [:db_insert_placeholder_111] => 1\n    [:db_insert_placeholder_112] => core.base_field_override.node.migrate_example_beer.revision_default\n    [:db_insert_placeholder_113] => -1\n    [:db_insert_placeholder_114] => 1540278925.903\n    [:db_insert_placeholder_115] => \n    [:db_insert_placeholder_116] => 0\n    [:db_insert_placeholder_117] => b:0;\n    [:db_insert_placeholder_118] => 1\n    [:db_insert_placeholder_119] => core.base_field_override.node.migrate_example_beer.revision_translation_affected\n    [:db_insert_placeholder_120] => -1\n    [:db_insert_placeholder_121] => 1540278925.903\n    [:db_insert_placeholder_122] => \n    [:db_insert_placeholder_123] => 0\n    [:db_insert_placeholder_124] => b:0;\n    [:db_insert_placeholder_125] => 1\n    [:db_insert_placeholder_126] => core.base_field_override.node.migrate_example_beer.moderation_state\n    [:db_insert_placeholder_127] => -1\n    [:db_insert_placeholder_128] => 1540278925.903\n    [:db_insert_placeholder_129] => \n    [:db_insert_placeholder_130] => 0\n    [:db_insert_placeholder_131] => b:0;\n    [:db_insert_placeholder_132] => 1\n    [:db_insert_placeholder_133] => core.base_field_override.node.migrate_example_beer.path\n    [:db_insert_placeholder_134] => -1\n    [:db_insert_placeholder_135] => 1540278925.903\n    [:db_insert_placeholder_136] => \n    [:db_insert_placeholder_137] => 0\n    [:db_insert_placeholder_138] => b:0;\n    [:db_insert_placeholder_139] => 1\n)\n\";s:9:\"%function\";s:48:\"Drupal\\Core\\Config\\CachedStorage->readMultiple()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php\";s:5:\"%line\";i:105;s:17:\"@backtrace_string\";s:8048:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {ca...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Query/Upsert.php(106): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(263): Drupal\\Core\\Database\\Query\\Upsert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(193): Drupal\\Core\\Cache\\DatabaseBackend->doSetMultiple(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php(105): Drupal\\Core\\Cache\\DatabaseBackend->setMultiple(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(165): Drupal\\Core\\Config\\CachedStorage->readMultiple(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(136): Drupal\\Core\\Config\\ConfigFactory->doLoadMultiple(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(188): Drupal\\Core\\Config\\ConfigFactory->loadMultiple(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->doLoadMultiple(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(369): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(329): Drupal\\Core\\Entity\\EntityFieldManager->buildBundleFieldDefinitions(\'node\', \'migrate_example...\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityManager.php(195): Drupal\\Core\\Entity\\EntityFieldManager->getFieldDefinitions(\'node\', \'migrate_example...\')\n#13 /var/www/html/drupal8/web/core/modules/views/views.views.inc(252): Drupal\\Core\\Entity\\EntityManager->getFieldDefinitions(\'node\', \'migrate_example...\')\n#14 /var/www/html/drupal8/web/core/modules/views/views.views.inc(495): views_entity_field_label(\'node\', \'body\')\n#15 /var/www/html/drupal8/web/core/modules/views/views.views.inc(185): views_field_default_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#16 [internal function]: views_views_data()\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'views_views_dat...\', Array)\n#18 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(243): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'views\', \'views_data\')\n#19 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(160): Drupal\\views\\ViewsData->getData()\n#20 /var/www/html/drupal8/web/core/modules/views/src/Plugin/ViewsHandlerManager.php(85): Drupal\\views\\ViewsData->get(\'node_field_data\')\n#21 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(889): Drupal\\views\\Plugin\\ViewsHandlerManager->getHandler(Array, NULL)\n#22 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1040): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->getHandlers(\'sort\')\n#23 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(898): Drupal\\views\\ViewExecutable->_initHandler(\'sort\', Array)\n#24 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(2267): Drupal\\views\\ViewExecutable->initHandlers()\n#25 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1692): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->preExecute()\n#26 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1627): Drupal\\views\\ViewExecutable->preExecute(Array)\n#27 /var/www/html/drupal8/web/core/modules/views/src/Element/View.php(77): Drupal\\views\\ViewExecutable->executeDisplay(\'page_1\', Array)\n#28 [internal function]: Drupal\\views\\Element\\View::preRenderViewElement(Array)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#36 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#38 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#39 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#42 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#43 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#49 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540278925),(1185,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:6866:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {cache_config} (cid, expire, created, tags, checksum, data, serialized) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2, :db_insert_placeholder_3, :db_insert_placeholder_4, :db_insert_placeholder_5, :db_insert_placeholder_6), (:db_insert_placeholder_7, :db_insert_placeholder_8, :db_insert_placeholder_9, :db_insert_placeholder_10, :db_insert_placeholder_11, :db_insert_placeholder_12, :db_insert_placeholder_13), (:db_insert_placeholder_14, :db_insert_placeholder_15, :db_insert_placeholder_16, :db_insert_placeholder_17, :db_insert_placeholder_18, :db_insert_placeholder_19, :db_insert_placeholder_20), (:db_insert_placeholder_21, :db_insert_placeholder_22, :db_insert_placeholder_23, :db_insert_placeholder_24, :db_insert_placeholder_25, :db_insert_placeholder_26, :db_insert_placeholder_27), (:db_insert_placeholder_28, :db_insert_placeholder_29, :db_insert_placeholder_30, :db_insert_placeholder_31, :db_insert_placeholder_32, :db_insert_placeholder_33, :db_insert_placeholder_34), (:db_insert_placeholder_35, :db_insert_placeholder_36, :db_insert_placeholder_37, :db_insert_placeholder_38, :db_insert_placeholder_39, :db_insert_placeholder_40, :db_insert_placeholder_41), (:db_insert_placeholder_42, :db_insert_placeholder_43, :db_insert_placeholder_44, :db_insert_placeholder_45, :db_insert_placeholder_46, :db_insert_placeholder_47, :db_insert_placeholder_48), (:db_insert_placeholder_49, :db_insert_placeholder_50, :db_insert_placeholder_51, :db_insert_placeholder_52, :db_insert_placeholder_53, :db_insert_placeholder_54, :db_insert_placeholder_55), (:db_insert_placeholder_56, :db_insert_placeholder_57, :db_insert_placeholder_58, :db_insert_placeholder_59, :db_insert_placeholder_60, :db_insert_placeholder_61, :db_insert_placeholder_62), (:db_insert_placeholder_63, :db_insert_placeholder_64, :db_insert_placeholder_65, :db_insert_placeholder_66, :db_insert_placeholder_67, :db_insert_placeholder_68, :db_insert_placeholder_69), (:db_insert_placeholder_70, :db_insert_placeholder_71, :db_insert_placeholder_72, :db_insert_placeholder_73, :db_insert_placeholder_74, :db_insert_placeholder_75, :db_insert_placeholder_76), (:db_insert_placeholder_77, :db_insert_placeholder_78, :db_insert_placeholder_79, :db_insert_placeholder_80, :db_insert_placeholder_81, :db_insert_placeholder_82, :db_insert_placeholder_83) ON DUPLICATE KEY UPDATE cid = VALUES(cid), expire = VALUES(expire), created = VALUES(created), tags = VALUES(tags), checksum = VALUES(checksum), data = VALUES(data), serialized = VALUES(serialized); Array\n(\n    [:db_insert_placeholder_0] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.tid\n    [:db_insert_placeholder_1] => -1\n    [:db_insert_placeholder_2] => 1540278926.017\n    [:db_insert_placeholder_3] => \n    [:db_insert_placeholder_4] => 0\n    [:db_insert_placeholder_5] => b:0;\n    [:db_insert_placeholder_6] => 1\n    [:db_insert_placeholder_7] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.uuid\n    [:db_insert_placeholder_8] => -1\n    [:db_insert_placeholder_9] => 1540278926.017\n    [:db_insert_placeholder_10] => \n    [:db_insert_placeholder_11] => 0\n    [:db_insert_placeholder_12] => b:0;\n    [:db_insert_placeholder_13] => 1\n    [:db_insert_placeholder_14] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.langcode\n    [:db_insert_placeholder_15] => -1\n    [:db_insert_placeholder_16] => 1540278926.017\n    [:db_insert_placeholder_17] => \n    [:db_insert_placeholder_18] => 0\n    [:db_insert_placeholder_19] => b:0;\n    [:db_insert_placeholder_20] => 1\n    [:db_insert_placeholder_21] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.vid\n    [:db_insert_placeholder_22] => -1\n    [:db_insert_placeholder_23] => 1540278926.017\n    [:db_insert_placeholder_24] => \n    [:db_insert_placeholder_25] => 0\n    [:db_insert_placeholder_26] => b:0;\n    [:db_insert_placeholder_27] => 1\n    [:db_insert_placeholder_28] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.status\n    [:db_insert_placeholder_29] => -1\n    [:db_insert_placeholder_30] => 1540278926.017\n    [:db_insert_placeholder_31] => \n    [:db_insert_placeholder_32] => 0\n    [:db_insert_placeholder_33] => b:0;\n    [:db_insert_placeholder_34] => 1\n    [:db_insert_placeholder_35] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.name\n    [:db_insert_placeholder_36] => -1\n    [:db_insert_placeholder_37] => 1540278926.017\n    [:db_insert_placeholder_38] => \n    [:db_insert_placeholder_39] => 0\n    [:db_insert_placeholder_40] => b:0;\n    [:db_insert_placeholder_41] => 1\n    [:db_insert_placeholder_42] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.description\n    [:db_insert_placeholder_43] => -1\n    [:db_insert_placeholder_44] => 1540278926.017\n    [:db_insert_placeholder_45] => \n    [:db_insert_placeholder_46] => 0\n    [:db_insert_placeholder_47] => b:0;\n    [:db_insert_placeholder_48] => 1\n    [:db_insert_placeholder_49] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.weight\n    [:db_insert_placeholder_50] => -1\n    [:db_insert_placeholder_51] => 1540278926.017\n    [:db_insert_placeholder_52] => \n    [:db_insert_placeholder_53] => 0\n    [:db_insert_placeholder_54] => b:0;\n    [:db_insert_placeholder_55] => 1\n    [:db_insert_placeholder_56] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.parent\n    [:db_insert_placeholder_57] => -1\n    [:db_insert_placeholder_58] => 1540278926.017\n    [:db_insert_placeholder_59] => \n    [:db_insert_placeholder_60] => 0\n    [:db_insert_placeholder_61] => b:0;\n    [:db_insert_placeholder_62] => 1\n    [:db_insert_placeholder_63] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.changed\n    [:db_insert_placeholder_64] => -1\n    [:db_insert_placeholder_65] => 1540278926.017\n    [:db_insert_placeholder_66] => \n    [:db_insert_placeholder_67] => 0\n    [:db_insert_placeholder_68] => b:0;\n    [:db_insert_placeholder_69] => 1\n    [:db_insert_placeholder_70] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.default_langcode\n    [:db_insert_placeholder_71] => -1\n    [:db_insert_placeholder_72] => 1540278926.017\n    [:db_insert_placeholder_73] => \n    [:db_insert_placeholder_74] => 0\n    [:db_insert_placeholder_75] => b:0;\n    [:db_insert_placeholder_76] => 1\n    [:db_insert_placeholder_77] => core.base_field_override.taxonomy_term.migrate_example_wine_regions.path\n    [:db_insert_placeholder_78] => -1\n    [:db_insert_placeholder_79] => 1540278926.017\n    [:db_insert_placeholder_80] => \n    [:db_insert_placeholder_81] => 0\n    [:db_insert_placeholder_82] => b:0;\n    [:db_insert_placeholder_83] => 1\n)\n\";s:9:\"%function\";s:48:\"Drupal\\Core\\Config\\CachedStorage->readMultiple()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php\";s:5:\"%line\";i:105;s:17:\"@backtrace_string\";s:8480:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {ca...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Query/Upsert.php(106): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(263): Drupal\\Core\\Database\\Query\\Upsert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(193): Drupal\\Core\\Cache\\DatabaseBackend->doSetMultiple(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php(105): Drupal\\Core\\Cache\\DatabaseBackend->setMultiple(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(165): Drupal\\Core\\Config\\CachedStorage->readMultiple(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(136): Drupal\\Core\\Config\\ConfigFactory->doLoadMultiple(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(188): Drupal\\Core\\Config\\ConfigFactory->loadMultiple(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->doLoadMultiple(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(369): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(329): Drupal\\Core\\Entity\\EntityFieldManager->buildBundleFieldDefinitions(\'taxonomy_term\', \'migrate_example...\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityManager.php(195): Drupal\\Core\\Entity\\EntityFieldManager->getFieldDefinitions(\'taxonomy_term\', \'migrate_example...\')\n#13 /var/www/html/drupal8/web/core/modules/views/views.views.inc(252): Drupal\\Core\\Entity\\EntityManager->getFieldDefinitions(\'taxonomy_term\', \'migrate_example...\')\n#14 /var/www/html/drupal8/web/core/modules/views/views.views.inc(495): views_entity_field_label(\'taxonomy_term\', \'field_variety_a...\')\n#15 /var/www/html/drupal8/web/core/modules/views/views.views.inc(760): views_field_default_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#16 [internal function]: core_field_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'core_field_view...\', Array)\n#18 /var/www/html/drupal8/web/core/modules/views/views.views.inc(183): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'core\', \'field_views_dat...\', Array)\n#19 [internal function]: views_views_data()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'views_views_dat...\', Array)\n#21 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(243): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'views\', \'views_data\')\n#22 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(160): Drupal\\views\\ViewsData->getData()\n#23 /var/www/html/drupal8/web/core/modules/views/src/Plugin/ViewsHandlerManager.php(85): Drupal\\views\\ViewsData->get(\'node_field_data\')\n#24 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(889): Drupal\\views\\Plugin\\ViewsHandlerManager->getHandler(Array, NULL)\n#25 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1040): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->getHandlers(\'sort\')\n#26 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(898): Drupal\\views\\ViewExecutable->_initHandler(\'sort\', Array)\n#27 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(2267): Drupal\\views\\ViewExecutable->initHandlers()\n#28 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1692): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->preExecute()\n#29 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1627): Drupal\\views\\ViewExecutable->preExecute(Array)\n#30 /var/www/html/drupal8/web/core/modules/views/src/Element/View.php(77): Drupal\\views\\ViewExecutable->executeDisplay(\'page_1\', Array)\n#31 [internal function]: Drupal\\views\\Element\\View::preRenderViewElement(Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#39 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#52 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540278926),(1186,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:6890:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {cache_config} (cid, expire, created, tags, checksum, data, serialized) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2, :db_insert_placeholder_3, :db_insert_placeholder_4, :db_insert_placeholder_5, :db_insert_placeholder_6), (:db_insert_placeholder_7, :db_insert_placeholder_8, :db_insert_placeholder_9, :db_insert_placeholder_10, :db_insert_placeholder_11, :db_insert_placeholder_12, :db_insert_placeholder_13), (:db_insert_placeholder_14, :db_insert_placeholder_15, :db_insert_placeholder_16, :db_insert_placeholder_17, :db_insert_placeholder_18, :db_insert_placeholder_19, :db_insert_placeholder_20), (:db_insert_placeholder_21, :db_insert_placeholder_22, :db_insert_placeholder_23, :db_insert_placeholder_24, :db_insert_placeholder_25, :db_insert_placeholder_26, :db_insert_placeholder_27), (:db_insert_placeholder_28, :db_insert_placeholder_29, :db_insert_placeholder_30, :db_insert_placeholder_31, :db_insert_placeholder_32, :db_insert_placeholder_33, :db_insert_placeholder_34), (:db_insert_placeholder_35, :db_insert_placeholder_36, :db_insert_placeholder_37, :db_insert_placeholder_38, :db_insert_placeholder_39, :db_insert_placeholder_40, :db_insert_placeholder_41), (:db_insert_placeholder_42, :db_insert_placeholder_43, :db_insert_placeholder_44, :db_insert_placeholder_45, :db_insert_placeholder_46, :db_insert_placeholder_47, :db_insert_placeholder_48), (:db_insert_placeholder_49, :db_insert_placeholder_50, :db_insert_placeholder_51, :db_insert_placeholder_52, :db_insert_placeholder_53, :db_insert_placeholder_54, :db_insert_placeholder_55), (:db_insert_placeholder_56, :db_insert_placeholder_57, :db_insert_placeholder_58, :db_insert_placeholder_59, :db_insert_placeholder_60, :db_insert_placeholder_61, :db_insert_placeholder_62), (:db_insert_placeholder_63, :db_insert_placeholder_64, :db_insert_placeholder_65, :db_insert_placeholder_66, :db_insert_placeholder_67, :db_insert_placeholder_68, :db_insert_placeholder_69), (:db_insert_placeholder_70, :db_insert_placeholder_71, :db_insert_placeholder_72, :db_insert_placeholder_73, :db_insert_placeholder_74, :db_insert_placeholder_75, :db_insert_placeholder_76), (:db_insert_placeholder_77, :db_insert_placeholder_78, :db_insert_placeholder_79, :db_insert_placeholder_80, :db_insert_placeholder_81, :db_insert_placeholder_82, :db_insert_placeholder_83) ON DUPLICATE KEY UPDATE cid = VALUES(cid), expire = VALUES(expire), created = VALUES(created), tags = VALUES(tags), checksum = VALUES(checksum), data = VALUES(data), serialized = VALUES(serialized); Array\n(\n    [:db_insert_placeholder_0] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.tid\n    [:db_insert_placeholder_1] => -1\n    [:db_insert_placeholder_2] => 1540278926.028\n    [:db_insert_placeholder_3] => \n    [:db_insert_placeholder_4] => 0\n    [:db_insert_placeholder_5] => b:0;\n    [:db_insert_placeholder_6] => 1\n    [:db_insert_placeholder_7] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.uuid\n    [:db_insert_placeholder_8] => -1\n    [:db_insert_placeholder_9] => 1540278926.028\n    [:db_insert_placeholder_10] => \n    [:db_insert_placeholder_11] => 0\n    [:db_insert_placeholder_12] => b:0;\n    [:db_insert_placeholder_13] => 1\n    [:db_insert_placeholder_14] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.langcode\n    [:db_insert_placeholder_15] => -1\n    [:db_insert_placeholder_16] => 1540278926.028\n    [:db_insert_placeholder_17] => \n    [:db_insert_placeholder_18] => 0\n    [:db_insert_placeholder_19] => b:0;\n    [:db_insert_placeholder_20] => 1\n    [:db_insert_placeholder_21] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.vid\n    [:db_insert_placeholder_22] => -1\n    [:db_insert_placeholder_23] => 1540278926.028\n    [:db_insert_placeholder_24] => \n    [:db_insert_placeholder_25] => 0\n    [:db_insert_placeholder_26] => b:0;\n    [:db_insert_placeholder_27] => 1\n    [:db_insert_placeholder_28] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.status\n    [:db_insert_placeholder_29] => -1\n    [:db_insert_placeholder_30] => 1540278926.028\n    [:db_insert_placeholder_31] => \n    [:db_insert_placeholder_32] => 0\n    [:db_insert_placeholder_33] => b:0;\n    [:db_insert_placeholder_34] => 1\n    [:db_insert_placeholder_35] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.name\n    [:db_insert_placeholder_36] => -1\n    [:db_insert_placeholder_37] => 1540278926.028\n    [:db_insert_placeholder_38] => \n    [:db_insert_placeholder_39] => 0\n    [:db_insert_placeholder_40] => b:0;\n    [:db_insert_placeholder_41] => 1\n    [:db_insert_placeholder_42] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.description\n    [:db_insert_placeholder_43] => -1\n    [:db_insert_placeholder_44] => 1540278926.028\n    [:db_insert_placeholder_45] => \n    [:db_insert_placeholder_46] => 0\n    [:db_insert_placeholder_47] => b:0;\n    [:db_insert_placeholder_48] => 1\n    [:db_insert_placeholder_49] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.weight\n    [:db_insert_placeholder_50] => -1\n    [:db_insert_placeholder_51] => 1540278926.028\n    [:db_insert_placeholder_52] => \n    [:db_insert_placeholder_53] => 0\n    [:db_insert_placeholder_54] => b:0;\n    [:db_insert_placeholder_55] => 1\n    [:db_insert_placeholder_56] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.parent\n    [:db_insert_placeholder_57] => -1\n    [:db_insert_placeholder_58] => 1540278926.028\n    [:db_insert_placeholder_59] => \n    [:db_insert_placeholder_60] => 0\n    [:db_insert_placeholder_61] => b:0;\n    [:db_insert_placeholder_62] => 1\n    [:db_insert_placeholder_63] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.changed\n    [:db_insert_placeholder_64] => -1\n    [:db_insert_placeholder_65] => 1540278926.028\n    [:db_insert_placeholder_66] => \n    [:db_insert_placeholder_67] => 0\n    [:db_insert_placeholder_68] => b:0;\n    [:db_insert_placeholder_69] => 1\n    [:db_insert_placeholder_70] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.default_langcode\n    [:db_insert_placeholder_71] => -1\n    [:db_insert_placeholder_72] => 1540278926.028\n    [:db_insert_placeholder_73] => \n    [:db_insert_placeholder_74] => 0\n    [:db_insert_placeholder_75] => b:0;\n    [:db_insert_placeholder_76] => 1\n    [:db_insert_placeholder_77] => core.base_field_override.taxonomy_term.migrate_example_wine_varieties.path\n    [:db_insert_placeholder_78] => -1\n    [:db_insert_placeholder_79] => 1540278926.028\n    [:db_insert_placeholder_80] => \n    [:db_insert_placeholder_81] => 0\n    [:db_insert_placeholder_82] => b:0;\n    [:db_insert_placeholder_83] => 1\n)\n\";s:9:\"%function\";s:48:\"Drupal\\Core\\Config\\CachedStorage->readMultiple()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php\";s:5:\"%line\";i:105;s:17:\"@backtrace_string\";s:8480:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {ca...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Query/Upsert.php(106): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(263): Drupal\\Core\\Database\\Query\\Upsert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(193): Drupal\\Core\\Cache\\DatabaseBackend->doSetMultiple(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php(105): Drupal\\Core\\Cache\\DatabaseBackend->setMultiple(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(165): Drupal\\Core\\Config\\CachedStorage->readMultiple(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(136): Drupal\\Core\\Config\\ConfigFactory->doLoadMultiple(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(188): Drupal\\Core\\Config\\ConfigFactory->loadMultiple(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->doLoadMultiple(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(369): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(329): Drupal\\Core\\Entity\\EntityFieldManager->buildBundleFieldDefinitions(\'taxonomy_term\', \'migrate_example...\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityManager.php(195): Drupal\\Core\\Entity\\EntityFieldManager->getFieldDefinitions(\'taxonomy_term\', \'migrate_example...\')\n#13 /var/www/html/drupal8/web/core/modules/views/views.views.inc(252): Drupal\\Core\\Entity\\EntityManager->getFieldDefinitions(\'taxonomy_term\', \'migrate_example...\')\n#14 /var/www/html/drupal8/web/core/modules/views/views.views.inc(495): views_entity_field_label(\'taxonomy_term\', \'field_variety_a...\')\n#15 /var/www/html/drupal8/web/core/modules/views/views.views.inc(760): views_field_default_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#16 [internal function]: core_field_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'core_field_view...\', Array)\n#18 /var/www/html/drupal8/web/core/modules/views/views.views.inc(183): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'core\', \'field_views_dat...\', Array)\n#19 [internal function]: views_views_data()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'views_views_dat...\', Array)\n#21 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(243): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'views\', \'views_data\')\n#22 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(160): Drupal\\views\\ViewsData->getData()\n#23 /var/www/html/drupal8/web/core/modules/views/src/Plugin/ViewsHandlerManager.php(85): Drupal\\views\\ViewsData->get(\'node_field_data\')\n#24 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(889): Drupal\\views\\Plugin\\ViewsHandlerManager->getHandler(Array, NULL)\n#25 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1040): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->getHandlers(\'sort\')\n#26 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(898): Drupal\\views\\ViewExecutable->_initHandler(\'sort\', Array)\n#27 /var/www/html/drupal8/web/core/modules/views/src/Plugin/views/display/DisplayPluginBase.php(2267): Drupal\\views\\ViewExecutable->initHandlers()\n#28 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1692): Drupal\\views\\Plugin\\views\\display\\DisplayPluginBase->preExecute()\n#29 /var/www/html/drupal8/web/core/modules/views/src/ViewExecutable.php(1627): Drupal\\views\\ViewExecutable->preExecute(Array)\n#30 /var/www/html/drupal8/web/core/modules/views/src/Element/View.php(77): Drupal\\views\\ViewExecutable->executeDisplay(\'page_1\', Array)\n#31 [internal function]: Drupal\\views\\Element\\View::preRenderViewElement(Array)\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(378): call_user_func(Array, Array)\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#39 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#41 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#42 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#43 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#45 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#46 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#52 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540278926),(1187,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540279542),(1188,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540279549),(1189,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540279595),(1190,0,'php','%type: @message in %function (line %line of %file) @backtrace_string.',_binary 'a:6:{s:5:\"%type\";s:10:\"ParseError\";s:8:\"@message\";s:50:\"syntax error, unexpected \'$variables\' (T_VARIABLE)\";s:9:\"%function\";s:39:\"Drupal\\Core\\Extension\\Extension->load()\";s:5:\"%file\";s:61:\"/var/www/html/drupal8/web/themes/custom/justice/justice.theme\";s:5:\"%line\";i:334;s:17:\"@backtrace_string\";s:5536:\"#0 /var/www/html/drupal8/web/core/themes/engines/twig/twig.engine(35): Drupal\\Core\\Extension\\Extension->load()\n#1 [internal function]: twig_init(Object(Drupal\\Core\\Extension\\Extension))\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeInitialization.php(146): call_user_func(\'twig_init\', Object(Drupal\\Core\\Extension\\Extension))\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeInitialization.php(74): Drupal\\Core\\Theme\\ThemeInitialization->loadActiveTheme(Object(Drupal\\Core\\Theme\\ActiveTheme))\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(406): Drupal\\Core\\Theme\\ThemeInitialization->initTheme(\'justice\')\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(96): Drupal\\Core\\Theme\\ThemeManager->initTheme(Object(Drupal\\Core\\Routing\\RouteMatch))\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/Context/ThemeCacheContext.php(43): Drupal\\Core\\Theme\\ThemeManager->getActiveTheme()\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/Context/CacheContextsManager.php(118): Drupal\\Core\\Cache\\Context\\ThemeCacheContext->getContext(NULL)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/RenderCache.php(307): Drupal\\Core\\Cache\\Context\\CacheContextsManager->convertTokensToKeys(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/RenderCache.php(66): Drupal\\Core\\Render\\RenderCache->createCacheID(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/PlaceholderingRenderCache.php(109): Drupal\\Core\\Render\\RenderCache->get(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(263): Drupal\\Core\\Render\\PlaceholderingRenderCache->get(Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#13 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#14 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#15 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#16 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#18 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#19 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#20 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#21 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#22 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#23 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#24 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(99): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#25 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(78): Drupal\\page_cache\\StackMiddleware\\PageCache->pass(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#28 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#30 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#31 {main}\";}',3,'','http://drupal-cms.com/','','127.0.0.1',1540279633),(1191,0,'cron','Starting execution of @module_cron().',_binary 'a:1:{s:7:\"@module\";s:7:\"comment\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1192,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"dblog\";s:16:\"@module_previous\";s:7:\"comment\";s:5:\"@time\";s:7:\"16.04ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1193,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/justice/css/owl.carousel.min.css?ph1jdk','http://drupal-cms.com/','127.0.0.1',1540283840),(1194,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:5:\"field\";s:16:\"@module_previous\";s:5:\"dblog\";s:5:\"@time\";s:7:\"24.58ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1195,0,'cron','Attempting to re-run cron while it is already running.',_binary 'a:0:{}',4,'','http://drupal-cms.com/themes/custom/justice/css/flexslider.css?ph1jdk','http://drupal-cms.com/','127.0.0.1',1540283840),(1196,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"file\";s:16:\"@module_previous\";s:5:\"field\";s:5:\"@time\";s:7:\"17.11ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1197,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:7:\"history\";s:16:\"@module_previous\";s:4:\"file\";s:5:\"@time\";s:6:\"22.5ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1198,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:4:\"node\";s:16:\"@module_previous\";s:7:\"history\";s:5:\"@time\";s:6:\"0.49ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1199,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"search\";s:16:\"@module_previous\";s:4:\"node\";s:5:\"@time\";s:7:\"24.69ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1200,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"system\";s:16:\"@module_previous\";s:6:\"search\";s:5:\"@time\";s:6:\"4.14ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1201,0,'cron','Starting execution of @module_cron(), execution of @module_previous_cron() took @time.',_binary 'a:3:{s:7:\"@module\";s:6:\"update\";s:16:\"@module_previous\";s:6:\"system\";s:5:\"@time\";s:7:\"19.86ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283840),(1202,0,'cron','Execution of @module_previous_cron() took @time.',_binary 'a:2:{s:16:\"@module_previous\";s:6:\"update\";s:5:\"@time\";s:9:\"5778.23ms\";}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283846),(1203,0,'cron','Cron run completed.',_binary 'a:0:{}',5,'','http://drupal-cms.com/','','127.0.0.1',1540283846),(1204,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540284337),(1205,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540284409),(1206,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540286188),(1207,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540286674),(1208,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540286680),(1209,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540287040),(1210,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540287911),(1211,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540288027),(1212,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540288146),(1213,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540288422),(1214,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540288535),(1215,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540288656),(1216,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540288674),(1217,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540288741),(1218,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540288765),(1219,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540288799),(1220,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540289119),(1221,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540289195),(1222,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540289251),(1223,1,'block_content','@type: added %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:18:\"content info title\";}',5,'','http://drupal-cms.com/block/add?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/add?destination=/admin/structure/block/block-content','127.0.0.1',1540289280),(1224,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1540290385),(1225,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','','127.0.0.1',1540290420),(1226,1,'system','%module module uninstalled.',_binary 'a:1:{s:7:\"%module\";s:24:\"migrate_example_advanced\";}',6,'','http://drupal-cms.com/admin/modules/uninstall/confirm','http://drupal-cms.com/admin/modules/uninstall/confirm','127.0.0.1',1540290560),(1227,1,'system','%module module uninstalled.',_binary 'a:1:{s:7:\"%module\";s:15:\"migrate_example\";}',6,'','http://drupal-cms.com/admin/modules/uninstall/confirm','http://drupal-cms.com/admin/modules/uninstall/confirm','127.0.0.1',1540290561),(1228,1,'system','%module module uninstalled.',_binary 'a:1:{s:7:\"%module\";s:14:\"render_example\";}',6,'','http://drupal-cms.com/admin/modules/uninstall/confirm','http://drupal-cms.com/admin/modules/uninstall/confirm','127.0.0.1',1540290562),(1229,1,'system','%module module uninstalled.',_binary 'a:1:{s:7:\"%module\";s:13:\"hooks_example\";}',6,'','http://drupal-cms.com/admin/modules/uninstall/confirm','http://drupal-cms.com/admin/modules/uninstall/confirm','127.0.0.1',1540290562),(1230,1,'system','%module module uninstalled.',_binary 'a:1:{s:7:\"%module\";s:30:\"migrate_example_advanced_setup\";}',6,'','http://drupal-cms.com/admin/modules/uninstall/confirm','http://drupal-cms.com/admin/modules/uninstall/confirm','127.0.0.1',1540290588),(1231,1,'system','%module module uninstalled.',_binary 'a:1:{s:7:\"%module\";s:21:\"migrate_example_setup\";}',6,'','http://drupal-cms.com/admin/modules/uninstall/confirm','http://drupal-cms.com/admin/modules/uninstall/confirm','127.0.0.1',1540290589),(1232,1,'system','%module module uninstalled.',_binary 'a:1:{s:7:\"%module\";s:8:\"examples\";}',6,'','http://drupal-cms.com/admin/modules/uninstall/confirm','http://drupal-cms.com/admin/modules/uninstall/confirm','127.0.0.1',1540290590),(1233,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:6:\"/login\";}',4,'','http://drupal-cms.com/login','','127.0.0.1',1540291487),(1234,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540291505),(1235,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1540291519),(1236,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:15:\"Main navigation\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_main_menu/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/justice_main_menu/delete?destination=/admin/structure/block','127.0.0.1',1540291578),(1237,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:17:\"User account menu\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_account_menu/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/justice_account_menu/delete?destination=/admin/structure/block','127.0.0.1',1540291642),(1238,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:21:\"Primary admin actions\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_local_actions/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/justice_local_actions/delete?destination=/admin/structure/block','127.0.0.1',1540291651),(1239,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:5:\"Tools\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_tools/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/justice_tools/delete?destination=/admin/structure/block','127.0.0.1',1540291660),(1240,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:4:\"Tabs\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_local_tasks/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/justice_local_tasks/delete?destination=/admin/structure/block','127.0.0.1',1540291672),(1241,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540291846),(1242,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540291875),(1243,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:11:\"/user/loout\";}',4,'','http://drupal-cms.com/user/loout','','127.0.0.1',1540291882),(1244,1,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540291882),(1245,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','','127.0.0.1',1540291886),(1246,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540291887),(1247,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540291935),(1248,0,'php','%type: @message in %function (line %line of %file).',_binary 'a:6:{s:5:\"%type\";s:45:\"Drupal\\Core\\Database\\DatabaseExceptionWrapper\";s:8:\"@message\";s:6854:\"SQLSTATE[40001]: Serialization failure: 1213 Deadlock found when trying to get lock; try restarting transaction: INSERT INTO {cache_config} (cid, expire, created, tags, checksum, data, serialized) VALUES (:db_insert_placeholder_0, :db_insert_placeholder_1, :db_insert_placeholder_2, :db_insert_placeholder_3, :db_insert_placeholder_4, :db_insert_placeholder_5, :db_insert_placeholder_6), (:db_insert_placeholder_7, :db_insert_placeholder_8, :db_insert_placeholder_9, :db_insert_placeholder_10, :db_insert_placeholder_11, :db_insert_placeholder_12, :db_insert_placeholder_13), (:db_insert_placeholder_14, :db_insert_placeholder_15, :db_insert_placeholder_16, :db_insert_placeholder_17, :db_insert_placeholder_18, :db_insert_placeholder_19, :db_insert_placeholder_20), (:db_insert_placeholder_21, :db_insert_placeholder_22, :db_insert_placeholder_23, :db_insert_placeholder_24, :db_insert_placeholder_25, :db_insert_placeholder_26, :db_insert_placeholder_27), (:db_insert_placeholder_28, :db_insert_placeholder_29, :db_insert_placeholder_30, :db_insert_placeholder_31, :db_insert_placeholder_32, :db_insert_placeholder_33, :db_insert_placeholder_34), (:db_insert_placeholder_35, :db_insert_placeholder_36, :db_insert_placeholder_37, :db_insert_placeholder_38, :db_insert_placeholder_39, :db_insert_placeholder_40, :db_insert_placeholder_41), (:db_insert_placeholder_42, :db_insert_placeholder_43, :db_insert_placeholder_44, :db_insert_placeholder_45, :db_insert_placeholder_46, :db_insert_placeholder_47, :db_insert_placeholder_48), (:db_insert_placeholder_49, :db_insert_placeholder_50, :db_insert_placeholder_51, :db_insert_placeholder_52, :db_insert_placeholder_53, :db_insert_placeholder_54, :db_insert_placeholder_55), (:db_insert_placeholder_56, :db_insert_placeholder_57, :db_insert_placeholder_58, :db_insert_placeholder_59, :db_insert_placeholder_60, :db_insert_placeholder_61, :db_insert_placeholder_62), (:db_insert_placeholder_63, :db_insert_placeholder_64, :db_insert_placeholder_65, :db_insert_placeholder_66, :db_insert_placeholder_67, :db_insert_placeholder_68, :db_insert_placeholder_69), (:db_insert_placeholder_70, :db_insert_placeholder_71, :db_insert_placeholder_72, :db_insert_placeholder_73, :db_insert_placeholder_74, :db_insert_placeholder_75, :db_insert_placeholder_76), (:db_insert_placeholder_77, :db_insert_placeholder_78, :db_insert_placeholder_79, :db_insert_placeholder_80, :db_insert_placeholder_81, :db_insert_placeholder_82, :db_insert_placeholder_83) ON DUPLICATE KEY UPDATE cid = VALUES(cid), expire = VALUES(expire), created = VALUES(created), tags = VALUES(tags), checksum = VALUES(checksum), data = VALUES(data), serialized = VALUES(serialized); Array\n(\n    [:db_insert_placeholder_0] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.tid\n    [:db_insert_placeholder_1] => -1\n    [:db_insert_placeholder_2] => 1540292209.631\n    [:db_insert_placeholder_3] => \n    [:db_insert_placeholder_4] => 0\n    [:db_insert_placeholder_5] => b:0;\n    [:db_insert_placeholder_6] => 1\n    [:db_insert_placeholder_7] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.uuid\n    [:db_insert_placeholder_8] => -1\n    [:db_insert_placeholder_9] => 1540292209.631\n    [:db_insert_placeholder_10] => \n    [:db_insert_placeholder_11] => 0\n    [:db_insert_placeholder_12] => b:0;\n    [:db_insert_placeholder_13] => 1\n    [:db_insert_placeholder_14] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.langcode\n    [:db_insert_placeholder_15] => -1\n    [:db_insert_placeholder_16] => 1540292209.631\n    [:db_insert_placeholder_17] => \n    [:db_insert_placeholder_18] => 0\n    [:db_insert_placeholder_19] => b:0;\n    [:db_insert_placeholder_20] => 1\n    [:db_insert_placeholder_21] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.vid\n    [:db_insert_placeholder_22] => -1\n    [:db_insert_placeholder_23] => 1540292209.631\n    [:db_insert_placeholder_24] => \n    [:db_insert_placeholder_25] => 0\n    [:db_insert_placeholder_26] => b:0;\n    [:db_insert_placeholder_27] => 1\n    [:db_insert_placeholder_28] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.status\n    [:db_insert_placeholder_29] => -1\n    [:db_insert_placeholder_30] => 1540292209.631\n    [:db_insert_placeholder_31] => \n    [:db_insert_placeholder_32] => 0\n    [:db_insert_placeholder_33] => b:0;\n    [:db_insert_placeholder_34] => 1\n    [:db_insert_placeholder_35] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.name\n    [:db_insert_placeholder_36] => -1\n    [:db_insert_placeholder_37] => 1540292209.631\n    [:db_insert_placeholder_38] => \n    [:db_insert_placeholder_39] => 0\n    [:db_insert_placeholder_40] => b:0;\n    [:db_insert_placeholder_41] => 1\n    [:db_insert_placeholder_42] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.description\n    [:db_insert_placeholder_43] => -1\n    [:db_insert_placeholder_44] => 1540292209.631\n    [:db_insert_placeholder_45] => \n    [:db_insert_placeholder_46] => 0\n    [:db_insert_placeholder_47] => b:0;\n    [:db_insert_placeholder_48] => 1\n    [:db_insert_placeholder_49] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.weight\n    [:db_insert_placeholder_50] => -1\n    [:db_insert_placeholder_51] => 1540292209.631\n    [:db_insert_placeholder_52] => \n    [:db_insert_placeholder_53] => 0\n    [:db_insert_placeholder_54] => b:0;\n    [:db_insert_placeholder_55] => 1\n    [:db_insert_placeholder_56] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.parent\n    [:db_insert_placeholder_57] => -1\n    [:db_insert_placeholder_58] => 1540292209.631\n    [:db_insert_placeholder_59] => \n    [:db_insert_placeholder_60] => 0\n    [:db_insert_placeholder_61] => b:0;\n    [:db_insert_placeholder_62] => 1\n    [:db_insert_placeholder_63] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.changed\n    [:db_insert_placeholder_64] => -1\n    [:db_insert_placeholder_65] => 1540292209.631\n    [:db_insert_placeholder_66] => \n    [:db_insert_placeholder_67] => 0\n    [:db_insert_placeholder_68] => b:0;\n    [:db_insert_placeholder_69] => 1\n    [:db_insert_placeholder_70] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.default_langcode\n    [:db_insert_placeholder_71] => -1\n    [:db_insert_placeholder_72] => 1540292209.631\n    [:db_insert_placeholder_73] => \n    [:db_insert_placeholder_74] => 0\n    [:db_insert_placeholder_75] => b:0;\n    [:db_insert_placeholder_76] => 1\n    [:db_insert_placeholder_77] => core.base_field_override.taxonomy_term.migrate_example_beer_styles.path\n    [:db_insert_placeholder_78] => -1\n    [:db_insert_placeholder_79] => 1540292209.631\n    [:db_insert_placeholder_80] => \n    [:db_insert_placeholder_81] => 0\n    [:db_insert_placeholder_82] => b:0;\n    [:db_insert_placeholder_83] => 1\n)\n\";s:9:\"%function\";s:48:\"Drupal\\Core\\Config\\CachedStorage->readMultiple()\";s:5:\"%file\";s:71:\"/var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php\";s:5:\"%line\";i:105;s:17:\"@backtrace_string\";s:9518:\"#0 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Connection.php(650): Drupal\\Core\\Database\\Connection->handleQueryException(Object(PDOException), \'INSERT INTO {ca...\', Array, Array)\n#1 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Driver/mysql/Connection.php(358): Drupal\\Core\\Database\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#2 /var/www/html/drupal8/web/core/lib/Drupal/Core/Database/Query/Upsert.php(106): Drupal\\Core\\Database\\Driver\\mysql\\Connection->query(\'INSERT INTO {ca...\', Array, Array)\n#3 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(263): Drupal\\Core\\Database\\Query\\Upsert->execute()\n#4 /var/www/html/drupal8/web/core/lib/Drupal/Core/Cache/DatabaseBackend.php(193): Drupal\\Core\\Cache\\DatabaseBackend->doSetMultiple(Array)\n#5 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/CachedStorage.php(105): Drupal\\Core\\Cache\\DatabaseBackend->setMultiple(Array)\n#6 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(165): Drupal\\Core\\Config\\CachedStorage->readMultiple(Array)\n#7 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/ConfigFactory.php(136): Drupal\\Core\\Config\\ConfigFactory->doLoadMultiple(Array)\n#8 /var/www/html/drupal8/web/core/lib/Drupal/Core/Config/Entity/ConfigEntityStorage.php(188): Drupal\\Core\\Config\\ConfigFactory->loadMultiple(Array)\n#9 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityStorageBase.php(279): Drupal\\Core\\Config\\Entity\\ConfigEntityStorage->doLoadMultiple(Array)\n#10 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(369): Drupal\\Core\\Entity\\EntityStorageBase->loadMultiple(Array)\n#11 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityFieldManager.php(329): Drupal\\Core\\Entity\\EntityFieldManager->buildBundleFieldDefinitions(\'taxonomy_term\', \'migrate_example...\', Array)\n#12 /var/www/html/drupal8/web/core/lib/Drupal/Core/Entity/EntityManager.php(195): Drupal\\Core\\Entity\\EntityFieldManager->getFieldDefinitions(\'taxonomy_term\', \'migrate_example...\')\n#13 /var/www/html/drupal8/web/core/modules/views/views.views.inc(252): Drupal\\Core\\Entity\\EntityManager->getFieldDefinitions(\'taxonomy_term\', \'migrate_example...\')\n#14 /var/www/html/drupal8/web/core/modules/views/views.views.inc(495): views_entity_field_label(\'taxonomy_term\', \'field_variety_a...\')\n#15 /var/www/html/drupal8/web/core/modules/views/views.views.inc(760): views_field_default_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#16 [internal function]: core_field_views_data(Object(Drupal\\field\\Entity\\FieldStorageConfig))\n#17 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'core_field_view...\', Array)\n#18 /var/www/html/drupal8/web/core/modules/views/views.views.inc(183): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'core\', \'field_views_dat...\', Array)\n#19 [internal function]: views_views_data()\n#20 /var/www/html/drupal8/web/core/lib/Drupal/Core/Extension/ModuleHandler.php(392): call_user_func_array(\'views_views_dat...\', Array)\n#21 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(243): Drupal\\Core\\Extension\\ModuleHandler->invoke(\'views\', \'views_data\')\n#22 /var/www/html/drupal8/web/core/modules/views/src/ViewsData.php(160): Drupal\\views\\ViewsData->getData()\n#23 /var/www/html/drupal8/web/core/modules/views/src/Plugin/Derivative/ViewsEntityRow.php(91): Drupal\\views\\ViewsData->get(\'block_content\')\n#24 /var/www/html/drupal8/web/core/lib/Drupal/Component/Plugin/Discovery/DerivativeDiscoveryDecorator.php(101): Drupal\\views\\Plugin\\Derivative\\ViewsEntityRow->getDerivativeDefinitions(Array)\n#25 /var/www/html/drupal8/web/core/lib/Drupal/Component/Plugin/Discovery/DerivativeDiscoveryDecorator.php(87): Drupal\\Component\\Plugin\\Discovery\\DerivativeDiscoveryDecorator->getDerivatives(Array)\n#26 /var/www/html/drupal8/web/core/lib/Drupal/Core/Plugin/DefaultPluginManager.php(284): Drupal\\Component\\Plugin\\Discovery\\DerivativeDiscoveryDecorator->getDefinitions()\n#27 /var/www/html/drupal8/web/core/lib/Drupal/Core/Plugin/DefaultPluginManager.php(175): Drupal\\Core\\Plugin\\DefaultPluginManager->findDefinitions()\n#28 /var/www/html/drupal8/web/core/modules/views/views.module(147): Drupal\\Core\\Plugin\\DefaultPluginManager->getDefinitions()\n#29 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(447): views_theme(Array, \'module\', \'views\', \'core/modules/vi...\')\n#30 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(334): Drupal\\Core\\Theme\\Registry->processExtension(Array, \'views\', \'module\', \'views\', \'core/modules/vi...\')\n#31 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(233): Drupal\\Core\\Theme\\Registry->build()\n#32 /var/www/html/drupal8/web/core/lib/Drupal/Core/Utility/ThemeRegistry.php(86): Drupal\\Core\\Theme\\Registry->get()\n#33 /var/www/html/drupal8/web/core/lib/Drupal/Core/Utility/ThemeRegistry.php(67): Drupal\\Core\\Utility\\ThemeRegistry->initializeRegistry()\n#34 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/Registry.php(253): Drupal\\Core\\Utility\\ThemeRegistry->__construct(\'theme_registry:...\', Object(Drupal\\Core\\Cache\\DatabaseBackend), Object(Drupal\\Core\\ProxyClass\\Lock\\DatabaseLockBackend), Array, true)\n#35 /var/www/html/drupal8/web/core/lib/Drupal/Core/Theme/ThemeManager.php(142): Drupal\\Core\\Theme\\Registry->getRuntime()\n#36 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(437): Drupal\\Core\\Theme\\ThemeManager->render(Array, Array)\n#37 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(195): Drupal\\Core\\Render\\Renderer->doRender(Array, false)\n#38 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(226): Drupal\\Core\\Render\\Renderer->render(Array, false)\n#39 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/Renderer.php(582): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->Drupal\\Core\\Render\\MainContent\\{closure}()\n#40 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(227): Drupal\\Core\\Render\\Renderer->executeInRenderContext(Object(Drupal\\Core\\Render\\RenderContext), Object(Closure))\n#41 /var/www/html/drupal8/web/core/lib/Drupal/Core/Render/MainContent/HtmlRenderer.php(117): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->prepare(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#42 /var/www/html/drupal8/web/core/lib/Drupal/Core/EventSubscriber/MainContentViewSubscriber.php(90): Drupal\\Core\\Render\\MainContent\\HtmlRenderer->renderResponse(Array, Object(Symfony\\Component\\HttpFoundation\\Request), Object(Drupal\\Core\\Routing\\CurrentRouteMatch))\n#43 [internal function]: Drupal\\Core\\EventSubscriber\\MainContentViewSubscriber->onViewRenderArray(Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#44 /var/www/html/drupal8/web/core/lib/Drupal/Component/EventDispatcher/ContainerAwareEventDispatcher.php(111): call_user_func(Array, Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent), \'kernel.view\', Object(Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher))\n#45 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(156): Drupal\\Component\\EventDispatcher\\ContainerAwareEventDispatcher->dispatch(\'kernel.view\', Object(Symfony\\Component\\HttpKernel\\Event\\GetResponseForControllerResultEvent))\n#46 /var/www/html/drupal8/vendor/symfony/http-kernel/HttpKernel.php(68): Symfony\\Component\\HttpKernel\\HttpKernel->handleRaw(Object(Symfony\\Component\\HttpFoundation\\Request), 1)\n#47 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/Session.php(57): Symfony\\Component\\HttpKernel\\HttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#48 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/KernelPreHandle.php(47): Drupal\\Core\\StackMiddleware\\Session->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#49 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(184): Drupal\\Core\\StackMiddleware\\KernelPreHandle->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#50 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(121): Drupal\\page_cache\\StackMiddleware\\PageCache->fetch(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#51 /var/www/html/drupal8/web/core/modules/page_cache/src/StackMiddleware/PageCache.php(75): Drupal\\page_cache\\StackMiddleware\\PageCache->lookup(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#52 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/ReverseProxyMiddleware.php(47): Drupal\\page_cache\\StackMiddleware\\PageCache->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#53 /var/www/html/drupal8/web/core/lib/Drupal/Core/StackMiddleware/NegotiationMiddleware.php(52): Drupal\\Core\\StackMiddleware\\ReverseProxyMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#54 /var/www/html/drupal8/vendor/stack/builder/src/Stack/StackedHttpKernel.php(23): Drupal\\Core\\StackMiddleware\\NegotiationMiddleware->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#55 /var/www/html/drupal8/web/core/lib/Drupal/Core/DrupalKernel.php(665): Stack\\StackedHttpKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request), 1, true)\n#56 /var/www/html/drupal8/web/index.php(19): Drupal\\Core\\DrupalKernel->handle(Object(Symfony\\Component\\HttpFoundation\\Request))\n#57 {main}\";}',3,'','http://drupal-cms.com/user/login','','127.0.0.1',1540292209),(1249,1,'block','The @entity-type %label has been deleted.',_binary 'a:2:{s:12:\"@entity-type\";s:5:\"block\";s:6:\"%label\";s:11:\"Breadcrumbs\";}',5,'','http://drupal-cms.com/admin/structure/block/manage/justice_breadcrumbs/delete?destination=%2Fadmin%2Fstructure%2Fblock','http://drupal-cms.com/admin/structure/block/manage/justice_breadcrumbs/delete?destination=/admin/structure/block','127.0.0.1',1540292465),(1250,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540292483),(1251,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540292706),(1252,0,'page not found','@uri',_binary 'a:1:{s:4:\"@uri\";s:40:\"/themes/custom/justice/js/jquery.min.map\";}',4,'','http://drupal-cms.com/themes/custom/justice/js/jquery.min.map','','127.0.0.1',1540292906),(1253,1,'user','Session opened for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/login','http://drupal-cms.com/user/login','127.0.0.1',1540292930),(1254,1,'user','Session closed for %name.',_binary 'a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://drupal-cms.com/user/logout','','127.0.0.1',1540293558),(1255,1,'block_content','@type: updated %info.',_binary 'a:2:{s:5:\"@type\";s:5:\"basic\";s:5:\"%info\";s:10:\"Contact Us\";}',5,'','http://drupal-cms.com/block/10?destination=%2Fadmin%2Fstructure%2Fblock%2Fblock-content','http://drupal-cms.com/block/10?destination=/admin/structure/block/block-content','127.0.0.1',1540293696);
/*!40000 ALTER TABLE `watchdog` ENABLE KEYS */;
UNLOCK TABLES;
commit;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2018-10-23 17:10:50
